/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 94;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 66,
  Feature_HasRCPC_IMMOBit = 86,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 65,
  Feature_HasSHA3Bit = 64,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 93,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 83,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 77,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 44,
  Feature_HasSVEAESBit = 37,
  Feature_HasSVE2SM4Bit = 41,
  Feature_HasSVE2SHA3Bit = 92,
  Feature_HasSVEBitPermBit = 39,
  Feature_HasSMEandIsNonStreamingSafeBit = 57,
  Feature_HasSMEBit = 50,
  Feature_HasSMEF64F64Bit = 52,
  Feature_HasSMEF16F16Bit = 63,
  Feature_HasSMEI16I64Bit = 55,
  Feature_HasSME2andIsNonStreamingSafeBit = 60,
  Feature_HasSME2Bit = 59,
  Feature_HasSME2p1Bit = 62,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 47,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 42,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 48,
  Feature_HasLUTBit = 49,
  Feature_HasSME_LUTv2Bit = 61,
  Feature_HasSMEF8F16Bit = 53,
  Feature_HasSMEF8F32Bit = 51,
  Feature_HasSME_MOP4Bit = 56,
  Feature_HasCMPBRBit = 84,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 31,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 40,
  Feature_HasSVE2_or_SMEBit = 33,
  Feature_HasSVE2_or_SME2Bit = 46,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 36,
  Feature_HasSVE2p1_or_SMEBit = 58,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 45,
  Feature_HasSVE2p2_or_SME2p2Bit = 32,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 54,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 38,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 74,
  Feature_HasRCPCBit = 85,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 91,
  Feature_HasMatMulFP64Bit = 43,
  Feature_HasLS64Bit = 81,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 82,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 72,
  Feature_IsBEBit = 78,
  Feature_UseExperimentalZeroingPseudosBit = 35,
  Feature_UseAlternateSExtLoadCVTF32Bit = 76,
  Feature_UseScalarIncVLBit = 34,
  Feature_NoUseScalarIncVLBit = 89,
  Feature_UseSVEFPLD1RBit = 88,
  Feature_UseLDAPURBit = 87,
  Feature_AllowMisalignedMemAccessesBit = 90,
  Feature_NotForCodeSizeBit = 75,
  Feature_UseSTRQroBit = 73,
  Feature_TailCallX16X17Bit = 68,
  Feature_TailCallX17Bit = 79,
  Feature_TailCallNotX16Bit = 80,
  Feature_TailCallAnyBit = 67,
  Feature_SLSBLRMitigationBit = 71,
  Feature_NoSLSBLRMitigationBit = 70,
  Feature_OptimizedGISelOrOtherSelectorBit = 69,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(889), /*)*//*default:*//*Label 157*/ GIMT_Encode4(409676),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3354),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(36617),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(50845),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(52674),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(52756), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(52838),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(60584),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(72631), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(78570), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(86094), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(96038),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(96529),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(97020),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(97288),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(97438),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(97929), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(97962),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(106772),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(107822), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(110791), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(124317),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(125668),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(126660),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(127652),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(129144), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(130636),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(131628),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(132620),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(133612),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(134604),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(135596),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(136588), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(137293),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(137998), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    286 */ /*TargetOpcode::G_FENCE*//*Label 34*/ GIMT_Encode4(138703), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 35*/ GIMT_Encode4(138754),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 36*/ GIMT_Encode4(248487), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 37*/ GIMT_Encode4(259807),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 38*/ GIMT_Encode4(260097),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 39*/ GIMT_Encode4(261534),
     /*    334 */ /*TargetOpcode::G_FCONSTANT*//*Label 40*/ GIMT_Encode4(261654), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 41*/ GIMT_Encode4(261895),
     /*    350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 42*/ GIMT_Encode4(263793),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 43*/ GIMT_Encode4(265447),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 44*/ GIMT_Encode4(268226),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 45*/ GIMT_Encode4(269006),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 46*/ GIMT_Encode4(269399), GIMT_Encode4(0),
     /*    374 */ /*TargetOpcode::G_FSHR*//*Label 47*/ GIMT_Encode4(270175),
     /*    378 */ /*TargetOpcode::G_ROTR*//*Label 48*/ GIMT_Encode4(270305), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ICMP*//*Label 49*/ GIMT_Encode4(270798), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(275374), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(276419),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(276903),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(277387),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(277817),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(278247),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(278677), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 57*/ GIMT_Encode4(279107),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 58*/ GIMT_Encode4(280905),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 59*/ GIMT_Encode4(281643),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 60*/ GIMT_Encode4(285739), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FDIV*//*Label 61*/ GIMT_Encode4(302012), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 62*/ GIMT_Encode4(302628),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 63*/ GIMT_Encode4(306135),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 64*/ GIMT_Encode4(306383),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 65*/ GIMT_Encode4(306571),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 66*/ GIMT_Encode4(307634),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 67*/ GIMT_Encode4(308697),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 68*/ GIMT_Encode4(313094),
     /*    606 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 69*/ GIMT_Encode4(316869),
     /*    610 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 70*/ GIMT_Encode4(317189),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 71*/ GIMT_Encode4(317509), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    626 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 72*/ GIMT_Encode4(318366),
     /*    630 */ /*TargetOpcode::G_FMINNUM*//*Label 73*/ GIMT_Encode4(318648),
     /*    634 */ /*TargetOpcode::G_FMAXNUM*//*Label 74*/ GIMT_Encode4(319026),
     /*    638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 75*/ GIMT_Encode4(319404),
     /*    642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 76*/ GIMT_Encode4(319754),
     /*    646 */ /*TargetOpcode::G_FMINIMUM*//*Label 77*/ GIMT_Encode4(320104),
     /*    650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 78*/ GIMT_Encode4(320807), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 79*/ GIMT_Encode4(321510),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 80*/ GIMT_Encode4(321914),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 81*/ GIMT_Encode4(322318),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 82*/ GIMT_Encode4(322722),
     /*    702 */ /*TargetOpcode::G_ABS*//*Label 83*/ GIMT_Encode4(323126),
     /*    706 */ /*TargetOpcode::G_LROUND*//*Label 84*/ GIMT_Encode4(323941),
     /*    710 */ /*TargetOpcode::G_LLROUND*//*Label 85*/ GIMT_Encode4(324107),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 86*/ GIMT_Encode4(324206), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 87*/ GIMT_Encode4(324222),
     /*    734 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 88*/ GIMT_Encode4(329594),
     /*    738 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 89*/ GIMT_Encode4(356991), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 90*/ GIMT_Encode4(359909), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    758 */ /*TargetOpcode::G_CTTZ*//*Label 91*/ GIMT_Encode4(361615), GIMT_Encode4(0),
     /*    766 */ /*TargetOpcode::G_CTLZ*//*Label 92*/ GIMT_Encode4(361767), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 93*/ GIMT_Encode4(362441),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 94*/ GIMT_Encode4(362601),
     /*    782 */ /*TargetOpcode::G_BITREVERSE*//*Label 95*/ GIMT_Encode4(362915),
     /*    786 */ /*TargetOpcode::G_FCEIL*//*Label 96*/ GIMT_Encode4(363069), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 97*/ GIMT_Encode4(363560),
     /*    838 */ /*TargetOpcode::G_FFLOOR*//*Label 98*/ GIMT_Encode4(363860),
     /*    842 */ /*TargetOpcode::G_FRINT*//*Label 99*/ GIMT_Encode4(364351),
     /*    846 */ /*TargetOpcode::G_FNEARBYINT*//*Label 100*/ GIMT_Encode4(364842), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 101*/ GIMT_Encode4(365333),
     /*    878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 102*/ GIMT_Encode4(366459),
     /*    882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 103*/ GIMT_Encode4(367075),
     /*    886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 104*/ GIMT_Encode4(370797), GIMT_Encode4(0),
     /*    894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 105*/ GIMT_Encode4(371413),
     /*    898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 106*/ GIMT_Encode4(387020), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    934 */ /*TargetOpcode::G_TRAP*//*Label 107*/ GIMT_Encode4(387320),
     /*    938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 108*/ GIMT_Encode4(387334),
     /*    942 */ /*TargetOpcode::G_UBSANTRAP*//*Label 109*/ GIMT_Encode4(387355), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    954 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 110*/ GIMT_Encode4(387380), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 111*/ GIMT_Encode4(387690),
     /*    966 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 112*/ GIMT_Encode4(387861),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 113*/ GIMT_Encode4(388032),
     /*    974 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 114*/ GIMT_Encode4(388203),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 115*/ GIMT_Encode4(388374), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    998 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 116*/ GIMT_Encode4(389503),
     /*   1002 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 117*/ GIMT_Encode4(389706),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 118*/ GIMT_Encode4(389909),
     /*   1010 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 119*/ GIMT_Encode4(390112), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3202 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 120*/ GIMT_Encode4(390315), GIMT_Encode4(0),
     /*   3210 */ /*AArch64::G_BSP*//*Label 121*/ GIMT_Encode4(390455),
     /*   3214 */ /*AArch64::G_DUP*//*Label 122*/ GIMT_Encode4(390995),
     /*   3218 */ /*AArch64::G_DUPLANE16*//*Label 123*/ GIMT_Encode4(392818),
     /*   3222 */ /*AArch64::G_DUPLANE32*//*Label 124*/ GIMT_Encode4(393073),
     /*   3226 */ /*AArch64::G_DUPLANE64*//*Label 125*/ GIMT_Encode4(393328),
     /*   3230 */ /*AArch64::G_DUPLANE8*//*Label 126*/ GIMT_Encode4(393474),
     /*   3234 */ /*AArch64::G_EXT*//*Label 127*/ GIMT_Encode4(393653),
     /*   3238 */ /*AArch64::G_FCMEQ*//*Label 128*/ GIMT_Encode4(395303),
     /*   3242 */ /*AArch64::G_FCMEQZ*//*Label 129*/ GIMT_Encode4(395642),
     /*   3246 */ /*AArch64::G_FCMGE*//*Label 130*/ GIMT_Encode4(395872),
     /*   3250 */ /*AArch64::G_FCMGEZ*//*Label 131*/ GIMT_Encode4(396536),
     /*   3254 */ /*AArch64::G_FCMGT*//*Label 132*/ GIMT_Encode4(396766),
     /*   3258 */ /*AArch64::G_FCMGTZ*//*Label 133*/ GIMT_Encode4(397430),
     /*   3262 */ /*AArch64::G_FCMLEZ*//*Label 134*/ GIMT_Encode4(397660),
     /*   3266 */ /*AArch64::G_FCMLTZ*//*Label 135*/ GIMT_Encode4(397890),
     /*   3270 */ /*AArch64::G_REV16*//*Label 136*/ GIMT_Encode4(398120),
     /*   3274 */ /*AArch64::G_REV32*//*Label 137*/ GIMT_Encode4(398274),
     /*   3278 */ /*AArch64::G_REV64*//*Label 138*/ GIMT_Encode4(398450),
     /*   3282 */ /*AArch64::G_SADDLP*//*Label 139*/ GIMT_Encode4(398724),
     /*   3286 */ /*AArch64::G_SADDLV*//*Label 140*/ GIMT_Encode4(398930),
     /*   3290 */ /*AArch64::G_SDOT*//*Label 141*/ GIMT_Encode4(399329),
     /*   3294 */ /*AArch64::G_SITOF*//*Label 142*/ GIMT_Encode4(399699),
     /*   3298 */ /*AArch64::G_SMULL*//*Label 143*/ GIMT_Encode4(399816),
     /*   3302 */ /*AArch64::G_TRN1*//*Label 144*/ GIMT_Encode4(401049),
     /*   3306 */ /*AArch64::G_TRN2*//*Label 145*/ GIMT_Encode4(401829),
     /*   3310 */ /*AArch64::G_UADDLP*//*Label 146*/ GIMT_Encode4(402609),
     /*   3314 */ /*AArch64::G_UADDLV*//*Label 147*/ GIMT_Encode4(402815),
     /*   3318 */ /*AArch64::G_UDOT*//*Label 148*/ GIMT_Encode4(403682),
     /*   3322 */ /*AArch64::G_UITOF*//*Label 149*/ GIMT_Encode4(404052),
     /*   3326 */ /*AArch64::G_UMULL*//*Label 150*/ GIMT_Encode4(404169),
     /*   3330 */ /*AArch64::G_UZP1*//*Label 151*/ GIMT_Encode4(405402),
     /*   3334 */ /*AArch64::G_UZP2*//*Label 152*/ GIMT_Encode4(406182),
     /*   3338 */ /*AArch64::G_VASHR*//*Label 153*/ GIMT_Encode4(406962),
     /*   3342 */ /*AArch64::G_VLSHR*//*Label 154*/ GIMT_Encode4(407660),
     /*   3346 */ /*AArch64::G_ZIP1*//*Label 155*/ GIMT_Encode4(408116),
     /*   3350 */ /*AArch64::G_ZIP2*//*Label 156*/ GIMT_Encode4(408896),
     /*   3354 */ // Label 0: @3354
     /*   3354 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 171*/ GIMT_Encode4(36616),
     /*   3365 */ /*GILLT_s32*//*Label 158*/ GIMT_Encode4(3453),
     /*   3369 */ /*GILLT_s64*//*Label 159*/ GIMT_Encode4(6232), GIMT_Encode4(0),
     /*   3377 */ /*GILLT_v2s32*//*Label 160*/ GIMT_Encode4(11828),
     /*   3381 */ /*GILLT_v2s64*//*Label 161*/ GIMT_Encode4(15436),
     /*   3385 */ /*GILLT_v4s16*//*Label 162*/ GIMT_Encode4(21338),
     /*   3389 */ /*GILLT_v4s32*//*Label 163*/ GIMT_Encode4(24836),
     /*   3393 */ /*GILLT_v8s8*//*Label 164*/ GIMT_Encode4(31014),
     /*   3397 */ /*GILLT_v8s16*//*Label 165*/ GIMT_Encode4(31864),
     /*   3401 */ /*GILLT_v16s8*//*Label 166*/ GIMT_Encode4(35442), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3421 */ /*GILLT_nxv2s64*//*Label 167*/ GIMT_Encode4(36166), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3433 */ /*GILLT_nxv4s32*//*Label 168*/ GIMT_Encode4(36538), GIMT_Encode4(0),
     /*   3441 */ /*GILLT_nxv8s16*//*Label 169*/ GIMT_Encode4(36564), GIMT_Encode4(0),
     /*   3449 */ /*GILLT_nxv16s8*//*Label 170*/ GIMT_Encode4(36590),
     /*   3453 */ // Label 158: @3453
     /*   3453 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(6231),
     /*   3458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3464 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3497), // Rule ID 13117 //
     /*   3469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3484 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3495 */     GIR_RootConstrainSelectedInstOperands,
     /*   3496 */     // GIR_Coverage, 13117,
     /*   3496 */     GIR_EraseRootFromParent_Done,
     /*   3497 */   // Label 173: @3497
     /*   3497 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(3649), // Rule ID 13544 //
     /*   3502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3529 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3532 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3537 */     // MIs[2] pattern
     /*   3537 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3540 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3551 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3551 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3554 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3558 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3565 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3568 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3572 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3577 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3580 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3584 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3587 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3592 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3614 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3631 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3648 */     // GIR_Coverage, 13544,
     /*   3648 */     GIR_EraseRootFromParent_Done,
     /*   3649 */   // Label 174: @3649
     /*   3649 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(3801), // Rule ID 15401 //
     /*   3654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3681 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3684 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3689 */     // MIs[2] pattern
     /*   3689 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3692 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3703 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3703 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3706 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3710 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3717 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3720 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3724 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3729 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3732 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3736 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3739 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3766 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3769 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3773 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3783 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3800 */     // GIR_Coverage, 15401,
     /*   3800 */     GIR_EraseRootFromParent_Done,
     /*   3801 */   // Label 175: @3801
     /*   3801 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(3953), // Rule ID 15413 //
     /*   3806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3833 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3836 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3841 */     // MIs[2] pattern
     /*   3841 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3844 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3855 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3855 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3858 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3862 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3869 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3872 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3876 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3881 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3884 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3888 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3891 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3896 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3901 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3918 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3925 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3935 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3952 */     // GIR_Coverage, 15413,
     /*   3952 */     GIR_EraseRootFromParent_Done,
     /*   3953 */   // Label 176: @3953
     /*   3953 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4105), // Rule ID 15425 //
     /*   3958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3985 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3988 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   3993 */     // MIs[2] pattern
     /*   3993 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3996 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4007 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4007 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4010 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4014 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4033 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4036 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4040 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4048 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4053 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4070 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4077 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4087 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4104 */     // GIR_Coverage, 15425,
     /*   4104 */     GIR_EraseRootFromParent_Done,
     /*   4105 */   // Label 177: @4105
     /*   4105 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4138), // Rule ID 91 //
     /*   4110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4125 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4136 */     GIR_RootConstrainSelectedInstOperands,
     /*   4137 */     // GIR_Coverage, 91,
     /*   4137 */     GIR_EraseRootFromParent_Done,
     /*   4138 */   // Label 178: @4138
     /*   4138 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4290), // Rule ID 2647 //
     /*   4143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4174 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4177 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4182 */     // MIs[2] pattern
     /*   4182 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4185 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4192 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4192 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4195 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4199 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4218 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4221 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4225 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4228 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4262 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4272 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4289 */     // GIR_Coverage, 2647,
     /*   4289 */     GIR_EraseRootFromParent_Done,
     /*   4290 */   // Label 179: @4290
     /*   4290 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4442), // Rule ID 9876 //
     /*   4295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4326 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4329 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4334 */     // MIs[2] pattern
     /*   4334 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4337 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4344 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4344 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4347 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4351 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4358 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4361 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4365 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4370 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4373 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4377 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4380 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4385 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4390 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4407 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4414 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4424 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4441 */     // GIR_Coverage, 9876,
     /*   4441 */     GIR_EraseRootFromParent_Done,
     /*   4442 */   // Label 180: @4442
     /*   4442 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4594), // Rule ID 9888 //
     /*   4447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4478 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4481 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4486 */     // MIs[2] pattern
     /*   4486 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4489 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4496 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4522 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4525 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4529 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4532 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4542 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4566 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4576 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4593 */     // GIR_Coverage, 9888,
     /*   4593 */     GIR_EraseRootFromParent_Done,
     /*   4594 */   // Label 181: @4594
     /*   4594 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4746), // Rule ID 9900 //
     /*   4599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4630 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4633 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4638 */     // MIs[2] pattern
     /*   4638 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4641 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4648 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4648 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4651 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4655 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4662 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4665 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4669 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4674 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4677 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4681 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4684 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4689 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4694 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4711 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4714 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4728 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4745 */     // GIR_Coverage, 9900,
     /*   4745 */     GIR_EraseRootFromParent_Done,
     /*   4746 */   // Label 182: @4746
     /*   4746 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4903), // Rule ID 15444 //
     /*   4751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4778 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4781 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4790 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4797 */     // MIs[2] pred
     /*   4797 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4808 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4808 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4811 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4815 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4822 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4825 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4829 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4834 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4837 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4841 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4844 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4849 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4854 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4875 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4885 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4902 */     // GIR_Coverage, 15444,
     /*   4902 */     GIR_EraseRootFromParent_Done,
     /*   4903 */   // Label 183: @4903
     /*   4903 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5060), // Rule ID 15445 //
     /*   4908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4935 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4938 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   4947 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4954 */     // MIs[2] pred
     /*   4954 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4965 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4965 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4968 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4972 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4979 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4982 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4986 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4991 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4994 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4998 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5006 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5011 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5042 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5059 */     // GIR_Coverage, 15445,
     /*   5059 */     GIR_EraseRootFromParent_Done,
     /*   5060 */   // Label 184: @5060
     /*   5060 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5217), // Rule ID 15446 //
     /*   5065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5092 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5095 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5104 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5111 */     // MIs[2] pred
     /*   5111 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5122 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5122 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5125 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5129 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5136 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5139 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5143 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5148 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5151 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5155 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5163 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5168 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5189 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5199 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5216 */     // GIR_Coverage, 15446,
     /*   5216 */     GIR_EraseRootFromParent_Done,
     /*   5217 */   // Label 185: @5217
     /*   5217 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5374), // Rule ID 15447 //
     /*   5222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5249 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5252 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5261 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5268 */     // MIs[2] pred
     /*   5268 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5279 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5279 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5282 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5286 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5293 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5296 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5300 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5305 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5308 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5312 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5315 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5320 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5325 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5342 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5346 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5356 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5363 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5373 */     // GIR_Coverage, 15447,
     /*   5373 */     GIR_EraseRootFromParent_Done,
     /*   5374 */   // Label 186: @5374
     /*   5374 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(5531), // Rule ID 9992 //
     /*   5379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5410 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5413 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5422 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5429 */     // MIs[2] pred
     /*   5429 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5436 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5436 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5439 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5443 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5450 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5453 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5457 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5462 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5465 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5469 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5472 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5477 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5482 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5499 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5503 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5513 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5530 */     // GIR_Coverage, 9992,
     /*   5530 */     GIR_EraseRootFromParent_Done,
     /*   5531 */   // Label 187: @5531
     /*   5531 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(5688), // Rule ID 9993 //
     /*   5536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5567 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5570 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5579 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5586 */     // MIs[2] pred
     /*   5586 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5593 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5593 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5596 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5600 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5607 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5610 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5614 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5619 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5622 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5626 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5629 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5634 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5639 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5656 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5670 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5687 */     // GIR_Coverage, 9993,
     /*   5687 */     GIR_EraseRootFromParent_Done,
     /*   5688 */   // Label 188: @5688
     /*   5688 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(5845), // Rule ID 9994 //
     /*   5693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5724 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5727 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5736 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5743 */     // MIs[2] pred
     /*   5743 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5750 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5750 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5753 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5757 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5764 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5767 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5771 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5776 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5779 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5783 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5786 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5791 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5796 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5817 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5827 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5844 */     // GIR_Coverage, 9994,
     /*   5844 */     GIR_EraseRootFromParent_Done,
     /*   5845 */   // Label 189: @5845
     /*   5845 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6002), // Rule ID 9995 //
     /*   5850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5881 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5884 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5893 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5900 */     // MIs[2] pred
     /*   5900 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5907 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5907 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5910 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5914 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5921 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5924 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5928 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5933 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5936 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5940 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5943 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5953 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5984 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6001 */     // GIR_Coverage, 9995,
     /*   6001 */     GIR_EraseRootFromParent_Done,
     /*   6002 */   // Label 190: @6002
     /*   6002 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6035), // Rule ID 13121 //
     /*   6007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6022 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6029 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6033 */     GIR_RootConstrainSelectedInstOperands,
     /*   6034 */     // GIR_Coverage, 13121,
     /*   6034 */     GIR_EraseRootFromParent_Done,
     /*   6035 */   // Label 191: @6035
     /*   6035 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6071), // Rule ID 13684 //
     /*   6040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6055 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6069 */     GIR_RootConstrainSelectedInstOperands,
     /*   6070 */     // GIR_Coverage, 13684,
     /*   6070 */     GIR_EraseRootFromParent_Done,
     /*   6071 */   // Label 192: @6071
     /*   6071 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(6104), // Rule ID 97 //
     /*   6076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6091 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6098 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6102 */     GIR_RootConstrainSelectedInstOperands,
     /*   6103 */     // GIR_Coverage, 97,
     /*   6103 */     GIR_EraseRootFromParent_Done,
     /*   6104 */   // Label 193: @6104
     /*   6104 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6140), // Rule ID 3902 //
     /*   6109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6124 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6131 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6138 */     GIR_RootConstrainSelectedInstOperands,
     /*   6139 */     // GIR_Coverage, 3902,
     /*   6139 */     GIR_EraseRootFromParent_Done,
     /*   6140 */   // Label 194: @6140
     /*   6140 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(6173), // Rule ID 13119 //
     /*   6145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6160 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6171 */     GIR_RootConstrainSelectedInstOperands,
     /*   6172 */     // GIR_Coverage, 13119,
     /*   6172 */     GIR_EraseRootFromParent_Done,
     /*   6173 */   // Label 195: @6173
     /*   6173 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(6206), // Rule ID 95 //
     /*   6178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6193 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6200 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6204 */     GIR_RootConstrainSelectedInstOperands,
     /*   6205 */     // GIR_Coverage, 95,
     /*   6205 */     GIR_EraseRootFromParent_Done,
     /*   6206 */   // Label 196: @6206
     /*   6206 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6230), // Rule ID 93 //
     /*   6211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6223 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6228 */     GIR_RootConstrainSelectedInstOperands,
     /*   6229 */     // GIR_Coverage, 93,
     /*   6229 */     GIR_Done,
     /*   6230 */   // Label 197: @6230
     /*   6230 */   GIM_Reject,
     /*   6231 */ // Label 172: @6231
     /*   6231 */ GIM_Reject,
     /*   6232 */ // Label 159: @6232
     /*   6232 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(11827),
     /*   6237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6243 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6379), // Rule ID 5352 //
     /*   6248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6281 */     // MIs[1] Operand 2
     /*   6281 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6300 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6304 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6308 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6312 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6316 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6321 */     // MIs[3] Operand 2
     /*   6321 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6332 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6334 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6346 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6361 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6378 */     // GIR_Coverage, 5352,
     /*   6378 */     GIR_EraseRootFromParent_Done,
     /*   6379 */   // Label 199: @6379
     /*   6379 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6515), // Rule ID 5351 //
     /*   6384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6417 */     // MIs[1] Operand 2
     /*   6417 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6436 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6440 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6444 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6448 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6452 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6457 */     // MIs[3] Operand 2
     /*   6457 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6468 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6470 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6482 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6497 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6504 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6514 */     // GIR_Coverage, 5351,
     /*   6514 */     GIR_EraseRootFromParent_Done,
     /*   6515 */   // Label 200: @6515
     /*   6515 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(6651), // Rule ID 5361 //
     /*   6520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6553 */     // MIs[1] Operand 2
     /*   6553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6572 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6576 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6580 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6584 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6588 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6593 */     // MIs[3] Operand 2
     /*   6593 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6604 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6606 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6633 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6650 */     // GIR_Coverage, 5361,
     /*   6650 */     GIR_EraseRootFromParent_Done,
     /*   6651 */   // Label 201: @6651
     /*   6651 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(6787), // Rule ID 5350 //
     /*   6656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6689 */     // MIs[1] Operand 2
     /*   6689 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6708 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6712 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6716 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6720 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6724 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6729 */     // MIs[3] Operand 2
     /*   6729 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6740 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6742 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6769 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6786 */     // GIR_Coverage, 5350,
     /*   6786 */     GIR_EraseRootFromParent_Done,
     /*   6787 */   // Label 202: @6787
     /*   6787 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(6923), // Rule ID 5349 //
     /*   6792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6825 */     // MIs[1] Operand 2
     /*   6825 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6844 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6852 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6856 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6860 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6865 */     // MIs[3] Operand 2
     /*   6865 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6876 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6878 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6905 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6922 */     // GIR_Coverage, 5349,
     /*   6922 */     GIR_EraseRootFromParent_Done,
     /*   6923 */   // Label 203: @6923
     /*   6923 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(6991), // Rule ID 6864 //
     /*   6928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6953 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   6957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   6961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   6969 */     // MIs[2] Rn
     /*   6969 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   6974 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   6978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   6980 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   6980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   6983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6989 */     GIR_RootConstrainSelectedInstOperands,
     /*   6990 */     // GIR_Coverage, 6864,
     /*   6990 */     GIR_EraseRootFromParent_Done,
     /*   6991 */   // Label 204: @6991
     /*   6991 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7059), // Rule ID 13845 //
     /*   6996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7037 */     // MIs[2] Rn
     /*   7037 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7042 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7048 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7057 */     GIR_RootConstrainSelectedInstOperands,
     /*   7058 */     // GIR_Coverage, 13845,
     /*   7058 */     GIR_EraseRootFromParent_Done,
     /*   7059 */   // Label 205: @7059
     /*   7059 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7092), // Rule ID 13118 //
     /*   7064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7079 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7086 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7090 */     GIR_RootConstrainSelectedInstOperands,
     /*   7091 */     // GIR_Coverage, 13118,
     /*   7091 */     GIR_EraseRootFromParent_Done,
     /*   7092 */   // Label 206: @7092
     /*   7092 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7225), // Rule ID 3954 //
     /*   7097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7134 */     // MIs[2] Operand 2
     /*   7134 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7153 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7157 */     // MIs[3] Operand 1
     /*   7157 */     // No operand predicates
     /*   7157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7163 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7175 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7194 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7223 */     GIR_RootConstrainSelectedInstOperands,
     /*   7224 */     // GIR_Coverage, 3954,
     /*   7224 */     GIR_EraseRootFromParent_Done,
     /*   7225 */   // Label 207: @7225
     /*   7225 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7320), // Rule ID 3952 //
     /*   7230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7275 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7279 */     // MIs[3] Operand 1
     /*   7279 */     // No operand predicates
     /*   7279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7285 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7297 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7318 */     GIR_RootConstrainSelectedInstOperands,
     /*   7319 */     // GIR_Coverage, 3952,
     /*   7319 */     GIR_EraseRootFromParent_Done,
     /*   7320 */   // Label 208: @7320
     /*   7320 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7415), // Rule ID 3953 //
     /*   7325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7370 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7374 */     // MIs[3] Operand 1
     /*   7374 */     // No operand predicates
     /*   7374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7380 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7392 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7413 */     GIR_RootConstrainSelectedInstOperands,
     /*   7414 */     // GIR_Coverage, 3953,
     /*   7414 */     GIR_EraseRootFromParent_Done,
     /*   7415 */   // Label 209: @7415
     /*   7415 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7448), // Rule ID 92 //
     /*   7420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7435 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7442 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7446 */     GIR_RootConstrainSelectedInstOperands,
     /*   7447 */     // GIR_Coverage, 92,
     /*   7447 */     GIR_EraseRootFromParent_Done,
     /*   7448 */   // Label 210: @7448
     /*   7448 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(7581), // Rule ID 13694 //
     /*   7453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7494 */     // MIs[2] Operand 2
     /*   7494 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7513 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7517 */     // MIs[3] Operand 1
     /*   7517 */     // No operand predicates
     /*   7517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7519 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7519 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7522 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7526 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7531 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7550 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7579 */     GIR_RootConstrainSelectedInstOperands,
     /*   7580 */     // GIR_Coverage, 13694,
     /*   7580 */     GIR_EraseRootFromParent_Done,
     /*   7581 */   // Label 211: @7581
     /*   7581 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(7676), // Rule ID 13692 //
     /*   7586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7635 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7639 */     // MIs[3] Operand 1
     /*   7639 */     // No operand predicates
     /*   7639 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7641 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7653 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7674 */     GIR_RootConstrainSelectedInstOperands,
     /*   7675 */     // GIR_Coverage, 13692,
     /*   7675 */     GIR_EraseRootFromParent_Done,
     /*   7676 */   // Label 212: @7676
     /*   7676 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(7771), // Rule ID 13693 //
     /*   7681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7730 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7734 */     // MIs[3] Operand 1
     /*   7734 */     // No operand predicates
     /*   7734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7736 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7748 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7769 */     GIR_RootConstrainSelectedInstOperands,
     /*   7770 */     // GIR_Coverage, 13693,
     /*   7770 */     GIR_EraseRootFromParent_Done,
     /*   7771 */   // Label 213: @7771
     /*   7771 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(7853), // Rule ID 13129 //
     /*   7776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7821 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7825 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7836 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7851 */     GIR_RootConstrainSelectedInstOperands,
     /*   7852 */     // GIR_Coverage, 13129,
     /*   7852 */     GIR_EraseRootFromParent_Done,
     /*   7853 */   // Label 214: @7853
     /*   7853 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(7935), // Rule ID 13130 //
     /*   7858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7903 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7907 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7918 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7933 */     GIR_RootConstrainSelectedInstOperands,
     /*   7934 */     // GIR_Coverage, 13130,
     /*   7934 */     GIR_EraseRootFromParent_Done,
     /*   7935 */   // Label 215: @7935
     /*   7935 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8017), // Rule ID 123 //
     /*   7940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7989 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7993 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8000 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8015 */     GIR_RootConstrainSelectedInstOperands,
     /*   8016 */     // GIR_Coverage, 123,
     /*   8016 */     GIR_EraseRootFromParent_Done,
     /*   8017 */   // Label 216: @8017
     /*   8017 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8099), // Rule ID 125 //
     /*   8022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8071 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8082 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8097 */     GIR_RootConstrainSelectedInstOperands,
     /*   8098 */     // GIR_Coverage, 125,
     /*   8098 */     GIR_EraseRootFromParent_Done,
     /*   8099 */   // Label 217: @8099
     /*   8099 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8157), // Rule ID 13539 //
     /*   8104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8119 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8122 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8127 */     // MIs[1] pattern
     /*   8127 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8130 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8141 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8155 */     GIR_RootConstrainSelectedInstOperands,
     /*   8156 */     // GIR_Coverage, 13539,
     /*   8156 */     GIR_EraseRootFromParent_Done,
     /*   8157 */   // Label 218: @8157
     /*   8157 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8215), // Rule ID 15396 //
     /*   8162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8177 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8180 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8185 */     // MIs[1] pattern
     /*   8185 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8188 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8199 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8213 */     GIR_RootConstrainSelectedInstOperands,
     /*   8214 */     // GIR_Coverage, 15396,
     /*   8214 */     GIR_EraseRootFromParent_Done,
     /*   8215 */   // Label 219: @8215
     /*   8215 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8273), // Rule ID 15408 //
     /*   8220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8235 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8238 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8243 */     // MIs[1] pattern
     /*   8243 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8246 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8257 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8271 */     GIR_RootConstrainSelectedInstOperands,
     /*   8272 */     // GIR_Coverage, 15408,
     /*   8272 */     GIR_EraseRootFromParent_Done,
     /*   8273 */   // Label 220: @8273
     /*   8273 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8331), // Rule ID 15420 //
     /*   8278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8293 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8296 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8301 */     // MIs[1] pattern
     /*   8301 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8304 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8315 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8329 */     GIR_RootConstrainSelectedInstOperands,
     /*   8330 */     // GIR_Coverage, 15420,
     /*   8330 */     GIR_EraseRootFromParent_Done,
     /*   8331 */   // Label 221: @8331
     /*   8331 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8389), // Rule ID 2644 //
     /*   8336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8355 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8358 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8363 */     // MIs[1] pattern
     /*   8363 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8366 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8373 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8387 */     GIR_RootConstrainSelectedInstOperands,
     /*   8388 */     // GIR_Coverage, 2644,
     /*   8388 */     GIR_EraseRootFromParent_Done,
     /*   8389 */   // Label 222: @8389
     /*   8389 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8447), // Rule ID 9873 //
     /*   8394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8413 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8416 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8421 */     // MIs[1] pattern
     /*   8421 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8424 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8431 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8445 */     GIR_RootConstrainSelectedInstOperands,
     /*   8446 */     // GIR_Coverage, 9873,
     /*   8446 */     GIR_EraseRootFromParent_Done,
     /*   8447 */   // Label 223: @8447
     /*   8447 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8505), // Rule ID 9885 //
     /*   8452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8471 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8474 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8479 */     // MIs[1] pattern
     /*   8479 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8482 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8489 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8503 */     GIR_RootConstrainSelectedInstOperands,
     /*   8504 */     // GIR_Coverage, 9885,
     /*   8504 */     GIR_EraseRootFromParent_Done,
     /*   8505 */   // Label 224: @8505
     /*   8505 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(8563), // Rule ID 9897 //
     /*   8510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8529 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8532 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8537 */     // MIs[1] pattern
     /*   8537 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8540 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8547 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8561 */     GIR_RootConstrainSelectedInstOperands,
     /*   8562 */     // GIR_Coverage, 9897,
     /*   8562 */     GIR_EraseRootFromParent_Done,
     /*   8563 */   // Label 225: @8563
     /*   8563 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(8726), // Rule ID 13811 //
     /*   8568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   8592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8605 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8610 */     // MIs[1] Operand 2
     /*   8610 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8627 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8627 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8630 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8634 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8641 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8644 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8648 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8653 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8656 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8660 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8663 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8673 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8690 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8697 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8708 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8725 */     // GIR_Coverage, 13811,
     /*   8725 */     GIR_EraseRootFromParent_Done,
     /*   8726 */   // Label 226: @8726
     /*   8726 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(8889), // Rule ID 13808 //
     /*   8731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8773 */     // MIs[1] Operand 2
     /*   8773 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8790 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8790 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8793 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8797 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8804 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8807 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8811 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8816 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8819 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8823 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8826 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8853 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8871 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8888 */     // GIR_Coverage, 13808,
     /*   8888 */     GIR_EraseRootFromParent_Done,
     /*   8889 */   // Label 227: @8889
     /*   8889 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9039), // Rule ID 13817 //
     /*   8894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8927 */     // MIs[1] Operand 2
     /*   8927 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8944 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8944 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8947 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8951 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8958 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8961 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8965 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8970 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8973 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   8977 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8980 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8985 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8990 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9007 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9021 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9038 */     // GIR_Coverage, 13817,
     /*   9038 */     GIR_EraseRootFromParent_Done,
     /*   9039 */   // Label 228: @9039
     /*   9039 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(9189), // Rule ID 13820 //
     /*   9044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9077 */     // MIs[1] Operand 2
     /*   9077 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9094 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9094 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9097 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9101 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9108 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9111 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9115 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9120 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9123 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9127 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9130 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9135 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9140 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9157 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9160 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9171 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9188 */     // GIR_Coverage, 13820,
     /*   9188 */     GIR_EraseRootFromParent_Done,
     /*   9189 */   // Label 229: @9189
     /*   9189 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(9339), // Rule ID 13816 //
     /*   9194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9227 */     // MIs[1] Operand 2
     /*   9227 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9244 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9244 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9247 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9251 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9258 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9261 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9265 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9270 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9273 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9277 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9285 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9290 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9307 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9321 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9338 */     // GIR_Coverage, 13816,
     /*   9338 */     GIR_EraseRootFromParent_Done,
     /*   9339 */   // Label 230: @9339
     /*   9339 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(9502), // Rule ID 5334 //
     /*   9344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9390 */     // MIs[1] Operand 2
     /*   9390 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9403 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9403 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9406 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9410 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9417 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9420 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9424 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9429 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9432 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9436 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9444 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9449 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9466 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9484 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9496 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9501 */     // GIR_Coverage, 5334,
     /*   9501 */     GIR_EraseRootFromParent_Done,
     /*   9502 */   // Label 231: @9502
     /*   9502 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(9665), // Rule ID 5331 //
     /*   9507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9553 */     // MIs[1] Operand 2
     /*   9553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9566 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9566 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9569 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9573 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9580 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9583 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9587 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9592 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9595 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9599 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9612 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9629 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9647 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9664 */     // GIR_Coverage, 5331,
     /*   9664 */     GIR_EraseRootFromParent_Done,
     /*   9665 */   // Label 232: @9665
     /*   9665 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(9815), // Rule ID 5358 //
     /*   9670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9707 */     // MIs[1] Operand 2
     /*   9707 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9720 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9720 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9723 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9727 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9734 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9737 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9741 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9746 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9749 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9753 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9756 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9761 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9766 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9783 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9797 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9814 */     // GIR_Coverage, 5358,
     /*   9814 */     GIR_EraseRootFromParent_Done,
     /*   9815 */   // Label 233: @9815
     /*   9815 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(9965), // Rule ID 5364 //
     /*   9820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9857 */     // MIs[1] Operand 2
     /*   9857 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9870 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9870 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9873 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9877 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9884 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9887 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9891 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9896 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9899 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9903 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9906 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9911 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9916 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9933 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9936 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9947 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9959 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9964 */     // GIR_Coverage, 5364,
     /*   9964 */     GIR_EraseRootFromParent_Done,
     /*   9965 */   // Label 234: @9965
     /*   9965 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10115), // Rule ID 5357 //
     /*   9970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10007 */     // MIs[1] Operand 2
     /*  10007 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10020 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10020 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10023 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10027 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10034 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10037 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10041 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10046 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10049 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10053 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10056 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10083 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10097 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10114 */     // GIR_Coverage, 5357,
     /*  10114 */     GIR_EraseRootFromParent_Done,
     /*  10115 */   // Label 235: @10115
     /*  10115 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10148), // Rule ID 13122 //
     /*  10120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10135 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10146 */     GIR_RootConstrainSelectedInstOperands,
     /*  10147 */     // GIR_Coverage, 13122,
     /*  10147 */     GIR_EraseRootFromParent_Done,
     /*  10148 */   // Label 236: @10148
     /*  10148 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10184), // Rule ID 13685 //
     /*  10153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10168 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10175 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10182 */     GIR_RootConstrainSelectedInstOperands,
     /*  10183 */     // GIR_Coverage, 13685,
     /*  10183 */     GIR_EraseRootFromParent_Done,
     /*  10184 */   // Label 237: @10184
     /*  10184 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10217), // Rule ID 98 //
     /*  10189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10204 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10211 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10215 */     GIR_RootConstrainSelectedInstOperands,
     /*  10216 */     // GIR_Coverage, 98,
     /*  10216 */     GIR_EraseRootFromParent_Done,
     /*  10217 */   // Label 238: @10217
     /*  10217 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10253), // Rule ID 3903 //
     /*  10222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10237 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10244 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10251 */     GIR_RootConstrainSelectedInstOperands,
     /*  10252 */     // GIR_Coverage, 3903,
     /*  10252 */     GIR_EraseRootFromParent_Done,
     /*  10253 */   // Label 239: @10253
     /*  10253 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10286), // Rule ID 13120 //
     /*  10258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10273 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10280 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10284 */     GIR_RootConstrainSelectedInstOperands,
     /*  10285 */     // GIR_Coverage, 13120,
     /*  10285 */     GIR_EraseRootFromParent_Done,
     /*  10286 */   // Label 240: @10286
     /*  10286 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10349), // Rule ID 15436 //
     /*  10291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10306 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10309 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10318 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10325 */     // MIs[1] pred
     /*  10325 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10336 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10347 */     GIR_RootConstrainSelectedInstOperands,
     /*  10348 */     // GIR_Coverage, 15436,
     /*  10348 */     GIR_EraseRootFromParent_Done,
     /*  10349 */   // Label 241: @10349
     /*  10349 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10412), // Rule ID 15437 //
     /*  10354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10369 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10372 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10388 */     // MIs[1] pred
     /*  10388 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10399 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10410 */     GIR_RootConstrainSelectedInstOperands,
     /*  10411 */     // GIR_Coverage, 15437,
     /*  10411 */     GIR_EraseRootFromParent_Done,
     /*  10412 */   // Label 242: @10412
     /*  10412 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10475), // Rule ID 15438 //
     /*  10417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10432 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10435 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10444 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10451 */     // MIs[1] pred
     /*  10451 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10462 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10473 */     GIR_RootConstrainSelectedInstOperands,
     /*  10474 */     // GIR_Coverage, 15438,
     /*  10474 */     GIR_EraseRootFromParent_Done,
     /*  10475 */   // Label 243: @10475
     /*  10475 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(10538), // Rule ID 15439 //
     /*  10480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10495 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10498 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10507 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10514 */     // MIs[1] pred
     /*  10514 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10525 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10536 */     GIR_RootConstrainSelectedInstOperands,
     /*  10537 */     // GIR_Coverage, 15439,
     /*  10537 */     GIR_EraseRootFromParent_Done,
     /*  10538 */   // Label 244: @10538
     /*  10538 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(10571), // Rule ID 96 //
     /*  10543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10558 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10565 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10569 */     GIR_RootConstrainSelectedInstOperands,
     /*  10570 */     // GIR_Coverage, 96,
     /*  10570 */     GIR_EraseRootFromParent_Done,
     /*  10571 */   // Label 245: @10571
     /*  10571 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(10634), // Rule ID 9984 //
     /*  10576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10595 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10598 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10607 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10614 */     // MIs[1] pred
     /*  10614 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10621 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10632 */     GIR_RootConstrainSelectedInstOperands,
     /*  10633 */     // GIR_Coverage, 9984,
     /*  10633 */     GIR_EraseRootFromParent_Done,
     /*  10634 */   // Label 246: @10634
     /*  10634 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(10697), // Rule ID 9985 //
     /*  10639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10658 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10661 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10670 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10677 */     // MIs[1] pred
     /*  10677 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10684 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10695 */     GIR_RootConstrainSelectedInstOperands,
     /*  10696 */     // GIR_Coverage, 9985,
     /*  10696 */     GIR_EraseRootFromParent_Done,
     /*  10697 */   // Label 247: @10697
     /*  10697 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(10760), // Rule ID 9986 //
     /*  10702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10721 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10724 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10733 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10740 */     // MIs[1] pred
     /*  10740 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10747 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10758 */     GIR_RootConstrainSelectedInstOperands,
     /*  10759 */     // GIR_Coverage, 9986,
     /*  10759 */     GIR_EraseRootFromParent_Done,
     /*  10760 */   // Label 248: @10760
     /*  10760 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(10823), // Rule ID 9987 //
     /*  10765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10784 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10787 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10796 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10803 */     // MIs[1] pred
     /*  10803 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10810 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10821 */     GIR_RootConstrainSelectedInstOperands,
     /*  10822 */     // GIR_Coverage, 9987,
     /*  10822 */     GIR_EraseRootFromParent_Done,
     /*  10823 */   // Label 249: @10823
     /*  10823 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(10879), // Rule ID 13228 //
     /*  10828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10843 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10846 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  10851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10866 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  10869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10877 */     GIR_RootConstrainSelectedInstOperands,
     /*  10878 */     // GIR_Coverage, 13228,
     /*  10878 */     GIR_EraseRootFromParent_Done,
     /*  10879 */   // Label 250: @10879
     /*  10879 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(10935), // Rule ID 13240 //
     /*  10884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10899 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10902 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  10907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10922 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10933 */     GIR_RootConstrainSelectedInstOperands,
     /*  10934 */     // GIR_Coverage, 13240,
     /*  10934 */     GIR_EraseRootFromParent_Done,
     /*  10935 */   // Label 251: @10935
     /*  10935 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11002), // Rule ID 13446 //
     /*  10940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  10955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  10959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10964 */     // MIs[1] imm
     /*  10964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  10968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10972 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  10976 */     // MIs[2] Operand 1
     /*  10976 */     // No operand predicates
     /*  10976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  10984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10986 */     // (add:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  10989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11000 */     GIR_RootConstrainSelectedInstOperands,
     /*  11001 */     // GIR_Coverage, 13446,
     /*  11001 */     GIR_EraseRootFromParent_Done,
     /*  11002 */   // Label 252: @11002
     /*  11002 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11069), // Rule ID 13834 //
     /*  11007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11031 */     // MIs[1] imm
     /*  11031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11039 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11043 */     // MIs[2] Operand 1
     /*  11043 */     // No operand predicates
     /*  11043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11047 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11053 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  11053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11067 */     GIR_RootConstrainSelectedInstOperands,
     /*  11068 */     // GIR_Coverage, 13834,
     /*  11068 */     GIR_EraseRootFromParent_Done,
     /*  11069 */   // Label 253: @11069
     /*  11069 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11136), // Rule ID 13449 //
     /*  11074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11098 */     // MIs[1] imm
     /*  11098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11106 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11110 */     // MIs[2] Operand 1
     /*  11110 */     // No operand predicates
     /*  11110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11114 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11120 */     // (add:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11134 */     GIR_RootConstrainSelectedInstOperands,
     /*  11135 */     // GIR_Coverage, 13449,
     /*  11135 */     GIR_EraseRootFromParent_Done,
     /*  11136 */   // Label 254: @11136
     /*  11136 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11203), // Rule ID 13837 //
     /*  11141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11165 */     // MIs[1] imm
     /*  11165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11173 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11177 */     // MIs[2] Operand 1
     /*  11177 */     // No operand predicates
     /*  11177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11181 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11187 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  11187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11201 */     GIR_RootConstrainSelectedInstOperands,
     /*  11202 */     // GIR_Coverage, 13837,
     /*  11202 */     GIR_EraseRootFromParent_Done,
     /*  11203 */   // Label 255: @11203
     /*  11203 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11259), // Rule ID 990 //
     /*  11208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11227 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11230 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11246 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11257 */     GIR_RootConstrainSelectedInstOperands,
     /*  11258 */     // GIR_Coverage, 990,
     /*  11258 */     GIR_EraseRootFromParent_Done,
     /*  11259 */   // Label 256: @11259
     /*  11259 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11315), // Rule ID 1051 //
     /*  11264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11283 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11286 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11302 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11313 */     GIR_RootConstrainSelectedInstOperands,
     /*  11314 */     // GIR_Coverage, 1051,
     /*  11314 */     GIR_EraseRootFromParent_Done,
     /*  11315 */   // Label 257: @11315
     /*  11315 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11382), // Rule ID 2112 //
     /*  11320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11348 */     // MIs[1] imm
     /*  11348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11356 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11360 */     // MIs[2] Operand 1
     /*  11360 */     // No operand predicates
     /*  11360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11366 */     // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11380 */     GIR_RootConstrainSelectedInstOperands,
     /*  11381 */     // GIR_Coverage, 2112,
     /*  11381 */     GIR_EraseRootFromParent_Done,
     /*  11382 */   // Label 258: @11382
     /*  11382 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11449), // Rule ID 6242 //
     /*  11387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11415 */     // MIs[1] imm
     /*  11415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11423 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11427 */     // MIs[2] Operand 1
     /*  11427 */     // No operand predicates
     /*  11427 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11433 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  11433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11447 */     GIR_RootConstrainSelectedInstOperands,
     /*  11448 */     // GIR_Coverage, 6242,
     /*  11448 */     GIR_EraseRootFromParent_Done,
     /*  11449 */   // Label 259: @11449
     /*  11449 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11516), // Rule ID 2121 //
     /*  11454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11482 */     // MIs[1] imm
     /*  11482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11490 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11494 */     // MIs[2] Operand 1
     /*  11494 */     // No operand predicates
     /*  11494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11500 */     // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11514 */     GIR_RootConstrainSelectedInstOperands,
     /*  11515 */     // GIR_Coverage, 2121,
     /*  11515 */     GIR_EraseRootFromParent_Done,
     /*  11516 */   // Label 260: @11516
     /*  11516 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11583), // Rule ID 6248 //
     /*  11521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11549 */     // MIs[1] imm
     /*  11549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11557 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11561 */     // MIs[2] Operand 1
     /*  11561 */     // No operand predicates
     /*  11561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11567 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  11567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11581 */     GIR_RootConstrainSelectedInstOperands,
     /*  11582 */     // GIR_Coverage, 6248,
     /*  11582 */     GIR_EraseRootFromParent_Done,
     /*  11583 */   // Label 261: @11583
     /*  11583 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11631), // Rule ID 13227 //
     /*  11588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11618 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11629 */     GIR_RootConstrainSelectedInstOperands,
     /*  11630 */     // GIR_Coverage, 13227,
     /*  11630 */     GIR_EraseRootFromParent_Done,
     /*  11631 */   // Label 262: @11631
     /*  11631 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11679), // Rule ID 13239 //
     /*  11636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11666 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11677 */     GIR_RootConstrainSelectedInstOperands,
     /*  11678 */     // GIR_Coverage, 13239,
     /*  11678 */     GIR_EraseRootFromParent_Done,
     /*  11679 */   // Label 263: @11679
     /*  11679 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(11727), // Rule ID 989 //
     /*  11684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11714 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11725 */     GIR_RootConstrainSelectedInstOperands,
     /*  11726 */     // GIR_Coverage, 989,
     /*  11726 */     GIR_EraseRootFromParent_Done,
     /*  11727 */   // Label 264: @11727
     /*  11727 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(11775), // Rule ID 1050 //
     /*  11732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11762 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11773 */     GIR_RootConstrainSelectedInstOperands,
     /*  11774 */     // GIR_Coverage, 1050,
     /*  11774 */     GIR_EraseRootFromParent_Done,
     /*  11775 */   // Label 265: @11775
     /*  11775 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(11799), // Rule ID 94 //
     /*  11780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11792 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  11792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  11797 */     GIR_RootConstrainSelectedInstOperands,
     /*  11798 */     // GIR_Coverage, 94,
     /*  11798 */     GIR_Done,
     /*  11799 */   // Label 266: @11799
     /*  11799 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(11826), // Rule ID 1600 //
     /*  11804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11819 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  11819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  11824 */     GIR_RootConstrainSelectedInstOperands,
     /*  11825 */     // GIR_Coverage, 1600,
     /*  11825 */     GIR_Done,
     /*  11826 */   // Label 267: @11826
     /*  11826 */   GIM_Reject,
     /*  11827 */ // Label 198: @11827
     /*  11827 */ GIM_Reject,
     /*  11828 */ // Label 160: @11828
     /*  11828 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(15435),
     /*  11833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11839 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12027), // Rule ID 6885 //
     /*  11844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11881 */     // MIs[2] Operand 2
     /*  11881 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11900 */     // MIs[3] Rn
     /*  11900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11905 */     // MIs[3] Operand 2
     /*  11905 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11916 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11920 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11924 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11928 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11932 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11936 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11940 */     // MIs[5] Rn
     /*  11940 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11945 */     // MIs[5] Operand 2
     /*  11945 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11956 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11960 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11964 */     // MIs[6] Rn
     /*  11964 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11969 */     // MIs[6] Operand 2
     /*  11969 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11980 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11982 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11998 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12009 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12026 */     // GIR_Coverage, 6885,
     /*  12026 */     GIR_EraseRootFromParent_Done,
     /*  12027 */   // Label 269: @12027
     /*  12027 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12215), // Rule ID 13856 //
     /*  12032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  12044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12069 */     // MIs[2] Operand 2
     /*  12069 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  12080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  12084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12088 */     // MIs[3] Rn
     /*  12088 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12093 */     // MIs[3] Operand 2
     /*  12093 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  12104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  12108 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  12112 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12116 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12120 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  12124 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12128 */     // MIs[5] Rn
     /*  12128 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12133 */     // MIs[5] Operand 2
     /*  12133 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  12144 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  12148 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12152 */     // MIs[6] Rn
     /*  12152 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12157 */     // MIs[6] Operand 2
     /*  12157 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  12168 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12170 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  12170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  12173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  12177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12197 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12214 */     // GIR_Coverage, 13856,
     /*  12214 */     GIR_EraseRootFromParent_Done,
     /*  12215 */   // Label 270: @12215
     /*  12215 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12351), // Rule ID 5348 //
     /*  12220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12253 */     // MIs[1] Operand 2
     /*  12253 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12272 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12276 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12280 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12284 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12288 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12293 */     // MIs[3] Operand 2
     /*  12293 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12304 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12306 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12318 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12333 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12350 */     // GIR_Coverage, 5348,
     /*  12350 */     GIR_EraseRootFromParent_Done,
     /*  12351 */   // Label 271: @12351
     /*  12351 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12487), // Rule ID 5347 //
     /*  12356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12389 */     // MIs[1] Operand 2
     /*  12389 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12408 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12420 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12424 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12429 */     // MIs[3] Operand 2
     /*  12429 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12440 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12442 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12469 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12486 */     // GIR_Coverage, 5347,
     /*  12486 */     GIR_EraseRootFromParent_Done,
     /*  12487 */   // Label 272: @12487
     /*  12487 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12623), // Rule ID 5360 //
     /*  12492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12525 */     // MIs[1] Operand 2
     /*  12525 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12544 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12548 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12552 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12556 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12560 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12565 */     // MIs[3] Operand 2
     /*  12565 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12576 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12578 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12605 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12622 */     // GIR_Coverage, 5360,
     /*  12622 */     GIR_EraseRootFromParent_Done,
     /*  12623 */   // Label 273: @12623
     /*  12623 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12759), // Rule ID 5346 //
     /*  12628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12661 */     // MIs[1] Operand 2
     /*  12661 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12680 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12684 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12688 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12692 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12696 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12701 */     // MIs[3] Operand 2
     /*  12701 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12712 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12714 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12741 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12758 */     // GIR_Coverage, 5346,
     /*  12758 */     GIR_EraseRootFromParent_Done,
     /*  12759 */   // Label 274: @12759
     /*  12759 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12895), // Rule ID 5345 //
     /*  12764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12797 */     // MIs[1] Operand 2
     /*  12797 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12816 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12820 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12824 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12828 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12832 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12837 */     // MIs[3] Operand 2
     /*  12837 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12848 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12850 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12877 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12889 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12894 */     // GIR_Coverage, 5345,
     /*  12894 */     GIR_EraseRootFromParent_Done,
     /*  12895 */   // Label 275: @12895
     /*  12895 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13058), // Rule ID 13810 //
     /*  12900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  12924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12942 */     // MIs[1] Operand 2
     /*  12942 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12959 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12959 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12962 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12966 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12973 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12976 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12980 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12985 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12988 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12992 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12995 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13000 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13005 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13022 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13040 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13057 */     // GIR_Coverage, 13810,
     /*  13057 */     GIR_EraseRootFromParent_Done,
     /*  13058 */   // Label 276: @13058
     /*  13058 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13221), // Rule ID 13807 //
     /*  13063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13105 */     // MIs[1] Operand 2
     /*  13105 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13122 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13122 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13125 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13129 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13136 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13139 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13143 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13148 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13151 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  13155 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13163 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13168 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13185 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13192 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13203 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13215 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13220 */     // GIR_Coverage, 13807,
     /*  13220 */     GIR_EraseRootFromParent_Done,
     /*  13221 */   // Label 277: @13221
     /*  13221 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(13371), // Rule ID 13815 //
     /*  13226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13259 */     // MIs[1] Operand 2
     /*  13259 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13276 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13276 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13279 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13283 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13290 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13293 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13297 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13302 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13305 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13309 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13312 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13317 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13322 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13339 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13342 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13353 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13370 */     // GIR_Coverage, 13815,
     /*  13370 */     GIR_EraseRootFromParent_Done,
     /*  13371 */   // Label 278: @13371
     /*  13371 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(13521), // Rule ID 13819 //
     /*  13376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13409 */     // MIs[1] Operand 2
     /*  13409 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13426 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13426 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13429 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13433 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13440 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13443 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13447 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13452 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13455 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13459 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13462 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13467 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13472 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13489 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13503 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13510 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13520 */     // GIR_Coverage, 13819,
     /*  13520 */     GIR_EraseRootFromParent_Done,
     /*  13521 */   // Label 279: @13521
     /*  13521 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(13671), // Rule ID 13814 //
     /*  13526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13559 */     // MIs[1] Operand 2
     /*  13559 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13574 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13576 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13576 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13579 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13583 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13590 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13593 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13597 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13602 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13605 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13609 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13612 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13617 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13622 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13639 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13653 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13670 */     // GIR_Coverage, 13814,
     /*  13670 */     GIR_EraseRootFromParent_Done,
     /*  13671 */   // Label 280: @13671
     /*  13671 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13834), // Rule ID 5333 //
     /*  13676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13722 */     // MIs[1] Operand 2
     /*  13722 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13735 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13735 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13738 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13742 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13749 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13752 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13756 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13761 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13764 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13768 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13771 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13776 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13781 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13798 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13801 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13816 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13833 */     // GIR_Coverage, 5333,
     /*  13833 */     GIR_EraseRootFromParent_Done,
     /*  13834 */   // Label 281: @13834
     /*  13834 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13997), // Rule ID 5330 //
     /*  13839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13885 */     // MIs[1] Operand 2
     /*  13885 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13898 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13898 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13901 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13905 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13912 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13915 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13919 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13924 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13927 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13931 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13934 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13939 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13944 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13961 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13968 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13979 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13996 */     // GIR_Coverage, 5330,
     /*  13996 */     GIR_EraseRootFromParent_Done,
     /*  13997 */   // Label 282: @13997
     /*  13997 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14147), // Rule ID 5356 //
     /*  14002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  14030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14039 */     // MIs[1] Operand 2
     /*  14039 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14052 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14052 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14055 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14059 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14066 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14069 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14073 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14078 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14081 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14085 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14088 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14098 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14115 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14129 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14146 */     // GIR_Coverage, 5356,
     /*  14146 */     GIR_EraseRootFromParent_Done,
     /*  14147 */   // Label 283: @14147
     /*  14147 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14297), // Rule ID 5363 //
     /*  14152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  14180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14189 */     // MIs[1] Operand 2
     /*  14189 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14202 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14202 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14205 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14209 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14216 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14219 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14223 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14228 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14231 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14235 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14243 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14248 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14265 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14279 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14296 */     // GIR_Coverage, 5363,
     /*  14296 */     GIR_EraseRootFromParent_Done,
     /*  14297 */   // Label 284: @14297
     /*  14297 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14447), // Rule ID 5355 //
     /*  14302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14339 */     // MIs[1] Operand 2
     /*  14339 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14352 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14352 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14355 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14359 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14366 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14369 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14373 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14378 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14381 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14385 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14388 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14393 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14398 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14415 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14429 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14446 */     // GIR_Coverage, 5355,
     /*  14446 */     GIR_EraseRootFromParent_Done,
     /*  14447 */   // Label 285: @14447
     /*  14447 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14516), // Rule ID 13262 //
     /*  14452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14467 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14470 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14479 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14499 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14514 */     GIR_RootConstrainSelectedInstOperands,
     /*  14515 */     // GIR_Coverage, 13262,
     /*  14515 */     GIR_EraseRootFromParent_Done,
     /*  14516 */   // Label 286: @14516
     /*  14516 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(14585), // Rule ID 13274 //
     /*  14521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14536 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14539 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14548 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14568 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14583 */     GIR_RootConstrainSelectedInstOperands,
     /*  14584 */     // GIR_Coverage, 13274,
     /*  14584 */     GIR_EraseRootFromParent_Done,
     /*  14585 */   // Label 287: @14585
     /*  14585 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(14641), // Rule ID 13224 //
     /*  14590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14605 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14608 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14628 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14639 */     GIR_RootConstrainSelectedInstOperands,
     /*  14640 */     // GIR_Coverage, 13224,
     /*  14640 */     GIR_EraseRootFromParent_Done,
     /*  14641 */   // Label 288: @14641
     /*  14641 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(14697), // Rule ID 13236 //
     /*  14646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14661 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14664 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14684 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14695 */     GIR_RootConstrainSelectedInstOperands,
     /*  14696 */     // GIR_Coverage, 13236,
     /*  14696 */     GIR_EraseRootFromParent_Done,
     /*  14697 */   // Label 289: @14697
     /*  14697 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(14764), // Rule ID 13466 //
     /*  14702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14726 */     // MIs[1] imm
     /*  14726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14734 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14738 */     // MIs[2] Operand 1
     /*  14738 */     // No operand predicates
     /*  14738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14742 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14748 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14762 */     GIR_RootConstrainSelectedInstOperands,
     /*  14763 */     // GIR_Coverage, 13466,
     /*  14763 */     GIR_EraseRootFromParent_Done,
     /*  14764 */   // Label 290: @14764
     /*  14764 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(14831), // Rule ID 13487 //
     /*  14769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14793 */     // MIs[1] imm
     /*  14793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14801 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14805 */     // MIs[2] Operand 1
     /*  14805 */     // No operand predicates
     /*  14805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14809 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14815 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14829 */     GIR_RootConstrainSelectedInstOperands,
     /*  14830 */     // GIR_Coverage, 13487,
     /*  14830 */     GIR_EraseRootFromParent_Done,
     /*  14831 */   // Label 291: @14831
     /*  14831 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(14900), // Rule ID 1358 //
     /*  14836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14855 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14858 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14867 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14883 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14898 */     GIR_RootConstrainSelectedInstOperands,
     /*  14899 */     // GIR_Coverage, 1358,
     /*  14899 */     GIR_EraseRootFromParent_Done,
     /*  14900 */   // Label 292: @14900
     /*  14900 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(14969), // Rule ID 1481 //
     /*  14905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14924 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14927 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14936 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14952 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14967 */     GIR_RootConstrainSelectedInstOperands,
     /*  14968 */     // GIR_Coverage, 1481,
     /*  14968 */     GIR_EraseRootFromParent_Done,
     /*  14969 */   // Label 293: @14969
     /*  14969 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(15025), // Rule ID 986 //
     /*  14974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14993 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14996 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  15001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15012 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15023 */     GIR_RootConstrainSelectedInstOperands,
     /*  15024 */     // GIR_Coverage, 986,
     /*  15024 */     GIR_EraseRootFromParent_Done,
     /*  15025 */   // Label 294: @15025
     /*  15025 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15081), // Rule ID 1047 //
     /*  15030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15049 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15052 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  15057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15068 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15079 */     GIR_RootConstrainSelectedInstOperands,
     /*  15080 */     // GIR_Coverage, 1047,
     /*  15080 */     GIR_EraseRootFromParent_Done,
     /*  15081 */   // Label 295: @15081
     /*  15081 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(15148), // Rule ID 2229 //
     /*  15086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  15105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15114 */     // MIs[1] imm
     /*  15114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15122 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15126 */     // MIs[2] Operand 1
     /*  15126 */     // No operand predicates
     /*  15126 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15132 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  15135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15146 */     GIR_RootConstrainSelectedInstOperands,
     /*  15147 */     // GIR_Coverage, 2229,
     /*  15147 */     GIR_EraseRootFromParent_Done,
     /*  15148 */   // Label 296: @15148
     /*  15148 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15215), // Rule ID 2288 //
     /*  15153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  15172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15181 */     // MIs[1] imm
     /*  15181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15189 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15193 */     // MIs[2] Operand 1
     /*  15193 */     // No operand predicates
     /*  15193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15199 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  15202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15213 */     GIR_RootConstrainSelectedInstOperands,
     /*  15214 */     // GIR_Coverage, 2288,
     /*  15214 */     GIR_EraseRootFromParent_Done,
     /*  15215 */   // Label 297: @15215
     /*  15215 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15263), // Rule ID 13223 //
     /*  15220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15250 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15261 */     GIR_RootConstrainSelectedInstOperands,
     /*  15262 */     // GIR_Coverage, 13223,
     /*  15262 */     GIR_EraseRootFromParent_Done,
     /*  15263 */   // Label 298: @15263
     /*  15263 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15311), // Rule ID 13235 //
     /*  15268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15298 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15309 */     GIR_RootConstrainSelectedInstOperands,
     /*  15310 */     // GIR_Coverage, 13235,
     /*  15310 */     GIR_EraseRootFromParent_Done,
     /*  15311 */   // Label 299: @15311
     /*  15311 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15359), // Rule ID 985 //
     /*  15316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15346 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15351 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15357 */     GIR_RootConstrainSelectedInstOperands,
     /*  15358 */     // GIR_Coverage, 985,
     /*  15358 */     GIR_EraseRootFromParent_Done,
     /*  15359 */   // Label 300: @15359
     /*  15359 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15407), // Rule ID 1046 //
     /*  15364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15394 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15405 */     GIR_RootConstrainSelectedInstOperands,
     /*  15406 */     // GIR_Coverage, 1046,
     /*  15406 */     GIR_EraseRootFromParent_Done,
     /*  15407 */   // Label 301: @15407
     /*  15407 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15434), // Rule ID 1097 //
     /*  15412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15427 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15432 */     GIR_RootConstrainSelectedInstOperands,
     /*  15433 */     // GIR_Coverage, 1097,
     /*  15433 */     GIR_Done,
     /*  15434 */   // Label 302: @15434
     /*  15434 */   GIM_Reject,
     /*  15435 */ // Label 268: @15435
     /*  15435 */ GIM_Reject,
     /*  15436 */ // Label 161: @15436
     /*  15436 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(21337),
     /*  15441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15447 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(15565), // Rule ID 13401 //
     /*  15452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15495 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15499 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15503 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15508 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15512 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15516 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15520 */     // MIs[4] Operand 1
     /*  15520 */     // No operand predicates
     /*  15520 */     // MIs[2] Operand 2
     /*  15520 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15535 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15544 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15563 */     GIR_RootConstrainSelectedInstOperands,
     /*  15564 */     // GIR_Coverage, 13401,
     /*  15564 */     GIR_EraseRootFromParent_Done,
     /*  15565 */   // Label 304: @15565
     /*  15565 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(15683), // Rule ID 13402 //
     /*  15570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15613 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15617 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15621 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15626 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15630 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15634 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15638 */     // MIs[4] Operand 1
     /*  15638 */     // No operand predicates
     /*  15638 */     // MIs[2] Operand 2
     /*  15638 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15653 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15662 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15681 */     GIR_RootConstrainSelectedInstOperands,
     /*  15682 */     // GIR_Coverage, 13402,
     /*  15682 */     GIR_EraseRootFromParent_Done,
     /*  15683 */   // Label 305: @15683
     /*  15683 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(15801), // Rule ID 13431 //
     /*  15688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15731 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15735 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15739 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15744 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15748 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15752 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15756 */     // MIs[4] Operand 1
     /*  15756 */     // No operand predicates
     /*  15756 */     // MIs[2] Operand 2
     /*  15756 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15771 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15780 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15799 */     GIR_RootConstrainSelectedInstOperands,
     /*  15800 */     // GIR_Coverage, 13431,
     /*  15800 */     GIR_EraseRootFromParent_Done,
     /*  15801 */   // Label 306: @15801
     /*  15801 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(15919), // Rule ID 13432 //
     /*  15806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15849 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15853 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15857 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15862 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15866 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15870 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15874 */     // MIs[4] Operand 1
     /*  15874 */     // No operand predicates
     /*  15874 */     // MIs[2] Operand 2
     /*  15874 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15889 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15898 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15917 */     GIR_RootConstrainSelectedInstOperands,
     /*  15918 */     // GIR_Coverage, 13432,
     /*  15918 */     GIR_EraseRootFromParent_Done,
     /*  15919 */   // Label 307: @15919
     /*  15919 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16037), // Rule ID 2035 //
     /*  15924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15971 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15975 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15979 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15988 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15992 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15996 */     // MIs[4] Operand 1
     /*  15996 */     // No operand predicates
     /*  15996 */     // MIs[2] Operand 2
     /*  15996 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16007 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16016 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16035 */     GIR_RootConstrainSelectedInstOperands,
     /*  16036 */     // GIR_Coverage, 2035,
     /*  16036 */     GIR_EraseRootFromParent_Done,
     /*  16037 */   // Label 308: @16037
     /*  16037 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16155), // Rule ID 13400 //
     /*  16042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16089 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16093 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16097 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16102 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16106 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16110 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16114 */     // MIs[4] Operand 1
     /*  16114 */     // No operand predicates
     /*  16114 */     // MIs[2] Operand 2
     /*  16114 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16125 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16134 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16153 */     GIR_RootConstrainSelectedInstOperands,
     /*  16154 */     // GIR_Coverage, 13400,
     /*  16154 */     GIR_EraseRootFromParent_Done,
     /*  16155 */   // Label 309: @16155
     /*  16155 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16273), // Rule ID 2087 //
     /*  16160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16207 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16211 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16215 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16220 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16224 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16228 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16232 */     // MIs[4] Operand 1
     /*  16232 */     // No operand predicates
     /*  16232 */     // MIs[2] Operand 2
     /*  16232 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16243 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16252 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16271 */     GIR_RootConstrainSelectedInstOperands,
     /*  16272 */     // GIR_Coverage, 2087,
     /*  16272 */     GIR_EraseRootFromParent_Done,
     /*  16273 */   // Label 310: @16273
     /*  16273 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16391), // Rule ID 13430 //
     /*  16278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16325 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16329 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16333 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16338 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16342 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16346 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16350 */     // MIs[4] Operand 1
     /*  16350 */     // No operand predicates
     /*  16350 */     // MIs[2] Operand 2
     /*  16350 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16361 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16370 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16389 */     GIR_RootConstrainSelectedInstOperands,
     /*  16390 */     // GIR_Coverage, 13430,
     /*  16390 */     GIR_EraseRootFromParent_Done,
     /*  16391 */   // Label 311: @16391
     /*  16391 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16478), // Rule ID 13306 //
     /*  16396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16423 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16426 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16435 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16459 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16476 */     GIR_RootConstrainSelectedInstOperands,
     /*  16477 */     // GIR_Coverage, 13306,
     /*  16477 */     GIR_EraseRootFromParent_Done,
     /*  16478 */   // Label 312: @16478
     /*  16478 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(16565), // Rule ID 13330 //
     /*  16483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16510 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16513 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16522 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16546 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16563 */     GIR_RootConstrainSelectedInstOperands,
     /*  16564 */     // GIR_Coverage, 13330,
     /*  16564 */     GIR_EraseRootFromParent_Done,
     /*  16565 */   // Label 313: @16565
     /*  16565 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(16652), // Rule ID 1692 //
     /*  16570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16601 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16604 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16613 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16619 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16633 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16650 */     GIR_RootConstrainSelectedInstOperands,
     /*  16651 */     // GIR_Coverage, 1692,
     /*  16651 */     GIR_EraseRootFromParent_Done,
     /*  16652 */   // Label 314: @16652
     /*  16652 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(16739), // Rule ID 1770 //
     /*  16657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16688 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16691 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16700 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16706 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16720 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16737 */     GIR_RootConstrainSelectedInstOperands,
     /*  16738 */     // GIR_Coverage, 1770,
     /*  16738 */     GIR_EraseRootFromParent_Done,
     /*  16739 */   // Label 315: @16739
     /*  16739 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(16854), // Rule ID 13396 //
     /*  16744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16787 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16791 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16795 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16800 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16804 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16808 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16812 */     // MIs[4] Operand 1
     /*  16812 */     // No operand predicates
     /*  16812 */     // MIs[2] Operand 2
     /*  16812 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16832 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16834 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16852 */     GIR_RootConstrainSelectedInstOperands,
     /*  16853 */     // GIR_Coverage, 13396,
     /*  16853 */     GIR_EraseRootFromParent_Done,
     /*  16854 */   // Label 316: @16854
     /*  16854 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(16969), // Rule ID 13395 //
     /*  16859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16903 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16907 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16911 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16915 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16920 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16924 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16928 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16932 */     // MIs[4] Operand 1
     /*  16932 */     // No operand predicates
     /*  16932 */     // MIs[2] Operand 2
     /*  16932 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16947 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16949 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16967 */     GIR_RootConstrainSelectedInstOperands,
     /*  16968 */     // GIR_Coverage, 13395,
     /*  16968 */     GIR_EraseRootFromParent_Done,
     /*  16969 */   // Label 317: @16969
     /*  16969 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17084), // Rule ID 13426 //
     /*  16974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17017 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17021 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17025 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17030 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17034 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17038 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17042 */     // MIs[4] Operand 1
     /*  17042 */     // No operand predicates
     /*  17042 */     // MIs[2] Operand 2
     /*  17042 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17062 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17064 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17082 */     GIR_RootConstrainSelectedInstOperands,
     /*  17083 */     // GIR_Coverage, 13426,
     /*  17083 */     GIR_EraseRootFromParent_Done,
     /*  17084 */   // Label 318: @17084
     /*  17084 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17199), // Rule ID 13425 //
     /*  17089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17137 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17141 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17145 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17150 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17154 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17158 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17162 */     // MIs[4] Operand 1
     /*  17162 */     // No operand predicates
     /*  17162 */     // MIs[2] Operand 2
     /*  17162 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17177 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17179 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17197 */     GIR_RootConstrainSelectedInstOperands,
     /*  17198 */     // GIR_Coverage, 13425,
     /*  17198 */     GIR_EraseRootFromParent_Done,
     /*  17199 */   // Label 319: @17199
     /*  17199 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17268), // Rule ID 1794 //
     /*  17204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17251 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17266 */     GIR_RootConstrainSelectedInstOperands,
     /*  17267 */     // GIR_Coverage, 1794,
     /*  17267 */     GIR_EraseRootFromParent_Done,
     /*  17268 */   // Label 320: @17268
     /*  17268 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17337), // Rule ID 1793 //
     /*  17273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17313 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17320 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17335 */     GIR_RootConstrainSelectedInstOperands,
     /*  17336 */     // GIR_Coverage, 1793,
     /*  17336 */     GIR_EraseRootFromParent_Done,
     /*  17337 */   // Label 321: @17337
     /*  17337 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17406), // Rule ID 1710 //
     /*  17342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17382 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17389 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17404 */     GIR_RootConstrainSelectedInstOperands,
     /*  17405 */     // GIR_Coverage, 1710,
     /*  17405 */     GIR_EraseRootFromParent_Done,
     /*  17406 */   // Label 322: @17406
     /*  17406 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17475), // Rule ID 1792 //
     /*  17411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17458 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17473 */     GIR_RootConstrainSelectedInstOperands,
     /*  17474 */     // GIR_Coverage, 1792,
     /*  17474 */     GIR_EraseRootFromParent_Done,
     /*  17475 */   // Label 323: @17475
     /*  17475 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17544), // Rule ID 1791 //
     /*  17480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17520 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17527 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17542 */     GIR_RootConstrainSelectedInstOperands,
     /*  17543 */     // GIR_Coverage, 1791,
     /*  17543 */     GIR_EraseRootFromParent_Done,
     /*  17544 */   // Label 324: @17544
     /*  17544 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(17659), // Rule ID 13394 //
     /*  17549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17596 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17600 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17604 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17609 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17613 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17617 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17621 */     // MIs[4] Operand 1
     /*  17621 */     // No operand predicates
     /*  17621 */     // MIs[2] Operand 2
     /*  17621 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17637 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17639 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17657 */     GIR_RootConstrainSelectedInstOperands,
     /*  17658 */     // GIR_Coverage, 13394,
     /*  17658 */     GIR_EraseRootFromParent_Done,
     /*  17659 */   // Label 325: @17659
     /*  17659 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(17774), // Rule ID 2033 //
     /*  17664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17716 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17720 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17724 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17729 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17733 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17737 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17741 */     // MIs[4] Operand 1
     /*  17741 */     // No operand predicates
     /*  17741 */     // MIs[2] Operand 2
     /*  17741 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17752 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17754 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17772 */     GIR_RootConstrainSelectedInstOperands,
     /*  17773 */     // GIR_Coverage, 2033,
     /*  17773 */     GIR_EraseRootFromParent_Done,
     /*  17774 */   // Label 326: @17774
     /*  17774 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(17889), // Rule ID 13424 //
     /*  17779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17826 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17830 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17834 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17839 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17843 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17847 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17851 */     // MIs[4] Operand 1
     /*  17851 */     // No operand predicates
     /*  17851 */     // MIs[2] Operand 2
     /*  17851 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17867 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17869 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17887 */     GIR_RootConstrainSelectedInstOperands,
     /*  17888 */     // GIR_Coverage, 13424,
     /*  17888 */     GIR_EraseRootFromParent_Done,
     /*  17889 */   // Label 327: @17889
     /*  17889 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18004), // Rule ID 2085 //
     /*  17894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17946 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17950 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17954 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17959 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17963 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17967 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17971 */     // MIs[4] Operand 1
     /*  17971 */     // No operand predicates
     /*  17971 */     // MIs[2] Operand 2
     /*  17971 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17982 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17984 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18002 */     GIR_RootConstrainSelectedInstOperands,
     /*  18003 */     // GIR_Coverage, 2085,
     /*  18003 */     GIR_EraseRootFromParent_Done,
     /*  18004 */   // Label 328: @18004
     /*  18004 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18071), // Rule ID 13318 //
     /*  18009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18052 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  18055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18069 */     GIR_RootConstrainSelectedInstOperands,
     /*  18070 */     // GIR_Coverage, 13318,
     /*  18070 */     GIR_EraseRootFromParent_Done,
     /*  18071 */   // Label 329: @18071
     /*  18071 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18138), // Rule ID 13348 //
     /*  18076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18119 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18136 */     GIR_RootConstrainSelectedInstOperands,
     /*  18137 */     // GIR_Coverage, 13348,
     /*  18137 */     GIR_EraseRootFromParent_Done,
     /*  18138 */   // Label 330: @18138
     /*  18138 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18205), // Rule ID 1722 //
     /*  18143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18186 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  18189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18203 */     GIR_RootConstrainSelectedInstOperands,
     /*  18204 */     // GIR_Coverage, 1722,
     /*  18204 */     GIR_EraseRootFromParent_Done,
     /*  18205 */   // Label 331: @18205
     /*  18205 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18272), // Rule ID 1812 //
     /*  18210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18253 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18270 */     GIR_RootConstrainSelectedInstOperands,
     /*  18271 */     // GIR_Coverage, 1812,
     /*  18271 */     GIR_EraseRootFromParent_Done,
     /*  18272 */   // Label 332: @18272
     /*  18272 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18353), // Rule ID 13304 //
     /*  18277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18304 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18307 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18316 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18336 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18351 */     GIR_RootConstrainSelectedInstOperands,
     /*  18352 */     // GIR_Coverage, 13304,
     /*  18352 */     GIR_EraseRootFromParent_Done,
     /*  18353 */   // Label 333: @18353
     /*  18353 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18434), // Rule ID 13328 //
     /*  18358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18385 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18388 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18397 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18417 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18432 */     GIR_RootConstrainSelectedInstOperands,
     /*  18433 */     // GIR_Coverage, 13328,
     /*  18433 */     GIR_EraseRootFromParent_Done,
     /*  18434 */   // Label 334: @18434
     /*  18434 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18515), // Rule ID 1690 //
     /*  18439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18470 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18473 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18482 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18498 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18513 */     GIR_RootConstrainSelectedInstOperands,
     /*  18514 */     // GIR_Coverage, 1690,
     /*  18514 */     GIR_EraseRootFromParent_Done,
     /*  18515 */   // Label 335: @18515
     /*  18515 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(18596), // Rule ID 1768 //
     /*  18520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18551 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18554 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18563 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18579 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18594 */     GIR_RootConstrainSelectedInstOperands,
     /*  18595 */     // GIR_Coverage, 1768,
     /*  18595 */     GIR_EraseRootFromParent_Done,
     /*  18596 */   // Label 336: @18596
     /*  18596 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(18688), // Rule ID 13399 //
     /*  18601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18649 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18653 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18657 */     // MIs[3] Operand 1
     /*  18657 */     // No operand predicates
     /*  18657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18668 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18686 */     GIR_RootConstrainSelectedInstOperands,
     /*  18687 */     // GIR_Coverage, 13399,
     /*  18687 */     GIR_EraseRootFromParent_Done,
     /*  18688 */   // Label 337: @18688
     /*  18688 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(18780), // Rule ID 13398 //
     /*  18693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18750 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18754 */     // MIs[3] Operand 1
     /*  18754 */     // No operand predicates
     /*  18754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18760 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18778 */     GIR_RootConstrainSelectedInstOperands,
     /*  18779 */     // GIR_Coverage, 13398,
     /*  18779 */     GIR_EraseRootFromParent_Done,
     /*  18780 */   // Label 338: @18780
     /*  18780 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(18872), // Rule ID 13429 //
     /*  18785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18837 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18841 */     // MIs[3] Operand 1
     /*  18841 */     // No operand predicates
     /*  18841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18852 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18870 */     GIR_RootConstrainSelectedInstOperands,
     /*  18871 */     // GIR_Coverage, 13429,
     /*  18871 */     GIR_EraseRootFromParent_Done,
     /*  18872 */   // Label 339: @18872
     /*  18872 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(18964), // Rule ID 13428 //
     /*  18877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18934 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18938 */     // MIs[3] Operand 1
     /*  18938 */     // No operand predicates
     /*  18938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18944 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18962 */     GIR_RootConstrainSelectedInstOperands,
     /*  18963 */     // GIR_Coverage, 13428,
     /*  18963 */     GIR_EraseRootFromParent_Done,
     /*  18964 */   // Label 340: @18964
     /*  18964 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19056), // Rule ID 13397 //
     /*  18969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19025 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19029 */     // MIs[3] Operand 1
     /*  19029 */     // No operand predicates
     /*  19029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19036 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19054 */     GIR_RootConstrainSelectedInstOperands,
     /*  19055 */     // GIR_Coverage, 13397,
     /*  19055 */     GIR_EraseRootFromParent_Done,
     /*  19056 */   // Label 341: @19056
     /*  19056 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19148), // Rule ID 2034 //
     /*  19061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19122 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19126 */     // MIs[3] Operand 1
     /*  19126 */     // No operand predicates
     /*  19126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19128 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19146 */     GIR_RootConstrainSelectedInstOperands,
     /*  19147 */     // GIR_Coverage, 2034,
     /*  19147 */     GIR_EraseRootFromParent_Done,
     /*  19148 */   // Label 342: @19148
     /*  19148 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19240), // Rule ID 13427 //
     /*  19153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19209 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19213 */     // MIs[3] Operand 1
     /*  19213 */     // No operand predicates
     /*  19213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19220 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19238 */     GIR_RootConstrainSelectedInstOperands,
     /*  19239 */     // GIR_Coverage, 13427,
     /*  19239 */     GIR_EraseRootFromParent_Done,
     /*  19240 */   // Label 343: @19240
     /*  19240 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19332), // Rule ID 2086 //
     /*  19245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19306 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19310 */     // MIs[3] Operand 1
     /*  19310 */     // No operand predicates
     /*  19310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19312 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19330 */     GIR_RootConstrainSelectedInstOperands,
     /*  19331 */     // GIR_Coverage, 2086,
     /*  19331 */     GIR_EraseRootFromParent_Done,
     /*  19332 */   // Label 344: @19332
     /*  19332 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19383), // Rule ID 13342 //
     /*  19337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19369 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19381 */     GIR_RootConstrainSelectedInstOperands,
     /*  19382 */     // GIR_Coverage, 13342,
     /*  19382 */     GIR_EraseRootFromParent_Done,
     /*  19383 */   // Label 345: @19383
     /*  19383 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19434), // Rule ID 13312 //
     /*  19388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19420 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19432 */     GIR_RootConstrainSelectedInstOperands,
     /*  19433 */     // GIR_Coverage, 13312,
     /*  19433 */     GIR_EraseRootFromParent_Done,
     /*  19434 */   // Label 346: @19434
     /*  19434 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19485), // Rule ID 13341 //
     /*  19439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19471 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19483 */     GIR_RootConstrainSelectedInstOperands,
     /*  19484 */     // GIR_Coverage, 13341,
     /*  19484 */     GIR_EraseRootFromParent_Done,
     /*  19485 */   // Label 347: @19485
     /*  19485 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19536), // Rule ID 1806 //
     /*  19490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19522 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19534 */     GIR_RootConstrainSelectedInstOperands,
     /*  19535 */     // GIR_Coverage, 1806,
     /*  19535 */     GIR_EraseRootFromParent_Done,
     /*  19536 */   // Label 348: @19536
     /*  19536 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(19587), // Rule ID 1716 //
     /*  19541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19573 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19585 */     GIR_RootConstrainSelectedInstOperands,
     /*  19586 */     // GIR_Coverage, 1716,
     /*  19586 */     GIR_EraseRootFromParent_Done,
     /*  19587 */   // Label 349: @19587
     /*  19587 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(19638), // Rule ID 1805 //
     /*  19592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19624 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19636 */     GIR_RootConstrainSelectedInstOperands,
     /*  19637 */     // GIR_Coverage, 1805,
     /*  19637 */     GIR_EraseRootFromParent_Done,
     /*  19638 */   // Label 350: @19638
     /*  19638 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(19694), // Rule ID 13230 //
     /*  19643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19658 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19661 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19681 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19692 */     GIR_RootConstrainSelectedInstOperands,
     /*  19693 */     // GIR_Coverage, 13230,
     /*  19693 */     GIR_EraseRootFromParent_Done,
     /*  19694 */   // Label 351: @19694
     /*  19694 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(19750), // Rule ID 13242 //
     /*  19699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19714 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19717 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19737 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19748 */     GIR_RootConstrainSelectedInstOperands,
     /*  19749 */     // GIR_Coverage, 13242,
     /*  19749 */     GIR_EraseRootFromParent_Done,
     /*  19750 */   // Label 352: @19750
     /*  19750 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(19817), // Rule ID 13470 //
     /*  19755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19779 */     // MIs[1] imm
     /*  19779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19787 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19791 */     // MIs[2] Operand 1
     /*  19791 */     // No operand predicates
     /*  19791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19795 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19801 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19815 */     GIR_RootConstrainSelectedInstOperands,
     /*  19816 */     // GIR_Coverage, 13470,
     /*  19816 */     GIR_EraseRootFromParent_Done,
     /*  19817 */   // Label 353: @19817
     /*  19817 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(19884), // Rule ID 13491 //
     /*  19822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19846 */     // MIs[1] imm
     /*  19846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19854 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19858 */     // MIs[2] Operand 1
     /*  19858 */     // No operand predicates
     /*  19858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19862 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19868 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19882 */     GIR_RootConstrainSelectedInstOperands,
     /*  19883 */     // GIR_Coverage, 13491,
     /*  19883 */     GIR_EraseRootFromParent_Done,
     /*  19884 */   // Label 354: @19884
     /*  19884 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(19940), // Rule ID 992 //
     /*  19889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19908 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19911 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19927 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19938 */     GIR_RootConstrainSelectedInstOperands,
     /*  19939 */     // GIR_Coverage, 992,
     /*  19939 */     GIR_EraseRootFromParent_Done,
     /*  19940 */   // Label 355: @19940
     /*  19940 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(19996), // Rule ID 1053 //
     /*  19945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19964 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19967 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19983 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19994 */     GIR_RootConstrainSelectedInstOperands,
     /*  19995 */     // GIR_Coverage, 1053,
     /*  19995 */     GIR_EraseRootFromParent_Done,
     /*  19996 */   // Label 356: @19996
     /*  19996 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20063), // Rule ID 2233 //
     /*  20001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  20020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20029 */     // MIs[1] imm
     /*  20029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20037 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20041 */     // MIs[2] Operand 1
     /*  20041 */     // No operand predicates
     /*  20041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20047 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  20050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20061 */     GIR_RootConstrainSelectedInstOperands,
     /*  20062 */     // GIR_Coverage, 2233,
     /*  20062 */     GIR_EraseRootFromParent_Done,
     /*  20063 */   // Label 357: @20063
     /*  20063 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20130), // Rule ID 2292 //
     /*  20068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  20087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20096 */     // MIs[1] imm
     /*  20096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20104 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20108 */     // MIs[2] Operand 1
     /*  20108 */     // No operand predicates
     /*  20108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20114 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  20117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20128 */     GIR_RootConstrainSelectedInstOperands,
     /*  20129 */     // GIR_Coverage, 2292,
     /*  20129 */     GIR_EraseRootFromParent_Done,
     /*  20130 */   // Label 358: @20130
     /*  20130 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20200), // Rule ID 6881 //
     /*  20135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20173 */     // MIs[2] Rn
     /*  20173 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20178 */     // MIs[2] Rm
     /*  20178 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20185 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20198 */     GIR_RootConstrainSelectedInstOperands,
     /*  20199 */     // GIR_Coverage, 6881,
     /*  20199 */     GIR_EraseRootFromParent_Done,
     /*  20200 */   // Label 359: @20200
     /*  20200 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20270), // Rule ID 13852 //
     /*  20205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20243 */     // MIs[2] Rn
     /*  20243 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20248 */     // MIs[2] Rm
     /*  20248 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20255 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20268 */     GIR_RootConstrainSelectedInstOperands,
     /*  20269 */     // GIR_Coverage, 13852,
     /*  20269 */     GIR_EraseRootFromParent_Done,
     /*  20270 */   // Label 360: @20270
     /*  20270 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20333), // Rule ID 1790 //
     /*  20275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20318 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20331 */     GIR_RootConstrainSelectedInstOperands,
     /*  20332 */     // GIR_Coverage, 1790,
     /*  20332 */     GIR_EraseRootFromParent_Done,
     /*  20333 */   // Label 361: @20333
     /*  20333 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20396), // Rule ID 1789 //
     /*  20338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20381 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20394 */     GIR_RootConstrainSelectedInstOperands,
     /*  20395 */     // GIR_Coverage, 1789,
     /*  20395 */     GIR_EraseRootFromParent_Done,
     /*  20396 */   // Label 362: @20396
     /*  20396 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20459), // Rule ID 1709 //
     /*  20401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20444 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20457 */     GIR_RootConstrainSelectedInstOperands,
     /*  20458 */     // GIR_Coverage, 1709,
     /*  20458 */     GIR_EraseRootFromParent_Done,
     /*  20459 */   // Label 363: @20459
     /*  20459 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20522), // Rule ID 1788 //
     /*  20464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20507 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20520 */     GIR_RootConstrainSelectedInstOperands,
     /*  20521 */     // GIR_Coverage, 1788,
     /*  20521 */     GIR_EraseRootFromParent_Done,
     /*  20522 */   // Label 364: @20522
     /*  20522 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(20585), // Rule ID 1787 //
     /*  20527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20570 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20583 */     GIR_RootConstrainSelectedInstOperands,
     /*  20584 */     // GIR_Coverage, 1787,
     /*  20584 */     GIR_EraseRootFromParent_Done,
     /*  20585 */   // Label 365: @20585
     /*  20585 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(20646), // Rule ID 13317 //
     /*  20590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20629 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20644 */     GIR_RootConstrainSelectedInstOperands,
     /*  20645 */     // GIR_Coverage, 13317,
     /*  20645 */     GIR_EraseRootFromParent_Done,
     /*  20646 */   // Label 366: @20646
     /*  20646 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20707), // Rule ID 13347 //
     /*  20651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20690 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20705 */     GIR_RootConstrainSelectedInstOperands,
     /*  20706 */     // GIR_Coverage, 13347,
     /*  20706 */     GIR_EraseRootFromParent_Done,
     /*  20707 */   // Label 367: @20707
     /*  20707 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20755), // Rule ID 13340 //
     /*  20712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20742 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20753 */     GIR_RootConstrainSelectedInstOperands,
     /*  20754 */     // GIR_Coverage, 13340,
     /*  20754 */     GIR_EraseRootFromParent_Done,
     /*  20755 */   // Label 368: @20755
     /*  20755 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20803), // Rule ID 13229 //
     /*  20760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20790 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20801 */     GIR_RootConstrainSelectedInstOperands,
     /*  20802 */     // GIR_Coverage, 13229,
     /*  20802 */     GIR_EraseRootFromParent_Done,
     /*  20803 */   // Label 369: @20803
     /*  20803 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20851), // Rule ID 13311 //
     /*  20808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20838 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20849 */     GIR_RootConstrainSelectedInstOperands,
     /*  20850 */     // GIR_Coverage, 13311,
     /*  20850 */     GIR_EraseRootFromParent_Done,
     /*  20851 */   // Label 370: @20851
     /*  20851 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20899), // Rule ID 13241 //
     /*  20856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  20871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20886 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20897 */     GIR_RootConstrainSelectedInstOperands,
     /*  20898 */     // GIR_Coverage, 13241,
     /*  20898 */     GIR_EraseRootFromParent_Done,
     /*  20899 */   // Label 371: @20899
     /*  20899 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20947), // Rule ID 13339 //
     /*  20904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20934 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20945 */     GIR_RootConstrainSelectedInstOperands,
     /*  20946 */     // GIR_Coverage, 13339,
     /*  20946 */     GIR_EraseRootFromParent_Done,
     /*  20947 */   // Label 372: @20947
     /*  20947 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21008), // Rule ID 1721 //
     /*  20952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20991 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21006 */     GIR_RootConstrainSelectedInstOperands,
     /*  21007 */     // GIR_Coverage, 1721,
     /*  21007 */     GIR_EraseRootFromParent_Done,
     /*  21008 */   // Label 373: @21008
     /*  21008 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(21069), // Rule ID 1811 //
     /*  21013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  21032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21052 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  21055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21067 */     GIR_RootConstrainSelectedInstOperands,
     /*  21068 */     // GIR_Coverage, 1811,
     /*  21068 */     GIR_EraseRootFromParent_Done,
     /*  21069 */   // Label 374: @21069
     /*  21069 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21117), // Rule ID 1804 //
     /*  21074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21104 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21115 */     GIR_RootConstrainSelectedInstOperands,
     /*  21116 */     // GIR_Coverage, 1804,
     /*  21116 */     GIR_EraseRootFromParent_Done,
     /*  21117 */   // Label 375: @21117
     /*  21117 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21165), // Rule ID 991 //
     /*  21122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  21141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21152 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  21155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21163 */     GIR_RootConstrainSelectedInstOperands,
     /*  21164 */     // GIR_Coverage, 991,
     /*  21164 */     GIR_EraseRootFromParent_Done,
     /*  21165 */   // Label 376: @21165
     /*  21165 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21213), // Rule ID 1715 //
     /*  21170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21200 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  21203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21211 */     GIR_RootConstrainSelectedInstOperands,
     /*  21212 */     // GIR_Coverage, 1715,
     /*  21212 */     GIR_EraseRootFromParent_Done,
     /*  21213 */   // Label 377: @21213
     /*  21213 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21261), // Rule ID 1052 //
     /*  21218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21248 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21259 */     GIR_RootConstrainSelectedInstOperands,
     /*  21260 */     // GIR_Coverage, 1052,
     /*  21260 */     GIR_EraseRootFromParent_Done,
     /*  21261 */   // Label 378: @21261
     /*  21261 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21309), // Rule ID 1803 //
     /*  21266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21296 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21307 */     GIR_RootConstrainSelectedInstOperands,
     /*  21308 */     // GIR_Coverage, 1803,
     /*  21308 */     GIR_EraseRootFromParent_Done,
     /*  21309 */   // Label 379: @21309
     /*  21309 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21336), // Rule ID 1099 //
     /*  21314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21329 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21334 */     GIR_RootConstrainSelectedInstOperands,
     /*  21335 */     // GIR_Coverage, 1099,
     /*  21335 */     GIR_Done,
     /*  21336 */   // Label 380: @21336
     /*  21336 */   GIM_Reject,
     /*  21337 */ // Label 303: @21337
     /*  21337 */ GIM_Reject,
     /*  21338 */ // Label 162: @21338
     /*  21338 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(24835),
     /*  21343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21349 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(21485), // Rule ID 5344 //
     /*  21354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21387 */     // MIs[1] Operand 2
     /*  21387 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21406 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21410 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21414 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21418 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21422 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21427 */     // MIs[3] Operand 2
     /*  21427 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21438 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21440 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21467 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21484 */     // GIR_Coverage, 5344,
     /*  21484 */     GIR_EraseRootFromParent_Done,
     /*  21485 */   // Label 382: @21485
     /*  21485 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(21621), // Rule ID 5343 //
     /*  21490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21523 */     // MIs[1] Operand 2
     /*  21523 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21542 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21546 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21550 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21554 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21558 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21563 */     // MIs[3] Operand 2
     /*  21563 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21574 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21576 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21603 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21620 */     // GIR_Coverage, 5343,
     /*  21620 */     GIR_EraseRootFromParent_Done,
     /*  21621 */   // Label 383: @21621
     /*  21621 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(21757), // Rule ID 5359 //
     /*  21626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21659 */     // MIs[1] Operand 2
     /*  21659 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21682 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21686 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21690 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21694 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21699 */     // MIs[3] Operand 2
     /*  21699 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21710 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21712 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  21719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21739 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21756 */     // GIR_Coverage, 5359,
     /*  21756 */     GIR_EraseRootFromParent_Done,
     /*  21757 */   // Label 384: @21757
     /*  21757 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(21893), // Rule ID 5342 //
     /*  21762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21795 */     // MIs[1] Operand 2
     /*  21795 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21818 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21822 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21826 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21830 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21835 */     // MIs[3] Operand 2
     /*  21835 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21846 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21848 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21875 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21892 */     // GIR_Coverage, 5342,
     /*  21892 */     GIR_EraseRootFromParent_Done,
     /*  21893 */   // Label 385: @21893
     /*  21893 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22029), // Rule ID 5341 //
     /*  21898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21931 */     // MIs[1] Operand 2
     /*  21931 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21950 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21962 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21966 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21971 */     // MIs[3] Operand 2
     /*  21971 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21982 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21984 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22011 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22028 */     // GIR_Coverage, 5341,
     /*  22028 */     GIR_EraseRootFromParent_Done,
     /*  22029 */   // Label 386: @22029
     /*  22029 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22162), // Rule ID 13857 //
     /*  22034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  22058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  22075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22079 */     // MIs[1] Operand 2
     /*  22079 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22090 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  22094 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  22098 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22102 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  22106 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  22110 */     // MIs[5] Rn
     /*  22110 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22115 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22117 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22133 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22144 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22161 */     // GIR_Coverage, 13857,
     /*  22161 */     GIR_EraseRootFromParent_Done,
     /*  22162 */   // Label 387: @22162
     /*  22162 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22295), // Rule ID 6886 //
     /*  22167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  22179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  22191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22208 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22212 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22216 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  22220 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22224 */     // MIs[4] Rn
     /*  22224 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22229 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22233 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22237 */     // MIs[3] Operand 2
     /*  22237 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22248 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22250 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22277 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22294 */     // GIR_Coverage, 6886,
     /*  22294 */     GIR_EraseRootFromParent_Done,
     /*  22295 */   // Label 388: @22295
     /*  22295 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22458), // Rule ID 13809 //
     /*  22300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22342 */     // MIs[1] Operand 2
     /*  22342 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22359 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22359 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22362 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22366 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22385 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22388 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22392 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22422 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22429 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22440 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22457 */     // GIR_Coverage, 13809,
     /*  22457 */     GIR_EraseRootFromParent_Done,
     /*  22458 */   // Label 389: @22458
     /*  22458 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(22621), // Rule ID 13806 //
     /*  22463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22505 */     // MIs[1] Operand 2
     /*  22505 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22522 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22522 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22525 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22529 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22536 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22539 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22543 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22548 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22551 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22555 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22558 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22563 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22568 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22585 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22603 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22620 */     // GIR_Coverage, 13806,
     /*  22620 */     GIR_EraseRootFromParent_Done,
     /*  22621 */   // Label 390: @22621
     /*  22621 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(22771), // Rule ID 13813 //
     /*  22626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22659 */     // MIs[1] Operand 2
     /*  22659 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22676 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22676 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22679 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22683 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22702 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22705 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22709 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22712 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22717 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22753 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22770 */     // GIR_Coverage, 13813,
     /*  22770 */     GIR_EraseRootFromParent_Done,
     /*  22771 */   // Label 391: @22771
     /*  22771 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(22921), // Rule ID 13818 //
     /*  22776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22809 */     // MIs[1] Operand 2
     /*  22809 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22826 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22826 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22829 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22833 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22843 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22847 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22852 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22859 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  22884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22903 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22920 */     // GIR_Coverage, 13818,
     /*  22920 */     GIR_EraseRootFromParent_Done,
     /*  22921 */   // Label 392: @22921
     /*  22921 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23071), // Rule ID 13812 //
     /*  22926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22959 */     // MIs[1] Operand 2
     /*  22959 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22976 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22976 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22979 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22983 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22990 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22993 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22997 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23002 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23005 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  23009 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23012 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23022 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23039 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23053 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23070 */     // GIR_Coverage, 13812,
     /*  23070 */     GIR_EraseRootFromParent_Done,
     /*  23071 */   // Label 393: @23071
     /*  23071 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23234), // Rule ID 5332 //
     /*  23076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  23104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23122 */     // MIs[1] Operand 2
     /*  23122 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23135 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23135 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23138 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23142 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23161 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23164 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23168 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23171 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  23193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23216 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23233 */     // GIR_Coverage, 5332,
     /*  23233 */     GIR_EraseRootFromParent_Done,
     /*  23234 */   // Label 394: @23234
     /*  23234 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23397), // Rule ID 5329 //
     /*  23239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23285 */     // MIs[1] Operand 2
     /*  23285 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23298 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23298 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23301 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23305 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23312 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23315 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23319 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23324 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23327 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23331 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23334 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23339 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23361 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23379 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23396 */     // GIR_Coverage, 5329,
     /*  23396 */     GIR_EraseRootFromParent_Done,
     /*  23397 */   // Label 395: @23397
     /*  23397 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23547), // Rule ID 5354 //
     /*  23402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23439 */     // MIs[1] Operand 2
     /*  23439 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23452 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23452 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23455 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23459 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23478 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23481 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23485 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23488 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23493 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23498 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23546 */     // GIR_Coverage, 5354,
     /*  23546 */     GIR_EraseRootFromParent_Done,
     /*  23547 */   // Label 396: @23547
     /*  23547 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(23697), // Rule ID 5362 //
     /*  23552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23589 */     // MIs[1] Operand 2
     /*  23589 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23602 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23602 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23605 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23609 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23616 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23619 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23623 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23628 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23631 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23635 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23638 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23665 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23668 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23679 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23696 */     // GIR_Coverage, 5362,
     /*  23696 */     GIR_EraseRootFromParent_Done,
     /*  23697 */   // Label 397: @23697
     /*  23697 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(23847), // Rule ID 5353 //
     /*  23702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23739 */     // MIs[1] Operand 2
     /*  23739 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23752 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23752 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23755 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23759 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23766 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23769 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23773 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23778 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23781 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23785 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23788 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23793 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23798 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23815 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23829 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23846 */     // GIR_Coverage, 5353,
     /*  23846 */     GIR_EraseRootFromParent_Done,
     /*  23847 */   // Label 398: @23847
     /*  23847 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(23916), // Rule ID 13258 //
     /*  23852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23867 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23870 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23879 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23899 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  23902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23914 */     GIR_RootConstrainSelectedInstOperands,
     /*  23915 */     // GIR_Coverage, 13258,
     /*  23915 */     GIR_EraseRootFromParent_Done,
     /*  23916 */   // Label 399: @23916
     /*  23916 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(23985), // Rule ID 13270 //
     /*  23921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23936 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23939 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23948 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23968 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  23971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23983 */     GIR_RootConstrainSelectedInstOperands,
     /*  23984 */     // GIR_Coverage, 13270,
     /*  23984 */     GIR_EraseRootFromParent_Done,
     /*  23985 */   // Label 400: @23985
     /*  23985 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24041), // Rule ID 13220 //
     /*  23990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24005 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24008 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24028 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24039 */     GIR_RootConstrainSelectedInstOperands,
     /*  24040 */     // GIR_Coverage, 13220,
     /*  24040 */     GIR_EraseRootFromParent_Done,
     /*  24041 */   // Label 401: @24041
     /*  24041 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24097), // Rule ID 13232 //
     /*  24046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24061 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24064 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24084 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24095 */     GIR_RootConstrainSelectedInstOperands,
     /*  24096 */     // GIR_Coverage, 13232,
     /*  24096 */     GIR_EraseRootFromParent_Done,
     /*  24097 */   // Label 402: @24097
     /*  24097 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24164), // Rule ID 13462 //
     /*  24102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24126 */     // MIs[1] imm
     /*  24126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24134 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24138 */     // MIs[2] Operand 1
     /*  24138 */     // No operand predicates
     /*  24138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24142 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24148 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24162 */     GIR_RootConstrainSelectedInstOperands,
     /*  24163 */     // GIR_Coverage, 13462,
     /*  24163 */     GIR_EraseRootFromParent_Done,
     /*  24164 */   // Label 403: @24164
     /*  24164 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24231), // Rule ID 13483 //
     /*  24169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24193 */     // MIs[1] imm
     /*  24193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24201 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24205 */     // MIs[2] Operand 1
     /*  24205 */     // No operand predicates
     /*  24205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24215 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24229 */     GIR_RootConstrainSelectedInstOperands,
     /*  24230 */     // GIR_Coverage, 13483,
     /*  24230 */     GIR_EraseRootFromParent_Done,
     /*  24231 */   // Label 404: @24231
     /*  24231 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24300), // Rule ID 1354 //
     /*  24236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24283 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24298 */     GIR_RootConstrainSelectedInstOperands,
     /*  24299 */     // GIR_Coverage, 1354,
     /*  24299 */     GIR_EraseRootFromParent_Done,
     /*  24300 */   // Label 405: @24300
     /*  24300 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24369), // Rule ID 1477 //
     /*  24305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24324 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24327 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24352 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24367 */     GIR_RootConstrainSelectedInstOperands,
     /*  24368 */     // GIR_Coverage, 1477,
     /*  24368 */     GIR_EraseRootFromParent_Done,
     /*  24369 */   // Label 406: @24369
     /*  24369 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24425), // Rule ID 982 //
     /*  24374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24393 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24396 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24412 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24423 */     GIR_RootConstrainSelectedInstOperands,
     /*  24424 */     // GIR_Coverage, 982,
     /*  24424 */     GIR_EraseRootFromParent_Done,
     /*  24425 */   // Label 407: @24425
     /*  24425 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24481), // Rule ID 1043 //
     /*  24430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24449 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24452 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24468 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24479 */     GIR_RootConstrainSelectedInstOperands,
     /*  24480 */     // GIR_Coverage, 1043,
     /*  24480 */     GIR_EraseRootFromParent_Done,
     /*  24481 */   // Label 408: @24481
     /*  24481 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(24548), // Rule ID 2225 //
     /*  24486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24514 */     // MIs[1] imm
     /*  24514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24526 */     // MIs[2] Operand 1
     /*  24526 */     // No operand predicates
     /*  24526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24532 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24546 */     GIR_RootConstrainSelectedInstOperands,
     /*  24547 */     // GIR_Coverage, 2225,
     /*  24547 */     GIR_EraseRootFromParent_Done,
     /*  24548 */   // Label 409: @24548
     /*  24548 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24615), // Rule ID 2284 //
     /*  24553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24581 */     // MIs[1] imm
     /*  24581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24593 */     // MIs[2] Operand 1
     /*  24593 */     // No operand predicates
     /*  24593 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24599 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24613 */     GIR_RootConstrainSelectedInstOperands,
     /*  24614 */     // GIR_Coverage, 2284,
     /*  24614 */     GIR_EraseRootFromParent_Done,
     /*  24615 */   // Label 410: @24615
     /*  24615 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24663), // Rule ID 13219 //
     /*  24620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24650 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24661 */     GIR_RootConstrainSelectedInstOperands,
     /*  24662 */     // GIR_Coverage, 13219,
     /*  24662 */     GIR_EraseRootFromParent_Done,
     /*  24663 */   // Label 411: @24663
     /*  24663 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(24711), // Rule ID 13231 //
     /*  24668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24698 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24709 */     GIR_RootConstrainSelectedInstOperands,
     /*  24710 */     // GIR_Coverage, 13231,
     /*  24710 */     GIR_EraseRootFromParent_Done,
     /*  24711 */   // Label 412: @24711
     /*  24711 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(24759), // Rule ID 981 //
     /*  24716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24746 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24757 */     GIR_RootConstrainSelectedInstOperands,
     /*  24758 */     // GIR_Coverage, 981,
     /*  24758 */     GIR_EraseRootFromParent_Done,
     /*  24759 */   // Label 413: @24759
     /*  24759 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(24807), // Rule ID 1042 //
     /*  24764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24794 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24805 */     GIR_RootConstrainSelectedInstOperands,
     /*  24806 */     // GIR_Coverage, 1042,
     /*  24806 */     GIR_EraseRootFromParent_Done,
     /*  24807 */   // Label 414: @24807
     /*  24807 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(24834), // Rule ID 1095 //
     /*  24812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24827 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  24832 */     GIR_RootConstrainSelectedInstOperands,
     /*  24833 */     // GIR_Coverage, 1095,
     /*  24833 */     GIR_Done,
     /*  24834 */   // Label 415: @24834
     /*  24834 */   GIM_Reject,
     /*  24835 */ // Label 381: @24835
     /*  24835 */ GIM_Reject,
     /*  24836 */ // Label 163: @24836
     /*  24836 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(31013),
     /*  24841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24847 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(24965), // Rule ID 13392 //
     /*  24852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24895 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24899 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24903 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24912 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24916 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24920 */     // MIs[4] Operand 1
     /*  24920 */     // No operand predicates
     /*  24920 */     // MIs[2] Operand 2
     /*  24920 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24935 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24944 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24963 */     GIR_RootConstrainSelectedInstOperands,
     /*  24964 */     // GIR_Coverage, 13392,
     /*  24964 */     GIR_EraseRootFromParent_Done,
     /*  24965 */   // Label 417: @24965
     /*  24965 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25083), // Rule ID 13393 //
     /*  24970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25013 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25017 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25021 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25026 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25030 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25034 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25038 */     // MIs[4] Operand 1
     /*  25038 */     // No operand predicates
     /*  25038 */     // MIs[2] Operand 2
     /*  25038 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25062 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25081 */     GIR_RootConstrainSelectedInstOperands,
     /*  25082 */     // GIR_Coverage, 13393,
     /*  25082 */     GIR_EraseRootFromParent_Done,
     /*  25083 */   // Label 418: @25083
     /*  25083 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25201), // Rule ID 13422 //
     /*  25088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25131 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25135 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25139 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25144 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25148 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25152 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25156 */     // MIs[4] Operand 1
     /*  25156 */     // No operand predicates
     /*  25156 */     // MIs[2] Operand 2
     /*  25156 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25171 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25180 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25199 */     GIR_RootConstrainSelectedInstOperands,
     /*  25200 */     // GIR_Coverage, 13422,
     /*  25200 */     GIR_EraseRootFromParent_Done,
     /*  25201 */   // Label 419: @25201
     /*  25201 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25319), // Rule ID 13423 //
     /*  25206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25249 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25253 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25257 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25262 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25266 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25270 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25274 */     // MIs[4] Operand 1
     /*  25274 */     // No operand predicates
     /*  25274 */     // MIs[2] Operand 2
     /*  25274 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25289 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25298 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25317 */     GIR_RootConstrainSelectedInstOperands,
     /*  25318 */     // GIR_Coverage, 13423,
     /*  25318 */     GIR_EraseRootFromParent_Done,
     /*  25319 */   // Label 420: @25319
     /*  25319 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25437), // Rule ID 2032 //
     /*  25324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25371 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25375 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25379 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25384 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25388 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25392 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25396 */     // MIs[4] Operand 1
     /*  25396 */     // No operand predicates
     /*  25396 */     // MIs[2] Operand 2
     /*  25396 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25407 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25416 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25435 */     GIR_RootConstrainSelectedInstOperands,
     /*  25436 */     // GIR_Coverage, 2032,
     /*  25436 */     GIR_EraseRootFromParent_Done,
     /*  25437 */   // Label 421: @25437
     /*  25437 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(25555), // Rule ID 13391 //
     /*  25442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25489 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25493 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25497 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25502 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25506 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25510 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25514 */     // MIs[4] Operand 1
     /*  25514 */     // No operand predicates
     /*  25514 */     // MIs[2] Operand 2
     /*  25514 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25525 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25534 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25553 */     GIR_RootConstrainSelectedInstOperands,
     /*  25554 */     // GIR_Coverage, 13391,
     /*  25554 */     GIR_EraseRootFromParent_Done,
     /*  25555 */   // Label 422: @25555
     /*  25555 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(25673), // Rule ID 2084 //
     /*  25560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25607 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25611 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25615 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25620 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25624 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25628 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25632 */     // MIs[4] Operand 1
     /*  25632 */     // No operand predicates
     /*  25632 */     // MIs[2] Operand 2
     /*  25632 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25643 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25652 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25671 */     GIR_RootConstrainSelectedInstOperands,
     /*  25672 */     // GIR_Coverage, 2084,
     /*  25672 */     GIR_EraseRootFromParent_Done,
     /*  25673 */   // Label 423: @25673
     /*  25673 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(25791), // Rule ID 13421 //
     /*  25678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25729 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25733 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25746 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25750 */     // MIs[4] Operand 1
     /*  25750 */     // No operand predicates
     /*  25750 */     // MIs[2] Operand 2
     /*  25750 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25761 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25770 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25789 */     GIR_RootConstrainSelectedInstOperands,
     /*  25790 */     // GIR_Coverage, 13421,
     /*  25790 */     GIR_EraseRootFromParent_Done,
     /*  25791 */   // Label 424: @25791
     /*  25791 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(25878), // Rule ID 13302 //
     /*  25796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25823 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25826 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25835 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25859 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25876 */     GIR_RootConstrainSelectedInstOperands,
     /*  25877 */     // GIR_Coverage, 13302,
     /*  25877 */     GIR_EraseRootFromParent_Done,
     /*  25878 */   // Label 425: @25878
     /*  25878 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(25965), // Rule ID 13326 //
     /*  25883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25910 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25913 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25922 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25932 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25946 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25963 */     GIR_RootConstrainSelectedInstOperands,
     /*  25964 */     // GIR_Coverage, 13326,
     /*  25964 */     GIR_EraseRootFromParent_Done,
     /*  25965 */   // Label 426: @25965
     /*  25965 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26052), // Rule ID 1688 //
     /*  25970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26001 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26004 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  26009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26013 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26033 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  26036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26050 */     GIR_RootConstrainSelectedInstOperands,
     /*  26051 */     // GIR_Coverage, 1688,
     /*  26051 */     GIR_EraseRootFromParent_Done,
     /*  26052 */   // Label 427: @26052
     /*  26052 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26139), // Rule ID 1766 //
     /*  26057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26088 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26091 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  26096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26100 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26120 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  26123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26137 */     GIR_RootConstrainSelectedInstOperands,
     /*  26138 */     // GIR_Coverage, 1766,
     /*  26138 */     GIR_EraseRootFromParent_Done,
     /*  26139 */   // Label 428: @26139
     /*  26139 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26254), // Rule ID 13387 //
     /*  26144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26187 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26191 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26195 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26208 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26212 */     // MIs[4] Operand 1
     /*  26212 */     // No operand predicates
     /*  26212 */     // MIs[2] Operand 2
     /*  26212 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26232 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26234 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26252 */     GIR_RootConstrainSelectedInstOperands,
     /*  26253 */     // GIR_Coverage, 13387,
     /*  26253 */     GIR_EraseRootFromParent_Done,
     /*  26254 */   // Label 429: @26254
     /*  26254 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26369), // Rule ID 13386 //
     /*  26259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26307 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26311 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26315 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26324 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26328 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26332 */     // MIs[4] Operand 1
     /*  26332 */     // No operand predicates
     /*  26332 */     // MIs[2] Operand 2
     /*  26332 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26347 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26349 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26367 */     GIR_RootConstrainSelectedInstOperands,
     /*  26368 */     // GIR_Coverage, 13386,
     /*  26368 */     GIR_EraseRootFromParent_Done,
     /*  26369 */   // Label 430: @26369
     /*  26369 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26484), // Rule ID 13417 //
     /*  26374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26417 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26421 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26425 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26430 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26434 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26438 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26442 */     // MIs[4] Operand 1
     /*  26442 */     // No operand predicates
     /*  26442 */     // MIs[2] Operand 2
     /*  26442 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26462 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26464 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26482 */     GIR_RootConstrainSelectedInstOperands,
     /*  26483 */     // GIR_Coverage, 13417,
     /*  26483 */     GIR_EraseRootFromParent_Done,
     /*  26484 */   // Label 431: @26484
     /*  26484 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26599), // Rule ID 13416 //
     /*  26489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26537 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26541 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26545 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26554 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26558 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26562 */     // MIs[4] Operand 1
     /*  26562 */     // No operand predicates
     /*  26562 */     // MIs[2] Operand 2
     /*  26562 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26577 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26579 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26597 */     GIR_RootConstrainSelectedInstOperands,
     /*  26598 */     // GIR_Coverage, 13416,
     /*  26598 */     GIR_EraseRootFromParent_Done,
     /*  26599 */   // Label 432: @26599
     /*  26599 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(26668), // Rule ID 1786 //
     /*  26604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26651 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26666 */     GIR_RootConstrainSelectedInstOperands,
     /*  26667 */     // GIR_Coverage, 1786,
     /*  26667 */     GIR_EraseRootFromParent_Done,
     /*  26668 */   // Label 433: @26668
     /*  26668 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(26737), // Rule ID 1785 //
     /*  26673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26720 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26735 */     GIR_RootConstrainSelectedInstOperands,
     /*  26736 */     // GIR_Coverage, 1785,
     /*  26736 */     GIR_EraseRootFromParent_Done,
     /*  26737 */   // Label 434: @26737
     /*  26737 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(26806), // Rule ID 1708 //
     /*  26742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26789 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  26792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26804 */     GIR_RootConstrainSelectedInstOperands,
     /*  26805 */     // GIR_Coverage, 1708,
     /*  26805 */     GIR_EraseRootFromParent_Done,
     /*  26806 */   // Label 435: @26806
     /*  26806 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(26875), // Rule ID 1784 //
     /*  26811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26858 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26873 */     GIR_RootConstrainSelectedInstOperands,
     /*  26874 */     // GIR_Coverage, 1784,
     /*  26874 */     GIR_EraseRootFromParent_Done,
     /*  26875 */   // Label 436: @26875
     /*  26875 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(26944), // Rule ID 1783 //
     /*  26880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26927 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26942 */     GIR_RootConstrainSelectedInstOperands,
     /*  26943 */     // GIR_Coverage, 1783,
     /*  26943 */     GIR_EraseRootFromParent_Done,
     /*  26944 */   // Label 437: @26944
     /*  26944 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27059), // Rule ID 13385 //
     /*  26949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27000 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27004 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27009 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27013 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27017 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27021 */     // MIs[4] Operand 1
     /*  27021 */     // No operand predicates
     /*  27021 */     // MIs[2] Operand 2
     /*  27021 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27037 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27039 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27057 */     GIR_RootConstrainSelectedInstOperands,
     /*  27058 */     // GIR_Coverage, 13385,
     /*  27058 */     GIR_EraseRootFromParent_Done,
     /*  27059 */   // Label 438: @27059
     /*  27059 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27174), // Rule ID 2030 //
     /*  27064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27116 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27120 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27124 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27129 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27133 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27137 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27141 */     // MIs[4] Operand 1
     /*  27141 */     // No operand predicates
     /*  27141 */     // MIs[2] Operand 2
     /*  27141 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27152 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27154 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27172 */     GIR_RootConstrainSelectedInstOperands,
     /*  27173 */     // GIR_Coverage, 2030,
     /*  27173 */     GIR_EraseRootFromParent_Done,
     /*  27174 */   // Label 439: @27174
     /*  27174 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27289), // Rule ID 13415 //
     /*  27179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27226 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27230 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27234 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27239 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27243 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27247 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27251 */     // MIs[4] Operand 1
     /*  27251 */     // No operand predicates
     /*  27251 */     // MIs[2] Operand 2
     /*  27251 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27267 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27269 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27287 */     GIR_RootConstrainSelectedInstOperands,
     /*  27288 */     // GIR_Coverage, 13415,
     /*  27288 */     GIR_EraseRootFromParent_Done,
     /*  27289 */   // Label 440: @27289
     /*  27289 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27404), // Rule ID 2082 //
     /*  27294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27346 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27350 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27354 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27359 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27363 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27367 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27371 */     // MIs[4] Operand 1
     /*  27371 */     // No operand predicates
     /*  27371 */     // MIs[2] Operand 2
     /*  27371 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27382 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27384 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27402 */     GIR_RootConstrainSelectedInstOperands,
     /*  27403 */     // GIR_Coverage, 2082,
     /*  27403 */     GIR_EraseRootFromParent_Done,
     /*  27404 */   // Label 441: @27404
     /*  27404 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27471), // Rule ID 13316 //
     /*  27409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27452 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27469 */     GIR_RootConstrainSelectedInstOperands,
     /*  27470 */     // GIR_Coverage, 13316,
     /*  27470 */     GIR_EraseRootFromParent_Done,
     /*  27471 */   // Label 442: @27471
     /*  27471 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27538), // Rule ID 13346 //
     /*  27476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27519 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27536 */     GIR_RootConstrainSelectedInstOperands,
     /*  27537 */     // GIR_Coverage, 13346,
     /*  27537 */     GIR_EraseRootFromParent_Done,
     /*  27538 */   // Label 443: @27538
     /*  27538 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(27605), // Rule ID 1720 //
     /*  27543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27586 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27603 */     GIR_RootConstrainSelectedInstOperands,
     /*  27604 */     // GIR_Coverage, 1720,
     /*  27604 */     GIR_EraseRootFromParent_Done,
     /*  27605 */   // Label 444: @27605
     /*  27605 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(27672), // Rule ID 1810 //
     /*  27610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27653 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27670 */     GIR_RootConstrainSelectedInstOperands,
     /*  27671 */     // GIR_Coverage, 1810,
     /*  27671 */     GIR_EraseRootFromParent_Done,
     /*  27672 */   // Label 445: @27672
     /*  27672 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(27753), // Rule ID 13300 //
     /*  27677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27704 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27707 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27716 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27736 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27751 */     GIR_RootConstrainSelectedInstOperands,
     /*  27752 */     // GIR_Coverage, 13300,
     /*  27752 */     GIR_EraseRootFromParent_Done,
     /*  27753 */   // Label 446: @27753
     /*  27753 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(27834), // Rule ID 13324 //
     /*  27758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27785 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27788 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27797 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27817 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27832 */     GIR_RootConstrainSelectedInstOperands,
     /*  27833 */     // GIR_Coverage, 13324,
     /*  27833 */     GIR_EraseRootFromParent_Done,
     /*  27834 */   // Label 447: @27834
     /*  27834 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(27915), // Rule ID 1686 //
     /*  27839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27870 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27873 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27882 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27898 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27913 */     GIR_RootConstrainSelectedInstOperands,
     /*  27914 */     // GIR_Coverage, 1686,
     /*  27914 */     GIR_EraseRootFromParent_Done,
     /*  27915 */   // Label 448: @27915
     /*  27915 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(27996), // Rule ID 1764 //
     /*  27920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27951 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27954 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27963 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27979 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27994 */     GIR_RootConstrainSelectedInstOperands,
     /*  27995 */     // GIR_Coverage, 1764,
     /*  27995 */     GIR_EraseRootFromParent_Done,
     /*  27996 */   // Label 449: @27996
     /*  27996 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28088), // Rule ID 13390 //
     /*  28001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28053 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28057 */     // MIs[3] Operand 1
     /*  28057 */     // No operand predicates
     /*  28057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28068 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28086 */     GIR_RootConstrainSelectedInstOperands,
     /*  28087 */     // GIR_Coverage, 13390,
     /*  28087 */     GIR_EraseRootFromParent_Done,
     /*  28088 */   // Label 450: @28088
     /*  28088 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28180), // Rule ID 13389 //
     /*  28093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28150 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28154 */     // MIs[3] Operand 1
     /*  28154 */     // No operand predicates
     /*  28154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28160 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28178 */     GIR_RootConstrainSelectedInstOperands,
     /*  28179 */     // GIR_Coverage, 13389,
     /*  28179 */     GIR_EraseRootFromParent_Done,
     /*  28180 */   // Label 451: @28180
     /*  28180 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28272), // Rule ID 13420 //
     /*  28185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28237 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28241 */     // MIs[3] Operand 1
     /*  28241 */     // No operand predicates
     /*  28241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28252 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28270 */     GIR_RootConstrainSelectedInstOperands,
     /*  28271 */     // GIR_Coverage, 13420,
     /*  28271 */     GIR_EraseRootFromParent_Done,
     /*  28272 */   // Label 452: @28272
     /*  28272 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28364), // Rule ID 13419 //
     /*  28277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28334 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28338 */     // MIs[3] Operand 1
     /*  28338 */     // No operand predicates
     /*  28338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28344 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28362 */     GIR_RootConstrainSelectedInstOperands,
     /*  28363 */     // GIR_Coverage, 13419,
     /*  28363 */     GIR_EraseRootFromParent_Done,
     /*  28364 */   // Label 453: @28364
     /*  28364 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28456), // Rule ID 13388 //
     /*  28369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28425 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28429 */     // MIs[3] Operand 1
     /*  28429 */     // No operand predicates
     /*  28429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28436 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28454 */     GIR_RootConstrainSelectedInstOperands,
     /*  28455 */     // GIR_Coverage, 13388,
     /*  28455 */     GIR_EraseRootFromParent_Done,
     /*  28456 */   // Label 454: @28456
     /*  28456 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(28548), // Rule ID 2031 //
     /*  28461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28522 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28526 */     // MIs[3] Operand 1
     /*  28526 */     // No operand predicates
     /*  28526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28528 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28546 */     GIR_RootConstrainSelectedInstOperands,
     /*  28547 */     // GIR_Coverage, 2031,
     /*  28547 */     GIR_EraseRootFromParent_Done,
     /*  28548 */   // Label 455: @28548
     /*  28548 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(28640), // Rule ID 13418 //
     /*  28553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28609 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28613 */     // MIs[3] Operand 1
     /*  28613 */     // No operand predicates
     /*  28613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28620 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28638 */     GIR_RootConstrainSelectedInstOperands,
     /*  28639 */     // GIR_Coverage, 13418,
     /*  28639 */     GIR_EraseRootFromParent_Done,
     /*  28640 */   // Label 456: @28640
     /*  28640 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(28732), // Rule ID 2083 //
     /*  28645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28706 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28710 */     // MIs[3] Operand 1
     /*  28710 */     // No operand predicates
     /*  28710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28712 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28730 */     GIR_RootConstrainSelectedInstOperands,
     /*  28731 */     // GIR_Coverage, 2083,
     /*  28731 */     GIR_EraseRootFromParent_Done,
     /*  28732 */   // Label 457: @28732
     /*  28732 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(28783), // Rule ID 13338 //
     /*  28737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28769 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28781 */     GIR_RootConstrainSelectedInstOperands,
     /*  28782 */     // GIR_Coverage, 13338,
     /*  28782 */     GIR_EraseRootFromParent_Done,
     /*  28783 */   // Label 458: @28783
     /*  28783 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(28834), // Rule ID 13310 //
     /*  28788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28820 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28832 */     GIR_RootConstrainSelectedInstOperands,
     /*  28833 */     // GIR_Coverage, 13310,
     /*  28833 */     GIR_EraseRootFromParent_Done,
     /*  28834 */   // Label 459: @28834
     /*  28834 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(28885), // Rule ID 13337 //
     /*  28839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28871 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28883 */     GIR_RootConstrainSelectedInstOperands,
     /*  28884 */     // GIR_Coverage, 13337,
     /*  28884 */     GIR_EraseRootFromParent_Done,
     /*  28885 */   // Label 460: @28885
     /*  28885 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(28936), // Rule ID 1802 //
     /*  28890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28922 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28934 */     GIR_RootConstrainSelectedInstOperands,
     /*  28935 */     // GIR_Coverage, 1802,
     /*  28935 */     GIR_EraseRootFromParent_Done,
     /*  28936 */   // Label 461: @28936
     /*  28936 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(28987), // Rule ID 1714 //
     /*  28941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28973 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28985 */     GIR_RootConstrainSelectedInstOperands,
     /*  28986 */     // GIR_Coverage, 1714,
     /*  28986 */     GIR_EraseRootFromParent_Done,
     /*  28987 */   // Label 462: @28987
     /*  28987 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29038), // Rule ID 1801 //
     /*  28992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29024 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29036 */     GIR_RootConstrainSelectedInstOperands,
     /*  29037 */     // GIR_Coverage, 1801,
     /*  29037 */     GIR_EraseRootFromParent_Done,
     /*  29038 */   // Label 463: @29038
     /*  29038 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29107), // Rule ID 13264 //
     /*  29043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29058 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29061 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29070 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29090 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29105 */     GIR_RootConstrainSelectedInstOperands,
     /*  29106 */     // GIR_Coverage, 13264,
     /*  29106 */     GIR_EraseRootFromParent_Done,
     /*  29107 */   // Label 464: @29107
     /*  29107 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29176), // Rule ID 13276 //
     /*  29112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29127 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29130 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29139 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29159 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29174 */     GIR_RootConstrainSelectedInstOperands,
     /*  29175 */     // GIR_Coverage, 13276,
     /*  29175 */     GIR_EraseRootFromParent_Done,
     /*  29176 */   // Label 465: @29176
     /*  29176 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29232), // Rule ID 13226 //
     /*  29181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29196 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29199 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29219 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29230 */     GIR_RootConstrainSelectedInstOperands,
     /*  29231 */     // GIR_Coverage, 13226,
     /*  29231 */     GIR_EraseRootFromParent_Done,
     /*  29232 */   // Label 466: @29232
     /*  29232 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29288), // Rule ID 13238 //
     /*  29237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29252 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29255 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29275 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29286 */     GIR_RootConstrainSelectedInstOperands,
     /*  29287 */     // GIR_Coverage, 13238,
     /*  29287 */     GIR_EraseRootFromParent_Done,
     /*  29288 */   // Label 467: @29288
     /*  29288 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29355), // Rule ID 13468 //
     /*  29293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29317 */     // MIs[1] imm
     /*  29317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29325 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29329 */     // MIs[2] Operand 1
     /*  29329 */     // No operand predicates
     /*  29329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29339 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29353 */     GIR_RootConstrainSelectedInstOperands,
     /*  29354 */     // GIR_Coverage, 13468,
     /*  29354 */     GIR_EraseRootFromParent_Done,
     /*  29355 */   // Label 468: @29355
     /*  29355 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29422), // Rule ID 13489 //
     /*  29360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29384 */     // MIs[1] imm
     /*  29384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29392 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29396 */     // MIs[2] Operand 1
     /*  29396 */     // No operand predicates
     /*  29396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29400 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29406 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29420 */     GIR_RootConstrainSelectedInstOperands,
     /*  29421 */     // GIR_Coverage, 13489,
     /*  29421 */     GIR_EraseRootFromParent_Done,
     /*  29422 */   // Label 469: @29422
     /*  29422 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29491), // Rule ID 1360 //
     /*  29427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29446 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29449 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29458 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29474 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29489 */     GIR_RootConstrainSelectedInstOperands,
     /*  29490 */     // GIR_Coverage, 1360,
     /*  29490 */     GIR_EraseRootFromParent_Done,
     /*  29491 */   // Label 470: @29491
     /*  29491 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(29560), // Rule ID 1483 //
     /*  29496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29515 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29518 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29527 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29543 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29558 */     GIR_RootConstrainSelectedInstOperands,
     /*  29559 */     // GIR_Coverage, 1483,
     /*  29559 */     GIR_EraseRootFromParent_Done,
     /*  29560 */   // Label 471: @29560
     /*  29560 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(29616), // Rule ID 988 //
     /*  29565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29584 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29587 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29603 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29614 */     GIR_RootConstrainSelectedInstOperands,
     /*  29615 */     // GIR_Coverage, 988,
     /*  29615 */     GIR_EraseRootFromParent_Done,
     /*  29616 */   // Label 472: @29616
     /*  29616 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(29672), // Rule ID 1049 //
     /*  29621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29640 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29643 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29659 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29670 */     GIR_RootConstrainSelectedInstOperands,
     /*  29671 */     // GIR_Coverage, 1049,
     /*  29671 */     GIR_EraseRootFromParent_Done,
     /*  29672 */   // Label 473: @29672
     /*  29672 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(29739), // Rule ID 2231 //
     /*  29677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29705 */     // MIs[1] imm
     /*  29705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29713 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29717 */     // MIs[2] Operand 1
     /*  29717 */     // No operand predicates
     /*  29717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29723 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29737 */     GIR_RootConstrainSelectedInstOperands,
     /*  29738 */     // GIR_Coverage, 2231,
     /*  29738 */     GIR_EraseRootFromParent_Done,
     /*  29739 */   // Label 474: @29739
     /*  29739 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(29806), // Rule ID 2290 //
     /*  29744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29772 */     // MIs[1] imm
     /*  29772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29780 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29784 */     // MIs[2] Operand 1
     /*  29784 */     // No operand predicates
     /*  29784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29790 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29804 */     GIR_RootConstrainSelectedInstOperands,
     /*  29805 */     // GIR_Coverage, 2290,
     /*  29805 */     GIR_EraseRootFromParent_Done,
     /*  29806 */   // Label 475: @29806
     /*  29806 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(29876), // Rule ID 6882 //
     /*  29811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  29823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29849 */     // MIs[2] Rn
     /*  29849 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29854 */     // MIs[2] Rm
     /*  29854 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29861 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29874 */     GIR_RootConstrainSelectedInstOperands,
     /*  29875 */     // GIR_Coverage, 6882,
     /*  29875 */     GIR_EraseRootFromParent_Done,
     /*  29876 */   // Label 476: @29876
     /*  29876 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(29946), // Rule ID 13853 //
     /*  29881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  29893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  29919 */     // MIs[2] Rn
     /*  29919 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29924 */     // MIs[2] Rm
     /*  29924 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29931 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29944 */     GIR_RootConstrainSelectedInstOperands,
     /*  29945 */     // GIR_Coverage, 13853,
     /*  29945 */     GIR_EraseRootFromParent_Done,
     /*  29946 */   // Label 477: @29946
     /*  29946 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30009), // Rule ID 1782 //
     /*  29951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29994 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30007 */     GIR_RootConstrainSelectedInstOperands,
     /*  30008 */     // GIR_Coverage, 1782,
     /*  30008 */     GIR_EraseRootFromParent_Done,
     /*  30009 */   // Label 478: @30009
     /*  30009 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30072), // Rule ID 1781 //
     /*  30014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30057 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30070 */     GIR_RootConstrainSelectedInstOperands,
     /*  30071 */     // GIR_Coverage, 1781,
     /*  30071 */     GIR_EraseRootFromParent_Done,
     /*  30072 */   // Label 479: @30072
     /*  30072 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30135), // Rule ID 1707 //
     /*  30077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30120 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  30123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30133 */     GIR_RootConstrainSelectedInstOperands,
     /*  30134 */     // GIR_Coverage, 1707,
     /*  30134 */     GIR_EraseRootFromParent_Done,
     /*  30135 */   // Label 480: @30135
     /*  30135 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30198), // Rule ID 1780 //
     /*  30140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30183 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30196 */     GIR_RootConstrainSelectedInstOperands,
     /*  30197 */     // GIR_Coverage, 1780,
     /*  30197 */     GIR_EraseRootFromParent_Done,
     /*  30198 */   // Label 481: @30198
     /*  30198 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30261), // Rule ID 1779 //
     /*  30203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30239 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30246 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30259 */     GIR_RootConstrainSelectedInstOperands,
     /*  30260 */     // GIR_Coverage, 1779,
     /*  30260 */     GIR_EraseRootFromParent_Done,
     /*  30261 */   // Label 482: @30261
     /*  30261 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30322), // Rule ID 13315 //
     /*  30266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30305 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30320 */     GIR_RootConstrainSelectedInstOperands,
     /*  30321 */     // GIR_Coverage, 13315,
     /*  30321 */     GIR_EraseRootFromParent_Done,
     /*  30322 */   // Label 483: @30322
     /*  30322 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30383), // Rule ID 13345 //
     /*  30327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30366 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30381 */     GIR_RootConstrainSelectedInstOperands,
     /*  30382 */     // GIR_Coverage, 13345,
     /*  30382 */     GIR_EraseRootFromParent_Done,
     /*  30383 */   // Label 484: @30383
     /*  30383 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30431), // Rule ID 13336 //
     /*  30388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30418 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30429 */     GIR_RootConstrainSelectedInstOperands,
     /*  30430 */     // GIR_Coverage, 13336,
     /*  30430 */     GIR_EraseRootFromParent_Done,
     /*  30431 */   // Label 485: @30431
     /*  30431 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30479), // Rule ID 13225 //
     /*  30436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30466 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30477 */     GIR_RootConstrainSelectedInstOperands,
     /*  30478 */     // GIR_Coverage, 13225,
     /*  30478 */     GIR_EraseRootFromParent_Done,
     /*  30479 */   // Label 486: @30479
     /*  30479 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30527), // Rule ID 13309 //
     /*  30484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30514 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30525 */     GIR_RootConstrainSelectedInstOperands,
     /*  30526 */     // GIR_Coverage, 13309,
     /*  30526 */     GIR_EraseRootFromParent_Done,
     /*  30527 */   // Label 487: @30527
     /*  30527 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(30575), // Rule ID 13237 //
     /*  30532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30562 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30573 */     GIR_RootConstrainSelectedInstOperands,
     /*  30574 */     // GIR_Coverage, 13237,
     /*  30574 */     GIR_EraseRootFromParent_Done,
     /*  30575 */   // Label 488: @30575
     /*  30575 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(30623), // Rule ID 13335 //
     /*  30580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30610 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30621 */     GIR_RootConstrainSelectedInstOperands,
     /*  30622 */     // GIR_Coverage, 13335,
     /*  30622 */     GIR_EraseRootFromParent_Done,
     /*  30623 */   // Label 489: @30623
     /*  30623 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(30684), // Rule ID 1719 //
     /*  30628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30667 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30682 */     GIR_RootConstrainSelectedInstOperands,
     /*  30683 */     // GIR_Coverage, 1719,
     /*  30683 */     GIR_EraseRootFromParent_Done,
     /*  30684 */   // Label 490: @30684
     /*  30684 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(30745), // Rule ID 1809 //
     /*  30689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30728 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30743 */     GIR_RootConstrainSelectedInstOperands,
     /*  30744 */     // GIR_Coverage, 1809,
     /*  30744 */     GIR_EraseRootFromParent_Done,
     /*  30745 */   // Label 491: @30745
     /*  30745 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(30793), // Rule ID 1800 //
     /*  30750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30780 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30791 */     GIR_RootConstrainSelectedInstOperands,
     /*  30792 */     // GIR_Coverage, 1800,
     /*  30792 */     GIR_EraseRootFromParent_Done,
     /*  30793 */   // Label 492: @30793
     /*  30793 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(30841), // Rule ID 987 //
     /*  30798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30828 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30839 */     GIR_RootConstrainSelectedInstOperands,
     /*  30840 */     // GIR_Coverage, 987,
     /*  30840 */     GIR_EraseRootFromParent_Done,
     /*  30841 */   // Label 493: @30841
     /*  30841 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(30889), // Rule ID 1713 //
     /*  30846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30876 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30887 */     GIR_RootConstrainSelectedInstOperands,
     /*  30888 */     // GIR_Coverage, 1713,
     /*  30888 */     GIR_EraseRootFromParent_Done,
     /*  30889 */   // Label 494: @30889
     /*  30889 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(30937), // Rule ID 1048 //
     /*  30894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30924 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30935 */     GIR_RootConstrainSelectedInstOperands,
     /*  30936 */     // GIR_Coverage, 1048,
     /*  30936 */     GIR_EraseRootFromParent_Done,
     /*  30937 */   // Label 495: @30937
     /*  30937 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(30985), // Rule ID 1799 //
     /*  30942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30972 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30983 */     GIR_RootConstrainSelectedInstOperands,
     /*  30984 */     // GIR_Coverage, 1799,
     /*  30984 */     GIR_EraseRootFromParent_Done,
     /*  30985 */   // Label 496: @30985
     /*  30985 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(31012), // Rule ID 1098 //
     /*  30990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31005 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  31005 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  31010 */     GIR_RootConstrainSelectedInstOperands,
     /*  31011 */     // GIR_Coverage, 1098,
     /*  31011 */     GIR_Done,
     /*  31012 */   // Label 497: @31012
     /*  31012 */   GIM_Reject,
     /*  31013 */ // Label 416: @31013
     /*  31013 */ GIM_Reject,
     /*  31014 */ // Label 164: @31014
     /*  31014 */ GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(31863),
     /*  31019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31025 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31158), // Rule ID 13858 //
     /*  31030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  31042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  31054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31062 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  31071 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31075 */     // MIs[1] Operand 2
     /*  31075 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  31086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  31090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  31094 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31098 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  31102 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  31106 */     // MIs[5] Rn
     /*  31106 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31111 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31113 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31125 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31140 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31157 */     // GIR_Coverage, 13858,
     /*  31157 */     GIR_EraseRootFromParent_Done,
     /*  31158 */   // Label 499: @31158
     /*  31158 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31291), // Rule ID 6887 //
     /*  31163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  31175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  31187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  31200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  31204 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31208 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  31212 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  31216 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31220 */     // MIs[4] Rn
     /*  31220 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31225 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31229 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31233 */     // MIs[3] Operand 2
     /*  31233 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31244 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31246 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31273 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31290 */     // GIR_Coverage, 6887,
     /*  31290 */     GIR_EraseRootFromParent_Done,
     /*  31291 */   // Label 500: @31291
     /*  31291 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(31360), // Rule ID 13254 //
     /*  31296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31311 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31314 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31323 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31343 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31358 */     GIR_RootConstrainSelectedInstOperands,
     /*  31359 */     // GIR_Coverage, 13254,
     /*  31359 */     GIR_EraseRootFromParent_Done,
     /*  31360 */   // Label 501: @31360
     /*  31360 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31429), // Rule ID 13266 //
     /*  31365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31380 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31383 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31392 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31412 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31427 */     GIR_RootConstrainSelectedInstOperands,
     /*  31428 */     // GIR_Coverage, 13266,
     /*  31428 */     GIR_EraseRootFromParent_Done,
     /*  31429 */   // Label 502: @31429
     /*  31429 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(31496), // Rule ID 13458 //
     /*  31434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31458 */     // MIs[1] imm
     /*  31458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31466 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31470 */     // MIs[2] Operand 1
     /*  31470 */     // No operand predicates
     /*  31470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31474 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31480 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31494 */     GIR_RootConstrainSelectedInstOperands,
     /*  31495 */     // GIR_Coverage, 13458,
     /*  31495 */     GIR_EraseRootFromParent_Done,
     /*  31496 */   // Label 503: @31496
     /*  31496 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(31563), // Rule ID 13479 //
     /*  31501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31525 */     // MIs[1] imm
     /*  31525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31533 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31537 */     // MIs[2] Operand 1
     /*  31537 */     // No operand predicates
     /*  31537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31547 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31561 */     GIR_RootConstrainSelectedInstOperands,
     /*  31562 */     // GIR_Coverage, 13479,
     /*  31562 */     GIR_EraseRootFromParent_Done,
     /*  31563 */   // Label 504: @31563
     /*  31563 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(31632), // Rule ID 1350 //
     /*  31568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31587 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31590 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31599 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31615 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31630 */     GIR_RootConstrainSelectedInstOperands,
     /*  31631 */     // GIR_Coverage, 1350,
     /*  31631 */     GIR_EraseRootFromParent_Done,
     /*  31632 */   // Label 505: @31632
     /*  31632 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(31701), // Rule ID 1473 //
     /*  31637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31656 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31659 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31668 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31684 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31699 */     GIR_RootConstrainSelectedInstOperands,
     /*  31700 */     // GIR_Coverage, 1473,
     /*  31700 */     GIR_EraseRootFromParent_Done,
     /*  31701 */   // Label 506: @31701
     /*  31701 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(31768), // Rule ID 2221 //
     /*  31706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31734 */     // MIs[1] imm
     /*  31734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31742 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31746 */     // MIs[2] Operand 1
     /*  31746 */     // No operand predicates
     /*  31746 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31752 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31766 */     GIR_RootConstrainSelectedInstOperands,
     /*  31767 */     // GIR_Coverage, 2221,
     /*  31767 */     GIR_EraseRootFromParent_Done,
     /*  31768 */   // Label 507: @31768
     /*  31768 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(31835), // Rule ID 2280 //
     /*  31773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31801 */     // MIs[1] imm
     /*  31801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31809 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31813 */     // MIs[2] Operand 1
     /*  31813 */     // No operand predicates
     /*  31813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31819 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31833 */     GIR_RootConstrainSelectedInstOperands,
     /*  31834 */     // GIR_Coverage, 2280,
     /*  31834 */     GIR_EraseRootFromParent_Done,
     /*  31835 */   // Label 508: @31835
     /*  31835 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(31862), // Rule ID 1093 //
     /*  31840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31855 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  31860 */     GIR_RootConstrainSelectedInstOperands,
     /*  31861 */     // GIR_Coverage, 1093,
     /*  31861 */     GIR_Done,
     /*  31862 */   // Label 509: @31862
     /*  31862 */   GIM_Reject,
     /*  31863 */ // Label 498: @31863
     /*  31863 */ GIM_Reject,
     /*  31864 */ // Label 165: @31864
     /*  31864 */ GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(35441),
     /*  31869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31875 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(31962), // Rule ID 13298 //
     /*  31880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31907 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31910 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31915 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31919 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31943 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31960 */     GIR_RootConstrainSelectedInstOperands,
     /*  31961 */     // GIR_Coverage, 13298,
     /*  31961 */     GIR_EraseRootFromParent_Done,
     /*  31962 */   // Label 511: @31962
     /*  31962 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32049), // Rule ID 13322 //
     /*  31967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31994 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31997 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32006 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32030 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  32033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32047 */     GIR_RootConstrainSelectedInstOperands,
     /*  32048 */     // GIR_Coverage, 13322,
     /*  32048 */     GIR_EraseRootFromParent_Done,
     /*  32049 */   // Label 512: @32049
     /*  32049 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32136), // Rule ID 1684 //
     /*  32054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32085 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32088 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32097 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32103 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32117 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  32120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32134 */     GIR_RootConstrainSelectedInstOperands,
     /*  32135 */     // GIR_Coverage, 1684,
     /*  32135 */     GIR_EraseRootFromParent_Done,
     /*  32136 */   // Label 513: @32136
     /*  32136 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32223), // Rule ID 1762 //
     /*  32141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32172 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32175 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32184 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32190 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32197 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32204 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  32207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32221 */     GIR_RootConstrainSelectedInstOperands,
     /*  32222 */     // GIR_Coverage, 1762,
     /*  32222 */     GIR_EraseRootFromParent_Done,
     /*  32223 */   // Label 514: @32223
     /*  32223 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32292), // Rule ID 1778 //
     /*  32228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32268 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32275 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32290 */     GIR_RootConstrainSelectedInstOperands,
     /*  32291 */     // GIR_Coverage, 1778,
     /*  32291 */     GIR_EraseRootFromParent_Done,
     /*  32292 */   // Label 515: @32292
     /*  32292 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32361), // Rule ID 1777 //
     /*  32297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32344 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32359 */     GIR_RootConstrainSelectedInstOperands,
     /*  32360 */     // GIR_Coverage, 1777,
     /*  32360 */     GIR_EraseRootFromParent_Done,
     /*  32361 */   // Label 516: @32361
     /*  32361 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32430), // Rule ID 1706 //
     /*  32366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32413 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32428 */     GIR_RootConstrainSelectedInstOperands,
     /*  32429 */     // GIR_Coverage, 1706,
     /*  32429 */     GIR_EraseRootFromParent_Done,
     /*  32430 */   // Label 517: @32430
     /*  32430 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32499), // Rule ID 1776 //
     /*  32435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32475 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32482 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32497 */     GIR_RootConstrainSelectedInstOperands,
     /*  32498 */     // GIR_Coverage, 1776,
     /*  32498 */     GIR_EraseRootFromParent_Done,
     /*  32499 */   // Label 518: @32499
     /*  32499 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(32568), // Rule ID 1775 //
     /*  32504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32551 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32566 */     GIR_RootConstrainSelectedInstOperands,
     /*  32567 */     // GIR_Coverage, 1775,
     /*  32567 */     GIR_EraseRootFromParent_Done,
     /*  32568 */   // Label 519: @32568
     /*  32568 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(32635), // Rule ID 13314 //
     /*  32573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32616 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32633 */     GIR_RootConstrainSelectedInstOperands,
     /*  32634 */     // GIR_Coverage, 13314,
     /*  32634 */     GIR_EraseRootFromParent_Done,
     /*  32635 */   // Label 520: @32635
     /*  32635 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(32702), // Rule ID 13344 //
     /*  32640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32683 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32700 */     GIR_RootConstrainSelectedInstOperands,
     /*  32701 */     // GIR_Coverage, 13344,
     /*  32701 */     GIR_EraseRootFromParent_Done,
     /*  32702 */   // Label 521: @32702
     /*  32702 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(32769), // Rule ID 1718 //
     /*  32707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32750 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32767 */     GIR_RootConstrainSelectedInstOperands,
     /*  32768 */     // GIR_Coverage, 1718,
     /*  32768 */     GIR_EraseRootFromParent_Done,
     /*  32769 */   // Label 522: @32769
     /*  32769 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(32836), // Rule ID 1808 //
     /*  32774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32817 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32834 */     GIR_RootConstrainSelectedInstOperands,
     /*  32835 */     // GIR_Coverage, 1808,
     /*  32835 */     GIR_EraseRootFromParent_Done,
     /*  32836 */   // Label 523: @32836
     /*  32836 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(32917), // Rule ID 13296 //
     /*  32841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32868 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32871 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32880 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32900 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32915 */     GIR_RootConstrainSelectedInstOperands,
     /*  32916 */     // GIR_Coverage, 13296,
     /*  32916 */     GIR_EraseRootFromParent_Done,
     /*  32917 */   // Label 524: @32917
     /*  32917 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(32998), // Rule ID 13320 //
     /*  32922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32949 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32952 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32961 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32965 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32981 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32996 */     GIR_RootConstrainSelectedInstOperands,
     /*  32997 */     // GIR_Coverage, 13320,
     /*  32997 */     GIR_EraseRootFromParent_Done,
     /*  32998 */   // Label 525: @32998
     /*  32998 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33079), // Rule ID 1682 //
     /*  33003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33034 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33037 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33046 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33062 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  33065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33077 */     GIR_RootConstrainSelectedInstOperands,
     /*  33078 */     // GIR_Coverage, 1682,
     /*  33078 */     GIR_EraseRootFromParent_Done,
     /*  33079 */   // Label 526: @33079
     /*  33079 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33160), // Rule ID 1760 //
     /*  33084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33115 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33118 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33127 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33131 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33143 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  33146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33158 */     GIR_RootConstrainSelectedInstOperands,
     /*  33159 */     // GIR_Coverage, 1760,
     /*  33159 */     GIR_EraseRootFromParent_Done,
     /*  33160 */   // Label 527: @33160
     /*  33160 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33211), // Rule ID 13334 //
     /*  33165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33197 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33209 */     GIR_RootConstrainSelectedInstOperands,
     /*  33210 */     // GIR_Coverage, 13334,
     /*  33210 */     GIR_EraseRootFromParent_Done,
     /*  33211 */   // Label 528: @33211
     /*  33211 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33262), // Rule ID 13308 //
     /*  33216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33248 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33260 */     GIR_RootConstrainSelectedInstOperands,
     /*  33261 */     // GIR_Coverage, 13308,
     /*  33261 */     GIR_EraseRootFromParent_Done,
     /*  33262 */   // Label 529: @33262
     /*  33262 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33313), // Rule ID 13333 //
     /*  33267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33299 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33311 */     GIR_RootConstrainSelectedInstOperands,
     /*  33312 */     // GIR_Coverage, 13333,
     /*  33312 */     GIR_EraseRootFromParent_Done,
     /*  33313 */   // Label 530: @33313
     /*  33313 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33364), // Rule ID 1798 //
     /*  33318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33350 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33362 */     GIR_RootConstrainSelectedInstOperands,
     /*  33363 */     // GIR_Coverage, 1798,
     /*  33363 */     GIR_EraseRootFromParent_Done,
     /*  33364 */   // Label 531: @33364
     /*  33364 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33415), // Rule ID 1712 //
     /*  33369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33401 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33413 */     GIR_RootConstrainSelectedInstOperands,
     /*  33414 */     // GIR_Coverage, 1712,
     /*  33414 */     GIR_EraseRootFromParent_Done,
     /*  33415 */   // Label 532: @33415
     /*  33415 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33466), // Rule ID 1797 //
     /*  33420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33452 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33464 */     GIR_RootConstrainSelectedInstOperands,
     /*  33465 */     // GIR_Coverage, 1797,
     /*  33465 */     GIR_EraseRootFromParent_Done,
     /*  33466 */   // Label 533: @33466
     /*  33466 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(33535), // Rule ID 13260 //
     /*  33471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33486 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33489 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33498 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33518 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33533 */     GIR_RootConstrainSelectedInstOperands,
     /*  33534 */     // GIR_Coverage, 13260,
     /*  33534 */     GIR_EraseRootFromParent_Done,
     /*  33535 */   // Label 534: @33535
     /*  33535 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(33604), // Rule ID 13272 //
     /*  33540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33555 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33558 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33567 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33587 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33602 */     GIR_RootConstrainSelectedInstOperands,
     /*  33603 */     // GIR_Coverage, 13272,
     /*  33603 */     GIR_EraseRootFromParent_Done,
     /*  33604 */   // Label 535: @33604
     /*  33604 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(33660), // Rule ID 13222 //
     /*  33609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33624 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33627 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33647 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33658 */     GIR_RootConstrainSelectedInstOperands,
     /*  33659 */     // GIR_Coverage, 13222,
     /*  33659 */     GIR_EraseRootFromParent_Done,
     /*  33660 */   // Label 536: @33660
     /*  33660 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(33716), // Rule ID 13234 //
     /*  33665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33680 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33683 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33703 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33714 */     GIR_RootConstrainSelectedInstOperands,
     /*  33715 */     // GIR_Coverage, 13234,
     /*  33715 */     GIR_EraseRootFromParent_Done,
     /*  33716 */   // Label 537: @33716
     /*  33716 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(33783), // Rule ID 13464 //
     /*  33721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33745 */     // MIs[1] imm
     /*  33745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33757 */     // MIs[2] Operand 1
     /*  33757 */     // No operand predicates
     /*  33757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33761 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33767 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33781 */     GIR_RootConstrainSelectedInstOperands,
     /*  33782 */     // GIR_Coverage, 13464,
     /*  33782 */     GIR_EraseRootFromParent_Done,
     /*  33783 */   // Label 538: @33783
     /*  33783 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(33850), // Rule ID 13485 //
     /*  33788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33812 */     // MIs[1] imm
     /*  33812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33820 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33824 */     // MIs[2] Operand 1
     /*  33824 */     // No operand predicates
     /*  33824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33828 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33834 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33848 */     GIR_RootConstrainSelectedInstOperands,
     /*  33849 */     // GIR_Coverage, 13485,
     /*  33849 */     GIR_EraseRootFromParent_Done,
     /*  33850 */   // Label 539: @33850
     /*  33850 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(33919), // Rule ID 1356 //
     /*  33855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33874 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33877 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33886 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33902 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33917 */     GIR_RootConstrainSelectedInstOperands,
     /*  33918 */     // GIR_Coverage, 1356,
     /*  33918 */     GIR_EraseRootFromParent_Done,
     /*  33919 */   // Label 540: @33919
     /*  33919 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(33988), // Rule ID 1479 //
     /*  33924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33943 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33946 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33955 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33971 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33986 */     GIR_RootConstrainSelectedInstOperands,
     /*  33987 */     // GIR_Coverage, 1479,
     /*  33987 */     GIR_EraseRootFromParent_Done,
     /*  33988 */   // Label 541: @33988
     /*  33988 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34044), // Rule ID 984 //
     /*  33993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34012 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34015 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  34020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34031 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34042 */     GIR_RootConstrainSelectedInstOperands,
     /*  34043 */     // GIR_Coverage, 984,
     /*  34043 */     GIR_EraseRootFromParent_Done,
     /*  34044 */   // Label 542: @34044
     /*  34044 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34100), // Rule ID 1045 //
     /*  34049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34068 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34071 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  34076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34087 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34098 */     GIR_RootConstrainSelectedInstOperands,
     /*  34099 */     // GIR_Coverage, 1045,
     /*  34099 */     GIR_EraseRootFromParent_Done,
     /*  34100 */   // Label 543: @34100
     /*  34100 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34167), // Rule ID 2227 //
     /*  34105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  34124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34133 */     // MIs[1] imm
     /*  34133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34141 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34145 */     // MIs[2] Operand 1
     /*  34145 */     // No operand predicates
     /*  34145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34151 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  34154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34165 */     GIR_RootConstrainSelectedInstOperands,
     /*  34166 */     // GIR_Coverage, 2227,
     /*  34166 */     GIR_EraseRootFromParent_Done,
     /*  34167 */   // Label 544: @34167
     /*  34167 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34234), // Rule ID 2286 //
     /*  34172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  34191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34200 */     // MIs[1] imm
     /*  34200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34208 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34212 */     // MIs[2] Operand 1
     /*  34212 */     // No operand predicates
     /*  34212 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34218 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34232 */     GIR_RootConstrainSelectedInstOperands,
     /*  34233 */     // GIR_Coverage, 2286,
     /*  34233 */     GIR_EraseRootFromParent_Done,
     /*  34234 */   // Label 545: @34234
     /*  34234 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34304), // Rule ID 6883 //
     /*  34239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34277 */     // MIs[2] Rn
     /*  34277 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34282 */     // MIs[2] Rm
     /*  34282 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34289 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34302 */     GIR_RootConstrainSelectedInstOperands,
     /*  34303 */     // GIR_Coverage, 6883,
     /*  34303 */     GIR_EraseRootFromParent_Done,
     /*  34304 */   // Label 546: @34304
     /*  34304 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34374), // Rule ID 13854 //
     /*  34309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34347 */     // MIs[2] Rn
     /*  34347 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34352 */     // MIs[2] Rm
     /*  34352 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34359 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34372 */     GIR_RootConstrainSelectedInstOperands,
     /*  34373 */     // GIR_Coverage, 13854,
     /*  34373 */     GIR_EraseRootFromParent_Done,
     /*  34374 */   // Label 547: @34374
     /*  34374 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34437), // Rule ID 1774 //
     /*  34379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34422 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34435 */     GIR_RootConstrainSelectedInstOperands,
     /*  34436 */     // GIR_Coverage, 1774,
     /*  34436 */     GIR_EraseRootFromParent_Done,
     /*  34437 */   // Label 548: @34437
     /*  34437 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34500), // Rule ID 1773 //
     /*  34442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34485 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34498 */     GIR_RootConstrainSelectedInstOperands,
     /*  34499 */     // GIR_Coverage, 1773,
     /*  34499 */     GIR_EraseRootFromParent_Done,
     /*  34500 */   // Label 549: @34500
     /*  34500 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(34563), // Rule ID 1705 //
     /*  34505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34548 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34561 */     GIR_RootConstrainSelectedInstOperands,
     /*  34562 */     // GIR_Coverage, 1705,
     /*  34562 */     GIR_EraseRootFromParent_Done,
     /*  34563 */   // Label 550: @34563
     /*  34563 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(34626), // Rule ID 1772 //
     /*  34568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34611 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34624 */     GIR_RootConstrainSelectedInstOperands,
     /*  34625 */     // GIR_Coverage, 1772,
     /*  34625 */     GIR_EraseRootFromParent_Done,
     /*  34626 */   // Label 551: @34626
     /*  34626 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(34689), // Rule ID 1771 //
     /*  34631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34674 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34687 */     GIR_RootConstrainSelectedInstOperands,
     /*  34688 */     // GIR_Coverage, 1771,
     /*  34688 */     GIR_EraseRootFromParent_Done,
     /*  34689 */   // Label 552: @34689
     /*  34689 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(34750), // Rule ID 13313 //
     /*  34694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34733 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34748 */     GIR_RootConstrainSelectedInstOperands,
     /*  34749 */     // GIR_Coverage, 13313,
     /*  34749 */     GIR_EraseRootFromParent_Done,
     /*  34750 */   // Label 553: @34750
     /*  34750 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(34811), // Rule ID 13343 //
     /*  34755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34794 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34809 */     GIR_RootConstrainSelectedInstOperands,
     /*  34810 */     // GIR_Coverage, 13343,
     /*  34810 */     GIR_EraseRootFromParent_Done,
     /*  34811 */   // Label 554: @34811
     /*  34811 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(34859), // Rule ID 13332 //
     /*  34816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34846 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34857 */     GIR_RootConstrainSelectedInstOperands,
     /*  34858 */     // GIR_Coverage, 13332,
     /*  34858 */     GIR_EraseRootFromParent_Done,
     /*  34859 */   // Label 555: @34859
     /*  34859 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(34907), // Rule ID 13221 //
     /*  34864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  34879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34894 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34905 */     GIR_RootConstrainSelectedInstOperands,
     /*  34906 */     // GIR_Coverage, 13221,
     /*  34906 */     GIR_EraseRootFromParent_Done,
     /*  34907 */   // Label 556: @34907
     /*  34907 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(34955), // Rule ID 13307 //
     /*  34912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34942 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  34945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34953 */     GIR_RootConstrainSelectedInstOperands,
     /*  34954 */     // GIR_Coverage, 13307,
     /*  34954 */     GIR_EraseRootFromParent_Done,
     /*  34955 */   // Label 557: @34955
     /*  34955 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(35003), // Rule ID 13233 //
     /*  34960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  34975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34990 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35001 */     GIR_RootConstrainSelectedInstOperands,
     /*  35002 */     // GIR_Coverage, 13233,
     /*  35002 */     GIR_EraseRootFromParent_Done,
     /*  35003 */   // Label 558: @35003
     /*  35003 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35051), // Rule ID 13331 //
     /*  35008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35038 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  35045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35049 */     GIR_RootConstrainSelectedInstOperands,
     /*  35050 */     // GIR_Coverage, 13331,
     /*  35050 */     GIR_EraseRootFromParent_Done,
     /*  35051 */   // Label 559: @35051
     /*  35051 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35112), // Rule ID 1717 //
     /*  35056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  35075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35095 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  35098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35110 */     GIR_RootConstrainSelectedInstOperands,
     /*  35111 */     // GIR_Coverage, 1717,
     /*  35111 */     GIR_EraseRootFromParent_Done,
     /*  35112 */   // Label 560: @35112
     /*  35112 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35173), // Rule ID 1807 //
     /*  35117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  35136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35156 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  35159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35171 */     GIR_RootConstrainSelectedInstOperands,
     /*  35172 */     // GIR_Coverage, 1807,
     /*  35172 */     GIR_EraseRootFromParent_Done,
     /*  35173 */   // Label 561: @35173
     /*  35173 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35221), // Rule ID 1796 //
     /*  35178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35208 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35219 */     GIR_RootConstrainSelectedInstOperands,
     /*  35220 */     // GIR_Coverage, 1796,
     /*  35220 */     GIR_EraseRootFromParent_Done,
     /*  35221 */   // Label 562: @35221
     /*  35221 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35269), // Rule ID 983 //
     /*  35226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35256 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35267 */     GIR_RootConstrainSelectedInstOperands,
     /*  35268 */     // GIR_Coverage, 983,
     /*  35268 */     GIR_EraseRootFromParent_Done,
     /*  35269 */   // Label 563: @35269
     /*  35269 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35317), // Rule ID 1711 //
     /*  35274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35304 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35315 */     GIR_RootConstrainSelectedInstOperands,
     /*  35316 */     // GIR_Coverage, 1711,
     /*  35316 */     GIR_EraseRootFromParent_Done,
     /*  35317 */   // Label 564: @35317
     /*  35317 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35365), // Rule ID 1044 //
     /*  35322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35352 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35363 */     GIR_RootConstrainSelectedInstOperands,
     /*  35364 */     // GIR_Coverage, 1044,
     /*  35364 */     GIR_EraseRootFromParent_Done,
     /*  35365 */   // Label 565: @35365
     /*  35365 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35413), // Rule ID 1795 //
     /*  35370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35400 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35411 */     GIR_RootConstrainSelectedInstOperands,
     /*  35412 */     // GIR_Coverage, 1795,
     /*  35412 */     GIR_EraseRootFromParent_Done,
     /*  35413 */   // Label 566: @35413
     /*  35413 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(35440), // Rule ID 1096 //
     /*  35418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35433 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35438 */     GIR_RootConstrainSelectedInstOperands,
     /*  35439 */     // GIR_Coverage, 1096,
     /*  35439 */     GIR_Done,
     /*  35440 */   // Label 567: @35440
     /*  35440 */   GIM_Reject,
     /*  35441 */ // Label 510: @35441
     /*  35441 */ GIM_Reject,
     /*  35442 */ // Label 166: @35442
     /*  35442 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(36165),
     /*  35447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35453 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35522), // Rule ID 13256 //
     /*  35458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35473 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35476 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35485 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35505 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35520 */     GIR_RootConstrainSelectedInstOperands,
     /*  35521 */     // GIR_Coverage, 13256,
     /*  35521 */     GIR_EraseRootFromParent_Done,
     /*  35522 */   // Label 569: @35522
     /*  35522 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(35591), // Rule ID 13268 //
     /*  35527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35542 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35545 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35554 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35574 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35589 */     GIR_RootConstrainSelectedInstOperands,
     /*  35590 */     // GIR_Coverage, 13268,
     /*  35590 */     GIR_EraseRootFromParent_Done,
     /*  35591 */   // Label 570: @35591
     /*  35591 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(35658), // Rule ID 13460 //
     /*  35596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35620 */     // MIs[1] imm
     /*  35620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35628 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35632 */     // MIs[2] Operand 1
     /*  35632 */     // No operand predicates
     /*  35632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35636 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35642 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35656 */     GIR_RootConstrainSelectedInstOperands,
     /*  35657 */     // GIR_Coverage, 13460,
     /*  35657 */     GIR_EraseRootFromParent_Done,
     /*  35658 */   // Label 571: @35658
     /*  35658 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(35725), // Rule ID 13481 //
     /*  35663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35687 */     // MIs[1] imm
     /*  35687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35695 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35699 */     // MIs[2] Operand 1
     /*  35699 */     // No operand predicates
     /*  35699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35703 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35709 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35723 */     GIR_RootConstrainSelectedInstOperands,
     /*  35724 */     // GIR_Coverage, 13481,
     /*  35724 */     GIR_EraseRootFromParent_Done,
     /*  35725 */   // Label 572: @35725
     /*  35725 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(35794), // Rule ID 1352 //
     /*  35730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35749 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35752 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35761 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35777 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35792 */     GIR_RootConstrainSelectedInstOperands,
     /*  35793 */     // GIR_Coverage, 1352,
     /*  35793 */     GIR_EraseRootFromParent_Done,
     /*  35794 */   // Label 573: @35794
     /*  35794 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(35863), // Rule ID 1475 //
     /*  35799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35818 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35821 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35830 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35846 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35861 */     GIR_RootConstrainSelectedInstOperands,
     /*  35862 */     // GIR_Coverage, 1475,
     /*  35862 */     GIR_EraseRootFromParent_Done,
     /*  35863 */   // Label 574: @35863
     /*  35863 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(35930), // Rule ID 2223 //
     /*  35868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35896 */     // MIs[1] imm
     /*  35896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35908 */     // MIs[2] Operand 1
     /*  35908 */     // No operand predicates
     /*  35908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35914 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35928 */     GIR_RootConstrainSelectedInstOperands,
     /*  35929 */     // GIR_Coverage, 2223,
     /*  35929 */     GIR_EraseRootFromParent_Done,
     /*  35930 */   // Label 575: @35930
     /*  35930 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(35997), // Rule ID 2282 //
     /*  35935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35963 */     // MIs[1] imm
     /*  35963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35971 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35975 */     // MIs[2] Operand 1
     /*  35975 */     // No operand predicates
     /*  35975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35981 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35995 */     GIR_RootConstrainSelectedInstOperands,
     /*  35996 */     // GIR_Coverage, 2282,
     /*  35996 */     GIR_EraseRootFromParent_Done,
     /*  35997 */   // Label 576: @35997
     /*  35997 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36067), // Rule ID 6884 //
     /*  36002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  36014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  36036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  36040 */     // MIs[2] Rn
     /*  36040 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36045 */     // MIs[2] Rm
     /*  36045 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  36050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36052 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  36052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  36055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  36065 */     GIR_RootConstrainSelectedInstOperands,
     /*  36066 */     // GIR_Coverage, 6884,
     /*  36066 */     GIR_EraseRootFromParent_Done,
     /*  36067 */   // Label 577: @36067
     /*  36067 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36137), // Rule ID 13855 //
     /*  36072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  36084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  36106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  36110 */     // MIs[2] Rn
     /*  36110 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36115 */     // MIs[2] Rm
     /*  36115 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  36120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36122 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  36122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  36125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  36135 */     GIR_RootConstrainSelectedInstOperands,
     /*  36136 */     // GIR_Coverage, 13855,
     /*  36136 */     GIR_EraseRootFromParent_Done,
     /*  36137 */   // Label 578: @36137
     /*  36137 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36164), // Rule ID 1094 //
     /*  36142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36157 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  36157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  36162 */     GIR_RootConstrainSelectedInstOperands,
     /*  36163 */     // GIR_Coverage, 1094,
     /*  36163 */     GIR_Done,
     /*  36164 */   // Label 579: @36164
     /*  36164 */   GIM_Reject,
     /*  36165 */ // Label 568: @36165
     /*  36165 */ GIM_Reject,
     /*  36166 */ // Label 167: @36166
     /*  36166 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36537),
     /*  36171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36181 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36243), // Rule ID 15039 //
     /*  36186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36217 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36230 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36241 */     GIR_RootConstrainSelectedInstOperands,
     /*  36242 */     // GIR_Coverage, 15039,
     /*  36242 */     GIR_EraseRootFromParent_Done,
     /*  36243 */   // Label 581: @36243
     /*  36243 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(36305), // Rule ID 15038 //
     /*  36248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36279 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36292 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36303 */     GIR_RootConstrainSelectedInstOperands,
     /*  36304 */     // GIR_Coverage, 15038,
     /*  36304 */     GIR_EraseRootFromParent_Done,
     /*  36305 */   // Label 582: @36305
     /*  36305 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(36367), // Rule ID 15037 //
     /*  36310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36341 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36354 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36359 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36365 */     GIR_RootConstrainSelectedInstOperands,
     /*  36366 */     // GIR_Coverage, 15037,
     /*  36366 */     GIR_EraseRootFromParent_Done,
     /*  36367 */   // Label 583: @36367
     /*  36367 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(36429), // Rule ID 8823 //
     /*  36372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36403 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36416 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36427 */     GIR_RootConstrainSelectedInstOperands,
     /*  36428 */     // GIR_Coverage, 8823,
     /*  36428 */     GIR_EraseRootFromParent_Done,
     /*  36429 */   // Label 584: @36429
     /*  36429 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(36475), // Rule ID 15040 //
     /*  36434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36449 */     // MIs[1] Operand 2
     /*  36449 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36462 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36473 */     GIR_RootConstrainSelectedInstOperands,
     /*  36474 */     // GIR_Coverage, 15040,
     /*  36474 */     GIR_EraseRootFromParent_Done,
     /*  36475 */   // Label 585: @36475
     /*  36475 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(36521), // Rule ID 8824 //
     /*  36480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36495 */     // MIs[1] Operand 2
     /*  36495 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36508 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36519 */     GIR_RootConstrainSelectedInstOperands,
     /*  36520 */     // GIR_Coverage, 8824,
     /*  36520 */     GIR_EraseRootFromParent_Done,
     /*  36521 */   // Label 586: @36521
     /*  36521 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(36536), // Rule ID 2771 //
     /*  36526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36529 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36534 */     GIR_RootConstrainSelectedInstOperands,
     /*  36535 */     // GIR_Coverage, 2771,
     /*  36535 */     GIR_Done,
     /*  36536 */   // Label 587: @36536
     /*  36536 */   GIM_Reject,
     /*  36537 */ // Label 580: @36537
     /*  36537 */ GIM_Reject,
     /*  36538 */ // Label 168: @36538
     /*  36538 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(36563), // Rule ID 2770 //
     /*  36543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36556 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36561 */   GIR_RootConstrainSelectedInstOperands,
     /*  36562 */   // GIR_Coverage, 2770,
     /*  36562 */   GIR_Done,
     /*  36563 */ // Label 588: @36563
     /*  36563 */ GIM_Reject,
     /*  36564 */ // Label 169: @36564
     /*  36564 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(36589), // Rule ID 2769 //
     /*  36569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36582 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36587 */   GIR_RootConstrainSelectedInstOperands,
     /*  36588 */   // GIR_Coverage, 2769,
     /*  36588 */   GIR_Done,
     /*  36589 */ // Label 589: @36589
     /*  36589 */ GIM_Reject,
     /*  36590 */ // Label 170: @36590
     /*  36590 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(36615), // Rule ID 2768 //
     /*  36595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  36601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  36604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36608 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  36608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  36613 */   GIR_RootConstrainSelectedInstOperands,
     /*  36614 */   // GIR_Coverage, 2768,
     /*  36614 */   GIR_Done,
     /*  36615 */ // Label 590: @36615
     /*  36615 */ GIM_Reject,
     /*  36616 */ // Label 171: @36616
     /*  36616 */ GIM_Reject,
     /*  36617 */ // Label 1: @36617
     /*  36617 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 604*/ GIMT_Encode4(50844),
     /*  36628 */ /*GILLT_s32*//*Label 591*/ GIMT_Encode4(36716),
     /*  36632 */ /*GILLT_s64*//*Label 592*/ GIMT_Encode4(38198), GIMT_Encode4(0),
     /*  36640 */ /*GILLT_v2s32*//*Label 593*/ GIMT_Encode4(41480),
     /*  36644 */ /*GILLT_v2s64*//*Label 594*/ GIMT_Encode4(42971),
     /*  36648 */ /*GILLT_v4s16*//*Label 595*/ GIMT_Encode4(45431),
     /*  36652 */ /*GILLT_v4s32*//*Label 596*/ GIMT_Encode4(46922),
     /*  36656 */ /*GILLT_v8s8*//*Label 597*/ GIMT_Encode4(49382),
     /*  36660 */ /*GILLT_v8s16*//*Label 598*/ GIMT_Encode4(49457),
     /*  36664 */ /*GILLT_v16s8*//*Label 599*/ GIMT_Encode4(50665), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36684 */ /*GILLT_nxv2s64*//*Label 600*/ GIMT_Encode4(50740), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36696 */ /*GILLT_nxv4s32*//*Label 601*/ GIMT_Encode4(50766), GIMT_Encode4(0),
     /*  36704 */ /*GILLT_nxv8s16*//*Label 602*/ GIMT_Encode4(50792), GIMT_Encode4(0),
     /*  36712 */ /*GILLT_nxv16s8*//*Label 603*/ GIMT_Encode4(50818),
     /*  36716 */ // Label 591: @36716
     /*  36716 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(38197),
     /*  36721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36727 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(36879), // Rule ID 9870 //
     /*  36732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36763 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36766 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  36771 */     // MIs[2] pattern
     /*  36771 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36774 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36781 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36781 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36784 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36788 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36795 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36798 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36802 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36807 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36810 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36814 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36817 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36822 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36827 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  36839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36844 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36847 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36851 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36861 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36878 */     // GIR_Coverage, 9870,
     /*  36878 */     GIR_EraseRootFromParent_Done,
     /*  36879 */   // Label 606: @36879
     /*  36879 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37031), // Rule ID 9882 //
     /*  36884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36915 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36918 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  36923 */     // MIs[2] pattern
     /*  36923 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36926 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36933 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36933 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36936 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36940 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36947 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36950 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36954 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36959 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36962 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36966 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36969 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  36991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36996 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36999 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37003 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37013 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37030 */     // GIR_Coverage, 9882,
     /*  37030 */     GIR_EraseRootFromParent_Done,
     /*  37031 */   // Label 607: @37031
     /*  37031 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37183), // Rule ID 9894 //
     /*  37036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37067 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37070 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  37075 */     // MIs[2] pattern
     /*  37075 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37078 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37085 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37085 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37088 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37092 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37111 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37114 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37118 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37121 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37126 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37131 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  37143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37148 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37155 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37165 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37182 */     // GIR_Coverage, 9894,
     /*  37182 */     GIR_EraseRootFromParent_Done,
     /*  37183 */   // Label 608: @37183
     /*  37183 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37335), // Rule ID 9906 //
     /*  37188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37219 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37222 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37227 */     // MIs[2] pattern
     /*  37227 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37230 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37237 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37237 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37240 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37244 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37251 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37254 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37258 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37263 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37266 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37270 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37273 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37278 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37300 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37303 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37307 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37317 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37334 */     // GIR_Coverage, 9906,
     /*  37334 */     GIR_EraseRootFromParent_Done,
     /*  37335 */   // Label 609: @37335
     /*  37335 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37397), // Rule ID 3934 //
     /*  37340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37376 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37395 */     GIR_RootConstrainSelectedInstOperands,
     /*  37396 */     // GIR_Coverage, 3934,
     /*  37396 */     GIR_EraseRootFromParent_Done,
     /*  37397 */   // Label 610: @37397
     /*  37397 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37554), // Rule ID 10008 //
     /*  37402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37433 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37436 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37445 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37452 */     // MIs[2] pred
     /*  37452 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37459 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37459 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37462 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37466 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37473 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37476 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37480 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37485 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37488 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37492 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37495 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37526 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37536 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37553 */     // GIR_Coverage, 10008,
     /*  37553 */     GIR_EraseRootFromParent_Done,
     /*  37554 */   // Label 611: @37554
     /*  37554 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37711), // Rule ID 10009 //
     /*  37559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37590 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37593 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  37602 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37609 */     // MIs[2] pred
     /*  37609 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37616 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37616 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37619 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37623 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37630 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37633 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37637 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37642 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37645 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37649 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37652 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37657 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37662 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  37674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37679 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37683 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37693 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37710 */     // GIR_Coverage, 10009,
     /*  37710 */     GIR_EraseRootFromParent_Done,
     /*  37711 */   // Label 612: @37711
     /*  37711 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(37868), // Rule ID 10010 //
     /*  37716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37747 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37750 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  37759 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37766 */     // MIs[2] pred
     /*  37766 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37773 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37773 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37776 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37780 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37787 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37790 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37794 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37799 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37802 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37806 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37809 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37814 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  37831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37836 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37840 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37850 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37867 */     // GIR_Coverage, 10010,
     /*  37867 */     GIR_EraseRootFromParent_Done,
     /*  37868 */   // Label 613: @37868
     /*  37868 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38025), // Rule ID 10011 //
     /*  37873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37904 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37907 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  37916 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37923 */     // MIs[2] pred
     /*  37923 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37930 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37930 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37933 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37937 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37956 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37959 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37963 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37966 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37976 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  37988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37997 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38007 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  38014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38024 */     // GIR_Coverage, 10011,
     /*  38024 */     GIR_EraseRootFromParent_Done,
     /*  38025 */   // Label 614: @38025
     /*  38025 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(38061), // Rule ID 3899 //
     /*  38030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  38045 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  38045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  38048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38050 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  38052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  38056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38059 */     GIR_RootConstrainSelectedInstOperands,
     /*  38060 */     // GIR_Coverage, 3899,
     /*  38060 */     GIR_EraseRootFromParent_Done,
     /*  38061 */   // Label 615: @38061
     /*  38061 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(38094), // Rule ID 3904 //
     /*  38066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  38081 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  38081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  38084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38088 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38092 */     GIR_RootConstrainSelectedInstOperands,
     /*  38093 */     // GIR_Coverage, 3904,
     /*  38093 */     GIR_EraseRootFromParent_Done,
     /*  38094 */   // Label 616: @38094
     /*  38094 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38130), // Rule ID 3893 //
     /*  38099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  38114 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  38114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  38117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38128 */     GIR_RootConstrainSelectedInstOperands,
     /*  38129 */     // GIR_Coverage, 3893,
     /*  38129 */     GIR_EraseRootFromParent_Done,
     /*  38130 */   // Label 617: @38130
     /*  38130 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38166), // Rule ID 3897 //
     /*  38135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  38150 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  38150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  38153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38157 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  38161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38164 */     GIR_RootConstrainSelectedInstOperands,
     /*  38165 */     // GIR_Coverage, 3897,
     /*  38165 */     GIR_EraseRootFromParent_Done,
     /*  38166 */   // Label 618: @38166
     /*  38166 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38196), // Rule ID 3895 //
     /*  38171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38183 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  38183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  38188 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  38194 */     GIR_RootConstrainSelectedInstOperands,
     /*  38195 */     // GIR_Coverage, 3895,
     /*  38195 */     GIR_Done,
     /*  38196 */   // Label 619: @38196
     /*  38196 */   GIM_Reject,
     /*  38197 */ // Label 605: @38197
     /*  38197 */ GIM_Reject,
     /*  38198 */ // Label 592: @38198
     /*  38198 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(41479),
     /*  38203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  38206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  38209 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(38345), // Rule ID 5376 //
     /*  38214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38247 */     // MIs[1] Operand 2
     /*  38247 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38270 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38274 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38278 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38282 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38287 */     // MIs[3] Operand 2
     /*  38287 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38298 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38300 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38327 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38344 */     // GIR_Coverage, 5376,
     /*  38344 */     GIR_EraseRootFromParent_Done,
     /*  38345 */   // Label 621: @38345
     /*  38345 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(38481), // Rule ID 5375 //
     /*  38350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38383 */     // MIs[1] Operand 2
     /*  38383 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38402 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38406 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38410 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38414 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38418 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38423 */     // MIs[3] Operand 2
     /*  38423 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38434 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38436 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38448 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38463 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38480 */     // GIR_Coverage, 5375,
     /*  38480 */     GIR_EraseRootFromParent_Done,
     /*  38481 */   // Label 622: @38481
     /*  38481 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(38617), // Rule ID 5385 //
     /*  38486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38519 */     // MIs[1] Operand 2
     /*  38519 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38538 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38542 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38546 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38550 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38554 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38559 */     // MIs[3] Operand 2
     /*  38559 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38570 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38572 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38599 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38606 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38616 */     // GIR_Coverage, 5385,
     /*  38616 */     GIR_EraseRootFromParent_Done,
     /*  38617 */   // Label 623: @38617
     /*  38617 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(38753), // Rule ID 5374 //
     /*  38622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38655 */     // MIs[1] Operand 2
     /*  38655 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38674 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38682 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38686 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38690 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38695 */     // MIs[3] Operand 2
     /*  38695 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38706 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38708 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38735 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38742 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38752 */     // GIR_Coverage, 5374,
     /*  38752 */     GIR_EraseRootFromParent_Done,
     /*  38753 */   // Label 624: @38753
     /*  38753 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(38889), // Rule ID 5373 //
     /*  38758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38791 */     // MIs[1] Operand 2
     /*  38791 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38810 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38814 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38818 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38822 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38826 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38831 */     // MIs[3] Operand 2
     /*  38831 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38842 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38844 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38871 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38888 */     // GIR_Coverage, 5373,
     /*  38888 */     GIR_EraseRootFromParent_Done,
     /*  38889 */   // Label 625: @38889
     /*  38889 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39026), // Rule ID 3951 //
     /*  38894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  38926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  38930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38935 */     // MIs[2] Operand 2
     /*  38935 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  38946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38954 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38958 */     // MIs[3] Operand 1
     /*  38958 */     // No operand predicates
     /*  38958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38960 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38960 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  38963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38967 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38972 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  38979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38991 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  38997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39024 */     GIR_RootConstrainSelectedInstOperands,
     /*  39025 */     // GIR_Coverage, 3951,
     /*  39025 */     GIR_EraseRootFromParent_Done,
     /*  39026 */   // Label 626: @39026
     /*  39026 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39125), // Rule ID 3949 //
     /*  39031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39035 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39080 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39084 */     // MIs[3] Operand 1
     /*  39084 */     // No operand predicates
     /*  39084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39086 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39098 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39123 */     GIR_RootConstrainSelectedInstOperands,
     /*  39124 */     // GIR_Coverage, 3949,
     /*  39124 */     GIR_EraseRootFromParent_Done,
     /*  39125 */   // Label 627: @39125
     /*  39125 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39224), // Rule ID 3950 //
     /*  39130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39179 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39183 */     // MIs[3] Operand 1
     /*  39183 */     // No operand predicates
     /*  39183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39185 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39197 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39222 */     GIR_RootConstrainSelectedInstOperands,
     /*  39223 */     // GIR_Coverage, 3950,
     /*  39223 */     GIR_EraseRootFromParent_Done,
     /*  39224 */   // Label 628: @39224
     /*  39224 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39310), // Rule ID 3944 //
     /*  39229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39278 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39282 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39289 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39308 */     GIR_RootConstrainSelectedInstOperands,
     /*  39309 */     // GIR_Coverage, 3944,
     /*  39309 */     GIR_EraseRootFromParent_Done,
     /*  39310 */   // Label 629: @39310
     /*  39310 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39396), // Rule ID 3945 //
     /*  39315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39364 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39368 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39375 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39394 */     GIR_RootConstrainSelectedInstOperands,
     /*  39395 */     // GIR_Coverage, 3945,
     /*  39395 */     GIR_EraseRootFromParent_Done,
     /*  39396 */   // Label 630: @39396
     /*  39396 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39529), // Rule ID 3957 //
     /*  39401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39442 */     // MIs[2] Operand 2
     /*  39442 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39457 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39461 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39465 */     // MIs[3] Operand 1
     /*  39465 */     // No operand predicates
     /*  39465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39467 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39479 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39498 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39527 */     GIR_RootConstrainSelectedInstOperands,
     /*  39528 */     // GIR_Coverage, 3957,
     /*  39528 */     GIR_EraseRootFromParent_Done,
     /*  39529 */   // Label 631: @39529
     /*  39529 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(39624), // Rule ID 3955 //
     /*  39534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39575 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39579 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39583 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39587 */     // MIs[3] Operand 1
     /*  39587 */     // No operand predicates
     /*  39587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39589 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39601 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39622 */     GIR_RootConstrainSelectedInstOperands,
     /*  39623 */     // GIR_Coverage, 3955,
     /*  39623 */     GIR_EraseRootFromParent_Done,
     /*  39624 */   // Label 632: @39624
     /*  39624 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(39719), // Rule ID 3956 //
     /*  39629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39678 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39682 */     // MIs[3] Operand 1
     /*  39682 */     // No operand predicates
     /*  39682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39684 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39696 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39717 */     GIR_RootConstrainSelectedInstOperands,
     /*  39718 */     // GIR_Coverage, 3956,
     /*  39718 */     GIR_EraseRootFromParent_Done,
     /*  39719 */   // Label 633: @39719
     /*  39719 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(39801), // Rule ID 124 //
     /*  39724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39777 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39784 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39799 */     GIR_RootConstrainSelectedInstOperands,
     /*  39800 */     // GIR_Coverage, 124,
     /*  39800 */     GIR_EraseRootFromParent_Done,
     /*  39801 */   // Label 634: @39801
     /*  39801 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(39883), // Rule ID 126 //
     /*  39806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39855 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39859 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39866 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39881 */     GIR_RootConstrainSelectedInstOperands,
     /*  39882 */     // GIR_Coverage, 126,
     /*  39882 */     GIR_EraseRootFromParent_Done,
     /*  39883 */   // Label 635: @39883
     /*  39883 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(39945), // Rule ID 3935 //
     /*  39888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39924 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  39924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  39927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  39933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  39937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39943 */     GIR_RootConstrainSelectedInstOperands,
     /*  39944 */     // GIR_Coverage, 3935,
     /*  39944 */     GIR_EraseRootFromParent_Done,
     /*  39945 */   // Label 636: @39945
     /*  39945 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40003), // Rule ID 9867 //
     /*  39950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39969 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39972 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  39977 */     // MIs[1] pattern
     /*  39977 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39980 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39987 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  39990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40001 */     GIR_RootConstrainSelectedInstOperands,
     /*  40002 */     // GIR_Coverage, 9867,
     /*  40002 */     GIR_EraseRootFromParent_Done,
     /*  40003 */   // Label 637: @40003
     /*  40003 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40061), // Rule ID 9879 //
     /*  40008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40027 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40030 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  40035 */     // MIs[1] pattern
     /*  40035 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40038 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40045 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  40048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40059 */     GIR_RootConstrainSelectedInstOperands,
     /*  40060 */     // GIR_Coverage, 9879,
     /*  40060 */     GIR_EraseRootFromParent_Done,
     /*  40061 */   // Label 638: @40061
     /*  40061 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40119), // Rule ID 9891 //
     /*  40066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40085 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40088 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  40093 */     // MIs[1] pattern
     /*  40093 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40096 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40103 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  40106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40117 */     GIR_RootConstrainSelectedInstOperands,
     /*  40118 */     // GIR_Coverage, 9891,
     /*  40118 */     GIR_EraseRootFromParent_Done,
     /*  40119 */   // Label 639: @40119
     /*  40119 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40177), // Rule ID 9903 //
     /*  40124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40143 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40146 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  40151 */     // MIs[1] pattern
     /*  40151 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40154 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40161 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  40164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40175 */     GIR_RootConstrainSelectedInstOperands,
     /*  40176 */     // GIR_Coverage, 9903,
     /*  40176 */     GIR_EraseRootFromParent_Done,
     /*  40177 */   // Label 640: @40177
     /*  40177 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40340), // Rule ID 5340 //
     /*  40182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  40210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40228 */     // MIs[1] Operand 2
     /*  40228 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40241 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40241 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40244 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40248 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40267 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40270 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40274 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40282 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40287 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  40299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40304 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40311 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40322 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40339 */     // GIR_Coverage, 5340,
     /*  40339 */     GIR_EraseRootFromParent_Done,
     /*  40340 */   // Label 641: @40340
     /*  40340 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40503), // Rule ID 5337 //
     /*  40345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  40373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40391 */     // MIs[1] Operand 2
     /*  40391 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40404 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40404 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40407 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40411 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40418 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40421 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40425 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40430 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40433 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40437 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40440 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  40462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40467 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40470 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40474 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40485 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40502 */     // GIR_Coverage, 5337,
     /*  40502 */     GIR_EraseRootFromParent_Done,
     /*  40503 */   // Label 642: @40503
     /*  40503 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40653), // Rule ID 5382 //
     /*  40508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40545 */     // MIs[1] Operand 2
     /*  40545 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40558 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40558 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40561 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40565 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40572 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40575 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40579 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40584 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40591 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40594 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40599 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40604 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40621 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40635 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40652 */     // GIR_Coverage, 5382,
     /*  40652 */     GIR_EraseRootFromParent_Done,
     /*  40653 */   // Label 643: @40653
     /*  40653 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(40803), // Rule ID 5388 //
     /*  40658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40695 */     // MIs[1] Operand 2
     /*  40695 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40708 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40708 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40711 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40715 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40722 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40725 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40729 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40734 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40737 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40741 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  40766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40771 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40785 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40802 */     // GIR_Coverage, 5388,
     /*  40802 */     GIR_EraseRootFromParent_Done,
     /*  40803 */   // Label 644: @40803
     /*  40803 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(40953), // Rule ID 5381 //
     /*  40808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40845 */     // MIs[1] Operand 2
     /*  40845 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40858 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40858 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40861 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40865 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40872 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40875 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40879 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40884 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40887 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40891 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40894 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40899 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40904 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40921 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40935 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40952 */     // GIR_Coverage, 5381,
     /*  40952 */     GIR_EraseRootFromParent_Done,
     /*  40953 */   // Label 645: @40953
     /*  40953 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(40989), // Rule ID 3900 //
     /*  40958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  40973 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  40973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  40976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40978 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  40980 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  40984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40987 */     GIR_RootConstrainSelectedInstOperands,
     /*  40988 */     // GIR_Coverage, 3900,
     /*  40988 */     GIR_EraseRootFromParent_Done,
     /*  40989 */   // Label 646: @40989
     /*  40989 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(41022), // Rule ID 3905 //
     /*  40994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  41009 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  41009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  41012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  41020 */     GIR_RootConstrainSelectedInstOperands,
     /*  41021 */     // GIR_Coverage, 3905,
     /*  41021 */     GIR_EraseRootFromParent_Done,
     /*  41022 */   // Label 647: @41022
     /*  41022 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41058), // Rule ID 3894 //
     /*  41027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  41035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  41042 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  41042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  41045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41047 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41049 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  41053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  41056 */     GIR_RootConstrainSelectedInstOperands,
     /*  41057 */     // GIR_Coverage, 3894,
     /*  41057 */     GIR_EraseRootFromParent_Done,
     /*  41058 */   // Label 648: @41058
     /*  41058 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(41094), // Rule ID 3898 //
     /*  41063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  41078 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  41078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  41081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  41089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  41092 */     GIR_RootConstrainSelectedInstOperands,
     /*  41093 */     // GIR_Coverage, 3898,
     /*  41093 */     GIR_EraseRootFromParent_Done,
     /*  41094 */   // Label 649: @41094
     /*  41094 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41157), // Rule ID 10000 //
     /*  41099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41118 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41121 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  41130 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41137 */     // MIs[1] pred
     /*  41137 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41144 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  41147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41155 */     GIR_RootConstrainSelectedInstOperands,
     /*  41156 */     // GIR_Coverage, 10000,
     /*  41156 */     GIR_EraseRootFromParent_Done,
     /*  41157 */   // Label 650: @41157
     /*  41157 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(41220), // Rule ID 10001 //
     /*  41162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41181 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41184 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  41193 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41200 */     // MIs[1] pred
     /*  41200 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41207 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  41210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41218 */     GIR_RootConstrainSelectedInstOperands,
     /*  41219 */     // GIR_Coverage, 10001,
     /*  41219 */     GIR_EraseRootFromParent_Done,
     /*  41220 */   // Label 651: @41220
     /*  41220 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(41283), // Rule ID 10002 //
     /*  41225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41244 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41247 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  41256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41263 */     // MIs[1] pred
     /*  41263 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41270 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  41273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41281 */     GIR_RootConstrainSelectedInstOperands,
     /*  41282 */     // GIR_Coverage, 10002,
     /*  41282 */     GIR_EraseRootFromParent_Done,
     /*  41283 */   // Label 652: @41283
     /*  41283 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(41346), // Rule ID 10003 //
     /*  41288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41307 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41310 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  41319 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41326 */     // MIs[1] pred
     /*  41326 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41333 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  41336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41344 */     GIR_RootConstrainSelectedInstOperands,
     /*  41345 */     // GIR_Coverage, 10003,
     /*  41345 */     GIR_EraseRootFromParent_Done,
     /*  41346 */   // Label 653: @41346
     /*  41346 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(41385), // Rule ID 1648 //
     /*  41351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41362 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41368 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41376 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  41376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41383 */     GIR_RootConstrainSelectedInstOperands,
     /*  41384 */     // GIR_Coverage, 1648,
     /*  41384 */     GIR_EraseRootFromParent_Done,
     /*  41385 */   // Label 654: @41385
     /*  41385 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41421), // Rule ID 5223 //
     /*  41390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41398 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41404 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41412 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  41412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41419 */     GIR_RootConstrainSelectedInstOperands,
     /*  41420 */     // GIR_Coverage, 5223,
     /*  41420 */     GIR_EraseRootFromParent_Done,
     /*  41421 */   // Label 655: @41421
     /*  41421 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(41448), // Rule ID 1637 //
     /*  41426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41441 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  41441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  41446 */     GIR_RootConstrainSelectedInstOperands,
     /*  41447 */     // GIR_Coverage, 1637,
     /*  41447 */     GIR_Done,
     /*  41448 */   // Label 656: @41448
     /*  41448 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(41478), // Rule ID 3896 //
     /*  41453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41465 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  41465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  41470 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  41476 */     GIR_RootConstrainSelectedInstOperands,
     /*  41477 */     // GIR_Coverage, 3896,
     /*  41477 */     GIR_Done,
     /*  41478 */   // Label 657: @41478
     /*  41478 */   GIM_Reject,
     /*  41479 */ // Label 620: @41479
     /*  41479 */ GIM_Reject,
     /*  41480 */ // Label 593: @41480
     /*  41480 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42970),
     /*  41485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41495 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(41627), // Rule ID 5372 //
     /*  41500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41529 */     // MIs[1] Operand 2
     /*  41529 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41548 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41552 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41556 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41560 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41564 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41569 */     // MIs[3] Operand 2
     /*  41569 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41580 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41582 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41598 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41609 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41621 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41626 */     // GIR_Coverage, 5372,
     /*  41626 */     GIR_EraseRootFromParent_Done,
     /*  41627 */   // Label 659: @41627
     /*  41627 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(41759), // Rule ID 5371 //
     /*  41632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41661 */     // MIs[1] Operand 2
     /*  41661 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41680 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41684 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41688 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41692 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41696 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41701 */     // MIs[3] Operand 2
     /*  41701 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41712 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41714 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41741 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41758 */     // GIR_Coverage, 5371,
     /*  41758 */     GIR_EraseRootFromParent_Done,
     /*  41759 */   // Label 660: @41759
     /*  41759 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(41891), // Rule ID 5384 //
     /*  41764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41793 */     // MIs[1] Operand 2
     /*  41793 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41812 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41816 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41820 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41824 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41828 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41833 */     // MIs[3] Operand 2
     /*  41833 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41844 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41846 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  41853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41873 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41890 */     // GIR_Coverage, 5384,
     /*  41890 */     GIR_EraseRootFromParent_Done,
     /*  41891 */   // Label 661: @41891
     /*  41891 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(42023), // Rule ID 5370 //
     /*  41896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41925 */     // MIs[1] Operand 2
     /*  41925 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41944 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41948 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41952 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41956 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41960 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41965 */     // MIs[3] Operand 2
     /*  41965 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41976 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41978 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42005 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42022 */     // GIR_Coverage, 5370,
     /*  42022 */     GIR_EraseRootFromParent_Done,
     /*  42023 */   // Label 662: @42023
     /*  42023 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(42155), // Rule ID 5369 //
     /*  42028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42057 */     // MIs[1] Operand 2
     /*  42057 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42076 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42080 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42084 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42088 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42092 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42097 */     // MIs[3] Operand 2
     /*  42097 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42108 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42110 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  42117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42122 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42137 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42154 */     // GIR_Coverage, 5369,
     /*  42154 */     GIR_EraseRootFromParent_Done,
     /*  42155 */   // Label 663: @42155
     /*  42155 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(42314), // Rule ID 5339 //
     /*  42160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  42184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42202 */     // MIs[1] Operand 2
     /*  42202 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42215 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42215 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42218 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42222 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42229 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42232 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42236 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42241 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42244 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42248 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42251 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42256 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42261 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  42273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42278 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42281 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42285 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42296 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42313 */     // GIR_Coverage, 5339,
     /*  42313 */     GIR_EraseRootFromParent_Done,
     /*  42314 */   // Label 664: @42314
     /*  42314 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(42473), // Rule ID 5336 //
     /*  42319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  42343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42361 */     // MIs[1] Operand 2
     /*  42361 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42374 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42374 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42377 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42381 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42388 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42391 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42395 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42400 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42403 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42407 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42415 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  42432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42437 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42455 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42472 */     // GIR_Coverage, 5336,
     /*  42472 */     GIR_EraseRootFromParent_Done,
     /*  42473 */   // Label 665: @42473
     /*  42473 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(42619), // Rule ID 5380 //
     /*  42478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42511 */     // MIs[1] Operand 2
     /*  42511 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42524 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42524 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42527 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42531 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42538 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42541 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42545 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42550 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42553 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42557 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42560 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42565 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42570 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42601 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42618 */     // GIR_Coverage, 5380,
     /*  42618 */     GIR_EraseRootFromParent_Done,
     /*  42619 */   // Label 666: @42619
     /*  42619 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(42765), // Rule ID 5387 //
     /*  42624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42657 */     // MIs[1] Operand 2
     /*  42657 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42670 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42670 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42673 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42677 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42684 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42687 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42691 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42696 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42699 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42703 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42706 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42716 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  42728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42733 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42747 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42764 */     // GIR_Coverage, 5387,
     /*  42764 */     GIR_EraseRootFromParent_Done,
     /*  42765 */   // Label 667: @42765
     /*  42765 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(42911), // Rule ID 5379 //
     /*  42770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42803 */     // MIs[1] Operand 2
     /*  42803 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42816 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42816 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42819 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42823 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42830 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42833 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42837 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42842 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42845 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42849 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42857 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42879 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42893 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42910 */     // GIR_Coverage, 5379,
     /*  42910 */     GIR_EraseRootFromParent_Done,
     /*  42911 */   // Label 668: @42911
     /*  42911 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(42946), // Rule ID 962 //
     /*  42916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42923 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42929 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42937 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  42937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  42940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42944 */     GIR_RootConstrainSelectedInstOperands,
     /*  42945 */     // GIR_Coverage, 962,
     /*  42945 */     GIR_EraseRootFromParent_Done,
     /*  42946 */   // Label 669: @42946
     /*  42946 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(42969), // Rule ID 1469 //
     /*  42951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42962 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  42967 */     GIR_RootConstrainSelectedInstOperands,
     /*  42968 */     // GIR_Coverage, 1469,
     /*  42968 */     GIR_Done,
     /*  42969 */   // Label 670: @42969
     /*  42969 */   GIM_Reject,
     /*  42970 */ // Label 658: @42970
     /*  42970 */ GIM_Reject,
     /*  42971 */ // Label 594: @42971
     /*  42971 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(45430),
     /*  42976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  42979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  42982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42986 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43100), // Rule ID 2041 //
     /*  42991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43034 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43038 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43042 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43047 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43051 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43055 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43059 */     // MIs[4] Operand 1
     /*  43059 */     // No operand predicates
     /*  43059 */     // MIs[2] Operand 2
     /*  43059 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43070 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43079 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  43082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43098 */     GIR_RootConstrainSelectedInstOperands,
     /*  43099 */     // GIR_Coverage, 2041,
     /*  43099 */     GIR_EraseRootFromParent_Done,
     /*  43100 */   // Label 672: @43100
     /*  43100 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43214), // Rule ID 13408 //
     /*  43105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43161 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43165 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43169 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43173 */     // MIs[4] Operand 1
     /*  43173 */     // No operand predicates
     /*  43173 */     // MIs[2] Operand 2
     /*  43173 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43184 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43193 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  43196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43212 */     GIR_RootConstrainSelectedInstOperands,
     /*  43213 */     // GIR_Coverage, 13408,
     /*  43213 */     GIR_EraseRootFromParent_Done,
     /*  43214 */   // Label 673: @43214
     /*  43214 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43328), // Rule ID 2093 //
     /*  43219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43262 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43266 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43270 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43275 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43279 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43283 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43287 */     // MIs[4] Operand 1
     /*  43287 */     // No operand predicates
     /*  43287 */     // MIs[2] Operand 2
     /*  43287 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43298 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43307 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43326 */     GIR_RootConstrainSelectedInstOperands,
     /*  43327 */     // GIR_Coverage, 2093,
     /*  43327 */     GIR_EraseRootFromParent_Done,
     /*  43328 */   // Label 674: @43328
     /*  43328 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43442), // Rule ID 13438 //
     /*  43333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43376 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43380 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43384 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43389 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43393 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43397 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43401 */     // MIs[4] Operand 1
     /*  43401 */     // No operand predicates
     /*  43401 */     // MIs[2] Operand 2
     /*  43401 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43412 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43421 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43440 */     GIR_RootConstrainSelectedInstOperands,
     /*  43441 */     // GIR_Coverage, 13438,
     /*  43441 */     GIR_EraseRootFromParent_Done,
     /*  43442 */   // Label 675: @43442
     /*  43442 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(43507), // Rule ID 1848 //
     /*  43447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43476 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43483 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43490 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43505 */     GIR_RootConstrainSelectedInstOperands,
     /*  43506 */     // GIR_Coverage, 1848,
     /*  43506 */     GIR_EraseRootFromParent_Done,
     /*  43507 */   // Label 676: @43507
     /*  43507 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(43572), // Rule ID 1847 //
     /*  43512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43555 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43570 */     GIR_RootConstrainSelectedInstOperands,
     /*  43571 */     // GIR_Coverage, 1847,
     /*  43571 */     GIR_EraseRootFromParent_Done,
     /*  43572 */   // Label 677: @43572
     /*  43572 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(43637), // Rule ID 1752 //
     /*  43577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43613 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43620 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  43623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43635 */     GIR_RootConstrainSelectedInstOperands,
     /*  43636 */     // GIR_Coverage, 1752,
     /*  43636 */     GIR_EraseRootFromParent_Done,
     /*  43637 */   // Label 678: @43637
     /*  43637 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(43702), // Rule ID 1846 //
     /*  43642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43678 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43685 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43700 */     GIR_RootConstrainSelectedInstOperands,
     /*  43701 */     // GIR_Coverage, 1846,
     /*  43701 */     GIR_EraseRootFromParent_Done,
     /*  43702 */   // Label 679: @43702
     /*  43702 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(43767), // Rule ID 1845 //
     /*  43707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43743 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43750 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43765 */     GIR_RootConstrainSelectedInstOperands,
     /*  43766 */     // GIR_Coverage, 1845,
     /*  43766 */     GIR_EraseRootFromParent_Done,
     /*  43767 */   // Label 680: @43767
     /*  43767 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(43878), // Rule ID 13406 //
     /*  43772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43815 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43819 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43823 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43828 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43832 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43836 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43840 */     // MIs[4] Operand 1
     /*  43840 */     // No operand predicates
     /*  43840 */     // MIs[2] Operand 2
     /*  43840 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43856 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43858 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43876 */     GIR_RootConstrainSelectedInstOperands,
     /*  43877 */     // GIR_Coverage, 13406,
     /*  43877 */     GIR_EraseRootFromParent_Done,
     /*  43878 */   // Label 681: @43878
     /*  43878 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(43989), // Rule ID 2039 //
     /*  43883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43931 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43935 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43939 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43944 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43948 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43952 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43956 */     // MIs[4] Operand 1
     /*  43956 */     // No operand predicates
     /*  43956 */     // MIs[2] Operand 2
     /*  43956 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43967 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43969 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43987 */     GIR_RootConstrainSelectedInstOperands,
     /*  43988 */     // GIR_Coverage, 2039,
     /*  43988 */     GIR_EraseRootFromParent_Done,
     /*  43989 */   // Label 682: @43989
     /*  43989 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44100), // Rule ID 13436 //
     /*  43994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44037 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44041 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44045 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44050 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44054 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44058 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44062 */     // MIs[4] Operand 1
     /*  44062 */     // No operand predicates
     /*  44062 */     // MIs[2] Operand 2
     /*  44062 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44078 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44080 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44098 */     GIR_RootConstrainSelectedInstOperands,
     /*  44099 */     // GIR_Coverage, 13436,
     /*  44099 */     GIR_EraseRootFromParent_Done,
     /*  44100 */   // Label 683: @44100
     /*  44100 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44211), // Rule ID 2091 //
     /*  44105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44153 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44157 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44161 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44166 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44170 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44174 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44178 */     // MIs[4] Operand 1
     /*  44178 */     // No operand predicates
     /*  44178 */     // MIs[2] Operand 2
     /*  44178 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44189 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44191 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44209 */     GIR_RootConstrainSelectedInstOperands,
     /*  44210 */     // GIR_Coverage, 2091,
     /*  44210 */     GIR_EraseRootFromParent_Done,
     /*  44211 */   // Label 684: @44211
     /*  44211 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44274), // Rule ID 1728 //
     /*  44216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44255 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  44258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44272 */     GIR_RootConstrainSelectedInstOperands,
     /*  44273 */     // GIR_Coverage, 1728,
     /*  44273 */     GIR_EraseRootFromParent_Done,
     /*  44274 */   // Label 685: @44274
     /*  44274 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44337), // Rule ID 1818 //
     /*  44279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44318 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  44321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44335 */     GIR_RootConstrainSelectedInstOperands,
     /*  44336 */     // GIR_Coverage, 1818,
     /*  44336 */     GIR_EraseRootFromParent_Done,
     /*  44337 */   // Label 686: @44337
     /*  44337 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(44425), // Rule ID 13407 //
     /*  44342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44394 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44398 */     // MIs[3] Operand 1
     /*  44398 */     // No operand predicates
     /*  44398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44405 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44423 */     GIR_RootConstrainSelectedInstOperands,
     /*  44424 */     // GIR_Coverage, 13407,
     /*  44424 */     GIR_EraseRootFromParent_Done,
     /*  44425 */   // Label 687: @44425
     /*  44425 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(44513), // Rule ID 2040 //
     /*  44430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44487 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44491 */     // MIs[3] Operand 1
     /*  44491 */     // No operand predicates
     /*  44491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44493 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44511 */     GIR_RootConstrainSelectedInstOperands,
     /*  44512 */     // GIR_Coverage, 2040,
     /*  44512 */     GIR_EraseRootFromParent_Done,
     /*  44513 */   // Label 688: @44513
     /*  44513 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44601), // Rule ID 13437 //
     /*  44518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44570 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44574 */     // MIs[3] Operand 1
     /*  44574 */     // No operand predicates
     /*  44574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44581 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44599 */     GIR_RootConstrainSelectedInstOperands,
     /*  44600 */     // GIR_Coverage, 13437,
     /*  44600 */     GIR_EraseRootFromParent_Done,
     /*  44601 */   // Label 689: @44601
     /*  44601 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44689), // Rule ID 2092 //
     /*  44606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44663 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44667 */     // MIs[3] Operand 1
     /*  44667 */     // No operand predicates
     /*  44667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44669 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44687 */     GIR_RootConstrainSelectedInstOperands,
     /*  44688 */     // GIR_Coverage, 2092,
     /*  44688 */     GIR_EraseRootFromParent_Done,
     /*  44689 */   // Label 690: @44689
     /*  44689 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44736), // Rule ID 1860 //
     /*  44694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44722 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44734 */     GIR_RootConstrainSelectedInstOperands,
     /*  44735 */     // GIR_Coverage, 1860,
     /*  44735 */     GIR_EraseRootFromParent_Done,
     /*  44736 */   // Label 691: @44736
     /*  44736 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(44783), // Rule ID 1758 //
     /*  44741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44769 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  44772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44781 */     GIR_RootConstrainSelectedInstOperands,
     /*  44782 */     // GIR_Coverage, 1758,
     /*  44782 */     GIR_EraseRootFromParent_Done,
     /*  44783 */   // Label 692: @44783
     /*  44783 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(44830), // Rule ID 1859 //
     /*  44788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44816 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44828 */     GIR_RootConstrainSelectedInstOperands,
     /*  44829 */     // GIR_Coverage, 1859,
     /*  44829 */     GIR_EraseRootFromParent_Done,
     /*  44830 */   // Label 693: @44830
     /*  44830 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(44889), // Rule ID 1844 //
     /*  44835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44874 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44887 */     GIR_RootConstrainSelectedInstOperands,
     /*  44888 */     // GIR_Coverage, 1844,
     /*  44888 */     GIR_EraseRootFromParent_Done,
     /*  44889 */   // Label 694: @44889
     /*  44889 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(44948), // Rule ID 1843 //
     /*  44894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44933 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44946 */     GIR_RootConstrainSelectedInstOperands,
     /*  44947 */     // GIR_Coverage, 1843,
     /*  44947 */     GIR_EraseRootFromParent_Done,
     /*  44948 */   // Label 695: @44948
     /*  44948 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(45007), // Rule ID 1751 //
     /*  44953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44992 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  44995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45005 */     GIR_RootConstrainSelectedInstOperands,
     /*  45006 */     // GIR_Coverage, 1751,
     /*  45006 */     GIR_EraseRootFromParent_Done,
     /*  45007 */   // Label 696: @45007
     /*  45007 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(45066), // Rule ID 1842 //
     /*  45012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45051 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  45054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45064 */     GIR_RootConstrainSelectedInstOperands,
     /*  45065 */     // GIR_Coverage, 1842,
     /*  45065 */     GIR_EraseRootFromParent_Done,
     /*  45066 */   // Label 697: @45066
     /*  45066 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45125), // Rule ID 1841 //
     /*  45071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45110 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  45113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45123 */     GIR_RootConstrainSelectedInstOperands,
     /*  45124 */     // GIR_Coverage, 1841,
     /*  45124 */     GIR_EraseRootFromParent_Done,
     /*  45125 */   // Label 698: @45125
     /*  45125 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(45160), // Rule ID 964 //
     /*  45130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45137 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45143 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  45145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45151 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  45151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  45154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45158 */     GIR_RootConstrainSelectedInstOperands,
     /*  45159 */     // GIR_Coverage, 964,
     /*  45159 */     GIR_EraseRootFromParent_Done,
     /*  45160 */   // Label 699: @45160
     /*  45160 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45217), // Rule ID 1727 //
     /*  45165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45200 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  45203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45215 */     GIR_RootConstrainSelectedInstOperands,
     /*  45216 */     // GIR_Coverage, 1727,
     /*  45216 */     GIR_EraseRootFromParent_Done,
     /*  45217 */   // Label 700: @45217
     /*  45217 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(45274), // Rule ID 1817 //
     /*  45222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45257 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  45260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45272 */     GIR_RootConstrainSelectedInstOperands,
     /*  45273 */     // GIR_Coverage, 1817,
     /*  45273 */     GIR_EraseRootFromParent_Done,
     /*  45274 */   // Label 701: @45274
     /*  45274 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(45318), // Rule ID 1858 //
     /*  45279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45305 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45316 */     GIR_RootConstrainSelectedInstOperands,
     /*  45317 */     // GIR_Coverage, 1858,
     /*  45317 */     GIR_EraseRootFromParent_Done,
     /*  45318 */   // Label 702: @45318
     /*  45318 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(45362), // Rule ID 1757 //
     /*  45323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45349 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  45352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45360 */     GIR_RootConstrainSelectedInstOperands,
     /*  45361 */     // GIR_Coverage, 1757,
     /*  45361 */     GIR_EraseRootFromParent_Done,
     /*  45362 */   // Label 703: @45362
     /*  45362 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(45406), // Rule ID 1857 //
     /*  45367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45393 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45404 */     GIR_RootConstrainSelectedInstOperands,
     /*  45405 */     // GIR_Coverage, 1857,
     /*  45405 */     GIR_EraseRootFromParent_Done,
     /*  45406 */   // Label 704: @45406
     /*  45406 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(45429), // Rule ID 1471 //
     /*  45411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45422 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  45422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  45427 */     GIR_RootConstrainSelectedInstOperands,
     /*  45428 */     // GIR_Coverage, 1471,
     /*  45428 */     GIR_Done,
     /*  45429 */   // Label 705: @45429
     /*  45429 */   GIM_Reject,
     /*  45430 */ // Label 671: @45430
     /*  45430 */ GIM_Reject,
     /*  45431 */ // Label 595: @45431
     /*  45431 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(46921),
     /*  45436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45446 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(45578), // Rule ID 5368 //
     /*  45451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45480 */     // MIs[1] Operand 2
     /*  45480 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45499 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45503 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45507 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45511 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45515 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45520 */     // MIs[3] Operand 2
     /*  45520 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45531 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45533 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45545 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45549 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45560 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45577 */     // GIR_Coverage, 5368,
     /*  45577 */     GIR_EraseRootFromParent_Done,
     /*  45578 */   // Label 707: @45578
     /*  45578 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(45710), // Rule ID 5367 //
     /*  45583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45612 */     // MIs[1] Operand 2
     /*  45612 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45631 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45635 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45639 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45643 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45647 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45652 */     // MIs[3] Operand 2
     /*  45652 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45663 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45665 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45681 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45692 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45709 */     // GIR_Coverage, 5367,
     /*  45709 */     GIR_EraseRootFromParent_Done,
     /*  45710 */   // Label 708: @45710
     /*  45710 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(45842), // Rule ID 5383 //
     /*  45715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45739 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45744 */     // MIs[1] Operand 2
     /*  45744 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45763 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45767 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45771 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45775 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45779 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45784 */     // MIs[3] Operand 2
     /*  45784 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45795 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45797 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  45804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45824 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45841 */     // GIR_Coverage, 5383,
     /*  45841 */     GIR_EraseRootFromParent_Done,
     /*  45842 */   // Label 709: @45842
     /*  45842 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(45974), // Rule ID 5366 //
     /*  45847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45876 */     // MIs[1] Operand 2
     /*  45876 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45895 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45899 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45903 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45907 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45911 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45916 */     // MIs[3] Operand 2
     /*  45916 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45927 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45929 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45941 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45945 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45956 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45973 */     // GIR_Coverage, 5366,
     /*  45973 */     GIR_EraseRootFromParent_Done,
     /*  45974 */   // Label 710: @45974
     /*  45974 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(46106), // Rule ID 5365 //
     /*  45979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46008 */     // MIs[1] Operand 2
     /*  46008 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46027 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46031 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46035 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46039 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46043 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46048 */     // MIs[3] Operand 2
     /*  46048 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46059 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46061 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  46068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46088 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46105 */     // GIR_Coverage, 5365,
     /*  46105 */     GIR_EraseRootFromParent_Done,
     /*  46106 */   // Label 711: @46106
     /*  46106 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(46265), // Rule ID 5338 //
     /*  46111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  46135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46153 */     // MIs[1] Operand 2
     /*  46153 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46166 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46166 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46169 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46173 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46180 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46183 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46187 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46192 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46195 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  46199 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46202 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46207 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46212 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  46224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46229 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46247 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46264 */     // GIR_Coverage, 5338,
     /*  46264 */     GIR_EraseRootFromParent_Done,
     /*  46265 */   // Label 712: @46265
     /*  46265 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(46424), // Rule ID 5335 //
     /*  46270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  46294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46312 */     // MIs[1] Operand 2
     /*  46312 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46325 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46325 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46328 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46332 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46339 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46342 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46346 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46351 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46354 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  46358 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46361 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  46383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46388 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46395 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46406 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46423 */     // GIR_Coverage, 5335,
     /*  46423 */     GIR_EraseRootFromParent_Done,
     /*  46424 */   // Label 713: @46424
     /*  46424 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(46570), // Rule ID 5378 //
     /*  46429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46462 */     // MIs[1] Operand 2
     /*  46462 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46475 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46475 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46478 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46482 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46489 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46492 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46496 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46501 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46504 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46508 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46511 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46516 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46521 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46538 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46541 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46552 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46569 */     // GIR_Coverage, 5378,
     /*  46569 */     GIR_EraseRootFromParent_Done,
     /*  46570 */   // Label 714: @46570
     /*  46570 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(46716), // Rule ID 5386 //
     /*  46575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46608 */     // MIs[1] Operand 2
     /*  46608 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46619 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46621 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46621 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46624 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46628 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46635 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46638 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46642 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46647 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46650 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46654 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46657 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46662 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46667 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  46679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46684 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46698 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46715 */     // GIR_Coverage, 5386,
     /*  46715 */     GIR_EraseRootFromParent_Done,
     /*  46716 */   // Label 715: @46716
     /*  46716 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(46862), // Rule ID 5377 //
     /*  46721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46754 */     // MIs[1] Operand 2
     /*  46754 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46767 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46767 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46770 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46774 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46781 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46784 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46788 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46793 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46796 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46800 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46803 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46808 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46813 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46830 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46844 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46861 */     // GIR_Coverage, 5377,
     /*  46861 */     GIR_EraseRootFromParent_Done,
     /*  46862 */   // Label 716: @46862
     /*  46862 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(46897), // Rule ID 960 //
     /*  46867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46874 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46880 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46888 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  46888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  46891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46895 */     GIR_RootConstrainSelectedInstOperands,
     /*  46896 */     // GIR_Coverage, 960,
     /*  46896 */     GIR_EraseRootFromParent_Done,
     /*  46897 */   // Label 717: @46897
     /*  46897 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(46920), // Rule ID 1467 //
     /*  46902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46913 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  46918 */     GIR_RootConstrainSelectedInstOperands,
     /*  46919 */     // GIR_Coverage, 1467,
     /*  46919 */     GIR_Done,
     /*  46920 */   // Label 718: @46920
     /*  46920 */   GIM_Reject,
     /*  46921 */ // Label 706: @46921
     /*  46921 */ GIM_Reject,
     /*  46922 */ // Label 596: @46922
     /*  46922 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(49381),
     /*  46927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46937 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47051), // Rule ID 2038 //
     /*  46942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46985 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46989 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46993 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46998 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47002 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47006 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47010 */     // MIs[4] Operand 1
     /*  47010 */     // No operand predicates
     /*  47010 */     // MIs[2] Operand 2
     /*  47010 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47021 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47030 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  47033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47049 */     GIR_RootConstrainSelectedInstOperands,
     /*  47050 */     // GIR_Coverage, 2038,
     /*  47050 */     GIR_EraseRootFromParent_Done,
     /*  47051 */   // Label 720: @47051
     /*  47051 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47165), // Rule ID 13405 //
     /*  47056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47099 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47103 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47107 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47112 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47116 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47120 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47124 */     // MIs[4] Operand 1
     /*  47124 */     // No operand predicates
     /*  47124 */     // MIs[2] Operand 2
     /*  47124 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47135 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47144 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  47147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47163 */     GIR_RootConstrainSelectedInstOperands,
     /*  47164 */     // GIR_Coverage, 13405,
     /*  47164 */     GIR_EraseRootFromParent_Done,
     /*  47165 */   // Label 721: @47165
     /*  47165 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47279), // Rule ID 2090 //
     /*  47170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47213 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47217 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47221 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47226 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47230 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47234 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47238 */     // MIs[4] Operand 1
     /*  47238 */     // No operand predicates
     /*  47238 */     // MIs[2] Operand 2
     /*  47238 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47249 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47251 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47258 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47277 */     GIR_RootConstrainSelectedInstOperands,
     /*  47278 */     // GIR_Coverage, 2090,
     /*  47278 */     GIR_EraseRootFromParent_Done,
     /*  47279 */   // Label 722: @47279
     /*  47279 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47393), // Rule ID 13435 //
     /*  47284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47323 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47327 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47331 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47335 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47340 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47344 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47348 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47352 */     // MIs[4] Operand 1
     /*  47352 */     // No operand predicates
     /*  47352 */     // MIs[2] Operand 2
     /*  47352 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47363 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47372 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47391 */     GIR_RootConstrainSelectedInstOperands,
     /*  47392 */     // GIR_Coverage, 13435,
     /*  47392 */     GIR_EraseRootFromParent_Done,
     /*  47393 */   // Label 723: @47393
     /*  47393 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(47458), // Rule ID 1840 //
     /*  47398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47441 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47456 */     GIR_RootConstrainSelectedInstOperands,
     /*  47457 */     // GIR_Coverage, 1840,
     /*  47457 */     GIR_EraseRootFromParent_Done,
     /*  47458 */   // Label 724: @47458
     /*  47458 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(47523), // Rule ID 1839 //
     /*  47463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47506 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47521 */     GIR_RootConstrainSelectedInstOperands,
     /*  47522 */     // GIR_Coverage, 1839,
     /*  47522 */     GIR_EraseRootFromParent_Done,
     /*  47523 */   // Label 725: @47523
     /*  47523 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(47588), // Rule ID 1750 //
     /*  47528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47571 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  47574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47586 */     GIR_RootConstrainSelectedInstOperands,
     /*  47587 */     // GIR_Coverage, 1750,
     /*  47587 */     GIR_EraseRootFromParent_Done,
     /*  47588 */   // Label 726: @47588
     /*  47588 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(47653), // Rule ID 1838 //
     /*  47593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47636 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47651 */     GIR_RootConstrainSelectedInstOperands,
     /*  47652 */     // GIR_Coverage, 1838,
     /*  47652 */     GIR_EraseRootFromParent_Done,
     /*  47653 */   // Label 727: @47653
     /*  47653 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(47718), // Rule ID 1837 //
     /*  47658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47701 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47716 */     GIR_RootConstrainSelectedInstOperands,
     /*  47717 */     // GIR_Coverage, 1837,
     /*  47717 */     GIR_EraseRootFromParent_Done,
     /*  47718 */   // Label 728: @47718
     /*  47718 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(47829), // Rule ID 13403 //
     /*  47723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47766 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47770 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47774 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47783 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47787 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47791 */     // MIs[4] Operand 1
     /*  47791 */     // No operand predicates
     /*  47791 */     // MIs[2] Operand 2
     /*  47791 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47807 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47809 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47827 */     GIR_RootConstrainSelectedInstOperands,
     /*  47828 */     // GIR_Coverage, 13403,
     /*  47828 */     GIR_EraseRootFromParent_Done,
     /*  47829 */   // Label 729: @47829
     /*  47829 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(47940), // Rule ID 2036 //
     /*  47834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47882 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47886 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47890 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47895 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47899 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47903 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47907 */     // MIs[4] Operand 1
     /*  47907 */     // No operand predicates
     /*  47907 */     // MIs[2] Operand 2
     /*  47907 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47918 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47920 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47938 */     GIR_RootConstrainSelectedInstOperands,
     /*  47939 */     // GIR_Coverage, 2036,
     /*  47939 */     GIR_EraseRootFromParent_Done,
     /*  47940 */   // Label 730: @47940
     /*  47940 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48051), // Rule ID 13433 //
     /*  47945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47988 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47992 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47996 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48001 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48005 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48009 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48013 */     // MIs[4] Operand 1
     /*  48013 */     // No operand predicates
     /*  48013 */     // MIs[2] Operand 2
     /*  48013 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  48024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48029 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48031 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48049 */     GIR_RootConstrainSelectedInstOperands,
     /*  48050 */     // GIR_Coverage, 13433,
     /*  48050 */     GIR_EraseRootFromParent_Done,
     /*  48051 */   // Label 731: @48051
     /*  48051 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48162), // Rule ID 2088 //
     /*  48056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48104 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48108 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48112 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48117 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48121 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48125 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48129 */     // MIs[4] Operand 1
     /*  48129 */     // No operand predicates
     /*  48129 */     // MIs[2] Operand 2
     /*  48129 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  48140 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48142 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48160 */     GIR_RootConstrainSelectedInstOperands,
     /*  48161 */     // GIR_Coverage, 2088,
     /*  48161 */     GIR_EraseRootFromParent_Done,
     /*  48162 */   // Label 732: @48162
     /*  48162 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48225), // Rule ID 1726 //
     /*  48167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48206 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  48209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48223 */     GIR_RootConstrainSelectedInstOperands,
     /*  48224 */     // GIR_Coverage, 1726,
     /*  48224 */     GIR_EraseRootFromParent_Done,
     /*  48225 */   // Label 733: @48225
     /*  48225 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48288), // Rule ID 1816 //
     /*  48230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48269 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  48272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48286 */     GIR_RootConstrainSelectedInstOperands,
     /*  48287 */     // GIR_Coverage, 1816,
     /*  48287 */     GIR_EraseRootFromParent_Done,
     /*  48288 */   // Label 734: @48288
     /*  48288 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48376), // Rule ID 13404 //
     /*  48293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48345 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48349 */     // MIs[3] Operand 1
     /*  48349 */     // No operand predicates
     /*  48349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48356 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48374 */     GIR_RootConstrainSelectedInstOperands,
     /*  48375 */     // GIR_Coverage, 13404,
     /*  48375 */     GIR_EraseRootFromParent_Done,
     /*  48376 */   // Label 735: @48376
     /*  48376 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(48464), // Rule ID 2037 //
     /*  48381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48438 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48442 */     // MIs[3] Operand 1
     /*  48442 */     // No operand predicates
     /*  48442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48444 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48462 */     GIR_RootConstrainSelectedInstOperands,
     /*  48463 */     // GIR_Coverage, 2037,
     /*  48463 */     GIR_EraseRootFromParent_Done,
     /*  48464 */   // Label 736: @48464
     /*  48464 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(48552), // Rule ID 13434 //
     /*  48469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48521 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48525 */     // MIs[3] Operand 1
     /*  48525 */     // No operand predicates
     /*  48525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48532 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48550 */     GIR_RootConstrainSelectedInstOperands,
     /*  48551 */     // GIR_Coverage, 13434,
     /*  48551 */     GIR_EraseRootFromParent_Done,
     /*  48552 */   // Label 737: @48552
     /*  48552 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(48640), // Rule ID 2089 //
     /*  48557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48614 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48618 */     // MIs[3] Operand 1
     /*  48618 */     // No operand predicates
     /*  48618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48620 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48638 */     GIR_RootConstrainSelectedInstOperands,
     /*  48639 */     // GIR_Coverage, 2089,
     /*  48639 */     GIR_EraseRootFromParent_Done,
     /*  48640 */   // Label 738: @48640
     /*  48640 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(48687), // Rule ID 1856 //
     /*  48645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48673 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48685 */     GIR_RootConstrainSelectedInstOperands,
     /*  48686 */     // GIR_Coverage, 1856,
     /*  48686 */     GIR_EraseRootFromParent_Done,
     /*  48687 */   // Label 739: @48687
     /*  48687 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(48734), // Rule ID 1756 //
     /*  48692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48720 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  48723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48732 */     GIR_RootConstrainSelectedInstOperands,
     /*  48733 */     // GIR_Coverage, 1756,
     /*  48733 */     GIR_EraseRootFromParent_Done,
     /*  48734 */   // Label 740: @48734
     /*  48734 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(48781), // Rule ID 1855 //
     /*  48739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48767 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48779 */     GIR_RootConstrainSelectedInstOperands,
     /*  48780 */     // GIR_Coverage, 1855,
     /*  48780 */     GIR_EraseRootFromParent_Done,
     /*  48781 */   // Label 741: @48781
     /*  48781 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(48840), // Rule ID 1836 //
     /*  48786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48825 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48838 */     GIR_RootConstrainSelectedInstOperands,
     /*  48839 */     // GIR_Coverage, 1836,
     /*  48839 */     GIR_EraseRootFromParent_Done,
     /*  48840 */   // Label 742: @48840
     /*  48840 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(48899), // Rule ID 1835 //
     /*  48845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48884 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48897 */     GIR_RootConstrainSelectedInstOperands,
     /*  48898 */     // GIR_Coverage, 1835,
     /*  48898 */     GIR_EraseRootFromParent_Done,
     /*  48899 */   // Label 743: @48899
     /*  48899 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(48958), // Rule ID 1749 //
     /*  48904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48943 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  48946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48956 */     GIR_RootConstrainSelectedInstOperands,
     /*  48957 */     // GIR_Coverage, 1749,
     /*  48957 */     GIR_EraseRootFromParent_Done,
     /*  48958 */   // Label 744: @48958
     /*  48958 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(49017), // Rule ID 1834 //
     /*  48963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49002 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  49005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49015 */     GIR_RootConstrainSelectedInstOperands,
     /*  49016 */     // GIR_Coverage, 1834,
     /*  49016 */     GIR_EraseRootFromParent_Done,
     /*  49017 */   // Label 745: @49017
     /*  49017 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49076), // Rule ID 1833 //
     /*  49022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49061 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  49064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49074 */     GIR_RootConstrainSelectedInstOperands,
     /*  49075 */     // GIR_Coverage, 1833,
     /*  49075 */     GIR_EraseRootFromParent_Done,
     /*  49076 */   // Label 746: @49076
     /*  49076 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49111), // Rule ID 963 //
     /*  49081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49088 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  49094 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  49096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49102 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  49102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  49105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49109 */     GIR_RootConstrainSelectedInstOperands,
     /*  49110 */     // GIR_Coverage, 963,
     /*  49110 */     GIR_EraseRootFromParent_Done,
     /*  49111 */   // Label 747: @49111
     /*  49111 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(49168), // Rule ID 1725 //
     /*  49116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49151 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  49154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  49166 */     GIR_RootConstrainSelectedInstOperands,
     /*  49167 */     // GIR_Coverage, 1725,
     /*  49167 */     GIR_EraseRootFromParent_Done,
     /*  49168 */   // Label 748: @49168
     /*  49168 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49225), // Rule ID 1815 //
     /*  49173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49208 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  49211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  49223 */     GIR_RootConstrainSelectedInstOperands,
     /*  49224 */     // GIR_Coverage, 1815,
     /*  49224 */     GIR_EraseRootFromParent_Done,
     /*  49225 */   // Label 749: @49225
     /*  49225 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(49269), // Rule ID 1854 //
     /*  49230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49256 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49267 */     GIR_RootConstrainSelectedInstOperands,
     /*  49268 */     // GIR_Coverage, 1854,
     /*  49268 */     GIR_EraseRootFromParent_Done,
     /*  49269 */   // Label 750: @49269
     /*  49269 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(49313), // Rule ID 1755 //
     /*  49274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49300 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  49303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49311 */     GIR_RootConstrainSelectedInstOperands,
     /*  49312 */     // GIR_Coverage, 1755,
     /*  49312 */     GIR_EraseRootFromParent_Done,
     /*  49313 */   // Label 751: @49313
     /*  49313 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(49357), // Rule ID 1853 //
     /*  49318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49344 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49355 */     GIR_RootConstrainSelectedInstOperands,
     /*  49356 */     // GIR_Coverage, 1853,
     /*  49356 */     GIR_EraseRootFromParent_Done,
     /*  49357 */   // Label 752: @49357
     /*  49357 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(49380), // Rule ID 1470 //
     /*  49362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49373 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  49378 */     GIR_RootConstrainSelectedInstOperands,
     /*  49379 */     // GIR_Coverage, 1470,
     /*  49379 */     GIR_Done,
     /*  49380 */   // Label 753: @49380
     /*  49380 */   GIM_Reject,
     /*  49381 */ // Label 719: @49381
     /*  49381 */ GIM_Reject,
     /*  49382 */ // Label 597: @49382
     /*  49382 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(49456),
     /*  49387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49397 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(49432), // Rule ID 958 //
     /*  49402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49409 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  49415 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  49417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49423 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  49423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  49426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49430 */     GIR_RootConstrainSelectedInstOperands,
     /*  49431 */     // GIR_Coverage, 958,
     /*  49431 */     GIR_EraseRootFromParent_Done,
     /*  49432 */   // Label 755: @49432
     /*  49432 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(49455), // Rule ID 1465 //
     /*  49437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49448 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  49453 */     GIR_RootConstrainSelectedInstOperands,
     /*  49454 */     // GIR_Coverage, 1465,
     /*  49454 */     GIR_Done,
     /*  49455 */   // Label 756: @49455
     /*  49455 */   GIM_Reject,
     /*  49456 */ // Label 754: @49456
     /*  49456 */ GIM_Reject,
     /*  49457 */ // Label 598: @49457
     /*  49457 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(50664),
     /*  49462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49472 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(49537), // Rule ID 1832 //
     /*  49477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49506 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49520 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49535 */     GIR_RootConstrainSelectedInstOperands,
     /*  49536 */     // GIR_Coverage, 1832,
     /*  49536 */     GIR_EraseRootFromParent_Done,
     /*  49537 */   // Label 758: @49537
     /*  49537 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(49602), // Rule ID 1831 //
     /*  49542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49578 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49585 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49600 */     GIR_RootConstrainSelectedInstOperands,
     /*  49601 */     // GIR_Coverage, 1831,
     /*  49601 */     GIR_EraseRootFromParent_Done,
     /*  49602 */   // Label 759: @49602
     /*  49602 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(49667), // Rule ID 1748 //
     /*  49607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49650 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  49653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49665 */     GIR_RootConstrainSelectedInstOperands,
     /*  49666 */     // GIR_Coverage, 1748,
     /*  49666 */     GIR_EraseRootFromParent_Done,
     /*  49667 */   // Label 760: @49667
     /*  49667 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(49732), // Rule ID 1830 //
     /*  49672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49715 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49730 */     GIR_RootConstrainSelectedInstOperands,
     /*  49731 */     // GIR_Coverage, 1830,
     /*  49731 */     GIR_EraseRootFromParent_Done,
     /*  49732 */   // Label 761: @49732
     /*  49732 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(49797), // Rule ID 1829 //
     /*  49737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49780 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49795 */     GIR_RootConstrainSelectedInstOperands,
     /*  49796 */     // GIR_Coverage, 1829,
     /*  49796 */     GIR_EraseRootFromParent_Done,
     /*  49797 */   // Label 762: @49797
     /*  49797 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(49860), // Rule ID 1724 //
     /*  49802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49841 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  49844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49858 */     GIR_RootConstrainSelectedInstOperands,
     /*  49859 */     // GIR_Coverage, 1724,
     /*  49859 */     GIR_EraseRootFromParent_Done,
     /*  49860 */   // Label 763: @49860
     /*  49860 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(49923), // Rule ID 1814 //
     /*  49865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49904 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  49907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49921 */     GIR_RootConstrainSelectedInstOperands,
     /*  49922 */     // GIR_Coverage, 1814,
     /*  49922 */     GIR_EraseRootFromParent_Done,
     /*  49923 */   // Label 764: @49923
     /*  49923 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(49970), // Rule ID 1852 //
     /*  49928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49956 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49968 */     GIR_RootConstrainSelectedInstOperands,
     /*  49969 */     // GIR_Coverage, 1852,
     /*  49969 */     GIR_EraseRootFromParent_Done,
     /*  49970 */   // Label 765: @49970
     /*  49970 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50017), // Rule ID 1754 //
     /*  49975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50003 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  50006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  50015 */     GIR_RootConstrainSelectedInstOperands,
     /*  50016 */     // GIR_Coverage, 1754,
     /*  50016 */     GIR_EraseRootFromParent_Done,
     /*  50017 */   // Label 766: @50017
     /*  50017 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50064), // Rule ID 1851 //
     /*  50022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50050 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  50053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  50062 */     GIR_RootConstrainSelectedInstOperands,
     /*  50063 */     // GIR_Coverage, 1851,
     /*  50063 */     GIR_EraseRootFromParent_Done,
     /*  50064 */   // Label 767: @50064
     /*  50064 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50123), // Rule ID 1828 //
     /*  50069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50108 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50121 */     GIR_RootConstrainSelectedInstOperands,
     /*  50122 */     // GIR_Coverage, 1828,
     /*  50122 */     GIR_EraseRootFromParent_Done,
     /*  50123 */   // Label 768: @50123
     /*  50123 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50182), // Rule ID 1827 //
     /*  50128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50167 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50180 */     GIR_RootConstrainSelectedInstOperands,
     /*  50181 */     // GIR_Coverage, 1827,
     /*  50181 */     GIR_EraseRootFromParent_Done,
     /*  50182 */   // Label 769: @50182
     /*  50182 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50241), // Rule ID 1747 //
     /*  50187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50226 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  50229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50239 */     GIR_RootConstrainSelectedInstOperands,
     /*  50240 */     // GIR_Coverage, 1747,
     /*  50240 */     GIR_EraseRootFromParent_Done,
     /*  50241 */   // Label 770: @50241
     /*  50241 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(50300), // Rule ID 1826 //
     /*  50246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50285 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50298 */     GIR_RootConstrainSelectedInstOperands,
     /*  50299 */     // GIR_Coverage, 1826,
     /*  50299 */     GIR_EraseRootFromParent_Done,
     /*  50300 */   // Label 771: @50300
     /*  50300 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(50359), // Rule ID 1825 //
     /*  50305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50344 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50357 */     GIR_RootConstrainSelectedInstOperands,
     /*  50358 */     // GIR_Coverage, 1825,
     /*  50358 */     GIR_EraseRootFromParent_Done,
     /*  50359 */   // Label 772: @50359
     /*  50359 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(50394), // Rule ID 961 //
     /*  50364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50371 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50377 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50385 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  50385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  50388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50392 */     GIR_RootConstrainSelectedInstOperands,
     /*  50393 */     // GIR_Coverage, 961,
     /*  50393 */     GIR_EraseRootFromParent_Done,
     /*  50394 */   // Label 773: @50394
     /*  50394 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(50451), // Rule ID 1723 //
     /*  50399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50434 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  50437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50439 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50449 */     GIR_RootConstrainSelectedInstOperands,
     /*  50450 */     // GIR_Coverage, 1723,
     /*  50450 */     GIR_EraseRootFromParent_Done,
     /*  50451 */   // Label 774: @50451
     /*  50451 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(50508), // Rule ID 1813 //
     /*  50456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50491 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  50494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50506 */     GIR_RootConstrainSelectedInstOperands,
     /*  50507 */     // GIR_Coverage, 1813,
     /*  50507 */     GIR_EraseRootFromParent_Done,
     /*  50508 */   // Label 775: @50508
     /*  50508 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(50552), // Rule ID 1850 //
     /*  50513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50539 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50550 */     GIR_RootConstrainSelectedInstOperands,
     /*  50551 */     // GIR_Coverage, 1850,
     /*  50551 */     GIR_EraseRootFromParent_Done,
     /*  50552 */   // Label 776: @50552
     /*  50552 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(50596), // Rule ID 1753 //
     /*  50557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50583 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  50586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50588 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50594 */     GIR_RootConstrainSelectedInstOperands,
     /*  50595 */     // GIR_Coverage, 1753,
     /*  50595 */     GIR_EraseRootFromParent_Done,
     /*  50596 */   // Label 777: @50596
     /*  50596 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(50640), // Rule ID 1849 //
     /*  50601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50627 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50638 */     GIR_RootConstrainSelectedInstOperands,
     /*  50639 */     // GIR_Coverage, 1849,
     /*  50639 */     GIR_EraseRootFromParent_Done,
     /*  50640 */   // Label 778: @50640
     /*  50640 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(50663), // Rule ID 1468 //
     /*  50645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50656 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  50656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  50661 */     GIR_RootConstrainSelectedInstOperands,
     /*  50662 */     // GIR_Coverage, 1468,
     /*  50662 */     GIR_Done,
     /*  50663 */   // Label 779: @50663
     /*  50663 */   GIM_Reject,
     /*  50664 */ // Label 757: @50664
     /*  50664 */ GIM_Reject,
     /*  50665 */ // Label 599: @50665
     /*  50665 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(50739),
     /*  50670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50680 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(50715), // Rule ID 959 //
     /*  50685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50692 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50698 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50706 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  50706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  50709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50713 */     GIR_RootConstrainSelectedInstOperands,
     /*  50714 */     // GIR_Coverage, 959,
     /*  50714 */     GIR_EraseRootFromParent_Done,
     /*  50715 */   // Label 781: @50715
     /*  50715 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(50738), // Rule ID 1466 //
     /*  50720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50731 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  50736 */     GIR_RootConstrainSelectedInstOperands,
     /*  50737 */     // GIR_Coverage, 1466,
     /*  50737 */     GIR_Done,
     /*  50738 */   // Label 782: @50738
     /*  50738 */   GIM_Reject,
     /*  50739 */ // Label 780: @50739
     /*  50739 */ GIM_Reject,
     /*  50740 */ // Label 600: @50740
     /*  50740 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(50765), // Rule ID 7374 //
     /*  50745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  50751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  50754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50758 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  50758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  50763 */   GIR_RootConstrainSelectedInstOperands,
     /*  50764 */   // GIR_Coverage, 7374,
     /*  50764 */   GIR_Done,
     /*  50765 */ // Label 783: @50765
     /*  50765 */ GIM_Reject,
     /*  50766 */ // Label 601: @50766
     /*  50766 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(50791), // Rule ID 7373 //
     /*  50771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  50777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  50780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50784 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  50784 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  50789 */   GIR_RootConstrainSelectedInstOperands,
     /*  50790 */   // GIR_Coverage, 7373,
     /*  50790 */   GIR_Done,
     /*  50791 */ // Label 784: @50791
     /*  50791 */ GIM_Reject,
     /*  50792 */ // Label 602: @50792
     /*  50792 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(50817), // Rule ID 7372 //
     /*  50797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  50803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  50806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50810 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  50810 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  50815 */   GIR_RootConstrainSelectedInstOperands,
     /*  50816 */   // GIR_Coverage, 7372,
     /*  50816 */   GIR_Done,
     /*  50817 */ // Label 785: @50817
     /*  50817 */ GIM_Reject,
     /*  50818 */ // Label 603: @50818
     /*  50818 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(50843), // Rule ID 7371 //
     /*  50823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  50829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  50832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50836 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  50836 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  50841 */   GIR_RootConstrainSelectedInstOperands,
     /*  50842 */   // GIR_Coverage, 7371,
     /*  50842 */   GIR_Done,
     /*  50843 */ // Label 786: @50843
     /*  50843 */ GIM_Reject,
     /*  50844 */ // Label 604: @50844
     /*  50844 */ GIM_Reject,
     /*  50845 */ // Label 2: @50845
     /*  50845 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 795*/ GIMT_Encode4(52673),
     /*  50856 */ /*GILLT_s32*//*Label 787*/ GIMT_Encode4(50896),
     /*  50860 */ /*GILLT_s64*//*Label 788*/ GIMT_Encode4(51053), GIMT_Encode4(0),
     /*  50868 */ /*GILLT_v2s32*//*Label 789*/ GIMT_Encode4(51597), GIMT_Encode4(0),
     /*  50876 */ /*GILLT_v4s16*//*Label 790*/ GIMT_Encode4(51935),
     /*  50880 */ /*GILLT_v4s32*//*Label 791*/ GIMT_Encode4(52273),
     /*  50884 */ /*GILLT_v8s8*//*Label 792*/ GIMT_Encode4(52439),
     /*  50888 */ /*GILLT_v8s16*//*Label 793*/ GIMT_Encode4(52473),
     /*  50892 */ /*GILLT_v16s8*//*Label 794*/ GIMT_Encode4(52639),
     /*  50896 */ // Label 787: @50896
     /*  50896 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(51052),
     /*  50901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50911 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(50966), // Rule ID 3936 //
     /*  50916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50932 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50947 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50958 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50964 */     GIR_RootConstrainSelectedInstOperands,
     /*  50965 */     // GIR_Coverage, 3936,
     /*  50965 */     GIR_EraseRootFromParent_Done,
     /*  50966 */   // Label 797: @50966
     /*  50966 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(51021), // Rule ID 13688 //
     /*  50971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50991 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51002 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  51002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  51005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  51013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51019 */     GIR_RootConstrainSelectedInstOperands,
     /*  51020 */     // GIR_Coverage, 13688,
     /*  51020 */     GIR_EraseRootFromParent_Done,
     /*  51021 */   // Label 798: @51021
     /*  51021 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(51051), // Rule ID 3932 //
     /*  51026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51034 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  51034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  51037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51049 */     GIR_RootConstrainSelectedInstOperands,
     /*  51050 */     // GIR_Coverage, 3932,
     /*  51050 */     GIR_EraseRootFromParent_Done,
     /*  51051 */   // Label 799: @51051
     /*  51051 */   GIM_Reject,
     /*  51052 */ // Label 796: @51052
     /*  51052 */ GIM_Reject,
     /*  51053 */ // Label 788: @51053
     /*  51053 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(51596),
     /*  51058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  51061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  51064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51068 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(51123), // Rule ID 3937 //
     /*  51073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51089 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51104 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51115 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51121 */     GIR_RootConstrainSelectedInstOperands,
     /*  51122 */     // GIR_Coverage, 3937,
     /*  51122 */     GIR_EraseRootFromParent_Done,
     /*  51123 */   // Label 801: @51123
     /*  51123 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(51178), // Rule ID 13689 //
     /*  51128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51148 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51159 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  51170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51176 */     GIR_RootConstrainSelectedInstOperands,
     /*  51177 */     // GIR_Coverage, 13689,
     /*  51177 */     GIR_EraseRootFromParent_Done,
     /*  51178 */   // Label 802: @51178
     /*  51178 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(51291), // Rule ID 3948 //
     /*  51183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51200 */     // MIs[1] Operand 2
     /*  51200 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51219 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51223 */     // MIs[2] Operand 1
     /*  51223 */     // No operand predicates
     /*  51223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51225 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51225 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51228 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51232 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51237 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51256 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51289 */     GIR_RootConstrainSelectedInstOperands,
     /*  51290 */     // GIR_Coverage, 3948,
     /*  51290 */     GIR_EraseRootFromParent_Done,
     /*  51291 */   // Label 803: @51291
     /*  51291 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(51366), // Rule ID 3946 //
     /*  51296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51321 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51325 */     // MIs[2] Operand 1
     /*  51325 */     // No operand predicates
     /*  51325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51327 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51339 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51364 */     GIR_RootConstrainSelectedInstOperands,
     /*  51365 */     // GIR_Coverage, 3946,
     /*  51365 */     GIR_EraseRootFromParent_Done,
     /*  51366 */   // Label 804: @51366
     /*  51366 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(51441), // Rule ID 3947 //
     /*  51371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51396 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  51400 */     // MIs[2] Operand 1
     /*  51400 */     // No operand predicates
     /*  51400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51402 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51414 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51439 */     GIR_RootConstrainSelectedInstOperands,
     /*  51440 */     // GIR_Coverage, 3947,
     /*  51440 */     GIR_EraseRootFromParent_Done,
     /*  51441 */   // Label 805: @51441
     /*  51441 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(51503), // Rule ID 3940 //
     /*  51446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51482 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51501 */     GIR_RootConstrainSelectedInstOperands,
     /*  51502 */     // GIR_Coverage, 3940,
     /*  51502 */     GIR_EraseRootFromParent_Done,
     /*  51503 */   // Label 806: @51503
     /*  51503 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(51565), // Rule ID 3943 //
     /*  51508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51544 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51563 */     GIR_RootConstrainSelectedInstOperands,
     /*  51564 */     // GIR_Coverage, 3943,
     /*  51564 */     GIR_EraseRootFromParent_Done,
     /*  51565 */   // Label 807: @51565
     /*  51565 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(51595), // Rule ID 3933 //
     /*  51570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51578 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  51581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51593 */     GIR_RootConstrainSelectedInstOperands,
     /*  51594 */     // GIR_Coverage, 3933,
     /*  51594 */     GIR_EraseRootFromParent_Done,
     /*  51595 */   // Label 808: @51595
     /*  51595 */   GIM_Reject,
     /*  51596 */ // Label 800: @51596
     /*  51596 */ GIM_Reject,
     /*  51597 */ // Label 789: @51597
     /*  51597 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(51934),
     /*  51602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  51605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51612 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(51698), // Rule ID 13382 //
     /*  51617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51661 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51665 */     // MIs[3] Operand 1
     /*  51665 */     // No operand predicates
     /*  51665 */     // MIs[1] Operand 2
     /*  51665 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51682 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51696 */     GIR_RootConstrainSelectedInstOperands,
     /*  51697 */     // GIR_Coverage, 13382,
     /*  51697 */     GIR_EraseRootFromParent_Done,
     /*  51698 */   // Label 810: @51698
     /*  51698 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(51784), // Rule ID 2027 //
     /*  51703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51751 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51755 */     // MIs[3] Operand 1
     /*  51755 */     // No operand predicates
     /*  51755 */     // MIs[1] Operand 2
     /*  51755 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51768 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51782 */     GIR_RootConstrainSelectedInstOperands,
     /*  51783 */     // GIR_Coverage, 2027,
     /*  51783 */     GIR_EraseRootFromParent_Done,
     /*  51784 */   // Label 811: @51784
     /*  51784 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(51847), // Rule ID 13383 //
     /*  51789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51821 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51825 */     // MIs[2] Operand 1
     /*  51825 */     // No operand predicates
     /*  51825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51831 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  51845 */     GIR_RootConstrainSelectedInstOperands,
     /*  51846 */     // GIR_Coverage, 13383,
     /*  51846 */     GIR_EraseRootFromParent_Done,
     /*  51847 */   // Label 812: @51847
     /*  51847 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(51910), // Rule ID 2028 //
     /*  51852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51888 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51892 */     // MIs[2] Operand 1
     /*  51892 */     // No operand predicates
     /*  51892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51894 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  51908 */     GIR_RootConstrainSelectedInstOperands,
     /*  51909 */     // GIR_Coverage, 2028,
     /*  51909 */     GIR_EraseRootFromParent_Done,
     /*  51910 */   // Label 813: @51910
     /*  51910 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(51933), // Rule ID 1345 //
     /*  51915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51926 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  51926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  51931 */     GIR_RootConstrainSelectedInstOperands,
     /*  51932 */     // GIR_Coverage, 1345,
     /*  51932 */     GIR_Done,
     /*  51933 */   // Label 814: @51933
     /*  51933 */   GIM_Reject,
     /*  51934 */ // Label 809: @51934
     /*  51934 */ GIM_Reject,
     /*  51935 */ // Label 790: @51935
     /*  51935 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(52272),
     /*  51940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  51943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51950 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(52036), // Rule ID 13379 //
     /*  51955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  51978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  51991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51999 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52003 */     // MIs[3] Operand 1
     /*  52003 */     // No operand predicates
     /*  52003 */     // MIs[1] Operand 2
     /*  52003 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52020 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52034 */     GIR_RootConstrainSelectedInstOperands,
     /*  52035 */     // GIR_Coverage, 13379,
     /*  52035 */     GIR_EraseRootFromParent_Done,
     /*  52036 */   // Label 816: @52036
     /*  52036 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(52122), // Rule ID 2024 //
     /*  52041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52089 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52093 */     // MIs[3] Operand 1
     /*  52093 */     // No operand predicates
     /*  52093 */     // MIs[1] Operand 2
     /*  52093 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52106 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52120 */     GIR_RootConstrainSelectedInstOperands,
     /*  52121 */     // GIR_Coverage, 2024,
     /*  52121 */     GIR_EraseRootFromParent_Done,
     /*  52122 */   // Label 817: @52122
     /*  52122 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(52185), // Rule ID 13380 //
     /*  52127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52159 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52163 */     // MIs[2] Operand 1
     /*  52163 */     // No operand predicates
     /*  52163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52169 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52183 */     GIR_RootConstrainSelectedInstOperands,
     /*  52184 */     // GIR_Coverage, 13380,
     /*  52184 */     GIR_EraseRootFromParent_Done,
     /*  52185 */   // Label 818: @52185
     /*  52185 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(52248), // Rule ID 2025 //
     /*  52190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52226 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52230 */     // MIs[2] Operand 1
     /*  52230 */     // No operand predicates
     /*  52230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52232 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52246 */     GIR_RootConstrainSelectedInstOperands,
     /*  52247 */     // GIR_Coverage, 2025,
     /*  52247 */     GIR_EraseRootFromParent_Done,
     /*  52248 */   // Label 819: @52248
     /*  52248 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(52271), // Rule ID 1343 //
     /*  52253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52264 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  52264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  52269 */     GIR_RootConstrainSelectedInstOperands,
     /*  52270 */     // GIR_Coverage, 1343,
     /*  52270 */     GIR_Done,
     /*  52271 */   // Label 820: @52271
     /*  52271 */   GIM_Reject,
     /*  52272 */ // Label 815: @52272
     /*  52272 */ GIM_Reject,
     /*  52273 */ // Label 791: @52273
     /*  52273 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(52438),
     /*  52278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52288 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(52351), // Rule ID 13384 //
     /*  52293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52325 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52329 */     // MIs[2] Operand 1
     /*  52329 */     // No operand predicates
     /*  52329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52335 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52349 */     GIR_RootConstrainSelectedInstOperands,
     /*  52350 */     // GIR_Coverage, 13384,
     /*  52350 */     GIR_EraseRootFromParent_Done,
     /*  52351 */   // Label 822: @52351
     /*  52351 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(52414), // Rule ID 2029 //
     /*  52356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52392 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52396 */     // MIs[2] Operand 1
     /*  52396 */     // No operand predicates
     /*  52396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52398 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52412 */     GIR_RootConstrainSelectedInstOperands,
     /*  52413 */     // GIR_Coverage, 2029,
     /*  52413 */     GIR_EraseRootFromParent_Done,
     /*  52414 */   // Label 823: @52414
     /*  52414 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(52437), // Rule ID 1346 //
     /*  52419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52430 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  52430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  52435 */     GIR_RootConstrainSelectedInstOperands,
     /*  52436 */     // GIR_Coverage, 1346,
     /*  52436 */     GIR_Done,
     /*  52437 */   // Label 824: @52437
     /*  52437 */   GIM_Reject,
     /*  52438 */ // Label 821: @52438
     /*  52438 */ GIM_Reject,
     /*  52439 */ // Label 792: @52439
     /*  52439 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(52472), // Rule ID 1341 //
     /*  52444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52465 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  52470 */   GIR_RootConstrainSelectedInstOperands,
     /*  52471 */   // GIR_Coverage, 1341,
     /*  52471 */   GIR_Done,
     /*  52472 */ // Label 825: @52472
     /*  52472 */ GIM_Reject,
     /*  52473 */ // Label 793: @52473
     /*  52473 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(52638),
     /*  52478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52488 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(52551), // Rule ID 13381 //
     /*  52493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52525 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52529 */     // MIs[2] Operand 1
     /*  52529 */     // No operand predicates
     /*  52529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52535 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  52538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52549 */     GIR_RootConstrainSelectedInstOperands,
     /*  52550 */     // GIR_Coverage, 13381,
     /*  52550 */     GIR_EraseRootFromParent_Done,
     /*  52551 */   // Label 827: @52551
     /*  52551 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(52614), // Rule ID 2026 //
     /*  52556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52596 */     // MIs[2] Operand 1
     /*  52596 */     // No operand predicates
     /*  52596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52598 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  52601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52612 */     GIR_RootConstrainSelectedInstOperands,
     /*  52613 */     // GIR_Coverage, 2026,
     /*  52613 */     GIR_EraseRootFromParent_Done,
     /*  52614 */   // Label 828: @52614
     /*  52614 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(52637), // Rule ID 1344 //
     /*  52619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52630 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  52630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  52635 */     GIR_RootConstrainSelectedInstOperands,
     /*  52636 */     // GIR_Coverage, 1344,
     /*  52636 */     GIR_Done,
     /*  52637 */   // Label 829: @52637
     /*  52637 */   GIM_Reject,
     /*  52638 */ // Label 826: @52638
     /*  52638 */ GIM_Reject,
     /*  52639 */ // Label 794: @52639
     /*  52639 */ GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(52672), // Rule ID 1342 //
     /*  52644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  52650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52665 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  52665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  52670 */   GIR_RootConstrainSelectedInstOperands,
     /*  52671 */   // GIR_Coverage, 1342,
     /*  52671 */   GIR_Done,
     /*  52672 */ // Label 830: @52672
     /*  52672 */ GIM_Reject,
     /*  52673 */ // Label 795: @52673
     /*  52673 */ GIM_Reject,
     /*  52674 */ // Label 3: @52674
     /*  52674 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 833*/ GIMT_Encode4(52755),
     /*  52685 */ /*GILLT_s32*//*Label 831*/ GIMT_Encode4(52693),
     /*  52689 */ /*GILLT_s64*//*Label 832*/ GIMT_Encode4(52724),
     /*  52693 */ // Label 831: @52693
     /*  52693 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(52723), // Rule ID 117 //
     /*  52698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52716 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  52716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  52721 */   GIR_RootConstrainSelectedInstOperands,
     /*  52722 */   // GIR_Coverage, 117,
     /*  52722 */   GIR_Done,
     /*  52723 */ // Label 834: @52723
     /*  52723 */ GIM_Reject,
     /*  52724 */ // Label 832: @52724
     /*  52724 */ GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(52754), // Rule ID 118 //
     /*  52729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  52735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52747 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  52747 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  52752 */   GIR_RootConstrainSelectedInstOperands,
     /*  52753 */   // GIR_Coverage, 118,
     /*  52753 */   GIR_Done,
     /*  52754 */ // Label 835: @52754
     /*  52754 */ GIM_Reject,
     /*  52755 */ // Label 833: @52755
     /*  52755 */ GIM_Reject,
     /*  52756 */ // Label 4: @52756
     /*  52756 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 838*/ GIMT_Encode4(52837),
     /*  52767 */ /*GILLT_s32*//*Label 836*/ GIMT_Encode4(52775),
     /*  52771 */ /*GILLT_s64*//*Label 837*/ GIMT_Encode4(52806),
     /*  52775 */ // Label 836: @52775
     /*  52775 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(52805), // Rule ID 115 //
     /*  52780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52798 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  52798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  52803 */   GIR_RootConstrainSelectedInstOperands,
     /*  52804 */   // GIR_Coverage, 115,
     /*  52804 */   GIR_Done,
     /*  52805 */ // Label 839: @52805
     /*  52805 */ GIM_Reject,
     /*  52806 */ // Label 837: @52806
     /*  52806 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(52836), // Rule ID 116 //
     /*  52811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  52817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52829 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  52829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  52834 */   GIR_RootConstrainSelectedInstOperands,
     /*  52835 */   // GIR_Coverage, 116,
     /*  52835 */   GIR_Done,
     /*  52836 */ // Label 840: @52836
     /*  52836 */ GIM_Reject,
     /*  52837 */ // Label 838: @52837
     /*  52837 */ GIM_Reject,
     /*  52838 */ // Label 5: @52838
     /*  52838 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 859*/ GIMT_Encode4(60583),
     /*  52849 */ /*GILLT_s32*//*Label 841*/ GIMT_Encode4(52937),
     /*  52853 */ /*GILLT_s64*//*Label 842*/ GIMT_Encode4(53435), GIMT_Encode4(0),
     /*  52861 */ /*GILLT_v2s32*//*Label 843*/ GIMT_Encode4(54870),
     /*  52865 */ /*GILLT_v2s64*//*Label 844*/ GIMT_Encode4(55030),
     /*  52869 */ /*GILLT_v4s16*//*Label 845*/ GIMT_Encode4(55190),
     /*  52873 */ /*GILLT_v4s32*//*Label 846*/ GIMT_Encode4(55350),
     /*  52877 */ /*GILLT_v8s8*//*Label 847*/ GIMT_Encode4(55510),
     /*  52881 */ /*GILLT_v8s16*//*Label 848*/ GIMT_Encode4(55670),
     /*  52885 */ /*GILLT_v16s8*//*Label 849*/ GIMT_Encode4(55830),
     /*  52889 */ /*GILLT_nxv1s1*//*Label 850*/ GIMT_Encode4(55990),
     /*  52893 */ /*GILLT_nxv2s1*//*Label 851*/ GIMT_Encode4(56531), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  52905 */ /*GILLT_nxv2s64*//*Label 852*/ GIMT_Encode4(57072),
     /*  52909 */ /*GILLT_nxv4s1*//*Label 853*/ GIMT_Encode4(57544), GIMT_Encode4(0),
     /*  52917 */ /*GILLT_nxv4s32*//*Label 854*/ GIMT_Encode4(58085),
     /*  52921 */ /*GILLT_nxv8s1*//*Label 855*/ GIMT_Encode4(58557),
     /*  52925 */ /*GILLT_nxv8s16*//*Label 856*/ GIMT_Encode4(59098),
     /*  52929 */ /*GILLT_nxv16s1*//*Label 857*/ GIMT_Encode4(59570),
     /*  52933 */ /*GILLT_nxv16s8*//*Label 858*/ GIMT_Encode4(60111),
     /*  52937 */ // Label 841: @52937
     /*  52937 */ GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53434),
     /*  52942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52948 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53003), // Rule ID 13141 //
     /*  52953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52973 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  52977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  52990 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  52990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  52993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52997 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53001 */     GIR_RootConstrainSelectedInstOperands,
     /*  53002 */     // GIR_Coverage, 13141,
     /*  53002 */     GIR_EraseRootFromParent_Done,
     /*  53003 */   // Label 861: @53003
     /*  53003 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53058), // Rule ID 162 //
     /*  53008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53032 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53045 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53056 */     GIR_RootConstrainSelectedInstOperands,
     /*  53057 */     // GIR_Coverage, 162,
     /*  53057 */     GIR_EraseRootFromParent_Done,
     /*  53058 */   // Label 862: @53058
     /*  53058 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53127), // Rule ID 5635 //
     /*  53063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53096 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  53100 */     // MIs[2] Operand 1
     /*  53100 */     // No operand predicates
     /*  53100 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53113 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  53113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  53116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53125 */     GIR_RootConstrainSelectedInstOperands,
     /*  53126 */     // GIR_Coverage, 5635,
     /*  53126 */     GIR_EraseRootFromParent_Done,
     /*  53127 */   // Label 863: @53127
     /*  53127 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53196), // Rule ID 5636 //
     /*  53132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53165 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53169 */     // MIs[2] Operand 1
     /*  53169 */     // No operand predicates
     /*  53169 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53182 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  53182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  53185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53194 */     GIR_RootConstrainSelectedInstOperands,
     /*  53195 */     // GIR_Coverage, 5636,
     /*  53195 */     GIR_EraseRootFromParent_Done,
     /*  53196 */   // Label 864: @53196
     /*  53196 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53249), // Rule ID 13139 //
     /*  53201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53226 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53236 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53247 */     GIR_RootConstrainSelectedInstOperands,
     /*  53248 */     // GIR_Coverage, 13139,
     /*  53248 */     GIR_EraseRootFromParent_Done,
     /*  53249 */   // Label 865: @53249
     /*  53249 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53302), // Rule ID 160 //
     /*  53254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53283 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53289 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53294 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53300 */     GIR_RootConstrainSelectedInstOperands,
     /*  53301 */     // GIR_Coverage, 160,
     /*  53301 */     GIR_EraseRootFromParent_Done,
     /*  53302 */   // Label 866: @53302
     /*  53302 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(53343), // Rule ID 142 //
     /*  53307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  53311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53323 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  53327 */     // MIs[1] Operand 1
     /*  53327 */     // No operand predicates
     /*  53327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53329 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  53329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  53332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53336 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  53341 */     GIR_RootConstrainSelectedInstOperands,
     /*  53342 */     // GIR_Coverage, 142,
     /*  53342 */     GIR_EraseRootFromParent_Done,
     /*  53343 */   // Label 867: @53343
     /*  53343 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(53376), // Rule ID 13137 //
     /*  53348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53363 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53370 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53374 */     GIR_RootConstrainSelectedInstOperands,
     /*  53375 */     // GIR_Coverage, 13137,
     /*  53375 */     GIR_EraseRootFromParent_Done,
     /*  53376 */   // Label 868: @53376
     /*  53376 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(53409), // Rule ID 158 //
     /*  53381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53396 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53407 */     GIR_RootConstrainSelectedInstOperands,
     /*  53408 */     // GIR_Coverage, 158,
     /*  53408 */     GIR_EraseRootFromParent_Done,
     /*  53409 */   // Label 869: @53409
     /*  53409 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(53433), // Rule ID 156 //
     /*  53414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53426 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  53431 */     GIR_RootConstrainSelectedInstOperands,
     /*  53432 */     // GIR_Coverage, 156,
     /*  53432 */     GIR_Done,
     /*  53433 */   // Label 870: @53433
     /*  53433 */   GIM_Reject,
     /*  53434 */ // Label 860: @53434
     /*  53434 */ GIM_Reject,
     /*  53435 */ // Label 842: @53435
     /*  53435 */ GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(54869),
     /*  53440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53446 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(53501), // Rule ID 13142 //
     /*  53451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53471 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53488 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53495 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53499 */     GIR_RootConstrainSelectedInstOperands,
     /*  53500 */     // GIR_Coverage, 13142,
     /*  53500 */     GIR_EraseRootFromParent_Done,
     /*  53501 */   // Label 872: @53501
     /*  53501 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(53556), // Rule ID 163 //
     /*  53506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53530 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53543 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53550 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53554 */     GIR_RootConstrainSelectedInstOperands,
     /*  53555 */     // GIR_Coverage, 163,
     /*  53555 */     GIR_EraseRootFromParent_Done,
     /*  53556 */   // Label 873: @53556
     /*  53556 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(53669), // Rule ID 5637 //
     /*  53561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  53573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53606 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  53610 */     // MIs[3] Operand 1
     /*  53610 */     // No operand predicates
     /*  53610 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53623 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  53623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  53630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  53639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  53642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53668 */     // GIR_Coverage, 5637,
     /*  53668 */     GIR_EraseRootFromParent_Done,
     /*  53669 */   // Label 874: @53669
     /*  53669 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(53782), // Rule ID 5638 //
     /*  53674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  53686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53719 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53723 */     // MIs[3] Operand 1
     /*  53723 */     // No operand predicates
     /*  53723 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53736 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  53736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  53743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  53752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  53755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53781 */     // GIR_Coverage, 5638,
     /*  53781 */     GIR_EraseRootFromParent_Done,
     /*  53782 */   // Label 875: @53782
     /*  53782 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(53881), // Rule ID 7053 //
     /*  53787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53799 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53802 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  53807 */     // MIs[1] addr
     /*  53807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53816 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  53820 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53833 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  53840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53849 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53880 */     // GIR_Coverage, 7053,
     /*  53880 */     GIR_EraseRootFromParent_Done,
     /*  53881 */   // Label 876: @53881
     /*  53881 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(53980), // Rule ID 7054 //
     /*  53886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53898 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53901 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  53906 */     // MIs[1] addr
     /*  53906 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53915 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  53919 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53932 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  53939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53944 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53948 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53979 */     // GIR_Coverage, 7054,
     /*  53979 */     GIR_EraseRootFromParent_Done,
     /*  53980 */   // Label 877: @53980
     /*  53980 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(54079), // Rule ID 7055 //
     /*  53985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53997 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54000 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54005 */     // MIs[1] addr
     /*  54005 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54014 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  54018 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54031 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  54038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54047 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54078 */     // GIR_Coverage, 7055,
     /*  54078 */     GIR_EraseRootFromParent_Done,
     /*  54079 */   // Label 878: @54079
     /*  54079 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(54178), // Rule ID 7060 //
     /*  54084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54096 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54099 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54104 */     // MIs[1] addr
     /*  54104 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54113 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  54117 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54130 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  54137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54146 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54177 */     // GIR_Coverage, 7060,
     /*  54177 */     GIR_EraseRootFromParent_Done,
     /*  54178 */   // Label 879: @54178
     /*  54178 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(54277), // Rule ID 7061 //
     /*  54183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54195 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54198 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54203 */     // MIs[1] addr
     /*  54203 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54212 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  54216 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54229 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  54236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54245 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54266 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54276 */     // GIR_Coverage, 7061,
     /*  54276 */     GIR_EraseRootFromParent_Done,
     /*  54277 */   // Label 880: @54277
     /*  54277 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(54376), // Rule ID 7062 //
     /*  54282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54294 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54297 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54302 */     // MIs[1] addr
     /*  54302 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54311 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  54315 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54328 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  54335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54340 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54344 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54375 */     // GIR_Coverage, 7062,
     /*  54375 */     GIR_EraseRootFromParent_Done,
     /*  54376 */   // Label 881: @54376
     /*  54376 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(54429), // Rule ID 13140 //
     /*  54381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54406 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54416 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54427 */     GIR_RootConstrainSelectedInstOperands,
     /*  54428 */     // GIR_Coverage, 13140,
     /*  54428 */     GIR_EraseRootFromParent_Done,
     /*  54429 */   // Label 882: @54429
     /*  54429 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(54482), // Rule ID 161 //
     /*  54434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54463 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54469 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54480 */     GIR_RootConstrainSelectedInstOperands,
     /*  54481 */     // GIR_Coverage, 161,
     /*  54481 */     GIR_EraseRootFromParent_Done,
     /*  54482 */   // Label 883: @54482
     /*  54482 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(54582), // Rule ID 3985 //
     /*  54487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54495 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54506 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  54506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  54509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54518 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  54524 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54529 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  54541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54546 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54552 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54581 */     // GIR_Coverage, 3985,
     /*  54581 */     GIR_EraseRootFromParent_Done,
     /*  54582 */   // Label 884: @54582
     /*  54582 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(54623), // Rule ID 143 //
     /*  54587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54603 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  54607 */     // MIs[1] Operand 1
     /*  54607 */     // No operand predicates
     /*  54607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54609 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  54609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  54612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54616 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  54621 */     GIR_RootConstrainSelectedInstOperands,
     /*  54622 */     // GIR_Coverage, 143,
     /*  54622 */     GIR_EraseRootFromParent_Done,
     /*  54623 */   // Label 885: @54623
     /*  54623 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(54656), // Rule ID 13138 //
     /*  54628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54643 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  54646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54654 */     GIR_RootConstrainSelectedInstOperands,
     /*  54655 */     // GIR_Coverage, 13138,
     /*  54655 */     GIR_EraseRootFromParent_Done,
     /*  54656 */   // Label 886: @54656
     /*  54656 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(54689), // Rule ID 159 //
     /*  54661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54676 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  54679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54687 */     GIR_RootConstrainSelectedInstOperands,
     /*  54688 */     // GIR_Coverage, 159,
     /*  54688 */     GIR_EraseRootFromParent_Done,
     /*  54689 */   // Label 887: @54689
     /*  54689 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(54753), // Rule ID 13793 //
     /*  54694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54726 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54732 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54740 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54745 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  54747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54751 */     GIR_RootConstrainSelectedInstOperands,
     /*  54752 */     // GIR_Coverage, 13793,
     /*  54752 */     GIR_EraseRootFromParent_Done,
     /*  54753 */   // Label 888: @54753
     /*  54753 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(54817), // Rule ID 5020 //
     /*  54758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54794 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54804 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54809 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  54811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54815 */     GIR_RootConstrainSelectedInstOperands,
     /*  54816 */     // GIR_Coverage, 5020,
     /*  54816 */     GIR_EraseRootFromParent_Done,
     /*  54817 */   // Label 889: @54817
     /*  54817 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(54841), // Rule ID 157 //
     /*  54822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54834 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  54839 */     GIR_RootConstrainSelectedInstOperands,
     /*  54840 */     // GIR_Coverage, 157,
     /*  54840 */     GIR_Done,
     /*  54841 */   // Label 890: @54841
     /*  54841 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(54868), // Rule ID 2475 //
     /*  54846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54861 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  54866 */     GIR_RootConstrainSelectedInstOperands,
     /*  54867 */     // GIR_Coverage, 2475,
     /*  54867 */     GIR_Done,
     /*  54868 */   // Label 891: @54868
     /*  54868 */   GIM_Reject,
     /*  54869 */ // Label 871: @54869
     /*  54869 */ GIM_Reject,
     /*  54870 */ // Label 843: @54870
     /*  54870 */ GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(55029),
     /*  54875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54885 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(54945), // Rule ID 13792 //
     /*  54890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54918 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54924 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54932 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  54932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54937 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  54939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54943 */     GIR_RootConstrainSelectedInstOperands,
     /*  54944 */     // GIR_Coverage, 13792,
     /*  54944 */     GIR_EraseRootFromParent_Done,
     /*  54945 */   // Label 893: @54945
     /*  54945 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(55005), // Rule ID 5019 //
     /*  54950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54982 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54988 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54992 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  54992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54997 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  54999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55003 */     GIR_RootConstrainSelectedInstOperands,
     /*  55004 */     // GIR_Coverage, 5019,
     /*  55004 */     GIR_EraseRootFromParent_Done,
     /*  55005 */   // Label 894: @55005
     /*  55005 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(55028), // Rule ID 2474 //
     /*  55010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55021 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55026 */     GIR_RootConstrainSelectedInstOperands,
     /*  55027 */     // GIR_Coverage, 2474,
     /*  55027 */     GIR_Done,
     /*  55028 */   // Label 895: @55028
     /*  55028 */   GIM_Reject,
     /*  55029 */ // Label 892: @55029
     /*  55029 */ GIM_Reject,
     /*  55030 */ // Label 844: @55030
     /*  55030 */ GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(55189),
     /*  55035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55045 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(55105), // Rule ID 13796 //
     /*  55050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55078 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55084 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55092 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55097 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55103 */     GIR_RootConstrainSelectedInstOperands,
     /*  55104 */     // GIR_Coverage, 13796,
     /*  55104 */     GIR_EraseRootFromParent_Done,
     /*  55105 */   // Label 897: @55105
     /*  55105 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(55165), // Rule ID 5023 //
     /*  55110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55142 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55148 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55152 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55157 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55163 */     GIR_RootConstrainSelectedInstOperands,
     /*  55164 */     // GIR_Coverage, 5023,
     /*  55164 */     GIR_EraseRootFromParent_Done,
     /*  55165 */   // Label 898: @55165
     /*  55165 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(55188), // Rule ID 2478 //
     /*  55170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55181 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55186 */     GIR_RootConstrainSelectedInstOperands,
     /*  55187 */     // GIR_Coverage, 2478,
     /*  55187 */     GIR_Done,
     /*  55188 */   // Label 899: @55188
     /*  55188 */   GIM_Reject,
     /*  55189 */ // Label 896: @55189
     /*  55189 */ GIM_Reject,
     /*  55190 */ // Label 845: @55190
     /*  55190 */ GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(55349),
     /*  55195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55205 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(55265), // Rule ID 13791 //
     /*  55210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55238 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55244 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55252 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55257 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55263 */     GIR_RootConstrainSelectedInstOperands,
     /*  55264 */     // GIR_Coverage, 13791,
     /*  55264 */     GIR_EraseRootFromParent_Done,
     /*  55265 */   // Label 901: @55265
     /*  55265 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(55325), // Rule ID 5018 //
     /*  55270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55302 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55308 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55312 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55317 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55323 */     GIR_RootConstrainSelectedInstOperands,
     /*  55324 */     // GIR_Coverage, 5018,
     /*  55324 */     GIR_EraseRootFromParent_Done,
     /*  55325 */   // Label 902: @55325
     /*  55325 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(55348), // Rule ID 2473 //
     /*  55330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55341 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55346 */     GIR_RootConstrainSelectedInstOperands,
     /*  55347 */     // GIR_Coverage, 2473,
     /*  55347 */     GIR_Done,
     /*  55348 */   // Label 903: @55348
     /*  55348 */   GIM_Reject,
     /*  55349 */ // Label 900: @55349
     /*  55349 */ GIM_Reject,
     /*  55350 */ // Label 846: @55350
     /*  55350 */ GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(55509),
     /*  55355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55365 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(55425), // Rule ID 13795 //
     /*  55370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55398 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55412 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55417 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55423 */     GIR_RootConstrainSelectedInstOperands,
     /*  55424 */     // GIR_Coverage, 13795,
     /*  55424 */     GIR_EraseRootFromParent_Done,
     /*  55425 */   // Label 905: @55425
     /*  55425 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(55485), // Rule ID 5022 //
     /*  55430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55462 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55468 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55472 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55477 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55483 */     GIR_RootConstrainSelectedInstOperands,
     /*  55484 */     // GIR_Coverage, 5022,
     /*  55484 */     GIR_EraseRootFromParent_Done,
     /*  55485 */   // Label 906: @55485
     /*  55485 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(55508), // Rule ID 2477 //
     /*  55490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55501 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55506 */     GIR_RootConstrainSelectedInstOperands,
     /*  55507 */     // GIR_Coverage, 2477,
     /*  55507 */     GIR_Done,
     /*  55508 */   // Label 907: @55508
     /*  55508 */   GIM_Reject,
     /*  55509 */ // Label 904: @55509
     /*  55509 */ GIM_Reject,
     /*  55510 */ // Label 847: @55510
     /*  55510 */ GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(55669),
     /*  55515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55525 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(55585), // Rule ID 13277 //
     /*  55530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55558 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55564 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55572 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55583 */     GIR_RootConstrainSelectedInstOperands,
     /*  55584 */     // GIR_Coverage, 13277,
     /*  55584 */     GIR_EraseRootFromParent_Done,
     /*  55585 */   // Label 909: @55585
     /*  55585 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(55645), // Rule ID 1590 //
     /*  55590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55622 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55632 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55643 */     GIR_RootConstrainSelectedInstOperands,
     /*  55644 */     // GIR_Coverage, 1590,
     /*  55644 */     GIR_EraseRootFromParent_Done,
     /*  55645 */   // Label 910: @55645
     /*  55645 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(55668), // Rule ID 1588 //
     /*  55650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55661 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55666 */     GIR_RootConstrainSelectedInstOperands,
     /*  55667 */     // GIR_Coverage, 1588,
     /*  55667 */     GIR_Done,
     /*  55668 */   // Label 911: @55668
     /*  55668 */   GIM_Reject,
     /*  55669 */ // Label 908: @55669
     /*  55669 */ GIM_Reject,
     /*  55670 */ // Label 848: @55670
     /*  55670 */ GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(55829),
     /*  55675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55685 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(55745), // Rule ID 13794 //
     /*  55690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55718 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55732 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55737 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55743 */     GIR_RootConstrainSelectedInstOperands,
     /*  55744 */     // GIR_Coverage, 13794,
     /*  55744 */     GIR_EraseRootFromParent_Done,
     /*  55745 */   // Label 913: @55745
     /*  55745 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(55805), // Rule ID 5021 //
     /*  55750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55782 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55788 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55792 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55797 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55803 */     GIR_RootConstrainSelectedInstOperands,
     /*  55804 */     // GIR_Coverage, 5021,
     /*  55804 */     GIR_EraseRootFromParent_Done,
     /*  55805 */   // Label 914: @55805
     /*  55805 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(55828), // Rule ID 2476 //
     /*  55810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55821 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55826 */     GIR_RootConstrainSelectedInstOperands,
     /*  55827 */     // GIR_Coverage, 2476,
     /*  55827 */     GIR_Done,
     /*  55828 */   // Label 915: @55828
     /*  55828 */   GIM_Reject,
     /*  55829 */ // Label 912: @55829
     /*  55829 */ GIM_Reject,
     /*  55830 */ // Label 849: @55830
     /*  55830 */ GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(55989),
     /*  55835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55845 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(55905), // Rule ID 13278 //
     /*  55850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55878 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55892 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55903 */     GIR_RootConstrainSelectedInstOperands,
     /*  55904 */     // GIR_Coverage, 13278,
     /*  55904 */     GIR_EraseRootFromParent_Done,
     /*  55905 */   // Label 917: @55905
     /*  55905 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(55965), // Rule ID 1591 //
     /*  55910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55952 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55963 */     GIR_RootConstrainSelectedInstOperands,
     /*  55964 */     // GIR_Coverage, 1591,
     /*  55964 */     GIR_EraseRootFromParent_Done,
     /*  55965 */   // Label 918: @55965
     /*  55965 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(55988), // Rule ID 1589 //
     /*  55970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55981 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55986 */     GIR_RootConstrainSelectedInstOperands,
     /*  55987 */     // GIR_Coverage, 1589,
     /*  55987 */     GIR_Done,
     /*  55988 */   // Label 919: @55988
     /*  55988 */   GIM_Reject,
     /*  55989 */ // Label 916: @55989
     /*  55989 */ GIM_Reject,
     /*  55990 */ // Label 850: @55990
     /*  55990 */ GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(56530),
     /*  55995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56005 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(56062), // Rule ID 14994 //
     /*  56010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56041 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56047 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56060 */     GIR_RootConstrainSelectedInstOperands,
     /*  56061 */     // GIR_Coverage, 14994,
     /*  56061 */     GIR_EraseRootFromParent_Done,
     /*  56062 */   // Label 921: @56062
     /*  56062 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(56119), // Rule ID 14997 //
     /*  56067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56098 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56104 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56117 */     GIR_RootConstrainSelectedInstOperands,
     /*  56118 */     // GIR_Coverage, 14997,
     /*  56118 */     GIR_EraseRootFromParent_Done,
     /*  56119 */   // Label 922: @56119
     /*  56119 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(56176), // Rule ID 14993 //
     /*  56124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56155 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56161 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56174 */     GIR_RootConstrainSelectedInstOperands,
     /*  56175 */     // GIR_Coverage, 14993,
     /*  56175 */     GIR_EraseRootFromParent_Done,
     /*  56176 */   // Label 923: @56176
     /*  56176 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(56233), // Rule ID 14996 //
     /*  56181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56212 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56218 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56231 */     GIR_RootConstrainSelectedInstOperands,
     /*  56232 */     // GIR_Coverage, 14996,
     /*  56232 */     GIR_EraseRootFromParent_Done,
     /*  56233 */   // Label 924: @56233
     /*  56233 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(56290), // Rule ID 14992 //
     /*  56238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56269 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56275 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56288 */     GIR_RootConstrainSelectedInstOperands,
     /*  56289 */     // GIR_Coverage, 14992,
     /*  56289 */     GIR_EraseRootFromParent_Done,
     /*  56290 */   // Label 925: @56290
     /*  56290 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(56347), // Rule ID 14995 //
     /*  56295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56326 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56332 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56345 */     GIR_RootConstrainSelectedInstOperands,
     /*  56346 */     // GIR_Coverage, 14995,
     /*  56346 */     GIR_EraseRootFromParent_Done,
     /*  56347 */   // Label 926: @56347
     /*  56347 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(56404), // Rule ID 8362 //
     /*  56352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56383 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56389 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56402 */     GIR_RootConstrainSelectedInstOperands,
     /*  56403 */     // GIR_Coverage, 8362,
     /*  56403 */     GIR_EraseRootFromParent_Done,
     /*  56404 */   // Label 927: @56404
     /*  56404 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(56461), // Rule ID 8363 //
     /*  56409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56440 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56446 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56459 */     GIR_RootConstrainSelectedInstOperands,
     /*  56460 */     // GIR_Coverage, 8363,
     /*  56460 */     GIR_EraseRootFromParent_Done,
     /*  56461 */   // Label 928: @56461
     /*  56461 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(56508), // Rule ID 10614 //
     /*  56466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56477 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  56477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56489 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56506 */     GIR_RootConstrainSelectedInstOperands,
     /*  56507 */     // GIR_Coverage, 10614,
     /*  56507 */     GIR_EraseRootFromParent_Done,
     /*  56508 */   // Label 929: @56508
     /*  56508 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(56529), // Rule ID 2744 //
     /*  56513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56516 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  56527 */     GIR_RootConstrainSelectedInstOperands,
     /*  56528 */     // GIR_Coverage, 2744,
     /*  56528 */     GIR_EraseRootFromParent_Done,
     /*  56529 */   // Label 930: @56529
     /*  56529 */   GIM_Reject,
     /*  56530 */ // Label 920: @56530
     /*  56530 */ GIM_Reject,
     /*  56531 */ // Label 851: @56531
     /*  56531 */ GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(57071),
     /*  56536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56546 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(56603), // Rule ID 14985 //
     /*  56551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56582 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56588 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56601 */     GIR_RootConstrainSelectedInstOperands,
     /*  56602 */     // GIR_Coverage, 14985,
     /*  56602 */     GIR_EraseRootFromParent_Done,
     /*  56603 */   // Label 932: @56603
     /*  56603 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(56660), // Rule ID 14988 //
     /*  56608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56639 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56645 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56658 */     GIR_RootConstrainSelectedInstOperands,
     /*  56659 */     // GIR_Coverage, 14988,
     /*  56659 */     GIR_EraseRootFromParent_Done,
     /*  56660 */   // Label 933: @56660
     /*  56660 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(56717), // Rule ID 14984 //
     /*  56665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56696 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56702 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56715 */     GIR_RootConstrainSelectedInstOperands,
     /*  56716 */     // GIR_Coverage, 14984,
     /*  56716 */     GIR_EraseRootFromParent_Done,
     /*  56717 */   // Label 934: @56717
     /*  56717 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(56774), // Rule ID 14987 //
     /*  56722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56753 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56759 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56772 */     GIR_RootConstrainSelectedInstOperands,
     /*  56773 */     // GIR_Coverage, 14987,
     /*  56773 */     GIR_EraseRootFromParent_Done,
     /*  56774 */   // Label 935: @56774
     /*  56774 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(56831), // Rule ID 14983 //
     /*  56779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56810 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56816 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56829 */     GIR_RootConstrainSelectedInstOperands,
     /*  56830 */     // GIR_Coverage, 14983,
     /*  56830 */     GIR_EraseRootFromParent_Done,
     /*  56831 */   // Label 936: @56831
     /*  56831 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(56888), // Rule ID 14986 //
     /*  56836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56867 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56873 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56886 */     GIR_RootConstrainSelectedInstOperands,
     /*  56887 */     // GIR_Coverage, 14986,
     /*  56887 */     GIR_EraseRootFromParent_Done,
     /*  56888 */   // Label 937: @56888
     /*  56888 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(56945), // Rule ID 8358 //
     /*  56893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56924 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56930 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56943 */     GIR_RootConstrainSelectedInstOperands,
     /*  56944 */     // GIR_Coverage, 8358,
     /*  56944 */     GIR_EraseRootFromParent_Done,
     /*  56945 */   // Label 938: @56945
     /*  56945 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(57002), // Rule ID 8359 //
     /*  56950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56981 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56987 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57000 */     GIR_RootConstrainSelectedInstOperands,
     /*  57001 */     // GIR_Coverage, 8359,
     /*  57001 */     GIR_EraseRootFromParent_Done,
     /*  57002 */   // Label 939: @57002
     /*  57002 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(57049), // Rule ID 10613 //
     /*  57007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57018 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  57018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  57025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57030 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57047 */     GIR_RootConstrainSelectedInstOperands,
     /*  57048 */     // GIR_Coverage, 10613,
     /*  57048 */     GIR_EraseRootFromParent_Done,
     /*  57049 */   // Label 940: @57049
     /*  57049 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(57070), // Rule ID 2743 //
     /*  57054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57057 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57068 */     GIR_RootConstrainSelectedInstOperands,
     /*  57069 */     // GIR_Coverage, 2743,
     /*  57069 */     GIR_EraseRootFromParent_Done,
     /*  57070 */   // Label 941: @57070
     /*  57070 */   GIM_Reject,
     /*  57071 */ // Label 931: @57071
     /*  57071 */ GIM_Reject,
     /*  57072 */ // Label 852: @57072
     /*  57072 */ GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(57543),
     /*  57077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57087 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(57142), // Rule ID 14925 //
     /*  57092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57123 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57129 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57140 */     GIR_RootConstrainSelectedInstOperands,
     /*  57141 */     // GIR_Coverage, 14925,
     /*  57141 */     GIR_EraseRootFromParent_Done,
     /*  57142 */   // Label 943: @57142
     /*  57142 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(57197), // Rule ID 14928 //
     /*  57147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57178 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57184 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57195 */     GIR_RootConstrainSelectedInstOperands,
     /*  57196 */     // GIR_Coverage, 14928,
     /*  57196 */     GIR_EraseRootFromParent_Done,
     /*  57197 */   // Label 944: @57197
     /*  57197 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(57252), // Rule ID 14924 //
     /*  57202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57233 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57239 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57250 */     GIR_RootConstrainSelectedInstOperands,
     /*  57251 */     // GIR_Coverage, 14924,
     /*  57251 */     GIR_EraseRootFromParent_Done,
     /*  57252 */   // Label 945: @57252
     /*  57252 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(57307), // Rule ID 14927 //
     /*  57257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57288 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57294 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57305 */     GIR_RootConstrainSelectedInstOperands,
     /*  57306 */     // GIR_Coverage, 14927,
     /*  57306 */     GIR_EraseRootFromParent_Done,
     /*  57307 */   // Label 946: @57307
     /*  57307 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(57362), // Rule ID 14923 //
     /*  57312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57343 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57349 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57360 */     GIR_RootConstrainSelectedInstOperands,
     /*  57361 */     // GIR_Coverage, 14923,
     /*  57361 */     GIR_EraseRootFromParent_Done,
     /*  57362 */   // Label 947: @57362
     /*  57362 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(57417), // Rule ID 14926 //
     /*  57367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57398 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57404 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57415 */     GIR_RootConstrainSelectedInstOperands,
     /*  57416 */     // GIR_Coverage, 14926,
     /*  57416 */     GIR_EraseRootFromParent_Done,
     /*  57417 */   // Label 948: @57417
     /*  57417 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(57472), // Rule ID 7411 //
     /*  57422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57453 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57459 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57470 */     GIR_RootConstrainSelectedInstOperands,
     /*  57471 */     // GIR_Coverage, 7411,
     /*  57471 */     GIR_EraseRootFromParent_Done,
     /*  57472 */   // Label 949: @57472
     /*  57472 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(57527), // Rule ID 7412 //
     /*  57477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57508 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57514 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57525 */     GIR_RootConstrainSelectedInstOperands,
     /*  57526 */     // GIR_Coverage, 7412,
     /*  57526 */     GIR_EraseRootFromParent_Done,
     /*  57527 */   // Label 950: @57527
     /*  57527 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(57542), // Rule ID 3137 //
     /*  57532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57535 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  57540 */     GIR_RootConstrainSelectedInstOperands,
     /*  57541 */     // GIR_Coverage, 3137,
     /*  57541 */     GIR_Done,
     /*  57542 */   // Label 951: @57542
     /*  57542 */   GIM_Reject,
     /*  57543 */ // Label 942: @57543
     /*  57543 */ GIM_Reject,
     /*  57544 */ // Label 853: @57544
     /*  57544 */ GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(58084),
     /*  57549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57559 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(57616), // Rule ID 14976 //
     /*  57564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57595 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57601 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57614 */     GIR_RootConstrainSelectedInstOperands,
     /*  57615 */     // GIR_Coverage, 14976,
     /*  57615 */     GIR_EraseRootFromParent_Done,
     /*  57616 */   // Label 953: @57616
     /*  57616 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(57673), // Rule ID 14979 //
     /*  57621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57652 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57658 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57671 */     GIR_RootConstrainSelectedInstOperands,
     /*  57672 */     // GIR_Coverage, 14979,
     /*  57672 */     GIR_EraseRootFromParent_Done,
     /*  57673 */   // Label 954: @57673
     /*  57673 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(57730), // Rule ID 14975 //
     /*  57678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57709 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57715 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57728 */     GIR_RootConstrainSelectedInstOperands,
     /*  57729 */     // GIR_Coverage, 14975,
     /*  57729 */     GIR_EraseRootFromParent_Done,
     /*  57730 */   // Label 955: @57730
     /*  57730 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(57787), // Rule ID 14978 //
     /*  57735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57766 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57772 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57785 */     GIR_RootConstrainSelectedInstOperands,
     /*  57786 */     // GIR_Coverage, 14978,
     /*  57786 */     GIR_EraseRootFromParent_Done,
     /*  57787 */   // Label 956: @57787
     /*  57787 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(57844), // Rule ID 14974 //
     /*  57792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57823 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57829 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57842 */     GIR_RootConstrainSelectedInstOperands,
     /*  57843 */     // GIR_Coverage, 14974,
     /*  57843 */     GIR_EraseRootFromParent_Done,
     /*  57844 */   // Label 957: @57844
     /*  57844 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(57901), // Rule ID 14977 //
     /*  57849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57880 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57886 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57899 */     GIR_RootConstrainSelectedInstOperands,
     /*  57900 */     // GIR_Coverage, 14977,
     /*  57900 */     GIR_EraseRootFromParent_Done,
     /*  57901 */   // Label 958: @57901
     /*  57901 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(57958), // Rule ID 8354 //
     /*  57906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57937 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57943 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57956 */     GIR_RootConstrainSelectedInstOperands,
     /*  57957 */     // GIR_Coverage, 8354,
     /*  57957 */     GIR_EraseRootFromParent_Done,
     /*  57958 */   // Label 959: @57958
     /*  57958 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(58015), // Rule ID 8355 //
     /*  57963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57994 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58000 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58013 */     GIR_RootConstrainSelectedInstOperands,
     /*  58014 */     // GIR_Coverage, 8355,
     /*  58014 */     GIR_EraseRootFromParent_Done,
     /*  58015 */   // Label 960: @58015
     /*  58015 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(58062), // Rule ID 10612 //
     /*  58020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58031 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  58031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  58038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58043 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58060 */     GIR_RootConstrainSelectedInstOperands,
     /*  58061 */     // GIR_Coverage, 10612,
     /*  58061 */     GIR_EraseRootFromParent_Done,
     /*  58062 */   // Label 961: @58062
     /*  58062 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(58083), // Rule ID 2742 //
     /*  58067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58070 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58081 */     GIR_RootConstrainSelectedInstOperands,
     /*  58082 */     // GIR_Coverage, 2742,
     /*  58082 */     GIR_EraseRootFromParent_Done,
     /*  58083 */   // Label 962: @58083
     /*  58083 */   GIM_Reject,
     /*  58084 */ // Label 952: @58084
     /*  58084 */ GIM_Reject,
     /*  58085 */ // Label 854: @58085
     /*  58085 */ GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(58556),
     /*  58090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  58100 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(58155), // Rule ID 14916 //
     /*  58105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58136 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58142 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58153 */     GIR_RootConstrainSelectedInstOperands,
     /*  58154 */     // GIR_Coverage, 14916,
     /*  58154 */     GIR_EraseRootFromParent_Done,
     /*  58155 */   // Label 964: @58155
     /*  58155 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(58210), // Rule ID 14919 //
     /*  58160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58191 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58197 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58208 */     GIR_RootConstrainSelectedInstOperands,
     /*  58209 */     // GIR_Coverage, 14919,
     /*  58209 */     GIR_EraseRootFromParent_Done,
     /*  58210 */   // Label 965: @58210
     /*  58210 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(58265), // Rule ID 14915 //
     /*  58215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58246 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58252 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58263 */     GIR_RootConstrainSelectedInstOperands,
     /*  58264 */     // GIR_Coverage, 14915,
     /*  58264 */     GIR_EraseRootFromParent_Done,
     /*  58265 */   // Label 966: @58265
     /*  58265 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(58320), // Rule ID 14918 //
     /*  58270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58301 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58307 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58318 */     GIR_RootConstrainSelectedInstOperands,
     /*  58319 */     // GIR_Coverage, 14918,
     /*  58319 */     GIR_EraseRootFromParent_Done,
     /*  58320 */   // Label 967: @58320
     /*  58320 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(58375), // Rule ID 14914 //
     /*  58325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58356 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58362 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58373 */     GIR_RootConstrainSelectedInstOperands,
     /*  58374 */     // GIR_Coverage, 14914,
     /*  58374 */     GIR_EraseRootFromParent_Done,
     /*  58375 */   // Label 968: @58375
     /*  58375 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(58430), // Rule ID 14917 //
     /*  58380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58411 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58417 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58428 */     GIR_RootConstrainSelectedInstOperands,
     /*  58429 */     // GIR_Coverage, 14917,
     /*  58429 */     GIR_EraseRootFromParent_Done,
     /*  58430 */   // Label 969: @58430
     /*  58430 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(58485), // Rule ID 7407 //
     /*  58435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58466 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58472 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58483 */     GIR_RootConstrainSelectedInstOperands,
     /*  58484 */     // GIR_Coverage, 7407,
     /*  58484 */     GIR_EraseRootFromParent_Done,
     /*  58485 */   // Label 970: @58485
     /*  58485 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(58540), // Rule ID 7408 //
     /*  58490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58521 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58527 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58538 */     GIR_RootConstrainSelectedInstOperands,
     /*  58539 */     // GIR_Coverage, 7408,
     /*  58539 */     GIR_EraseRootFromParent_Done,
     /*  58540 */   // Label 971: @58540
     /*  58540 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(58555), // Rule ID 3136 //
     /*  58545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58548 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  58553 */     GIR_RootConstrainSelectedInstOperands,
     /*  58554 */     // GIR_Coverage, 3136,
     /*  58554 */     GIR_Done,
     /*  58555 */   // Label 972: @58555
     /*  58555 */   GIM_Reject,
     /*  58556 */ // Label 963: @58556
     /*  58556 */ GIM_Reject,
     /*  58557 */ // Label 855: @58557
     /*  58557 */ GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(59097),
     /*  58562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58572 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(58629), // Rule ID 14967 //
     /*  58577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58608 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58614 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58627 */     GIR_RootConstrainSelectedInstOperands,
     /*  58628 */     // GIR_Coverage, 14967,
     /*  58628 */     GIR_EraseRootFromParent_Done,
     /*  58629 */   // Label 974: @58629
     /*  58629 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(58686), // Rule ID 14970 //
     /*  58634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58665 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58671 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58684 */     GIR_RootConstrainSelectedInstOperands,
     /*  58685 */     // GIR_Coverage, 14970,
     /*  58685 */     GIR_EraseRootFromParent_Done,
     /*  58686 */   // Label 975: @58686
     /*  58686 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(58743), // Rule ID 14966 //
     /*  58691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58722 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58726 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58728 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58741 */     GIR_RootConstrainSelectedInstOperands,
     /*  58742 */     // GIR_Coverage, 14966,
     /*  58742 */     GIR_EraseRootFromParent_Done,
     /*  58743 */   // Label 976: @58743
     /*  58743 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(58800), // Rule ID 14969 //
     /*  58748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58779 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58785 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58798 */     GIR_RootConstrainSelectedInstOperands,
     /*  58799 */     // GIR_Coverage, 14969,
     /*  58799 */     GIR_EraseRootFromParent_Done,
     /*  58800 */   // Label 977: @58800
     /*  58800 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(58857), // Rule ID 14965 //
     /*  58805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58836 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58842 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58855 */     GIR_RootConstrainSelectedInstOperands,
     /*  58856 */     // GIR_Coverage, 14965,
     /*  58856 */     GIR_EraseRootFromParent_Done,
     /*  58857 */   // Label 978: @58857
     /*  58857 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(58914), // Rule ID 14968 //
     /*  58862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58893 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58899 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58912 */     GIR_RootConstrainSelectedInstOperands,
     /*  58913 */     // GIR_Coverage, 14968,
     /*  58913 */     GIR_EraseRootFromParent_Done,
     /*  58914 */   // Label 979: @58914
     /*  58914 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(58971), // Rule ID 8350 //
     /*  58919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58950 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58956 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58969 */     GIR_RootConstrainSelectedInstOperands,
     /*  58970 */     // GIR_Coverage, 8350,
     /*  58970 */     GIR_EraseRootFromParent_Done,
     /*  58971 */   // Label 980: @58971
     /*  58971 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(59028), // Rule ID 8351 //
     /*  58976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59007 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59013 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59026 */     GIR_RootConstrainSelectedInstOperands,
     /*  59027 */     // GIR_Coverage, 8351,
     /*  59027 */     GIR_EraseRootFromParent_Done,
     /*  59028 */   // Label 981: @59028
     /*  59028 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(59075), // Rule ID 10611 //
     /*  59033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59044 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  59044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  59051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59056 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  59059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59073 */     GIR_RootConstrainSelectedInstOperands,
     /*  59074 */     // GIR_Coverage, 10611,
     /*  59074 */     GIR_EraseRootFromParent_Done,
     /*  59075 */   // Label 982: @59075
     /*  59075 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(59096), // Rule ID 2741 //
     /*  59080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59083 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59094 */     GIR_RootConstrainSelectedInstOperands,
     /*  59095 */     // GIR_Coverage, 2741,
     /*  59095 */     GIR_EraseRootFromParent_Done,
     /*  59096 */   // Label 983: @59096
     /*  59096 */   GIM_Reject,
     /*  59097 */ // Label 973: @59097
     /*  59097 */ GIM_Reject,
     /*  59098 */ // Label 856: @59098
     /*  59098 */ GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(59569),
     /*  59103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59113 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(59168), // Rule ID 14907 //
     /*  59118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59149 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59155 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59166 */     GIR_RootConstrainSelectedInstOperands,
     /*  59167 */     // GIR_Coverage, 14907,
     /*  59167 */     GIR_EraseRootFromParent_Done,
     /*  59168 */   // Label 985: @59168
     /*  59168 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(59223), // Rule ID 14910 //
     /*  59173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59204 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59210 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59221 */     GIR_RootConstrainSelectedInstOperands,
     /*  59222 */     // GIR_Coverage, 14910,
     /*  59222 */     GIR_EraseRootFromParent_Done,
     /*  59223 */   // Label 986: @59223
     /*  59223 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(59278), // Rule ID 14906 //
     /*  59228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59259 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59265 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59276 */     GIR_RootConstrainSelectedInstOperands,
     /*  59277 */     // GIR_Coverage, 14906,
     /*  59277 */     GIR_EraseRootFromParent_Done,
     /*  59278 */   // Label 987: @59278
     /*  59278 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(59333), // Rule ID 14909 //
     /*  59283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59314 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59320 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59331 */     GIR_RootConstrainSelectedInstOperands,
     /*  59332 */     // GIR_Coverage, 14909,
     /*  59332 */     GIR_EraseRootFromParent_Done,
     /*  59333 */   // Label 988: @59333
     /*  59333 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(59388), // Rule ID 14905 //
     /*  59338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59369 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59375 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59386 */     GIR_RootConstrainSelectedInstOperands,
     /*  59387 */     // GIR_Coverage, 14905,
     /*  59387 */     GIR_EraseRootFromParent_Done,
     /*  59388 */   // Label 989: @59388
     /*  59388 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(59443), // Rule ID 14908 //
     /*  59393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59424 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59430 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59441 */     GIR_RootConstrainSelectedInstOperands,
     /*  59442 */     // GIR_Coverage, 14908,
     /*  59442 */     GIR_EraseRootFromParent_Done,
     /*  59443 */   // Label 990: @59443
     /*  59443 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(59498), // Rule ID 7403 //
     /*  59448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59479 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59485 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59496 */     GIR_RootConstrainSelectedInstOperands,
     /*  59497 */     // GIR_Coverage, 7403,
     /*  59497 */     GIR_EraseRootFromParent_Done,
     /*  59498 */   // Label 991: @59498
     /*  59498 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(59553), // Rule ID 7404 //
     /*  59503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59534 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59540 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59551 */     GIR_RootConstrainSelectedInstOperands,
     /*  59552 */     // GIR_Coverage, 7404,
     /*  59552 */     GIR_EraseRootFromParent_Done,
     /*  59553 */   // Label 992: @59553
     /*  59553 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(59568), // Rule ID 3135 //
     /*  59558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59561 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59566 */     GIR_RootConstrainSelectedInstOperands,
     /*  59567 */     // GIR_Coverage, 3135,
     /*  59567 */     GIR_Done,
     /*  59568 */   // Label 993: @59568
     /*  59568 */   GIM_Reject,
     /*  59569 */ // Label 984: @59569
     /*  59569 */ GIM_Reject,
     /*  59570 */ // Label 857: @59570
     /*  59570 */ GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(60110),
     /*  59575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59585 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(59642), // Rule ID 14958 //
     /*  59590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59621 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59627 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59640 */     GIR_RootConstrainSelectedInstOperands,
     /*  59641 */     // GIR_Coverage, 14958,
     /*  59641 */     GIR_EraseRootFromParent_Done,
     /*  59642 */   // Label 995: @59642
     /*  59642 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(59699), // Rule ID 14961 //
     /*  59647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59678 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59684 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59697 */     GIR_RootConstrainSelectedInstOperands,
     /*  59698 */     // GIR_Coverage, 14961,
     /*  59698 */     GIR_EraseRootFromParent_Done,
     /*  59699 */   // Label 996: @59699
     /*  59699 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(59756), // Rule ID 14957 //
     /*  59704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59735 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59741 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59754 */     GIR_RootConstrainSelectedInstOperands,
     /*  59755 */     // GIR_Coverage, 14957,
     /*  59755 */     GIR_EraseRootFromParent_Done,
     /*  59756 */   // Label 997: @59756
     /*  59756 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(59813), // Rule ID 14960 //
     /*  59761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59792 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59798 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59811 */     GIR_RootConstrainSelectedInstOperands,
     /*  59812 */     // GIR_Coverage, 14960,
     /*  59812 */     GIR_EraseRootFromParent_Done,
     /*  59813 */   // Label 998: @59813
     /*  59813 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(59870), // Rule ID 14956 //
     /*  59818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59849 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59855 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59868 */     GIR_RootConstrainSelectedInstOperands,
     /*  59869 */     // GIR_Coverage, 14956,
     /*  59869 */     GIR_EraseRootFromParent_Done,
     /*  59870 */   // Label 999: @59870
     /*  59870 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(59927), // Rule ID 14959 //
     /*  59875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59906 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59912 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59925 */     GIR_RootConstrainSelectedInstOperands,
     /*  59926 */     // GIR_Coverage, 14959,
     /*  59926 */     GIR_EraseRootFromParent_Done,
     /*  59927 */   // Label 1000: @59927
     /*  59927 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(59984), // Rule ID 8346 //
     /*  59932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59963 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59969 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59982 */     GIR_RootConstrainSelectedInstOperands,
     /*  59983 */     // GIR_Coverage, 8346,
     /*  59983 */     GIR_EraseRootFromParent_Done,
     /*  59984 */   // Label 1001: @59984
     /*  59984 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(60041), // Rule ID 8347 //
     /*  59989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60020 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60026 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60039 */     GIR_RootConstrainSelectedInstOperands,
     /*  60040 */     // GIR_Coverage, 8347,
     /*  60040 */     GIR_EraseRootFromParent_Done,
     /*  60041 */   // Label 1002: @60041
     /*  60041 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(60088), // Rule ID 10610 //
     /*  60046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60057 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  60057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  60060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  60064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60069 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  60072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  60084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  60086 */     GIR_RootConstrainSelectedInstOperands,
     /*  60087 */     // GIR_Coverage, 10610,
     /*  60087 */     GIR_EraseRootFromParent_Done,
     /*  60088 */   // Label 1003: @60088
     /*  60088 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(60109), // Rule ID 2740 //
     /*  60093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60096 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  60107 */     GIR_RootConstrainSelectedInstOperands,
     /*  60108 */     // GIR_Coverage, 2740,
     /*  60108 */     GIR_EraseRootFromParent_Done,
     /*  60109 */   // Label 1004: @60109
     /*  60109 */   GIM_Reject,
     /*  60110 */ // Label 994: @60110
     /*  60110 */ GIM_Reject,
     /*  60111 */ // Label 858: @60111
     /*  60111 */ GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(60582),
     /*  60116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  60126 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(60181), // Rule ID 14898 //
     /*  60131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60162 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60168 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60179 */     GIR_RootConstrainSelectedInstOperands,
     /*  60180 */     // GIR_Coverage, 14898,
     /*  60180 */     GIR_EraseRootFromParent_Done,
     /*  60181 */   // Label 1006: @60181
     /*  60181 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(60236), // Rule ID 14901 //
     /*  60186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60217 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60223 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60234 */     GIR_RootConstrainSelectedInstOperands,
     /*  60235 */     // GIR_Coverage, 14901,
     /*  60235 */     GIR_EraseRootFromParent_Done,
     /*  60236 */   // Label 1007: @60236
     /*  60236 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(60291), // Rule ID 14897 //
     /*  60241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60272 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60278 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60289 */     GIR_RootConstrainSelectedInstOperands,
     /*  60290 */     // GIR_Coverage, 14897,
     /*  60290 */     GIR_EraseRootFromParent_Done,
     /*  60291 */   // Label 1008: @60291
     /*  60291 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(60346), // Rule ID 14900 //
     /*  60296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60327 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60333 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60344 */     GIR_RootConstrainSelectedInstOperands,
     /*  60345 */     // GIR_Coverage, 14900,
     /*  60345 */     GIR_EraseRootFromParent_Done,
     /*  60346 */   // Label 1009: @60346
     /*  60346 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(60401), // Rule ID 14896 //
     /*  60351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60382 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60388 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60399 */     GIR_RootConstrainSelectedInstOperands,
     /*  60400 */     // GIR_Coverage, 14896,
     /*  60400 */     GIR_EraseRootFromParent_Done,
     /*  60401 */   // Label 1010: @60401
     /*  60401 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(60456), // Rule ID 14899 //
     /*  60406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60437 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60443 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60454 */     GIR_RootConstrainSelectedInstOperands,
     /*  60455 */     // GIR_Coverage, 14899,
     /*  60455 */     GIR_EraseRootFromParent_Done,
     /*  60456 */   // Label 1011: @60456
     /*  60456 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(60511), // Rule ID 7399 //
     /*  60461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60492 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60498 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60509 */     GIR_RootConstrainSelectedInstOperands,
     /*  60510 */     // GIR_Coverage, 7399,
     /*  60510 */     GIR_EraseRootFromParent_Done,
     /*  60511 */   // Label 1012: @60511
     /*  60511 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(60566), // Rule ID 7400 //
     /*  60516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60547 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60553 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60564 */     GIR_RootConstrainSelectedInstOperands,
     /*  60565 */     // GIR_Coverage, 7400,
     /*  60565 */     GIR_EraseRootFromParent_Done,
     /*  60566 */   // Label 1013: @60566
     /*  60566 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(60581), // Rule ID 3134 //
     /*  60571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60574 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60579 */     GIR_RootConstrainSelectedInstOperands,
     /*  60580 */     // GIR_Coverage, 3134,
     /*  60580 */     GIR_Done,
     /*  60581 */   // Label 1014: @60581
     /*  60581 */   GIM_Reject,
     /*  60582 */ // Label 1005: @60582
     /*  60582 */ GIM_Reject,
     /*  60583 */ // Label 859: @60583
     /*  60583 */ GIM_Reject,
     /*  60584 */ // Label 6: @60584
     /*  60584 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1033*/ GIMT_Encode4(72630),
     /*  60595 */ /*GILLT_s32*//*Label 1015*/ GIMT_Encode4(60683),
     /*  60599 */ /*GILLT_s64*//*Label 1016*/ GIMT_Encode4(61043), GIMT_Encode4(0),
     /*  60607 */ /*GILLT_v2s32*//*Label 1017*/ GIMT_Encode4(63210),
     /*  60611 */ /*GILLT_v2s64*//*Label 1018*/ GIMT_Encode4(64518),
     /*  60615 */ /*GILLT_v4s16*//*Label 1019*/ GIMT_Encode4(65826),
     /*  60619 */ /*GILLT_v4s32*//*Label 1020*/ GIMT_Encode4(67134),
     /*  60623 */ /*GILLT_v8s8*//*Label 1021*/ GIMT_Encode4(68442),
     /*  60627 */ /*GILLT_v8s16*//*Label 1022*/ GIMT_Encode4(69750),
     /*  60631 */ /*GILLT_v16s8*//*Label 1023*/ GIMT_Encode4(71058),
     /*  60635 */ /*GILLT_nxv1s1*//*Label 1024*/ GIMT_Encode4(72366),
     /*  60639 */ /*GILLT_nxv2s1*//*Label 1025*/ GIMT_Encode4(72398), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  60651 */ /*GILLT_nxv2s64*//*Label 1026*/ GIMT_Encode4(72430),
     /*  60655 */ /*GILLT_nxv4s1*//*Label 1027*/ GIMT_Encode4(72456), GIMT_Encode4(0),
     /*  60663 */ /*GILLT_nxv4s32*//*Label 1028*/ GIMT_Encode4(72488),
     /*  60667 */ /*GILLT_nxv8s1*//*Label 1029*/ GIMT_Encode4(72514),
     /*  60671 */ /*GILLT_nxv8s16*//*Label 1030*/ GIMT_Encode4(72546),
     /*  60675 */ /*GILLT_nxv16s1*//*Label 1031*/ GIMT_Encode4(72572),
     /*  60679 */ /*GILLT_nxv16s8*//*Label 1032*/ GIMT_Encode4(72604),
     /*  60683 */ // Label 1015: @60683
     /*  60683 */ GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(61042),
     /*  60688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  60691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60694 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(60749), // Rule ID 13161 //
     /*  60699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60719 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60736 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  60739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60743 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60747 */     GIR_RootConstrainSelectedInstOperands,
     /*  60748 */     // GIR_Coverage, 13161,
     /*  60748 */     GIR_EraseRootFromParent_Done,
     /*  60749 */   // Label 1035: @60749
     /*  60749 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(60804), // Rule ID 174 //
     /*  60754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60778 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60791 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  60794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60798 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60802 */     GIR_RootConstrainSelectedInstOperands,
     /*  60803 */     // GIR_Coverage, 174,
     /*  60803 */     GIR_EraseRootFromParent_Done,
     /*  60804 */   // Label 1036: @60804
     /*  60804 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(60845), // Rule ID 146 //
     /*  60809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  60813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  60825 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  60829 */     // MIs[1] Operand 1
     /*  60829 */     // No operand predicates
     /*  60829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60831 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  60831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  60834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60838 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  60843 */     GIR_RootConstrainSelectedInstOperands,
     /*  60844 */     // GIR_Coverage, 146,
     /*  60844 */     GIR_EraseRootFromParent_Done,
     /*  60845 */   // Label 1037: @60845
     /*  60845 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(60878), // Rule ID 13163 //
     /*  60850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60865 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  60868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60872 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60876 */     GIR_RootConstrainSelectedInstOperands,
     /*  60877 */     // GIR_Coverage, 13163,
     /*  60877 */     GIR_EraseRootFromParent_Done,
     /*  60878 */   // Label 1038: @60878
     /*  60878 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(60911), // Rule ID 178 //
     /*  60883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60898 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  60901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60905 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60909 */     GIR_RootConstrainSelectedInstOperands,
     /*  60910 */     // GIR_Coverage, 178,
     /*  60910 */     GIR_EraseRootFromParent_Done,
     /*  60911 */   // Label 1039: @60911
     /*  60911 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(60964), // Rule ID 13159 //
     /*  60916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60941 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60951 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  60951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  60954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  60962 */     GIR_RootConstrainSelectedInstOperands,
     /*  60963 */     // GIR_Coverage, 13159,
     /*  60963 */     GIR_EraseRootFromParent_Done,
     /*  60964 */   // Label 1040: @60964
     /*  60964 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(61017), // Rule ID 172 //
     /*  60969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60998 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61004 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61015 */     GIR_RootConstrainSelectedInstOperands,
     /*  61016 */     // GIR_Coverage, 172,
     /*  61016 */     GIR_EraseRootFromParent_Done,
     /*  61017 */   // Label 1041: @61017
     /*  61017 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(61041), // Rule ID 176 //
     /*  61022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61034 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  61039 */     GIR_RootConstrainSelectedInstOperands,
     /*  61040 */     // GIR_Coverage, 176,
     /*  61040 */     GIR_Done,
     /*  61041 */   // Label 1042: @61041
     /*  61041 */   GIM_Reject,
     /*  61042 */ // Label 1034: @61042
     /*  61042 */ GIM_Reject,
     /*  61043 */ // Label 1016: @61043
     /*  61043 */ GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(63209),
     /*  61048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  61051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  61054 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(61176), // Rule ID 3998 //
     /*  61059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61100 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61104 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61123 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61127 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61131 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61135 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61139 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61143 */     // MIs[4] Rn
     /*  61143 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61148 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61152 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61163 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61165 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61174 */     GIR_RootConstrainSelectedInstOperands,
     /*  61175 */     // GIR_Coverage, 3998,
     /*  61175 */     GIR_EraseRootFromParent_Done,
     /*  61176 */   // Label 1044: @61176
     /*  61176 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(61298), // Rule ID 13711 //
     /*  61181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61222 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61226 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61245 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61249 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61253 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61257 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61261 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61265 */     // MIs[4] Rn
     /*  61265 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61270 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61274 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61285 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61287 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61296 */     GIR_RootConstrainSelectedInstOperands,
     /*  61297 */     // GIR_Coverage, 13711,
     /*  61297 */     GIR_EraseRootFromParent_Done,
     /*  61298 */   // Label 1045: @61298
     /*  61298 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(61353), // Rule ID 13162 //
     /*  61303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61323 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61340 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61351 */     GIR_RootConstrainSelectedInstOperands,
     /*  61352 */     // GIR_Coverage, 13162,
     /*  61352 */     GIR_EraseRootFromParent_Done,
     /*  61353 */   // Label 1046: @61353
     /*  61353 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(61408), // Rule ID 175 //
     /*  61358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61382 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61395 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61400 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61406 */     GIR_RootConstrainSelectedInstOperands,
     /*  61407 */     // GIR_Coverage, 175,
     /*  61407 */     GIR_EraseRootFromParent_Done,
     /*  61408 */   // Label 1047: @61408
     /*  61408 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(61517), // Rule ID 13511 //
     /*  61413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61461 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61467 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61474 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61478 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61482 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61486 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61491 */     // MIs[4] LHS
     /*  61491 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61496 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61498 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61515 */     GIR_RootConstrainSelectedInstOperands,
     /*  61516 */     // GIR_Coverage, 13511,
     /*  61516 */     GIR_EraseRootFromParent_Done,
     /*  61517 */   // Label 1048: @61517
     /*  61517 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(61626), // Rule ID 13510 //
     /*  61522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61570 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61576 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61583 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61587 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61591 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61595 */     // MIs[4] LHS
     /*  61595 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61600 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61605 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61607 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  61620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61624 */     GIR_RootConstrainSelectedInstOperands,
     /*  61625 */     // GIR_Coverage, 13510,
     /*  61625 */     GIR_EraseRootFromParent_Done,
     /*  61626 */   // Label 1049: @61626
     /*  61626 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(61735), // Rule ID 13513 //
     /*  61631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61684 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61690 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61692 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61696 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61700 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61704 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61709 */     // MIs[4] LHS
     /*  61709 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61714 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61716 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61733 */     GIR_RootConstrainSelectedInstOperands,
     /*  61734 */     // GIR_Coverage, 13513,
     /*  61734 */     GIR_EraseRootFromParent_Done,
     /*  61735 */   // Label 1050: @61735
     /*  61735 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(61844), // Rule ID 13512 //
     /*  61740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61789 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61793 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61799 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61801 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61805 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61809 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61813 */     // MIs[4] LHS
     /*  61813 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61818 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61823 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61825 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  61838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61842 */     GIR_RootConstrainSelectedInstOperands,
     /*  61843 */     // GIR_Coverage, 13512,
     /*  61843 */     GIR_EraseRootFromParent_Done,
     /*  61844 */   // Label 1051: @61844
     /*  61844 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(61953), // Rule ID 2462 //
     /*  61849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61906 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61910 */     // MIs[3] LHS
     /*  61910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  61915 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61919 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61925 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61932 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61934 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  61943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  61947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  61951 */     GIR_RootConstrainSelectedInstOperands,
     /*  61952 */     // GIR_Coverage, 2462,
     /*  61952 */     GIR_EraseRootFromParent_Done,
     /*  61953 */   // Label 1052: @61953
     /*  61953 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62062), // Rule ID 13508 //
     /*  61958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62015 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62019 */     // MIs[3] LHS
     /*  62019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62024 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62028 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62034 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62041 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62043 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62060 */     GIR_RootConstrainSelectedInstOperands,
     /*  62061 */     // GIR_Coverage, 13508,
     /*  62061 */     GIR_EraseRootFromParent_Done,
     /*  62062 */   // Label 1053: @62062
     /*  62062 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62171), // Rule ID 13507 //
     /*  62067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62129 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62133 */     // MIs[3] LHS
     /*  62133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62142 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62148 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62150 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62152 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62169 */     GIR_RootConstrainSelectedInstOperands,
     /*  62170 */     // GIR_Coverage, 13507,
     /*  62170 */     GIR_EraseRootFromParent_Done,
     /*  62171 */   // Label 1054: @62171
     /*  62171 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62280), // Rule ID 13509 //
     /*  62176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62221 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62238 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62242 */     // MIs[3] LHS
     /*  62242 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62247 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62251 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62257 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62259 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62261 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62278 */     GIR_RootConstrainSelectedInstOperands,
     /*  62279 */     // GIR_Coverage, 13509,
     /*  62279 */     GIR_EraseRootFromParent_Done,
     /*  62280 */   // Label 1055: @62280
     /*  62280 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(62321), // Rule ID 147 //
     /*  62285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  62289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62301 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  62305 */     // MIs[1] Operand 1
     /*  62305 */     // No operand predicates
     /*  62305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62307 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  62307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  62310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62314 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  62319 */     GIR_RootConstrainSelectedInstOperands,
     /*  62320 */     // GIR_Coverage, 147,
     /*  62320 */     GIR_EraseRootFromParent_Done,
     /*  62321 */   // Label 1056: @62321
     /*  62321 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(62354), // Rule ID 13164 //
     /*  62326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62341 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62348 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62352 */     GIR_RootConstrainSelectedInstOperands,
     /*  62353 */     // GIR_Coverage, 13164,
     /*  62353 */     GIR_EraseRootFromParent_Done,
     /*  62354 */   // Label 1057: @62354
     /*  62354 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(62387), // Rule ID 179 //
     /*  62359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62374 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62381 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62385 */     GIR_RootConstrainSelectedInstOperands,
     /*  62386 */     // GIR_Coverage, 179,
     /*  62386 */     GIR_EraseRootFromParent_Done,
     /*  62387 */   // Label 1058: @62387
     /*  62387 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(62454), // Rule ID 13447 //
     /*  62392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62416 */     // MIs[1] imm
     /*  62416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62424 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62428 */     // MIs[2] Operand 1
     /*  62428 */     // No operand predicates
     /*  62428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62432 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62438 */     // (or:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62452 */     GIR_RootConstrainSelectedInstOperands,
     /*  62453 */     // GIR_Coverage, 13447,
     /*  62453 */     GIR_EraseRootFromParent_Done,
     /*  62454 */   // Label 1059: @62454
     /*  62454 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(62521), // Rule ID 13835 //
     /*  62459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62483 */     // MIs[1] imm
     /*  62483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62491 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62495 */     // MIs[2] Operand 1
     /*  62495 */     // No operand predicates
     /*  62495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62499 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62505 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  62505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62519 */     GIR_RootConstrainSelectedInstOperands,
     /*  62520 */     // GIR_Coverage, 13835,
     /*  62520 */     GIR_EraseRootFromParent_Done,
     /*  62521 */   // Label 1060: @62521
     /*  62521 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(62588), // Rule ID 13450 //
     /*  62526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62550 */     // MIs[1] imm
     /*  62550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62558 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62562 */     // MIs[2] Operand 1
     /*  62562 */     // No operand predicates
     /*  62562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62572 */     // (or:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62586 */     GIR_RootConstrainSelectedInstOperands,
     /*  62587 */     // GIR_Coverage, 13450,
     /*  62587 */     GIR_EraseRootFromParent_Done,
     /*  62588 */   // Label 1061: @62588
     /*  62588 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(62655), // Rule ID 13838 //
     /*  62593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62617 */     // MIs[1] imm
     /*  62617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62625 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62629 */     // MIs[2] Operand 1
     /*  62629 */     // No operand predicates
     /*  62629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62633 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62639 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  62639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62653 */     GIR_RootConstrainSelectedInstOperands,
     /*  62654 */     // GIR_Coverage, 13838,
     /*  62654 */     GIR_EraseRootFromParent_Done,
     /*  62655 */   // Label 1062: @62655
     /*  62655 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(62708), // Rule ID 13160 //
     /*  62660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62685 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62695 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  62695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  62698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62706 */     GIR_RootConstrainSelectedInstOperands,
     /*  62707 */     // GIR_Coverage, 13160,
     /*  62707 */     GIR_EraseRootFromParent_Done,
     /*  62708 */   // Label 1063: @62708
     /*  62708 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(62775), // Rule ID 2113 //
     /*  62713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62741 */     // MIs[1] imm
     /*  62741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62749 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62753 */     // MIs[2] Operand 1
     /*  62753 */     // No operand predicates
     /*  62753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62759 */     // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62773 */     GIR_RootConstrainSelectedInstOperands,
     /*  62774 */     // GIR_Coverage, 2113,
     /*  62774 */     GIR_EraseRootFromParent_Done,
     /*  62775 */   // Label 1064: @62775
     /*  62775 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(62842), // Rule ID 6243 //
     /*  62780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62808 */     // MIs[1] imm
     /*  62808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62816 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62820 */     // MIs[2] Operand 1
     /*  62820 */     // No operand predicates
     /*  62820 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62826 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  62826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62831 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62840 */     GIR_RootConstrainSelectedInstOperands,
     /*  62841 */     // GIR_Coverage, 6243,
     /*  62841 */     GIR_EraseRootFromParent_Done,
     /*  62842 */   // Label 1065: @62842
     /*  62842 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(62909), // Rule ID 2122 //
     /*  62847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62875 */     // MIs[1] imm
     /*  62875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62883 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62887 */     // MIs[2] Operand 1
     /*  62887 */     // No operand predicates
     /*  62887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62893 */     // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62898 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62907 */     GIR_RootConstrainSelectedInstOperands,
     /*  62908 */     // GIR_Coverage, 2122,
     /*  62908 */     GIR_EraseRootFromParent_Done,
     /*  62909 */   // Label 1066: @62909
     /*  62909 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(62976), // Rule ID 6249 //
     /*  62914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62942 */     // MIs[1] imm
     /*  62942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62950 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62954 */     // MIs[2] Operand 1
     /*  62954 */     // No operand predicates
     /*  62954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62960 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  62960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62974 */     GIR_RootConstrainSelectedInstOperands,
     /*  62975 */     // GIR_Coverage, 6249,
     /*  62975 */     GIR_EraseRootFromParent_Done,
     /*  62976 */   // Label 1067: @62976
     /*  62976 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(63029), // Rule ID 173 //
     /*  62981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63010 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63016 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  63023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63027 */     GIR_RootConstrainSelectedInstOperands,
     /*  63028 */     // GIR_Coverage, 173,
     /*  63028 */     GIR_EraseRootFromParent_Done,
     /*  63029 */   // Label 1068: @63029
     /*  63029 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(63093), // Rule ID 13799 //
     /*  63034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63066 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63072 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63080 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63085 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  63087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63091 */     GIR_RootConstrainSelectedInstOperands,
     /*  63092 */     // GIR_Coverage, 13799,
     /*  63092 */     GIR_EraseRootFromParent_Done,
     /*  63093 */   // Label 1069: @63093
     /*  63093 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(63157), // Rule ID 5032 //
     /*  63098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63134 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63140 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63144 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63149 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  63151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63155 */     GIR_RootConstrainSelectedInstOperands,
     /*  63156 */     // GIR_Coverage, 5032,
     /*  63156 */     GIR_EraseRootFromParent_Done,
     /*  63157 */   // Label 1070: @63157
     /*  63157 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(63181), // Rule ID 177 //
     /*  63162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63174 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  63179 */     GIR_RootConstrainSelectedInstOperands,
     /*  63180 */     // GIR_Coverage, 177,
     /*  63180 */     GIR_Done,
     /*  63181 */   // Label 1071: @63181
     /*  63181 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(63208), // Rule ID 5038 //
     /*  63186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63201 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  63206 */     GIR_RootConstrainSelectedInstOperands,
     /*  63207 */     // GIR_Coverage, 5038,
     /*  63207 */     GIR_Done,
     /*  63208 */   // Label 1072: @63208
     /*  63208 */   GIM_Reject,
     /*  63209 */ // Label 1043: @63209
     /*  63209 */ GIM_Reject,
     /*  63210 */ // Label 1017: @63210
     /*  63210 */ GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(64517),
     /*  63215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63221 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(63330), // Rule ID 13504 //
     /*  63226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63274 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63291 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63295 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63299 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63304 */     // MIs[4] LHS
     /*  63304 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63309 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63311 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63328 */     GIR_RootConstrainSelectedInstOperands,
     /*  63329 */     // GIR_Coverage, 13504,
     /*  63329 */     GIR_EraseRootFromParent_Done,
     /*  63330 */   // Label 1074: @63330
     /*  63330 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(63439), // Rule ID 13503 //
     /*  63335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63383 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63396 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63400 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63404 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63408 */     // MIs[4] LHS
     /*  63408 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63413 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63418 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63420 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63437 */     GIR_RootConstrainSelectedInstOperands,
     /*  63438 */     // GIR_Coverage, 13503,
     /*  63438 */     GIR_EraseRootFromParent_Done,
     /*  63439 */   // Label 1075: @63439
     /*  63439 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(63548), // Rule ID 13506 //
     /*  63444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63497 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63503 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63505 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63509 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63513 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63517 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63522 */     // MIs[4] LHS
     /*  63522 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63527 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63529 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63546 */     GIR_RootConstrainSelectedInstOperands,
     /*  63547 */     // GIR_Coverage, 13506,
     /*  63547 */     GIR_EraseRootFromParent_Done,
     /*  63548 */   // Label 1076: @63548
     /*  63548 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(63657), // Rule ID 13505 //
     /*  63553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63606 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63612 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63614 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63618 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63622 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63626 */     // MIs[4] LHS
     /*  63626 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63631 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63638 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63655 */     GIR_RootConstrainSelectedInstOperands,
     /*  63656 */     // GIR_Coverage, 13505,
     /*  63656 */     GIR_EraseRootFromParent_Done,
     /*  63657 */   // Label 1077: @63657
     /*  63657 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(63766), // Rule ID 2461 //
     /*  63662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63719 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63723 */     // MIs[3] LHS
     /*  63723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63732 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63738 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63745 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63747 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63764 */     GIR_RootConstrainSelectedInstOperands,
     /*  63765 */     // GIR_Coverage, 2461,
     /*  63765 */     GIR_EraseRootFromParent_Done,
     /*  63766 */   // Label 1078: @63766
     /*  63766 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(63875), // Rule ID 13501 //
     /*  63771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63828 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63832 */     // MIs[3] LHS
     /*  63832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63837 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63841 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63847 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63854 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63856 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63873 */     GIR_RootConstrainSelectedInstOperands,
     /*  63874 */     // GIR_Coverage, 13501,
     /*  63874 */     GIR_EraseRootFromParent_Done,
     /*  63875 */   // Label 1079: @63875
     /*  63875 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(63984), // Rule ID 13500 //
     /*  63880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63942 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63946 */     // MIs[3] LHS
     /*  63946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63951 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63955 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63963 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63965 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63982 */     GIR_RootConstrainSelectedInstOperands,
     /*  63983 */     // GIR_Coverage, 13500,
     /*  63983 */     GIR_EraseRootFromParent_Done,
     /*  63984 */   // Label 1080: @63984
     /*  63984 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64093), // Rule ID 13502 //
     /*  63989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64051 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64055 */     // MIs[3] LHS
     /*  64055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64060 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64064 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64072 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64074 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64091 */     GIR_RootConstrainSelectedInstOperands,
     /*  64092 */     // GIR_Coverage, 13502,
     /*  64092 */     GIR_EraseRootFromParent_Done,
     /*  64093 */   // Label 1081: @64093
     /*  64093 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64160), // Rule ID 13467 //
     /*  64098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64122 */     // MIs[1] imm
     /*  64122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64134 */     // MIs[2] Operand 1
     /*  64134 */     // No operand predicates
     /*  64134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64144 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64158 */     GIR_RootConstrainSelectedInstOperands,
     /*  64159 */     // GIR_Coverage, 13467,
     /*  64159 */     GIR_EraseRootFromParent_Done,
     /*  64160 */   // Label 1082: @64160
     /*  64160 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(64227), // Rule ID 13488 //
     /*  64165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64189 */     // MIs[1] imm
     /*  64189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64197 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64201 */     // MIs[2] Operand 1
     /*  64201 */     // No operand predicates
     /*  64201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64211 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64225 */     GIR_RootConstrainSelectedInstOperands,
     /*  64226 */     // GIR_Coverage, 13488,
     /*  64226 */     GIR_EraseRootFromParent_Done,
     /*  64227 */   // Label 1083: @64227
     /*  64227 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(64294), // Rule ID 2230 //
     /*  64232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64260 */     // MIs[1] imm
     /*  64260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64268 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64272 */     // MIs[2] Operand 1
     /*  64272 */     // No operand predicates
     /*  64272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64278 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64292 */     GIR_RootConstrainSelectedInstOperands,
     /*  64293 */     // GIR_Coverage, 2230,
     /*  64293 */     GIR_EraseRootFromParent_Done,
     /*  64294 */   // Label 1084: @64294
     /*  64294 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(64361), // Rule ID 2289 //
     /*  64299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64327 */     // MIs[1] imm
     /*  64327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64335 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64339 */     // MIs[2] Operand 1
     /*  64339 */     // No operand predicates
     /*  64339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64345 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64359 */     GIR_RootConstrainSelectedInstOperands,
     /*  64360 */     // GIR_Coverage, 2289,
     /*  64360 */     GIR_EraseRootFromParent_Done,
     /*  64361 */   // Label 1085: @64361
     /*  64361 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(64425), // Rule ID 13798 //
     /*  64366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64398 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64412 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64417 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64423 */     GIR_RootConstrainSelectedInstOperands,
     /*  64424 */     // GIR_Coverage, 13798,
     /*  64424 */     GIR_EraseRootFromParent_Done,
     /*  64425 */   // Label 1086: @64425
     /*  64425 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(64489), // Rule ID 5031 //
     /*  64430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64466 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64472 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64476 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64481 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64487 */     GIR_RootConstrainSelectedInstOperands,
     /*  64488 */     // GIR_Coverage, 5031,
     /*  64488 */     GIR_EraseRootFromParent_Done,
     /*  64489 */   // Label 1087: @64489
     /*  64489 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(64516), // Rule ID 5037 //
     /*  64494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64509 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64514 */     GIR_RootConstrainSelectedInstOperands,
     /*  64515 */     // GIR_Coverage, 5037,
     /*  64515 */     GIR_Done,
     /*  64516 */   // Label 1088: @64516
     /*  64516 */   GIM_Reject,
     /*  64517 */ // Label 1073: @64517
     /*  64517 */ GIM_Reject,
     /*  64518 */ // Label 1018: @64518
     /*  64518 */ GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(65825),
     /*  64523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64529 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(64638), // Rule ID 13532 //
     /*  64534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64582 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64595 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64599 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64603 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64607 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64612 */     // MIs[4] LHS
     /*  64612 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64617 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64619 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64636 */     GIR_RootConstrainSelectedInstOperands,
     /*  64637 */     // GIR_Coverage, 13532,
     /*  64637 */     GIR_EraseRootFromParent_Done,
     /*  64638 */   // Label 1090: @64638
     /*  64638 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(64747), // Rule ID 13531 //
     /*  64643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64691 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64712 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64716 */     // MIs[4] LHS
     /*  64716 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64721 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64726 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64728 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64745 */     GIR_RootConstrainSelectedInstOperands,
     /*  64746 */     // GIR_Coverage, 13531,
     /*  64746 */     GIR_EraseRootFromParent_Done,
     /*  64747 */   // Label 1091: @64747
     /*  64747 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(64856), // Rule ID 13534 //
     /*  64752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64805 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64811 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64813 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64817 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64821 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64825 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64830 */     // MIs[4] LHS
     /*  64830 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64835 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64837 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64854 */     GIR_RootConstrainSelectedInstOperands,
     /*  64855 */     // GIR_Coverage, 13534,
     /*  64855 */     GIR_EraseRootFromParent_Done,
     /*  64856 */   // Label 1092: @64856
     /*  64856 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(64965), // Rule ID 13533 //
     /*  64861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64914 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64920 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64922 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64926 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64930 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64934 */     // MIs[4] LHS
     /*  64934 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64939 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64944 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64946 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64963 */     GIR_RootConstrainSelectedInstOperands,
     /*  64964 */     // GIR_Coverage, 13533,
     /*  64964 */     GIR_EraseRootFromParent_Done,
     /*  64965 */   // Label 1093: @64965
     /*  64965 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65074), // Rule ID 2465 //
     /*  64970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65027 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65031 */     // MIs[3] LHS
     /*  65031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65036 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65040 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65046 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65055 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65072 */     GIR_RootConstrainSelectedInstOperands,
     /*  65073 */     // GIR_Coverage, 2465,
     /*  65073 */     GIR_EraseRootFromParent_Done,
     /*  65074 */   // Label 1094: @65074
     /*  65074 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(65183), // Rule ID 13529 //
     /*  65079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65136 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65140 */     // MIs[3] LHS
     /*  65140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65145 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65149 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65155 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65162 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65164 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65181 */     GIR_RootConstrainSelectedInstOperands,
     /*  65182 */     // GIR_Coverage, 13529,
     /*  65182 */     GIR_EraseRootFromParent_Done,
     /*  65183 */   // Label 1095: @65183
     /*  65183 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(65292), // Rule ID 13528 //
     /*  65188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65250 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65254 */     // MIs[3] LHS
     /*  65254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65259 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65263 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65271 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65273 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65290 */     GIR_RootConstrainSelectedInstOperands,
     /*  65291 */     // GIR_Coverage, 13528,
     /*  65291 */     GIR_EraseRootFromParent_Done,
     /*  65292 */   // Label 1096: @65292
     /*  65292 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(65401), // Rule ID 13530 //
     /*  65297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65359 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65363 */     // MIs[3] LHS
     /*  65363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65372 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65378 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65380 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65382 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65399 */     GIR_RootConstrainSelectedInstOperands,
     /*  65400 */     // GIR_Coverage, 13530,
     /*  65400 */     GIR_EraseRootFromParent_Done,
     /*  65401 */   // Label 1097: @65401
     /*  65401 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(65468), // Rule ID 13471 //
     /*  65406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65430 */     // MIs[1] imm
     /*  65430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65438 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65442 */     // MIs[2] Operand 1
     /*  65442 */     // No operand predicates
     /*  65442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65452 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65466 */     GIR_RootConstrainSelectedInstOperands,
     /*  65467 */     // GIR_Coverage, 13471,
     /*  65467 */     GIR_EraseRootFromParent_Done,
     /*  65468 */   // Label 1098: @65468
     /*  65468 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(65535), // Rule ID 13492 //
     /*  65473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65497 */     // MIs[1] imm
     /*  65497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65505 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65509 */     // MIs[2] Operand 1
     /*  65509 */     // No operand predicates
     /*  65509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65519 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65533 */     GIR_RootConstrainSelectedInstOperands,
     /*  65534 */     // GIR_Coverage, 13492,
     /*  65534 */     GIR_EraseRootFromParent_Done,
     /*  65535 */   // Label 1099: @65535
     /*  65535 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(65602), // Rule ID 2234 //
     /*  65540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65568 */     // MIs[1] imm
     /*  65568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65580 */     // MIs[2] Operand 1
     /*  65580 */     // No operand predicates
     /*  65580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65586 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65600 */     GIR_RootConstrainSelectedInstOperands,
     /*  65601 */     // GIR_Coverage, 2234,
     /*  65601 */     GIR_EraseRootFromParent_Done,
     /*  65602 */   // Label 1100: @65602
     /*  65602 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(65669), // Rule ID 2293 //
     /*  65607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65635 */     // MIs[1] imm
     /*  65635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65643 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65647 */     // MIs[2] Operand 1
     /*  65647 */     // No operand predicates
     /*  65647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65653 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65667 */     GIR_RootConstrainSelectedInstOperands,
     /*  65668 */     // GIR_Coverage, 2293,
     /*  65668 */     GIR_EraseRootFromParent_Done,
     /*  65669 */   // Label 1101: @65669
     /*  65669 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(65733), // Rule ID 13802 //
     /*  65674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65706 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65712 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65720 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65725 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65731 */     GIR_RootConstrainSelectedInstOperands,
     /*  65732 */     // GIR_Coverage, 13802,
     /*  65732 */     GIR_EraseRootFromParent_Done,
     /*  65733 */   // Label 1102: @65733
     /*  65733 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(65797), // Rule ID 5035 //
     /*  65738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65774 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65784 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65789 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  65791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65795 */     GIR_RootConstrainSelectedInstOperands,
     /*  65796 */     // GIR_Coverage, 5035,
     /*  65796 */     GIR_EraseRootFromParent_Done,
     /*  65797 */   // Label 1103: @65797
     /*  65797 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(65824), // Rule ID 5041 //
     /*  65802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65817 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  65822 */     GIR_RootConstrainSelectedInstOperands,
     /*  65823 */     // GIR_Coverage, 5041,
     /*  65823 */     GIR_Done,
     /*  65824 */   // Label 1104: @65824
     /*  65824 */   GIM_Reject,
     /*  65825 */ // Label 1089: @65825
     /*  65825 */ GIM_Reject,
     /*  65826 */ // Label 1019: @65826
     /*  65826 */ GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(67133),
     /*  65831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65837 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(65946), // Rule ID 13497 //
     /*  65842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65890 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65896 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65903 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65907 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65911 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65915 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65920 */     // MIs[4] LHS
     /*  65920 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65925 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65927 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65944 */     GIR_RootConstrainSelectedInstOperands,
     /*  65945 */     // GIR_Coverage, 13497,
     /*  65945 */     GIR_EraseRootFromParent_Done,
     /*  65946 */   // Label 1106: @65946
     /*  65946 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(66055), // Rule ID 13496 //
     /*  65951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65999 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66012 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66016 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66020 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66024 */     // MIs[4] LHS
     /*  66024 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66029 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66034 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66036 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66053 */     GIR_RootConstrainSelectedInstOperands,
     /*  66054 */     // GIR_Coverage, 13496,
     /*  66054 */     GIR_EraseRootFromParent_Done,
     /*  66055 */   // Label 1107: @66055
     /*  66055 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(66164), // Rule ID 13499 //
     /*  66060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66129 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66133 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66138 */     // MIs[4] LHS
     /*  66138 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66143 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66145 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66162 */     GIR_RootConstrainSelectedInstOperands,
     /*  66163 */     // GIR_Coverage, 13499,
     /*  66163 */     GIR_EraseRootFromParent_Done,
     /*  66164 */   // Label 1108: @66164
     /*  66164 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(66273), // Rule ID 13498 //
     /*  66169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66222 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66230 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66234 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66238 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66242 */     // MIs[4] LHS
     /*  66242 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66247 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66252 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66254 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66271 */     GIR_RootConstrainSelectedInstOperands,
     /*  66272 */     // GIR_Coverage, 13498,
     /*  66272 */     GIR_EraseRootFromParent_Done,
     /*  66273 */   // Label 1109: @66273
     /*  66273 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(66382), // Rule ID 2460 //
     /*  66278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66335 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66339 */     // MIs[3] LHS
     /*  66339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66344 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66348 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66354 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66361 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66363 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66380 */     GIR_RootConstrainSelectedInstOperands,
     /*  66381 */     // GIR_Coverage, 2460,
     /*  66381 */     GIR_EraseRootFromParent_Done,
     /*  66382 */   // Label 1110: @66382
     /*  66382 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(66491), // Rule ID 13494 //
     /*  66387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66444 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66448 */     // MIs[3] LHS
     /*  66448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66453 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66457 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66463 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66470 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66472 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66489 */     GIR_RootConstrainSelectedInstOperands,
     /*  66490 */     // GIR_Coverage, 13494,
     /*  66490 */     GIR_EraseRootFromParent_Done,
     /*  66491 */   // Label 1111: @66491
     /*  66491 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(66600), // Rule ID 13493 //
     /*  66496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66558 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66562 */     // MIs[3] LHS
     /*  66562 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66567 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66571 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66577 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66579 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66581 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66598 */     GIR_RootConstrainSelectedInstOperands,
     /*  66599 */     // GIR_Coverage, 13493,
     /*  66599 */     GIR_EraseRootFromParent_Done,
     /*  66600 */   // Label 1112: @66600
     /*  66600 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(66709), // Rule ID 13495 //
     /*  66605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66667 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66671 */     // MIs[3] LHS
     /*  66671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66680 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66686 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66688 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66690 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66707 */     GIR_RootConstrainSelectedInstOperands,
     /*  66708 */     // GIR_Coverage, 13495,
     /*  66708 */     GIR_EraseRootFromParent_Done,
     /*  66709 */   // Label 1113: @66709
     /*  66709 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(66776), // Rule ID 13463 //
     /*  66714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66738 */     // MIs[1] imm
     /*  66738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66746 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66750 */     // MIs[2] Operand 1
     /*  66750 */     // No operand predicates
     /*  66750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66754 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66760 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66774 */     GIR_RootConstrainSelectedInstOperands,
     /*  66775 */     // GIR_Coverage, 13463,
     /*  66775 */     GIR_EraseRootFromParent_Done,
     /*  66776 */   // Label 1114: @66776
     /*  66776 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(66843), // Rule ID 13484 //
     /*  66781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66805 */     // MIs[1] imm
     /*  66805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66813 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66817 */     // MIs[2] Operand 1
     /*  66817 */     // No operand predicates
     /*  66817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66827 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  66830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66841 */     GIR_RootConstrainSelectedInstOperands,
     /*  66842 */     // GIR_Coverage, 13484,
     /*  66842 */     GIR_EraseRootFromParent_Done,
     /*  66843 */   // Label 1115: @66843
     /*  66843 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(66910), // Rule ID 2226 //
     /*  66848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66876 */     // MIs[1] imm
     /*  66876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66884 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66888 */     // MIs[2] Operand 1
     /*  66888 */     // No operand predicates
     /*  66888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66894 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66908 */     GIR_RootConstrainSelectedInstOperands,
     /*  66909 */     // GIR_Coverage, 2226,
     /*  66909 */     GIR_EraseRootFromParent_Done,
     /*  66910 */   // Label 1116: @66910
     /*  66910 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(66977), // Rule ID 2285 //
     /*  66915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66943 */     // MIs[1] imm
     /*  66943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66951 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66955 */     // MIs[2] Operand 1
     /*  66955 */     // No operand predicates
     /*  66955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66961 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  66964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66975 */     GIR_RootConstrainSelectedInstOperands,
     /*  66976 */     // GIR_Coverage, 2285,
     /*  66976 */     GIR_EraseRootFromParent_Done,
     /*  66977 */   // Label 1117: @66977
     /*  66977 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67041), // Rule ID 13797 //
     /*  66982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67014 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67020 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67028 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67033 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67039 */     GIR_RootConstrainSelectedInstOperands,
     /*  67040 */     // GIR_Coverage, 13797,
     /*  67040 */     GIR_EraseRootFromParent_Done,
     /*  67041 */   // Label 1118: @67041
     /*  67041 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67105), // Rule ID 5030 //
     /*  67046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67082 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67092 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67097 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67103 */     GIR_RootConstrainSelectedInstOperands,
     /*  67104 */     // GIR_Coverage, 5030,
     /*  67104 */     GIR_EraseRootFromParent_Done,
     /*  67105 */   // Label 1119: @67105
     /*  67105 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(67132), // Rule ID 5036 //
     /*  67110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67125 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  67130 */     GIR_RootConstrainSelectedInstOperands,
     /*  67131 */     // GIR_Coverage, 5036,
     /*  67131 */     GIR_Done,
     /*  67132 */   // Label 1120: @67132
     /*  67132 */   GIM_Reject,
     /*  67133 */ // Label 1105: @67133
     /*  67133 */ GIM_Reject,
     /*  67134 */ // Label 1020: @67134
     /*  67134 */ GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(68441),
     /*  67139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67145 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(67254), // Rule ID 13525 //
     /*  67150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67198 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67211 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67215 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67219 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67223 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67228 */     // MIs[4] LHS
     /*  67228 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67233 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67235 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67252 */     GIR_RootConstrainSelectedInstOperands,
     /*  67253 */     // GIR_Coverage, 13525,
     /*  67253 */     GIR_EraseRootFromParent_Done,
     /*  67254 */   // Label 1122: @67254
     /*  67254 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(67363), // Rule ID 13524 //
     /*  67259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67307 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67313 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67324 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67328 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67332 */     // MIs[4] LHS
     /*  67332 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67337 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67342 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67344 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67361 */     GIR_RootConstrainSelectedInstOperands,
     /*  67362 */     // GIR_Coverage, 13524,
     /*  67362 */     GIR_EraseRootFromParent_Done,
     /*  67363 */   // Label 1123: @67363
     /*  67363 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(67472), // Rule ID 13527 //
     /*  67368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67421 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67427 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67429 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67433 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67437 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67441 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67446 */     // MIs[4] LHS
     /*  67446 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67451 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67453 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67470 */     GIR_RootConstrainSelectedInstOperands,
     /*  67471 */     // GIR_Coverage, 13527,
     /*  67471 */     GIR_EraseRootFromParent_Done,
     /*  67472 */   // Label 1124: @67472
     /*  67472 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(67581), // Rule ID 13526 //
     /*  67477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67530 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67538 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67542 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67546 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67550 */     // MIs[4] LHS
     /*  67550 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67555 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67560 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67562 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67579 */     GIR_RootConstrainSelectedInstOperands,
     /*  67580 */     // GIR_Coverage, 13526,
     /*  67580 */     GIR_EraseRootFromParent_Done,
     /*  67581 */   // Label 1125: @67581
     /*  67581 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(67690), // Rule ID 2464 //
     /*  67586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67643 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67647 */     // MIs[3] LHS
     /*  67647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67652 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67656 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67662 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67669 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67671 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67688 */     GIR_RootConstrainSelectedInstOperands,
     /*  67689 */     // GIR_Coverage, 2464,
     /*  67689 */     GIR_EraseRootFromParent_Done,
     /*  67690 */   // Label 1126: @67690
     /*  67690 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(67799), // Rule ID 13522 //
     /*  67695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67752 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67756 */     // MIs[3] LHS
     /*  67756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67765 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67771 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67778 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67780 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67797 */     GIR_RootConstrainSelectedInstOperands,
     /*  67798 */     // GIR_Coverage, 13522,
     /*  67798 */     GIR_EraseRootFromParent_Done,
     /*  67799 */   // Label 1127: @67799
     /*  67799 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(67908), // Rule ID 13521 //
     /*  67804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67866 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67870 */     // MIs[3] LHS
     /*  67870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67875 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67879 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67887 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67889 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67906 */     GIR_RootConstrainSelectedInstOperands,
     /*  67907 */     // GIR_Coverage, 13521,
     /*  67907 */     GIR_EraseRootFromParent_Done,
     /*  67908 */   // Label 1128: @67908
     /*  67908 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68017), // Rule ID 13523 //
     /*  67913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67975 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67979 */     // MIs[3] LHS
     /*  67979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67988 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67996 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67998 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68015 */     GIR_RootConstrainSelectedInstOperands,
     /*  68016 */     // GIR_Coverage, 13523,
     /*  68016 */     GIR_EraseRootFromParent_Done,
     /*  68017 */   // Label 1129: @68017
     /*  68017 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68084), // Rule ID 13469 //
     /*  68022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68046 */     // MIs[1] imm
     /*  68046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68054 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68058 */     // MIs[2] Operand 1
     /*  68058 */     // No operand predicates
     /*  68058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68068 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68082 */     GIR_RootConstrainSelectedInstOperands,
     /*  68083 */     // GIR_Coverage, 13469,
     /*  68083 */     GIR_EraseRootFromParent_Done,
     /*  68084 */   // Label 1130: @68084
     /*  68084 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(68151), // Rule ID 13490 //
     /*  68089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68113 */     // MIs[1] imm
     /*  68113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68121 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68125 */     // MIs[2] Operand 1
     /*  68125 */     // No operand predicates
     /*  68125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68135 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68149 */     GIR_RootConstrainSelectedInstOperands,
     /*  68150 */     // GIR_Coverage, 13490,
     /*  68150 */     GIR_EraseRootFromParent_Done,
     /*  68151 */   // Label 1131: @68151
     /*  68151 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(68218), // Rule ID 2232 //
     /*  68156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68184 */     // MIs[1] imm
     /*  68184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68192 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68196 */     // MIs[2] Operand 1
     /*  68196 */     // No operand predicates
     /*  68196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68202 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68216 */     GIR_RootConstrainSelectedInstOperands,
     /*  68217 */     // GIR_Coverage, 2232,
     /*  68217 */     GIR_EraseRootFromParent_Done,
     /*  68218 */   // Label 1132: @68218
     /*  68218 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(68285), // Rule ID 2291 //
     /*  68223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68251 */     // MIs[1] imm
     /*  68251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68259 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68263 */     // MIs[2] Operand 1
     /*  68263 */     // No operand predicates
     /*  68263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68269 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68283 */     GIR_RootConstrainSelectedInstOperands,
     /*  68284 */     // GIR_Coverage, 2291,
     /*  68284 */     GIR_EraseRootFromParent_Done,
     /*  68285 */   // Label 1133: @68285
     /*  68285 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(68349), // Rule ID 13801 //
     /*  68290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68322 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68328 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68336 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68341 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68347 */     GIR_RootConstrainSelectedInstOperands,
     /*  68348 */     // GIR_Coverage, 13801,
     /*  68348 */     GIR_EraseRootFromParent_Done,
     /*  68349 */   // Label 1134: @68349
     /*  68349 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(68413), // Rule ID 5034 //
     /*  68354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68390 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68396 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68400 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68405 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68411 */     GIR_RootConstrainSelectedInstOperands,
     /*  68412 */     // GIR_Coverage, 5034,
     /*  68412 */     GIR_EraseRootFromParent_Done,
     /*  68413 */   // Label 1135: @68413
     /*  68413 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(68440), // Rule ID 5040 //
     /*  68418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68433 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  68438 */     GIR_RootConstrainSelectedInstOperands,
     /*  68439 */     // GIR_Coverage, 5040,
     /*  68439 */     GIR_Done,
     /*  68440 */   // Label 1136: @68440
     /*  68440 */   GIM_Reject,
     /*  68441 */ // Label 1121: @68441
     /*  68441 */ GIM_Reject,
     /*  68442 */ // Label 1021: @68442
     /*  68442 */ GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(69749),
     /*  68447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68453 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(68562), // Rule ID 13285 //
     /*  68458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68506 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68512 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68519 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68523 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68527 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68531 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68536 */     // MIs[4] Rd
     /*  68536 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68541 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68543 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68560 */     GIR_RootConstrainSelectedInstOperands,
     /*  68561 */     // GIR_Coverage, 13285,
     /*  68561 */     GIR_EraseRootFromParent_Done,
     /*  68562 */   // Label 1138: @68562
     /*  68562 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(68671), // Rule ID 13284 //
     /*  68567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68615 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68621 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68628 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68632 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68636 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68640 */     // MIs[4] Rd
     /*  68640 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68645 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68650 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68652 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68669 */     GIR_RootConstrainSelectedInstOperands,
     /*  68670 */     // GIR_Coverage, 13284,
     /*  68670 */     GIR_EraseRootFromParent_Done,
     /*  68671 */   // Label 1139: @68671
     /*  68671 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(68780), // Rule ID 13287 //
     /*  68676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68729 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68737 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68741 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68745 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68749 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68754 */     // MIs[4] Rd
     /*  68754 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68759 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68761 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68778 */     GIR_RootConstrainSelectedInstOperands,
     /*  68779 */     // GIR_Coverage, 13287,
     /*  68779 */     GIR_EraseRootFromParent_Done,
     /*  68780 */   // Label 1140: @68780
     /*  68780 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(68889), // Rule ID 13286 //
     /*  68785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68838 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68846 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68850 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68854 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68858 */     // MIs[4] Rd
     /*  68858 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68863 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68868 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68870 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68887 */     GIR_RootConstrainSelectedInstOperands,
     /*  68888 */     // GIR_Coverage, 13286,
     /*  68888 */     GIR_EraseRootFromParent_Done,
     /*  68889 */   // Label 1141: @68889
     /*  68889 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(68998), // Rule ID 1598 //
     /*  68894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68951 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68955 */     // MIs[3] Rd
     /*  68955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68960 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68964 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68977 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68979 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68996 */     GIR_RootConstrainSelectedInstOperands,
     /*  68997 */     // GIR_Coverage, 1598,
     /*  68997 */     GIR_EraseRootFromParent_Done,
     /*  68998 */   // Label 1142: @68998
     /*  68998 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69107), // Rule ID 13282 //
     /*  69003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69060 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69064 */     // MIs[3] Rd
     /*  69064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69069 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69073 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69079 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69088 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69105 */     GIR_RootConstrainSelectedInstOperands,
     /*  69106 */     // GIR_Coverage, 13282,
     /*  69106 */     GIR_EraseRootFromParent_Done,
     /*  69107 */   // Label 1143: @69107
     /*  69107 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(69216), // Rule ID 13281 //
     /*  69112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69174 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69178 */     // MIs[3] Rd
     /*  69178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69183 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69187 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69193 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69195 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69197 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69214 */     GIR_RootConstrainSelectedInstOperands,
     /*  69215 */     // GIR_Coverage, 13281,
     /*  69215 */     GIR_EraseRootFromParent_Done,
     /*  69216 */   // Label 1144: @69216
     /*  69216 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(69325), // Rule ID 13283 //
     /*  69221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69283 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69287 */     // MIs[3] Rd
     /*  69287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69292 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69296 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69302 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69304 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69306 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69323 */     GIR_RootConstrainSelectedInstOperands,
     /*  69324 */     // GIR_Coverage, 13283,
     /*  69324 */     GIR_EraseRootFromParent_Done,
     /*  69325 */   // Label 1145: @69325
     /*  69325 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(69392), // Rule ID 13459 //
     /*  69330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69354 */     // MIs[1] imm
     /*  69354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69362 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69366 */     // MIs[2] Operand 1
     /*  69366 */     // No operand predicates
     /*  69366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69370 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69376 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69390 */     GIR_RootConstrainSelectedInstOperands,
     /*  69391 */     // GIR_Coverage, 13459,
     /*  69391 */     GIR_EraseRootFromParent_Done,
     /*  69392 */   // Label 1146: @69392
     /*  69392 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(69459), // Rule ID 13480 //
     /*  69397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69421 */     // MIs[1] imm
     /*  69421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69429 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69433 */     // MIs[2] Operand 1
     /*  69433 */     // No operand predicates
     /*  69433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69443 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69457 */     GIR_RootConstrainSelectedInstOperands,
     /*  69458 */     // GIR_Coverage, 13480,
     /*  69458 */     GIR_EraseRootFromParent_Done,
     /*  69459 */   // Label 1147: @69459
     /*  69459 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(69526), // Rule ID 2222 //
     /*  69464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69492 */     // MIs[1] imm
     /*  69492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69500 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69504 */     // MIs[2] Operand 1
     /*  69504 */     // No operand predicates
     /*  69504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69510 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69524 */     GIR_RootConstrainSelectedInstOperands,
     /*  69525 */     // GIR_Coverage, 2222,
     /*  69525 */     GIR_EraseRootFromParent_Done,
     /*  69526 */   // Label 1148: @69526
     /*  69526 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(69593), // Rule ID 2281 //
     /*  69531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69559 */     // MIs[1] imm
     /*  69559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69567 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69571 */     // MIs[2] Operand 1
     /*  69571 */     // No operand predicates
     /*  69571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69577 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69591 */     GIR_RootConstrainSelectedInstOperands,
     /*  69592 */     // GIR_Coverage, 2281,
     /*  69592 */     GIR_EraseRootFromParent_Done,
     /*  69593 */   // Label 1149: @69593
     /*  69593 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(69657), // Rule ID 13279 //
     /*  69598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69630 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69644 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69655 */     GIR_RootConstrainSelectedInstOperands,
     /*  69656 */     // GIR_Coverage, 13279,
     /*  69656 */     GIR_EraseRootFromParent_Done,
     /*  69657 */   // Label 1150: @69657
     /*  69657 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(69721), // Rule ID 1594 //
     /*  69662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69698 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69704 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69708 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69719 */     GIR_RootConstrainSelectedInstOperands,
     /*  69720 */     // GIR_Coverage, 1594,
     /*  69720 */     GIR_EraseRootFromParent_Done,
     /*  69721 */   // Label 1151: @69721
     /*  69721 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(69748), // Rule ID 1596 //
     /*  69726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69741 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  69746 */     GIR_RootConstrainSelectedInstOperands,
     /*  69747 */     // GIR_Coverage, 1596,
     /*  69747 */     GIR_Done,
     /*  69748 */   // Label 1152: @69748
     /*  69748 */   GIM_Reject,
     /*  69749 */ // Label 1137: @69749
     /*  69749 */ GIM_Reject,
     /*  69750 */ // Label 1022: @69750
     /*  69750 */ GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(71057),
     /*  69755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69761 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(69870), // Rule ID 13518 //
     /*  69766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69814 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69827 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69831 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69835 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69839 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69844 */     // MIs[4] LHS
     /*  69844 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69849 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69851 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  69864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  69868 */     GIR_RootConstrainSelectedInstOperands,
     /*  69869 */     // GIR_Coverage, 13518,
     /*  69869 */     GIR_EraseRootFromParent_Done,
     /*  69870 */   // Label 1154: @69870
     /*  69870 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(69979), // Rule ID 13517 //
     /*  69875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69923 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69929 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69936 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69940 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69944 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69948 */     // MIs[4] LHS
     /*  69948 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69953 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69958 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69960 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  69977 */     GIR_RootConstrainSelectedInstOperands,
     /*  69978 */     // GIR_Coverage, 13517,
     /*  69978 */     GIR_EraseRootFromParent_Done,
     /*  69979 */   // Label 1155: @69979
     /*  69979 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(70088), // Rule ID 13520 //
     /*  69984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70037 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70045 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70049 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70053 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70057 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70062 */     // MIs[4] LHS
     /*  70062 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70067 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70069 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70086 */     GIR_RootConstrainSelectedInstOperands,
     /*  70087 */     // GIR_Coverage, 13520,
     /*  70087 */     GIR_EraseRootFromParent_Done,
     /*  70088 */   // Label 1156: @70088
     /*  70088 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(70197), // Rule ID 13519 //
     /*  70093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70146 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70152 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70154 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70158 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70162 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70166 */     // MIs[4] LHS
     /*  70166 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70171 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70176 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70178 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70195 */     GIR_RootConstrainSelectedInstOperands,
     /*  70196 */     // GIR_Coverage, 13519,
     /*  70196 */     GIR_EraseRootFromParent_Done,
     /*  70197 */   // Label 1157: @70197
     /*  70197 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(70306), // Rule ID 2463 //
     /*  70202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70259 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70263 */     // MIs[3] LHS
     /*  70263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70268 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70272 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70278 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70285 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70287 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70304 */     GIR_RootConstrainSelectedInstOperands,
     /*  70305 */     // GIR_Coverage, 2463,
     /*  70305 */     GIR_EraseRootFromParent_Done,
     /*  70306 */   // Label 1158: @70306
     /*  70306 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(70415), // Rule ID 13515 //
     /*  70311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70368 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70372 */     // MIs[3] LHS
     /*  70372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70377 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70381 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70387 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70394 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70396 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70413 */     GIR_RootConstrainSelectedInstOperands,
     /*  70414 */     // GIR_Coverage, 13515,
     /*  70414 */     GIR_EraseRootFromParent_Done,
     /*  70415 */   // Label 1159: @70415
     /*  70415 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(70524), // Rule ID 13514 //
     /*  70420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70482 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70486 */     // MIs[3] LHS
     /*  70486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70491 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70495 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70501 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70503 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70505 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70522 */     GIR_RootConstrainSelectedInstOperands,
     /*  70523 */     // GIR_Coverage, 13514,
     /*  70523 */     GIR_EraseRootFromParent_Done,
     /*  70524 */   // Label 1160: @70524
     /*  70524 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(70633), // Rule ID 13516 //
     /*  70529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70591 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70595 */     // MIs[3] LHS
     /*  70595 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70604 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70610 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70612 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70614 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70631 */     GIR_RootConstrainSelectedInstOperands,
     /*  70632 */     // GIR_Coverage, 13516,
     /*  70632 */     GIR_EraseRootFromParent_Done,
     /*  70633 */   // Label 1161: @70633
     /*  70633 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(70700), // Rule ID 13465 //
     /*  70638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70662 */     // MIs[1] imm
     /*  70662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70670 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70674 */     // MIs[2] Operand 1
     /*  70674 */     // No operand predicates
     /*  70674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70684 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70698 */     GIR_RootConstrainSelectedInstOperands,
     /*  70699 */     // GIR_Coverage, 13465,
     /*  70699 */     GIR_EraseRootFromParent_Done,
     /*  70700 */   // Label 1162: @70700
     /*  70700 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(70767), // Rule ID 13486 //
     /*  70705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70729 */     // MIs[1] imm
     /*  70729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70737 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70741 */     // MIs[2] Operand 1
     /*  70741 */     // No operand predicates
     /*  70741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70751 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70765 */     GIR_RootConstrainSelectedInstOperands,
     /*  70766 */     // GIR_Coverage, 13486,
     /*  70766 */     GIR_EraseRootFromParent_Done,
     /*  70767 */   // Label 1163: @70767
     /*  70767 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(70834), // Rule ID 2228 //
     /*  70772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70800 */     // MIs[1] imm
     /*  70800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70812 */     // MIs[2] Operand 1
     /*  70812 */     // No operand predicates
     /*  70812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70818 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  70825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70832 */     GIR_RootConstrainSelectedInstOperands,
     /*  70833 */     // GIR_Coverage, 2228,
     /*  70833 */     GIR_EraseRootFromParent_Done,
     /*  70834 */   // Label 1164: @70834
     /*  70834 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(70901), // Rule ID 2287 //
     /*  70839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70867 */     // MIs[1] imm
     /*  70867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70875 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70879 */     // MIs[2] Operand 1
     /*  70879 */     // No operand predicates
     /*  70879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70885 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  70892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70899 */     GIR_RootConstrainSelectedInstOperands,
     /*  70900 */     // GIR_Coverage, 2287,
     /*  70900 */     GIR_EraseRootFromParent_Done,
     /*  70901 */   // Label 1165: @70901
     /*  70901 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(70965), // Rule ID 13800 //
     /*  70906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70938 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70944 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70952 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  70952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70957 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  70959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70963 */     GIR_RootConstrainSelectedInstOperands,
     /*  70964 */     // GIR_Coverage, 13800,
     /*  70964 */     GIR_EraseRootFromParent_Done,
     /*  70965 */   // Label 1166: @70965
     /*  70965 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71029), // Rule ID 5033 //
     /*  70970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71006 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71016 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71021 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  71023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71027 */     GIR_RootConstrainSelectedInstOperands,
     /*  71028 */     // GIR_Coverage, 5033,
     /*  71028 */     GIR_EraseRootFromParent_Done,
     /*  71029 */   // Label 1167: @71029
     /*  71029 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71056), // Rule ID 5039 //
     /*  71034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71049 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  71054 */     GIR_RootConstrainSelectedInstOperands,
     /*  71055 */     // GIR_Coverage, 5039,
     /*  71055 */     GIR_Done,
     /*  71056 */   // Label 1168: @71056
     /*  71056 */   GIM_Reject,
     /*  71057 */ // Label 1153: @71057
     /*  71057 */ GIM_Reject,
     /*  71058 */ // Label 1023: @71058
     /*  71058 */ GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72365),
     /*  71063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71069 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(71178), // Rule ID 13292 //
     /*  71074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71122 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71128 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71135 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71139 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71143 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71147 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71152 */     // MIs[4] Rd
     /*  71152 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71157 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71159 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71176 */     GIR_RootConstrainSelectedInstOperands,
     /*  71177 */     // GIR_Coverage, 13292,
     /*  71177 */     GIR_EraseRootFromParent_Done,
     /*  71178 */   // Label 1170: @71178
     /*  71178 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(71287), // Rule ID 13291 //
     /*  71183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71231 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71237 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71244 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71248 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71252 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71256 */     // MIs[4] Rd
     /*  71256 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71261 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71266 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71268 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71285 */     GIR_RootConstrainSelectedInstOperands,
     /*  71286 */     // GIR_Coverage, 13291,
     /*  71286 */     GIR_EraseRootFromParent_Done,
     /*  71287 */   // Label 1171: @71287
     /*  71287 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(71396), // Rule ID 13294 //
     /*  71292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71345 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71351 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71353 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71357 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71361 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71365 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71370 */     // MIs[4] Rd
     /*  71370 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71375 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71377 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71394 */     GIR_RootConstrainSelectedInstOperands,
     /*  71395 */     // GIR_Coverage, 13294,
     /*  71395 */     GIR_EraseRootFromParent_Done,
     /*  71396 */   // Label 1172: @71396
     /*  71396 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(71505), // Rule ID 13293 //
     /*  71401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71454 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71460 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71462 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71466 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71470 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71474 */     // MIs[4] Rd
     /*  71474 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71479 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71484 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71486 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71503 */     GIR_RootConstrainSelectedInstOperands,
     /*  71504 */     // GIR_Coverage, 13293,
     /*  71504 */     GIR_EraseRootFromParent_Done,
     /*  71505 */   // Label 1173: @71505
     /*  71505 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(71614), // Rule ID 1599 //
     /*  71510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71567 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71571 */     // MIs[3] Rd
     /*  71571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71576 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71580 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71586 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71593 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71595 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71612 */     GIR_RootConstrainSelectedInstOperands,
     /*  71613 */     // GIR_Coverage, 1599,
     /*  71613 */     GIR_EraseRootFromParent_Done,
     /*  71614 */   // Label 1174: @71614
     /*  71614 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(71723), // Rule ID 13289 //
     /*  71619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71676 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71680 */     // MIs[3] Rd
     /*  71680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71685 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71689 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71695 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71702 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71704 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71721 */     GIR_RootConstrainSelectedInstOperands,
     /*  71722 */     // GIR_Coverage, 13289,
     /*  71722 */     GIR_EraseRootFromParent_Done,
     /*  71723 */   // Label 1175: @71723
     /*  71723 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(71832), // Rule ID 13288 //
     /*  71728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71790 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71794 */     // MIs[3] Rd
     /*  71794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71799 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71803 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71809 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71811 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71813 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  71830 */     GIR_RootConstrainSelectedInstOperands,
     /*  71831 */     // GIR_Coverage, 13288,
     /*  71831 */     GIR_EraseRootFromParent_Done,
     /*  71832 */   // Label 1176: @71832
     /*  71832 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(71941), // Rule ID 13290 //
     /*  71837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71899 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71903 */     // MIs[3] Rd
     /*  71903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71912 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71918 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71920 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71922 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  71939 */     GIR_RootConstrainSelectedInstOperands,
     /*  71940 */     // GIR_Coverage, 13290,
     /*  71940 */     GIR_EraseRootFromParent_Done,
     /*  71941 */   // Label 1177: @71941
     /*  71941 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72008), // Rule ID 13461 //
     /*  71946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71970 */     // MIs[1] imm
     /*  71970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71978 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71982 */     // MIs[2] Operand 1
     /*  71982 */     // No operand predicates
     /*  71982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71986 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71992 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  71995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72006 */     GIR_RootConstrainSelectedInstOperands,
     /*  72007 */     // GIR_Coverage, 13461,
     /*  72007 */     GIR_EraseRootFromParent_Done,
     /*  72008 */   // Label 1178: @72008
     /*  72008 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72075), // Rule ID 13482 //
     /*  72013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72037 */     // MIs[1] imm
     /*  72037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72045 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72049 */     // MIs[2] Operand 1
     /*  72049 */     // No operand predicates
     /*  72049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72053 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72059 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72073 */     GIR_RootConstrainSelectedInstOperands,
     /*  72074 */     // GIR_Coverage, 13482,
     /*  72074 */     GIR_EraseRootFromParent_Done,
     /*  72075 */   // Label 1179: @72075
     /*  72075 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(72142), // Rule ID 2224 //
     /*  72080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72108 */     // MIs[1] imm
     /*  72108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72116 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72120 */     // MIs[2] Operand 1
     /*  72120 */     // No operand predicates
     /*  72120 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72126 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72140 */     GIR_RootConstrainSelectedInstOperands,
     /*  72141 */     // GIR_Coverage, 2224,
     /*  72141 */     GIR_EraseRootFromParent_Done,
     /*  72142 */   // Label 1180: @72142
     /*  72142 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(72209), // Rule ID 2283 //
     /*  72147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72175 */     // MIs[1] imm
     /*  72175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72183 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72187 */     // MIs[2] Operand 1
     /*  72187 */     // No operand predicates
     /*  72187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72193 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72207 */     GIR_RootConstrainSelectedInstOperands,
     /*  72208 */     // GIR_Coverage, 2283,
     /*  72208 */     GIR_EraseRootFromParent_Done,
     /*  72209 */   // Label 1181: @72209
     /*  72209 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(72273), // Rule ID 13280 //
     /*  72214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72246 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72252 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72260 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72271 */     GIR_RootConstrainSelectedInstOperands,
     /*  72272 */     // GIR_Coverage, 13280,
     /*  72272 */     GIR_EraseRootFromParent_Done,
     /*  72273 */   // Label 1182: @72273
     /*  72273 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(72337), // Rule ID 1595 //
     /*  72278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72314 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72320 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72324 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72335 */     GIR_RootConstrainSelectedInstOperands,
     /*  72336 */     // GIR_Coverage, 1595,
     /*  72336 */     GIR_EraseRootFromParent_Done,
     /*  72337 */   // Label 1183: @72337
     /*  72337 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(72364), // Rule ID 1597 //
     /*  72342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72357 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  72362 */     GIR_RootConstrainSelectedInstOperands,
     /*  72363 */     // GIR_Coverage, 1597,
     /*  72363 */     GIR_Done,
     /*  72364 */   // Label 1184: @72364
     /*  72364 */   GIM_Reject,
     /*  72365 */ // Label 1169: @72365
     /*  72365 */ GIM_Reject,
     /*  72366 */ // Label 1024: @72366
     /*  72366 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(72397), // Rule ID 8385 //
     /*  72371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  72377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  72380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72384 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  72384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72389 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72391 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72393 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72395 */   GIR_RootConstrainSelectedInstOperands,
     /*  72396 */   // GIR_Coverage, 8385,
     /*  72396 */   GIR_EraseRootFromParent_Done,
     /*  72397 */ // Label 1185: @72397
     /*  72397 */ GIM_Reject,
     /*  72398 */ // Label 1025: @72398
     /*  72398 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(72429), // Rule ID 8384 //
     /*  72403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  72409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  72412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72416 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  72416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72421 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72423 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72425 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72427 */   GIR_RootConstrainSelectedInstOperands,
     /*  72428 */   // GIR_Coverage, 8384,
     /*  72428 */   GIR_EraseRootFromParent_Done,
     /*  72429 */ // Label 1186: @72429
     /*  72429 */ GIM_Reject,
     /*  72430 */ // Label 1026: @72430
     /*  72430 */ GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(72455), // Rule ID 7394 //
     /*  72435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72448 */   // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  72448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72453 */   GIR_RootConstrainSelectedInstOperands,
     /*  72454 */   // GIR_Coverage, 7394,
     /*  72454 */   GIR_Done,
     /*  72455 */ // Label 1187: @72455
     /*  72455 */ GIM_Reject,
     /*  72456 */ // Label 1027: @72456
     /*  72456 */ GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(72487), // Rule ID 8383 //
     /*  72461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  72467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  72470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72474 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  72474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72479 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72481 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72483 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72485 */   GIR_RootConstrainSelectedInstOperands,
     /*  72486 */   // GIR_Coverage, 8383,
     /*  72486 */   GIR_EraseRootFromParent_Done,
     /*  72487 */ // Label 1188: @72487
     /*  72487 */ GIM_Reject,
     /*  72488 */ // Label 1028: @72488
     /*  72488 */ GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(72513), // Rule ID 7393 //
     /*  72493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  72499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  72502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72506 */   // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  72506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72511 */   GIR_RootConstrainSelectedInstOperands,
     /*  72512 */   // GIR_Coverage, 7393,
     /*  72512 */   GIR_Done,
     /*  72513 */ // Label 1189: @72513
     /*  72513 */ GIM_Reject,
     /*  72514 */ // Label 1029: @72514
     /*  72514 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(72545), // Rule ID 8382 //
     /*  72519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  72525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  72528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72532 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  72532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72537 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72539 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72541 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72543 */   GIR_RootConstrainSelectedInstOperands,
     /*  72544 */   // GIR_Coverage, 8382,
     /*  72544 */   GIR_EraseRootFromParent_Done,
     /*  72545 */ // Label 1190: @72545
     /*  72545 */ GIM_Reject,
     /*  72546 */ // Label 1030: @72546
     /*  72546 */ GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(72571), // Rule ID 7392 //
     /*  72551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  72557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  72560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72564 */   // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  72564 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72569 */   GIR_RootConstrainSelectedInstOperands,
     /*  72570 */   // GIR_Coverage, 7392,
     /*  72570 */   GIR_Done,
     /*  72571 */ // Label 1191: @72571
     /*  72571 */ GIM_Reject,
     /*  72572 */ // Label 1031: @72572
     /*  72572 */ GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(72603), // Rule ID 8381 //
     /*  72577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  72583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  72586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72590 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  72590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72595 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72597 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72599 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72601 */   GIR_RootConstrainSelectedInstOperands,
     /*  72602 */   // GIR_Coverage, 8381,
     /*  72602 */   GIR_EraseRootFromParent_Done,
     /*  72603 */ // Label 1192: @72603
     /*  72603 */ GIM_Reject,
     /*  72604 */ // Label 1032: @72604
     /*  72604 */ GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(72629), // Rule ID 7391 //
     /*  72609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  72615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  72618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72622 */   // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  72622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72627 */   GIR_RootConstrainSelectedInstOperands,
     /*  72628 */   // GIR_Coverage, 7391,
     /*  72628 */   GIR_Done,
     /*  72629 */ // Label 1193: @72629
     /*  72629 */ GIM_Reject,
     /*  72630 */ // Label 1033: @72630
     /*  72630 */ GIM_Reject,
     /*  72631 */ // Label 7: @72631
     /*  72631 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1212*/ GIMT_Encode4(78569),
     /*  72642 */ /*GILLT_s32*//*Label 1194*/ GIMT_Encode4(72730),
     /*  72646 */ /*GILLT_s64*//*Label 1195*/ GIMT_Encode4(73410), GIMT_Encode4(0),
     /*  72654 */ /*GILLT_v2s32*//*Label 1196*/ GIMT_Encode4(74153),
     /*  72658 */ /*GILLT_v2s64*//*Label 1197*/ GIMT_Encode4(74221),
     /*  72662 */ /*GILLT_v4s16*//*Label 1198*/ GIMT_Encode4(74747),
     /*  72666 */ /*GILLT_v4s32*//*Label 1199*/ GIMT_Encode4(74815),
     /*  72670 */ /*GILLT_v8s8*//*Label 1200*/ GIMT_Encode4(75341),
     /*  72674 */ /*GILLT_v8s16*//*Label 1201*/ GIMT_Encode4(75412),
     /*  72678 */ /*GILLT_v16s8*//*Label 1202*/ GIMT_Encode4(75938),
     /*  72682 */ /*GILLT_nxv1s1*//*Label 1203*/ GIMT_Encode4(76467),
     /*  72686 */ /*GILLT_nxv2s1*//*Label 1204*/ GIMT_Encode4(76517), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  72698 */ /*GILLT_nxv2s64*//*Label 1205*/ GIMT_Encode4(76567),
     /*  72702 */ /*GILLT_nxv4s1*//*Label 1206*/ GIMT_Encode4(77030), GIMT_Encode4(0),
     /*  72710 */ /*GILLT_nxv4s32*//*Label 1207*/ GIMT_Encode4(77080),
     /*  72714 */ /*GILLT_nxv8s1*//*Label 1208*/ GIMT_Encode4(77543),
     /*  72718 */ /*GILLT_nxv8s16*//*Label 1209*/ GIMT_Encode4(77593),
     /*  72722 */ /*GILLT_nxv16s1*//*Label 1210*/ GIMT_Encode4(78056),
     /*  72726 */ /*GILLT_nxv16s8*//*Label 1211*/ GIMT_Encode4(78106),
     /*  72730 */ // Label 1194: @72730
     /*  72730 */ GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(73409),
     /*  72735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  72738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  72741 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(72799), // Rule ID 13150 //
     /*  72746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72771 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72784 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72797 */     GIR_RootConstrainSelectedInstOperands,
     /*  72798 */     // GIR_Coverage, 13150,
     /*  72798 */     GIR_EraseRootFromParent_Done,
     /*  72799 */   // Label 1214: @72799
     /*  72799 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(72854), // Rule ID 13149 //
     /*  72804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72824 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72841 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72848 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72852 */     GIR_RootConstrainSelectedInstOperands,
     /*  72853 */     // GIR_Coverage, 13149,
     /*  72853 */     GIR_EraseRootFromParent_Done,
     /*  72854 */   // Label 1215: @72854
     /*  72854 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(72912), // Rule ID 13147 //
     /*  72859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72897 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  72906 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72910 */     GIR_RootConstrainSelectedInstOperands,
     /*  72911 */     // GIR_Coverage, 13147,
     /*  72911 */     GIR_EraseRootFromParent_Done,
     /*  72912 */   // Label 1216: @72912
     /*  72912 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(72970), // Rule ID 166 //
     /*  72917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72955 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72968 */     GIR_RootConstrainSelectedInstOperands,
     /*  72969 */     // GIR_Coverage, 166,
     /*  72969 */     GIR_EraseRootFromParent_Done,
     /*  72970 */   // Label 1217: @72970
     /*  72970 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(73028), // Rule ID 13148 //
     /*  72975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73000 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73013 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73026 */     GIR_RootConstrainSelectedInstOperands,
     /*  73027 */     // GIR_Coverage, 13148,
     /*  73027 */     GIR_EraseRootFromParent_Done,
     /*  73028 */   // Label 1218: @73028
     /*  73028 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(73083), // Rule ID 13151 //
     /*  73033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73057 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73070 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73077 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73081 */     GIR_RootConstrainSelectedInstOperands,
     /*  73082 */     // GIR_Coverage, 13151,
     /*  73082 */     GIR_EraseRootFromParent_Done,
     /*  73083 */   // Label 1219: @73083
     /*  73083 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(73124), // Rule ID 144 //
     /*  73088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  73092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73104 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  73108 */     // MIs[1] Operand 1
     /*  73108 */     // No operand predicates
     /*  73108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73110 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  73110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  73113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73117 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  73122 */     GIR_RootConstrainSelectedInstOperands,
     /*  73123 */     // GIR_Coverage, 144,
     /*  73123 */     GIR_EraseRootFromParent_Done,
     /*  73124 */   // Label 1220: @73124
     /*  73124 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(73157), // Rule ID 13157 //
     /*  73129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73144 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  73147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73155 */     GIR_RootConstrainSelectedInstOperands,
     /*  73156 */     // GIR_Coverage, 13157,
     /*  73156 */     GIR_EraseRootFromParent_Done,
     /*  73157 */   // Label 1221: @73157
     /*  73157 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(73190), // Rule ID 170 //
     /*  73162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73177 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  73180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73188 */     GIR_RootConstrainSelectedInstOperands,
     /*  73189 */     // GIR_Coverage, 170,
     /*  73189 */     GIR_EraseRootFromParent_Done,
     /*  73190 */   // Label 1222: @73190
     /*  73190 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(73243), // Rule ID 13143 //
     /*  73195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73220 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73230 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  73241 */     GIR_RootConstrainSelectedInstOperands,
     /*  73242 */     // GIR_Coverage, 13143,
     /*  73242 */     GIR_EraseRootFromParent_Done,
     /*  73243 */   // Label 1223: @73243
     /*  73243 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(73299), // Rule ID 164 //
     /*  73248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73284 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  73297 */     GIR_RootConstrainSelectedInstOperands,
     /*  73298 */     // GIR_Coverage, 164,
     /*  73298 */     GIR_EraseRootFromParent_Done,
     /*  73299 */   // Label 1224: @73299
     /*  73299 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(73352), // Rule ID 13144 //
     /*  73304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73333 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73339 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  73350 */     GIR_RootConstrainSelectedInstOperands,
     /*  73351 */     // GIR_Coverage, 13144,
     /*  73351 */     GIR_EraseRootFromParent_Done,
     /*  73352 */   // Label 1225: @73352
     /*  73352 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(73384), // Rule ID 3983 //
     /*  73357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73369 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  73369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  73372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  73382 */     GIR_RootConstrainSelectedInstOperands,
     /*  73383 */     // GIR_Coverage, 3983,
     /*  73383 */     GIR_EraseRootFromParent_Done,
     /*  73384 */   // Label 1226: @73384
     /*  73384 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(73408), // Rule ID 168 //
     /*  73389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73401 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  73406 */     GIR_RootConstrainSelectedInstOperands,
     /*  73407 */     // GIR_Coverage, 168,
     /*  73407 */     GIR_Done,
     /*  73408 */   // Label 1227: @73408
     /*  73408 */   GIM_Reject,
     /*  73409 */ // Label 1213: @73409
     /*  73409 */ GIM_Reject,
     /*  73410 */ // Label 1195: @73410
     /*  73410 */ GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(74152),
     /*  73415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  73418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  73421 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(73479), // Rule ID 13155 //
     /*  73426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73451 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73464 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73473 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73477 */     GIR_RootConstrainSelectedInstOperands,
     /*  73478 */     // GIR_Coverage, 13155,
     /*  73478 */     GIR_EraseRootFromParent_Done,
     /*  73479 */   // Label 1229: @73479
     /*  73479 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(73534), // Rule ID 13154 //
     /*  73484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73504 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73521 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73528 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73532 */     GIR_RootConstrainSelectedInstOperands,
     /*  73533 */     // GIR_Coverage, 13154,
     /*  73533 */     GIR_EraseRootFromParent_Done,
     /*  73534 */   // Label 1230: @73534
     /*  73534 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(73592), // Rule ID 13152 //
     /*  73539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73577 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73586 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73590 */     GIR_RootConstrainSelectedInstOperands,
     /*  73591 */     // GIR_Coverage, 13152,
     /*  73591 */     GIR_EraseRootFromParent_Done,
     /*  73592 */   // Label 1231: @73592
     /*  73592 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(73650), // Rule ID 167 //
     /*  73597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73635 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73644 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73648 */     GIR_RootConstrainSelectedInstOperands,
     /*  73649 */     // GIR_Coverage, 167,
     /*  73649 */     GIR_EraseRootFromParent_Done,
     /*  73650 */   // Label 1232: @73650
     /*  73650 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(73708), // Rule ID 13153 //
     /*  73655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73680 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73693 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73702 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73706 */     GIR_RootConstrainSelectedInstOperands,
     /*  73707 */     // GIR_Coverage, 13153,
     /*  73707 */     GIR_EraseRootFromParent_Done,
     /*  73708 */   // Label 1233: @73708
     /*  73708 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(73763), // Rule ID 13156 //
     /*  73713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73737 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73750 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73761 */     GIR_RootConstrainSelectedInstOperands,
     /*  73762 */     // GIR_Coverage, 13156,
     /*  73762 */     GIR_EraseRootFromParent_Done,
     /*  73763 */   // Label 1234: @73763
     /*  73763 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(73804), // Rule ID 145 //
     /*  73768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  73772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73784 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  73788 */     // MIs[1] Operand 1
     /*  73788 */     // No operand predicates
     /*  73788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73790 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  73790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  73793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73797 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  73802 */     GIR_RootConstrainSelectedInstOperands,
     /*  73803 */     // GIR_Coverage, 145,
     /*  73803 */     GIR_EraseRootFromParent_Done,
     /*  73804 */   // Label 1235: @73804
     /*  73804 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(73837), // Rule ID 13158 //
     /*  73809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73824 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  73827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73835 */     GIR_RootConstrainSelectedInstOperands,
     /*  73836 */     // GIR_Coverage, 13158,
     /*  73836 */     GIR_EraseRootFromParent_Done,
     /*  73837 */   // Label 1236: @73837
     /*  73837 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(73870), // Rule ID 171 //
     /*  73842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73857 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  73860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73864 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73868 */     GIR_RootConstrainSelectedInstOperands,
     /*  73869 */     // GIR_Coverage, 171,
     /*  73869 */     GIR_EraseRootFromParent_Done,
     /*  73870 */   // Label 1237: @73870
     /*  73870 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(73923), // Rule ID 13145 //
     /*  73875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73900 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73910 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  73910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  73913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  73921 */     GIR_RootConstrainSelectedInstOperands,
     /*  73922 */     // GIR_Coverage, 13145,
     /*  73922 */     GIR_EraseRootFromParent_Done,
     /*  73923 */   // Label 1238: @73923
     /*  73923 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(73979), // Rule ID 165 //
     /*  73928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73964 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  73964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  73967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  73977 */     GIR_RootConstrainSelectedInstOperands,
     /*  73978 */     // GIR_Coverage, 165,
     /*  73978 */     GIR_EraseRootFromParent_Done,
     /*  73979 */   // Label 1239: @73979
     /*  73979 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(74032), // Rule ID 13146 //
     /*  73984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  74004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  74008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74013 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  74017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74019 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  74022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  74028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  74030 */     GIR_RootConstrainSelectedInstOperands,
     /*  74031 */     // GIR_Coverage, 13146,
     /*  74031 */     GIR_EraseRootFromParent_Done,
     /*  74032 */   // Label 1240: @74032
     /*  74032 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(74064), // Rule ID 3984 //
     /*  74037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  74049 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  74049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  74052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  74062 */     GIR_RootConstrainSelectedInstOperands,
     /*  74063 */     // GIR_Coverage, 3984,
     /*  74063 */     GIR_EraseRootFromParent_Done,
     /*  74064 */   // Label 1241: @74064
     /*  74064 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(74100), // Rule ID 4930 //
     /*  74069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74081 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74087 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74091 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  74091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  74094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74098 */     GIR_RootConstrainSelectedInstOperands,
     /*  74099 */     // GIR_Coverage, 4930,
     /*  74099 */     GIR_EraseRootFromParent_Done,
     /*  74100 */   // Label 1242: @74100
     /*  74100 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(74124), // Rule ID 169 //
     /*  74105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74117 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  74122 */     GIR_RootConstrainSelectedInstOperands,
     /*  74123 */     // GIR_Coverage, 169,
     /*  74123 */     GIR_Done,
     /*  74124 */   // Label 1243: @74124
     /*  74124 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(74151), // Rule ID 5026 //
     /*  74129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74144 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  74144 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  74149 */     GIR_RootConstrainSelectedInstOperands,
     /*  74150 */     // GIR_Coverage, 5026,
     /*  74150 */     GIR_Done,
     /*  74151 */   // Label 1244: @74151
     /*  74151 */   GIM_Reject,
     /*  74152 */ // Label 1228: @74152
     /*  74152 */ GIM_Reject,
     /*  74153 */ // Label 1196: @74153
     /*  74153 */ GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(74220),
     /*  74158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  74161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74172 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(74200), // Rule ID 4928 //
     /*  74177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74181 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74187 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74191 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  74191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  74194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74198 */     GIR_RootConstrainSelectedInstOperands,
     /*  74199 */     // GIR_Coverage, 4928,
     /*  74199 */     GIR_EraseRootFromParent_Done,
     /*  74200 */   // Label 1246: @74200
     /*  74200 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(74219), // Rule ID 5025 //
     /*  74205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74212 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  74212 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  74217 */     GIR_RootConstrainSelectedInstOperands,
     /*  74218 */     // GIR_Coverage, 5025,
     /*  74218 */     GIR_Done,
     /*  74219 */   // Label 1247: @74219
     /*  74219 */   GIM_Reject,
     /*  74220 */ // Label 1245: @74220
     /*  74220 */ GIM_Reject,
     /*  74221 */ // Label 1197: @74221
     /*  74221 */ GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(74746),
     /*  74226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74236 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(74321), // Rule ID 13680 //
     /*  74241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74285 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74291 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74304 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74319 */     GIR_RootConstrainSelectedInstOperands,
     /*  74320 */     // GIR_Coverage, 13680,
     /*  74320 */     GIR_EraseRootFromParent_Done,
     /*  74321 */   // Label 1249: @74321
     /*  74321 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(74406), // Rule ID 13679 //
     /*  74326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74375 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74381 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74389 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  74400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74404 */     GIR_RootConstrainSelectedInstOperands,
     /*  74405 */     // GIR_Coverage, 13679,
     /*  74405 */     GIR_EraseRootFromParent_Done,
     /*  74406 */   // Label 1250: @74406
     /*  74406 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(74491), // Rule ID 13678 //
     /*  74411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74459 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74465 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74472 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74474 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  74481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74489 */     GIR_RootConstrainSelectedInstOperands,
     /*  74490 */     // GIR_Coverage, 13678,
     /*  74490 */     GIR_EraseRootFromParent_Done,
     /*  74491 */   // Label 1251: @74491
     /*  74491 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(74576), // Rule ID 3811 //
     /*  74496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74549 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74555 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74559 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  74566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  74570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74574 */     GIR_RootConstrainSelectedInstOperands,
     /*  74575 */     // GIR_Coverage, 3811,
     /*  74575 */     GIR_EraseRootFromParent_Done,
     /*  74576 */   // Label 1252: @74576
     /*  74576 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(74608), // Rule ID 4931 //
     /*  74581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74589 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74595 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74599 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  74599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  74602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74606 */     GIR_RootConstrainSelectedInstOperands,
     /*  74607 */     // GIR_Coverage, 4931,
     /*  74607 */     GIR_EraseRootFromParent_Done,
     /*  74608 */   // Label 1253: @74608
     /*  74608 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(74665), // Rule ID 3807 //
     /*  74613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74648 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  74651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  74657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  74663 */     GIR_RootConstrainSelectedInstOperands,
     /*  74664 */     // GIR_Coverage, 3807,
     /*  74664 */     GIR_EraseRootFromParent_Done,
     /*  74665 */   // Label 1254: @74665
     /*  74665 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(74722), // Rule ID 13668 //
     /*  74670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74705 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  74708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  74714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  74720 */     GIR_RootConstrainSelectedInstOperands,
     /*  74721 */     // GIR_Coverage, 13668,
     /*  74721 */     GIR_EraseRootFromParent_Done,
     /*  74722 */   // Label 1255: @74722
     /*  74722 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(74745), // Rule ID 5029 //
     /*  74727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74738 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  74738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  74743 */     GIR_RootConstrainSelectedInstOperands,
     /*  74744 */     // GIR_Coverage, 5029,
     /*  74744 */     GIR_Done,
     /*  74745 */   // Label 1256: @74745
     /*  74745 */   GIM_Reject,
     /*  74746 */ // Label 1248: @74746
     /*  74746 */ GIM_Reject,
     /*  74747 */ // Label 1198: @74747
     /*  74747 */ GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(74814),
     /*  74752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  74755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  74758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74766 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(74794), // Rule ID 4926 //
     /*  74771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74775 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74781 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74785 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  74785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  74788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74790 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74792 */     GIR_RootConstrainSelectedInstOperands,
     /*  74793 */     // GIR_Coverage, 4926,
     /*  74793 */     GIR_EraseRootFromParent_Done,
     /*  74794 */   // Label 1258: @74794
     /*  74794 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(74813), // Rule ID 5024 //
     /*  74799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74806 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  74806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  74811 */     GIR_RootConstrainSelectedInstOperands,
     /*  74812 */     // GIR_Coverage, 5024,
     /*  74812 */     GIR_Done,
     /*  74813 */   // Label 1259: @74813
     /*  74813 */   GIM_Reject,
     /*  74814 */ // Label 1257: @74814
     /*  74814 */ GIM_Reject,
     /*  74815 */ // Label 1199: @74815
     /*  74815 */ GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(75340),
     /*  74820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  74823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74830 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(74915), // Rule ID 13677 //
     /*  74835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  74850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  74866 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74870 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74879 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74896 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74898 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  74898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74913 */     GIR_RootConstrainSelectedInstOperands,
     /*  74914 */     // GIR_Coverage, 13677,
     /*  74914 */     GIR_EraseRootFromParent_Done,
     /*  74915 */   // Label 1261: @74915
     /*  74915 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(75000), // Rule ID 13676 //
     /*  74920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  74935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  74956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74969 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74975 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74983 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  74983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  74994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74998 */     GIR_RootConstrainSelectedInstOperands,
     /*  74999 */     // GIR_Coverage, 13676,
     /*  74999 */     GIR_EraseRootFromParent_Done,
     /*  75000 */   // Label 1262: @75000
     /*  75000 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(75085), // Rule ID 13675 //
     /*  75005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75053 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75059 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75068 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75083 */     GIR_RootConstrainSelectedInstOperands,
     /*  75084 */     // GIR_Coverage, 13675,
     /*  75084 */     GIR_EraseRootFromParent_Done,
     /*  75085 */   // Label 1263: @75085
     /*  75085 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(75170), // Rule ID 3810 //
     /*  75090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75143 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75149 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75153 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75168 */     GIR_RootConstrainSelectedInstOperands,
     /*  75169 */     // GIR_Coverage, 3810,
     /*  75169 */     GIR_EraseRootFromParent_Done,
     /*  75170 */   // Label 1264: @75170
     /*  75170 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(75202), // Rule ID 4929 //
     /*  75175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75183 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75189 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75193 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  75193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  75196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75200 */     GIR_RootConstrainSelectedInstOperands,
     /*  75201 */     // GIR_Coverage, 4929,
     /*  75201 */     GIR_EraseRootFromParent_Done,
     /*  75202 */   // Label 1265: @75202
     /*  75202 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(75259), // Rule ID 3806 //
     /*  75207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75242 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  75257 */     GIR_RootConstrainSelectedInstOperands,
     /*  75258 */     // GIR_Coverage, 3806,
     /*  75258 */     GIR_EraseRootFromParent_Done,
     /*  75259 */   // Label 1266: @75259
     /*  75259 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(75316), // Rule ID 13667 //
     /*  75264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75299 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  75314 */     GIR_RootConstrainSelectedInstOperands,
     /*  75315 */     // GIR_Coverage, 13667,
     /*  75315 */     GIR_EraseRootFromParent_Done,
     /*  75316 */   // Label 1267: @75316
     /*  75316 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(75339), // Rule ID 5028 //
     /*  75321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75332 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  75332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  75337 */     GIR_RootConstrainSelectedInstOperands,
     /*  75338 */     // GIR_Coverage, 5028,
     /*  75338 */     GIR_Done,
     /*  75339 */   // Label 1268: @75339
     /*  75339 */   GIM_Reject,
     /*  75340 */ // Label 1260: @75340
     /*  75340 */ GIM_Reject,
     /*  75341 */ // Label 1200: @75341
     /*  75341 */ GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(75411),
     /*  75346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  75349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  75352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75360 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(75391), // Rule ID 965 //
     /*  75365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75372 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75378 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75382 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  75382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  75385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75389 */     GIR_RootConstrainSelectedInstOperands,
     /*  75390 */     // GIR_Coverage, 965,
     /*  75390 */     GIR_EraseRootFromParent_Done,
     /*  75391 */   // Label 1270: @75391
     /*  75391 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(75410), // Rule ID 1592 //
     /*  75396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75403 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  75403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  75408 */     GIR_RootConstrainSelectedInstOperands,
     /*  75409 */     // GIR_Coverage, 1592,
     /*  75409 */     GIR_Done,
     /*  75410 */   // Label 1271: @75410
     /*  75410 */   GIM_Reject,
     /*  75411 */ // Label 1269: @75411
     /*  75411 */ GIM_Reject,
     /*  75412 */ // Label 1201: @75412
     /*  75412 */ GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(75937),
     /*  75417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75427 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(75512), // Rule ID 13674 //
     /*  75432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75467 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75476 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75482 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75495 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  75495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75510 */     GIR_RootConstrainSelectedInstOperands,
     /*  75511 */     // GIR_Coverage, 13674,
     /*  75511 */     GIR_EraseRootFromParent_Done,
     /*  75512 */   // Label 1273: @75512
     /*  75512 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(75597), // Rule ID 13673 //
     /*  75517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75566 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75572 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75578 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75580 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  75580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75595 */     GIR_RootConstrainSelectedInstOperands,
     /*  75596 */     // GIR_Coverage, 13673,
     /*  75596 */     GIR_EraseRootFromParent_Done,
     /*  75597 */   // Label 1274: @75597
     /*  75597 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(75682), // Rule ID 13672 //
     /*  75602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75650 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75656 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75663 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75665 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  75665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75680 */     GIR_RootConstrainSelectedInstOperands,
     /*  75681 */     // GIR_Coverage, 13672,
     /*  75681 */     GIR_EraseRootFromParent_Done,
     /*  75682 */   // Label 1275: @75682
     /*  75682 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(75767), // Rule ID 3809 //
     /*  75687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75731 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75740 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75746 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75748 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75750 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  75750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75765 */     GIR_RootConstrainSelectedInstOperands,
     /*  75766 */     // GIR_Coverage, 3809,
     /*  75766 */     GIR_EraseRootFromParent_Done,
     /*  75767 */   // Label 1276: @75767
     /*  75767 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(75799), // Rule ID 4927 //
     /*  75772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75780 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75786 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75790 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  75790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  75793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75797 */     GIR_RootConstrainSelectedInstOperands,
     /*  75798 */     // GIR_Coverage, 4927,
     /*  75798 */     GIR_EraseRootFromParent_Done,
     /*  75799 */   // Label 1277: @75799
     /*  75799 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(75856), // Rule ID 3805 //
     /*  75804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75839 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  75839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  75854 */     GIR_RootConstrainSelectedInstOperands,
     /*  75855 */     // GIR_Coverage, 3805,
     /*  75855 */     GIR_EraseRootFromParent_Done,
     /*  75856 */   // Label 1278: @75856
     /*  75856 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(75913), // Rule ID 13666 //
     /*  75861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75896 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  75896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  75911 */     GIR_RootConstrainSelectedInstOperands,
     /*  75912 */     // GIR_Coverage, 13666,
     /*  75912 */     GIR_EraseRootFromParent_Done,
     /*  75913 */   // Label 1279: @75913
     /*  75913 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(75936), // Rule ID 5027 //
     /*  75918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75929 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  75929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  75934 */     GIR_RootConstrainSelectedInstOperands,
     /*  75935 */     // GIR_Coverage, 5027,
     /*  75935 */     GIR_Done,
     /*  75936 */   // Label 1280: @75936
     /*  75936 */   GIM_Reject,
     /*  75937 */ // Label 1272: @75937
     /*  75937 */ GIM_Reject,
     /*  75938 */ // Label 1202: @75938
     /*  75938 */ GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(76466),
     /*  75943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  75946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75953 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(76038), // Rule ID 13671 //
     /*  75958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  75973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  75989 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76002 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76008 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76021 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76036 */     GIR_RootConstrainSelectedInstOperands,
     /*  76037 */     // GIR_Coverage, 13671,
     /*  76037 */     GIR_EraseRootFromParent_Done,
     /*  76038 */   // Label 1282: @76038
     /*  76038 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(76123), // Rule ID 13670 //
     /*  76043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76092 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76098 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76106 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76121 */     GIR_RootConstrainSelectedInstOperands,
     /*  76122 */     // GIR_Coverage, 13670,
     /*  76122 */     GIR_EraseRootFromParent_Done,
     /*  76123 */   // Label 1283: @76123
     /*  76123 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(76208), // Rule ID 13669 //
     /*  76128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76176 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76182 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76191 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76206 */     GIR_RootConstrainSelectedInstOperands,
     /*  76207 */     // GIR_Coverage, 13669,
     /*  76207 */     GIR_EraseRootFromParent_Done,
     /*  76208 */   // Label 1284: @76208
     /*  76208 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(76293), // Rule ID 3808 //
     /*  76213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76266 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76272 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76276 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76291 */     GIR_RootConstrainSelectedInstOperands,
     /*  76292 */     // GIR_Coverage, 3808,
     /*  76292 */     GIR_EraseRootFromParent_Done,
     /*  76293 */   // Label 1285: @76293
     /*  76293 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(76328), // Rule ID 966 //
     /*  76298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76309 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76315 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  76317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76319 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  76319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  76322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76326 */     GIR_RootConstrainSelectedInstOperands,
     /*  76327 */     // GIR_Coverage, 966,
     /*  76327 */     GIR_EraseRootFromParent_Done,
     /*  76328 */   // Label 1286: @76328
     /*  76328 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(76385), // Rule ID 3804 //
     /*  76333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76368 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  76383 */     GIR_RootConstrainSelectedInstOperands,
     /*  76384 */     // GIR_Coverage, 3804,
     /*  76384 */     GIR_EraseRootFromParent_Done,
     /*  76385 */   // Label 1287: @76385
     /*  76385 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(76442), // Rule ID 13665 //
     /*  76390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76425 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  76440 */     GIR_RootConstrainSelectedInstOperands,
     /*  76441 */     // GIR_Coverage, 13665,
     /*  76441 */     GIR_EraseRootFromParent_Done,
     /*  76442 */   // Label 1288: @76442
     /*  76442 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(76465), // Rule ID 1593 //
     /*  76447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76458 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  76458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  76463 */     GIR_RootConstrainSelectedInstOperands,
     /*  76464 */     // GIR_Coverage, 1593,
     /*  76464 */     GIR_Done,
     /*  76465 */   // Label 1289: @76465
     /*  76465 */   GIM_Reject,
     /*  76466 */ // Label 1281: @76466
     /*  76466 */ GIM_Reject,
     /*  76467 */ // Label 1203: @76467
     /*  76467 */ GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(76516), // Rule ID 8375 //
     /*  76472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  76475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  76478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  76481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  76485 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  76485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  76488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  76492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76497 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  76500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  76502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  76505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  76507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76510 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  76512 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  76514 */   GIR_RootConstrainSelectedInstOperands,
     /*  76515 */   // GIR_Coverage, 8375,
     /*  76515 */   GIR_EraseRootFromParent_Done,
     /*  76516 */ // Label 1290: @76516
     /*  76516 */ GIM_Reject,
     /*  76517 */ // Label 1204: @76517
     /*  76517 */ GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(76566), // Rule ID 8374 //
     /*  76522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  76525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  76528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  76531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  76535 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  76535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  76538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  76542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76547 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  76550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  76552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  76555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  76557 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76560 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  76562 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  76564 */   GIR_RootConstrainSelectedInstOperands,
     /*  76565 */   // GIR_Coverage, 8374,
     /*  76565 */   GIR_EraseRootFromParent_Done,
     /*  76566 */ // Label 1291: @76566
     /*  76566 */ GIM_Reject,
     /*  76567 */ // Label 1205: @76567
     /*  76567 */ GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(77029),
     /*  76572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  76582 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(76653), // Rule ID 15523 //
     /*  76587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76626 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76632 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76636 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  76639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  76643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76651 */     GIR_RootConstrainSelectedInstOperands,
     /*  76652 */     // GIR_Coverage, 15523,
     /*  76652 */     GIR_EraseRootFromParent_Done,
     /*  76653 */   // Label 1293: @76653
     /*  76653 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(76724), // Rule ID 15522 //
     /*  76658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76697 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76703 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76707 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  76710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  76714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  76718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76722 */     GIR_RootConstrainSelectedInstOperands,
     /*  76723 */     // GIR_Coverage, 15522,
     /*  76723 */     GIR_EraseRootFromParent_Done,
     /*  76724 */   // Label 1294: @76724
     /*  76724 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(76795), // Rule ID 15521 //
     /*  76729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76768 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76774 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76778 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  76781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  76785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76793 */     GIR_RootConstrainSelectedInstOperands,
     /*  76794 */     // GIR_Coverage, 15521,
     /*  76794 */     GIR_EraseRootFromParent_Done,
     /*  76795 */   // Label 1295: @76795
     /*  76795 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(76866), // Rule ID 11785 //
     /*  76800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76839 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76845 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76849 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  76852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  76856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  76860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76864 */     GIR_RootConstrainSelectedInstOperands,
     /*  76865 */     // GIR_Coverage, 11785,
     /*  76865 */     GIR_EraseRootFromParent_Done,
     /*  76866 */   // Label 1296: @76866
     /*  76866 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(76927), // Rule ID 11809 //
     /*  76871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  76882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76890 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  76894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76898 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76904 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  76906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76908 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  76911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  76921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76925 */     GIR_RootConstrainSelectedInstOperands,
     /*  76926 */     // GIR_Coverage, 11809,
     /*  76926 */     GIR_EraseRootFromParent_Done,
     /*  76927 */   // Label 1297: @76927
     /*  76927 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(76970), // Rule ID 13632 //
     /*  76932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76953 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  76956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  76962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  76968 */     GIR_RootConstrainSelectedInstOperands,
     /*  76969 */     // GIR_Coverage, 13632,
     /*  76969 */     GIR_EraseRootFromParent_Done,
     /*  76970 */   // Label 1298: @76970
     /*  76970 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(77013), // Rule ID 3145 //
     /*  76975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76996 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  76999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77011 */     GIR_RootConstrainSelectedInstOperands,
     /*  77012 */     // GIR_Coverage, 3145,
     /*  77012 */     GIR_EraseRootFromParent_Done,
     /*  77013 */   // Label 1299: @77013
     /*  77013 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(77028), // Rule ID 7398 //
     /*  77018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77021 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  77021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  77026 */     GIR_RootConstrainSelectedInstOperands,
     /*  77027 */     // GIR_Coverage, 7398,
     /*  77027 */     GIR_Done,
     /*  77028 */   // Label 1300: @77028
     /*  77028 */   GIM_Reject,
     /*  77029 */ // Label 1292: @77029
     /*  77029 */ GIM_Reject,
     /*  77030 */ // Label 1206: @77030
     /*  77030 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(77079), // Rule ID 8373 //
     /*  77035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  77041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  77044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77048 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  77048 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77051 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  77055 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77060 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77073 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77075 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77077 */   GIR_RootConstrainSelectedInstOperands,
     /*  77078 */   // GIR_Coverage, 8373,
     /*  77078 */   GIR_EraseRootFromParent_Done,
     /*  77079 */ // Label 1301: @77079
     /*  77079 */ GIM_Reject,
     /*  77080 */ // Label 1207: @77080
     /*  77080 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(77542),
     /*  77085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  77095 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(77166), // Rule ID 15520 //
     /*  77100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77131 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77139 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77145 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77149 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77164 */     GIR_RootConstrainSelectedInstOperands,
     /*  77165 */     // GIR_Coverage, 15520,
     /*  77165 */     GIR_EraseRootFromParent_Done,
     /*  77166 */   // Label 1303: @77166
     /*  77166 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(77237), // Rule ID 15519 //
     /*  77171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77210 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77216 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77220 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77235 */     GIR_RootConstrainSelectedInstOperands,
     /*  77236 */     // GIR_Coverage, 15519,
     /*  77236 */     GIR_EraseRootFromParent_Done,
     /*  77237 */   // Label 1304: @77237
     /*  77237 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(77308), // Rule ID 15518 //
     /*  77242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77281 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77287 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77291 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77306 */     GIR_RootConstrainSelectedInstOperands,
     /*  77307 */     // GIR_Coverage, 15518,
     /*  77307 */     GIR_EraseRootFromParent_Done,
     /*  77308 */   // Label 1305: @77308
     /*  77308 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(77379), // Rule ID 11783 //
     /*  77313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77352 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77358 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77362 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77377 */     GIR_RootConstrainSelectedInstOperands,
     /*  77378 */     // GIR_Coverage, 11783,
     /*  77378 */     GIR_EraseRootFromParent_Done,
     /*  77379 */   // Label 1306: @77379
     /*  77379 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(77440), // Rule ID 11807 //
     /*  77384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  77395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77403 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  77407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77411 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77417 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  77419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77421 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  77424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  77434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77438 */     GIR_RootConstrainSelectedInstOperands,
     /*  77439 */     // GIR_Coverage, 11807,
     /*  77439 */     GIR_EraseRootFromParent_Done,
     /*  77440 */   // Label 1307: @77440
     /*  77440 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(77483), // Rule ID 13631 //
     /*  77445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77466 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  77469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  77481 */     GIR_RootConstrainSelectedInstOperands,
     /*  77482 */     // GIR_Coverage, 13631,
     /*  77482 */     GIR_EraseRootFromParent_Done,
     /*  77483 */   // Label 1308: @77483
     /*  77483 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(77526), // Rule ID 3143 //
     /*  77488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77509 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  77512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77524 */     GIR_RootConstrainSelectedInstOperands,
     /*  77525 */     // GIR_Coverage, 3143,
     /*  77525 */     GIR_EraseRootFromParent_Done,
     /*  77526 */   // Label 1309: @77526
     /*  77526 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(77541), // Rule ID 7397 //
     /*  77531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77534 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  77534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  77539 */     GIR_RootConstrainSelectedInstOperands,
     /*  77540 */     // GIR_Coverage, 7397,
     /*  77540 */     GIR_Done,
     /*  77541 */   // Label 1310: @77541
     /*  77541 */   GIM_Reject,
     /*  77542 */ // Label 1302: @77542
     /*  77542 */ GIM_Reject,
     /*  77543 */ // Label 1208: @77543
     /*  77543 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(77592), // Rule ID 8372 //
     /*  77548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  77554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  77557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77561 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  77561 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77564 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  77568 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77573 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77586 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77588 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77590 */   GIR_RootConstrainSelectedInstOperands,
     /*  77591 */   // GIR_Coverage, 8372,
     /*  77591 */   GIR_EraseRootFromParent_Done,
     /*  77592 */ // Label 1311: @77592
     /*  77592 */ GIM_Reject,
     /*  77593 */ // Label 1209: @77593
     /*  77593 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(78055),
     /*  77598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  77601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  77604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  77608 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(77679), // Rule ID 15517 //
     /*  77613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  77628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  77632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  77644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  77648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77652 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77658 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77662 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  77662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77677 */     GIR_RootConstrainSelectedInstOperands,
     /*  77678 */     // GIR_Coverage, 15517,
     /*  77678 */     GIR_EraseRootFromParent_Done,
     /*  77679 */   // Label 1313: @77679
     /*  77679 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(77750), // Rule ID 15516 //
     /*  77684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  77699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  77703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  77715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  77719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77723 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77731 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77733 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  77733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77748 */     GIR_RootConstrainSelectedInstOperands,
     /*  77749 */     // GIR_Coverage, 15516,
     /*  77749 */     GIR_EraseRootFromParent_Done,
     /*  77750 */   // Label 1314: @77750
     /*  77750 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(77821), // Rule ID 15515 //
     /*  77755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  77770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  77774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  77786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  77790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77794 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77804 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  77804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77819 */     GIR_RootConstrainSelectedInstOperands,
     /*  77820 */     // GIR_Coverage, 15515,
     /*  77820 */     GIR_EraseRootFromParent_Done,
     /*  77821 */   // Label 1315: @77821
     /*  77821 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(77892), // Rule ID 11781 //
     /*  77826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  77841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  77845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  77857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  77861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77865 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77871 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77875 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  77875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77890 */     GIR_RootConstrainSelectedInstOperands,
     /*  77891 */     // GIR_Coverage, 11781,
     /*  77891 */     GIR_EraseRootFromParent_Done,
     /*  77892 */   // Label 1316: @77892
     /*  77892 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(77953), // Rule ID 11805 //
     /*  77897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  77908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  77912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  77916 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  77920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77924 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77930 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  77932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77934 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  77934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  77937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  77947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77951 */     GIR_RootConstrainSelectedInstOperands,
     /*  77952 */     // GIR_Coverage, 11805,
     /*  77952 */     GIR_EraseRootFromParent_Done,
     /*  77953 */   // Label 1317: @77953
     /*  77953 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(77996), // Rule ID 13630 //
     /*  77958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  77973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  77977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77979 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  77979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  77982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  77994 */     GIR_RootConstrainSelectedInstOperands,
     /*  77995 */     // GIR_Coverage, 13630,
     /*  77995 */     GIR_EraseRootFromParent_Done,
     /*  77996 */   // Label 1318: @77996
     /*  77996 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(78039), // Rule ID 3141 //
     /*  78001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78022 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78027 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78037 */     GIR_RootConstrainSelectedInstOperands,
     /*  78038 */     // GIR_Coverage, 3141,
     /*  78038 */     GIR_EraseRootFromParent_Done,
     /*  78039 */   // Label 1319: @78039
     /*  78039 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(78054), // Rule ID 7396 //
     /*  78044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78047 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  78047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78052 */     GIR_RootConstrainSelectedInstOperands,
     /*  78053 */     // GIR_Coverage, 7396,
     /*  78053 */     GIR_Done,
     /*  78054 */   // Label 1320: @78054
     /*  78054 */   GIM_Reject,
     /*  78055 */ // Label 1312: @78055
     /*  78055 */ GIM_Reject,
     /*  78056 */ // Label 1210: @78056
     /*  78056 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(78105), // Rule ID 8371 //
     /*  78061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  78067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  78070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  78074 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  78074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  78077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  78081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78086 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  78089 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78099 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78101 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78103 */   GIR_RootConstrainSelectedInstOperands,
     /*  78104 */   // GIR_Coverage, 8371,
     /*  78104 */   GIR_EraseRootFromParent_Done,
     /*  78105 */ // Label 1321: @78105
     /*  78105 */ GIM_Reject,
     /*  78106 */ // Label 1211: @78106
     /*  78106 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(78568),
     /*  78111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78121 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(78192), // Rule ID 15514 //
     /*  78126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78161 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78165 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78171 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78175 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  78175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78190 */     GIR_RootConstrainSelectedInstOperands,
     /*  78191 */     // GIR_Coverage, 15514,
     /*  78191 */     GIR_EraseRootFromParent_Done,
     /*  78192 */   // Label 1323: @78192
     /*  78192 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(78263), // Rule ID 15513 //
     /*  78197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78236 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78242 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78244 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78246 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  78246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78261 */     GIR_RootConstrainSelectedInstOperands,
     /*  78262 */     // GIR_Coverage, 15513,
     /*  78262 */     GIR_EraseRootFromParent_Done,
     /*  78263 */   // Label 1324: @78263
     /*  78263 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(78334), // Rule ID 15512 //
     /*  78268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78307 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78313 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78317 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  78317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78332 */     GIR_RootConstrainSelectedInstOperands,
     /*  78333 */     // GIR_Coverage, 15512,
     /*  78333 */     GIR_EraseRootFromParent_Done,
     /*  78334 */   // Label 1325: @78334
     /*  78334 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(78405), // Rule ID 11779 //
     /*  78339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78378 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78384 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78388 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  78388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78403 */     GIR_RootConstrainSelectedInstOperands,
     /*  78404 */     // GIR_Coverage, 11779,
     /*  78404 */     GIR_EraseRootFromParent_Done,
     /*  78405 */   // Label 1326: @78405
     /*  78405 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(78466), // Rule ID 11803 //
     /*  78410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78429 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  78433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78437 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78443 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78447 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  78447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78464 */     GIR_RootConstrainSelectedInstOperands,
     /*  78465 */     // GIR_Coverage, 11803,
     /*  78465 */     GIR_EraseRootFromParent_Done,
     /*  78466 */   // Label 1327: @78466
     /*  78466 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(78509), // Rule ID 13629 //
     /*  78471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78492 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  78492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78507 */     GIR_RootConstrainSelectedInstOperands,
     /*  78508 */     // GIR_Coverage, 13629,
     /*  78508 */     GIR_EraseRootFromParent_Done,
     /*  78509 */   // Label 1328: @78509
     /*  78509 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(78552), // Rule ID 3139 //
     /*  78514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78535 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  78535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78550 */     GIR_RootConstrainSelectedInstOperands,
     /*  78551 */     // GIR_Coverage, 3139,
     /*  78551 */     GIR_EraseRootFromParent_Done,
     /*  78552 */   // Label 1329: @78552
     /*  78552 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(78567), // Rule ID 7395 //
     /*  78557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78560 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  78560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78565 */     GIR_RootConstrainSelectedInstOperands,
     /*  78566 */     // GIR_Coverage, 7395,
     /*  78566 */     GIR_Done,
     /*  78567 */   // Label 1330: @78567
     /*  78567 */   GIM_Reject,
     /*  78568 */ // Label 1322: @78568
     /*  78568 */ GIM_Reject,
     /*  78569 */ // Label 1212: @78569
     /*  78569 */ GIM_Reject,
     /*  78570 */ // Label 8: @78570
     /*  78570 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(86093),
     /*  78575 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  78578 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1343*/ GIMT_Encode4(86092),
     /*  78589 */   /*GILLT_v2s64*//*Label 1332*/ GIMT_Encode4(78657), GIMT_Encode4(0),
     /*  78597 */   /*GILLT_v4s32*//*Label 1333*/ GIMT_Encode4(79178), GIMT_Encode4(0),
     /*  78605 */   /*GILLT_v8s16*//*Label 1334*/ GIMT_Encode4(81590),
     /*  78609 */   /*GILLT_v16s8*//*Label 1335*/ GIMT_Encode4(83999), GIMT_Encode4(0),
     /*  78617 */   /*GILLT_nxv2s1*//*Label 1336*/ GIMT_Encode4(85910), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  78633 */   /*GILLT_nxv4s1*//*Label 1337*/ GIMT_Encode4(85936),
     /*  78637 */   /*GILLT_nxv4s16*//*Label 1338*/ GIMT_Encode4(85962),
     /*  78641 */   /*GILLT_nxv4s32*//*Label 1339*/ GIMT_Encode4(85988),
     /*  78645 */   /*GILLT_nxv8s1*//*Label 1340*/ GIMT_Encode4(86014),
     /*  78649 */   /*GILLT_nxv8s16*//*Label 1341*/ GIMT_Encode4(86040),
     /*  78653 */   /*GILLT_nxv16s1*//*Label 1342*/ GIMT_Encode4(86066),
     /*  78657 */   // Label 1332: @78657
     /*  78657 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(79177),
     /*  78662 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  78665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  78668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78676 */     GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(78738), // Rule ID 5743 //
     /*  78681 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78685 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78691 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  78693 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78695 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  78695 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  78698 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  78702 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78707 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  78711 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78713 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78716 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78718 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78721 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78724 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78727 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78732 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78737 */       // GIR_Coverage, 5743,
     /*  78737 */       GIR_EraseRootFromParent_Done,
     /*  78738 */     // Label 1345: @78738
     /*  78738 */     GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(78800), // Rule ID 5747 //
     /*  78743 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78747 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78753 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  78755 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78757 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  78757 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  78760 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  78764 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78769 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  78773 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78775 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  78778 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78780 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78783 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78786 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78789 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78794 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78799 */       // GIR_Coverage, 5747,
     /*  78799 */       GIR_EraseRootFromParent_Done,
     /*  78800 */     // Label 1346: @78800
     /*  78800 */     GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(78858), // Rule ID 5744 //
     /*  78805 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78809 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  78813 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78815 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  78815 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  78818 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78822 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78827 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78829 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78832 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78834 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78837 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  78839 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78842 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78847 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78852 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78857 */       // GIR_Coverage, 5744,
     /*  78857 */       GIR_EraseRootFromParent_Done,
     /*  78858 */     // Label 1347: @78858
     /*  78858 */     GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(78916), // Rule ID 5748 //
     /*  78863 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78867 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  78871 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78873 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  78873 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  78876 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78880 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78885 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78887 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78890 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  78892 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78895 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  78897 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  78900 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78905 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78910 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78915 */       // GIR_Coverage, 5748,
     /*  78915 */       GIR_EraseRootFromParent_Done,
     /*  78916 */     // Label 1348: @78916
     /*  78916 */     GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(79046), // Rule ID 5742 //
     /*  78921 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78925 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  78925 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  78928 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78932 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78937 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  78939 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  78942 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78946 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78951 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  78954 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  78958 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  78961 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78966 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  78971 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  78976 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  78979 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78983 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78988 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  78990 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  78993 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  78997 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79002 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79005 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79009 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79012 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79017 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79022 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79027 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79030 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79032 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79035 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79038 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  79041 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79044 */       GIR_RootConstrainSelectedInstOperands,
     /*  79045 */       // GIR_Coverage, 5742,
     /*  79045 */       GIR_EraseRootFromParent_Done,
     /*  79046 */     // Label 1349: @79046
     /*  79046 */     GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(79176), // Rule ID 5746 //
     /*  79051 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79055 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  79055 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  79058 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79062 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79067 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  79069 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  79072 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79076 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79081 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  79084 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  79088 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  79091 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79096 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79101 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79106 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79109 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79113 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79118 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79120 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79123 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79127 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79132 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79135 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79139 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79142 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79147 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79152 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79157 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79160 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79162 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79165 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79168 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  79171 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79174 */       GIR_RootConstrainSelectedInstOperands,
     /*  79175 */       // GIR_Coverage, 5746,
     /*  79175 */       GIR_EraseRootFromParent_Done,
     /*  79176 */     // Label 1350: @79176
     /*  79176 */     GIM_Reject,
     /*  79177 */   // Label 1344: @79177
     /*  79177 */   GIM_Reject,
     /*  79178 */   // Label 1333: @79178
     /*  79178 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(81589),
     /*  79183 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  79186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  79189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79193 */     GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(79322), // Rule ID 5406 //
     /*  79198 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79202 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79206 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79210 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79214 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79218 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79222 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79226 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79230 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79234 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79238 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  79242 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79247 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79251 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79257 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79259 */       // MIs[2] Operand 2
     /*  79259 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  79270 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79272 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  79272 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79275 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79279 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79284 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  79287 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79291 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79294 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79299 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79304 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  79307 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79309 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79312 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  79316 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  79320 */       GIR_RootConstrainSelectedInstOperands,
     /*  79321 */       // GIR_Coverage, 5406,
     /*  79321 */       GIR_EraseRootFromParent_Done,
     /*  79322 */     // Label 1352: @79322
     /*  79322 */     GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(79444), // Rule ID 5402 //
     /*  79327 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79331 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79335 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79339 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79343 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79347 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79351 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79355 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79359 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  79363 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79367 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  79371 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79376 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79381 */       // MIs[2] Operand 2
     /*  79381 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  79392 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79394 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  79394 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79397 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79401 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79406 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  79409 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79413 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79416 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79421 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79426 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  79429 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79431 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79434 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  79438 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  79442 */       GIR_RootConstrainSelectedInstOperands,
     /*  79443 */       // GIR_Coverage, 5402,
     /*  79443 */       GIR_EraseRootFromParent_Done,
     /*  79444 */     // Label 1353: @79444
     /*  79444 */     GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(79566), // Rule ID 5404 //
     /*  79449 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79453 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79457 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79461 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79465 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79469 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79473 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79477 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79481 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  79485 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79489 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  79493 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79498 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79503 */       // MIs[2] Operand 2
     /*  79503 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  79514 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79516 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  79516 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79519 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79523 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79528 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  79531 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79535 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79538 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79543 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79548 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  79551 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79553 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79556 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  79560 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  79564 */       GIR_RootConstrainSelectedInstOperands,
     /*  79565 */       // GIR_Coverage, 5404,
     /*  79565 */       GIR_EraseRootFromParent_Done,
     /*  79566 */     // Label 1354: @79566
     /*  79566 */     GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(79668), // Rule ID 5552 //
     /*  79571 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79575 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79579 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79583 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79587 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79591 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79595 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79600 */       // MIs[2] Operand 2
     /*  79600 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  79611 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  79615 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79619 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79623 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  79627 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79631 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79635 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79640 */       // MIs[4] Operand 2
     /*  79640 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  79651 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79653 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  79653 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  79656 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  79658 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  79662 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  79666 */       GIR_RootConstrainSelectedInstOperands,
     /*  79667 */       // GIR_Coverage, 5552,
     /*  79667 */       GIR_EraseRootFromParent_Done,
     /*  79668 */     // Label 1355: @79668
     /*  79668 */     GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(79797), // Rule ID 6296 //
     /*  79673 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79677 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79681 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79685 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79688 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  79693 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  79697 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  79701 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79706 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  79710 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79712 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  79712 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  79715 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  79719 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79724 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  79727 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  79729 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79732 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79736 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79741 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79743 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79746 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79750 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79755 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79758 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  79762 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79765 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79770 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79775 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79780 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  79783 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79785 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79788 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  79792 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  79795 */       GIR_RootConstrainSelectedInstOperands,
     /*  79796 */       // GIR_Coverage, 6296,
     /*  79796 */       GIR_EraseRootFromParent_Done,
     /*  79797 */     // Label 1356: @79797
     /*  79797 */     GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(79839), // Rule ID 5753 //
     /*  79802 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  79809 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  79816 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  79816 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79819 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79821 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  79826 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79829 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  79834 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79837 */       GIR_RootConstrainSelectedInstOperands,
     /*  79838 */       // GIR_Coverage, 5753,
     /*  79838 */       GIR_EraseRootFromParent_Done,
     /*  79839 */     // Label 1357: @79839
     /*  79839 */     GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(79881), // Rule ID 5757 //
     /*  79844 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  79851 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  79858 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  79858 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79861 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79863 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  79868 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79871 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  79876 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79879 */       GIR_RootConstrainSelectedInstOperands,
     /*  79880 */       // GIR_Coverage, 5757,
     /*  79880 */       GIR_EraseRootFromParent_Done,
     /*  79881 */     // Label 1358: @79881
     /*  79881 */     GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(80004), // Rule ID 2569 //
     /*  79886 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  79889 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79893 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79897 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  79901 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  79904 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  79909 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  79913 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  79917 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79922 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  79926 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  79930 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  79934 */       // MIs[2] Operand 1
     /*  79934 */       // No operand predicates
     /*  79934 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79936 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  79936 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79939 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79943 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79948 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79950 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79953 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79957 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79962 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79965 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79969 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79972 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79977 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79982 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79987 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  79990 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79992 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79995 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  79999 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  80002 */       GIR_RootConstrainSelectedInstOperands,
     /*  80003 */       // GIR_Coverage, 2569,
     /*  80003 */       GIR_EraseRootFromParent_Done,
     /*  80004 */     // Label 1359: @80004
     /*  80004 */     GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(80127), // Rule ID 6264 //
     /*  80009 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80012 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80016 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80020 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80024 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80028 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80032 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  80036 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80040 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80045 */       // MIs[2] imm
     /*  80045 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80049 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80053 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  80057 */       // MIs[3] Operand 1
     /*  80057 */       // No operand predicates
     /*  80057 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80059 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  80059 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80062 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80066 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80071 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80073 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80076 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80080 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80085 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80088 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80092 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80095 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80100 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80105 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80110 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  80113 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80115 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80118 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  80122 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  80125 */       GIR_RootConstrainSelectedInstOperands,
     /*  80126 */       // GIR_Coverage, 6264,
     /*  80126 */       GIR_EraseRootFromParent_Done,
     /*  80127 */     // Label 1360: @80127
     /*  80127 */     GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(80247), // Rule ID 6302 //
     /*  80132 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80136 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80140 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80144 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80148 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80152 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80156 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80160 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80165 */       // MIs[2] imm
     /*  80165 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80169 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80173 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  80177 */       // MIs[3] Operand 1
     /*  80177 */       // No operand predicates
     /*  80177 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80179 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  80179 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80182 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80186 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80191 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80193 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80196 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80200 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80205 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80208 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80212 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80215 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80220 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80225 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80230 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  80233 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80235 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80238 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  80242 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  80245 */       GIR_RootConstrainSelectedInstOperands,
     /*  80246 */       // GIR_Coverage, 6302,
     /*  80246 */       GIR_EraseRootFromParent_Done,
     /*  80247 */     // Label 1361: @80247
     /*  80247 */     GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(80364), // Rule ID 2492 //
     /*  80252 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80255 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80259 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80263 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80267 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80270 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  80275 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80279 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  80283 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80288 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80293 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80295 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80295 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80298 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80302 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80307 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80309 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80312 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80316 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80321 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80324 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80328 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80331 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80336 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80341 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80346 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  80349 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80351 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80354 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80358 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80362 */       GIR_RootConstrainSelectedInstOperands,
     /*  80363 */       // GIR_Coverage, 2492,
     /*  80363 */       GIR_EraseRootFromParent_Done,
     /*  80364 */     // Label 1362: @80364
     /*  80364 */     GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(80481), // Rule ID 5322 //
     /*  80369 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80372 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80376 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80380 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80384 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80387 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  80392 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80396 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  80400 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80405 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80410 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80412 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80412 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80415 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80419 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80424 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80426 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80429 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80433 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80438 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80441 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80445 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80448 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80453 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80458 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80463 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  80466 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80468 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80471 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80475 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80479 */       GIR_RootConstrainSelectedInstOperands,
     /*  80480 */       // GIR_Coverage, 5322,
     /*  80480 */       GIR_EraseRootFromParent_Done,
     /*  80481 */     // Label 1363: @80481
     /*  80481 */     GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(80598), // Rule ID 5325 //
     /*  80486 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80489 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80493 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80497 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80501 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80504 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  80509 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80513 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  80517 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80522 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80527 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80529 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80529 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80532 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80536 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80541 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80543 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80546 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80550 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80555 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80558 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80562 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80565 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80570 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80575 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80580 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  80583 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80585 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80588 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80592 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80596 */       GIR_RootConstrainSelectedInstOperands,
     /*  80597 */       // GIR_Coverage, 5325,
     /*  80597 */       GIR_EraseRootFromParent_Done,
     /*  80598 */     // Label 1364: @80598
     /*  80598 */     GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(80715), // Rule ID 5328 //
     /*  80603 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80606 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80610 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80614 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80618 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80621 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  80626 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80630 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  80634 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80639 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80644 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80646 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80646 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80649 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80653 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80658 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80660 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80663 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80667 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80672 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80675 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80679 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80682 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80687 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80692 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80697 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  80700 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80702 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80705 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80709 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  80713 */       GIR_RootConstrainSelectedInstOperands,
     /*  80714 */       // GIR_Coverage, 5328,
     /*  80714 */       GIR_EraseRootFromParent_Done,
     /*  80715 */     // Label 1365: @80715
     /*  80715 */     GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(80819), // Rule ID 2488 //
     /*  80720 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80723 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80727 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80731 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80735 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  80738 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  80743 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80747 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80752 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80754 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  80754 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80757 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80761 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80766 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80768 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80771 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80775 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80780 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80783 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80787 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80790 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80795 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80800 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80805 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  80808 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80810 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80813 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80817 */       GIR_RootConstrainSelectedInstOperands,
     /*  80818 */       // GIR_Coverage, 2488,
     /*  80818 */       GIR_EraseRootFromParent_Done,
     /*  80819 */     // Label 1366: @80819
     /*  80819 */     GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(80875), // Rule ID 5485 //
     /*  80824 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80828 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80832 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80836 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80841 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80845 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80849 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80853 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80858 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80860 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  80860 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  80863 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  80865 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  80869 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  80873 */       GIR_RootConstrainSelectedInstOperands,
     /*  80874 */       // GIR_Coverage, 5485,
     /*  80874 */       GIR_EraseRootFromParent_Done,
     /*  80875 */     // Label 1367: @80875
     /*  80875 */     GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(80941), // Rule ID 5751 //
     /*  80880 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80884 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80888 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80894 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80896 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80898 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  80898 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80901 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80905 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80910 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80914 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80916 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80919 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80921 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80924 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80927 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80930 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80935 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80940 */       // GIR_Coverage, 5751,
     /*  80940 */       GIR_EraseRootFromParent_Done,
     /*  80941 */     // Label 1368: @80941
     /*  80941 */     GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(81007), // Rule ID 5755 //
     /*  80946 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80950 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80954 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80960 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80962 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80964 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  80964 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80967 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80971 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80976 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80980 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80982 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80985 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80987 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80990 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80993 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80996 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81001 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81006 */       // GIR_Coverage, 5755,
     /*  81006 */       GIR_EraseRootFromParent_Done,
     /*  81007 */     // Label 1369: @81007
     /*  81007 */     GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(81100), // Rule ID 4893 //
     /*  81012 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81016 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81020 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  81024 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81028 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81033 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81035 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  81035 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81038 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81042 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81047 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81049 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81052 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81056 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81061 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81064 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81068 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81071 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81076 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81081 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81086 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  81089 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81091 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81094 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  81098 */       GIR_RootConstrainSelectedInstOperands,
     /*  81099 */       // GIR_Coverage, 4893,
     /*  81099 */       GIR_EraseRootFromParent_Done,
     /*  81100 */     // Label 1370: @81100
     /*  81100 */     GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(81196), // Rule ID 4940 //
     /*  81105 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81108 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81112 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81116 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81120 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81124 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81129 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81131 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  81131 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81134 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81138 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81143 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81145 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81148 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81152 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81157 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81160 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81164 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81167 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81172 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81177 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81182 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  81185 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81187 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81190 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  81194 */       GIR_RootConstrainSelectedInstOperands,
     /*  81195 */       // GIR_Coverage, 4940,
     /*  81195 */       GIR_EraseRootFromParent_Done,
     /*  81196 */     // Label 1371: @81196
     /*  81196 */     GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(81258), // Rule ID 5752 //
     /*  81201 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81205 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81209 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  81213 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81215 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  81215 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81218 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81222 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81227 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  81229 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81232 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81234 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81237 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  81239 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  81242 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81247 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81252 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81257 */       // GIR_Coverage, 5752,
     /*  81257 */       GIR_EraseRootFromParent_Done,
     /*  81258 */     // Label 1372: @81258
     /*  81258 */     GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(81320), // Rule ID 5756 //
     /*  81263 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81267 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81271 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  81275 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81277 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  81277 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81280 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81284 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81289 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  81291 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81294 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81296 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81299 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  81301 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  81304 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81309 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81314 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81319 */       // GIR_Coverage, 5756,
     /*  81319 */       GIR_EraseRootFromParent_Done,
     /*  81320 */     // Label 1373: @81320
     /*  81320 */     GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(81454), // Rule ID 5750 //
     /*  81325 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81329 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81333 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  81333 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  81336 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81340 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81345 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  81347 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  81350 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81354 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81359 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  81362 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  81366 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  81369 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81374 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81379 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81384 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81387 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81391 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81396 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81398 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81401 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81405 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81410 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81413 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81417 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81420 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81425 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81430 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81435 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81438 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81440 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81443 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81446 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81449 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81452 */       GIR_RootConstrainSelectedInstOperands,
     /*  81453 */       // GIR_Coverage, 5750,
     /*  81453 */       GIR_EraseRootFromParent_Done,
     /*  81454 */     // Label 1374: @81454
     /*  81454 */     GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(81588), // Rule ID 5754 //
     /*  81459 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81463 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81467 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  81467 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  81470 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81474 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81479 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  81481 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  81484 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81488 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81493 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  81496 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  81500 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  81503 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81508 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81513 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81518 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81521 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81525 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81530 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81532 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81535 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81539 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81544 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81547 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81551 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81554 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81559 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81564 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81569 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81572 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81574 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81577 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81580 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81583 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81586 */       GIR_RootConstrainSelectedInstOperands,
     /*  81587 */       // GIR_Coverage, 5754,
     /*  81587 */       GIR_EraseRootFromParent_Done,
     /*  81588 */     // Label 1375: @81588
     /*  81588 */     GIM_Reject,
     /*  81589 */   // Label 1351: @81589
     /*  81589 */   GIM_Reject,
     /*  81590 */   // Label 1334: @81590
     /*  81590 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(83998),
     /*  81595 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  81598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  81601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81605 */     GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(81734), // Rule ID 5400 //
     /*  81610 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81614 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81618 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81622 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  81626 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81630 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81634 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  81638 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81642 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81646 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  81650 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81654 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81659 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81663 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81669 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81671 */       // MIs[2] Operand 2
     /*  81671 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  81682 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81684 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /*  81684 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81687 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81691 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81696 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81699 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81703 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81706 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81711 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81716 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  81719 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81721 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81724 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81728 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81732 */       GIR_RootConstrainSelectedInstOperands,
     /*  81733 */       // GIR_Coverage, 5400,
     /*  81733 */       GIR_EraseRootFromParent_Done,
     /*  81734 */     // Label 1377: @81734
     /*  81734 */     GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(81856), // Rule ID 5396 //
     /*  81739 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81743 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81747 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81751 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  81755 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81759 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81763 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  81767 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81771 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  81775 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  81779 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81783 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81788 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81793 */       // MIs[2] Operand 2
     /*  81793 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  81804 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81806 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  81806 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81809 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81813 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81818 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81821 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81825 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81828 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81833 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81838 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  81841 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81843 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81846 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81850 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81854 */       GIR_RootConstrainSelectedInstOperands,
     /*  81855 */       // GIR_Coverage, 5396,
     /*  81855 */       GIR_EraseRootFromParent_Done,
     /*  81856 */     // Label 1378: @81856
     /*  81856 */     GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(81978), // Rule ID 5398 //
     /*  81861 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81865 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81869 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81873 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  81877 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81881 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81885 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  81889 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81893 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  81897 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  81901 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81905 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81910 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81915 */       // MIs[2] Operand 2
     /*  81915 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  81926 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81928 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  81928 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81931 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81935 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81940 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  81943 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81947 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81950 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81955 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81960 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  81963 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81965 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81968 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  81972 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  81976 */       GIR_RootConstrainSelectedInstOperands,
     /*  81977 */       // GIR_Coverage, 5398,
     /*  81977 */       GIR_EraseRootFromParent_Done,
     /*  81978 */     // Label 1379: @81978
     /*  81978 */     GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(82080), // Rule ID 5551 //
     /*  81983 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81987 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81991 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  81995 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81999 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82003 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82007 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82012 */       // MIs[2] Operand 2
     /*  82012 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  82023 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  82027 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82031 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82035 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  82039 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82043 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82047 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82052 */       // MIs[4] Operand 2
     /*  82052 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /*  82063 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82065 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  82065 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /*  82068 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  82070 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  82074 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  82078 */       GIR_RootConstrainSelectedInstOperands,
     /*  82079 */       // GIR_Coverage, 5551,
     /*  82079 */       GIR_EraseRootFromParent_Done,
     /*  82080 */     // Label 1380: @82080
     /*  82080 */     GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(82209), // Rule ID 6295 //
     /*  82085 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82089 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82093 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82097 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82100 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  82105 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82109 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  82113 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82118 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /*  82122 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82124 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /*  82124 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  82127 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  82131 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82136 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  82139 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  82141 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82144 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82148 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82153 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82155 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82158 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82162 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82167 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82170 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  82174 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82177 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82182 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82187 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82192 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  82195 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82197 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82200 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  82204 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82207 */       GIR_RootConstrainSelectedInstOperands,
     /*  82208 */       // GIR_Coverage, 6295,
     /*  82208 */       GIR_EraseRootFromParent_Done,
     /*  82209 */     // Label 1381: @82209
     /*  82209 */     GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(82251), // Rule ID 5761 //
     /*  82214 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  82221 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  82228 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /*  82228 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82231 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82233 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  82238 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82241 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  82246 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82249 */       GIR_RootConstrainSelectedInstOperands,
     /*  82250 */       // GIR_Coverage, 5761,
     /*  82250 */       GIR_EraseRootFromParent_Done,
     /*  82251 */     // Label 1382: @82251
     /*  82251 */     GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(82293), // Rule ID 5765 //
     /*  82256 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  82263 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  82270 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /*  82270 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82273 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82275 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  82280 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82283 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  82288 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82291 */       GIR_RootConstrainSelectedInstOperands,
     /*  82292 */       // GIR_Coverage, 5765,
     /*  82292 */       GIR_EraseRootFromParent_Done,
     /*  82293 */     // Label 1383: @82293
     /*  82293 */     GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(82416), // Rule ID 2567 //
     /*  82298 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82301 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82305 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82309 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82313 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82316 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  82321 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82325 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  82329 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82334 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  82338 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82342 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  82346 */       // MIs[2] Operand 1
     /*  82346 */       // No operand predicates
     /*  82346 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  82348 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  82348 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82351 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82355 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82360 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82362 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82365 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82369 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82374 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82377 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82381 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82384 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82389 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82394 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82399 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /*  82402 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82404 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82407 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82411 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  82414 */       GIR_RootConstrainSelectedInstOperands,
     /*  82415 */       // GIR_Coverage, 2567,
     /*  82415 */       GIR_EraseRootFromParent_Done,
     /*  82416 */     // Label 1384: @82416
     /*  82416 */     GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(82539), // Rule ID 6263 //
     /*  82421 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82424 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82428 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82432 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82436 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82440 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82444 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  82448 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82452 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82457 */       // MIs[2] imm
     /*  82457 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82461 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82465 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  82469 */       // MIs[3] Operand 1
     /*  82469 */       // No operand predicates
     /*  82469 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82471 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  82471 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82474 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82478 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82483 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82485 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82488 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82492 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82497 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82500 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82504 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82507 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82512 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82517 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82522 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  82525 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82527 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82530 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  82534 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  82537 */       GIR_RootConstrainSelectedInstOperands,
     /*  82538 */       // GIR_Coverage, 6263,
     /*  82538 */       GIR_EraseRootFromParent_Done,
     /*  82539 */     // Label 1385: @82539
     /*  82539 */     GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(82659), // Rule ID 6301 //
     /*  82544 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82548 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82552 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82556 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82560 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82564 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82568 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82572 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82577 */       // MIs[2] imm
     /*  82577 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82581 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82585 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  82589 */       // MIs[3] Operand 1
     /*  82589 */       // No operand predicates
     /*  82589 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82591 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  82591 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82594 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82598 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82603 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82605 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82608 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82612 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82617 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82620 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82624 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82627 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82632 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82637 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82642 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  82645 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82647 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82650 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  82654 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  82657 */       GIR_RootConstrainSelectedInstOperands,
     /*  82658 */       // GIR_Coverage, 6301,
     /*  82658 */       GIR_EraseRootFromParent_Done,
     /*  82659 */     // Label 1386: @82659
     /*  82659 */     GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(82776), // Rule ID 2491 //
     /*  82664 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82667 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82671 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82675 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82679 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82682 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  82687 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82691 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  82695 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82700 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82705 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82707 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  82707 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82710 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82714 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82719 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82721 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82724 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82728 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82733 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82736 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82740 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82743 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82748 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82753 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82758 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  82761 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82763 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82766 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82770 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82774 */       GIR_RootConstrainSelectedInstOperands,
     /*  82775 */       // GIR_Coverage, 2491,
     /*  82775 */       GIR_EraseRootFromParent_Done,
     /*  82776 */     // Label 1387: @82776
     /*  82776 */     GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(82893), // Rule ID 5321 //
     /*  82781 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82784 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82788 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82792 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82796 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82799 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  82804 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82808 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  82812 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82817 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82822 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82824 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  82824 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82827 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82831 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82836 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82838 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82841 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82845 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82850 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82853 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82857 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82860 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82865 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82870 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82875 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  82878 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82880 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82883 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82887 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  82891 */       GIR_RootConstrainSelectedInstOperands,
     /*  82892 */       // GIR_Coverage, 5321,
     /*  82892 */       GIR_EraseRootFromParent_Done,
     /*  82893 */     // Label 1388: @82893
     /*  82893 */     GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(83010), // Rule ID 5324 //
     /*  82898 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82901 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82905 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82909 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82913 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82916 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  82921 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82925 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  82929 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82934 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82939 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82941 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  82941 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82944 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82948 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82953 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82955 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82958 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82962 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82967 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82970 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82974 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82977 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82982 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82987 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82992 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  82995 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82997 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83000 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83004 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  83008 */       GIR_RootConstrainSelectedInstOperands,
     /*  83009 */       // GIR_Coverage, 5324,
     /*  83009 */       GIR_EraseRootFromParent_Done,
     /*  83010 */     // Label 1389: @83010
     /*  83010 */     GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(83127), // Rule ID 5327 //
     /*  83015 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83018 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83022 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83026 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83030 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83033 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  83038 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83042 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  83046 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83051 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83056 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83058 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83058 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83061 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83065 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83070 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83072 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83075 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83079 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83084 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83087 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83091 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83094 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83099 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83104 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83109 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /*  83112 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83114 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83117 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83121 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  83125 */       GIR_RootConstrainSelectedInstOperands,
     /*  83126 */       // GIR_Coverage, 5327,
     /*  83126 */       GIR_EraseRootFromParent_Done,
     /*  83127 */     // Label 1390: @83127
     /*  83127 */     GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(83228), // Rule ID 4887 //
     /*  83132 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83136 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83140 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83144 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  83147 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /*  83152 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83156 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83161 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83163 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  83163 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83166 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83170 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83175 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83177 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83180 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83184 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83189 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83192 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83196 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83199 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83204 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83209 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83214 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  83217 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83219 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83222 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83226 */       GIR_RootConstrainSelectedInstOperands,
     /*  83227 */       // GIR_Coverage, 4887,
     /*  83227 */       GIR_EraseRootFromParent_Done,
     /*  83228 */     // Label 1391: @83228
     /*  83228 */     GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(83284), // Rule ID 5476 //
     /*  83233 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83237 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83241 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83245 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83250 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83254 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83258 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83262 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83267 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83269 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  83269 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /*  83272 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  83274 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  83278 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  83282 */       GIR_RootConstrainSelectedInstOperands,
     /*  83283 */       // GIR_Coverage, 5476,
     /*  83283 */       GIR_EraseRootFromParent_Done,
     /*  83284 */     // Label 1392: @83284
     /*  83284 */     GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(83350), // Rule ID 5759 //
     /*  83289 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83293 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83297 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83303 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  83305 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83307 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /*  83307 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  83310 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  83314 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83319 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  83323 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  83325 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  83328 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83330 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83333 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83336 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  83339 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83344 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83349 */       // GIR_Coverage, 5759,
     /*  83349 */       GIR_EraseRootFromParent_Done,
     /*  83350 */     // Label 1393: @83350
     /*  83350 */     GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(83416), // Rule ID 5763 //
     /*  83355 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83359 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83363 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83369 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  83371 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83373 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /*  83373 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  83376 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  83380 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83385 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  83389 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  83391 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  83394 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83396 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83399 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83402 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  83405 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83410 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83415 */       // GIR_Coverage, 5763,
     /*  83415 */       GIR_EraseRootFromParent_Done,
     /*  83416 */     // Label 1394: @83416
     /*  83416 */     GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(83509), // Rule ID 4895 //
     /*  83421 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83425 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83429 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  83433 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83437 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83442 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83444 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  83444 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83447 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83451 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83456 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83458 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83461 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83465 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83470 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83473 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83477 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83480 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83485 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83490 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83495 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  83498 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83500 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83503 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  83507 */       GIR_RootConstrainSelectedInstOperands,
     /*  83508 */       // GIR_Coverage, 4895,
     /*  83508 */       GIR_EraseRootFromParent_Done,
     /*  83509 */     // Label 1395: @83509
     /*  83509 */     GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(83605), // Rule ID 4939 //
     /*  83514 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83517 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83521 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83525 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83529 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83533 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83538 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83540 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /*  83540 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83543 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83547 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83552 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83554 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83557 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83561 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83566 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83569 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83573 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83576 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83581 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83586 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83591 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /*  83594 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83596 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83599 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  83603 */       GIR_RootConstrainSelectedInstOperands,
     /*  83604 */       // GIR_Coverage, 4939,
     /*  83604 */       GIR_EraseRootFromParent_Done,
     /*  83605 */     // Label 1396: @83605
     /*  83605 */     GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(83667), // Rule ID 5760 //
     /*  83610 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83614 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83618 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  83622 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83624 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /*  83624 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  83627 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83631 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83636 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  83638 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83641 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83643 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83646 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  83648 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  83651 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83656 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83661 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83666 */       // GIR_Coverage, 5760,
     /*  83666 */       GIR_EraseRootFromParent_Done,
     /*  83667 */     // Label 1397: @83667
     /*  83667 */     GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(83729), // Rule ID 5764 //
     /*  83672 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83676 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83680 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  83684 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83686 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /*  83686 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  83689 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83693 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83698 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  83700 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83703 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83705 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83708 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  83710 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  83713 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83718 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83723 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83728 */       // GIR_Coverage, 5764,
     /*  83728 */       GIR_EraseRootFromParent_Done,
     /*  83729 */     // Label 1398: @83729
     /*  83729 */     GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(83863), // Rule ID 5758 //
     /*  83734 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83738 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83742 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  83742 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  83745 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83749 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83754 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  83756 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  83759 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83763 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83768 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  83771 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  83775 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  83778 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83783 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83788 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83793 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83796 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83800 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83805 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83807 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83810 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83814 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83819 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83822 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83826 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83829 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83834 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83839 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83844 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83847 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83849 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83852 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83855 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  83858 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83861 */       GIR_RootConstrainSelectedInstOperands,
     /*  83862 */       // GIR_Coverage, 5758,
     /*  83862 */       GIR_EraseRootFromParent_Done,
     /*  83863 */     // Label 1399: @83863
     /*  83863 */     GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(83997), // Rule ID 5762 //
     /*  83868 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83872 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83876 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  83876 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  83879 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83883 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83888 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  83890 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  83893 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83897 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83902 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  83905 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  83909 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  83912 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83917 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83922 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83927 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83930 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83934 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83939 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83941 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83944 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83948 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83953 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83956 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83960 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83963 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83968 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83973 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83978 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83981 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83983 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83986 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83989 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  83992 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83995 */       GIR_RootConstrainSelectedInstOperands,
     /*  83996 */       // GIR_Coverage, 5762,
     /*  83996 */       GIR_EraseRootFromParent_Done,
     /*  83997 */     // Label 1400: @83997
     /*  83997 */     GIM_Reject,
     /*  83998 */   // Label 1376: @83998
     /*  83998 */   GIM_Reject,
     /*  83999 */   // Label 1335: @83999
     /*  83999 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(85909),
     /*  84004 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  84010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84014 */     GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(84143), // Rule ID 5394 //
     /*  84019 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84023 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84027 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84031 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84035 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84039 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84043 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84047 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84051 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84055 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84059 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84063 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84068 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84072 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84078 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84080 */       // MIs[2] Operand 2
     /*  84080 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  84091 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84093 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /*  84093 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84096 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84100 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84105 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  84108 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84112 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84115 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84120 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84125 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  84128 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84130 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84133 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  84137 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  84141 */       GIR_RootConstrainSelectedInstOperands,
     /*  84142 */       // GIR_Coverage, 5394,
     /*  84142 */       GIR_EraseRootFromParent_Done,
     /*  84143 */     // Label 1402: @84143
     /*  84143 */     GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(84265), // Rule ID 5390 //
     /*  84148 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84152 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84156 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84160 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84164 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84168 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84172 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84176 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84180 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  84184 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84188 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84192 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84197 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84202 */       // MIs[2] Operand 2
     /*  84202 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  84213 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84215 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  84215 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84218 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84222 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84227 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  84230 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84234 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84237 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84242 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84247 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  84250 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84252 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84255 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  84259 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  84263 */       GIR_RootConstrainSelectedInstOperands,
     /*  84264 */       // GIR_Coverage, 5390,
     /*  84264 */       GIR_EraseRootFromParent_Done,
     /*  84265 */     // Label 1403: @84265
     /*  84265 */     GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(84387), // Rule ID 5392 //
     /*  84270 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84274 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84278 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84282 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84286 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84290 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84294 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84298 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84302 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  84306 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84310 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84314 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84319 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84324 */       // MIs[2] Operand 2
     /*  84324 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  84335 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84337 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  84337 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84340 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84344 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84349 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  84352 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84356 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84359 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84364 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84369 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  84372 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84374 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84377 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  84381 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  84385 */       GIR_RootConstrainSelectedInstOperands,
     /*  84386 */       // GIR_Coverage, 5392,
     /*  84386 */       GIR_EraseRootFromParent_Done,
     /*  84387 */     // Label 1404: @84387
     /*  84387 */     GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(84489), // Rule ID 5550 //
     /*  84392 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84396 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84400 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84404 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84408 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84412 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84416 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84421 */       // MIs[2] Operand 2
     /*  84421 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  84432 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  84436 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84440 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84444 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  84448 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84452 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84456 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84461 */       // MIs[4] Operand 2
     /*  84461 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  84472 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84474 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  84474 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /*  84477 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84479 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  84483 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  84487 */       GIR_RootConstrainSelectedInstOperands,
     /*  84488 */       // GIR_Coverage, 5550,
     /*  84488 */       GIR_EraseRootFromParent_Done,
     /*  84489 */     // Label 1405: @84489
     /*  84489 */     GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(84618), // Rule ID 6294 //
     /*  84494 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84498 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84502 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84506 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84509 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  84514 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84518 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  84522 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84527 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /*  84531 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84533 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /*  84533 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  84536 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  84540 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84545 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  84548 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  84550 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84553 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84557 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84562 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84564 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84567 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84571 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84576 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84579 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  84583 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84586 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84591 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84596 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84601 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  84604 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84606 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84609 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  84613 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  84616 */       GIR_RootConstrainSelectedInstOperands,
     /*  84617 */       // GIR_Coverage, 6294,
     /*  84617 */       GIR_EraseRootFromParent_Done,
     /*  84618 */     // Label 1406: @84618
     /*  84618 */     GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(84660), // Rule ID 5769 //
     /*  84623 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  84630 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  84637 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /*  84637 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  84640 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84642 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  84647 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84650 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  84655 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  84658 */       GIR_RootConstrainSelectedInstOperands,
     /*  84659 */       // GIR_Coverage, 5769,
     /*  84659 */       GIR_EraseRootFromParent_Done,
     /*  84660 */     // Label 1407: @84660
     /*  84660 */     GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(84783), // Rule ID 2565 //
     /*  84665 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84668 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84672 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84676 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84680 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84683 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  84688 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84692 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  84696 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84701 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  84705 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84709 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  84713 */       // MIs[2] Operand 1
     /*  84713 */       // No operand predicates
     /*  84713 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84715 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  84715 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84718 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84722 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84727 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84729 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84732 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84736 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84741 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84744 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84748 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84751 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84756 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84761 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84766 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /*  84769 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84771 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84774 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84778 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  84781 */       GIR_RootConstrainSelectedInstOperands,
     /*  84782 */       // GIR_Coverage, 2565,
     /*  84782 */       GIR_EraseRootFromParent_Done,
     /*  84783 */     // Label 1408: @84783
     /*  84783 */     GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(84906), // Rule ID 6262 //
     /*  84788 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84791 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84795 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84799 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84803 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84807 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84811 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  84815 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84819 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84824 */       // MIs[2] imm
     /*  84824 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84828 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84832 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  84836 */       // MIs[3] Operand 1
     /*  84836 */       // No operand predicates
     /*  84836 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84838 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  84838 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84841 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84845 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84850 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84852 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84855 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84859 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84864 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84867 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84871 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84874 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84879 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84884 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84889 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  84892 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84894 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84897 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  84901 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  84904 */       GIR_RootConstrainSelectedInstOperands,
     /*  84905 */       // GIR_Coverage, 6262,
     /*  84905 */       GIR_EraseRootFromParent_Done,
     /*  84906 */     // Label 1409: @84906
     /*  84906 */     GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(85026), // Rule ID 6300 //
     /*  84911 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84915 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84919 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84923 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84927 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84931 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84935 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84939 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84944 */       // MIs[2] imm
     /*  84944 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84948 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84952 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  84956 */       // MIs[3] Operand 1
     /*  84956 */       // No operand predicates
     /*  84956 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84958 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  84958 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84961 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84965 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84970 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84972 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84975 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84979 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84984 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84987 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84991 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84994 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84999 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85004 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85009 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  85012 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85014 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85017 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  85021 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  85024 */       GIR_RootConstrainSelectedInstOperands,
     /*  85025 */       // GIR_Coverage, 6300,
     /*  85025 */       GIR_EraseRootFromParent_Done,
     /*  85026 */     // Label 1410: @85026
     /*  85026 */     GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(85143), // Rule ID 2490 //
     /*  85031 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85034 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85038 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85042 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85046 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85049 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  85054 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85058 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85062 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85067 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85072 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85074 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85074 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85077 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85081 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85086 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85088 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85091 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85095 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85100 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85103 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85107 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85110 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85115 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85120 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85125 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  85128 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85130 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85133 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  85137 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  85141 */       GIR_RootConstrainSelectedInstOperands,
     /*  85142 */       // GIR_Coverage, 2490,
     /*  85142 */       GIR_EraseRootFromParent_Done,
     /*  85143 */     // Label 1411: @85143
     /*  85143 */     GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(85260), // Rule ID 5320 //
     /*  85148 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85151 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85155 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85159 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85163 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85166 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  85171 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85175 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85179 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85184 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85189 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85191 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85191 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85194 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85198 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85203 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85205 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85208 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85212 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85217 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85220 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85224 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85227 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85232 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85237 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85242 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  85245 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85247 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85250 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  85254 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  85258 */       GIR_RootConstrainSelectedInstOperands,
     /*  85259 */       // GIR_Coverage, 5320,
     /*  85259 */       GIR_EraseRootFromParent_Done,
     /*  85260 */     // Label 1412: @85260
     /*  85260 */     GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(85377), // Rule ID 5323 //
     /*  85265 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85268 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85272 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85276 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85280 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85283 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  85288 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85292 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85296 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85301 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85306 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85308 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85308 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85311 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85315 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85320 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85322 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85325 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85329 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85334 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85337 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85341 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85344 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85349 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85354 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85359 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  85362 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85364 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85367 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  85371 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  85375 */       GIR_RootConstrainSelectedInstOperands,
     /*  85376 */       // GIR_Coverage, 5323,
     /*  85376 */       GIR_EraseRootFromParent_Done,
     /*  85377 */     // Label 1413: @85377
     /*  85377 */     GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(85494), // Rule ID 5326 //
     /*  85382 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85385 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85389 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85393 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85397 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85400 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  85405 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85409 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85413 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85418 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85423 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85425 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85425 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85428 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85432 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85437 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85439 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85442 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85446 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85451 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85454 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85458 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85461 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85466 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85471 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85476 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /*  85479 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85481 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85484 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  85488 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  85492 */       GIR_RootConstrainSelectedInstOperands,
     /*  85493 */       // GIR_Coverage, 5326,
     /*  85493 */       GIR_EraseRootFromParent_Done,
     /*  85494 */     // Label 1414: @85494
     /*  85494 */     GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(85550), // Rule ID 5467 //
     /*  85499 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85503 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85507 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85511 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85516 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85520 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85524 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85528 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85533 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85535 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  85535 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /*  85538 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  85540 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  85544 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  85548 */       GIR_RootConstrainSelectedInstOperands,
     /*  85549 */       // GIR_Coverage, 5467,
     /*  85549 */       GIR_EraseRootFromParent_Done,
     /*  85550 */     // Label 1415: @85550
     /*  85550 */     GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(85616), // Rule ID 5767 //
     /*  85555 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85559 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85563 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85569 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  85571 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85573 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /*  85573 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  85576 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  85580 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85585 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  85589 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  85591 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85594 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85596 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85599 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85602 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  85605 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85610 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85615 */       // GIR_Coverage, 5767,
     /*  85615 */       GIR_EraseRootFromParent_Done,
     /*  85616 */     // Label 1416: @85616
     /*  85616 */     GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(85712), // Rule ID 4938 //
     /*  85621 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85624 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85628 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85632 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85636 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85640 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85645 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85647 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /*  85647 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85650 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85654 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85659 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85661 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85664 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85668 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85673 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85676 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85680 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85683 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85688 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85693 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85698 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /*  85701 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85703 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85706 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  85710 */       GIR_RootConstrainSelectedInstOperands,
     /*  85711 */       // GIR_Coverage, 4938,
     /*  85711 */       GIR_EraseRootFromParent_Done,
     /*  85712 */     // Label 1417: @85712
     /*  85712 */     GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(85774), // Rule ID 5768 //
     /*  85717 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85721 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85725 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  85729 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85731 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /*  85731 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  85734 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85738 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85743 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  85745 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85748 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85750 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85753 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  85755 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  85758 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85763 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85768 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85773 */       // GIR_Coverage, 5768,
     /*  85773 */       GIR_EraseRootFromParent_Done,
     /*  85774 */     // Label 1418: @85774
     /*  85774 */     GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(85908), // Rule ID 5766 //
     /*  85779 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85783 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85787 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  85787 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  85790 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85794 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85799 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  85801 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  85804 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85808 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85813 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  85816 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  85820 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  85823 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85828 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85833 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85838 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85841 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85845 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85850 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85852 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85855 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85859 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85864 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85867 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85871 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85874 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85879 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85884 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85889 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  85892 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85894 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85897 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  85900 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  85903 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85906 */       GIR_RootConstrainSelectedInstOperands,
     /*  85907 */       // GIR_Coverage, 5766,
     /*  85907 */       GIR_EraseRootFromParent_Done,
     /*  85908 */     // Label 1419: @85908
     /*  85908 */     GIM_Reject,
     /*  85909 */   // Label 1401: @85909
     /*  85909 */   GIM_Reject,
     /*  85910 */   // Label 1336: @85910
     /*  85910 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(85935), // Rule ID 9002 //
     /*  85915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  85918 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  85921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  85924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  85928 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /*  85928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /*  85933 */     GIR_RootConstrainSelectedInstOperands,
     /*  85934 */     // GIR_Coverage, 9002,
     /*  85934 */     GIR_Done,
     /*  85935 */   // Label 1420: @85935
     /*  85935 */   GIM_Reject,
     /*  85936 */   // Label 1337: @85936
     /*  85936 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(85961), // Rule ID 9003 //
     /*  85941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  85944 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  85947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  85950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  85954 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /*  85954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /*  85959 */     GIR_RootConstrainSelectedInstOperands,
     /*  85960 */     // GIR_Coverage, 9003,
     /*  85960 */     GIR_Done,
     /*  85961 */   // Label 1421: @85961
     /*  85961 */   GIM_Reject,
     /*  85962 */   // Label 1338: @85962
     /*  85962 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(85987), // Rule ID 9006 //
     /*  85967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  85970 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  85973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  85976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  85980 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /*  85980 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  85985 */     GIR_RootConstrainSelectedInstOperands,
     /*  85986 */     // GIR_Coverage, 9006,
     /*  85986 */     GIR_Done,
     /*  85987 */   // Label 1422: @85987
     /*  85987 */   GIM_Reject,
     /*  85988 */   // Label 1339: @85988
     /*  85988 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(86013), // Rule ID 9008 //
     /*  85993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  85996 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  85999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  86002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  86006 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /*  86006 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  86011 */     GIR_RootConstrainSelectedInstOperands,
     /*  86012 */     // GIR_Coverage, 9008,
     /*  86012 */     GIR_Done,
     /*  86013 */   // Label 1423: @86013
     /*  86013 */   GIM_Reject,
     /*  86014 */   // Label 1340: @86014
     /*  86014 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(86039), // Rule ID 9004 //
     /*  86019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86022 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  86025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  86028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  86032 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /*  86032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /*  86037 */     GIR_RootConstrainSelectedInstOperands,
     /*  86038 */     // GIR_Coverage, 9004,
     /*  86038 */     GIR_Done,
     /*  86039 */   // Label 1424: @86039
     /*  86039 */   GIM_Reject,
     /*  86040 */   // Label 1341: @86040
     /*  86040 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(86065), // Rule ID 9007 //
     /*  86045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86048 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  86051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  86054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  86058 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /*  86058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /*  86063 */     GIR_RootConstrainSelectedInstOperands,
     /*  86064 */     // GIR_Coverage, 9007,
     /*  86064 */     GIR_Done,
     /*  86065 */   // Label 1425: @86065
     /*  86065 */   GIM_Reject,
     /*  86066 */   // Label 1342: @86066
     /*  86066 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(86091), // Rule ID 9005 //
     /*  86071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86074 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  86077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  86080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  86084 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /*  86084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /*  86089 */     GIR_RootConstrainSelectedInstOperands,
     /*  86090 */     // GIR_Coverage, 9005,
     /*  86090 */     GIR_Done,
     /*  86091 */   // Label 1426: @86091
     /*  86091 */   GIM_Reject,
     /*  86092 */   // Label 1343: @86092
     /*  86092 */   GIM_Reject,
     /*  86093 */ // Label 1331: @86093
     /*  86093 */ GIM_Reject,
     /*  86094 */ // Label 9: @86094
     /*  86094 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1441*/ GIMT_Encode4(96037),
     /*  86105 */ /*GILLT_s32*//*Label 1427*/ GIMT_Encode4(86193),
     /*  86109 */ /*GILLT_s64*//*Label 1428*/ GIMT_Encode4(86574),
     /*  86113 */ /*GILLT_s128*//*Label 1429*/ GIMT_Encode4(88549),
     /*  86117 */ /*GILLT_v2s32*//*Label 1430*/ GIMT_Encode4(89195),
     /*  86121 */ /*GILLT_v2s64*//*Label 1431*/ GIMT_Encode4(90110),
     /*  86125 */ /*GILLT_v4s16*//*Label 1432*/ GIMT_Encode4(90879),
     /*  86129 */ /*GILLT_v4s32*//*Label 1433*/ GIMT_Encode4(91794),
     /*  86133 */ /*GILLT_v8s8*//*Label 1434*/ GIMT_Encode4(92639),
     /*  86137 */ /*GILLT_v8s16*//*Label 1435*/ GIMT_Encode4(93200),
     /*  86141 */ /*GILLT_v16s8*//*Label 1436*/ GIMT_Encode4(94045), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  86161 */ /*GILLT_nxv2s64*//*Label 1437*/ GIMT_Encode4(94497), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  86173 */ /*GILLT_nxv4s32*//*Label 1438*/ GIMT_Encode4(94946), GIMT_Encode4(0),
     /*  86181 */ /*GILLT_nxv8s16*//*Label 1439*/ GIMT_Encode4(95395), GIMT_Encode4(0),
     /*  86189 */ /*GILLT_nxv16s8*//*Label 1440*/ GIMT_Encode4(95844),
     /*  86193 */ // Label 1427: @86193
     /*  86193 */ GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(86573),
     /*  86198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  86201 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(86271), // Rule ID 7013 //
     /*  86206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  86210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86218 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86221 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86228 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  86231 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  86244 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15811>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  86244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  86247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  86249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  86254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  86259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  86264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86269 */     GIR_RootConstrainSelectedInstOperands,
     /*  86270 */     // GIR_Coverage, 7013,
     /*  86270 */     GIR_EraseRootFromParent_Done,
     /*  86271 */   // Label 1443: @86271
     /*  86271 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(86341), // Rule ID 7014 //
     /*  86276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  86280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86288 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86291 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86298 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  86301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  86314 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15811>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  86314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  86317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  86319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  86324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  86329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  86334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86339 */     GIR_RootConstrainSelectedInstOperands,
     /*  86340 */     // GIR_Coverage, 7014,
     /*  86340 */     GIR_EraseRootFromParent_Done,
     /*  86341 */   // Label 1444: @86341
     /*  86341 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(86406), // Rule ID 7015 //
     /*  86346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  86350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86358 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86361 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86368 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  86371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  86384 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15811>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  86384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  86387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  86389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  86394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86404 */     GIR_RootConstrainSelectedInstOperands,
     /*  86405 */     // GIR_Coverage, 7015,
     /*  86405 */     GIR_EraseRootFromParent_Done,
     /*  86406 */   // Label 1445: @86406
     /*  86406 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(86471), // Rule ID 7016 //
     /*  86411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  86415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86423 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86426 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86433 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  86436 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  86449 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15811>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  86449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  86452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  86454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  86459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86469 */     GIR_RootConstrainSelectedInstOperands,
     /*  86470 */     // GIR_Coverage, 7016,
     /*  86470 */     GIR_EraseRootFromParent_Done,
     /*  86471 */   // Label 1446: @86471
     /*  86471 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(86524), // Rule ID 5733 //
     /*  86476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  86480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  86488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  86492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  86496 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  86500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86502 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /*  86502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86507 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /*  86513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  86518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86523 */     // GIR_Coverage, 5733,
     /*  86523 */     GIR_EraseRootFromParent_Done,
     /*  86524 */   // Label 1447: @86524
     /*  86524 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(86548), // Rule ID 6626 //
     /*  86529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  86533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86537 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /*  86537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  86547 */     // GIR_Coverage, 6626,
     /*  86547 */     GIR_Done,
     /*  86548 */   // Label 1448: @86548
     /*  86548 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(86572), // Rule ID 6627 //
     /*  86553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  86561 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /*  86561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86566 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86571 */     // GIR_Coverage, 6627,
     /*  86571 */     GIR_Done,
     /*  86572 */   // Label 1449: @86572
     /*  86572 */   GIM_Reject,
     /*  86573 */ // Label 1442: @86573
     /*  86573 */ GIM_Reject,
     /*  86574 */ // Label 1428: @86574
     /*  86574 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(86647), // Rule ID 7017 //
     /*  86579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86586 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86590 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86594 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86597 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  86604 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  86607 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86611 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86613 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  86620 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15819>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  86620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  86623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  86625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  86630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  86635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  86640 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86645 */   GIR_RootConstrainSelectedInstOperands,
     /*  86646 */   // GIR_Coverage, 7017,
     /*  86646 */   GIR_EraseRootFromParent_Done,
     /*  86647 */ // Label 1450: @86647
     /*  86647 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(86720), // Rule ID 7018 //
     /*  86652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86659 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86663 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86667 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86670 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  86677 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  86680 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86684 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86686 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  86693 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15819>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  86693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  86696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  86698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  86703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  86708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  86713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86718 */   GIR_RootConstrainSelectedInstOperands,
     /*  86719 */   // GIR_Coverage, 7018,
     /*  86719 */   GIR_EraseRootFromParent_Done,
     /*  86720 */ // Label 1451: @86720
     /*  86720 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(86788), // Rule ID 7019 //
     /*  86725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86732 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86740 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86743 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  86750 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  86753 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86757 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86759 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  86766 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15819>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  86766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  86769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  86771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  86776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86781 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86786 */   GIR_RootConstrainSelectedInstOperands,
     /*  86787 */   // GIR_Coverage, 7019,
     /*  86787 */   GIR_EraseRootFromParent_Done,
     /*  86788 */ // Label 1452: @86788
     /*  86788 */ GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(86856), // Rule ID 7020 //
     /*  86793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86800 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86804 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86808 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86811 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  86818 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  86821 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86825 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86827 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  86834 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15819>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  86834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  86837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  86839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  86844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  86849 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86854 */   GIR_RootConstrainSelectedInstOperands,
     /*  86855 */   // GIR_Coverage, 7020,
     /*  86855 */   GIR_EraseRootFromParent_Done,
     /*  86856 */ // Label 1453: @86856
     /*  86856 */ GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(86912), // Rule ID 5735 //
     /*  86861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86868 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  86876 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  86880 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  86884 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  86888 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86890 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /*  86890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86895 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /*  86901 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86906 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86911 */   // GIR_Coverage, 5735,
     /*  86911 */   GIR_EraseRootFromParent_Done,
     /*  86912 */ // Label 1454: @86912
     /*  86912 */ GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(86942), // Rule ID 6601 //
     /*  86917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  86923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86931 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /*  86931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86936 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86941 */   // GIR_Coverage, 6601,
     /*  86941 */   GIR_Done,
     /*  86942 */ // Label 1455: @86942
     /*  86942 */ GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(86972), // Rule ID 6602 //
     /*  86947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  86953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86961 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /*  86961 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86966 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86971 */   // GIR_Coverage, 6602,
     /*  86971 */   GIR_Done,
     /*  86972 */ // Label 1456: @86972
     /*  86972 */ GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(87002), // Rule ID 6603 //
     /*  86977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  86980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  86983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86991 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /*  86991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86996 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87001 */   // GIR_Coverage, 6603,
     /*  87001 */   GIR_Done,
     /*  87002 */ // Label 1457: @87002
     /*  87002 */ GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(87032), // Rule ID 6604 //
     /*  87007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87021 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /*  87021 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87026 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87031 */   // GIR_Coverage, 6604,
     /*  87031 */   GIR_Done,
     /*  87032 */ // Label 1458: @87032
     /*  87032 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(87062), // Rule ID 6605 //
     /*  87037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87051 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /*  87051 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87061 */   // GIR_Coverage, 6605,
     /*  87061 */   GIR_Done,
     /*  87062 */ // Label 1459: @87062
     /*  87062 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(87092), // Rule ID 6606 //
     /*  87067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87081 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  87081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87086 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87091 */   // GIR_Coverage, 6606,
     /*  87091 */   GIR_Done,
     /*  87092 */ // Label 1460: @87092
     /*  87092 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(87142), // Rule ID 6612 //
     /*  87097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  87103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87111 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /*  87111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87123 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  87135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87137 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87140 */   GIR_RootConstrainSelectedInstOperands,
     /*  87141 */   // GIR_Coverage, 6612,
     /*  87141 */   GIR_EraseRootFromParent_Done,
     /*  87142 */ // Label 1461: @87142
     /*  87142 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(87192), // Rule ID 6613 //
     /*  87147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87161 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /*  87161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87173 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87177 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  87185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87187 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87190 */   GIR_RootConstrainSelectedInstOperands,
     /*  87191 */   // GIR_Coverage, 6613,
     /*  87191 */   GIR_EraseRootFromParent_Done,
     /*  87192 */ // Label 1462: @87192
     /*  87192 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(87242), // Rule ID 6614 //
     /*  87197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87211 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /*  87211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87223 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87227 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87240 */   GIR_RootConstrainSelectedInstOperands,
     /*  87241 */   // GIR_Coverage, 6614,
     /*  87241 */   GIR_EraseRootFromParent_Done,
     /*  87242 */ // Label 1463: @87242
     /*  87242 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(87292), // Rule ID 6615 //
     /*  87247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87261 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /*  87261 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87264 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87268 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87273 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87277 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  87285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87290 */   GIR_RootConstrainSelectedInstOperands,
     /*  87291 */   // GIR_Coverage, 6615,
     /*  87291 */   GIR_EraseRootFromParent_Done,
     /*  87292 */ // Label 1464: @87292
     /*  87292 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(87342), // Rule ID 6616 //
     /*  87297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87311 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /*  87311 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87314 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87318 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87323 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87327 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87337 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87340 */   GIR_RootConstrainSelectedInstOperands,
     /*  87341 */   // GIR_Coverage, 6616,
     /*  87341 */   GIR_EraseRootFromParent_Done,
     /*  87342 */ // Label 1465: @87342
     /*  87342 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(87369), // Rule ID 6617 //
     /*  87347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87358 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  87358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87363 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87368 */   // GIR_Coverage, 6617,
     /*  87368 */   GIR_Done,
     /*  87369 */ // Label 1466: @87369
     /*  87369 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(87396), // Rule ID 6618 //
     /*  87374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87385 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  87385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87390 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87395 */   // GIR_Coverage, 6618,
     /*  87395 */   GIR_Done,
     /*  87396 */ // Label 1467: @87396
     /*  87396 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(87423), // Rule ID 6619 //
     /*  87401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87412 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /*  87412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87422 */   // GIR_Coverage, 6619,
     /*  87422 */   GIR_Done,
     /*  87423 */ // Label 1468: @87423
     /*  87423 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(87450), // Rule ID 6628 //
     /*  87428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87439 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  87439 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87444 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87449 */   // GIR_Coverage, 6628,
     /*  87449 */   GIR_Done,
     /*  87450 */ // Label 1469: @87450
     /*  87450 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(87477), // Rule ID 6629 //
     /*  87455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87466 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /*  87466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87471 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87476 */   // GIR_Coverage, 6629,
     /*  87476 */   GIR_Done,
     /*  87477 */ // Label 1470: @87477
     /*  87477 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(87504), // Rule ID 6630 //
     /*  87482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87493 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  87493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87498 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87503 */   // GIR_Coverage, 6630,
     /*  87503 */   GIR_Done,
     /*  87504 */ // Label 1471: @87504
     /*  87504 */ GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(87536), // Rule ID 6631 //
     /*  87509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87523 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  87523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87526 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87528 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87530 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87535 */   // GIR_Coverage, 6631,
     /*  87535 */   GIR_EraseRootFromParent_Done,
     /*  87536 */ // Label 1472: @87536
     /*  87536 */ GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(87568), // Rule ID 6632 //
     /*  87541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87555 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  87555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87558 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87560 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87562 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87567 */   // GIR_Coverage, 6632,
     /*  87567 */   GIR_EraseRootFromParent_Done,
     /*  87568 */ // Label 1473: @87568
     /*  87568 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(87600), // Rule ID 6633 //
     /*  87573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  87579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87587 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  87587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87590 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87592 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87599 */   // GIR_Coverage, 6633,
     /*  87599 */   GIR_EraseRootFromParent_Done,
     /*  87600 */ // Label 1474: @87600
     /*  87600 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(87632), // Rule ID 6634 //
     /*  87605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87619 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  87619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87622 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87624 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87626 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87631 */   // GIR_Coverage, 6634,
     /*  87631 */   GIR_EraseRootFromParent_Done,
     /*  87632 */ // Label 1475: @87632
     /*  87632 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(87664), // Rule ID 6635 //
     /*  87637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87651 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  87651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87654 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87656 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87658 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87663 */   // GIR_Coverage, 6635,
     /*  87663 */   GIR_EraseRootFromParent_Done,
     /*  87664 */ // Label 1476: @87664
     /*  87664 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(87690), // Rule ID 6636 //
     /*  87669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87683 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /*  87683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87688 */   GIR_RootConstrainSelectedInstOperands,
     /*  87689 */   // GIR_Coverage, 6636,
     /*  87689 */   GIR_Done,
     /*  87690 */ // Label 1477: @87690
     /*  87690 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(87716), // Rule ID 6637 //
     /*  87695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87709 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /*  87709 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  87714 */   GIR_RootConstrainSelectedInstOperands,
     /*  87715 */   // GIR_Coverage, 6637,
     /*  87715 */   GIR_Done,
     /*  87716 */ // Label 1478: @87716
     /*  87716 */ GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(87742), // Rule ID 6638 //
     /*  87721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  87727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87735 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /*  87735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  87740 */   GIR_RootConstrainSelectedInstOperands,
     /*  87741 */   // GIR_Coverage, 6638,
     /*  87741 */   GIR_Done,
     /*  87742 */ // Label 1479: @87742
     /*  87742 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(87768), // Rule ID 6639 //
     /*  87747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87761 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /*  87761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  87766 */   GIR_RootConstrainSelectedInstOperands,
     /*  87767 */   // GIR_Coverage, 6639,
     /*  87767 */   GIR_Done,
     /*  87768 */ // Label 1480: @87768
     /*  87768 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(87794), // Rule ID 6640 //
     /*  87773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87787 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /*  87787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87792 */   GIR_RootConstrainSelectedInstOperands,
     /*  87793 */   // GIR_Coverage, 6640,
     /*  87793 */   GIR_Done,
     /*  87794 */ // Label 1481: @87794
     /*  87794 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(87823), // Rule ID 6641 //
     /*  87799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87810 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  87810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87813 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87815 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87817 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87822 */   // GIR_Coverage, 6641,
     /*  87822 */   GIR_EraseRootFromParent_Done,
     /*  87823 */ // Label 1482: @87823
     /*  87823 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(87852), // Rule ID 6642 //
     /*  87828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87839 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  87839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87842 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87844 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87846 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87851 */   // GIR_Coverage, 6642,
     /*  87851 */   GIR_EraseRootFromParent_Done,
     /*  87852 */ // Label 1483: @87852
     /*  87852 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(87884), // Rule ID 6696 //
     /*  87857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87871 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  87871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87874 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87876 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87878 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87883 */   // GIR_Coverage, 6696,
     /*  87883 */   GIR_EraseRootFromParent_Done,
     /*  87884 */ // Label 1484: @87884
     /*  87884 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(87916), // Rule ID 6697 //
     /*  87889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87903 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  87903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87906 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87908 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87915 */   // GIR_Coverage, 6697,
     /*  87915 */   GIR_EraseRootFromParent_Done,
     /*  87916 */ // Label 1485: @87916
     /*  87916 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(87948), // Rule ID 6698 //
     /*  87921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87935 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  87935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87938 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87940 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87947 */   // GIR_Coverage, 6698,
     /*  87947 */   GIR_EraseRootFromParent_Done,
     /*  87948 */ // Label 1486: @87948
     /*  87948 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(87980), // Rule ID 6699 //
     /*  87953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  87959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87967 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  87967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87970 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  87972 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  87974 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87979 */   // GIR_Coverage, 6699,
     /*  87979 */   GIR_EraseRootFromParent_Done,
     /*  87980 */ // Label 1487: @87980
     /*  87980 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(88012), // Rule ID 6700 //
     /*  87985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87999 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  87999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88002 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88004 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88011 */   // GIR_Coverage, 6700,
     /*  88011 */   GIR_EraseRootFromParent_Done,
     /*  88012 */ // Label 1488: @88012
     /*  88012 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(88038), // Rule ID 6701 //
     /*  88017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88031 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /*  88031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88036 */   GIR_RootConstrainSelectedInstOperands,
     /*  88037 */   // GIR_Coverage, 6701,
     /*  88037 */   GIR_Done,
     /*  88038 */ // Label 1489: @88038
     /*  88038 */ GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(88064), // Rule ID 6702 //
     /*  88043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88057 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /*  88057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88062 */   GIR_RootConstrainSelectedInstOperands,
     /*  88063 */   // GIR_Coverage, 6702,
     /*  88063 */   GIR_Done,
     /*  88064 */ // Label 1490: @88064
     /*  88064 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(88090), // Rule ID 6703 //
     /*  88069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88083 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /*  88083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88088 */   GIR_RootConstrainSelectedInstOperands,
     /*  88089 */   // GIR_Coverage, 6703,
     /*  88089 */   GIR_Done,
     /*  88090 */ // Label 1491: @88090
     /*  88090 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(88116), // Rule ID 6704 //
     /*  88095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88109 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /*  88109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  88114 */   GIR_RootConstrainSelectedInstOperands,
     /*  88115 */   // GIR_Coverage, 6704,
     /*  88115 */   GIR_Done,
     /*  88116 */ // Label 1492: @88116
     /*  88116 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(88142), // Rule ID 6705 //
     /*  88121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88135 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /*  88135 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88140 */   GIR_RootConstrainSelectedInstOperands,
     /*  88141 */   // GIR_Coverage, 6705,
     /*  88141 */   GIR_Done,
     /*  88142 */ // Label 1493: @88142
     /*  88142 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(88171), // Rule ID 6706 //
     /*  88147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88158 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88161 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88163 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88170 */   // GIR_Coverage, 6706,
     /*  88170 */   GIR_EraseRootFromParent_Done,
     /*  88171 */ // Label 1494: @88171
     /*  88171 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(88200), // Rule ID 6707 //
     /*  88176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88187 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88190 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88192 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88194 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88199 */   // GIR_Coverage, 6707,
     /*  88199 */   GIR_EraseRootFromParent_Done,
     /*  88200 */ // Label 1495: @88200
     /*  88200 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(88232), // Rule ID 6708 //
     /*  88205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88219 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  88219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88222 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88224 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88226 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88231 */   // GIR_Coverage, 6708,
     /*  88231 */   GIR_EraseRootFromParent_Done,
     /*  88232 */ // Label 1496: @88232
     /*  88232 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(88264), // Rule ID 6709 //
     /*  88237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88251 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  88251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88254 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88256 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88258 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88263 */   // GIR_Coverage, 6709,
     /*  88263 */   GIR_EraseRootFromParent_Done,
     /*  88264 */ // Label 1497: @88264
     /*  88264 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(88296), // Rule ID 6710 //
     /*  88269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88283 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  88283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88286 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88288 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88290 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88295 */   // GIR_Coverage, 6710,
     /*  88295 */   GIR_EraseRootFromParent_Done,
     /*  88296 */ // Label 1498: @88296
     /*  88296 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(88328), // Rule ID 6711 //
     /*  88301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88315 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  88315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88318 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88320 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88327 */   // GIR_Coverage, 6711,
     /*  88327 */   GIR_EraseRootFromParent_Done,
     /*  88328 */ // Label 1499: @88328
     /*  88328 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(88360), // Rule ID 6712 //
     /*  88333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88347 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  88347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88350 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88352 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88354 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88359 */   // GIR_Coverage, 6712,
     /*  88359 */   GIR_EraseRootFromParent_Done,
     /*  88360 */ // Label 1500: @88360
     /*  88360 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(88386), // Rule ID 6713 //
     /*  88365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88379 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /*  88379 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88384 */   GIR_RootConstrainSelectedInstOperands,
     /*  88385 */   // GIR_Coverage, 6713,
     /*  88385 */   GIR_Done,
     /*  88386 */ // Label 1501: @88386
     /*  88386 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(88412), // Rule ID 6714 //
     /*  88391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88405 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /*  88405 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88410 */   GIR_RootConstrainSelectedInstOperands,
     /*  88411 */   // GIR_Coverage, 6714,
     /*  88411 */   GIR_Done,
     /*  88412 */ // Label 1502: @88412
     /*  88412 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(88438), // Rule ID 6715 //
     /*  88417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88431 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /*  88431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  88436 */   GIR_RootConstrainSelectedInstOperands,
     /*  88437 */   // GIR_Coverage, 6715,
     /*  88437 */   GIR_Done,
     /*  88438 */ // Label 1503: @88438
     /*  88438 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(88464), // Rule ID 6716 //
     /*  88443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88457 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /*  88457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88462 */   GIR_RootConstrainSelectedInstOperands,
     /*  88463 */   // GIR_Coverage, 6716,
     /*  88463 */   GIR_Done,
     /*  88464 */ // Label 1504: @88464
     /*  88464 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(88490), // Rule ID 6717 //
     /*  88469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88483 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /*  88483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88488 */   GIR_RootConstrainSelectedInstOperands,
     /*  88489 */   // GIR_Coverage, 6717,
     /*  88489 */   GIR_Done,
     /*  88490 */ // Label 1505: @88490
     /*  88490 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(88519), // Rule ID 6718 //
     /*  88495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88506 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  88506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88509 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88511 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88513 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88518 */   // GIR_Coverage, 6718,
     /*  88518 */   GIR_EraseRootFromParent_Done,
     /*  88519 */ // Label 1506: @88519
     /*  88519 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(88548), // Rule ID 6719 //
     /*  88524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88535 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  88535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88538 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88540 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88542 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88547 */   // GIR_Coverage, 6719,
     /*  88547 */   GIR_EraseRootFromParent_Done,
     /*  88548 */ // Label 1507: @88548
     /*  88548 */ GIM_Reject,
     /*  88549 */ // Label 1429: @88549
     /*  88549 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(88581), // Rule ID 6733 //
     /*  88554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88568 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  88568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88571 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88573 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88580 */   // GIR_Coverage, 6733,
     /*  88580 */   GIR_EraseRootFromParent_Done,
     /*  88581 */ // Label 1508: @88581
     /*  88581 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(88613), // Rule ID 6734 //
     /*  88586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  88592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88600 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  88600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88603 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88605 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88607 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88612 */   // GIR_Coverage, 6734,
     /*  88612 */   GIR_EraseRootFromParent_Done,
     /*  88613 */ // Label 1509: @88613
     /*  88613 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(88645), // Rule ID 6735 //
     /*  88618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  88624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88632 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  88632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88635 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88637 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88639 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88644 */   // GIR_Coverage, 6735,
     /*  88644 */   GIR_EraseRootFromParent_Done,
     /*  88645 */ // Label 1510: @88645
     /*  88645 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(88677), // Rule ID 6736 //
     /*  88650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88664 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  88664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88667 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88669 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88671 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88676 */   // GIR_Coverage, 6736,
     /*  88676 */   GIR_EraseRootFromParent_Done,
     /*  88677 */ // Label 1511: @88677
     /*  88677 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(88709), // Rule ID 6737 //
     /*  88682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  88688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88696 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  88696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88699 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88701 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88703 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88708 */   // GIR_Coverage, 6737,
     /*  88708 */   GIR_EraseRootFromParent_Done,
     /*  88709 */ // Label 1512: @88709
     /*  88709 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(88741), // Rule ID 6738 //
     /*  88714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  88720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88728 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  88728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88731 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88733 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88735 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88740 */   // GIR_Coverage, 6738,
     /*  88740 */   GIR_EraseRootFromParent_Done,
     /*  88741 */ // Label 1513: @88741
     /*  88741 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(88773), // Rule ID 6739 //
     /*  88746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  88752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88760 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  88760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88763 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88765 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88767 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88772 */   // GIR_Coverage, 6739,
     /*  88772 */   GIR_EraseRootFromParent_Done,
     /*  88773 */ // Label 1514: @88773
     /*  88773 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(88806), // Rule ID 6740 //
     /*  88778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88792 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /*  88792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  88795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88797 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88799 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  88804 */   GIR_RootConstrainSelectedInstOperands,
     /*  88805 */   // GIR_Coverage, 6740,
     /*  88805 */   GIR_EraseRootFromParent_Done,
     /*  88806 */ // Label 1515: @88806
     /*  88806 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(88877), // Rule ID 6741 //
     /*  88811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  88817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88825 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /*  88825 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  88828 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  88832 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88837 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  88841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  88843 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  88846 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  88850 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88855 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  88859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  88861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  88864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  88875 */   GIR_RootConstrainSelectedInstOperands,
     /*  88876 */   // GIR_Coverage, 6741,
     /*  88876 */   GIR_EraseRootFromParent_Done,
     /*  88877 */ // Label 1516: @88877
     /*  88877 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(88948), // Rule ID 6742 //
     /*  88882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  88888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88896 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /*  88896 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  88899 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  88903 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88908 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  88912 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  88914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  88917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  88921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88926 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  88930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  88932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  88935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88937 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88940 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  88946 */   GIR_RootConstrainSelectedInstOperands,
     /*  88947 */   // GIR_Coverage, 6742,
     /*  88947 */   GIR_EraseRootFromParent_Done,
     /*  88948 */ // Label 1517: @88948
     /*  88948 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(89019), // Rule ID 6743 //
     /*  88953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  88959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88967 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /*  88967 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  88970 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  88974 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88979 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  88983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  88985 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  88988 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  88992 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88997 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89017 */   GIR_RootConstrainSelectedInstOperands,
     /*  89018 */   // GIR_Coverage, 6743,
     /*  89018 */   GIR_EraseRootFromParent_Done,
     /*  89019 */ // Label 1518: @89019
     /*  89019 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(89052), // Rule ID 6744 //
     /*  89024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89038 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /*  89038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89043 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89045 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89050 */   GIR_RootConstrainSelectedInstOperands,
     /*  89051 */   // GIR_Coverage, 6744,
     /*  89051 */   GIR_EraseRootFromParent_Done,
     /*  89052 */ // Label 1519: @89052
     /*  89052 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(89123), // Rule ID 6745 //
     /*  89057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89071 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /*  89071 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89074 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89078 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89083 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89089 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89092 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89096 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89101 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89112 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89115 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89121 */   GIR_RootConstrainSelectedInstOperands,
     /*  89122 */   // GIR_Coverage, 6745,
     /*  89122 */   GIR_EraseRootFromParent_Done,
     /*  89123 */ // Label 1520: @89123
     /*  89123 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(89194), // Rule ID 6746 //
     /*  89128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89142 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /*  89142 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89145 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  89149 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89154 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  89167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89172 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89192 */   GIR_RootConstrainSelectedInstOperands,
     /*  89193 */   // GIR_Coverage, 6746,
     /*  89193 */   GIR_EraseRootFromParent_Done,
     /*  89194 */ // Label 1521: @89194
     /*  89194 */ GIM_Reject,
     /*  89195 */ // Label 1430: @89195
     /*  89195 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(89225), // Rule ID 6598 //
     /*  89200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89214 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  89214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89224 */   // GIR_Coverage, 6598,
     /*  89224 */   GIR_Done,
     /*  89225 */ // Label 1522: @89225
     /*  89225 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(89255), // Rule ID 6600 //
     /*  89230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89244 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  89244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89249 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89254 */   // GIR_Coverage, 6600,
     /*  89254 */   GIR_Done,
     /*  89255 */ // Label 1523: @89255
     /*  89255 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(89305), // Rule ID 6609 //
     /*  89260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89274 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  89274 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  89277 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89281 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89286 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  89290 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89300 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89303 */   GIR_RootConstrainSelectedInstOperands,
     /*  89304 */   // GIR_Coverage, 6609,
     /*  89304 */   GIR_EraseRootFromParent_Done,
     /*  89305 */ // Label 1524: @89305
     /*  89305 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(89355), // Rule ID 6611 //
     /*  89310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89324 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  89324 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  89327 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89331 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89336 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  89340 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89353 */   GIR_RootConstrainSelectedInstOperands,
     /*  89354 */   // GIR_Coverage, 6611,
     /*  89354 */   GIR_EraseRootFromParent_Done,
     /*  89355 */ // Label 1525: @89355
     /*  89355 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(89387), // Rule ID 6643 //
     /*  89360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89374 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  89374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89377 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89379 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89381 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89386 */   // GIR_Coverage, 6643,
     /*  89386 */   GIR_EraseRootFromParent_Done,
     /*  89387 */ // Label 1526: @89387
     /*  89387 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(89419), // Rule ID 6644 //
     /*  89392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89406 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  89406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89409 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89411 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89413 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89418 */   // GIR_Coverage, 6644,
     /*  89418 */   GIR_EraseRootFromParent_Done,
     /*  89419 */ // Label 1527: @89419
     /*  89419 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(89451), // Rule ID 6645 //
     /*  89424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89438 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  89438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89441 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89443 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89445 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89450 */   // GIR_Coverage, 6645,
     /*  89450 */   GIR_EraseRootFromParent_Done,
     /*  89451 */ // Label 1528: @89451
     /*  89451 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(89483), // Rule ID 6646 //
     /*  89456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89470 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  89470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89473 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89475 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89477 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89482 */   // GIR_Coverage, 6646,
     /*  89482 */   GIR_EraseRootFromParent_Done,
     /*  89483 */ // Label 1529: @89483
     /*  89483 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(89515), // Rule ID 6647 //
     /*  89488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89502 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  89502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89505 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89507 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89509 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89514 */   // GIR_Coverage, 6647,
     /*  89514 */   GIR_EraseRootFromParent_Done,
     /*  89515 */ // Label 1530: @89515
     /*  89515 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(89547), // Rule ID 6648 //
     /*  89520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89534 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  89534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89537 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89539 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89541 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89546 */   // GIR_Coverage, 6648,
     /*  89546 */   GIR_EraseRootFromParent_Done,
     /*  89547 */ // Label 1531: @89547
     /*  89547 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(89573), // Rule ID 6649 //
     /*  89552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89566 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /*  89566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89571 */   GIR_RootConstrainSelectedInstOperands,
     /*  89572 */   // GIR_Coverage, 6649,
     /*  89572 */   GIR_Done,
     /*  89573 */ // Label 1532: @89573
     /*  89573 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(89599), // Rule ID 6650 //
     /*  89578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89592 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /*  89592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  89597 */   GIR_RootConstrainSelectedInstOperands,
     /*  89598 */   // GIR_Coverage, 6650,
     /*  89598 */   GIR_Done,
     /*  89599 */ // Label 1533: @89599
     /*  89599 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(89625), // Rule ID 6651 //
     /*  89604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89618 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /*  89618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  89623 */   GIR_RootConstrainSelectedInstOperands,
     /*  89624 */   // GIR_Coverage, 6651,
     /*  89624 */   GIR_Done,
     /*  89625 */ // Label 1534: @89625
     /*  89625 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(89651), // Rule ID 6652 //
     /*  89630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89644 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /*  89644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89649 */   GIR_RootConstrainSelectedInstOperands,
     /*  89650 */   // GIR_Coverage, 6652,
     /*  89650 */   GIR_Done,
     /*  89651 */ // Label 1535: @89651
     /*  89651 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(89677), // Rule ID 6653 //
     /*  89656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89670 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /*  89670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89675 */   GIR_RootConstrainSelectedInstOperands,
     /*  89676 */   // GIR_Coverage, 6653,
     /*  89676 */   GIR_Done,
     /*  89677 */ // Label 1536: @89677
     /*  89677 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(89703), // Rule ID 6654 //
     /*  89682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89696 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /*  89696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  89701 */   GIR_RootConstrainSelectedInstOperands,
     /*  89702 */   // GIR_Coverage, 6654,
     /*  89702 */   GIR_Done,
     /*  89703 */ // Label 1537: @89703
     /*  89703 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(89732), // Rule ID 6655 //
     /*  89708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89719 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  89719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89722 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89724 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89726 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89731 */   // GIR_Coverage, 6655,
     /*  89731 */   GIR_EraseRootFromParent_Done,
     /*  89732 */ // Label 1538: @89732
     /*  89732 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(89764), // Rule ID 6720 //
     /*  89737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89751 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  89751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89754 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89756 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89758 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89763 */   // GIR_Coverage, 6720,
     /*  89763 */   GIR_EraseRootFromParent_Done,
     /*  89764 */ // Label 1539: @89764
     /*  89764 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(89796), // Rule ID 6721 //
     /*  89769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89783 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  89783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89786 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89788 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89790 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89795 */   // GIR_Coverage, 6721,
     /*  89795 */   GIR_EraseRootFromParent_Done,
     /*  89796 */ // Label 1540: @89796
     /*  89796 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(89828), // Rule ID 6722 //
     /*  89801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89815 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  89815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89818 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89820 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89822 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89827 */   // GIR_Coverage, 6722,
     /*  89827 */   GIR_EraseRootFromParent_Done,
     /*  89828 */ // Label 1541: @89828
     /*  89828 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(89860), // Rule ID 6723 //
     /*  89833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89847 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  89847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89850 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89852 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89854 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89859 */   // GIR_Coverage, 6723,
     /*  89859 */   GIR_EraseRootFromParent_Done,
     /*  89860 */ // Label 1542: @89860
     /*  89860 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(89892), // Rule ID 6724 //
     /*  89865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89879 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  89879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89882 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89884 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89886 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89891 */   // GIR_Coverage, 6724,
     /*  89891 */   GIR_EraseRootFromParent_Done,
     /*  89892 */ // Label 1543: @89892
     /*  89892 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(89924), // Rule ID 6725 //
     /*  89897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89911 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  89911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89914 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89916 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89918 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89923 */   // GIR_Coverage, 6725,
     /*  89923 */   GIR_EraseRootFromParent_Done,
     /*  89924 */ // Label 1544: @89924
     /*  89924 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(89950), // Rule ID 6726 //
     /*  89929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89943 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /*  89943 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89948 */   GIR_RootConstrainSelectedInstOperands,
     /*  89949 */   // GIR_Coverage, 6726,
     /*  89949 */   GIR_Done,
     /*  89950 */ // Label 1545: @89950
     /*  89950 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(89976), // Rule ID 6727 //
     /*  89955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89969 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /*  89969 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  89974 */   GIR_RootConstrainSelectedInstOperands,
     /*  89975 */   // GIR_Coverage, 6727,
     /*  89975 */   GIR_Done,
     /*  89976 */ // Label 1546: @89976
     /*  89976 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(90002), // Rule ID 6728 //
     /*  89981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89995 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /*  89995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90000 */   GIR_RootConstrainSelectedInstOperands,
     /*  90001 */   // GIR_Coverage, 6728,
     /*  90001 */   GIR_Done,
     /*  90002 */ // Label 1547: @90002
     /*  90002 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(90028), // Rule ID 6729 //
     /*  90007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90021 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /*  90021 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90026 */   GIR_RootConstrainSelectedInstOperands,
     /*  90027 */   // GIR_Coverage, 6729,
     /*  90027 */   GIR_Done,
     /*  90028 */ // Label 1548: @90028
     /*  90028 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(90054), // Rule ID 6730 //
     /*  90033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90047 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /*  90047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90052 */   GIR_RootConstrainSelectedInstOperands,
     /*  90053 */   // GIR_Coverage, 6730,
     /*  90053 */   GIR_Done,
     /*  90054 */ // Label 1549: @90054
     /*  90054 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(90080), // Rule ID 6731 //
     /*  90059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90073 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /*  90073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90078 */   GIR_RootConstrainSelectedInstOperands,
     /*  90079 */   // GIR_Coverage, 6731,
     /*  90079 */   GIR_Done,
     /*  90080 */ // Label 1550: @90080
     /*  90080 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(90109), // Rule ID 6732 //
     /*  90085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90096 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90099 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90101 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90103 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90108 */   // GIR_Coverage, 6732,
     /*  90108 */   GIR_EraseRootFromParent_Done,
     /*  90109 */ // Label 1551: @90109
     /*  90109 */ GIM_Reject,
     /*  90110 */ // Label 1431: @90110
     /*  90110 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(90142), // Rule ID 6747 //
     /*  90115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90129 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90132 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90134 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90141 */   // GIR_Coverage, 6747,
     /*  90141 */   GIR_EraseRootFromParent_Done,
     /*  90142 */ // Label 1552: @90142
     /*  90142 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(90174), // Rule ID 6748 //
     /*  90147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90161 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90164 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90166 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90168 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90173 */   // GIR_Coverage, 6748,
     /*  90173 */   GIR_EraseRootFromParent_Done,
     /*  90174 */ // Label 1553: @90174
     /*  90174 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(90206), // Rule ID 6749 //
     /*  90179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90193 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90196 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90198 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90200 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90205 */   // GIR_Coverage, 6749,
     /*  90205 */   GIR_EraseRootFromParent_Done,
     /*  90206 */ // Label 1554: @90206
     /*  90206 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(90238), // Rule ID 6750 //
     /*  90211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90225 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90228 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90230 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90232 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90237 */   // GIR_Coverage, 6750,
     /*  90237 */   GIR_EraseRootFromParent_Done,
     /*  90238 */ // Label 1555: @90238
     /*  90238 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(90270), // Rule ID 6751 //
     /*  90243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90257 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90260 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90262 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90264 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90269 */   // GIR_Coverage, 6751,
     /*  90269 */   GIR_EraseRootFromParent_Done,
     /*  90270 */ // Label 1556: @90270
     /*  90270 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(90302), // Rule ID 6752 //
     /*  90275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90289 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90292 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90294 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90296 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90301 */   // GIR_Coverage, 6752,
     /*  90301 */   GIR_EraseRootFromParent_Done,
     /*  90302 */ // Label 1557: @90302
     /*  90302 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(90335), // Rule ID 6753 //
     /*  90307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90321 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  90321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90326 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90328 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90333 */   GIR_RootConstrainSelectedInstOperands,
     /*  90334 */   // GIR_Coverage, 6753,
     /*  90334 */   GIR_EraseRootFromParent_Done,
     /*  90335 */ // Label 1558: @90335
     /*  90335 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(90361), // Rule ID 6754 //
     /*  90340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90354 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /*  90354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90359 */   GIR_RootConstrainSelectedInstOperands,
     /*  90360 */   // GIR_Coverage, 6754,
     /*  90360 */   GIR_Done,
     /*  90361 */ // Label 1559: @90361
     /*  90361 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(90387), // Rule ID 6755 //
     /*  90366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90380 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /*  90380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90385 */   GIR_RootConstrainSelectedInstOperands,
     /*  90386 */   // GIR_Coverage, 6755,
     /*  90386 */   GIR_Done,
     /*  90387 */ // Label 1560: @90387
     /*  90387 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(90413), // Rule ID 6756 //
     /*  90392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90406 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /*  90406 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90411 */   GIR_RootConstrainSelectedInstOperands,
     /*  90412 */   // GIR_Coverage, 6756,
     /*  90412 */   GIR_Done,
     /*  90413 */ // Label 1561: @90413
     /*  90413 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(90439), // Rule ID 6757 //
     /*  90418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90432 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /*  90432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  90437 */   GIR_RootConstrainSelectedInstOperands,
     /*  90438 */   // GIR_Coverage, 6757,
     /*  90438 */   GIR_Done,
     /*  90439 */ // Label 1562: @90439
     /*  90439 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(90465), // Rule ID 6758 //
     /*  90444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90458 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /*  90458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90463 */   GIR_RootConstrainSelectedInstOperands,
     /*  90464 */   // GIR_Coverage, 6758,
     /*  90464 */   GIR_Done,
     /*  90465 */ // Label 1563: @90465
     /*  90465 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(90494), // Rule ID 6759 //
     /*  90470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90481 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90484 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90486 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90488 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90493 */   // GIR_Coverage, 6759,
     /*  90493 */   GIR_EraseRootFromParent_Done,
     /*  90494 */ // Label 1564: @90494
     /*  90494 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(90526), // Rule ID 6773 //
     /*  90499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90513 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  90513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90516 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90518 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90525 */   // GIR_Coverage, 6773,
     /*  90525 */   GIR_EraseRootFromParent_Done,
     /*  90526 */ // Label 1565: @90526
     /*  90526 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(90558), // Rule ID 6774 //
     /*  90531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90545 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  90545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90548 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90550 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90557 */   // GIR_Coverage, 6774,
     /*  90557 */   GIR_EraseRootFromParent_Done,
     /*  90558 */ // Label 1566: @90558
     /*  90558 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(90590), // Rule ID 6775 //
     /*  90563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90577 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  90577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90580 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90582 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90584 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90589 */   // GIR_Coverage, 6775,
     /*  90589 */   GIR_EraseRootFromParent_Done,
     /*  90590 */ // Label 1567: @90590
     /*  90590 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(90622), // Rule ID 6776 //
     /*  90595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90609 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  90609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90612 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90614 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90621 */   // GIR_Coverage, 6776,
     /*  90621 */   GIR_EraseRootFromParent_Done,
     /*  90622 */ // Label 1568: @90622
     /*  90622 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(90654), // Rule ID 6777 //
     /*  90627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90641 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  90641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90644 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90653 */   // GIR_Coverage, 6777,
     /*  90653 */   GIR_EraseRootFromParent_Done,
     /*  90654 */ // Label 1569: @90654
     /*  90654 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(90686), // Rule ID 6778 //
     /*  90659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90673 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  90673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90676 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90678 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90680 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90685 */   // GIR_Coverage, 6778,
     /*  90685 */   GIR_EraseRootFromParent_Done,
     /*  90686 */ // Label 1570: @90686
     /*  90686 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(90719), // Rule ID 6779 //
     /*  90691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90705 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  90705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90710 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90712 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90717 */   GIR_RootConstrainSelectedInstOperands,
     /*  90718 */   // GIR_Coverage, 6779,
     /*  90718 */   GIR_EraseRootFromParent_Done,
     /*  90719 */ // Label 1571: @90719
     /*  90719 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(90745), // Rule ID 6780 //
     /*  90724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90738 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /*  90738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90743 */   GIR_RootConstrainSelectedInstOperands,
     /*  90744 */   // GIR_Coverage, 6780,
     /*  90744 */   GIR_Done,
     /*  90745 */ // Label 1572: @90745
     /*  90745 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(90771), // Rule ID 6781 //
     /*  90750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90764 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /*  90764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90769 */   GIR_RootConstrainSelectedInstOperands,
     /*  90770 */   // GIR_Coverage, 6781,
     /*  90770 */   GIR_Done,
     /*  90771 */ // Label 1573: @90771
     /*  90771 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(90797), // Rule ID 6782 //
     /*  90776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90790 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /*  90790 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  90795 */   GIR_RootConstrainSelectedInstOperands,
     /*  90796 */   // GIR_Coverage, 6782,
     /*  90796 */   GIR_Done,
     /*  90797 */ // Label 1574: @90797
     /*  90797 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(90823), // Rule ID 6783 //
     /*  90802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90816 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /*  90816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90821 */   GIR_RootConstrainSelectedInstOperands,
     /*  90822 */   // GIR_Coverage, 6783,
     /*  90822 */   GIR_Done,
     /*  90823 */ // Label 1575: @90823
     /*  90823 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(90849), // Rule ID 6784 //
     /*  90828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90842 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /*  90842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90847 */   GIR_RootConstrainSelectedInstOperands,
     /*  90848 */   // GIR_Coverage, 6784,
     /*  90848 */   GIR_Done,
     /*  90849 */ // Label 1576: @90849
     /*  90849 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(90878), // Rule ID 6785 //
     /*  90854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90865 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  90865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90868 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90870 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90872 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90877 */   // GIR_Coverage, 6785,
     /*  90877 */   GIR_EraseRootFromParent_Done,
     /*  90878 */ // Label 1577: @90878
     /*  90878 */ GIM_Reject,
     /*  90879 */ // Label 1432: @90879
     /*  90879 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(90909), // Rule ID 6597 //
     /*  90884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90898 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  90898 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90908 */   // GIR_Coverage, 6597,
     /*  90908 */   GIR_Done,
     /*  90909 */ // Label 1578: @90909
     /*  90909 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(90939), // Rule ID 6599 //
     /*  90914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90928 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  90928 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90938 */   // GIR_Coverage, 6599,
     /*  90938 */   GIR_Done,
     /*  90939 */ // Label 1579: @90939
     /*  90939 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(90989), // Rule ID 6608 //
     /*  90944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90958 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  90958 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  90961 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90965 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90970 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90974 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  90982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90984 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90987 */   GIR_RootConstrainSelectedInstOperands,
     /*  90988 */   // GIR_Coverage, 6608,
     /*  90988 */   GIR_EraseRootFromParent_Done,
     /*  90989 */ // Label 1580: @90989
     /*  90989 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(91039), // Rule ID 6610 //
     /*  90994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  91008 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  91008 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  91011 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91015 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91020 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  91024 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  91032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91037 */   GIR_RootConstrainSelectedInstOperands,
     /*  91038 */   // GIR_Coverage, 6610,
     /*  91038 */   GIR_EraseRootFromParent_Done,
     /*  91039 */ // Label 1581: @91039
     /*  91039 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(91071), // Rule ID 6656 //
     /*  91044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91058 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91061 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91063 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91070 */   // GIR_Coverage, 6656,
     /*  91070 */   GIR_EraseRootFromParent_Done,
     /*  91071 */ // Label 1582: @91071
     /*  91071 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(91103), // Rule ID 6657 //
     /*  91076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91090 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91093 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91095 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91097 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91102 */   // GIR_Coverage, 6657,
     /*  91102 */   GIR_EraseRootFromParent_Done,
     /*  91103 */ // Label 1583: @91103
     /*  91103 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(91135), // Rule ID 6658 //
     /*  91108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91122 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91134 */   // GIR_Coverage, 6658,
     /*  91134 */   GIR_EraseRootFromParent_Done,
     /*  91135 */ // Label 1584: @91135
     /*  91135 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(91167), // Rule ID 6659 //
     /*  91140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91154 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91157 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91159 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91166 */   // GIR_Coverage, 6659,
     /*  91166 */   GIR_EraseRootFromParent_Done,
     /*  91167 */ // Label 1585: @91167
     /*  91167 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(91199), // Rule ID 6660 //
     /*  91172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91186 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91189 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91191 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91193 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91198 */   // GIR_Coverage, 6660,
     /*  91198 */   GIR_EraseRootFromParent_Done,
     /*  91199 */ // Label 1586: @91199
     /*  91199 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(91231), // Rule ID 6661 //
     /*  91204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91218 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91221 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91223 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91230 */   // GIR_Coverage, 6661,
     /*  91230 */   GIR_EraseRootFromParent_Done,
     /*  91231 */ // Label 1587: @91231
     /*  91231 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(91257), // Rule ID 6662 //
     /*  91236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91250 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /*  91250 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  91255 */   GIR_RootConstrainSelectedInstOperands,
     /*  91256 */   // GIR_Coverage, 6662,
     /*  91256 */   GIR_Done,
     /*  91257 */ // Label 1588: @91257
     /*  91257 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(91283), // Rule ID 6663 //
     /*  91262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91276 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /*  91276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91281 */   GIR_RootConstrainSelectedInstOperands,
     /*  91282 */   // GIR_Coverage, 6663,
     /*  91282 */   GIR_Done,
     /*  91283 */ // Label 1589: @91283
     /*  91283 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(91309), // Rule ID 6664 //
     /*  91288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91302 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /*  91302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  91307 */   GIR_RootConstrainSelectedInstOperands,
     /*  91308 */   // GIR_Coverage, 6664,
     /*  91308 */   GIR_Done,
     /*  91309 */ // Label 1590: @91309
     /*  91309 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(91335), // Rule ID 6665 //
     /*  91314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91328 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /*  91328 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  91333 */   GIR_RootConstrainSelectedInstOperands,
     /*  91334 */   // GIR_Coverage, 6665,
     /*  91334 */   GIR_Done,
     /*  91335 */ // Label 1591: @91335
     /*  91335 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(91361), // Rule ID 6666 //
     /*  91340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91354 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /*  91354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91359 */   GIR_RootConstrainSelectedInstOperands,
     /*  91360 */   // GIR_Coverage, 6666,
     /*  91360 */   GIR_Done,
     /*  91361 */ // Label 1592: @91361
     /*  91361 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(91387), // Rule ID 6667 //
     /*  91366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91380 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /*  91380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  91385 */   GIR_RootConstrainSelectedInstOperands,
     /*  91386 */   // GIR_Coverage, 6667,
     /*  91386 */   GIR_Done,
     /*  91387 */ // Label 1593: @91387
     /*  91387 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(91416), // Rule ID 6668 //
     /*  91392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91403 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91406 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91408 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91410 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91415 */   // GIR_Coverage, 6668,
     /*  91415 */   GIR_EraseRootFromParent_Done,
     /*  91416 */ // Label 1594: @91416
     /*  91416 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(91448), // Rule ID 6669 //
     /*  91421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91435 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  91435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91438 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91447 */   // GIR_Coverage, 6669,
     /*  91447 */   GIR_EraseRootFromParent_Done,
     /*  91448 */ // Label 1595: @91448
     /*  91448 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(91480), // Rule ID 6670 //
     /*  91453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91467 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  91467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91470 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91472 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91479 */   // GIR_Coverage, 6670,
     /*  91479 */   GIR_EraseRootFromParent_Done,
     /*  91480 */ // Label 1596: @91480
     /*  91480 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(91512), // Rule ID 6671 //
     /*  91485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91499 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  91499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91502 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91504 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91511 */   // GIR_Coverage, 6671,
     /*  91511 */   GIR_EraseRootFromParent_Done,
     /*  91512 */ // Label 1597: @91512
     /*  91512 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(91544), // Rule ID 6672 //
     /*  91517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91531 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  91531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91534 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91536 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91538 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91543 */   // GIR_Coverage, 6672,
     /*  91543 */   GIR_EraseRootFromParent_Done,
     /*  91544 */ // Label 1598: @91544
     /*  91544 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(91576), // Rule ID 6673 //
     /*  91549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91563 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  91563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91566 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91568 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91570 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91575 */   // GIR_Coverage, 6673,
     /*  91575 */   GIR_EraseRootFromParent_Done,
     /*  91576 */ // Label 1599: @91576
     /*  91576 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(91608), // Rule ID 6674 //
     /*  91581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91595 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  91595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91598 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91600 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91602 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91607 */   // GIR_Coverage, 6674,
     /*  91607 */   GIR_EraseRootFromParent_Done,
     /*  91608 */ // Label 1600: @91608
     /*  91608 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(91634), // Rule ID 6675 //
     /*  91613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91627 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /*  91627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  91632 */   GIR_RootConstrainSelectedInstOperands,
     /*  91633 */   // GIR_Coverage, 6675,
     /*  91633 */   GIR_Done,
     /*  91634 */ // Label 1601: @91634
     /*  91634 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(91660), // Rule ID 6676 //
     /*  91639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91653 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /*  91653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91658 */   GIR_RootConstrainSelectedInstOperands,
     /*  91659 */   // GIR_Coverage, 6676,
     /*  91659 */   GIR_Done,
     /*  91660 */ // Label 1602: @91660
     /*  91660 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(91686), // Rule ID 6677 //
     /*  91665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91679 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /*  91679 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  91684 */   GIR_RootConstrainSelectedInstOperands,
     /*  91685 */   // GIR_Coverage, 6677,
     /*  91685 */   GIR_Done,
     /*  91686 */ // Label 1603: @91686
     /*  91686 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(91712), // Rule ID 6678 //
     /*  91691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91705 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /*  91705 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  91710 */   GIR_RootConstrainSelectedInstOperands,
     /*  91711 */   // GIR_Coverage, 6678,
     /*  91711 */   GIR_Done,
     /*  91712 */ // Label 1604: @91712
     /*  91712 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(91738), // Rule ID 6679 //
     /*  91717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91731 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /*  91731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91736 */   GIR_RootConstrainSelectedInstOperands,
     /*  91737 */   // GIR_Coverage, 6679,
     /*  91737 */   GIR_Done,
     /*  91738 */ // Label 1605: @91738
     /*  91738 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(91764), // Rule ID 6680 //
     /*  91743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91757 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /*  91757 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  91762 */   GIR_RootConstrainSelectedInstOperands,
     /*  91763 */   // GIR_Coverage, 6680,
     /*  91763 */   GIR_Done,
     /*  91764 */ // Label 1606: @91764
     /*  91764 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(91793), // Rule ID 6681 //
     /*  91769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91780 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  91780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91783 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91785 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91792 */   // GIR_Coverage, 6681,
     /*  91792 */   GIR_EraseRootFromParent_Done,
     /*  91793 */ // Label 1607: @91793
     /*  91793 */ GIM_Reject,
     /*  91794 */ // Label 1433: @91794
     /*  91794 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(91826), // Rule ID 6760 //
     /*  91799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91813 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  91813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91816 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91818 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91820 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91825 */   // GIR_Coverage, 6760,
     /*  91825 */   GIR_EraseRootFromParent_Done,
     /*  91826 */ // Label 1608: @91826
     /*  91826 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(91858), // Rule ID 6761 //
     /*  91831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91845 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  91845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91848 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91850 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91852 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91857 */   // GIR_Coverage, 6761,
     /*  91857 */   GIR_EraseRootFromParent_Done,
     /*  91858 */ // Label 1609: @91858
     /*  91858 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(91890), // Rule ID 6762 //
     /*  91863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91877 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  91877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91880 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91882 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91884 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91889 */   // GIR_Coverage, 6762,
     /*  91889 */   GIR_EraseRootFromParent_Done,
     /*  91890 */ // Label 1610: @91890
     /*  91890 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(91922), // Rule ID 6763 //
     /*  91895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91909 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  91909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91912 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91914 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91916 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91921 */   // GIR_Coverage, 6763,
     /*  91921 */   GIR_EraseRootFromParent_Done,
     /*  91922 */ // Label 1611: @91922
     /*  91922 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(91954), // Rule ID 6764 //
     /*  91927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91941 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  91941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91944 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91946 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91948 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91953 */   // GIR_Coverage, 6764,
     /*  91953 */   GIR_EraseRootFromParent_Done,
     /*  91954 */ // Label 1612: @91954
     /*  91954 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(91986), // Rule ID 6765 //
     /*  91959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91973 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  91973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91976 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91978 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91980 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91985 */   // GIR_Coverage, 6765,
     /*  91985 */   GIR_EraseRootFromParent_Done,
     /*  91986 */ // Label 1613: @91986
     /*  91986 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(92057), // Rule ID 6766 //
     /*  91991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92005 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  92005 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  92008 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92012 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92017 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  92021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  92023 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  92026 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92030 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92035 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  92039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  92044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92049 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  92052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  92055 */   GIR_RootConstrainSelectedInstOperands,
     /*  92056 */   // GIR_Coverage, 6766,
     /*  92056 */   GIR_EraseRootFromParent_Done,
     /*  92057 */ // Label 1614: @92057
     /*  92057 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(92083), // Rule ID 6767 //
     /*  92062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92076 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /*  92076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  92081 */   GIR_RootConstrainSelectedInstOperands,
     /*  92082 */   // GIR_Coverage, 6767,
     /*  92082 */   GIR_Done,
     /*  92083 */ // Label 1615: @92083
     /*  92083 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(92109), // Rule ID 6768 //
     /*  92088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92102 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /*  92102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  92107 */   GIR_RootConstrainSelectedInstOperands,
     /*  92108 */   // GIR_Coverage, 6768,
     /*  92108 */   GIR_Done,
     /*  92109 */ // Label 1616: @92109
     /*  92109 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(92135), // Rule ID 6769 //
     /*  92114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92128 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /*  92128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  92133 */   GIR_RootConstrainSelectedInstOperands,
     /*  92134 */   // GIR_Coverage, 6769,
     /*  92134 */   GIR_Done,
     /*  92135 */ // Label 1617: @92135
     /*  92135 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(92161), // Rule ID 6770 //
     /*  92140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92154 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /*  92154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92159 */   GIR_RootConstrainSelectedInstOperands,
     /*  92160 */   // GIR_Coverage, 6770,
     /*  92160 */   GIR_Done,
     /*  92161 */ // Label 1618: @92161
     /*  92161 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(92187), // Rule ID 6771 //
     /*  92166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92180 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /*  92180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92185 */   GIR_RootConstrainSelectedInstOperands,
     /*  92186 */   // GIR_Coverage, 6771,
     /*  92186 */   GIR_Done,
     /*  92187 */ // Label 1619: @92187
     /*  92187 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(92216), // Rule ID 6772 //
     /*  92192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92203 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92206 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92208 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92210 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92215 */   // GIR_Coverage, 6772,
     /*  92215 */   GIR_EraseRootFromParent_Done,
     /*  92216 */ // Label 1620: @92216
     /*  92216 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(92248), // Rule ID 6786 //
     /*  92221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92235 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  92235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92238 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92240 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92242 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92247 */   // GIR_Coverage, 6786,
     /*  92247 */   GIR_EraseRootFromParent_Done,
     /*  92248 */ // Label 1621: @92248
     /*  92248 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(92280), // Rule ID 6787 //
     /*  92253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92267 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  92267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92270 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92272 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92274 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92279 */   // GIR_Coverage, 6787,
     /*  92279 */   GIR_EraseRootFromParent_Done,
     /*  92280 */ // Label 1622: @92280
     /*  92280 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(92312), // Rule ID 6788 //
     /*  92285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92299 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  92299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92302 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92304 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92306 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92311 */   // GIR_Coverage, 6788,
     /*  92311 */   GIR_EraseRootFromParent_Done,
     /*  92312 */ // Label 1623: @92312
     /*  92312 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(92344), // Rule ID 6789 //
     /*  92317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92331 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  92331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92334 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92336 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92338 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92343 */   // GIR_Coverage, 6789,
     /*  92343 */   GIR_EraseRootFromParent_Done,
     /*  92344 */ // Label 1624: @92344
     /*  92344 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(92376), // Rule ID 6790 //
     /*  92349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92363 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  92363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92366 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92368 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92375 */   // GIR_Coverage, 6790,
     /*  92375 */   GIR_EraseRootFromParent_Done,
     /*  92376 */ // Label 1625: @92376
     /*  92376 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(92408), // Rule ID 6791 //
     /*  92381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92395 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  92395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92398 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92400 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92402 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92407 */   // GIR_Coverage, 6791,
     /*  92407 */   GIR_EraseRootFromParent_Done,
     /*  92408 */ // Label 1626: @92408
     /*  92408 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(92479), // Rule ID 6792 //
     /*  92413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92427 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  92427 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  92430 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92434 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92439 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  92443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  92445 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  92448 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92452 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92457 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  92461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  92466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  92474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  92477 */   GIR_RootConstrainSelectedInstOperands,
     /*  92478 */   // GIR_Coverage, 6792,
     /*  92478 */   GIR_EraseRootFromParent_Done,
     /*  92479 */ // Label 1627: @92479
     /*  92479 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(92505), // Rule ID 6793 //
     /*  92484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92498 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /*  92498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92503 */   GIR_RootConstrainSelectedInstOperands,
     /*  92504 */   // GIR_Coverage, 6793,
     /*  92504 */   GIR_Done,
     /*  92505 */ // Label 1628: @92505
     /*  92505 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(92531), // Rule ID 6794 //
     /*  92510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92524 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /*  92524 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  92529 */   GIR_RootConstrainSelectedInstOperands,
     /*  92530 */   // GIR_Coverage, 6794,
     /*  92530 */   GIR_Done,
     /*  92531 */ // Label 1629: @92531
     /*  92531 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(92557), // Rule ID 6795 //
     /*  92536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92550 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /*  92550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  92555 */   GIR_RootConstrainSelectedInstOperands,
     /*  92556 */   // GIR_Coverage, 6795,
     /*  92556 */   GIR_Done,
     /*  92557 */ // Label 1630: @92557
     /*  92557 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(92583), // Rule ID 6796 //
     /*  92562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92576 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /*  92576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92581 */   GIR_RootConstrainSelectedInstOperands,
     /*  92582 */   // GIR_Coverage, 6796,
     /*  92582 */   GIR_Done,
     /*  92583 */ // Label 1631: @92583
     /*  92583 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(92609), // Rule ID 6797 //
     /*  92588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92602 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /*  92602 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  92607 */   GIR_RootConstrainSelectedInstOperands,
     /*  92608 */   // GIR_Coverage, 6797,
     /*  92608 */   GIR_Done,
     /*  92609 */ // Label 1632: @92609
     /*  92609 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(92638), // Rule ID 6798 //
     /*  92614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92625 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  92625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92637 */   // GIR_Coverage, 6798,
     /*  92637 */   GIR_EraseRootFromParent_Done,
     /*  92638 */ // Label 1633: @92638
     /*  92638 */ GIM_Reject,
     /*  92639 */ // Label 1434: @92639
     /*  92639 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(92713), // Rule ID 5643 //
     /*  92644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92651 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92655 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  92659 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  92663 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  92668 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92670 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /*  92670 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  92673 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /*  92677 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92682 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  92686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  92691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92696 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /*  92702 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92707 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  92712 */   // GIR_Coverage, 5643,
     /*  92712 */   GIR_EraseRootFromParent_Done,
     /*  92713 */ // Label 1634: @92713
     /*  92713 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(92743), // Rule ID 6596 //
     /*  92718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92732 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  92732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92737 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92742 */   // GIR_Coverage, 6596,
     /*  92742 */   GIR_Done,
     /*  92743 */ // Label 1635: @92743
     /*  92743 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(92793), // Rule ID 6607 //
     /*  92748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92762 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  92762 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  92765 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92769 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92774 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  92778 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  92786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92788 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92791 */   GIR_RootConstrainSelectedInstOperands,
     /*  92792 */   // GIR_Coverage, 6607,
     /*  92792 */   GIR_EraseRootFromParent_Done,
     /*  92793 */ // Label 1636: @92793
     /*  92793 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(92825), // Rule ID 6682 //
     /*  92798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92812 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  92812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92815 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92819 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92824 */   // GIR_Coverage, 6682,
     /*  92824 */   GIR_EraseRootFromParent_Done,
     /*  92825 */ // Label 1637: @92825
     /*  92825 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(92857), // Rule ID 6683 //
     /*  92830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92844 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  92844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92847 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92849 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92856 */   // GIR_Coverage, 6683,
     /*  92856 */   GIR_EraseRootFromParent_Done,
     /*  92857 */ // Label 1638: @92857
     /*  92857 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(92889), // Rule ID 6684 //
     /*  92862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  92868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92876 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  92876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92879 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92881 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92888 */   // GIR_Coverage, 6684,
     /*  92888 */   GIR_EraseRootFromParent_Done,
     /*  92889 */ // Label 1639: @92889
     /*  92889 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(92921), // Rule ID 6685 //
     /*  92894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92908 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  92908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92911 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92913 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92920 */   // GIR_Coverage, 6685,
     /*  92920 */   GIR_EraseRootFromParent_Done,
     /*  92921 */ // Label 1640: @92921
     /*  92921 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(92953), // Rule ID 6686 //
     /*  92926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92940 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  92940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92943 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92952 */   // GIR_Coverage, 6686,
     /*  92952 */   GIR_EraseRootFromParent_Done,
     /*  92953 */ // Label 1641: @92953
     /*  92953 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(92985), // Rule ID 6687 //
     /*  92958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92972 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  92972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92975 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92977 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92984 */   // GIR_Coverage, 6687,
     /*  92984 */   GIR_EraseRootFromParent_Done,
     /*  92985 */ // Label 1642: @92985
     /*  92985 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(93017), // Rule ID 6688 //
     /*  92990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  92996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93004 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93007 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93016 */   // GIR_Coverage, 6688,
     /*  93016 */   GIR_EraseRootFromParent_Done,
     /*  93017 */ // Label 1643: @93017
     /*  93017 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(93043), // Rule ID 6689 //
     /*  93022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93036 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /*  93036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93041 */   GIR_RootConstrainSelectedInstOperands,
     /*  93042 */   // GIR_Coverage, 6689,
     /*  93042 */   GIR_Done,
     /*  93043 */ // Label 1644: @93043
     /*  93043 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(93069), // Rule ID 6690 //
     /*  93048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93062 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /*  93062 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  93067 */   GIR_RootConstrainSelectedInstOperands,
     /*  93068 */   // GIR_Coverage, 6690,
     /*  93068 */   GIR_Done,
     /*  93069 */ // Label 1645: @93069
     /*  93069 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(93095), // Rule ID 6691 //
     /*  93074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93088 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /*  93088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  93093 */   GIR_RootConstrainSelectedInstOperands,
     /*  93094 */   // GIR_Coverage, 6691,
     /*  93094 */   GIR_Done,
     /*  93095 */ // Label 1646: @93095
     /*  93095 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(93121), // Rule ID 6692 //
     /*  93100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93114 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /*  93114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93119 */   GIR_RootConstrainSelectedInstOperands,
     /*  93120 */   // GIR_Coverage, 6692,
     /*  93120 */   GIR_Done,
     /*  93121 */ // Label 1647: @93121
     /*  93121 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(93147), // Rule ID 6693 //
     /*  93126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93140 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /*  93140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  93145 */   GIR_RootConstrainSelectedInstOperands,
     /*  93146 */   // GIR_Coverage, 6693,
     /*  93146 */   GIR_Done,
     /*  93147 */ // Label 1648: @93147
     /*  93147 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(93173), // Rule ID 6694 //
     /*  93152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93166 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /*  93166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93171 */   GIR_RootConstrainSelectedInstOperands,
     /*  93172 */   // GIR_Coverage, 6694,
     /*  93172 */   GIR_Done,
     /*  93173 */ // Label 1649: @93173
     /*  93173 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(93199), // Rule ID 6695 //
     /*  93178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93192 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /*  93192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  93197 */   GIR_RootConstrainSelectedInstOperands,
     /*  93198 */   // GIR_Coverage, 6695,
     /*  93198 */   GIR_Done,
     /*  93199 */ // Label 1650: @93199
     /*  93199 */ GIM_Reject,
     /*  93200 */ // Label 1435: @93200
     /*  93200 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(93232), // Rule ID 6799 //
     /*  93205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93219 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  93219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93222 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93224 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93226 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93231 */   // GIR_Coverage, 6799,
     /*  93231 */   GIR_EraseRootFromParent_Done,
     /*  93232 */ // Label 1651: @93232
     /*  93232 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(93264), // Rule ID 6800 //
     /*  93237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93251 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  93251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93254 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93256 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93258 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93263 */   // GIR_Coverage, 6800,
     /*  93263 */   GIR_EraseRootFromParent_Done,
     /*  93264 */ // Label 1652: @93264
     /*  93264 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(93296), // Rule ID 6801 //
     /*  93269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93283 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  93283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93286 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93288 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93290 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93295 */   // GIR_Coverage, 6801,
     /*  93295 */   GIR_EraseRootFromParent_Done,
     /*  93296 */ // Label 1653: @93296
     /*  93296 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(93328), // Rule ID 6802 //
     /*  93301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93315 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  93315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93318 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93320 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93327 */   // GIR_Coverage, 6802,
     /*  93327 */   GIR_EraseRootFromParent_Done,
     /*  93328 */ // Label 1654: @93328
     /*  93328 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(93360), // Rule ID 6803 //
     /*  93333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93347 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  93347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93350 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93352 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93354 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93359 */   // GIR_Coverage, 6803,
     /*  93359 */   GIR_EraseRootFromParent_Done,
     /*  93360 */ // Label 1655: @93360
     /*  93360 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(93392), // Rule ID 6804 //
     /*  93365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93379 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  93379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93382 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93384 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93386 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93391 */   // GIR_Coverage, 6804,
     /*  93391 */   GIR_EraseRootFromParent_Done,
     /*  93392 */ // Label 1656: @93392
     /*  93392 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(93463), // Rule ID 6805 //
     /*  93397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93411 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  93411 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93414 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  93418 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93423 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  93436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93441 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  93450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  93458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  93461 */   GIR_RootConstrainSelectedInstOperands,
     /*  93462 */   // GIR_Coverage, 6805,
     /*  93462 */   GIR_EraseRootFromParent_Done,
     /*  93463 */ // Label 1657: @93463
     /*  93463 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(93489), // Rule ID 6806 //
     /*  93468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93482 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /*  93482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  93487 */   GIR_RootConstrainSelectedInstOperands,
     /*  93488 */   // GIR_Coverage, 6806,
     /*  93488 */   GIR_Done,
     /*  93489 */ // Label 1658: @93489
     /*  93489 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(93515), // Rule ID 6807 //
     /*  93494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93508 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /*  93508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93513 */   GIR_RootConstrainSelectedInstOperands,
     /*  93514 */   // GIR_Coverage, 6807,
     /*  93514 */   GIR_Done,
     /*  93515 */ // Label 1659: @93515
     /*  93515 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(93541), // Rule ID 6808 //
     /*  93520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93534 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /*  93534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  93539 */   GIR_RootConstrainSelectedInstOperands,
     /*  93540 */   // GIR_Coverage, 6808,
     /*  93540 */   GIR_Done,
     /*  93541 */ // Label 1660: @93541
     /*  93541 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(93567), // Rule ID 6809 //
     /*  93546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93560 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /*  93560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  93565 */   GIR_RootConstrainSelectedInstOperands,
     /*  93566 */   // GIR_Coverage, 6809,
     /*  93566 */   GIR_Done,
     /*  93567 */ // Label 1661: @93567
     /*  93567 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(93593), // Rule ID 6810 //
     /*  93572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93586 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /*  93586 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93591 */   GIR_RootConstrainSelectedInstOperands,
     /*  93592 */   // GIR_Coverage, 6810,
     /*  93592 */   GIR_Done,
     /*  93593 */ // Label 1662: @93593
     /*  93593 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(93622), // Rule ID 6811 //
     /*  93598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93609 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  93609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93612 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93614 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93621 */   // GIR_Coverage, 6811,
     /*  93621 */   GIR_EraseRootFromParent_Done,
     /*  93622 */ // Label 1663: @93622
     /*  93622 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(93654), // Rule ID 6812 //
     /*  93627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93641 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  93641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93644 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93653 */   // GIR_Coverage, 6812,
     /*  93653 */   GIR_EraseRootFromParent_Done,
     /*  93654 */ // Label 1664: @93654
     /*  93654 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(93686), // Rule ID 6813 //
     /*  93659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93673 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  93673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93676 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93678 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93680 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93685 */   // GIR_Coverage, 6813,
     /*  93685 */   GIR_EraseRootFromParent_Done,
     /*  93686 */ // Label 1665: @93686
     /*  93686 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(93718), // Rule ID 6814 //
     /*  93691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93705 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  93705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93708 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93710 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93717 */   // GIR_Coverage, 6814,
     /*  93717 */   GIR_EraseRootFromParent_Done,
     /*  93718 */ // Label 1666: @93718
     /*  93718 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(93750), // Rule ID 6815 //
     /*  93723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93737 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  93737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93740 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93744 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93749 */   // GIR_Coverage, 6815,
     /*  93749 */   GIR_EraseRootFromParent_Done,
     /*  93750 */ // Label 1667: @93750
     /*  93750 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(93782), // Rule ID 6816 //
     /*  93755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93769 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  93769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93772 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93774 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93776 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93781 */   // GIR_Coverage, 6816,
     /*  93781 */   GIR_EraseRootFromParent_Done,
     /*  93782 */ // Label 1668: @93782
     /*  93782 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(93814), // Rule ID 6817 //
     /*  93787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93801 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  93801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93804 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93806 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93808 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93813 */   // GIR_Coverage, 6817,
     /*  93813 */   GIR_EraseRootFromParent_Done,
     /*  93814 */ // Label 1669: @93814
     /*  93814 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(93885), // Rule ID 6818 //
     /*  93819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93833 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  93833 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93836 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  93840 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93845 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  93858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93863 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  93872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  93880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  93883 */   GIR_RootConstrainSelectedInstOperands,
     /*  93884 */   // GIR_Coverage, 6818,
     /*  93884 */   GIR_EraseRootFromParent_Done,
     /*  93885 */ // Label 1670: @93885
     /*  93885 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(93911), // Rule ID 6819 //
     /*  93890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93904 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /*  93904 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  93909 */   GIR_RootConstrainSelectedInstOperands,
     /*  93910 */   // GIR_Coverage, 6819,
     /*  93910 */   GIR_Done,
     /*  93911 */ // Label 1671: @93911
     /*  93911 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(93937), // Rule ID 6820 //
     /*  93916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93930 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /*  93930 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93935 */   GIR_RootConstrainSelectedInstOperands,
     /*  93936 */   // GIR_Coverage, 6820,
     /*  93936 */   GIR_Done,
     /*  93937 */ // Label 1672: @93937
     /*  93937 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(93963), // Rule ID 6821 //
     /*  93942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93956 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /*  93956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  93961 */   GIR_RootConstrainSelectedInstOperands,
     /*  93962 */   // GIR_Coverage, 6821,
     /*  93962 */   GIR_Done,
     /*  93963 */ // Label 1673: @93963
     /*  93963 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(93989), // Rule ID 6822 //
     /*  93968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93982 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /*  93982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  93987 */   GIR_RootConstrainSelectedInstOperands,
     /*  93988 */   // GIR_Coverage, 6822,
     /*  93988 */   GIR_Done,
     /*  93989 */ // Label 1674: @93989
     /*  93989 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(94015), // Rule ID 6823 //
     /*  93994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94008 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /*  94008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94013 */   GIR_RootConstrainSelectedInstOperands,
     /*  94014 */   // GIR_Coverage, 6823,
     /*  94014 */   GIR_Done,
     /*  94015 */ // Label 1675: @94015
     /*  94015 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(94044), // Rule ID 6824 //
     /*  94020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94031 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94034 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94036 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94043 */   // GIR_Coverage, 6824,
     /*  94043 */   GIR_EraseRootFromParent_Done,
     /*  94044 */ // Label 1676: @94044
     /*  94044 */ GIM_Reject,
     /*  94045 */ // Label 1436: @94045
     /*  94045 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(94077), // Rule ID 6825 //
     /*  94050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94064 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94067 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94069 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94076 */   // GIR_Coverage, 6825,
     /*  94076 */   GIR_EraseRootFromParent_Done,
     /*  94077 */ // Label 1677: @94077
     /*  94077 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(94109), // Rule ID 6826 //
     /*  94082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94096 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94099 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94101 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94103 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94108 */   // GIR_Coverage, 6826,
     /*  94108 */   GIR_EraseRootFromParent_Done,
     /*  94109 */ // Label 1678: @94109
     /*  94109 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(94141), // Rule ID 6827 //
     /*  94114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94128 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94131 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94133 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94135 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94140 */   // GIR_Coverage, 6827,
     /*  94140 */   GIR_EraseRootFromParent_Done,
     /*  94141 */ // Label 1679: @94141
     /*  94141 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(94173), // Rule ID 6828 //
     /*  94146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94160 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94163 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94165 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94172 */   // GIR_Coverage, 6828,
     /*  94172 */   GIR_EraseRootFromParent_Done,
     /*  94173 */ // Label 1680: @94173
     /*  94173 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(94205), // Rule ID 6829 //
     /*  94178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94192 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94195 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94197 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94199 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94204 */   // GIR_Coverage, 6829,
     /*  94204 */   GIR_EraseRootFromParent_Done,
     /*  94205 */ // Label 1681: @94205
     /*  94205 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(94237), // Rule ID 6830 //
     /*  94210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94224 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94227 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94229 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94231 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94236 */   // GIR_Coverage, 6830,
     /*  94236 */   GIR_EraseRootFromParent_Done,
     /*  94237 */ // Label 1682: @94237
     /*  94237 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(94269), // Rule ID 6831 //
     /*  94242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94256 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94259 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94261 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94263 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94268 */   // GIR_Coverage, 6831,
     /*  94268 */   GIR_EraseRootFromParent_Done,
     /*  94269 */ // Label 1683: @94269
     /*  94269 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(94340), // Rule ID 6832 //
     /*  94274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94288 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  94288 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94291 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  94295 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94300 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  94313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94318 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  94327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94329 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  94338 */   GIR_RootConstrainSelectedInstOperands,
     /*  94339 */   // GIR_Coverage, 6832,
     /*  94339 */   GIR_EraseRootFromParent_Done,
     /*  94340 */ // Label 1684: @94340
     /*  94340 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(94366), // Rule ID 6833 //
     /*  94345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94359 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /*  94359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  94364 */   GIR_RootConstrainSelectedInstOperands,
     /*  94365 */   // GIR_Coverage, 6833,
     /*  94365 */   GIR_Done,
     /*  94366 */ // Label 1685: @94366
     /*  94366 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(94392), // Rule ID 6834 //
     /*  94371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94385 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /*  94385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  94390 */   GIR_RootConstrainSelectedInstOperands,
     /*  94391 */   // GIR_Coverage, 6834,
     /*  94391 */   GIR_Done,
     /*  94392 */ // Label 1686: @94392
     /*  94392 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(94418), // Rule ID 6835 //
     /*  94397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94411 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /*  94411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  94416 */   GIR_RootConstrainSelectedInstOperands,
     /*  94417 */   // GIR_Coverage, 6835,
     /*  94417 */   GIR_Done,
     /*  94418 */ // Label 1687: @94418
     /*  94418 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(94444), // Rule ID 6836 //
     /*  94423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94437 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /*  94437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  94442 */   GIR_RootConstrainSelectedInstOperands,
     /*  94443 */   // GIR_Coverage, 6836,
     /*  94443 */   GIR_Done,
     /*  94444 */ // Label 1688: @94444
     /*  94444 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(94470), // Rule ID 6837 //
     /*  94449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94463 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /*  94463 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  94468 */   GIR_RootConstrainSelectedInstOperands,
     /*  94469 */   // GIR_Coverage, 6837,
     /*  94469 */   GIR_Done,
     /*  94470 */ // Label 1689: @94470
     /*  94470 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(94496), // Rule ID 6838 //
     /*  94475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94489 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /*  94489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  94494 */   GIR_RootConstrainSelectedInstOperands,
     /*  94495 */   // GIR_Coverage, 6838,
     /*  94495 */   GIR_Done,
     /*  94496 */ // Label 1690: @94496
     /*  94496 */ GIM_Reject,
     /*  94497 */ // Label 1437: @94497
     /*  94497 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(94529), // Rule ID 10491 //
     /*  94502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  94508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94516 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  94516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94519 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94521 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94523 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94528 */   // GIR_Coverage, 10491,
     /*  94528 */   GIR_EraseRootFromParent_Done,
     /*  94529 */ // Label 1691: @94529
     /*  94529 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(94561), // Rule ID 10492 //
     /*  94534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94548 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  94548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94551 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94553 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94555 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94560 */   // GIR_Coverage, 10492,
     /*  94560 */   GIR_EraseRootFromParent_Done,
     /*  94561 */ // Label 1692: @94561
     /*  94561 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(94593), // Rule ID 10493 //
     /*  94566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94580 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  94580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94583 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94585 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94587 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94592 */   // GIR_Coverage, 10493,
     /*  94592 */   GIR_EraseRootFromParent_Done,
     /*  94593 */ // Label 1693: @94593
     /*  94593 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(94625), // Rule ID 10494 //
     /*  94598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94612 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  94612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94615 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94617 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94619 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94624 */   // GIR_Coverage, 10494,
     /*  94624 */   GIR_EraseRootFromParent_Done,
     /*  94625 */ // Label 1694: @94625
     /*  94625 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(94657), // Rule ID 10495 //
     /*  94630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94644 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  94644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94647 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94649 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94651 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94656 */   // GIR_Coverage, 10495,
     /*  94656 */   GIR_EraseRootFromParent_Done,
     /*  94657 */ // Label 1695: @94657
     /*  94657 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(94689), // Rule ID 10496 //
     /*  94662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94676 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  94676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94679 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94681 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94683 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94688 */   // GIR_Coverage, 10496,
     /*  94688 */   GIR_EraseRootFromParent_Done,
     /*  94689 */ // Label 1696: @94689
     /*  94689 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(94721), // Rule ID 10509 //
     /*  94694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  94700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94708 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  94708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94711 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94713 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94715 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94720 */   // GIR_Coverage, 10509,
     /*  94720 */   GIR_EraseRootFromParent_Done,
     /*  94721 */ // Label 1697: @94721
     /*  94721 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(94753), // Rule ID 10510 //
     /*  94726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94740 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  94740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94743 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94745 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94752 */   // GIR_Coverage, 10510,
     /*  94752 */   GIR_EraseRootFromParent_Done,
     /*  94753 */ // Label 1698: @94753
     /*  94753 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(94785), // Rule ID 10511 //
     /*  94758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94772 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  94772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94775 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94777 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94779 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94784 */   // GIR_Coverage, 10511,
     /*  94784 */   GIR_EraseRootFromParent_Done,
     /*  94785 */ // Label 1699: @94785
     /*  94785 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(94817), // Rule ID 10512 //
     /*  94790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94804 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  94804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94807 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94809 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94811 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94816 */   // GIR_Coverage, 10512,
     /*  94816 */   GIR_EraseRootFromParent_Done,
     /*  94817 */ // Label 1700: @94817
     /*  94817 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(94849), // Rule ID 10513 //
     /*  94822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94836 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  94836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94839 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94841 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94848 */   // GIR_Coverage, 10513,
     /*  94848 */   GIR_EraseRootFromParent_Done,
     /*  94849 */ // Label 1701: @94849
     /*  94849 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(94881), // Rule ID 10514 //
     /*  94854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94868 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  94868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94871 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94873 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94880 */   // GIR_Coverage, 10514,
     /*  94880 */   GIR_EraseRootFromParent_Done,
     /*  94881 */ // Label 1702: @94881
     /*  94881 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(94913), // Rule ID 10519 //
     /*  94886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94900 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  94900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94903 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94905 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94907 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94912 */   // GIR_Coverage, 10519,
     /*  94912 */   GIR_EraseRootFromParent_Done,
     /*  94913 */ // Label 1703: @94913
     /*  94913 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(94945), // Rule ID 10520 //
     /*  94918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94932 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  94932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94935 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94937 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94939 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94944 */   // GIR_Coverage, 10520,
     /*  94944 */   GIR_EraseRootFromParent_Done,
     /*  94945 */ // Label 1704: @94945
     /*  94945 */ GIM_Reject,
     /*  94946 */ // Label 1438: @94946
     /*  94946 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(94978), // Rule ID 10485 //
     /*  94951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  94957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94965 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  94965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94968 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94970 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94972 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94977 */   // GIR_Coverage, 10485,
     /*  94977 */   GIR_EraseRootFromParent_Done,
     /*  94978 */ // Label 1705: @94978
     /*  94978 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(95010), // Rule ID 10486 //
     /*  94983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94997 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  94997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95000 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95002 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95004 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95009 */   // GIR_Coverage, 10486,
     /*  95009 */   GIR_EraseRootFromParent_Done,
     /*  95010 */ // Label 1706: @95010
     /*  95010 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(95042), // Rule ID 10487 //
     /*  95015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95029 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95032 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95034 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95036 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95041 */   // GIR_Coverage, 10487,
     /*  95041 */   GIR_EraseRootFromParent_Done,
     /*  95042 */ // Label 1707: @95042
     /*  95042 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(95074), // Rule ID 10488 //
     /*  95047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95061 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95064 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95066 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95068 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95073 */   // GIR_Coverage, 10488,
     /*  95073 */   GIR_EraseRootFromParent_Done,
     /*  95074 */ // Label 1708: @95074
     /*  95074 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(95106), // Rule ID 10489 //
     /*  95079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95093 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95096 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95100 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95105 */   // GIR_Coverage, 10489,
     /*  95105 */   GIR_EraseRootFromParent_Done,
     /*  95106 */ // Label 1709: @95106
     /*  95106 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(95138), // Rule ID 10490 //
     /*  95111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95125 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95128 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95130 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95132 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95137 */   // GIR_Coverage, 10490,
     /*  95137 */   GIR_EraseRootFromParent_Done,
     /*  95138 */ // Label 1710: @95138
     /*  95138 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(95170), // Rule ID 10503 //
     /*  95143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95157 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95160 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95162 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95164 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95169 */   // GIR_Coverage, 10503,
     /*  95169 */   GIR_EraseRootFromParent_Done,
     /*  95170 */ // Label 1711: @95170
     /*  95170 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(95202), // Rule ID 10504 //
     /*  95175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95189 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95192 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95194 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95196 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95201 */   // GIR_Coverage, 10504,
     /*  95201 */   GIR_EraseRootFromParent_Done,
     /*  95202 */ // Label 1712: @95202
     /*  95202 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(95234), // Rule ID 10505 //
     /*  95207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95221 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95224 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95226 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95233 */   // GIR_Coverage, 10505,
     /*  95233 */   GIR_EraseRootFromParent_Done,
     /*  95234 */ // Label 1713: @95234
     /*  95234 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(95266), // Rule ID 10506 //
     /*  95239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95253 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95256 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95258 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95265 */   // GIR_Coverage, 10506,
     /*  95265 */   GIR_EraseRootFromParent_Done,
     /*  95266 */ // Label 1714: @95266
     /*  95266 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(95298), // Rule ID 10507 //
     /*  95271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95285 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95288 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95292 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95297 */   // GIR_Coverage, 10507,
     /*  95297 */   GIR_EraseRootFromParent_Done,
     /*  95298 */ // Label 1715: @95298
     /*  95298 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(95330), // Rule ID 10508 //
     /*  95303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95317 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95320 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95322 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95324 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95329 */   // GIR_Coverage, 10508,
     /*  95329 */   GIR_EraseRootFromParent_Done,
     /*  95330 */ // Label 1716: @95330
     /*  95330 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(95362), // Rule ID 10517 //
     /*  95335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95349 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95352 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95354 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95356 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95361 */   // GIR_Coverage, 10517,
     /*  95361 */   GIR_EraseRootFromParent_Done,
     /*  95362 */ // Label 1717: @95362
     /*  95362 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(95394), // Rule ID 10518 //
     /*  95367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95381 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95384 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95386 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95393 */   // GIR_Coverage, 10518,
     /*  95393 */   GIR_EraseRootFromParent_Done,
     /*  95394 */ // Label 1718: @95394
     /*  95394 */ GIM_Reject,
     /*  95395 */ // Label 1439: @95395
     /*  95395 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(95427), // Rule ID 10479 //
     /*  95400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95414 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  95414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95417 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95419 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95421 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95426 */   // GIR_Coverage, 10479,
     /*  95426 */   GIR_EraseRootFromParent_Done,
     /*  95427 */ // Label 1719: @95427
     /*  95427 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(95459), // Rule ID 10480 //
     /*  95432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95446 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  95446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95449 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95451 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95458 */   // GIR_Coverage, 10480,
     /*  95458 */   GIR_EraseRootFromParent_Done,
     /*  95459 */ // Label 1720: @95459
     /*  95459 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(95491), // Rule ID 10481 //
     /*  95464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95478 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  95478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95481 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95483 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95485 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95490 */   // GIR_Coverage, 10481,
     /*  95490 */   GIR_EraseRootFromParent_Done,
     /*  95491 */ // Label 1721: @95491
     /*  95491 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(95523), // Rule ID 10482 //
     /*  95496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95510 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  95510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95513 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95515 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95517 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95522 */   // GIR_Coverage, 10482,
     /*  95522 */   GIR_EraseRootFromParent_Done,
     /*  95523 */ // Label 1722: @95523
     /*  95523 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(95555), // Rule ID 10483 //
     /*  95528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95542 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  95542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95554 */   // GIR_Coverage, 10483,
     /*  95554 */   GIR_EraseRootFromParent_Done,
     /*  95555 */ // Label 1723: @95555
     /*  95555 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(95587), // Rule ID 10484 //
     /*  95560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95574 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  95574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95577 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95579 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95581 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95586 */   // GIR_Coverage, 10484,
     /*  95586 */   GIR_EraseRootFromParent_Done,
     /*  95587 */ // Label 1724: @95587
     /*  95587 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(95619), // Rule ID 10497 //
     /*  95592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95606 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  95606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95609 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95611 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95613 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95618 */   // GIR_Coverage, 10497,
     /*  95618 */   GIR_EraseRootFromParent_Done,
     /*  95619 */ // Label 1725: @95619
     /*  95619 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(95651), // Rule ID 10498 //
     /*  95624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95638 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  95638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95641 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95643 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95645 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95650 */   // GIR_Coverage, 10498,
     /*  95650 */   GIR_EraseRootFromParent_Done,
     /*  95651 */ // Label 1726: @95651
     /*  95651 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(95683), // Rule ID 10499 //
     /*  95656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95670 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  95670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95673 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95675 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95682 */   // GIR_Coverage, 10499,
     /*  95682 */   GIR_EraseRootFromParent_Done,
     /*  95683 */ // Label 1727: @95683
     /*  95683 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(95715), // Rule ID 10500 //
     /*  95688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95702 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  95702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95705 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95707 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95714 */   // GIR_Coverage, 10500,
     /*  95714 */   GIR_EraseRootFromParent_Done,
     /*  95715 */ // Label 1728: @95715
     /*  95715 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(95747), // Rule ID 10501 //
     /*  95720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95734 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  95734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95737 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95739 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95746 */   // GIR_Coverage, 10501,
     /*  95746 */   GIR_EraseRootFromParent_Done,
     /*  95747 */ // Label 1729: @95747
     /*  95747 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(95779), // Rule ID 10502 //
     /*  95752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95766 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  95766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95769 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95771 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95773 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95778 */   // GIR_Coverage, 10502,
     /*  95778 */   GIR_EraseRootFromParent_Done,
     /*  95779 */ // Label 1730: @95779
     /*  95779 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(95811), // Rule ID 10515 //
     /*  95784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95798 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  95798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95801 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95803 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95805 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95810 */   // GIR_Coverage, 10515,
     /*  95810 */   GIR_EraseRootFromParent_Done,
     /*  95811 */ // Label 1731: @95811
     /*  95811 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(95843), // Rule ID 10516 //
     /*  95816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95830 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  95830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95833 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95835 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95842 */   // GIR_Coverage, 10516,
     /*  95842 */   GIR_EraseRootFromParent_Done,
     /*  95843 */ // Label 1732: @95843
     /*  95843 */ GIM_Reject,
     /*  95844 */ // Label 1440: @95844
     /*  95844 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(95876), // Rule ID 10473 //
     /*  95849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95863 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  95863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95866 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95868 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95870 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95875 */   // GIR_Coverage, 10473,
     /*  95875 */   GIR_EraseRootFromParent_Done,
     /*  95876 */ // Label 1733: @95876
     /*  95876 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(95908), // Rule ID 10474 //
     /*  95881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95895 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  95895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95898 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95900 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95902 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95907 */   // GIR_Coverage, 10474,
     /*  95907 */   GIR_EraseRootFromParent_Done,
     /*  95908 */ // Label 1734: @95908
     /*  95908 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(95940), // Rule ID 10475 //
     /*  95913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95927 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  95927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95930 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95932 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95934 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95939 */   // GIR_Coverage, 10475,
     /*  95939 */   GIR_EraseRootFromParent_Done,
     /*  95940 */ // Label 1735: @95940
     /*  95940 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(95972), // Rule ID 10476 //
     /*  95945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95959 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  95959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95962 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95964 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95966 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95971 */   // GIR_Coverage, 10476,
     /*  95971 */   GIR_EraseRootFromParent_Done,
     /*  95972 */ // Label 1736: @95972
     /*  95972 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(96004), // Rule ID 10477 //
     /*  95977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95991 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  95991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95994 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95996 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95998 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96003 */   // GIR_Coverage, 10477,
     /*  96003 */   GIR_EraseRootFromParent_Done,
     /*  96004 */ // Label 1737: @96004
     /*  96004 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(96036), // Rule ID 10478 //
     /*  96009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96023 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96026 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96028 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96030 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96035 */   // GIR_Coverage, 10478,
     /*  96035 */   GIR_EraseRootFromParent_Done,
     /*  96036 */ // Label 1738: @96036
     /*  96036 */ GIM_Reject,
     /*  96037 */ // Label 1441: @96037
     /*  96037 */ GIM_Reject,
     /*  96038 */ // Label 10: @96038
     /*  96038 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1747*/ GIMT_Encode4(96528),
     /*  96049 */ /*GILLT_s16*//*Label 1739*/ GIMT_Encode4(96089),
     /*  96053 */ /*GILLT_s32*//*Label 1740*/ GIMT_Encode4(96120),
     /*  96057 */ /*GILLT_s64*//*Label 1741*/ GIMT_Encode4(96151), GIMT_Encode4(0),
     /*  96065 */ /*GILLT_v2s32*//*Label 1742*/ GIMT_Encode4(96182),
     /*  96069 */ /*GILLT_v2s64*//*Label 1743*/ GIMT_Encode4(96213),
     /*  96073 */ /*GILLT_v4s16*//*Label 1744*/ GIMT_Encode4(96244),
     /*  96077 */ /*GILLT_v4s32*//*Label 1745*/ GIMT_Encode4(96275), GIMT_Encode4(0),
     /*  96085 */ /*GILLT_v8s16*//*Label 1746*/ GIMT_Encode4(96306),
     /*  96089 */ // Label 1739: @96089
     /*  96089 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(96119), // Rule ID 564 //
     /*  96094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  96097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  96100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  96104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  96108 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  96108 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /*  96113 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96117 */   GIR_RootConstrainSelectedInstOperands,
     /*  96118 */   // GIR_Coverage, 564,
     /*  96118 */   GIR_Done,
     /*  96119 */ // Label 1748: @96119
     /*  96119 */ GIM_Reject,
     /*  96120 */ // Label 1740: @96120
     /*  96120 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(96150), // Rule ID 566 //
     /*  96125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  96131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96139 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  96139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /*  96144 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96148 */   GIR_RootConstrainSelectedInstOperands,
     /*  96149 */   // GIR_Coverage, 566,
     /*  96149 */   GIR_Done,
     /*  96150 */ // Label 1749: @96150
     /*  96150 */ GIM_Reject,
     /*  96151 */ // Label 1741: @96151
     /*  96151 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(96181), // Rule ID 568 //
     /*  96156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  96162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96170 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  96170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /*  96175 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96179 */   GIR_RootConstrainSelectedInstOperands,
     /*  96180 */   // GIR_Coverage, 568,
     /*  96180 */   GIR_Done,
     /*  96181 */ // Label 1750: @96181
     /*  96181 */ GIM_Reject,
     /*  96182 */ // Label 1742: @96182
     /*  96182 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(96212), // Rule ID 926 //
     /*  96187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  96190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  96193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96201 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  96201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /*  96206 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96210 */   GIR_RootConstrainSelectedInstOperands,
     /*  96211 */   // GIR_Coverage, 926,
     /*  96211 */   GIR_Done,
     /*  96212 */ // Label 1751: @96212
     /*  96212 */ GIM_Reject,
     /*  96213 */ // Label 1743: @96213
     /*  96213 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(96243), // Rule ID 930 //
     /*  96218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  96221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  96224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96232 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  96232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /*  96237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96241 */   GIR_RootConstrainSelectedInstOperands,
     /*  96242 */   // GIR_Coverage, 930,
     /*  96242 */   GIR_Done,
     /*  96243 */ // Label 1752: @96243
     /*  96243 */ GIM_Reject,
     /*  96244 */ // Label 1744: @96244
     /*  96244 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(96274), // Rule ID 922 //
     /*  96249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  96252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  96255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96263 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  96263 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /*  96268 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96272 */   GIR_RootConstrainSelectedInstOperands,
     /*  96273 */   // GIR_Coverage, 922,
     /*  96273 */   GIR_Done,
     /*  96274 */ // Label 1753: @96274
     /*  96274 */ GIM_Reject,
     /*  96275 */ // Label 1745: @96275
     /*  96275 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(96305), // Rule ID 928 //
     /*  96280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  96283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  96286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96294 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  96294 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  96299 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96303 */   GIR_RootConstrainSelectedInstOperands,
     /*  96304 */   // GIR_Coverage, 928,
     /*  96304 */   GIR_Done,
     /*  96305 */ // Label 1754: @96305
     /*  96305 */ GIM_Reject,
     /*  96306 */ // Label 1746: @96306
     /*  96306 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(96527),
     /*  96311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  96314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96322 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(96341), // Rule ID 924 //
     /*  96327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  96330 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  96330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /*  96335 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96339 */     GIR_RootConstrainSelectedInstOperands,
     /*  96340 */     // GIR_Coverage, 924,
     /*  96340 */     GIR_Done,
     /*  96341 */   // Label 1756: @96341
     /*  96341 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(96526), // Rule ID 6957 //
     /*  96346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  96349 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  96349 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  96352 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  96356 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96361 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  96365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  96367 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  96370 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  96374 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96379 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  96382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  96384 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  96387 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96391 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96396 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  96402 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96407 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96412 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  96415 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  96419 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96424 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  96427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  96429 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  96432 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  96436 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96441 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  96444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  96446 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  96449 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  96453 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96458 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  96461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96463 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  96466 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  96470 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  96480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  96484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96489 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96492 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  96495 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  96498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  96516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  96524 */     GIR_RootConstrainSelectedInstOperands,
     /*  96525 */     // GIR_Coverage, 6957,
     /*  96525 */     GIR_EraseRootFromParent_Done,
     /*  96526 */   // Label 1757: @96526
     /*  96526 */   GIM_Reject,
     /*  96527 */ // Label 1755: @96527
     /*  96527 */ GIM_Reject,
     /*  96528 */ // Label 1747: @96528
     /*  96528 */ GIM_Reject,
     /*  96529 */ // Label 11: @96529
     /*  96529 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1766*/ GIMT_Encode4(97019),
     /*  96540 */ /*GILLT_s16*//*Label 1758*/ GIMT_Encode4(96580),
     /*  96544 */ /*GILLT_s32*//*Label 1759*/ GIMT_Encode4(96611),
     /*  96548 */ /*GILLT_s64*//*Label 1760*/ GIMT_Encode4(96642), GIMT_Encode4(0),
     /*  96556 */ /*GILLT_v2s32*//*Label 1761*/ GIMT_Encode4(96673),
     /*  96560 */ /*GILLT_v2s64*//*Label 1762*/ GIMT_Encode4(96704),
     /*  96564 */ /*GILLT_v4s16*//*Label 1763*/ GIMT_Encode4(96735),
     /*  96568 */ /*GILLT_v4s32*//*Label 1764*/ GIMT_Encode4(96766), GIMT_Encode4(0),
     /*  96576 */ /*GILLT_v8s16*//*Label 1765*/ GIMT_Encode4(96797),
     /*  96580 */ // Label 1758: @96580
     /*  96580 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(96610), // Rule ID 528 //
     /*  96585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  96588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  96591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  96595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  96599 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  96599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /*  96604 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96608 */   GIR_RootConstrainSelectedInstOperands,
     /*  96609 */   // GIR_Coverage, 528,
     /*  96609 */   GIR_Done,
     /*  96610 */ // Label 1767: @96610
     /*  96610 */ GIM_Reject,
     /*  96611 */ // Label 1759: @96611
     /*  96611 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(96641), // Rule ID 530 //
     /*  96616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  96622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96630 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  96630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /*  96635 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96639 */   GIR_RootConstrainSelectedInstOperands,
     /*  96640 */   // GIR_Coverage, 530,
     /*  96640 */   GIR_Done,
     /*  96641 */ // Label 1768: @96641
     /*  96641 */ GIM_Reject,
     /*  96642 */ // Label 1760: @96642
     /*  96642 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(96672), // Rule ID 532 //
     /*  96647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  96653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96661 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  96661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /*  96666 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96670 */   GIR_RootConstrainSelectedInstOperands,
     /*  96671 */   // GIR_Coverage, 532,
     /*  96671 */   GIR_Done,
     /*  96672 */ // Label 1769: @96672
     /*  96672 */ GIM_Reject,
     /*  96673 */ // Label 1761: @96673
     /*  96673 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(96703), // Rule ID 866 //
     /*  96678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  96681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  96684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96692 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  96692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /*  96697 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96701 */   GIR_RootConstrainSelectedInstOperands,
     /*  96702 */   // GIR_Coverage, 866,
     /*  96702 */   GIR_Done,
     /*  96703 */ // Label 1770: @96703
     /*  96703 */ GIM_Reject,
     /*  96704 */ // Label 1762: @96704
     /*  96704 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(96734), // Rule ID 870 //
     /*  96709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  96712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  96715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96723 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  96723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /*  96728 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96732 */   GIR_RootConstrainSelectedInstOperands,
     /*  96733 */   // GIR_Coverage, 870,
     /*  96733 */   GIR_Done,
     /*  96734 */ // Label 1771: @96734
     /*  96734 */ GIM_Reject,
     /*  96735 */ // Label 1763: @96735
     /*  96735 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(96765), // Rule ID 862 //
     /*  96740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  96743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  96746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96754 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  96754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /*  96759 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96763 */   GIR_RootConstrainSelectedInstOperands,
     /*  96764 */   // GIR_Coverage, 862,
     /*  96764 */   GIR_Done,
     /*  96765 */ // Label 1772: @96765
     /*  96765 */ GIM_Reject,
     /*  96766 */ // Label 1764: @96766
     /*  96766 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(96796), // Rule ID 868 //
     /*  96771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  96774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  96777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96785 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  96785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  96790 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96794 */   GIR_RootConstrainSelectedInstOperands,
     /*  96795 */   // GIR_Coverage, 868,
     /*  96795 */   GIR_Done,
     /*  96796 */ // Label 1773: @96796
     /*  96796 */ GIM_Reject,
     /*  96797 */ // Label 1765: @96797
     /*  96797 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(97018),
     /*  96802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  96805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96813 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(96832), // Rule ID 864 //
     /*  96818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  96821 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  96821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /*  96826 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96830 */     GIR_RootConstrainSelectedInstOperands,
     /*  96831 */     // GIR_Coverage, 864,
     /*  96831 */     GIR_Done,
     /*  96832 */   // Label 1775: @96832
     /*  96832 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(97017), // Rule ID 6951 //
     /*  96837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  96840 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  96840 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  96843 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  96847 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96852 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  96856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  96858 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  96861 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  96865 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96870 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  96873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  96875 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  96878 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96882 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96887 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  96893 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96898 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96903 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  96906 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  96910 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96915 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  96918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  96920 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  96923 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  96927 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96932 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  96935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  96937 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  96940 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  96944 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96949 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  96952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96954 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  96957 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  96961 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  96971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  96975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96980 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96983 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  96986 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  96989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  97007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  97015 */     GIR_RootConstrainSelectedInstOperands,
     /*  97016 */     // GIR_Coverage, 6951,
     /*  97016 */     GIR_EraseRootFromParent_Done,
     /*  97017 */   // Label 1776: @97017
     /*  97017 */   GIM_Reject,
     /*  97018 */ // Label 1774: @97018
     /*  97018 */ GIM_Reject,
     /*  97019 */ // Label 1766: @97019
     /*  97019 */ GIM_Reject,
     /*  97020 */ // Label 12: @97020
     /*  97020 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1779*/ GIMT_Encode4(97287),
     /*  97031 */ /*GILLT_s32*//*Label 1777*/ GIMT_Encode4(97039),
     /*  97035 */ /*GILLT_s64*//*Label 1778*/ GIMT_Encode4(97163),
     /*  97039 */ // Label 1777: @97039
     /*  97039 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(97082), // Rule ID 4764 //
     /*  97044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97054 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  97054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  97057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  97061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97066 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /*  97075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97080 */   GIR_RootConstrainSelectedInstOperands,
     /*  97081 */   // GIR_Coverage, 4764,
     /*  97081 */   GIR_EraseRootFromParent_Done,
     /*  97082 */ // Label 1780: @97082
     /*  97082 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(97122), // Rule ID 4770 //
     /*  97087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97094 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  97094 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  97097 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  97101 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97106 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /*  97115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97117 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97120 */   GIR_RootConstrainSelectedInstOperands,
     /*  97121 */   // GIR_Coverage, 4770,
     /*  97121 */   GIR_EraseRootFromParent_Done,
     /*  97122 */ // Label 1781: @97122
     /*  97122 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(97162), // Rule ID 4772 //
     /*  97127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97134 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  97134 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97137 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  97141 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97146 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /*  97155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97157 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97160 */   GIR_RootConstrainSelectedInstOperands,
     /*  97161 */   // GIR_Coverage, 4772,
     /*  97161 */   GIR_EraseRootFromParent_Done,
     /*  97162 */ // Label 1782: @97162
     /*  97162 */ GIM_Reject,
     /*  97163 */ // Label 1778: @97163
     /*  97163 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(97206), // Rule ID 4766 //
     /*  97168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97178 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  97178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  97181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  97185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97190 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  97199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97204 */   GIR_RootConstrainSelectedInstOperands,
     /*  97205 */   // GIR_Coverage, 4766,
     /*  97205 */   GIR_EraseRootFromParent_Done,
     /*  97206 */ // Label 1783: @97206
     /*  97206 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(97246), // Rule ID 4774 //
     /*  97211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97218 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  97218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  97221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  97225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97230 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  97239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97244 */   GIR_RootConstrainSelectedInstOperands,
     /*  97245 */   // GIR_Coverage, 4774,
     /*  97245 */   GIR_EraseRootFromParent_Done,
     /*  97246 */ // Label 1784: @97246
     /*  97246 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(97286), // Rule ID 4776 //
     /*  97251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97258 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  97258 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97261 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  97265 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97270 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  97279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97281 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97284 */   GIR_RootConstrainSelectedInstOperands,
     /*  97285 */   // GIR_Coverage, 4776,
     /*  97285 */   GIR_EraseRootFromParent_Done,
     /*  97286 */ // Label 1785: @97286
     /*  97286 */ GIM_Reject,
     /*  97287 */ // Label 1779: @97287
     /*  97287 */ GIM_Reject,
     /*  97288 */ // Label 13: @97288
     /*  97288 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(97437),
     /*  97293 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  97296 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1790*/ GIMT_Encode4(97436),
     /*  97307 */   /*GILLT_s16*//*Label 1787*/ GIMT_Encode4(97319),
     /*  97311 */   /*GILLT_s32*//*Label 1788*/ GIMT_Encode4(97360),
     /*  97315 */   /*GILLT_s64*//*Label 1789*/ GIMT_Encode4(97398),
     /*  97319 */   // Label 1787: @97319
     /*  97319 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(97359), // Rule ID 4768 //
     /*  97324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97331 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  97331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  97334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  97338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  97352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97357 */     GIR_RootConstrainSelectedInstOperands,
     /*  97358 */     // GIR_Coverage, 4768,
     /*  97358 */     GIR_EraseRootFromParent_Done,
     /*  97359 */   // Label 1791: @97359
     /*  97359 */   GIM_Reject,
     /*  97360 */   // Label 1788: @97360
     /*  97360 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(97397), // Rule ID 4778 //
     /*  97365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97369 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  97369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  97372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  97376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97381 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  97390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97395 */     GIR_RootConstrainSelectedInstOperands,
     /*  97396 */     // GIR_Coverage, 4778,
     /*  97396 */     GIR_EraseRootFromParent_Done,
     /*  97397 */   // Label 1792: @97397
     /*  97397 */   GIM_Reject,
     /*  97398 */   // Label 1789: @97398
     /*  97398 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(97435), // Rule ID 4780 //
     /*  97403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97407 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  97407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  97414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  97428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97433 */     GIR_RootConstrainSelectedInstOperands,
     /*  97434 */     // GIR_Coverage, 4780,
     /*  97434 */     GIR_EraseRootFromParent_Done,
     /*  97435 */   // Label 1793: @97435
     /*  97435 */   GIM_Reject,
     /*  97436 */   // Label 1790: @97436
     /*  97436 */   GIM_Reject,
     /*  97437 */ // Label 1786: @97437
     /*  97437 */ GIM_Reject,
     /*  97438 */ // Label 14: @97438
     /*  97438 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1802*/ GIMT_Encode4(97928),
     /*  97449 */ /*GILLT_s16*//*Label 1794*/ GIMT_Encode4(97489),
     /*  97453 */ /*GILLT_s32*//*Label 1795*/ GIMT_Encode4(97520),
     /*  97457 */ /*GILLT_s64*//*Label 1796*/ GIMT_Encode4(97551), GIMT_Encode4(0),
     /*  97465 */ /*GILLT_v2s32*//*Label 1797*/ GIMT_Encode4(97582),
     /*  97469 */ /*GILLT_v2s64*//*Label 1798*/ GIMT_Encode4(97613),
     /*  97473 */ /*GILLT_v4s16*//*Label 1799*/ GIMT_Encode4(97644),
     /*  97477 */ /*GILLT_v4s32*//*Label 1800*/ GIMT_Encode4(97675), GIMT_Encode4(0),
     /*  97485 */ /*GILLT_v8s16*//*Label 1801*/ GIMT_Encode4(97706),
     /*  97489 */ // Label 1794: @97489
     /*  97489 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(97519), // Rule ID 546 //
     /*  97494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97508 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  97508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /*  97513 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97517 */   GIR_RootConstrainSelectedInstOperands,
     /*  97518 */   // GIR_Coverage, 546,
     /*  97518 */   GIR_Done,
     /*  97519 */ // Label 1803: @97519
     /*  97519 */ GIM_Reject,
     /*  97520 */ // Label 1795: @97520
     /*  97520 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(97550), // Rule ID 548 //
     /*  97525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97539 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  97539 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /*  97544 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97548 */   GIR_RootConstrainSelectedInstOperands,
     /*  97549 */   // GIR_Coverage, 548,
     /*  97549 */   GIR_Done,
     /*  97550 */ // Label 1804: @97550
     /*  97550 */ GIM_Reject,
     /*  97551 */ // Label 1796: @97551
     /*  97551 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(97581), // Rule ID 550 //
     /*  97556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97570 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  97570 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /*  97575 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97579 */   GIR_RootConstrainSelectedInstOperands,
     /*  97580 */   // GIR_Coverage, 550,
     /*  97580 */   GIR_Done,
     /*  97581 */ // Label 1805: @97581
     /*  97581 */ GIM_Reject,
     /*  97582 */ // Label 1797: @97582
     /*  97582 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(97612), // Rule ID 896 //
     /*  97587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  97593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97601 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  97601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /*  97606 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97610 */   GIR_RootConstrainSelectedInstOperands,
     /*  97611 */   // GIR_Coverage, 896,
     /*  97611 */   GIR_Done,
     /*  97612 */ // Label 1806: @97612
     /*  97612 */ GIM_Reject,
     /*  97613 */ // Label 1798: @97613
     /*  97613 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(97643), // Rule ID 900 //
     /*  97618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97632 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  97632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /*  97637 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97641 */   GIR_RootConstrainSelectedInstOperands,
     /*  97642 */   // GIR_Coverage, 900,
     /*  97642 */   GIR_Done,
     /*  97643 */ // Label 1807: @97643
     /*  97643 */ GIM_Reject,
     /*  97644 */ // Label 1799: @97644
     /*  97644 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(97674), // Rule ID 892 //
     /*  97649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  97655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97663 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  97663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /*  97668 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97672 */   GIR_RootConstrainSelectedInstOperands,
     /*  97673 */   // GIR_Coverage, 892,
     /*  97673 */   GIR_Done,
     /*  97674 */ // Label 1808: @97674
     /*  97674 */ GIM_Reject,
     /*  97675 */ // Label 1800: @97675
     /*  97675 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(97705), // Rule ID 898 //
     /*  97680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  97686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97694 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  97694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  97699 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97703 */   GIR_RootConstrainSelectedInstOperands,
     /*  97704 */   // GIR_Coverage, 898,
     /*  97704 */   GIR_Done,
     /*  97705 */ // Label 1809: @97705
     /*  97705 */ GIM_Reject,
     /*  97706 */ // Label 1801: @97706
     /*  97706 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(97927),
     /*  97711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  97714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97722 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(97741), // Rule ID 894 //
     /*  97727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97730 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  97730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /*  97735 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97739 */     GIR_RootConstrainSelectedInstOperands,
     /*  97740 */     // GIR_Coverage, 894,
     /*  97740 */     GIR_Done,
     /*  97741 */   // Label 1811: @97741
     /*  97741 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(97926), // Rule ID 6953 //
     /*  97746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  97749 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  97749 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  97752 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  97756 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97761 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  97767 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  97770 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  97774 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97779 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  97782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  97784 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  97787 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97791 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97796 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  97802 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97807 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97812 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  97815 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  97819 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97824 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  97827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  97829 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  97832 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  97836 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97841 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  97844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97846 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  97849 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  97853 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97858 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97863 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97866 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97870 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97892 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  97895 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  97916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  97924 */     GIR_RootConstrainSelectedInstOperands,
     /*  97925 */     // GIR_Coverage, 6953,
     /*  97925 */     GIR_EraseRootFromParent_Done,
     /*  97926 */   // Label 1812: @97926
     /*  97926 */   GIM_Reject,
     /*  97927 */ // Label 1810: @97927
     /*  97927 */ GIM_Reject,
     /*  97928 */ // Label 1802: @97928
     /*  97928 */ GIM_Reject,
     /*  97929 */ // Label 15: @97929
     /*  97929 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(97961), // Rule ID 3885 //
     /*  97934 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  97937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97941 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /*  97941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /*  97944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  97946 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /*  97956 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  97959 */   GIR_RootConstrainSelectedInstOperands,
     /*  97960 */   // GIR_Coverage, 3885,
     /*  97960 */   GIR_EraseRootFromParent_Done,
     /*  97961 */ // Label 1813: @97961
     /*  97961 */ GIM_Reject,
     /*  97962 */ // Label 16: @97962
     /*  97962 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 1834*/ GIMT_Encode4(106771),
     /*  97973 */ /*GILLT_s8*//*Label 1814*/ GIMT_Encode4(98069),
     /*  97977 */ /*GILLT_s16*//*Label 1815*/ GIMT_Encode4(98245),
     /*  97981 */ /*GILLT_s32*//*Label 1816*/ GIMT_Encode4(98421),
     /*  97985 */ /*GILLT_s64*//*Label 1817*/ GIMT_Encode4(100719),
     /*  97989 */ /*GILLT_s128*//*Label 1818*/ GIMT_Encode4(103400),
     /*  97993 */ /*GILLT_v2s32*//*Label 1819*/ GIMT_Encode4(103609),
     /*  97997 */ /*GILLT_v2s64*//*Label 1820*/ GIMT_Encode4(103987),
     /*  98001 */ /*GILLT_v4s16*//*Label 1821*/ GIMT_Encode4(104365),
     /*  98005 */ /*GILLT_v4s32*//*Label 1822*/ GIMT_Encode4(104743),
     /*  98009 */ /*GILLT_v8s8*//*Label 1823*/ GIMT_Encode4(105121),
     /*  98013 */ /*GILLT_v8s16*//*Label 1824*/ GIMT_Encode4(105329),
     /*  98017 */ /*GILLT_v16s8*//*Label 1825*/ GIMT_Encode4(105707), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98029 */ /*GILLT_nxv2s16*//*Label 1826*/ GIMT_Encode4(105915),
     /*  98033 */ /*GILLT_nxv2s32*//*Label 1827*/ GIMT_Encode4(105979),
     /*  98037 */ /*GILLT_nxv2s64*//*Label 1828*/ GIMT_Encode4(106043), GIMT_Encode4(0),
     /*  98045 */ /*GILLT_nxv4s16*//*Label 1829*/ GIMT_Encode4(106217),
     /*  98049 */ /*GILLT_nxv4s32*//*Label 1830*/ GIMT_Encode4(106281), GIMT_Encode4(0),
     /*  98057 */ /*GILLT_nxv8s16*//*Label 1831*/ GIMT_Encode4(106455),
     /*  98061 */ /*GILLT_nxv16s1*//*Label 1832*/ GIMT_Encode4(106629),
     /*  98065 */ /*GILLT_nxv16s8*//*Label 1833*/ GIMT_Encode4(106673),
     /*  98069 */ // Label 1814: @98069
     /*  98069 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(98244),
     /*  98074 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98077 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /*  98085 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98089 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(98130), // Rule ID 237 //
     /*  98094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  98104 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  98104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /*  98107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98128 */     GIR_RootConstrainSelectedInstOperands,
     /*  98129 */     // GIR_Coverage, 237,
     /*  98129 */     GIR_EraseRootFromParent_Done,
     /*  98130 */   // Label 1836: @98130
     /*  98130 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(98171), // Rule ID 238 //
     /*  98135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  98145 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  98145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /*  98148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98169 */     GIR_RootConstrainSelectedInstOperands,
     /*  98170 */     // GIR_Coverage, 238,
     /*  98170 */     GIR_EraseRootFromParent_Done,
     /*  98171 */   // Label 1837: @98171
     /*  98171 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(98207), // Rule ID 261 //
     /*  98176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  98186 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  98186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /*  98189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98205 */     GIR_RootConstrainSelectedInstOperands,
     /*  98206 */     // GIR_Coverage, 261,
     /*  98206 */     GIR_EraseRootFromParent_Done,
     /*  98207 */   // Label 1838: @98207
     /*  98207 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(98243), // Rule ID 282 //
     /*  98212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  98222 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  98222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /*  98225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98241 */     GIR_RootConstrainSelectedInstOperands,
     /*  98242 */     // GIR_Coverage, 282,
     /*  98242 */     GIR_EraseRootFromParent_Done,
     /*  98243 */   // Label 1839: @98243
     /*  98243 */   GIM_Reject,
     /*  98244 */ // Label 1835: @98244
     /*  98244 */ GIM_Reject,
     /*  98245 */ // Label 1815: @98245
     /*  98245 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(98420),
     /*  98250 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98253 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98265 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(98306), // Rule ID 239 //
     /*  98270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  98280 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  98280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /*  98283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98304 */     GIR_RootConstrainSelectedInstOperands,
     /*  98305 */     // GIR_Coverage, 239,
     /*  98305 */     GIR_EraseRootFromParent_Done,
     /*  98306 */   // Label 1841: @98306
     /*  98306 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(98347), // Rule ID 240 //
     /*  98311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  98321 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  98321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /*  98324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98345 */     GIR_RootConstrainSelectedInstOperands,
     /*  98346 */     // GIR_Coverage, 240,
     /*  98346 */     GIR_EraseRootFromParent_Done,
     /*  98347 */   // Label 1842: @98347
     /*  98347 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(98383), // Rule ID 262 //
     /*  98352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  98362 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  98362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /*  98365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98381 */     GIR_RootConstrainSelectedInstOperands,
     /*  98382 */     // GIR_Coverage, 262,
     /*  98382 */     GIR_EraseRootFromParent_Done,
     /*  98383 */   // Label 1843: @98383
     /*  98383 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(98419), // Rule ID 283 //
     /*  98388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  98398 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  98398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /*  98401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98417 */     GIR_RootConstrainSelectedInstOperands,
     /*  98418 */     // GIR_Coverage, 283,
     /*  98418 */     GIR_EraseRootFromParent_Done,
     /*  98419 */   // Label 1844: @98419
     /*  98419 */   GIM_Reject,
     /*  98420 */ // Label 1840: @98420
     /*  98420 */ GIM_Reject,
     /*  98421 */ // Label 1816: @98421
     /*  98421 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(98474), // Rule ID 233 //
     /*  98426 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98429 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98437 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98441 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  98448 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  98448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  98451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98472 */   GIR_RootConstrainSelectedInstOperands,
     /*  98473 */   // GIR_Coverage, 233,
     /*  98473 */   GIR_EraseRootFromParent_Done,
     /*  98474 */ // Label 1845: @98474
     /*  98474 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(98527), // Rule ID 234 //
     /*  98479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98482 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98494 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  98501 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  98501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  98504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98521 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98525 */   GIR_RootConstrainSelectedInstOperands,
     /*  98526 */   // GIR_Coverage, 234,
     /*  98526 */   GIR_EraseRootFromParent_Done,
     /*  98527 */ // Label 1846: @98527
     /*  98527 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(98583), // Rule ID 241 //
     /*  98532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98535 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98538 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98546 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98550 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  98557 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  98557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  98560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98567 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98572 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98581 */   GIR_RootConstrainSelectedInstOperands,
     /*  98582 */   // GIR_Coverage, 241,
     /*  98582 */   GIR_EraseRootFromParent_Done,
     /*  98583 */ // Label 1847: @98583
     /*  98583 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(98639), // Rule ID 242 //
     /*  98588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98591 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98594 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98602 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98606 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  98613 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  98613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  98616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98633 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98637 */   GIR_RootConstrainSelectedInstOperands,
     /*  98638 */   // GIR_Coverage, 242,
     /*  98638 */   GIR_EraseRootFromParent_Done,
     /*  98639 */ // Label 1848: @98639
     /*  98639 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(98699), // Rule ID 4101 //
     /*  98644 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98647 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98651 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98662 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98666 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  98673 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  98673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  98676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98683 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98693 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98697 */   GIR_RootConstrainSelectedInstOperands,
     /*  98698 */   // GIR_Coverage, 4101,
     /*  98698 */   GIR_EraseRootFromParent_Done,
     /*  98699 */ // Label 1849: @98699
     /*  98699 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(98759), // Rule ID 4102 //
     /*  98704 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98707 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98711 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  98718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98722 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98726 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  98733 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  98733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  98736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98748 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98753 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98757 */   GIR_RootConstrainSelectedInstOperands,
     /*  98758 */   // GIR_Coverage, 4102,
     /*  98758 */   GIR_EraseRootFromParent_Done,
     /*  98759 */ // Label 1850: @98759
     /*  98759 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(98819), // Rule ID 4103 //
     /*  98764 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98767 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98771 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98782 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98786 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  98793 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  98793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  98796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98813 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98817 */   GIR_RootConstrainSelectedInstOperands,
     /*  98818 */   // GIR_Coverage, 4103,
     /*  98818 */   GIR_EraseRootFromParent_Done,
     /*  98819 */ // Label 1851: @98819
     /*  98819 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(98879), // Rule ID 4104 //
     /*  98824 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98827 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98831 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  98838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98842 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98846 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  98853 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  98853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  98856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98873 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98877 */   GIR_RootConstrainSelectedInstOperands,
     /*  98878 */   // GIR_Coverage, 4104,
     /*  98878 */   GIR_EraseRootFromParent_Done,
     /*  98879 */ // Label 1852: @98879
     /*  98879 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(98939), // Rule ID 4105 //
     /*  98884 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98887 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98891 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  98898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98902 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98906 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  98913 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  98913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  98916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98923 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98933 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98937 */   GIR_RootConstrainSelectedInstOperands,
     /*  98938 */   // GIR_Coverage, 4105,
     /*  98938 */   GIR_EraseRootFromParent_Done,
     /*  98939 */ // Label 1853: @98939
     /*  98939 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(98999), // Rule ID 4106 //
     /*  98944 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98947 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98951 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  98958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98962 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98966 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  98973 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  98973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  98976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98993 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98997 */   GIR_RootConstrainSelectedInstOperands,
     /*  98998 */   // GIR_Coverage, 4106,
     /*  98998 */   GIR_EraseRootFromParent_Done,
     /*  98999 */ // Label 1854: @98999
     /*  98999 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(99047), // Rule ID 260 //
     /*  99004 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99007 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99015 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99019 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  99026 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  99026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  99029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99036 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99041 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99045 */   GIR_RootConstrainSelectedInstOperands,
     /*  99046 */   // GIR_Coverage, 260,
     /*  99046 */   GIR_EraseRootFromParent_Done,
     /*  99047 */ // Label 1855: @99047
     /*  99047 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(99098), // Rule ID 263 //
     /*  99052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99055 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99058 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99066 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99070 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  99077 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  99077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  99080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99092 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99096 */   GIR_RootConstrainSelectedInstOperands,
     /*  99097 */   // GIR_Coverage, 263,
     /*  99097 */   GIR_EraseRootFromParent_Done,
     /*  99098 */ // Label 1856: @99098
     /*  99098 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(99157), // Rule ID 6981 //
     /*  99103 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99106 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99113 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99124 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  99131 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15794>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /*  99131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  99134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99151 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99155 */   GIR_RootConstrainSelectedInstOperands,
     /*  99156 */   // GIR_Coverage, 6981,
     /*  99156 */   GIR_EraseRootFromParent_Done,
     /*  99157 */ // Label 1857: @99157
     /*  99157 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(99216), // Rule ID 6983 //
     /*  99162 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99165 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99172 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99179 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99183 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  99190 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15794>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /*  99190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  99193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99210 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99214 */   GIR_RootConstrainSelectedInstOperands,
     /*  99215 */   // GIR_Coverage, 6983,
     /*  99215 */   GIR_EraseRootFromParent_Done,
     /*  99216 */ // Label 1858: @99216
     /*  99216 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(99275), // Rule ID 6993 //
     /*  99221 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99224 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99231 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99238 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99242 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  99249 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15803>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  99249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  99252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99269 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99273 */   GIR_RootConstrainSelectedInstOperands,
     /*  99274 */   // GIR_Coverage, 6993,
     /*  99274 */   GIR_EraseRootFromParent_Done,
     /*  99275 */ // Label 1859: @99275
     /*  99275 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(99334), // Rule ID 6995 //
     /*  99280 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99283 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99290 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99297 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99301 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  99308 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15803>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  99308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  99311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99332 */   GIR_RootConstrainSelectedInstOperands,
     /*  99333 */   // GIR_Coverage, 6995,
     /*  99333 */   GIR_EraseRootFromParent_Done,
     /*  99334 */ // Label 1860: @99334
     /*  99334 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(99393), // Rule ID 7003 //
     /*  99339 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99342 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  99349 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99356 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99360 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99367 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15811>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  99370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99387 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99391 */   GIR_RootConstrainSelectedInstOperands,
     /*  99392 */   // GIR_Coverage, 7003,
     /*  99392 */   GIR_EraseRootFromParent_Done,
     /*  99393 */ // Label 1861: @99393
     /*  99393 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(99452), // Rule ID 7004 //
     /*  99398 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99401 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  99408 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99426 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15811>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  99429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99446 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99450 */   GIR_RootConstrainSelectedInstOperands,
     /*  99451 */   // GIR_Coverage, 7004,
     /*  99451 */   GIR_EraseRootFromParent_Done,
     /*  99452 */ // Label 1862: @99452
     /*  99452 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(99500), // Rule ID 281 //
     /*  99457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99460 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  99479 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /*  99482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99498 */   GIR_RootConstrainSelectedInstOperands,
     /*  99499 */   // GIR_Coverage, 281,
     /*  99499 */   GIR_EraseRootFromParent_Done,
     /*  99500 */ // Label 1863: @99500
     /*  99500 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(99551), // Rule ID 284 //
     /*  99505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99508 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99511 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99519 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99523 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  99530 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  99533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99545 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99549 */   GIR_RootConstrainSelectedInstOperands,
     /*  99550 */   // GIR_Coverage, 284,
     /*  99550 */   GIR_EraseRootFromParent_Done,
     /*  99551 */ // Label 1864: @99551
     /*  99551 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(99605), // Rule ID 6985 //
     /*  99556 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99559 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99566 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99573 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99577 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  99584 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15794>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  99584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /*  99587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99599 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99603 */   GIR_RootConstrainSelectedInstOperands,
     /*  99604 */   // GIR_Coverage, 6985,
     /*  99604 */   GIR_EraseRootFromParent_Done,
     /*  99605 */ // Label 1865: @99605
     /*  99605 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(99659), // Rule ID 6987 //
     /*  99610 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99613 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99620 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99627 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99631 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  99638 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15794>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  99638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /*  99641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99653 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99657 */   GIR_RootConstrainSelectedInstOperands,
     /*  99658 */   // GIR_Coverage, 6987,
     /*  99658 */   GIR_EraseRootFromParent_Done,
     /*  99659 */ // Label 1866: @99659
     /*  99659 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(99713), // Rule ID 6997 //
     /*  99664 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99667 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99674 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99681 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99685 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  99692 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15803>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  99692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /*  99695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99707 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99711 */   GIR_RootConstrainSelectedInstOperands,
     /*  99712 */   // GIR_Coverage, 6997,
     /*  99712 */   GIR_EraseRootFromParent_Done,
     /*  99713 */ // Label 1867: @99713
     /*  99713 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(99767), // Rule ID 6999 //
     /*  99718 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99721 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99728 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99739 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  99746 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15803>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  99746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /*  99749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99761 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99765 */   GIR_RootConstrainSelectedInstOperands,
     /*  99766 */   // GIR_Coverage, 6999,
     /*  99766 */   GIR_EraseRootFromParent_Done,
     /*  99767 */ // Label 1868: @99767
     /*  99767 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(99821), // Rule ID 7005 //
     /*  99772 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99775 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  99782 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99789 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99793 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  99800 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15811>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  99800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  99803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99815 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99819 */   GIR_RootConstrainSelectedInstOperands,
     /*  99820 */   // GIR_Coverage, 7005,
     /*  99820 */   GIR_EraseRootFromParent_Done,
     /*  99821 */ // Label 1869: @99821
     /*  99821 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(99875), // Rule ID 7006 //
     /*  99826 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99829 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  99836 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99843 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99847 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  99854 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15811>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  99854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /*  99857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99869 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99873 */   GIR_RootConstrainSelectedInstOperands,
     /*  99874 */   // GIR_Coverage, 7006,
     /*  99874 */   GIR_EraseRootFromParent_Done,
     /*  99875 */ // Label 1870: @99875
     /*  99875 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(99932), // Rule ID 7361 //
     /*  99880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  99883 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99886 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99893 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99900 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99904 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  99911 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15792>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  99911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /*  99914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99926 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99930 */   GIR_RootConstrainSelectedInstOperands,
     /*  99931 */   // GIR_Coverage, 7361,
     /*  99931 */   GIR_EraseRootFromParent_Done,
     /*  99932 */ // Label 1871: @99932
     /*  99932 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(99989), // Rule ID 7363 //
     /*  99937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  99940 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99943 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99950 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99961 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  99968 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15801>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  99968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /*  99971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99978 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99983 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99987 */   GIR_RootConstrainSelectedInstOperands,
     /*  99988 */   // GIR_Coverage, 7363,
     /*  99988 */   GIR_EraseRootFromParent_Done,
     /*  99989 */ // Label 1872: @99989
     /*  99989 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(100046), // Rule ID 7365 //
     /*  99994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /*  99997 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100000 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100007 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100014 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100018 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100025 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15786>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 100028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100040 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100044 */   GIR_RootConstrainSelectedInstOperands,
     /* 100045 */   // GIR_Coverage, 7365,
     /* 100045 */   GIR_EraseRootFromParent_Done,
     /* 100046 */ // Label 1873: @100046
     /* 100046 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(100101), // Rule ID 4128 //
     /* 100051 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100054 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100058 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100069 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 100080 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 100080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 100083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100095 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100099 */   GIR_RootConstrainSelectedInstOperands,
     /* 100100 */   // GIR_Coverage, 4128,
     /* 100100 */   GIR_EraseRootFromParent_Done,
     /* 100101 */ // Label 1874: @100101
     /* 100101 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(100156), // Rule ID 4129 //
     /* 100106 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100109 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100113 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100124 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100128 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 100135 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 100135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 100138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100145 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100150 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100154 */   GIR_RootConstrainSelectedInstOperands,
     /* 100155 */   // GIR_Coverage, 4129,
     /* 100155 */   GIR_EraseRootFromParent_Done,
     /* 100156 */ // Label 1875: @100156
     /* 100156 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(100211), // Rule ID 4130 //
     /* 100161 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100164 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100168 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100179 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100183 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 100190 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 100190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 100193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100205 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100209 */   GIR_RootConstrainSelectedInstOperands,
     /* 100210 */   // GIR_Coverage, 4130,
     /* 100210 */   GIR_EraseRootFromParent_Done,
     /* 100211 */ // Label 1876: @100211
     /* 100211 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(100266), // Rule ID 4151 //
     /* 100216 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100219 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100223 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100234 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100238 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 100245 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 100248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100250 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100260 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100264 */   GIR_RootConstrainSelectedInstOperands,
     /* 100265 */   // GIR_Coverage, 4151,
     /* 100265 */   GIR_EraseRootFromParent_Done,
     /* 100266 */ // Label 1877: @100266
     /* 100266 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(100321), // Rule ID 4152 //
     /* 100271 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100274 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100278 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100289 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100293 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100300 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 100303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100310 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100315 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100319 */   GIR_RootConstrainSelectedInstOperands,
     /* 100320 */   // GIR_Coverage, 4152,
     /* 100320 */   GIR_EraseRootFromParent_Done,
     /* 100321 */ // Label 1878: @100321
     /* 100321 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(100376), // Rule ID 4153 //
     /* 100326 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100329 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100333 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100344 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100348 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100355 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 100358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100370 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100374 */   GIR_RootConstrainSelectedInstOperands,
     /* 100375 */   // GIR_Coverage, 4153,
     /* 100375 */   GIR_EraseRootFromParent_Done,
     /* 100376 */ // Label 1879: @100376
     /* 100376 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(100416), // Rule ID 6973 //
     /* 100381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 100384 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100387 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100394 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100401 */   // MIs[0] ptr
     /* 100401 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100409 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15782>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 100414 */   GIR_RootConstrainSelectedInstOperands,
     /* 100415 */   // GIR_Coverage, 6973,
     /* 100415 */   GIR_Done,
     /* 100416 */ // Label 1880: @100416
     /* 100416 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(100456), // Rule ID 6974 //
     /* 100421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 100424 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100427 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100434 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100441 */   // MIs[0] ptr
     /* 100441 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100449 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15784>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 100454 */   GIR_RootConstrainSelectedInstOperands,
     /* 100455 */   // GIR_Coverage, 6974,
     /* 100455 */   GIR_Done,
     /* 100456 */ // Label 1881: @100456
     /* 100456 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(100496), // Rule ID 6975 //
     /* 100461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 100464 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100467 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100474 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100481 */   // MIs[0] ptr
     /* 100481 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100489 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15786>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 100494 */   GIR_RootConstrainSelectedInstOperands,
     /* 100495 */   // GIR_Coverage, 6975,
     /* 100495 */   GIR_Done,
     /* 100496 */ // Label 1882: @100496
     /* 100496 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(100533), // Rule ID 6977 //
     /* 100501 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100504 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100511 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 100514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100518 */   // MIs[0] ptr
     /* 100518 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100526 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15790>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 100531 */   GIR_RootConstrainSelectedInstOperands,
     /* 100532 */   // GIR_Coverage, 6977,
     /* 100532 */   GIR_Done,
     /* 100533 */ // Label 1883: @100533
     /* 100533 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(100570), // Rule ID 6979 //
     /* 100538 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100541 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100555 */   // MIs[0] ptr
     /* 100555 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100563 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15792>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100563 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 100568 */   GIR_RootConstrainSelectedInstOperands,
     /* 100569 */   // GIR_Coverage, 6979,
     /* 100569 */   GIR_Done,
     /* 100570 */ // Label 1884: @100570
     /* 100570 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(100607), // Rule ID 6989 //
     /* 100575 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100578 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100585 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 100588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100592 */   // MIs[0] ptr
     /* 100592 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100600 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15799>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 100605 */   GIR_RootConstrainSelectedInstOperands,
     /* 100606 */   // GIR_Coverage, 6989,
     /* 100606 */   GIR_Done,
     /* 100607 */ // Label 1885: @100607
     /* 100607 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(100644), // Rule ID 6991 //
     /* 100612 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100615 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100622 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100629 */   // MIs[0] ptr
     /* 100629 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100637 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15801>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100637 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 100642 */   GIR_RootConstrainSelectedInstOperands,
     /* 100643 */   // GIR_Coverage, 6991,
     /* 100643 */   GIR_Done,
     /* 100644 */ // Label 1886: @100644
     /* 100644 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(100681), // Rule ID 7001 //
     /* 100649 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100652 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100659 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 100662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100666 */   // MIs[0] ptr
     /* 100666 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100674 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15808>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 100679 */   GIR_RootConstrainSelectedInstOperands,
     /* 100680 */   // GIR_Coverage, 7001,
     /* 100680 */   GIR_Done,
     /* 100681 */ // Label 1887: @100681
     /* 100681 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(100718), // Rule ID 7002 //
     /* 100686 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100689 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100696 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100703 */   // MIs[0] ptr
     /* 100703 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 100707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 100711 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15786>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 100711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 100716 */   GIR_RootConstrainSelectedInstOperands,
     /* 100717 */   // GIR_Coverage, 7002,
     /* 100717 */   GIR_Done,
     /* 100718 */ // Label 1888: @100718
     /* 100718 */ GIM_Reject,
     /* 100719 */ // Label 1817: @100719
     /* 100719 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(100772), // Rule ID 235 //
     /* 100724 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100727 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 100735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100739 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 100746 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 100746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 100749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100770 */   GIR_RootConstrainSelectedInstOperands,
     /* 100771 */   // GIR_Coverage, 235,
     /* 100771 */   GIR_EraseRootFromParent_Done,
     /* 100772 */ // Label 1889: @100772
     /* 100772 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(100825), // Rule ID 236 //
     /* 100777 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100780 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 100788 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100792 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 100799 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 100799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 100802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100823 */   GIR_RootConstrainSelectedInstOperands,
     /* 100824 */   // GIR_Coverage, 236,
     /* 100824 */   GIR_EraseRootFromParent_Done,
     /* 100825 */ // Label 1890: @100825
     /* 100825 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(100881), // Rule ID 243 //
     /* 100830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100833 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100836 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100844 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100848 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 100855 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 100855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 100858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100865 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100875 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100879 */   GIR_RootConstrainSelectedInstOperands,
     /* 100880 */   // GIR_Coverage, 243,
     /* 100880 */   GIR_EraseRootFromParent_Done,
     /* 100881 */ // Label 1891: @100881
     /* 100881 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(100937), // Rule ID 244 //
     /* 100886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100889 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100892 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100900 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100904 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 100911 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 100911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 100914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100921 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100931 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100935 */   GIR_RootConstrainSelectedInstOperands,
     /* 100936 */   // GIR_Coverage, 244,
     /* 100936 */   GIR_EraseRootFromParent_Done,
     /* 100937 */ // Label 1892: @100937
     /* 100937 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(100990), // Rule ID 4067 //
     /* 100942 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100945 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100957 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 100964 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 100964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 100967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100984 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100988 */   GIR_RootConstrainSelectedInstOperands,
     /* 100989 */   // GIR_Coverage, 4067,
     /* 100989 */   GIR_EraseRootFromParent_Done,
     /* 100990 */ // Label 1893: @100990
     /* 100990 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(101043), // Rule ID 4068 //
     /* 100995 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100998 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101006 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101010 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101017 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101041 */   GIR_RootConstrainSelectedInstOperands,
     /* 101042 */   // GIR_Coverage, 4068,
     /* 101042 */   GIR_EraseRootFromParent_Done,
     /* 101043 */ // Label 1894: @101043
     /* 101043 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(101096), // Rule ID 4069 //
     /* 101048 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101051 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101059 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101063 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101070 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101080 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101090 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101094 */   GIR_RootConstrainSelectedInstOperands,
     /* 101095 */   // GIR_Coverage, 4069,
     /* 101095 */   GIR_EraseRootFromParent_Done,
     /* 101096 */ // Label 1895: @101096
     /* 101096 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(101149), // Rule ID 4070 //
     /* 101101 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101104 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101123 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101143 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101147 */   GIR_RootConstrainSelectedInstOperands,
     /* 101148 */   // GIR_Coverage, 4070,
     /* 101148 */   GIR_EraseRootFromParent_Done,
     /* 101149 */ // Label 1896: @101149
     /* 101149 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(101241), // Rule ID 4093 //
     /* 101154 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101157 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101161 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101172 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101176 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 101183 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 101183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 101186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 101190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101210 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 101230 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101235 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101240 */   // GIR_Coverage, 4093,
     /* 101240 */   GIR_EraseRootFromParent_Done,
     /* 101241 */ // Label 1897: @101241
     /* 101241 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(101333), // Rule ID 4094 //
     /* 101246 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101249 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101253 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101264 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101268 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 101275 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 101275 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 101278 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 101282 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101302 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 101322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101327 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101332 */   // GIR_Coverage, 4094,
     /* 101332 */   GIR_EraseRootFromParent_Done,
     /* 101333 */ // Label 1898: @101333
     /* 101333 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(101425), // Rule ID 4095 //
     /* 101338 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101341 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101345 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101356 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101360 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 101367 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 101367 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 101370 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 101374 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101394 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 101414 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101424 */   // GIR_Coverage, 4095,
     /* 101424 */   GIR_EraseRootFromParent_Done,
     /* 101425 */ // Label 1899: @101425
     /* 101425 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(101517), // Rule ID 4096 //
     /* 101430 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101433 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101437 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101448 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101452 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 101459 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 101459 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 101462 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 101466 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101486 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 101506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101511 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101516 */   // GIR_Coverage, 4096,
     /* 101516 */   GIR_EraseRootFromParent_Done,
     /* 101517 */ // Label 1900: @101517
     /* 101517 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(101609), // Rule ID 4097 //
     /* 101522 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101525 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101529 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101540 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101544 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 101551 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 101551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 101554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 101558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101563 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101578 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 101598 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101603 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101608 */   // GIR_Coverage, 4097,
     /* 101608 */   GIR_EraseRootFromParent_Done,
     /* 101609 */ // Label 1901: @101609
     /* 101609 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(101701), // Rule ID 4098 //
     /* 101614 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101617 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101621 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101632 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101636 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 101643 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 101643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 101646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 101650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101665 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101670 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101684 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 101690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101700 */   // GIR_Coverage, 4098,
     /* 101700 */   GIR_EraseRootFromParent_Done,
     /* 101701 */ // Label 1902: @101701
     /* 101701 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(101793), // Rule ID 4099 //
     /* 101706 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101709 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101713 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101724 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101728 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 101735 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 101735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 101738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 101742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101762 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 101782 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101792 */   // GIR_Coverage, 4099,
     /* 101792 */   GIR_EraseRootFromParent_Done,
     /* 101793 */ // Label 1903: @101793
     /* 101793 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(101885), // Rule ID 4100 //
     /* 101798 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101801 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101805 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101816 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101820 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 101827 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 101827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 101830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 101834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101854 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101868 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 101874 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101884 */   // GIR_Coverage, 4100,
     /* 101884 */   GIR_EraseRootFromParent_Done,
     /* 101885 */ // Label 1904: @101885
     /* 101885 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(101933), // Rule ID 259 //
     /* 101890 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101893 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 101901 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101905 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 101912 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 101912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 101915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101917 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101927 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101931 */   GIR_RootConstrainSelectedInstOperands,
     /* 101932 */   // GIR_Coverage, 259,
     /* 101932 */   GIR_EraseRootFromParent_Done,
     /* 101933 */ // Label 1905: @101933
     /* 101933 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(101984), // Rule ID 264 //
     /* 101938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 101941 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101944 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101952 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101956 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 101963 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 101963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 101966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101978 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101982 */   GIR_RootConstrainSelectedInstOperands,
     /* 101983 */   // GIR_Coverage, 264,
     /* 101983 */   GIR_EraseRootFromParent_Done,
     /* 101984 */ // Label 1906: @101984
     /* 101984 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102043), // Rule ID 7009 //
     /* 101989 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101992 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 101999 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102006 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102010 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102017 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15819>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 102020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102041 */   GIR_RootConstrainSelectedInstOperands,
     /* 102042 */   // GIR_Coverage, 7009,
     /* 102042 */   GIR_EraseRootFromParent_Done,
     /* 102043 */ // Label 1907: @102043
     /* 102043 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102102), // Rule ID 7010 //
     /* 102048 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102051 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102058 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102069 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102076 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15819>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 102079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102096 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102100 */   GIR_RootConstrainSelectedInstOperands,
     /* 102101 */   // GIR_Coverage, 7010,
     /* 102101 */   GIR_EraseRootFromParent_Done,
     /* 102102 */ // Label 1908: @102102
     /* 102102 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102150), // Rule ID 280 //
     /* 102107 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102110 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102118 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102122 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102129 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 102129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 102132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102134 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102144 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102148 */   GIR_RootConstrainSelectedInstOperands,
     /* 102149 */   // GIR_Coverage, 280,
     /* 102149 */   GIR_EraseRootFromParent_Done,
     /* 102150 */ // Label 1909: @102150
     /* 102150 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(102201), // Rule ID 285 //
     /* 102155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102158 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102161 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102169 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102173 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102180 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 102180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 102183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102195 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102199 */   GIR_RootConstrainSelectedInstOperands,
     /* 102200 */   // GIR_Coverage, 285,
     /* 102200 */   GIR_EraseRootFromParent_Done,
     /* 102201 */ // Label 1910: @102201
     /* 102201 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(102255), // Rule ID 7011 //
     /* 102206 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102209 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102216 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102223 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102227 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102234 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15819>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 102237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102249 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102253 */   GIR_RootConstrainSelectedInstOperands,
     /* 102254 */   // GIR_Coverage, 7011,
     /* 102254 */   GIR_EraseRootFromParent_Done,
     /* 102255 */ // Label 1911: @102255
     /* 102255 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(102309), // Rule ID 7012 //
     /* 102260 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102263 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102270 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102281 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102288 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15819>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 102291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102303 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102307 */   GIR_RootConstrainSelectedInstOperands,
     /* 102308 */   // GIR_Coverage, 7012,
     /* 102308 */   GIR_EraseRootFromParent_Done,
     /* 102309 */ // Label 1912: @102309
     /* 102309 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(102366), // Rule ID 7366 //
     /* 102314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 102317 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102320 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102327 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102334 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102338 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102345 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15788>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 102348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102360 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102364 */   GIR_RootConstrainSelectedInstOperands,
     /* 102365 */   // GIR_Coverage, 7366,
     /* 102365 */   GIR_EraseRootFromParent_Done,
     /* 102366 */ // Label 1913: @102366
     /* 102366 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(102414), // Rule ID 4114 //
     /* 102371 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102374 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102382 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102386 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102393 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 102396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102408 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102412 */   GIR_RootConstrainSelectedInstOperands,
     /* 102413 */   // GIR_Coverage, 4114,
     /* 102413 */   GIR_EraseRootFromParent_Done,
     /* 102414 */ // Label 1914: @102414
     /* 102414 */ GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(102462), // Rule ID 4115 //
     /* 102419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102422 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102430 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102434 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102441 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 102444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102451 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102456 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102460 */   GIR_RootConstrainSelectedInstOperands,
     /* 102461 */   // GIR_Coverage, 4115,
     /* 102461 */   GIR_EraseRootFromParent_Done,
     /* 102462 */ // Label 1915: @102462
     /* 102462 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(102549), // Rule ID 4131 //
     /* 102467 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102470 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102474 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102485 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102489 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 102496 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 102496 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102499 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 102503 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102518 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102538 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102543 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102548 */   // GIR_Coverage, 4131,
     /* 102548 */   GIR_EraseRootFromParent_Done,
     /* 102549 */ // Label 1916: @102549
     /* 102549 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(102636), // Rule ID 4132 //
     /* 102554 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102557 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102561 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102572 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102576 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 102583 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 102583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 102590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102600 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102605 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102625 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102630 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102635 */   // GIR_Coverage, 4132,
     /* 102635 */   GIR_EraseRootFromParent_Done,
     /* 102636 */ // Label 1917: @102636
     /* 102636 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(102723), // Rule ID 4133 //
     /* 102641 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102644 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102648 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102659 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102663 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 102670 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 102670 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102673 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 102677 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102687 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102692 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102722 */   // GIR_Coverage, 4133,
     /* 102722 */   GIR_EraseRootFromParent_Done,
     /* 102723 */ // Label 1918: @102723
     /* 102723 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(102810), // Rule ID 4134 //
     /* 102728 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102731 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102735 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102746 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102750 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 102757 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 102757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 102764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102774 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102779 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102783 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102796 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102799 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102804 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102809 */   // GIR_Coverage, 4134,
     /* 102809 */   GIR_EraseRootFromParent_Done,
     /* 102810 */ // Label 1919: @102810
     /* 102810 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(102858), // Rule ID 4142 //
     /* 102815 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102818 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102826 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102830 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102837 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 102840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102856 */   GIR_RootConstrainSelectedInstOperands,
     /* 102857 */   // GIR_Coverage, 4142,
     /* 102857 */   GIR_EraseRootFromParent_Done,
     /* 102858 */ // Label 1920: @102858
     /* 102858 */ GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(102906), // Rule ID 4143 //
     /* 102863 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102866 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102874 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102878 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102885 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 102885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 102888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102900 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102904 */   GIR_RootConstrainSelectedInstOperands,
     /* 102905 */   // GIR_Coverage, 4143,
     /* 102905 */   GIR_EraseRootFromParent_Done,
     /* 102906 */ // Label 1921: @102906
     /* 102906 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(102993), // Rule ID 4154 //
     /* 102911 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102914 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102918 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102929 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102933 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 102940 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 102940 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102943 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 102947 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102962 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102976 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102982 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102987 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102992 */   // GIR_Coverage, 4154,
     /* 102992 */   GIR_EraseRootFromParent_Done,
     /* 102993 */ // Label 1922: @102993
     /* 102993 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(103080), // Rule ID 4155 //
     /* 102998 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103001 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103005 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103016 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103020 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 103027 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 103034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103049 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103063 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103079 */   // GIR_Coverage, 4155,
     /* 103079 */   GIR_EraseRootFromParent_Done,
     /* 103080 */ // Label 1923: @103080
     /* 103080 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(103167), // Rule ID 4156 //
     /* 103085 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103088 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103092 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103103 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103107 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 103114 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103114 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103117 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 103121 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103126 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103136 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103140 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103156 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103166 */   // GIR_Coverage, 4156,
     /* 103166 */   GIR_EraseRootFromParent_Done,
     /* 103167 */ // Label 1924: @103167
     /* 103167 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(103254), // Rule ID 4157 //
     /* 103172 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103175 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103179 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103190 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103194 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 103201 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 103208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103223 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103243 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103248 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103253 */   // GIR_Coverage, 4157,
     /* 103253 */   GIR_EraseRootFromParent_Done,
     /* 103254 */ // Label 1925: @103254
     /* 103254 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(103294), // Rule ID 6976 //
     /* 103259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 103262 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103265 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103272 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103279 */   // MIs[0] ptr
     /* 103279 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103287 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15788>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 103287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 103292 */   GIR_RootConstrainSelectedInstOperands,
     /* 103293 */   // GIR_Coverage, 6976,
     /* 103293 */   GIR_Done,
     /* 103294 */ // Label 1926: @103294
     /* 103294 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(103331), // Rule ID 7007 //
     /* 103299 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103302 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103309 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 103312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103316 */   // MIs[0] ptr
     /* 103316 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103324 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15816>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 103324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 103329 */   GIR_RootConstrainSelectedInstOperands,
     /* 103330 */   // GIR_Coverage, 7007,
     /* 103330 */   GIR_Done,
     /* 103331 */ // Label 1927: @103331
     /* 103331 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(103368), // Rule ID 7008 //
     /* 103336 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103339 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103346 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103353 */   // MIs[0] ptr
     /* 103353 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103361 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15788>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 103361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 103366 */   GIR_RootConstrainSelectedInstOperands,
     /* 103367 */   // GIR_Coverage, 7008,
     /* 103367 */   GIR_Done,
     /* 103368 */ // Label 1928: @103368
     /* 103368 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(103399), // Rule ID 6356 //
     /* 103373 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103376 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103384 */   // MIs[0] Rn
     /* 103384 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103392 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 103392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 103397 */   GIR_RootConstrainSelectedInstOperands,
     /* 103398 */   // GIR_Coverage, 6356,
     /* 103398 */   GIR_Done,
     /* 103399 */ // Label 1929: @103399
     /* 103399 */ GIM_Reject,
     /* 103400 */ // Label 1818: @103400
     /* 103400 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(103608),
     /* 103405 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103408 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103420 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(103461), // Rule ID 245 //
     /* 103425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 103428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 103435 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 103435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 103438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103459 */     GIR_RootConstrainSelectedInstOperands,
     /* 103460 */     // GIR_Coverage, 245,
     /* 103460 */     GIR_EraseRootFromParent_Done,
     /* 103461 */   // Label 1931: @103461
     /* 103461 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(103502), // Rule ID 246 //
     /* 103466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 103469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 103476 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 103476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 103479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103500 */     GIR_RootConstrainSelectedInstOperands,
     /* 103501 */     // GIR_Coverage, 246,
     /* 103501 */     GIR_EraseRootFromParent_Done,
     /* 103502 */   // Label 1932: @103502
     /* 103502 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(103538), // Rule ID 265 //
     /* 103507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 103510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 103517 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 103517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 103520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103536 */     GIR_RootConstrainSelectedInstOperands,
     /* 103537 */     // GIR_Coverage, 265,
     /* 103537 */     GIR_EraseRootFromParent_Done,
     /* 103538 */   // Label 1933: @103538
     /* 103538 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(103574), // Rule ID 286 //
     /* 103543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 103546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 103553 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 103553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 103556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103572 */     GIR_RootConstrainSelectedInstOperands,
     /* 103573 */     // GIR_Coverage, 286,
     /* 103573 */     GIR_EraseRootFromParent_Done,
     /* 103574 */   // Label 1934: @103574
     /* 103574 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(103607), // Rule ID 4123 //
     /* 103579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 103586 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 103586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 103589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103605 */     GIR_RootConstrainSelectedInstOperands,
     /* 103606 */     // GIR_Coverage, 4123,
     /* 103606 */     GIR_EraseRootFromParent_Done,
     /* 103607 */   // Label 1935: @103607
     /* 103607 */   GIM_Reject,
     /* 103608 */ // Label 1930: @103608
     /* 103608 */ GIM_Reject,
     /* 103609 */ // Label 1819: @103609
     /* 103609 */ GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(103986),
     /* 103614 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103617 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103625 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(103670), // Rule ID 4057 //
     /* 103630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 103633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 103644 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 103644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 103647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103668 */     GIR_RootConstrainSelectedInstOperands,
     /* 103669 */     // GIR_Coverage, 4057,
     /* 103669 */     GIR_EraseRootFromParent_Done,
     /* 103670 */   // Label 1937: @103670
     /* 103670 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(103715), // Rule ID 4058 //
     /* 103675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 103678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 103689 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 103689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 103692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103713 */     GIR_RootConstrainSelectedInstOperands,
     /* 103714 */     // GIR_Coverage, 4058,
     /* 103714 */     GIR_EraseRootFromParent_Done,
     /* 103715 */   // Label 1938: @103715
     /* 103715 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(103760), // Rule ID 4059 //
     /* 103720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 103723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 103734 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 103734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 103737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103758 */     GIR_RootConstrainSelectedInstOperands,
     /* 103759 */     // GIR_Coverage, 4059,
     /* 103759 */     GIR_EraseRootFromParent_Done,
     /* 103760 */   // Label 1939: @103760
     /* 103760 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(103805), // Rule ID 4060 //
     /* 103765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 103768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 103779 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 103779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 103782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103803 */     GIR_RootConstrainSelectedInstOperands,
     /* 103804 */     // GIR_Coverage, 4060,
     /* 103804 */     GIR_EraseRootFromParent_Done,
     /* 103805 */   // Label 1940: @103805
     /* 103805 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(103845), // Rule ID 4109 //
     /* 103810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 103813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103824 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103843 */     GIR_RootConstrainSelectedInstOperands,
     /* 103844 */     // GIR_Coverage, 4109,
     /* 103844 */     GIR_EraseRootFromParent_Done,
     /* 103845 */   // Label 1941: @103845
     /* 103845 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(103885), // Rule ID 4112 //
     /* 103850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 103853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103864 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103883 */     GIR_RootConstrainSelectedInstOperands,
     /* 103884 */     // GIR_Coverage, 4112,
     /* 103884 */     GIR_EraseRootFromParent_Done,
     /* 103885 */   // Label 1942: @103885
     /* 103885 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(103925), // Rule ID 4137 //
     /* 103890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 103893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103904 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 103907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103923 */     GIR_RootConstrainSelectedInstOperands,
     /* 103924 */     // GIR_Coverage, 4137,
     /* 103924 */     GIR_EraseRootFromParent_Done,
     /* 103925 */   // Label 1943: @103925
     /* 103925 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(103965), // Rule ID 4138 //
     /* 103930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 103933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103944 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 103947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103963 */     GIR_RootConstrainSelectedInstOperands,
     /* 103964 */     // GIR_Coverage, 4138,
     /* 103964 */     GIR_EraseRootFromParent_Done,
     /* 103965 */   // Label 1944: @103965
     /* 103965 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(103985), // Rule ID 6355 //
     /* 103970 */     // MIs[0] Rn
     /* 103970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 103978 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 103978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 103983 */     GIR_RootConstrainSelectedInstOperands,
     /* 103984 */     // GIR_Coverage, 6355,
     /* 103984 */     GIR_Done,
     /* 103985 */   // Label 1945: @103985
     /* 103985 */   GIM_Reject,
     /* 103986 */ // Label 1936: @103986
     /* 103986 */ GIM_Reject,
     /* 103987 */ // Label 1820: @103987
     /* 103987 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(104364),
     /* 103992 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103995 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104003 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(104048), // Rule ID 4071 //
     /* 104008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104022 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104046 */     GIR_RootConstrainSelectedInstOperands,
     /* 104047 */     // GIR_Coverage, 4071,
     /* 104047 */     GIR_EraseRootFromParent_Done,
     /* 104048 */   // Label 1947: @104048
     /* 104048 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(104093), // Rule ID 4072 //
     /* 104053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104067 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104091 */     GIR_RootConstrainSelectedInstOperands,
     /* 104092 */     // GIR_Coverage, 4072,
     /* 104092 */     GIR_EraseRootFromParent_Done,
     /* 104093 */   // Label 1948: @104093
     /* 104093 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(104138), // Rule ID 4073 //
     /* 104098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104112 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104136 */     GIR_RootConstrainSelectedInstOperands,
     /* 104137 */     // GIR_Coverage, 4073,
     /* 104137 */     GIR_EraseRootFromParent_Done,
     /* 104138 */   // Label 1949: @104138
     /* 104138 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(104183), // Rule ID 4074 //
     /* 104143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104157 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104181 */     GIR_RootConstrainSelectedInstOperands,
     /* 104182 */     // GIR_Coverage, 4074,
     /* 104182 */     GIR_EraseRootFromParent_Done,
     /* 104183 */   // Label 1950: @104183
     /* 104183 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(104223), // Rule ID 4117 //
     /* 104188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104202 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104221 */     GIR_RootConstrainSelectedInstOperands,
     /* 104222 */     // GIR_Coverage, 4117,
     /* 104222 */     GIR_EraseRootFromParent_Done,
     /* 104223 */   // Label 1951: @104223
     /* 104223 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(104263), // Rule ID 4121 //
     /* 104228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104242 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104261 */     GIR_RootConstrainSelectedInstOperands,
     /* 104262 */     // GIR_Coverage, 4121,
     /* 104262 */     GIR_EraseRootFromParent_Done,
     /* 104263 */   // Label 1952: @104263
     /* 104263 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(104303), // Rule ID 4144 //
     /* 104268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 104282 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 104285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104301 */     GIR_RootConstrainSelectedInstOperands,
     /* 104302 */     // GIR_Coverage, 4144,
     /* 104302 */     GIR_EraseRootFromParent_Done,
     /* 104303 */   // Label 1953: @104303
     /* 104303 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(104343), // Rule ID 4145 //
     /* 104308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 104322 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 104325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104341 */     GIR_RootConstrainSelectedInstOperands,
     /* 104342 */     // GIR_Coverage, 4145,
     /* 104342 */     GIR_EraseRootFromParent_Done,
     /* 104343 */   // Label 1954: @104343
     /* 104343 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(104363), // Rule ID 6352 //
     /* 104348 */     // MIs[0] Rn
     /* 104348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104356 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 104356 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 104361 */     GIR_RootConstrainSelectedInstOperands,
     /* 104362 */     // GIR_Coverage, 6352,
     /* 104362 */     GIR_Done,
     /* 104363 */   // Label 1955: @104363
     /* 104363 */   GIM_Reject,
     /* 104364 */ // Label 1946: @104364
     /* 104364 */ GIM_Reject,
     /* 104365 */ // Label 1821: @104365
     /* 104365 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(104742),
     /* 104370 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104373 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104381 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(104426), // Rule ID 4063 //
     /* 104386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 104400 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 104400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 104403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104424 */     GIR_RootConstrainSelectedInstOperands,
     /* 104425 */     // GIR_Coverage, 4063,
     /* 104425 */     GIR_EraseRootFromParent_Done,
     /* 104426 */   // Label 1957: @104426
     /* 104426 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(104471), // Rule ID 4064 //
     /* 104431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 104445 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 104445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 104448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104469 */     GIR_RootConstrainSelectedInstOperands,
     /* 104470 */     // GIR_Coverage, 4064,
     /* 104470 */     GIR_EraseRootFromParent_Done,
     /* 104471 */   // Label 1958: @104471
     /* 104471 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(104516), // Rule ID 4065 //
     /* 104476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 104490 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 104490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 104493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104514 */     GIR_RootConstrainSelectedInstOperands,
     /* 104515 */     // GIR_Coverage, 4065,
     /* 104515 */     GIR_EraseRootFromParent_Done,
     /* 104516 */   // Label 1959: @104516
     /* 104516 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(104561), // Rule ID 4066 //
     /* 104521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 104535 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 104535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 104538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104559 */     GIR_RootConstrainSelectedInstOperands,
     /* 104560 */     // GIR_Coverage, 4066,
     /* 104560 */     GIR_EraseRootFromParent_Done,
     /* 104561 */   // Label 1960: @104561
     /* 104561 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(104601), // Rule ID 4111 //
     /* 104566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 104580 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 104580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 104583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104599 */     GIR_RootConstrainSelectedInstOperands,
     /* 104600 */     // GIR_Coverage, 4111,
     /* 104600 */     GIR_EraseRootFromParent_Done,
     /* 104601 */   // Label 1961: @104601
     /* 104601 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(104641), // Rule ID 4113 //
     /* 104606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 104620 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 104620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 104623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104639 */     GIR_RootConstrainSelectedInstOperands,
     /* 104640 */     // GIR_Coverage, 4113,
     /* 104640 */     GIR_EraseRootFromParent_Done,
     /* 104641 */   // Label 1962: @104641
     /* 104641 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(104681), // Rule ID 4139 //
     /* 104646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104660 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104679 */     GIR_RootConstrainSelectedInstOperands,
     /* 104680 */     // GIR_Coverage, 4139,
     /* 104680 */     GIR_EraseRootFromParent_Done,
     /* 104681 */   // Label 1963: @104681
     /* 104681 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(104721), // Rule ID 4141 //
     /* 104686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104700 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104719 */     GIR_RootConstrainSelectedInstOperands,
     /* 104720 */     // GIR_Coverage, 4141,
     /* 104720 */     GIR_EraseRootFromParent_Done,
     /* 104721 */   // Label 1964: @104721
     /* 104721 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(104741), // Rule ID 6354 //
     /* 104726 */     // MIs[0] Rn
     /* 104726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104734 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 104734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 104739 */     GIR_RootConstrainSelectedInstOperands,
     /* 104740 */     // GIR_Coverage, 6354,
     /* 104740 */     GIR_Done,
     /* 104741 */   // Label 1965: @104741
     /* 104741 */   GIM_Reject,
     /* 104742 */ // Label 1956: @104742
     /* 104742 */ GIM_Reject,
     /* 104743 */ // Label 1822: @104743
     /* 104743 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(105120),
     /* 104748 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104751 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104759 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(104804), // Rule ID 4075 //
     /* 104764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104778 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104802 */     GIR_RootConstrainSelectedInstOperands,
     /* 104803 */     // GIR_Coverage, 4075,
     /* 104803 */     GIR_EraseRootFromParent_Done,
     /* 104804 */   // Label 1967: @104804
     /* 104804 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(104849), // Rule ID 4076 //
     /* 104809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104823 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104847 */     GIR_RootConstrainSelectedInstOperands,
     /* 104848 */     // GIR_Coverage, 4076,
     /* 104848 */     GIR_EraseRootFromParent_Done,
     /* 104849 */   // Label 1968: @104849
     /* 104849 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(104894), // Rule ID 4077 //
     /* 104854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104868 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104892 */     GIR_RootConstrainSelectedInstOperands,
     /* 104893 */     // GIR_Coverage, 4077,
     /* 104893 */     GIR_EraseRootFromParent_Done,
     /* 104894 */   // Label 1969: @104894
     /* 104894 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(104939), // Rule ID 4078 //
     /* 104899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104913 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104937 */     GIR_RootConstrainSelectedInstOperands,
     /* 104938 */     // GIR_Coverage, 4078,
     /* 104938 */     GIR_EraseRootFromParent_Done,
     /* 104939 */   // Label 1970: @104939
     /* 104939 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(104979), // Rule ID 4116 //
     /* 104944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104958 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104977 */     GIR_RootConstrainSelectedInstOperands,
     /* 104978 */     // GIR_Coverage, 4116,
     /* 104978 */     GIR_EraseRootFromParent_Done,
     /* 104979 */   // Label 1971: @104979
     /* 104979 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(105019), // Rule ID 4120 //
     /* 104984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104998 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105017 */     GIR_RootConstrainSelectedInstOperands,
     /* 105018 */     // GIR_Coverage, 4120,
     /* 105018 */     GIR_EraseRootFromParent_Done,
     /* 105019 */   // Label 1972: @105019
     /* 105019 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(105059), // Rule ID 4146 //
     /* 105024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105038 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105057 */     GIR_RootConstrainSelectedInstOperands,
     /* 105058 */     // GIR_Coverage, 4146,
     /* 105058 */     GIR_EraseRootFromParent_Done,
     /* 105059 */   // Label 1973: @105059
     /* 105059 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(105099), // Rule ID 4147 //
     /* 105064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105078 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105097 */     GIR_RootConstrainSelectedInstOperands,
     /* 105098 */     // GIR_Coverage, 4147,
     /* 105098 */     GIR_EraseRootFromParent_Done,
     /* 105099 */   // Label 1974: @105099
     /* 105099 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(105119), // Rule ID 6351 //
     /* 105104 */     // MIs[0] Rn
     /* 105104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105112 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105112 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 105117 */     GIR_RootConstrainSelectedInstOperands,
     /* 105118 */     // GIR_Coverage, 6351,
     /* 105118 */     GIR_Done,
     /* 105119 */   // Label 1975: @105119
     /* 105119 */   GIM_Reject,
     /* 105120 */ // Label 1966: @105120
     /* 105120 */ GIM_Reject,
     /* 105121 */ // Label 1823: @105121
     /* 105121 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(105328),
     /* 105126 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105129 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105137 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(105182), // Rule ID 4061 //
     /* 105142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105156 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105180 */     GIR_RootConstrainSelectedInstOperands,
     /* 105181 */     // GIR_Coverage, 4061,
     /* 105181 */     GIR_EraseRootFromParent_Done,
     /* 105182 */   // Label 1977: @105182
     /* 105182 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(105227), // Rule ID 4062 //
     /* 105187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105201 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105225 */     GIR_RootConstrainSelectedInstOperands,
     /* 105226 */     // GIR_Coverage, 4062,
     /* 105226 */     GIR_EraseRootFromParent_Done,
     /* 105227 */   // Label 1978: @105227
     /* 105227 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(105267), // Rule ID 4110 //
     /* 105232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105246 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105261 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105265 */     GIR_RootConstrainSelectedInstOperands,
     /* 105266 */     // GIR_Coverage, 4110,
     /* 105266 */     GIR_EraseRootFromParent_Done,
     /* 105267 */   // Label 1979: @105267
     /* 105267 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(105307), // Rule ID 4140 //
     /* 105272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105286 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105305 */     GIR_RootConstrainSelectedInstOperands,
     /* 105306 */     // GIR_Coverage, 4140,
     /* 105306 */     GIR_EraseRootFromParent_Done,
     /* 105307 */   // Label 1980: @105307
     /* 105307 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(105327), // Rule ID 6353 //
     /* 105312 */     // MIs[0] Rn
     /* 105312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105320 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 105325 */     GIR_RootConstrainSelectedInstOperands,
     /* 105326 */     // GIR_Coverage, 6353,
     /* 105326 */     GIR_Done,
     /* 105327 */   // Label 1981: @105327
     /* 105327 */   GIM_Reject,
     /* 105328 */ // Label 1976: @105328
     /* 105328 */ GIM_Reject,
     /* 105329 */ // Label 1824: @105329
     /* 105329 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(105706),
     /* 105334 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105337 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105345 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(105390), // Rule ID 4079 //
     /* 105350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105364 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105388 */     GIR_RootConstrainSelectedInstOperands,
     /* 105389 */     // GIR_Coverage, 4079,
     /* 105389 */     GIR_EraseRootFromParent_Done,
     /* 105390 */   // Label 1983: @105390
     /* 105390 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(105435), // Rule ID 4080 //
     /* 105395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105409 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105433 */     GIR_RootConstrainSelectedInstOperands,
     /* 105434 */     // GIR_Coverage, 4080,
     /* 105434 */     GIR_EraseRootFromParent_Done,
     /* 105435 */   // Label 1984: @105435
     /* 105435 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(105480), // Rule ID 4081 //
     /* 105440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105454 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105478 */     GIR_RootConstrainSelectedInstOperands,
     /* 105479 */     // GIR_Coverage, 4081,
     /* 105479 */     GIR_EraseRootFromParent_Done,
     /* 105480 */   // Label 1985: @105480
     /* 105480 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(105525), // Rule ID 4082 //
     /* 105485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105499 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105523 */     GIR_RootConstrainSelectedInstOperands,
     /* 105524 */     // GIR_Coverage, 4082,
     /* 105524 */     GIR_EraseRootFromParent_Done,
     /* 105525 */   // Label 1986: @105525
     /* 105525 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(105565), // Rule ID 4119 //
     /* 105530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105544 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105563 */     GIR_RootConstrainSelectedInstOperands,
     /* 105564 */     // GIR_Coverage, 4119,
     /* 105564 */     GIR_EraseRootFromParent_Done,
     /* 105565 */   // Label 1987: @105565
     /* 105565 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(105605), // Rule ID 4122 //
     /* 105570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105584 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105603 */     GIR_RootConstrainSelectedInstOperands,
     /* 105604 */     // GIR_Coverage, 4122,
     /* 105604 */     GIR_EraseRootFromParent_Done,
     /* 105605 */   // Label 1988: @105605
     /* 105605 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(105645), // Rule ID 4148 //
     /* 105610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105624 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105643 */     GIR_RootConstrainSelectedInstOperands,
     /* 105644 */     // GIR_Coverage, 4148,
     /* 105644 */     GIR_EraseRootFromParent_Done,
     /* 105645 */   // Label 1989: @105645
     /* 105645 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(105685), // Rule ID 4150 //
     /* 105650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105664 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105683 */     GIR_RootConstrainSelectedInstOperands,
     /* 105684 */     // GIR_Coverage, 4150,
     /* 105684 */     GIR_EraseRootFromParent_Done,
     /* 105685 */   // Label 1990: @105685
     /* 105685 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(105705), // Rule ID 6350 //
     /* 105690 */     // MIs[0] Rn
     /* 105690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105698 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 105703 */     GIR_RootConstrainSelectedInstOperands,
     /* 105704 */     // GIR_Coverage, 6350,
     /* 105704 */     GIR_Done,
     /* 105705 */   // Label 1991: @105705
     /* 105705 */   GIM_Reject,
     /* 105706 */ // Label 1982: @105706
     /* 105706 */ GIM_Reject,
     /* 105707 */ // Label 1825: @105707
     /* 105707 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(105914),
     /* 105712 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105715 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105723 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(105768), // Rule ID 4083 //
     /* 105728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105742 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105766 */     GIR_RootConstrainSelectedInstOperands,
     /* 105767 */     // GIR_Coverage, 4083,
     /* 105767 */     GIR_EraseRootFromParent_Done,
     /* 105768 */   // Label 1993: @105768
     /* 105768 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(105813), // Rule ID 4084 //
     /* 105773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105787 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105811 */     GIR_RootConstrainSelectedInstOperands,
     /* 105812 */     // GIR_Coverage, 4084,
     /* 105812 */     GIR_EraseRootFromParent_Done,
     /* 105813 */   // Label 1994: @105813
     /* 105813 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(105853), // Rule ID 4118 //
     /* 105818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105832 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105851 */     GIR_RootConstrainSelectedInstOperands,
     /* 105852 */     // GIR_Coverage, 4118,
     /* 105852 */     GIR_EraseRootFromParent_Done,
     /* 105853 */   // Label 1995: @105853
     /* 105853 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(105893), // Rule ID 4149 //
     /* 105858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105872 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105891 */     GIR_RootConstrainSelectedInstOperands,
     /* 105892 */     // GIR_Coverage, 4149,
     /* 105892 */     GIR_EraseRootFromParent_Done,
     /* 105893 */   // Label 1996: @105893
     /* 105893 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(105913), // Rule ID 6349 //
     /* 105898 */     // MIs[0] Rn
     /* 105898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105906 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 105911 */     GIR_RootConstrainSelectedInstOperands,
     /* 105912 */     // GIR_Coverage, 6349,
     /* 105912 */     GIR_Done,
     /* 105913 */   // Label 1997: @105913
     /* 105913 */   GIM_Reject,
     /* 105914 */ // Label 1992: @105914
     /* 105914 */ GIM_Reject,
     /* 105915 */ // Label 1826: @105915
     /* 105915 */ GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(105978), // Rule ID 10875 //
     /* 105920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 105923 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105926 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 105934 */   // MIs[0] base
     /* 105934 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105942 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 105942 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 105945 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 105949 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105954 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 105957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 105962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 105964 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105967 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 105969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105976 */   GIR_RootConstrainSelectedInstOperands,
     /* 105977 */   // GIR_Coverage, 10875,
     /* 105977 */   GIR_EraseRootFromParent_Done,
     /* 105978 */ // Label 1998: @105978
     /* 105978 */ GIM_Reject,
     /* 105979 */ // Label 1827: @105979
     /* 105979 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(106042), // Rule ID 10881 //
     /* 105984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 105987 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105990 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 105998 */   // MIs[0] base
     /* 105998 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106006 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106018 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 106026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106031 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106036 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106040 */   GIR_RootConstrainSelectedInstOperands,
     /* 106041 */   // GIR_Coverage, 10881,
     /* 106041 */   GIR_EraseRootFromParent_Done,
     /* 106042 */ // Label 1999: @106042
     /* 106042 */ GIM_Reject,
     /* 106043 */ // Label 1828: @106043
     /* 106043 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(106216),
     /* 106048 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106051 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106059 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106063 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(106111), // Rule ID 10866 //
     /* 106068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106075 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106087 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 106095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106100 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106109 */     GIR_RootConstrainSelectedInstOperands,
     /* 106110 */     // GIR_Coverage, 10866,
     /* 106110 */     GIR_EraseRootFromParent_Done,
     /* 106111 */   // Label 2001: @106111
     /* 106111 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(106159), // Rule ID 10884 //
     /* 106116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106123 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106135 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 106143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106148 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106157 */     GIR_RootConstrainSelectedInstOperands,
     /* 106158 */     // GIR_Coverage, 10884,
     /* 106158 */     GIR_EraseRootFromParent_Done,
     /* 106159 */   // Label 2002: @106159
     /* 106159 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(106187), // Rule ID 10911 //
     /* 106164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 106167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106171 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 106174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106176 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106185 */     GIR_RootConstrainSelectedInstOperands,
     /* 106186 */     // GIR_Coverage, 10911,
     /* 106186 */     GIR_EraseRootFromParent_Done,
     /* 106187 */   // Label 2003: @106187
     /* 106187 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(106215), // Rule ID 10923 //
     /* 106192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 106195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106199 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 106202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106204 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106213 */     GIR_RootConstrainSelectedInstOperands,
     /* 106214 */     // GIR_Coverage, 10923,
     /* 106214 */     GIR_EraseRootFromParent_Done,
     /* 106215 */   // Label 2004: @106215
     /* 106215 */   GIM_Reject,
     /* 106216 */ // Label 2000: @106216
     /* 106216 */ GIM_Reject,
     /* 106217 */ // Label 1829: @106217
     /* 106217 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(106280), // Rule ID 10872 //
     /* 106222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106228 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106236 */   // MIs[0] base
     /* 106236 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106244 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106244 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106247 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 106251 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106256 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 106264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106266 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106269 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106274 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106278 */   GIR_RootConstrainSelectedInstOperands,
     /* 106279 */   // GIR_Coverage, 10872,
     /* 106279 */   GIR_EraseRootFromParent_Done,
     /* 106280 */ // Label 2005: @106280
     /* 106280 */ GIM_Reject,
     /* 106281 */ // Label 1830: @106281
     /* 106281 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(106454),
     /* 106286 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106289 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106297 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106301 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(106349), // Rule ID 10854 //
     /* 106306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106313 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 106320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106325 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 106333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106338 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106347 */     GIR_RootConstrainSelectedInstOperands,
     /* 106348 */     // GIR_Coverage, 10854,
     /* 106348 */     GIR_EraseRootFromParent_Done,
     /* 106349 */   // Label 2007: @106349
     /* 106349 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(106397), // Rule ID 10878 //
     /* 106354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106361 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 106368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106373 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 106381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106386 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106395 */     GIR_RootConstrainSelectedInstOperands,
     /* 106396 */     // GIR_Coverage, 10878,
     /* 106396 */     GIR_EraseRootFromParent_Done,
     /* 106397 */   // Label 2008: @106397
     /* 106397 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(106425), // Rule ID 10907 //
     /* 106402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 106405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106409 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 106412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106414 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106423 */     GIR_RootConstrainSelectedInstOperands,
     /* 106424 */     // GIR_Coverage, 10907,
     /* 106424 */     GIR_EraseRootFromParent_Done,
     /* 106425 */   // Label 2009: @106425
     /* 106425 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(106453), // Rule ID 10919 //
     /* 106430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 106433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106437 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 106440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106442 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106451 */     GIR_RootConstrainSelectedInstOperands,
     /* 106452 */     // GIR_Coverage, 10919,
     /* 106452 */     GIR_EraseRootFromParent_Done,
     /* 106453 */   // Label 2010: @106453
     /* 106453 */   GIM_Reject,
     /* 106454 */ // Label 2006: @106454
     /* 106454 */ GIM_Reject,
     /* 106455 */ // Label 1831: @106455
     /* 106455 */ GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(106628),
     /* 106460 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106463 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106471 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106475 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(106523), // Rule ID 10833 //
     /* 106480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106487 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 106494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106499 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 106507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106512 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106521 */     GIR_RootConstrainSelectedInstOperands,
     /* 106522 */     // GIR_Coverage, 10833,
     /* 106522 */     GIR_EraseRootFromParent_Done,
     /* 106523 */   // Label 2012: @106523
     /* 106523 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(106571), // Rule ID 10869 //
     /* 106528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106535 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 106542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106547 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 106555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106560 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106569 */     GIR_RootConstrainSelectedInstOperands,
     /* 106570 */     // GIR_Coverage, 10869,
     /* 106570 */     GIR_EraseRootFromParent_Done,
     /* 106571 */   // Label 2013: @106571
     /* 106571 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(106599), // Rule ID 10903 //
     /* 106576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 106579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106583 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 106586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106588 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106597 */     GIR_RootConstrainSelectedInstOperands,
     /* 106598 */     // GIR_Coverage, 10903,
     /* 106598 */     GIR_EraseRootFromParent_Done,
     /* 106599 */   // Label 2014: @106599
     /* 106599 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(106627), // Rule ID 10915 //
     /* 106604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 106607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106611 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 106614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106616 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106625 */     GIR_RootConstrainSelectedInstOperands,
     /* 106626 */     // GIR_Coverage, 10915,
     /* 106626 */     GIR_EraseRootFromParent_Done,
     /* 106627 */   // Label 2015: @106627
     /* 106627 */   GIM_Reject,
     /* 106628 */ // Label 2011: @106628
     /* 106628 */ GIM_Reject,
     /* 106629 */ // Label 1832: @106629
     /* 106629 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(106672), // Rule ID 2419 //
     /* 106634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106637 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106640 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 106648 */   // MIs[0] base
     /* 106648 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106656 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 106659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 106661 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106666 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106670 */   GIR_RootConstrainSelectedInstOperands,
     /* 106671 */   // GIR_Coverage, 2419,
     /* 106671 */   GIR_EraseRootFromParent_Done,
     /* 106672 */ // Label 2016: @106672
     /* 106672 */ GIM_Reject,
     /* 106673 */ // Label 1833: @106673
     /* 106673 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(106770),
     /* 106678 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106681 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106689 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106693 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(106741), // Rule ID 10801 //
     /* 106698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106705 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 106712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106717 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 106725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106730 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106739 */     GIR_RootConstrainSelectedInstOperands,
     /* 106740 */     // GIR_Coverage, 10801,
     /* 106740 */     GIR_EraseRootFromParent_Done,
     /* 106741 */   // Label 2018: @106741
     /* 106741 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(106769), // Rule ID 10899 //
     /* 106746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 106749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106753 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 106756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106758 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106767 */     GIR_RootConstrainSelectedInstOperands,
     /* 106768 */     // GIR_Coverage, 10899,
     /* 106768 */     GIR_EraseRootFromParent_Done,
     /* 106769 */   // Label 2019: @106769
     /* 106769 */   GIM_Reject,
     /* 106770 */ // Label 2017: @106770
     /* 106770 */ GIM_Reject,
     /* 106771 */ // Label 1834: @106771
     /* 106771 */ GIM_Reject,
     /* 106772 */ // Label 17: @106772
     /* 106772 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2022*/ GIMT_Encode4(107821),
     /* 106783 */ /*GILLT_s32*//*Label 2020*/ GIMT_Encode4(106791),
     /* 106787 */ /*GILLT_s64*//*Label 2021*/ GIMT_Encode4(107205),
     /* 106791 */ // Label 2020: @106791
     /* 106791 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(107204),
     /* 106796 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106799 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(106852), // Rule ID 247 //
     /* 106804 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 106826 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 106826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 106829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106850 */     GIR_RootConstrainSelectedInstOperands,
     /* 106851 */     // GIR_Coverage, 247,
     /* 106851 */     GIR_EraseRootFromParent_Done,
     /* 106852 */   // Label 2024: @106852
     /* 106852 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(106905), // Rule ID 248 //
     /* 106857 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 106864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 106879 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 106879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 106882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106903 */     GIR_RootConstrainSelectedInstOperands,
     /* 106904 */     // GIR_Coverage, 248,
     /* 106904 */     GIR_EraseRootFromParent_Done,
     /* 106905 */   // Label 2025: @106905
     /* 106905 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(106958), // Rule ID 251 //
     /* 106910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106921 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 106932 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 106932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 106935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106956 */     GIR_RootConstrainSelectedInstOperands,
     /* 106957 */     // GIR_Coverage, 251,
     /* 106957 */     GIR_EraseRootFromParent_Done,
     /* 106958 */   // Label 2026: @106958
     /* 106958 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(107011), // Rule ID 252 //
     /* 106963 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 106970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 106985 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 106985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 106988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107009 */     GIR_RootConstrainSelectedInstOperands,
     /* 107010 */     // GIR_Coverage, 252,
     /* 107010 */     GIR_EraseRootFromParent_Done,
     /* 107011 */   // Label 2027: @107011
     /* 107011 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(107059), // Rule ID 268 //
     /* 107016 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 107038 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 107038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 107041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107057 */     GIR_RootConstrainSelectedInstOperands,
     /* 107058 */     // GIR_Coverage, 268,
     /* 107058 */     GIR_EraseRootFromParent_Done,
     /* 107059 */   // Label 2028: @107059
     /* 107059 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(107107), // Rule ID 270 //
     /* 107064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 107086 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 107086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 107089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107105 */     GIR_RootConstrainSelectedInstOperands,
     /* 107106 */     // GIR_Coverage, 270,
     /* 107106 */     GIR_EraseRootFromParent_Done,
     /* 107107 */   // Label 2029: @107107
     /* 107107 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(107155), // Rule ID 289 //
     /* 107112 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 107134 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 107134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 107137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107153 */     GIR_RootConstrainSelectedInstOperands,
     /* 107154 */     // GIR_Coverage, 289,
     /* 107154 */     GIR_EraseRootFromParent_Done,
     /* 107155 */   // Label 2030: @107155
     /* 107155 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(107203), // Rule ID 291 //
     /* 107160 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107182 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 107182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 107185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107201 */     GIR_RootConstrainSelectedInstOperands,
     /* 107202 */     // GIR_Coverage, 291,
     /* 107202 */     GIR_EraseRootFromParent_Done,
     /* 107203 */   // Label 2031: @107203
     /* 107203 */   GIM_Reject,
     /* 107204 */ // Label 2023: @107204
     /* 107204 */ GIM_Reject,
     /* 107205 */ // Label 2021: @107205
     /* 107205 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(107820),
     /* 107210 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107213 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(107266), // Rule ID 249 //
     /* 107218 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 107240 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 107240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 107243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107264 */     GIR_RootConstrainSelectedInstOperands,
     /* 107265 */     // GIR_Coverage, 249,
     /* 107265 */     GIR_EraseRootFromParent_Done,
     /* 107266 */   // Label 2033: @107266
     /* 107266 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(107319), // Rule ID 250 //
     /* 107271 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 107293 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 107293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 107296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107317 */     GIR_RootConstrainSelectedInstOperands,
     /* 107318 */     // GIR_Coverage, 250,
     /* 107318 */     GIR_EraseRootFromParent_Done,
     /* 107319 */   // Label 2034: @107319
     /* 107319 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(107372), // Rule ID 253 //
     /* 107324 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 107346 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 107346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 107349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107370 */     GIR_RootConstrainSelectedInstOperands,
     /* 107371 */     // GIR_Coverage, 253,
     /* 107371 */     GIR_EraseRootFromParent_Done,
     /* 107372 */   // Label 2035: @107372
     /* 107372 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(107425), // Rule ID 254 //
     /* 107377 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 107399 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 107399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 107402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107423 */     GIR_RootConstrainSelectedInstOperands,
     /* 107424 */     // GIR_Coverage, 254,
     /* 107424 */     GIR_EraseRootFromParent_Done,
     /* 107425 */   // Label 2036: @107425
     /* 107425 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(107478), // Rule ID 255 //
     /* 107430 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 107437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 107452 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 107452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 107455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107476 */     GIR_RootConstrainSelectedInstOperands,
     /* 107477 */     // GIR_Coverage, 255,
     /* 107477 */     GIR_EraseRootFromParent_Done,
     /* 107478 */   // Label 2037: @107478
     /* 107478 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(107531), // Rule ID 256 //
     /* 107483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 107490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 107505 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 107505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 107508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107529 */     GIR_RootConstrainSelectedInstOperands,
     /* 107530 */     // GIR_Coverage, 256,
     /* 107530 */     GIR_EraseRootFromParent_Done,
     /* 107531 */   // Label 2038: @107531
     /* 107531 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(107579), // Rule ID 269 //
     /* 107536 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 107558 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 107558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 107561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107577 */     GIR_RootConstrainSelectedInstOperands,
     /* 107578 */     // GIR_Coverage, 269,
     /* 107578 */     GIR_EraseRootFromParent_Done,
     /* 107579 */   // Label 2039: @107579
     /* 107579 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(107627), // Rule ID 271 //
     /* 107584 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 107606 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 107606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 107609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107625 */     GIR_RootConstrainSelectedInstOperands,
     /* 107626 */     // GIR_Coverage, 271,
     /* 107626 */     GIR_EraseRootFromParent_Done,
     /* 107627 */   // Label 2040: @107627
     /* 107627 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(107675), // Rule ID 272 //
     /* 107632 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 107639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 107654 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 107654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 107657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107673 */     GIR_RootConstrainSelectedInstOperands,
     /* 107674 */     // GIR_Coverage, 272,
     /* 107674 */     GIR_EraseRootFromParent_Done,
     /* 107675 */   // Label 2041: @107675
     /* 107675 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(107723), // Rule ID 290 //
     /* 107680 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 107702 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 107702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 107705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107721 */     GIR_RootConstrainSelectedInstOperands,
     /* 107722 */     // GIR_Coverage, 290,
     /* 107722 */     GIR_EraseRootFromParent_Done,
     /* 107723 */   // Label 2042: @107723
     /* 107723 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(107771), // Rule ID 292 //
     /* 107728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107750 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 107750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 107753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107769 */     GIR_RootConstrainSelectedInstOperands,
     /* 107770 */     // GIR_Coverage, 292,
     /* 107770 */     GIR_EraseRootFromParent_Done,
     /* 107771 */   // Label 2043: @107771
     /* 107771 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(107819), // Rule ID 293 //
     /* 107776 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 107783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 107798 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 107798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 107801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107817 */     GIR_RootConstrainSelectedInstOperands,
     /* 107818 */     // GIR_Coverage, 293,
     /* 107818 */     GIR_EraseRootFromParent_Done,
     /* 107819 */   // Label 2044: @107819
     /* 107819 */   GIM_Reject,
     /* 107820 */ // Label 2032: @107820
     /* 107820 */ GIM_Reject,
     /* 107821 */ // Label 2022: @107821
     /* 107821 */ GIM_Reject,
     /* 107822 */ // Label 18: @107822
     /* 107822 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2047*/ GIMT_Encode4(110790),
     /* 107833 */ /*GILLT_s32*//*Label 2045*/ GIMT_Encode4(107841),
     /* 107837 */ /*GILLT_s64*//*Label 2046*/ GIMT_Encode4(109300),
     /* 107841 */ // Label 2045: @107841
     /* 107841 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(107897), // Rule ID 229 //
     /* 107846 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107849 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107860 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107864 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 107871 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 107871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 107874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107891 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107895 */   GIR_RootConstrainSelectedInstOperands,
     /* 107896 */   // GIR_Coverage, 229,
     /* 107896 */   GIR_EraseRootFromParent_Done,
     /* 107897 */ // Label 2048: @107897
     /* 107897 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(107953), // Rule ID 230 //
     /* 107902 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107905 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107916 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107920 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 107927 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 107927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 107930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107947 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107951 */   GIR_RootConstrainSelectedInstOperands,
     /* 107952 */   // GIR_Coverage, 230,
     /* 107952 */   GIR_EraseRootFromParent_Done,
     /* 107953 */ // Label 2049: @107953
     /* 107953 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(108009), // Rule ID 231 //
     /* 107958 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107961 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107972 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107976 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 107983 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 107983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 107986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107993 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107998 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108003 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108007 */   GIR_RootConstrainSelectedInstOperands,
     /* 108008 */   // GIR_Coverage, 231,
     /* 108008 */   GIR_EraseRootFromParent_Done,
     /* 108009 */ // Label 2050: @108009
     /* 108009 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(108065), // Rule ID 232 //
     /* 108014 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108017 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108028 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108032 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108039 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 108042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108063 */   GIR_RootConstrainSelectedInstOperands,
     /* 108064 */   // GIR_Coverage, 232,
     /* 108064 */   GIR_EraseRootFromParent_Done,
     /* 108065 */ // Label 2051: @108065
     /* 108065 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(108121), // Rule ID 4107 //
     /* 108070 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108088 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108095 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 108098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108110 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108115 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108119 */   GIR_RootConstrainSelectedInstOperands,
     /* 108120 */   // GIR_Coverage, 4107,
     /* 108120 */   GIR_EraseRootFromParent_Done,
     /* 108121 */ // Label 2052: @108121
     /* 108121 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(108177), // Rule ID 4108 //
     /* 108126 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108129 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108140 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108144 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108151 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 108154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108171 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108175 */   GIR_RootConstrainSelectedInstOperands,
     /* 108176 */   // GIR_Coverage, 4108,
     /* 108176 */   GIR_EraseRootFromParent_Done,
     /* 108177 */ // Label 2053: @108177
     /* 108177 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(108228), // Rule ID 266 //
     /* 108182 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108185 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108196 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108200 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108207 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 108210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108226 */   GIR_RootConstrainSelectedInstOperands,
     /* 108227 */   // GIR_Coverage, 266,
     /* 108227 */   GIR_EraseRootFromParent_Done,
     /* 108228 */ // Label 2054: @108228
     /* 108228 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(108279), // Rule ID 267 //
     /* 108233 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108236 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108247 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108251 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108258 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 108261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108273 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108277 */   GIR_RootConstrainSelectedInstOperands,
     /* 108278 */   // GIR_Coverage, 267,
     /* 108278 */   GIR_EraseRootFromParent_Done,
     /* 108279 */ // Label 2055: @108279
     /* 108279 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(108338), // Rule ID 6982 //
     /* 108284 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 108287 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108294 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 108297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108301 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108312 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15794>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 108312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 108315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 108332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108336 */   GIR_RootConstrainSelectedInstOperands,
     /* 108337 */   // GIR_Coverage, 6982,
     /* 108337 */   GIR_EraseRootFromParent_Done,
     /* 108338 */ // Label 2056: @108338
     /* 108338 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(108397), // Rule ID 6984 //
     /* 108343 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 108346 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108353 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 108356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108360 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108364 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108371 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15794>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 108371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 108374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 108391 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108395 */   GIR_RootConstrainSelectedInstOperands,
     /* 108396 */   // GIR_Coverage, 6984,
     /* 108396 */   GIR_EraseRootFromParent_Done,
     /* 108397 */ // Label 2057: @108397
     /* 108397 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(108456), // Rule ID 6994 //
     /* 108402 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 108405 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108412 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 108415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108419 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108423 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108430 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15803>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 108433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108454 */   GIR_RootConstrainSelectedInstOperands,
     /* 108455 */   // GIR_Coverage, 6994,
     /* 108455 */   GIR_EraseRootFromParent_Done,
     /* 108456 */ // Label 2058: @108456
     /* 108456 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(108515), // Rule ID 6996 //
     /* 108461 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 108464 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108471 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 108474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108478 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108482 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108489 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15803>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 108492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108494 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108499 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108509 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108513 */   GIR_RootConstrainSelectedInstOperands,
     /* 108514 */   // GIR_Coverage, 6996,
     /* 108514 */   GIR_EraseRootFromParent_Done,
     /* 108515 */ // Label 2059: @108515
     /* 108515 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(108566), // Rule ID 287 //
     /* 108520 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108523 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108538 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 108545 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 108548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108564 */   GIR_RootConstrainSelectedInstOperands,
     /* 108565 */   // GIR_Coverage, 287,
     /* 108565 */   GIR_EraseRootFromParent_Done,
     /* 108566 */ // Label 2060: @108566
     /* 108566 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(108617), // Rule ID 288 //
     /* 108571 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108574 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108585 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108589 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 108596 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 108599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108611 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108615 */   GIR_RootConstrainSelectedInstOperands,
     /* 108616 */   // GIR_Coverage, 288,
     /* 108616 */   GIR_EraseRootFromParent_Done,
     /* 108617 */ // Label 2061: @108617
     /* 108617 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(108668), // Rule ID 4126 //
     /* 108622 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108625 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108636 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108640 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108647 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 108650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108666 */   GIR_RootConstrainSelectedInstOperands,
     /* 108667 */   // GIR_Coverage, 4126,
     /* 108667 */   GIR_EraseRootFromParent_Done,
     /* 108668 */ // Label 2062: @108668
     /* 108668 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(108719), // Rule ID 4158 //
     /* 108673 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108676 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 108698 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 108698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 108701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108717 */   GIR_RootConstrainSelectedInstOperands,
     /* 108718 */   // GIR_Coverage, 4158,
     /* 108718 */   GIR_EraseRootFromParent_Done,
     /* 108719 */ // Label 2063: @108719
     /* 108719 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(108770), // Rule ID 4159 //
     /* 108724 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108727 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 108749 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 108749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 108752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108764 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108768 */   GIR_RootConstrainSelectedInstOperands,
     /* 108769 */   // GIR_Coverage, 4159,
     /* 108769 */   GIR_EraseRootFromParent_Done,
     /* 108770 */ // Label 2064: @108770
     /* 108770 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(108821), // Rule ID 4160 //
     /* 108775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108778 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108789 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108793 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 108800 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 108800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 108803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108815 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108819 */   GIR_RootConstrainSelectedInstOperands,
     /* 108820 */   // GIR_Coverage, 4160,
     /* 108820 */   GIR_EraseRootFromParent_Done,
     /* 108821 */ // Label 2065: @108821
     /* 108821 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(108875), // Rule ID 6986 //
     /* 108826 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 108829 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108836 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 108839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108843 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108847 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108854 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15794>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 108857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108869 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108873 */   GIR_RootConstrainSelectedInstOperands,
     /* 108874 */   // GIR_Coverage, 6986,
     /* 108874 */   GIR_EraseRootFromParent_Done,
     /* 108875 */ // Label 2066: @108875
     /* 108875 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(108929), // Rule ID 6988 //
     /* 108880 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 108883 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108890 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 108893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108897 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108901 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 108908 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15794>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 108908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 108911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108923 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108927 */   GIR_RootConstrainSelectedInstOperands,
     /* 108928 */   // GIR_Coverage, 6988,
     /* 108928 */   GIR_EraseRootFromParent_Done,
     /* 108929 */ // Label 2067: @108929
     /* 108929 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(108983), // Rule ID 6998 //
     /* 108934 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 108937 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108944 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 108947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108951 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108955 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108962 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15803>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 108965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108977 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108981 */   GIR_RootConstrainSelectedInstOperands,
     /* 108982 */   // GIR_Coverage, 6998,
     /* 108982 */   GIR_EraseRootFromParent_Done,
     /* 108983 */ // Label 2068: @108983
     /* 108983 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(109037), // Rule ID 7000 //
     /* 108988 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 108991 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108998 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109005 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109009 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109016 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15803>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 109019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109031 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109035 */   GIR_RootConstrainSelectedInstOperands,
     /* 109036 */   // GIR_Coverage, 7000,
     /* 109036 */   GIR_EraseRootFromParent_Done,
     /* 109037 */ // Label 2069: @109037
     /* 109037 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(109094), // Rule ID 7362 //
     /* 109042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 109045 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109048 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109055 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109062 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109066 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109073 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15792>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 109076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109078 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109083 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109088 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109092 */   GIR_RootConstrainSelectedInstOperands,
     /* 109093 */   // GIR_Coverage, 7362,
     /* 109093 */   GIR_EraseRootFromParent_Done,
     /* 109094 */ // Label 2070: @109094
     /* 109094 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(109151), // Rule ID 7364 //
     /* 109099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 109102 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109112 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109119 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109123 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109130 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15801>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 109133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109149 */   GIR_RootConstrainSelectedInstOperands,
     /* 109150 */   // GIR_Coverage, 7364,
     /* 109150 */   GIR_EraseRootFromParent_Done,
     /* 109151 */ // Label 2071: @109151
     /* 109151 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(109188), // Rule ID 6978 //
     /* 109156 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109159 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109166 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 109169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109173 */   // MIs[0] ptr
     /* 109173 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109181 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15790>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 109181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 109186 */   GIR_RootConstrainSelectedInstOperands,
     /* 109187 */   // GIR_Coverage, 6978,
     /* 109187 */   GIR_Done,
     /* 109188 */ // Label 2072: @109188
     /* 109188 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(109225), // Rule ID 6980 //
     /* 109193 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109196 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109203 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109210 */   // MIs[0] ptr
     /* 109210 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109218 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15792>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 109218 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 109223 */   GIR_RootConstrainSelectedInstOperands,
     /* 109224 */   // GIR_Coverage, 6980,
     /* 109224 */   GIR_Done,
     /* 109225 */ // Label 2073: @109225
     /* 109225 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(109262), // Rule ID 6990 //
     /* 109230 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109233 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109240 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 109243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109247 */   // MIs[0] ptr
     /* 109247 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109255 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15799>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 109255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 109260 */   GIR_RootConstrainSelectedInstOperands,
     /* 109261 */   // GIR_Coverage, 6990,
     /* 109261 */   GIR_Done,
     /* 109262 */ // Label 2074: @109262
     /* 109262 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(109299), // Rule ID 6992 //
     /* 109267 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109270 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109277 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109284 */   // MIs[0] ptr
     /* 109284 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109292 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15801>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 109292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 109297 */   GIR_RootConstrainSelectedInstOperands,
     /* 109298 */   // GIR_Coverage, 6992,
     /* 109298 */   GIR_Done,
     /* 109299 */ // Label 2075: @109299
     /* 109299 */ GIM_Reject,
     /* 109300 */ // Label 2046: @109300
     /* 109300 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(110789),
     /* 109305 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109308 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(109393), // Rule ID 4085 //
     /* 109313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109335 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 109335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109362 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 109382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109392 */     // GIR_Coverage, 4085,
     /* 109392 */     GIR_EraseRootFromParent_Done,
     /* 109393 */   // Label 2077: @109393
     /* 109393 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(109478), // Rule ID 4086 //
     /* 109398 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109420 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 109420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109447 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 109467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109477 */     // GIR_Coverage, 4086,
     /* 109477 */     GIR_EraseRootFromParent_Done,
     /* 109478 */   // Label 2078: @109478
     /* 109478 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(109563), // Rule ID 4087 //
     /* 109483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109505 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 109505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 109512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109532 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 109552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109562 */     // GIR_Coverage, 4087,
     /* 109562 */     GIR_EraseRootFromParent_Done,
     /* 109563 */   // Label 2079: @109563
     /* 109563 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(109648), // Rule ID 4088 //
     /* 109568 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109590 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 109590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 109597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109617 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 109637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109647 */     // GIR_Coverage, 4088,
     /* 109647 */     GIR_EraseRootFromParent_Done,
     /* 109648 */   // Label 2080: @109648
     /* 109648 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(109733), // Rule ID 4089 //
     /* 109653 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 109660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 109675 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 109675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 109682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109702 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 109722 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109732 */     // GIR_Coverage, 4089,
     /* 109732 */     GIR_EraseRootFromParent_Done,
     /* 109733 */   // Label 2081: @109733
     /* 109733 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(109818), // Rule ID 4090 //
     /* 109738 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 109745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 109760 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 109760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 109767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109787 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 109807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109817 */     // GIR_Coverage, 4090,
     /* 109817 */     GIR_EraseRootFromParent_Done,
     /* 109818 */   // Label 2082: @109818
     /* 109818 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(109903), // Rule ID 4091 //
     /* 109823 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109845 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 109845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109872 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 109892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109902 */     // GIR_Coverage, 4091,
     /* 109902 */     GIR_EraseRootFromParent_Done,
     /* 109903 */   // Label 2083: @109903
     /* 109903 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(109988), // Rule ID 4092 //
     /* 109908 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109930 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 109930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109957 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 109977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 109982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109987 */     // GIR_Coverage, 4092,
     /* 109987 */     GIR_EraseRootFromParent_Done,
     /* 109988 */   // Label 2084: @109988
     /* 109988 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110068), // Rule ID 4124 //
     /* 109993 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110015 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 110015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110037 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110067 */     // GIR_Coverage, 4124,
     /* 110067 */     GIR_EraseRootFromParent_Done,
     /* 110068 */   // Label 2085: @110068
     /* 110068 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110148), // Rule ID 4125 //
     /* 110073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 110095 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 110095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 110102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110117 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110147 */     // GIR_Coverage, 4125,
     /* 110147 */     GIR_EraseRootFromParent_Done,
     /* 110148 */   // Label 2086: @110148
     /* 110148 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110228), // Rule ID 4127 //
     /* 110153 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110175 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 110175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110197 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110227 */     // GIR_Coverage, 4127,
     /* 110227 */     GIR_EraseRootFromParent_Done,
     /* 110228 */   // Label 2087: @110228
     /* 110228 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(110308), // Rule ID 4135 //
     /* 110233 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 110240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 110255 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 110255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 110262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110277 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110307 */     // GIR_Coverage, 4135,
     /* 110307 */     GIR_EraseRootFromParent_Done,
     /* 110308 */   // Label 2088: @110308
     /* 110308 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(110388), // Rule ID 4161 //
     /* 110313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 110320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 110335 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 110335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 110342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110357 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110387 */     // GIR_Coverage, 4161,
     /* 110387 */     GIR_EraseRootFromParent_Done,
     /* 110388 */   // Label 2089: @110388
     /* 110388 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(110468), // Rule ID 4162 //
     /* 110393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110415 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 110415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 110422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110437 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110457 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110467 */     // GIR_Coverage, 4162,
     /* 110467 */     GIR_EraseRootFromParent_Done,
     /* 110468 */   // Label 2090: @110468
     /* 110468 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(110548), // Rule ID 4163 //
     /* 110473 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110495 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 110495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110517 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110547 */     // GIR_Coverage, 4163,
     /* 110547 */     GIR_EraseRootFromParent_Done,
     /* 110548 */   // Label 2091: @110548
     /* 110548 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(110628), // Rule ID 4164 //
     /* 110553 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110575 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 110575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110597 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110627 */     // GIR_Coverage, 4164,
     /* 110627 */     GIR_EraseRootFromParent_Done,
     /* 110628 */   // Label 2092: @110628
     /* 110628 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(110708), // Rule ID 4165 //
     /* 110633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110655 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 110655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110677 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110707 */     // GIR_Coverage, 4165,
     /* 110707 */     GIR_EraseRootFromParent_Done,
     /* 110708 */   // Label 2093: @110708
     /* 110708 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(110788), // Rule ID 4166 //
     /* 110713 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110735 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 110735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 110742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110757 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110787 */     // GIR_Coverage, 4166,
     /* 110787 */     GIR_EraseRootFromParent_Done,
     /* 110788 */   // Label 2094: @110788
     /* 110788 */   GIM_Reject,
     /* 110789 */ // Label 2076: @110789
     /* 110789 */ GIM_Reject,
     /* 110790 */ // Label 2047: @110790
     /* 110790 */ GIM_Reject,
     /* 110791 */ // Label 19: @110791
     /* 110791 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2115*/ GIMT_Encode4(124316),
     /* 110802 */ /*GILLT_s8*//*Label 2095*/ GIMT_Encode4(110898),
     /* 110806 */ /*GILLT_s16*//*Label 2096*/ GIMT_Encode4(111265),
     /* 110810 */ /*GILLT_s32*//*Label 2097*/ GIMT_Encode4(112404),
     /* 110814 */ /*GILLT_s64*//*Label 2098*/ GIMT_Encode4(116999),
     /* 110818 */ /*GILLT_s128*//*Label 2099*/ GIMT_Encode4(120768),
     /* 110822 */ /*GILLT_v2s32*//*Label 2100*/ GIMT_Encode4(120974),
     /* 110826 */ /*GILLT_v2s64*//*Label 2101*/ GIMT_Encode4(121380),
     /* 110830 */ /*GILLT_v4s16*//*Label 2102*/ GIMT_Encode4(121830),
     /* 110834 */ /*GILLT_v4s32*//*Label 2103*/ GIMT_Encode4(122236),
     /* 110838 */ /*GILLT_v8s8*//*Label 2104*/ GIMT_Encode4(122642),
     /* 110842 */ /*GILLT_v8s16*//*Label 2105*/ GIMT_Encode4(122862),
     /* 110846 */ /*GILLT_v16s8*//*Label 2106*/ GIMT_Encode4(123268), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110858 */ /*GILLT_nxv2s16*//*Label 2107*/ GIMT_Encode4(123488),
     /* 110862 */ /*GILLT_nxv2s32*//*Label 2108*/ GIMT_Encode4(123548),
     /* 110866 */ /*GILLT_nxv2s64*//*Label 2109*/ GIMT_Encode4(123608), GIMT_Encode4(0),
     /* 110874 */ /*GILLT_nxv4s16*//*Label 2110*/ GIMT_Encode4(123778),
     /* 110878 */ /*GILLT_nxv4s32*//*Label 2111*/ GIMT_Encode4(123838), GIMT_Encode4(0),
     /* 110886 */ /*GILLT_nxv8s16*//*Label 2112*/ GIMT_Encode4(124008),
     /* 110890 */ /*GILLT_nxv16s1*//*Label 2113*/ GIMT_Encode4(124178),
     /* 110894 */ /*GILLT_nxv16s8*//*Label 2114*/ GIMT_Encode4(124222),
     /* 110898 */ // Label 2095: @110898
     /* 110898 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(111264),
     /* 110903 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110906 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 110910 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(110978), // Rule ID 13102 //
     /* 110915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 110940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 110944 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 110948 */     // MIs[2] Operand 1
     /* 110948 */     // No operand predicates
     /* 110948 */     // MIs[0] Rn
     /* 110948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 110958 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 110958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 110961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 110965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 110968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 110970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 110976 */     GIR_RootConstrainSelectedInstOperands,
     /* 110977 */     // GIR_Coverage, 13102,
     /* 110977 */     GIR_EraseRootFromParent_Done,
     /* 110978 */   // Label 2117: @110978
     /* 110978 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(111077), // Rule ID 13103 //
     /* 110983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 110987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 110991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111012 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111016 */     // MIs[2] Operand 1
     /* 111016 */     // No operand predicates
     /* 111016 */     // MIs[0] Rn
     /* 111016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111026 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111038 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111045 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111075 */     GIR_RootConstrainSelectedInstOperands,
     /* 111076 */     // GIR_Coverage, 13103,
     /* 111076 */     GIR_EraseRootFromParent_Done,
     /* 111077 */   // Label 2118: @111077
     /* 111077 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(111126), // Rule ID 303 //
     /* 111082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 111100 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 111100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 111103 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111124 */     GIR_RootConstrainSelectedInstOperands,
     /* 111125 */     // GIR_Coverage, 303,
     /* 111125 */     GIR_EraseRootFromParent_Done,
     /* 111126 */   // Label 2119: @111126
     /* 111126 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(111175), // Rule ID 304 //
     /* 111131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 111149 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 111149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 111152 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111173 */     GIR_RootConstrainSelectedInstOperands,
     /* 111174 */     // GIR_Coverage, 304,
     /* 111174 */     GIR_EraseRootFromParent_Done,
     /* 111175 */   // Label 2120: @111175
     /* 111175 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(111219), // Rule ID 313 //
     /* 111180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 111198 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 111198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 111201 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111217 */     GIR_RootConstrainSelectedInstOperands,
     /* 111218 */     // GIR_Coverage, 313,
     /* 111218 */     GIR_EraseRootFromParent_Done,
     /* 111219 */   // Label 2121: @111219
     /* 111219 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(111263), // Rule ID 321 //
     /* 111224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111242 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 111242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 111245 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111261 */     GIR_RootConstrainSelectedInstOperands,
     /* 111262 */     // GIR_Coverage, 321,
     /* 111262 */     GIR_EraseRootFromParent_Done,
     /* 111263 */   // Label 2122: @111263
     /* 111263 */   GIM_Reject,
     /* 111264 */ // Label 2116: @111264
     /* 111264 */ GIM_Reject,
     /* 111265 */ // Label 2096: @111265
     /* 111265 */ GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(112403),
     /* 111270 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111273 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111277 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(111376), // Rule ID 4463 //
     /* 111282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111294 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111303 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 111307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 111320 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 111320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 111323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111332 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 111338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 111343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 111351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111374 */     GIR_RootConstrainSelectedInstOperands,
     /* 111375 */     // GIR_Coverage, 4463,
     /* 111375 */     GIR_EraseRootFromParent_Done,
     /* 111376 */   // Label 2124: @111376
     /* 111376 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(111475), // Rule ID 4464 //
     /* 111381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111402 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 111406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 111419 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 111419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 111422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111431 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 111437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 111442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 111450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111473 */     GIR_RootConstrainSelectedInstOperands,
     /* 111474 */     // GIR_Coverage, 4464,
     /* 111474 */     GIR_EraseRootFromParent_Done,
     /* 111475 */   // Label 2125: @111475
     /* 111475 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(111574), // Rule ID 13100 //
     /* 111480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111501 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 111505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 111518 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 111518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 111521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111530 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 111536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 111541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 111549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111572 */     GIR_RootConstrainSelectedInstOperands,
     /* 111573 */     // GIR_Coverage, 13100,
     /* 111573 */     GIR_EraseRootFromParent_Done,
     /* 111574 */   // Label 2126: @111574
     /* 111574 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(111673), // Rule ID 13101 //
     /* 111579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111600 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 111604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 111617 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 111617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 111620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111629 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 111635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 111640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 111648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111671 */     GIR_RootConstrainSelectedInstOperands,
     /* 111672 */     // GIR_Coverage, 13101,
     /* 111672 */     GIR_EraseRootFromParent_Done,
     /* 111673 */   // Label 2127: @111673
     /* 111673 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(111767), // Rule ID 4492 //
     /* 111678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111699 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 111703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 111716 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 111716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 111719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111728 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 111734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 111739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 111747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111765 */     GIR_RootConstrainSelectedInstOperands,
     /* 111766 */     // GIR_Coverage, 4492,
     /* 111766 */     GIR_EraseRootFromParent_Done,
     /* 111767 */   // Label 2128: @111767
     /* 111767 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(111861), // Rule ID 4517 //
     /* 111772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111793 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 111797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 111810 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 111810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 111813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111822 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 111828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 111833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 111841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111859 */     GIR_RootConstrainSelectedInstOperands,
     /* 111860 */     // GIR_Coverage, 4517,
     /* 111860 */     GIR_EraseRootFromParent_Done,
     /* 111861 */   // Label 2129: @111861
     /* 111861 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(111955), // Rule ID 13099 //
     /* 111866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111887 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 111891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 111904 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 111904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 111907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111916 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 111922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 111927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 111935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 111953 */     GIR_RootConstrainSelectedInstOperands,
     /* 111954 */     // GIR_Coverage, 13099,
     /* 111954 */     GIR_EraseRootFromParent_Done,
     /* 111955 */   // Label 2130: @111955
     /* 111955 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112049), // Rule ID 13105 //
     /* 111960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111981 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 111985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 111998 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 111998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112010 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 112029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112047 */     GIR_RootConstrainSelectedInstOperands,
     /* 112048 */     // GIR_Coverage, 13105,
     /* 112048 */     GIR_EraseRootFromParent_Done,
     /* 112049 */   // Label 2131: @112049
     /* 112049 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112117), // Rule ID 6416 //
     /* 112054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112083 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 112087 */     // MIs[2] Operand 1
     /* 112087 */     // No operand predicates
     /* 112087 */     // MIs[0] Rn
     /* 112087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112097 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 112100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112115 */     GIR_RootConstrainSelectedInstOperands,
     /* 112116 */     // GIR_Coverage, 6416,
     /* 112116 */     GIR_EraseRootFromParent_Done,
     /* 112117 */   // Label 2132: @112117
     /* 112117 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112216), // Rule ID 6421 //
     /* 112122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112151 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 112155 */     // MIs[2] Operand 1
     /* 112155 */     // No operand predicates
     /* 112155 */     // MIs[0] Rn
     /* 112155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112165 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112177 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 112180 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112184 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 112187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 112200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112214 */     GIR_RootConstrainSelectedInstOperands,
     /* 112215 */     // GIR_Coverage, 6421,
     /* 112215 */     GIR_EraseRootFromParent_Done,
     /* 112216 */   // Label 2133: @112216
     /* 112216 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112265), // Rule ID 305 //
     /* 112221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112239 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 112242 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112263 */     GIR_RootConstrainSelectedInstOperands,
     /* 112264 */     // GIR_Coverage, 305,
     /* 112264 */     GIR_EraseRootFromParent_Done,
     /* 112265 */   // Label 2134: @112265
     /* 112265 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(112314), // Rule ID 306 //
     /* 112270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112288 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 112291 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112312 */     GIR_RootConstrainSelectedInstOperands,
     /* 112313 */     // GIR_Coverage, 306,
     /* 112313 */     GIR_EraseRootFromParent_Done,
     /* 112314 */   // Label 2135: @112314
     /* 112314 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(112358), // Rule ID 314 //
     /* 112319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 112337 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 112337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 112340 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112356 */     GIR_RootConstrainSelectedInstOperands,
     /* 112357 */     // GIR_Coverage, 314,
     /* 112357 */     GIR_EraseRootFromParent_Done,
     /* 112358 */   // Label 2136: @112358
     /* 112358 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(112402), // Rule ID 322 //
     /* 112363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 112381 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 112381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 112384 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112400 */     GIR_RootConstrainSelectedInstOperands,
     /* 112401 */     // GIR_Coverage, 322,
     /* 112401 */     GIR_EraseRootFromParent_Done,
     /* 112402 */   // Label 2137: @112402
     /* 112402 */   GIM_Reject,
     /* 112403 */ // Label 2123: @112403
     /* 112403 */ GIM_Reject,
     /* 112404 */ // Label 2097: @112404
     /* 112404 */ GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(112517), // Rule ID 4461 //
     /* 112409 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112412 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112416 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112423 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112427 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112431 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112435 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112439 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112444 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112448 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112452 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112454 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112461 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112461 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112464 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112468 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112473 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112479 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112484 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 112492 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112495 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112505 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112510 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112515 */   GIR_RootConstrainSelectedInstOperands,
     /* 112516 */   // GIR_Coverage, 4461,
     /* 112516 */   GIR_EraseRootFromParent_Done,
     /* 112517 */ // Label 2138: @112517
     /* 112517 */ GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(112630), // Rule ID 4462 //
     /* 112522 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112525 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112529 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 112536 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112540 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112544 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112548 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112552 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112557 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112561 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112565 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112567 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112574 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112586 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112592 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112597 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 112605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112623 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112628 */   GIR_RootConstrainSelectedInstOperands,
     /* 112629 */   // GIR_Coverage, 4462,
     /* 112629 */   GIR_EraseRootFromParent_Done,
     /* 112630 */ // Label 2139: @112630
     /* 112630 */ GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(112736), // Rule ID 4465 //
     /* 112635 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112638 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112642 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112646 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112650 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112654 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112658 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112663 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112667 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112671 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112673 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112680 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112680 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112683 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112687 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112692 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 112698 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112703 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 112711 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112734 */   GIR_RootConstrainSelectedInstOperands,
     /* 112735 */   // GIR_Coverage, 4465,
     /* 112735 */   GIR_EraseRootFromParent_Done,
     /* 112736 */ // Label 2140: @112736
     /* 112736 */ GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(112842), // Rule ID 4466 //
     /* 112741 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112744 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112748 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112752 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112756 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112760 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112764 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112769 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112773 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112779 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112786 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112786 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112789 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112793 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112798 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 112804 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112809 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 112817 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112835 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112840 */   GIR_RootConstrainSelectedInstOperands,
     /* 112841 */   // GIR_Coverage, 4466,
     /* 112841 */   GIR_EraseRootFromParent_Done,
     /* 112842 */ // Label 2141: @112842
     /* 112842 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(112948), // Rule ID 4467 //
     /* 112847 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112850 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112854 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112858 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112862 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112866 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112870 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112875 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112879 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112883 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112885 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 112892 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 112892 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112895 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112899 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112904 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 112910 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112915 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 112923 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112936 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112941 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112946 */   GIR_RootConstrainSelectedInstOperands,
     /* 112947 */   // GIR_Coverage, 4467,
     /* 112947 */   GIR_EraseRootFromParent_Done,
     /* 112948 */ // Label 2142: @112948
     /* 112948 */ GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(113054), // Rule ID 4468 //
     /* 112953 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112956 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112960 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112964 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112968 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112972 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112976 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112981 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112985 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112989 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112991 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 112998 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 112998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113010 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113016 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113021 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 113029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113037 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113047 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113052 */   GIR_RootConstrainSelectedInstOperands,
     /* 113053 */   // GIR_Coverage, 4468,
     /* 113053 */   GIR_EraseRootFromParent_Done,
     /* 113054 */ // Label 2143: @113054
     /* 113054 */ GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(113160), // Rule ID 13107 //
     /* 113059 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113062 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113066 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113070 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113074 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113078 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113082 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113087 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113097 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 113104 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 113104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113116 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113122 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 113135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113153 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113158 */   GIR_RootConstrainSelectedInstOperands,
     /* 113159 */   // GIR_Coverage, 13107,
     /* 113159 */   GIR_EraseRootFromParent_Done,
     /* 113160 */ // Label 2144: @113160
     /* 113160 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(113266), // Rule ID 13108 //
     /* 113165 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113168 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113172 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113176 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113180 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113184 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113188 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113193 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113197 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113201 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113203 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 113210 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 113210 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113213 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113217 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113222 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113228 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113233 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 113241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113249 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113254 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113259 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113264 */   GIR_RootConstrainSelectedInstOperands,
     /* 113265 */   // GIR_Coverage, 13108,
     /* 113265 */   GIR_EraseRootFromParent_Done,
     /* 113266 */ // Label 2145: @113266
     /* 113266 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(113374), // Rule ID 4491 //
     /* 113271 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113274 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113278 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113293 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113297 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113301 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113306 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113310 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113316 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113323 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113323 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113326 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113330 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113335 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113341 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113346 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 113354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113362 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113367 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113372 */   GIR_RootConstrainSelectedInstOperands,
     /* 113373 */   // GIR_Coverage, 4491,
     /* 113373 */   GIR_EraseRootFromParent_Done,
     /* 113374 */ // Label 2146: @113374
     /* 113374 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(113475), // Rule ID 4493 //
     /* 113379 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113382 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113386 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113390 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113394 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113398 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113402 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113407 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113411 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113415 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113417 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 113424 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 113424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113436 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113442 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113447 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 113455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113473 */   GIR_RootConstrainSelectedInstOperands,
     /* 113474 */   // GIR_Coverage, 4493,
     /* 113474 */   GIR_EraseRootFromParent_Done,
     /* 113475 */ // Label 2147: @113475
     /* 113475 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(113576), // Rule ID 4494 //
     /* 113480 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113483 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113487 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113491 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113495 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113499 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113503 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113508 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113512 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113516 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113518 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 113525 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 113525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113537 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113543 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113548 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 113556 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113569 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113574 */   GIR_RootConstrainSelectedInstOperands,
     /* 113575 */   // GIR_Coverage, 4494,
     /* 113575 */   GIR_EraseRootFromParent_Done,
     /* 113576 */ // Label 2148: @113576
     /* 113576 */ GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(113684), // Rule ID 4516 //
     /* 113581 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113584 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113588 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113595 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113599 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113603 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113607 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113611 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113616 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113620 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113624 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113626 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 113633 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113645 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113651 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113656 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 113664 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113677 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113682 */   GIR_RootConstrainSelectedInstOperands,
     /* 113683 */   // GIR_Coverage, 4516,
     /* 113683 */   GIR_EraseRootFromParent_Done,
     /* 113684 */ // Label 2149: @113684
     /* 113684 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(113785), // Rule ID 4518 //
     /* 113689 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113692 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113696 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113704 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113708 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113712 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113717 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113721 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113725 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113727 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 113734 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113734 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113737 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113741 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113746 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113752 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113757 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 113765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113778 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113783 */   GIR_RootConstrainSelectedInstOperands,
     /* 113784 */   // GIR_Coverage, 4518,
     /* 113784 */   GIR_EraseRootFromParent_Done,
     /* 113785 */ // Label 2150: @113785
     /* 113785 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(113886), // Rule ID 4519 //
     /* 113790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113793 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113797 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113801 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113805 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113809 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113813 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113818 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113822 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113826 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113828 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 113835 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113847 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113853 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113858 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 113866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113884 */   GIR_RootConstrainSelectedInstOperands,
     /* 113885 */   // GIR_Coverage, 4519,
     /* 113885 */   GIR_EraseRootFromParent_Done,
     /* 113886 */ // Label 2151: @113886
     /* 113886 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(113987), // Rule ID 13104 //
     /* 113891 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113894 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113898 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113906 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113910 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113914 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113919 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113923 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113927 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113929 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 113936 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 113936 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113939 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113943 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113948 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113954 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113959 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 113967 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113980 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113985 */   GIR_RootConstrainSelectedInstOperands,
     /* 113986 */   // GIR_Coverage, 13104,
     /* 113986 */   GIR_EraseRootFromParent_Done,
     /* 113987 */ // Label 2152: @113987
     /* 113987 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(114088), // Rule ID 13106 //
     /* 113992 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113995 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113999 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114003 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114007 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114011 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114015 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114020 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114024 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114028 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114030 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 114037 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114037 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114040 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114044 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114049 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114055 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114060 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 114068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114076 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114081 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114086 */   GIR_RootConstrainSelectedInstOperands,
     /* 114087 */   // GIR_Coverage, 13106,
     /* 114087 */   GIR_EraseRootFromParent_Done,
     /* 114088 */ // Label 2153: @114088
     /* 114088 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(114170), // Rule ID 6410 //
     /* 114093 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114096 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114100 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 114107 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114111 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114115 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 114119 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114123 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114128 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114132 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114136 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 114140 */   // MIs[2] Operand 1
     /* 114140 */   // No operand predicates
     /* 114140 */   // MIs[0] Rn
     /* 114140 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114148 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114150 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 114153 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114157 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114160 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114162 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114168 */   GIR_RootConstrainSelectedInstOperands,
     /* 114169 */   // GIR_Coverage, 6410,
     /* 114169 */   GIR_EraseRootFromParent_Done,
     /* 114170 */ // Label 2154: @114170
     /* 114170 */ GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(114252), // Rule ID 6411 //
     /* 114175 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114178 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114182 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114189 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114193 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114197 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114201 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114205 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114210 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114214 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114218 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 114222 */   // MIs[2] Operand 1
     /* 114222 */   // No operand predicates
     /* 114222 */   // MIs[0] Rn
     /* 114222 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114230 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114232 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 114235 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114239 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114242 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114244 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114250 */   GIR_RootConstrainSelectedInstOperands,
     /* 114251 */   // GIR_Coverage, 6411,
     /* 114251 */   GIR_EraseRootFromParent_Done,
     /* 114252 */ // Label 2155: @114252
     /* 114252 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(114327), // Rule ID 6412 //
     /* 114257 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114260 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114264 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114268 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114272 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114276 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114280 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114285 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114289 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114293 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 114297 */   // MIs[2] Operand 1
     /* 114297 */   // No operand predicates
     /* 114297 */   // MIs[0] Rn
     /* 114297 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114305 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114307 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 114310 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114314 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114317 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114319 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114325 */   GIR_RootConstrainSelectedInstOperands,
     /* 114326 */   // GIR_Coverage, 6412,
     /* 114326 */   GIR_EraseRootFromParent_Done,
     /* 114327 */ // Label 2156: @114327
     /* 114327 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(114402), // Rule ID 6413 //
     /* 114332 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114335 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114339 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114347 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114351 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114355 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114360 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114364 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114368 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 114372 */   // MIs[2] Operand 1
     /* 114372 */   // No operand predicates
     /* 114372 */   // MIs[0] Rn
     /* 114372 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114380 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114382 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 114385 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114389 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114392 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114400 */   GIR_RootConstrainSelectedInstOperands,
     /* 114401 */   // GIR_Coverage, 6413,
     /* 114401 */   GIR_EraseRootFromParent_Done,
     /* 114402 */ // Label 2157: @114402
     /* 114402 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(114515), // Rule ID 6417 //
     /* 114407 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114410 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114414 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 114421 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114425 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114429 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 114433 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114437 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114442 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114446 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114450 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 114454 */   // MIs[2] Operand 1
     /* 114454 */   // No operand predicates
     /* 114454 */   // MIs[0] Rn
     /* 114454 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114462 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114464 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114464 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 114467 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114471 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114476 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 114479 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114483 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 114486 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114491 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 114499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114502 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114505 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114507 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114513 */   GIR_RootConstrainSelectedInstOperands,
     /* 114514 */   // GIR_Coverage, 6417,
     /* 114514 */   GIR_EraseRootFromParent_Done,
     /* 114515 */ // Label 2158: @114515
     /* 114515 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(114628), // Rule ID 6418 //
     /* 114520 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114523 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114527 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114534 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114542 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114546 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114550 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114555 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114559 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114563 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 114567 */   // MIs[2] Operand 1
     /* 114567 */   // No operand predicates
     /* 114567 */   // MIs[0] Rn
     /* 114567 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114575 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114577 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114577 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 114580 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114584 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114589 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 114592 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114596 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 114599 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114604 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 114612 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114615 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114618 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114626 */   GIR_RootConstrainSelectedInstOperands,
     /* 114627 */   // GIR_Coverage, 6418,
     /* 114627 */   GIR_EraseRootFromParent_Done,
     /* 114628 */ // Label 2159: @114628
     /* 114628 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(114734), // Rule ID 6419 //
     /* 114633 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114636 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114640 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114644 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114648 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114652 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114656 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114661 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114665 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114669 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 114673 */   // MIs[2] Operand 1
     /* 114673 */   // No operand predicates
     /* 114673 */   // MIs[0] Rn
     /* 114673 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114681 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114683 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114683 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 114686 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114690 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114695 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 114698 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114702 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 114705 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114710 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 114718 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114721 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114724 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114726 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114732 */   GIR_RootConstrainSelectedInstOperands,
     /* 114733 */   // GIR_Coverage, 6419,
     /* 114733 */   GIR_EraseRootFromParent_Done,
     /* 114734 */ // Label 2160: @114734
     /* 114734 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(114840), // Rule ID 6420 //
     /* 114739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114742 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114746 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114750 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114754 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114758 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114762 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114767 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114771 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114775 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 114779 */   // MIs[2] Operand 1
     /* 114779 */   // No operand predicates
     /* 114779 */   // MIs[0] Rn
     /* 114779 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114787 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114789 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114789 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 114792 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114796 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114801 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 114804 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114808 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 114811 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114816 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 114824 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114827 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114830 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114832 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114838 */   GIR_RootConstrainSelectedInstOperands,
     /* 114839 */   // GIR_Coverage, 6420,
     /* 114839 */   GIR_EraseRootFromParent_Done,
     /* 114840 */ // Label 2161: @114840
     /* 114840 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(114900), // Rule ID 295 //
     /* 114845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114848 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114852 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 114859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 114863 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114867 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 114874 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 114874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 114877 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 114879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114894 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114898 */   GIR_RootConstrainSelectedInstOperands,
     /* 114899 */   // GIR_Coverage, 295,
     /* 114899 */   GIR_EraseRootFromParent_Done,
     /* 114900 */ // Label 2162: @114900
     /* 114900 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(114960), // Rule ID 296 //
     /* 114905 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114908 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114912 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 114919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 114923 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114927 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 114934 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 114934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 114937 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 114939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114944 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114954 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 114958 */   GIR_RootConstrainSelectedInstOperands,
     /* 114959 */   // GIR_Coverage, 296,
     /* 114959 */   GIR_EraseRootFromParent_Done,
     /* 114960 */ // Label 2163: @114960
     /* 114960 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(115020), // Rule ID 297 //
     /* 114965 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114968 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114972 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 114983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114987 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 114994 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 114994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 114997 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 114999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115018 */   GIR_RootConstrainSelectedInstOperands,
     /* 115019 */   // GIR_Coverage, 297,
     /* 115019 */   GIR_EraseRootFromParent_Done,
     /* 115020 */ // Label 2164: @115020
     /* 115020 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(115080), // Rule ID 298 //
     /* 115025 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115028 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115032 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115043 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115047 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 115054 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 115054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 115057 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115069 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115074 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115078 */   GIR_RootConstrainSelectedInstOperands,
     /* 115079 */   // GIR_Coverage, 298,
     /* 115079 */   GIR_EraseRootFromParent_Done,
     /* 115080 */ // Label 2165: @115080
     /* 115080 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(115133), // Rule ID 299 //
     /* 115085 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115088 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115096 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115100 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 115107 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 115107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 115110 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115131 */   GIR_RootConstrainSelectedInstOperands,
     /* 115132 */   // GIR_Coverage, 299,
     /* 115132 */   GIR_EraseRootFromParent_Done,
     /* 115133 */ // Label 2166: @115133
     /* 115133 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(115186), // Rule ID 300 //
     /* 115138 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115141 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115149 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115153 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 115160 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 115160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 115163 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115180 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115184 */   GIR_RootConstrainSelectedInstOperands,
     /* 115185 */   // GIR_Coverage, 300,
     /* 115185 */   GIR_EraseRootFromParent_Done,
     /* 115186 */ // Label 2167: @115186
     /* 115186 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(115242), // Rule ID 307 //
     /* 115191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115194 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115197 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115205 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115209 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 115216 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 115216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 115219 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115240 */   GIR_RootConstrainSelectedInstOperands,
     /* 115241 */   // GIR_Coverage, 307,
     /* 115241 */   GIR_EraseRootFromParent_Done,
     /* 115242 */ // Label 2168: @115242
     /* 115242 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(115298), // Rule ID 308 //
     /* 115247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115250 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115253 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 115272 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 115272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 115275 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115292 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115296 */   GIR_RootConstrainSelectedInstOperands,
     /* 115297 */   // GIR_Coverage, 308,
     /* 115297 */   GIR_EraseRootFromParent_Done,
     /* 115298 */ // Label 2169: @115298
     /* 115298 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(115350), // Rule ID 312 //
     /* 115303 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115306 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115314 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115318 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 115325 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 115325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 115328 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 115334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115348 */   GIR_RootConstrainSelectedInstOperands,
     /* 115349 */   // GIR_Coverage, 312,
     /* 115349 */   GIR_EraseRootFromParent_Done,
     /* 115350 */ // Label 2170: @115350
     /* 115350 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(115401), // Rule ID 315 //
     /* 115355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115358 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115361 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115369 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115373 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 115380 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 115380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 115383 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115395 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115399 */   GIR_RootConstrainSelectedInstOperands,
     /* 115400 */   // GIR_Coverage, 315,
     /* 115400 */   GIR_EraseRootFromParent_Done,
     /* 115401 */ // Label 2171: @115401
     /* 115401 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(115460), // Rule ID 317 //
     /* 115406 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115409 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115413 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115424 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115428 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 115435 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 115435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 115438 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 115444 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115454 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115458 */   GIR_RootConstrainSelectedInstOperands,
     /* 115459 */   // GIR_Coverage, 317,
     /* 115459 */   GIR_EraseRootFromParent_Done,
     /* 115460 */ // Label 2172: @115460
     /* 115460 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(115519), // Rule ID 318 //
     /* 115465 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115468 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115472 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115483 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115487 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 115494 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 115494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 115497 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 115503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115513 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115517 */   GIR_RootConstrainSelectedInstOperands,
     /* 115518 */   // GIR_Coverage, 318,
     /* 115518 */   GIR_EraseRootFromParent_Done,
     /* 115519 */ // Label 2173: @115519
     /* 115519 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(115596), // Rule ID 7041 //
     /* 115524 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 115527 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 115534 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 115537 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115541 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 115545 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115549 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115554 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115558 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115560 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 115567 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15848>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 115567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 115570 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 115574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115594 */   GIR_RootConstrainSelectedInstOperands,
     /* 115595 */   // GIR_Coverage, 7041,
     /* 115595 */   GIR_EraseRootFromParent_Done,
     /* 115596 */ // Label 2174: @115596
     /* 115596 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(115673), // Rule ID 7042 //
     /* 115601 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 115604 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 115611 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 115614 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115618 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 115622 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115626 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115631 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115635 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115637 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 115644 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15848>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 115644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 115647 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 115651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115666 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115671 */   GIR_RootConstrainSelectedInstOperands,
     /* 115672 */   // GIR_Coverage, 7042,
     /* 115672 */   GIR_EraseRootFromParent_Done,
     /* 115673 */ // Label 2175: @115673
     /* 115673 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(115732), // Rule ID 7022 //
     /* 115678 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 115681 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115688 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 115691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115695 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115699 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 115706 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15834>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 115706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 115709 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 115711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115726 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115730 */   GIR_RootConstrainSelectedInstOperands,
     /* 115731 */   // GIR_Coverage, 7022,
     /* 115731 */   GIR_EraseRootFromParent_Done,
     /* 115732 */ // Label 2176: @115732
     /* 115732 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(115791), // Rule ID 7023 //
     /* 115737 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 115740 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115747 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 115750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115754 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115758 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 115765 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15834>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 115765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 115768 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 115770 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115775 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115785 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115789 */   GIR_RootConstrainSelectedInstOperands,
     /* 115790 */   // GIR_Coverage, 7023,
     /* 115790 */   GIR_EraseRootFromParent_Done,
     /* 115791 */ // Label 2177: @115791
     /* 115791 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(115850), // Rule ID 7027 //
     /* 115796 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 115799 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115806 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 115809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115813 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115817 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 115824 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15841>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 115824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 115827 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 115829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115844 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115848 */   GIR_RootConstrainSelectedInstOperands,
     /* 115849 */   // GIR_Coverage, 7027,
     /* 115849 */   GIR_EraseRootFromParent_Done,
     /* 115850 */ // Label 2178: @115850
     /* 115850 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(115909), // Rule ID 7028 //
     /* 115855 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 115858 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115865 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 115868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115872 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115876 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 115883 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15841>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 115883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 115886 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 115888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115907 */   GIR_RootConstrainSelectedInstOperands,
     /* 115908 */   // GIR_Coverage, 7028,
     /* 115908 */   GIR_EraseRootFromParent_Done,
     /* 115909 */ // Label 2179: @115909
     /* 115909 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(115968), // Rule ID 7032 //
     /* 115914 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 115917 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 115924 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 115927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115931 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115935 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 115942 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15848>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 115942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 115945 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 115947 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115962 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115966 */   GIR_RootConstrainSelectedInstOperands,
     /* 115967 */   // GIR_Coverage, 7032,
     /* 115967 */   GIR_EraseRootFromParent_Done,
     /* 115968 */ // Label 2180: @115968
     /* 115968 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(116027), // Rule ID 7033 //
     /* 115973 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 115976 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 115983 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 115986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115990 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115994 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116001 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15848>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 116004 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116021 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116025 */   GIR_RootConstrainSelectedInstOperands,
     /* 116026 */   // GIR_Coverage, 7033,
     /* 116026 */   GIR_EraseRootFromParent_Done,
     /* 116027 */ // Label 2181: @116027
     /* 116027 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(116099), // Rule ID 7043 //
     /* 116032 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116035 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116042 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116045 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116049 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116053 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116057 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116062 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116066 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116068 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116075 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15848>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 116078 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116092 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116097 */   GIR_RootConstrainSelectedInstOperands,
     /* 116098 */   // GIR_Coverage, 7043,
     /* 116098 */   GIR_EraseRootFromParent_Done,
     /* 116099 */ // Label 2182: @116099
     /* 116099 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(116171), // Rule ID 7044 //
     /* 116104 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116107 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116114 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116117 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116121 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116125 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116129 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116134 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116138 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116140 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 116147 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15848>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 116147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 116150 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116159 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116164 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116169 */   GIR_RootConstrainSelectedInstOperands,
     /* 116170 */   // GIR_Coverage, 7044,
     /* 116170 */   GIR_EraseRootFromParent_Done,
     /* 116171 */ // Label 2183: @116171
     /* 116171 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(116223), // Rule ID 320 //
     /* 116176 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116179 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116187 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116191 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 116198 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 116201 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116217 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116221 */   GIR_RootConstrainSelectedInstOperands,
     /* 116222 */   // GIR_Coverage, 320,
     /* 116222 */   GIR_EraseRootFromParent_Done,
     /* 116223 */ // Label 2184: @116223
     /* 116223 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(116274), // Rule ID 323 //
     /* 116228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116231 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116234 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116242 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116246 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 116253 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 116256 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116268 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116272 */   GIR_RootConstrainSelectedInstOperands,
     /* 116273 */   // GIR_Coverage, 323,
     /* 116273 */   GIR_EraseRootFromParent_Done,
     /* 116274 */ // Label 2185: @116274
     /* 116274 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(116333), // Rule ID 326 //
     /* 116279 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116282 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116286 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116297 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116301 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 116308 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 116311 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116327 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116331 */   GIR_RootConstrainSelectedInstOperands,
     /* 116332 */   // GIR_Coverage, 326,
     /* 116332 */   GIR_EraseRootFromParent_Done,
     /* 116333 */ // Label 2186: @116333
     /* 116333 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(116392), // Rule ID 327 //
     /* 116338 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116341 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116345 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116356 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116360 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 116367 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 116370 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116390 */   GIR_RootConstrainSelectedInstOperands,
     /* 116391 */   // GIR_Coverage, 327,
     /* 116391 */   GIR_EraseRootFromParent_Done,
     /* 116392 */ // Label 2187: @116392
     /* 116392 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(116446), // Rule ID 7024 //
     /* 116397 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116400 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116407 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116414 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116418 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 116425 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15834>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 116425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 116428 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116444 */   GIR_RootConstrainSelectedInstOperands,
     /* 116445 */   // GIR_Coverage, 7024,
     /* 116445 */   GIR_EraseRootFromParent_Done,
     /* 116446 */ // Label 2188: @116446
     /* 116446 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(116500), // Rule ID 7025 //
     /* 116451 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116454 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116461 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 116479 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15834>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 116479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 116482 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116498 */   GIR_RootConstrainSelectedInstOperands,
     /* 116499 */   // GIR_Coverage, 7025,
     /* 116499 */   GIR_EraseRootFromParent_Done,
     /* 116500 */ // Label 2189: @116500
     /* 116500 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(116554), // Rule ID 7029 //
     /* 116505 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116508 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116515 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116522 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116526 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 116533 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15841>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 116533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 116536 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116548 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116552 */   GIR_RootConstrainSelectedInstOperands,
     /* 116553 */   // GIR_Coverage, 7029,
     /* 116553 */   GIR_EraseRootFromParent_Done,
     /* 116554 */ // Label 2190: @116554
     /* 116554 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(116608), // Rule ID 7030 //
     /* 116559 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116562 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116569 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116576 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116580 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 116587 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15841>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 116587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 116590 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116602 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116606 */   GIR_RootConstrainSelectedInstOperands,
     /* 116607 */   // GIR_Coverage, 7030,
     /* 116607 */   GIR_EraseRootFromParent_Done,
     /* 116608 */ // Label 2191: @116608
     /* 116608 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(116662), // Rule ID 7034 //
     /* 116613 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116616 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116623 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116630 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116634 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116641 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15848>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 116644 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116656 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116660 */   GIR_RootConstrainSelectedInstOperands,
     /* 116661 */   // GIR_Coverage, 7034,
     /* 116661 */   GIR_EraseRootFromParent_Done,
     /* 116662 */ // Label 2192: @116662
     /* 116662 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(116716), // Rule ID 7035 //
     /* 116667 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116670 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116677 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116684 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116688 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 116695 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15848>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 116695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 116698 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116710 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116714 */   GIR_RootConstrainSelectedInstOperands,
     /* 116715 */   // GIR_Coverage, 7035,
     /* 116715 */   GIR_EraseRootFromParent_Done,
     /* 116716 */ // Label 2193: @116716
     /* 116716 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(116773), // Rule ID 7367 //
     /* 116721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 116724 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116727 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116734 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116741 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116745 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 116752 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15832>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 116752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 116755 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116767 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116771 */   GIR_RootConstrainSelectedInstOperands,
     /* 116772 */   // GIR_Coverage, 7367,
     /* 116772 */   GIR_EraseRootFromParent_Done,
     /* 116773 */ // Label 2194: @116773
     /* 116773 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(116830), // Rule ID 7368 //
     /* 116778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 116781 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116784 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116791 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116798 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116802 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 116809 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15839>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 116809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 116812 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116824 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116828 */   GIR_RootConstrainSelectedInstOperands,
     /* 116829 */   // GIR_Coverage, 7368,
     /* 116829 */   GIR_EraseRootFromParent_Done,
     /* 116830 */ // Label 2195: @116830
     /* 116830 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(116887), // Rule ID 7369 //
     /* 116835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 116838 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116841 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116848 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116855 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116859 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 116866 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15846>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 116866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 116869 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116881 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116885 */   GIR_RootConstrainSelectedInstOperands,
     /* 116886 */   // GIR_Coverage, 7369,
     /* 116886 */   GIR_EraseRootFromParent_Done,
     /* 116887 */ // Label 2196: @116887
     /* 116887 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(116924), // Rule ID 7021 //
     /* 116892 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116895 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116902 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116909 */   // MIs[0] ptr
     /* 116909 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116917 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15832>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 116917 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 116922 */   GIR_RootConstrainSelectedInstOperands,
     /* 116923 */   // GIR_Coverage, 7021,
     /* 116923 */   GIR_Done,
     /* 116924 */ // Label 2197: @116924
     /* 116924 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(116961), // Rule ID 7026 //
     /* 116929 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116932 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116939 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116946 */   // MIs[0] ptr
     /* 116946 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116954 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15839>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 116954 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 116959 */   GIR_RootConstrainSelectedInstOperands,
     /* 116960 */   // GIR_Coverage, 7026,
     /* 116960 */   GIR_Done,
     /* 116961 */ // Label 2198: @116961
     /* 116961 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(116998), // Rule ID 7031 //
     /* 116966 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116969 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116976 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116983 */   // MIs[0] ptr
     /* 116983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116991 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15846>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 116991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 116996 */   GIR_RootConstrainSelectedInstOperands,
     /* 116997 */   // GIR_Coverage, 7031,
     /* 116997 */   GIR_Done,
     /* 116998 */ // Label 2199: @116998
     /* 116998 */ GIM_Reject,
     /* 116999 */ // Label 2098: @116999
     /* 116999 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(117105), // Rule ID 4469 //
     /* 117004 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117007 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117011 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117019 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117023 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117027 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117032 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117036 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117040 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117042 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 117049 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 117049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117061 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117067 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117072 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 117080 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117083 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117088 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117098 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117103 */   GIR_RootConstrainSelectedInstOperands,
     /* 117104 */   // GIR_Coverage, 4469,
     /* 117104 */   GIR_EraseRootFromParent_Done,
     /* 117105 */ // Label 2200: @117105
     /* 117105 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(117211), // Rule ID 4470 //
     /* 117110 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117113 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117117 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117121 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117125 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117129 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117133 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117138 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117142 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117146 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 117155 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 117155 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117158 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117162 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117167 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117173 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117178 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 117186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117204 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117209 */   GIR_RootConstrainSelectedInstOperands,
     /* 117210 */   // GIR_Coverage, 4470,
     /* 117210 */   GIR_EraseRootFromParent_Done,
     /* 117211 */ // Label 2201: @117211
     /* 117211 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(117317), // Rule ID 4471 //
     /* 117216 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117219 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117223 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117231 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117235 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117239 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117244 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117248 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117252 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117254 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 117261 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 117261 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117264 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117268 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117273 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117279 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117284 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 117292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117300 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117310 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117315 */   GIR_RootConstrainSelectedInstOperands,
     /* 117316 */   // GIR_Coverage, 4471,
     /* 117316 */   GIR_EraseRootFromParent_Done,
     /* 117317 */ // Label 2202: @117317
     /* 117317 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(117423), // Rule ID 4472 //
     /* 117322 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117325 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117329 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117333 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117337 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117341 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117345 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117350 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117354 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117358 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117360 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 117367 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 117367 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117370 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117374 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117379 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117385 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117390 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 117398 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117416 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117421 */   GIR_RootConstrainSelectedInstOperands,
     /* 117422 */   // GIR_Coverage, 4472,
     /* 117422 */   GIR_EraseRootFromParent_Done,
     /* 117423 */ // Label 2203: @117423
     /* 117423 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(117524), // Rule ID 4495 //
     /* 117428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117431 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117435 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117439 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117443 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117447 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117451 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117456 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117460 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117464 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117466 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 117473 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 117473 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117476 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117480 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117485 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117491 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117496 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 117504 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117517 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117522 */   GIR_RootConstrainSelectedInstOperands,
     /* 117523 */   // GIR_Coverage, 4495,
     /* 117523 */   GIR_EraseRootFromParent_Done,
     /* 117524 */ // Label 2204: @117524
     /* 117524 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(117625), // Rule ID 4496 //
     /* 117529 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117532 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117536 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117540 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117544 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117548 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117552 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117557 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117561 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117565 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117567 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 117574 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 117574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117586 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117592 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117597 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 117605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117623 */   GIR_RootConstrainSelectedInstOperands,
     /* 117624 */   // GIR_Coverage, 4496,
     /* 117624 */   GIR_EraseRootFromParent_Done,
     /* 117625 */ // Label 2205: @117625
     /* 117625 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(117726), // Rule ID 4520 //
     /* 117630 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117633 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117637 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117641 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117645 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117649 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117653 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117658 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117662 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117666 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117668 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 117675 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117687 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117693 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117698 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 117706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117719 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117724 */   GIR_RootConstrainSelectedInstOperands,
     /* 117725 */   // GIR_Coverage, 4520,
     /* 117725 */   GIR_EraseRootFromParent_Done,
     /* 117726 */ // Label 2206: @117726
     /* 117726 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(117827), // Rule ID 4521 //
     /* 117731 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117734 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117738 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117746 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117750 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117754 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117759 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117763 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117767 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117769 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 117776 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117788 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117794 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117799 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 117807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117820 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117825 */   GIR_RootConstrainSelectedInstOperands,
     /* 117826 */   // GIR_Coverage, 4521,
     /* 117826 */   GIR_EraseRootFromParent_Done,
     /* 117827 */ // Label 2207: @117827
     /* 117827 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(117902), // Rule ID 6414 //
     /* 117832 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117835 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117839 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117843 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117847 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117851 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117855 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117860 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 117864 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117868 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 117872 */   // MIs[2] Operand 1
     /* 117872 */   // No operand predicates
     /* 117872 */   // MIs[0] Rn
     /* 117872 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117880 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 117882 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 117882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 117885 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 117889 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 117892 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 117894 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 117900 */   GIR_RootConstrainSelectedInstOperands,
     /* 117901 */   // GIR_Coverage, 6414,
     /* 117901 */   GIR_EraseRootFromParent_Done,
     /* 117902 */ // Label 2208: @117902
     /* 117902 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(117977), // Rule ID 6415 //
     /* 117907 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117910 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117914 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117918 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117922 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117926 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117930 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117935 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 117939 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117943 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 117947 */   // MIs[2] Operand 1
     /* 117947 */   // No operand predicates
     /* 117947 */   // MIs[0] Rn
     /* 117947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117955 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 117957 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 117957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 117960 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 117964 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 117967 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 117969 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 117975 */   GIR_RootConstrainSelectedInstOperands,
     /* 117976 */   // GIR_Coverage, 6415,
     /* 117976 */   GIR_EraseRootFromParent_Done,
     /* 117977 */ // Label 2209: @117977
     /* 117977 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(118030), // Rule ID 301 //
     /* 117982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117985 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117993 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117997 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118004 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 118007 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118024 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118028 */   GIR_RootConstrainSelectedInstOperands,
     /* 118029 */   // GIR_Coverage, 301,
     /* 118029 */   GIR_EraseRootFromParent_Done,
     /* 118030 */ // Label 2210: @118030
     /* 118030 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(118083), // Rule ID 302 //
     /* 118035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118038 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118046 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118050 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118057 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 118060 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118077 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118081 */   GIR_RootConstrainSelectedInstOperands,
     /* 118082 */   // GIR_Coverage, 302,
     /* 118082 */   GIR_EraseRootFromParent_Done,
     /* 118083 */ // Label 2211: @118083
     /* 118083 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(118139), // Rule ID 309 //
     /* 118088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118091 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118094 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118102 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118106 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118113 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118116 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118133 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118137 */   GIR_RootConstrainSelectedInstOperands,
     /* 118138 */   // GIR_Coverage, 309,
     /* 118138 */   GIR_EraseRootFromParent_Done,
     /* 118139 */ // Label 2212: @118139
     /* 118139 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(118195), // Rule ID 310 //
     /* 118144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118147 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118150 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118158 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118162 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118169 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118172 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118189 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118193 */   GIR_RootConstrainSelectedInstOperands,
     /* 118194 */   // GIR_Coverage, 310,
     /* 118194 */   GIR_EraseRootFromParent_Done,
     /* 118195 */ // Label 2213: @118195
     /* 118195 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(118284), // Rule ID 4427 //
     /* 118200 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118203 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118207 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118218 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118222 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 118229 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 118229 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118232 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118236 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118241 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 118247 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118252 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 118260 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118273 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118278 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118282 */   GIR_RootConstrainSelectedInstOperands,
     /* 118283 */   // GIR_Coverage, 4427,
     /* 118283 */   GIR_EraseRootFromParent_Done,
     /* 118284 */ // Label 2214: @118284
     /* 118284 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(118373), // Rule ID 4428 //
     /* 118289 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118292 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118296 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118307 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118311 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 118318 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 118318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118330 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 118336 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118341 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 118349 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118362 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118367 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118371 */   GIR_RootConstrainSelectedInstOperands,
     /* 118372 */   // GIR_Coverage, 4428,
     /* 118372 */   GIR_EraseRootFromParent_Done,
     /* 118373 */ // Label 2215: @118373
     /* 118373 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(118462), // Rule ID 4429 //
     /* 118378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118381 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118385 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118396 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118400 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 118407 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 118407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118419 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 118425 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118430 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 118438 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118451 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118456 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118460 */   GIR_RootConstrainSelectedInstOperands,
     /* 118461 */   // GIR_Coverage, 4429,
     /* 118461 */   GIR_EraseRootFromParent_Done,
     /* 118462 */ // Label 2216: @118462
     /* 118462 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(118551), // Rule ID 4430 //
     /* 118467 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118470 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118474 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118485 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118489 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 118496 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 118496 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118499 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118503 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118508 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 118514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118519 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 118527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118545 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118549 */   GIR_RootConstrainSelectedInstOperands,
     /* 118550 */   // GIR_Coverage, 4430,
     /* 118550 */   GIR_EraseRootFromParent_Done,
     /* 118551 */ // Label 2217: @118551
     /* 118551 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(118640), // Rule ID 4431 //
     /* 118556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118559 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118563 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118574 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118578 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 118585 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 118585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118597 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 118603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118608 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 118616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118634 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118638 */   GIR_RootConstrainSelectedInstOperands,
     /* 118639 */   // GIR_Coverage, 4431,
     /* 118639 */   GIR_EraseRootFromParent_Done,
     /* 118640 */ // Label 2218: @118640
     /* 118640 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(118729), // Rule ID 4432 //
     /* 118645 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118648 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118652 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118663 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118667 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 118674 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 118674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118686 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 118692 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118697 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 118705 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118718 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118723 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118727 */   GIR_RootConstrainSelectedInstOperands,
     /* 118728 */   // GIR_Coverage, 4432,
     /* 118728 */   GIR_EraseRootFromParent_Done,
     /* 118729 */ // Label 2219: @118729
     /* 118729 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(118782), // Rule ID 4443 //
     /* 118734 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118737 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118745 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118749 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118756 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118759 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118776 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118780 */   GIR_RootConstrainSelectedInstOperands,
     /* 118781 */   // GIR_Coverage, 4443,
     /* 118781 */   GIR_EraseRootFromParent_Done,
     /* 118782 */ // Label 2220: @118782
     /* 118782 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(118835), // Rule ID 4444 //
     /* 118787 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118790 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118798 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118802 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118809 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118812 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118829 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118833 */   GIR_RootConstrainSelectedInstOperands,
     /* 118834 */   // GIR_Coverage, 4444,
     /* 118834 */   GIR_EraseRootFromParent_Done,
     /* 118835 */ // Label 2221: @118835
     /* 118835 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(118888), // Rule ID 4445 //
     /* 118840 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118843 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118851 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118855 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118862 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118865 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118867 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118882 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118886 */   GIR_RootConstrainSelectedInstOperands,
     /* 118887 */   // GIR_Coverage, 4445,
     /* 118887 */   GIR_EraseRootFromParent_Done,
     /* 118888 */ // Label 2222: @118888
     /* 118888 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(118941), // Rule ID 4446 //
     /* 118893 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118896 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118904 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118908 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118915 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118918 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118935 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118939 */   GIR_RootConstrainSelectedInstOperands,
     /* 118940 */   // GIR_Coverage, 4446,
     /* 118940 */   GIR_EraseRootFromParent_Done,
     /* 118941 */ // Label 2223: @118941
     /* 118941 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(118993), // Rule ID 311 //
     /* 118946 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118949 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118961 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118968 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 118971 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 118977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118987 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118991 */   GIR_RootConstrainSelectedInstOperands,
     /* 118992 */   // GIR_Coverage, 311,
     /* 118992 */   GIR_EraseRootFromParent_Done,
     /* 118993 */ // Label 2224: @118993
     /* 118993 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(119044), // Rule ID 316 //
     /* 118998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119001 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119004 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119016 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119023 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119026 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119038 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119042 */   GIR_RootConstrainSelectedInstOperands,
     /* 119043 */   // GIR_Coverage, 316,
     /* 119043 */   GIR_EraseRootFromParent_Done,
     /* 119044 */ // Label 2225: @119044
     /* 119044 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(119092), // Rule ID 4473 //
     /* 119049 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119052 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119060 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119064 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119071 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119074 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119076 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119086 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119090 */   GIR_RootConstrainSelectedInstOperands,
     /* 119091 */   // GIR_Coverage, 4473,
     /* 119091 */   GIR_EraseRootFromParent_Done,
     /* 119092 */ // Label 2226: @119092
     /* 119092 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(119140), // Rule ID 4474 //
     /* 119097 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119100 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119108 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119112 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119119 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119122 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119134 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119138 */   GIR_RootConstrainSelectedInstOperands,
     /* 119139 */   // GIR_Coverage, 4474,
     /* 119139 */   GIR_EraseRootFromParent_Done,
     /* 119140 */ // Label 2227: @119140
     /* 119140 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(119224), // Rule ID 4488 //
     /* 119145 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119148 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119152 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119163 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119167 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 119174 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 119174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119186 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119192 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119197 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 119205 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119218 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119222 */   GIR_RootConstrainSelectedInstOperands,
     /* 119223 */   // GIR_Coverage, 4488,
     /* 119223 */   GIR_EraseRootFromParent_Done,
     /* 119224 */ // Label 2228: @119224
     /* 119224 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(119308), // Rule ID 4489 //
     /* 119229 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119232 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119236 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119247 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119251 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 119258 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 119258 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119261 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119265 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119270 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119276 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119281 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 119289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119302 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119306 */   GIR_RootConstrainSelectedInstOperands,
     /* 119307 */   // GIR_Coverage, 4489,
     /* 119307 */   GIR_EraseRootFromParent_Done,
     /* 119308 */ // Label 2229: @119308
     /* 119308 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(119392), // Rule ID 4490 //
     /* 119313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119316 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119320 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119331 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119335 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 119342 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 119342 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119345 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119349 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119354 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119360 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 119373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119390 */   GIR_RootConstrainSelectedInstOperands,
     /* 119391 */   // GIR_Coverage, 4490,
     /* 119391 */   GIR_EraseRootFromParent_Done,
     /* 119392 */ // Label 2230: @119392
     /* 119392 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(119469), // Rule ID 7045 //
     /* 119397 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119400 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 119407 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 119410 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119414 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 119418 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 119422 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119427 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119440 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15855>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119443 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 119447 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119462 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119467 */   GIR_RootConstrainSelectedInstOperands,
     /* 119468 */   // GIR_Coverage, 7045,
     /* 119468 */   GIR_EraseRootFromParent_Done,
     /* 119469 */ // Label 2231: @119469
     /* 119469 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(119546), // Rule ID 7046 //
     /* 119474 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119477 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 119484 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 119487 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119491 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 119495 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 119499 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119504 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119508 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119510 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119517 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15855>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119520 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 119524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119539 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119544 */   GIR_RootConstrainSelectedInstOperands,
     /* 119545 */   // GIR_Coverage, 7046,
     /* 119545 */   GIR_EraseRootFromParent_Done,
     /* 119546 */ // Label 2232: @119546
     /* 119546 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(119605), // Rule ID 7037 //
     /* 119551 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119554 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 119561 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 119564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119568 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119572 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119579 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15855>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 119582 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 119584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119599 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119603 */   GIR_RootConstrainSelectedInstOperands,
     /* 119604 */   // GIR_Coverage, 7037,
     /* 119604 */   GIR_EraseRootFromParent_Done,
     /* 119605 */ // Label 2233: @119605
     /* 119605 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(119664), // Rule ID 7038 //
     /* 119610 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119613 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 119620 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 119623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119627 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119631 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119638 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15855>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 119641 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 119643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119658 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119662 */   GIR_RootConstrainSelectedInstOperands,
     /* 119663 */   // GIR_Coverage, 7038,
     /* 119663 */   GIR_EraseRootFromParent_Done,
     /* 119664 */ // Label 2234: @119664
     /* 119664 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(119736), // Rule ID 7047 //
     /* 119669 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119672 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 119679 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 119682 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119686 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 119690 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 119694 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119699 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119703 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119705 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119712 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15855>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 119712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119715 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 119719 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119734 */   GIR_RootConstrainSelectedInstOperands,
     /* 119735 */   // GIR_Coverage, 7047,
     /* 119735 */   GIR_EraseRootFromParent_Done,
     /* 119736 */ // Label 2235: @119736
     /* 119736 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(119808), // Rule ID 7048 //
     /* 119741 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119744 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 119751 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 119754 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119758 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 119762 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 119766 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119771 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119775 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119777 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119784 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15855>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119787 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 119791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119806 */   GIR_RootConstrainSelectedInstOperands,
     /* 119807 */   // GIR_Coverage, 7048,
     /* 119807 */   GIR_EraseRootFromParent_Done,
     /* 119808 */ // Label 2236: @119808
     /* 119808 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(119905), // Rule ID 7359 //
     /* 119813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 119816 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 119826 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 119829 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119833 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 119837 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 119841 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 119845 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119849 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119853 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 119857 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119862 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 119866 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119870 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 119874 */   // MIs[3] Operand 1
     /* 119874 */   // No operand predicates
     /* 119874 */   // MIs[0] Rn
     /* 119874 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119882 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 119884 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15853>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 119884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 119887 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 119891 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 119894 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 119896 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 119903 */   GIR_RootConstrainSelectedInstOperands,
     /* 119904 */   // GIR_Coverage, 7359,
     /* 119904 */   GIR_EraseRootFromParent_Done,
     /* 119905 */ // Label 2237: @119905
     /* 119905 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(119957), // Rule ID 319 //
     /* 119910 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119913 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119921 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119925 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119932 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 119932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 119935 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 119941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119951 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119955 */   GIR_RootConstrainSelectedInstOperands,
     /* 119956 */   // GIR_Coverage, 319,
     /* 119956 */   GIR_EraseRootFromParent_Done,
     /* 119957 */ // Label 2238: @119957
     /* 119957 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(120008), // Rule ID 324 //
     /* 119962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119965 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119968 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119976 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119980 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 119987 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 119987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119990 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120002 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120006 */   GIR_RootConstrainSelectedInstOperands,
     /* 120007 */   // GIR_Coverage, 324,
     /* 120007 */   GIR_EraseRootFromParent_Done,
     /* 120008 */ // Label 2239: @120008
     /* 120008 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(120062), // Rule ID 7039 //
     /* 120013 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120016 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120023 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120030 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120034 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120041 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15855>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 120044 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120056 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120060 */   GIR_RootConstrainSelectedInstOperands,
     /* 120061 */   // GIR_Coverage, 7039,
     /* 120061 */   GIR_EraseRootFromParent_Done,
     /* 120062 */ // Label 2240: @120062
     /* 120062 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(120116), // Rule ID 7040 //
     /* 120067 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120070 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120077 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120088 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120095 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15855>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 120098 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120110 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120114 */   GIR_RootConstrainSelectedInstOperands,
     /* 120115 */   // GIR_Coverage, 7040,
     /* 120115 */   GIR_EraseRootFromParent_Done,
     /* 120116 */ // Label 2241: @120116
     /* 120116 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(120173), // Rule ID 7370 //
     /* 120121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 120124 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120127 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120134 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120141 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120145 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120152 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15853>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 120155 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120157 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120167 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120171 */   GIR_RootConstrainSelectedInstOperands,
     /* 120172 */   // GIR_Coverage, 7370,
     /* 120172 */   GIR_EraseRootFromParent_Done,
     /* 120173 */ // Label 2242: @120173
     /* 120173 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(120221), // Rule ID 4497 //
     /* 120178 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120181 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120189 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120193 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120200 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 120203 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120215 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120219 */   GIR_RootConstrainSelectedInstOperands,
     /* 120220 */   // GIR_Coverage, 4497,
     /* 120220 */   GIR_EraseRootFromParent_Done,
     /* 120221 */ // Label 2243: @120221
     /* 120221 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(120269), // Rule ID 4498 //
     /* 120226 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120229 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120248 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 120251 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120263 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120267 */   GIR_RootConstrainSelectedInstOperands,
     /* 120268 */   // GIR_Coverage, 4498,
     /* 120268 */   GIR_EraseRootFromParent_Done,
     /* 120269 */ // Label 2244: @120269
     /* 120269 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(120353), // Rule ID 4513 //
     /* 120274 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120277 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120281 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120292 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120296 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 120303 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120303 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120306 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120310 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120315 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120321 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120326 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 120334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120347 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120351 */   GIR_RootConstrainSelectedInstOperands,
     /* 120352 */   // GIR_Coverage, 4513,
     /* 120352 */   GIR_EraseRootFromParent_Done,
     /* 120353 */ // Label 2245: @120353
     /* 120353 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(120437), // Rule ID 4514 //
     /* 120358 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120361 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120365 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120376 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120380 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 120387 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120399 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120405 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120410 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 120418 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120431 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120435 */   GIR_RootConstrainSelectedInstOperands,
     /* 120436 */   // GIR_Coverage, 4514,
     /* 120436 */   GIR_EraseRootFromParent_Done,
     /* 120437 */ // Label 2246: @120437
     /* 120437 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(120521), // Rule ID 4515 //
     /* 120442 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120445 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120449 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120460 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120464 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120471 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120483 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120489 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120494 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 120502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120505 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120510 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120515 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120519 */   GIR_RootConstrainSelectedInstOperands,
     /* 120520 */   // GIR_Coverage, 4515,
     /* 120520 */   GIR_EraseRootFromParent_Done,
     /* 120521 */ // Label 2247: @120521
     /* 120521 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(120605), // Rule ID 7358 //
     /* 120526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 120529 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120532 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120539 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120542 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120546 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 120550 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 120554 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120558 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120563 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 120567 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120571 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 120575 */   // MIs[2] Operand 1
     /* 120575 */   // No operand predicates
     /* 120575 */   // MIs[0] Rn
     /* 120575 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120583 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120585 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15853>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 120585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 120588 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 120592 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 120595 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 120597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120603 */   GIR_RootConstrainSelectedInstOperands,
     /* 120604 */   // GIR_Coverage, 7358,
     /* 120604 */   GIR_EraseRootFromParent_Done,
     /* 120605 */ // Label 2248: @120605
     /* 120605 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(120703), // Rule ID 7360 //
     /* 120610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 120613 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120616 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120623 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120626 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120630 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120634 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120638 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120643 */   // MIs[0] Rn
     /* 120643 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120651 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120653 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15853>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 120653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 120656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120665 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 120668 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 120672 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 120675 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120680 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 120688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120694 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 120696 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120701 */   GIR_RootConstrainSelectedInstOperands,
     /* 120702 */   // GIR_Coverage, 7360,
     /* 120702 */   GIR_EraseRootFromParent_Done,
     /* 120703 */ // Label 2249: @120703
     /* 120703 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(120740), // Rule ID 7036 //
     /* 120708 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120711 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120718 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120725 */   // MIs[0] ptr
     /* 120725 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120733 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15853>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 120733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 120738 */   GIR_RootConstrainSelectedInstOperands,
     /* 120739 */   // GIR_Coverage, 7036,
     /* 120739 */   GIR_Done,
     /* 120740 */ // Label 2250: @120740
     /* 120740 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(120767), // Rule ID 6364 //
     /* 120745 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120748 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120752 */   // MIs[0] Rn
     /* 120752 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120760 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 120760 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 120765 */   GIR_RootConstrainSelectedInstOperands,
     /* 120766 */   // GIR_Coverage, 6364,
     /* 120766 */   GIR_Done,
     /* 120767 */ // Label 2251: @120767
     /* 120767 */ GIM_Reject,
     /* 120768 */ // Label 2099: @120768
     /* 120768 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(120973),
     /* 120773 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120776 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120784 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120788 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(120829), // Rule ID 4425 //
     /* 120793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 120796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 120803 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 120803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 120806 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120827 */     GIR_RootConstrainSelectedInstOperands,
     /* 120828 */     // GIR_Coverage, 4425,
     /* 120828 */     GIR_EraseRootFromParent_Done,
     /* 120829 */   // Label 2253: @120829
     /* 120829 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(120870), // Rule ID 4426 //
     /* 120834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 120837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 120844 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 120844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 120847 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120868 */     GIR_RootConstrainSelectedInstOperands,
     /* 120869 */     // GIR_Coverage, 4426,
     /* 120869 */     GIR_EraseRootFromParent_Done,
     /* 120870 */   // Label 2254: @120870
     /* 120870 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(120903), // Rule ID 4480 //
     /* 120875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 120882 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 120882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 120885 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120901 */     GIR_RootConstrainSelectedInstOperands,
     /* 120902 */     // GIR_Coverage, 4480,
     /* 120902 */     GIR_EraseRootFromParent_Done,
     /* 120903 */   // Label 2255: @120903
     /* 120903 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(120936), // Rule ID 4504 //
     /* 120908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 120915 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 120918 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120934 */     GIR_RootConstrainSelectedInstOperands,
     /* 120935 */     // GIR_Coverage, 4504,
     /* 120935 */     GIR_EraseRootFromParent_Done,
     /* 120936 */   // Label 2256: @120936
     /* 120936 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(120972), // Rule ID 325 //
     /* 120941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 120951 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 120954 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120970 */     GIR_RootConstrainSelectedInstOperands,
     /* 120971 */     // GIR_Coverage, 325,
     /* 120971 */     GIR_EraseRootFromParent_Done,
     /* 120972 */   // Label 2257: @120972
     /* 120972 */   GIM_Reject,
     /* 120973 */ // Label 2252: @120973
     /* 120973 */ GIM_Reject,
     /* 120974 */ // Label 2100: @120974
     /* 120974 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(121379),
     /* 120979 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120982 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120986 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(121035), // Rule ID 4433 //
     /* 120991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 120994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121009 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 121012 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121033 */     GIR_RootConstrainSelectedInstOperands,
     /* 121034 */     // GIR_Coverage, 4433,
     /* 121034 */     GIR_EraseRootFromParent_Done,
     /* 121035 */   // Label 2259: @121035
     /* 121035 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(121084), // Rule ID 4434 //
     /* 121040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121058 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 121061 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121082 */     GIR_RootConstrainSelectedInstOperands,
     /* 121083 */     // GIR_Coverage, 4434,
     /* 121083 */     GIR_EraseRootFromParent_Done,
     /* 121084 */   // Label 2260: @121084
     /* 121084 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(121133), // Rule ID 4435 //
     /* 121089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121107 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 121110 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121131 */     GIR_RootConstrainSelectedInstOperands,
     /* 121132 */     // GIR_Coverage, 4435,
     /* 121132 */     GIR_EraseRootFromParent_Done,
     /* 121133 */   // Label 2261: @121133
     /* 121133 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(121182), // Rule ID 4436 //
     /* 121138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121156 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 121159 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121180 */     GIR_RootConstrainSelectedInstOperands,
     /* 121181 */     // GIR_Coverage, 4436,
     /* 121181 */     GIR_EraseRootFromParent_Done,
     /* 121182 */   // Label 2262: @121182
     /* 121182 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(121226), // Rule ID 4475 //
     /* 121187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121205 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 121208 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121224 */     GIR_RootConstrainSelectedInstOperands,
     /* 121225 */     // GIR_Coverage, 4475,
     /* 121225 */     GIR_EraseRootFromParent_Done,
     /* 121226 */   // Label 2263: @121226
     /* 121226 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(121270), // Rule ID 4478 //
     /* 121231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121249 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 121252 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121268 */     GIR_RootConstrainSelectedInstOperands,
     /* 121269 */     // GIR_Coverage, 4478,
     /* 121269 */     GIR_EraseRootFromParent_Done,
     /* 121270 */   // Label 2264: @121270
     /* 121270 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(121314), // Rule ID 4499 //
     /* 121275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121293 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121296 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121312 */     GIR_RootConstrainSelectedInstOperands,
     /* 121313 */     // GIR_Coverage, 4499,
     /* 121313 */     GIR_EraseRootFromParent_Done,
     /* 121314 */   // Label 2265: @121314
     /* 121314 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(121358), // Rule ID 4502 //
     /* 121319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121337 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121340 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121356 */     GIR_RootConstrainSelectedInstOperands,
     /* 121357 */     // GIR_Coverage, 4502,
     /* 121357 */     GIR_EraseRootFromParent_Done,
     /* 121358 */   // Label 2266: @121358
     /* 121358 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(121378), // Rule ID 6363 //
     /* 121363 */     // MIs[0] Rn
     /* 121363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121371 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 121371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 121376 */     GIR_RootConstrainSelectedInstOperands,
     /* 121377 */     // GIR_Coverage, 6363,
     /* 121377 */     GIR_Done,
     /* 121378 */   // Label 2267: @121378
     /* 121378 */   GIM_Reject,
     /* 121379 */ // Label 2258: @121379
     /* 121379 */ GIM_Reject,
     /* 121380 */ // Label 2101: @121380
     /* 121380 */ GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(121829),
     /* 121385 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121388 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121392 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(121441), // Rule ID 4447 //
     /* 121397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 121400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 121415 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 121415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 121418 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121439 */     GIR_RootConstrainSelectedInstOperands,
     /* 121440 */     // GIR_Coverage, 4447,
     /* 121440 */     GIR_EraseRootFromParent_Done,
     /* 121441 */   // Label 2269: @121441
     /* 121441 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(121490), // Rule ID 4448 //
     /* 121446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 121449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 121464 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 121464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 121467 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121488 */     GIR_RootConstrainSelectedInstOperands,
     /* 121489 */     // GIR_Coverage, 4448,
     /* 121489 */     GIR_EraseRootFromParent_Done,
     /* 121490 */   // Label 2270: @121490
     /* 121490 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(121539), // Rule ID 4449 //
     /* 121495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 121498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 121513 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 121513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 121516 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121537 */     GIR_RootConstrainSelectedInstOperands,
     /* 121538 */     // GIR_Coverage, 4449,
     /* 121538 */     GIR_EraseRootFromParent_Done,
     /* 121539 */   // Label 2271: @121539
     /* 121539 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(121588), // Rule ID 4450 //
     /* 121544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 121547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 121562 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 121562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 121565 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121586 */     GIR_RootConstrainSelectedInstOperands,
     /* 121587 */     // GIR_Coverage, 4450,
     /* 121587 */     GIR_EraseRootFromParent_Done,
     /* 121588 */   // Label 2272: @121588
     /* 121588 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(121632), // Rule ID 4482 //
     /* 121593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 121611 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 121611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 121614 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121630 */     GIR_RootConstrainSelectedInstOperands,
     /* 121631 */     // GIR_Coverage, 4482,
     /* 121631 */     GIR_EraseRootFromParent_Done,
     /* 121632 */   // Label 2273: @121632
     /* 121632 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(121676), // Rule ID 4486 //
     /* 121637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 121655 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 121655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 121658 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121674 */     GIR_RootConstrainSelectedInstOperands,
     /* 121675 */     // GIR_Coverage, 4486,
     /* 121675 */     GIR_EraseRootFromParent_Done,
     /* 121676 */   // Label 2274: @121676
     /* 121676 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(121720), // Rule ID 4506 //
     /* 121681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 121699 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 121702 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121718 */     GIR_RootConstrainSelectedInstOperands,
     /* 121719 */     // GIR_Coverage, 4506,
     /* 121719 */     GIR_EraseRootFromParent_Done,
     /* 121720 */   // Label 2275: @121720
     /* 121720 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(121764), // Rule ID 4510 //
     /* 121725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 121743 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 121746 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121762 */     GIR_RootConstrainSelectedInstOperands,
     /* 121763 */     // GIR_Coverage, 4510,
     /* 121763 */     GIR_EraseRootFromParent_Done,
     /* 121764 */   // Label 2276: @121764
     /* 121764 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(121808), // Rule ID 4511 //
     /* 121769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 121787 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 121790 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121806 */     GIR_RootConstrainSelectedInstOperands,
     /* 121807 */     // GIR_Coverage, 4511,
     /* 121807 */     GIR_EraseRootFromParent_Done,
     /* 121808 */   // Label 2277: @121808
     /* 121808 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(121828), // Rule ID 6360 //
     /* 121813 */     // MIs[0] Rn
     /* 121813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121821 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 121821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 121826 */     GIR_RootConstrainSelectedInstOperands,
     /* 121827 */     // GIR_Coverage, 6360,
     /* 121827 */     GIR_Done,
     /* 121828 */   // Label 2278: @121828
     /* 121828 */   GIM_Reject,
     /* 121829 */ // Label 2268: @121829
     /* 121829 */ GIM_Reject,
     /* 121830 */ // Label 2102: @121830
     /* 121830 */ GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(122235),
     /* 121835 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121838 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121842 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(121891), // Rule ID 4437 //
     /* 121847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121865 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 121868 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121889 */     GIR_RootConstrainSelectedInstOperands,
     /* 121890 */     // GIR_Coverage, 4437,
     /* 121890 */     GIR_EraseRootFromParent_Done,
     /* 121891 */   // Label 2280: @121891
     /* 121891 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(121940), // Rule ID 4438 //
     /* 121896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121914 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 121917 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121938 */     GIR_RootConstrainSelectedInstOperands,
     /* 121939 */     // GIR_Coverage, 4438,
     /* 121939 */     GIR_EraseRootFromParent_Done,
     /* 121940 */   // Label 2281: @121940
     /* 121940 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(121989), // Rule ID 4441 //
     /* 121945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121963 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 121966 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121987 */     GIR_RootConstrainSelectedInstOperands,
     /* 121988 */     // GIR_Coverage, 4441,
     /* 121988 */     GIR_EraseRootFromParent_Done,
     /* 121989 */   // Label 2282: @121989
     /* 121989 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(122038), // Rule ID 4442 //
     /* 121994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122012 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122015 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122036 */     GIR_RootConstrainSelectedInstOperands,
     /* 122037 */     // GIR_Coverage, 4442,
     /* 122037 */     GIR_EraseRootFromParent_Done,
     /* 122038 */   // Label 2283: @122038
     /* 122038 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(122082), // Rule ID 4477 //
     /* 122043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122061 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122064 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122080 */     GIR_RootConstrainSelectedInstOperands,
     /* 122081 */     // GIR_Coverage, 4477,
     /* 122081 */     GIR_EraseRootFromParent_Done,
     /* 122082 */   // Label 2284: @122082
     /* 122082 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(122126), // Rule ID 4479 //
     /* 122087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122105 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122108 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122124 */     GIR_RootConstrainSelectedInstOperands,
     /* 122125 */     // GIR_Coverage, 4479,
     /* 122125 */     GIR_EraseRootFromParent_Done,
     /* 122126 */   // Label 2285: @122126
     /* 122126 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(122170), // Rule ID 4501 //
     /* 122131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122149 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122152 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122168 */     GIR_RootConstrainSelectedInstOperands,
     /* 122169 */     // GIR_Coverage, 4501,
     /* 122169 */     GIR_EraseRootFromParent_Done,
     /* 122170 */   // Label 2286: @122170
     /* 122170 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(122214), // Rule ID 4503 //
     /* 122175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122193 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122196 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122212 */     GIR_RootConstrainSelectedInstOperands,
     /* 122213 */     // GIR_Coverage, 4503,
     /* 122213 */     GIR_EraseRootFromParent_Done,
     /* 122214 */   // Label 2287: @122214
     /* 122214 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(122234), // Rule ID 6362 //
     /* 122219 */     // MIs[0] Rn
     /* 122219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122227 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 122232 */     GIR_RootConstrainSelectedInstOperands,
     /* 122233 */     // GIR_Coverage, 6362,
     /* 122233 */     GIR_Done,
     /* 122234 */   // Label 2288: @122234
     /* 122234 */   GIM_Reject,
     /* 122235 */ // Label 2279: @122235
     /* 122235 */ GIM_Reject,
     /* 122236 */ // Label 2103: @122236
     /* 122236 */ GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(122641),
     /* 122241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122244 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122248 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(122297), // Rule ID 4451 //
     /* 122253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122271 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122274 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122295 */     GIR_RootConstrainSelectedInstOperands,
     /* 122296 */     // GIR_Coverage, 4451,
     /* 122296 */     GIR_EraseRootFromParent_Done,
     /* 122297 */   // Label 2290: @122297
     /* 122297 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(122346), // Rule ID 4452 //
     /* 122302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122320 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122323 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122344 */     GIR_RootConstrainSelectedInstOperands,
     /* 122345 */     // GIR_Coverage, 4452,
     /* 122345 */     GIR_EraseRootFromParent_Done,
     /* 122346 */   // Label 2291: @122346
     /* 122346 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(122395), // Rule ID 4453 //
     /* 122351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122369 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122372 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122393 */     GIR_RootConstrainSelectedInstOperands,
     /* 122394 */     // GIR_Coverage, 4453,
     /* 122394 */     GIR_EraseRootFromParent_Done,
     /* 122395 */   // Label 2292: @122395
     /* 122395 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(122444), // Rule ID 4454 //
     /* 122400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122418 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122421 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122442 */     GIR_RootConstrainSelectedInstOperands,
     /* 122443 */     // GIR_Coverage, 4454,
     /* 122443 */     GIR_EraseRootFromParent_Done,
     /* 122444 */   // Label 2293: @122444
     /* 122444 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(122488), // Rule ID 4481 //
     /* 122449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122467 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 122470 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122486 */     GIR_RootConstrainSelectedInstOperands,
     /* 122487 */     // GIR_Coverage, 4481,
     /* 122487 */     GIR_EraseRootFromParent_Done,
     /* 122488 */   // Label 2294: @122488
     /* 122488 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(122532), // Rule ID 4485 //
     /* 122493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122511 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 122514 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122530 */     GIR_RootConstrainSelectedInstOperands,
     /* 122531 */     // GIR_Coverage, 4485,
     /* 122531 */     GIR_EraseRootFromParent_Done,
     /* 122532 */   // Label 2295: @122532
     /* 122532 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(122576), // Rule ID 4505 //
     /* 122537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122555 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122558 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122574 */     GIR_RootConstrainSelectedInstOperands,
     /* 122575 */     // GIR_Coverage, 4505,
     /* 122575 */     GIR_EraseRootFromParent_Done,
     /* 122576 */   // Label 2296: @122576
     /* 122576 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(122620), // Rule ID 4509 //
     /* 122581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122599 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122602 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122618 */     GIR_RootConstrainSelectedInstOperands,
     /* 122619 */     // GIR_Coverage, 4509,
     /* 122619 */     GIR_EraseRootFromParent_Done,
     /* 122620 */   // Label 2297: @122620
     /* 122620 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(122640), // Rule ID 6359 //
     /* 122625 */     // MIs[0] Rn
     /* 122625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122633 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 122638 */     GIR_RootConstrainSelectedInstOperands,
     /* 122639 */     // GIR_Coverage, 6359,
     /* 122639 */     GIR_Done,
     /* 122640 */   // Label 2298: @122640
     /* 122640 */   GIM_Reject,
     /* 122641 */ // Label 2289: @122641
     /* 122641 */ GIM_Reject,
     /* 122642 */ // Label 2104: @122642
     /* 122642 */ GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(122861),
     /* 122647 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122650 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122654 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(122703), // Rule ID 4439 //
     /* 122659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122677 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122680 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122701 */     GIR_RootConstrainSelectedInstOperands,
     /* 122702 */     // GIR_Coverage, 4439,
     /* 122702 */     GIR_EraseRootFromParent_Done,
     /* 122703 */   // Label 2300: @122703
     /* 122703 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(122752), // Rule ID 4440 //
     /* 122708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122726 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122729 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122750 */     GIR_RootConstrainSelectedInstOperands,
     /* 122751 */     // GIR_Coverage, 4440,
     /* 122751 */     GIR_EraseRootFromParent_Done,
     /* 122752 */   // Label 2301: @122752
     /* 122752 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(122796), // Rule ID 4476 //
     /* 122757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122775 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122778 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122794 */     GIR_RootConstrainSelectedInstOperands,
     /* 122795 */     // GIR_Coverage, 4476,
     /* 122795 */     GIR_EraseRootFromParent_Done,
     /* 122796 */   // Label 2302: @122796
     /* 122796 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(122840), // Rule ID 4500 //
     /* 122801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122819 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122822 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122838 */     GIR_RootConstrainSelectedInstOperands,
     /* 122839 */     // GIR_Coverage, 4500,
     /* 122839 */     GIR_EraseRootFromParent_Done,
     /* 122840 */   // Label 2303: @122840
     /* 122840 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(122860), // Rule ID 6361 //
     /* 122845 */     // MIs[0] Rn
     /* 122845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122853 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 122858 */     GIR_RootConstrainSelectedInstOperands,
     /* 122859 */     // GIR_Coverage, 6361,
     /* 122859 */     GIR_Done,
     /* 122860 */   // Label 2304: @122860
     /* 122860 */   GIM_Reject,
     /* 122861 */ // Label 2299: @122861
     /* 122861 */ GIM_Reject,
     /* 122862 */ // Label 2105: @122862
     /* 122862 */ GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(123267),
     /* 122867 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122870 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122874 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(122923), // Rule ID 4455 //
     /* 122879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122897 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122900 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122921 */     GIR_RootConstrainSelectedInstOperands,
     /* 122922 */     // GIR_Coverage, 4455,
     /* 122922 */     GIR_EraseRootFromParent_Done,
     /* 122923 */   // Label 2306: @122923
     /* 122923 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(122972), // Rule ID 4456 //
     /* 122928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122946 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122949 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122970 */     GIR_RootConstrainSelectedInstOperands,
     /* 122971 */     // GIR_Coverage, 4456,
     /* 122971 */     GIR_EraseRootFromParent_Done,
     /* 122972 */   // Label 2307: @122972
     /* 122972 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(123021), // Rule ID 4459 //
     /* 122977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122995 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122998 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123019 */     GIR_RootConstrainSelectedInstOperands,
     /* 123020 */     // GIR_Coverage, 4459,
     /* 123020 */     GIR_EraseRootFromParent_Done,
     /* 123021 */   // Label 2308: @123021
     /* 123021 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(123070), // Rule ID 4460 //
     /* 123026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123044 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123047 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123068 */     GIR_RootConstrainSelectedInstOperands,
     /* 123069 */     // GIR_Coverage, 4460,
     /* 123069 */     GIR_EraseRootFromParent_Done,
     /* 123070 */   // Label 2309: @123070
     /* 123070 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(123114), // Rule ID 4484 //
     /* 123075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123093 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123096 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123112 */     GIR_RootConstrainSelectedInstOperands,
     /* 123113 */     // GIR_Coverage, 4484,
     /* 123113 */     GIR_EraseRootFromParent_Done,
     /* 123114 */   // Label 2310: @123114
     /* 123114 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(123158), // Rule ID 4487 //
     /* 123119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123137 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123140 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123156 */     GIR_RootConstrainSelectedInstOperands,
     /* 123157 */     // GIR_Coverage, 4487,
     /* 123157 */     GIR_EraseRootFromParent_Done,
     /* 123158 */   // Label 2311: @123158
     /* 123158 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(123202), // Rule ID 4508 //
     /* 123163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123181 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123184 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123200 */     GIR_RootConstrainSelectedInstOperands,
     /* 123201 */     // GIR_Coverage, 4508,
     /* 123201 */     GIR_EraseRootFromParent_Done,
     /* 123202 */   // Label 2312: @123202
     /* 123202 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(123246), // Rule ID 4512 //
     /* 123207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123225 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123228 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123244 */     GIR_RootConstrainSelectedInstOperands,
     /* 123245 */     // GIR_Coverage, 4512,
     /* 123245 */     GIR_EraseRootFromParent_Done,
     /* 123246 */   // Label 2313: @123246
     /* 123246 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(123266), // Rule ID 6358 //
     /* 123251 */     // MIs[0] Rn
     /* 123251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123259 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 123264 */     GIR_RootConstrainSelectedInstOperands,
     /* 123265 */     // GIR_Coverage, 6358,
     /* 123265 */     GIR_Done,
     /* 123266 */   // Label 2314: @123266
     /* 123266 */   GIM_Reject,
     /* 123267 */ // Label 2305: @123267
     /* 123267 */ GIM_Reject,
     /* 123268 */ // Label 2106: @123268
     /* 123268 */ GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(123487),
     /* 123273 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123276 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123280 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(123329), // Rule ID 4457 //
     /* 123285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123303 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123306 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123327 */     GIR_RootConstrainSelectedInstOperands,
     /* 123328 */     // GIR_Coverage, 4457,
     /* 123328 */     GIR_EraseRootFromParent_Done,
     /* 123329 */   // Label 2316: @123329
     /* 123329 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(123378), // Rule ID 4458 //
     /* 123334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123352 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123355 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123376 */     GIR_RootConstrainSelectedInstOperands,
     /* 123377 */     // GIR_Coverage, 4458,
     /* 123377 */     GIR_EraseRootFromParent_Done,
     /* 123378 */   // Label 2317: @123378
     /* 123378 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(123422), // Rule ID 4483 //
     /* 123383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123401 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123404 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123420 */     GIR_RootConstrainSelectedInstOperands,
     /* 123421 */     // GIR_Coverage, 4483,
     /* 123421 */     GIR_EraseRootFromParent_Done,
     /* 123422 */   // Label 2318: @123422
     /* 123422 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(123466), // Rule ID 4507 //
     /* 123427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123445 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123448 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123464 */     GIR_RootConstrainSelectedInstOperands,
     /* 123465 */     // GIR_Coverage, 4507,
     /* 123465 */     GIR_EraseRootFromParent_Done,
     /* 123466 */   // Label 2319: @123466
     /* 123466 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(123486), // Rule ID 6357 //
     /* 123471 */     // MIs[0] Rn
     /* 123471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123479 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 123484 */     GIR_RootConstrainSelectedInstOperands,
     /* 123485 */     // GIR_Coverage, 6357,
     /* 123485 */     GIR_Done,
     /* 123486 */   // Label 2320: @123486
     /* 123486 */   GIM_Reject,
     /* 123487 */ // Label 2315: @123487
     /* 123487 */ GIM_Reject,
     /* 123488 */ // Label 2107: @123488
     /* 123488 */ GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(123547), // Rule ID 10791 //
     /* 123493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 123496 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123499 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123503 */   // MIs[0] base
     /* 123503 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123511 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 123511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 123514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 123518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123523 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 123526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 123531 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 123533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123536 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 123538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123541 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123545 */   GIR_RootConstrainSelectedInstOperands,
     /* 123546 */   // GIR_Coverage, 10791,
     /* 123546 */   GIR_EraseRootFromParent_Done,
     /* 123547 */ // Label 2321: @123547
     /* 123547 */ GIM_Reject,
     /* 123548 */ // Label 2108: @123548
     /* 123548 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(123607), // Rule ID 10797 //
     /* 123553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 123556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123559 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123563 */   // MIs[0] base
     /* 123563 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123571 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 123571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 123574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 123578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123583 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 123586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 123591 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 123593 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123596 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 123598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123601 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123605 */   GIR_RootConstrainSelectedInstOperands,
     /* 123606 */   // GIR_Coverage, 10797,
     /* 123606 */   GIR_EraseRootFromParent_Done,
     /* 123607 */ // Label 2322: @123607
     /* 123607 */ GIM_Reject,
     /* 123608 */ // Label 2109: @123608
     /* 123608 */ GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(123777),
     /* 123613 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123616 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123620 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123624 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(123672), // Rule ID 10782 //
     /* 123629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 123632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123636 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 123636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 123639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 123643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123648 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 123651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 123656 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 123658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123661 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 123663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123670 */     GIR_RootConstrainSelectedInstOperands,
     /* 123671 */     // GIR_Coverage, 10782,
     /* 123671 */     GIR_EraseRootFromParent_Done,
     /* 123672 */   // Label 2324: @123672
     /* 123672 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(123720), // Rule ID 10800 //
     /* 123677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 123680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123684 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 123684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 123687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 123691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123696 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 123699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 123704 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 123706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123709 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 123711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123718 */     GIR_RootConstrainSelectedInstOperands,
     /* 123719 */     // GIR_Coverage, 10800,
     /* 123719 */     GIR_EraseRootFromParent_Done,
     /* 123720 */   // Label 2325: @123720
     /* 123720 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(123748), // Rule ID 10912 //
     /* 123725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 123728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123732 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 123732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 123735 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 123737 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 123739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123746 */     GIR_RootConstrainSelectedInstOperands,
     /* 123747 */     // GIR_Coverage, 10912,
     /* 123747 */     GIR_EraseRootFromParent_Done,
     /* 123748 */   // Label 2326: @123748
     /* 123748 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(123776), // Rule ID 10924 //
     /* 123753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 123756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123760 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 123760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 123763 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 123765 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 123767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123774 */     GIR_RootConstrainSelectedInstOperands,
     /* 123775 */     // GIR_Coverage, 10924,
     /* 123775 */     GIR_EraseRootFromParent_Done,
     /* 123776 */   // Label 2327: @123776
     /* 123776 */   GIM_Reject,
     /* 123777 */ // Label 2323: @123777
     /* 123777 */ GIM_Reject,
     /* 123778 */ // Label 2110: @123778
     /* 123778 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(123837), // Rule ID 10788 //
     /* 123783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 123786 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123789 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123793 */   // MIs[0] base
     /* 123793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123801 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 123801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 123804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 123808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123813 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 123816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 123821 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 123823 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123826 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 123828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123835 */   GIR_RootConstrainSelectedInstOperands,
     /* 123836 */   // GIR_Coverage, 10788,
     /* 123836 */   GIR_EraseRootFromParent_Done,
     /* 123837 */ // Label 2328: @123837
     /* 123837 */ GIM_Reject,
     /* 123838 */ // Label 2111: @123838
     /* 123838 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(124007),
     /* 123843 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123846 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123850 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123854 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(123902), // Rule ID 10776 //
     /* 123859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 123862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123866 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 123866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 123869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 123873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123878 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 123881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 123886 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 123888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123891 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 123893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123900 */     GIR_RootConstrainSelectedInstOperands,
     /* 123901 */     // GIR_Coverage, 10776,
     /* 123901 */     GIR_EraseRootFromParent_Done,
     /* 123902 */   // Label 2330: @123902
     /* 123902 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(123950), // Rule ID 10794 //
     /* 123907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 123910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123914 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 123914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 123917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 123921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123926 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 123929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 123934 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 123936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123939 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 123941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123948 */     GIR_RootConstrainSelectedInstOperands,
     /* 123949 */     // GIR_Coverage, 10794,
     /* 123949 */     GIR_EraseRootFromParent_Done,
     /* 123950 */   // Label 2331: @123950
     /* 123950 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(123978), // Rule ID 10908 //
     /* 123955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 123958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123962 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 123962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 123965 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 123967 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 123969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123976 */     GIR_RootConstrainSelectedInstOperands,
     /* 123977 */     // GIR_Coverage, 10908,
     /* 123977 */     GIR_EraseRootFromParent_Done,
     /* 123978 */   // Label 2332: @123978
     /* 123978 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(124006), // Rule ID 10920 //
     /* 123983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 123986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123990 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 123990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 123993 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 123995 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 123997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124004 */     GIR_RootConstrainSelectedInstOperands,
     /* 124005 */     // GIR_Coverage, 10920,
     /* 124005 */     GIR_EraseRootFromParent_Done,
     /* 124006 */   // Label 2333: @124006
     /* 124006 */   GIM_Reject,
     /* 124007 */ // Label 2329: @124007
     /* 124007 */ GIM_Reject,
     /* 124008 */ // Label 2112: @124008
     /* 124008 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(124177),
     /* 124013 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124016 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124020 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124024 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(124072), // Rule ID 10767 //
     /* 124029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124036 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 124043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124048 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 124056 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124061 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124070 */     GIR_RootConstrainSelectedInstOperands,
     /* 124071 */     // GIR_Coverage, 10767,
     /* 124071 */     GIR_EraseRootFromParent_Done,
     /* 124072 */   // Label 2335: @124072
     /* 124072 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(124120), // Rule ID 10785 //
     /* 124077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124084 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 124091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124096 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 124104 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124109 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124118 */     GIR_RootConstrainSelectedInstOperands,
     /* 124119 */     // GIR_Coverage, 10785,
     /* 124119 */     GIR_EraseRootFromParent_Done,
     /* 124120 */   // Label 2336: @124120
     /* 124120 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(124148), // Rule ID 10904 //
     /* 124125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124132 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124135 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124137 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124146 */     GIR_RootConstrainSelectedInstOperands,
     /* 124147 */     // GIR_Coverage, 10904,
     /* 124147 */     GIR_EraseRootFromParent_Done,
     /* 124148 */   // Label 2337: @124148
     /* 124148 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(124176), // Rule ID 10916 //
     /* 124153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124160 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124163 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124165 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124174 */     GIR_RootConstrainSelectedInstOperands,
     /* 124175 */     // GIR_Coverage, 10916,
     /* 124175 */     GIR_EraseRootFromParent_Done,
     /* 124176 */   // Label 2338: @124176
     /* 124176 */   GIM_Reject,
     /* 124177 */ // Label 2334: @124177
     /* 124177 */ GIM_Reject,
     /* 124178 */ // Label 2113: @124178
     /* 124178 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(124221), // Rule ID 2421 //
     /* 124183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124186 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124189 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 124197 */   // MIs[0] base
     /* 124197 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124205 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 124208 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 124210 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124215 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124219 */   GIR_RootConstrainSelectedInstOperands,
     /* 124220 */   // GIR_Coverage, 2421,
     /* 124220 */   GIR_EraseRootFromParent_Done,
     /* 124221 */ // Label 2339: @124221
     /* 124221 */ GIM_Reject,
     /* 124222 */ // Label 2114: @124222
     /* 124222 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(124315),
     /* 124227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124230 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124234 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124238 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(124286), // Rule ID 10753 //
     /* 124243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124250 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 124257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124262 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 124270 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124275 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124284 */     GIR_RootConstrainSelectedInstOperands,
     /* 124285 */     // GIR_Coverage, 10753,
     /* 124285 */     GIR_EraseRootFromParent_Done,
     /* 124286 */   // Label 2341: @124286
     /* 124286 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(124314), // Rule ID 10900 //
     /* 124291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124298 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124301 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124303 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124312 */     GIR_RootConstrainSelectedInstOperands,
     /* 124313 */     // GIR_Coverage, 10900,
     /* 124313 */     GIR_EraseRootFromParent_Done,
     /* 124314 */   // Label 2342: @124314
     /* 124314 */   GIM_Reject,
     /* 124315 */ // Label 2340: @124315
     /* 124315 */ GIM_Reject,
     /* 124316 */ // Label 2115: @124316
     /* 124316 */ GIM_Reject,
     /* 124317 */ // Label 20: @124317
     /* 124317 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2345*/ GIMT_Encode4(125667),
     /* 124328 */ /*GILLT_s32*//*Label 2343*/ GIMT_Encode4(124336),
     /* 124332 */ /*GILLT_s64*//*Label 2344*/ GIMT_Encode4(125354),
     /* 124336 */ // Label 2343: @124336
     /* 124336 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(125353),
     /* 124341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 124344 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 124347 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(124402), // Rule ID 7259 //
     /* 124352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124355 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124362 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124369 */     // MIs[0] Rn
     /* 124369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124385 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 124385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 124388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 124390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 124392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 124394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124400 */     GIR_RootConstrainSelectedInstOperands,
     /* 124401 */     // GIR_Coverage, 7259,
     /* 124401 */     GIR_EraseRootFromParent_Done,
     /* 124402 */   // Label 2347: @124402
     /* 124402 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(124457), // Rule ID 7260 //
     /* 124407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124410 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124417 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124424 */     // MIs[0] Rn
     /* 124424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124440 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 124440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 124443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 124445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 124447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 124449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124455 */     GIR_RootConstrainSelectedInstOperands,
     /* 124456 */     // GIR_Coverage, 7260,
     /* 124456 */     GIR_EraseRootFromParent_Done,
     /* 124457 */   // Label 2348: @124457
     /* 124457 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(124512), // Rule ID 7261 //
     /* 124462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124465 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124472 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124479 */     // MIs[0] Rn
     /* 124479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124495 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 124495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 124498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 124500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 124502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 124504 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124510 */     GIR_RootConstrainSelectedInstOperands,
     /* 124511 */     // GIR_Coverage, 7261,
     /* 124511 */     GIR_EraseRootFromParent_Done,
     /* 124512 */   // Label 2349: @124512
     /* 124512 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(124567), // Rule ID 7262 //
     /* 124517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124520 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124527 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124534 */     // MIs[0] Rn
     /* 124534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124550 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 124550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 124553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 124555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 124557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 124559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124565 */     GIR_RootConstrainSelectedInstOperands,
     /* 124566 */     // GIR_Coverage, 7262,
     /* 124566 */     GIR_EraseRootFromParent_Done,
     /* 124567 */   // Label 2350: @124567
     /* 124567 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(124622), // Rule ID 7263 //
     /* 124572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124575 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 124582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124589 */     // MIs[0] Rn
     /* 124589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124605 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 124605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 124608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 124610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 124612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 124614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124620 */     GIR_RootConstrainSelectedInstOperands,
     /* 124621 */     // GIR_Coverage, 7263,
     /* 124621 */     GIR_EraseRootFromParent_Done,
     /* 124622 */   // Label 2351: @124622
     /* 124622 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(124677), // Rule ID 7264 //
     /* 124627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124644 */     // MIs[0] Rn
     /* 124644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124660 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 124660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 124663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 124665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 124667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 124669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124675 */     GIR_RootConstrainSelectedInstOperands,
     /* 124676 */     // GIR_Coverage, 7264,
     /* 124676 */     GIR_EraseRootFromParent_Done,
     /* 124677 */   // Label 2352: @124677
     /* 124677 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(124732), // Rule ID 7265 //
     /* 124682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124685 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124692 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124699 */     // MIs[0] Rn
     /* 124699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124715 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 124715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 124718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 124720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 124722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 124724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124730 */     GIR_RootConstrainSelectedInstOperands,
     /* 124731 */     // GIR_Coverage, 7265,
     /* 124731 */     GIR_EraseRootFromParent_Done,
     /* 124732 */   // Label 2353: @124732
     /* 124732 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(124787), // Rule ID 7266 //
     /* 124737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124740 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124747 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 124750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124754 */     // MIs[0] Rn
     /* 124754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124770 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 124770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 124773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 124775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 124777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 124779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124785 */     GIR_RootConstrainSelectedInstOperands,
     /* 124786 */     // GIR_Coverage, 7266,
     /* 124786 */     GIR_EraseRootFromParent_Done,
     /* 124787 */   // Label 2354: @124787
     /* 124787 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(124842), // Rule ID 7267 //
     /* 124792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124795 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 124805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124809 */     // MIs[0] Rn
     /* 124809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124825 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 124825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 124828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 124830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 124832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 124834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124840 */     GIR_RootConstrainSelectedInstOperands,
     /* 124841 */     // GIR_Coverage, 7267,
     /* 124841 */     GIR_EraseRootFromParent_Done,
     /* 124842 */   // Label 2355: @124842
     /* 124842 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(124897), // Rule ID 7268 //
     /* 124847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124850 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 124857 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 124860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124864 */     // MIs[0] Rn
     /* 124864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124880 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 124880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 124883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 124885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 124887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 124889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124895 */     GIR_RootConstrainSelectedInstOperands,
     /* 124896 */     // GIR_Coverage, 7268,
     /* 124896 */     GIR_EraseRootFromParent_Done,
     /* 124897 */   // Label 2356: @124897
     /* 124897 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(124952), // Rule ID 7269 //
     /* 124902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124905 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 124915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124919 */     // MIs[0] Rn
     /* 124919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124935 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 124935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 124938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 124940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 124942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 124944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 124946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124950 */     GIR_RootConstrainSelectedInstOperands,
     /* 124951 */     // GIR_Coverage, 7269,
     /* 124951 */     GIR_EraseRootFromParent_Done,
     /* 124952 */   // Label 2357: @124952
     /* 124952 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(125007), // Rule ID 7270 //
     /* 124957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 124960 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 124967 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 124970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124974 */     // MIs[0] Rn
     /* 124974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 124990 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 124990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 124993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 124995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 124997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 124999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125005 */     GIR_RootConstrainSelectedInstOperands,
     /* 125006 */     // GIR_Coverage, 7270,
     /* 125006 */     GIR_EraseRootFromParent_Done,
     /* 125007 */   // Label 2358: @125007
     /* 125007 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(125062), // Rule ID 7271 //
     /* 125012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125015 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125022 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125029 */     // MIs[0] Rn
     /* 125029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125045 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 125048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125060 */     GIR_RootConstrainSelectedInstOperands,
     /* 125061 */     // GIR_Coverage, 7271,
     /* 125061 */     GIR_EraseRootFromParent_Done,
     /* 125062 */   // Label 2359: @125062
     /* 125062 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(125117), // Rule ID 7272 //
     /* 125067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125070 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125077 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125084 */     // MIs[0] Rn
     /* 125084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125100 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 125103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125115 */     GIR_RootConstrainSelectedInstOperands,
     /* 125116 */     // GIR_Coverage, 7272,
     /* 125116 */     GIR_EraseRootFromParent_Done,
     /* 125117 */   // Label 2360: @125117
     /* 125117 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(125172), // Rule ID 7273 //
     /* 125122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125139 */     // MIs[0] Rn
     /* 125139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125155 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 125158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125170 */     GIR_RootConstrainSelectedInstOperands,
     /* 125171 */     // GIR_Coverage, 7273,
     /* 125171 */     GIR_EraseRootFromParent_Done,
     /* 125172 */   // Label 2361: @125172
     /* 125172 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(125232), // Rule ID 13031 //
     /* 125177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 125180 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125191 */     // MIs[0] addr
     /* 125191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125207 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 125207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 125213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 125215 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 125220 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 125222 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 125224 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 125226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125230 */     GIR_RootConstrainSelectedInstOperands,
     /* 125231 */     // GIR_Coverage, 13031,
     /* 125231 */     GIR_EraseRootFromParent_Done,
     /* 125232 */   // Label 2362: @125232
     /* 125232 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(125292), // Rule ID 13032 //
     /* 125237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 125240 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125251 */     // MIs[0] addr
     /* 125251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125267 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 125267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 125273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 125275 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 125280 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 125282 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 125284 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 125286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125290 */     GIR_RootConstrainSelectedInstOperands,
     /* 125291 */     // GIR_Coverage, 13032,
     /* 125291 */     GIR_EraseRootFromParent_Done,
     /* 125292 */   // Label 2363: @125292
     /* 125292 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(125352), // Rule ID 13033 //
     /* 125297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 125300 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125311 */     // MIs[0] addr
     /* 125311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125327 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 125327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 125333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 125335 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 125340 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 125342 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 125344 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 125346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125350 */     GIR_RootConstrainSelectedInstOperands,
     /* 125351 */     // GIR_Coverage, 13033,
     /* 125351 */     GIR_EraseRootFromParent_Done,
     /* 125352 */   // Label 2364: @125352
     /* 125352 */   GIM_Reject,
     /* 125353 */ // Label 2346: @125353
     /* 125353 */ GIM_Reject,
     /* 125354 */ // Label 2344: @125354
     /* 125354 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(125666),
     /* 125359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 125362 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 125365 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 125372 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(125420), // Rule ID 2580 //
     /* 125377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125380 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125387 */     // MIs[0] Rn
     /* 125387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125403 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 125406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125418 */     GIR_RootConstrainSelectedInstOperands,
     /* 125419 */     // GIR_Coverage, 2580,
     /* 125419 */     GIR_EraseRootFromParent_Done,
     /* 125420 */   // Label 2366: @125420
     /* 125420 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(125468), // Rule ID 2581 //
     /* 125425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125428 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125435 */     // MIs[0] Rn
     /* 125435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125451 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 125454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125466 */     GIR_RootConstrainSelectedInstOperands,
     /* 125467 */     // GIR_Coverage, 2581,
     /* 125467 */     GIR_EraseRootFromParent_Done,
     /* 125468 */   // Label 2367: @125468
     /* 125468 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(125516), // Rule ID 2582 //
     /* 125473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125483 */     // MIs[0] Rn
     /* 125483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125499 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 125502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125514 */     GIR_RootConstrainSelectedInstOperands,
     /* 125515 */     // GIR_Coverage, 2582,
     /* 125515 */     GIR_EraseRootFromParent_Done,
     /* 125516 */   // Label 2368: @125516
     /* 125516 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(125564), // Rule ID 2583 //
     /* 125521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125524 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125531 */     // MIs[0] Rn
     /* 125531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125547 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 125550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125562 */     GIR_RootConstrainSelectedInstOperands,
     /* 125563 */     // GIR_Coverage, 2583,
     /* 125563 */     GIR_EraseRootFromParent_Done,
     /* 125564 */   // Label 2369: @125564
     /* 125564 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(125612), // Rule ID 2584 //
     /* 125569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125572 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125579 */     // MIs[0] Rn
     /* 125579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125595 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 125598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125610 */     GIR_RootConstrainSelectedInstOperands,
     /* 125611 */     // GIR_Coverage, 2584,
     /* 125611 */     GIR_EraseRootFromParent_Done,
     /* 125612 */   // Label 2370: @125612
     /* 125612 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(125665), // Rule ID 13034 //
     /* 125617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 125620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125624 */     // MIs[0] addr
     /* 125624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125640 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 125640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 125646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 125648 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 125653 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 125655 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 125657 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 125659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125663 */     GIR_RootConstrainSelectedInstOperands,
     /* 125664 */     // GIR_Coverage, 13034,
     /* 125664 */     GIR_EraseRootFromParent_Done,
     /* 125665 */   // Label 2371: @125665
     /* 125665 */   GIM_Reject,
     /* 125666 */ // Label 2365: @125666
     /* 125666 */ GIM_Reject,
     /* 125667 */ // Label 2345: @125667
     /* 125667 */ GIM_Reject,
     /* 125668 */ // Label 21: @125668
     /* 125668 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2374*/ GIMT_Encode4(126659),
     /* 125679 */ /*GILLT_s32*//*Label 2372*/ GIMT_Encode4(125687),
     /* 125683 */ /*GILLT_s64*//*Label 2373*/ GIMT_Encode4(126432),
     /* 125687 */ // Label 2372: @125687
     /* 125687 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(126431),
     /* 125692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 125695 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(125744), // Rule ID 7244 //
     /* 125700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125710 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125717 */     // MIs[0] Rn
     /* 125717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125729 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 125729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 125732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 125736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125742 */     GIR_RootConstrainSelectedInstOperands,
     /* 125743 */     // GIR_Coverage, 7244,
     /* 125743 */     GIR_EraseRootFromParent_Done,
     /* 125744 */   // Label 2376: @125744
     /* 125744 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(125793), // Rule ID 7245 //
     /* 125749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125752 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125759 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125766 */     // MIs[0] Rn
     /* 125766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125778 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 125778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 125781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 125785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125791 */     GIR_RootConstrainSelectedInstOperands,
     /* 125792 */     // GIR_Coverage, 7245,
     /* 125792 */     GIR_EraseRootFromParent_Done,
     /* 125793 */   // Label 2377: @125793
     /* 125793 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(125842), // Rule ID 7246 //
     /* 125798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125808 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125815 */     // MIs[0] Rn
     /* 125815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125827 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 125827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 125830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 125834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125840 */     GIR_RootConstrainSelectedInstOperands,
     /* 125841 */     // GIR_Coverage, 7246,
     /* 125841 */     GIR_EraseRootFromParent_Done,
     /* 125842 */   // Label 2378: @125842
     /* 125842 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(125891), // Rule ID 7247 //
     /* 125847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125850 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125857 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125864 */     // MIs[0] Rn
     /* 125864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125876 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 125876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 125879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 125883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125889 */     GIR_RootConstrainSelectedInstOperands,
     /* 125890 */     // GIR_Coverage, 7247,
     /* 125890 */     GIR_EraseRootFromParent_Done,
     /* 125891 */   // Label 2379: @125891
     /* 125891 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(125940), // Rule ID 7248 //
     /* 125896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125899 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125906 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125913 */     // MIs[0] Rn
     /* 125913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125925 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 125925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 125928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 125932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125938 */     GIR_RootConstrainSelectedInstOperands,
     /* 125939 */     // GIR_Coverage, 7248,
     /* 125939 */     GIR_EraseRootFromParent_Done,
     /* 125940 */   // Label 2380: @125940
     /* 125940 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(125989), // Rule ID 7249 //
     /* 125945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125948 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125955 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125962 */     // MIs[0] Rn
     /* 125962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125974 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 125974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 125977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 125981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125987 */     GIR_RootConstrainSelectedInstOperands,
     /* 125988 */     // GIR_Coverage, 7249,
     /* 125988 */     GIR_EraseRootFromParent_Done,
     /* 125989 */   // Label 2381: @125989
     /* 125989 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(126038), // Rule ID 7250 //
     /* 125994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125997 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126004 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126011 */     // MIs[0] Rn
     /* 126011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126023 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 126026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126036 */     GIR_RootConstrainSelectedInstOperands,
     /* 126037 */     // GIR_Coverage, 7250,
     /* 126037 */     GIR_EraseRootFromParent_Done,
     /* 126038 */   // Label 2382: @126038
     /* 126038 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(126087), // Rule ID 7251 //
     /* 126043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126046 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126053 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126060 */     // MIs[0] Rn
     /* 126060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126072 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 126075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126085 */     GIR_RootConstrainSelectedInstOperands,
     /* 126086 */     // GIR_Coverage, 7251,
     /* 126086 */     GIR_EraseRootFromParent_Done,
     /* 126087 */   // Label 2383: @126087
     /* 126087 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(126136), // Rule ID 7252 //
     /* 126092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126095 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126102 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126109 */     // MIs[0] Rn
     /* 126109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126121 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 126124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126134 */     GIR_RootConstrainSelectedInstOperands,
     /* 126135 */     // GIR_Coverage, 7252,
     /* 126135 */     GIR_EraseRootFromParent_Done,
     /* 126136 */   // Label 2384: @126136
     /* 126136 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(126185), // Rule ID 7253 //
     /* 126141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126144 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126151 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126158 */     // MIs[0] Rn
     /* 126158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126170 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 126173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126183 */     GIR_RootConstrainSelectedInstOperands,
     /* 126184 */     // GIR_Coverage, 7253,
     /* 126184 */     GIR_EraseRootFromParent_Done,
     /* 126185 */   // Label 2385: @126185
     /* 126185 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(126234), // Rule ID 7254 //
     /* 126190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126193 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126200 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126207 */     // MIs[0] Rn
     /* 126207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126219 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 126222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126232 */     GIR_RootConstrainSelectedInstOperands,
     /* 126233 */     // GIR_Coverage, 7254,
     /* 126233 */     GIR_EraseRootFromParent_Done,
     /* 126234 */   // Label 2386: @126234
     /* 126234 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(126283), // Rule ID 7255 //
     /* 126239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126242 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126249 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126256 */     // MIs[0] Rn
     /* 126256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126268 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 126271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126281 */     GIR_RootConstrainSelectedInstOperands,
     /* 126282 */     // GIR_Coverage, 7255,
     /* 126282 */     GIR_EraseRootFromParent_Done,
     /* 126283 */   // Label 2387: @126283
     /* 126283 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(126332), // Rule ID 7256 //
     /* 126288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126291 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126298 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126305 */     // MIs[0] Rn
     /* 126305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126317 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 126320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126330 */     GIR_RootConstrainSelectedInstOperands,
     /* 126331 */     // GIR_Coverage, 7256,
     /* 126331 */     GIR_EraseRootFromParent_Done,
     /* 126332 */   // Label 2388: @126332
     /* 126332 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(126381), // Rule ID 7257 //
     /* 126337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126340 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126347 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126354 */     // MIs[0] Rn
     /* 126354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126366 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 126369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126379 */     GIR_RootConstrainSelectedInstOperands,
     /* 126380 */     // GIR_Coverage, 7257,
     /* 126380 */     GIR_EraseRootFromParent_Done,
     /* 126381 */   // Label 2389: @126381
     /* 126381 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(126430), // Rule ID 7258 //
     /* 126386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126389 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126396 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126403 */     // MIs[0] Rn
     /* 126403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126415 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 126418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126428 */     GIR_RootConstrainSelectedInstOperands,
     /* 126429 */     // GIR_Coverage, 7258,
     /* 126429 */     GIR_EraseRootFromParent_Done,
     /* 126430 */   // Label 2390: @126430
     /* 126430 */   GIM_Reject,
     /* 126431 */ // Label 2375: @126431
     /* 126431 */ GIM_Reject,
     /* 126432 */ // Label 2373: @126432
     /* 126432 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(126658),
     /* 126437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 126440 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 126447 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(126489), // Rule ID 7239 //
     /* 126452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126455 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126462 */     // MIs[0] Rn
     /* 126462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126474 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 126477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126487 */     GIR_RootConstrainSelectedInstOperands,
     /* 126488 */     // GIR_Coverage, 7239,
     /* 126488 */     GIR_EraseRootFromParent_Done,
     /* 126489 */   // Label 2392: @126489
     /* 126489 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(126531), // Rule ID 7240 //
     /* 126494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126504 */     // MIs[0] Rn
     /* 126504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126516 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 126519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126529 */     GIR_RootConstrainSelectedInstOperands,
     /* 126530 */     // GIR_Coverage, 7240,
     /* 126530 */     GIR_EraseRootFromParent_Done,
     /* 126531 */   // Label 2393: @126531
     /* 126531 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(126573), // Rule ID 7241 //
     /* 126536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126546 */     // MIs[0] Rn
     /* 126546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126558 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 126561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126571 */     GIR_RootConstrainSelectedInstOperands,
     /* 126572 */     // GIR_Coverage, 7241,
     /* 126572 */     GIR_EraseRootFromParent_Done,
     /* 126573 */   // Label 2394: @126573
     /* 126573 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(126615), // Rule ID 7242 //
     /* 126578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126581 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126588 */     // MIs[0] Rn
     /* 126588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126600 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 126603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126613 */     GIR_RootConstrainSelectedInstOperands,
     /* 126614 */     // GIR_Coverage, 7242,
     /* 126614 */     GIR_EraseRootFromParent_Done,
     /* 126615 */   // Label 2395: @126615
     /* 126615 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(126657), // Rule ID 7243 //
     /* 126620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126630 */     // MIs[0] Rn
     /* 126630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126642 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 126645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126655 */     GIR_RootConstrainSelectedInstOperands,
     /* 126656 */     // GIR_Coverage, 7243,
     /* 126656 */     GIR_EraseRootFromParent_Done,
     /* 126657 */   // Label 2396: @126657
     /* 126657 */   GIM_Reject,
     /* 126658 */ // Label 2391: @126658
     /* 126658 */ GIM_Reject,
     /* 126659 */ // Label 2374: @126659
     /* 126659 */ GIM_Reject,
     /* 126660 */ // Label 22: @126660
     /* 126660 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2399*/ GIMT_Encode4(127651),
     /* 126671 */ /*GILLT_s32*//*Label 2397*/ GIMT_Encode4(126679),
     /* 126675 */ /*GILLT_s64*//*Label 2398*/ GIMT_Encode4(127424),
     /* 126679 */ // Label 2397: @126679
     /* 126679 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(127423),
     /* 126684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126687 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(126736), // Rule ID 7084 //
     /* 126692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126709 */     // MIs[0] Rn
     /* 126709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126721 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 126724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126734 */     GIR_RootConstrainSelectedInstOperands,
     /* 126735 */     // GIR_Coverage, 7084,
     /* 126735 */     GIR_EraseRootFromParent_Done,
     /* 126736 */   // Label 2401: @126736
     /* 126736 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(126785), // Rule ID 7085 //
     /* 126741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126744 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126751 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126758 */     // MIs[0] Rn
     /* 126758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126770 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 126773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126783 */     GIR_RootConstrainSelectedInstOperands,
     /* 126784 */     // GIR_Coverage, 7085,
     /* 126784 */     GIR_EraseRootFromParent_Done,
     /* 126785 */   // Label 2402: @126785
     /* 126785 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(126834), // Rule ID 7086 //
     /* 126790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126793 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126800 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126807 */     // MIs[0] Rn
     /* 126807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126819 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 126822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126832 */     GIR_RootConstrainSelectedInstOperands,
     /* 126833 */     // GIR_Coverage, 7086,
     /* 126833 */     GIR_EraseRootFromParent_Done,
     /* 126834 */   // Label 2403: @126834
     /* 126834 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(126883), // Rule ID 7087 //
     /* 126839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126842 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126849 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126856 */     // MIs[0] Rn
     /* 126856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126868 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 126871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126881 */     GIR_RootConstrainSelectedInstOperands,
     /* 126882 */     // GIR_Coverage, 7087,
     /* 126882 */     GIR_EraseRootFromParent_Done,
     /* 126883 */   // Label 2404: @126883
     /* 126883 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(126932), // Rule ID 7088 //
     /* 126888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126898 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126905 */     // MIs[0] Rn
     /* 126905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126917 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 126920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126924 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126930 */     GIR_RootConstrainSelectedInstOperands,
     /* 126931 */     // GIR_Coverage, 7088,
     /* 126931 */     GIR_EraseRootFromParent_Done,
     /* 126932 */   // Label 2405: @126932
     /* 126932 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(126981), // Rule ID 7089 //
     /* 126937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126940 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126947 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126954 */     // MIs[0] Rn
     /* 126954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126966 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 126969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126979 */     GIR_RootConstrainSelectedInstOperands,
     /* 126980 */     // GIR_Coverage, 7089,
     /* 126980 */     GIR_EraseRootFromParent_Done,
     /* 126981 */   // Label 2406: @126981
     /* 126981 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(127030), // Rule ID 7090 //
     /* 126986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126989 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126996 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127003 */     // MIs[0] Rn
     /* 127003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127015 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 127018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127028 */     GIR_RootConstrainSelectedInstOperands,
     /* 127029 */     // GIR_Coverage, 7090,
     /* 127029 */     GIR_EraseRootFromParent_Done,
     /* 127030 */   // Label 2407: @127030
     /* 127030 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(127079), // Rule ID 7091 //
     /* 127035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127038 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127045 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127052 */     // MIs[0] Rn
     /* 127052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127064 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 127067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127077 */     GIR_RootConstrainSelectedInstOperands,
     /* 127078 */     // GIR_Coverage, 7091,
     /* 127078 */     GIR_EraseRootFromParent_Done,
     /* 127079 */   // Label 2408: @127079
     /* 127079 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(127128), // Rule ID 7092 //
     /* 127084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127087 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127094 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127101 */     // MIs[0] Rn
     /* 127101 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127113 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 127116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127120 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127126 */     GIR_RootConstrainSelectedInstOperands,
     /* 127127 */     // GIR_Coverage, 7092,
     /* 127127 */     GIR_EraseRootFromParent_Done,
     /* 127128 */   // Label 2409: @127128
     /* 127128 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(127177), // Rule ID 7093 //
     /* 127133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127136 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127143 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127150 */     // MIs[0] Rn
     /* 127150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127162 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 127165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127175 */     GIR_RootConstrainSelectedInstOperands,
     /* 127176 */     // GIR_Coverage, 7093,
     /* 127176 */     GIR_EraseRootFromParent_Done,
     /* 127177 */   // Label 2410: @127177
     /* 127177 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(127226), // Rule ID 7094 //
     /* 127182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127185 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127192 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127199 */     // MIs[0] Rn
     /* 127199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127211 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 127214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127224 */     GIR_RootConstrainSelectedInstOperands,
     /* 127225 */     // GIR_Coverage, 7094,
     /* 127225 */     GIR_EraseRootFromParent_Done,
     /* 127226 */   // Label 2411: @127226
     /* 127226 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(127275), // Rule ID 7095 //
     /* 127231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127234 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127241 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127248 */     // MIs[0] Rn
     /* 127248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127260 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 127263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127273 */     GIR_RootConstrainSelectedInstOperands,
     /* 127274 */     // GIR_Coverage, 7095,
     /* 127274 */     GIR_EraseRootFromParent_Done,
     /* 127275 */   // Label 2412: @127275
     /* 127275 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(127324), // Rule ID 7096 //
     /* 127280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127283 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127290 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127297 */     // MIs[0] Rn
     /* 127297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127309 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 127312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127322 */     GIR_RootConstrainSelectedInstOperands,
     /* 127323 */     // GIR_Coverage, 7096,
     /* 127323 */     GIR_EraseRootFromParent_Done,
     /* 127324 */   // Label 2413: @127324
     /* 127324 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(127373), // Rule ID 7097 //
     /* 127329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127332 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127339 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127346 */     // MIs[0] Rn
     /* 127346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127358 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 127361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127371 */     GIR_RootConstrainSelectedInstOperands,
     /* 127372 */     // GIR_Coverage, 7097,
     /* 127372 */     GIR_EraseRootFromParent_Done,
     /* 127373 */   // Label 2414: @127373
     /* 127373 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(127422), // Rule ID 7098 //
     /* 127378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127381 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127388 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127395 */     // MIs[0] Rn
     /* 127395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127407 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 127410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127420 */     GIR_RootConstrainSelectedInstOperands,
     /* 127421 */     // GIR_Coverage, 7098,
     /* 127421 */     GIR_EraseRootFromParent_Done,
     /* 127422 */   // Label 2415: @127422
     /* 127422 */   GIM_Reject,
     /* 127423 */ // Label 2400: @127423
     /* 127423 */ GIM_Reject,
     /* 127424 */ // Label 2398: @127424
     /* 127424 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(127650),
     /* 127429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 127432 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 127439 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(127481), // Rule ID 2570 //
     /* 127444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127454 */     // MIs[0] Rn
     /* 127454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127466 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 127469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127479 */     GIR_RootConstrainSelectedInstOperands,
     /* 127480 */     // GIR_Coverage, 2570,
     /* 127480 */     GIR_EraseRootFromParent_Done,
     /* 127481 */   // Label 2417: @127481
     /* 127481 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(127523), // Rule ID 2571 //
     /* 127486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127496 */     // MIs[0] Rn
     /* 127496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127508 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 127511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127521 */     GIR_RootConstrainSelectedInstOperands,
     /* 127522 */     // GIR_Coverage, 2571,
     /* 127522 */     GIR_EraseRootFromParent_Done,
     /* 127523 */   // Label 2418: @127523
     /* 127523 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(127565), // Rule ID 2572 //
     /* 127528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127538 */     // MIs[0] Rn
     /* 127538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127550 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 127553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127563 */     GIR_RootConstrainSelectedInstOperands,
     /* 127564 */     // GIR_Coverage, 2572,
     /* 127564 */     GIR_EraseRootFromParent_Done,
     /* 127565 */   // Label 2419: @127565
     /* 127565 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(127607), // Rule ID 2573 //
     /* 127570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127573 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127580 */     // MIs[0] Rn
     /* 127580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127592 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 127595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127605 */     GIR_RootConstrainSelectedInstOperands,
     /* 127606 */     // GIR_Coverage, 2573,
     /* 127606 */     GIR_EraseRootFromParent_Done,
     /* 127607 */   // Label 2420: @127607
     /* 127607 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(127649), // Rule ID 2574 //
     /* 127612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127622 */     // MIs[0] Rn
     /* 127622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127634 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 127637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127647 */     GIR_RootConstrainSelectedInstOperands,
     /* 127648 */     // GIR_Coverage, 2574,
     /* 127648 */     GIR_EraseRootFromParent_Done,
     /* 127649 */   // Label 2421: @127649
     /* 127649 */   GIM_Reject,
     /* 127650 */ // Label 2416: @127650
     /* 127650 */ GIM_Reject,
     /* 127651 */ // Label 2399: @127651
     /* 127651 */ GIM_Reject,
     /* 127652 */ // Label 23: @127652
     /* 127652 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2424*/ GIMT_Encode4(129143),
     /* 127663 */ /*GILLT_s32*//*Label 2422*/ GIMT_Encode4(127671),
     /* 127667 */ /*GILLT_s64*//*Label 2423*/ GIMT_Encode4(128791),
     /* 127671 */ // Label 2422: @127671
     /* 127671 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(128790),
     /* 127676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 127679 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(127753), // Rule ID 7279 //
     /* 127684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127701 */     // MIs[0] Rn
     /* 127701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127713 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 127720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127725 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 127740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127751 */     GIR_RootConstrainSelectedInstOperands,
     /* 127752 */     // GIR_Coverage, 7279,
     /* 127752 */     GIR_EraseRootFromParent_Done,
     /* 127753 */   // Label 2426: @127753
     /* 127753 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(127827), // Rule ID 7280 //
     /* 127758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127761 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127768 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127775 */     // MIs[0] Rn
     /* 127775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127787 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 127794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127799 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 127814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127825 */     GIR_RootConstrainSelectedInstOperands,
     /* 127826 */     // GIR_Coverage, 7280,
     /* 127826 */     GIR_EraseRootFromParent_Done,
     /* 127827 */   // Label 2427: @127827
     /* 127827 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(127901), // Rule ID 7281 //
     /* 127832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127849 */     // MIs[0] Rn
     /* 127849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127861 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 127868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127873 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127879 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 127888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127899 */     GIR_RootConstrainSelectedInstOperands,
     /* 127900 */     // GIR_Coverage, 7281,
     /* 127900 */     GIR_EraseRootFromParent_Done,
     /* 127901 */   // Label 2428: @127901
     /* 127901 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(127975), // Rule ID 7282 //
     /* 127906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127909 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127916 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127923 */     // MIs[0] Rn
     /* 127923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127935 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 127935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 127942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127947 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127953 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 127957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 127962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127973 */     GIR_RootConstrainSelectedInstOperands,
     /* 127974 */     // GIR_Coverage, 7282,
     /* 127974 */     GIR_EraseRootFromParent_Done,
     /* 127975 */   // Label 2429: @127975
     /* 127975 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(128049), // Rule ID 7283 //
     /* 127980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127983 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127990 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127997 */     // MIs[0] Rn
     /* 127997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128009 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128021 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128027 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128047 */     GIR_RootConstrainSelectedInstOperands,
     /* 128048 */     // GIR_Coverage, 7283,
     /* 128048 */     GIR_EraseRootFromParent_Done,
     /* 128049 */   // Label 2430: @128049
     /* 128049 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(128123), // Rule ID 7284 //
     /* 128054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128057 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128064 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128071 */     // MIs[0] Rn
     /* 128071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128083 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128095 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 128110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128121 */     GIR_RootConstrainSelectedInstOperands,
     /* 128122 */     // GIR_Coverage, 7284,
     /* 128122 */     GIR_EraseRootFromParent_Done,
     /* 128123 */   // Label 2431: @128123
     /* 128123 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(128197), // Rule ID 7285 //
     /* 128128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128131 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128138 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128145 */     // MIs[0] Rn
     /* 128145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128157 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128169 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128175 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 128184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128195 */     GIR_RootConstrainSelectedInstOperands,
     /* 128196 */     // GIR_Coverage, 7285,
     /* 128196 */     GIR_EraseRootFromParent_Done,
     /* 128197 */   // Label 2432: @128197
     /* 128197 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(128271), // Rule ID 7286 //
     /* 128202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128205 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128219 */     // MIs[0] Rn
     /* 128219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128231 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128243 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 128258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128269 */     GIR_RootConstrainSelectedInstOperands,
     /* 128270 */     // GIR_Coverage, 7286,
     /* 128270 */     GIR_EraseRootFromParent_Done,
     /* 128271 */   // Label 2433: @128271
     /* 128271 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(128345), // Rule ID 7287 //
     /* 128276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128279 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128286 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128293 */     // MIs[0] Rn
     /* 128293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128305 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128317 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128323 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 128332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128343 */     GIR_RootConstrainSelectedInstOperands,
     /* 128344 */     // GIR_Coverage, 7287,
     /* 128344 */     GIR_EraseRootFromParent_Done,
     /* 128345 */   // Label 2434: @128345
     /* 128345 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(128419), // Rule ID 7288 //
     /* 128350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128353 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128360 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128367 */     // MIs[0] Rn
     /* 128367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128379 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128391 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128397 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 128406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128417 */     GIR_RootConstrainSelectedInstOperands,
     /* 128418 */     // GIR_Coverage, 7288,
     /* 128418 */     GIR_EraseRootFromParent_Done,
     /* 128419 */   // Label 2435: @128419
     /* 128419 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(128493), // Rule ID 7289 //
     /* 128424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128434 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128441 */     // MIs[0] Rn
     /* 128441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128453 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128465 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128471 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 128480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128491 */     GIR_RootConstrainSelectedInstOperands,
     /* 128492 */     // GIR_Coverage, 7289,
     /* 128492 */     GIR_EraseRootFromParent_Done,
     /* 128493 */   // Label 2436: @128493
     /* 128493 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(128567), // Rule ID 7290 //
     /* 128498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128501 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128508 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128515 */     // MIs[0] Rn
     /* 128515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128527 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128539 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128545 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 128554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128565 */     GIR_RootConstrainSelectedInstOperands,
     /* 128566 */     // GIR_Coverage, 7290,
     /* 128566 */     GIR_EraseRootFromParent_Done,
     /* 128567 */   // Label 2437: @128567
     /* 128567 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(128641), // Rule ID 7291 //
     /* 128572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128575 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128589 */     // MIs[0] Rn
     /* 128589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128601 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128613 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128619 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 128628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128639 */     GIR_RootConstrainSelectedInstOperands,
     /* 128640 */     // GIR_Coverage, 7291,
     /* 128640 */     GIR_EraseRootFromParent_Done,
     /* 128641 */   // Label 2438: @128641
     /* 128641 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(128715), // Rule ID 7292 //
     /* 128646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128649 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128656 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128663 */     // MIs[0] Rn
     /* 128663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128675 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128687 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 128702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128713 */     GIR_RootConstrainSelectedInstOperands,
     /* 128714 */     // GIR_Coverage, 7292,
     /* 128714 */     GIR_EraseRootFromParent_Done,
     /* 128715 */   // Label 2439: @128715
     /* 128715 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(128789), // Rule ID 7293 //
     /* 128720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128723 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128730 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128737 */     // MIs[0] Rn
     /* 128737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128749 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128761 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128767 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 128776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128787 */     GIR_RootConstrainSelectedInstOperands,
     /* 128788 */     // GIR_Coverage, 7293,
     /* 128788 */     GIR_EraseRootFromParent_Done,
     /* 128789 */   // Label 2440: @128789
     /* 128789 */   GIM_Reject,
     /* 128790 */ // Label 2425: @128790
     /* 128790 */ GIM_Reject,
     /* 128791 */ // Label 2423: @128791
     /* 128791 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(129142),
     /* 128796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 128799 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 128806 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(128873), // Rule ID 7274 //
     /* 128811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128814 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128821 */     // MIs[0] Rn
     /* 128821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128833 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 128836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 128840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128845 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128851 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 128860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128871 */     GIR_RootConstrainSelectedInstOperands,
     /* 128872 */     // GIR_Coverage, 7274,
     /* 128872 */     GIR_EraseRootFromParent_Done,
     /* 128873 */   // Label 2442: @128873
     /* 128873 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(128940), // Rule ID 7275 //
     /* 128878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128881 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128888 */     // MIs[0] Rn
     /* 128888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128900 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 128903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 128907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128912 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 128927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128938 */     GIR_RootConstrainSelectedInstOperands,
     /* 128939 */     // GIR_Coverage, 7275,
     /* 128939 */     GIR_EraseRootFromParent_Done,
     /* 128940 */   // Label 2443: @128940
     /* 128940 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(129007), // Rule ID 7276 //
     /* 128945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128948 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128955 */     // MIs[0] Rn
     /* 128955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128967 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 128970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 128974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128979 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 128994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129005 */     GIR_RootConstrainSelectedInstOperands,
     /* 129006 */     // GIR_Coverage, 7276,
     /* 129006 */     GIR_EraseRootFromParent_Done,
     /* 129007 */   // Label 2444: @129007
     /* 129007 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(129074), // Rule ID 7277 //
     /* 129012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129015 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129022 */     // MIs[0] Rn
     /* 129022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129034 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129046 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129052 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 129061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129066 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129072 */     GIR_RootConstrainSelectedInstOperands,
     /* 129073 */     // GIR_Coverage, 7277,
     /* 129073 */     GIR_EraseRootFromParent_Done,
     /* 129074 */   // Label 2445: @129074
     /* 129074 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(129141), // Rule ID 7278 //
     /* 129079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129082 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129089 */     // MIs[0] Rn
     /* 129089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129101 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129113 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129119 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 129128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129139 */     GIR_RootConstrainSelectedInstOperands,
     /* 129140 */     // GIR_Coverage, 7278,
     /* 129140 */     GIR_EraseRootFromParent_Done,
     /* 129141 */   // Label 2446: @129141
     /* 129141 */   GIM_Reject,
     /* 129142 */ // Label 2441: @129142
     /* 129142 */ GIM_Reject,
     /* 129143 */ // Label 2424: @129143
     /* 129143 */ GIM_Reject,
     /* 129144 */ // Label 24: @129144
     /* 129144 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2449*/ GIMT_Encode4(130635),
     /* 129155 */ /*GILLT_s32*//*Label 2447*/ GIMT_Encode4(129163),
     /* 129159 */ /*GILLT_s64*//*Label 2448*/ GIMT_Encode4(130283),
     /* 129163 */ // Label 2447: @129163
     /* 129163 */ GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(130282),
     /* 129168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 129171 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(129245), // Rule ID 7299 //
     /* 129176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129179 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129186 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129193 */     // MIs[0] Rn
     /* 129193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129205 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 129212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129217 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 129232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129243 */     GIR_RootConstrainSelectedInstOperands,
     /* 129244 */     // GIR_Coverage, 7299,
     /* 129244 */     GIR_EraseRootFromParent_Done,
     /* 129245 */   // Label 2451: @129245
     /* 129245 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(129319), // Rule ID 7300 //
     /* 129250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129267 */     // MIs[0] Rn
     /* 129267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129279 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 129286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129291 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129297 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 129306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129317 */     GIR_RootConstrainSelectedInstOperands,
     /* 129318 */     // GIR_Coverage, 7300,
     /* 129318 */     GIR_EraseRootFromParent_Done,
     /* 129319 */   // Label 2452: @129319
     /* 129319 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(129393), // Rule ID 7301 //
     /* 129324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129327 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129334 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129341 */     // MIs[0] Rn
     /* 129341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129353 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 129360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129365 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129371 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 129380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129391 */     GIR_RootConstrainSelectedInstOperands,
     /* 129392 */     // GIR_Coverage, 7301,
     /* 129392 */     GIR_EraseRootFromParent_Done,
     /* 129393 */   // Label 2453: @129393
     /* 129393 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(129467), // Rule ID 7302 //
     /* 129398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129415 */     // MIs[0] Rn
     /* 129415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129427 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 129434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129439 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129445 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 129454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129465 */     GIR_RootConstrainSelectedInstOperands,
     /* 129466 */     // GIR_Coverage, 7302,
     /* 129466 */     GIR_EraseRootFromParent_Done,
     /* 129467 */   // Label 2454: @129467
     /* 129467 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(129541), // Rule ID 7303 //
     /* 129472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129489 */     // MIs[0] Rn
     /* 129489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129501 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 129508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129513 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129519 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 129528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129539 */     GIR_RootConstrainSelectedInstOperands,
     /* 129540 */     // GIR_Coverage, 7303,
     /* 129540 */     GIR_EraseRootFromParent_Done,
     /* 129541 */   // Label 2455: @129541
     /* 129541 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(129615), // Rule ID 7304 //
     /* 129546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129549 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129556 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129563 */     // MIs[0] Rn
     /* 129563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129575 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 129582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129587 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 129602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129613 */     GIR_RootConstrainSelectedInstOperands,
     /* 129614 */     // GIR_Coverage, 7304,
     /* 129614 */     GIR_EraseRootFromParent_Done,
     /* 129615 */   // Label 2456: @129615
     /* 129615 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(129689), // Rule ID 7305 //
     /* 129620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129623 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129630 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129637 */     // MIs[0] Rn
     /* 129637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129649 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 129656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129661 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129667 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 129676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129687 */     GIR_RootConstrainSelectedInstOperands,
     /* 129688 */     // GIR_Coverage, 7305,
     /* 129688 */     GIR_EraseRootFromParent_Done,
     /* 129689 */   // Label 2457: @129689
     /* 129689 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(129763), // Rule ID 7306 //
     /* 129694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129697 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129704 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129711 */     // MIs[0] Rn
     /* 129711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129723 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 129730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129735 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 129750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129761 */     GIR_RootConstrainSelectedInstOperands,
     /* 129762 */     // GIR_Coverage, 7306,
     /* 129762 */     GIR_EraseRootFromParent_Done,
     /* 129763 */   // Label 2458: @129763
     /* 129763 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(129837), // Rule ID 7307 //
     /* 129768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129771 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129778 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129785 */     // MIs[0] Rn
     /* 129785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129797 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 129804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129809 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129815 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 129824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129835 */     GIR_RootConstrainSelectedInstOperands,
     /* 129836 */     // GIR_Coverage, 7307,
     /* 129836 */     GIR_EraseRootFromParent_Done,
     /* 129837 */   // Label 2459: @129837
     /* 129837 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(129911), // Rule ID 7308 //
     /* 129842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129845 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129852 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129859 */     // MIs[0] Rn
     /* 129859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129871 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 129878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129883 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129889 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 129898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129909 */     GIR_RootConstrainSelectedInstOperands,
     /* 129910 */     // GIR_Coverage, 7308,
     /* 129910 */     GIR_EraseRootFromParent_Done,
     /* 129911 */   // Label 2460: @129911
     /* 129911 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(129985), // Rule ID 7309 //
     /* 129916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129919 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129926 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129933 */     // MIs[0] Rn
     /* 129933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129945 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 129952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129957 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129963 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 129972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129983 */     GIR_RootConstrainSelectedInstOperands,
     /* 129984 */     // GIR_Coverage, 7309,
     /* 129984 */     GIR_EraseRootFromParent_Done,
     /* 129985 */   // Label 2461: @129985
     /* 129985 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(130059), // Rule ID 7310 //
     /* 129990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129993 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130000 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130007 */     // MIs[0] Rn
     /* 130007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130019 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130031 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130037 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 130046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130057 */     GIR_RootConstrainSelectedInstOperands,
     /* 130058 */     // GIR_Coverage, 7310,
     /* 130058 */     GIR_EraseRootFromParent_Done,
     /* 130059 */   // Label 2462: @130059
     /* 130059 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(130133), // Rule ID 7311 //
     /* 130064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130081 */     // MIs[0] Rn
     /* 130081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130093 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130105 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 130120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130131 */     GIR_RootConstrainSelectedInstOperands,
     /* 130132 */     // GIR_Coverage, 7311,
     /* 130132 */     GIR_EraseRootFromParent_Done,
     /* 130133 */   // Label 2463: @130133
     /* 130133 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(130207), // Rule ID 7312 //
     /* 130138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130141 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130148 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130155 */     // MIs[0] Rn
     /* 130155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130167 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130179 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 130194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130205 */     GIR_RootConstrainSelectedInstOperands,
     /* 130206 */     // GIR_Coverage, 7312,
     /* 130206 */     GIR_EraseRootFromParent_Done,
     /* 130207 */   // Label 2464: @130207
     /* 130207 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(130281), // Rule ID 7313 //
     /* 130212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130229 */     // MIs[0] Rn
     /* 130229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130241 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130253 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130259 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 130268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130279 */     GIR_RootConstrainSelectedInstOperands,
     /* 130280 */     // GIR_Coverage, 7313,
     /* 130280 */     GIR_EraseRootFromParent_Done,
     /* 130281 */   // Label 2465: @130281
     /* 130281 */   GIM_Reject,
     /* 130282 */ // Label 2450: @130282
     /* 130282 */ GIM_Reject,
     /* 130283 */ // Label 2448: @130283
     /* 130283 */ GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(130634),
     /* 130288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 130291 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 130298 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(130365), // Rule ID 7294 //
     /* 130303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130313 */     // MIs[0] Rn
     /* 130313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130325 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 130332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130337 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 130352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130363 */     GIR_RootConstrainSelectedInstOperands,
     /* 130364 */     // GIR_Coverage, 7294,
     /* 130364 */     GIR_EraseRootFromParent_Done,
     /* 130365 */   // Label 2467: @130365
     /* 130365 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(130432), // Rule ID 7295 //
     /* 130370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130373 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130380 */     // MIs[0] Rn
     /* 130380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130392 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 130399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130404 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 130419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130430 */     GIR_RootConstrainSelectedInstOperands,
     /* 130431 */     // GIR_Coverage, 7295,
     /* 130431 */     GIR_EraseRootFromParent_Done,
     /* 130432 */   // Label 2468: @130432
     /* 130432 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(130499), // Rule ID 7296 //
     /* 130437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130440 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130447 */     // MIs[0] Rn
     /* 130447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130459 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 130466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130471 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 130486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130497 */     GIR_RootConstrainSelectedInstOperands,
     /* 130498 */     // GIR_Coverage, 7296,
     /* 130498 */     GIR_EraseRootFromParent_Done,
     /* 130499 */   // Label 2469: @130499
     /* 130499 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(130566), // Rule ID 7297 //
     /* 130504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130514 */     // MIs[0] Rn
     /* 130514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130526 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 130533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130538 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 130553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130564 */     GIR_RootConstrainSelectedInstOperands,
     /* 130565 */     // GIR_Coverage, 7297,
     /* 130565 */     GIR_EraseRootFromParent_Done,
     /* 130566 */   // Label 2470: @130566
     /* 130566 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(130633), // Rule ID 7298 //
     /* 130571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130581 */     // MIs[0] Rn
     /* 130581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130593 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 130600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130605 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130611 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 130620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130631 */     GIR_RootConstrainSelectedInstOperands,
     /* 130632 */     // GIR_Coverage, 7298,
     /* 130632 */     GIR_EraseRootFromParent_Done,
     /* 130633 */   // Label 2471: @130633
     /* 130633 */   GIM_Reject,
     /* 130634 */ // Label 2466: @130634
     /* 130634 */ GIM_Reject,
     /* 130635 */ // Label 2449: @130635
     /* 130635 */ GIM_Reject,
     /* 130636 */ // Label 25: @130636
     /* 130636 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2474*/ GIMT_Encode4(131627),
     /* 130647 */ /*GILLT_s32*//*Label 2472*/ GIMT_Encode4(130655),
     /* 130651 */ /*GILLT_s64*//*Label 2473*/ GIMT_Encode4(131400),
     /* 130655 */ // Label 2472: @130655
     /* 130655 */ GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(131399),
     /* 130660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 130663 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(130712), // Rule ID 7104 //
     /* 130668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130685 */     // MIs[0] Rn
     /* 130685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130697 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 130700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130710 */     GIR_RootConstrainSelectedInstOperands,
     /* 130711 */     // GIR_Coverage, 7104,
     /* 130711 */     GIR_EraseRootFromParent_Done,
     /* 130712 */   // Label 2476: @130712
     /* 130712 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(130761), // Rule ID 7105 //
     /* 130717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130734 */     // MIs[0] Rn
     /* 130734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130746 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 130749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130759 */     GIR_RootConstrainSelectedInstOperands,
     /* 130760 */     // GIR_Coverage, 7105,
     /* 130760 */     GIR_EraseRootFromParent_Done,
     /* 130761 */   // Label 2477: @130761
     /* 130761 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(130810), // Rule ID 7106 //
     /* 130766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130769 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130776 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130783 */     // MIs[0] Rn
     /* 130783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130795 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 130798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130808 */     GIR_RootConstrainSelectedInstOperands,
     /* 130809 */     // GIR_Coverage, 7106,
     /* 130809 */     GIR_EraseRootFromParent_Done,
     /* 130810 */   // Label 2478: @130810
     /* 130810 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(130859), // Rule ID 7107 //
     /* 130815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130818 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130825 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130832 */     // MIs[0] Rn
     /* 130832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130844 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 130847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130857 */     GIR_RootConstrainSelectedInstOperands,
     /* 130858 */     // GIR_Coverage, 7107,
     /* 130858 */     GIR_EraseRootFromParent_Done,
     /* 130859 */   // Label 2479: @130859
     /* 130859 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(130908), // Rule ID 7108 //
     /* 130864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130867 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130874 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130881 */     // MIs[0] Rn
     /* 130881 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130893 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 130896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130906 */     GIR_RootConstrainSelectedInstOperands,
     /* 130907 */     // GIR_Coverage, 7108,
     /* 130907 */     GIR_EraseRootFromParent_Done,
     /* 130908 */   // Label 2480: @130908
     /* 130908 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(130957), // Rule ID 7109 //
     /* 130913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130916 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130923 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130930 */     // MIs[0] Rn
     /* 130930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130942 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 130945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130955 */     GIR_RootConstrainSelectedInstOperands,
     /* 130956 */     // GIR_Coverage, 7109,
     /* 130956 */     GIR_EraseRootFromParent_Done,
     /* 130957 */   // Label 2481: @130957
     /* 130957 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(131006), // Rule ID 7110 //
     /* 130962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130965 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130972 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130979 */     // MIs[0] Rn
     /* 130979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130991 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 130991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 130994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 130998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131004 */     GIR_RootConstrainSelectedInstOperands,
     /* 131005 */     // GIR_Coverage, 7110,
     /* 131005 */     GIR_EraseRootFromParent_Done,
     /* 131006 */   // Label 2482: @131006
     /* 131006 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(131055), // Rule ID 7111 //
     /* 131011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131014 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131021 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131028 */     // MIs[0] Rn
     /* 131028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131040 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 131043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131047 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131053 */     GIR_RootConstrainSelectedInstOperands,
     /* 131054 */     // GIR_Coverage, 7111,
     /* 131054 */     GIR_EraseRootFromParent_Done,
     /* 131055 */   // Label 2483: @131055
     /* 131055 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(131104), // Rule ID 7112 //
     /* 131060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131063 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131077 */     // MIs[0] Rn
     /* 131077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131089 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 131092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131102 */     GIR_RootConstrainSelectedInstOperands,
     /* 131103 */     // GIR_Coverage, 7112,
     /* 131103 */     GIR_EraseRootFromParent_Done,
     /* 131104 */   // Label 2484: @131104
     /* 131104 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(131153), // Rule ID 7113 //
     /* 131109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131112 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131119 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131126 */     // MIs[0] Rn
     /* 131126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131138 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 131141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131151 */     GIR_RootConstrainSelectedInstOperands,
     /* 131152 */     // GIR_Coverage, 7113,
     /* 131152 */     GIR_EraseRootFromParent_Done,
     /* 131153 */   // Label 2485: @131153
     /* 131153 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(131202), // Rule ID 7114 //
     /* 131158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131161 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131175 */     // MIs[0] Rn
     /* 131175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131187 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 131190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131200 */     GIR_RootConstrainSelectedInstOperands,
     /* 131201 */     // GIR_Coverage, 7114,
     /* 131201 */     GIR_EraseRootFromParent_Done,
     /* 131202 */   // Label 2486: @131202
     /* 131202 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(131251), // Rule ID 7115 //
     /* 131207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131210 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131217 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131224 */     // MIs[0] Rn
     /* 131224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131236 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 131239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131249 */     GIR_RootConstrainSelectedInstOperands,
     /* 131250 */     // GIR_Coverage, 7115,
     /* 131250 */     GIR_EraseRootFromParent_Done,
     /* 131251 */   // Label 2487: @131251
     /* 131251 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(131300), // Rule ID 7116 //
     /* 131256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131259 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131266 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131273 */     // MIs[0] Rn
     /* 131273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131285 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 131288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131298 */     GIR_RootConstrainSelectedInstOperands,
     /* 131299 */     // GIR_Coverage, 7116,
     /* 131299 */     GIR_EraseRootFromParent_Done,
     /* 131300 */   // Label 2488: @131300
     /* 131300 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(131349), // Rule ID 7117 //
     /* 131305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131308 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131315 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131322 */     // MIs[0] Rn
     /* 131322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131334 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 131337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131341 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131347 */     GIR_RootConstrainSelectedInstOperands,
     /* 131348 */     // GIR_Coverage, 7117,
     /* 131348 */     GIR_EraseRootFromParent_Done,
     /* 131349 */   // Label 2489: @131349
     /* 131349 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(131398), // Rule ID 7118 //
     /* 131354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131357 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131364 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131371 */     // MIs[0] Rn
     /* 131371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131383 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 131386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131396 */     GIR_RootConstrainSelectedInstOperands,
     /* 131397 */     // GIR_Coverage, 7118,
     /* 131397 */     GIR_EraseRootFromParent_Done,
     /* 131398 */   // Label 2490: @131398
     /* 131398 */   GIM_Reject,
     /* 131399 */ // Label 2475: @131399
     /* 131399 */ GIM_Reject,
     /* 131400 */ // Label 2473: @131400
     /* 131400 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(131626),
     /* 131405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 131408 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 131415 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(131457), // Rule ID 7099 //
     /* 131420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131423 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131430 */     // MIs[0] Rn
     /* 131430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131442 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 131445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131455 */     GIR_RootConstrainSelectedInstOperands,
     /* 131456 */     // GIR_Coverage, 7099,
     /* 131456 */     GIR_EraseRootFromParent_Done,
     /* 131457 */   // Label 2492: @131457
     /* 131457 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(131499), // Rule ID 7100 //
     /* 131462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131472 */     // MIs[0] Rn
     /* 131472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131484 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 131487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131497 */     GIR_RootConstrainSelectedInstOperands,
     /* 131498 */     // GIR_Coverage, 7100,
     /* 131498 */     GIR_EraseRootFromParent_Done,
     /* 131499 */   // Label 2493: @131499
     /* 131499 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(131541), // Rule ID 7101 //
     /* 131504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131514 */     // MIs[0] Rn
     /* 131514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131526 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 131529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131539 */     GIR_RootConstrainSelectedInstOperands,
     /* 131540 */     // GIR_Coverage, 7101,
     /* 131540 */     GIR_EraseRootFromParent_Done,
     /* 131541 */   // Label 2494: @131541
     /* 131541 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(131583), // Rule ID 7102 //
     /* 131546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131549 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131556 */     // MIs[0] Rn
     /* 131556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131568 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 131571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131581 */     GIR_RootConstrainSelectedInstOperands,
     /* 131582 */     // GIR_Coverage, 7102,
     /* 131582 */     GIR_EraseRootFromParent_Done,
     /* 131583 */   // Label 2495: @131583
     /* 131583 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(131625), // Rule ID 7103 //
     /* 131588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131591 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131598 */     // MIs[0] Rn
     /* 131598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131610 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 131613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131623 */     GIR_RootConstrainSelectedInstOperands,
     /* 131624 */     // GIR_Coverage, 7103,
     /* 131624 */     GIR_EraseRootFromParent_Done,
     /* 131625 */   // Label 2496: @131625
     /* 131625 */   GIM_Reject,
     /* 131626 */ // Label 2491: @131626
     /* 131626 */ GIM_Reject,
     /* 131627 */ // Label 2474: @131627
     /* 131627 */ GIM_Reject,
     /* 131628 */ // Label 26: @131628
     /* 131628 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2499*/ GIMT_Encode4(132619),
     /* 131639 */ /*GILLT_s32*//*Label 2497*/ GIMT_Encode4(131647),
     /* 131643 */ /*GILLT_s64*//*Label 2498*/ GIMT_Encode4(132392),
     /* 131647 */ // Label 2497: @131647
     /* 131647 */ GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(132391),
     /* 131652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 131655 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(131704), // Rule ID 7124 //
     /* 131660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131677 */     // MIs[0] Rn
     /* 131677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131689 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 131692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131702 */     GIR_RootConstrainSelectedInstOperands,
     /* 131703 */     // GIR_Coverage, 7124,
     /* 131703 */     GIR_EraseRootFromParent_Done,
     /* 131704 */   // Label 2501: @131704
     /* 131704 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(131753), // Rule ID 7125 //
     /* 131709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131726 */     // MIs[0] Rn
     /* 131726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131738 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 131741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131751 */     GIR_RootConstrainSelectedInstOperands,
     /* 131752 */     // GIR_Coverage, 7125,
     /* 131752 */     GIR_EraseRootFromParent_Done,
     /* 131753 */   // Label 2502: @131753
     /* 131753 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(131802), // Rule ID 7126 //
     /* 131758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131761 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131768 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131775 */     // MIs[0] Rn
     /* 131775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131787 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 131790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131800 */     GIR_RootConstrainSelectedInstOperands,
     /* 131801 */     // GIR_Coverage, 7126,
     /* 131801 */     GIR_EraseRootFromParent_Done,
     /* 131802 */   // Label 2503: @131802
     /* 131802 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(131851), // Rule ID 7127 //
     /* 131807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131817 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131824 */     // MIs[0] Rn
     /* 131824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131836 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 131839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131849 */     GIR_RootConstrainSelectedInstOperands,
     /* 131850 */     // GIR_Coverage, 7127,
     /* 131850 */     GIR_EraseRootFromParent_Done,
     /* 131851 */   // Label 2504: @131851
     /* 131851 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(131900), // Rule ID 7128 //
     /* 131856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131859 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131866 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131873 */     // MIs[0] Rn
     /* 131873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131885 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 131888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131892 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131898 */     GIR_RootConstrainSelectedInstOperands,
     /* 131899 */     // GIR_Coverage, 7128,
     /* 131899 */     GIR_EraseRootFromParent_Done,
     /* 131900 */   // Label 2505: @131900
     /* 131900 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(131949), // Rule ID 7129 //
     /* 131905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131908 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131922 */     // MIs[0] Rn
     /* 131922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131934 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 131937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131947 */     GIR_RootConstrainSelectedInstOperands,
     /* 131948 */     // GIR_Coverage, 7129,
     /* 131948 */     GIR_EraseRootFromParent_Done,
     /* 131949 */   // Label 2506: @131949
     /* 131949 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(131998), // Rule ID 7130 //
     /* 131954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131957 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131964 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131971 */     // MIs[0] Rn
     /* 131971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131983 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 131986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131996 */     GIR_RootConstrainSelectedInstOperands,
     /* 131997 */     // GIR_Coverage, 7130,
     /* 131997 */     GIR_EraseRootFromParent_Done,
     /* 131998 */   // Label 2507: @131998
     /* 131998 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(132047), // Rule ID 7131 //
     /* 132003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132006 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132013 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132020 */     // MIs[0] Rn
     /* 132020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132032 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 132035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132045 */     GIR_RootConstrainSelectedInstOperands,
     /* 132046 */     // GIR_Coverage, 7131,
     /* 132046 */     GIR_EraseRootFromParent_Done,
     /* 132047 */   // Label 2508: @132047
     /* 132047 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(132096), // Rule ID 7132 //
     /* 132052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132055 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132062 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132069 */     // MIs[0] Rn
     /* 132069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132081 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 132084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132094 */     GIR_RootConstrainSelectedInstOperands,
     /* 132095 */     // GIR_Coverage, 7132,
     /* 132095 */     GIR_EraseRootFromParent_Done,
     /* 132096 */   // Label 2509: @132096
     /* 132096 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(132145), // Rule ID 7133 //
     /* 132101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132104 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132111 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132118 */     // MIs[0] Rn
     /* 132118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132130 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 132133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132143 */     GIR_RootConstrainSelectedInstOperands,
     /* 132144 */     // GIR_Coverage, 7133,
     /* 132144 */     GIR_EraseRootFromParent_Done,
     /* 132145 */   // Label 2510: @132145
     /* 132145 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(132194), // Rule ID 7134 //
     /* 132150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132153 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132160 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132167 */     // MIs[0] Rn
     /* 132167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132179 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 132182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132192 */     GIR_RootConstrainSelectedInstOperands,
     /* 132193 */     // GIR_Coverage, 7134,
     /* 132193 */     GIR_EraseRootFromParent_Done,
     /* 132194 */   // Label 2511: @132194
     /* 132194 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(132243), // Rule ID 7135 //
     /* 132199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132202 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132209 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132216 */     // MIs[0] Rn
     /* 132216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132228 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 132231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132235 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132241 */     GIR_RootConstrainSelectedInstOperands,
     /* 132242 */     // GIR_Coverage, 7135,
     /* 132242 */     GIR_EraseRootFromParent_Done,
     /* 132243 */   // Label 2512: @132243
     /* 132243 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(132292), // Rule ID 7136 //
     /* 132248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132251 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132258 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132265 */     // MIs[0] Rn
     /* 132265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132277 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 132280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132290 */     GIR_RootConstrainSelectedInstOperands,
     /* 132291 */     // GIR_Coverage, 7136,
     /* 132291 */     GIR_EraseRootFromParent_Done,
     /* 132292 */   // Label 2513: @132292
     /* 132292 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(132341), // Rule ID 7137 //
     /* 132297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132300 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132307 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132314 */     // MIs[0] Rn
     /* 132314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132326 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 132329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132339 */     GIR_RootConstrainSelectedInstOperands,
     /* 132340 */     // GIR_Coverage, 7137,
     /* 132340 */     GIR_EraseRootFromParent_Done,
     /* 132341 */   // Label 2514: @132341
     /* 132341 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(132390), // Rule ID 7138 //
     /* 132346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132349 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132356 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132363 */     // MIs[0] Rn
     /* 132363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132375 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 132378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132388 */     GIR_RootConstrainSelectedInstOperands,
     /* 132389 */     // GIR_Coverage, 7138,
     /* 132389 */     GIR_EraseRootFromParent_Done,
     /* 132390 */   // Label 2515: @132390
     /* 132390 */   GIM_Reject,
     /* 132391 */ // Label 2500: @132391
     /* 132391 */ GIM_Reject,
     /* 132392 */ // Label 2498: @132392
     /* 132392 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(132618),
     /* 132397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 132400 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 132407 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(132449), // Rule ID 7119 //
     /* 132412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132415 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132422 */     // MIs[0] Rn
     /* 132422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132434 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 132437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132447 */     GIR_RootConstrainSelectedInstOperands,
     /* 132448 */     // GIR_Coverage, 7119,
     /* 132448 */     GIR_EraseRootFromParent_Done,
     /* 132449 */   // Label 2517: @132449
     /* 132449 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(132491), // Rule ID 7120 //
     /* 132454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132464 */     // MIs[0] Rn
     /* 132464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132476 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 132479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132489 */     GIR_RootConstrainSelectedInstOperands,
     /* 132490 */     // GIR_Coverage, 7120,
     /* 132490 */     GIR_EraseRootFromParent_Done,
     /* 132491 */   // Label 2518: @132491
     /* 132491 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(132533), // Rule ID 7121 //
     /* 132496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132499 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132506 */     // MIs[0] Rn
     /* 132506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132518 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 132521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132531 */     GIR_RootConstrainSelectedInstOperands,
     /* 132532 */     // GIR_Coverage, 7121,
     /* 132532 */     GIR_EraseRootFromParent_Done,
     /* 132533 */   // Label 2519: @132533
     /* 132533 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(132575), // Rule ID 7122 //
     /* 132538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132548 */     // MIs[0] Rn
     /* 132548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132560 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 132563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132573 */     GIR_RootConstrainSelectedInstOperands,
     /* 132574 */     // GIR_Coverage, 7122,
     /* 132574 */     GIR_EraseRootFromParent_Done,
     /* 132575 */   // Label 2520: @132575
     /* 132575 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(132617), // Rule ID 7123 //
     /* 132580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132583 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132590 */     // MIs[0] Rn
     /* 132590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132602 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 132605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132615 */     GIR_RootConstrainSelectedInstOperands,
     /* 132616 */     // GIR_Coverage, 7123,
     /* 132616 */     GIR_EraseRootFromParent_Done,
     /* 132617 */   // Label 2521: @132617
     /* 132617 */   GIM_Reject,
     /* 132618 */ // Label 2516: @132618
     /* 132618 */ GIM_Reject,
     /* 132619 */ // Label 2499: @132619
     /* 132619 */ GIM_Reject,
     /* 132620 */ // Label 27: @132620
     /* 132620 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2524*/ GIMT_Encode4(133611),
     /* 132631 */ /*GILLT_s32*//*Label 2522*/ GIMT_Encode4(132639),
     /* 132635 */ /*GILLT_s64*//*Label 2523*/ GIMT_Encode4(133384),
     /* 132639 */ // Label 2522: @132639
     /* 132639 */ GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(133383),
     /* 132644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 132647 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(132696), // Rule ID 7164 //
     /* 132652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132655 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132669 */     // MIs[0] Rn
     /* 132669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132681 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 132684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132688 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132694 */     GIR_RootConstrainSelectedInstOperands,
     /* 132695 */     // GIR_Coverage, 7164,
     /* 132695 */     GIR_EraseRootFromParent_Done,
     /* 132696 */   // Label 2526: @132696
     /* 132696 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(132745), // Rule ID 7165 //
     /* 132701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132704 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132711 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132718 */     // MIs[0] Rn
     /* 132718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132730 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 132733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132743 */     GIR_RootConstrainSelectedInstOperands,
     /* 132744 */     // GIR_Coverage, 7165,
     /* 132744 */     GIR_EraseRootFromParent_Done,
     /* 132745 */   // Label 2527: @132745
     /* 132745 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(132794), // Rule ID 7166 //
     /* 132750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132767 */     // MIs[0] Rn
     /* 132767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132779 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 132782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132792 */     GIR_RootConstrainSelectedInstOperands,
     /* 132793 */     // GIR_Coverage, 7166,
     /* 132793 */     GIR_EraseRootFromParent_Done,
     /* 132794 */   // Label 2528: @132794
     /* 132794 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(132843), // Rule ID 7167 //
     /* 132799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132802 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132809 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132816 */     // MIs[0] Rn
     /* 132816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132828 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 132831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132841 */     GIR_RootConstrainSelectedInstOperands,
     /* 132842 */     // GIR_Coverage, 7167,
     /* 132842 */     GIR_EraseRootFromParent_Done,
     /* 132843 */   // Label 2529: @132843
     /* 132843 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(132892), // Rule ID 7168 //
     /* 132848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132851 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132858 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132865 */     // MIs[0] Rn
     /* 132865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132877 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 132880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132890 */     GIR_RootConstrainSelectedInstOperands,
     /* 132891 */     // GIR_Coverage, 7168,
     /* 132891 */     GIR_EraseRootFromParent_Done,
     /* 132892 */   // Label 2530: @132892
     /* 132892 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(132941), // Rule ID 7169 //
     /* 132897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132900 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132907 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132914 */     // MIs[0] Rn
     /* 132914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132926 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 132929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132939 */     GIR_RootConstrainSelectedInstOperands,
     /* 132940 */     // GIR_Coverage, 7169,
     /* 132940 */     GIR_EraseRootFromParent_Done,
     /* 132941 */   // Label 2531: @132941
     /* 132941 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(132990), // Rule ID 7170 //
     /* 132946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132949 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132956 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132963 */     // MIs[0] Rn
     /* 132963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132975 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 132978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132988 */     GIR_RootConstrainSelectedInstOperands,
     /* 132989 */     // GIR_Coverage, 7170,
     /* 132989 */     GIR_EraseRootFromParent_Done,
     /* 132990 */   // Label 2532: @132990
     /* 132990 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(133039), // Rule ID 7171 //
     /* 132995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132998 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133005 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133012 */     // MIs[0] Rn
     /* 133012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133024 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 133027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133037 */     GIR_RootConstrainSelectedInstOperands,
     /* 133038 */     // GIR_Coverage, 7171,
     /* 133038 */     GIR_EraseRootFromParent_Done,
     /* 133039 */   // Label 2533: @133039
     /* 133039 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(133088), // Rule ID 7172 //
     /* 133044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133047 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133054 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133061 */     // MIs[0] Rn
     /* 133061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133073 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 133076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133080 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133086 */     GIR_RootConstrainSelectedInstOperands,
     /* 133087 */     // GIR_Coverage, 7172,
     /* 133087 */     GIR_EraseRootFromParent_Done,
     /* 133088 */   // Label 2534: @133088
     /* 133088 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(133137), // Rule ID 7173 //
     /* 133093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133096 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133103 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133110 */     // MIs[0] Rn
     /* 133110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133122 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 133125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133135 */     GIR_RootConstrainSelectedInstOperands,
     /* 133136 */     // GIR_Coverage, 7173,
     /* 133136 */     GIR_EraseRootFromParent_Done,
     /* 133137 */   // Label 2535: @133137
     /* 133137 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(133186), // Rule ID 7174 //
     /* 133142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133145 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133159 */     // MIs[0] Rn
     /* 133159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133171 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 133174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133184 */     GIR_RootConstrainSelectedInstOperands,
     /* 133185 */     // GIR_Coverage, 7174,
     /* 133185 */     GIR_EraseRootFromParent_Done,
     /* 133186 */   // Label 2536: @133186
     /* 133186 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(133235), // Rule ID 7175 //
     /* 133191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133194 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133201 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133208 */     // MIs[0] Rn
     /* 133208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133220 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 133223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133233 */     GIR_RootConstrainSelectedInstOperands,
     /* 133234 */     // GIR_Coverage, 7175,
     /* 133234 */     GIR_EraseRootFromParent_Done,
     /* 133235 */   // Label 2537: @133235
     /* 133235 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(133284), // Rule ID 7176 //
     /* 133240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133243 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133250 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133257 */     // MIs[0] Rn
     /* 133257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133269 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 133272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133282 */     GIR_RootConstrainSelectedInstOperands,
     /* 133283 */     // GIR_Coverage, 7176,
     /* 133283 */     GIR_EraseRootFromParent_Done,
     /* 133284 */   // Label 2538: @133284
     /* 133284 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(133333), // Rule ID 7177 //
     /* 133289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133292 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133299 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133306 */     // MIs[0] Rn
     /* 133306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133318 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 133321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133331 */     GIR_RootConstrainSelectedInstOperands,
     /* 133332 */     // GIR_Coverage, 7177,
     /* 133332 */     GIR_EraseRootFromParent_Done,
     /* 133333 */   // Label 2539: @133333
     /* 133333 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(133382), // Rule ID 7178 //
     /* 133338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133341 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133355 */     // MIs[0] Rn
     /* 133355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133367 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 133370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133380 */     GIR_RootConstrainSelectedInstOperands,
     /* 133381 */     // GIR_Coverage, 7178,
     /* 133381 */     GIR_EraseRootFromParent_Done,
     /* 133382 */   // Label 2540: @133382
     /* 133382 */   GIM_Reject,
     /* 133383 */ // Label 2525: @133383
     /* 133383 */ GIM_Reject,
     /* 133384 */ // Label 2523: @133384
     /* 133384 */ GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(133610),
     /* 133389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133392 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 133399 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(133441), // Rule ID 7159 //
     /* 133404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133414 */     // MIs[0] Rn
     /* 133414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133426 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 133429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133439 */     GIR_RootConstrainSelectedInstOperands,
     /* 133440 */     // GIR_Coverage, 7159,
     /* 133440 */     GIR_EraseRootFromParent_Done,
     /* 133441 */   // Label 2542: @133441
     /* 133441 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(133483), // Rule ID 7160 //
     /* 133446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133456 */     // MIs[0] Rn
     /* 133456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133468 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 133471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133481 */     GIR_RootConstrainSelectedInstOperands,
     /* 133482 */     // GIR_Coverage, 7160,
     /* 133482 */     GIR_EraseRootFromParent_Done,
     /* 133483 */   // Label 2543: @133483
     /* 133483 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(133525), // Rule ID 7161 //
     /* 133488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133491 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133498 */     // MIs[0] Rn
     /* 133498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133510 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 133513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133523 */     GIR_RootConstrainSelectedInstOperands,
     /* 133524 */     // GIR_Coverage, 7161,
     /* 133524 */     GIR_EraseRootFromParent_Done,
     /* 133525 */   // Label 2544: @133525
     /* 133525 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(133567), // Rule ID 7162 //
     /* 133530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133540 */     // MIs[0] Rn
     /* 133540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133552 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 133555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133565 */     GIR_RootConstrainSelectedInstOperands,
     /* 133566 */     // GIR_Coverage, 7162,
     /* 133566 */     GIR_EraseRootFromParent_Done,
     /* 133567 */   // Label 2545: @133567
     /* 133567 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(133609), // Rule ID 7163 //
     /* 133572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133575 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133582 */     // MIs[0] Rn
     /* 133582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133594 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 133597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133607 */     GIR_RootConstrainSelectedInstOperands,
     /* 133608 */     // GIR_Coverage, 7163,
     /* 133608 */     GIR_EraseRootFromParent_Done,
     /* 133609 */   // Label 2546: @133609
     /* 133609 */   GIM_Reject,
     /* 133610 */ // Label 2541: @133610
     /* 133610 */ GIM_Reject,
     /* 133611 */ // Label 2524: @133611
     /* 133611 */ GIM_Reject,
     /* 133612 */ // Label 28: @133612
     /* 133612 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2549*/ GIMT_Encode4(134603),
     /* 133623 */ /*GILLT_s32*//*Label 2547*/ GIMT_Encode4(133631),
     /* 133627 */ /*GILLT_s64*//*Label 2548*/ GIMT_Encode4(134376),
     /* 133631 */ // Label 2547: @133631
     /* 133631 */ GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(134375),
     /* 133636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 133639 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(133688), // Rule ID 7184 //
     /* 133644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133654 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133661 */     // MIs[0] Rn
     /* 133661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133673 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 133676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133680 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133686 */     GIR_RootConstrainSelectedInstOperands,
     /* 133687 */     // GIR_Coverage, 7184,
     /* 133687 */     GIR_EraseRootFromParent_Done,
     /* 133688 */   // Label 2551: @133688
     /* 133688 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(133737), // Rule ID 7185 //
     /* 133693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133696 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133703 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133710 */     // MIs[0] Rn
     /* 133710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133722 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 133725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133729 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133731 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133735 */     GIR_RootConstrainSelectedInstOperands,
     /* 133736 */     // GIR_Coverage, 7185,
     /* 133736 */     GIR_EraseRootFromParent_Done,
     /* 133737 */   // Label 2552: @133737
     /* 133737 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(133786), // Rule ID 7186 //
     /* 133742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133745 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133752 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133759 */     // MIs[0] Rn
     /* 133759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133771 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 133774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133784 */     GIR_RootConstrainSelectedInstOperands,
     /* 133785 */     // GIR_Coverage, 7186,
     /* 133785 */     GIR_EraseRootFromParent_Done,
     /* 133786 */   // Label 2553: @133786
     /* 133786 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(133835), // Rule ID 7187 //
     /* 133791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133794 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133801 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133808 */     // MIs[0] Rn
     /* 133808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133820 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 133823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133833 */     GIR_RootConstrainSelectedInstOperands,
     /* 133834 */     // GIR_Coverage, 7187,
     /* 133834 */     GIR_EraseRootFromParent_Done,
     /* 133835 */   // Label 2554: @133835
     /* 133835 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(133884), // Rule ID 7188 //
     /* 133840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133843 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133857 */     // MIs[0] Rn
     /* 133857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133869 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 133872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133882 */     GIR_RootConstrainSelectedInstOperands,
     /* 133883 */     // GIR_Coverage, 7188,
     /* 133883 */     GIR_EraseRootFromParent_Done,
     /* 133884 */   // Label 2555: @133884
     /* 133884 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(133933), // Rule ID 7189 //
     /* 133889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133892 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133906 */     // MIs[0] Rn
     /* 133906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133918 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 133921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133931 */     GIR_RootConstrainSelectedInstOperands,
     /* 133932 */     // GIR_Coverage, 7189,
     /* 133932 */     GIR_EraseRootFromParent_Done,
     /* 133933 */   // Label 2556: @133933
     /* 133933 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(133982), // Rule ID 7190 //
     /* 133938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133941 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133948 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133955 */     // MIs[0] Rn
     /* 133955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133967 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 133970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133980 */     GIR_RootConstrainSelectedInstOperands,
     /* 133981 */     // GIR_Coverage, 7190,
     /* 133981 */     GIR_EraseRootFromParent_Done,
     /* 133982 */   // Label 2557: @133982
     /* 133982 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(134031), // Rule ID 7191 //
     /* 133987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133990 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133997 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134004 */     // MIs[0] Rn
     /* 134004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134016 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 134019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134023 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134029 */     GIR_RootConstrainSelectedInstOperands,
     /* 134030 */     // GIR_Coverage, 7191,
     /* 134030 */     GIR_EraseRootFromParent_Done,
     /* 134031 */   // Label 2558: @134031
     /* 134031 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(134080), // Rule ID 7192 //
     /* 134036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134039 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134046 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134053 */     // MIs[0] Rn
     /* 134053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134065 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 134068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134078 */     GIR_RootConstrainSelectedInstOperands,
     /* 134079 */     // GIR_Coverage, 7192,
     /* 134079 */     GIR_EraseRootFromParent_Done,
     /* 134080 */   // Label 2559: @134080
     /* 134080 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(134129), // Rule ID 7193 //
     /* 134085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134088 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134102 */     // MIs[0] Rn
     /* 134102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134114 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 134117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134127 */     GIR_RootConstrainSelectedInstOperands,
     /* 134128 */     // GIR_Coverage, 7193,
     /* 134128 */     GIR_EraseRootFromParent_Done,
     /* 134129 */   // Label 2560: @134129
     /* 134129 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(134178), // Rule ID 7194 //
     /* 134134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134137 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134144 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134151 */     // MIs[0] Rn
     /* 134151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134163 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 134166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134176 */     GIR_RootConstrainSelectedInstOperands,
     /* 134177 */     // GIR_Coverage, 7194,
     /* 134177 */     GIR_EraseRootFromParent_Done,
     /* 134178 */   // Label 2561: @134178
     /* 134178 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(134227), // Rule ID 7195 //
     /* 134183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134186 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134193 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134200 */     // MIs[0] Rn
     /* 134200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134212 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 134215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134225 */     GIR_RootConstrainSelectedInstOperands,
     /* 134226 */     // GIR_Coverage, 7195,
     /* 134226 */     GIR_EraseRootFromParent_Done,
     /* 134227 */   // Label 2562: @134227
     /* 134227 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(134276), // Rule ID 7196 //
     /* 134232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134235 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134242 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134249 */     // MIs[0] Rn
     /* 134249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134261 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 134264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134274 */     GIR_RootConstrainSelectedInstOperands,
     /* 134275 */     // GIR_Coverage, 7196,
     /* 134275 */     GIR_EraseRootFromParent_Done,
     /* 134276 */   // Label 2563: @134276
     /* 134276 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(134325), // Rule ID 7197 //
     /* 134281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134284 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134291 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134298 */     // MIs[0] Rn
     /* 134298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134310 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 134313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134323 */     GIR_RootConstrainSelectedInstOperands,
     /* 134324 */     // GIR_Coverage, 7197,
     /* 134324 */     GIR_EraseRootFromParent_Done,
     /* 134325 */   // Label 2564: @134325
     /* 134325 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(134374), // Rule ID 7198 //
     /* 134330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134333 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134340 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134347 */     // MIs[0] Rn
     /* 134347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134359 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 134362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134372 */     GIR_RootConstrainSelectedInstOperands,
     /* 134373 */     // GIR_Coverage, 7198,
     /* 134373 */     GIR_EraseRootFromParent_Done,
     /* 134374 */   // Label 2565: @134374
     /* 134374 */   GIM_Reject,
     /* 134375 */ // Label 2550: @134375
     /* 134375 */ GIM_Reject,
     /* 134376 */ // Label 2548: @134376
     /* 134376 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(134602),
     /* 134381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134384 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 134391 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(134433), // Rule ID 7179 //
     /* 134396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134406 */     // MIs[0] Rn
     /* 134406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134418 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 134421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134431 */     GIR_RootConstrainSelectedInstOperands,
     /* 134432 */     // GIR_Coverage, 7179,
     /* 134432 */     GIR_EraseRootFromParent_Done,
     /* 134433 */   // Label 2567: @134433
     /* 134433 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(134475), // Rule ID 7180 //
     /* 134438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134448 */     // MIs[0] Rn
     /* 134448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134460 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 134463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134473 */     GIR_RootConstrainSelectedInstOperands,
     /* 134474 */     // GIR_Coverage, 7180,
     /* 134474 */     GIR_EraseRootFromParent_Done,
     /* 134475 */   // Label 2568: @134475
     /* 134475 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(134517), // Rule ID 7181 //
     /* 134480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134483 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134490 */     // MIs[0] Rn
     /* 134490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134502 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 134505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134515 */     GIR_RootConstrainSelectedInstOperands,
     /* 134516 */     // GIR_Coverage, 7181,
     /* 134516 */     GIR_EraseRootFromParent_Done,
     /* 134517 */   // Label 2569: @134517
     /* 134517 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(134559), // Rule ID 7182 //
     /* 134522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134532 */     // MIs[0] Rn
     /* 134532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134544 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 134547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134557 */     GIR_RootConstrainSelectedInstOperands,
     /* 134558 */     // GIR_Coverage, 7182,
     /* 134558 */     GIR_EraseRootFromParent_Done,
     /* 134559 */   // Label 2570: @134559
     /* 134559 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(134601), // Rule ID 7183 //
     /* 134564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134567 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134574 */     // MIs[0] Rn
     /* 134574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134586 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 134589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134599 */     GIR_RootConstrainSelectedInstOperands,
     /* 134600 */     // GIR_Coverage, 7183,
     /* 134600 */     GIR_EraseRootFromParent_Done,
     /* 134601 */   // Label 2571: @134601
     /* 134601 */   GIM_Reject,
     /* 134602 */ // Label 2566: @134602
     /* 134602 */ GIM_Reject,
     /* 134603 */ // Label 2549: @134603
     /* 134603 */ GIM_Reject,
     /* 134604 */ // Label 29: @134604
     /* 134604 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2574*/ GIMT_Encode4(135595),
     /* 134615 */ /*GILLT_s32*//*Label 2572*/ GIMT_Encode4(134623),
     /* 134619 */ /*GILLT_s64*//*Label 2573*/ GIMT_Encode4(135368),
     /* 134623 */ // Label 2572: @134623
     /* 134623 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(135367),
     /* 134628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134631 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(134680), // Rule ID 7204 //
     /* 134636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134639 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134653 */     // MIs[0] Rn
     /* 134653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134665 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 134668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134678 */     GIR_RootConstrainSelectedInstOperands,
     /* 134679 */     // GIR_Coverage, 7204,
     /* 134679 */     GIR_EraseRootFromParent_Done,
     /* 134680 */   // Label 2576: @134680
     /* 134680 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(134729), // Rule ID 7205 //
     /* 134685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134702 */     // MIs[0] Rn
     /* 134702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134714 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 134717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134727 */     GIR_RootConstrainSelectedInstOperands,
     /* 134728 */     // GIR_Coverage, 7205,
     /* 134728 */     GIR_EraseRootFromParent_Done,
     /* 134729 */   // Label 2577: @134729
     /* 134729 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(134778), // Rule ID 7206 //
     /* 134734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134751 */     // MIs[0] Rn
     /* 134751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134763 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 134766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134770 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134776 */     GIR_RootConstrainSelectedInstOperands,
     /* 134777 */     // GIR_Coverage, 7206,
     /* 134777 */     GIR_EraseRootFromParent_Done,
     /* 134778 */   // Label 2578: @134778
     /* 134778 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(134827), // Rule ID 7207 //
     /* 134783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134800 */     // MIs[0] Rn
     /* 134800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134812 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 134815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134825 */     GIR_RootConstrainSelectedInstOperands,
     /* 134826 */     // GIR_Coverage, 7207,
     /* 134826 */     GIR_EraseRootFromParent_Done,
     /* 134827 */   // Label 2579: @134827
     /* 134827 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(134876), // Rule ID 7208 //
     /* 134832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134849 */     // MIs[0] Rn
     /* 134849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134861 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 134864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134874 */     GIR_RootConstrainSelectedInstOperands,
     /* 134875 */     // GIR_Coverage, 7208,
     /* 134875 */     GIR_EraseRootFromParent_Done,
     /* 134876 */   // Label 2580: @134876
     /* 134876 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(134925), // Rule ID 7209 //
     /* 134881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134898 */     // MIs[0] Rn
     /* 134898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134910 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 134913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134923 */     GIR_RootConstrainSelectedInstOperands,
     /* 134924 */     // GIR_Coverage, 7209,
     /* 134924 */     GIR_EraseRootFromParent_Done,
     /* 134925 */   // Label 2581: @134925
     /* 134925 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(134974), // Rule ID 7210 //
     /* 134930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134940 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134947 */     // MIs[0] Rn
     /* 134947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134959 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 134962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134972 */     GIR_RootConstrainSelectedInstOperands,
     /* 134973 */     // GIR_Coverage, 7210,
     /* 134973 */     GIR_EraseRootFromParent_Done,
     /* 134974 */   // Label 2582: @134974
     /* 134974 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(135023), // Rule ID 7211 //
     /* 134979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134982 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134989 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134996 */     // MIs[0] Rn
     /* 134996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135008 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 135011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135015 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135021 */     GIR_RootConstrainSelectedInstOperands,
     /* 135022 */     // GIR_Coverage, 7211,
     /* 135022 */     GIR_EraseRootFromParent_Done,
     /* 135023 */   // Label 2583: @135023
     /* 135023 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(135072), // Rule ID 7212 //
     /* 135028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135031 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135038 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135045 */     // MIs[0] Rn
     /* 135045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135057 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 135060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135070 */     GIR_RootConstrainSelectedInstOperands,
     /* 135071 */     // GIR_Coverage, 7212,
     /* 135071 */     GIR_EraseRootFromParent_Done,
     /* 135072 */   // Label 2584: @135072
     /* 135072 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(135121), // Rule ID 7213 //
     /* 135077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135080 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135087 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135094 */     // MIs[0] Rn
     /* 135094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135106 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 135109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135119 */     GIR_RootConstrainSelectedInstOperands,
     /* 135120 */     // GIR_Coverage, 7213,
     /* 135120 */     GIR_EraseRootFromParent_Done,
     /* 135121 */   // Label 2585: @135121
     /* 135121 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(135170), // Rule ID 7214 //
     /* 135126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135129 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135136 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135143 */     // MIs[0] Rn
     /* 135143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135155 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 135158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135168 */     GIR_RootConstrainSelectedInstOperands,
     /* 135169 */     // GIR_Coverage, 7214,
     /* 135169 */     GIR_EraseRootFromParent_Done,
     /* 135170 */   // Label 2586: @135170
     /* 135170 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(135219), // Rule ID 7215 //
     /* 135175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135178 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135185 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135192 */     // MIs[0] Rn
     /* 135192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135204 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 135207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135217 */     GIR_RootConstrainSelectedInstOperands,
     /* 135218 */     // GIR_Coverage, 7215,
     /* 135218 */     GIR_EraseRootFromParent_Done,
     /* 135219 */   // Label 2587: @135219
     /* 135219 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(135268), // Rule ID 7216 //
     /* 135224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135227 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135234 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135241 */     // MIs[0] Rn
     /* 135241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135253 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 135256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135266 */     GIR_RootConstrainSelectedInstOperands,
     /* 135267 */     // GIR_Coverage, 7216,
     /* 135267 */     GIR_EraseRootFromParent_Done,
     /* 135268 */   // Label 2588: @135268
     /* 135268 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(135317), // Rule ID 7217 //
     /* 135273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135276 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135283 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135290 */     // MIs[0] Rn
     /* 135290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135302 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 135305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135315 */     GIR_RootConstrainSelectedInstOperands,
     /* 135316 */     // GIR_Coverage, 7217,
     /* 135316 */     GIR_EraseRootFromParent_Done,
     /* 135317 */   // Label 2589: @135317
     /* 135317 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(135366), // Rule ID 7218 //
     /* 135322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135325 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135332 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135339 */     // MIs[0] Rn
     /* 135339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135351 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 135354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135364 */     GIR_RootConstrainSelectedInstOperands,
     /* 135365 */     // GIR_Coverage, 7218,
     /* 135365 */     GIR_EraseRootFromParent_Done,
     /* 135366 */   // Label 2590: @135366
     /* 135366 */   GIM_Reject,
     /* 135367 */ // Label 2575: @135367
     /* 135367 */ GIM_Reject,
     /* 135368 */ // Label 2573: @135368
     /* 135368 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(135594),
     /* 135373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135376 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 135383 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(135425), // Rule ID 7199 //
     /* 135388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135391 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135398 */     // MIs[0] Rn
     /* 135398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135410 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 135413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135423 */     GIR_RootConstrainSelectedInstOperands,
     /* 135424 */     // GIR_Coverage, 7199,
     /* 135424 */     GIR_EraseRootFromParent_Done,
     /* 135425 */   // Label 2592: @135425
     /* 135425 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(135467), // Rule ID 7200 //
     /* 135430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135440 */     // MIs[0] Rn
     /* 135440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135452 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 135455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135465 */     GIR_RootConstrainSelectedInstOperands,
     /* 135466 */     // GIR_Coverage, 7200,
     /* 135466 */     GIR_EraseRootFromParent_Done,
     /* 135467 */   // Label 2593: @135467
     /* 135467 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(135509), // Rule ID 7201 //
     /* 135472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135482 */     // MIs[0] Rn
     /* 135482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135494 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 135497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135501 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135507 */     GIR_RootConstrainSelectedInstOperands,
     /* 135508 */     // GIR_Coverage, 7201,
     /* 135508 */     GIR_EraseRootFromParent_Done,
     /* 135509 */   // Label 2594: @135509
     /* 135509 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(135551), // Rule ID 7202 //
     /* 135514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135524 */     // MIs[0] Rn
     /* 135524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135536 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 135539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135549 */     GIR_RootConstrainSelectedInstOperands,
     /* 135550 */     // GIR_Coverage, 7202,
     /* 135550 */     GIR_EraseRootFromParent_Done,
     /* 135551 */   // Label 2595: @135551
     /* 135551 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(135593), // Rule ID 7203 //
     /* 135556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135559 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135566 */     // MIs[0] Rn
     /* 135566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135578 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 135581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135591 */     GIR_RootConstrainSelectedInstOperands,
     /* 135592 */     // GIR_Coverage, 7203,
     /* 135592 */     GIR_EraseRootFromParent_Done,
     /* 135593 */   // Label 2596: @135593
     /* 135593 */   GIM_Reject,
     /* 135594 */ // Label 2591: @135594
     /* 135594 */ GIM_Reject,
     /* 135595 */ // Label 2574: @135595
     /* 135595 */ GIM_Reject,
     /* 135596 */ // Label 30: @135596
     /* 135596 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2599*/ GIMT_Encode4(136587),
     /* 135607 */ /*GILLT_s32*//*Label 2597*/ GIMT_Encode4(135615),
     /* 135611 */ /*GILLT_s64*//*Label 2598*/ GIMT_Encode4(136360),
     /* 135615 */ // Label 2597: @135615
     /* 135615 */ GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(136359),
     /* 135620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135623 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(135672), // Rule ID 7224 //
     /* 135628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135631 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135638 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135645 */     // MIs[0] Rn
     /* 135645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135657 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 135660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135670 */     GIR_RootConstrainSelectedInstOperands,
     /* 135671 */     // GIR_Coverage, 7224,
     /* 135671 */     GIR_EraseRootFromParent_Done,
     /* 135672 */   // Label 2601: @135672
     /* 135672 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(135721), // Rule ID 7225 //
     /* 135677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135680 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135687 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135694 */     // MIs[0] Rn
     /* 135694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135706 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 135709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135719 */     GIR_RootConstrainSelectedInstOperands,
     /* 135720 */     // GIR_Coverage, 7225,
     /* 135720 */     GIR_EraseRootFromParent_Done,
     /* 135721 */   // Label 2602: @135721
     /* 135721 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(135770), // Rule ID 7226 //
     /* 135726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135729 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135736 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135743 */     // MIs[0] Rn
     /* 135743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135755 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 135758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135768 */     GIR_RootConstrainSelectedInstOperands,
     /* 135769 */     // GIR_Coverage, 7226,
     /* 135769 */     GIR_EraseRootFromParent_Done,
     /* 135770 */   // Label 2603: @135770
     /* 135770 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(135819), // Rule ID 7227 //
     /* 135775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135778 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135785 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135792 */     // MIs[0] Rn
     /* 135792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135804 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 135807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135817 */     GIR_RootConstrainSelectedInstOperands,
     /* 135818 */     // GIR_Coverage, 7227,
     /* 135818 */     GIR_EraseRootFromParent_Done,
     /* 135819 */   // Label 2604: @135819
     /* 135819 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(135868), // Rule ID 7228 //
     /* 135824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135841 */     // MIs[0] Rn
     /* 135841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135853 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 135856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135866 */     GIR_RootConstrainSelectedInstOperands,
     /* 135867 */     // GIR_Coverage, 7228,
     /* 135867 */     GIR_EraseRootFromParent_Done,
     /* 135868 */   // Label 2605: @135868
     /* 135868 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(135917), // Rule ID 7229 //
     /* 135873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135890 */     // MIs[0] Rn
     /* 135890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135902 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 135905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135915 */     GIR_RootConstrainSelectedInstOperands,
     /* 135916 */     // GIR_Coverage, 7229,
     /* 135916 */     GIR_EraseRootFromParent_Done,
     /* 135917 */   // Label 2606: @135917
     /* 135917 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(135966), // Rule ID 7230 //
     /* 135922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135939 */     // MIs[0] Rn
     /* 135939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135951 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 135954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135964 */     GIR_RootConstrainSelectedInstOperands,
     /* 135965 */     // GIR_Coverage, 7230,
     /* 135965 */     GIR_EraseRootFromParent_Done,
     /* 135966 */   // Label 2607: @135966
     /* 135966 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(136015), // Rule ID 7231 //
     /* 135971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135974 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135981 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135988 */     // MIs[0] Rn
     /* 135988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136000 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 136003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136013 */     GIR_RootConstrainSelectedInstOperands,
     /* 136014 */     // GIR_Coverage, 7231,
     /* 136014 */     GIR_EraseRootFromParent_Done,
     /* 136015 */   // Label 2608: @136015
     /* 136015 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(136064), // Rule ID 7232 //
     /* 136020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136023 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136030 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136037 */     // MIs[0] Rn
     /* 136037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136049 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 136052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136062 */     GIR_RootConstrainSelectedInstOperands,
     /* 136063 */     // GIR_Coverage, 7232,
     /* 136063 */     GIR_EraseRootFromParent_Done,
     /* 136064 */   // Label 2609: @136064
     /* 136064 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(136113), // Rule ID 7233 //
     /* 136069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136072 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136079 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136086 */     // MIs[0] Rn
     /* 136086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136098 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 136101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136111 */     GIR_RootConstrainSelectedInstOperands,
     /* 136112 */     // GIR_Coverage, 7233,
     /* 136112 */     GIR_EraseRootFromParent_Done,
     /* 136113 */   // Label 2610: @136113
     /* 136113 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(136162), // Rule ID 7234 //
     /* 136118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136121 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136128 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136135 */     // MIs[0] Rn
     /* 136135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136147 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 136150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136160 */     GIR_RootConstrainSelectedInstOperands,
     /* 136161 */     // GIR_Coverage, 7234,
     /* 136161 */     GIR_EraseRootFromParent_Done,
     /* 136162 */   // Label 2611: @136162
     /* 136162 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(136211), // Rule ID 7235 //
     /* 136167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136170 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136177 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136184 */     // MIs[0] Rn
     /* 136184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136196 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 136199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136203 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136209 */     GIR_RootConstrainSelectedInstOperands,
     /* 136210 */     // GIR_Coverage, 7235,
     /* 136210 */     GIR_EraseRootFromParent_Done,
     /* 136211 */   // Label 2612: @136211
     /* 136211 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(136260), // Rule ID 7236 //
     /* 136216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136219 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136226 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136233 */     // MIs[0] Rn
     /* 136233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136245 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 136248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136258 */     GIR_RootConstrainSelectedInstOperands,
     /* 136259 */     // GIR_Coverage, 7236,
     /* 136259 */     GIR_EraseRootFromParent_Done,
     /* 136260 */   // Label 2613: @136260
     /* 136260 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(136309), // Rule ID 7237 //
     /* 136265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136268 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136275 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136282 */     // MIs[0] Rn
     /* 136282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136294 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 136297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136307 */     GIR_RootConstrainSelectedInstOperands,
     /* 136308 */     // GIR_Coverage, 7237,
     /* 136308 */     GIR_EraseRootFromParent_Done,
     /* 136309 */   // Label 2614: @136309
     /* 136309 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(136358), // Rule ID 7238 //
     /* 136314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136317 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136324 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136331 */     // MIs[0] Rn
     /* 136331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136343 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 136346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136356 */     GIR_RootConstrainSelectedInstOperands,
     /* 136357 */     // GIR_Coverage, 7238,
     /* 136357 */     GIR_EraseRootFromParent_Done,
     /* 136358 */   // Label 2615: @136358
     /* 136358 */   GIM_Reject,
     /* 136359 */ // Label 2600: @136359
     /* 136359 */ GIM_Reject,
     /* 136360 */ // Label 2598: @136360
     /* 136360 */ GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(136586),
     /* 136365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136368 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 136375 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(136417), // Rule ID 7219 //
     /* 136380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136383 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136390 */     // MIs[0] Rn
     /* 136390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136402 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 136405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136415 */     GIR_RootConstrainSelectedInstOperands,
     /* 136416 */     // GIR_Coverage, 7219,
     /* 136416 */     GIR_EraseRootFromParent_Done,
     /* 136417 */   // Label 2617: @136417
     /* 136417 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(136459), // Rule ID 7220 //
     /* 136422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136425 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136432 */     // MIs[0] Rn
     /* 136432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136444 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 136447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136457 */     GIR_RootConstrainSelectedInstOperands,
     /* 136458 */     // GIR_Coverage, 7220,
     /* 136458 */     GIR_EraseRootFromParent_Done,
     /* 136459 */   // Label 2618: @136459
     /* 136459 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(136501), // Rule ID 7221 //
     /* 136464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136474 */     // MIs[0] Rn
     /* 136474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136486 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 136489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136493 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136499 */     GIR_RootConstrainSelectedInstOperands,
     /* 136500 */     // GIR_Coverage, 7221,
     /* 136500 */     GIR_EraseRootFromParent_Done,
     /* 136501 */   // Label 2619: @136501
     /* 136501 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(136543), // Rule ID 7222 //
     /* 136506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136509 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136516 */     // MIs[0] Rn
     /* 136516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136528 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 136531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136541 */     GIR_RootConstrainSelectedInstOperands,
     /* 136542 */     // GIR_Coverage, 7222,
     /* 136542 */     GIR_EraseRootFromParent_Done,
     /* 136543 */   // Label 2620: @136543
     /* 136543 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(136585), // Rule ID 7223 //
     /* 136548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136551 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136558 */     // MIs[0] Rn
     /* 136558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136570 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 136573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136583 */     GIR_RootConstrainSelectedInstOperands,
     /* 136584 */     // GIR_Coverage, 7223,
     /* 136584 */     GIR_EraseRootFromParent_Done,
     /* 136585 */   // Label 2621: @136585
     /* 136585 */   GIM_Reject,
     /* 136586 */ // Label 2616: @136586
     /* 136586 */ GIM_Reject,
     /* 136587 */ // Label 2599: @136587
     /* 136587 */ GIM_Reject,
     /* 136588 */ // Label 31: @136588
     /* 136588 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2625*/ GIMT_Encode4(137292),
     /* 136599 */ /*GILLT_s16*//*Label 2622*/ GIMT_Encode4(136611),
     /* 136603 */ /*GILLT_s32*//*Label 2623*/ GIMT_Encode4(136838),
     /* 136607 */ /*GILLT_s64*//*Label 2624*/ GIMT_Encode4(137065),
     /* 136611 */ // Label 2622: @136611
     /* 136611 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(136837),
     /* 136616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 136619 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136626 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(136668), // Rule ID 2575 //
     /* 136631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 136634 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136641 */     // MIs[0] Rn
     /* 136641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136653 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 136653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 136656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136666 */     GIR_RootConstrainSelectedInstOperands,
     /* 136667 */     // GIR_Coverage, 2575,
     /* 136667 */     GIR_EraseRootFromParent_Done,
     /* 136668 */   // Label 2627: @136668
     /* 136668 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(136710), // Rule ID 2576 //
     /* 136673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 136676 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136683 */     // MIs[0] Rn
     /* 136683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136695 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 136695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 136698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136708 */     GIR_RootConstrainSelectedInstOperands,
     /* 136709 */     // GIR_Coverage, 2576,
     /* 136709 */     GIR_EraseRootFromParent_Done,
     /* 136710 */   // Label 2628: @136710
     /* 136710 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(136752), // Rule ID 2577 //
     /* 136715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 136718 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136725 */     // MIs[0] Rn
     /* 136725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136737 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 136737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 136740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136750 */     GIR_RootConstrainSelectedInstOperands,
     /* 136751 */     // GIR_Coverage, 2577,
     /* 136751 */     GIR_EraseRootFromParent_Done,
     /* 136752 */   // Label 2629: @136752
     /* 136752 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(136794), // Rule ID 2578 //
     /* 136757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 136760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136767 */     // MIs[0] Rn
     /* 136767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136779 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 136779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 136782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136792 */     GIR_RootConstrainSelectedInstOperands,
     /* 136793 */     // GIR_Coverage, 2578,
     /* 136793 */     GIR_EraseRootFromParent_Done,
     /* 136794 */   // Label 2630: @136794
     /* 136794 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(136836), // Rule ID 2579 //
     /* 136799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 136802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136809 */     // MIs[0] Rn
     /* 136809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 136821 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 136821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 136824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136834 */     GIR_RootConstrainSelectedInstOperands,
     /* 136835 */     // GIR_Coverage, 2579,
     /* 136835 */     GIR_EraseRootFromParent_Done,
     /* 136836 */   // Label 2631: @136836
     /* 136836 */   GIM_Reject,
     /* 136837 */ // Label 2626: @136837
     /* 136837 */ GIM_Reject,
     /* 136838 */ // Label 2623: @136838
     /* 136838 */ GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(137064),
     /* 136843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136846 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136853 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(136895), // Rule ID 7314 //
     /* 136858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 136861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136868 */     // MIs[0] Rn
     /* 136868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136880 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 136880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 136883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136893 */     GIR_RootConstrainSelectedInstOperands,
     /* 136894 */     // GIR_Coverage, 7314,
     /* 136894 */     GIR_EraseRootFromParent_Done,
     /* 136895 */   // Label 2633: @136895
     /* 136895 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(136937), // Rule ID 7315 //
     /* 136900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 136903 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136910 */     // MIs[0] Rn
     /* 136910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136922 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 136922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 136925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136935 */     GIR_RootConstrainSelectedInstOperands,
     /* 136936 */     // GIR_Coverage, 7315,
     /* 136936 */     GIR_EraseRootFromParent_Done,
     /* 136937 */   // Label 2634: @136937
     /* 136937 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(136979), // Rule ID 7316 //
     /* 136942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 136945 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136952 */     // MIs[0] Rn
     /* 136952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136964 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 136964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 136967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136977 */     GIR_RootConstrainSelectedInstOperands,
     /* 136978 */     // GIR_Coverage, 7316,
     /* 136978 */     GIR_EraseRootFromParent_Done,
     /* 136979 */   // Label 2635: @136979
     /* 136979 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(137021), // Rule ID 7317 //
     /* 136984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 136987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136994 */     // MIs[0] Rn
     /* 136994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137006 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 137009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137019 */     GIR_RootConstrainSelectedInstOperands,
     /* 137020 */     // GIR_Coverage, 7317,
     /* 137020 */     GIR_EraseRootFromParent_Done,
     /* 137021 */   // Label 2636: @137021
     /* 137021 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(137063), // Rule ID 7318 //
     /* 137026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137029 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137036 */     // MIs[0] Rn
     /* 137036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137048 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 137051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137061 */     GIR_RootConstrainSelectedInstOperands,
     /* 137062 */     // GIR_Coverage, 7318,
     /* 137062 */     GIR_EraseRootFromParent_Done,
     /* 137063 */   // Label 2637: @137063
     /* 137063 */   GIM_Reject,
     /* 137064 */ // Label 2632: @137064
     /* 137064 */ GIM_Reject,
     /* 137065 */ // Label 2624: @137065
     /* 137065 */ GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(137291),
     /* 137070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 137080 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(137122), // Rule ID 7319 //
     /* 137085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137095 */     // MIs[0] Rn
     /* 137095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137107 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 137110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137120 */     GIR_RootConstrainSelectedInstOperands,
     /* 137121 */     // GIR_Coverage, 7319,
     /* 137121 */     GIR_EraseRootFromParent_Done,
     /* 137122 */   // Label 2639: @137122
     /* 137122 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(137164), // Rule ID 7320 //
     /* 137127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137137 */     // MIs[0] Rn
     /* 137137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137149 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 137152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137162 */     GIR_RootConstrainSelectedInstOperands,
     /* 137163 */     // GIR_Coverage, 7320,
     /* 137163 */     GIR_EraseRootFromParent_Done,
     /* 137164 */   // Label 2640: @137164
     /* 137164 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(137206), // Rule ID 7321 //
     /* 137169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137179 */     // MIs[0] Rn
     /* 137179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137191 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 137194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137204 */     GIR_RootConstrainSelectedInstOperands,
     /* 137205 */     // GIR_Coverage, 7321,
     /* 137205 */     GIR_EraseRootFromParent_Done,
     /* 137206 */   // Label 2641: @137206
     /* 137206 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(137248), // Rule ID 7322 //
     /* 137211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137221 */     // MIs[0] Rn
     /* 137221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137233 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 137236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137246 */     GIR_RootConstrainSelectedInstOperands,
     /* 137247 */     // GIR_Coverage, 7322,
     /* 137247 */     GIR_EraseRootFromParent_Done,
     /* 137248 */   // Label 2642: @137248
     /* 137248 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(137290), // Rule ID 7323 //
     /* 137253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137256 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137263 */     // MIs[0] Rn
     /* 137263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137275 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 137278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137288 */     GIR_RootConstrainSelectedInstOperands,
     /* 137289 */     // GIR_Coverage, 7323,
     /* 137289 */     GIR_EraseRootFromParent_Done,
     /* 137290 */   // Label 2643: @137290
     /* 137290 */   GIM_Reject,
     /* 137291 */ // Label 2638: @137291
     /* 137291 */ GIM_Reject,
     /* 137292 */ // Label 2625: @137292
     /* 137292 */ GIM_Reject,
     /* 137293 */ // Label 32: @137293
     /* 137293 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2647*/ GIMT_Encode4(137997),
     /* 137304 */ /*GILLT_s16*//*Label 2644*/ GIMT_Encode4(137316),
     /* 137308 */ /*GILLT_s32*//*Label 2645*/ GIMT_Encode4(137543),
     /* 137312 */ /*GILLT_s64*//*Label 2646*/ GIMT_Encode4(137770),
     /* 137316 */ // Label 2644: @137316
     /* 137316 */ GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(137542),
     /* 137321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137324 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137331 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(137373), // Rule ID 7324 //
     /* 137336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137339 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137346 */     // MIs[0] Rn
     /* 137346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137358 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 137361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137371 */     GIR_RootConstrainSelectedInstOperands,
     /* 137372 */     // GIR_Coverage, 7324,
     /* 137372 */     GIR_EraseRootFromParent_Done,
     /* 137373 */   // Label 2649: @137373
     /* 137373 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(137415), // Rule ID 7325 //
     /* 137378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137381 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137388 */     // MIs[0] Rn
     /* 137388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137400 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 137403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137413 */     GIR_RootConstrainSelectedInstOperands,
     /* 137414 */     // GIR_Coverage, 7325,
     /* 137414 */     GIR_EraseRootFromParent_Done,
     /* 137415 */   // Label 2650: @137415
     /* 137415 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(137457), // Rule ID 7326 //
     /* 137420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137423 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137430 */     // MIs[0] Rn
     /* 137430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137442 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 137445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137455 */     GIR_RootConstrainSelectedInstOperands,
     /* 137456 */     // GIR_Coverage, 7326,
     /* 137456 */     GIR_EraseRootFromParent_Done,
     /* 137457 */   // Label 2651: @137457
     /* 137457 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(137499), // Rule ID 7327 //
     /* 137462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137472 */     // MIs[0] Rn
     /* 137472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137484 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 137487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137497 */     GIR_RootConstrainSelectedInstOperands,
     /* 137498 */     // GIR_Coverage, 7327,
     /* 137498 */     GIR_EraseRootFromParent_Done,
     /* 137499 */   // Label 2652: @137499
     /* 137499 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(137541), // Rule ID 7328 //
     /* 137504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137507 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137514 */     // MIs[0] Rn
     /* 137514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137526 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 137529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137539 */     GIR_RootConstrainSelectedInstOperands,
     /* 137540 */     // GIR_Coverage, 7328,
     /* 137540 */     GIR_EraseRootFromParent_Done,
     /* 137541 */   // Label 2653: @137541
     /* 137541 */   GIM_Reject,
     /* 137542 */ // Label 2648: @137542
     /* 137542 */ GIM_Reject,
     /* 137543 */ // Label 2645: @137543
     /* 137543 */ GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(137769),
     /* 137548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137551 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137558 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(137600), // Rule ID 7329 //
     /* 137563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137573 */     // MIs[0] Rn
     /* 137573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137585 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 137588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137598 */     GIR_RootConstrainSelectedInstOperands,
     /* 137599 */     // GIR_Coverage, 7329,
     /* 137599 */     GIR_EraseRootFromParent_Done,
     /* 137600 */   // Label 2655: @137600
     /* 137600 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(137642), // Rule ID 7330 //
     /* 137605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137608 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137615 */     // MIs[0] Rn
     /* 137615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137627 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 137630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137640 */     GIR_RootConstrainSelectedInstOperands,
     /* 137641 */     // GIR_Coverage, 7330,
     /* 137641 */     GIR_EraseRootFromParent_Done,
     /* 137642 */   // Label 2656: @137642
     /* 137642 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(137684), // Rule ID 7331 //
     /* 137647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137650 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137657 */     // MIs[0] Rn
     /* 137657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137669 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 137672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137682 */     GIR_RootConstrainSelectedInstOperands,
     /* 137683 */     // GIR_Coverage, 7331,
     /* 137683 */     GIR_EraseRootFromParent_Done,
     /* 137684 */   // Label 2657: @137684
     /* 137684 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(137726), // Rule ID 7332 //
     /* 137689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137692 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137699 */     // MIs[0] Rn
     /* 137699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137711 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 137714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137724 */     GIR_RootConstrainSelectedInstOperands,
     /* 137725 */     // GIR_Coverage, 7332,
     /* 137725 */     GIR_EraseRootFromParent_Done,
     /* 137726 */   // Label 2658: @137726
     /* 137726 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(137768), // Rule ID 7333 //
     /* 137731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137734 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137741 */     // MIs[0] Rn
     /* 137741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137753 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 137756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137766 */     GIR_RootConstrainSelectedInstOperands,
     /* 137767 */     // GIR_Coverage, 7333,
     /* 137767 */     GIR_EraseRootFromParent_Done,
     /* 137768 */   // Label 2659: @137768
     /* 137768 */   GIM_Reject,
     /* 137769 */ // Label 2654: @137769
     /* 137769 */ GIM_Reject,
     /* 137770 */ // Label 2646: @137770
     /* 137770 */ GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(137996),
     /* 137775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137778 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 137785 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(137827), // Rule ID 7334 //
     /* 137790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137800 */     // MIs[0] Rn
     /* 137800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137812 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 137815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137825 */     GIR_RootConstrainSelectedInstOperands,
     /* 137826 */     // GIR_Coverage, 7334,
     /* 137826 */     GIR_EraseRootFromParent_Done,
     /* 137827 */   // Label 2661: @137827
     /* 137827 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(137869), // Rule ID 7335 //
     /* 137832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137842 */     // MIs[0] Rn
     /* 137842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137854 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 137857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137867 */     GIR_RootConstrainSelectedInstOperands,
     /* 137868 */     // GIR_Coverage, 7335,
     /* 137868 */     GIR_EraseRootFromParent_Done,
     /* 137869 */   // Label 2662: @137869
     /* 137869 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(137911), // Rule ID 7336 //
     /* 137874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137884 */     // MIs[0] Rn
     /* 137884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137896 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 137899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137909 */     GIR_RootConstrainSelectedInstOperands,
     /* 137910 */     // GIR_Coverage, 7336,
     /* 137910 */     GIR_EraseRootFromParent_Done,
     /* 137911 */   // Label 2663: @137911
     /* 137911 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(137953), // Rule ID 7337 //
     /* 137916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137926 */     // MIs[0] Rn
     /* 137926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137938 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 137941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137951 */     GIR_RootConstrainSelectedInstOperands,
     /* 137952 */     // GIR_Coverage, 7337,
     /* 137952 */     GIR_EraseRootFromParent_Done,
     /* 137953 */   // Label 2664: @137953
     /* 137953 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(137995), // Rule ID 7338 //
     /* 137958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137968 */     // MIs[0] Rn
     /* 137968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137980 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 137983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137993 */     GIR_RootConstrainSelectedInstOperands,
     /* 137994 */     // GIR_Coverage, 7338,
     /* 137994 */     GIR_EraseRootFromParent_Done,
     /* 137995 */   // Label 2665: @137995
     /* 137995 */   GIM_Reject,
     /* 137996 */ // Label 2660: @137996
     /* 137996 */ GIM_Reject,
     /* 137997 */ // Label 2647: @137997
     /* 137997 */ GIM_Reject,
     /* 137998 */ // Label 33: @137998
     /* 137998 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2669*/ GIMT_Encode4(138702),
     /* 138009 */ /*GILLT_s16*//*Label 2666*/ GIMT_Encode4(138021),
     /* 138013 */ /*GILLT_s32*//*Label 2667*/ GIMT_Encode4(138248),
     /* 138017 */ /*GILLT_s64*//*Label 2668*/ GIMT_Encode4(138475),
     /* 138021 */ // Label 2666: @138021
     /* 138021 */ GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(138247),
     /* 138026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 138029 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138036 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(138078), // Rule ID 7339 //
     /* 138041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138044 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138051 */     // MIs[0] Rn
     /* 138051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138063 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 138066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138070 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138076 */     GIR_RootConstrainSelectedInstOperands,
     /* 138077 */     // GIR_Coverage, 7339,
     /* 138077 */     GIR_EraseRootFromParent_Done,
     /* 138078 */   // Label 2671: @138078
     /* 138078 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(138120), // Rule ID 7340 //
     /* 138083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138086 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138093 */     // MIs[0] Rn
     /* 138093 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138105 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 138108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138118 */     GIR_RootConstrainSelectedInstOperands,
     /* 138119 */     // GIR_Coverage, 7340,
     /* 138119 */     GIR_EraseRootFromParent_Done,
     /* 138120 */   // Label 2672: @138120
     /* 138120 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(138162), // Rule ID 7341 //
     /* 138125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138128 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138135 */     // MIs[0] Rn
     /* 138135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138147 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 138150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138160 */     GIR_RootConstrainSelectedInstOperands,
     /* 138161 */     // GIR_Coverage, 7341,
     /* 138161 */     GIR_EraseRootFromParent_Done,
     /* 138162 */   // Label 2673: @138162
     /* 138162 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(138204), // Rule ID 7342 //
     /* 138167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138170 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138177 */     // MIs[0] Rn
     /* 138177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138189 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 138192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138202 */     GIR_RootConstrainSelectedInstOperands,
     /* 138203 */     // GIR_Coverage, 7342,
     /* 138203 */     GIR_EraseRootFromParent_Done,
     /* 138204 */   // Label 2674: @138204
     /* 138204 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(138246), // Rule ID 7343 //
     /* 138209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138219 */     // MIs[0] Rn
     /* 138219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138231 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 138234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138244 */     GIR_RootConstrainSelectedInstOperands,
     /* 138245 */     // GIR_Coverage, 7343,
     /* 138245 */     GIR_EraseRootFromParent_Done,
     /* 138246 */   // Label 2675: @138246
     /* 138246 */   GIM_Reject,
     /* 138247 */ // Label 2670: @138247
     /* 138247 */ GIM_Reject,
     /* 138248 */ // Label 2667: @138248
     /* 138248 */ GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(138474),
     /* 138253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138256 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138263 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(138305), // Rule ID 7344 //
     /* 138268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138278 */     // MIs[0] Rn
     /* 138278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138290 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 138293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138303 */     GIR_RootConstrainSelectedInstOperands,
     /* 138304 */     // GIR_Coverage, 7344,
     /* 138304 */     GIR_EraseRootFromParent_Done,
     /* 138305 */   // Label 2677: @138305
     /* 138305 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(138347), // Rule ID 7345 //
     /* 138310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138313 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138320 */     // MIs[0] Rn
     /* 138320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138332 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 138335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138345 */     GIR_RootConstrainSelectedInstOperands,
     /* 138346 */     // GIR_Coverage, 7345,
     /* 138346 */     GIR_EraseRootFromParent_Done,
     /* 138347 */   // Label 2678: @138347
     /* 138347 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(138389), // Rule ID 7346 //
     /* 138352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138355 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138362 */     // MIs[0] Rn
     /* 138362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138374 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 138377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138387 */     GIR_RootConstrainSelectedInstOperands,
     /* 138388 */     // GIR_Coverage, 7346,
     /* 138388 */     GIR_EraseRootFromParent_Done,
     /* 138389 */   // Label 2679: @138389
     /* 138389 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(138431), // Rule ID 7347 //
     /* 138394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138397 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138404 */     // MIs[0] Rn
     /* 138404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138416 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 138419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138429 */     GIR_RootConstrainSelectedInstOperands,
     /* 138430 */     // GIR_Coverage, 7347,
     /* 138430 */     GIR_EraseRootFromParent_Done,
     /* 138431 */   // Label 2680: @138431
     /* 138431 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(138473), // Rule ID 7348 //
     /* 138436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138446 */     // MIs[0] Rn
     /* 138446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138458 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 138461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138471 */     GIR_RootConstrainSelectedInstOperands,
     /* 138472 */     // GIR_Coverage, 7348,
     /* 138472 */     GIR_EraseRootFromParent_Done,
     /* 138473 */   // Label 2681: @138473
     /* 138473 */   GIM_Reject,
     /* 138474 */ // Label 2676: @138474
     /* 138474 */ GIM_Reject,
     /* 138475 */ // Label 2668: @138475
     /* 138475 */ GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(138701),
     /* 138480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138483 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138490 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(138532), // Rule ID 7349 //
     /* 138495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138505 */     // MIs[0] Rn
     /* 138505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138517 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 138520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138530 */     GIR_RootConstrainSelectedInstOperands,
     /* 138531 */     // GIR_Coverage, 7349,
     /* 138531 */     GIR_EraseRootFromParent_Done,
     /* 138532 */   // Label 2683: @138532
     /* 138532 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(138574), // Rule ID 7350 //
     /* 138537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138540 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138547 */     // MIs[0] Rn
     /* 138547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138559 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 138562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138572 */     GIR_RootConstrainSelectedInstOperands,
     /* 138573 */     // GIR_Coverage, 7350,
     /* 138573 */     GIR_EraseRootFromParent_Done,
     /* 138574 */   // Label 2684: @138574
     /* 138574 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(138616), // Rule ID 7351 //
     /* 138579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138589 */     // MIs[0] Rn
     /* 138589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138601 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 138604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138614 */     GIR_RootConstrainSelectedInstOperands,
     /* 138615 */     // GIR_Coverage, 7351,
     /* 138615 */     GIR_EraseRootFromParent_Done,
     /* 138616 */   // Label 2685: @138616
     /* 138616 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(138658), // Rule ID 7352 //
     /* 138621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138624 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138631 */     // MIs[0] Rn
     /* 138631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138643 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 138646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138656 */     GIR_RootConstrainSelectedInstOperands,
     /* 138657 */     // GIR_Coverage, 7352,
     /* 138657 */     GIR_EraseRootFromParent_Done,
     /* 138658 */   // Label 2686: @138658
     /* 138658 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(138700), // Rule ID 7353 //
     /* 138663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138666 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138673 */     // MIs[0] Rn
     /* 138673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138685 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 138688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138698 */     GIR_RootConstrainSelectedInstOperands,
     /* 138699 */     // GIR_Coverage, 7353,
     /* 138699 */     GIR_EraseRootFromParent_Done,
     /* 138700 */   // Label 2687: @138700
     /* 138700 */   GIM_Reject,
     /* 138701 */ // Label 2682: @138701
     /* 138701 */ GIM_Reject,
     /* 138702 */ // Label 2669: @138702
     /* 138702 */ GIM_Reject,
     /* 138703 */ // Label 34: @138703
     /* 138703 */ GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(138730), // Rule ID 6971 //
     /* 138708 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 138711 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 138715 */   // MIs[0] Operand 1
     /* 138715 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 138718 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 138718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 138721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 138724 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138728 */   GIR_RootConstrainSelectedInstOperands,
     /* 138729 */   // GIR_Coverage, 6971,
     /* 138729 */   GIR_EraseRootFromParent_Done,
     /* 138730 */ // Label 2688: @138730
     /* 138730 */ GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(138753), // Rule ID 6972 //
     /* 138735 */   // MIs[0] Operand 0
     /* 138735 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 138738 */   // MIs[0] Operand 1
     /* 138738 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 138741 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 138741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 138744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 138747 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138751 */   GIR_RootConstrainSelectedInstOperands,
     /* 138752 */   // GIR_Coverage, 6972,
     /* 138752 */   GIR_EraseRootFromParent_Done,
     /* 138753 */ // Label 2689: @138753
     /* 138753 */ GIM_Reject,
     /* 138754 */ // Label 35: @138754
     /* 138754 */ GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(151281),
     /* 138759 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 138762 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(138853), // Rule ID 6450 //
     /* 138767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 138770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 138775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 138778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 138781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 138793 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 138796 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 138801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 138805 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 138809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138821 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 138821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 138824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 138828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 138837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 138841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 138846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138851 */     GIR_RootConstrainSelectedInstOperands,
     /* 138852 */     // GIR_Coverage, 6450,
     /* 138852 */     GIR_EraseRootFromParent_Done,
     /* 138853 */   // Label 2691: @138853
     /* 138853 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(138944), // Rule ID 6451 //
     /* 138858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 138861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 138866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 138869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 138872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 138884 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 138887 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 138892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 138896 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 138900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138912 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 138912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 138915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 138919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 138928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 138932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 138937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138942 */     GIR_RootConstrainSelectedInstOperands,
     /* 138943 */     // GIR_Coverage, 6451,
     /* 138943 */     GIR_EraseRootFromParent_Done,
     /* 138944 */   // Label 2692: @138944
     /* 138944 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(139005), // Rule ID 4877 //
     /* 138949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 138954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 138957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 138960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 138972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 138976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138981 */     // MIs[1] Operand 2
     /* 138981 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 138992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138994 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 138994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 138997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 138999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 139003 */     GIR_RootConstrainSelectedInstOperands,
     /* 139004 */     // GIR_Coverage, 4877,
     /* 139004 */     GIR_EraseRootFromParent_Done,
     /* 139005 */   // Label 2693: @139005
     /* 139005 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(139045), // Rule ID 2642 //
     /* 139010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 139018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139025 */     // MIs[0] pattern
     /* 139025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139033 */     // (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 139036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139038 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139043 */     GIR_RootConstrainSelectedInstOperands,
     /* 139044 */     // GIR_Coverage, 2642,
     /* 139044 */     GIR_EraseRootFromParent_Done,
     /* 139045 */   // Label 2694: @139045
     /* 139045 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(139085), // Rule ID 9856 //
     /* 139050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 139058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139065 */     // MIs[0] pattern
     /* 139065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139073 */     // (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 139076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139078 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139083 */     GIR_RootConstrainSelectedInstOperands,
     /* 139084 */     // GIR_Coverage, 9856,
     /* 139084 */     GIR_EraseRootFromParent_Done,
     /* 139085 */   // Label 2695: @139085
     /* 139085 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(139125), // Rule ID 9859 //
     /* 139090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 139098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139105 */     // MIs[0] pattern
     /* 139105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139108 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139113 */     // (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 139116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139118 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139123 */     GIR_RootConstrainSelectedInstOperands,
     /* 139124 */     // GIR_Coverage, 9859,
     /* 139124 */     GIR_EraseRootFromParent_Done,
     /* 139125 */   // Label 2696: @139125
     /* 139125 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(139165), // Rule ID 9862 //
     /* 139130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 139138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139145 */     // MIs[0] pattern
     /* 139145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139153 */     // (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 139156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139158 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139163 */     GIR_RootConstrainSelectedInstOperands,
     /* 139164 */     // GIR_Coverage, 9862,
     /* 139164 */     GIR_EraseRootFromParent_Done,
     /* 139165 */   // Label 2697: @139165
     /* 139165 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(139204), // Rule ID 66 //
     /* 139170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 139173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 139178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139192 */     // (intrinsic_wo_chain:{ *:[i32] } 546:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 139192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 139195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139199 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 139202 */     GIR_RootConstrainSelectedInstOperands,
     /* 139203 */     // GIR_Coverage, 66,
     /* 139203 */     GIR_EraseRootFromParent_Done,
     /* 139204 */   // Label 2698: @139204
     /* 139204 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(139240), // Rule ID 346 //
     /* 139209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 139212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 139217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139231 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 139231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 139234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139238 */     GIR_RootConstrainSelectedInstOperands,
     /* 139239 */     // GIR_Coverage, 346,
     /* 139239 */     GIR_EraseRootFromParent_Done,
     /* 139240 */   // Label 2699: @139240
     /* 139240 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(139276), // Rule ID 347 //
     /* 139245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 139248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 139253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139267 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 139267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 139270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139274 */     GIR_RootConstrainSelectedInstOperands,
     /* 139275 */     // GIR_Coverage, 347,
     /* 139275 */     GIR_EraseRootFromParent_Done,
     /* 139276 */   // Label 2700: @139276
     /* 139276 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(139312), // Rule ID 348 //
     /* 139281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 139289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139303 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 139303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 139306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139310 */     GIR_RootConstrainSelectedInstOperands,
     /* 139311 */     // GIR_Coverage, 348,
     /* 139311 */     GIR_EraseRootFromParent_Done,
     /* 139312 */   // Label 2701: @139312
     /* 139312 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(139348), // Rule ID 349 //
     /* 139317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 139325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139339 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 139339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 139342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139346 */     GIR_RootConstrainSelectedInstOperands,
     /* 139347 */     // GIR_Coverage, 349,
     /* 139347 */     GIR_EraseRootFromParent_Done,
     /* 139348 */   // Label 2702: @139348
     /* 139348 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(139384), // Rule ID 350 //
     /* 139353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 139361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139375 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 139375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 139378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139382 */     GIR_RootConstrainSelectedInstOperands,
     /* 139383 */     // GIR_Coverage, 350,
     /* 139383 */     GIR_EraseRootFromParent_Done,
     /* 139384 */   // Label 2703: @139384
     /* 139384 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(139420), // Rule ID 351 //
     /* 139389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 139397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139411 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 139411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 139414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139418 */     GIR_RootConstrainSelectedInstOperands,
     /* 139419 */     // GIR_Coverage, 351,
     /* 139419 */     GIR_EraseRootFromParent_Done,
     /* 139420 */   // Label 2704: @139420
     /* 139420 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(139456), // Rule ID 352 //
     /* 139425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 139428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 139433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139447 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 139447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 139450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139454 */     GIR_RootConstrainSelectedInstOperands,
     /* 139455 */     // GIR_Coverage, 352,
     /* 139455 */     GIR_EraseRootFromParent_Done,
     /* 139456 */   // Label 2705: @139456
     /* 139456 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(139492), // Rule ID 353 //
     /* 139461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 139464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 139469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139483 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 139483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 139486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139490 */     GIR_RootConstrainSelectedInstOperands,
     /* 139491 */     // GIR_Coverage, 353,
     /* 139491 */     GIR_EraseRootFromParent_Done,
     /* 139492 */   // Label 2706: @139492
     /* 139492 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(139528), // Rule ID 354 //
     /* 139497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 139505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139519 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 139519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 139522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139526 */     GIR_RootConstrainSelectedInstOperands,
     /* 139527 */     // GIR_Coverage, 354,
     /* 139527 */     GIR_EraseRootFromParent_Done,
     /* 139528 */   // Label 2707: @139528
     /* 139528 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(139564), // Rule ID 355 //
     /* 139533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 139541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139555 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 139555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 139558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139562 */     GIR_RootConstrainSelectedInstOperands,
     /* 139563 */     // GIR_Coverage, 355,
     /* 139563 */     GIR_EraseRootFromParent_Done,
     /* 139564 */   // Label 2708: @139564
     /* 139564 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(139600), // Rule ID 356 //
     /* 139569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 139577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139591 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 139591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 139594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139598 */     GIR_RootConstrainSelectedInstOperands,
     /* 139599 */     // GIR_Coverage, 356,
     /* 139599 */     GIR_EraseRootFromParent_Done,
     /* 139600 */   // Label 2709: @139600
     /* 139600 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(139636), // Rule ID 357 //
     /* 139605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 139613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139627 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 139627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 139630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139634 */     GIR_RootConstrainSelectedInstOperands,
     /* 139635 */     // GIR_Coverage, 357,
     /* 139635 */     GIR_EraseRootFromParent_Done,
     /* 139636 */   // Label 2710: @139636
     /* 139636 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(139672), // Rule ID 358 //
     /* 139641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 139644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 139649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139663 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 139663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 139666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139670 */     GIR_RootConstrainSelectedInstOperands,
     /* 139671 */     // GIR_Coverage, 358,
     /* 139671 */     GIR_EraseRootFromParent_Done,
     /* 139672 */   // Label 2711: @139672
     /* 139672 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(139708), // Rule ID 359 //
     /* 139677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 139680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 139685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139699 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 139699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 139702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139706 */     GIR_RootConstrainSelectedInstOperands,
     /* 139707 */     // GIR_Coverage, 359,
     /* 139707 */     GIR_EraseRootFromParent_Done,
     /* 139708 */   // Label 2712: @139708
     /* 139708 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(139744), // Rule ID 360 //
     /* 139713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 139721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139735 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 139735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 139738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139742 */     GIR_RootConstrainSelectedInstOperands,
     /* 139743 */     // GIR_Coverage, 360,
     /* 139743 */     GIR_EraseRootFromParent_Done,
     /* 139744 */   // Label 2713: @139744
     /* 139744 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(139780), // Rule ID 361 //
     /* 139749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 139757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139771 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 139771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 139774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139778 */     GIR_RootConstrainSelectedInstOperands,
     /* 139779 */     // GIR_Coverage, 361,
     /* 139779 */     GIR_EraseRootFromParent_Done,
     /* 139780 */   // Label 2714: @139780
     /* 139780 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(139816), // Rule ID 362 //
     /* 139785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 139793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139807 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 139807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 139810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139814 */     GIR_RootConstrainSelectedInstOperands,
     /* 139815 */     // GIR_Coverage, 362,
     /* 139815 */     GIR_EraseRootFromParent_Done,
     /* 139816 */   // Label 2715: @139816
     /* 139816 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(139852), // Rule ID 363 //
     /* 139821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 139829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139843 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 139843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 139846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139850 */     GIR_RootConstrainSelectedInstOperands,
     /* 139851 */     // GIR_Coverage, 363,
     /* 139851 */     GIR_EraseRootFromParent_Done,
     /* 139852 */   // Label 2716: @139852
     /* 139852 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(139888), // Rule ID 364 //
     /* 139857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 139860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 139865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139879 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 139879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 139882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139886 */     GIR_RootConstrainSelectedInstOperands,
     /* 139887 */     // GIR_Coverage, 364,
     /* 139887 */     GIR_EraseRootFromParent_Done,
     /* 139888 */   // Label 2717: @139888
     /* 139888 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(139924), // Rule ID 365 //
     /* 139893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 139896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 139901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139915 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 139915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 139918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139922 */     GIR_RootConstrainSelectedInstOperands,
     /* 139923 */     // GIR_Coverage, 365,
     /* 139923 */     GIR_EraseRootFromParent_Done,
     /* 139924 */   // Label 2718: @139924
     /* 139924 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(139960), // Rule ID 366 //
     /* 139929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 139937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139951 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 139951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 139954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139958 */     GIR_RootConstrainSelectedInstOperands,
     /* 139959 */     // GIR_Coverage, 366,
     /* 139959 */     GIR_EraseRootFromParent_Done,
     /* 139960 */   // Label 2719: @139960
     /* 139960 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(139996), // Rule ID 367 //
     /* 139965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 139973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139987 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 139987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 139990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139994 */     GIR_RootConstrainSelectedInstOperands,
     /* 139995 */     // GIR_Coverage, 367,
     /* 139995 */     GIR_EraseRootFromParent_Done,
     /* 139996 */   // Label 2720: @139996
     /* 139996 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(140032), // Rule ID 368 //
     /* 140001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140023 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 140026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140030 */     GIR_RootConstrainSelectedInstOperands,
     /* 140031 */     // GIR_Coverage, 368,
     /* 140031 */     GIR_EraseRootFromParent_Done,
     /* 140032 */   // Label 2721: @140032
     /* 140032 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(140068), // Rule ID 369 //
     /* 140037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140059 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 140062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140066 */     GIR_RootConstrainSelectedInstOperands,
     /* 140067 */     // GIR_Coverage, 369,
     /* 140067 */     GIR_EraseRootFromParent_Done,
     /* 140068 */   // Label 2722: @140068
     /* 140068 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(140104), // Rule ID 370 //
     /* 140073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140095 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 140098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140102 */     GIR_RootConstrainSelectedInstOperands,
     /* 140103 */     // GIR_Coverage, 370,
     /* 140103 */     GIR_EraseRootFromParent_Done,
     /* 140104 */   // Label 2723: @140104
     /* 140104 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(140140), // Rule ID 371 //
     /* 140109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140131 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 140134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140138 */     GIR_RootConstrainSelectedInstOperands,
     /* 140139 */     // GIR_Coverage, 371,
     /* 140139 */     GIR_EraseRootFromParent_Done,
     /* 140140 */   // Label 2724: @140140
     /* 140140 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(140176), // Rule ID 372 //
     /* 140145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140167 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 140170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140174 */     GIR_RootConstrainSelectedInstOperands,
     /* 140175 */     // GIR_Coverage, 372,
     /* 140175 */     GIR_EraseRootFromParent_Done,
     /* 140176 */   // Label 2725: @140176
     /* 140176 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(140212), // Rule ID 373 //
     /* 140181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140203 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 140206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140210 */     GIR_RootConstrainSelectedInstOperands,
     /* 140211 */     // GIR_Coverage, 373,
     /* 140211 */     GIR_EraseRootFromParent_Done,
     /* 140212 */   // Label 2726: @140212
     /* 140212 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(140248), // Rule ID 374 //
     /* 140217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140239 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 140242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140246 */     GIR_RootConstrainSelectedInstOperands,
     /* 140247 */     // GIR_Coverage, 374,
     /* 140247 */     GIR_EraseRootFromParent_Done,
     /* 140248 */   // Label 2727: @140248
     /* 140248 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(140284), // Rule ID 375 //
     /* 140253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140275 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 140278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140282 */     GIR_RootConstrainSelectedInstOperands,
     /* 140283 */     // GIR_Coverage, 375,
     /* 140283 */     GIR_EraseRootFromParent_Done,
     /* 140284 */   // Label 2728: @140284
     /* 140284 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(140320), // Rule ID 376 //
     /* 140289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 140297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140311 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 140314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140318 */     GIR_RootConstrainSelectedInstOperands,
     /* 140319 */     // GIR_Coverage, 376,
     /* 140319 */     GIR_EraseRootFromParent_Done,
     /* 140320 */   // Label 2729: @140320
     /* 140320 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(140356), // Rule ID 377 //
     /* 140325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 140333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140347 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 140350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140354 */     GIR_RootConstrainSelectedInstOperands,
     /* 140355 */     // GIR_Coverage, 377,
     /* 140355 */     GIR_EraseRootFromParent_Done,
     /* 140356 */   // Label 2730: @140356
     /* 140356 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(140392), // Rule ID 378 //
     /* 140361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 140369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140383 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 140386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140390 */     GIR_RootConstrainSelectedInstOperands,
     /* 140391 */     // GIR_Coverage, 378,
     /* 140391 */     GIR_EraseRootFromParent_Done,
     /* 140392 */   // Label 2731: @140392
     /* 140392 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(140428), // Rule ID 379 //
     /* 140397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 140405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140419 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 140422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140426 */     GIR_RootConstrainSelectedInstOperands,
     /* 140427 */     // GIR_Coverage, 379,
     /* 140427 */     GIR_EraseRootFromParent_Done,
     /* 140428 */   // Label 2732: @140428
     /* 140428 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(140464), // Rule ID 380 //
     /* 140433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 140441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140455 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 140458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140462 */     GIR_RootConstrainSelectedInstOperands,
     /* 140463 */     // GIR_Coverage, 380,
     /* 140463 */     GIR_EraseRootFromParent_Done,
     /* 140464 */   // Label 2733: @140464
     /* 140464 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(140500), // Rule ID 381 //
     /* 140469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 140477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140491 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 140494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140498 */     GIR_RootConstrainSelectedInstOperands,
     /* 140499 */     // GIR_Coverage, 381,
     /* 140499 */     GIR_EraseRootFromParent_Done,
     /* 140500 */   // Label 2734: @140500
     /* 140500 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(140536), // Rule ID 382 //
     /* 140505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 140513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140527 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 140530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140534 */     GIR_RootConstrainSelectedInstOperands,
     /* 140535 */     // GIR_Coverage, 382,
     /* 140535 */     GIR_EraseRootFromParent_Done,
     /* 140536 */   // Label 2735: @140536
     /* 140536 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(140572), // Rule ID 383 //
     /* 140541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 140549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140563 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 140566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140570 */     GIR_RootConstrainSelectedInstOperands,
     /* 140571 */     // GIR_Coverage, 383,
     /* 140571 */     GIR_EraseRootFromParent_Done,
     /* 140572 */   // Label 2736: @140572
     /* 140572 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(140608), // Rule ID 384 //
     /* 140577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 140585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140599 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 140602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140606 */     GIR_RootConstrainSelectedInstOperands,
     /* 140607 */     // GIR_Coverage, 384,
     /* 140607 */     GIR_EraseRootFromParent_Done,
     /* 140608 */   // Label 2737: @140608
     /* 140608 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(140644), // Rule ID 385 //
     /* 140613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 140621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140635 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 140638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140642 */     GIR_RootConstrainSelectedInstOperands,
     /* 140643 */     // GIR_Coverage, 385,
     /* 140643 */     GIR_EraseRootFromParent_Done,
     /* 140644 */   // Label 2738: @140644
     /* 140644 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(140680), // Rule ID 386 //
     /* 140649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 140657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140671 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 140674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140678 */     GIR_RootConstrainSelectedInstOperands,
     /* 140679 */     // GIR_Coverage, 386,
     /* 140679 */     GIR_EraseRootFromParent_Done,
     /* 140680 */   // Label 2739: @140680
     /* 140680 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(140716), // Rule ID 387 //
     /* 140685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 140693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140707 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 140710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140714 */     GIR_RootConstrainSelectedInstOperands,
     /* 140715 */     // GIR_Coverage, 387,
     /* 140715 */     GIR_EraseRootFromParent_Done,
     /* 140716 */   // Label 2740: @140716
     /* 140716 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(140752), // Rule ID 388 //
     /* 140721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 140729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140743 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 140746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140750 */     GIR_RootConstrainSelectedInstOperands,
     /* 140751 */     // GIR_Coverage, 388,
     /* 140751 */     GIR_EraseRootFromParent_Done,
     /* 140752 */   // Label 2741: @140752
     /* 140752 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(140788), // Rule ID 389 //
     /* 140757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 140765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140779 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 140782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140786 */     GIR_RootConstrainSelectedInstOperands,
     /* 140787 */     // GIR_Coverage, 389,
     /* 140787 */     GIR_EraseRootFromParent_Done,
     /* 140788 */   // Label 2742: @140788
     /* 140788 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(140824), // Rule ID 390 //
     /* 140793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 140801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140815 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 140818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140822 */     GIR_RootConstrainSelectedInstOperands,
     /* 140823 */     // GIR_Coverage, 390,
     /* 140823 */     GIR_EraseRootFromParent_Done,
     /* 140824 */   // Label 2743: @140824
     /* 140824 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(140860), // Rule ID 391 //
     /* 140829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 140837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140851 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 140854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140858 */     GIR_RootConstrainSelectedInstOperands,
     /* 140859 */     // GIR_Coverage, 391,
     /* 140859 */     GIR_EraseRootFromParent_Done,
     /* 140860 */   // Label 2744: @140860
     /* 140860 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(140896), // Rule ID 392 //
     /* 140865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 140873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140887 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 140890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140894 */     GIR_RootConstrainSelectedInstOperands,
     /* 140895 */     // GIR_Coverage, 392,
     /* 140895 */     GIR_EraseRootFromParent_Done,
     /* 140896 */   // Label 2745: @140896
     /* 140896 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(140932), // Rule ID 393 //
     /* 140901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 140909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140923 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 140926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140930 */     GIR_RootConstrainSelectedInstOperands,
     /* 140931 */     // GIR_Coverage, 393,
     /* 140931 */     GIR_EraseRootFromParent_Done,
     /* 140932 */   // Label 2746: @140932
     /* 140932 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(140968), // Rule ID 575 //
     /* 140937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 140940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 140945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140959 */     // (intrinsic_wo_chain:{ *:[f32] } 548:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 140959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 140962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140966 */     GIR_RootConstrainSelectedInstOperands,
     /* 140967 */     // GIR_Coverage, 575,
     /* 140967 */     GIR_EraseRootFromParent_Done,
     /* 140968 */   // Label 2747: @140968
     /* 140968 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(141004), // Rule ID 576 //
     /* 140973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 140976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 140981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140995 */     // (intrinsic_wo_chain:{ *:[f64] } 548:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 140995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 140998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141002 */     GIR_RootConstrainSelectedInstOperands,
     /* 141003 */     // GIR_Coverage, 576,
     /* 141003 */     GIR_EraseRootFromParent_Done,
     /* 141004 */   // Label 2748: @141004
     /* 141004 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(141040), // Rule ID 577 //
     /* 141009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 141017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141031 */     // (intrinsic_wo_chain:{ *:[f32] } 550:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 141034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141038 */     GIR_RootConstrainSelectedInstOperands,
     /* 141039 */     // GIR_Coverage, 577,
     /* 141039 */     GIR_EraseRootFromParent_Done,
     /* 141040 */   // Label 2749: @141040
     /* 141040 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(141076), // Rule ID 578 //
     /* 141045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 141053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141067 */     // (intrinsic_wo_chain:{ *:[f64] } 550:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 141070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141074 */     GIR_RootConstrainSelectedInstOperands,
     /* 141075 */     // GIR_Coverage, 578,
     /* 141075 */     GIR_EraseRootFromParent_Done,
     /* 141076 */   // Label 2750: @141076
     /* 141076 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(141112), // Rule ID 579 //
     /* 141081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 141089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141103 */     // (intrinsic_wo_chain:{ *:[f32] } 547:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 141106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141110 */     GIR_RootConstrainSelectedInstOperands,
     /* 141111 */     // GIR_Coverage, 579,
     /* 141111 */     GIR_EraseRootFromParent_Done,
     /* 141112 */   // Label 2751: @141112
     /* 141112 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(141148), // Rule ID 580 //
     /* 141117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 141125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141139 */     // (intrinsic_wo_chain:{ *:[f64] } 547:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 141142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141146 */     GIR_RootConstrainSelectedInstOperands,
     /* 141147 */     // GIR_Coverage, 580,
     /* 141147 */     GIR_EraseRootFromParent_Done,
     /* 141148 */   // Label 2752: @141148
     /* 141148 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(141184), // Rule ID 581 //
     /* 141153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 141161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141175 */     // (intrinsic_wo_chain:{ *:[f32] } 549:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 141178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141182 */     GIR_RootConstrainSelectedInstOperands,
     /* 141183 */     // GIR_Coverage, 581,
     /* 141183 */     GIR_EraseRootFromParent_Done,
     /* 141184 */   // Label 2753: @141184
     /* 141184 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(141220), // Rule ID 582 //
     /* 141189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 141197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141211 */     // (intrinsic_wo_chain:{ *:[f64] } 549:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 141214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141218 */     GIR_RootConstrainSelectedInstOperands,
     /* 141219 */     // GIR_Coverage, 582,
     /* 141219 */     GIR_EraseRootFromParent_Done,
     /* 141220 */   // Label 2754: @141220
     /* 141220 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(141256), // Rule ID 710 //
     /* 141225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 141233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 141236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 141239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141247 */     // (intrinsic_wo_chain:{ *:[v8i8] } 575:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 141247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 141250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141254 */     GIR_RootConstrainSelectedInstOperands,
     /* 141255 */     // GIR_Coverage, 710,
     /* 141255 */     GIR_EraseRootFromParent_Done,
     /* 141256 */   // Label 2755: @141256
     /* 141256 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(141292), // Rule ID 711 //
     /* 141261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 141269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 141272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 141275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141283 */     // (intrinsic_wo_chain:{ *:[v16i8] } 575:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 141283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 141286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141290 */     GIR_RootConstrainSelectedInstOperands,
     /* 141291 */     // GIR_Coverage, 711,
     /* 141291 */     GIR_EraseRootFromParent_Done,
     /* 141292 */   // Label 2756: @141292
     /* 141292 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(141328), // Rule ID 712 //
     /* 141297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 141305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 141308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 141311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141319 */     // (intrinsic_wo_chain:{ *:[v4i16] } 575:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 141319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 141322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141326 */     GIR_RootConstrainSelectedInstOperands,
     /* 141327 */     // GIR_Coverage, 712,
     /* 141327 */     GIR_EraseRootFromParent_Done,
     /* 141328 */   // Label 2757: @141328
     /* 141328 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(141364), // Rule ID 713 //
     /* 141333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 141341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 141344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 141347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141355 */     // (intrinsic_wo_chain:{ *:[v8i16] } 575:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 141355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 141358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141362 */     GIR_RootConstrainSelectedInstOperands,
     /* 141363 */     // GIR_Coverage, 713,
     /* 141363 */     GIR_EraseRootFromParent_Done,
     /* 141364 */   // Label 2758: @141364
     /* 141364 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(141400), // Rule ID 714 //
     /* 141369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 141377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 141380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141391 */     // (intrinsic_wo_chain:{ *:[v2i32] } 575:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 141391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 141394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141398 */     GIR_RootConstrainSelectedInstOperands,
     /* 141399 */     // GIR_Coverage, 714,
     /* 141399 */     GIR_EraseRootFromParent_Done,
     /* 141400 */   // Label 2759: @141400
     /* 141400 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(141436), // Rule ID 715 //
     /* 141405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 141413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 141416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 141419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141427 */     // (intrinsic_wo_chain:{ *:[v4i32] } 575:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 141427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 141430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141434 */     GIR_RootConstrainSelectedInstOperands,
     /* 141435 */     // GIR_Coverage, 715,
     /* 141435 */     GIR_EraseRootFromParent_Done,
     /* 141436 */   // Label 2760: @141436
     /* 141436 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(141472), // Rule ID 789 //
     /* 141441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 141444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 141449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 141452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 141455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141463 */     // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 141463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 141466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141470 */     GIR_RootConstrainSelectedInstOperands,
     /* 141471 */     // GIR_Coverage, 789,
     /* 141471 */     GIR_EraseRootFromParent_Done,
     /* 141472 */   // Label 2761: @141472
     /* 141472 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(141508), // Rule ID 790 //
     /* 141477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 141480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 141485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 141488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 141491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141499 */     // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 141499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 141502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141506 */     GIR_RootConstrainSelectedInstOperands,
     /* 141507 */     // GIR_Coverage, 790,
     /* 141507 */     GIR_EraseRootFromParent_Done,
     /* 141508 */   // Label 2762: @141508
     /* 141508 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(141544), // Rule ID 791 //
     /* 141513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 141521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 141524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141535 */     // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 141535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 141538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141542 */     GIR_RootConstrainSelectedInstOperands,
     /* 141543 */     // GIR_Coverage, 791,
     /* 141543 */     GIR_EraseRootFromParent_Done,
     /* 141544 */   // Label 2763: @141544
     /* 141544 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(141580), // Rule ID 792 //
     /* 141549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 141557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 141560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 141563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141571 */     // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 141571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 141574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141578 */     GIR_RootConstrainSelectedInstOperands,
     /* 141579 */     // GIR_Coverage, 792,
     /* 141579 */     GIR_EraseRootFromParent_Done,
     /* 141580 */   // Label 2764: @141580
     /* 141580 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(141616), // Rule ID 793 //
     /* 141585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 141593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 141596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 141599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141607 */     // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 141607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 141610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141614 */     GIR_RootConstrainSelectedInstOperands,
     /* 141615 */     // GIR_Coverage, 793,
     /* 141615 */     GIR_EraseRootFromParent_Done,
     /* 141616 */   // Label 2765: @141616
     /* 141616 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(141652), // Rule ID 794 //
     /* 141621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 141624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 141629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 141632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 141635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141643 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 141643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 141646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141650 */     GIR_RootConstrainSelectedInstOperands,
     /* 141651 */     // GIR_Coverage, 794,
     /* 141651 */     GIR_EraseRootFromParent_Done,
     /* 141652 */   // Label 2766: @141652
     /* 141652 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(141688), // Rule ID 795 //
     /* 141657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 141660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 141665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 141668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 141671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141679 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 141679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 141682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141686 */     GIR_RootConstrainSelectedInstOperands,
     /* 141687 */     // GIR_Coverage, 795,
     /* 141687 */     GIR_EraseRootFromParent_Done,
     /* 141688 */   // Label 2767: @141688
     /* 141688 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(141724), // Rule ID 796 //
     /* 141693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 141701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 141704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141715 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 141715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 141718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141722 */     GIR_RootConstrainSelectedInstOperands,
     /* 141723 */     // GIR_Coverage, 796,
     /* 141723 */     GIR_EraseRootFromParent_Done,
     /* 141724 */   // Label 2768: @141724
     /* 141724 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(141760), // Rule ID 797 //
     /* 141729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 141737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 141740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 141743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141751 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 141751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 141754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141758 */     GIR_RootConstrainSelectedInstOperands,
     /* 141759 */     // GIR_Coverage, 797,
     /* 141759 */     GIR_EraseRootFromParent_Done,
     /* 141760 */   // Label 2769: @141760
     /* 141760 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(141796), // Rule ID 798 //
     /* 141765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 141773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 141776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 141779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141787 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 141787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 141790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141794 */     GIR_RootConstrainSelectedInstOperands,
     /* 141795 */     // GIR_Coverage, 798,
     /* 141795 */     GIR_EraseRootFromParent_Done,
     /* 141796 */   // Label 2770: @141796
     /* 141796 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(141832), // Rule ID 799 //
     /* 141801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 141804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 141812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 141815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141823 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 141823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 141826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141830 */     GIR_RootConstrainSelectedInstOperands,
     /* 141831 */     // GIR_Coverage, 799,
     /* 141831 */     GIR_EraseRootFromParent_Done,
     /* 141832 */   // Label 2771: @141832
     /* 141832 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(141868), // Rule ID 800 //
     /* 141837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 141840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 141848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 141851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141859 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 141859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 141862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141866 */     GIR_RootConstrainSelectedInstOperands,
     /* 141867 */     // GIR_Coverage, 800,
     /* 141867 */     GIR_EraseRootFromParent_Done,
     /* 141868 */   // Label 2772: @141868
     /* 141868 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(141904), // Rule ID 801 //
     /* 141873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 141884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 141887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141895 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 141895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 141898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141902 */     GIR_RootConstrainSelectedInstOperands,
     /* 141903 */     // GIR_Coverage, 801,
     /* 141903 */     GIR_EraseRootFromParent_Done,
     /* 141904 */   // Label 2773: @141904
     /* 141904 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(141940), // Rule ID 802 //
     /* 141909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 141920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 141923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141931 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 141931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 141934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141938 */     GIR_RootConstrainSelectedInstOperands,
     /* 141939 */     // GIR_Coverage, 802,
     /* 141939 */     GIR_EraseRootFromParent_Done,
     /* 141940 */   // Label 2774: @141940
     /* 141940 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(141976), // Rule ID 803 //
     /* 141945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 141956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 141959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141967 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 141967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 141970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141974 */     GIR_RootConstrainSelectedInstOperands,
     /* 141975 */     // GIR_Coverage, 803,
     /* 141975 */     GIR_EraseRootFromParent_Done,
     /* 141976 */   // Label 2775: @141976
     /* 141976 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(142012), // Rule ID 804 //
     /* 141981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 141984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 141992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 141995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142003 */     // (intrinsic_wo_chain:{ *:[v4i16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 142006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142010 */     GIR_RootConstrainSelectedInstOperands,
     /* 142011 */     // GIR_Coverage, 804,
     /* 142011 */     GIR_EraseRootFromParent_Done,
     /* 142012 */   // Label 2776: @142012
     /* 142012 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(142048), // Rule ID 805 //
     /* 142017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142039 */     // (intrinsic_wo_chain:{ *:[v8i16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 142042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142046 */     GIR_RootConstrainSelectedInstOperands,
     /* 142047 */     // GIR_Coverage, 805,
     /* 142047 */     GIR_EraseRootFromParent_Done,
     /* 142048 */   // Label 2777: @142048
     /* 142048 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(142084), // Rule ID 806 //
     /* 142053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142075 */     // (intrinsic_wo_chain:{ *:[v2i32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 142078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142082 */     GIR_RootConstrainSelectedInstOperands,
     /* 142083 */     // GIR_Coverage, 806,
     /* 142083 */     GIR_EraseRootFromParent_Done,
     /* 142084 */   // Label 2778: @142084
     /* 142084 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(142120), // Rule ID 807 //
     /* 142089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142111 */     // (intrinsic_wo_chain:{ *:[v4i32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 142114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142118 */     GIR_RootConstrainSelectedInstOperands,
     /* 142119 */     // GIR_Coverage, 807,
     /* 142119 */     GIR_EraseRootFromParent_Done,
     /* 142120 */   // Label 2779: @142120
     /* 142120 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(142156), // Rule ID 808 //
     /* 142125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142147 */     // (intrinsic_wo_chain:{ *:[v2i64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 142150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142154 */     GIR_RootConstrainSelectedInstOperands,
     /* 142155 */     // GIR_Coverage, 808,
     /* 142155 */     GIR_EraseRootFromParent_Done,
     /* 142156 */   // Label 2780: @142156
     /* 142156 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(142192), // Rule ID 809 //
     /* 142161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142183 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 142186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142190 */     GIR_RootConstrainSelectedInstOperands,
     /* 142191 */     // GIR_Coverage, 809,
     /* 142191 */     GIR_EraseRootFromParent_Done,
     /* 142192 */   // Label 2781: @142192
     /* 142192 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(142228), // Rule ID 810 //
     /* 142197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142219 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 142222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142226 */     GIR_RootConstrainSelectedInstOperands,
     /* 142227 */     // GIR_Coverage, 810,
     /* 142227 */     GIR_EraseRootFromParent_Done,
     /* 142228 */   // Label 2782: @142228
     /* 142228 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(142264), // Rule ID 811 //
     /* 142233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142255 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 142258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142262 */     GIR_RootConstrainSelectedInstOperands,
     /* 142263 */     // GIR_Coverage, 811,
     /* 142263 */     GIR_EraseRootFromParent_Done,
     /* 142264 */   // Label 2783: @142264
     /* 142264 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(142300), // Rule ID 812 //
     /* 142269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142291 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 142294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142298 */     GIR_RootConstrainSelectedInstOperands,
     /* 142299 */     // GIR_Coverage, 812,
     /* 142299 */     GIR_EraseRootFromParent_Done,
     /* 142300 */   // Label 2784: @142300
     /* 142300 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(142336), // Rule ID 813 //
     /* 142305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142327 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 142330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142334 */     GIR_RootConstrainSelectedInstOperands,
     /* 142335 */     // GIR_Coverage, 813,
     /* 142335 */     GIR_EraseRootFromParent_Done,
     /* 142336 */   // Label 2785: @142336
     /* 142336 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(142372), // Rule ID 814 //
     /* 142341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 142349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142363 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 142366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142370 */     GIR_RootConstrainSelectedInstOperands,
     /* 142371 */     // GIR_Coverage, 814,
     /* 142371 */     GIR_EraseRootFromParent_Done,
     /* 142372 */   // Label 2786: @142372
     /* 142372 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(142408), // Rule ID 815 //
     /* 142377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 142385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142399 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 142402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142406 */     GIR_RootConstrainSelectedInstOperands,
     /* 142407 */     // GIR_Coverage, 815,
     /* 142407 */     GIR_EraseRootFromParent_Done,
     /* 142408 */   // Label 2787: @142408
     /* 142408 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(142444), // Rule ID 816 //
     /* 142413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 142421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142435 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 142438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142442 */     GIR_RootConstrainSelectedInstOperands,
     /* 142443 */     // GIR_Coverage, 816,
     /* 142443 */     GIR_EraseRootFromParent_Done,
     /* 142444 */   // Label 2788: @142444
     /* 142444 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(142480), // Rule ID 817 //
     /* 142449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 142457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142471 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 142474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142478 */     GIR_RootConstrainSelectedInstOperands,
     /* 142479 */     // GIR_Coverage, 817,
     /* 142479 */     GIR_EraseRootFromParent_Done,
     /* 142480 */   // Label 2789: @142480
     /* 142480 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(142516), // Rule ID 818 //
     /* 142485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 142493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142507 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 142510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142514 */     GIR_RootConstrainSelectedInstOperands,
     /* 142515 */     // GIR_Coverage, 818,
     /* 142515 */     GIR_EraseRootFromParent_Done,
     /* 142516 */   // Label 2790: @142516
     /* 142516 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(142552), // Rule ID 819 //
     /* 142521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 142529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142543 */     // (intrinsic_wo_chain:{ *:[v4i16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 142546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142550 */     GIR_RootConstrainSelectedInstOperands,
     /* 142551 */     // GIR_Coverage, 819,
     /* 142551 */     GIR_EraseRootFromParent_Done,
     /* 142552 */   // Label 2791: @142552
     /* 142552 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(142588), // Rule ID 820 //
     /* 142557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 142565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142579 */     // (intrinsic_wo_chain:{ *:[v8i16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 142582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142586 */     GIR_RootConstrainSelectedInstOperands,
     /* 142587 */     // GIR_Coverage, 820,
     /* 142587 */     GIR_EraseRootFromParent_Done,
     /* 142588 */   // Label 2792: @142588
     /* 142588 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(142624), // Rule ID 821 //
     /* 142593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 142601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142615 */     // (intrinsic_wo_chain:{ *:[v2i32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 142618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142622 */     GIR_RootConstrainSelectedInstOperands,
     /* 142623 */     // GIR_Coverage, 821,
     /* 142623 */     GIR_EraseRootFromParent_Done,
     /* 142624 */   // Label 2793: @142624
     /* 142624 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(142660), // Rule ID 822 //
     /* 142629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 142637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142651 */     // (intrinsic_wo_chain:{ *:[v4i32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 142654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142658 */     GIR_RootConstrainSelectedInstOperands,
     /* 142659 */     // GIR_Coverage, 822,
     /* 142659 */     GIR_EraseRootFromParent_Done,
     /* 142660 */   // Label 2794: @142660
     /* 142660 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(142696), // Rule ID 823 //
     /* 142665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 142673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142687 */     // (intrinsic_wo_chain:{ *:[v2i64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 142690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142694 */     GIR_RootConstrainSelectedInstOperands,
     /* 142695 */     // GIR_Coverage, 823,
     /* 142695 */     GIR_EraseRootFromParent_Done,
     /* 142696 */   // Label 2795: @142696
     /* 142696 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(142732), // Rule ID 824 //
     /* 142701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142723 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 142726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142730 */     GIR_RootConstrainSelectedInstOperands,
     /* 142731 */     // GIR_Coverage, 824,
     /* 142731 */     GIR_EraseRootFromParent_Done,
     /* 142732 */   // Label 2796: @142732
     /* 142732 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(142768), // Rule ID 825 //
     /* 142737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142759 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 142762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142766 */     GIR_RootConstrainSelectedInstOperands,
     /* 142767 */     // GIR_Coverage, 825,
     /* 142767 */     GIR_EraseRootFromParent_Done,
     /* 142768 */   // Label 2797: @142768
     /* 142768 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(142804), // Rule ID 826 //
     /* 142773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142795 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 142798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142802 */     GIR_RootConstrainSelectedInstOperands,
     /* 142803 */     // GIR_Coverage, 826,
     /* 142803 */     GIR_EraseRootFromParent_Done,
     /* 142804 */   // Label 2798: @142804
     /* 142804 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(142840), // Rule ID 827 //
     /* 142809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142831 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 142834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142838 */     GIR_RootConstrainSelectedInstOperands,
     /* 142839 */     // GIR_Coverage, 827,
     /* 142839 */     GIR_EraseRootFromParent_Done,
     /* 142840 */   // Label 2799: @142840
     /* 142840 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(142876), // Rule ID 828 //
     /* 142845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142867 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 142870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142874 */     GIR_RootConstrainSelectedInstOperands,
     /* 142875 */     // GIR_Coverage, 828,
     /* 142875 */     GIR_EraseRootFromParent_Done,
     /* 142876 */   // Label 2800: @142876
     /* 142876 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(142912), // Rule ID 829 //
     /* 142881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 142889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142903 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 142903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 142906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142910 */     GIR_RootConstrainSelectedInstOperands,
     /* 142911 */     // GIR_Coverage, 829,
     /* 142911 */     GIR_EraseRootFromParent_Done,
     /* 142912 */   // Label 2801: @142912
     /* 142912 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(142948), // Rule ID 856 //
     /* 142917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 142925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142939 */     // (intrinsic_wo_chain:{ *:[v4f16] } 632:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 142939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 142942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142946 */     GIR_RootConstrainSelectedInstOperands,
     /* 142947 */     // GIR_Coverage, 856,
     /* 142947 */     GIR_EraseRootFromParent_Done,
     /* 142948 */   // Label 2802: @142948
     /* 142948 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(142984), // Rule ID 857 //
     /* 142953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 142961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142975 */     // (intrinsic_wo_chain:{ *:[v8f16] } 632:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 142975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 142978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142982 */     GIR_RootConstrainSelectedInstOperands,
     /* 142983 */     // GIR_Coverage, 857,
     /* 142983 */     GIR_EraseRootFromParent_Done,
     /* 142984 */   // Label 2803: @142984
     /* 142984 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(143020), // Rule ID 858 //
     /* 142989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 142997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143011 */     // (intrinsic_wo_chain:{ *:[v2f32] } 632:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 143014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143018 */     GIR_RootConstrainSelectedInstOperands,
     /* 143019 */     // GIR_Coverage, 858,
     /* 143019 */     GIR_EraseRootFromParent_Done,
     /* 143020 */   // Label 2804: @143020
     /* 143020 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(143056), // Rule ID 859 //
     /* 143025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143047 */     // (intrinsic_wo_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 143047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 143050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143054 */     GIR_RootConstrainSelectedInstOperands,
     /* 143055 */     // GIR_Coverage, 859,
     /* 143055 */     GIR_EraseRootFromParent_Done,
     /* 143056 */   // Label 2805: @143056
     /* 143056 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(143092), // Rule ID 860 //
     /* 143061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143083 */     // (intrinsic_wo_chain:{ *:[v2f64] } 632:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 143083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 143086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143090 */     GIR_RootConstrainSelectedInstOperands,
     /* 143091 */     // GIR_Coverage, 860,
     /* 143091 */     GIR_EraseRootFromParent_Done,
     /* 143092 */   // Label 2806: @143092
     /* 143092 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(143128), // Rule ID 931 //
     /* 143097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 143105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143119 */     // (intrinsic_wo_chain:{ *:[v2f32] } 636:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 143122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143126 */     GIR_RootConstrainSelectedInstOperands,
     /* 143127 */     // GIR_Coverage, 931,
     /* 143127 */     GIR_EraseRootFromParent_Done,
     /* 143128 */   // Label 2807: @143128
     /* 143128 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(143164), // Rule ID 932 //
     /* 143133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 143141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143155 */     // (intrinsic_wo_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 143155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 143158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143162 */     GIR_RootConstrainSelectedInstOperands,
     /* 143163 */     // GIR_Coverage, 932,
     /* 143163 */     GIR_EraseRootFromParent_Done,
     /* 143164 */   // Label 2808: @143164
     /* 143164 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(143200), // Rule ID 933 //
     /* 143169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 143177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143191 */     // (intrinsic_wo_chain:{ *:[v2f64] } 636:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 143191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 143194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143198 */     GIR_RootConstrainSelectedInstOperands,
     /* 143199 */     // GIR_Coverage, 933,
     /* 143199 */     GIR_EraseRootFromParent_Done,
     /* 143200 */   // Label 2809: @143200
     /* 143200 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(143236), // Rule ID 934 //
     /* 143205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 143213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143227 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 143230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143234 */     GIR_RootConstrainSelectedInstOperands,
     /* 143235 */     // GIR_Coverage, 934,
     /* 143235 */     GIR_EraseRootFromParent_Done,
     /* 143236 */   // Label 2810: @143236
     /* 143236 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(143272), // Rule ID 935 //
     /* 143241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 143249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143263 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 143263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 143266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143270 */     GIR_RootConstrainSelectedInstOperands,
     /* 143271 */     // GIR_Coverage, 935,
     /* 143271 */     GIR_EraseRootFromParent_Done,
     /* 143272 */   // Label 2811: @143272
     /* 143272 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(143308), // Rule ID 936 //
     /* 143277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 143285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143299 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 143299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 143302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143306 */     GIR_RootConstrainSelectedInstOperands,
     /* 143307 */     // GIR_Coverage, 936,
     /* 143307 */     GIR_EraseRootFromParent_Done,
     /* 143308 */   // Label 2812: @143308
     /* 143308 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(143344), // Rule ID 937 //
     /* 143313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 143321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143335 */     // (intrinsic_wo_chain:{ *:[v2f32] } 635:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 143338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143342 */     GIR_RootConstrainSelectedInstOperands,
     /* 143343 */     // GIR_Coverage, 937,
     /* 143343 */     GIR_EraseRootFromParent_Done,
     /* 143344 */   // Label 2813: @143344
     /* 143344 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(143380), // Rule ID 938 //
     /* 143349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 143357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143371 */     // (intrinsic_wo_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 143371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 143374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143378 */     GIR_RootConstrainSelectedInstOperands,
     /* 143379 */     // GIR_Coverage, 938,
     /* 143379 */     GIR_EraseRootFromParent_Done,
     /* 143380 */   // Label 2814: @143380
     /* 143380 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(143416), // Rule ID 939 //
     /* 143385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 143393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143407 */     // (intrinsic_wo_chain:{ *:[v2f64] } 635:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 143407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 143410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143414 */     GIR_RootConstrainSelectedInstOperands,
     /* 143415 */     // GIR_Coverage, 939,
     /* 143415 */     GIR_EraseRootFromParent_Done,
     /* 143416 */   // Label 2815: @143416
     /* 143416 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(143452), // Rule ID 940 //
     /* 143421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 143429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143443 */     // (intrinsic_wo_chain:{ *:[v2f32] } 637:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 143446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143450 */     GIR_RootConstrainSelectedInstOperands,
     /* 143451 */     // GIR_Coverage, 940,
     /* 143451 */     GIR_EraseRootFromParent_Done,
     /* 143452 */   // Label 2816: @143452
     /* 143452 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(143488), // Rule ID 941 //
     /* 143457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 143465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143479 */     // (intrinsic_wo_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 143479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 143482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143486 */     GIR_RootConstrainSelectedInstOperands,
     /* 143487 */     // GIR_Coverage, 941,
     /* 143487 */     GIR_EraseRootFromParent_Done,
     /* 143488 */   // Label 2817: @143488
     /* 143488 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(143524), // Rule ID 942 //
     /* 143493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 143501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143515 */     // (intrinsic_wo_chain:{ *:[v2f64] } 637:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 143515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 143518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143522 */     GIR_RootConstrainSelectedInstOperands,
     /* 143523 */     // GIR_Coverage, 942,
     /* 143523 */     GIR_EraseRootFromParent_Done,
     /* 143524 */   // Label 2818: @143524
     /* 143524 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(143560), // Rule ID 943 //
     /* 143529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 143537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143551 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 143551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 143554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143558 */     GIR_RootConstrainSelectedInstOperands,
     /* 143559 */     // GIR_Coverage, 943,
     /* 143559 */     GIR_EraseRootFromParent_Done,
     /* 143560 */   // Label 2819: @143560
     /* 143560 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(143596), // Rule ID 944 //
     /* 143565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 143573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143587 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 143587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 143590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143594 */     GIR_RootConstrainSelectedInstOperands,
     /* 143595 */     // GIR_Coverage, 944,
     /* 143595 */     GIR_EraseRootFromParent_Done,
     /* 143596 */   // Label 2820: @143596
     /* 143596 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(143632), // Rule ID 945 //
     /* 143601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 143609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143623 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 143626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143630 */     GIR_RootConstrainSelectedInstOperands,
     /* 143631 */     // GIR_Coverage, 945,
     /* 143631 */     GIR_EraseRootFromParent_Done,
     /* 143632 */   // Label 2821: @143632
     /* 143632 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(143668), // Rule ID 946 //
     /* 143637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 143645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143659 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 143659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 143662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143666 */     GIR_RootConstrainSelectedInstOperands,
     /* 143667 */     // GIR_Coverage, 946,
     /* 143667 */     GIR_EraseRootFromParent_Done,
     /* 143668 */   // Label 2822: @143668
     /* 143668 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(143704), // Rule ID 947 //
     /* 143673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 143681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143695 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 143695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 143698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143702 */     GIR_RootConstrainSelectedInstOperands,
     /* 143703 */     // GIR_Coverage, 947,
     /* 143703 */     GIR_EraseRootFromParent_Done,
     /* 143704 */   // Label 2823: @143704
     /* 143704 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(143740), // Rule ID 994 //
     /* 143709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 143717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 143723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143731 */     // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 143731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 143734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143738 */     GIR_RootConstrainSelectedInstOperands,
     /* 143739 */     // GIR_Coverage, 994,
     /* 143739 */     GIR_EraseRootFromParent_Done,
     /* 143740 */   // Label 2824: @143740
     /* 143740 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(143776), // Rule ID 996 //
     /* 143745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 143753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 143759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143767 */     // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 143767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 143770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143774 */     GIR_RootConstrainSelectedInstOperands,
     /* 143775 */     // GIR_Coverage, 996,
     /* 143775 */     GIR_EraseRootFromParent_Done,
     /* 143776 */   // Label 2825: @143776
     /* 143776 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(143812), // Rule ID 998 //
     /* 143781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 143789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143803 */     // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 143803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 143806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143810 */     GIR_RootConstrainSelectedInstOperands,
     /* 143811 */     // GIR_Coverage, 998,
     /* 143811 */     GIR_EraseRootFromParent_Done,
     /* 143812 */   // Label 2826: @143812
     /* 143812 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(143848), // Rule ID 1000 //
     /* 143817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 143825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143839 */     // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 143839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 143842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143846 */     GIR_RootConstrainSelectedInstOperands,
     /* 143847 */     // GIR_Coverage, 1000,
     /* 143847 */     GIR_EraseRootFromParent_Done,
     /* 143848 */   // Label 2827: @143848
     /* 143848 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(143884), // Rule ID 1002 //
     /* 143853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 143861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 143864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143875 */     // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 143875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 143878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143882 */     GIR_RootConstrainSelectedInstOperands,
     /* 143883 */     // GIR_Coverage, 1002,
     /* 143883 */     GIR_EraseRootFromParent_Done,
     /* 143884 */   // Label 2828: @143884
     /* 143884 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(143920), // Rule ID 1004 //
     /* 143889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 143897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143911 */     // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 143911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 143914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143918 */     GIR_RootConstrainSelectedInstOperands,
     /* 143919 */     // GIR_Coverage, 1004,
     /* 143919 */     GIR_EraseRootFromParent_Done,
     /* 143920 */   // Label 2829: @143920
     /* 143920 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(143956), // Rule ID 1015 //
     /* 143925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 143933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 143936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 143939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143947 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 143947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 143950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143954 */     GIR_RootConstrainSelectedInstOperands,
     /* 143955 */     // GIR_Coverage, 1015,
     /* 143955 */     GIR_EraseRootFromParent_Done,
     /* 143956 */   // Label 2830: @143956
     /* 143956 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(143992), // Rule ID 1016 //
     /* 143961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 143969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 143972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 143975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143983 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 143983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 143986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143990 */     GIR_RootConstrainSelectedInstOperands,
     /* 143991 */     // GIR_Coverage, 1016,
     /* 143991 */     GIR_EraseRootFromParent_Done,
     /* 143992 */   // Label 2831: @143992
     /* 143992 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(144028), // Rule ID 1017 //
     /* 143997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144019 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 144019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 144022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144026 */     GIR_RootConstrainSelectedInstOperands,
     /* 144027 */     // GIR_Coverage, 1017,
     /* 144027 */     GIR_EraseRootFromParent_Done,
     /* 144028 */   // Label 2832: @144028
     /* 144028 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(144064), // Rule ID 1018 //
     /* 144033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144055 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 144055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 144058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144062 */     GIR_RootConstrainSelectedInstOperands,
     /* 144063 */     // GIR_Coverage, 1018,
     /* 144063 */     GIR_EraseRootFromParent_Done,
     /* 144064 */   // Label 2833: @144064
     /* 144064 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(144100), // Rule ID 1019 //
     /* 144069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144091 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 144091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 144094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144098 */     GIR_RootConstrainSelectedInstOperands,
     /* 144099 */     // GIR_Coverage, 1019,
     /* 144099 */     GIR_EraseRootFromParent_Done,
     /* 144100 */   // Label 2834: @144100
     /* 144100 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(144136), // Rule ID 1020 //
     /* 144105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144127 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 144127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 144130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144134 */     GIR_RootConstrainSelectedInstOperands,
     /* 144135 */     // GIR_Coverage, 1020,
     /* 144135 */     GIR_EraseRootFromParent_Done,
     /* 144136 */   // Label 2835: @144136
     /* 144136 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(144172), // Rule ID 1021 //
     /* 144141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144163 */     // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 144163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 144166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144170 */     GIR_RootConstrainSelectedInstOperands,
     /* 144171 */     // GIR_Coverage, 1021,
     /* 144171 */     GIR_EraseRootFromParent_Done,
     /* 144172 */   // Label 2836: @144172
     /* 144172 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(144208), // Rule ID 1022 //
     /* 144177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 144188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144199 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 144202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144206 */     GIR_RootConstrainSelectedInstOperands,
     /* 144207 */     // GIR_Coverage, 1022,
     /* 144207 */     GIR_EraseRootFromParent_Done,
     /* 144208 */   // Label 2837: @144208
     /* 144208 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(144244), // Rule ID 1023 //
     /* 144213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 144224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144235 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 144238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144242 */     GIR_RootConstrainSelectedInstOperands,
     /* 144243 */     // GIR_Coverage, 1023,
     /* 144243 */     GIR_EraseRootFromParent_Done,
     /* 144244 */   // Label 2838: @144244
     /* 144244 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(144280), // Rule ID 1024 //
     /* 144249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144271 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 144271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 144274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144278 */     GIR_RootConstrainSelectedInstOperands,
     /* 144279 */     // GIR_Coverage, 1024,
     /* 144279 */     GIR_EraseRootFromParent_Done,
     /* 144280 */   // Label 2839: @144280
     /* 144280 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(144316), // Rule ID 1025 //
     /* 144285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144307 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 144307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 144310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144314 */     GIR_RootConstrainSelectedInstOperands,
     /* 144315 */     // GIR_Coverage, 1025,
     /* 144315 */     GIR_EraseRootFromParent_Done,
     /* 144316 */   // Label 2840: @144316
     /* 144316 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(144352), // Rule ID 1026 //
     /* 144321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144343 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 144343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 144346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144350 */     GIR_RootConstrainSelectedInstOperands,
     /* 144351 */     // GIR_Coverage, 1026,
     /* 144351 */     GIR_EraseRootFromParent_Done,
     /* 144352 */   // Label 2841: @144352
     /* 144352 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(144388), // Rule ID 1027 //
     /* 144357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144379 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 144379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 144382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144386 */     GIR_RootConstrainSelectedInstOperands,
     /* 144387 */     // GIR_Coverage, 1027,
     /* 144387 */     GIR_EraseRootFromParent_Done,
     /* 144388 */   // Label 2842: @144388
     /* 144388 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(144424), // Rule ID 1028 //
     /* 144393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144415 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 144415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 144418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144422 */     GIR_RootConstrainSelectedInstOperands,
     /* 144423 */     // GIR_Coverage, 1028,
     /* 144423 */     GIR_EraseRootFromParent_Done,
     /* 144424 */   // Label 2843: @144424
     /* 144424 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(144460), // Rule ID 1055 //
     /* 144429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 144437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144451 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 144451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 144454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144458 */     GIR_RootConstrainSelectedInstOperands,
     /* 144459 */     // GIR_Coverage, 1055,
     /* 144459 */     GIR_EraseRootFromParent_Done,
     /* 144460 */   // Label 2844: @144460
     /* 144460 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(144496), // Rule ID 1057 //
     /* 144465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 144473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144487 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 144487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 144490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144494 */     GIR_RootConstrainSelectedInstOperands,
     /* 144495 */     // GIR_Coverage, 1057,
     /* 144495 */     GIR_EraseRootFromParent_Done,
     /* 144496 */   // Label 2845: @144496
     /* 144496 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(144532), // Rule ID 1059 //
     /* 144501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 144509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144523 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 144523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 144526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144530 */     GIR_RootConstrainSelectedInstOperands,
     /* 144531 */     // GIR_Coverage, 1059,
     /* 144531 */     GIR_EraseRootFromParent_Done,
     /* 144532 */   // Label 2846: @144532
     /* 144532 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(144568), // Rule ID 1061 //
     /* 144537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 144545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144559 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 144559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 144562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144566 */     GIR_RootConstrainSelectedInstOperands,
     /* 144567 */     // GIR_Coverage, 1061,
     /* 144567 */     GIR_EraseRootFromParent_Done,
     /* 144568 */   // Label 2847: @144568
     /* 144568 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(144604), // Rule ID 1063 //
     /* 144573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 144581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144595 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 144595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 144598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144602 */     GIR_RootConstrainSelectedInstOperands,
     /* 144603 */     // GIR_Coverage, 1063,
     /* 144603 */     GIR_EraseRootFromParent_Done,
     /* 144604 */   // Label 2848: @144604
     /* 144604 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(144640), // Rule ID 1065 //
     /* 144609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 144617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144631 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 144631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 144634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144638 */     GIR_RootConstrainSelectedInstOperands,
     /* 144639 */     // GIR_Coverage, 1065,
     /* 144639 */     GIR_EraseRootFromParent_Done,
     /* 144640 */   // Label 2849: @144640
     /* 144640 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(144676), // Rule ID 1079 //
     /* 144645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 144653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144667 */     // (intrinsic_wo_chain:{ *:[v2i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 144667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 144670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144674 */     GIR_RootConstrainSelectedInstOperands,
     /* 144675 */     // GIR_Coverage, 1079,
     /* 144675 */     GIR_EraseRootFromParent_Done,
     /* 144676 */   // Label 2850: @144676
     /* 144676 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(144712), // Rule ID 1080 //
     /* 144681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 144689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144703 */     // (intrinsic_wo_chain:{ *:[v4i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 144703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 144706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144710 */     GIR_RootConstrainSelectedInstOperands,
     /* 144711 */     // GIR_Coverage, 1080,
     /* 144711 */     GIR_EraseRootFromParent_Done,
     /* 144712 */   // Label 2851: @144712
     /* 144712 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(144748), // Rule ID 1081 //
     /* 144717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 144725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144739 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 144739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 144742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144746 */     GIR_RootConstrainSelectedInstOperands,
     /* 144747 */     // GIR_Coverage, 1081,
     /* 144747 */     GIR_EraseRootFromParent_Done,
     /* 144748 */   // Label 2852: @144748
     /* 144748 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(144784), // Rule ID 1082 //
     /* 144753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 144761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144775 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 144775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 144778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144782 */     GIR_RootConstrainSelectedInstOperands,
     /* 144783 */     // GIR_Coverage, 1082,
     /* 144783 */     GIR_EraseRootFromParent_Done,
     /* 144784 */   // Label 2853: @144784
     /* 144784 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(144820), // Rule ID 1646 //
     /* 144789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 144797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144811 */     // (intrinsic_wo_chain:{ *:[f32] } 786:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 144811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 144814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144818 */     GIR_RootConstrainSelectedInstOperands,
     /* 144819 */     // GIR_Coverage, 1646,
     /* 144819 */     GIR_EraseRootFromParent_Done,
     /* 144820 */   // Label 2854: @144820
     /* 144820 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(144856), // Rule ID 1652 //
     /* 144825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144847 */     // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 144847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 144850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144854 */     GIR_RootConstrainSelectedInstOperands,
     /* 144855 */     // GIR_Coverage, 1652,
     /* 144855 */     GIR_EraseRootFromParent_Done,
     /* 144856 */   // Label 2855: @144856
     /* 144856 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(144892), // Rule ID 1653 //
     /* 144861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144883 */     // (intrinsic_wo_chain:{ *:[i32] } 678:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 144883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 144886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144890 */     GIR_RootConstrainSelectedInstOperands,
     /* 144891 */     // GIR_Coverage, 1653,
     /* 144891 */     GIR_EraseRootFromParent_Done,
     /* 144892 */   // Label 2856: @144892
     /* 144892 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(144928), // Rule ID 1654 //
     /* 144897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144919 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 144919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 144922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144926 */     GIR_RootConstrainSelectedInstOperands,
     /* 144927 */     // GIR_Coverage, 1654,
     /* 144927 */     GIR_EraseRootFromParent_Done,
     /* 144928 */   // Label 2857: @144928
     /* 144928 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(144964), // Rule ID 1655 //
     /* 144933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144955 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 144955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 144958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144962 */     GIR_RootConstrainSelectedInstOperands,
     /* 144963 */     // GIR_Coverage, 1655,
     /* 144963 */     GIR_EraseRootFromParent_Done,
     /* 144964 */   // Label 2858: @144964
     /* 144964 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(145000), // Rule ID 1656 //
     /* 144969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 144977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 144980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 144987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144991 */     // (intrinsic_wo_chain:{ *:[f32] } 663:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 144991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 144994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144998 */     GIR_RootConstrainSelectedInstOperands,
     /* 144999 */     // GIR_Coverage, 1656,
     /* 144999 */     GIR_EraseRootFromParent_Done,
     /* 145000 */   // Label 2859: @145000
     /* 145000 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(145036), // Rule ID 1657 //
     /* 145005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 145013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145027 */     // (intrinsic_wo_chain:{ *:[f32] } 664:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 145027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 145030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145034 */     GIR_RootConstrainSelectedInstOperands,
     /* 145035 */     // GIR_Coverage, 1657,
     /* 145035 */     GIR_EraseRootFromParent_Done,
     /* 145036 */   // Label 2860: @145036
     /* 145036 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(145072), // Rule ID 1663 //
     /* 145041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 145049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145063 */     // (intrinsic_wo_chain:{ *:[f32] } 665:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 145063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 145066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145070 */     GIR_RootConstrainSelectedInstOperands,
     /* 145071 */     // GIR_Coverage, 1663,
     /* 145071 */     GIR_EraseRootFromParent_Done,
     /* 145072 */   // Label 2861: @145072
     /* 145072 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(145108), // Rule ID 1936 //
     /* 145077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 145085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145099 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 145099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 145102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145106 */     GIR_RootConstrainSelectedInstOperands,
     /* 145107 */     // GIR_Coverage, 1936,
     /* 145107 */     GIR_EraseRootFromParent_Done,
     /* 145108 */   // Label 2862: @145108
     /* 145108 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(145144), // Rule ID 1938 //
     /* 145113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 145121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145135 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 145135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 145138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145142 */     GIR_RootConstrainSelectedInstOperands,
     /* 145143 */     // GIR_Coverage, 1938,
     /* 145143 */     GIR_EraseRootFromParent_Done,
     /* 145144 */   // Label 2863: @145144
     /* 145144 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(145180), // Rule ID 1940 //
     /* 145149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 145157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145171 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 145171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 145174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145178 */     GIR_RootConstrainSelectedInstOperands,
     /* 145179 */     // GIR_Coverage, 1940,
     /* 145179 */     GIR_EraseRootFromParent_Done,
     /* 145180 */   // Label 2864: @145180
     /* 145180 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(145216), // Rule ID 1942 //
     /* 145185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 145193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145207 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 145207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 145210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145214 */     GIR_RootConstrainSelectedInstOperands,
     /* 145215 */     // GIR_Coverage, 1942,
     /* 145215 */     GIR_EraseRootFromParent_Done,
     /* 145216 */   // Label 2865: @145216
     /* 145216 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(145252), // Rule ID 1944 //
     /* 145221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 145229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145243 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 145243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 145246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145250 */     GIR_RootConstrainSelectedInstOperands,
     /* 145251 */     // GIR_Coverage, 1944,
     /* 145251 */     GIR_EraseRootFromParent_Done,
     /* 145252 */   // Label 2866: @145252
     /* 145252 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(145288), // Rule ID 1946 //
     /* 145257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 145265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145279 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 145279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 145282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145286 */     GIR_RootConstrainSelectedInstOperands,
     /* 145287 */     // GIR_Coverage, 1946,
     /* 145287 */     GIR_EraseRootFromParent_Done,
     /* 145288 */   // Label 2867: @145288
     /* 145288 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(145324), // Rule ID 1948 //
     /* 145293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 145301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145315 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 145315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 145318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145322 */     GIR_RootConstrainSelectedInstOperands,
     /* 145323 */     // GIR_Coverage, 1948,
     /* 145323 */     GIR_EraseRootFromParent_Done,
     /* 145324 */   // Label 2868: @145324
     /* 145324 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(145360), // Rule ID 1950 //
     /* 145329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 145337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145351 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 145351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 145354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145358 */     GIR_RootConstrainSelectedInstOperands,
     /* 145359 */     // GIR_Coverage, 1950,
     /* 145359 */     GIR_EraseRootFromParent_Done,
     /* 145360 */   // Label 2869: @145360
     /* 145360 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(145396), // Rule ID 1952 //
     /* 145365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 145373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145387 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 145387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 145390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145394 */     GIR_RootConstrainSelectedInstOperands,
     /* 145395 */     // GIR_Coverage, 1952,
     /* 145395 */     GIR_EraseRootFromParent_Done,
     /* 145396 */   // Label 2870: @145396
     /* 145396 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(145432), // Rule ID 1954 //
     /* 145401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 145409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145423 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 145423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 145426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145430 */     GIR_RootConstrainSelectedInstOperands,
     /* 145431 */     // GIR_Coverage, 1954,
     /* 145431 */     GIR_EraseRootFromParent_Done,
     /* 145432 */   // Label 2871: @145432
     /* 145432 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(145468), // Rule ID 1956 //
     /* 145437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 145445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145459 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 145459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 145462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145466 */     GIR_RootConstrainSelectedInstOperands,
     /* 145467 */     // GIR_Coverage, 1956,
     /* 145467 */     GIR_EraseRootFromParent_Done,
     /* 145468 */   // Label 2872: @145468
     /* 145468 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(145504), // Rule ID 1958 //
     /* 145473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 145481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145495 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 145495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 145498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145502 */     GIR_RootConstrainSelectedInstOperands,
     /* 145503 */     // GIR_Coverage, 1958,
     /* 145503 */     GIR_EraseRootFromParent_Done,
     /* 145504 */   // Label 2873: @145504
     /* 145504 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(145540), // Rule ID 2296 //
     /* 145509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 145512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 145517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 145520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145531 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 145531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 145534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145538 */     GIR_RootConstrainSelectedInstOperands,
     /* 145539 */     // GIR_Coverage, 2296,
     /* 145539 */     GIR_EraseRootFromParent_Done,
     /* 145540 */   // Label 2874: @145540
     /* 145540 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(145576), // Rule ID 2297 //
     /* 145545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 145548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 145553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 145556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145567 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 145567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 145570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145574 */     GIR_RootConstrainSelectedInstOperands,
     /* 145575 */     // GIR_Coverage, 2297,
     /* 145575 */     GIR_EraseRootFromParent_Done,
     /* 145576 */   // Label 2875: @145576
     /* 145576 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(145612), // Rule ID 2305 //
     /* 145581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 145584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 145589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145603 */     // (intrinsic_wo_chain:{ *:[i32] } 521:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 145603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 145606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145610 */     GIR_RootConstrainSelectedInstOperands,
     /* 145611 */     // GIR_Coverage, 2305,
     /* 145611 */     GIR_EraseRootFromParent_Done,
     /* 145612 */   // Label 2876: @145612
     /* 145612 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(145648), // Rule ID 2506 //
     /* 145617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145639 */     // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 145639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 145642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145646 */     GIR_RootConstrainSelectedInstOperands,
     /* 145647 */     // GIR_Coverage, 2506,
     /* 145647 */     GIR_EraseRootFromParent_Done,
     /* 145648 */   // Label 2877: @145648
     /* 145648 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(145687), // Rule ID 3539 //
     /* 145653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 145656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 145661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 145664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 145667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145675 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1613:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 145675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 145678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 145682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145685 */     GIR_RootConstrainSelectedInstOperands,
     /* 145686 */     // GIR_Coverage, 3539,
     /* 145686 */     GIR_EraseRootFromParent_Done,
     /* 145687 */   // Label 2878: @145687
     /* 145687 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(145726), // Rule ID 3540 //
     /* 145692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 145695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 145700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 145703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 145706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145714 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1613:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 145714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 145717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 145721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145724 */     GIR_RootConstrainSelectedInstOperands,
     /* 145725 */     // GIR_Coverage, 3540,
     /* 145725 */     GIR_EraseRootFromParent_Done,
     /* 145726 */   // Label 2879: @145726
     /* 145726 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(145765), // Rule ID 3541 //
     /* 145731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 145734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 145739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 145742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 145745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145753 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1613:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 145753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 145756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 145760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145763 */     GIR_RootConstrainSelectedInstOperands,
     /* 145764 */     // GIR_Coverage, 3541,
     /* 145764 */     GIR_EraseRootFromParent_Done,
     /* 145765 */   // Label 2880: @145765
     /* 145765 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(145804), // Rule ID 3542 //
     /* 145770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 145773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 145778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 145781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 145784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145792 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1613:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 145792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 145795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 145797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 145799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145802 */     GIR_RootConstrainSelectedInstOperands,
     /* 145803 */     // GIR_Coverage, 3542,
     /* 145803 */     GIR_EraseRootFromParent_Done,
     /* 145804 */   // Label 2881: @145804
     /* 145804 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(145860), // Rule ID 3546 //
     /* 145809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 145812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 145817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 145820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 145823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145831 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1615:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 145831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 145834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 145838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 145845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 145848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 145858 */     GIR_RootConstrainSelectedInstOperands,
     /* 145859 */     // GIR_Coverage, 3546,
     /* 145859 */     GIR_EraseRootFromParent_Done,
     /* 145860 */   // Label 2882: @145860
     /* 145860 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(145916), // Rule ID 3547 //
     /* 145865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 145868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 145873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 145876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 145879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145887 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1615:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 145887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 145890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 145894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 145901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 145904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 145914 */     GIR_RootConstrainSelectedInstOperands,
     /* 145915 */     // GIR_Coverage, 3547,
     /* 145915 */     GIR_EraseRootFromParent_Done,
     /* 145916 */   // Label 2883: @145916
     /* 145916 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(145972), // Rule ID 3548 //
     /* 145921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 145924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 145929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 145932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 145935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145943 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1615:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 145943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 145946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 145950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 145957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 145960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 145962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 145968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 145970 */     GIR_RootConstrainSelectedInstOperands,
     /* 145971 */     // GIR_Coverage, 3548,
     /* 145971 */     GIR_EraseRootFromParent_Done,
     /* 145972 */   // Label 2884: @145972
     /* 145972 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(146028), // Rule ID 3549 //
     /* 145977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 145980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 145985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 145988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 145991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 145995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 145999 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1615:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 145999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 146002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 146016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 146026 */     GIR_RootConstrainSelectedInstOperands,
     /* 146027 */     // GIR_Coverage, 3549,
     /* 146027 */     GIR_EraseRootFromParent_Done,
     /* 146028 */   // Label 2885: @146028
     /* 146028 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(146061), // Rule ID 3990 //
     /* 146033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 146038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146052 */     // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 146052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 146055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146059 */     GIR_RootConstrainSelectedInstOperands,
     /* 146060 */     // GIR_Coverage, 3990,
     /* 146060 */     GIR_EraseRootFromParent_Done,
     /* 146061 */   // Label 2886: @146061
     /* 146061 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(146126), // Rule ID 3991 //
     /* 146066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 146071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146085 */     // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 146085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 146088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 146092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146097 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146108 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 146115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146125 */     // GIR_Coverage, 3991,
     /* 146125 */     GIR_EraseRootFromParent_Done,
     /* 146126 */   // Label 2887: @146126
     /* 146126 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(146159), // Rule ID 4759 //
     /* 146131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 146136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146150 */     // (intrinsic_wo_chain:{ *:[v1f64] } 636:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 146153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146157 */     GIR_RootConstrainSelectedInstOperands,
     /* 146158 */     // GIR_Coverage, 4759,
     /* 146158 */     GIR_EraseRootFromParent_Done,
     /* 146159 */   // Label 2888: @146159
     /* 146159 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(146192), // Rule ID 4760 //
     /* 146164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 146169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146183 */     // (intrinsic_wo_chain:{ *:[v1f64] } 638:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 146186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146190 */     GIR_RootConstrainSelectedInstOperands,
     /* 146191 */     // GIR_Coverage, 4760,
     /* 146191 */     GIR_EraseRootFromParent_Done,
     /* 146192 */   // Label 2889: @146192
     /* 146192 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(146225), // Rule ID 4761 //
     /* 146197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 146202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146216 */     // (intrinsic_wo_chain:{ *:[v1f64] } 635:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 146219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146223 */     GIR_RootConstrainSelectedInstOperands,
     /* 146224 */     // GIR_Coverage, 4761,
     /* 146224 */     GIR_EraseRootFromParent_Done,
     /* 146225 */   // Label 2890: @146225
     /* 146225 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(146258), // Rule ID 4762 //
     /* 146230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 146235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146249 */     // (intrinsic_wo_chain:{ *:[v1f64] } 637:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 146252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146256 */     GIR_RootConstrainSelectedInstOperands,
     /* 146257 */     // GIR_Coverage, 4762,
     /* 146257 */     GIR_EraseRootFromParent_Done,
     /* 146258 */   // Label 2891: @146258
     /* 146258 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(146291), // Rule ID 4876 //
     /* 146263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 146268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146282 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 146282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 146285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146289 */     GIR_RootConstrainSelectedInstOperands,
     /* 146290 */     // GIR_Coverage, 4876,
     /* 146290 */     GIR_EraseRootFromParent_Done,
     /* 146291 */   // Label 2892: @146291
     /* 146291 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(146324), // Rule ID 4886 //
     /* 146296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 146301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 146304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146315 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 146315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 146318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146322 */     GIR_RootConstrainSelectedInstOperands,
     /* 146323 */     // GIR_Coverage, 4886,
     /* 146323 */     GIR_EraseRootFromParent_Done,
     /* 146324 */   // Label 2893: @146324
     /* 146324 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(146360), // Rule ID 5224 //
     /* 146329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 146337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146351 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 146351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 146354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146358 */     GIR_RootConstrainSelectedInstOperands,
     /* 146359 */     // GIR_Coverage, 5224,
     /* 146359 */     GIR_EraseRootFromParent_Done,
     /* 146360 */   // Label 2894: @146360
     /* 146360 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(146393), // Rule ID 5227 //
     /* 146365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 146370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146384 */     // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 146387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146391 */     GIR_RootConstrainSelectedInstOperands,
     /* 146392 */     // GIR_Coverage, 5227,
     /* 146392 */     GIR_EraseRootFromParent_Done,
     /* 146393 */   // Label 2895: @146393
     /* 146393 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(146426), // Rule ID 5228 //
     /* 146398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 146403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146417 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 146420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146424 */     GIR_RootConstrainSelectedInstOperands,
     /* 146425 */     // GIR_Coverage, 5228,
     /* 146425 */     GIR_EraseRootFromParent_Done,
     /* 146426 */   // Label 2896: @146426
     /* 146426 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(146459), // Rule ID 5229 //
     /* 146431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 146436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146450 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 146453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146457 */     GIR_RootConstrainSelectedInstOperands,
     /* 146458 */     // GIR_Coverage, 5229,
     /* 146458 */     GIR_EraseRootFromParent_Done,
     /* 146459 */   // Label 2897: @146459
     /* 146459 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(146492), // Rule ID 5230 //
     /* 146464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 146469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146483 */     // (intrinsic_wo_chain:{ *:[v1i64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 146486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146490 */     GIR_RootConstrainSelectedInstOperands,
     /* 146491 */     // GIR_Coverage, 5230,
     /* 146491 */     GIR_EraseRootFromParent_Done,
     /* 146492 */   // Label 2898: @146492
     /* 146492 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(146525), // Rule ID 5231 //
     /* 146497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 146502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146516 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 146519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146523 */     GIR_RootConstrainSelectedInstOperands,
     /* 146524 */     // GIR_Coverage, 5231,
     /* 146524 */     GIR_EraseRootFromParent_Done,
     /* 146525 */   // Label 2899: @146525
     /* 146525 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(146558), // Rule ID 5232 //
     /* 146530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 146535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146549 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 146552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146556 */     GIR_RootConstrainSelectedInstOperands,
     /* 146557 */     // GIR_Coverage, 5232,
     /* 146557 */     GIR_EraseRootFromParent_Done,
     /* 146558 */   // Label 2900: @146558
     /* 146558 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(146591), // Rule ID 5233 //
     /* 146563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 146568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146582 */     // (intrinsic_wo_chain:{ *:[v1i64] } 589:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 146585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146589 */     GIR_RootConstrainSelectedInstOperands,
     /* 146590 */     // GIR_Coverage, 5233,
     /* 146590 */     GIR_EraseRootFromParent_Done,
     /* 146591 */   // Label 2901: @146591
     /* 146591 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(146624), // Rule ID 5234 //
     /* 146596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 146601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146615 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 146618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146622 */     GIR_RootConstrainSelectedInstOperands,
     /* 146623 */     // GIR_Coverage, 5234,
     /* 146623 */     GIR_EraseRootFromParent_Done,
     /* 146624 */   // Label 2902: @146624
     /* 146624 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(146657), // Rule ID 5235 //
     /* 146629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 146634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146648 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 146651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146655 */     GIR_RootConstrainSelectedInstOperands,
     /* 146656 */     // GIR_Coverage, 5235,
     /* 146656 */     GIR_EraseRootFromParent_Done,
     /* 146657 */   // Label 2903: @146657
     /* 146657 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(146690), // Rule ID 5236 //
     /* 146662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 146667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146681 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 146684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146688 */     GIR_RootConstrainSelectedInstOperands,
     /* 146689 */     // GIR_Coverage, 5236,
     /* 146689 */     GIR_EraseRootFromParent_Done,
     /* 146690 */   // Label 2904: @146690
     /* 146690 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(146723), // Rule ID 5237 //
     /* 146695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 146700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 146706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146714 */     // (intrinsic_wo_chain:{ *:[f16] } 632:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 146714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 146717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146721 */     GIR_RootConstrainSelectedInstOperands,
     /* 146722 */     // GIR_Coverage, 5237,
     /* 146722 */     GIR_EraseRootFromParent_Done,
     /* 146723 */   // Label 2905: @146723
     /* 146723 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(146756), // Rule ID 5238 //
     /* 146728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 146733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146747 */     // (intrinsic_wo_chain:{ *:[f32] } 632:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 146747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 146750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146754 */     GIR_RootConstrainSelectedInstOperands,
     /* 146755 */     // GIR_Coverage, 5238,
     /* 146755 */     GIR_EraseRootFromParent_Done,
     /* 146756 */   // Label 2906: @146756
     /* 146756 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(146789), // Rule ID 5239 //
     /* 146761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 146766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146780 */     // (intrinsic_wo_chain:{ *:[f64] } 632:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 146780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 146783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146787 */     GIR_RootConstrainSelectedInstOperands,
     /* 146788 */     // GIR_Coverage, 5239,
     /* 146788 */     GIR_EraseRootFromParent_Done,
     /* 146789 */   // Label 2907: @146789
     /* 146789 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(146822), // Rule ID 5240 //
     /* 146794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 146799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146813 */     // (intrinsic_wo_chain:{ *:[v1f64] } 632:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 146816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146820 */     GIR_RootConstrainSelectedInstOperands,
     /* 146821 */     // GIR_Coverage, 5240,
     /* 146821 */     GIR_EraseRootFromParent_Done,
     /* 146822 */   // Label 2908: @146822
     /* 146822 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(146855), // Rule ID 5252 //
     /* 146827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 146832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 146838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146846 */     // (intrinsic_wo_chain:{ *:[f16] } 634:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 146846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 146849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146853 */     GIR_RootConstrainSelectedInstOperands,
     /* 146854 */     // GIR_Coverage, 5252,
     /* 146854 */     GIR_EraseRootFromParent_Done,
     /* 146855 */   // Label 2909: @146855
     /* 146855 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(146888), // Rule ID 5253 //
     /* 146860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 146865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146879 */     // (intrinsic_wo_chain:{ *:[f32] } 634:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 146879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 146882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146886 */     GIR_RootConstrainSelectedInstOperands,
     /* 146887 */     // GIR_Coverage, 5253,
     /* 146887 */     GIR_EraseRootFromParent_Done,
     /* 146888 */   // Label 2910: @146888
     /* 146888 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(146921), // Rule ID 5254 //
     /* 146893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 146898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146912 */     // (intrinsic_wo_chain:{ *:[f64] } 634:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 146912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 146915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146919 */     GIR_RootConstrainSelectedInstOperands,
     /* 146920 */     // GIR_Coverage, 5254,
     /* 146920 */     GIR_EraseRootFromParent_Done,
     /* 146921 */   // Label 2911: @146921
     /* 146921 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(146954), // Rule ID 5255 //
     /* 146926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 146931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 146937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146945 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 146945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 146948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146952 */     GIR_RootConstrainSelectedInstOperands,
     /* 146953 */     // GIR_Coverage, 5255,
     /* 146953 */     GIR_EraseRootFromParent_Done,
     /* 146954 */   // Label 2912: @146954
     /* 146954 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(146987), // Rule ID 5256 //
     /* 146959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 146964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146978 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 146978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 146981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146985 */     GIR_RootConstrainSelectedInstOperands,
     /* 146986 */     // GIR_Coverage, 5256,
     /* 146986 */     GIR_EraseRootFromParent_Done,
     /* 146987 */   // Label 2913: @146987
     /* 146987 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(147020), // Rule ID 5257 //
     /* 146992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 146997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147011 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 147011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 147014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147018 */     GIR_RootConstrainSelectedInstOperands,
     /* 147019 */     // GIR_Coverage, 5257,
     /* 147019 */     GIR_EraseRootFromParent_Done,
     /* 147020 */   // Label 2914: @147020
     /* 147020 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(147053), // Rule ID 5258 //
     /* 147025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 147030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147044 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 147047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147051 */     GIR_RootConstrainSelectedInstOperands,
     /* 147052 */     // GIR_Coverage, 5258,
     /* 147052 */     GIR_EraseRootFromParent_Done,
     /* 147053 */   // Label 2915: @147053
     /* 147053 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(147086), // Rule ID 5588 //
     /* 147058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 147063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147077 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 147077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 147080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147084 */     GIR_RootConstrainSelectedInstOperands,
     /* 147085 */     // GIR_Coverage, 5588,
     /* 147085 */     GIR_EraseRootFromParent_Done,
     /* 147086 */   // Label 2916: @147086
     /* 147086 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(147171), // Rule ID 5589 //
     /* 147091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 147096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147110 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 147110 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 147113 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 147117 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147122 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 147126 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 147130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147144 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 147151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 147164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147169 */     GIR_RootConstrainSelectedInstOperands,
     /* 147170 */     // GIR_Coverage, 5589,
     /* 147170 */     GIR_EraseRootFromParent_Done,
     /* 147171 */   // Label 2917: @147171
     /* 147171 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(147204), // Rule ID 5590 //
     /* 147176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 147181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147195 */     // (intrinsic_wo_chain:{ *:[f64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 147195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 147198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147202 */     GIR_RootConstrainSelectedInstOperands,
     /* 147203 */     // GIR_Coverage, 5590,
     /* 147203 */     GIR_EraseRootFromParent_Done,
     /* 147204 */   // Label 2918: @147204
     /* 147204 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(147237), // Rule ID 5592 //
     /* 147209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 147214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147228 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 147228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 147231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147235 */     GIR_RootConstrainSelectedInstOperands,
     /* 147236 */     // GIR_Coverage, 5592,
     /* 147236 */     GIR_EraseRootFromParent_Done,
     /* 147237 */   // Label 2919: @147237
     /* 147237 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(147270), // Rule ID 5594 //
     /* 147242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 147247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147261 */     // (intrinsic_wo_chain:{ *:[f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 147261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 147264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147268 */     GIR_RootConstrainSelectedInstOperands,
     /* 147269 */     // GIR_Coverage, 5594,
     /* 147269 */     GIR_EraseRootFromParent_Done,
     /* 147270 */   // Label 2920: @147270
     /* 147270 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(147303), // Rule ID 5596 //
     /* 147275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 147280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147294 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 147294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 147297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147301 */     GIR_RootConstrainSelectedInstOperands,
     /* 147302 */     // GIR_Coverage, 5596,
     /* 147302 */     GIR_EraseRootFromParent_Done,
     /* 147303 */   // Label 2921: @147303
     /* 147303 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(147336), // Rule ID 5598 //
     /* 147308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 147313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147327 */     // (intrinsic_wo_chain:{ *:[f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 147327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 147330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147334 */     GIR_RootConstrainSelectedInstOperands,
     /* 147335 */     // GIR_Coverage, 5598,
     /* 147335 */     GIR_EraseRootFromParent_Done,
     /* 147336 */   // Label 2922: @147336
     /* 147336 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(147369), // Rule ID 5600 //
     /* 147341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 147346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147360 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 147360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 147363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147367 */     GIR_RootConstrainSelectedInstOperands,
     /* 147368 */     // GIR_Coverage, 5600,
     /* 147368 */     GIR_EraseRootFromParent_Done,
     /* 147369 */   // Label 2923: @147369
     /* 147369 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(147402), // Rule ID 5602 //
     /* 147374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 147379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147393 */     // (intrinsic_wo_chain:{ *:[f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 147393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 147396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147400 */     GIR_RootConstrainSelectedInstOperands,
     /* 147401 */     // GIR_Coverage, 5602,
     /* 147401 */     GIR_EraseRootFromParent_Done,
     /* 147402 */   // Label 2924: @147402
     /* 147402 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(147435), // Rule ID 5604 //
     /* 147407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 147412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147426 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 147426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 147429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147433 */     GIR_RootConstrainSelectedInstOperands,
     /* 147434 */     // GIR_Coverage, 5604,
     /* 147434 */     GIR_EraseRootFromParent_Done,
     /* 147435 */   // Label 2925: @147435
     /* 147435 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(147468), // Rule ID 5606 //
     /* 147440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 147445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147459 */     // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 147459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 147462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147466 */     GIR_RootConstrainSelectedInstOperands,
     /* 147467 */     // GIR_Coverage, 5606,
     /* 147467 */     GIR_EraseRootFromParent_Done,
     /* 147468 */   // Label 2926: @147468
     /* 147468 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(147501), // Rule ID 13038 //
     /* 147473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 147478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 147481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 147484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 147488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147492 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 147492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 147495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147499 */     GIR_RootConstrainSelectedInstOperands,
     /* 147500 */     // GIR_Coverage, 13038,
     /* 147500 */     GIR_EraseRootFromParent_Done,
     /* 147501 */   // Label 2927: @147501
     /* 147501 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(147534), // Rule ID 13040 //
     /* 147506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 147511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 147514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 147517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 147521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147525 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 147525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 147528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147532 */     GIR_RootConstrainSelectedInstOperands,
     /* 147533 */     // GIR_Coverage, 13040,
     /* 147533 */     GIR_EraseRootFromParent_Done,
     /* 147534 */   // Label 2928: @147534
     /* 147534 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(147567), // Rule ID 13042 //
     /* 147539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 147544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147558 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 147558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 147561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147565 */     GIR_RootConstrainSelectedInstOperands,
     /* 147566 */     // GIR_Coverage, 13042,
     /* 147566 */     GIR_EraseRootFromParent_Done,
     /* 147567 */   // Label 2929: @147567
     /* 147567 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(147600), // Rule ID 13044 //
     /* 147572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 147577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 147583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147591 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 147591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 147594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147598 */     GIR_RootConstrainSelectedInstOperands,
     /* 147599 */     // GIR_Coverage, 13044,
     /* 147599 */     GIR_EraseRootFromParent_Done,
     /* 147600 */   // Label 2930: @147600
     /* 147600 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(147715), // Rule ID 13045 //
     /* 147605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 147610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147624 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 147624 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 147627 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 147631 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147636 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 147640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147642 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 147645 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 147649 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 147659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 147663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147668 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 147671 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 147674 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 147677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147697 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 147704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147714 */     // GIR_Coverage, 13045,
     /* 147714 */     GIR_EraseRootFromParent_Done,
     /* 147715 */   // Label 2931: @147715
     /* 147715 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(147748), // Rule ID 13047 //
     /* 147720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 147725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 147728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 147731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 147735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147739 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 147739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 147742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147746 */     GIR_RootConstrainSelectedInstOperands,
     /* 147747 */     // GIR_Coverage, 13047,
     /* 147747 */     GIR_EraseRootFromParent_Done,
     /* 147748 */   // Label 2932: @147748
     /* 147748 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(147781), // Rule ID 13049 //
     /* 147753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 147758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 147761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 147764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 147768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147772 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 147772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 147775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147779 */     GIR_RootConstrainSelectedInstOperands,
     /* 147780 */     // GIR_Coverage, 13049,
     /* 147780 */     GIR_EraseRootFromParent_Done,
     /* 147781 */   // Label 2933: @147781
     /* 147781 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(147814), // Rule ID 13051 //
     /* 147786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 147791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147805 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 147805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 147808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147812 */     GIR_RootConstrainSelectedInstOperands,
     /* 147813 */     // GIR_Coverage, 13051,
     /* 147813 */     GIR_EraseRootFromParent_Done,
     /* 147814 */   // Label 2934: @147814
     /* 147814 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(147847), // Rule ID 13053 //
     /* 147819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 147824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 147830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147838 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 147838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 147841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147845 */     GIR_RootConstrainSelectedInstOperands,
     /* 147846 */     // GIR_Coverage, 13053,
     /* 147846 */     GIR_EraseRootFromParent_Done,
     /* 147847 */   // Label 2935: @147847
     /* 147847 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(147962), // Rule ID 13054 //
     /* 147852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 147857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147871 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 147871 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 147874 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 147878 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147883 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 147887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147889 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 147892 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 147896 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 147906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 147910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 147918 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 147921 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 147924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147944 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 147951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147961 */     // GIR_Coverage, 13054,
     /* 147961 */     GIR_EraseRootFromParent_Done,
     /* 147962 */   // Label 2936: @147962
     /* 147962 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(148081), // Rule ID 13055 //
     /* 147967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 147972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147986 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 147986 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147989 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 147993 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147998 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148002 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148008 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148011 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148015 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148034 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148037 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148040 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 148043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148063 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 148070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148080 */     // GIR_Coverage, 13055,
     /* 148080 */     GIR_EraseRootFromParent_Done,
     /* 148081 */   // Label 2937: @148081
     /* 148081 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(148196), // Rule ID 13056 //
     /* 148086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148105 */     // (intrinsic_wo_chain:{ *:[i64] } 662:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 148105 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148108 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 148112 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148117 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148123 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 148126 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148130 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 148140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148149 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148152 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148155 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 148158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148178 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148195 */     // GIR_Coverage, 13056,
     /* 148195 */     GIR_EraseRootFromParent_Done,
     /* 148196 */   // Label 2938: @148196
     /* 148196 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(148315), // Rule ID 13057 //
     /* 148201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148220 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148220 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148223 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 148227 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148232 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148236 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148242 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148245 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148249 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148268 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148271 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148274 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 148277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148297 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 148304 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148314 */     // GIR_Coverage, 13057,
     /* 148314 */     GIR_EraseRootFromParent_Done,
     /* 148315 */   // Label 2939: @148315
     /* 148315 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(148430), // Rule ID 13058 //
     /* 148320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148339 */     // (intrinsic_wo_chain:{ *:[i64] } 727:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 148339 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148342 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 148346 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148351 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148357 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 148360 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148364 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 148374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148383 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148386 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148389 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 148392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148412 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148429 */     // GIR_Coverage, 13058,
     /* 148429 */     GIR_EraseRootFromParent_Done,
     /* 148430 */   // Label 2940: @148430
     /* 148430 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(148463), // Rule ID 13060 //
     /* 148435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 148440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 148446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148454 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 148454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 148457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148461 */     GIR_RootConstrainSelectedInstOperands,
     /* 148462 */     // GIR_Coverage, 13060,
     /* 148462 */     GIR_EraseRootFromParent_Done,
     /* 148463 */   // Label 2941: @148463
     /* 148463 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(148496), // Rule ID 13062 //
     /* 148468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 148473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 148479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148487 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 148487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 148490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148494 */     GIR_RootConstrainSelectedInstOperands,
     /* 148495 */     // GIR_Coverage, 13062,
     /* 148495 */     GIR_EraseRootFromParent_Done,
     /* 148496 */   // Label 2942: @148496
     /* 148496 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(148529), // Rule ID 13064 //
     /* 148501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 148506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148520 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 148520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 148523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148527 */     GIR_RootConstrainSelectedInstOperands,
     /* 148528 */     // GIR_Coverage, 13064,
     /* 148528 */     GIR_EraseRootFromParent_Done,
     /* 148529 */   // Label 2943: @148529
     /* 148529 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(148562), // Rule ID 13066 //
     /* 148534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 148539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148553 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 148553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 148556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148560 */     GIR_RootConstrainSelectedInstOperands,
     /* 148561 */     // GIR_Coverage, 13066,
     /* 148561 */     GIR_EraseRootFromParent_Done,
     /* 148562 */   // Label 2944: @148562
     /* 148562 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(148677), // Rule ID 13067 //
     /* 148567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 148572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148586 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148586 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 148589 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 148593 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148598 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148604 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148607 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148611 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148630 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148633 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148636 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 148639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148659 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 148666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148676 */     // GIR_Coverage, 13067,
     /* 148676 */     GIR_EraseRootFromParent_Done,
     /* 148677 */   // Label 2945: @148677
     /* 148677 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(148796), // Rule ID 13068 //
     /* 148682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 148687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148701 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148701 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148704 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 148708 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148713 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148717 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148749 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148752 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148755 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 148758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148778 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 148785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148795 */     // GIR_Coverage, 13068,
     /* 148795 */     GIR_EraseRootFromParent_Done,
     /* 148796 */   // Label 2946: @148796
     /* 148796 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(148829), // Rule ID 13070 //
     /* 148801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 148806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 148812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148820 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 148820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 148823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148827 */     GIR_RootConstrainSelectedInstOperands,
     /* 148828 */     // GIR_Coverage, 13070,
     /* 148828 */     GIR_EraseRootFromParent_Done,
     /* 148829 */   // Label 2947: @148829
     /* 148829 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(148862), // Rule ID 13072 //
     /* 148834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 148839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 148845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148853 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 148853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 148856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148860 */     GIR_RootConstrainSelectedInstOperands,
     /* 148861 */     // GIR_Coverage, 13072,
     /* 148861 */     GIR_EraseRootFromParent_Done,
     /* 148862 */   // Label 2948: @148862
     /* 148862 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(148895), // Rule ID 13074 //
     /* 148867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 148872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148886 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 148886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 148889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148893 */     GIR_RootConstrainSelectedInstOperands,
     /* 148894 */     // GIR_Coverage, 13074,
     /* 148894 */     GIR_EraseRootFromParent_Done,
     /* 148895 */   // Label 2949: @148895
     /* 148895 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(148928), // Rule ID 13076 //
     /* 148900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 148905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148919 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 148919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 148922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148926 */     GIR_RootConstrainSelectedInstOperands,
     /* 148927 */     // GIR_Coverage, 13076,
     /* 148927 */     GIR_EraseRootFromParent_Done,
     /* 148928 */   // Label 2950: @148928
     /* 148928 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(149043), // Rule ID 13077 //
     /* 148933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 148938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148952 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148952 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 148955 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 148959 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148964 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148970 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148973 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148977 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148996 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148999 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149002 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 149005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149025 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149042 */     // GIR_Coverage, 13077,
     /* 149042 */     GIR_EraseRootFromParent_Done,
     /* 149043 */   // Label 2951: @149043
     /* 149043 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(149162), // Rule ID 13078 //
     /* 149048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149067 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149067 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149070 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 149074 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149079 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149083 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149089 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149092 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149096 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149115 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149118 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149121 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149144 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149161 */     // GIR_Coverage, 13078,
     /* 149161 */     GIR_EraseRootFromParent_Done,
     /* 149162 */   // Label 2952: @149162
     /* 149162 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(149195), // Rule ID 13080 //
     /* 149167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 149178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149186 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 149186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 149189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149193 */     GIR_RootConstrainSelectedInstOperands,
     /* 149194 */     // GIR_Coverage, 13080,
     /* 149194 */     GIR_EraseRootFromParent_Done,
     /* 149195 */   // Label 2953: @149195
     /* 149195 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(149228), // Rule ID 13082 //
     /* 149200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149219 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 149222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149226 */     GIR_RootConstrainSelectedInstOperands,
     /* 149227 */     // GIR_Coverage, 13082,
     /* 149227 */     GIR_EraseRootFromParent_Done,
     /* 149228 */   // Label 2954: @149228
     /* 149228 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(149261), // Rule ID 13084 //
     /* 149233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149252 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 149252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 149255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149259 */     GIR_RootConstrainSelectedInstOperands,
     /* 149260 */     // GIR_Coverage, 13084,
     /* 149260 */     GIR_EraseRootFromParent_Done,
     /* 149261 */   // Label 2955: @149261
     /* 149261 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(149294), // Rule ID 13086 //
     /* 149266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 149277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149285 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 149285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 149288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149292 */     GIR_RootConstrainSelectedInstOperands,
     /* 149293 */     // GIR_Coverage, 13086,
     /* 149293 */     GIR_EraseRootFromParent_Done,
     /* 149294 */   // Label 2956: @149294
     /* 149294 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(149409), // Rule ID 13087 //
     /* 149299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149318 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149318 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 149321 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 149325 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149330 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149336 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149339 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149343 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149362 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149368 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 149371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149408 */     // GIR_Coverage, 13087,
     /* 149408 */     GIR_EraseRootFromParent_Done,
     /* 149409 */   // Label 2957: @149409
     /* 149409 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(149528), // Rule ID 13088 //
     /* 149414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149433 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149433 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149436 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 149440 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149445 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149449 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149455 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149458 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149462 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149481 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149484 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149487 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149510 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149527 */     // GIR_Coverage, 13088,
     /* 149527 */     GIR_EraseRootFromParent_Done,
     /* 149528 */   // Label 2958: @149528
     /* 149528 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(149561), // Rule ID 13090 //
     /* 149533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 149538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 149544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149552 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 149552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 149555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149559 */     GIR_RootConstrainSelectedInstOperands,
     /* 149560 */     // GIR_Coverage, 13090,
     /* 149560 */     GIR_EraseRootFromParent_Done,
     /* 149561 */   // Label 2959: @149561
     /* 149561 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(149594), // Rule ID 13092 //
     /* 149566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 149571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149585 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 149588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149592 */     GIR_RootConstrainSelectedInstOperands,
     /* 149593 */     // GIR_Coverage, 13092,
     /* 149593 */     GIR_EraseRootFromParent_Done,
     /* 149594 */   // Label 2960: @149594
     /* 149594 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(149627), // Rule ID 13094 //
     /* 149599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 149604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149618 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 149618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 149621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149625 */     GIR_RootConstrainSelectedInstOperands,
     /* 149626 */     // GIR_Coverage, 13094,
     /* 149626 */     GIR_EraseRootFromParent_Done,
     /* 149627 */   // Label 2961: @149627
     /* 149627 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(149660), // Rule ID 13096 //
     /* 149632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 149637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 149643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149651 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 149651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 149654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149658 */     GIR_RootConstrainSelectedInstOperands,
     /* 149659 */     // GIR_Coverage, 13096,
     /* 149659 */     GIR_EraseRootFromParent_Done,
     /* 149660 */   // Label 2962: @149660
     /* 149660 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(149775), // Rule ID 13097 //
     /* 149665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 149670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149684 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149684 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 149687 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 149691 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149696 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149702 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149705 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149709 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149728 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149731 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149734 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 149737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149757 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149769 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149774 */     // GIR_Coverage, 13097,
     /* 149774 */     GIR_EraseRootFromParent_Done,
     /* 149775 */   // Label 2963: @149775
     /* 149775 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(149894), // Rule ID 13098 //
     /* 149780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 149785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149799 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149799 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149802 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 149806 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149811 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149815 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149821 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149824 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149828 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149847 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149850 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149876 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149893 */     // GIR_Coverage, 13098,
     /* 149893 */     GIR_EraseRootFromParent_Done,
     /* 149894 */   // Label 2964: @149894
     /* 149894 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(149926), // Rule ID 2384 //
     /* 149899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 149902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 149907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 149910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 149913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 149917 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1655:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 149917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 149920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 149922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 149924 */     GIR_RootConstrainSelectedInstOperands,
     /* 149925 */     // GIR_Coverage, 2384,
     /* 149925 */     GIR_EraseRootFromParent_Done,
     /* 149926 */   // Label 2965: @149926
     /* 149926 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(149958), // Rule ID 2385 //
     /* 149931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 149934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 149939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 149942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 149945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 149949 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1656:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 149949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 149952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 149954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 149956 */     GIR_RootConstrainSelectedInstOperands,
     /* 149957 */     // GIR_Coverage, 2385,
     /* 149957 */     GIR_EraseRootFromParent_Done,
     /* 149958 */   // Label 2966: @149958
     /* 149958 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(149990), // Rule ID 2386 //
     /* 149963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 149966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 149971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 149974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 149977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 149981 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1657:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 149981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 149984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 149986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 149988 */     GIR_RootConstrainSelectedInstOperands,
     /* 149989 */     // GIR_Coverage, 2386,
     /* 149989 */     GIR_EraseRootFromParent_Done,
     /* 149990 */   // Label 2967: @149990
     /* 149990 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(150022), // Rule ID 3084 //
     /* 149995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 149998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 150003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 150006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 150009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150013 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1837:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 150013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 150016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150020 */     GIR_RootConstrainSelectedInstOperands,
     /* 150021 */     // GIR_Coverage, 3084,
     /* 150021 */     GIR_EraseRootFromParent_Done,
     /* 150022 */   // Label 2968: @150022
     /* 150022 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(150054), // Rule ID 3085 //
     /* 150027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 150030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 150035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 150038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 150041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150045 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1837:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 150045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 150048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150052 */     GIR_RootConstrainSelectedInstOperands,
     /* 150053 */     // GIR_Coverage, 3085,
     /* 150053 */     GIR_EraseRootFromParent_Done,
     /* 150054 */   // Label 2969: @150054
     /* 150054 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(150086), // Rule ID 3086 //
     /* 150059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 150062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 150067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 150070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 150073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150077 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1837:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 150077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 150080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150084 */     GIR_RootConstrainSelectedInstOperands,
     /* 150085 */     // GIR_Coverage, 3086,
     /* 150085 */     GIR_EraseRootFromParent_Done,
     /* 150086 */   // Label 2970: @150086
     /* 150086 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(150118), // Rule ID 3340 //
     /* 150091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 150099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 150102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 150105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150109 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1647:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 150109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 150112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150116 */     GIR_RootConstrainSelectedInstOperands,
     /* 150117 */     // GIR_Coverage, 3340,
     /* 150117 */     GIR_EraseRootFromParent_Done,
     /* 150118 */   // Label 2971: @150118
     /* 150118 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(150150), // Rule ID 3341 //
     /* 150123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 150131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 150134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 150137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150141 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1647:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 150141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 150144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150148 */     GIR_RootConstrainSelectedInstOperands,
     /* 150149 */     // GIR_Coverage, 3341,
     /* 150149 */     GIR_EraseRootFromParent_Done,
     /* 150150 */   // Label 2972: @150150
     /* 150150 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(150182), // Rule ID 3342 //
     /* 150155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 150163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 150166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 150169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150173 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1647:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 150173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 150176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150180 */     GIR_RootConstrainSelectedInstOperands,
     /* 150181 */     // GIR_Coverage, 3342,
     /* 150181 */     GIR_EraseRootFromParent_Done,
     /* 150182 */   // Label 2973: @150182
     /* 150182 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(150214), // Rule ID 3421 //
     /* 150187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 150190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 150195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 150198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 150201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150205 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1408:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 150205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 150208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150212 */     GIR_RootConstrainSelectedInstOperands,
     /* 150213 */     // GIR_Coverage, 3421,
     /* 150213 */     GIR_EraseRootFromParent_Done,
     /* 150214 */   // Label 2974: @150214
     /* 150214 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(150246), // Rule ID 3422 //
     /* 150219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 150222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 150227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 150230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 150233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150237 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1408:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 150237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 150240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150244 */     GIR_RootConstrainSelectedInstOperands,
     /* 150245 */     // GIR_Coverage, 3422,
     /* 150245 */     GIR_EraseRootFromParent_Done,
     /* 150246 */   // Label 2975: @150246
     /* 150246 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(150278), // Rule ID 3423 //
     /* 150251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 150254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 150259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 150262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 150265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150269 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1408:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 150269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 150272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150276 */     GIR_RootConstrainSelectedInstOperands,
     /* 150277 */     // GIR_Coverage, 3423,
     /* 150277 */     GIR_EraseRootFromParent_Done,
     /* 150278 */   // Label 2976: @150278
     /* 150278 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(150310), // Rule ID 3449 //
     /* 150283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 150286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 150291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 150294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 150297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150301 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1247:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 150301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 150304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 150306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150308 */     GIR_RootConstrainSelectedInstOperands,
     /* 150309 */     // GIR_Coverage, 3449,
     /* 150309 */     GIR_EraseRootFromParent_Done,
     /* 150310 */   // Label 2977: @150310
     /* 150310 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(150342), // Rule ID 4604 //
     /* 150315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 150318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 150323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 150329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150333 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 150333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 150336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150340 */     GIR_RootConstrainSelectedInstOperands,
     /* 150341 */     // GIR_Coverage, 4604,
     /* 150341 */     GIR_EraseRootFromParent_Done,
     /* 150342 */   // Label 2978: @150342
     /* 150342 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(150374), // Rule ID 4605 //
     /* 150347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 150350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 150355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 150361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150365 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 150365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 150368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150372 */     GIR_RootConstrainSelectedInstOperands,
     /* 150373 */     // GIR_Coverage, 4605,
     /* 150373 */     GIR_EraseRootFromParent_Done,
     /* 150374 */   // Label 2979: @150374
     /* 150374 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(150403), // Rule ID 4606 //
     /* 150379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 150384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150394 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 150394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 150397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150401 */     GIR_RootConstrainSelectedInstOperands,
     /* 150402 */     // GIR_Coverage, 4606,
     /* 150402 */     GIR_EraseRootFromParent_Done,
     /* 150403 */   // Label 2980: @150403
     /* 150403 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(150432), // Rule ID 4607 //
     /* 150408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 150413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150423 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 150423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 150426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150430 */     GIR_RootConstrainSelectedInstOperands,
     /* 150431 */     // GIR_Coverage, 4607,
     /* 150431 */     GIR_EraseRootFromParent_Done,
     /* 150432 */   // Label 2981: @150432
     /* 150432 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(150461), // Rule ID 4608 //
     /* 150437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 150442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150452 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 150452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 150455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150459 */     GIR_RootConstrainSelectedInstOperands,
     /* 150460 */     // GIR_Coverage, 4608,
     /* 150460 */     GIR_EraseRootFromParent_Done,
     /* 150461 */   // Label 2982: @150461
     /* 150461 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(150490), // Rule ID 4609 //
     /* 150466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 150471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150481 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 150481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 150484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150488 */     GIR_RootConstrainSelectedInstOperands,
     /* 150489 */     // GIR_Coverage, 4609,
     /* 150489 */     GIR_EraseRootFromParent_Done,
     /* 150490 */   // Label 2983: @150490
     /* 150490 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(150522), // Rule ID 4616 //
     /* 150495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 150498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 150503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 150509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150513 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 150513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 150516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150520 */     GIR_RootConstrainSelectedInstOperands,
     /* 150521 */     // GIR_Coverage, 4616,
     /* 150521 */     GIR_EraseRootFromParent_Done,
     /* 150522 */   // Label 2984: @150522
     /* 150522 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(150554), // Rule ID 4617 //
     /* 150527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 150530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 150535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 150541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150545 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 150545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 150548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150552 */     GIR_RootConstrainSelectedInstOperands,
     /* 150553 */     // GIR_Coverage, 4617,
     /* 150553 */     GIR_EraseRootFromParent_Done,
     /* 150554 */   // Label 2985: @150554
     /* 150554 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(150583), // Rule ID 4618 //
     /* 150559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 150564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150574 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 150574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 150577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150581 */     GIR_RootConstrainSelectedInstOperands,
     /* 150582 */     // GIR_Coverage, 4618,
     /* 150582 */     GIR_EraseRootFromParent_Done,
     /* 150583 */   // Label 2986: @150583
     /* 150583 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(150612), // Rule ID 4619 //
     /* 150588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 150593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150603 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 150603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 150606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150610 */     GIR_RootConstrainSelectedInstOperands,
     /* 150611 */     // GIR_Coverage, 4619,
     /* 150611 */     GIR_EraseRootFromParent_Done,
     /* 150612 */   // Label 2987: @150612
     /* 150612 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(150641), // Rule ID 4620 //
     /* 150617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 150622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150632 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 150632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 150635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150639 */     GIR_RootConstrainSelectedInstOperands,
     /* 150640 */     // GIR_Coverage, 4620,
     /* 150640 */     GIR_EraseRootFromParent_Done,
     /* 150641 */   // Label 2988: @150641
     /* 150641 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(150670), // Rule ID 4621 //
     /* 150646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 150651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 150654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150661 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 150661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 150664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150668 */     GIR_RootConstrainSelectedInstOperands,
     /* 150669 */     // GIR_Coverage, 4621,
     /* 150669 */     GIR_EraseRootFromParent_Done,
     /* 150670 */   // Label 2989: @150670
     /* 150670 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(150699), // Rule ID 4916 //
     /* 150675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 150680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 150683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150690 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 150690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 150693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150697 */     GIR_RootConstrainSelectedInstOperands,
     /* 150698 */     // GIR_Coverage, 4916,
     /* 150698 */     GIR_EraseRootFromParent_Done,
     /* 150699 */   // Label 2990: @150699
     /* 150699 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(150728), // Rule ID 4917 //
     /* 150704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 150709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 150712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150719 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 150719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 150722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150726 */     GIR_RootConstrainSelectedInstOperands,
     /* 150727 */     // GIR_Coverage, 4917,
     /* 150727 */     GIR_EraseRootFromParent_Done,
     /* 150728 */   // Label 2991: @150728
     /* 150728 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(150757), // Rule ID 4918 //
     /* 150733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 150738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 150741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150748 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 150748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 150751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150755 */     GIR_RootConstrainSelectedInstOperands,
     /* 150756 */     // GIR_Coverage, 4918,
     /* 150756 */     GIR_EraseRootFromParent_Done,
     /* 150757 */   // Label 2992: @150757
     /* 150757 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(150786), // Rule ID 4919 //
     /* 150762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 150767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 150770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150777 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 150777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 150780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150784 */     GIR_RootConstrainSelectedInstOperands,
     /* 150785 */     // GIR_Coverage, 4919,
     /* 150785 */     GIR_EraseRootFromParent_Done,
     /* 150786 */   // Label 2993: @150786
     /* 150786 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(150815), // Rule ID 4920 //
     /* 150791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 150796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 150799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150806 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 150806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 150809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150813 */     GIR_RootConstrainSelectedInstOperands,
     /* 150814 */     // GIR_Coverage, 4920,
     /* 150814 */     GIR_EraseRootFromParent_Done,
     /* 150815 */   // Label 2994: @150815
     /* 150815 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(150844), // Rule ID 4921 //
     /* 150820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 150825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 150828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150835 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 150835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 150838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150842 */     GIR_RootConstrainSelectedInstOperands,
     /* 150843 */     // GIR_Coverage, 4921,
     /* 150843 */     GIR_EraseRootFromParent_Done,
     /* 150844 */   // Label 2995: @150844
     /* 150844 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(150873), // Rule ID 4922 //
     /* 150849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 150854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 150857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150864 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 150864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 150867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150871 */     GIR_RootConstrainSelectedInstOperands,
     /* 150872 */     // GIR_Coverage, 4922,
     /* 150872 */     GIR_EraseRootFromParent_Done,
     /* 150873 */   // Label 2996: @150873
     /* 150873 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(150902), // Rule ID 4923 //
     /* 150878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 150883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 150886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150893 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 150893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 150896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150900 */     GIR_RootConstrainSelectedInstOperands,
     /* 150901 */     // GIR_Coverage, 4923,
     /* 150901 */     GIR_EraseRootFromParent_Done,
     /* 150902 */   // Label 2997: @150902
     /* 150902 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(150931), // Rule ID 4924 //
     /* 150907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 150912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 150915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150922 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 150922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 150925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150929 */     GIR_RootConstrainSelectedInstOperands,
     /* 150930 */     // GIR_Coverage, 4924,
     /* 150930 */     GIR_EraseRootFromParent_Done,
     /* 150931 */   // Label 2998: @150931
     /* 150931 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(150960), // Rule ID 4925 //
     /* 150936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 150941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 150944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 150947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150951 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 150951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 150954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150958 */     GIR_RootConstrainSelectedInstOperands,
     /* 150959 */     // GIR_Coverage, 4925,
     /* 150959 */     GIR_EraseRootFromParent_Done,
     /* 150960 */   // Label 2999: @150960
     /* 150960 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(150992), // Rule ID 8334 //
     /* 150965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 150973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 150976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 150979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150983 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1646:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 150983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 150986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150990 */     GIR_RootConstrainSelectedInstOperands,
     /* 150991 */     // GIR_Coverage, 8334,
     /* 150991 */     GIR_EraseRootFromParent_Done,
     /* 150992 */   // Label 3000: @150992
     /* 150992 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(151024), // Rule ID 8335 //
     /* 150997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 151005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 151008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 151011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151015 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1646:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 151015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 151018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151022 */     GIR_RootConstrainSelectedInstOperands,
     /* 151023 */     // GIR_Coverage, 8335,
     /* 151023 */     GIR_EraseRootFromParent_Done,
     /* 151024 */   // Label 3001: @151024
     /* 151024 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(151056), // Rule ID 8336 //
     /* 151029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 151037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 151040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 151043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151047 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1646:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 151047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 151050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151054 */     GIR_RootConstrainSelectedInstOperands,
     /* 151055 */     // GIR_Coverage, 8336,
     /* 151055 */     GIR_EraseRootFromParent_Done,
     /* 151056 */   // Label 3002: @151056
     /* 151056 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(151088), // Rule ID 11725 //
     /* 151061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 151069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 151075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151079 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2030:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 151079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 151082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151086 */     GIR_RootConstrainSelectedInstOperands,
     /* 151087 */     // GIR_Coverage, 11725,
     /* 151087 */     GIR_EraseRootFromParent_Done,
     /* 151088 */   // Label 3003: @151088
     /* 151088 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(151120), // Rule ID 11726 //
     /* 151093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 151101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 151104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 151107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151111 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2030:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 151111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 151114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151118 */     GIR_RootConstrainSelectedInstOperands,
     /* 151119 */     // GIR_Coverage, 11726,
     /* 151119 */     GIR_EraseRootFromParent_Done,
     /* 151120 */   // Label 3004: @151120
     /* 151120 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(151152), // Rule ID 11727 //
     /* 151125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 151133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 151136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 151139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2030:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 151143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 151146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151150 */     GIR_RootConstrainSelectedInstOperands,
     /* 151151 */     // GIR_Coverage, 11727,
     /* 151151 */     GIR_EraseRootFromParent_Done,
     /* 151152 */   // Label 3005: @151152
     /* 151152 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(151184), // Rule ID 11728 //
     /* 151157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 151165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 151171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151175 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1839:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 151175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 151178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151182 */     GIR_RootConstrainSelectedInstOperands,
     /* 151183 */     // GIR_Coverage, 11728,
     /* 151183 */     GIR_EraseRootFromParent_Done,
     /* 151184 */   // Label 3006: @151184
     /* 151184 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(151216), // Rule ID 11729 //
     /* 151189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 151197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 151200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 151203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151207 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1839:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 151207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 151210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151214 */     GIR_RootConstrainSelectedInstOperands,
     /* 151215 */     // GIR_Coverage, 11729,
     /* 151215 */     GIR_EraseRootFromParent_Done,
     /* 151216 */   // Label 3007: @151216
     /* 151216 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(151248), // Rule ID 11730 //
     /* 151221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 151229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 151232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 151235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151239 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1839:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 151239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 151242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151246 */     GIR_RootConstrainSelectedInstOperands,
     /* 151247 */     // GIR_Coverage, 11730,
     /* 151247 */     GIR_EraseRootFromParent_Done,
     /* 151248 */   // Label 3008: @151248
     /* 151248 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(151280), // Rule ID 11885 //
     /* 151253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 151256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 151261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 151267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151271 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1246:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 151271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 151274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 151276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151278 */     GIR_RootConstrainSelectedInstOperands,
     /* 151279 */     // GIR_Coverage, 11885,
     /* 151279 */     GIR_EraseRootFromParent_Done,
     /* 151280 */   // Label 3009: @151280
     /* 151280 */   GIM_Reject,
     /* 151281 */ // Label 2690: @151281
     /* 151281 */ GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(197592),
     /* 151286 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 151289 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(151473), // Rule ID 2559 //
     /* 151294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 151302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 151311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 151327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 151343 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 151346 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151351 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151355 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 151368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151372 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151376 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 151380 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151384 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151388 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 151392 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151397 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 151401 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151405 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151409 */     // MIs[5] Operand 1
     /* 151409 */     // No operand predicates
     /* 151409 */     // MIs[3] Operand 2
     /* 151409 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 151420 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 151424 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 151426 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 151426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 151429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151438 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 151444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 151457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 151461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 151468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 151471 */     GIR_RootConstrainSelectedInstOperands,
     /* 151472 */     // GIR_Coverage, 2559,
     /* 151472 */     GIR_EraseRootFromParent_Done,
     /* 151473 */   // Label 3011: @151473
     /* 151473 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(151657), // Rule ID 6212 //
     /* 151478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 151486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 151495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 151511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 151523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 151527 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 151530 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151539 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 151552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151556 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151560 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 151564 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151568 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151572 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 151576 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151581 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 151585 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151589 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151593 */     // MIs[5] Operand 1
     /* 151593 */     // No operand predicates
     /* 151593 */     // MIs[3] Operand 2
     /* 151593 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 151604 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 151608 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 151610 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 151610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 151613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151622 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 151628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 151633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 151641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 151645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 151652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 151655 */     GIR_RootConstrainSelectedInstOperands,
     /* 151656 */     // GIR_Coverage, 6212,
     /* 151656 */     GIR_EraseRootFromParent_Done,
     /* 151657 */   // Label 3012: @151657
     /* 151657 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(151797), // Rule ID 2050 //
     /* 151662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 151670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 151673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 151676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 151679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 151695 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 151698 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151707 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 151715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 151727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151731 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151735 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 151739 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151744 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 151748 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151752 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151756 */     // MIs[4] Operand 1
     /* 151756 */     // No operand predicates
     /* 151756 */     // MIs[2] Operand 2
     /* 151756 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 151767 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 151769 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 151776 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 151779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 151783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 151788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 151792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 151795 */     GIR_RootConstrainSelectedInstOperands,
     /* 151796 */     // GIR_Coverage, 2050,
     /* 151796 */     GIR_EraseRootFromParent_Done,
     /* 151797 */   // Label 3013: @151797
     /* 151797 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(151937), // Rule ID 2057 //
     /* 151802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 151810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 151813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 151816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 151819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 151835 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 151838 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151847 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 151851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 151855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 151867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 151871 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 151875 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 151879 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 151884 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 151888 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 151892 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 151896 */     // MIs[4] Operand 1
     /* 151896 */     // No operand predicates
     /* 151896 */     // MIs[2] Operand 2
     /* 151896 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 151907 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 151909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 151916 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 151916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 151919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 151923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 151928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 151932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 151935 */     GIR_RootConstrainSelectedInstOperands,
     /* 151936 */     // GIR_Coverage, 2057,
     /* 151936 */     GIR_EraseRootFromParent_Done,
     /* 151937 */   // Label 3014: @151937
     /* 151937 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(152077), // Rule ID 2053 //
     /* 151942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 151945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 151950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 151953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 151959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 151971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 151975 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 151978 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 151983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151987 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 151991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 151995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 151999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 152011 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152015 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152019 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152024 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152028 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152032 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 152036 */     // MIs[4] Operand 1
     /* 152036 */     // No operand predicates
     /* 152036 */     // MIs[2] Operand 2
     /* 152036 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 152047 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 152056 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 152059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152075 */     GIR_RootConstrainSelectedInstOperands,
     /* 152076 */     // GIR_Coverage, 2053,
     /* 152076 */     GIR_EraseRootFromParent_Done,
     /* 152077 */   // Label 3015: @152077
     /* 152077 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(152217), // Rule ID 2060 //
     /* 152082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152115 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152118 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152127 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 152151 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152155 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152159 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152164 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152168 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152172 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 152176 */     // MIs[4] Operand 1
     /* 152176 */     // No operand predicates
     /* 152176 */     // MIs[2] Operand 2
     /* 152176 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 152187 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 152196 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 152199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152215 */     GIR_RootConstrainSelectedInstOperands,
     /* 152216 */     // GIR_Coverage, 2060,
     /* 152216 */     GIR_EraseRootFromParent_Done,
     /* 152217 */   // Label 3016: @152217
     /* 152217 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(152354), // Rule ID 2048 //
     /* 152222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152296 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152300 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152304 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152309 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152313 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152317 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152321 */     // MIs[4] Operand 1
     /* 152321 */     // No operand predicates
     /* 152321 */     // MIs[2] Operand 2
     /* 152321 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 152332 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152334 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 152337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152352 */     GIR_RootConstrainSelectedInstOperands,
     /* 152353 */     // GIR_Coverage, 2048,
     /* 152353 */     GIR_EraseRootFromParent_Done,
     /* 152354 */   // Label 3017: @152354
     /* 152354 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(152491), // Rule ID 2055 //
     /* 152359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152392 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152395 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152404 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152433 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152437 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152441 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152446 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152450 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152454 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152458 */     // MIs[4] Operand 1
     /* 152458 */     // No operand predicates
     /* 152458 */     // MIs[2] Operand 2
     /* 152458 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 152469 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152471 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 152474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152489 */     GIR_RootConstrainSelectedInstOperands,
     /* 152490 */     // GIR_Coverage, 2055,
     /* 152490 */     GIR_EraseRootFromParent_Done,
     /* 152491 */   // Label 3018: @152491
     /* 152491 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(152628), // Rule ID 2051 //
     /* 152496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152529 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152532 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152541 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 152570 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152574 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152578 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152583 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152587 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152591 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 152595 */     // MIs[4] Operand 1
     /* 152595 */     // No operand predicates
     /* 152595 */     // MIs[2] Operand 2
     /* 152595 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 152606 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152608 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 152611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152626 */     GIR_RootConstrainSelectedInstOperands,
     /* 152627 */     // GIR_Coverage, 2051,
     /* 152627 */     GIR_EraseRootFromParent_Done,
     /* 152628 */   // Label 3019: @152628
     /* 152628 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(152765), // Rule ID 2058 //
     /* 152633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152666 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152669 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152678 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 152707 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152711 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152715 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152720 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152724 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152728 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 152732 */     // MIs[4] Operand 1
     /* 152732 */     // No operand predicates
     /* 152732 */     // MIs[2] Operand 2
     /* 152732 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 152743 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152745 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 152748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 152756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152763 */     GIR_RootConstrainSelectedInstOperands,
     /* 152764 */     // GIR_Coverage, 2058,
     /* 152764 */     GIR_EraseRootFromParent_Done,
     /* 152765 */   // Label 3020: @152765
     /* 152765 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(152926), // Rule ID 2560 //
     /* 152770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152819 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 152822 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152831 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 152844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152852 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152856 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152861 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152865 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152869 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152873 */     // MIs[4] Operand 1
     /* 152873 */     // No operand predicates
     /* 152873 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152877 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152879 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 152879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152891 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 152897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 152910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152924 */     GIR_RootConstrainSelectedInstOperands,
     /* 152925 */     // GIR_Coverage, 2560,
     /* 152925 */     GIR_EraseRootFromParent_Done,
     /* 152926 */   // Label 3021: @152926
     /* 152926 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(153087), // Rule ID 6213 //
     /* 152931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152980 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 152983 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152992 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 153005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153013 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153017 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153022 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153026 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153030 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153034 */     // MIs[4] Operand 1
     /* 153034 */     // No operand predicates
     /* 153034 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 153038 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153040 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 153040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 153043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153052 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 153058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 153071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153085 */     GIR_RootConstrainSelectedInstOperands,
     /* 153086 */     // GIR_Coverage, 6213,
     /* 153086 */     GIR_EraseRootFromParent_Done,
     /* 153087 */   // Label 3022: @153087
     /* 153087 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(153197), // Rule ID 2078 //
     /* 153092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153154 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153158 */     // MIs[3] Operand 1
     /* 153158 */     // No operand predicates
     /* 153158 */     // MIs[1] Operand 2
     /* 153158 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 153169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 153178 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 153181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 153192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 153195 */     GIR_RootConstrainSelectedInstOperands,
     /* 153196 */     // GIR_Coverage, 2078,
     /* 153196 */     GIR_EraseRootFromParent_Done,
     /* 153197 */   // Label 3023: @153197
     /* 153197 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(153307), // Rule ID 2081 //
     /* 153202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153264 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153268 */     // MIs[3] Operand 1
     /* 153268 */     // No operand predicates
     /* 153268 */     // MIs[1] Operand 2
     /* 153268 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 153279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 153288 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 153291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 153302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 153305 */     GIR_RootConstrainSelectedInstOperands,
     /* 153306 */     // GIR_Coverage, 2081,
     /* 153306 */     GIR_EraseRootFromParent_Done,
     /* 153307 */   // Label 3024: @153307
     /* 153307 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(153396), // Rule ID 1736 //
     /* 153312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153345 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153348 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153357 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 153370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 153377 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 153377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 153380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 153394 */     GIR_RootConstrainSelectedInstOperands,
     /* 153395 */     // GIR_Coverage, 1736,
     /* 153395 */     GIR_EraseRootFromParent_Done,
     /* 153396 */   // Label 3025: @153396
     /* 153396 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(153485), // Rule ID 1738 //
     /* 153401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153434 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153437 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153446 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153452 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 153459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 153466 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 153466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 153469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 153483 */     GIR_RootConstrainSelectedInstOperands,
     /* 153484 */     // GIR_Coverage, 1738,
     /* 153484 */     GIR_EraseRootFromParent_Done,
     /* 153485 */   // Label 3026: @153485
     /* 153485 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(153574), // Rule ID 1740 //
     /* 153490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153523 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153526 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153535 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 153548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 153555 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 153555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 153558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 153572 */     GIR_RootConstrainSelectedInstOperands,
     /* 153573 */     // GIR_Coverage, 1740,
     /* 153573 */     GIR_EraseRootFromParent_Done,
     /* 153574 */   // Label 3027: @153574
     /* 153574 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(153663), // Rule ID 1742 //
     /* 153579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153612 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153615 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153624 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 153637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 153644 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 153644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 153647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 153661 */     GIR_RootConstrainSelectedInstOperands,
     /* 153662 */     // GIR_Coverage, 1742,
     /* 153662 */     GIR_EraseRootFromParent_Done,
     /* 153663 */   // Label 3028: @153663
     /* 153663 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(153785), // Rule ID 6872 //
     /* 153668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 153673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 153676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153703 */     // MIs[1] Operand 2
     /* 153703 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 153714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 153718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153722 */     // MIs[2] Rn
     /* 153722 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 153727 */     // MIs[2] Operand 2
     /* 153727 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 153738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153740 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 153740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 153743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 153747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153752 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 153756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 153760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 153774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153784 */     // GIR_Coverage, 6872,
     /* 153784 */     GIR_EraseRootFromParent_Done,
     /* 153785 */   // Label 3029: @153785
     /* 153785 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(153907), // Rule ID 6874 //
     /* 153790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 153795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 153798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153825 */     // MIs[1] Operand 2
     /* 153825 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 153836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 153840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153844 */     // MIs[2] Rn
     /* 153844 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 153849 */     // MIs[2] Operand 2
     /* 153849 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 153860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153862 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 153862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 153865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 153869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 153878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 153882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153889 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 153896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153906 */     // GIR_Coverage, 6874,
     /* 153906 */     GIR_EraseRootFromParent_Done,
     /* 153907 */   // Label 3030: @153907
     /* 153907 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(154029), // Rule ID 6876 //
     /* 153912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 153917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 153920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 153923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 153926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 153942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153947 */     // MIs[1] Operand 2
     /* 153947 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 153958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 153962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153966 */     // MIs[2] Rn
     /* 153966 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 153971 */     // MIs[2] Operand 2
     /* 153971 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 153982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153984 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 153984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 153987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 153991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154011 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154028 */     // GIR_Coverage, 6876,
     /* 154028 */     GIR_EraseRootFromParent_Done,
     /* 154029 */   // Label 3031: @154029
     /* 154029 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(154151), // Rule ID 6878 //
     /* 154034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 154039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154069 */     // MIs[1] Operand 2
     /* 154069 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154088 */     // MIs[2] Rn
     /* 154088 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154093 */     // MIs[2] Operand 2
     /* 154093 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 154104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154106 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 154106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 154113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154122 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154133 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154150 */     // GIR_Coverage, 6878,
     /* 154150 */     GIR_EraseRootFromParent_Done,
     /* 154151 */   // Label 3032: @154151
     /* 154151 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(154273), // Rule ID 6880 //
     /* 154156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 154161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 154164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154191 */     // MIs[1] Operand 2
     /* 154191 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154210 */     // MIs[2] Rn
     /* 154210 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154215 */     // MIs[2] Operand 2
     /* 154215 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 154226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154228 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 154228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 154235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154244 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154272 */     // GIR_Coverage, 6880,
     /* 154272 */     GIR_EraseRootFromParent_Done,
     /* 154273 */   // Label 3033: @154273
     /* 154273 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(154456), // Rule ID 2558 //
     /* 154278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 154289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154327 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 154330 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154339 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154353 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 154357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154359 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 154359 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 154362 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 154366 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 154373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 154376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 154380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154385 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 154388 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 154392 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 154395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 154413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154422 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 154428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 154441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 154451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154454 */     GIR_RootConstrainSelectedInstOperands,
     /* 154455 */     // GIR_Coverage, 2558,
     /* 154455 */     GIR_EraseRootFromParent_Done,
     /* 154456 */   // Label 3034: @154456
     /* 154456 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(154639), // Rule ID 6211 //
     /* 154461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 154472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154510 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 154513 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154522 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154536 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 154540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154542 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 154542 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 154545 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 154549 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 154556 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 154559 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 154563 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154568 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 154571 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 154575 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 154578 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154583 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 154596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154605 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 154611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 154624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 154634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 154637 */     GIR_RootConstrainSelectedInstOperands,
     /* 154638 */     // GIR_Coverage, 6211,
     /* 154638 */     GIR_EraseRootFromParent_Done,
     /* 154639 */   // Label 3035: @154639
     /* 154639 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(154743), // Rule ID 13349 //
     /* 154644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 154647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 154655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 154693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 154702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154706 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154710 */     // MIs[3] Operand 1
     /* 154710 */     // No operand predicates
     /* 154710 */     // MIs[1] Operand 2
     /* 154710 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 154727 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 154730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 154734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 154738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 154741 */     GIR_RootConstrainSelectedInstOperands,
     /* 154742 */     // GIR_Coverage, 13349,
     /* 154742 */     GIR_EraseRootFromParent_Done,
     /* 154743 */   // Label 3036: @154743
     /* 154743 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(154847), // Rule ID 13352 //
     /* 154748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 154797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 154806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154810 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154814 */     // MIs[3] Operand 1
     /* 154814 */     // No operand predicates
     /* 154814 */     // MIs[1] Operand 2
     /* 154814 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154829 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 154831 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 154834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 154838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 154842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 154845 */     GIR_RootConstrainSelectedInstOperands,
     /* 154846 */     // GIR_Coverage, 13352,
     /* 154846 */     GIR_EraseRootFromParent_Done,
     /* 154847 */   // Label 3037: @154847
     /* 154847 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(154978), // Rule ID 2515 //
     /* 154852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 154855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 154863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 154866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 154869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154894 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 154898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 154914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 154923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154927 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154931 */     // MIs[3] Operand 1
     /* 154931 */     // No operand predicates
     /* 154931 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 154933 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 154933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 154936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154945 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 154951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 154964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 154973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 154976 */     GIR_RootConstrainSelectedInstOperands,
     /* 154977 */     // GIR_Coverage, 2515,
     /* 154977 */     GIR_EraseRootFromParent_Done,
     /* 154978 */   // Label 3038: @154978
     /* 154978 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(155109), // Rule ID 2516 //
     /* 154983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 154991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 154994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155025 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155058 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155062 */     // MIs[3] Operand 1
     /* 155062 */     // No operand predicates
     /* 155062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155064 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 155064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155076 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 155082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 155095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155107 */     GIR_RootConstrainSelectedInstOperands,
     /* 155108 */     // GIR_Coverage, 2516,
     /* 155108 */     GIR_EraseRootFromParent_Done,
     /* 155109 */   // Label 3039: @155109
     /* 155109 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(155240), // Rule ID 2517 //
     /* 155114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155156 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155189 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 155193 */     // MIs[3] Operand 1
     /* 155193 */     // No operand predicates
     /* 155193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155195 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 155195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 155198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155207 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 155213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 155226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155238 */     GIR_RootConstrainSelectedInstOperands,
     /* 155239 */     // GIR_Coverage, 2517,
     /* 155239 */     GIR_EraseRootFromParent_Done,
     /* 155240 */   // Label 3040: @155240
     /* 155240 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(155371), // Rule ID 13535 //
     /* 155245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 155256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 155259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 155262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155295 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155299 */     // MIs[2] Operand 1
     /* 155299 */     // No operand predicates
     /* 155299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 155303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155307 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155311 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155315 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155320 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 155324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155326 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 155326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155338 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 155344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 155357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155369 */     GIR_RootConstrainSelectedInstOperands,
     /* 155370 */     // GIR_Coverage, 13535,
     /* 155370 */     GIR_EraseRootFromParent_Done,
     /* 155371 */   // Label 3041: @155371
     /* 155371 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(155502), // Rule ID 13536 //
     /* 155376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155426 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155430 */     // MIs[2] Operand 1
     /* 155430 */     // No operand predicates
     /* 155430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 155434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155438 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155442 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155446 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155451 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 155455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155457 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 155457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155469 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 155475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 155488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155500 */     GIR_RootConstrainSelectedInstOperands,
     /* 155501 */     // GIR_Coverage, 13536,
     /* 155501 */     GIR_EraseRootFromParent_Done,
     /* 155502 */   // Label 3042: @155502
     /* 155502 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(155633), // Rule ID 13537 //
     /* 155507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 155553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155557 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 155561 */     // MIs[2] Operand 1
     /* 155561 */     // No operand predicates
     /* 155561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 155565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155569 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155573 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 155577 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155582 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 155586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155588 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 155588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 155591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155600 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 155606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 155619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 155628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 155631 */     GIR_RootConstrainSelectedInstOperands,
     /* 155632 */     // GIR_Coverage, 13537,
     /* 155632 */     GIR_EraseRootFromParent_Done,
     /* 155633 */   // Label 3043: @155633
     /* 155633 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(155747), // Rule ID 2049 //
     /* 155638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 155649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 155652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 155655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155671 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155674 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155683 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 155700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155721 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155725 */     // MIs[3] Operand 1
     /* 155725 */     // No operand predicates
     /* 155725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155727 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 155730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155745 */     GIR_RootConstrainSelectedInstOperands,
     /* 155746 */     // GIR_Coverage, 2049,
     /* 155746 */     GIR_EraseRootFromParent_Done,
     /* 155747 */   // Label 3044: @155747
     /* 155747 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(155861), // Rule ID 2056 //
     /* 155752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 155763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 155766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 155769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155785 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155788 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155797 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 155814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155835 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155839 */     // MIs[3] Operand 1
     /* 155839 */     // No operand predicates
     /* 155839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155841 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 155844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155859 */     GIR_RootConstrainSelectedInstOperands,
     /* 155860 */     // GIR_Coverage, 2056,
     /* 155860 */     GIR_EraseRootFromParent_Done,
     /* 155861 */   // Label 3045: @155861
     /* 155861 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(155975), // Rule ID 2052 //
     /* 155866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155899 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 155902 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155911 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 155924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155949 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155953 */     // MIs[3] Operand 1
     /* 155953 */     // No operand predicates
     /* 155953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155955 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 155958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 155966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155973 */     GIR_RootConstrainSelectedInstOperands,
     /* 155974 */     // GIR_Coverage, 2052,
     /* 155974 */     GIR_EraseRootFromParent_Done,
     /* 155975 */   // Label 3046: @155975
     /* 155975 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(156089), // Rule ID 2059 //
     /* 155980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 155991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 155994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 155997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156013 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156016 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156025 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156063 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156067 */     // MIs[3] Operand 1
     /* 156067 */     // No operand predicates
     /* 156067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156069 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 156072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156087 */     GIR_RootConstrainSelectedInstOperands,
     /* 156088 */     // GIR_Coverage, 2059,
     /* 156088 */     GIR_EraseRootFromParent_Done,
     /* 156089 */   // Label 3047: @156089
     /* 156089 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(156203), // Rule ID 2054 //
     /* 156094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156127 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156130 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 156135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 156139 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 156143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156177 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156181 */     // MIs[3] Operand 1
     /* 156181 */     // No operand predicates
     /* 156181 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156183 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 156186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156201 */     GIR_RootConstrainSelectedInstOperands,
     /* 156202 */     // GIR_Coverage, 2054,
     /* 156202 */     GIR_EraseRootFromParent_Done,
     /* 156203 */   // Label 3048: @156203
     /* 156203 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(156317), // Rule ID 2061 //
     /* 156208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156241 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156244 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 156249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 156253 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 156257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156291 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156295 */     // MIs[3] Operand 1
     /* 156295 */     // No operand predicates
     /* 156295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156297 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 156300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156315 */     GIR_RootConstrainSelectedInstOperands,
     /* 156316 */     // GIR_Coverage, 2061,
     /* 156316 */     GIR_EraseRootFromParent_Done,
     /* 156317 */   // Label 3049: @156317
     /* 156317 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(156421), // Rule ID 1980 //
     /* 156322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 156325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 156333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156388 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156392 */     // MIs[3] Operand 1
     /* 156392 */     // No operand predicates
     /* 156392 */     // MIs[1] Operand 2
     /* 156392 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 156403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156405 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 156408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156419 */     GIR_RootConstrainSelectedInstOperands,
     /* 156420 */     // GIR_Coverage, 1980,
     /* 156420 */     GIR_EraseRootFromParent_Done,
     /* 156421 */   // Label 3050: @156421
     /* 156421 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(156525), // Rule ID 2010 //
     /* 156426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 156434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 156437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156492 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156496 */     // MIs[3] Operand 1
     /* 156496 */     // No operand predicates
     /* 156496 */     // MIs[1] Operand 2
     /* 156496 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 156507 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156509 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 156512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156523 */     GIR_RootConstrainSelectedInstOperands,
     /* 156524 */     // GIR_Coverage, 2010,
     /* 156524 */     GIR_EraseRootFromParent_Done,
     /* 156525 */   // Label 3051: @156525
     /* 156525 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(156629), // Rule ID 2017 //
     /* 156530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 156538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 156541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156596 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156600 */     // MIs[3] Operand 1
     /* 156600 */     // No operand predicates
     /* 156600 */     // MIs[1] Operand 2
     /* 156600 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 156611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156613 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 156616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156627 */     GIR_RootConstrainSelectedInstOperands,
     /* 156628 */     // GIR_Coverage, 2017,
     /* 156628 */     GIR_EraseRootFromParent_Done,
     /* 156629 */   // Label 3052: @156629
     /* 156629 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(156733), // Rule ID 2076 //
     /* 156634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156700 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156704 */     // MIs[3] Operand 1
     /* 156704 */     // No operand predicates
     /* 156704 */     // MIs[1] Operand 2
     /* 156704 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 156715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156717 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 156720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156731 */     GIR_RootConstrainSelectedInstOperands,
     /* 156732 */     // GIR_Coverage, 2076,
     /* 156732 */     GIR_EraseRootFromParent_Done,
     /* 156733 */   // Label 3053: @156733
     /* 156733 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(156837), // Rule ID 1983 //
     /* 156738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 156749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156796 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156800 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156804 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156808 */     // MIs[3] Operand 1
     /* 156808 */     // No operand predicates
     /* 156808 */     // MIs[1] Operand 2
     /* 156808 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 156819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156821 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 156824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156835 */     GIR_RootConstrainSelectedInstOperands,
     /* 156836 */     // GIR_Coverage, 1983,
     /* 156836 */     GIR_EraseRootFromParent_Done,
     /* 156837 */   // Label 3054: @156837
     /* 156837 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(156941), // Rule ID 2013 //
     /* 156842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 156850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 156853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156908 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156912 */     // MIs[3] Operand 1
     /* 156912 */     // No operand predicates
     /* 156912 */     // MIs[1] Operand 2
     /* 156912 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 156923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156925 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 156928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 156932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156939 */     GIR_RootConstrainSelectedInstOperands,
     /* 156940 */     // GIR_Coverage, 2013,
     /* 156940 */     GIR_EraseRootFromParent_Done,
     /* 156941 */   // Label 3055: @156941
     /* 156941 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(157045), // Rule ID 2020 //
     /* 156946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 156954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 156957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156995 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157012 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157016 */     // MIs[3] Operand 1
     /* 157016 */     // No operand predicates
     /* 157016 */     // MIs[1] Operand 2
     /* 157016 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157029 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 157032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157043 */     GIR_RootConstrainSelectedInstOperands,
     /* 157044 */     // GIR_Coverage, 2020,
     /* 157044 */     GIR_EraseRootFromParent_Done,
     /* 157045 */   // Label 3056: @157045
     /* 157045 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(157149), // Rule ID 2079 //
     /* 157050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157116 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157120 */     // MIs[3] Operand 1
     /* 157120 */     // No operand predicates
     /* 157120 */     // MIs[1] Operand 2
     /* 157120 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157133 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 157136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157147 */     GIR_RootConstrainSelectedInstOperands,
     /* 157148 */     // GIR_Coverage, 2079,
     /* 157148 */     GIR_EraseRootFromParent_Done,
     /* 157149 */   // Label 3057: @157149
     /* 157149 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(157206), // Rule ID 1744 //
     /* 157154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 157182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 157189 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 157189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 157192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 157199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 157204 */     GIR_RootConstrainSelectedInstOperands,
     /* 157205 */     // GIR_Coverage, 1744,
     /* 157205 */     GIR_EraseRootFromParent_Done,
     /* 157206 */   // Label 3058: @157206
     /* 157206 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(157263), // Rule ID 1746 //
     /* 157211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 157239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 157246 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 157246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 157249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 157256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 157261 */     GIR_RootConstrainSelectedInstOperands,
     /* 157262 */     // GIR_Coverage, 1746,
     /* 157262 */     GIR_EraseRootFromParent_Done,
     /* 157263 */   // Label 3059: @157263
     /* 157263 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(157373), // Rule ID 6230 //
     /* 157268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 157273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 157294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 157298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 157302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157307 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 157318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 157322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157326 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 157330 */     // MIs[2] Operand 1
     /* 157330 */     // No operand predicates
     /* 157330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 157332 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 157332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157344 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 157350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 157363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 157371 */     GIR_RootConstrainSelectedInstOperands,
     /* 157372 */     // GIR_Coverage, 6230,
     /* 157372 */     GIR_EraseRootFromParent_Done,
     /* 157373 */   // Label 3060: @157373
     /* 157373 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(157470), // Rule ID 13803 //
     /* 157378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 157381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 157395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157420 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 157424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157430 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 157430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 157433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157442 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 157448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 157461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 157465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157468 */     GIR_RootConstrainSelectedInstOperands,
     /* 157469 */     // GIR_Coverage, 13803,
     /* 157469 */     GIR_EraseRootFromParent_Done,
     /* 157470 */   // Label 3061: @157470
     /* 157470 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(157567), // Rule ID 13804 //
     /* 157475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 157478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 157486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157517 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 157521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157527 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 157527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 157530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157539 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 157545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 157558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 157562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157565 */     GIR_RootConstrainSelectedInstOperands,
     /* 157566 */     // GIR_Coverage, 13804,
     /* 157566 */     GIR_EraseRootFromParent_Done,
     /* 157567 */   // Label 3062: @157567
     /* 157567 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(157664), // Rule ID 13805 //
     /* 157572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 157575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 157605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 157609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157614 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 157618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157624 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 157624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 157627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157636 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 157642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 157655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 157659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157662 */     GIR_RootConstrainSelectedInstOperands,
     /* 157663 */     // GIR_Coverage, 13805,
     /* 157663 */     GIR_EraseRootFromParent_Done,
     /* 157664 */   // Label 3063: @157664
     /* 157664 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(157747), // Rule ID 1735 //
     /* 157669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 157677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 157683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 157686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157702 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157705 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157714 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157730 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 157730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 157733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 157745 */     GIR_RootConstrainSelectedInstOperands,
     /* 157746 */     // GIR_Coverage, 1735,
     /* 157746 */     GIR_EraseRootFromParent_Done,
     /* 157747 */   // Label 3064: @157747
     /* 157747 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(157830), // Rule ID 1737 //
     /* 157752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 157760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 157766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 157769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157785 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157788 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157797 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157813 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 157813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 157816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 157828 */     GIR_RootConstrainSelectedInstOperands,
     /* 157829 */     // GIR_Coverage, 1737,
     /* 157829 */     GIR_EraseRootFromParent_Done,
     /* 157830 */   // Label 3065: @157830
     /* 157830 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(157913), // Rule ID 1739 //
     /* 157835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 157843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 157849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 157852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157868 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157871 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157880 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157896 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 157896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 157899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 157911 */     GIR_RootConstrainSelectedInstOperands,
     /* 157912 */     // GIR_Coverage, 1739,
     /* 157912 */     GIR_EraseRootFromParent_Done,
     /* 157913 */   // Label 3066: @157913
     /* 157913 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(157996), // Rule ID 1741 //
     /* 157918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 157926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 157932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 157935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157951 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157954 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157963 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157979 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 157979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 157982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 157994 */     GIR_RootConstrainSelectedInstOperands,
     /* 157995 */     // GIR_Coverage, 1741,
     /* 157995 */     GIR_EraseRootFromParent_Done,
     /* 157996 */   // Label 3067: @157996
     /* 157996 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(158076), // Rule ID 5213 //
     /* 158001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158031 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158034 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 158039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 158043 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 158047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158059 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 158059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 158062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158074 */     GIR_RootConstrainSelectedInstOperands,
     /* 158075 */     // GIR_Coverage, 5213,
     /* 158075 */     GIR_EraseRootFromParent_Done,
     /* 158076 */   // Label 3068: @158076
     /* 158076 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(158156), // Rule ID 5214 //
     /* 158081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 158086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158111 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158114 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 158119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 158123 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 158127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158139 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 158139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 158142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158154 */     GIR_RootConstrainSelectedInstOperands,
     /* 158155 */     // GIR_Coverage, 5214,
     /* 158155 */     GIR_EraseRootFromParent_Done,
     /* 158156 */   // Label 3069: @158156
     /* 158156 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(158253), // Rule ID 5210 //
     /* 158161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 158164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 158178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158213 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 158213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158225 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 158231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 158244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158251 */     GIR_RootConstrainSelectedInstOperands,
     /* 158252 */     // GIR_Coverage, 5210,
     /* 158252 */     GIR_EraseRootFromParent_Done,
     /* 158253 */   // Label 3070: @158253
     /* 158253 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(158350), // Rule ID 5211 //
     /* 158258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 158261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158304 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158310 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 158310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158322 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 158328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 158341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158348 */     GIR_RootConstrainSelectedInstOperands,
     /* 158349 */     // GIR_Coverage, 5211,
     /* 158349 */     GIR_EraseRootFromParent_Done,
     /* 158350 */   // Label 3071: @158350
     /* 158350 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(158447), // Rule ID 5212 //
     /* 158355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 158358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158401 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158407 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 158407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 158410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158419 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 158425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 158438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158445 */     GIR_RootConstrainSelectedInstOperands,
     /* 158446 */     // GIR_Coverage, 5212,
     /* 158446 */     GIR_EraseRootFromParent_Done,
     /* 158447 */   // Label 3072: @158447
     /* 158447 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(158528), // Rule ID 13350 //
     /* 158452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 158455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 158463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 158481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 158494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 158498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158502 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 158506 */     // MIs[2] Operand 1
     /* 158506 */     // No operand predicates
     /* 158506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158512 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 158515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 158523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 158526 */     GIR_RootConstrainSelectedInstOperands,
     /* 158527 */     // GIR_Coverage, 13350,
     /* 158527 */     GIR_EraseRootFromParent_Done,
     /* 158528 */   // Label 3073: @158528
     /* 158528 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(158609), // Rule ID 13351 //
     /* 158533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 158536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 158544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 158547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 158550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 158562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 158575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 158579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158583 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 158587 */     // MIs[2] Operand 1
     /* 158587 */     // No operand predicates
     /* 158587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158593 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 158596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 158604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 158607 */     GIR_RootConstrainSelectedInstOperands,
     /* 158608 */     // GIR_Coverage, 13351,
     /* 158608 */     GIR_EraseRootFromParent_Done,
     /* 158609 */   // Label 3074: @158609
     /* 158609 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(158690), // Rule ID 13353 //
     /* 158614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 158625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 158643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 158660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158664 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158668 */     // MIs[2] Operand 1
     /* 158668 */     // No operand predicates
     /* 158668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158674 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 158677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 158685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 158688 */     GIR_RootConstrainSelectedInstOperands,
     /* 158689 */     // GIR_Coverage, 13353,
     /* 158689 */     GIR_EraseRootFromParent_Done,
     /* 158690 */   // Label 3075: @158690
     /* 158690 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(158771), // Rule ID 13354 //
     /* 158695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 158724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 158741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158745 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158749 */     // MIs[2] Operand 1
     /* 158749 */     // No operand predicates
     /* 158749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158755 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 158758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 158766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 158769 */     GIR_RootConstrainSelectedInstOperands,
     /* 158770 */     // GIR_Coverage, 13354,
     /* 158770 */     GIR_EraseRootFromParent_Done,
     /* 158771 */   // Label 3076: @158771
     /* 158771 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(158852), // Rule ID 13355 //
     /* 158776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 158787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 158793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 158805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 158822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 158830 */     // MIs[2] Operand 1
     /* 158830 */     // No operand predicates
     /* 158830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158836 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 158839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 158847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 158850 */     GIR_RootConstrainSelectedInstOperands,
     /* 158851 */     // GIR_Coverage, 13355,
     /* 158851 */     GIR_EraseRootFromParent_Done,
     /* 158852 */   // Label 3077: @158852
     /* 158852 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(158933), // Rule ID 13356 //
     /* 158857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 158860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 158874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 158899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 158903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158907 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 158911 */     // MIs[2] Operand 1
     /* 158911 */     // No operand predicates
     /* 158911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158917 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 158920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 158928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 158931 */     GIR_RootConstrainSelectedInstOperands,
     /* 158932 */     // GIR_Coverage, 13356,
     /* 158932 */     GIR_EraseRootFromParent_Done,
     /* 158933 */   // Label 3078: @158933
     /* 158933 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(159014), // Rule ID 13357 //
     /* 158938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 158984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158988 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158992 */     // MIs[2] Operand 1
     /* 158992 */     // No operand predicates
     /* 158992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158998 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 159001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159012 */     GIR_RootConstrainSelectedInstOperands,
     /* 159013 */     // GIR_Coverage, 13357,
     /* 159013 */     GIR_EraseRootFromParent_Done,
     /* 159014 */   // Label 3079: @159014
     /* 159014 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(159095), // Rule ID 13358 //
     /* 159019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159069 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 159073 */     // MIs[2] Operand 1
     /* 159073 */     // No operand predicates
     /* 159073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159079 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 159082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159093 */     GIR_RootConstrainSelectedInstOperands,
     /* 159094 */     // GIR_Coverage, 13358,
     /* 159094 */     GIR_EraseRootFromParent_Done,
     /* 159095 */   // Label 3080: @159095
     /* 159095 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(159201), // Rule ID 6227 //
     /* 159100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 159105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 159108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 159126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 159130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159135 */     // MIs[1] Operand 2
     /* 159135 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 159146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 159150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159154 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 159158 */     // MIs[2] Operand 1
     /* 159158 */     // No operand predicates
     /* 159158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159160 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 159160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 159163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159172 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 159178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 159191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 159199 */     GIR_RootConstrainSelectedInstOperands,
     /* 159200 */     // GIR_Coverage, 6227,
     /* 159200 */     GIR_EraseRootFromParent_Done,
     /* 159201 */   // Label 3081: @159201
     /* 159201 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(159282), // Rule ID 1981 //
     /* 159206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159260 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159264 */     // MIs[2] Operand 1
     /* 159264 */     // No operand predicates
     /* 159264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159266 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 159269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159280 */     GIR_RootConstrainSelectedInstOperands,
     /* 159281 */     // GIR_Coverage, 1981,
     /* 159281 */     GIR_EraseRootFromParent_Done,
     /* 159282 */   // Label 3082: @159282
     /* 159282 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(159363), // Rule ID 1982 //
     /* 159287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 159298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 159304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159341 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159345 */     // MIs[2] Operand 1
     /* 159345 */     // No operand predicates
     /* 159345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159347 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 159350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159361 */     GIR_RootConstrainSelectedInstOperands,
     /* 159362 */     // GIR_Coverage, 1982,
     /* 159362 */     GIR_EraseRootFromParent_Done,
     /* 159363 */   // Label 3083: @159363
     /* 159363 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(159444), // Rule ID 2011 //
     /* 159368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 159376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159422 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159426 */     // MIs[2] Operand 1
     /* 159426 */     // No operand predicates
     /* 159426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159428 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 159431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159442 */     GIR_RootConstrainSelectedInstOperands,
     /* 159443 */     // GIR_Coverage, 2011,
     /* 159443 */     GIR_EraseRootFromParent_Done,
     /* 159444 */   // Label 3084: @159444
     /* 159444 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(159525), // Rule ID 2012 //
     /* 159449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 159457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 159460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 159466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159503 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159507 */     // MIs[2] Operand 1
     /* 159507 */     // No operand predicates
     /* 159507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159509 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 159512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159523 */     GIR_RootConstrainSelectedInstOperands,
     /* 159524 */     // GIR_Coverage, 2012,
     /* 159524 */     GIR_EraseRootFromParent_Done,
     /* 159525 */   // Label 3085: @159525
     /* 159525 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(159606), // Rule ID 2018 //
     /* 159530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 159538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159584 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159588 */     // MIs[2] Operand 1
     /* 159588 */     // No operand predicates
     /* 159588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159590 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 159593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159604 */     GIR_RootConstrainSelectedInstOperands,
     /* 159605 */     // GIR_Coverage, 2018,
     /* 159605 */     GIR_EraseRootFromParent_Done,
     /* 159606 */   // Label 3086: @159606
     /* 159606 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(159687), // Rule ID 2019 //
     /* 159611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 159619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 159622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 159628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159665 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159669 */     // MIs[2] Operand 1
     /* 159669 */     // No operand predicates
     /* 159669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159671 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 159674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159685 */     GIR_RootConstrainSelectedInstOperands,
     /* 159686 */     // GIR_Coverage, 2019,
     /* 159686 */     GIR_EraseRootFromParent_Done,
     /* 159687 */   // Label 3087: @159687
     /* 159687 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(159768), // Rule ID 2077 //
     /* 159692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 159700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159746 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159750 */     // MIs[2] Operand 1
     /* 159750 */     // No operand predicates
     /* 159750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159752 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 159755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159766 */     GIR_RootConstrainSelectedInstOperands,
     /* 159767 */     // GIR_Coverage, 2077,
     /* 159767 */     GIR_EraseRootFromParent_Done,
     /* 159768 */   // Label 3088: @159768
     /* 159768 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(159849), // Rule ID 1984 //
     /* 159773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 159784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159827 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159831 */     // MIs[2] Operand 1
     /* 159831 */     // No operand predicates
     /* 159831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159833 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 159836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159847 */     GIR_RootConstrainSelectedInstOperands,
     /* 159848 */     // GIR_Coverage, 1984,
     /* 159848 */     GIR_EraseRootFromParent_Done,
     /* 159849 */   // Label 3089: @159849
     /* 159849 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(159930), // Rule ID 1985 //
     /* 159854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 159871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159908 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159912 */     // MIs[2] Operand 1
     /* 159912 */     // No operand predicates
     /* 159912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159914 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 159917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159928 */     GIR_RootConstrainSelectedInstOperands,
     /* 159929 */     // GIR_Coverage, 1985,
     /* 159929 */     GIR_EraseRootFromParent_Done,
     /* 159930 */   // Label 3090: @159930
     /* 159930 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(160011), // Rule ID 2014 //
     /* 159935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 159943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 159946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159993 */     // MIs[2] Operand 1
     /* 159993 */     // No operand predicates
     /* 159993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159995 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 159998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160009 */     GIR_RootConstrainSelectedInstOperands,
     /* 160010 */     // GIR_Coverage, 2014,
     /* 160010 */     GIR_EraseRootFromParent_Done,
     /* 160011 */   // Label 3091: @160011
     /* 160011 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(160092), // Rule ID 2015 //
     /* 160016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160074 */     // MIs[2] Operand 1
     /* 160074 */     // No operand predicates
     /* 160074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160076 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 160079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160090 */     GIR_RootConstrainSelectedInstOperands,
     /* 160091 */     // GIR_Coverage, 2015,
     /* 160091 */     GIR_EraseRootFromParent_Done,
     /* 160092 */   // Label 3092: @160092
     /* 160092 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(160173), // Rule ID 2021 //
     /* 160097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160151 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160155 */     // MIs[2] Operand 1
     /* 160155 */     // No operand predicates
     /* 160155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160157 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 160160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160171 */     GIR_RootConstrainSelectedInstOperands,
     /* 160172 */     // GIR_Coverage, 2021,
     /* 160172 */     GIR_EraseRootFromParent_Done,
     /* 160173 */   // Label 3093: @160173
     /* 160173 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(160254), // Rule ID 2022 //
     /* 160178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160232 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160236 */     // MIs[2] Operand 1
     /* 160236 */     // No operand predicates
     /* 160236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160238 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 160241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160252 */     GIR_RootConstrainSelectedInstOperands,
     /* 160253 */     // GIR_Coverage, 2022,
     /* 160253 */     GIR_EraseRootFromParent_Done,
     /* 160254 */   // Label 3094: @160254
     /* 160254 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(160335), // Rule ID 2080 //
     /* 160259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160313 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160317 */     // MIs[2] Operand 1
     /* 160317 */     // No operand predicates
     /* 160317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160319 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 160322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160333 */     GIR_RootConstrainSelectedInstOperands,
     /* 160334 */     // GIR_Coverage, 2080,
     /* 160334 */     GIR_EraseRootFromParent_Done,
     /* 160335 */   // Label 3095: @160335
     /* 160335 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(160416), // Rule ID 1986 //
     /* 160340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 160357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 160373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 160377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160394 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 160398 */     // MIs[2] Operand 1
     /* 160398 */     // No operand predicates
     /* 160398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160400 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 160403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160414 */     GIR_RootConstrainSelectedInstOperands,
     /* 160415 */     // GIR_Coverage, 1986,
     /* 160415 */     GIR_EraseRootFromParent_Done,
     /* 160416 */   // Label 3096: @160416
     /* 160416 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(160497), // Rule ID 1987 //
     /* 160421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 160432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 160438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160475 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160479 */     // MIs[2] Operand 1
     /* 160479 */     // No operand predicates
     /* 160479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160481 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 160484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160495 */     GIR_RootConstrainSelectedInstOperands,
     /* 160496 */     // GIR_Coverage, 1987,
     /* 160496 */     GIR_EraseRootFromParent_Done,
     /* 160497 */   // Label 3097: @160497
     /* 160497 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(160578), // Rule ID 1988 //
     /* 160502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160556 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160560 */     // MIs[2] Operand 1
     /* 160560 */     // No operand predicates
     /* 160560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160562 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 160565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160576 */     GIR_RootConstrainSelectedInstOperands,
     /* 160577 */     // GIR_Coverage, 1988,
     /* 160577 */     GIR_EraseRootFromParent_Done,
     /* 160578 */   // Label 3098: @160578
     /* 160578 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(160659), // Rule ID 1989 //
     /* 160583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 160600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 160620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160637 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 160641 */     // MIs[2] Operand 1
     /* 160641 */     // No operand predicates
     /* 160641 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160643 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 160646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160657 */     GIR_RootConstrainSelectedInstOperands,
     /* 160658 */     // GIR_Coverage, 1989,
     /* 160658 */     GIR_EraseRootFromParent_Done,
     /* 160659 */   // Label 3099: @160659
     /* 160659 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(160740), // Rule ID 2016 //
     /* 160664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160718 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160722 */     // MIs[2] Operand 1
     /* 160722 */     // No operand predicates
     /* 160722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160724 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 160727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160738 */     GIR_RootConstrainSelectedInstOperands,
     /* 160739 */     // GIR_Coverage, 2016,
     /* 160739 */     GIR_EraseRootFromParent_Done,
     /* 160740 */   // Label 3100: @160740
     /* 160740 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(160821), // Rule ID 2023 //
     /* 160745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160799 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160803 */     // MIs[2] Operand 1
     /* 160803 */     // No operand predicates
     /* 160803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160805 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 160808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160819 */     GIR_RootConstrainSelectedInstOperands,
     /* 160820 */     // GIR_Coverage, 2023,
     /* 160820 */     GIR_EraseRootFromParent_Done,
     /* 160821 */   // Label 3101: @160821
     /* 160821 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(160899), // Rule ID 6214 //
     /* 160826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 160831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160877 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160881 */     // MIs[2] Operand 1
     /* 160881 */     // No operand predicates
     /* 160881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160883 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 160883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 160886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 160894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160897 */     GIR_RootConstrainSelectedInstOperands,
     /* 160898 */     // GIR_Coverage, 6214,
     /* 160898 */     GIR_EraseRootFromParent_Done,
     /* 160899 */   // Label 3102: @160899
     /* 160899 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(160959), // Rule ID 6288 //
     /* 160904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 160909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 160912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160926 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 160930 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 160930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 160933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 160937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160942 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 160945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 160950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 160954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160957 */     GIR_RootConstrainSelectedInstOperands,
     /* 160958 */     // GIR_Coverage, 6288,
     /* 160958 */     GIR_EraseRootFromParent_Done,
     /* 160959 */   // Label 3103: @160959
     /* 160959 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(161019), // Rule ID 6289 //
     /* 160964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 160969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 160990 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 160990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 160993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 160997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161002 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 161005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 161010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 161014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161017 */     GIR_RootConstrainSelectedInstOperands,
     /* 161018 */     // GIR_Coverage, 6289,
     /* 161018 */     GIR_EraseRootFromParent_Done,
     /* 161019 */   // Label 3104: @161019
     /* 161019 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(161079), // Rule ID 6290 //
     /* 161024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 161029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 161050 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 161050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 161053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 161057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161062 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 161065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 161070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 161074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161077 */     GIR_RootConstrainSelectedInstOperands,
     /* 161078 */     // GIR_Coverage, 6290,
     /* 161078 */     GIR_EraseRootFromParent_Done,
     /* 161079 */   // Label 3105: @161079
     /* 161079 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(161126), // Rule ID 3878 //
     /* 161084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161106 */     // MIs[0] Operand 3
     /* 161106 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 161117 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 161117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 161120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161124 */     GIR_RootConstrainSelectedInstOperands,
     /* 161125 */     // GIR_Coverage, 3878,
     /* 161125 */     GIR_EraseRootFromParent_Done,
     /* 161126 */   // Label 3106: @161126
     /* 161126 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(161173), // Rule ID 3879 //
     /* 161131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161153 */     // MIs[0] Operand 3
     /* 161153 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 161164 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 161164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 161167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161171 */     GIR_RootConstrainSelectedInstOperands,
     /* 161172 */     // GIR_Coverage, 3879,
     /* 161172 */     GIR_EraseRootFromParent_Done,
     /* 161173 */   // Label 3107: @161173
     /* 161173 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(161220), // Rule ID 3880 //
     /* 161178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161200 */     // MIs[0] Operand 3
     /* 161200 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 161211 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 161211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 161214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161218 */     GIR_RootConstrainSelectedInstOperands,
     /* 161219 */     // GIR_Coverage, 3880,
     /* 161219 */     GIR_EraseRootFromParent_Done,
     /* 161220 */   // Label 3108: @161220
     /* 161220 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(161267), // Rule ID 3881 //
     /* 161225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161247 */     // MIs[0] Operand 3
     /* 161247 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 161258 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 161258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 161261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161265 */     GIR_RootConstrainSelectedInstOperands,
     /* 161266 */     // GIR_Coverage, 3881,
     /* 161266 */     GIR_EraseRootFromParent_Done,
     /* 161267 */   // Label 3109: @161267
     /* 161267 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(161313), // Rule ID 3535 //
     /* 161272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 161275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 161280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 161283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 161286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 161290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161294 */     // MIs[0] Idx
     /* 161294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161297 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 161302 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1612:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 161302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 161305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 161307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 161309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 161311 */     GIR_RootConstrainSelectedInstOperands,
     /* 161312 */     // GIR_Coverage, 3535,
     /* 161312 */     GIR_EraseRootFromParent_Done,
     /* 161313 */   // Label 3110: @161313
     /* 161313 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(161359), // Rule ID 3536 //
     /* 161318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 161321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 161326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 161329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 161332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 161336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161340 */     // MIs[0] Idx
     /* 161340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 161348 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1612:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 161348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 161351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 161353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 161355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 161357 */     GIR_RootConstrainSelectedInstOperands,
     /* 161358 */     // GIR_Coverage, 3536,
     /* 161358 */     GIR_EraseRootFromParent_Done,
     /* 161359 */   // Label 3111: @161359
     /* 161359 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(161405), // Rule ID 3537 //
     /* 161364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 161367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 161372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 161375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 161378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 161382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161386 */     // MIs[0] Idx
     /* 161386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161389 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 161394 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1612:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 161394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 161397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 161399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 161401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 161403 */     GIR_RootConstrainSelectedInstOperands,
     /* 161404 */     // GIR_Coverage, 3537,
     /* 161404 */     GIR_EraseRootFromParent_Done,
     /* 161405 */   // Label 3112: @161405
     /* 161405 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(161451), // Rule ID 3538 //
     /* 161410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 161413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 161418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 161421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 161424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 161428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 161432 */     // MIs[0] Idx
     /* 161432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 161435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 161440 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1612:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 161440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 161443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 161445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 161447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 161449 */     GIR_RootConstrainSelectedInstOperands,
     /* 161450 */     // GIR_Coverage, 3538,
     /* 161450 */     GIR_EraseRootFromParent_Done,
     /* 161451 */   // Label 3113: @161451
     /* 161451 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(161507), // Rule ID 2101 //
     /* 161456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 161464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 161493 */     // MIs[1] Operand 1
     /* 161493 */     // No operand predicates
     /* 161493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161495 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 161498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161505 */     GIR_RootConstrainSelectedInstOperands,
     /* 161506 */     // GIR_Coverage, 2101,
     /* 161506 */     GIR_EraseRootFromParent_Done,
     /* 161507 */   // Label 3114: @161507
     /* 161507 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(161563), // Rule ID 2102 //
     /* 161512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 161520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 161549 */     // MIs[1] Operand 1
     /* 161549 */     // No operand predicates
     /* 161549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161551 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 161554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161561 */     GIR_RootConstrainSelectedInstOperands,
     /* 161562 */     // GIR_Coverage, 2102,
     /* 161562 */     GIR_EraseRootFromParent_Done,
     /* 161563 */   // Label 3115: @161563
     /* 161563 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(161619), // Rule ID 2107 //
     /* 161568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 161576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 161605 */     // MIs[1] Operand 1
     /* 161605 */     // No operand predicates
     /* 161605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161607 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 161610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161617 */     GIR_RootConstrainSelectedInstOperands,
     /* 161618 */     // GIR_Coverage, 2107,
     /* 161618 */     GIR_EraseRootFromParent_Done,
     /* 161619 */   // Label 3116: @161619
     /* 161619 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(161675), // Rule ID 2108 //
     /* 161624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 161632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 161661 */     // MIs[1] Operand 1
     /* 161661 */     // No operand predicates
     /* 161661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161663 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 161666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161673 */     GIR_RootConstrainSelectedInstOperands,
     /* 161674 */     // GIR_Coverage, 2108,
     /* 161674 */     GIR_EraseRootFromParent_Done,
     /* 161675 */   // Label 3117: @161675
     /* 161675 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(161731), // Rule ID 2114 //
     /* 161680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 161688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 161717 */     // MIs[1] Operand 1
     /* 161717 */     // No operand predicates
     /* 161717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161719 */     // (intrinsic_wo_chain:{ *:[i32] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 161722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161729 */     GIR_RootConstrainSelectedInstOperands,
     /* 161730 */     // GIR_Coverage, 2114,
     /* 161730 */     GIR_EraseRootFromParent_Done,
     /* 161731 */   // Label 3118: @161731
     /* 161731 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(161787), // Rule ID 2117 //
     /* 161736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 161744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 161773 */     // MIs[1] Operand 1
     /* 161773 */     // No operand predicates
     /* 161773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161775 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 161778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161785 */     GIR_RootConstrainSelectedInstOperands,
     /* 161786 */     // GIR_Coverage, 2117,
     /* 161786 */     GIR_EraseRootFromParent_Done,
     /* 161787 */   // Label 3119: @161787
     /* 161787 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(161843), // Rule ID 2139 //
     /* 161792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 161800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 161829 */     // MIs[1] Operand 1
     /* 161829 */     // No operand predicates
     /* 161829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161831 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 161834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161841 */     GIR_RootConstrainSelectedInstOperands,
     /* 161842 */     // GIR_Coverage, 2139,
     /* 161842 */     GIR_EraseRootFromParent_Done,
     /* 161843 */   // Label 3120: @161843
     /* 161843 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(161899), // Rule ID 2141 //
     /* 161848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 161856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 161885 */     // MIs[1] Operand 1
     /* 161885 */     // No operand predicates
     /* 161885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161887 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 161890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161897 */     GIR_RootConstrainSelectedInstOperands,
     /* 161898 */     // GIR_Coverage, 2141,
     /* 161898 */     GIR_EraseRootFromParent_Done,
     /* 161899 */   // Label 3121: @161899
     /* 161899 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(161955), // Rule ID 2143 //
     /* 161904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 161912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 161941 */     // MIs[1] Operand 1
     /* 161941 */     // No operand predicates
     /* 161941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161943 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 161943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 161946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 161953 */     GIR_RootConstrainSelectedInstOperands,
     /* 161954 */     // GIR_Coverage, 2143,
     /* 161954 */     GIR_EraseRootFromParent_Done,
     /* 161955 */   // Label 3122: @161955
     /* 161955 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(162008), // Rule ID 6215 //
     /* 161960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 161965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 161994 */     // MIs[1] Operand 1
     /* 161994 */     // No operand predicates
     /* 161994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161996 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 161996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 161999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162006 */     GIR_RootConstrainSelectedInstOperands,
     /* 162007 */     // GIR_Coverage, 6215,
     /* 162007 */     GIR_EraseRootFromParent_Done,
     /* 162008 */   // Label 3123: @162008
     /* 162008 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(162061), // Rule ID 6216 //
     /* 162013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162047 */     // MIs[1] Operand 1
     /* 162047 */     // No operand predicates
     /* 162047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162049 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 162049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 162052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162059 */     GIR_RootConstrainSelectedInstOperands,
     /* 162060 */     // GIR_Coverage, 6216,
     /* 162060 */     GIR_EraseRootFromParent_Done,
     /* 162061 */   // Label 3124: @162061
     /* 162061 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(162114), // Rule ID 6217 //
     /* 162066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162100 */     // MIs[1] Operand 1
     /* 162100 */     // No operand predicates
     /* 162100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162102 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 162105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162112 */     GIR_RootConstrainSelectedInstOperands,
     /* 162113 */     // GIR_Coverage, 6217,
     /* 162113 */     GIR_EraseRootFromParent_Done,
     /* 162114 */   // Label 3125: @162114
     /* 162114 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(162167), // Rule ID 6218 //
     /* 162119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162153 */     // MIs[1] Operand 1
     /* 162153 */     // No operand predicates
     /* 162153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162155 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 162158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162165 */     GIR_RootConstrainSelectedInstOperands,
     /* 162166 */     // GIR_Coverage, 6218,
     /* 162166 */     GIR_EraseRootFromParent_Done,
     /* 162167 */   // Label 3126: @162167
     /* 162167 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(162220), // Rule ID 6219 //
     /* 162172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162206 */     // MIs[1] Operand 1
     /* 162206 */     // No operand predicates
     /* 162206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162208 */     // (intrinsic_wo_chain:{ *:[v1i64] } 762:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 162211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162218 */     GIR_RootConstrainSelectedInstOperands,
     /* 162219 */     // GIR_Coverage, 6219,
     /* 162219 */     GIR_EraseRootFromParent_Done,
     /* 162220 */   // Label 3127: @162220
     /* 162220 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(162273), // Rule ID 6220 //
     /* 162225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162259 */     // MIs[1] Operand 1
     /* 162259 */     // No operand predicates
     /* 162259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162261 */     // (intrinsic_wo_chain:{ *:[v1i64] } 763:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 162264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162271 */     GIR_RootConstrainSelectedInstOperands,
     /* 162272 */     // GIR_Coverage, 6220,
     /* 162272 */     GIR_EraseRootFromParent_Done,
     /* 162273 */   // Label 3128: @162273
     /* 162273 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(162326), // Rule ID 6221 //
     /* 162278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 162283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162312 */     // MIs[1] Operand 1
     /* 162312 */     // No operand predicates
     /* 162312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162314 */     // (intrinsic_wo_chain:{ *:[f32] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 162314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 162317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162324 */     GIR_RootConstrainSelectedInstOperands,
     /* 162325 */     // GIR_Coverage, 6221,
     /* 162325 */     GIR_EraseRootFromParent_Done,
     /* 162326 */   // Label 3129: @162326
     /* 162326 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(162379), // Rule ID 6222 //
     /* 162331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 162336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162365 */     // MIs[1] Operand 1
     /* 162365 */     // No operand predicates
     /* 162365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162367 */     // (intrinsic_wo_chain:{ *:[f64] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 162370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162377 */     GIR_RootConstrainSelectedInstOperands,
     /* 162378 */     // GIR_Coverage, 6222,
     /* 162378 */     GIR_EraseRootFromParent_Done,
     /* 162379 */   // Label 3130: @162379
     /* 162379 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(162432), // Rule ID 6223 //
     /* 162384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 162389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162418 */     // MIs[1] Operand 1
     /* 162418 */     // No operand predicates
     /* 162418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162420 */     // (intrinsic_wo_chain:{ *:[v1f64] } 765:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 162423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162430 */     GIR_RootConstrainSelectedInstOperands,
     /* 162431 */     // GIR_Coverage, 6223,
     /* 162431 */     GIR_EraseRootFromParent_Done,
     /* 162432 */   // Label 3131: @162432
     /* 162432 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(162485), // Rule ID 6224 //
     /* 162437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 162442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162471 */     // MIs[1] Operand 1
     /* 162471 */     // No operand predicates
     /* 162471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162473 */     // (intrinsic_wo_chain:{ *:[f64] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 162476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162483 */     GIR_RootConstrainSelectedInstOperands,
     /* 162484 */     // GIR_Coverage, 6224,
     /* 162484 */     GIR_EraseRootFromParent_Done,
     /* 162485 */   // Label 3132: @162485
     /* 162485 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(162538), // Rule ID 6225 //
     /* 162490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 162495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162524 */     // MIs[1] Operand 1
     /* 162524 */     // No operand predicates
     /* 162524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162526 */     // (intrinsic_wo_chain:{ *:[v1f64] } 766:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 162529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162536 */     GIR_RootConstrainSelectedInstOperands,
     /* 162537 */     // GIR_Coverage, 6225,
     /* 162537 */     GIR_EraseRootFromParent_Done,
     /* 162538 */   // Label 3133: @162538
     /* 162538 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(162591), // Rule ID 6226 //
     /* 162543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 162548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162577 */     // MIs[1] Operand 1
     /* 162577 */     // No operand predicates
     /* 162577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162579 */     // (intrinsic_wo_chain:{ *:[f32] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 162579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 162582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162589 */     GIR_RootConstrainSelectedInstOperands,
     /* 162590 */     // GIR_Coverage, 6226,
     /* 162590 */     GIR_EraseRootFromParent_Done,
     /* 162591 */   // Label 3134: @162591
     /* 162591 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(162673), // Rule ID 6228 //
     /* 162596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 162601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 162604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 162630 */     // MIs[1] Operand 1
     /* 162630 */     // No operand predicates
     /* 162630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162632 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 162632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 162635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162644 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 162650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 162663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162671 */     GIR_RootConstrainSelectedInstOperands,
     /* 162672 */     // GIR_Coverage, 6228,
     /* 162672 */     GIR_EraseRootFromParent_Done,
     /* 162673 */   // Label 3135: @162673
     /* 162673 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(162755), // Rule ID 6229 //
     /* 162678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 162683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 162686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 162712 */     // MIs[1] Operand 1
     /* 162712 */     // No operand predicates
     /* 162712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162714 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 162714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 162717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162726 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 162732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 162745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162753 */     GIR_RootConstrainSelectedInstOperands,
     /* 162754 */     // GIR_Coverage, 6229,
     /* 162754 */     GIR_EraseRootFromParent_Done,
     /* 162755 */   // Label 3136: @162755
     /* 162755 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(162837), // Rule ID 6231 //
     /* 162760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 162765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 162768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 162794 */     // MIs[1] Operand 1
     /* 162794 */     // No operand predicates
     /* 162794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162796 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 162796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 162799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162808 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 162814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 162827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162835 */     GIR_RootConstrainSelectedInstOperands,
     /* 162836 */     // GIR_Coverage, 6231,
     /* 162836 */     GIR_EraseRootFromParent_Done,
     /* 162837 */   // Label 3137: @162837
     /* 162837 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(162919), // Rule ID 6232 //
     /* 162842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 162847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 162850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 162876 */     // MIs[1] Operand 1
     /* 162876 */     // No operand predicates
     /* 162876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162878 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 162878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 162881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162890 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 162896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 162909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162917 */     GIR_RootConstrainSelectedInstOperands,
     /* 162918 */     // GIR_Coverage, 6232,
     /* 162918 */     GIR_EraseRootFromParent_Done,
     /* 162919 */   // Label 3138: @162919
     /* 162919 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(163025), // Rule ID 6233 //
     /* 162924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162958 */     // MIs[1] Operand 1
     /* 162958 */     // No operand predicates
     /* 162958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162960 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 162960 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 162963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 162967 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162972 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 162976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 162979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 162981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 162984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 162988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 162995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 162998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 163006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 163009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163024 */     // GIR_Coverage, 6233,
     /* 163024 */     GIR_EraseRootFromParent_Done,
     /* 163025 */   // Label 3139: @163025
     /* 163025 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(163131), // Rule ID 6234 //
     /* 163030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 163035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163064 */     // MIs[1] Operand 1
     /* 163064 */     // No operand predicates
     /* 163064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163066 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 163066 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 163069 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 163073 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163078 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 163082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 163085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 163090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 163094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 163104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 163112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 163115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163130 */     // GIR_Coverage, 6234,
     /* 163130 */     GIR_EraseRootFromParent_Done,
     /* 163131 */   // Label 3140: @163131
     /* 163131 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(163237), // Rule ID 6235 //
     /* 163136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 163141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163170 */     // MIs[1] Operand 1
     /* 163170 */     // No operand predicates
     /* 163170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163172 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 163172 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 163175 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 163179 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163184 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 163188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 163191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 163196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 163200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 163210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 163218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 163221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163236 */     // GIR_Coverage, 6235,
     /* 163236 */     GIR_EraseRootFromParent_Done,
     /* 163237 */   // Label 3141: @163237
     /* 163237 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(163343), // Rule ID 6236 //
     /* 163242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 163247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163276 */     // MIs[1] Operand 1
     /* 163276 */     // No operand predicates
     /* 163276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163278 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 163278 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 163281 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 163285 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163290 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 163294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 163297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 163302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 163306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 163316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 163324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 163327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163342 */     // GIR_Coverage, 6236,
     /* 163342 */     GIR_EraseRootFromParent_Done,
     /* 163343 */   // Label 3142: @163343
     /* 163343 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(163398), // Rule ID 6933 //
     /* 163348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 163353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 163362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 163366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 163370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 163382 */     // MIs[1] Operand 1
     /* 163382 */     // No operand predicates
     /* 163382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163384 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (PAUTH_BLEND:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm))
     /* 163384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PAUTH_BLEND),
     /* 163387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[disc]
     /* 163389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 163391 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 163396 */     GIR_RootConstrainSelectedInstOperands,
     /* 163397 */     // GIR_Coverage, 6933,
     /* 163397 */     GIR_EraseRootFromParent_Done,
     /* 163398 */   // Label 3143: @163398
     /* 163398 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(163440), // Rule ID 3036 //
     /* 163403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 163406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 163411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 163414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 163417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163421 */     // MIs[0] Op2
     /* 163421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 163429 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1850:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 163429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 163432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 163434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 163436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 163438 */     GIR_RootConstrainSelectedInstOperands,
     /* 163439 */     // GIR_Coverage, 3036,
     /* 163439 */     GIR_EraseRootFromParent_Done,
     /* 163440 */   // Label 3144: @163440
     /* 163440 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(163482), // Rule ID 3037 //
     /* 163445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 163448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 163453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 163456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 163459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163463 */     // MIs[0] Op2
     /* 163463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163466 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 163471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1850:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 163471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 163474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 163476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 163478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 163480 */     GIR_RootConstrainSelectedInstOperands,
     /* 163481 */     // GIR_Coverage, 3037,
     /* 163481 */     GIR_EraseRootFromParent_Done,
     /* 163482 */   // Label 3145: @163482
     /* 163482 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(163524), // Rule ID 3038 //
     /* 163487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 163490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 163495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 163498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 163501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163505 */     // MIs[0] Op2
     /* 163505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163508 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 163513 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1850:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 163513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 163516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 163518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 163520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 163522 */     GIR_RootConstrainSelectedInstOperands,
     /* 163523 */     // GIR_Coverage, 3038,
     /* 163523 */     GIR_EraseRootFromParent_Done,
     /* 163524 */   // Label 3146: @163524
     /* 163524 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(163566), // Rule ID 3072 //
     /* 163529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 163532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 163537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 163540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 163543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163547 */     // MIs[0] Op2
     /* 163547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 163555 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1831:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 163555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 163558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 163560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 163562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 163564 */     GIR_RootConstrainSelectedInstOperands,
     /* 163565 */     // GIR_Coverage, 3072,
     /* 163565 */     GIR_EraseRootFromParent_Done,
     /* 163566 */   // Label 3147: @163566
     /* 163566 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(163608), // Rule ID 3073 //
     /* 163571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 163574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 163579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 163582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 163585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163589 */     // MIs[0] Op2
     /* 163589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 163597 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1831:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 163597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 163600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 163602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 163604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 163606 */     GIR_RootConstrainSelectedInstOperands,
     /* 163607 */     // GIR_Coverage, 3073,
     /* 163607 */     GIR_EraseRootFromParent_Done,
     /* 163608 */   // Label 3148: @163608
     /* 163608 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(163650), // Rule ID 3074 //
     /* 163613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 163616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 163621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 163624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 163627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163631 */     // MIs[0] Op2
     /* 163631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 163639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1831:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 163639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 163642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 163644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 163646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 163648 */     GIR_RootConstrainSelectedInstOperands,
     /* 163649 */     // GIR_Coverage, 3074,
     /* 163649 */     GIR_EraseRootFromParent_Done,
     /* 163650 */   // Label 3149: @163650
     /* 163650 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(163692), // Rule ID 3521 //
     /* 163655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 163658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 163663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 163666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 163669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163673 */     // MIs[0] Op2
     /* 163673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 163681 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1331:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 163681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 163684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 163686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 163688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 163690 */     GIR_RootConstrainSelectedInstOperands,
     /* 163691 */     // GIR_Coverage, 3521,
     /* 163691 */     GIR_EraseRootFromParent_Done,
     /* 163692 */   // Label 3150: @163692
     /* 163692 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(163734), // Rule ID 3522 //
     /* 163697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 163700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 163705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 163708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 163711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163715 */     // MIs[0] Op2
     /* 163715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 163723 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1331:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 163723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 163726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 163728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 163730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 163732 */     GIR_RootConstrainSelectedInstOperands,
     /* 163733 */     // GIR_Coverage, 3522,
     /* 163733 */     GIR_EraseRootFromParent_Done,
     /* 163734 */   // Label 3151: @163734
     /* 163734 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(163776), // Rule ID 3523 //
     /* 163739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 163742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 163747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 163750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 163753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163757 */     // MIs[0] Op2
     /* 163757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 163765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1331:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 163765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 163768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 163770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 163772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 163774 */     GIR_RootConstrainSelectedInstOperands,
     /* 163775 */     // GIR_Coverage, 3523,
     /* 163775 */     GIR_EraseRootFromParent_Done,
     /* 163776 */   // Label 3152: @163776
     /* 163776 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(163818), // Rule ID 3524 //
     /* 163781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 163784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 163789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 163792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 163795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163799 */     // MIs[0] Op2
     /* 163799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 163807 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1331:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 163807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 163810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 163812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 163814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 163816 */     GIR_RootConstrainSelectedInstOperands,
     /* 163817 */     // GIR_Coverage, 3524,
     /* 163817 */     GIR_EraseRootFromParent_Done,
     /* 163818 */   // Label 3153: @163818
     /* 163818 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(163860), // Rule ID 3525 //
     /* 163823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 163826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 163831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 163834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 163837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163841 */     // MIs[0] Op2
     /* 163841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 163849 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1331:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 163849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 163852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 163854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 163856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 163858 */     GIR_RootConstrainSelectedInstOperands,
     /* 163859 */     // GIR_Coverage, 3525,
     /* 163859 */     GIR_EraseRootFromParent_Done,
     /* 163860 */   // Label 3154: @163860
     /* 163860 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(163902), // Rule ID 3526 //
     /* 163865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 163868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 163873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 163876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 163879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163883 */     // MIs[0] Op2
     /* 163883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 163891 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1331:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 163891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 163894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 163896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 163898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 163900 */     GIR_RootConstrainSelectedInstOperands,
     /* 163901 */     // GIR_Coverage, 3526,
     /* 163901 */     GIR_EraseRootFromParent_Done,
     /* 163902 */   // Label 3155: @163902
     /* 163902 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(163944), // Rule ID 3527 //
     /* 163907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 163910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 163915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 163918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 163921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163925 */     // MIs[0] Op2
     /* 163925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 163933 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1331:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 163933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 163936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 163938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 163940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 163942 */     GIR_RootConstrainSelectedInstOperands,
     /* 163943 */     // GIR_Coverage, 3527,
     /* 163943 */     GIR_EraseRootFromParent_Done,
     /* 163944 */   // Label 3156: @163944
     /* 163944 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(163986), // Rule ID 11662 //
     /* 163949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 163952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 163957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 163960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 163963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 163967 */     // MIs[0] Op2
     /* 163967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 163970 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 163975 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1825:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 163975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 163978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 163980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 163982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 163984 */     GIR_RootConstrainSelectedInstOperands,
     /* 163985 */     // GIR_Coverage, 11662,
     /* 163985 */     GIR_EraseRootFromParent_Done,
     /* 163986 */   // Label 3157: @163986
     /* 163986 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(164028), // Rule ID 11663 //
     /* 163991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 163994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 163999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164009 */     // MIs[0] Op2
     /* 164009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164017 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1825:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 164020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164026 */     GIR_RootConstrainSelectedInstOperands,
     /* 164027 */     // GIR_Coverage, 11663,
     /* 164027 */     GIR_EraseRootFromParent_Done,
     /* 164028 */   // Label 3158: @164028
     /* 164028 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(164070), // Rule ID 11664 //
     /* 164033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 164041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164051 */     // MIs[0] Op2
     /* 164051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164059 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1825:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 164062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164068 */     GIR_RootConstrainSelectedInstOperands,
     /* 164069 */     // GIR_Coverage, 11664,
     /* 164069 */     GIR_EraseRootFromParent_Done,
     /* 164070 */   // Label 3159: @164070
     /* 164070 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(164112), // Rule ID 11665 //
     /* 164075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 164083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164093 */     // MIs[0] Op2
     /* 164093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1704:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 164104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164110 */     GIR_RootConstrainSelectedInstOperands,
     /* 164111 */     // GIR_Coverage, 11665,
     /* 164111 */     GIR_EraseRootFromParent_Done,
     /* 164112 */   // Label 3160: @164112
     /* 164112 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(164154), // Rule ID 11666 //
     /* 164117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 164125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164135 */     // MIs[0] Op2
     /* 164135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1704:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 164146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164152 */     GIR_RootConstrainSelectedInstOperands,
     /* 164153 */     // GIR_Coverage, 11666,
     /* 164153 */     GIR_EraseRootFromParent_Done,
     /* 164154 */   // Label 3161: @164154
     /* 164154 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(164196), // Rule ID 11667 //
     /* 164159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 164167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164177 */     // MIs[0] Op2
     /* 164177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164185 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1704:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 164188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164194 */     GIR_RootConstrainSelectedInstOperands,
     /* 164195 */     // GIR_Coverage, 11667,
     /* 164195 */     GIR_EraseRootFromParent_Done,
     /* 164196 */   // Label 3162: @164196
     /* 164196 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(164238), // Rule ID 11669 //
     /* 164201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 164209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164219 */     // MIs[0] Op2
     /* 164219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164227 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1662:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 164230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164236 */     GIR_RootConstrainSelectedInstOperands,
     /* 164237 */     // GIR_Coverage, 11669,
     /* 164237 */     GIR_EraseRootFromParent_Done,
     /* 164238 */   // Label 3163: @164238
     /* 164238 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(164280), // Rule ID 11671 //
     /* 164243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 164251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164261 */     // MIs[0] Op2
     /* 164261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1662:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 164272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164278 */     GIR_RootConstrainSelectedInstOperands,
     /* 164279 */     // GIR_Coverage, 11671,
     /* 164279 */     GIR_EraseRootFromParent_Done,
     /* 164280 */   // Label 3164: @164280
     /* 164280 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(164322), // Rule ID 11673 //
     /* 164285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 164293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164303 */     // MIs[0] Op2
     /* 164303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164311 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1662:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 164314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164320 */     GIR_RootConstrainSelectedInstOperands,
     /* 164321 */     // GIR_Coverage, 11673,
     /* 164321 */     GIR_EraseRootFromParent_Done,
     /* 164322 */   // Label 3165: @164322
     /* 164322 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(164364), // Rule ID 11674 //
     /* 164327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 164335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164345 */     // MIs[0] Op2
     /* 164345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164353 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1829:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 164356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164362 */     GIR_RootConstrainSelectedInstOperands,
     /* 164363 */     // GIR_Coverage, 11674,
     /* 164363 */     GIR_EraseRootFromParent_Done,
     /* 164364 */   // Label 3166: @164364
     /* 164364 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(164406), // Rule ID 11675 //
     /* 164369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 164377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164387 */     // MIs[0] Op2
     /* 164387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164395 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1829:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 164398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164404 */     GIR_RootConstrainSelectedInstOperands,
     /* 164405 */     // GIR_Coverage, 11675,
     /* 164405 */     GIR_EraseRootFromParent_Done,
     /* 164406 */   // Label 3167: @164406
     /* 164406 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(164448), // Rule ID 11676 //
     /* 164411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 164419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164429 */     // MIs[0] Op2
     /* 164429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164437 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1829:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 164440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164446 */     GIR_RootConstrainSelectedInstOperands,
     /* 164447 */     // GIR_Coverage, 11676,
     /* 164447 */     GIR_EraseRootFromParent_Done,
     /* 164448 */   // Label 3168: @164448
     /* 164448 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(164490), // Rule ID 11677 //
     /* 164453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 164461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164471 */     // MIs[0] Op2
     /* 164471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164474 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164479 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1819:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 164482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164488 */     GIR_RootConstrainSelectedInstOperands,
     /* 164489 */     // GIR_Coverage, 11677,
     /* 164489 */     GIR_EraseRootFromParent_Done,
     /* 164490 */   // Label 3169: @164490
     /* 164490 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(164532), // Rule ID 11678 //
     /* 164495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 164503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164513 */     // MIs[0] Op2
     /* 164513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 164524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164530 */     GIR_RootConstrainSelectedInstOperands,
     /* 164531 */     // GIR_Coverage, 11678,
     /* 164531 */     GIR_EraseRootFromParent_Done,
     /* 164532 */   // Label 3170: @164532
     /* 164532 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(164574), // Rule ID 11679 //
     /* 164537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 164545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164555 */     // MIs[0] Op2
     /* 164555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 164566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164572 */     GIR_RootConstrainSelectedInstOperands,
     /* 164573 */     // GIR_Coverage, 11679,
     /* 164573 */     GIR_EraseRootFromParent_Done,
     /* 164574 */   // Label 3171: @164574
     /* 164574 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(164616), // Rule ID 11680 //
     /* 164579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 164587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164597 */     // MIs[0] Op2
     /* 164597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164605 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2024:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 164608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164614 */     GIR_RootConstrainSelectedInstOperands,
     /* 164615 */     // GIR_Coverage, 11680,
     /* 164615 */     GIR_EraseRootFromParent_Done,
     /* 164616 */   // Label 3172: @164616
     /* 164616 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(164658), // Rule ID 11681 //
     /* 164621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 164629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164639 */     // MIs[0] Op2
     /* 164639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164647 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2024:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 164650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164656 */     GIR_RootConstrainSelectedInstOperands,
     /* 164657 */     // GIR_Coverage, 11681,
     /* 164657 */     GIR_EraseRootFromParent_Done,
     /* 164658 */   // Label 3173: @164658
     /* 164658 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(164700), // Rule ID 11682 //
     /* 164663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 164671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164681 */     // MIs[0] Op2
     /* 164681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164689 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2024:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 164692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164698 */     GIR_RootConstrainSelectedInstOperands,
     /* 164699 */     // GIR_Coverage, 11682,
     /* 164699 */     GIR_EraseRootFromParent_Done,
     /* 164700 */   // Label 3174: @164700
     /* 164700 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(164742), // Rule ID 11683 //
     /* 164705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 164713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164723 */     // MIs[0] Op2
     /* 164723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164731 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2021:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 164734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164740 */     GIR_RootConstrainSelectedInstOperands,
     /* 164741 */     // GIR_Coverage, 11683,
     /* 164741 */     GIR_EraseRootFromParent_Done,
     /* 164742 */   // Label 3175: @164742
     /* 164742 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(164784), // Rule ID 11684 //
     /* 164747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 164755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164765 */     // MIs[0] Op2
     /* 164765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164773 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2021:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 164776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164782 */     GIR_RootConstrainSelectedInstOperands,
     /* 164783 */     // GIR_Coverage, 11684,
     /* 164783 */     GIR_EraseRootFromParent_Done,
     /* 164784 */   // Label 3176: @164784
     /* 164784 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(164826), // Rule ID 11685 //
     /* 164789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 164797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164807 */     // MIs[0] Op2
     /* 164807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164810 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164815 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2021:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 164818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164824 */     GIR_RootConstrainSelectedInstOperands,
     /* 164825 */     // GIR_Coverage, 11685,
     /* 164825 */     GIR_EraseRootFromParent_Done,
     /* 164826 */   // Label 3177: @164826
     /* 164826 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(164868), // Rule ID 11743 //
     /* 164831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 164839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 164845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164849 */     // MIs[0] Op2
     /* 164849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 164857 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 164857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 164860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164866 */     GIR_RootConstrainSelectedInstOperands,
     /* 164867 */     // GIR_Coverage, 11743,
     /* 164867 */     GIR_EraseRootFromParent_Done,
     /* 164868 */   // Label 3178: @164868
     /* 164868 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(164910), // Rule ID 11744 //
     /* 164873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 164881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164891 */     // MIs[0] Op2
     /* 164891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 164899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 164899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 164902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164908 */     GIR_RootConstrainSelectedInstOperands,
     /* 164909 */     // GIR_Coverage, 11744,
     /* 164909 */     GIR_EraseRootFromParent_Done,
     /* 164910 */   // Label 3179: @164910
     /* 164910 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(164952), // Rule ID 11745 //
     /* 164915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 164923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 164926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164933 */     // MIs[0] Op2
     /* 164933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 164941 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1851:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 164941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 164944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164950 */     GIR_RootConstrainSelectedInstOperands,
     /* 164951 */     // GIR_Coverage, 11745,
     /* 164951 */     GIR_EraseRootFromParent_Done,
     /* 164952 */   // Label 3180: @164952
     /* 164952 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(164994), // Rule ID 11746 //
     /* 164957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 164965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 164971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164975 */     // MIs[0] Op2
     /* 164975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164978 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 164983 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2044:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 164983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 164986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164992 */     GIR_RootConstrainSelectedInstOperands,
     /* 164993 */     // GIR_Coverage, 11746,
     /* 164993 */     GIR_EraseRootFromParent_Done,
     /* 164994 */   // Label 3181: @164994
     /* 164994 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(165036), // Rule ID 11747 //
     /* 164999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 165007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165017 */     // MIs[0] Op2
     /* 165017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 165025 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2044:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 165025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 165028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165034 */     GIR_RootConstrainSelectedInstOperands,
     /* 165035 */     // GIR_Coverage, 11747,
     /* 165035 */     GIR_EraseRootFromParent_Done,
     /* 165036 */   // Label 3182: @165036
     /* 165036 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(165078), // Rule ID 11748 //
     /* 165041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 165049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165059 */     // MIs[0] Op2
     /* 165059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165062 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 165067 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2044:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 165067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 165070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165076 */     GIR_RootConstrainSelectedInstOperands,
     /* 165077 */     // GIR_Coverage, 11748,
     /* 165077 */     GIR_EraseRootFromParent_Done,
     /* 165078 */   // Label 3183: @165078
     /* 165078 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(165120), // Rule ID 11749 //
     /* 165083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 165091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 165097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165101 */     // MIs[0] Op2
     /* 165101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 165109 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 165109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 165112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165118 */     GIR_RootConstrainSelectedInstOperands,
     /* 165119 */     // GIR_Coverage, 11749,
     /* 165119 */     GIR_EraseRootFromParent_Done,
     /* 165120 */   // Label 3184: @165120
     /* 165120 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(165162), // Rule ID 11750 //
     /* 165125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 165133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165143 */     // MIs[0] Op2
     /* 165143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 165151 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 165151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 165154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165160 */     GIR_RootConstrainSelectedInstOperands,
     /* 165161 */     // GIR_Coverage, 11750,
     /* 165161 */     GIR_EraseRootFromParent_Done,
     /* 165162 */   // Label 3185: @165162
     /* 165162 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(165204), // Rule ID 11751 //
     /* 165167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 165175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165185 */     // MIs[0] Op2
     /* 165185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 165193 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 165193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 165196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165202 */     GIR_RootConstrainSelectedInstOperands,
     /* 165203 */     // GIR_Coverage, 11751,
     /* 165203 */     GIR_EraseRootFromParent_Done,
     /* 165204 */   // Label 3186: @165204
     /* 165204 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(165256), // Rule ID 2123 //
     /* 165209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165242 */     // MIs[1] Operand 1
     /* 165242 */     // No operand predicates
     /* 165242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165244 */     // (intrinsic_wo_chain:{ *:[v4i16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 165247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165254 */     GIR_RootConstrainSelectedInstOperands,
     /* 165255 */     // GIR_Coverage, 2123,
     /* 165255 */     GIR_EraseRootFromParent_Done,
     /* 165256 */   // Label 3187: @165256
     /* 165256 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(165308), // Rule ID 2124 //
     /* 165261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165294 */     // MIs[1] Operand 1
     /* 165294 */     // No operand predicates
     /* 165294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165296 */     // (intrinsic_wo_chain:{ *:[v8i16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 165299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165306 */     GIR_RootConstrainSelectedInstOperands,
     /* 165307 */     // GIR_Coverage, 2124,
     /* 165307 */     GIR_EraseRootFromParent_Done,
     /* 165308 */   // Label 3188: @165308
     /* 165308 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(165360), // Rule ID 2125 //
     /* 165313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165346 */     // MIs[1] Operand 1
     /* 165346 */     // No operand predicates
     /* 165346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165348 */     // (intrinsic_wo_chain:{ *:[v2i32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 165351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165358 */     GIR_RootConstrainSelectedInstOperands,
     /* 165359 */     // GIR_Coverage, 2125,
     /* 165359 */     GIR_EraseRootFromParent_Done,
     /* 165360 */   // Label 3189: @165360
     /* 165360 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(165412), // Rule ID 2126 //
     /* 165365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165398 */     // MIs[1] Operand 1
     /* 165398 */     // No operand predicates
     /* 165398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165400 */     // (intrinsic_wo_chain:{ *:[v4i32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 165403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165410 */     GIR_RootConstrainSelectedInstOperands,
     /* 165411 */     // GIR_Coverage, 2126,
     /* 165411 */     GIR_EraseRootFromParent_Done,
     /* 165412 */   // Label 3190: @165412
     /* 165412 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(165464), // Rule ID 2127 //
     /* 165417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165450 */     // MIs[1] Operand 1
     /* 165450 */     // No operand predicates
     /* 165450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165452 */     // (intrinsic_wo_chain:{ *:[v2i64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 165455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165462 */     GIR_RootConstrainSelectedInstOperands,
     /* 165463 */     // GIR_Coverage, 2127,
     /* 165463 */     GIR_EraseRootFromParent_Done,
     /* 165464 */   // Label 3191: @165464
     /* 165464 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(165516), // Rule ID 2128 //
     /* 165469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 165477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165502 */     // MIs[1] Operand 1
     /* 165502 */     // No operand predicates
     /* 165502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165504 */     // (intrinsic_wo_chain:{ *:[v4i16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 165507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165514 */     GIR_RootConstrainSelectedInstOperands,
     /* 165515 */     // GIR_Coverage, 2128,
     /* 165515 */     GIR_EraseRootFromParent_Done,
     /* 165516 */   // Label 3192: @165516
     /* 165516 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(165568), // Rule ID 2129 //
     /* 165521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 165529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165554 */     // MIs[1] Operand 1
     /* 165554 */     // No operand predicates
     /* 165554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165556 */     // (intrinsic_wo_chain:{ *:[v8i16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 165559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165566 */     GIR_RootConstrainSelectedInstOperands,
     /* 165567 */     // GIR_Coverage, 2129,
     /* 165567 */     GIR_EraseRootFromParent_Done,
     /* 165568 */   // Label 3193: @165568
     /* 165568 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(165620), // Rule ID 2130 //
     /* 165573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 165581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165606 */     // MIs[1] Operand 1
     /* 165606 */     // No operand predicates
     /* 165606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165608 */     // (intrinsic_wo_chain:{ *:[v2i32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 165611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165618 */     GIR_RootConstrainSelectedInstOperands,
     /* 165619 */     // GIR_Coverage, 2130,
     /* 165619 */     GIR_EraseRootFromParent_Done,
     /* 165620 */   // Label 3194: @165620
     /* 165620 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(165672), // Rule ID 2131 //
     /* 165625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 165633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165658 */     // MIs[1] Operand 1
     /* 165658 */     // No operand predicates
     /* 165658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165660 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 165663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165670 */     GIR_RootConstrainSelectedInstOperands,
     /* 165671 */     // GIR_Coverage, 2131,
     /* 165671 */     GIR_EraseRootFromParent_Done,
     /* 165672 */   // Label 3195: @165672
     /* 165672 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(165724), // Rule ID 2132 //
     /* 165677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 165685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165710 */     // MIs[1] Operand 1
     /* 165710 */     // No operand predicates
     /* 165710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165712 */     // (intrinsic_wo_chain:{ *:[v2i64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 165715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165722 */     GIR_RootConstrainSelectedInstOperands,
     /* 165723 */     // GIR_Coverage, 2132,
     /* 165723 */     GIR_EraseRootFromParent_Done,
     /* 165724 */   // Label 3196: @165724
     /* 165724 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(165776), // Rule ID 2133 //
     /* 165729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165762 */     // MIs[1] Operand 1
     /* 165762 */     // No operand predicates
     /* 165762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165764 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 165767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165774 */     GIR_RootConstrainSelectedInstOperands,
     /* 165775 */     // GIR_Coverage, 2133,
     /* 165775 */     GIR_EraseRootFromParent_Done,
     /* 165776 */   // Label 3197: @165776
     /* 165776 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(165828), // Rule ID 2134 //
     /* 165781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165814 */     // MIs[1] Operand 1
     /* 165814 */     // No operand predicates
     /* 165814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165816 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 165819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165826 */     GIR_RootConstrainSelectedInstOperands,
     /* 165827 */     // GIR_Coverage, 2134,
     /* 165827 */     GIR_EraseRootFromParent_Done,
     /* 165828 */   // Label 3198: @165828
     /* 165828 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(165880), // Rule ID 2135 //
     /* 165833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165866 */     // MIs[1] Operand 1
     /* 165866 */     // No operand predicates
     /* 165866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165868 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 165871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165878 */     GIR_RootConstrainSelectedInstOperands,
     /* 165879 */     // GIR_Coverage, 2135,
     /* 165879 */     GIR_EraseRootFromParent_Done,
     /* 165880 */   // Label 3199: @165880
     /* 165880 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(165932), // Rule ID 2136 //
     /* 165885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165918 */     // MIs[1] Operand 1
     /* 165918 */     // No operand predicates
     /* 165918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165920 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 165923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165930 */     GIR_RootConstrainSelectedInstOperands,
     /* 165931 */     // GIR_Coverage, 2136,
     /* 165931 */     GIR_EraseRootFromParent_Done,
     /* 165932 */   // Label 3200: @165932
     /* 165932 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(165984), // Rule ID 2137 //
     /* 165937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 165945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165970 */     // MIs[1] Operand 1
     /* 165970 */     // No operand predicates
     /* 165970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165972 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 165975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165982 */     GIR_RootConstrainSelectedInstOperands,
     /* 165983 */     // GIR_Coverage, 2137,
     /* 165983 */     GIR_EraseRootFromParent_Done,
     /* 165984 */   // Label 3201: @165984
     /* 165984 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(166036), // Rule ID 2235 //
     /* 165989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 165997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166022 */     // MIs[1] Operand 1
     /* 166022 */     // No operand predicates
     /* 166022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166024 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 166027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166034 */     GIR_RootConstrainSelectedInstOperands,
     /* 166035 */     // GIR_Coverage, 2235,
     /* 166035 */     GIR_EraseRootFromParent_Done,
     /* 166036 */   // Label 3202: @166036
     /* 166036 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(166088), // Rule ID 2236 //
     /* 166041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166074 */     // MIs[1] Operand 1
     /* 166074 */     // No operand predicates
     /* 166074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166076 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 166079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166086 */     GIR_RootConstrainSelectedInstOperands,
     /* 166087 */     // GIR_Coverage, 2236,
     /* 166087 */     GIR_EraseRootFromParent_Done,
     /* 166088 */   // Label 3203: @166088
     /* 166088 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(166140), // Rule ID 2237 //
     /* 166093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166126 */     // MIs[1] Operand 1
     /* 166126 */     // No operand predicates
     /* 166126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166128 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 166131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166138 */     GIR_RootConstrainSelectedInstOperands,
     /* 166139 */     // GIR_Coverage, 2237,
     /* 166139 */     GIR_EraseRootFromParent_Done,
     /* 166140 */   // Label 3204: @166140
     /* 166140 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(166192), // Rule ID 2238 //
     /* 166145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166178 */     // MIs[1] Operand 1
     /* 166178 */     // No operand predicates
     /* 166178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166180 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 166183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166190 */     GIR_RootConstrainSelectedInstOperands,
     /* 166191 */     // GIR_Coverage, 2238,
     /* 166191 */     GIR_EraseRootFromParent_Done,
     /* 166192 */   // Label 3205: @166192
     /* 166192 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(166244), // Rule ID 2239 //
     /* 166197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166230 */     // MIs[1] Operand 1
     /* 166230 */     // No operand predicates
     /* 166230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166232 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 166235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166242 */     GIR_RootConstrainSelectedInstOperands,
     /* 166243 */     // GIR_Coverage, 2239,
     /* 166243 */     GIR_EraseRootFromParent_Done,
     /* 166244 */   // Label 3206: @166244
     /* 166244 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(166289), // Rule ID 63 //
     /* 166249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 166252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 166257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 166266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 166278 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 166278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 166281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166287 */     GIR_RootConstrainSelectedInstOperands,
     /* 166288 */     // GIR_Coverage, 63,
     /* 166288 */     GIR_EraseRootFromParent_Done,
     /* 166289 */   // Label 3207: @166289
     /* 166289 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(166334), // Rule ID 129 //
     /* 166294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 166297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 166302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166323 */     // (intrinsic_wo_chain:{ *:[i32] } 503:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 166323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 166326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166332 */     GIR_RootConstrainSelectedInstOperands,
     /* 166333 */     // GIR_Coverage, 129,
     /* 166333 */     GIR_EraseRootFromParent_Done,
     /* 166334 */   // Label 3208: @166334
     /* 166334 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(166379), // Rule ID 130 //
     /* 166339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 166342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 166347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166368 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 166368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 166371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166377 */     GIR_RootConstrainSelectedInstOperands,
     /* 166378 */     // GIR_Coverage, 130,
     /* 166378 */     GIR_EraseRootFromParent_Done,
     /* 166379 */   // Label 3209: @166379
     /* 166379 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(166424), // Rule ID 131 //
     /* 166384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 166387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 166392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166413 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 166413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 166416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166422 */     GIR_RootConstrainSelectedInstOperands,
     /* 166423 */     // GIR_Coverage, 131,
     /* 166423 */     GIR_EraseRootFromParent_Done,
     /* 166424 */   // Label 3210: @166424
     /* 166424 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(166469), // Rule ID 132 //
     /* 166429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 166432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 166437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 166446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166458 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 166458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 166461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166467 */     GIR_RootConstrainSelectedInstOperands,
     /* 166468 */     // GIR_Coverage, 132,
     /* 166468 */     GIR_EraseRootFromParent_Done,
     /* 166469 */   // Label 3211: @166469
     /* 166469 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(166514), // Rule ID 133 //
     /* 166474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 166477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 166482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166503 */     // (intrinsic_wo_chain:{ *:[i32] } 504:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 166503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 166506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166512 */     GIR_RootConstrainSelectedInstOperands,
     /* 166513 */     // GIR_Coverage, 133,
     /* 166513 */     GIR_EraseRootFromParent_Done,
     /* 166514 */   // Label 3212: @166514
     /* 166514 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(166559), // Rule ID 134 //
     /* 166519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 166522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 166527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166548 */     // (intrinsic_wo_chain:{ *:[i32] } 505:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 166548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 166551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166557 */     GIR_RootConstrainSelectedInstOperands,
     /* 166558 */     // GIR_Coverage, 134,
     /* 166558 */     GIR_EraseRootFromParent_Done,
     /* 166559 */   // Label 3213: @166559
     /* 166559 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(166604), // Rule ID 135 //
     /* 166564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 166567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 166572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166593 */     // (intrinsic_wo_chain:{ *:[i32] } 506:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 166593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 166596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166602 */     GIR_RootConstrainSelectedInstOperands,
     /* 166603 */     // GIR_Coverage, 135,
     /* 166603 */     GIR_EraseRootFromParent_Done,
     /* 166604 */   // Label 3214: @166604
     /* 166604 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(166649), // Rule ID 136 //
     /* 166609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 166612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 166617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 166626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166638 */     // (intrinsic_wo_chain:{ *:[i32] } 507:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 166638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 166641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 166647 */     GIR_RootConstrainSelectedInstOperands,
     /* 166648 */     // GIR_Coverage, 136,
     /* 166648 */     GIR_EraseRootFromParent_Done,
     /* 166649 */   // Label 3215: @166649
     /* 166649 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(166694), // Rule ID 1035 //
     /* 166654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 166662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 166665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 166671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166683 */     // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 166683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 166686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 166690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 166692 */     GIR_RootConstrainSelectedInstOperands,
     /* 166693 */     // GIR_Coverage, 1035,
     /* 166693 */     GIR_EraseRootFromParent_Done,
     /* 166694 */   // Label 3216: @166694
     /* 166694 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(166739), // Rule ID 1036 //
     /* 166699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 166707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 166710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 166716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166728 */     // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 166728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 166731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 166735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 166737 */     GIR_RootConstrainSelectedInstOperands,
     /* 166738 */     // GIR_Coverage, 1036,
     /* 166738 */     GIR_EraseRootFromParent_Done,
     /* 166739 */   // Label 3217: @166739
     /* 166739 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(166784), // Rule ID 1037 //
     /* 166744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 166752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 166761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166773 */     // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 166773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 166776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 166780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 166782 */     GIR_RootConstrainSelectedInstOperands,
     /* 166783 */     // GIR_Coverage, 1037,
     /* 166783 */     GIR_EraseRootFromParent_Done,
     /* 166784 */   // Label 3218: @166784
     /* 166784 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(166829), // Rule ID 1038 //
     /* 166789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 166797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 166806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166818 */     // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 166818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 166821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 166825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 166827 */     GIR_RootConstrainSelectedInstOperands,
     /* 166828 */     // GIR_Coverage, 1038,
     /* 166828 */     GIR_EraseRootFromParent_Done,
     /* 166829 */   // Label 3219: @166829
     /* 166829 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(166874), // Rule ID 1039 //
     /* 166834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 166842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 166851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166863 */     // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 166863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 166866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 166870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 166872 */     GIR_RootConstrainSelectedInstOperands,
     /* 166873 */     // GIR_Coverage, 1039,
     /* 166873 */     GIR_EraseRootFromParent_Done,
     /* 166874 */   // Label 3220: @166874
     /* 166874 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(166919), // Rule ID 1040 //
     /* 166879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 166887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166908 */     // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 166908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 166911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 166915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 166917 */     GIR_RootConstrainSelectedInstOperands,
     /* 166918 */     // GIR_Coverage, 1040,
     /* 166918 */     GIR_EraseRootFromParent_Done,
     /* 166919 */   // Label 3221: @166919
     /* 166919 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(166964), // Rule ID 1041 //
     /* 166924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 166932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166953 */     // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 166953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 166956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 166960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 166962 */     GIR_RootConstrainSelectedInstOperands,
     /* 166963 */     // GIR_Coverage, 1041,
     /* 166963 */     GIR_EraseRootFromParent_Done,
     /* 166964 */   // Label 3222: @166964
     /* 166964 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(167009), // Rule ID 1083 //
     /* 166969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 166977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 166980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 166986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166998 */     // (intrinsic_wo_chain:{ *:[v8i8] } 754:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 166998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 167001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167007 */     GIR_RootConstrainSelectedInstOperands,
     /* 167008 */     // GIR_Coverage, 1083,
     /* 167008 */     GIR_EraseRootFromParent_Done,
     /* 167009 */   // Label 3223: @167009
     /* 167009 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(167054), // Rule ID 1084 //
     /* 167014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167043 */     // (intrinsic_wo_chain:{ *:[v16i8] } 754:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 167043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 167046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167052 */     GIR_RootConstrainSelectedInstOperands,
     /* 167053 */     // GIR_Coverage, 1084,
     /* 167053 */     GIR_EraseRootFromParent_Done,
     /* 167054 */   // Label 3224: @167054
     /* 167054 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(167099), // Rule ID 1085 //
     /* 167059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167088 */     // (intrinsic_wo_chain:{ *:[v4i16] } 754:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 167088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 167091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167097 */     GIR_RootConstrainSelectedInstOperands,
     /* 167098 */     // GIR_Coverage, 1085,
     /* 167098 */     GIR_EraseRootFromParent_Done,
     /* 167099 */   // Label 3225: @167099
     /* 167099 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(167144), // Rule ID 1086 //
     /* 167104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167133 */     // (intrinsic_wo_chain:{ *:[v8i16] } 754:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 167133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 167136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167142 */     GIR_RootConstrainSelectedInstOperands,
     /* 167143 */     // GIR_Coverage, 1086,
     /* 167143 */     GIR_EraseRootFromParent_Done,
     /* 167144 */   // Label 3226: @167144
     /* 167144 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(167189), // Rule ID 1087 //
     /* 167149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167178 */     // (intrinsic_wo_chain:{ *:[v2i32] } 754:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 167178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 167181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167187 */     GIR_RootConstrainSelectedInstOperands,
     /* 167188 */     // GIR_Coverage, 1087,
     /* 167188 */     GIR_EraseRootFromParent_Done,
     /* 167189 */   // Label 3227: @167189
     /* 167189 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(167234), // Rule ID 1088 //
     /* 167194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167223 */     // (intrinsic_wo_chain:{ *:[v4i32] } 754:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 167223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 167226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167232 */     GIR_RootConstrainSelectedInstOperands,
     /* 167233 */     // GIR_Coverage, 1088,
     /* 167233 */     GIR_EraseRootFromParent_Done,
     /* 167234 */   // Label 3228: @167234
     /* 167234 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(167279), // Rule ID 1089 //
     /* 167239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167268 */     // (intrinsic_wo_chain:{ *:[v2i64] } 754:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 167268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 167271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167277 */     GIR_RootConstrainSelectedInstOperands,
     /* 167278 */     // GIR_Coverage, 1089,
     /* 167278 */     GIR_EraseRootFromParent_Done,
     /* 167279 */   // Label 3229: @167279
     /* 167279 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(167324), // Rule ID 1101 //
     /* 167284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 167292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167313 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 167313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 167316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167322 */     GIR_RootConstrainSelectedInstOperands,
     /* 167323 */     // GIR_Coverage, 1101,
     /* 167323 */     GIR_EraseRootFromParent_Done,
     /* 167324 */   // Label 3230: @167324
     /* 167324 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(167369), // Rule ID 1103 //
     /* 167329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 167337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167358 */     // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 167358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 167361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167367 */     GIR_RootConstrainSelectedInstOperands,
     /* 167368 */     // GIR_Coverage, 1103,
     /* 167368 */     GIR_EraseRootFromParent_Done,
     /* 167369 */   // Label 3231: @167369
     /* 167369 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(167414), // Rule ID 1105 //
     /* 167374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 167382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167403 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 167403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 167406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167412 */     GIR_RootConstrainSelectedInstOperands,
     /* 167413 */     // GIR_Coverage, 1105,
     /* 167413 */     GIR_EraseRootFromParent_Done,
     /* 167414 */   // Label 3232: @167414
     /* 167414 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(167459), // Rule ID 1107 //
     /* 167419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 167427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167448 */     // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 167448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 167451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167457 */     GIR_RootConstrainSelectedInstOperands,
     /* 167458 */     // GIR_Coverage, 1107,
     /* 167458 */     GIR_EraseRootFromParent_Done,
     /* 167459 */   // Label 3233: @167459
     /* 167459 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(167504), // Rule ID 1109 //
     /* 167464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 167472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167493 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 167493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 167496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167502 */     GIR_RootConstrainSelectedInstOperands,
     /* 167503 */     // GIR_Coverage, 1109,
     /* 167503 */     GIR_EraseRootFromParent_Done,
     /* 167504 */   // Label 3234: @167504
     /* 167504 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(167549), // Rule ID 1111 //
     /* 167509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 167517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167538 */     // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 167538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 167541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167547 */     GIR_RootConstrainSelectedInstOperands,
     /* 167548 */     // GIR_Coverage, 1111,
     /* 167548 */     GIR_EraseRootFromParent_Done,
     /* 167549 */   // Label 3235: @167549
     /* 167549 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(167594), // Rule ID 1113 //
     /* 167554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 167562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167583 */     // (intrinsic_wo_chain:{ *:[v2i64] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 167583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 167586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167592 */     GIR_RootConstrainSelectedInstOperands,
     /* 167593 */     // GIR_Coverage, 1113,
     /* 167593 */     GIR_EraseRootFromParent_Done,
     /* 167594 */   // Label 3236: @167594
     /* 167594 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(167639), // Rule ID 1156 //
     /* 167599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 167607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167628 */     // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 167628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 167631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167637 */     GIR_RootConstrainSelectedInstOperands,
     /* 167638 */     // GIR_Coverage, 1156,
     /* 167638 */     GIR_EraseRootFromParent_Done,
     /* 167639 */   // Label 3237: @167639
     /* 167639 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(167684), // Rule ID 1157 //
     /* 167644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 167652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167673 */     // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 167673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 167676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167682 */     GIR_RootConstrainSelectedInstOperands,
     /* 167683 */     // GIR_Coverage, 1157,
     /* 167683 */     GIR_EraseRootFromParent_Done,
     /* 167684 */   // Label 3238: @167684
     /* 167684 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(167729), // Rule ID 1158 //
     /* 167689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 167697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167718 */     // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 167718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 167721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167727 */     GIR_RootConstrainSelectedInstOperands,
     /* 167728 */     // GIR_Coverage, 1158,
     /* 167728 */     GIR_EraseRootFromParent_Done,
     /* 167729 */   // Label 3239: @167729
     /* 167729 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(167774), // Rule ID 1159 //
     /* 167734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 167742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167763 */     // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 167763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 167766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167772 */     GIR_RootConstrainSelectedInstOperands,
     /* 167773 */     // GIR_Coverage, 1159,
     /* 167773 */     GIR_EraseRootFromParent_Done,
     /* 167774 */   // Label 3240: @167774
     /* 167774 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(167819), // Rule ID 1160 //
     /* 167779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 167787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167808 */     // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 167808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 167811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167817 */     GIR_RootConstrainSelectedInstOperands,
     /* 167818 */     // GIR_Coverage, 1160,
     /* 167818 */     GIR_EraseRootFromParent_Done,
     /* 167819 */   // Label 3241: @167819
     /* 167819 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(167864), // Rule ID 1162 //
     /* 167824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 167832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167853 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 167853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 167856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167862 */     GIR_RootConstrainSelectedInstOperands,
     /* 167863 */     // GIR_Coverage, 1162,
     /* 167863 */     GIR_EraseRootFromParent_Done,
     /* 167864 */   // Label 3242: @167864
     /* 167864 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(167909), // Rule ID 1164 //
     /* 167869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 167877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167898 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 167898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 167901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167907 */     GIR_RootConstrainSelectedInstOperands,
     /* 167908 */     // GIR_Coverage, 1164,
     /* 167908 */     GIR_EraseRootFromParent_Done,
     /* 167909 */   // Label 3243: @167909
     /* 167909 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(167954), // Rule ID 1166 //
     /* 167914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 167922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167943 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 167943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 167946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167952 */     GIR_RootConstrainSelectedInstOperands,
     /* 167953 */     // GIR_Coverage, 1166,
     /* 167953 */     GIR_EraseRootFromParent_Done,
     /* 167954 */   // Label 3244: @167954
     /* 167954 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(167999), // Rule ID 1168 //
     /* 167959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 167967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167988 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 167988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 167991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167997 */     GIR_RootConstrainSelectedInstOperands,
     /* 167998 */     // GIR_Coverage, 1168,
     /* 167998 */     GIR_EraseRootFromParent_Done,
     /* 167999 */   // Label 3245: @167999
     /* 167999 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(168044), // Rule ID 1170 //
     /* 168004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168033 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 168033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 168036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168042 */     GIR_RootConstrainSelectedInstOperands,
     /* 168043 */     // GIR_Coverage, 1170,
     /* 168043 */     GIR_EraseRootFromParent_Done,
     /* 168044 */   // Label 3246: @168044
     /* 168044 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(168089), // Rule ID 1172 //
     /* 168049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168078 */     // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 168081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168087 */     GIR_RootConstrainSelectedInstOperands,
     /* 168088 */     // GIR_Coverage, 1172,
     /* 168088 */     GIR_EraseRootFromParent_Done,
     /* 168089 */   // Label 3247: @168089
     /* 168089 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(168134), // Rule ID 1174 //
     /* 168094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168123 */     // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 168123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 168126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168132 */     GIR_RootConstrainSelectedInstOperands,
     /* 168133 */     // GIR_Coverage, 1174,
     /* 168133 */     GIR_EraseRootFromParent_Done,
     /* 168134 */   // Label 3248: @168134
     /* 168134 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(168179), // Rule ID 1176 //
     /* 168139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168168 */     // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 168168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 168171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168177 */     GIR_RootConstrainSelectedInstOperands,
     /* 168178 */     // GIR_Coverage, 1176,
     /* 168178 */     GIR_EraseRootFromParent_Done,
     /* 168179 */   // Label 3249: @168179
     /* 168179 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(168224), // Rule ID 1178 //
     /* 168184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168213 */     // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 168213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 168216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168222 */     GIR_RootConstrainSelectedInstOperands,
     /* 168223 */     // GIR_Coverage, 1178,
     /* 168223 */     GIR_EraseRootFromParent_Done,
     /* 168224 */   // Label 3250: @168224
     /* 168224 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(168269), // Rule ID 1180 //
     /* 168229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168258 */     // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 168258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 168261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168267 */     GIR_RootConstrainSelectedInstOperands,
     /* 168268 */     // GIR_Coverage, 1180,
     /* 168268 */     GIR_EraseRootFromParent_Done,
     /* 168269 */   // Label 3251: @168269
     /* 168269 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(168314), // Rule ID 1182 //
     /* 168274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 168282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168303 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 168306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168312 */     GIR_RootConstrainSelectedInstOperands,
     /* 168313 */     // GIR_Coverage, 1182,
     /* 168313 */     GIR_EraseRootFromParent_Done,
     /* 168314 */   // Label 3252: @168314
     /* 168314 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(168359), // Rule ID 1184 //
     /* 168319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 168327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168348 */     // (intrinsic_wo_chain:{ *:[v8f16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 168348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 168351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168357 */     GIR_RootConstrainSelectedInstOperands,
     /* 168358 */     // GIR_Coverage, 1184,
     /* 168358 */     GIR_EraseRootFromParent_Done,
     /* 168359 */   // Label 3253: @168359
     /* 168359 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(168404), // Rule ID 1186 //
     /* 168364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 168372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168393 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 168393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 168396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168402 */     GIR_RootConstrainSelectedInstOperands,
     /* 168403 */     // GIR_Coverage, 1186,
     /* 168403 */     GIR_EraseRootFromParent_Done,
     /* 168404 */   // Label 3254: @168404
     /* 168404 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(168449), // Rule ID 1188 //
     /* 168409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 168417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168438 */     // (intrinsic_wo_chain:{ *:[v4f32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 168438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 168441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168447 */     GIR_RootConstrainSelectedInstOperands,
     /* 168448 */     // GIR_Coverage, 1188,
     /* 168448 */     GIR_EraseRootFromParent_Done,
     /* 168449 */   // Label 3255: @168449
     /* 168449 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(168494), // Rule ID 1190 //
     /* 168454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 168462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168483 */     // (intrinsic_wo_chain:{ *:[v2f64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 168483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 168486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168492 */     GIR_RootConstrainSelectedInstOperands,
     /* 168493 */     // GIR_Coverage, 1190,
     /* 168493 */     GIR_EraseRootFromParent_Done,
     /* 168494 */   // Label 3256: @168494
     /* 168494 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(168539), // Rule ID 1226 //
     /* 168499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 168507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168528 */     // (intrinsic_wo_chain:{ *:[v4f16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 168531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168537 */     GIR_RootConstrainSelectedInstOperands,
     /* 168538 */     // GIR_Coverage, 1226,
     /* 168538 */     GIR_EraseRootFromParent_Done,
     /* 168539 */   // Label 3257: @168539
     /* 168539 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(168584), // Rule ID 1227 //
     /* 168544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 168552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168573 */     // (intrinsic_wo_chain:{ *:[v8f16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 168573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 168576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168582 */     GIR_RootConstrainSelectedInstOperands,
     /* 168583 */     // GIR_Coverage, 1227,
     /* 168583 */     GIR_EraseRootFromParent_Done,
     /* 168584 */   // Label 3258: @168584
     /* 168584 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(168629), // Rule ID 1228 //
     /* 168589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 168597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168618 */     // (intrinsic_wo_chain:{ *:[v2f32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 168618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 168621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168627 */     GIR_RootConstrainSelectedInstOperands,
     /* 168628 */     // GIR_Coverage, 1228,
     /* 168628 */     GIR_EraseRootFromParent_Done,
     /* 168629 */   // Label 3259: @168629
     /* 168629 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(168674), // Rule ID 1229 //
     /* 168634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 168642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168663 */     // (intrinsic_wo_chain:{ *:[v4f32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 168663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 168666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168672 */     GIR_RootConstrainSelectedInstOperands,
     /* 168673 */     // GIR_Coverage, 1229,
     /* 168673 */     GIR_EraseRootFromParent_Done,
     /* 168674 */   // Label 3260: @168674
     /* 168674 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(168719), // Rule ID 1230 //
     /* 168679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 168687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168708 */     // (intrinsic_wo_chain:{ *:[v2f64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 168708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 168711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168717 */     GIR_RootConstrainSelectedInstOperands,
     /* 168718 */     // GIR_Coverage, 1230,
     /* 168718 */     GIR_EraseRootFromParent_Done,
     /* 168719 */   // Label 3261: @168719
     /* 168719 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(168764), // Rule ID 1241 //
     /* 168724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 168732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168753 */     // (intrinsic_wo_chain:{ *:[v4f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 168756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168762 */     GIR_RootConstrainSelectedInstOperands,
     /* 168763 */     // GIR_Coverage, 1241,
     /* 168763 */     GIR_EraseRootFromParent_Done,
     /* 168764 */   // Label 3262: @168764
     /* 168764 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(168809), // Rule ID 1242 //
     /* 168769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 168777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168798 */     // (intrinsic_wo_chain:{ *:[v8f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 168798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 168801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168807 */     GIR_RootConstrainSelectedInstOperands,
     /* 168808 */     // GIR_Coverage, 1242,
     /* 168808 */     GIR_EraseRootFromParent_Done,
     /* 168809 */   // Label 3263: @168809
     /* 168809 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(168854), // Rule ID 1243 //
     /* 168814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 168822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168843 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 168843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 168846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168852 */     GIR_RootConstrainSelectedInstOperands,
     /* 168853 */     // GIR_Coverage, 1243,
     /* 168853 */     GIR_EraseRootFromParent_Done,
     /* 168854 */   // Label 3264: @168854
     /* 168854 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(168899), // Rule ID 1244 //
     /* 168859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 168867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168888 */     // (intrinsic_wo_chain:{ *:[v4f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 168888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 168891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168897 */     GIR_RootConstrainSelectedInstOperands,
     /* 168898 */     // GIR_Coverage, 1244,
     /* 168898 */     GIR_EraseRootFromParent_Done,
     /* 168899 */   // Label 3265: @168899
     /* 168899 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(168944), // Rule ID 1245 //
     /* 168904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 168912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168933 */     // (intrinsic_wo_chain:{ *:[v2f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 168933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 168936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168942 */     GIR_RootConstrainSelectedInstOperands,
     /* 168943 */     // GIR_Coverage, 1245,
     /* 168943 */     GIR_EraseRootFromParent_Done,
     /* 168944 */   // Label 3266: @168944
     /* 168944 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(168989), // Rule ID 1256 //
     /* 168949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 168957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168978 */     // (intrinsic_wo_chain:{ *:[v4f16] } 602:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 168981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168987 */     GIR_RootConstrainSelectedInstOperands,
     /* 168988 */     // GIR_Coverage, 1256,
     /* 168988 */     GIR_EraseRootFromParent_Done,
     /* 168989 */   // Label 3267: @168989
     /* 168989 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(169034), // Rule ID 1257 //
     /* 168994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169023 */     // (intrinsic_wo_chain:{ *:[v8f16] } 602:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 169026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169032 */     GIR_RootConstrainSelectedInstOperands,
     /* 169033 */     // GIR_Coverage, 1257,
     /* 169033 */     GIR_EraseRootFromParent_Done,
     /* 169034 */   // Label 3268: @169034
     /* 169034 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(169079), // Rule ID 1258 //
     /* 169039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169068 */     // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 169071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169077 */     GIR_RootConstrainSelectedInstOperands,
     /* 169078 */     // GIR_Coverage, 1258,
     /* 169078 */     GIR_EraseRootFromParent_Done,
     /* 169079 */   // Label 3269: @169079
     /* 169079 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(169124), // Rule ID 1259 //
     /* 169084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169113 */     // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 169116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169122 */     GIR_RootConstrainSelectedInstOperands,
     /* 169123 */     // GIR_Coverage, 1259,
     /* 169123 */     GIR_EraseRootFromParent_Done,
     /* 169124 */   // Label 3270: @169124
     /* 169124 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(169169), // Rule ID 1260 //
     /* 169129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169158 */     // (intrinsic_wo_chain:{ *:[v2f64] } 602:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 169161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169167 */     GIR_RootConstrainSelectedInstOperands,
     /* 169168 */     // GIR_Coverage, 1260,
     /* 169168 */     GIR_EraseRootFromParent_Done,
     /* 169169 */   // Label 3271: @169169
     /* 169169 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(169214), // Rule ID 1271 //
     /* 169174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 169182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169203 */     // (intrinsic_wo_chain:{ *:[v4f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 169206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169212 */     GIR_RootConstrainSelectedInstOperands,
     /* 169213 */     // GIR_Coverage, 1271,
     /* 169213 */     GIR_EraseRootFromParent_Done,
     /* 169214 */   // Label 3272: @169214
     /* 169214 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(169259), // Rule ID 1272 //
     /* 169219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 169227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169248 */     // (intrinsic_wo_chain:{ *:[v8f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 169251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169257 */     GIR_RootConstrainSelectedInstOperands,
     /* 169258 */     // GIR_Coverage, 1272,
     /* 169258 */     GIR_EraseRootFromParent_Done,
     /* 169259 */   // Label 3273: @169259
     /* 169259 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(169304), // Rule ID 1273 //
     /* 169264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 169272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169293 */     // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 169296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169302 */     GIR_RootConstrainSelectedInstOperands,
     /* 169303 */     // GIR_Coverage, 1273,
     /* 169303 */     GIR_EraseRootFromParent_Done,
     /* 169304 */   // Label 3274: @169304
     /* 169304 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(169349), // Rule ID 1274 //
     /* 169309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 169317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169338 */     // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 169341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169347 */     GIR_RootConstrainSelectedInstOperands,
     /* 169348 */     // GIR_Coverage, 1274,
     /* 169348 */     GIR_EraseRootFromParent_Done,
     /* 169349 */   // Label 3275: @169349
     /* 169349 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(169394), // Rule ID 1275 //
     /* 169354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 169362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169383 */     // (intrinsic_wo_chain:{ *:[v2f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 169386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169392 */     GIR_RootConstrainSelectedInstOperands,
     /* 169393 */     // GIR_Coverage, 1275,
     /* 169393 */     GIR_EraseRootFromParent_Done,
     /* 169394 */   // Label 3276: @169394
     /* 169394 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(169439), // Rule ID 1306 //
     /* 169399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 169407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169428 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 169431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169437 */     GIR_RootConstrainSelectedInstOperands,
     /* 169438 */     // GIR_Coverage, 1306,
     /* 169438 */     GIR_EraseRootFromParent_Done,
     /* 169439 */   // Label 3277: @169439
     /* 169439 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(169484), // Rule ID 1307 //
     /* 169444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 169452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169473 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 169476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169482 */     GIR_RootConstrainSelectedInstOperands,
     /* 169483 */     // GIR_Coverage, 1307,
     /* 169483 */     GIR_EraseRootFromParent_Done,
     /* 169484 */   // Label 3278: @169484
     /* 169484 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(169529), // Rule ID 1308 //
     /* 169489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 169497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169518 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 169521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169527 */     GIR_RootConstrainSelectedInstOperands,
     /* 169528 */     // GIR_Coverage, 1308,
     /* 169528 */     GIR_EraseRootFromParent_Done,
     /* 169529 */   // Label 3279: @169529
     /* 169529 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(169574), // Rule ID 1309 //
     /* 169534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 169542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169563 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 169566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169572 */     GIR_RootConstrainSelectedInstOperands,
     /* 169573 */     // GIR_Coverage, 1309,
     /* 169573 */     GIR_EraseRootFromParent_Done,
     /* 169574 */   // Label 3280: @169574
     /* 169574 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(169619), // Rule ID 1310 //
     /* 169579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 169587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169608 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 169611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169617 */     GIR_RootConstrainSelectedInstOperands,
     /* 169618 */     // GIR_Coverage, 1310,
     /* 169618 */     GIR_EraseRootFromParent_Done,
     /* 169619 */   // Label 3281: @169619
     /* 169619 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(169664), // Rule ID 1321 //
     /* 169624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 169632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169653 */     // (intrinsic_wo_chain:{ *:[v4f16] } 633:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 169656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169662 */     GIR_RootConstrainSelectedInstOperands,
     /* 169663 */     // GIR_Coverage, 1321,
     /* 169663 */     GIR_EraseRootFromParent_Done,
     /* 169664 */   // Label 3282: @169664
     /* 169664 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(169709), // Rule ID 1322 //
     /* 169669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 169677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169698 */     // (intrinsic_wo_chain:{ *:[v8f16] } 633:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 169701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169707 */     GIR_RootConstrainSelectedInstOperands,
     /* 169708 */     // GIR_Coverage, 1322,
     /* 169708 */     GIR_EraseRootFromParent_Done,
     /* 169709 */   // Label 3283: @169709
     /* 169709 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(169754), // Rule ID 1323 //
     /* 169714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 169722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169743 */     // (intrinsic_wo_chain:{ *:[v2f32] } 633:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 169746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169752 */     GIR_RootConstrainSelectedInstOperands,
     /* 169753 */     // GIR_Coverage, 1323,
     /* 169753 */     GIR_EraseRootFromParent_Done,
     /* 169754 */   // Label 3284: @169754
     /* 169754 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(169799), // Rule ID 1324 //
     /* 169759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 169767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169788 */     // (intrinsic_wo_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 169791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169797 */     GIR_RootConstrainSelectedInstOperands,
     /* 169798 */     // GIR_Coverage, 1324,
     /* 169798 */     GIR_EraseRootFromParent_Done,
     /* 169799 */   // Label 3285: @169799
     /* 169799 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(169844), // Rule ID 1325 //
     /* 169804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 169812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169833 */     // (intrinsic_wo_chain:{ *:[v2f64] } 633:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 169836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169842 */     GIR_RootConstrainSelectedInstOperands,
     /* 169843 */     // GIR_Coverage, 1325,
     /* 169843 */     GIR_EraseRootFromParent_Done,
     /* 169844 */   // Label 3286: @169844
     /* 169844 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(169889), // Rule ID 1326 //
     /* 169849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 169857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169878 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 169881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169887 */     GIR_RootConstrainSelectedInstOperands,
     /* 169888 */     // GIR_Coverage, 1326,
     /* 169888 */     GIR_EraseRootFromParent_Done,
     /* 169889 */   // Label 3287: @169889
     /* 169889 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(169934), // Rule ID 1327 //
     /* 169894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 169902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169923 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 169926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169932 */     GIR_RootConstrainSelectedInstOperands,
     /* 169933 */     // GIR_Coverage, 1327,
     /* 169933 */     GIR_EraseRootFromParent_Done,
     /* 169934 */   // Label 3288: @169934
     /* 169934 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(169979), // Rule ID 1328 //
     /* 169939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 169947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169968 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 169971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169977 */     GIR_RootConstrainSelectedInstOperands,
     /* 169978 */     // GIR_Coverage, 1328,
     /* 169978 */     GIR_EraseRootFromParent_Done,
     /* 169979 */   // Label 3289: @169979
     /* 169979 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(170024), // Rule ID 1329 //
     /* 169984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 169992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170013 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 170016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170022 */     GIR_RootConstrainSelectedInstOperands,
     /* 170023 */     // GIR_Coverage, 1329,
     /* 170023 */     GIR_EraseRootFromParent_Done,
     /* 170024 */   // Label 3290: @170024
     /* 170024 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(170069), // Rule ID 1330 //
     /* 170029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170058 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 170061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170067 */     GIR_RootConstrainSelectedInstOperands,
     /* 170068 */     // GIR_Coverage, 1330,
     /* 170068 */     GIR_EraseRootFromParent_Done,
     /* 170069 */   // Label 3291: @170069
     /* 170069 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(170114), // Rule ID 1347 //
     /* 170074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 170082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170103 */     // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 170106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170112 */     GIR_RootConstrainSelectedInstOperands,
     /* 170113 */     // GIR_Coverage, 1347,
     /* 170113 */     GIR_EraseRootFromParent_Done,
     /* 170114 */   // Label 3292: @170114
     /* 170114 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(170159), // Rule ID 1348 //
     /* 170119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 170127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170148 */     // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 170151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170157 */     GIR_RootConstrainSelectedInstOperands,
     /* 170158 */     // GIR_Coverage, 1348,
     /* 170158 */     GIR_EraseRootFromParent_Done,
     /* 170159 */   // Label 3293: @170159
     /* 170159 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(170204), // Rule ID 1362 //
     /* 170164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 170172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170193 */     // (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 170196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170202 */     GIR_RootConstrainSelectedInstOperands,
     /* 170203 */     // GIR_Coverage, 1362,
     /* 170203 */     GIR_EraseRootFromParent_Done,
     /* 170204 */   // Label 3294: @170204
     /* 170204 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(170249), // Rule ID 1364 //
     /* 170209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 170217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170238 */     // (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 170241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170247 */     GIR_RootConstrainSelectedInstOperands,
     /* 170248 */     // GIR_Coverage, 1364,
     /* 170248 */     GIR_EraseRootFromParent_Done,
     /* 170249 */   // Label 3295: @170249
     /* 170249 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(170294), // Rule ID 1366 //
     /* 170254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 170262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170283 */     // (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 170286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170292 */     GIR_RootConstrainSelectedInstOperands,
     /* 170293 */     // GIR_Coverage, 1366,
     /* 170293 */     GIR_EraseRootFromParent_Done,
     /* 170294 */   // Label 3296: @170294
     /* 170294 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(170339), // Rule ID 1368 //
     /* 170299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 170307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170328 */     // (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 170331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170337 */     GIR_RootConstrainSelectedInstOperands,
     /* 170338 */     // GIR_Coverage, 1368,
     /* 170338 */     GIR_EraseRootFromParent_Done,
     /* 170339 */   // Label 3297: @170339
     /* 170339 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(170384), // Rule ID 1370 //
     /* 170344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 170352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170373 */     // (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 170376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170382 */     GIR_RootConstrainSelectedInstOperands,
     /* 170383 */     // GIR_Coverage, 1370,
     /* 170383 */     GIR_EraseRootFromParent_Done,
     /* 170384 */   // Label 3298: @170384
     /* 170384 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(170429), // Rule ID 1372 //
     /* 170389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 170397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170418 */     // (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 170421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170427 */     GIR_RootConstrainSelectedInstOperands,
     /* 170428 */     // GIR_Coverage, 1372,
     /* 170428 */     GIR_EraseRootFromParent_Done,
     /* 170429 */   // Label 3299: @170429
     /* 170429 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(170474), // Rule ID 1379 //
     /* 170434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 170442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170463 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 170466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170472 */     GIR_RootConstrainSelectedInstOperands,
     /* 170473 */     // GIR_Coverage, 1379,
     /* 170473 */     GIR_EraseRootFromParent_Done,
     /* 170474 */   // Label 3300: @170474
     /* 170474 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(170519), // Rule ID 1380 //
     /* 170479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 170487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170508 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 170511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170517 */     GIR_RootConstrainSelectedInstOperands,
     /* 170518 */     // GIR_Coverage, 1380,
     /* 170518 */     GIR_EraseRootFromParent_Done,
     /* 170519 */   // Label 3301: @170519
     /* 170519 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(170564), // Rule ID 1381 //
     /* 170524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 170532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170553 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 170556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170562 */     GIR_RootConstrainSelectedInstOperands,
     /* 170563 */     // GIR_Coverage, 1381,
     /* 170563 */     GIR_EraseRootFromParent_Done,
     /* 170564 */   // Label 3302: @170564
     /* 170564 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(170609), // Rule ID 1382 //
     /* 170569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 170577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170598 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 170601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170607 */     GIR_RootConstrainSelectedInstOperands,
     /* 170608 */     // GIR_Coverage, 1382,
     /* 170608 */     GIR_EraseRootFromParent_Done,
     /* 170609 */   // Label 3303: @170609
     /* 170609 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(170654), // Rule ID 1383 //
     /* 170614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 170622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170643 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 170646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170652 */     GIR_RootConstrainSelectedInstOperands,
     /* 170653 */     // GIR_Coverage, 1383,
     /* 170653 */     GIR_EraseRootFromParent_Done,
     /* 170654 */   // Label 3304: @170654
     /* 170654 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(170699), // Rule ID 1384 //
     /* 170659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 170667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170688 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 170691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170697 */     GIR_RootConstrainSelectedInstOperands,
     /* 170698 */     // GIR_Coverage, 1384,
     /* 170698 */     GIR_EraseRootFromParent_Done,
     /* 170699 */   // Label 3305: @170699
     /* 170699 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(170744), // Rule ID 1385 //
     /* 170704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 170712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170733 */     // (intrinsic_wo_chain:{ *:[v8i8] } 671:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 170736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170742 */     GIR_RootConstrainSelectedInstOperands,
     /* 170743 */     // GIR_Coverage, 1385,
     /* 170743 */     GIR_EraseRootFromParent_Done,
     /* 170744 */   // Label 3306: @170744
     /* 170744 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(170789), // Rule ID 1386 //
     /* 170749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 170757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170778 */     // (intrinsic_wo_chain:{ *:[v16i8] } 671:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 170781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170787 */     GIR_RootConstrainSelectedInstOperands,
     /* 170788 */     // GIR_Coverage, 1386,
     /* 170788 */     GIR_EraseRootFromParent_Done,
     /* 170789 */   // Label 3307: @170789
     /* 170789 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(170834), // Rule ID 1387 //
     /* 170794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 170802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170823 */     // (intrinsic_wo_chain:{ *:[v4i16] } 671:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 170823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 170826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170832 */     GIR_RootConstrainSelectedInstOperands,
     /* 170833 */     // GIR_Coverage, 1387,
     /* 170833 */     GIR_EraseRootFromParent_Done,
     /* 170834 */   // Label 3308: @170834
     /* 170834 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(170879), // Rule ID 1388 //
     /* 170839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 170847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170868 */     // (intrinsic_wo_chain:{ *:[v8i16] } 671:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 170868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 170871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170877 */     GIR_RootConstrainSelectedInstOperands,
     /* 170878 */     // GIR_Coverage, 1388,
     /* 170878 */     GIR_EraseRootFromParent_Done,
     /* 170879 */   // Label 3309: @170879
     /* 170879 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(170924), // Rule ID 1389 //
     /* 170884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 170892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170913 */     // (intrinsic_wo_chain:{ *:[v2i32] } 671:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 170913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 170916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170922 */     GIR_RootConstrainSelectedInstOperands,
     /* 170923 */     // GIR_Coverage, 1389,
     /* 170923 */     GIR_EraseRootFromParent_Done,
     /* 170924 */   // Label 3310: @170924
     /* 170924 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(170969), // Rule ID 1390 //
     /* 170929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 170937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170958 */     // (intrinsic_wo_chain:{ *:[v4i32] } 671:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 170958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 170961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170967 */     GIR_RootConstrainSelectedInstOperands,
     /* 170968 */     // GIR_Coverage, 1390,
     /* 170968 */     GIR_EraseRootFromParent_Done,
     /* 170969 */   // Label 3311: @170969
     /* 170969 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(171014), // Rule ID 1397 //
     /* 170974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 170982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171003 */     // (intrinsic_wo_chain:{ *:[v8i8] } 674:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 171006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171012 */     GIR_RootConstrainSelectedInstOperands,
     /* 171013 */     // GIR_Coverage, 1397,
     /* 171013 */     GIR_EraseRootFromParent_Done,
     /* 171014 */   // Label 3312: @171014
     /* 171014 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(171059), // Rule ID 1398 //
     /* 171019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171048 */     // (intrinsic_wo_chain:{ *:[v16i8] } 674:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 171051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171057 */     GIR_RootConstrainSelectedInstOperands,
     /* 171058 */     // GIR_Coverage, 1398,
     /* 171058 */     GIR_EraseRootFromParent_Done,
     /* 171059 */   // Label 3313: @171059
     /* 171059 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(171104), // Rule ID 1399 //
     /* 171064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171093 */     // (intrinsic_wo_chain:{ *:[v4i16] } 674:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 171096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171102 */     GIR_RootConstrainSelectedInstOperands,
     /* 171103 */     // GIR_Coverage, 1399,
     /* 171103 */     GIR_EraseRootFromParent_Done,
     /* 171104 */   // Label 3314: @171104
     /* 171104 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(171149), // Rule ID 1400 //
     /* 171109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171138 */     // (intrinsic_wo_chain:{ *:[v8i16] } 674:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 171141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171147 */     GIR_RootConstrainSelectedInstOperands,
     /* 171148 */     // GIR_Coverage, 1400,
     /* 171148 */     GIR_EraseRootFromParent_Done,
     /* 171149 */   // Label 3315: @171149
     /* 171149 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(171194), // Rule ID 1401 //
     /* 171154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171183 */     // (intrinsic_wo_chain:{ *:[v2i32] } 674:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 171186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171192 */     GIR_RootConstrainSelectedInstOperands,
     /* 171193 */     // GIR_Coverage, 1401,
     /* 171193 */     GIR_EraseRootFromParent_Done,
     /* 171194 */   // Label 3316: @171194
     /* 171194 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(171239), // Rule ID 1402 //
     /* 171199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171228 */     // (intrinsic_wo_chain:{ *:[v4i32] } 674:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 171231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171237 */     GIR_RootConstrainSelectedInstOperands,
     /* 171238 */     // GIR_Coverage, 1402,
     /* 171238 */     GIR_EraseRootFromParent_Done,
     /* 171239 */   // Label 3317: @171239
     /* 171239 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(171284), // Rule ID 1409 //
     /* 171244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171273 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 171276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171282 */     GIR_RootConstrainSelectedInstOperands,
     /* 171283 */     // GIR_Coverage, 1409,
     /* 171283 */     GIR_EraseRootFromParent_Done,
     /* 171284 */   // Label 3318: @171284
     /* 171284 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(171329), // Rule ID 1410 //
     /* 171289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171318 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 171321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171327 */     GIR_RootConstrainSelectedInstOperands,
     /* 171328 */     // GIR_Coverage, 1410,
     /* 171328 */     GIR_EraseRootFromParent_Done,
     /* 171329 */   // Label 3319: @171329
     /* 171329 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(171374), // Rule ID 1411 //
     /* 171334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171363 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 171366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171372 */     GIR_RootConstrainSelectedInstOperands,
     /* 171373 */     // GIR_Coverage, 1411,
     /* 171373 */     GIR_EraseRootFromParent_Done,
     /* 171374 */   // Label 3320: @171374
     /* 171374 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(171419), // Rule ID 1412 //
     /* 171379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171408 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 171411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171417 */     GIR_RootConstrainSelectedInstOperands,
     /* 171418 */     // GIR_Coverage, 1412,
     /* 171418 */     GIR_EraseRootFromParent_Done,
     /* 171419 */   // Label 3321: @171419
     /* 171419 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(171464), // Rule ID 1413 //
     /* 171424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171453 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 171456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171462 */     GIR_RootConstrainSelectedInstOperands,
     /* 171463 */     // GIR_Coverage, 1413,
     /* 171463 */     GIR_EraseRootFromParent_Done,
     /* 171464 */   // Label 3322: @171464
     /* 171464 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(171509), // Rule ID 1414 //
     /* 171469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171498 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 171501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171507 */     GIR_RootConstrainSelectedInstOperands,
     /* 171508 */     // GIR_Coverage, 1414,
     /* 171508 */     GIR_EraseRootFromParent_Done,
     /* 171509 */   // Label 3323: @171509
     /* 171509 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(171554), // Rule ID 1415 //
     /* 171514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171543 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 171543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 171546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171552 */     GIR_RootConstrainSelectedInstOperands,
     /* 171553 */     // GIR_Coverage, 1415,
     /* 171553 */     GIR_EraseRootFromParent_Done,
     /* 171554 */   // Label 3324: @171554
     /* 171554 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(171599), // Rule ID 1416 //
     /* 171559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 171567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171588 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 171591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171597 */     GIR_RootConstrainSelectedInstOperands,
     /* 171598 */     // GIR_Coverage, 1416,
     /* 171598 */     GIR_EraseRootFromParent_Done,
     /* 171599 */   // Label 3325: @171599
     /* 171599 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(171644), // Rule ID 1417 //
     /* 171604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 171612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171633 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 171636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171642 */     GIR_RootConstrainSelectedInstOperands,
     /* 171643 */     // GIR_Coverage, 1417,
     /* 171643 */     GIR_EraseRootFromParent_Done,
     /* 171644 */   // Label 3326: @171644
     /* 171644 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(171689), // Rule ID 1418 //
     /* 171649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 171657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171678 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 171681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171687 */     GIR_RootConstrainSelectedInstOperands,
     /* 171688 */     // GIR_Coverage, 1418,
     /* 171688 */     GIR_EraseRootFromParent_Done,
     /* 171689 */   // Label 3327: @171689
     /* 171689 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(171734), // Rule ID 1419 //
     /* 171694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 171702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171723 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 171726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171732 */     GIR_RootConstrainSelectedInstOperands,
     /* 171733 */     // GIR_Coverage, 1419,
     /* 171733 */     GIR_EraseRootFromParent_Done,
     /* 171734 */   // Label 3328: @171734
     /* 171734 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(171779), // Rule ID 1420 //
     /* 171739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 171747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171768 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 171771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171777 */     GIR_RootConstrainSelectedInstOperands,
     /* 171778 */     // GIR_Coverage, 1420,
     /* 171778 */     GIR_EraseRootFromParent_Done,
     /* 171779 */   // Label 3329: @171779
     /* 171779 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(171824), // Rule ID 1421 //
     /* 171784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 171792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171813 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 171816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171822 */     GIR_RootConstrainSelectedInstOperands,
     /* 171823 */     // GIR_Coverage, 1421,
     /* 171823 */     GIR_EraseRootFromParent_Done,
     /* 171824 */   // Label 3330: @171824
     /* 171824 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(171869), // Rule ID 1422 //
     /* 171829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 171837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171858 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 171861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171867 */     GIR_RootConstrainSelectedInstOperands,
     /* 171868 */     // GIR_Coverage, 1422,
     /* 171868 */     GIR_EraseRootFromParent_Done,
     /* 171869 */   // Label 3331: @171869
     /* 171869 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(171914), // Rule ID 1423 //
     /* 171874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 171882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171903 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 171906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171912 */     GIR_RootConstrainSelectedInstOperands,
     /* 171913 */     // GIR_Coverage, 1423,
     /* 171913 */     GIR_EraseRootFromParent_Done,
     /* 171914 */   // Label 3332: @171914
     /* 171914 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(171959), // Rule ID 1424 //
     /* 171919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 171927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171948 */     // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 171951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171957 */     GIR_RootConstrainSelectedInstOperands,
     /* 171958 */     // GIR_Coverage, 1424,
     /* 171958 */     GIR_EraseRootFromParent_Done,
     /* 171959 */   // Label 3333: @171959
     /* 171959 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(172004), // Rule ID 1425 //
     /* 171964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 171972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171993 */     // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 171996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172002 */     GIR_RootConstrainSelectedInstOperands,
     /* 172003 */     // GIR_Coverage, 1425,
     /* 172003 */     GIR_EraseRootFromParent_Done,
     /* 172004 */   // Label 3334: @172004
     /* 172004 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(172049), // Rule ID 1426 //
     /* 172009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172038 */     // (intrinsic_wo_chain:{ *:[v4i16] } 691:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 172041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172047 */     GIR_RootConstrainSelectedInstOperands,
     /* 172048 */     // GIR_Coverage, 1426,
     /* 172048 */     GIR_EraseRootFromParent_Done,
     /* 172049 */   // Label 3335: @172049
     /* 172049 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(172094), // Rule ID 1427 //
     /* 172054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172083 */     // (intrinsic_wo_chain:{ *:[v8i16] } 691:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 172086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172092 */     GIR_RootConstrainSelectedInstOperands,
     /* 172093 */     // GIR_Coverage, 1427,
     /* 172093 */     GIR_EraseRootFromParent_Done,
     /* 172094 */   // Label 3336: @172094
     /* 172094 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(172139), // Rule ID 1428 //
     /* 172099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172128 */     // (intrinsic_wo_chain:{ *:[v2i32] } 691:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 172131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172137 */     GIR_RootConstrainSelectedInstOperands,
     /* 172138 */     // GIR_Coverage, 1428,
     /* 172138 */     GIR_EraseRootFromParent_Done,
     /* 172139 */   // Label 3337: @172139
     /* 172139 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(172184), // Rule ID 1429 //
     /* 172144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172173 */     // (intrinsic_wo_chain:{ *:[v4i32] } 691:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 172176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172182 */     GIR_RootConstrainSelectedInstOperands,
     /* 172183 */     // GIR_Coverage, 1429,
     /* 172183 */     GIR_EraseRootFromParent_Done,
     /* 172184 */   // Label 3338: @172184
     /* 172184 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(172229), // Rule ID 1430 //
     /* 172189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172218 */     // (intrinsic_wo_chain:{ *:[v2i64] } 691:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 172221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172227 */     GIR_RootConstrainSelectedInstOperands,
     /* 172228 */     // GIR_Coverage, 1430,
     /* 172228 */     GIR_EraseRootFromParent_Done,
     /* 172229 */   // Label 3339: @172229
     /* 172229 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(172274), // Rule ID 1431 //
     /* 172234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 172242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172263 */     // (intrinsic_wo_chain:{ *:[v8i8] } 694:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 172266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172272 */     GIR_RootConstrainSelectedInstOperands,
     /* 172273 */     // GIR_Coverage, 1431,
     /* 172273 */     GIR_EraseRootFromParent_Done,
     /* 172274 */   // Label 3340: @172274
     /* 172274 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(172319), // Rule ID 1432 //
     /* 172279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 172287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172308 */     // (intrinsic_wo_chain:{ *:[v16i8] } 694:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 172311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172317 */     GIR_RootConstrainSelectedInstOperands,
     /* 172318 */     // GIR_Coverage, 1432,
     /* 172318 */     GIR_EraseRootFromParent_Done,
     /* 172319 */   // Label 3341: @172319
     /* 172319 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(172364), // Rule ID 1433 //
     /* 172324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 172332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172353 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 172356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172362 */     GIR_RootConstrainSelectedInstOperands,
     /* 172363 */     // GIR_Coverage, 1433,
     /* 172363 */     GIR_EraseRootFromParent_Done,
     /* 172364 */   // Label 3342: @172364
     /* 172364 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(172409), // Rule ID 1434 //
     /* 172369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 172377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172398 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 172401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172407 */     GIR_RootConstrainSelectedInstOperands,
     /* 172408 */     // GIR_Coverage, 1434,
     /* 172408 */     GIR_EraseRootFromParent_Done,
     /* 172409 */   // Label 3343: @172409
     /* 172409 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(172454), // Rule ID 1435 //
     /* 172414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 172422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172443 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 172446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172452 */     GIR_RootConstrainSelectedInstOperands,
     /* 172453 */     // GIR_Coverage, 1435,
     /* 172453 */     GIR_EraseRootFromParent_Done,
     /* 172454 */   // Label 3344: @172454
     /* 172454 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(172499), // Rule ID 1436 //
     /* 172459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 172467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172488 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 172491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172497 */     GIR_RootConstrainSelectedInstOperands,
     /* 172498 */     // GIR_Coverage, 1436,
     /* 172498 */     GIR_EraseRootFromParent_Done,
     /* 172499 */   // Label 3345: @172499
     /* 172499 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(172544), // Rule ID 1437 //
     /* 172504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 172512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172533 */     // (intrinsic_wo_chain:{ *:[v2i64] } 694:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 172536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172542 */     GIR_RootConstrainSelectedInstOperands,
     /* 172543 */     // GIR_Coverage, 1437,
     /* 172543 */     GIR_EraseRootFromParent_Done,
     /* 172544 */   // Label 3346: @172544
     /* 172544 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(172589), // Rule ID 1438 //
     /* 172549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172578 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 172581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172587 */     GIR_RootConstrainSelectedInstOperands,
     /* 172588 */     // GIR_Coverage, 1438,
     /* 172588 */     GIR_EraseRootFromParent_Done,
     /* 172589 */   // Label 3347: @172589
     /* 172589 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(172634), // Rule ID 1439 //
     /* 172594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172623 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 172626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172632 */     GIR_RootConstrainSelectedInstOperands,
     /* 172633 */     // GIR_Coverage, 1439,
     /* 172633 */     GIR_EraseRootFromParent_Done,
     /* 172634 */   // Label 3348: @172634
     /* 172634 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(172679), // Rule ID 1440 //
     /* 172639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172668 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 172671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172677 */     GIR_RootConstrainSelectedInstOperands,
     /* 172678 */     // GIR_Coverage, 1440,
     /* 172678 */     GIR_EraseRootFromParent_Done,
     /* 172679 */   // Label 3349: @172679
     /* 172679 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(172724), // Rule ID 1441 //
     /* 172684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172713 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 172716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172722 */     GIR_RootConstrainSelectedInstOperands,
     /* 172723 */     // GIR_Coverage, 1441,
     /* 172723 */     GIR_EraseRootFromParent_Done,
     /* 172724 */   // Label 3350: @172724
     /* 172724 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(172769), // Rule ID 1442 //
     /* 172729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172758 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 172761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172767 */     GIR_RootConstrainSelectedInstOperands,
     /* 172768 */     // GIR_Coverage, 1442,
     /* 172768 */     GIR_EraseRootFromParent_Done,
     /* 172769 */   // Label 3351: @172769
     /* 172769 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(172814), // Rule ID 1443 //
     /* 172774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172803 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 172806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172812 */     GIR_RootConstrainSelectedInstOperands,
     /* 172813 */     // GIR_Coverage, 1443,
     /* 172813 */     GIR_EraseRootFromParent_Done,
     /* 172814 */   // Label 3352: @172814
     /* 172814 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(172859), // Rule ID 1444 //
     /* 172819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172848 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 172851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172857 */     GIR_RootConstrainSelectedInstOperands,
     /* 172858 */     // GIR_Coverage, 1444,
     /* 172858 */     GIR_EraseRootFromParent_Done,
     /* 172859 */   // Label 3353: @172859
     /* 172859 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(172904), // Rule ID 1451 //
     /* 172864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 172872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172893 */     // (intrinsic_wo_chain:{ *:[v8i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 172896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172902 */     GIR_RootConstrainSelectedInstOperands,
     /* 172903 */     // GIR_Coverage, 1451,
     /* 172903 */     GIR_EraseRootFromParent_Done,
     /* 172904 */   // Label 3354: @172904
     /* 172904 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(172949), // Rule ID 1452 //
     /* 172909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 172917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172938 */     // (intrinsic_wo_chain:{ *:[v16i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 172941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172947 */     GIR_RootConstrainSelectedInstOperands,
     /* 172948 */     // GIR_Coverage, 1452,
     /* 172948 */     GIR_EraseRootFromParent_Done,
     /* 172949 */   // Label 3355: @172949
     /* 172949 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(172994), // Rule ID 1453 //
     /* 172954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 172962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172983 */     // (intrinsic_wo_chain:{ *:[v4i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 172986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172992 */     GIR_RootConstrainSelectedInstOperands,
     /* 172993 */     // GIR_Coverage, 1453,
     /* 172993 */     GIR_EraseRootFromParent_Done,
     /* 172994 */   // Label 3356: @172994
     /* 172994 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(173039), // Rule ID 1454 //
     /* 172999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173028 */     // (intrinsic_wo_chain:{ *:[v8i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 173031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173037 */     GIR_RootConstrainSelectedInstOperands,
     /* 173038 */     // GIR_Coverage, 1454,
     /* 173038 */     GIR_EraseRootFromParent_Done,
     /* 173039 */   // Label 3357: @173039
     /* 173039 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(173084), // Rule ID 1455 //
     /* 173044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173073 */     // (intrinsic_wo_chain:{ *:[v2i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 173076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173082 */     GIR_RootConstrainSelectedInstOperands,
     /* 173083 */     // GIR_Coverage, 1455,
     /* 173083 */     GIR_EraseRootFromParent_Done,
     /* 173084 */   // Label 3358: @173084
     /* 173084 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(173129), // Rule ID 1456 //
     /* 173089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173118 */     // (intrinsic_wo_chain:{ *:[v4i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 173121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173127 */     GIR_RootConstrainSelectedInstOperands,
     /* 173128 */     // GIR_Coverage, 1456,
     /* 173128 */     GIR_EraseRootFromParent_Done,
     /* 173129 */   // Label 3359: @173129
     /* 173129 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(173174), // Rule ID 1457 //
     /* 173134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173163 */     // (intrinsic_wo_chain:{ *:[v2i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 173166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173172 */     GIR_RootConstrainSelectedInstOperands,
     /* 173173 */     // GIR_Coverage, 1457,
     /* 173173 */     GIR_EraseRootFromParent_Done,
     /* 173174 */   // Label 3360: @173174
     /* 173174 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(173219), // Rule ID 1458 //
     /* 173179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 173187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173208 */     // (intrinsic_wo_chain:{ *:[v8i8] } 703:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 173211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173217 */     GIR_RootConstrainSelectedInstOperands,
     /* 173218 */     // GIR_Coverage, 1458,
     /* 173218 */     GIR_EraseRootFromParent_Done,
     /* 173219 */   // Label 3361: @173219
     /* 173219 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(173264), // Rule ID 1459 //
     /* 173224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 173232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173253 */     // (intrinsic_wo_chain:{ *:[v16i8] } 703:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 173256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173262 */     GIR_RootConstrainSelectedInstOperands,
     /* 173263 */     // GIR_Coverage, 1459,
     /* 173263 */     GIR_EraseRootFromParent_Done,
     /* 173264 */   // Label 3362: @173264
     /* 173264 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(173309), // Rule ID 1460 //
     /* 173269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 173277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173298 */     // (intrinsic_wo_chain:{ *:[v4i16] } 703:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 173301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173307 */     GIR_RootConstrainSelectedInstOperands,
     /* 173308 */     // GIR_Coverage, 1460,
     /* 173308 */     GIR_EraseRootFromParent_Done,
     /* 173309 */   // Label 3363: @173309
     /* 173309 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(173354), // Rule ID 1461 //
     /* 173314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 173322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173343 */     // (intrinsic_wo_chain:{ *:[v8i16] } 703:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 173346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173352 */     GIR_RootConstrainSelectedInstOperands,
     /* 173353 */     // GIR_Coverage, 1461,
     /* 173353 */     GIR_EraseRootFromParent_Done,
     /* 173354 */   // Label 3364: @173354
     /* 173354 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(173399), // Rule ID 1462 //
     /* 173359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 173367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173388 */     // (intrinsic_wo_chain:{ *:[v2i32] } 703:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 173391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173397 */     GIR_RootConstrainSelectedInstOperands,
     /* 173398 */     // GIR_Coverage, 1462,
     /* 173398 */     GIR_EraseRootFromParent_Done,
     /* 173399 */   // Label 3365: @173399
     /* 173399 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(173444), // Rule ID 1463 //
     /* 173404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 173412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173433 */     // (intrinsic_wo_chain:{ *:[v4i32] } 703:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 173436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173442 */     GIR_RootConstrainSelectedInstOperands,
     /* 173443 */     // GIR_Coverage, 1463,
     /* 173443 */     GIR_EraseRootFromParent_Done,
     /* 173444 */   // Label 3366: @173444
     /* 173444 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(173489), // Rule ID 1464 //
     /* 173449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 173457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173478 */     // (intrinsic_wo_chain:{ *:[v2i64] } 703:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 173481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173487 */     GIR_RootConstrainSelectedInstOperands,
     /* 173488 */     // GIR_Coverage, 1464,
     /* 173488 */     GIR_EraseRootFromParent_Done,
     /* 173489 */   // Label 3367: @173489
     /* 173489 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(173534), // Rule ID 1485 //
     /* 173494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 173502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173523 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 173526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173532 */     GIR_RootConstrainSelectedInstOperands,
     /* 173533 */     // GIR_Coverage, 1485,
     /* 173533 */     GIR_EraseRootFromParent_Done,
     /* 173534 */   // Label 3368: @173534
     /* 173534 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(173579), // Rule ID 1487 //
     /* 173539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 173547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173568 */     // (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 173571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173577 */     GIR_RootConstrainSelectedInstOperands,
     /* 173578 */     // GIR_Coverage, 1487,
     /* 173578 */     GIR_EraseRootFromParent_Done,
     /* 173579 */   // Label 3369: @173579
     /* 173579 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(173624), // Rule ID 1489 //
     /* 173584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 173592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173613 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 173616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173622 */     GIR_RootConstrainSelectedInstOperands,
     /* 173623 */     // GIR_Coverage, 1489,
     /* 173623 */     GIR_EraseRootFromParent_Done,
     /* 173624 */   // Label 3370: @173624
     /* 173624 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(173669), // Rule ID 1491 //
     /* 173629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 173637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173658 */     // (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 173661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173667 */     GIR_RootConstrainSelectedInstOperands,
     /* 173668 */     // GIR_Coverage, 1491,
     /* 173668 */     GIR_EraseRootFromParent_Done,
     /* 173669 */   // Label 3371: @173669
     /* 173669 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(173714), // Rule ID 1493 //
     /* 173674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 173682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173703 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 173706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173712 */     GIR_RootConstrainSelectedInstOperands,
     /* 173713 */     // GIR_Coverage, 1493,
     /* 173713 */     GIR_EraseRootFromParent_Done,
     /* 173714 */   // Label 3372: @173714
     /* 173714 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(173759), // Rule ID 1495 //
     /* 173719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 173727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173748 */     // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 173751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173757 */     GIR_RootConstrainSelectedInstOperands,
     /* 173758 */     // GIR_Coverage, 1495,
     /* 173758 */     GIR_EraseRootFromParent_Done,
     /* 173759 */   // Label 3373: @173759
     /* 173759 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(173804), // Rule ID 1502 //
     /* 173764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 173772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173793 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 173796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173802 */     GIR_RootConstrainSelectedInstOperands,
     /* 173803 */     // GIR_Coverage, 1502,
     /* 173803 */     GIR_EraseRootFromParent_Done,
     /* 173804 */   // Label 3374: @173804
     /* 173804 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(173849), // Rule ID 1503 //
     /* 173809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 173817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173838 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 173841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173847 */     GIR_RootConstrainSelectedInstOperands,
     /* 173848 */     // GIR_Coverage, 1503,
     /* 173848 */     GIR_EraseRootFromParent_Done,
     /* 173849 */   // Label 3375: @173849
     /* 173849 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(173894), // Rule ID 1504 //
     /* 173854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 173862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173883 */     // (intrinsic_wo_chain:{ *:[v4i16] } 730:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 173886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173892 */     GIR_RootConstrainSelectedInstOperands,
     /* 173893 */     // GIR_Coverage, 1504,
     /* 173893 */     GIR_EraseRootFromParent_Done,
     /* 173894 */   // Label 3376: @173894
     /* 173894 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(173939), // Rule ID 1505 //
     /* 173899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 173907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173928 */     // (intrinsic_wo_chain:{ *:[v8i16] } 730:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 173931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173937 */     GIR_RootConstrainSelectedInstOperands,
     /* 173938 */     // GIR_Coverage, 1505,
     /* 173938 */     GIR_EraseRootFromParent_Done,
     /* 173939 */   // Label 3377: @173939
     /* 173939 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(173984), // Rule ID 1506 //
     /* 173944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 173952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173973 */     // (intrinsic_wo_chain:{ *:[v2i32] } 730:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 173976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173982 */     GIR_RootConstrainSelectedInstOperands,
     /* 173983 */     // GIR_Coverage, 1506,
     /* 173983 */     GIR_EraseRootFromParent_Done,
     /* 173984 */   // Label 3378: @173984
     /* 173984 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(174029), // Rule ID 1507 //
     /* 173989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 173997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174018 */     // (intrinsic_wo_chain:{ *:[v4i32] } 730:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 174021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174027 */     GIR_RootConstrainSelectedInstOperands,
     /* 174028 */     // GIR_Coverage, 1507,
     /* 174028 */     GIR_EraseRootFromParent_Done,
     /* 174029 */   // Label 3379: @174029
     /* 174029 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(174074), // Rule ID 1508 //
     /* 174034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174063 */     // (intrinsic_wo_chain:{ *:[v8i8] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 174066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174072 */     GIR_RootConstrainSelectedInstOperands,
     /* 174073 */     // GIR_Coverage, 1508,
     /* 174073 */     GIR_EraseRootFromParent_Done,
     /* 174074 */   // Label 3380: @174074
     /* 174074 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(174119), // Rule ID 1509 //
     /* 174079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174108 */     // (intrinsic_wo_chain:{ *:[v16i8] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 174111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174117 */     GIR_RootConstrainSelectedInstOperands,
     /* 174118 */     // GIR_Coverage, 1509,
     /* 174118 */     GIR_EraseRootFromParent_Done,
     /* 174119 */   // Label 3381: @174119
     /* 174119 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(174164), // Rule ID 1510 //
     /* 174124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174153 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 174156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174162 */     GIR_RootConstrainSelectedInstOperands,
     /* 174163 */     // GIR_Coverage, 1510,
     /* 174163 */     GIR_EraseRootFromParent_Done,
     /* 174164 */   // Label 3382: @174164
     /* 174164 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(174209), // Rule ID 1511 //
     /* 174169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174198 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 174201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174207 */     GIR_RootConstrainSelectedInstOperands,
     /* 174208 */     // GIR_Coverage, 1511,
     /* 174208 */     GIR_EraseRootFromParent_Done,
     /* 174209 */   // Label 3383: @174209
     /* 174209 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(174254), // Rule ID 1512 //
     /* 174214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174243 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 174246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174252 */     GIR_RootConstrainSelectedInstOperands,
     /* 174253 */     // GIR_Coverage, 1512,
     /* 174253 */     GIR_EraseRootFromParent_Done,
     /* 174254 */   // Label 3384: @174254
     /* 174254 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(174299), // Rule ID 1513 //
     /* 174259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174288 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 174291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174297 */     GIR_RootConstrainSelectedInstOperands,
     /* 174298 */     // GIR_Coverage, 1513,
     /* 174298 */     GIR_EraseRootFromParent_Done,
     /* 174299 */   // Label 3385: @174299
     /* 174299 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(174344), // Rule ID 1520 //
     /* 174304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 174312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174333 */     // (intrinsic_wo_chain:{ *:[v8i8] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 174336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174342 */     GIR_RootConstrainSelectedInstOperands,
     /* 174343 */     // GIR_Coverage, 1520,
     /* 174343 */     GIR_EraseRootFromParent_Done,
     /* 174344 */   // Label 3386: @174344
     /* 174344 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(174389), // Rule ID 1521 //
     /* 174349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 174357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174378 */     // (intrinsic_wo_chain:{ *:[v16i8] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 174381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174387 */     GIR_RootConstrainSelectedInstOperands,
     /* 174388 */     // GIR_Coverage, 1521,
     /* 174388 */     GIR_EraseRootFromParent_Done,
     /* 174389 */   // Label 3387: @174389
     /* 174389 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(174434), // Rule ID 1522 //
     /* 174394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 174402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174423 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 174426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174432 */     GIR_RootConstrainSelectedInstOperands,
     /* 174433 */     // GIR_Coverage, 1522,
     /* 174433 */     GIR_EraseRootFromParent_Done,
     /* 174434 */   // Label 3388: @174434
     /* 174434 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(174479), // Rule ID 1523 //
     /* 174439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 174447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174468 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 174471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174477 */     GIR_RootConstrainSelectedInstOperands,
     /* 174478 */     // GIR_Coverage, 1523,
     /* 174478 */     GIR_EraseRootFromParent_Done,
     /* 174479 */   // Label 3389: @174479
     /* 174479 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(174524), // Rule ID 1524 //
     /* 174484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 174492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174513 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 174516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174522 */     GIR_RootConstrainSelectedInstOperands,
     /* 174523 */     // GIR_Coverage, 1524,
     /* 174523 */     GIR_EraseRootFromParent_Done,
     /* 174524 */   // Label 3390: @174524
     /* 174524 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(174569), // Rule ID 1525 //
     /* 174529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 174537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174558 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 174561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174567 */     GIR_RootConstrainSelectedInstOperands,
     /* 174568 */     // GIR_Coverage, 1525,
     /* 174568 */     GIR_EraseRootFromParent_Done,
     /* 174569 */   // Label 3391: @174569
     /* 174569 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(174614), // Rule ID 1532 //
     /* 174574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 174582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174603 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 174606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174612 */     GIR_RootConstrainSelectedInstOperands,
     /* 174613 */     // GIR_Coverage, 1532,
     /* 174613 */     GIR_EraseRootFromParent_Done,
     /* 174614 */   // Label 3392: @174614
     /* 174614 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(174659), // Rule ID 1533 //
     /* 174619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 174627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174648 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 174651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174657 */     GIR_RootConstrainSelectedInstOperands,
     /* 174658 */     // GIR_Coverage, 1533,
     /* 174658 */     GIR_EraseRootFromParent_Done,
     /* 174659 */   // Label 3393: @174659
     /* 174659 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(174704), // Rule ID 1534 //
     /* 174664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 174672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174693 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 174696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174702 */     GIR_RootConstrainSelectedInstOperands,
     /* 174703 */     // GIR_Coverage, 1534,
     /* 174703 */     GIR_EraseRootFromParent_Done,
     /* 174704 */   // Label 3394: @174704
     /* 174704 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(174749), // Rule ID 1535 //
     /* 174709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 174717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174738 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 174741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174747 */     GIR_RootConstrainSelectedInstOperands,
     /* 174748 */     // GIR_Coverage, 1535,
     /* 174748 */     GIR_EraseRootFromParent_Done,
     /* 174749 */   // Label 3395: @174749
     /* 174749 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(174794), // Rule ID 1536 //
     /* 174754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 174762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174783 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 174786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174792 */     GIR_RootConstrainSelectedInstOperands,
     /* 174793 */     // GIR_Coverage, 1536,
     /* 174793 */     GIR_EraseRootFromParent_Done,
     /* 174794 */   // Label 3396: @174794
     /* 174794 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(174839), // Rule ID 1537 //
     /* 174799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 174807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174828 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 174831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174837 */     GIR_RootConstrainSelectedInstOperands,
     /* 174838 */     // GIR_Coverage, 1537,
     /* 174838 */     GIR_EraseRootFromParent_Done,
     /* 174839 */   // Label 3397: @174839
     /* 174839 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(174884), // Rule ID 1538 //
     /* 174844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 174852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174873 */     // (intrinsic_wo_chain:{ *:[v2i64] } 739:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 174873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 174876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174882 */     GIR_RootConstrainSelectedInstOperands,
     /* 174883 */     // GIR_Coverage, 1538,
     /* 174883 */     GIR_EraseRootFromParent_Done,
     /* 174884 */   // Label 3398: @174884
     /* 174884 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(174929), // Rule ID 1539 //
     /* 174889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 174897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174918 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 174921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174927 */     GIR_RootConstrainSelectedInstOperands,
     /* 174928 */     // GIR_Coverage, 1539,
     /* 174928 */     GIR_EraseRootFromParent_Done,
     /* 174929 */   // Label 3399: @174929
     /* 174929 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(174974), // Rule ID 1540 //
     /* 174934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 174942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174963 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 174966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174972 */     GIR_RootConstrainSelectedInstOperands,
     /* 174973 */     // GIR_Coverage, 1540,
     /* 174973 */     GIR_EraseRootFromParent_Done,
     /* 174974 */   // Label 3400: @174974
     /* 174974 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(175019), // Rule ID 1541 //
     /* 174979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 174987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175008 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 175011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175017 */     GIR_RootConstrainSelectedInstOperands,
     /* 175018 */     // GIR_Coverage, 1541,
     /* 175018 */     GIR_EraseRootFromParent_Done,
     /* 175019 */   // Label 3401: @175019
     /* 175019 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(175064), // Rule ID 1542 //
     /* 175024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175053 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 175056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175062 */     GIR_RootConstrainSelectedInstOperands,
     /* 175063 */     // GIR_Coverage, 1542,
     /* 175063 */     GIR_EraseRootFromParent_Done,
     /* 175064 */   // Label 3402: @175064
     /* 175064 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(175109), // Rule ID 1543 //
     /* 175069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175098 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 175101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175107 */     GIR_RootConstrainSelectedInstOperands,
     /* 175108 */     // GIR_Coverage, 1543,
     /* 175108 */     GIR_EraseRootFromParent_Done,
     /* 175109 */   // Label 3403: @175109
     /* 175109 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(175154), // Rule ID 1544 //
     /* 175114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175143 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 175146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175152 */     GIR_RootConstrainSelectedInstOperands,
     /* 175153 */     // GIR_Coverage, 1544,
     /* 175153 */     GIR_EraseRootFromParent_Done,
     /* 175154 */   // Label 3404: @175154
     /* 175154 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(175199), // Rule ID 1545 //
     /* 175159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175188 */     // (intrinsic_wo_chain:{ *:[v2i64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 175191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175197 */     GIR_RootConstrainSelectedInstOperands,
     /* 175198 */     // GIR_Coverage, 1545,
     /* 175198 */     GIR_EraseRootFromParent_Done,
     /* 175199 */   // Label 3405: @175199
     /* 175199 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(175244), // Rule ID 1546 //
     /* 175204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 175212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175233 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 175236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175242 */     GIR_RootConstrainSelectedInstOperands,
     /* 175243 */     // GIR_Coverage, 1546,
     /* 175243 */     GIR_EraseRootFromParent_Done,
     /* 175244 */   // Label 3406: @175244
     /* 175244 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(175289), // Rule ID 1547 //
     /* 175249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 175257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175278 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 175281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175287 */     GIR_RootConstrainSelectedInstOperands,
     /* 175288 */     // GIR_Coverage, 1547,
     /* 175288 */     GIR_EraseRootFromParent_Done,
     /* 175289 */   // Label 3407: @175289
     /* 175289 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(175334), // Rule ID 1548 //
     /* 175294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 175302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175323 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 175326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175332 */     GIR_RootConstrainSelectedInstOperands,
     /* 175333 */     // GIR_Coverage, 1548,
     /* 175333 */     GIR_EraseRootFromParent_Done,
     /* 175334 */   // Label 3408: @175334
     /* 175334 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(175379), // Rule ID 1549 //
     /* 175339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 175347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175368 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 175371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175377 */     GIR_RootConstrainSelectedInstOperands,
     /* 175378 */     // GIR_Coverage, 1549,
     /* 175378 */     GIR_EraseRootFromParent_Done,
     /* 175379 */   // Label 3409: @175379
     /* 175379 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(175424), // Rule ID 1550 //
     /* 175384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 175392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175413 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 175416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175422 */     GIR_RootConstrainSelectedInstOperands,
     /* 175423 */     // GIR_Coverage, 1550,
     /* 175423 */     GIR_EraseRootFromParent_Done,
     /* 175424 */   // Label 3410: @175424
     /* 175424 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(175469), // Rule ID 1551 //
     /* 175429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 175437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175458 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 175461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175467 */     GIR_RootConstrainSelectedInstOperands,
     /* 175468 */     // GIR_Coverage, 1551,
     /* 175468 */     GIR_EraseRootFromParent_Done,
     /* 175469 */   // Label 3411: @175469
     /* 175469 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(175514), // Rule ID 1552 //
     /* 175474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 175482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175503 */     // (intrinsic_wo_chain:{ *:[v2i64] } 742:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 175506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175512 */     GIR_RootConstrainSelectedInstOperands,
     /* 175513 */     // GIR_Coverage, 1552,
     /* 175513 */     GIR_EraseRootFromParent_Done,
     /* 175514 */   // Label 3412: @175514
     /* 175514 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(175559), // Rule ID 1553 //
     /* 175519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 175527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175548 */     // (intrinsic_wo_chain:{ *:[v8i8] } 744:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 175551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175557 */     GIR_RootConstrainSelectedInstOperands,
     /* 175558 */     // GIR_Coverage, 1553,
     /* 175558 */     GIR_EraseRootFromParent_Done,
     /* 175559 */   // Label 3413: @175559
     /* 175559 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(175604), // Rule ID 1554 //
     /* 175564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 175572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175593 */     // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 175596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175602 */     GIR_RootConstrainSelectedInstOperands,
     /* 175603 */     // GIR_Coverage, 1554,
     /* 175603 */     GIR_EraseRootFromParent_Done,
     /* 175604 */   // Label 3414: @175604
     /* 175604 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(175649), // Rule ID 1555 //
     /* 175609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 175617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175638 */     // (intrinsic_wo_chain:{ *:[v4i16] } 744:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 175641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175647 */     GIR_RootConstrainSelectedInstOperands,
     /* 175648 */     // GIR_Coverage, 1555,
     /* 175648 */     GIR_EraseRootFromParent_Done,
     /* 175649 */   // Label 3415: @175649
     /* 175649 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(175694), // Rule ID 1556 //
     /* 175654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 175662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175683 */     // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 175686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175692 */     GIR_RootConstrainSelectedInstOperands,
     /* 175693 */     // GIR_Coverage, 1556,
     /* 175693 */     GIR_EraseRootFromParent_Done,
     /* 175694 */   // Label 3416: @175694
     /* 175694 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(175739), // Rule ID 1557 //
     /* 175699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 175707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175728 */     // (intrinsic_wo_chain:{ *:[v2i32] } 744:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 175731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175737 */     GIR_RootConstrainSelectedInstOperands,
     /* 175738 */     // GIR_Coverage, 1557,
     /* 175738 */     GIR_EraseRootFromParent_Done,
     /* 175739 */   // Label 3417: @175739
     /* 175739 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(175784), // Rule ID 1558 //
     /* 175744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 175752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175773 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 175776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175782 */     GIR_RootConstrainSelectedInstOperands,
     /* 175783 */     // GIR_Coverage, 1558,
     /* 175783 */     GIR_EraseRootFromParent_Done,
     /* 175784 */   // Label 3418: @175784
     /* 175784 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(175829), // Rule ID 1559 //
     /* 175789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 175797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175818 */     // (intrinsic_wo_chain:{ *:[v2i64] } 744:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 175821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175827 */     GIR_RootConstrainSelectedInstOperands,
     /* 175828 */     // GIR_Coverage, 1559,
     /* 175828 */     GIR_EraseRootFromParent_Done,
     /* 175829 */   // Label 3419: @175829
     /* 175829 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(175874), // Rule ID 1566 //
     /* 175834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 175842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175863 */     // (intrinsic_wo_chain:{ *:[v8i8] } 748:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 175866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175872 */     GIR_RootConstrainSelectedInstOperands,
     /* 175873 */     // GIR_Coverage, 1566,
     /* 175873 */     GIR_EraseRootFromParent_Done,
     /* 175874 */   // Label 3420: @175874
     /* 175874 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(175919), // Rule ID 1567 //
     /* 175879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 175887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175908 */     // (intrinsic_wo_chain:{ *:[v16i8] } 748:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 175911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175917 */     GIR_RootConstrainSelectedInstOperands,
     /* 175918 */     // GIR_Coverage, 1567,
     /* 175918 */     GIR_EraseRootFromParent_Done,
     /* 175919 */   // Label 3421: @175919
     /* 175919 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(175964), // Rule ID 1568 //
     /* 175924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 175932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175953 */     // (intrinsic_wo_chain:{ *:[v4i16] } 748:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 175956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175962 */     GIR_RootConstrainSelectedInstOperands,
     /* 175963 */     // GIR_Coverage, 1568,
     /* 175963 */     GIR_EraseRootFromParent_Done,
     /* 175964 */   // Label 3422: @175964
     /* 175964 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(176009), // Rule ID 1569 //
     /* 175969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 175977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175998 */     // (intrinsic_wo_chain:{ *:[v8i16] } 748:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 176001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176007 */     GIR_RootConstrainSelectedInstOperands,
     /* 176008 */     // GIR_Coverage, 1569,
     /* 176008 */     GIR_EraseRootFromParent_Done,
     /* 176009 */   // Label 3423: @176009
     /* 176009 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(176054), // Rule ID 1570 //
     /* 176014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176043 */     // (intrinsic_wo_chain:{ *:[v2i32] } 748:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 176046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176052 */     GIR_RootConstrainSelectedInstOperands,
     /* 176053 */     // GIR_Coverage, 1570,
     /* 176053 */     GIR_EraseRootFromParent_Done,
     /* 176054 */   // Label 3424: @176054
     /* 176054 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(176099), // Rule ID 1571 //
     /* 176059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176088 */     // (intrinsic_wo_chain:{ *:[v4i32] } 748:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 176091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176097 */     GIR_RootConstrainSelectedInstOperands,
     /* 176098 */     // GIR_Coverage, 1571,
     /* 176098 */     GIR_EraseRootFromParent_Done,
     /* 176099 */   // Label 3425: @176099
     /* 176099 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(176144), // Rule ID 1572 //
     /* 176104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176133 */     // (intrinsic_wo_chain:{ *:[v2i64] } 748:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 176136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176142 */     GIR_RootConstrainSelectedInstOperands,
     /* 176143 */     // GIR_Coverage, 1572,
     /* 176143 */     GIR_EraseRootFromParent_Done,
     /* 176144 */   // Label 3426: @176144
     /* 176144 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(176189), // Rule ID 1573 //
     /* 176149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176178 */     // (intrinsic_wo_chain:{ *:[v8i8] } 751:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 176181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176187 */     GIR_RootConstrainSelectedInstOperands,
     /* 176188 */     // GIR_Coverage, 1573,
     /* 176188 */     GIR_EraseRootFromParent_Done,
     /* 176189 */   // Label 3427: @176189
     /* 176189 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(176234), // Rule ID 1574 //
     /* 176194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176223 */     // (intrinsic_wo_chain:{ *:[v16i8] } 751:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 176226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176232 */     GIR_RootConstrainSelectedInstOperands,
     /* 176233 */     // GIR_Coverage, 1574,
     /* 176233 */     GIR_EraseRootFromParent_Done,
     /* 176234 */   // Label 3428: @176234
     /* 176234 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(176279), // Rule ID 1575 //
     /* 176239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176268 */     // (intrinsic_wo_chain:{ *:[v4i16] } 751:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 176271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176277 */     GIR_RootConstrainSelectedInstOperands,
     /* 176278 */     // GIR_Coverage, 1575,
     /* 176278 */     GIR_EraseRootFromParent_Done,
     /* 176279 */   // Label 3429: @176279
     /* 176279 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(176324), // Rule ID 1576 //
     /* 176284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176313 */     // (intrinsic_wo_chain:{ *:[v8i16] } 751:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 176316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176322 */     GIR_RootConstrainSelectedInstOperands,
     /* 176323 */     // GIR_Coverage, 1576,
     /* 176323 */     GIR_EraseRootFromParent_Done,
     /* 176324 */   // Label 3430: @176324
     /* 176324 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(176369), // Rule ID 1577 //
     /* 176329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176358 */     // (intrinsic_wo_chain:{ *:[v2i32] } 751:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 176361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176367 */     GIR_RootConstrainSelectedInstOperands,
     /* 176368 */     // GIR_Coverage, 1577,
     /* 176368 */     GIR_EraseRootFromParent_Done,
     /* 176369 */   // Label 3431: @176369
     /* 176369 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(176414), // Rule ID 1578 //
     /* 176374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176403 */     // (intrinsic_wo_chain:{ *:[v4i32] } 751:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 176406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176412 */     GIR_RootConstrainSelectedInstOperands,
     /* 176413 */     // GIR_Coverage, 1578,
     /* 176413 */     GIR_EraseRootFromParent_Done,
     /* 176414 */   // Label 3432: @176414
     /* 176414 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(176459), // Rule ID 1579 //
     /* 176419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176448 */     // (intrinsic_wo_chain:{ *:[v2i64] } 751:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 176451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176457 */     GIR_RootConstrainSelectedInstOperands,
     /* 176458 */     // GIR_Coverage, 1579,
     /* 176458 */     GIR_EraseRootFromParent_Done,
     /* 176459 */   // Label 3433: @176459
     /* 176459 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(176504), // Rule ID 1607 //
     /* 176464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 176472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176493 */     // (intrinsic_wo_chain:{ *:[f64] } 785:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 176493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 176496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176502 */     GIR_RootConstrainSelectedInstOperands,
     /* 176503 */     // GIR_Coverage, 1607,
     /* 176503 */     GIR_EraseRootFromParent_Done,
     /* 176504 */   // Label 3434: @176504
     /* 176504 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(176549), // Rule ID 1608 //
     /* 176509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 176517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176538 */     // (intrinsic_wo_chain:{ *:[f32] } 785:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 176538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 176541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176547 */     GIR_RootConstrainSelectedInstOperands,
     /* 176548 */     // GIR_Coverage, 1608,
     /* 176548 */     GIR_EraseRootFromParent_Done,
     /* 176549 */   // Label 3435: @176549
     /* 176549 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(176594), // Rule ID 1609 //
     /* 176554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 176557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 176562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 176565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 176568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 176571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176583 */     // (intrinsic_wo_chain:{ *:[f16] } 785:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 176583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 176586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176592 */     GIR_RootConstrainSelectedInstOperands,
     /* 176593 */     // GIR_Coverage, 1609,
     /* 176593 */     GIR_EraseRootFromParent_Done,
     /* 176594 */   // Label 3436: @176594
     /* 176594 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(176639), // Rule ID 1610 //
     /* 176599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 176607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176628 */     // (intrinsic_wo_chain:{ *:[i64] } 577:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 176628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 176631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176637 */     GIR_RootConstrainSelectedInstOperands,
     /* 176638 */     // GIR_Coverage, 1610,
     /* 176638 */     GIR_EraseRootFromParent_Done,
     /* 176639 */   // Label 3437: @176639
     /* 176639 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(176684), // Rule ID 1611 //
     /* 176644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 176652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176673 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 176673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 176676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176682 */     GIR_RootConstrainSelectedInstOperands,
     /* 176683 */     // GIR_Coverage, 1611,
     /* 176683 */     GIR_EraseRootFromParent_Done,
     /* 176684 */   // Label 3438: @176684
     /* 176684 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(176729), // Rule ID 1612 //
     /* 176689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 176697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176718 */     // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 176718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 176721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176727 */     GIR_RootConstrainSelectedInstOperands,
     /* 176728 */     // GIR_Coverage, 1612,
     /* 176728 */     GIR_EraseRootFromParent_Done,
     /* 176729 */   // Label 3439: @176729
     /* 176729 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(176774), // Rule ID 1613 //
     /* 176734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 176742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176763 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 176763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 176766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176772 */     GIR_RootConstrainSelectedInstOperands,
     /* 176773 */     // GIR_Coverage, 1613,
     /* 176773 */     GIR_EraseRootFromParent_Done,
     /* 176774 */   // Label 3440: @176774
     /* 176774 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(176819), // Rule ID 1620 //
     /* 176779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 176782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176808 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 176808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 176811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176817 */     GIR_RootConstrainSelectedInstOperands,
     /* 176818 */     // GIR_Coverage, 1620,
     /* 176818 */     GIR_EraseRootFromParent_Done,
     /* 176819 */   // Label 3441: @176819
     /* 176819 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(176864), // Rule ID 1621 //
     /* 176824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 176827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176853 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 176853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 176856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176862 */     GIR_RootConstrainSelectedInstOperands,
     /* 176863 */     // GIR_Coverage, 1621,
     /* 176863 */     GIR_EraseRootFromParent_Done,
     /* 176864 */   // Label 3442: @176864
     /* 176864 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(176909), // Rule ID 1622 //
     /* 176869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 176872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 176880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 176883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 176886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 176898 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 176898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 176901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176907 */     GIR_RootConstrainSelectedInstOperands,
     /* 176908 */     // GIR_Coverage, 1622,
     /* 176908 */     GIR_EraseRootFromParent_Done,
     /* 176909 */   // Label 3443: @176909
     /* 176909 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(176954), // Rule ID 1623 //
     /* 176914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 176917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 176922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176943 */     // (intrinsic_wo_chain:{ *:[f64] } 633:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 176943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 176946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176952 */     GIR_RootConstrainSelectedInstOperands,
     /* 176953 */     // GIR_Coverage, 1623,
     /* 176953 */     GIR_EraseRootFromParent_Done,
     /* 176954 */   // Label 3444: @176954
     /* 176954 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(176999), // Rule ID 1624 //
     /* 176959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 176962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 176967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 176970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 176973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 176976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176988 */     // (intrinsic_wo_chain:{ *:[f32] } 633:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 176988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 176991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176997 */     GIR_RootConstrainSelectedInstOperands,
     /* 176998 */     // GIR_Coverage, 1624,
     /* 176998 */     GIR_EraseRootFromParent_Done,
     /* 176999 */   // Label 3445: @176999
     /* 176999 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(177044), // Rule ID 1625 //
     /* 177004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 177012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177033 */     // (intrinsic_wo_chain:{ *:[f16] } 633:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 177036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177042 */     GIR_RootConstrainSelectedInstOperands,
     /* 177043 */     // GIR_Coverage, 1625,
     /* 177043 */     GIR_EraseRootFromParent_Done,
     /* 177044 */   // Label 3446: @177044
     /* 177044 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(177089), // Rule ID 1626 //
     /* 177049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 177057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177078 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 177081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177087 */     GIR_RootConstrainSelectedInstOperands,
     /* 177088 */     // GIR_Coverage, 1626,
     /* 177088 */     GIR_EraseRootFromParent_Done,
     /* 177089 */   // Label 3447: @177089
     /* 177089 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(177134), // Rule ID 1627 //
     /* 177094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 177102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177123 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 177126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177132 */     GIR_RootConstrainSelectedInstOperands,
     /* 177133 */     // GIR_Coverage, 1627,
     /* 177133 */     GIR_EraseRootFromParent_Done,
     /* 177134 */   // Label 3448: @177134
     /* 177134 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(177179), // Rule ID 1628 //
     /* 177139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 177147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177168 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 177171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177177 */     GIR_RootConstrainSelectedInstOperands,
     /* 177178 */     // GIR_Coverage, 1628,
     /* 177178 */     GIR_EraseRootFromParent_Done,
     /* 177179 */   // Label 3449: @177179
     /* 177179 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(177224), // Rule ID 1629 //
     /* 177184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 177192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177213 */     // (intrinsic_wo_chain:{ *:[v1i64] } 679:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 177216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177222 */     GIR_RootConstrainSelectedInstOperands,
     /* 177223 */     // GIR_Coverage, 1629,
     /* 177223 */     GIR_EraseRootFromParent_Done,
     /* 177224 */   // Label 3450: @177224
     /* 177224 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(177269), // Rule ID 1630 //
     /* 177229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 177237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177258 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 177258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 177261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177267 */     GIR_RootConstrainSelectedInstOperands,
     /* 177268 */     // GIR_Coverage, 1630,
     /* 177268 */     GIR_EraseRootFromParent_Done,
     /* 177269 */   // Label 3451: @177269
     /* 177269 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(177314), // Rule ID 1631 //
     /* 177274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 177282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177303 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 177303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 177306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177312 */     GIR_RootConstrainSelectedInstOperands,
     /* 177313 */     // GIR_Coverage, 1631,
     /* 177313 */     GIR_EraseRootFromParent_Done,
     /* 177314 */   // Label 3452: @177314
     /* 177314 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(177359), // Rule ID 1632 //
     /* 177319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 177327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177348 */     // (intrinsic_wo_chain:{ *:[v1i64] } 691:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 177351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177357 */     GIR_RootConstrainSelectedInstOperands,
     /* 177358 */     // GIR_Coverage, 1632,
     /* 177358 */     GIR_EraseRootFromParent_Done,
     /* 177359 */   // Label 3453: @177359
     /* 177359 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(177404), // Rule ID 1633 //
     /* 177364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 177372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177393 */     // (intrinsic_wo_chain:{ *:[v1i64] } 694:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 177396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177402 */     GIR_RootConstrainSelectedInstOperands,
     /* 177403 */     // GIR_Coverage, 1633,
     /* 177403 */     GIR_EraseRootFromParent_Done,
     /* 177404 */   // Label 3454: @177404
     /* 177404 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(177449), // Rule ID 1634 //
     /* 177409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 177417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177438 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 177441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177447 */     GIR_RootConstrainSelectedInstOperands,
     /* 177448 */     // GIR_Coverage, 1634,
     /* 177448 */     GIR_EraseRootFromParent_Done,
     /* 177449 */   // Label 3455: @177449
     /* 177449 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(177494), // Rule ID 1635 //
     /* 177454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 177462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177483 */     // (intrinsic_wo_chain:{ *:[v1i64] } 702:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 177486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177492 */     GIR_RootConstrainSelectedInstOperands,
     /* 177493 */     // GIR_Coverage, 1635,
     /* 177493 */     GIR_EraseRootFromParent_Done,
     /* 177494 */   // Label 3456: @177494
     /* 177494 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(177539), // Rule ID 1636 //
     /* 177499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 177507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177528 */     // (intrinsic_wo_chain:{ *:[v1i64] } 703:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 177531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177537 */     GIR_RootConstrainSelectedInstOperands,
     /* 177538 */     // GIR_Coverage, 1636,
     /* 177538 */     GIR_EraseRootFromParent_Done,
     /* 177539 */   // Label 3457: @177539
     /* 177539 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(177584), // Rule ID 1638 //
     /* 177544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 177552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177573 */     // (intrinsic_wo_chain:{ *:[v1i64] } 739:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 177576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177582 */     GIR_RootConstrainSelectedInstOperands,
     /* 177583 */     // GIR_Coverage, 1638,
     /* 177583 */     GIR_EraseRootFromParent_Done,
     /* 177584 */   // Label 3458: @177584
     /* 177584 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(177629), // Rule ID 1639 //
     /* 177589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 177597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177618 */     // (intrinsic_wo_chain:{ *:[v1i64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 177621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177627 */     GIR_RootConstrainSelectedInstOperands,
     /* 177628 */     // GIR_Coverage, 1639,
     /* 177628 */     GIR_EraseRootFromParent_Done,
     /* 177629 */   // Label 3459: @177629
     /* 177629 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(177674), // Rule ID 1640 //
     /* 177634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 177642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177663 */     // (intrinsic_wo_chain:{ *:[v1i64] } 742:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 177666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177672 */     GIR_RootConstrainSelectedInstOperands,
     /* 177673 */     // GIR_Coverage, 1640,
     /* 177673 */     GIR_EraseRootFromParent_Done,
     /* 177674 */   // Label 3460: @177674
     /* 177674 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(177719), // Rule ID 1641 //
     /* 177679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 177687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177708 */     // (intrinsic_wo_chain:{ *:[v1i64] } 744:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 177711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177717 */     GIR_RootConstrainSelectedInstOperands,
     /* 177718 */     // GIR_Coverage, 1641,
     /* 177718 */     GIR_EraseRootFromParent_Done,
     /* 177719 */   // Label 3461: @177719
     /* 177719 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(177764), // Rule ID 1642 //
     /* 177724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177753 */     // (intrinsic_wo_chain:{ *:[v1i64] } 748:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 177756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177762 */     GIR_RootConstrainSelectedInstOperands,
     /* 177763 */     // GIR_Coverage, 1642,
     /* 177763 */     GIR_EraseRootFromParent_Done,
     /* 177764 */   // Label 3462: @177764
     /* 177764 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(177809), // Rule ID 1643 //
     /* 177769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177798 */     // (intrinsic_wo_chain:{ *:[v1i64] } 751:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 177801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177807 */     GIR_RootConstrainSelectedInstOperands,
     /* 177808 */     // GIR_Coverage, 1643,
     /* 177808 */     GIR_EraseRootFromParent_Done,
     /* 177809 */   // Label 3463: @177809
     /* 177809 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(177854), // Rule ID 1644 //
     /* 177814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 177822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177843 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 177843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 177846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177852 */     GIR_RootConstrainSelectedInstOperands,
     /* 177853 */     // GIR_Coverage, 1644,
     /* 177853 */     GIR_EraseRootFromParent_Done,
     /* 177854 */   // Label 3464: @177854
     /* 177854 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(177899), // Rule ID 1658 //
     /* 177859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 177867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177888 */     // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 177888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 177891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 177895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177897 */     GIR_RootConstrainSelectedInstOperands,
     /* 177898 */     // GIR_Coverage, 1658,
     /* 177898 */     GIR_EraseRootFromParent_Done,
     /* 177899 */   // Label 3465: @177899
     /* 177899 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(177944), // Rule ID 1659 //
     /* 177904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 177912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177933 */     // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 177933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 177936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 177940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177942 */     GIR_RootConstrainSelectedInstOperands,
     /* 177943 */     // GIR_Coverage, 1659,
     /* 177943 */     GIR_EraseRootFromParent_Done,
     /* 177944 */   // Label 3466: @177944
     /* 177944 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(177989), // Rule ID 1664 //
     /* 177949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 177957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177978 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 177978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 177981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 177985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177987 */     GIR_RootConstrainSelectedInstOperands,
     /* 177988 */     // GIR_Coverage, 1664,
     /* 177988 */     GIR_EraseRootFromParent_Done,
     /* 177989 */   // Label 3467: @177989
     /* 177989 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(178034), // Rule ID 1665 //
     /* 177994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 178002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178023 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 178023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 178026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178032 */     GIR_RootConstrainSelectedInstOperands,
     /* 178033 */     // GIR_Coverage, 1665,
     /* 178033 */     GIR_EraseRootFromParent_Done,
     /* 178034 */   // Label 3468: @178034
     /* 178034 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(178079), // Rule ID 1666 //
     /* 178039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 178047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178068 */     // (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 178071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178077 */     GIR_RootConstrainSelectedInstOperands,
     /* 178078 */     // GIR_Coverage, 1666,
     /* 178078 */     GIR_EraseRootFromParent_Done,
     /* 178079 */   // Label 3469: @178079
     /* 178079 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(178124), // Rule ID 1667 //
     /* 178084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 178092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178113 */     // (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 178116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178122 */     GIR_RootConstrainSelectedInstOperands,
     /* 178123 */     // GIR_Coverage, 1667,
     /* 178123 */     GIR_EraseRootFromParent_Done,
     /* 178124 */   // Label 3470: @178124
     /* 178124 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(178169), // Rule ID 1668 //
     /* 178129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 178137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178158 */     // (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 178158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 178161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178167 */     GIR_RootConstrainSelectedInstOperands,
     /* 178168 */     // GIR_Coverage, 1668,
     /* 178168 */     GIR_EraseRootFromParent_Done,
     /* 178169 */   // Label 3471: @178169
     /* 178169 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(178214), // Rule ID 1669 //
     /* 178174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 178182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178203 */     // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 178206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178212 */     GIR_RootConstrainSelectedInstOperands,
     /* 178213 */     // GIR_Coverage, 1669,
     /* 178213 */     GIR_EraseRootFromParent_Done,
     /* 178214 */   // Label 3472: @178214
     /* 178214 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(178259), // Rule ID 1670 //
     /* 178219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 178227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178248 */     // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 178251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178257 */     GIR_RootConstrainSelectedInstOperands,
     /* 178258 */     // GIR_Coverage, 1670,
     /* 178258 */     GIR_EraseRootFromParent_Done,
     /* 178259 */   // Label 3473: @178259
     /* 178259 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(178304), // Rule ID 1671 //
     /* 178264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 178272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178293 */     // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 178293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 178296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178302 */     GIR_RootConstrainSelectedInstOperands,
     /* 178303 */     // GIR_Coverage, 1671,
     /* 178303 */     GIR_EraseRootFromParent_Done,
     /* 178304 */   // Label 3474: @178304
     /* 178304 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(178349), // Rule ID 1672 //
     /* 178309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 178317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178338 */     // (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 178341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178347 */     GIR_RootConstrainSelectedInstOperands,
     /* 178348 */     // GIR_Coverage, 1672,
     /* 178348 */     GIR_EraseRootFromParent_Done,
     /* 178349 */   // Label 3475: @178349
     /* 178349 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(178394), // Rule ID 1673 //
     /* 178354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 178362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178383 */     // (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 178386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178392 */     GIR_RootConstrainSelectedInstOperands,
     /* 178393 */     // GIR_Coverage, 1673,
     /* 178393 */     GIR_EraseRootFromParent_Done,
     /* 178394 */   // Label 3476: @178394
     /* 178394 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(178439), // Rule ID 1674 //
     /* 178399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 178407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178428 */     // (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 178428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 178431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178437 */     GIR_RootConstrainSelectedInstOperands,
     /* 178438 */     // GIR_Coverage, 1674,
     /* 178438 */     GIR_EraseRootFromParent_Done,
     /* 178439 */   // Label 3477: @178439
     /* 178439 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(178484), // Rule ID 1675 //
     /* 178444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 178452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178473 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 178476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178482 */     GIR_RootConstrainSelectedInstOperands,
     /* 178483 */     // GIR_Coverage, 1675,
     /* 178483 */     GIR_EraseRootFromParent_Done,
     /* 178484 */   // Label 3478: @178484
     /* 178484 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(178529), // Rule ID 1676 //
     /* 178489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 178497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178518 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 178521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178527 */     GIR_RootConstrainSelectedInstOperands,
     /* 178528 */     // GIR_Coverage, 1676,
     /* 178528 */     GIR_EraseRootFromParent_Done,
     /* 178529 */   // Label 3479: @178529
     /* 178529 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(178574), // Rule ID 1677 //
     /* 178534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 178542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178563 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 178563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 178566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178572 */     GIR_RootConstrainSelectedInstOperands,
     /* 178573 */     // GIR_Coverage, 1677,
     /* 178573 */     GIR_EraseRootFromParent_Done,
     /* 178574 */   // Label 3480: @178574
     /* 178574 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(178619), // Rule ID 1743 //
     /* 178579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 178587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178608 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 178608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 178611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178617 */     GIR_RootConstrainSelectedInstOperands,
     /* 178618 */     // GIR_Coverage, 1743,
     /* 178618 */     GIR_EraseRootFromParent_Done,
     /* 178619 */   // Label 3481: @178619
     /* 178619 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(178664), // Rule ID 1745 //
     /* 178624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 178632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178653 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 178653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 178656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178662 */     GIR_RootConstrainSelectedInstOperands,
     /* 178663 */     // GIR_Coverage, 1745,
     /* 178663 */     GIR_EraseRootFromParent_Done,
     /* 178664 */   // Label 3482: @178664
     /* 178664 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(178709), // Rule ID 2294 //
     /* 178669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 178672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 178677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 178680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 178683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 178686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178698 */     // (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 178698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 178701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178707 */     GIR_RootConstrainSelectedInstOperands,
     /* 178708 */     // GIR_Coverage, 2294,
     /* 178708 */     GIR_EraseRootFromParent_Done,
     /* 178709 */   // Label 3483: @178709
     /* 178709 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(178754), // Rule ID 2295 //
     /* 178714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 178717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 178722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 178725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 178728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 178731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178743 */     // (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 178743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 178746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178752 */     GIR_RootConstrainSelectedInstOperands,
     /* 178753 */     // GIR_Coverage, 2295,
     /* 178753 */     GIR_EraseRootFromParent_Done,
     /* 178754 */   // Label 3484: @178754
     /* 178754 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(178799), // Rule ID 2306 //
     /* 178759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 178762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 178767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178788 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 178788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 178791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178797 */     GIR_RootConstrainSelectedInstOperands,
     /* 178798 */     // GIR_Coverage, 2306,
     /* 178798 */     GIR_EraseRootFromParent_Done,
     /* 178799 */   // Label 3485: @178799
     /* 178799 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(178844), // Rule ID 2307 //
     /* 178804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 178807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 178812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178833 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 178833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 178836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178842 */     GIR_RootConstrainSelectedInstOperands,
     /* 178843 */     // GIR_Coverage, 2307,
     /* 178843 */     GIR_EraseRootFromParent_Done,
     /* 178844 */   // Label 3486: @178844
     /* 178844 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(178889), // Rule ID 2330 //
     /* 178849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 178852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 178857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178878 */     // (intrinsic_wo_chain:{ *:[v4f16] } 631:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 178878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 178881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178887 */     GIR_RootConstrainSelectedInstOperands,
     /* 178888 */     // GIR_Coverage, 2330,
     /* 178888 */     GIR_EraseRootFromParent_Done,
     /* 178889 */   // Label 3487: @178889
     /* 178889 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(178934), // Rule ID 2331 //
     /* 178894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 178897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 178902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178923 */     // (intrinsic_wo_chain:{ *:[v8f16] } 631:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 178926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178932 */     GIR_RootConstrainSelectedInstOperands,
     /* 178933 */     // GIR_Coverage, 2331,
     /* 178933 */     GIR_EraseRootFromParent_Done,
     /* 178934 */   // Label 3488: @178934
     /* 178934 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(178979), // Rule ID 2332 //
     /* 178939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 178942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 178947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178968 */     // (intrinsic_wo_chain:{ *:[v2f32] } 631:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 178968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 178971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178977 */     GIR_RootConstrainSelectedInstOperands,
     /* 178978 */     // GIR_Coverage, 2332,
     /* 178978 */     GIR_EraseRootFromParent_Done,
     /* 178979 */   // Label 3489: @178979
     /* 178979 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(179024), // Rule ID 2333 //
     /* 178984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 178987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 178992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179013 */     // (intrinsic_wo_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 179016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179022 */     GIR_RootConstrainSelectedInstOperands,
     /* 179023 */     // GIR_Coverage, 2333,
     /* 179023 */     GIR_EraseRootFromParent_Done,
     /* 179024 */   // Label 3490: @179024
     /* 179024 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(179069), // Rule ID 2334 //
     /* 179029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179058 */     // (intrinsic_wo_chain:{ *:[v2f64] } 631:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 179061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179067 */     GIR_RootConstrainSelectedInstOperands,
     /* 179068 */     // GIR_Coverage, 2334,
     /* 179068 */     GIR_EraseRootFromParent_Done,
     /* 179069 */   // Label 3491: @179069
     /* 179069 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(179114), // Rule ID 2335 //
     /* 179074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179103 */     // (intrinsic_wo_chain:{ *:[v4f16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 179103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 179106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179112 */     GIR_RootConstrainSelectedInstOperands,
     /* 179113 */     // GIR_Coverage, 2335,
     /* 179113 */     GIR_EraseRootFromParent_Done,
     /* 179114 */   // Label 3492: @179114
     /* 179114 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(179159), // Rule ID 2338 //
     /* 179119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179148 */     // (intrinsic_wo_chain:{ *:[v8f16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 179148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 179151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179157 */     GIR_RootConstrainSelectedInstOperands,
     /* 179158 */     // GIR_Coverage, 2338,
     /* 179158 */     GIR_EraseRootFromParent_Done,
     /* 179159 */   // Label 3493: @179159
     /* 179159 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(179204), // Rule ID 2341 //
     /* 179164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179193 */     // (intrinsic_wo_chain:{ *:[v2f32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 179193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 179196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179202 */     GIR_RootConstrainSelectedInstOperands,
     /* 179203 */     // GIR_Coverage, 2341,
     /* 179203 */     GIR_EraseRootFromParent_Done,
     /* 179204 */   // Label 3494: @179204
     /* 179204 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(179249), // Rule ID 2344 //
     /* 179209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179238 */     // (intrinsic_wo_chain:{ *:[v4f32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 179238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 179241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179247 */     GIR_RootConstrainSelectedInstOperands,
     /* 179248 */     // GIR_Coverage, 2344,
     /* 179248 */     GIR_EraseRootFromParent_Done,
     /* 179249 */   // Label 3495: @179249
     /* 179249 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(179294), // Rule ID 2347 //
     /* 179254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179283 */     // (intrinsic_wo_chain:{ *:[v2f64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 179283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 179286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179292 */     GIR_RootConstrainSelectedInstOperands,
     /* 179293 */     // GIR_Coverage, 2347,
     /* 179293 */     GIR_EraseRootFromParent_Done,
     /* 179294 */   // Label 3496: @179294
     /* 179294 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(179339), // Rule ID 2350 //
     /* 179299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 179307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179328 */     // (intrinsic_wo_chain:{ *:[v4f16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 179328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 179331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179337 */     GIR_RootConstrainSelectedInstOperands,
     /* 179338 */     // GIR_Coverage, 2350,
     /* 179338 */     GIR_EraseRootFromParent_Done,
     /* 179339 */   // Label 3497: @179339
     /* 179339 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(179384), // Rule ID 2353 //
     /* 179344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 179352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179373 */     // (intrinsic_wo_chain:{ *:[v8f16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 179373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 179376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179382 */     GIR_RootConstrainSelectedInstOperands,
     /* 179383 */     // GIR_Coverage, 2353,
     /* 179383 */     GIR_EraseRootFromParent_Done,
     /* 179384 */   // Label 3498: @179384
     /* 179384 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(179429), // Rule ID 2356 //
     /* 179389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 179397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179418 */     // (intrinsic_wo_chain:{ *:[v2f32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 179418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 179421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179427 */     GIR_RootConstrainSelectedInstOperands,
     /* 179428 */     // GIR_Coverage, 2356,
     /* 179428 */     GIR_EraseRootFromParent_Done,
     /* 179429 */   // Label 3499: @179429
     /* 179429 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(179474), // Rule ID 2359 //
     /* 179434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 179442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179463 */     // (intrinsic_wo_chain:{ *:[v4f32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 179463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 179466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179472 */     GIR_RootConstrainSelectedInstOperands,
     /* 179473 */     // GIR_Coverage, 2359,
     /* 179473 */     GIR_EraseRootFromParent_Done,
     /* 179474 */   // Label 3500: @179474
     /* 179474 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(179519), // Rule ID 2362 //
     /* 179479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 179487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179508 */     // (intrinsic_wo_chain:{ *:[v2f64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 179508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 179511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179517 */     GIR_RootConstrainSelectedInstOperands,
     /* 179518 */     // GIR_Coverage, 2362,
     /* 179518 */     GIR_EraseRootFromParent_Done,
     /* 179519 */   // Label 3501: @179519
     /* 179519 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(179564), // Rule ID 2499 //
     /* 179524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 179532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179553 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 179553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 179556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179562 */     GIR_RootConstrainSelectedInstOperands,
     /* 179563 */     // GIR_Coverage, 2499,
     /* 179563 */     GIR_EraseRootFromParent_Done,
     /* 179564 */   // Label 3502: @179564
     /* 179564 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(179609), // Rule ID 2500 //
     /* 179569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 179577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179598 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 179598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 179601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179607 */     GIR_RootConstrainSelectedInstOperands,
     /* 179608 */     // GIR_Coverage, 2500,
     /* 179608 */     GIR_EraseRootFromParent_Done,
     /* 179609 */   // Label 3503: @179609
     /* 179609 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(179654), // Rule ID 2501 //
     /* 179614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 179622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179643 */     // (intrinsic_wo_chain:{ *:[v1f64] } 785:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 179643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 179646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179652 */     GIR_RootConstrainSelectedInstOperands,
     /* 179653 */     // GIR_Coverage, 2501,
     /* 179653 */     GIR_EraseRootFromParent_Done,
     /* 179654 */   // Label 3504: @179654
     /* 179654 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(179699), // Rule ID 2502 //
     /* 179659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 179667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179688 */     // (intrinsic_wo_chain:{ *:[v1i64] } 577:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 179688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 179691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179697 */     GIR_RootConstrainSelectedInstOperands,
     /* 179698 */     // GIR_Coverage, 2502,
     /* 179698 */     GIR_EraseRootFromParent_Done,
     /* 179699 */   // Label 3505: @179699
     /* 179699 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(179744), // Rule ID 2507 //
     /* 179704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 179712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179733 */     // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 179733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 179736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179742 */     GIR_RootConstrainSelectedInstOperands,
     /* 179743 */     // GIR_Coverage, 2507,
     /* 179743 */     GIR_EraseRootFromParent_Done,
     /* 179744 */   // Label 3506: @179744
     /* 179744 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(179789), // Rule ID 2625 //
     /* 179749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 179757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 179766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 179770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 179774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179778 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 179778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 179781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179787 */     GIR_RootConstrainSelectedInstOperands,
     /* 179788 */     // GIR_Coverage, 2625,
     /* 179788 */     GIR_EraseRootFromParent_Done,
     /* 179789 */   // Label 3507: @179789
     /* 179789 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(179834), // Rule ID 2626 //
     /* 179794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 179802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 179811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 179815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 179819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179823 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 179823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 179826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179832 */     GIR_RootConstrainSelectedInstOperands,
     /* 179833 */     // GIR_Coverage, 2626,
     /* 179833 */     GIR_EraseRootFromParent_Done,
     /* 179834 */   // Label 3508: @179834
     /* 179834 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(179879), // Rule ID 2627 //
     /* 179839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 179847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 179856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 179860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 179864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179868 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 179868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 179871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179877 */     GIR_RootConstrainSelectedInstOperands,
     /* 179878 */     // GIR_Coverage, 2627,
     /* 179878 */     GIR_EraseRootFromParent_Done,
     /* 179879 */   // Label 3509: @179879
     /* 179879 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(179924), // Rule ID 2628 //
     /* 179884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 179892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 179901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 179905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 179909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179913 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 179913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 179916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179922 */     GIR_RootConstrainSelectedInstOperands,
     /* 179923 */     // GIR_Coverage, 2628,
     /* 179923 */     GIR_EraseRootFromParent_Done,
     /* 179924 */   // Label 3510: @179924
     /* 179924 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(179969), // Rule ID 2629 //
     /* 179929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 179937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 179946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 179958 */     // (intrinsic_wo_chain:{ *:[i64] } 1801:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 179958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 179961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 179963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 179965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179967 */     GIR_RootConstrainSelectedInstOperands,
     /* 179968 */     // GIR_Coverage, 2629,
     /* 179968 */     GIR_EraseRootFromParent_Done,
     /* 179969 */   // Label 3511: @179969
     /* 179969 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(180014), // Rule ID 2630 //
     /* 179974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 179977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 179982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 179991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 179999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180003 */     // (intrinsic_wo_chain:{ *:[i64] } 1801:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 180006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180012 */     GIR_RootConstrainSelectedInstOperands,
     /* 180013 */     // GIR_Coverage, 2630,
     /* 180013 */     GIR_EraseRootFromParent_Done,
     /* 180014 */   // Label 3512: @180014
     /* 180014 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(180059), // Rule ID 2631 //
     /* 180019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 180027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 180036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180048 */     // (intrinsic_wo_chain:{ *:[i64] } 1801:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 180051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180057 */     GIR_RootConstrainSelectedInstOperands,
     /* 180058 */     // GIR_Coverage, 2631,
     /* 180058 */     GIR_EraseRootFromParent_Done,
     /* 180059 */   // Label 3513: @180059
     /* 180059 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(180104), // Rule ID 2632 //
     /* 180064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 180072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 180081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180093 */     // (intrinsic_wo_chain:{ *:[i64] } 1801:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 180096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180102 */     GIR_RootConstrainSelectedInstOperands,
     /* 180103 */     // GIR_Coverage, 2632,
     /* 180103 */     GIR_EraseRootFromParent_Done,
     /* 180104 */   // Label 3514: @180104
     /* 180104 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(180149), // Rule ID 3796 //
     /* 180109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 180112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 180117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180138 */     // (intrinsic_wo_chain:{ *:[v2i64] } 532:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 180138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 180141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 180143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 180147 */     GIR_RootConstrainSelectedInstOperands,
     /* 180148 */     // GIR_Coverage, 3796,
     /* 180148 */     GIR_EraseRootFromParent_Done,
     /* 180149 */   // Label 3515: @180149
     /* 180149 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(180194), // Rule ID 3824 //
     /* 180154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 180157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 180162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180183 */     // (intrinsic_wo_chain:{ *:[v2i64] } 519:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 180183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 180186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 180192 */     GIR_RootConstrainSelectedInstOperands,
     /* 180193 */     // GIR_Coverage, 3824,
     /* 180193 */     GIR_EraseRootFromParent_Done,
     /* 180194 */   // Label 3516: @180194
     /* 180194 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(180239), // Rule ID 3834 //
     /* 180199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 180202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 180207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180228 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 180228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 180231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 180237 */     GIR_RootConstrainSelectedInstOperands,
     /* 180238 */     // GIR_Coverage, 3834,
     /* 180238 */     GIR_EraseRootFromParent_Done,
     /* 180239 */   // Label 3517: @180239
     /* 180239 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(180284), // Rule ID 3835 //
     /* 180244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 180247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 180252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180273 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 180273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 180276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 180278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 180282 */     GIR_RootConstrainSelectedInstOperands,
     /* 180283 */     // GIR_Coverage, 3835,
     /* 180283 */     GIR_EraseRootFromParent_Done,
     /* 180284 */   // Label 3518: @180284
     /* 180284 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(180332), // Rule ID 3836 //
     /* 180289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 180292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 180297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 180303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 180306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180318 */     // (intrinsic_wo_chain:{ *:[v4f16] } 756:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 180318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 180321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180330 */     GIR_RootConstrainSelectedInstOperands,
     /* 180331 */     // GIR_Coverage, 3836,
     /* 180331 */     GIR_EraseRootFromParent_Done,
     /* 180332 */   // Label 3519: @180332
     /* 180332 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(180380), // Rule ID 3837 //
     /* 180337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 180340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 180345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 180351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 180354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180366 */     // (intrinsic_wo_chain:{ *:[v4f16] } 755:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 180366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 180369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 180378 */     GIR_RootConstrainSelectedInstOperands,
     /* 180379 */     // GIR_Coverage, 3837,
     /* 180379 */     GIR_EraseRootFromParent_Done,
     /* 180380 */   // Label 3520: @180380
     /* 180380 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(180428), // Rule ID 3838 //
     /* 180385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 180388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 180393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 180396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 180402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180414 */     // (intrinsic_wo_chain:{ *:[v8f16] } 756:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 180414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 180417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180426 */     GIR_RootConstrainSelectedInstOperands,
     /* 180427 */     // GIR_Coverage, 3838,
     /* 180427 */     GIR_EraseRootFromParent_Done,
     /* 180428 */   // Label 3521: @180428
     /* 180428 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(180476), // Rule ID 3839 //
     /* 180433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 180436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 180441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 180444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 180450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180462 */     // (intrinsic_wo_chain:{ *:[v8f16] } 755:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 180462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 180465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 180474 */     GIR_RootConstrainSelectedInstOperands,
     /* 180475 */     // GIR_Coverage, 3839,
     /* 180475 */     GIR_EraseRootFromParent_Done,
     /* 180476 */   // Label 3522: @180476
     /* 180476 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(180524), // Rule ID 3840 //
     /* 180481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 180484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 180489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180510 */     // (intrinsic_wo_chain:{ *:[v2f32] } 756:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 180510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 180513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180522 */     GIR_RootConstrainSelectedInstOperands,
     /* 180523 */     // GIR_Coverage, 3840,
     /* 180523 */     GIR_EraseRootFromParent_Done,
     /* 180524 */   // Label 3523: @180524
     /* 180524 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(180572), // Rule ID 3841 //
     /* 180529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 180532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 180537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180558 */     // (intrinsic_wo_chain:{ *:[v2f32] } 755:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 180558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 180561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 180570 */     GIR_RootConstrainSelectedInstOperands,
     /* 180571 */     // GIR_Coverage, 3841,
     /* 180571 */     GIR_EraseRootFromParent_Done,
     /* 180572 */   // Label 3524: @180572
     /* 180572 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(180620), // Rule ID 3842 //
     /* 180577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 180580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 180585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180606 */     // (intrinsic_wo_chain:{ *:[v4f32] } 756:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 180606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 180609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180618 */     GIR_RootConstrainSelectedInstOperands,
     /* 180619 */     // GIR_Coverage, 3842,
     /* 180619 */     GIR_EraseRootFromParent_Done,
     /* 180620 */   // Label 3525: @180620
     /* 180620 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(180668), // Rule ID 3843 //
     /* 180625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 180628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 180633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180654 */     // (intrinsic_wo_chain:{ *:[v4f32] } 755:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 180654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 180657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 180666 */     GIR_RootConstrainSelectedInstOperands,
     /* 180667 */     // GIR_Coverage, 3843,
     /* 180667 */     GIR_EraseRootFromParent_Done,
     /* 180668 */   // Label 3526: @180668
     /* 180668 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(180716), // Rule ID 3844 //
     /* 180673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 180676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 180681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180702 */     // (intrinsic_wo_chain:{ *:[v2f64] } 756:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 180702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 180705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 180714 */     GIR_RootConstrainSelectedInstOperands,
     /* 180715 */     // GIR_Coverage, 3844,
     /* 180715 */     GIR_EraseRootFromParent_Done,
     /* 180716 */   // Label 3527: @180716
     /* 180716 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(180764), // Rule ID 3845 //
     /* 180721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 180724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 180729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180750 */     // (intrinsic_wo_chain:{ *:[v2f64] } 755:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 180750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 180753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 180762 */     GIR_RootConstrainSelectedInstOperands,
     /* 180763 */     // GIR_Coverage, 3845,
     /* 180763 */     GIR_EraseRootFromParent_Done,
     /* 180764 */   // Label 3528: @180764
     /* 180764 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(180806), // Rule ID 3910 //
     /* 180769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 180774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180795 */     // (intrinsic_wo_chain:{ *:[i32] } 2155:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 180795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 180798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180804 */     GIR_RootConstrainSelectedInstOperands,
     /* 180805 */     // GIR_Coverage, 3910,
     /* 180805 */     GIR_EraseRootFromParent_Done,
     /* 180806 */   // Label 3529: @180806
     /* 180806 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(180848), // Rule ID 3911 //
     /* 180811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 180816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180837 */     // (intrinsic_wo_chain:{ *:[i64] } 2155:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 180837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 180840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180846 */     GIR_RootConstrainSelectedInstOperands,
     /* 180847 */     // GIR_Coverage, 3911,
     /* 180847 */     GIR_EraseRootFromParent_Done,
     /* 180848 */   // Label 3530: @180848
     /* 180848 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(180890), // Rule ID 3912 //
     /* 180853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 180858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180879 */     // (intrinsic_wo_chain:{ *:[i32] } 779:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 180879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 180882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180888 */     GIR_RootConstrainSelectedInstOperands,
     /* 180889 */     // GIR_Coverage, 3912,
     /* 180889 */     GIR_EraseRootFromParent_Done,
     /* 180890 */   // Label 3531: @180890
     /* 180890 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(180932), // Rule ID 3913 //
     /* 180895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 180900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180921 */     // (intrinsic_wo_chain:{ *:[i64] } 779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 180921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 180924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180930 */     GIR_RootConstrainSelectedInstOperands,
     /* 180931 */     // GIR_Coverage, 3913,
     /* 180931 */     GIR_EraseRootFromParent_Done,
     /* 180932 */   // Label 3532: @180932
     /* 180932 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(180974), // Rule ID 5183 //
     /* 180937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 180942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180963 */     // (intrinsic_wo_chain:{ *:[v1f64] } 576:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 180963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 180966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180972 */     GIR_RootConstrainSelectedInstOperands,
     /* 180973 */     // GIR_Coverage, 5183,
     /* 180973 */     GIR_EraseRootFromParent_Done,
     /* 180974 */   // Label 3533: @180974
     /* 180974 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(181019), // Rule ID 5187 //
     /* 180979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 180987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181008 */     // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 181011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181017 */     GIR_RootConstrainSelectedInstOperands,
     /* 181018 */     // GIR_Coverage, 5187,
     /* 181018 */     GIR_EraseRootFromParent_Done,
     /* 181019 */   // Label 3534: @181019
     /* 181019 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(181064), // Rule ID 5191 //
     /* 181024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 181032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181053 */     // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 181056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181062 */     GIR_RootConstrainSelectedInstOperands,
     /* 181063 */     // GIR_Coverage, 5191,
     /* 181063 */     GIR_EraseRootFromParent_Done,
     /* 181064 */   // Label 3535: @181064
     /* 181064 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(181109), // Rule ID 5192 //
     /* 181069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 181077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181098 */     // (intrinsic_wo_chain:{ *:[v1f64] } 633:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 181101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181107 */     GIR_RootConstrainSelectedInstOperands,
     /* 181108 */     // GIR_Coverage, 5192,
     /* 181108 */     GIR_EraseRootFromParent_Done,
     /* 181109 */   // Label 3536: @181109
     /* 181109 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(181154), // Rule ID 5193 //
     /* 181114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 181122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181143 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 181146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181152 */     GIR_RootConstrainSelectedInstOperands,
     /* 181153 */     // GIR_Coverage, 5193,
     /* 181153 */     GIR_EraseRootFromParent_Done,
     /* 181154 */   // Label 3537: @181154
     /* 181154 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(181199), // Rule ID 5194 //
     /* 181159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 181167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181188 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 181188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 181191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181197 */     GIR_RootConstrainSelectedInstOperands,
     /* 181198 */     // GIR_Coverage, 5194,
     /* 181198 */     GIR_EraseRootFromParent_Done,
     /* 181199 */   // Label 3538: @181199
     /* 181199 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(181244), // Rule ID 5195 //
     /* 181204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 181212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181233 */     // (intrinsic_wo_chain:{ *:[i32] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 181233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 181236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181242 */     GIR_RootConstrainSelectedInstOperands,
     /* 181243 */     // GIR_Coverage, 5195,
     /* 181243 */     GIR_EraseRootFromParent_Done,
     /* 181244 */   // Label 3539: @181244
     /* 181244 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(181289), // Rule ID 5196 //
     /* 181249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 181257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181278 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 181278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 181281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181287 */     GIR_RootConstrainSelectedInstOperands,
     /* 181288 */     // GIR_Coverage, 5196,
     /* 181288 */     GIR_EraseRootFromParent_Done,
     /* 181289 */   // Label 3540: @181289
     /* 181289 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(181334), // Rule ID 5197 //
     /* 181294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 181302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181323 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 181323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 181326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181332 */     GIR_RootConstrainSelectedInstOperands,
     /* 181333 */     // GIR_Coverage, 5197,
     /* 181333 */     GIR_EraseRootFromParent_Done,
     /* 181334 */   // Label 3541: @181334
     /* 181334 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(181379), // Rule ID 5198 //
     /* 181339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 181347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181368 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 181368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 181371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181377 */     GIR_RootConstrainSelectedInstOperands,
     /* 181378 */     // GIR_Coverage, 5198,
     /* 181378 */     GIR_EraseRootFromParent_Done,
     /* 181379 */   // Label 3542: @181379
     /* 181379 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(181424), // Rule ID 5199 //
     /* 181384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 181392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181413 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 181413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 181416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181422 */     GIR_RootConstrainSelectedInstOperands,
     /* 181423 */     // GIR_Coverage, 5199,
     /* 181423 */     GIR_EraseRootFromParent_Done,
     /* 181424 */   // Label 3543: @181424
     /* 181424 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(181469), // Rule ID 5200 //
     /* 181429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 181437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181458 */     // (intrinsic_wo_chain:{ *:[i64] } 739:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 181458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 181461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181467 */     GIR_RootConstrainSelectedInstOperands,
     /* 181468 */     // GIR_Coverage, 5200,
     /* 181468 */     GIR_EraseRootFromParent_Done,
     /* 181469 */   // Label 3544: @181469
     /* 181469 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(181514), // Rule ID 5201 //
     /* 181474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 181482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181503 */     // (intrinsic_wo_chain:{ *:[i32] } 739:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 181503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 181506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181512 */     GIR_RootConstrainSelectedInstOperands,
     /* 181513 */     // GIR_Coverage, 5201,
     /* 181513 */     GIR_EraseRootFromParent_Done,
     /* 181514 */   // Label 3545: @181514
     /* 181514 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(181559), // Rule ID 5202 //
     /* 181519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 181527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181548 */     // (intrinsic_wo_chain:{ *:[i64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 181548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 181551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181557 */     GIR_RootConstrainSelectedInstOperands,
     /* 181558 */     // GIR_Coverage, 5202,
     /* 181558 */     GIR_EraseRootFromParent_Done,
     /* 181559 */   // Label 3546: @181559
     /* 181559 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(181604), // Rule ID 5203 //
     /* 181564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 181572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181593 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 181593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 181596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181602 */     GIR_RootConstrainSelectedInstOperands,
     /* 181603 */     // GIR_Coverage, 5203,
     /* 181603 */     GIR_EraseRootFromParent_Done,
     /* 181604 */   // Label 3547: @181604
     /* 181604 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(181649), // Rule ID 5204 //
     /* 181609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 181617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181638 */     // (intrinsic_wo_chain:{ *:[i64] } 742:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 181638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 181641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181647 */     GIR_RootConstrainSelectedInstOperands,
     /* 181648 */     // GIR_Coverage, 5204,
     /* 181648 */     GIR_EraseRootFromParent_Done,
     /* 181649 */   // Label 3548: @181649
     /* 181649 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(181694), // Rule ID 5205 //
     /* 181654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 181662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181683 */     // (intrinsic_wo_chain:{ *:[i32] } 742:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 181683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 181686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181692 */     GIR_RootConstrainSelectedInstOperands,
     /* 181693 */     // GIR_Coverage, 5205,
     /* 181693 */     GIR_EraseRootFromParent_Done,
     /* 181694 */   // Label 3549: @181694
     /* 181694 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(181739), // Rule ID 5206 //
     /* 181699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 181707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181728 */     // (intrinsic_wo_chain:{ *:[i64] } 744:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 181728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 181731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181737 */     GIR_RootConstrainSelectedInstOperands,
     /* 181738 */     // GIR_Coverage, 5206,
     /* 181738 */     GIR_EraseRootFromParent_Done,
     /* 181739 */   // Label 3550: @181739
     /* 181739 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(181784), // Rule ID 5207 //
     /* 181744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 181752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181773 */     // (intrinsic_wo_chain:{ *:[i32] } 744:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 181773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 181776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181782 */     GIR_RootConstrainSelectedInstOperands,
     /* 181783 */     // GIR_Coverage, 5207,
     /* 181783 */     GIR_EraseRootFromParent_Done,
     /* 181784 */   // Label 3551: @181784
     /* 181784 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(181829), // Rule ID 5225 //
     /* 181789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 181797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181818 */     // (intrinsic_wo_chain:{ *:[v1i64] } 754:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 181818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 181821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181827 */     GIR_RootConstrainSelectedInstOperands,
     /* 181828 */     // GIR_Coverage, 5225,
     /* 181828 */     GIR_EraseRootFromParent_Done,
     /* 181829 */   // Label 3552: @181829
     /* 181829 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(181871), // Rule ID 5559 //
     /* 181834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 181839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 181845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 181848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181860 */     // (intrinsic_wo_chain:{ *:[v8i8] } 716:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 181860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 181863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 181869 */     GIR_RootConstrainSelectedInstOperands,
     /* 181870 */     // GIR_Coverage, 5559,
     /* 181870 */     GIR_EraseRootFromParent_Done,
     /* 181871 */   // Label 3553: @181871
     /* 181871 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(181913), // Rule ID 5560 //
     /* 181876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 181881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 181884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 181887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 181890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181902 */     // (intrinsic_wo_chain:{ *:[v16i8] } 716:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 181902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 181905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 181909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 181911 */     GIR_RootConstrainSelectedInstOperands,
     /* 181912 */     // GIR_Coverage, 5560,
     /* 181912 */     GIR_EraseRootFromParent_Done,
     /* 181913 */   // Label 3554: @181913
     /* 181913 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(182010), // Rule ID 6237 //
     /* 181918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 181923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 181929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 181932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 181944 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 181944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 181947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 181951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181956 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 181960 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 181964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 181966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 181983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 181991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 181994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182009 */     // GIR_Coverage, 6237,
     /* 182009 */     GIR_EraseRootFromParent_Done,
     /* 182010 */   // Label 3555: @182010
     /* 182010 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(182107), // Rule ID 6238 //
     /* 182015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 182020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 182029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182041 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 182041 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182044 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 182048 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182053 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182057 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 182061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182106 */     // GIR_Coverage, 6238,
     /* 182106 */     GIR_EraseRootFromParent_Done,
     /* 182107 */   // Label 3556: @182107
     /* 182107 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(182149), // Rule ID 6891 //
     /* 182112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 182117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182138 */     // (intrinsic_wo_chain:{ *:[i64] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 182141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182147 */     GIR_RootConstrainSelectedInstOperands,
     /* 182148 */     // GIR_Coverage, 6891,
     /* 182148 */     GIR_EraseRootFromParent_Done,
     /* 182149 */   // Label 3557: @182149
     /* 182149 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(182191), // Rule ID 6892 //
     /* 182154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 182159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182180 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 182183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182189 */     GIR_RootConstrainSelectedInstOperands,
     /* 182190 */     // GIR_Coverage, 6892,
     /* 182190 */     GIR_EraseRootFromParent_Done,
     /* 182191 */   // Label 3558: @182191
     /* 182191 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(182233), // Rule ID 6893 //
     /* 182196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 182201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182222 */     // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 182225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182231 */     GIR_RootConstrainSelectedInstOperands,
     /* 182232 */     // GIR_Coverage, 6893,
     /* 182232 */     GIR_EraseRootFromParent_Done,
     /* 182233 */   // Label 3559: @182233
     /* 182233 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(182275), // Rule ID 6894 //
     /* 182238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 182243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182264 */     // (intrinsic_wo_chain:{ *:[i64] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 182267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182273 */     GIR_RootConstrainSelectedInstOperands,
     /* 182274 */     // GIR_Coverage, 6894,
     /* 182274 */     GIR_EraseRootFromParent_Done,
     /* 182275 */   // Label 3560: @182275
     /* 182275 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(182323), // Rule ID 6934 //
     /* 182280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 182285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182306 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 182306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 182309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 182313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 182315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 182318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 182321 */     GIR_RootConstrainSelectedInstOperands,
     /* 182322 */     // GIR_Coverage, 6934,
     /* 182322 */     GIR_EraseRootFromParent_Done,
     /* 182323 */   // Label 3561: @182323
     /* 182323 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(182368), // Rule ID 9956 //
     /* 182328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 182336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 182345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182357 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 182357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 182360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182366 */     GIR_RootConstrainSelectedInstOperands,
     /* 182367 */     // GIR_Coverage, 9956,
     /* 182367 */     GIR_EraseRootFromParent_Done,
     /* 182368 */   // Label 3562: @182368
     /* 182368 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(182413), // Rule ID 9957 //
     /* 182373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 182381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 182390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182402 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 182402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 182405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182411 */     GIR_RootConstrainSelectedInstOperands,
     /* 182412 */     // GIR_Coverage, 9957,
     /* 182412 */     GIR_EraseRootFromParent_Done,
     /* 182413 */   // Label 3563: @182413
     /* 182413 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(182458), // Rule ID 9958 //
     /* 182418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 182426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 182435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182447 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 182447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 182450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182456 */     GIR_RootConstrainSelectedInstOperands,
     /* 182457 */     // GIR_Coverage, 9958,
     /* 182457 */     GIR_EraseRootFromParent_Done,
     /* 182458 */   // Label 3564: @182458
     /* 182458 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(182503), // Rule ID 9959 //
     /* 182463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 182471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 182480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182492 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 182492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 182495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182501 */     GIR_RootConstrainSelectedInstOperands,
     /* 182502 */     // GIR_Coverage, 9959,
     /* 182502 */     GIR_EraseRootFromParent_Done,
     /* 182503 */   // Label 3565: @182503
     /* 182503 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(182548), // Rule ID 9968 //
     /* 182508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 182516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 182525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182537 */     // (intrinsic_wo_chain:{ *:[i64] } 1767:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 182537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 182540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182546 */     GIR_RootConstrainSelectedInstOperands,
     /* 182547 */     // GIR_Coverage, 9968,
     /* 182547 */     GIR_EraseRootFromParent_Done,
     /* 182548 */   // Label 3566: @182548
     /* 182548 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(182593), // Rule ID 9969 //
     /* 182553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 182561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 182570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182582 */     // (intrinsic_wo_chain:{ *:[i64] } 1767:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 182582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 182585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182591 */     GIR_RootConstrainSelectedInstOperands,
     /* 182592 */     // GIR_Coverage, 9969,
     /* 182592 */     GIR_EraseRootFromParent_Done,
     /* 182593 */   // Label 3567: @182593
     /* 182593 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(182638), // Rule ID 9970 //
     /* 182598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 182606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 182615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182627 */     // (intrinsic_wo_chain:{ *:[i64] } 1767:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 182627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 182630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182636 */     GIR_RootConstrainSelectedInstOperands,
     /* 182637 */     // GIR_Coverage, 9970,
     /* 182637 */     GIR_EraseRootFromParent_Done,
     /* 182638 */   // Label 3568: @182638
     /* 182638 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(182683), // Rule ID 9971 //
     /* 182643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 182651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 182660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182672 */     // (intrinsic_wo_chain:{ *:[i64] } 1767:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 182672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 182675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182681 */     GIR_RootConstrainSelectedInstOperands,
     /* 182682 */     // GIR_Coverage, 9971,
     /* 182682 */     GIR_EraseRootFromParent_Done,
     /* 182683 */   // Label 3569: @182683
     /* 182683 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(182728), // Rule ID 9972 //
     /* 182688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 182696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 182705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182717 */     // (intrinsic_wo_chain:{ *:[i32] } 1997:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 182717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 182720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182726 */     GIR_RootConstrainSelectedInstOperands,
     /* 182727 */     // GIR_Coverage, 9972,
     /* 182727 */     GIR_EraseRootFromParent_Done,
     /* 182728 */   // Label 3570: @182728
     /* 182728 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(182773), // Rule ID 9973 //
     /* 182733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 182741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 182750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182762 */     // (intrinsic_wo_chain:{ *:[i32] } 1997:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 182762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 182765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182771 */     GIR_RootConstrainSelectedInstOperands,
     /* 182772 */     // GIR_Coverage, 9973,
     /* 182772 */     GIR_EraseRootFromParent_Done,
     /* 182773 */   // Label 3571: @182773
     /* 182773 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(182818), // Rule ID 9974 //
     /* 182778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 182786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 182795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182807 */     // (intrinsic_wo_chain:{ *:[i32] } 1997:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 182807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 182810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182816 */     GIR_RootConstrainSelectedInstOperands,
     /* 182817 */     // GIR_Coverage, 9974,
     /* 182817 */     GIR_EraseRootFromParent_Done,
     /* 182818 */   // Label 3572: @182818
     /* 182818 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(182863), // Rule ID 9975 //
     /* 182823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 182831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 182840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182852 */     // (intrinsic_wo_chain:{ *:[i32] } 1997:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 182852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 182855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182861 */     GIR_RootConstrainSelectedInstOperands,
     /* 182862 */     // GIR_Coverage, 9975,
     /* 182862 */     GIR_EraseRootFromParent_Done,
     /* 182863 */   // Label 3573: @182863
     /* 182863 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(182908), // Rule ID 9976 //
     /* 182868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 182876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 182885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182897 */     // (intrinsic_wo_chain:{ *:[i64] } 1998:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 182897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 182900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182906 */     GIR_RootConstrainSelectedInstOperands,
     /* 182907 */     // GIR_Coverage, 9976,
     /* 182907 */     GIR_EraseRootFromParent_Done,
     /* 182908 */   // Label 3574: @182908
     /* 182908 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(182953), // Rule ID 9977 //
     /* 182913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 182921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 182930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182942 */     // (intrinsic_wo_chain:{ *:[i64] } 1998:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 182942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 182945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182951 */     GIR_RootConstrainSelectedInstOperands,
     /* 182952 */     // GIR_Coverage, 9977,
     /* 182952 */     GIR_EraseRootFromParent_Done,
     /* 182953 */   // Label 3575: @182953
     /* 182953 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(182998), // Rule ID 9978 //
     /* 182958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 182961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 182966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 182975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 182987 */     // (intrinsic_wo_chain:{ *:[i64] } 1998:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 182987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 182990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 182992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 182994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182996 */     GIR_RootConstrainSelectedInstOperands,
     /* 182997 */     // GIR_Coverage, 9978,
     /* 182997 */     GIR_EraseRootFromParent_Done,
     /* 182998 */   // Label 3576: @182998
     /* 182998 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(183043), // Rule ID 9979 //
     /* 183003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 183011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183032 */     // (intrinsic_wo_chain:{ *:[i64] } 1998:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 183035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183041 */     GIR_RootConstrainSelectedInstOperands,
     /* 183042 */     // GIR_Coverage, 9979,
     /* 183042 */     GIR_EraseRootFromParent_Done,
     /* 183043 */   // Label 3577: @183043
     /* 183043 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(183089), // Rule ID 138 //
     /* 183048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 183051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 183056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183066 */     // MIs[0] Rn
     /* 183066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 183070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 183074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183078 */     // (intrinsic_wo_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 183078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 183081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183087 */     GIR_RootConstrainSelectedInstOperands,
     /* 183088 */     // GIR_Coverage, 138,
     /* 183088 */     GIR_EraseRootFromParent_Done,
     /* 183089 */   // Label 3578: @183089
     /* 183089 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(183136), // Rule ID 139 //
     /* 183094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 183097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 183102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183109 */     // MIs[0] Rn
     /* 183109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 183113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 183117 */     // MIs[0] Rm
     /* 183117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 183121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 183125 */     // (intrinsic_wo_chain:{ *:[i64] } 1228:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 183125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 183128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183134 */     GIR_RootConstrainSelectedInstOperands,
     /* 183135 */     // GIR_Coverage, 139,
     /* 183135 */     GIR_EraseRootFromParent_Done,
     /* 183136 */   // Label 3579: @183136
     /* 183136 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(183173), // Rule ID 2390 //
     /* 183141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 183149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183162 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2137:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 183165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183171 */     GIR_RootConstrainSelectedInstOperands,
     /* 183172 */     // GIR_Coverage, 2390,
     /* 183172 */     GIR_EraseRootFromParent_Done,
     /* 183173 */   // Label 3580: @183173
     /* 183173 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(183210), // Rule ID 2391 //
     /* 183178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 183186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183199 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2138:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 183202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183208 */     GIR_RootConstrainSelectedInstOperands,
     /* 183209 */     // GIR_Coverage, 2391,
     /* 183209 */     GIR_EraseRootFromParent_Done,
     /* 183210 */   // Label 3581: @183210
     /* 183210 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(183247), // Rule ID 2392 //
     /* 183215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 183223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183236 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2139:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 183239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183245 */     GIR_RootConstrainSelectedInstOperands,
     /* 183246 */     // GIR_Coverage, 2392,
     /* 183246 */     GIR_EraseRootFromParent_Done,
     /* 183247 */   // Label 3582: @183247
     /* 183247 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(183284), // Rule ID 2394 //
     /* 183252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 183260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183273 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2142:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 183276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183282 */     GIR_RootConstrainSelectedInstOperands,
     /* 183283 */     // GIR_Coverage, 2394,
     /* 183283 */     GIR_EraseRootFromParent_Done,
     /* 183284 */   // Label 3583: @183284
     /* 183284 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(183321), // Rule ID 2395 //
     /* 183289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 183297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183310 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2143:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 183313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183319 */     GIR_RootConstrainSelectedInstOperands,
     /* 183320 */     // GIR_Coverage, 2395,
     /* 183320 */     GIR_EraseRootFromParent_Done,
     /* 183321 */   // Label 3584: @183321
     /* 183321 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(183358), // Rule ID 2396 //
     /* 183326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 183334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183347 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2144:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 183350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183356 */     GIR_RootConstrainSelectedInstOperands,
     /* 183357 */     // GIR_Coverage, 2396,
     /* 183357 */     GIR_EraseRootFromParent_Done,
     /* 183358 */   // Label 3585: @183358
     /* 183358 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(183395), // Rule ID 2398 //
     /* 183363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 183371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183384 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2063:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 183387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183393 */     GIR_RootConstrainSelectedInstOperands,
     /* 183394 */     // GIR_Coverage, 2398,
     /* 183394 */     GIR_EraseRootFromParent_Done,
     /* 183395 */   // Label 3586: @183395
     /* 183395 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(183432), // Rule ID 2399 //
     /* 183400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 183408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183421 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2064:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 183424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183430 */     GIR_RootConstrainSelectedInstOperands,
     /* 183431 */     // GIR_Coverage, 2399,
     /* 183431 */     GIR_EraseRootFromParent_Done,
     /* 183432 */   // Label 3587: @183432
     /* 183432 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(183469), // Rule ID 2400 //
     /* 183437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 183445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183458 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2065:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 183461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183467 */     GIR_RootConstrainSelectedInstOperands,
     /* 183468 */     // GIR_Coverage, 2400,
     /* 183468 */     GIR_EraseRootFromParent_Done,
     /* 183469 */   // Label 3588: @183469
     /* 183469 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(183506), // Rule ID 2402 //
     /* 183474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 183482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183495 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2068:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 183498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183504 */     GIR_RootConstrainSelectedInstOperands,
     /* 183505 */     // GIR_Coverage, 2402,
     /* 183505 */     GIR_EraseRootFromParent_Done,
     /* 183506 */   // Label 3589: @183506
     /* 183506 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(183543), // Rule ID 2403 //
     /* 183511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 183519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183532 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2069:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 183535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183541 */     GIR_RootConstrainSelectedInstOperands,
     /* 183542 */     // GIR_Coverage, 2403,
     /* 183542 */     GIR_EraseRootFromParent_Done,
     /* 183543 */   // Label 3590: @183543
     /* 183543 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(183580), // Rule ID 2404 //
     /* 183548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 183556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183569 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2070:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 183572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183578 */     GIR_RootConstrainSelectedInstOperands,
     /* 183579 */     // GIR_Coverage, 2404,
     /* 183579 */     GIR_EraseRootFromParent_Done,
     /* 183580 */   // Label 3591: @183580
     /* 183580 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(183617), // Rule ID 2406 //
     /* 183585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 183593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183606 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1907:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 183609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183615 */     GIR_RootConstrainSelectedInstOperands,
     /* 183616 */     // GIR_Coverage, 2406,
     /* 183616 */     GIR_EraseRootFromParent_Done,
     /* 183617 */   // Label 3592: @183617
     /* 183617 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(183654), // Rule ID 2407 //
     /* 183622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 183630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183643 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1908:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 183646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183652 */     GIR_RootConstrainSelectedInstOperands,
     /* 183653 */     // GIR_Coverage, 2407,
     /* 183653 */     GIR_EraseRootFromParent_Done,
     /* 183654 */   // Label 3593: @183654
     /* 183654 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(183691), // Rule ID 2408 //
     /* 183659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 183667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183680 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1909:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 183683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183689 */     GIR_RootConstrainSelectedInstOperands,
     /* 183690 */     // GIR_Coverage, 2408,
     /* 183690 */     GIR_EraseRootFromParent_Done,
     /* 183691 */   // Label 3594: @183691
     /* 183691 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(183728), // Rule ID 2410 //
     /* 183696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 183704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183717 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1912:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 183720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183726 */     GIR_RootConstrainSelectedInstOperands,
     /* 183727 */     // GIR_Coverage, 2410,
     /* 183727 */     GIR_EraseRootFromParent_Done,
     /* 183728 */   // Label 3595: @183728
     /* 183728 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(183765), // Rule ID 2411 //
     /* 183733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 183741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183754 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1913:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 183757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183763 */     GIR_RootConstrainSelectedInstOperands,
     /* 183764 */     // GIR_Coverage, 2411,
     /* 183764 */     GIR_EraseRootFromParent_Done,
     /* 183765 */   // Label 3596: @183765
     /* 183765 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(183802), // Rule ID 2412 //
     /* 183770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 183778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183791 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1914:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 183794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183800 */     GIR_RootConstrainSelectedInstOperands,
     /* 183801 */     // GIR_Coverage, 2412,
     /* 183801 */     GIR_EraseRootFromParent_Done,
     /* 183802 */   // Label 3597: @183802
     /* 183802 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(183839), // Rule ID 2413 //
     /* 183807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 183810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 183815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 183824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183828 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1532:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 183828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 183831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 183835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 183837 */     GIR_RootConstrainSelectedInstOperands,
     /* 183838 */     // GIR_Coverage, 2413,
     /* 183838 */     GIR_EraseRootFromParent_Done,
     /* 183839 */   // Label 3598: @183839
     /* 183839 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(183879), // Rule ID 2612 //
     /* 183844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 183852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183865 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 183865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 183868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 183870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 183877 */     GIR_RootConstrainSelectedInstOperands,
     /* 183878 */     // GIR_Coverage, 2612,
     /* 183878 */     GIR_EraseRootFromParent_Done,
     /* 183879 */   // Label 3599: @183879
     /* 183879 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(183919), // Rule ID 2613 //
     /* 183884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 183892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183905 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1619:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 183905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 183908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 183910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 183917 */     GIR_RootConstrainSelectedInstOperands,
     /* 183918 */     // GIR_Coverage, 2613,
     /* 183918 */     GIR_EraseRootFromParent_Done,
     /* 183919 */   // Label 3600: @183919
     /* 183919 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(183959), // Rule ID 2614 //
     /* 183924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 183932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 183935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 183938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183945 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1619:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 183945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 183948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 183950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 183957 */     GIR_RootConstrainSelectedInstOperands,
     /* 183958 */     // GIR_Coverage, 2614,
     /* 183958 */     GIR_EraseRootFromParent_Done,
     /* 183959 */   // Label 3601: @183959
     /* 183959 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(183999), // Rule ID 2615 //
     /* 183964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 183972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 183975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 183978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183985 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1619:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 183985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 183988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 183990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 183997 */     GIR_RootConstrainSelectedInstOperands,
     /* 183998 */     // GIR_Coverage, 2615,
     /* 183998 */     GIR_EraseRootFromParent_Done,
     /* 183999 */   // Label 3602: @183999
     /* 183999 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(184039), // Rule ID 2616 //
     /* 184004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 184012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 184015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 184018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184025 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1619:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 184025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 184028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184037 */     GIR_RootConstrainSelectedInstOperands,
     /* 184038 */     // GIR_Coverage, 2616,
     /* 184038 */     GIR_EraseRootFromParent_Done,
     /* 184039 */   // Label 3603: @184039
     /* 184039 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(184076), // Rule ID 2633 //
     /* 184044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 184052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184065 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1799:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 184065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 184068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 184070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184074 */     GIR_RootConstrainSelectedInstOperands,
     /* 184075 */     // GIR_Coverage, 2633,
     /* 184075 */     GIR_EraseRootFromParent_Done,
     /* 184076 */   // Label 3604: @184076
     /* 184076 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(184113), // Rule ID 2634 //
     /* 184081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 184089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184102 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1799:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 184102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 184105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 184107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184111 */     GIR_RootConstrainSelectedInstOperands,
     /* 184112 */     // GIR_Coverage, 2634,
     /* 184112 */     GIR_EraseRootFromParent_Done,
     /* 184113 */   // Label 3605: @184113
     /* 184113 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(184150), // Rule ID 2635 //
     /* 184118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 184126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184139 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1799:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 184139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 184142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 184144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184148 */     GIR_RootConstrainSelectedInstOperands,
     /* 184149 */     // GIR_Coverage, 2635,
     /* 184149 */     GIR_EraseRootFromParent_Done,
     /* 184150 */   // Label 3606: @184150
     /* 184150 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(184187), // Rule ID 2636 //
     /* 184155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 184163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184176 */     // (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 184176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 184179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184185 */     GIR_RootConstrainSelectedInstOperands,
     /* 184186 */     // GIR_Coverage, 2636,
     /* 184186 */     GIR_EraseRootFromParent_Done,
     /* 184187 */   // Label 3607: @184187
     /* 184187 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(184224), // Rule ID 2637 //
     /* 184192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 184200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 184206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184213 */     // (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 184213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 184216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184222 */     GIR_RootConstrainSelectedInstOperands,
     /* 184223 */     // GIR_Coverage, 2637,
     /* 184223 */     GIR_EraseRootFromParent_Done,
     /* 184224 */   // Label 3608: @184224
     /* 184224 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(184261), // Rule ID 2638 //
     /* 184229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 184237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 184243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184250 */     // (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 184250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 184253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184259 */     GIR_RootConstrainSelectedInstOperands,
     /* 184260 */     // GIR_Coverage, 2638,
     /* 184260 */     GIR_EraseRootFromParent_Done,
     /* 184261 */   // Label 3609: @184261
     /* 184261 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(184298), // Rule ID 2639 //
     /* 184266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 184274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 184280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184287 */     // (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 184287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 184290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184296 */     GIR_RootConstrainSelectedInstOperands,
     /* 184297 */     // GIR_Coverage, 2639,
     /* 184297 */     GIR_EraseRootFromParent_Done,
     /* 184298 */   // Label 3610: @184298
     /* 184298 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(184335), // Rule ID 2817 //
     /* 184303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 184306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 184311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184324 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1529:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 184327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184333 */     GIR_RootConstrainSelectedInstOperands,
     /* 184334 */     // GIR_Coverage, 2817,
     /* 184334 */     GIR_EraseRootFromParent_Done,
     /* 184335 */   // Label 3611: @184335
     /* 184335 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(184372), // Rule ID 2818 //
     /* 184340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 184343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 184348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184361 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1529:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 184364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184370 */     GIR_RootConstrainSelectedInstOperands,
     /* 184371 */     // GIR_Coverage, 2818,
     /* 184371 */     GIR_EraseRootFromParent_Done,
     /* 184372 */   // Label 3612: @184372
     /* 184372 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(184409), // Rule ID 2819 //
     /* 184377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 184380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 184385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184398 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1529:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 184401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184407 */     GIR_RootConstrainSelectedInstOperands,
     /* 184408 */     // GIR_Coverage, 2819,
     /* 184408 */     GIR_EraseRootFromParent_Done,
     /* 184409 */   // Label 3613: @184409
     /* 184409 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(184446), // Rule ID 2990 //
     /* 184414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 184422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184435 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1781:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 184438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184444 */     GIR_RootConstrainSelectedInstOperands,
     /* 184445 */     // GIR_Coverage, 2990,
     /* 184445 */     GIR_EraseRootFromParent_Done,
     /* 184446 */   // Label 3614: @184446
     /* 184446 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(184483), // Rule ID 2991 //
     /* 184451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 184459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184472 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1781:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 184475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184481 */     GIR_RootConstrainSelectedInstOperands,
     /* 184482 */     // GIR_Coverage, 2991,
     /* 184482 */     GIR_EraseRootFromParent_Done,
     /* 184483 */   // Label 3615: @184483
     /* 184483 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(184520), // Rule ID 2992 //
     /* 184488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 184496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184509 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1781:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 184512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184518 */     GIR_RootConstrainSelectedInstOperands,
     /* 184519 */     // GIR_Coverage, 2992,
     /* 184519 */     GIR_EraseRootFromParent_Done,
     /* 184520 */   // Label 3616: @184520
     /* 184520 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(184557), // Rule ID 2993 //
     /* 184525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 184533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184546 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1781:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 184549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184555 */     GIR_RootConstrainSelectedInstOperands,
     /* 184556 */     // GIR_Coverage, 2993,
     /* 184556 */     GIR_EraseRootFromParent_Done,
     /* 184557 */   // Label 3617: @184557
     /* 184557 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(184594), // Rule ID 2994 //
     /* 184562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 184570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184583 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 184586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184592 */     GIR_RootConstrainSelectedInstOperands,
     /* 184593 */     // GIR_Coverage, 2994,
     /* 184593 */     GIR_EraseRootFromParent_Done,
     /* 184594 */   // Label 3618: @184594
     /* 184594 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(184631), // Rule ID 3016 //
     /* 184599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 184607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184620 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1674:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 184623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184629 */     GIR_RootConstrainSelectedInstOperands,
     /* 184630 */     // GIR_Coverage, 3016,
     /* 184630 */     GIR_EraseRootFromParent_Done,
     /* 184631 */   // Label 3619: @184631
     /* 184631 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(184668), // Rule ID 3017 //
     /* 184636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 184644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184657 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1674:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 184660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184666 */     GIR_RootConstrainSelectedInstOperands,
     /* 184667 */     // GIR_Coverage, 3017,
     /* 184667 */     GIR_EraseRootFromParent_Done,
     /* 184668 */   // Label 3620: @184668
     /* 184668 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(184705), // Rule ID 3018 //
     /* 184673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 184681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184694 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1674:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 184697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184703 */     GIR_RootConstrainSelectedInstOperands,
     /* 184704 */     // GIR_Coverage, 3018,
     /* 184704 */     GIR_EraseRootFromParent_Done,
     /* 184705 */   // Label 3621: @184705
     /* 184705 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(184742), // Rule ID 3022 //
     /* 184710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 184713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 184718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184731 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1617:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 184734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184740 */     GIR_RootConstrainSelectedInstOperands,
     /* 184741 */     // GIR_Coverage, 3022,
     /* 184741 */     GIR_EraseRootFromParent_Done,
     /* 184742 */   // Label 3622: @184742
     /* 184742 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(184779), // Rule ID 3023 //
     /* 184747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 184755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184768 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1617:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 184771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184777 */     GIR_RootConstrainSelectedInstOperands,
     /* 184778 */     // GIR_Coverage, 3023,
     /* 184778 */     GIR_EraseRootFromParent_Done,
     /* 184779 */   // Label 3623: @184779
     /* 184779 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(184816), // Rule ID 3024 //
     /* 184784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 184792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184805 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1617:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 184808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184814 */     GIR_RootConstrainSelectedInstOperands,
     /* 184815 */     // GIR_Coverage, 3024,
     /* 184815 */     GIR_EraseRootFromParent_Done,
     /* 184816 */   // Label 3624: @184816
     /* 184816 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(184853), // Rule ID 3025 //
     /* 184821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 184824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 184829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184842 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1259:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 184845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184851 */     GIR_RootConstrainSelectedInstOperands,
     /* 184852 */     // GIR_Coverage, 3025,
     /* 184852 */     GIR_EraseRootFromParent_Done,
     /* 184853 */   // Label 3625: @184853
     /* 184853 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(184890), // Rule ID 3026 //
     /* 184858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 184861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 184866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 184875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184879 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1259:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 184879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 184882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184888 */     GIR_RootConstrainSelectedInstOperands,
     /* 184889 */     // GIR_Coverage, 3026,
     /* 184889 */     GIR_EraseRootFromParent_Done,
     /* 184890 */   // Label 3626: @184890
     /* 184890 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(184927), // Rule ID 3027 //
     /* 184895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 184898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 184903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 184912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1259:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 184916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 184919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184925 */     GIR_RootConstrainSelectedInstOperands,
     /* 184926 */     // GIR_Coverage, 3027,
     /* 184926 */     GIR_EraseRootFromParent_Done,
     /* 184927 */   // Label 3627: @184927
     /* 184927 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(184964), // Rule ID 3028 //
     /* 184932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 184935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 184940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 184949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184953 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1259:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 184953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 184956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184962 */     GIR_RootConstrainSelectedInstOperands,
     /* 184963 */     // GIR_Coverage, 3028,
     /* 184963 */     GIR_EraseRootFromParent_Done,
     /* 184964 */   // Label 3628: @184964
     /* 184964 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(185001), // Rule ID 3029 //
     /* 184969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 184977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184990 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1675:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 184990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 184993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184999 */     GIR_RootConstrainSelectedInstOperands,
     /* 185000 */     // GIR_Coverage, 3029,
     /* 185000 */     GIR_EraseRootFromParent_Done,
     /* 185001 */   // Label 3629: @185001
     /* 185001 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(185038), // Rule ID 3030 //
     /* 185006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 185014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185027 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1675:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 185030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185036 */     GIR_RootConstrainSelectedInstOperands,
     /* 185037 */     // GIR_Coverage, 3030,
     /* 185037 */     GIR_EraseRootFromParent_Done,
     /* 185038 */   // Label 3630: @185038
     /* 185038 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(185075), // Rule ID 3031 //
     /* 185043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 185051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185064 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1675:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 185067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185073 */     GIR_RootConstrainSelectedInstOperands,
     /* 185074 */     // GIR_Coverage, 3031,
     /* 185074 */     GIR_EraseRootFromParent_Done,
     /* 185075 */   // Label 3631: @185075
     /* 185075 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(185112), // Rule ID 3078 //
     /* 185080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 185088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1236:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 185104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185110 */     GIR_RootConstrainSelectedInstOperands,
     /* 185111 */     // GIR_Coverage, 3078,
     /* 185111 */     GIR_EraseRootFromParent_Done,
     /* 185112 */   // Label 3632: @185112
     /* 185112 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(185149), // Rule ID 3079 //
     /* 185117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 185125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185138 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1236:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 185141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185147 */     GIR_RootConstrainSelectedInstOperands,
     /* 185148 */     // GIR_Coverage, 3079,
     /* 185148 */     GIR_EraseRootFromParent_Done,
     /* 185149 */   // Label 3633: @185149
     /* 185149 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(185186), // Rule ID 3080 //
     /* 185154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 185162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185175 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1236:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 185178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185184 */     GIR_RootConstrainSelectedInstOperands,
     /* 185185 */     // GIR_Coverage, 3080,
     /* 185185 */     GIR_EraseRootFromParent_Done,
     /* 185186 */   // Label 3634: @185186
     /* 185186 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(185223), // Rule ID 3087 //
     /* 185191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 185199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185212 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1838:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 185215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185221 */     GIR_RootConstrainSelectedInstOperands,
     /* 185222 */     // GIR_Coverage, 3087,
     /* 185222 */     GIR_EraseRootFromParent_Done,
     /* 185223 */   // Label 3635: @185223
     /* 185223 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(185260), // Rule ID 3088 //
     /* 185228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 185236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185249 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1838:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 185252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185258 */     GIR_RootConstrainSelectedInstOperands,
     /* 185259 */     // GIR_Coverage, 3088,
     /* 185259 */     GIR_EraseRootFromParent_Done,
     /* 185260 */   // Label 3636: @185260
     /* 185260 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(185297), // Rule ID 3089 //
     /* 185265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 185273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1838:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 185289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185295 */     GIR_RootConstrainSelectedInstOperands,
     /* 185296 */     // GIR_Coverage, 3089,
     /* 185296 */     GIR_EraseRootFromParent_Done,
     /* 185297 */   // Label 3637: @185297
     /* 185297 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(185337), // Rule ID 3193 //
     /* 185302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 185310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185323 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 185323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 185326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185335 */     GIR_RootConstrainSelectedInstOperands,
     /* 185336 */     // GIR_Coverage, 3193,
     /* 185336 */     GIR_EraseRootFromParent_Done,
     /* 185337 */   // Label 3638: @185337
     /* 185337 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(185377), // Rule ID 3194 //
     /* 185342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 185350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 185353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185363 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 185363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 185366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185375 */     GIR_RootConstrainSelectedInstOperands,
     /* 185376 */     // GIR_Coverage, 3194,
     /* 185376 */     GIR_EraseRootFromParent_Done,
     /* 185377 */   // Label 3639: @185377
     /* 185377 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(185417), // Rule ID 3195 //
     /* 185382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 185390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 185393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185403 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 185403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 185406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185415 */     GIR_RootConstrainSelectedInstOperands,
     /* 185416 */     // GIR_Coverage, 3195,
     /* 185416 */     GIR_EraseRootFromParent_Done,
     /* 185417 */   // Label 3640: @185417
     /* 185417 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(185457), // Rule ID 3196 //
     /* 185422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 185430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 185433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185443 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 185443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 185446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185455 */     GIR_RootConstrainSelectedInstOperands,
     /* 185456 */     // GIR_Coverage, 3196,
     /* 185456 */     GIR_EraseRootFromParent_Done,
     /* 185457 */   // Label 3641: @185457
     /* 185457 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(185497), // Rule ID 3201 //
     /* 185462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 185470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185483 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 185486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185495 */     GIR_RootConstrainSelectedInstOperands,
     /* 185496 */     // GIR_Coverage, 3201,
     /* 185496 */     GIR_EraseRootFromParent_Done,
     /* 185497 */   // Label 3642: @185497
     /* 185497 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(185537), // Rule ID 3202 //
     /* 185502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 185510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 185513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185523 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 185526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185535 */     GIR_RootConstrainSelectedInstOperands,
     /* 185536 */     // GIR_Coverage, 3202,
     /* 185536 */     GIR_EraseRootFromParent_Done,
     /* 185537 */   // Label 3643: @185537
     /* 185537 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(185577), // Rule ID 3203 //
     /* 185542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 185550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 185553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185563 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 185566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185575 */     GIR_RootConstrainSelectedInstOperands,
     /* 185576 */     // GIR_Coverage, 3203,
     /* 185576 */     GIR_EraseRootFromParent_Done,
     /* 185577 */   // Label 3644: @185577
     /* 185577 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(185617), // Rule ID 3204 //
     /* 185582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 185590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 185593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185603 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 185603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 185606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185615 */     GIR_RootConstrainSelectedInstOperands,
     /* 185616 */     // GIR_Coverage, 3204,
     /* 185616 */     GIR_EraseRootFromParent_Done,
     /* 185617 */   // Label 3645: @185617
     /* 185617 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(185654), // Rule ID 3393 //
     /* 185622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 185625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 185630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 185636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185643 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 185646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185652 */     GIR_RootConstrainSelectedInstOperands,
     /* 185653 */     // GIR_Coverage, 3393,
     /* 185653 */     GIR_EraseRootFromParent_Done,
     /* 185654 */   // Label 3646: @185654
     /* 185654 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(185691), // Rule ID 3394 //
     /* 185659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 185662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 185667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 185673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185680 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 185680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 185683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185689 */     GIR_RootConstrainSelectedInstOperands,
     /* 185690 */     // GIR_Coverage, 3394,
     /* 185690 */     GIR_EraseRootFromParent_Done,
     /* 185691 */   // Label 3647: @185691
     /* 185691 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(185728), // Rule ID 3395 //
     /* 185696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 185699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 185704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 185710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185717 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1327:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 185720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185726 */     GIR_RootConstrainSelectedInstOperands,
     /* 185727 */     // GIR_Coverage, 3395,
     /* 185727 */     GIR_EraseRootFromParent_Done,
     /* 185728 */   // Label 3648: @185728
     /* 185728 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(185765), // Rule ID 3396 //
     /* 185733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 185736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 185741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 185747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185754 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1327:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 185754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 185757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185763 */     GIR_RootConstrainSelectedInstOperands,
     /* 185764 */     // GIR_Coverage, 3396,
     /* 185764 */     GIR_EraseRootFromParent_Done,
     /* 185765 */   // Label 3649: @185765
     /* 185765 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(185802), // Rule ID 3418 //
     /* 185770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 185778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185791 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1530:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 185794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185800 */     GIR_RootConstrainSelectedInstOperands,
     /* 185801 */     // GIR_Coverage, 3418,
     /* 185801 */     GIR_EraseRootFromParent_Done,
     /* 185802 */   // Label 3650: @185802
     /* 185802 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(185839), // Rule ID 3419 //
     /* 185807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 185815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185828 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1530:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 185831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185837 */     GIR_RootConstrainSelectedInstOperands,
     /* 185838 */     // GIR_Coverage, 3419,
     /* 185838 */     GIR_EraseRootFromParent_Done,
     /* 185839 */   // Label 3651: @185839
     /* 185839 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(185876), // Rule ID 3420 //
     /* 185844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 185852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185865 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1530:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 185868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185874 */     GIR_RootConstrainSelectedInstOperands,
     /* 185875 */     // GIR_Coverage, 3420,
     /* 185875 */     GIR_EraseRootFromParent_Done,
     /* 185876 */   // Label 3652: @185876
     /* 185876 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(185913), // Rule ID 3442 //
     /* 185881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 185889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185902 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1280:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 185902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 185905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185911 */     GIR_RootConstrainSelectedInstOperands,
     /* 185912 */     // GIR_Coverage, 3442,
     /* 185912 */     GIR_EraseRootFromParent_Done,
     /* 185913 */   // Label 3653: @185913
     /* 185913 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(185950), // Rule ID 3447 //
     /* 185918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 185921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 185926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185939 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1710:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 185942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185948 */     GIR_RootConstrainSelectedInstOperands,
     /* 185949 */     // GIR_Coverage, 3447,
     /* 185949 */     GIR_EraseRootFromParent_Done,
     /* 185950 */   // Label 3654: @185950
     /* 185950 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(185987), // Rule ID 3448 //
     /* 185955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 185958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 185963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185976 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1245:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 185979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185985 */     GIR_RootConstrainSelectedInstOperands,
     /* 185986 */     // GIR_Coverage, 3448,
     /* 185986 */     GIR_EraseRootFromParent_Done,
     /* 185987 */   // Label 3655: @185987
     /* 185987 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(186024), // Rule ID 3457 //
     /* 185992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 185995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186013 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2140:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186022 */     GIR_RootConstrainSelectedInstOperands,
     /* 186023 */     // GIR_Coverage, 3457,
     /* 186023 */     GIR_EraseRootFromParent_Done,
     /* 186024 */   // Label 3656: @186024
     /* 186024 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(186061), // Rule ID 3458 //
     /* 186029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186050 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2140:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186059 */     GIR_RootConstrainSelectedInstOperands,
     /* 186060 */     // GIR_Coverage, 3458,
     /* 186060 */     GIR_EraseRootFromParent_Done,
     /* 186061 */   // Label 3657: @186061
     /* 186061 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(186098), // Rule ID 3459 //
     /* 186066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186087 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2140:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 186087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186096 */     GIR_RootConstrainSelectedInstOperands,
     /* 186097 */     // GIR_Coverage, 3459,
     /* 186097 */     GIR_EraseRootFromParent_Done,
     /* 186098 */   // Label 3658: @186098
     /* 186098 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(186135), // Rule ID 3460 //
     /* 186103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186124 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2140:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186133 */     GIR_RootConstrainSelectedInstOperands,
     /* 186134 */     // GIR_Coverage, 3460,
     /* 186134 */     GIR_EraseRootFromParent_Done,
     /* 186135 */   // Label 3659: @186135
     /* 186135 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(186172), // Rule ID 3461 //
     /* 186140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186161 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2140:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 186161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186170 */     GIR_RootConstrainSelectedInstOperands,
     /* 186171 */     // GIR_Coverage, 3461,
     /* 186171 */     GIR_EraseRootFromParent_Done,
     /* 186172 */   // Label 3660: @186172
     /* 186172 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(186209), // Rule ID 3462 //
     /* 186177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2140:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186207 */     GIR_RootConstrainSelectedInstOperands,
     /* 186208 */     // GIR_Coverage, 3462,
     /* 186208 */     GIR_EraseRootFromParent_Done,
     /* 186209 */   // Label 3661: @186209
     /* 186209 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(186246), // Rule ID 3463 //
     /* 186214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186235 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2140:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 186235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186244 */     GIR_RootConstrainSelectedInstOperands,
     /* 186245 */     // GIR_Coverage, 3463,
     /* 186245 */     GIR_EraseRootFromParent_Done,
     /* 186246 */   // Label 3662: @186246
     /* 186246 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(186283), // Rule ID 3518 //
     /* 186251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 186259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 186265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186272 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1353:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 186272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 186275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 186277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186281 */     GIR_RootConstrainSelectedInstOperands,
     /* 186282 */     // GIR_Coverage, 3518,
     /* 186282 */     GIR_EraseRootFromParent_Done,
     /* 186283 */   // Label 3663: @186283
     /* 186283 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(186320), // Rule ID 3519 //
     /* 186288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 186296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 186302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186309 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1353:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 186309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 186312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 186314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186318 */     GIR_RootConstrainSelectedInstOperands,
     /* 186319 */     // GIR_Coverage, 3519,
     /* 186319 */     GIR_EraseRootFromParent_Done,
     /* 186320 */   // Label 3664: @186320
     /* 186320 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(186357), // Rule ID 3520 //
     /* 186325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 186333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 186339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186346 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1353:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 186346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 186349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 186351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186355 */     GIR_RootConstrainSelectedInstOperands,
     /* 186356 */     // GIR_Coverage, 3520,
     /* 186356 */     GIR_EraseRootFromParent_Done,
     /* 186357 */   // Label 3665: @186357
     /* 186357 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(186394), // Rule ID 3550 //
     /* 186362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 186370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 186373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186383 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1604:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 186386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 186388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186392 */     GIR_RootConstrainSelectedInstOperands,
     /* 186393 */     // GIR_Coverage, 3550,
     /* 186393 */     GIR_EraseRootFromParent_Done,
     /* 186394 */   // Label 3666: @186394
     /* 186394 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(186431), // Rule ID 3551 //
     /* 186399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 186407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 186413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186420 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1604:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 186423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 186425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186429 */     GIR_RootConstrainSelectedInstOperands,
     /* 186430 */     // GIR_Coverage, 3551,
     /* 186430 */     GIR_EraseRootFromParent_Done,
     /* 186431 */   // Label 3667: @186431
     /* 186431 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(186468), // Rule ID 3552 //
     /* 186436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 186444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 186450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186457 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1604:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 186460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 186462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186466 */     GIR_RootConstrainSelectedInstOperands,
     /* 186467 */     // GIR_Coverage, 3552,
     /* 186467 */     GIR_EraseRootFromParent_Done,
     /* 186468 */   // Label 3668: @186468
     /* 186468 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(186505), // Rule ID 3553 //
     /* 186473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 186481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 186487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186494 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1604:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 186497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 186499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186503 */     GIR_RootConstrainSelectedInstOperands,
     /* 186504 */     // GIR_Coverage, 3553,
     /* 186504 */     GIR_EraseRootFromParent_Done,
     /* 186505 */   // Label 3669: @186505
     /* 186505 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(186542), // Rule ID 3554 //
     /* 186510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 186518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186531 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2148:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 186534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186540 */     GIR_RootConstrainSelectedInstOperands,
     /* 186541 */     // GIR_Coverage, 3554,
     /* 186541 */     GIR_EraseRootFromParent_Done,
     /* 186542 */   // Label 3670: @186542
     /* 186542 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(186579), // Rule ID 3555 //
     /* 186547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 186555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2148:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 186571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186577 */     GIR_RootConstrainSelectedInstOperands,
     /* 186578 */     // GIR_Coverage, 3555,
     /* 186578 */     GIR_EraseRootFromParent_Done,
     /* 186579 */   // Label 3671: @186579
     /* 186579 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(186616), // Rule ID 3556 //
     /* 186584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 186592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186605 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2148:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 186608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186614 */     GIR_RootConstrainSelectedInstOperands,
     /* 186615 */     // GIR_Coverage, 3556,
     /* 186615 */     GIR_EraseRootFromParent_Done,
     /* 186616 */   // Label 3672: @186616
     /* 186616 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(186653), // Rule ID 3557 //
     /* 186621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 186629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186642 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2148:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 186645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186651 */     GIR_RootConstrainSelectedInstOperands,
     /* 186652 */     // GIR_Coverage, 3557,
     /* 186652 */     GIR_EraseRootFromParent_Done,
     /* 186653 */   // Label 3673: @186653
     /* 186653 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(186690), // Rule ID 3558 //
     /* 186658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 186666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186679 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2148:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 186679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 186682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186688 */     GIR_RootConstrainSelectedInstOperands,
     /* 186689 */     // GIR_Coverage, 3558,
     /* 186689 */     GIR_EraseRootFromParent_Done,
     /* 186690 */   // Label 3674: @186690
     /* 186690 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(186727), // Rule ID 3559 //
     /* 186695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 186703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186716 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2148:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 186716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 186719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186725 */     GIR_RootConstrainSelectedInstOperands,
     /* 186726 */     // GIR_Coverage, 3559,
     /* 186726 */     GIR_EraseRootFromParent_Done,
     /* 186727 */   // Label 3675: @186727
     /* 186727 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(186764), // Rule ID 3560 //
     /* 186732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 186740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186753 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2148:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 186753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 186756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186762 */     GIR_RootConstrainSelectedInstOperands,
     /* 186763 */     // GIR_Coverage, 3560,
     /* 186763 */     GIR_EraseRootFromParent_Done,
     /* 186764 */   // Label 3676: @186764
     /* 186764 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(186801), // Rule ID 3561 //
     /* 186769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 186777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186790 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1903:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 186793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186799 */     GIR_RootConstrainSelectedInstOperands,
     /* 186800 */     // GIR_Coverage, 3561,
     /* 186800 */     GIR_EraseRootFromParent_Done,
     /* 186801 */   // Label 3677: @186801
     /* 186801 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(186838), // Rule ID 3562 //
     /* 186806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 186814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186827 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1903:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 186830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186836 */     GIR_RootConstrainSelectedInstOperands,
     /* 186837 */     // GIR_Coverage, 3562,
     /* 186837 */     GIR_EraseRootFromParent_Done,
     /* 186838 */   // Label 3678: @186838
     /* 186838 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(186875), // Rule ID 3563 //
     /* 186843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 186851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1903:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 186867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186873 */     GIR_RootConstrainSelectedInstOperands,
     /* 186874 */     // GIR_Coverage, 3563,
     /* 186874 */     GIR_EraseRootFromParent_Done,
     /* 186875 */   // Label 3679: @186875
     /* 186875 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(186912), // Rule ID 3564 //
     /* 186880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 186888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186901 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1903:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 186904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186910 */     GIR_RootConstrainSelectedInstOperands,
     /* 186911 */     // GIR_Coverage, 3564,
     /* 186911 */     GIR_EraseRootFromParent_Done,
     /* 186912 */   // Label 3680: @186912
     /* 186912 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(186949), // Rule ID 3565 //
     /* 186917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 186925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186938 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1903:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 186941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186947 */     GIR_RootConstrainSelectedInstOperands,
     /* 186948 */     // GIR_Coverage, 3565,
     /* 186948 */     GIR_EraseRootFromParent_Done,
     /* 186949 */   // Label 3681: @186949
     /* 186949 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(186986), // Rule ID 3566 //
     /* 186954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 186962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186975 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1903:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 186978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186984 */     GIR_RootConstrainSelectedInstOperands,
     /* 186985 */     // GIR_Coverage, 3566,
     /* 186985 */     GIR_EraseRootFromParent_Done,
     /* 186986 */   // Label 3682: @186986
     /* 186986 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(187023), // Rule ID 3567 //
     /* 186991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 186999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187012 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1903:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 187015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187021 */     GIR_RootConstrainSelectedInstOperands,
     /* 187022 */     // GIR_Coverage, 3567,
     /* 187022 */     GIR_EraseRootFromParent_Done,
     /* 187023 */   // Label 3683: @187023
     /* 187023 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(187060), // Rule ID 8339 //
     /* 187028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 187036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 187045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187049 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1282:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 187049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 187052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187058 */     GIR_RootConstrainSelectedInstOperands,
     /* 187059 */     // GIR_Coverage, 8339,
     /* 187059 */     GIR_EraseRootFromParent_Done,
     /* 187060 */   // Label 3684: @187060
     /* 187060 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(187097), // Rule ID 8815 //
     /* 187065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 187073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187086 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1240:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 187089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187095 */     GIR_RootConstrainSelectedInstOperands,
     /* 187096 */     // GIR_Coverage, 8815,
     /* 187096 */     GIR_EraseRootFromParent_Done,
     /* 187097 */   // Label 3685: @187097
     /* 187097 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(187134), // Rule ID 8816 //
     /* 187102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 187110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187123 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1242:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 187126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187132 */     GIR_RootConstrainSelectedInstOperands,
     /* 187133 */     // GIR_Coverage, 8816,
     /* 187133 */     GIR_EraseRootFromParent_Done,
     /* 187134 */   // Label 3686: @187134
     /* 187134 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(187171), // Rule ID 8817 //
     /* 187139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 187147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1243:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 187163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187169 */     GIR_RootConstrainSelectedInstOperands,
     /* 187170 */     // GIR_Coverage, 8817,
     /* 187170 */     GIR_EraseRootFromParent_Done,
     /* 187171 */   // Label 3687: @187171
     /* 187171 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(187208), // Rule ID 8818 //
     /* 187176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 187184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1241:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 187200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187206 */     GIR_RootConstrainSelectedInstOperands,
     /* 187207 */     // GIR_Coverage, 8818,
     /* 187207 */     GIR_EraseRootFromParent_Done,
     /* 187208 */   // Label 3688: @187208
     /* 187208 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(187245), // Rule ID 8819 //
     /* 187213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 187221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1240:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 187237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187243 */     GIR_RootConstrainSelectedInstOperands,
     /* 187244 */     // GIR_Coverage, 8819,
     /* 187244 */     GIR_EraseRootFromParent_Done,
     /* 187245 */   // Label 3689: @187245
     /* 187245 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(187282), // Rule ID 8820 //
     /* 187250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 187258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187271 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1242:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 187274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187280 */     GIR_RootConstrainSelectedInstOperands,
     /* 187281 */     // GIR_Coverage, 8820,
     /* 187281 */     GIR_EraseRootFromParent_Done,
     /* 187282 */   // Label 3690: @187282
     /* 187282 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(187319), // Rule ID 8821 //
     /* 187287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 187295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187308 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1243:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 187311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187317 */     GIR_RootConstrainSelectedInstOperands,
     /* 187318 */     // GIR_Coverage, 8821,
     /* 187318 */     GIR_EraseRootFromParent_Done,
     /* 187319 */   // Label 3691: @187319
     /* 187319 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(187356), // Rule ID 8822 //
     /* 187324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 187332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187345 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1241:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 187348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187354 */     GIR_RootConstrainSelectedInstOperands,
     /* 187355 */     // GIR_Coverage, 8822,
     /* 187355 */     GIR_EraseRootFromParent_Done,
     /* 187356 */   // Label 3692: @187356
     /* 187356 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(187396), // Rule ID 9822 //
     /* 187361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 187369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187382 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 187385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187394 */     GIR_RootConstrainSelectedInstOperands,
     /* 187395 */     // GIR_Coverage, 9822,
     /* 187395 */     GIR_EraseRootFromParent_Done,
     /* 187396 */   // Label 3693: @187396
     /* 187396 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(187436), // Rule ID 9823 //
     /* 187401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 187409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 187412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187422 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 187425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187431 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187434 */     GIR_RootConstrainSelectedInstOperands,
     /* 187435 */     // GIR_Coverage, 9823,
     /* 187435 */     GIR_EraseRootFromParent_Done,
     /* 187436 */   // Label 3694: @187436
     /* 187436 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(187476), // Rule ID 9824 //
     /* 187441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 187449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 187452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187462 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 187465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187474 */     GIR_RootConstrainSelectedInstOperands,
     /* 187475 */     // GIR_Coverage, 9824,
     /* 187475 */     GIR_EraseRootFromParent_Done,
     /* 187476 */   // Label 3695: @187476
     /* 187476 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(187516), // Rule ID 9825 //
     /* 187481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 187489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 187492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187502 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 187505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187514 */     GIR_RootConstrainSelectedInstOperands,
     /* 187515 */     // GIR_Coverage, 9825,
     /* 187515 */     GIR_EraseRootFromParent_Done,
     /* 187516 */   // Label 3696: @187516
     /* 187516 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(187556), // Rule ID 9826 //
     /* 187521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 187529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187542 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
     /* 187545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187554 */     GIR_RootConstrainSelectedInstOperands,
     /* 187555 */     // GIR_Coverage, 9826,
     /* 187555 */     GIR_EraseRootFromParent_Done,
     /* 187556 */   // Label 3697: @187556
     /* 187556 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(187596), // Rule ID 9827 //
     /* 187561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 187569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 187572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187582 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
     /* 187585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187594 */     GIR_RootConstrainSelectedInstOperands,
     /* 187595 */     // GIR_Coverage, 9827,
     /* 187595 */     GIR_EraseRootFromParent_Done,
     /* 187596 */   // Label 3698: @187596
     /* 187596 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(187636), // Rule ID 9828 //
     /* 187601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 187609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 187612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187622 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
     /* 187625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187634 */     GIR_RootConstrainSelectedInstOperands,
     /* 187635 */     // GIR_Coverage, 9828,
     /* 187635 */     GIR_EraseRootFromParent_Done,
     /* 187636 */   // Label 3699: @187636
     /* 187636 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(187676), // Rule ID 9829 //
     /* 187641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 187649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 187652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187662 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
     /* 187665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187674 */     GIR_RootConstrainSelectedInstOperands,
     /* 187675 */     // GIR_Coverage, 9829,
     /* 187675 */     GIR_EraseRootFromParent_Done,
     /* 187676 */   // Label 3700: @187676
     /* 187676 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(187716), // Rule ID 9834 //
     /* 187681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 187689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187702 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 187705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187714 */     GIR_RootConstrainSelectedInstOperands,
     /* 187715 */     // GIR_Coverage, 9834,
     /* 187715 */     GIR_EraseRootFromParent_Done,
     /* 187716 */   // Label 3701: @187716
     /* 187716 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(187756), // Rule ID 9835 //
     /* 187721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 187729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 187732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187742 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 187745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187754 */     GIR_RootConstrainSelectedInstOperands,
     /* 187755 */     // GIR_Coverage, 9835,
     /* 187755 */     GIR_EraseRootFromParent_Done,
     /* 187756 */   // Label 3702: @187756
     /* 187756 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(187796), // Rule ID 9836 //
     /* 187761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 187769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 187772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187782 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 187785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187794 */     GIR_RootConstrainSelectedInstOperands,
     /* 187795 */     // GIR_Coverage, 9836,
     /* 187795 */     GIR_EraseRootFromParent_Done,
     /* 187796 */   // Label 3703: @187796
     /* 187796 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(187836), // Rule ID 9837 //
     /* 187801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 187809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 187812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 187815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 187818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187822 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 187822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 187825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187834 */     GIR_RootConstrainSelectedInstOperands,
     /* 187835 */     // GIR_Coverage, 9837,
     /* 187835 */     GIR_EraseRootFromParent_Done,
     /* 187836 */   // Label 3704: @187836
     /* 187836 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(187876), // Rule ID 9838 //
     /* 187841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 187849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 187855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 187858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187862 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 187862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 187865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187874 */     GIR_RootConstrainSelectedInstOperands,
     /* 187875 */     // GIR_Coverage, 9838,
     /* 187875 */     GIR_EraseRootFromParent_Done,
     /* 187876 */   // Label 3705: @187876
     /* 187876 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(187916), // Rule ID 9839 //
     /* 187881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 187889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 187892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 187895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 187898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187902 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 187902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 187905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187914 */     GIR_RootConstrainSelectedInstOperands,
     /* 187915 */     // GIR_Coverage, 9839,
     /* 187915 */     GIR_EraseRootFromParent_Done,
     /* 187916 */   // Label 3706: @187916
     /* 187916 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(187956), // Rule ID 9840 //
     /* 187921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 187929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 187932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 187935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 187938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187942 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 187942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 187945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187954 */     GIR_RootConstrainSelectedInstOperands,
     /* 187955 */     // GIR_Coverage, 9840,
     /* 187955 */     GIR_EraseRootFromParent_Done,
     /* 187956 */   // Label 3707: @187956
     /* 187956 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(187996), // Rule ID 9841 //
     /* 187961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 187969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 187972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 187975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 187978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187982 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 187982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 187985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 187994 */     GIR_RootConstrainSelectedInstOperands,
     /* 187995 */     // GIR_Coverage, 9841,
     /* 187995 */     GIR_EraseRootFromParent_Done,
     /* 187996 */   // Label 3708: @187996
     /* 187996 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(188036), // Rule ID 9842 //
     /* 188001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188022 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
     /* 188025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188034 */     GIR_RootConstrainSelectedInstOperands,
     /* 188035 */     // GIR_Coverage, 9842,
     /* 188035 */     GIR_EraseRootFromParent_Done,
     /* 188036 */   // Label 3709: @188036
     /* 188036 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(188076), // Rule ID 9843 //
     /* 188041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188062 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
     /* 188065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188074 */     GIR_RootConstrainSelectedInstOperands,
     /* 188075 */     // GIR_Coverage, 9843,
     /* 188075 */     GIR_EraseRootFromParent_Done,
     /* 188076 */   // Label 3710: @188076
     /* 188076 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(188116), // Rule ID 9844 //
     /* 188081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188102 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
     /* 188105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188114 */     GIR_RootConstrainSelectedInstOperands,
     /* 188115 */     // GIR_Coverage, 9844,
     /* 188115 */     GIR_EraseRootFromParent_Done,
     /* 188116 */   // Label 3711: @188116
     /* 188116 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(188156), // Rule ID 9845 //
     /* 188121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188142 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
     /* 188145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188154 */     GIR_RootConstrainSelectedInstOperands,
     /* 188155 */     // GIR_Coverage, 9845,
     /* 188155 */     GIR_EraseRootFromParent_Done,
     /* 188156 */   // Label 3712: @188156
     /* 188156 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(188196), // Rule ID 9850 //
     /* 188161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188182 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 188185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188194 */     GIR_RootConstrainSelectedInstOperands,
     /* 188195 */     // GIR_Coverage, 9850,
     /* 188195 */     GIR_EraseRootFromParent_Done,
     /* 188196 */   // Label 3713: @188196
     /* 188196 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(188236), // Rule ID 9851 //
     /* 188201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188222 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 188225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188234 */     GIR_RootConstrainSelectedInstOperands,
     /* 188235 */     // GIR_Coverage, 9851,
     /* 188235 */     GIR_EraseRootFromParent_Done,
     /* 188236 */   // Label 3714: @188236
     /* 188236 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(188276), // Rule ID 9852 //
     /* 188241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188262 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 188265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188274 */     GIR_RootConstrainSelectedInstOperands,
     /* 188275 */     // GIR_Coverage, 9852,
     /* 188275 */     GIR_EraseRootFromParent_Done,
     /* 188276 */   // Label 3715: @188276
     /* 188276 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(188316), // Rule ID 9853 //
     /* 188281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188302 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 188305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188314 */     GIR_RootConstrainSelectedInstOperands,
     /* 188315 */     // GIR_Coverage, 9853,
     /* 188315 */     GIR_EraseRootFromParent_Done,
     /* 188316 */   // Label 3716: @188316
     /* 188316 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(188353), // Rule ID 10012 //
     /* 188321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 188329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 188338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188342 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2010:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 188342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 188345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 188347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188351 */     GIR_RootConstrainSelectedInstOperands,
     /* 188352 */     // GIR_Coverage, 10012,
     /* 188352 */     GIR_EraseRootFromParent_Done,
     /* 188353 */   // Label 3717: @188353
     /* 188353 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(188390), // Rule ID 10013 //
     /* 188358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 188366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 188375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188379 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2010:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 188379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 188382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 188384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188388 */     GIR_RootConstrainSelectedInstOperands,
     /* 188389 */     // GIR_Coverage, 10013,
     /* 188389 */     GIR_EraseRootFromParent_Done,
     /* 188390 */   // Label 3718: @188390
     /* 188390 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(188427), // Rule ID 10014 //
     /* 188395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 188403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 188412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2010:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 188416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 188419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 188421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188425 */     GIR_RootConstrainSelectedInstOperands,
     /* 188426 */     // GIR_Coverage, 10014,
     /* 188426 */     GIR_EraseRootFromParent_Done,
     /* 188427 */   // Label 3719: @188427
     /* 188427 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(188464), // Rule ID 10015 //
     /* 188432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 188440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 188449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188453 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1765:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 188453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 188456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 188458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188462 */     GIR_RootConstrainSelectedInstOperands,
     /* 188463 */     // GIR_Coverage, 10015,
     /* 188463 */     GIR_EraseRootFromParent_Done,
     /* 188464 */   // Label 3720: @188464
     /* 188464 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(188501), // Rule ID 10016 //
     /* 188469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 188477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 188486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188490 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1765:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 188490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 188493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 188495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188499 */     GIR_RootConstrainSelectedInstOperands,
     /* 188500 */     // GIR_Coverage, 10016,
     /* 188500 */     GIR_EraseRootFromParent_Done,
     /* 188501 */   // Label 3721: @188501
     /* 188501 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(188538), // Rule ID 10017 //
     /* 188506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 188514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 188523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188527 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1765:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 188527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 188530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 188532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188536 */     GIR_RootConstrainSelectedInstOperands,
     /* 188537 */     // GIR_Coverage, 10017,
     /* 188537 */     GIR_EraseRootFromParent_Done,
     /* 188538 */   // Label 3722: @188538
     /* 188538 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(188575), // Rule ID 10018 //
     /* 188543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 188551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 188560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188564 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1996:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 188564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 188567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 188569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188573 */     GIR_RootConstrainSelectedInstOperands,
     /* 188574 */     // GIR_Coverage, 10018,
     /* 188574 */     GIR_EraseRootFromParent_Done,
     /* 188575 */   // Label 3723: @188575
     /* 188575 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(188612), // Rule ID 10019 //
     /* 188580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 188588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 188597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188601 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 188601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 188604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 188606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188610 */     GIR_RootConstrainSelectedInstOperands,
     /* 188611 */     // GIR_Coverage, 10019,
     /* 188611 */     GIR_EraseRootFromParent_Done,
     /* 188612 */   // Label 3724: @188612
     /* 188612 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(188649), // Rule ID 10020 //
     /* 188617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 188625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 188634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188638 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1996:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 188638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 188641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 188643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188647 */     GIR_RootConstrainSelectedInstOperands,
     /* 188648 */     // GIR_Coverage, 10020,
     /* 188648 */     GIR_EraseRootFromParent_Done,
     /* 188649 */   // Label 3725: @188649
     /* 188649 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(188686), // Rule ID 11188 //
     /* 188654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 188657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 188662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 188665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188675 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2145:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 188678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188684 */     GIR_RootConstrainSelectedInstOperands,
     /* 188685 */     // GIR_Coverage, 11188,
     /* 188685 */     GIR_EraseRootFromParent_Done,
     /* 188686 */   // Label 3726: @188686
     /* 188686 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(188723), // Rule ID 11189 //
     /* 188691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 188694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 188699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2145:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 188715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188721 */     GIR_RootConstrainSelectedInstOperands,
     /* 188722 */     // GIR_Coverage, 11189,
     /* 188722 */     GIR_EraseRootFromParent_Done,
     /* 188723 */   // Label 3727: @188723
     /* 188723 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(188760), // Rule ID 11190 //
     /* 188728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 188731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 188736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188749 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2145:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 188749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 188752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188758 */     GIR_RootConstrainSelectedInstOperands,
     /* 188759 */     // GIR_Coverage, 11190,
     /* 188759 */     GIR_EraseRootFromParent_Done,
     /* 188760 */   // Label 3728: @188760
     /* 188760 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(188797), // Rule ID 11191 //
     /* 188765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 188768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 188773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188786 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2145:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 188789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188795 */     GIR_RootConstrainSelectedInstOperands,
     /* 188796 */     // GIR_Coverage, 11191,
     /* 188796 */     GIR_EraseRootFromParent_Done,
     /* 188797 */   // Label 3729: @188797
     /* 188797 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(188834), // Rule ID 11192 //
     /* 188802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 188805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 188810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188823 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2145:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 188823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 188826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188832 */     GIR_RootConstrainSelectedInstOperands,
     /* 188833 */     // GIR_Coverage, 11192,
     /* 188833 */     GIR_EraseRootFromParent_Done,
     /* 188834 */   // Label 3730: @188834
     /* 188834 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(188871), // Rule ID 11193 //
     /* 188839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 188842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 188847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188860 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2145:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 188863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188869 */     GIR_RootConstrainSelectedInstOperands,
     /* 188870 */     // GIR_Coverage, 11193,
     /* 188870 */     GIR_EraseRootFromParent_Done,
     /* 188871 */   // Label 3731: @188871
     /* 188871 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(188908), // Rule ID 11194 //
     /* 188876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 188879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 188884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188897 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2145:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 188897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 188900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188906 */     GIR_RootConstrainSelectedInstOperands,
     /* 188907 */     // GIR_Coverage, 11194,
     /* 188907 */     GIR_EraseRootFromParent_Done,
     /* 188908 */   // Label 3732: @188908
     /* 188908 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(188945), // Rule ID 11195 //
     /* 188913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 188916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 188921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 188924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188934 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2066:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 188937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188943 */     GIR_RootConstrainSelectedInstOperands,
     /* 188944 */     // GIR_Coverage, 11195,
     /* 188944 */     GIR_EraseRootFromParent_Done,
     /* 188945 */   // Label 3733: @188945
     /* 188945 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(188982), // Rule ID 11196 //
     /* 188950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 188953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 188958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188971 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2066:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 188974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188980 */     GIR_RootConstrainSelectedInstOperands,
     /* 188981 */     // GIR_Coverage, 11196,
     /* 188981 */     GIR_EraseRootFromParent_Done,
     /* 188982 */   // Label 3734: @188982
     /* 188982 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(189019), // Rule ID 11197 //
     /* 188987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 188990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 188995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189008 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2066:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189017 */     GIR_RootConstrainSelectedInstOperands,
     /* 189018 */     // GIR_Coverage, 11197,
     /* 189018 */     GIR_EraseRootFromParent_Done,
     /* 189019 */   // Label 3735: @189019
     /* 189019 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(189056), // Rule ID 11198 //
     /* 189024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189045 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2066:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189054 */     GIR_RootConstrainSelectedInstOperands,
     /* 189055 */     // GIR_Coverage, 11198,
     /* 189055 */     GIR_EraseRootFromParent_Done,
     /* 189056 */   // Label 3736: @189056
     /* 189056 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(189093), // Rule ID 11199 //
     /* 189061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189082 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2066:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189091 */     GIR_RootConstrainSelectedInstOperands,
     /* 189092 */     // GIR_Coverage, 11199,
     /* 189092 */     GIR_EraseRootFromParent_Done,
     /* 189093 */   // Label 3737: @189093
     /* 189093 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(189130), // Rule ID 11200 //
     /* 189098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189119 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2066:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189128 */     GIR_RootConstrainSelectedInstOperands,
     /* 189129 */     // GIR_Coverage, 11200,
     /* 189129 */     GIR_EraseRootFromParent_Done,
     /* 189130 */   // Label 3738: @189130
     /* 189130 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(189167), // Rule ID 11201 //
     /* 189135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189156 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2066:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189165 */     GIR_RootConstrainSelectedInstOperands,
     /* 189166 */     // GIR_Coverage, 11201,
     /* 189166 */     GIR_EraseRootFromParent_Done,
     /* 189167 */   // Label 3739: @189167
     /* 189167 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(189204), // Rule ID 11202 //
     /* 189172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 189180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189193 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2071:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 189196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189202 */     GIR_RootConstrainSelectedInstOperands,
     /* 189203 */     // GIR_Coverage, 11202,
     /* 189203 */     GIR_EraseRootFromParent_Done,
     /* 189204 */   // Label 3740: @189204
     /* 189204 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(189241), // Rule ID 11203 //
     /* 189209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 189217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189230 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2071:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 189233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189239 */     GIR_RootConstrainSelectedInstOperands,
     /* 189240 */     // GIR_Coverage, 11203,
     /* 189240 */     GIR_EraseRootFromParent_Done,
     /* 189241 */   // Label 3741: @189241
     /* 189241 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(189278), // Rule ID 11204 //
     /* 189246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 189254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189267 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2071:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 189270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189276 */     GIR_RootConstrainSelectedInstOperands,
     /* 189277 */     // GIR_Coverage, 11204,
     /* 189277 */     GIR_EraseRootFromParent_Done,
     /* 189278 */   // Label 3742: @189278
     /* 189278 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(189315), // Rule ID 11205 //
     /* 189283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 189291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189304 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2071:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 189307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189313 */     GIR_RootConstrainSelectedInstOperands,
     /* 189314 */     // GIR_Coverage, 11205,
     /* 189314 */     GIR_EraseRootFromParent_Done,
     /* 189315 */   // Label 3743: @189315
     /* 189315 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(189352), // Rule ID 11206 //
     /* 189320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 189328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189341 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2071:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 189344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189350 */     GIR_RootConstrainSelectedInstOperands,
     /* 189351 */     // GIR_Coverage, 11206,
     /* 189351 */     GIR_EraseRootFromParent_Done,
     /* 189352 */   // Label 3744: @189352
     /* 189352 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(189389), // Rule ID 11207 //
     /* 189357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 189365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189378 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2071:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 189381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189387 */     GIR_RootConstrainSelectedInstOperands,
     /* 189388 */     // GIR_Coverage, 11207,
     /* 189388 */     GIR_EraseRootFromParent_Done,
     /* 189389 */   // Label 3745: @189389
     /* 189389 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(189426), // Rule ID 11208 //
     /* 189394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 189402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189415 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2071:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 189418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189424 */     GIR_RootConstrainSelectedInstOperands,
     /* 189425 */     // GIR_Coverage, 11208,
     /* 189425 */     GIR_EraseRootFromParent_Done,
     /* 189426 */   // Label 3746: @189426
     /* 189426 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(189463), // Rule ID 11209 //
     /* 189431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 189439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189452 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1910:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 189455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189461 */     GIR_RootConstrainSelectedInstOperands,
     /* 189462 */     // GIR_Coverage, 11209,
     /* 189462 */     GIR_EraseRootFromParent_Done,
     /* 189463 */   // Label 3747: @189463
     /* 189463 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(189500), // Rule ID 11210 //
     /* 189468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 189476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189489 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1910:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 189492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189498 */     GIR_RootConstrainSelectedInstOperands,
     /* 189499 */     // GIR_Coverage, 11210,
     /* 189499 */     GIR_EraseRootFromParent_Done,
     /* 189500 */   // Label 3748: @189500
     /* 189500 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(189537), // Rule ID 11211 //
     /* 189505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 189513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189526 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1910:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 189529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189535 */     GIR_RootConstrainSelectedInstOperands,
     /* 189536 */     // GIR_Coverage, 11211,
     /* 189536 */     GIR_EraseRootFromParent_Done,
     /* 189537 */   // Label 3749: @189537
     /* 189537 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(189574), // Rule ID 11212 //
     /* 189542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 189550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1910:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 189566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189572 */     GIR_RootConstrainSelectedInstOperands,
     /* 189573 */     // GIR_Coverage, 11212,
     /* 189573 */     GIR_EraseRootFromParent_Done,
     /* 189574 */   // Label 3750: @189574
     /* 189574 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(189611), // Rule ID 11213 //
     /* 189579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 189587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189600 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1910:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 189603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189609 */     GIR_RootConstrainSelectedInstOperands,
     /* 189610 */     // GIR_Coverage, 11213,
     /* 189610 */     GIR_EraseRootFromParent_Done,
     /* 189611 */   // Label 3751: @189611
     /* 189611 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(189648), // Rule ID 11214 //
     /* 189616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 189624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189637 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1910:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 189640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189646 */     GIR_RootConstrainSelectedInstOperands,
     /* 189647 */     // GIR_Coverage, 11214,
     /* 189647 */     GIR_EraseRootFromParent_Done,
     /* 189648 */   // Label 3752: @189648
     /* 189648 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(189685), // Rule ID 11215 //
     /* 189653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 189661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189674 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1910:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 189677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189683 */     GIR_RootConstrainSelectedInstOperands,
     /* 189684 */     // GIR_Coverage, 11215,
     /* 189684 */     GIR_EraseRootFromParent_Done,
     /* 189685 */   // Label 3753: @189685
     /* 189685 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(189722), // Rule ID 11216 //
     /* 189690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 189698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189711 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1915:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 189714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189720 */     GIR_RootConstrainSelectedInstOperands,
     /* 189721 */     // GIR_Coverage, 11216,
     /* 189721 */     GIR_EraseRootFromParent_Done,
     /* 189722 */   // Label 3754: @189722
     /* 189722 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(189759), // Rule ID 11217 //
     /* 189727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 189735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189748 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1915:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 189751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189757 */     GIR_RootConstrainSelectedInstOperands,
     /* 189758 */     // GIR_Coverage, 11217,
     /* 189758 */     GIR_EraseRootFromParent_Done,
     /* 189759 */   // Label 3755: @189759
     /* 189759 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(189796), // Rule ID 11218 //
     /* 189764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 189772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189785 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1915:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 189788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189794 */     GIR_RootConstrainSelectedInstOperands,
     /* 189795 */     // GIR_Coverage, 11218,
     /* 189795 */     GIR_EraseRootFromParent_Done,
     /* 189796 */   // Label 3756: @189796
     /* 189796 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(189833), // Rule ID 11219 //
     /* 189801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 189809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1915:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 189825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189831 */     GIR_RootConstrainSelectedInstOperands,
     /* 189832 */     // GIR_Coverage, 11219,
     /* 189832 */     GIR_EraseRootFromParent_Done,
     /* 189833 */   // Label 3757: @189833
     /* 189833 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(189870), // Rule ID 11220 //
     /* 189838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 189846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189859 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1915:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 189862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189868 */     GIR_RootConstrainSelectedInstOperands,
     /* 189869 */     // GIR_Coverage, 11220,
     /* 189869 */     GIR_EraseRootFromParent_Done,
     /* 189870 */   // Label 3758: @189870
     /* 189870 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(189907), // Rule ID 11221 //
     /* 189875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 189883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189896 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1915:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 189899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189905 */     GIR_RootConstrainSelectedInstOperands,
     /* 189906 */     // GIR_Coverage, 11221,
     /* 189906 */     GIR_EraseRootFromParent_Done,
     /* 189907 */   // Label 3759: @189907
     /* 189907 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(189944), // Rule ID 11222 //
     /* 189912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 189920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189933 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1915:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 189936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189942 */     GIR_RootConstrainSelectedInstOperands,
     /* 189943 */     // GIR_Coverage, 11222,
     /* 189943 */     GIR_EraseRootFromParent_Done,
     /* 189944 */   // Label 3760: @189944
     /* 189944 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(189981), // Rule ID 11242 //
     /* 189949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 189957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189970 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1812:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 189973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189979 */     GIR_RootConstrainSelectedInstOperands,
     /* 189980 */     // GIR_Coverage, 11242,
     /* 189980 */     GIR_EraseRootFromParent_Done,
     /* 189981 */   // Label 3761: @189981
     /* 189981 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(190018), // Rule ID 11243 //
     /* 189986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 189989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 189994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190007 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1812:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 190010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190016 */     GIR_RootConstrainSelectedInstOperands,
     /* 190017 */     // GIR_Coverage, 11243,
     /* 190017 */     GIR_EraseRootFromParent_Done,
     /* 190018 */   // Label 3762: @190018
     /* 190018 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(190055), // Rule ID 11244 //
     /* 190023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 190031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190044 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1812:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 190047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190053 */     GIR_RootConstrainSelectedInstOperands,
     /* 190054 */     // GIR_Coverage, 11244,
     /* 190054 */     GIR_EraseRootFromParent_Done,
     /* 190055 */   // Label 3763: @190055
     /* 190055 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(190092), // Rule ID 11245 //
     /* 190060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 190068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190081 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1812:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 190084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190090 */     GIR_RootConstrainSelectedInstOperands,
     /* 190091 */     // GIR_Coverage, 11245,
     /* 190091 */     GIR_EraseRootFromParent_Done,
     /* 190092 */   // Label 3764: @190092
     /* 190092 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(190129), // Rule ID 11533 //
     /* 190097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 190105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190118 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1676:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 190121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190127 */     GIR_RootConstrainSelectedInstOperands,
     /* 190128 */     // GIR_Coverage, 11533,
     /* 190128 */     GIR_EraseRootFromParent_Done,
     /* 190129 */   // Label 3765: @190129
     /* 190129 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(190166), // Rule ID 11534 //
     /* 190134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 190142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190155 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1676:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 190158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190164 */     GIR_RootConstrainSelectedInstOperands,
     /* 190165 */     // GIR_Coverage, 11534,
     /* 190165 */     GIR_EraseRootFromParent_Done,
     /* 190166 */   // Label 3766: @190166
     /* 190166 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(190203), // Rule ID 11535 //
     /* 190171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 190179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1676:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 190195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190201 */     GIR_RootConstrainSelectedInstOperands,
     /* 190202 */     // GIR_Coverage, 11535,
     /* 190202 */     GIR_EraseRootFromParent_Done,
     /* 190203 */   // Label 3767: @190203
     /* 190203 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(190240), // Rule ID 11536 //
     /* 190208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 190216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190229 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1924:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 190232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190238 */     GIR_RootConstrainSelectedInstOperands,
     /* 190239 */     // GIR_Coverage, 11536,
     /* 190239 */     GIR_EraseRootFromParent_Done,
     /* 190240 */   // Label 3768: @190240
     /* 190240 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(190277), // Rule ID 11537 //
     /* 190245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 190253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190266 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1924:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 190269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190275 */     GIR_RootConstrainSelectedInstOperands,
     /* 190276 */     // GIR_Coverage, 11537,
     /* 190276 */     GIR_EraseRootFromParent_Done,
     /* 190277 */   // Label 3769: @190277
     /* 190277 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(190314), // Rule ID 11538 //
     /* 190282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 190290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 190306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190312 */     GIR_RootConstrainSelectedInstOperands,
     /* 190313 */     // GIR_Coverage, 11538,
     /* 190313 */     GIR_EraseRootFromParent_Done,
     /* 190314 */   // Label 3770: @190314
     /* 190314 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(190351), // Rule ID 11539 //
     /* 190319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 190327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190340 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1925:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 190343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190349 */     GIR_RootConstrainSelectedInstOperands,
     /* 190350 */     // GIR_Coverage, 11539,
     /* 190350 */     GIR_EraseRootFromParent_Done,
     /* 190351 */   // Label 3771: @190351
     /* 190351 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(190388), // Rule ID 11540 //
     /* 190356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 190364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190377 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1925:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 190380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190386 */     GIR_RootConstrainSelectedInstOperands,
     /* 190387 */     // GIR_Coverage, 11540,
     /* 190387 */     GIR_EraseRootFromParent_Done,
     /* 190388 */   // Label 3772: @190388
     /* 190388 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(190425), // Rule ID 11541 //
     /* 190393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 190401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190414 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1925:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 190417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190423 */     GIR_RootConstrainSelectedInstOperands,
     /* 190424 */     // GIR_Coverage, 11541,
     /* 190424 */     GIR_EraseRootFromParent_Done,
     /* 190425 */   // Label 3773: @190425
     /* 190425 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(190462), // Rule ID 11542 //
     /* 190430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 190438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190451 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 190454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190460 */     GIR_RootConstrainSelectedInstOperands,
     /* 190461 */     // GIR_Coverage, 11542,
     /* 190461 */     GIR_EraseRootFromParent_Done,
     /* 190462 */   // Label 3774: @190462
     /* 190462 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(190499), // Rule ID 11543 //
     /* 190467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 190475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190488 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 190491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190497 */     GIR_RootConstrainSelectedInstOperands,
     /* 190498 */     // GIR_Coverage, 11543,
     /* 190498 */     GIR_EraseRootFromParent_Done,
     /* 190499 */   // Label 3775: @190499
     /* 190499 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(190536), // Rule ID 11544 //
     /* 190504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 190512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190525 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 190528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190534 */     GIR_RootConstrainSelectedInstOperands,
     /* 190535 */     // GIR_Coverage, 11544,
     /* 190535 */     GIR_EraseRootFromParent_Done,
     /* 190536 */   // Label 3776: @190536
     /* 190536 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(190573), // Rule ID 11545 //
     /* 190541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 190549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190562 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1855:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 190565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190571 */     GIR_RootConstrainSelectedInstOperands,
     /* 190572 */     // GIR_Coverage, 11545,
     /* 190572 */     GIR_EraseRootFromParent_Done,
     /* 190573 */   // Label 3777: @190573
     /* 190573 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(190610), // Rule ID 11546 //
     /* 190578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 190586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190599 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1855:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 190602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190608 */     GIR_RootConstrainSelectedInstOperands,
     /* 190609 */     // GIR_Coverage, 11546,
     /* 190609 */     GIR_EraseRootFromParent_Done,
     /* 190610 */   // Label 3778: @190610
     /* 190610 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(190647), // Rule ID 11547 //
     /* 190615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 190623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190636 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1855:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 190639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190645 */     GIR_RootConstrainSelectedInstOperands,
     /* 190646 */     // GIR_Coverage, 11547,
     /* 190646 */     GIR_EraseRootFromParent_Done,
     /* 190647 */   // Label 3779: @190647
     /* 190647 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(190684), // Rule ID 11548 //
     /* 190652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 190660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190673 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2049:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 190676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190682 */     GIR_RootConstrainSelectedInstOperands,
     /* 190683 */     // GIR_Coverage, 11548,
     /* 190683 */     GIR_EraseRootFromParent_Done,
     /* 190684 */   // Label 3780: @190684
     /* 190684 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(190721), // Rule ID 11549 //
     /* 190689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 190697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2049:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 190713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190719 */     GIR_RootConstrainSelectedInstOperands,
     /* 190720 */     // GIR_Coverage, 11549,
     /* 190720 */     GIR_EraseRootFromParent_Done,
     /* 190721 */   // Label 3781: @190721
     /* 190721 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(190758), // Rule ID 11550 //
     /* 190726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 190734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190747 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2049:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 190750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190756 */     GIR_RootConstrainSelectedInstOperands,
     /* 190757 */     // GIR_Coverage, 11550,
     /* 190757 */     GIR_EraseRootFromParent_Done,
     /* 190758 */   // Label 3782: @190758
     /* 190758 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(190795), // Rule ID 11551 //
     /* 190763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 190771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190784 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2050:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 190787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190793 */     GIR_RootConstrainSelectedInstOperands,
     /* 190794 */     // GIR_Coverage, 11551,
     /* 190794 */     GIR_EraseRootFromParent_Done,
     /* 190795 */   // Label 3783: @190795
     /* 190795 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(190832), // Rule ID 11552 //
     /* 190800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 190808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190821 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2050:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 190824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190830 */     GIR_RootConstrainSelectedInstOperands,
     /* 190831 */     // GIR_Coverage, 11552,
     /* 190831 */     GIR_EraseRootFromParent_Done,
     /* 190832 */   // Label 3784: @190832
     /* 190832 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(190869), // Rule ID 11553 //
     /* 190837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 190845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190858 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2050:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 190861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190867 */     GIR_RootConstrainSelectedInstOperands,
     /* 190868 */     // GIR_Coverage, 11553,
     /* 190868 */     GIR_EraseRootFromParent_Done,
     /* 190869 */   // Label 3785: @190869
     /* 190869 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(190906), // Rule ID 11554 //
     /* 190874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 190882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190895 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1671:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 190898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190904 */     GIR_RootConstrainSelectedInstOperands,
     /* 190905 */     // GIR_Coverage, 11554,
     /* 190905 */     GIR_EraseRootFromParent_Done,
     /* 190906 */   // Label 3786: @190906
     /* 190906 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(190943), // Rule ID 11555 //
     /* 190911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 190919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190932 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1671:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 190935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190941 */     GIR_RootConstrainSelectedInstOperands,
     /* 190942 */     // GIR_Coverage, 11555,
     /* 190942 */     GIR_EraseRootFromParent_Done,
     /* 190943 */   // Label 3787: @190943
     /* 190943 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(190980), // Rule ID 11556 //
     /* 190948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 190956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190969 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1671:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 190972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190978 */     GIR_RootConstrainSelectedInstOperands,
     /* 190979 */     // GIR_Coverage, 11556,
     /* 190979 */     GIR_EraseRootFromParent_Done,
     /* 190980 */   // Label 3788: @190980
     /* 190980 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(191017), // Rule ID 11557 //
     /* 190985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 190993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191006 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1672:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 191009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191015 */     GIR_RootConstrainSelectedInstOperands,
     /* 191016 */     // GIR_Coverage, 11557,
     /* 191016 */     GIR_EraseRootFromParent_Done,
     /* 191017 */   // Label 3789: @191017
     /* 191017 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(191054), // Rule ID 11558 //
     /* 191022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 191030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1672:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 191046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191052 */     GIR_RootConstrainSelectedInstOperands,
     /* 191053 */     // GIR_Coverage, 11558,
     /* 191053 */     GIR_EraseRootFromParent_Done,
     /* 191054 */   // Label 3790: @191054
     /* 191054 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(191091), // Rule ID 11559 //
     /* 191059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 191067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1672:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 191083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191089 */     GIR_RootConstrainSelectedInstOperands,
     /* 191090 */     // GIR_Coverage, 11559,
     /* 191090 */     GIR_EraseRootFromParent_Done,
     /* 191091 */   // Label 3791: @191091
     /* 191091 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(191128), // Rule ID 11560 //
     /* 191096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 191104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191117 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1921:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 191120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191126 */     GIR_RootConstrainSelectedInstOperands,
     /* 191127 */     // GIR_Coverage, 11560,
     /* 191127 */     GIR_EraseRootFromParent_Done,
     /* 191128 */   // Label 3792: @191128
     /* 191128 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(191165), // Rule ID 11561 //
     /* 191133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 191141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191154 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1921:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 191157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191163 */     GIR_RootConstrainSelectedInstOperands,
     /* 191164 */     // GIR_Coverage, 11561,
     /* 191164 */     GIR_EraseRootFromParent_Done,
     /* 191165 */   // Label 3793: @191165
     /* 191165 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(191202), // Rule ID 11562 //
     /* 191170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 191178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191191 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1921:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 191194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191200 */     GIR_RootConstrainSelectedInstOperands,
     /* 191201 */     // GIR_Coverage, 11562,
     /* 191201 */     GIR_EraseRootFromParent_Done,
     /* 191202 */   // Label 3794: @191202
     /* 191202 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(191239), // Rule ID 11563 //
     /* 191207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 191215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1922:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 191231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191237 */     GIR_RootConstrainSelectedInstOperands,
     /* 191238 */     // GIR_Coverage, 11563,
     /* 191238 */     GIR_EraseRootFromParent_Done,
     /* 191239 */   // Label 3795: @191239
     /* 191239 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(191276), // Rule ID 11564 //
     /* 191244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 191252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191265 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1922:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 191268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191274 */     GIR_RootConstrainSelectedInstOperands,
     /* 191275 */     // GIR_Coverage, 11564,
     /* 191275 */     GIR_EraseRootFromParent_Done,
     /* 191276 */   // Label 3796: @191276
     /* 191276 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(191313), // Rule ID 11565 //
     /* 191281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 191289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1922:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 191305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191311 */     GIR_RootConstrainSelectedInstOperands,
     /* 191312 */     // GIR_Coverage, 11565,
     /* 191312 */     GIR_EraseRootFromParent_Done,
     /* 191313 */   // Label 3797: @191313
     /* 191313 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(191350), // Rule ID 11575 //
     /* 191318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 191326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 191342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191348 */     GIR_RootConstrainSelectedInstOperands,
     /* 191349 */     // GIR_Coverage, 11575,
     /* 191349 */     GIR_EraseRootFromParent_Done,
     /* 191350 */   // Label 3798: @191350
     /* 191350 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(191387), // Rule ID 11576 //
     /* 191355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 191363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 191379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191385 */     GIR_RootConstrainSelectedInstOperands,
     /* 191386 */     // GIR_Coverage, 11576,
     /* 191386 */     GIR_EraseRootFromParent_Done,
     /* 191387 */   // Label 3799: @191387
     /* 191387 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(191424), // Rule ID 11577 //
     /* 191392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 191400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191413 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 191416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191422 */     GIR_RootConstrainSelectedInstOperands,
     /* 191423 */     // GIR_Coverage, 11577,
     /* 191423 */     GIR_EraseRootFromParent_Done,
     /* 191424 */   // Label 3800: @191424
     /* 191424 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(191461), // Rule ID 11578 //
     /* 191429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 191437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191450 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1858:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 191453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191459 */     GIR_RootConstrainSelectedInstOperands,
     /* 191460 */     // GIR_Coverage, 11578,
     /* 191460 */     GIR_EraseRootFromParent_Done,
     /* 191461 */   // Label 3801: @191461
     /* 191461 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(191498), // Rule ID 11579 //
     /* 191466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 191474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191487 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1858:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 191490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191496 */     GIR_RootConstrainSelectedInstOperands,
     /* 191497 */     // GIR_Coverage, 11579,
     /* 191497 */     GIR_EraseRootFromParent_Done,
     /* 191498 */   // Label 3802: @191498
     /* 191498 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(191535), // Rule ID 11580 //
     /* 191503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 191511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191524 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1858:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 191527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191533 */     GIR_RootConstrainSelectedInstOperands,
     /* 191534 */     // GIR_Coverage, 11580,
     /* 191534 */     GIR_EraseRootFromParent_Done,
     /* 191535 */   // Label 3803: @191535
     /* 191535 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(191572), // Rule ID 11581 //
     /* 191540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 191548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191561 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2051:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 191564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191570 */     GIR_RootConstrainSelectedInstOperands,
     /* 191571 */     // GIR_Coverage, 11581,
     /* 191571 */     GIR_EraseRootFromParent_Done,
     /* 191572 */   // Label 3804: @191572
     /* 191572 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(191609), // Rule ID 11582 //
     /* 191577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 191585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2051:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 191601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191607 */     GIR_RootConstrainSelectedInstOperands,
     /* 191608 */     // GIR_Coverage, 11582,
     /* 191608 */     GIR_EraseRootFromParent_Done,
     /* 191609 */   // Label 3805: @191609
     /* 191609 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(191646), // Rule ID 11583 //
     /* 191614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 191622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191635 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2051:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 191638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191644 */     GIR_RootConstrainSelectedInstOperands,
     /* 191645 */     // GIR_Coverage, 11583,
     /* 191645 */     GIR_EraseRootFromParent_Done,
     /* 191646 */   // Label 3806: @191646
     /* 191646 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(191683), // Rule ID 11584 //
     /* 191651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 191659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191672 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2052:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 191675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191681 */     GIR_RootConstrainSelectedInstOperands,
     /* 191682 */     // GIR_Coverage, 11584,
     /* 191682 */     GIR_EraseRootFromParent_Done,
     /* 191683 */   // Label 3807: @191683
     /* 191683 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(191720), // Rule ID 11585 //
     /* 191688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 191696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191709 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2052:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 191712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191718 */     GIR_RootConstrainSelectedInstOperands,
     /* 191719 */     // GIR_Coverage, 11585,
     /* 191719 */     GIR_EraseRootFromParent_Done,
     /* 191720 */   // Label 3808: @191720
     /* 191720 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(191757), // Rule ID 11586 //
     /* 191725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 191733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2052:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 191749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191755 */     GIR_RootConstrainSelectedInstOperands,
     /* 191756 */     // GIR_Coverage, 11586,
     /* 191756 */     GIR_EraseRootFromParent_Done,
     /* 191757 */   // Label 3809: @191757
     /* 191757 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(191794), // Rule ID 11587 //
     /* 191762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 191770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191783 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1787:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 191786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191792 */     GIR_RootConstrainSelectedInstOperands,
     /* 191793 */     // GIR_Coverage, 11587,
     /* 191793 */     GIR_EraseRootFromParent_Done,
     /* 191794 */   // Label 3810: @191794
     /* 191794 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(191831), // Rule ID 11588 //
     /* 191799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 191807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191820 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1787:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 191823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191829 */     GIR_RootConstrainSelectedInstOperands,
     /* 191830 */     // GIR_Coverage, 11588,
     /* 191830 */     GIR_EraseRootFromParent_Done,
     /* 191831 */   // Label 3811: @191831
     /* 191831 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(191868), // Rule ID 11589 //
     /* 191836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 191844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191857 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1787:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 191860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191866 */     GIR_RootConstrainSelectedInstOperands,
     /* 191867 */     // GIR_Coverage, 11589,
     /* 191867 */     GIR_EraseRootFromParent_Done,
     /* 191868 */   // Label 3812: @191868
     /* 191868 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(191905), // Rule ID 11590 //
     /* 191873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 191881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1789:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 191897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191903 */     GIR_RootConstrainSelectedInstOperands,
     /* 191904 */     // GIR_Coverage, 11590,
     /* 191904 */     GIR_EraseRootFromParent_Done,
     /* 191905 */   // Label 3813: @191905
     /* 191905 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(191942), // Rule ID 11591 //
     /* 191910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 191918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191931 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 191934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191940 */     GIR_RootConstrainSelectedInstOperands,
     /* 191941 */     // GIR_Coverage, 11591,
     /* 191941 */     GIR_EraseRootFromParent_Done,
     /* 191942 */   // Label 3814: @191942
     /* 191942 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(191979), // Rule ID 11592 //
     /* 191947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 191955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1789:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 191971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191977 */     GIR_RootConstrainSelectedInstOperands,
     /* 191978 */     // GIR_Coverage, 11592,
     /* 191978 */     GIR_EraseRootFromParent_Done,
     /* 191979 */   // Label 3815: @191979
     /* 191979 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(192016), // Rule ID 11593 //
     /* 191984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 191992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192005 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1740:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 192008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192014 */     GIR_RootConstrainSelectedInstOperands,
     /* 192015 */     // GIR_Coverage, 11593,
     /* 192015 */     GIR_EraseRootFromParent_Done,
     /* 192016 */   // Label 3816: @192016
     /* 192016 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(192053), // Rule ID 11594 //
     /* 192021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 192029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192042 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1740:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 192045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192051 */     GIR_RootConstrainSelectedInstOperands,
     /* 192052 */     // GIR_Coverage, 11594,
     /* 192052 */     GIR_EraseRootFromParent_Done,
     /* 192053 */   // Label 3817: @192053
     /* 192053 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(192090), // Rule ID 11595 //
     /* 192058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 192066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192079 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1740:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 192082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192088 */     GIR_RootConstrainSelectedInstOperands,
     /* 192089 */     // GIR_Coverage, 11595,
     /* 192089 */     GIR_EraseRootFromParent_Done,
     /* 192090 */   // Label 3818: @192090
     /* 192090 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(192127), // Rule ID 11596 //
     /* 192095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 192103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192116 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1742:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 192119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192125 */     GIR_RootConstrainSelectedInstOperands,
     /* 192126 */     // GIR_Coverage, 11596,
     /* 192126 */     GIR_EraseRootFromParent_Done,
     /* 192127 */   // Label 3819: @192127
     /* 192127 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(192164), // Rule ID 11597 //
     /* 192132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 192140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192153 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1742:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 192156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192162 */     GIR_RootConstrainSelectedInstOperands,
     /* 192163 */     // GIR_Coverage, 11597,
     /* 192163 */     GIR_EraseRootFromParent_Done,
     /* 192164 */   // Label 3820: @192164
     /* 192164 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(192201), // Rule ID 11598 //
     /* 192169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 192177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1742:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 192193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192199 */     GIR_RootConstrainSelectedInstOperands,
     /* 192200 */     // GIR_Coverage, 11598,
     /* 192200 */     GIR_EraseRootFromParent_Done,
     /* 192201 */   // Label 3821: @192201
     /* 192201 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(192238), // Rule ID 11599 //
     /* 192206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 192214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1978:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 192230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192236 */     GIR_RootConstrainSelectedInstOperands,
     /* 192237 */     // GIR_Coverage, 11599,
     /* 192237 */     GIR_EraseRootFromParent_Done,
     /* 192238 */   // Label 3822: @192238
     /* 192238 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(192275), // Rule ID 11600 //
     /* 192243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 192251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1978:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 192267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192273 */     GIR_RootConstrainSelectedInstOperands,
     /* 192274 */     // GIR_Coverage, 11600,
     /* 192274 */     GIR_EraseRootFromParent_Done,
     /* 192275 */   // Label 3823: @192275
     /* 192275 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(192312), // Rule ID 11601 //
     /* 192280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 192288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192301 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1978:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 192304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192310 */     GIR_RootConstrainSelectedInstOperands,
     /* 192311 */     // GIR_Coverage, 11601,
     /* 192311 */     GIR_EraseRootFromParent_Done,
     /* 192312 */   // Label 3824: @192312
     /* 192312 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(192349), // Rule ID 11602 //
     /* 192317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 192325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192338 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1980:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 192341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192347 */     GIR_RootConstrainSelectedInstOperands,
     /* 192348 */     // GIR_Coverage, 11602,
     /* 192348 */     GIR_EraseRootFromParent_Done,
     /* 192349 */   // Label 3825: @192349
     /* 192349 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(192386), // Rule ID 11603 //
     /* 192354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 192362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192375 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1980:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 192378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192384 */     GIR_RootConstrainSelectedInstOperands,
     /* 192385 */     // GIR_Coverage, 11603,
     /* 192385 */     GIR_EraseRootFromParent_Done,
     /* 192386 */   // Label 3826: @192386
     /* 192386 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(192423), // Rule ID 11604 //
     /* 192391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 192399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192412 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1980:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 192415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192421 */     GIR_RootConstrainSelectedInstOperands,
     /* 192422 */     // GIR_Coverage, 11604,
     /* 192422 */     GIR_EraseRootFromParent_Done,
     /* 192423 */   // Label 3827: @192423
     /* 192423 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(192460), // Rule ID 11605 //
     /* 192428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 192436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192449 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1618:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 192452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192458 */     GIR_RootConstrainSelectedInstOperands,
     /* 192459 */     // GIR_Coverage, 11605,
     /* 192459 */     GIR_EraseRootFromParent_Done,
     /* 192460 */   // Label 3828: @192460
     /* 192460 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(192497), // Rule ID 11606 //
     /* 192465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 192473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1618:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 192489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192495 */     GIR_RootConstrainSelectedInstOperands,
     /* 192496 */     // GIR_Coverage, 11606,
     /* 192496 */     GIR_EraseRootFromParent_Done,
     /* 192497 */   // Label 3829: @192497
     /* 192497 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(192534), // Rule ID 11707 //
     /* 192502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 192510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192523 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1648:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 192526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192532 */     GIR_RootConstrainSelectedInstOperands,
     /* 192533 */     // GIR_Coverage, 11707,
     /* 192533 */     GIR_EraseRootFromParent_Done,
     /* 192534 */   // Label 3830: @192534
     /* 192534 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(192571), // Rule ID 11708 //
     /* 192539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 192547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192560 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1648:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 192563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192569 */     GIR_RootConstrainSelectedInstOperands,
     /* 192570 */     // GIR_Coverage, 11708,
     /* 192570 */     GIR_EraseRootFromParent_Done,
     /* 192571 */   // Label 3831: @192571
     /* 192571 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(192608), // Rule ID 11709 //
     /* 192576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 192584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192597 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1648:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 192600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192606 */     GIR_RootConstrainSelectedInstOperands,
     /* 192607 */     // GIR_Coverage, 11709,
     /* 192607 */     GIR_EraseRootFromParent_Done,
     /* 192608 */   // Label 3832: @192608
     /* 192608 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(192645), // Rule ID 11710 //
     /* 192613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 192621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192634 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1889:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 192637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192643 */     GIR_RootConstrainSelectedInstOperands,
     /* 192644 */     // GIR_Coverage, 11710,
     /* 192644 */     GIR_EraseRootFromParent_Done,
     /* 192645 */   // Label 3833: @192645
     /* 192645 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(192682), // Rule ID 11711 //
     /* 192650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 192658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192671 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1889:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 192674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192680 */     GIR_RootConstrainSelectedInstOperands,
     /* 192681 */     // GIR_Coverage, 11711,
     /* 192681 */     GIR_EraseRootFromParent_Done,
     /* 192682 */   // Label 3834: @192682
     /* 192682 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(192719), // Rule ID 11712 //
     /* 192687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 192695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1889:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 192711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192717 */     GIR_RootConstrainSelectedInstOperands,
     /* 192718 */     // GIR_Coverage, 11712,
     /* 192718 */     GIR_EraseRootFromParent_Done,
     /* 192719 */   // Label 3835: @192719
     /* 192719 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(192756), // Rule ID 11713 //
     /* 192724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 192732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192745 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1664:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 192748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192754 */     GIR_RootConstrainSelectedInstOperands,
     /* 192755 */     // GIR_Coverage, 11713,
     /* 192755 */     GIR_EraseRootFromParent_Done,
     /* 192756 */   // Label 3836: @192756
     /* 192756 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(192793), // Rule ID 11714 //
     /* 192761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 192769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1664:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 192785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192791 */     GIR_RootConstrainSelectedInstOperands,
     /* 192792 */     // GIR_Coverage, 11714,
     /* 192792 */     GIR_EraseRootFromParent_Done,
     /* 192793 */   // Label 3837: @192793
     /* 192793 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(192830), // Rule ID 11715 //
     /* 192798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 192806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1664:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 192822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192828 */     GIR_RootConstrainSelectedInstOperands,
     /* 192829 */     // GIR_Coverage, 11715,
     /* 192829 */     GIR_EraseRootFromParent_Done,
     /* 192830 */   // Label 3838: @192830
     /* 192830 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(192867), // Rule ID 11731 //
     /* 192835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 192843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192856 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2031:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 192859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192865 */     GIR_RootConstrainSelectedInstOperands,
     /* 192866 */     // GIR_Coverage, 11731,
     /* 192866 */     GIR_EraseRootFromParent_Done,
     /* 192867 */   // Label 3839: @192867
     /* 192867 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(192904), // Rule ID 11732 //
     /* 192872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 192880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2031:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 192896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192902 */     GIR_RootConstrainSelectedInstOperands,
     /* 192903 */     // GIR_Coverage, 11732,
     /* 192903 */     GIR_EraseRootFromParent_Done,
     /* 192904 */   // Label 3840: @192904
     /* 192904 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(192941), // Rule ID 11733 //
     /* 192909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 192917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 192926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2031:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 192930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 192933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192939 */     GIR_RootConstrainSelectedInstOperands,
     /* 192940 */     // GIR_Coverage, 11733,
     /* 192940 */     GIR_EraseRootFromParent_Done,
     /* 192941 */   // Label 3841: @192941
     /* 192941 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(192978), // Rule ID 11734 //
     /* 192946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 192954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 192957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192967 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1840:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 192970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192976 */     GIR_RootConstrainSelectedInstOperands,
     /* 192977 */     // GIR_Coverage, 11734,
     /* 192977 */     GIR_EraseRootFromParent_Done,
     /* 192978 */   // Label 3842: @192978
     /* 192978 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(193015), // Rule ID 11735 //
     /* 192983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 192991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193004 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1840:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 193007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193013 */     GIR_RootConstrainSelectedInstOperands,
     /* 193014 */     // GIR_Coverage, 11735,
     /* 193014 */     GIR_EraseRootFromParent_Done,
     /* 193015 */   // Label 3843: @193015
     /* 193015 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(193052), // Rule ID 11736 //
     /* 193020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 193028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193041 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1840:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 193044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193050 */     GIR_RootConstrainSelectedInstOperands,
     /* 193051 */     // GIR_Coverage, 11736,
     /* 193051 */     GIR_EraseRootFromParent_Done,
     /* 193052 */   // Label 3844: @193052
     /* 193052 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(193089), // Rule ID 11752 //
     /* 193057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 193065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193078 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 193081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193087 */     GIR_RootConstrainSelectedInstOperands,
     /* 193088 */     // GIR_Coverage, 11752,
     /* 193088 */     GIR_EraseRootFromParent_Done,
     /* 193089 */   // Label 3845: @193089
     /* 193089 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(193126), // Rule ID 11753 //
     /* 193094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 193102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193115 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 193118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193124 */     GIR_RootConstrainSelectedInstOperands,
     /* 193125 */     // GIR_Coverage, 11753,
     /* 193125 */     GIR_EraseRootFromParent_Done,
     /* 193126 */   // Label 3846: @193126
     /* 193126 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(193163), // Rule ID 11754 //
     /* 193131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 193139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193152 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1854:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 193155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193161 */     GIR_RootConstrainSelectedInstOperands,
     /* 193162 */     // GIR_Coverage, 11754,
     /* 193162 */     GIR_EraseRootFromParent_Done,
     /* 193163 */   // Label 3847: @193163
     /* 193163 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(193200), // Rule ID 11755 //
     /* 193168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 193176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193189 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1856:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 193192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193198 */     GIR_RootConstrainSelectedInstOperands,
     /* 193199 */     // GIR_Coverage, 11755,
     /* 193199 */     GIR_EraseRootFromParent_Done,
     /* 193200 */   // Label 3848: @193200
     /* 193200 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(193237), // Rule ID 11756 //
     /* 193205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 193213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1856:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 193229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193235 */     GIR_RootConstrainSelectedInstOperands,
     /* 193236 */     // GIR_Coverage, 11756,
     /* 193236 */     GIR_EraseRootFromParent_Done,
     /* 193237 */   // Label 3849: @193237
     /* 193237 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(193274), // Rule ID 11757 //
     /* 193242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 193250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193263 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1856:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 193266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193272 */     GIR_RootConstrainSelectedInstOperands,
     /* 193273 */     // GIR_Coverage, 11757,
     /* 193273 */     GIR_EraseRootFromParent_Done,
     /* 193274 */   // Label 3850: @193274
     /* 193274 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(193314), // Rule ID 11832 //
     /* 193279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 193287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 193290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193300 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2076:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 193303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193312 */     GIR_RootConstrainSelectedInstOperands,
     /* 193313 */     // GIR_Coverage, 11832,
     /* 193313 */     GIR_EraseRootFromParent_Done,
     /* 193314 */   // Label 3851: @193314
     /* 193314 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(193354), // Rule ID 11833 //
     /* 193319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 193327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 193330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193340 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2076:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 193343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193352 */     GIR_RootConstrainSelectedInstOperands,
     /* 193353 */     // GIR_Coverage, 11833,
     /* 193353 */     GIR_EraseRootFromParent_Done,
     /* 193354 */   // Label 3852: @193354
     /* 193354 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(193394), // Rule ID 11834 //
     /* 193359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 193367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 193370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193380 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2076:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 193383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193392 */     GIR_RootConstrainSelectedInstOperands,
     /* 193393 */     // GIR_Coverage, 11834,
     /* 193393 */     GIR_EraseRootFromParent_Done,
     /* 193394 */   // Label 3853: @193394
     /* 193394 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(193434), // Rule ID 11835 //
     /* 193399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 193407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 193410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193420 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2076:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 193423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193432 */     GIR_RootConstrainSelectedInstOperands,
     /* 193433 */     // GIR_Coverage, 11835,
     /* 193433 */     GIR_EraseRootFromParent_Done,
     /* 193434 */   // Label 3854: @193434
     /* 193434 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(193474), // Rule ID 11836 //
     /* 193439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 193447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 193450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193460 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 193463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193472 */     GIR_RootConstrainSelectedInstOperands,
     /* 193473 */     // GIR_Coverage, 11836,
     /* 193473 */     GIR_EraseRootFromParent_Done,
     /* 193474 */   // Label 3855: @193474
     /* 193474 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(193514), // Rule ID 11837 //
     /* 193479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 193487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 193490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193500 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 193503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193512 */     GIR_RootConstrainSelectedInstOperands,
     /* 193513 */     // GIR_Coverage, 11837,
     /* 193513 */     GIR_EraseRootFromParent_Done,
     /* 193514 */   // Label 3856: @193514
     /* 193514 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(193554), // Rule ID 11838 //
     /* 193519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 193527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 193530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193540 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 193543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193552 */     GIR_RootConstrainSelectedInstOperands,
     /* 193553 */     // GIR_Coverage, 11838,
     /* 193553 */     GIR_EraseRootFromParent_Done,
     /* 193554 */   // Label 3857: @193554
     /* 193554 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(193594), // Rule ID 11839 //
     /* 193559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 193567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 193570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193580 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 193583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193592 */     GIR_RootConstrainSelectedInstOperands,
     /* 193593 */     // GIR_Coverage, 11839,
     /* 193593 */     GIR_EraseRootFromParent_Done,
     /* 193594 */   // Label 3858: @193594
     /* 193594 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(193634), // Rule ID 11844 //
     /* 193599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 193607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 193610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193620 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 193623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193632 */     GIR_RootConstrainSelectedInstOperands,
     /* 193633 */     // GIR_Coverage, 11844,
     /* 193633 */     GIR_EraseRootFromParent_Done,
     /* 193634 */   // Label 3859: @193634
     /* 193634 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(193674), // Rule ID 11845 //
     /* 193639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 193647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 193650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193660 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 193663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193672 */     GIR_RootConstrainSelectedInstOperands,
     /* 193673 */     // GIR_Coverage, 11845,
     /* 193673 */     GIR_EraseRootFromParent_Done,
     /* 193674 */   // Label 3860: @193674
     /* 193674 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(193714), // Rule ID 11846 //
     /* 193679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 193687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 193690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193700 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 193703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193712 */     GIR_RootConstrainSelectedInstOperands,
     /* 193713 */     // GIR_Coverage, 11846,
     /* 193713 */     GIR_EraseRootFromParent_Done,
     /* 193714 */   // Label 3861: @193714
     /* 193714 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(193754), // Rule ID 11847 //
     /* 193719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 193727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 193730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193740 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 193743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193752 */     GIR_RootConstrainSelectedInstOperands,
     /* 193753 */     // GIR_Coverage, 11847,
     /* 193753 */     GIR_EraseRootFromParent_Done,
     /* 193754 */   // Label 3862: @193754
     /* 193754 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(193794), // Rule ID 11848 //
     /* 193759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 193767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 193770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193780 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 193783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193792 */     GIR_RootConstrainSelectedInstOperands,
     /* 193793 */     // GIR_Coverage, 11848,
     /* 193793 */     GIR_EraseRootFromParent_Done,
     /* 193794 */   // Label 3863: @193794
     /* 193794 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(193834), // Rule ID 11849 //
     /* 193799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 193807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 193810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193820 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 193823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193832 */     GIR_RootConstrainSelectedInstOperands,
     /* 193833 */     // GIR_Coverage, 11849,
     /* 193833 */     GIR_EraseRootFromParent_Done,
     /* 193834 */   // Label 3864: @193834
     /* 193834 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(193874), // Rule ID 11850 //
     /* 193839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 193847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 193850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193860 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 193863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193872 */     GIR_RootConstrainSelectedInstOperands,
     /* 193873 */     // GIR_Coverage, 11850,
     /* 193873 */     GIR_EraseRootFromParent_Done,
     /* 193874 */   // Label 3865: @193874
     /* 193874 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(193914), // Rule ID 11851 //
     /* 193879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 193887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 193890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 193893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 193896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193900 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 193900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 193903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193912 */     GIR_RootConstrainSelectedInstOperands,
     /* 193913 */     // GIR_Coverage, 11851,
     /* 193913 */     GIR_EraseRootFromParent_Done,
     /* 193914 */   // Label 3866: @193914
     /* 193914 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(193954), // Rule ID 11856 //
     /* 193919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 193927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 193930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 193936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193940 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2076:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 193940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 193943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193952 */     GIR_RootConstrainSelectedInstOperands,
     /* 193953 */     // GIR_Coverage, 11856,
     /* 193953 */     GIR_EraseRootFromParent_Done,
     /* 193954 */   // Label 3867: @193954
     /* 193954 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(193994), // Rule ID 11857 //
     /* 193959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 193967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 193970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 193973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 193976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 193980 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2076:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 193980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 193983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 193985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 193992 */     GIR_RootConstrainSelectedInstOperands,
     /* 193993 */     // GIR_Coverage, 11857,
     /* 193993 */     GIR_EraseRootFromParent_Done,
     /* 193994 */   // Label 3868: @193994
     /* 193994 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(194034), // Rule ID 11858 //
     /* 193999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194020 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2076:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 194023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194032 */     GIR_RootConstrainSelectedInstOperands,
     /* 194033 */     // GIR_Coverage, 11858,
     /* 194033 */     GIR_EraseRootFromParent_Done,
     /* 194034 */   // Label 3869: @194034
     /* 194034 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(194074), // Rule ID 11859 //
     /* 194039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194060 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2076:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 194063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194072 */     GIR_RootConstrainSelectedInstOperands,
     /* 194073 */     // GIR_Coverage, 11859,
     /* 194073 */     GIR_EraseRootFromParent_Done,
     /* 194074 */   // Label 3870: @194074
     /* 194074 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(194114), // Rule ID 11860 //
     /* 194079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194100 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 194103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194112 */     GIR_RootConstrainSelectedInstOperands,
     /* 194113 */     // GIR_Coverage, 11860,
     /* 194113 */     GIR_EraseRootFromParent_Done,
     /* 194114 */   // Label 3871: @194114
     /* 194114 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(194154), // Rule ID 11861 //
     /* 194119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194140 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 194143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194152 */     GIR_RootConstrainSelectedInstOperands,
     /* 194153 */     // GIR_Coverage, 11861,
     /* 194153 */     GIR_EraseRootFromParent_Done,
     /* 194154 */   // Label 3872: @194154
     /* 194154 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(194194), // Rule ID 11862 //
     /* 194159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194180 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 194183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194192 */     GIR_RootConstrainSelectedInstOperands,
     /* 194193 */     // GIR_Coverage, 11862,
     /* 194193 */     GIR_EraseRootFromParent_Done,
     /* 194194 */   // Label 3873: @194194
     /* 194194 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(194234), // Rule ID 11863 //
     /* 194199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194220 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 194223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194232 */     GIR_RootConstrainSelectedInstOperands,
     /* 194233 */     // GIR_Coverage, 11863,
     /* 194233 */     GIR_EraseRootFromParent_Done,
     /* 194234 */   // Label 3874: @194234
     /* 194234 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(194274), // Rule ID 11868 //
     /* 194239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194260 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 194263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194272 */     GIR_RootConstrainSelectedInstOperands,
     /* 194273 */     // GIR_Coverage, 11868,
     /* 194273 */     GIR_EraseRootFromParent_Done,
     /* 194274 */   // Label 3875: @194274
     /* 194274 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(194314), // Rule ID 11869 //
     /* 194279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194300 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 194303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194312 */     GIR_RootConstrainSelectedInstOperands,
     /* 194313 */     // GIR_Coverage, 11869,
     /* 194313 */     GIR_EraseRootFromParent_Done,
     /* 194314 */   // Label 3876: @194314
     /* 194314 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(194354), // Rule ID 11870 //
     /* 194319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194340 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 194343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194352 */     GIR_RootConstrainSelectedInstOperands,
     /* 194353 */     // GIR_Coverage, 11870,
     /* 194353 */     GIR_EraseRootFromParent_Done,
     /* 194354 */   // Label 3877: @194354
     /* 194354 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(194394), // Rule ID 11871 //
     /* 194359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194380 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 194383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194392 */     GIR_RootConstrainSelectedInstOperands,
     /* 194393 */     // GIR_Coverage, 11871,
     /* 194393 */     GIR_EraseRootFromParent_Done,
     /* 194394 */   // Label 3878: @194394
     /* 194394 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(194434), // Rule ID 11872 //
     /* 194399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194420 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 194423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194432 */     GIR_RootConstrainSelectedInstOperands,
     /* 194433 */     // GIR_Coverage, 11872,
     /* 194433 */     GIR_EraseRootFromParent_Done,
     /* 194434 */   // Label 3879: @194434
     /* 194434 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(194474), // Rule ID 11873 //
     /* 194439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194460 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 194463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194472 */     GIR_RootConstrainSelectedInstOperands,
     /* 194473 */     // GIR_Coverage, 11873,
     /* 194473 */     GIR_EraseRootFromParent_Done,
     /* 194474 */   // Label 3880: @194474
     /* 194474 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(194514), // Rule ID 11874 //
     /* 194479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194500 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 194503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194512 */     GIR_RootConstrainSelectedInstOperands,
     /* 194513 */     // GIR_Coverage, 11874,
     /* 194513 */     GIR_EraseRootFromParent_Done,
     /* 194514 */   // Label 3881: @194514
     /* 194514 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(194554), // Rule ID 11875 //
     /* 194519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194540 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 194543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194552 */     GIR_RootConstrainSelectedInstOperands,
     /* 194553 */     // GIR_Coverage, 11875,
     /* 194553 */     GIR_EraseRootFromParent_Done,
     /* 194554 */   // Label 3882: @194554
     /* 194554 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(194591), // Rule ID 11884 //
     /* 194559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 194562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 194567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 194570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194580 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1244:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 194583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 194585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194589 */     GIR_RootConstrainSelectedInstOperands,
     /* 194590 */     // GIR_Coverage, 11884,
     /* 194590 */     GIR_EraseRootFromParent_Done,
     /* 194591 */   // Label 3883: @194591
     /* 194591 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(194628), // Rule ID 11886 //
     /* 194596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 194599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 194604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194617 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1618:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 194617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 194620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194626 */     GIR_RootConstrainSelectedInstOperands,
     /* 194627 */     // GIR_Coverage, 11886,
     /* 194627 */     GIR_EraseRootFromParent_Done,
     /* 194628 */   // Label 3884: @194628
     /* 194628 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(194665), // Rule ID 11887 //
     /* 194633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 194636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 194641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1709:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 194657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 194659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194663 */     GIR_RootConstrainSelectedInstOperands,
     /* 194664 */     // GIR_Coverage, 11887,
     /* 194664 */     GIR_EraseRootFromParent_Done,
     /* 194665 */   // Label 3885: @194665
     /* 194665 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(194702), // Rule ID 11888 //
     /* 194670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 194673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 194678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194691 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1650:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 194691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 194694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194700 */     GIR_RootConstrainSelectedInstOperands,
     /* 194701 */     // GIR_Coverage, 11888,
     /* 194701 */     GIR_EraseRootFromParent_Done,
     /* 194702 */   // Label 3886: @194702
     /* 194702 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(194739), // Rule ID 11889 //
     /* 194707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 194710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 194715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 194718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194728 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 194731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194737 */     GIR_RootConstrainSelectedInstOperands,
     /* 194738 */     // GIR_Coverage, 11889,
     /* 194738 */     GIR_EraseRootFromParent_Done,
     /* 194739 */   // Label 3887: @194739
     /* 194739 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(194776), // Rule ID 11890 //
     /* 194744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 194747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 194752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1258:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 194768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194774 */     GIR_RootConstrainSelectedInstOperands,
     /* 194775 */     // GIR_Coverage, 11890,
     /* 194775 */     GIR_EraseRootFromParent_Done,
     /* 194776 */   // Label 3888: @194776
     /* 194776 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(194813), // Rule ID 11891 //
     /* 194781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 194784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 194789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1258:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 194805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194811 */     GIR_RootConstrainSelectedInstOperands,
     /* 194812 */     // GIR_Coverage, 11891,
     /* 194812 */     GIR_EraseRootFromParent_Done,
     /* 194813 */   // Label 3889: @194813
     /* 194813 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(194850), // Rule ID 11892 //
     /* 194818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 194821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 194826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194839 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1258:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 194839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 194842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194848 */     GIR_RootConstrainSelectedInstOperands,
     /* 194849 */     // GIR_Coverage, 11892,
     /* 194849 */     GIR_EraseRootFromParent_Done,
     /* 194850 */   // Label 3890: @194850
     /* 194850 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(194887), // Rule ID 11893 //
     /* 194855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 194858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 194863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 194866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194876 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1275:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 194879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194885 */     GIR_RootConstrainSelectedInstOperands,
     /* 194886 */     // GIR_Coverage, 11893,
     /* 194886 */     GIR_EraseRootFromParent_Done,
     /* 194887 */   // Label 3891: @194887
     /* 194887 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(194924), // Rule ID 11894 //
     /* 194892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 194895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 194900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194913 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1275:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 194916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194922 */     GIR_RootConstrainSelectedInstOperands,
     /* 194923 */     // GIR_Coverage, 11894,
     /* 194923 */     GIR_EraseRootFromParent_Done,
     /* 194924 */   // Label 3892: @194924
     /* 194924 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(194961), // Rule ID 11895 //
     /* 194929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 194932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 194937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1275:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 194953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194959 */     GIR_RootConstrainSelectedInstOperands,
     /* 194960 */     // GIR_Coverage, 11895,
     /* 194960 */     GIR_EraseRootFromParent_Done,
     /* 194961 */   // Label 3893: @194961
     /* 194961 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(194998), // Rule ID 11896 //
     /* 194966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 194969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 194974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194987 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1275:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 194987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 194990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194996 */     GIR_RootConstrainSelectedInstOperands,
     /* 194997 */     // GIR_Coverage, 11896,
     /* 194997 */     GIR_EraseRootFromParent_Done,
     /* 194998 */   // Label 3894: @194998
     /* 194998 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(195035), // Rule ID 12009 //
     /* 195003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 195011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195024 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1424:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 195024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 195027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195033 */     GIR_RootConstrainSelectedInstOperands,
     /* 195034 */     // GIR_Coverage, 12009,
     /* 195034 */     GIR_EraseRootFromParent_Done,
     /* 195035 */   // Label 3895: @195035
     /* 195035 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(195072), // Rule ID 12010 //
     /* 195040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 195048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195061 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1424:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 195061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 195064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195070 */     GIR_RootConstrainSelectedInstOperands,
     /* 195071 */     // GIR_Coverage, 12010,
     /* 195071 */     GIR_EraseRootFromParent_Done,
     /* 195072 */   // Label 3896: @195072
     /* 195072 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(195109), // Rule ID 12011 //
     /* 195077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 195085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 195091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195098 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1424:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 195098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 195101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195107 */     GIR_RootConstrainSelectedInstOperands,
     /* 195108 */     // GIR_Coverage, 12011,
     /* 195108 */     GIR_EraseRootFromParent_Done,
     /* 195109 */   // Label 3897: @195109
     /* 195109 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(195146), // Rule ID 12012 //
     /* 195114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 195122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195135 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1442:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 195135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 195138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195144 */     GIR_RootConstrainSelectedInstOperands,
     /* 195145 */     // GIR_Coverage, 12012,
     /* 195145 */     GIR_EraseRootFromParent_Done,
     /* 195146 */   // Label 3898: @195146
     /* 195146 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(195183), // Rule ID 12013 //
     /* 195151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 195159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195172 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1442:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 195172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 195175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195181 */     GIR_RootConstrainSelectedInstOperands,
     /* 195182 */     // GIR_Coverage, 12013,
     /* 195182 */     GIR_EraseRootFromParent_Done,
     /* 195183 */   // Label 3899: @195183
     /* 195183 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(195220), // Rule ID 12014 //
     /* 195188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 195196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 195202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195209 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1442:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 195209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 195212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195218 */     GIR_RootConstrainSelectedInstOperands,
     /* 195219 */     // GIR_Coverage, 12014,
     /* 195219 */     GIR_EraseRootFromParent_Done,
     /* 195220 */   // Label 3900: @195220
     /* 195220 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(195257), // Rule ID 12015 //
     /* 195225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 195233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195246 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1427:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 195246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 195249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195255 */     GIR_RootConstrainSelectedInstOperands,
     /* 195256 */     // GIR_Coverage, 12015,
     /* 195256 */     GIR_EraseRootFromParent_Done,
     /* 195257 */   // Label 3901: @195257
     /* 195257 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(195294), // Rule ID 12016 //
     /* 195262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 195270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195283 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1427:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 195283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 195286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195292 */     GIR_RootConstrainSelectedInstOperands,
     /* 195293 */     // GIR_Coverage, 12016,
     /* 195293 */     GIR_EraseRootFromParent_Done,
     /* 195294 */   // Label 3902: @195294
     /* 195294 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(195331), // Rule ID 12017 //
     /* 195299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 195307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 195313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195320 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1427:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 195320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 195323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195329 */     GIR_RootConstrainSelectedInstOperands,
     /* 195330 */     // GIR_Coverage, 12017,
     /* 195330 */     GIR_EraseRootFromParent_Done,
     /* 195331 */   // Label 3903: @195331
     /* 195331 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(195368), // Rule ID 12018 //
     /* 195336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 195344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195357 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1445:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 195357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 195360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195366 */     GIR_RootConstrainSelectedInstOperands,
     /* 195367 */     // GIR_Coverage, 12018,
     /* 195367 */     GIR_EraseRootFromParent_Done,
     /* 195368 */   // Label 3904: @195368
     /* 195368 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(195405), // Rule ID 12019 //
     /* 195373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 195381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195394 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1445:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 195394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 195397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195403 */     GIR_RootConstrainSelectedInstOperands,
     /* 195404 */     // GIR_Coverage, 12019,
     /* 195404 */     GIR_EraseRootFromParent_Done,
     /* 195405 */   // Label 3905: @195405
     /* 195405 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(195442), // Rule ID 12020 //
     /* 195410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 195418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 195424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195431 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1445:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 195431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 195434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195440 */     GIR_RootConstrainSelectedInstOperands,
     /* 195441 */     // GIR_Coverage, 12020,
     /* 195441 */     GIR_EraseRootFromParent_Done,
     /* 195442 */   // Label 3906: @195442
     /* 195442 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(195479), // Rule ID 12021 //
     /* 195447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 195455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 195458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 195461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195468 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1339:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 195471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195477 */     GIR_RootConstrainSelectedInstOperands,
     /* 195478 */     // GIR_Coverage, 12021,
     /* 195478 */     GIR_EraseRootFromParent_Done,
     /* 195479 */   // Label 3907: @195479
     /* 195479 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(195516), // Rule ID 12022 //
     /* 195484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 195492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195505 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1339:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 195508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195514 */     GIR_RootConstrainSelectedInstOperands,
     /* 195515 */     // GIR_Coverage, 12022,
     /* 195515 */     GIR_EraseRootFromParent_Done,
     /* 195516 */   // Label 3908: @195516
     /* 195516 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(195553), // Rule ID 12023 //
     /* 195521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 195529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195542 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1339:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 195545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195551 */     GIR_RootConstrainSelectedInstOperands,
     /* 195552 */     // GIR_Coverage, 12023,
     /* 195552 */     GIR_EraseRootFromParent_Done,
     /* 195553 */   // Label 3909: @195553
     /* 195553 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(195590), // Rule ID 12024 //
     /* 195558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 195566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 195572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195579 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1339:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 195582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195588 */     GIR_RootConstrainSelectedInstOperands,
     /* 195589 */     // GIR_Coverage, 12024,
     /* 195589 */     GIR_EraseRootFromParent_Done,
     /* 195590 */   // Label 3910: @195590
     /* 195590 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(195627), // Rule ID 12025 //
     /* 195595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 195603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 195606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 195609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195616 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1251:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 195619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195625 */     GIR_RootConstrainSelectedInstOperands,
     /* 195626 */     // GIR_Coverage, 12025,
     /* 195626 */     GIR_EraseRootFromParent_Done,
     /* 195627 */   // Label 3911: @195627
     /* 195627 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(195664), // Rule ID 12026 //
     /* 195632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 195640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195653 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1251:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 195656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195662 */     GIR_RootConstrainSelectedInstOperands,
     /* 195663 */     // GIR_Coverage, 12026,
     /* 195663 */     GIR_EraseRootFromParent_Done,
     /* 195664 */   // Label 3912: @195664
     /* 195664 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(195701), // Rule ID 12027 //
     /* 195669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 195677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195690 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1251:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 195693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195699 */     GIR_RootConstrainSelectedInstOperands,
     /* 195700 */     // GIR_Coverage, 12027,
     /* 195700 */     GIR_EraseRootFromParent_Done,
     /* 195701 */   // Label 3913: @195701
     /* 195701 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(195738), // Rule ID 12028 //
     /* 195706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 195714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 195720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195727 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1251:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 195730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195736 */     GIR_RootConstrainSelectedInstOperands,
     /* 195737 */     // GIR_Coverage, 12028,
     /* 195737 */     GIR_EraseRootFromParent_Done,
     /* 195738 */   // Label 3914: @195738
     /* 195738 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(195775), // Rule ID 12029 //
     /* 195743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 195751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 195754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 195757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195764 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1239:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 195767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195773 */     GIR_RootConstrainSelectedInstOperands,
     /* 195774 */     // GIR_Coverage, 12029,
     /* 195774 */     GIR_EraseRootFromParent_Done,
     /* 195775 */   // Label 3915: @195775
     /* 195775 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(195812), // Rule ID 12030 //
     /* 195780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 195788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195801 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1239:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 195804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195810 */     GIR_RootConstrainSelectedInstOperands,
     /* 195811 */     // GIR_Coverage, 12030,
     /* 195811 */     GIR_EraseRootFromParent_Done,
     /* 195812 */   // Label 3916: @195812
     /* 195812 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(195849), // Rule ID 12031 //
     /* 195817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 195825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195838 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1239:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 195841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195847 */     GIR_RootConstrainSelectedInstOperands,
     /* 195848 */     // GIR_Coverage, 12031,
     /* 195848 */     GIR_EraseRootFromParent_Done,
     /* 195849 */   // Label 3917: @195849
     /* 195849 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(195886), // Rule ID 12032 //
     /* 195854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 195862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 195868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195875 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1239:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 195878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195884 */     GIR_RootConstrainSelectedInstOperands,
     /* 195885 */     // GIR_Coverage, 12032,
     /* 195885 */     GIR_EraseRootFromParent_Done,
     /* 195886 */   // Label 3918: @195886
     /* 195886 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(195923), // Rule ID 12033 //
     /* 195891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 195899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 195902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 195905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195912 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1718:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 195915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195921 */     GIR_RootConstrainSelectedInstOperands,
     /* 195922 */     // GIR_Coverage, 12033,
     /* 195922 */     GIR_EraseRootFromParent_Done,
     /* 195923 */   // Label 3919: @195923
     /* 195923 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(195960), // Rule ID 12034 //
     /* 195928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 195936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195949 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1718:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 195952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195958 */     GIR_RootConstrainSelectedInstOperands,
     /* 195959 */     // GIR_Coverage, 12034,
     /* 195959 */     GIR_EraseRootFromParent_Done,
     /* 195960 */   // Label 3920: @195960
     /* 195960 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(195997), // Rule ID 12035 //
     /* 195965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 195973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195986 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1718:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 195989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195995 */     GIR_RootConstrainSelectedInstOperands,
     /* 195996 */     // GIR_Coverage, 12035,
     /* 195996 */     GIR_EraseRootFromParent_Done,
     /* 195997 */   // Label 3921: @195997
     /* 195997 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(196034), // Rule ID 12036 //
     /* 196002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 196010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196023 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1718:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 196026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196032 */     GIR_RootConstrainSelectedInstOperands,
     /* 196033 */     // GIR_Coverage, 12036,
     /* 196033 */     GIR_EraseRootFromParent_Done,
     /* 196034 */   // Label 3922: @196034
     /* 196034 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(196071), // Rule ID 12037 //
     /* 196039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196060 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1956:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 196063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196069 */     GIR_RootConstrainSelectedInstOperands,
     /* 196070 */     // GIR_Coverage, 12037,
     /* 196070 */     GIR_EraseRootFromParent_Done,
     /* 196071 */   // Label 3923: @196071
     /* 196071 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(196108), // Rule ID 12038 //
     /* 196076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196097 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1956:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 196100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196106 */     GIR_RootConstrainSelectedInstOperands,
     /* 196107 */     // GIR_Coverage, 12038,
     /* 196107 */     GIR_EraseRootFromParent_Done,
     /* 196108 */   // Label 3924: @196108
     /* 196108 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(196145), // Rule ID 12039 //
     /* 196113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196134 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1956:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 196137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196143 */     GIR_RootConstrainSelectedInstOperands,
     /* 196144 */     // GIR_Coverage, 12039,
     /* 196144 */     GIR_EraseRootFromParent_Done,
     /* 196145 */   // Label 3925: @196145
     /* 196145 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(196182), // Rule ID 12040 //
     /* 196150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196171 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1956:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 196174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196180 */     GIR_RootConstrainSelectedInstOperands,
     /* 196181 */     // GIR_Coverage, 12040,
     /* 196181 */     GIR_EraseRootFromParent_Done,
     /* 196182 */   // Label 3926: @196182
     /* 196182 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(196219), // Rule ID 12041 //
     /* 196187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 196195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196208 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1727:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 196211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196217 */     GIR_RootConstrainSelectedInstOperands,
     /* 196218 */     // GIR_Coverage, 12041,
     /* 196218 */     GIR_EraseRootFromParent_Done,
     /* 196219 */   // Label 3927: @196219
     /* 196219 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(196256), // Rule ID 12042 //
     /* 196224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 196232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196245 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1727:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 196248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196254 */     GIR_RootConstrainSelectedInstOperands,
     /* 196255 */     // GIR_Coverage, 12042,
     /* 196255 */     GIR_EraseRootFromParent_Done,
     /* 196256 */   // Label 3928: @196256
     /* 196256 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(196293), // Rule ID 12043 //
     /* 196261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 196269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196282 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1727:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 196285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196291 */     GIR_RootConstrainSelectedInstOperands,
     /* 196292 */     // GIR_Coverage, 12043,
     /* 196292 */     GIR_EraseRootFromParent_Done,
     /* 196293 */   // Label 3929: @196293
     /* 196293 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(196330), // Rule ID 12044 //
     /* 196298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 196306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196319 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1727:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 196322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196328 */     GIR_RootConstrainSelectedInstOperands,
     /* 196329 */     // GIR_Coverage, 12044,
     /* 196329 */     GIR_EraseRootFromParent_Done,
     /* 196330 */   // Label 3930: @196330
     /* 196330 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(196367), // Rule ID 12045 //
     /* 196335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 196343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196356 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1965:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 196359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196365 */     GIR_RootConstrainSelectedInstOperands,
     /* 196366 */     // GIR_Coverage, 12045,
     /* 196366 */     GIR_EraseRootFromParent_Done,
     /* 196367 */   // Label 3931: @196367
     /* 196367 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(196404), // Rule ID 12046 //
     /* 196372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 196380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196393 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1965:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 196396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196402 */     GIR_RootConstrainSelectedInstOperands,
     /* 196403 */     // GIR_Coverage, 12046,
     /* 196403 */     GIR_EraseRootFromParent_Done,
     /* 196404 */   // Label 3932: @196404
     /* 196404 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(196441), // Rule ID 12047 //
     /* 196409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 196417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196430 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1965:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 196433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196439 */     GIR_RootConstrainSelectedInstOperands,
     /* 196440 */     // GIR_Coverage, 12047,
     /* 196440 */     GIR_EraseRootFromParent_Done,
     /* 196441 */   // Label 3933: @196441
     /* 196441 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(196478), // Rule ID 12048 //
     /* 196446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 196454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196467 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1965:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 196470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196476 */     GIR_RootConstrainSelectedInstOperands,
     /* 196477 */     // GIR_Coverage, 12048,
     /* 196477 */     GIR_EraseRootFromParent_Done,
     /* 196478 */   // Label 3934: @196478
     /* 196478 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(196515), // Rule ID 12049 //
     /* 196483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 196491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 196494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 196497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196504 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2149:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 196507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196513 */     GIR_RootConstrainSelectedInstOperands,
     /* 196514 */     // GIR_Coverage, 12049,
     /* 196514 */     GIR_EraseRootFromParent_Done,
     /* 196515 */   // Label 3935: @196515
     /* 196515 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(196552), // Rule ID 12050 //
     /* 196520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 196528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196541 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2149:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 196544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196550 */     GIR_RootConstrainSelectedInstOperands,
     /* 196551 */     // GIR_Coverage, 12050,
     /* 196551 */     GIR_EraseRootFromParent_Done,
     /* 196552 */   // Label 3936: @196552
     /* 196552 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(196589), // Rule ID 12051 //
     /* 196557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 196565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196578 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2149:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 196581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196587 */     GIR_RootConstrainSelectedInstOperands,
     /* 196588 */     // GIR_Coverage, 12051,
     /* 196588 */     GIR_EraseRootFromParent_Done,
     /* 196589 */   // Label 3937: @196589
     /* 196589 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(196626), // Rule ID 12052 //
     /* 196594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 196602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196615 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2149:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 196618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196624 */     GIR_RootConstrainSelectedInstOperands,
     /* 196625 */     // GIR_Coverage, 12052,
     /* 196625 */     GIR_EraseRootFromParent_Done,
     /* 196626 */   // Label 3938: @196626
     /* 196626 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(196663), // Rule ID 12053 //
     /* 196631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 196639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196652 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2149:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 196652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 196655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196661 */     GIR_RootConstrainSelectedInstOperands,
     /* 196662 */     // GIR_Coverage, 12053,
     /* 196662 */     GIR_EraseRootFromParent_Done,
     /* 196663 */   // Label 3939: @196663
     /* 196663 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(196700), // Rule ID 12054 //
     /* 196668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 196676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196689 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2149:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 196692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196698 */     GIR_RootConstrainSelectedInstOperands,
     /* 196699 */     // GIR_Coverage, 12054,
     /* 196699 */     GIR_EraseRootFromParent_Done,
     /* 196700 */   // Label 3940: @196700
     /* 196700 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(196737), // Rule ID 12055 //
     /* 196705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 196713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196726 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2149:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 196729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196735 */     GIR_RootConstrainSelectedInstOperands,
     /* 196736 */     // GIR_Coverage, 12055,
     /* 196736 */     GIR_EraseRootFromParent_Done,
     /* 196737 */   // Label 3941: @196737
     /* 196737 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(196774), // Rule ID 12056 //
     /* 196742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 196750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 196753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 196756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196763 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2074:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 196766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196772 */     GIR_RootConstrainSelectedInstOperands,
     /* 196773 */     // GIR_Coverage, 12056,
     /* 196773 */     GIR_EraseRootFromParent_Done,
     /* 196774 */   // Label 3942: @196774
     /* 196774 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(196811), // Rule ID 12057 //
     /* 196779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 196787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196800 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2074:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 196803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196809 */     GIR_RootConstrainSelectedInstOperands,
     /* 196810 */     // GIR_Coverage, 12057,
     /* 196810 */     GIR_EraseRootFromParent_Done,
     /* 196811 */   // Label 3943: @196811
     /* 196811 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(196848), // Rule ID 12058 //
     /* 196816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 196824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196837 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2074:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 196840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196846 */     GIR_RootConstrainSelectedInstOperands,
     /* 196847 */     // GIR_Coverage, 12058,
     /* 196847 */     GIR_EraseRootFromParent_Done,
     /* 196848 */   // Label 3944: @196848
     /* 196848 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(196885), // Rule ID 12059 //
     /* 196853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 196861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2074:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 196877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196883 */     GIR_RootConstrainSelectedInstOperands,
     /* 196884 */     // GIR_Coverage, 12059,
     /* 196884 */     GIR_EraseRootFromParent_Done,
     /* 196885 */   // Label 3945: @196885
     /* 196885 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(196922), // Rule ID 12060 //
     /* 196890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 196898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196911 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2074:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 196911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 196914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196920 */     GIR_RootConstrainSelectedInstOperands,
     /* 196921 */     // GIR_Coverage, 12060,
     /* 196921 */     GIR_EraseRootFromParent_Done,
     /* 196922 */   // Label 3946: @196922
     /* 196922 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(196959), // Rule ID 12061 //
     /* 196927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 196935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196948 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2074:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 196951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196957 */     GIR_RootConstrainSelectedInstOperands,
     /* 196958 */     // GIR_Coverage, 12061,
     /* 196958 */     GIR_EraseRootFromParent_Done,
     /* 196959 */   // Label 3947: @196959
     /* 196959 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(196996), // Rule ID 12062 //
     /* 196964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 196972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196985 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2074:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 196988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196994 */     GIR_RootConstrainSelectedInstOperands,
     /* 196995 */     // GIR_Coverage, 12062,
     /* 196995 */     GIR_EraseRootFromParent_Done,
     /* 196996 */   // Label 3948: @196996
     /* 196996 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(197033), // Rule ID 12063 //
     /* 197001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197022 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2075:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 197025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197031 */     GIR_RootConstrainSelectedInstOperands,
     /* 197032 */     // GIR_Coverage, 12063,
     /* 197032 */     GIR_EraseRootFromParent_Done,
     /* 197033 */   // Label 3949: @197033
     /* 197033 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(197070), // Rule ID 12064 //
     /* 197038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197059 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2075:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 197062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197068 */     GIR_RootConstrainSelectedInstOperands,
     /* 197069 */     // GIR_Coverage, 12064,
     /* 197069 */     GIR_EraseRootFromParent_Done,
     /* 197070 */   // Label 3950: @197070
     /* 197070 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(197107), // Rule ID 12065 //
     /* 197075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2075:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 197099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197105 */     GIR_RootConstrainSelectedInstOperands,
     /* 197106 */     // GIR_Coverage, 12065,
     /* 197106 */     GIR_EraseRootFromParent_Done,
     /* 197107 */   // Label 3951: @197107
     /* 197107 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(197144), // Rule ID 12066 //
     /* 197112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197133 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2075:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 197136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197142 */     GIR_RootConstrainSelectedInstOperands,
     /* 197143 */     // GIR_Coverage, 12066,
     /* 197143 */     GIR_EraseRootFromParent_Done,
     /* 197144 */   // Label 3952: @197144
     /* 197144 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(197181), // Rule ID 12067 //
     /* 197149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197170 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2075:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 197170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 197173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197179 */     GIR_RootConstrainSelectedInstOperands,
     /* 197180 */     // GIR_Coverage, 12067,
     /* 197180 */     GIR_EraseRootFromParent_Done,
     /* 197181 */   // Label 3953: @197181
     /* 197181 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(197218), // Rule ID 12068 //
     /* 197186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197207 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2075:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 197207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 197210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197216 */     GIR_RootConstrainSelectedInstOperands,
     /* 197217 */     // GIR_Coverage, 12068,
     /* 197217 */     GIR_EraseRootFromParent_Done,
     /* 197218 */   // Label 3954: @197218
     /* 197218 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(197255), // Rule ID 12069 //
     /* 197223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197244 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2075:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 197244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 197247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197253 */     GIR_RootConstrainSelectedInstOperands,
     /* 197254 */     // GIR_Coverage, 12069,
     /* 197254 */     GIR_EraseRootFromParent_Done,
     /* 197255 */   // Label 3955: @197255
     /* 197255 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(197297), // Rule ID 3209 //
     /* 197260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 197268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 197271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197275 */     // MIs[0] Op1
     /* 197275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 197279 */     // MIs[0] Op2
     /* 197279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 197283 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2128:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 197286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197295 */     GIR_RootConstrainSelectedInstOperands,
     /* 197296 */     // GIR_Coverage, 3209,
     /* 197296 */     GIR_EraseRootFromParent_Done,
     /* 197297 */   // Label 3956: @197297
     /* 197297 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(197339), // Rule ID 3210 //
     /* 197302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 197310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 197313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197317 */     // MIs[0] Op1
     /* 197317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 197321 */     // MIs[0] Op2
     /* 197321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 197325 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2130:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 197328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197337 */     GIR_RootConstrainSelectedInstOperands,
     /* 197338 */     // GIR_Coverage, 3210,
     /* 197338 */     GIR_EraseRootFromParent_Done,
     /* 197339 */   // Label 3957: @197339
     /* 197339 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(197381), // Rule ID 3211 //
     /* 197344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 197352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 197355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197359 */     // MIs[0] Op1
     /* 197359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 197363 */     // MIs[0] Op2
     /* 197363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 197367 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2131:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 197370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197379 */     GIR_RootConstrainSelectedInstOperands,
     /* 197380 */     // GIR_Coverage, 3211,
     /* 197380 */     GIR_EraseRootFromParent_Done,
     /* 197381 */   // Label 3958: @197381
     /* 197381 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(197423), // Rule ID 3212 //
     /* 197386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 197394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 197397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197401 */     // MIs[0] Op1
     /* 197401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 197405 */     // MIs[0] Op2
     /* 197405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 197409 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2129:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 197412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197421 */     GIR_RootConstrainSelectedInstOperands,
     /* 197422 */     // GIR_Coverage, 3212,
     /* 197422 */     GIR_EraseRootFromParent_Done,
     /* 197423 */   // Label 3959: @197423
     /* 197423 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(197465), // Rule ID 11880 //
     /* 197428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 197436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 197439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197443 */     // MIs[0] Op1
     /* 197443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 197447 */     // MIs[0] Op2
     /* 197447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 197451 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 197454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197463 */     GIR_RootConstrainSelectedInstOperands,
     /* 197464 */     // GIR_Coverage, 11880,
     /* 197464 */     GIR_EraseRootFromParent_Done,
     /* 197465 */   // Label 3960: @197465
     /* 197465 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(197507), // Rule ID 11881 //
     /* 197470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 197478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 197481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197485 */     // MIs[0] Op1
     /* 197485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 197489 */     // MIs[0] Op2
     /* 197489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 197493 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 197496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197505 */     GIR_RootConstrainSelectedInstOperands,
     /* 197506 */     // GIR_Coverage, 11881,
     /* 197506 */     GIR_EraseRootFromParent_Done,
     /* 197507 */   // Label 3961: @197507
     /* 197507 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(197549), // Rule ID 11882 //
     /* 197512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 197520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 197523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197527 */     // MIs[0] Op1
     /* 197527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 197531 */     // MIs[0] Op2
     /* 197531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 197535 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2127:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 197538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197547 */     GIR_RootConstrainSelectedInstOperands,
     /* 197548 */     // GIR_Coverage, 11882,
     /* 197548 */     GIR_EraseRootFromParent_Done,
     /* 197549 */   // Label 3962: @197549
     /* 197549 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(197591), // Rule ID 11883 //
     /* 197554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 197562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 197565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197569 */     // MIs[0] Op1
     /* 197569 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 197573 */     // MIs[0] Op2
     /* 197573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 197577 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2125:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 197577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 197580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 197582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 197589 */     GIR_RootConstrainSelectedInstOperands,
     /* 197590 */     // GIR_Coverage, 11883,
     /* 197590 */     GIR_EraseRootFromParent_Done,
     /* 197591 */   // Label 3963: @197591
     /* 197591 */   GIM_Reject,
     /* 197592 */ // Label 3010: @197592
     /* 197592 */ GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(241375),
     /* 197597 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 197600 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(197713), // Rule ID 2062 //
     /* 197605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 197613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 197625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 197645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 197653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 197665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 197674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197678 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197682 */     // MIs[3] Operand 1
     /* 197682 */     // No operand predicates
     /* 197682 */     // MIs[1] Operand 2
     /* 197682 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 197693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 197695 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 197698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 197708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 197711 */     GIR_RootConstrainSelectedInstOperands,
     /* 197712 */     // GIR_Coverage, 2062,
     /* 197712 */     GIR_EraseRootFromParent_Done,
     /* 197713 */   // Label 3965: @197713
     /* 197713 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(197826), // Rule ID 2069 //
     /* 197718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 197738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 197758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 197766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 197770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 197774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 197778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 197783 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 197787 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197791 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 197795 */     // MIs[3] Operand 1
     /* 197795 */     // No operand predicates
     /* 197795 */     // MIs[1] Operand 2
     /* 197795 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 197806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 197808 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 197811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 197821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 197824 */     GIR_RootConstrainSelectedInstOperands,
     /* 197825 */     // GIR_Coverage, 2069,
     /* 197825 */     GIR_EraseRootFromParent_Done,
     /* 197826 */   // Label 3966: @197826
     /* 197826 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(197939), // Rule ID 2065 //
     /* 197831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 197839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 197851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 197871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 197879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 197883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 197891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 197900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 197904 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 197908 */     // MIs[3] Operand 1
     /* 197908 */     // No operand predicates
     /* 197908 */     // MIs[1] Operand 2
     /* 197908 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 197919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 197921 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 197921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 197924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 197930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 197934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 197937 */     GIR_RootConstrainSelectedInstOperands,
     /* 197938 */     // GIR_Coverage, 2065,
     /* 197938 */     GIR_EraseRootFromParent_Done,
     /* 197939 */   // Label 3967: @197939
     /* 197939 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(198052), // Rule ID 2072 //
     /* 197944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 197947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 197952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 197964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 197980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 197984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 197988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 197992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 197996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198017 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 198021 */     // MIs[3] Operand 1
     /* 198021 */     // No operand predicates
     /* 198021 */     // MIs[1] Operand 2
     /* 198021 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 198032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198034 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 198037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198050 */     GIR_RootConstrainSelectedInstOperands,
     /* 198051 */     // GIR_Coverage, 2072,
     /* 198051 */     GIR_EraseRootFromParent_Done,
     /* 198052 */   // Label 3968: @198052
     /* 198052 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(198157), // Rule ID 3850 //
     /* 198057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 198065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 198101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198130 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 198134 */     // MIs[3] Operand 1
     /* 198134 */     // No operand predicates
     /* 198134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198136 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 198136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 198139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198155 */     GIR_RootConstrainSelectedInstOperands,
     /* 198156 */     // GIR_Coverage, 3850,
     /* 198156 */     GIR_EraseRootFromParent_Done,
     /* 198157 */   // Label 3969: @198157
     /* 198157 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(198262), // Rule ID 3851 //
     /* 198162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 198170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 198206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198235 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 198239 */     // MIs[3] Operand 1
     /* 198239 */     // No operand predicates
     /* 198239 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198241 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 198241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 198244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198260 */     GIR_RootConstrainSelectedInstOperands,
     /* 198261 */     // GIR_Coverage, 3851,
     /* 198261 */     GIR_EraseRootFromParent_Done,
     /* 198262 */   // Label 3970: @198262
     /* 198262 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(198367), // Rule ID 3852 //
     /* 198267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 198275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 198311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198327 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198340 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 198344 */     // MIs[3] Operand 1
     /* 198344 */     // No operand predicates
     /* 198344 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198346 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 198346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 198349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 198365 */     GIR_RootConstrainSelectedInstOperands,
     /* 198366 */     // GIR_Coverage, 3852,
     /* 198366 */     GIR_EraseRootFromParent_Done,
     /* 198367 */   // Label 3971: @198367
     /* 198367 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(198472), // Rule ID 3853 //
     /* 198372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 198380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 198416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198445 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 198449 */     // MIs[3] Operand 1
     /* 198449 */     // No operand predicates
     /* 198449 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198451 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 198451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 198454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 198470 */     GIR_RootConstrainSelectedInstOperands,
     /* 198471 */     // GIR_Coverage, 3853,
     /* 198471 */     GIR_EraseRootFromParent_Done,
     /* 198472 */   // Label 3972: @198472
     /* 198472 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(198577), // Rule ID 3858 //
     /* 198477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 198485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 198497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198550 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 198554 */     // MIs[3] Operand 1
     /* 198554 */     // No operand predicates
     /* 198554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198556 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 198556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 198559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198575 */     GIR_RootConstrainSelectedInstOperands,
     /* 198576 */     // GIR_Coverage, 3858,
     /* 198576 */     GIR_EraseRootFromParent_Done,
     /* 198577 */   // Label 3973: @198577
     /* 198577 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(198682), // Rule ID 3859 //
     /* 198582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 198590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 198602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198655 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 198659 */     // MIs[3] Operand 1
     /* 198659 */     // No operand predicates
     /* 198659 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198661 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 198661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 198664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198680 */     GIR_RootConstrainSelectedInstOperands,
     /* 198681 */     // GIR_Coverage, 3859,
     /* 198681 */     GIR_EraseRootFromParent_Done,
     /* 198682 */   // Label 3974: @198682
     /* 198682 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(198787), // Rule ID 3860 //
     /* 198687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 198695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 198707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198760 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 198764 */     // MIs[3] Operand 1
     /* 198764 */     // No operand predicates
     /* 198764 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198766 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 198766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 198769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 198785 */     GIR_RootConstrainSelectedInstOperands,
     /* 198786 */     // GIR_Coverage, 3860,
     /* 198786 */     GIR_EraseRootFromParent_Done,
     /* 198787 */   // Label 3975: @198787
     /* 198787 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(198892), // Rule ID 3861 //
     /* 198792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 198800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 198812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198865 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 198869 */     // MIs[3] Operand 1
     /* 198869 */     // No operand predicates
     /* 198869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198871 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 198871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 198874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 198890 */     GIR_RootConstrainSelectedInstOperands,
     /* 198891 */     // GIR_Coverage, 3861,
     /* 198891 */     GIR_EraseRootFromParent_Done,
     /* 198892 */   // Label 3976: @198892
     /* 198892 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(198997), // Rule ID 3874 //
     /* 198897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 198905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 198917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 198941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 198949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 198953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198966 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198970 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 198974 */     // MIs[3] Operand 1
     /* 198974 */     // No operand predicates
     /* 198974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198976 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 198976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 198979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198995 */     GIR_RootConstrainSelectedInstOperands,
     /* 198996 */     // GIR_Coverage, 3874,
     /* 198996 */     GIR_EraseRootFromParent_Done,
     /* 198997 */   // Label 3977: @198997
     /* 198997 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(199102), // Rule ID 3875 //
     /* 199002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 199010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 199054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199062 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199071 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199075 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199079 */     // MIs[3] Operand 1
     /* 199079 */     // No operand predicates
     /* 199079 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199081 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 199081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 199084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199100 */     GIR_RootConstrainSelectedInstOperands,
     /* 199101 */     // GIR_Coverage, 3875,
     /* 199101 */     GIR_EraseRootFromParent_Done,
     /* 199102 */   // Label 3978: @199102
     /* 199102 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(199207), // Rule ID 3876 //
     /* 199107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 199115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 199159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199180 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199184 */     // MIs[3] Operand 1
     /* 199184 */     // No operand predicates
     /* 199184 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199186 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 199186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 199189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 199205 */     GIR_RootConstrainSelectedInstOperands,
     /* 199206 */     // GIR_Coverage, 3876,
     /* 199206 */     GIR_EraseRootFromParent_Done,
     /* 199207 */   // Label 3979: @199207
     /* 199207 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(199312), // Rule ID 3877 //
     /* 199212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 199220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 199264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199285 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199289 */     // MIs[3] Operand 1
     /* 199289 */     // No operand predicates
     /* 199289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199291 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 199291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 199294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 199310 */     GIR_RootConstrainSelectedInstOperands,
     /* 199311 */     // GIR_Coverage, 3877,
     /* 199311 */     GIR_EraseRootFromParent_Done,
     /* 199312 */   // Label 3980: @199312
     /* 199312 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(199366), // Rule ID 59 //
     /* 199317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 199320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 199325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 199334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199342 */     // MIs[0] Operand 3
     /* 199342 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 199353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 199357 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 199357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 199360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199364 */     GIR_RootConstrainSelectedInstOperands,
     /* 199365 */     // GIR_Coverage, 59,
     /* 199365 */     GIR_EraseRootFromParent_Done,
     /* 199366 */   // Label 3981: @199366
     /* 199366 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(199420), // Rule ID 60 //
     /* 199371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 199374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 199379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 199388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199396 */     // MIs[0] Operand 3
     /* 199396 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 199407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 199411 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 199411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 199414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199418 */     GIR_RootConstrainSelectedInstOperands,
     /* 199419 */     // GIR_Coverage, 60,
     /* 199419 */     GIR_EraseRootFromParent_Done,
     /* 199420 */   // Label 3982: @199420
     /* 199420 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(199474), // Rule ID 61 //
     /* 199425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 199428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 199433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 199442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199450 */     // MIs[0] Operand 3
     /* 199450 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 199461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 199465 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 199465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 199468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199472 */     GIR_RootConstrainSelectedInstOperands,
     /* 199473 */     // GIR_Coverage, 61,
     /* 199473 */     GIR_EraseRootFromParent_Done,
     /* 199474 */   // Label 3983: @199474
     /* 199474 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(199528), // Rule ID 62 //
     /* 199479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 199482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 199487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 199496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199504 */     // MIs[0] Operand 3
     /* 199504 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 199515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 199519 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 199519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 199522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199526 */     GIR_RootConstrainSelectedInstOperands,
     /* 199527 */     // GIR_Coverage, 62,
     /* 199527 */     GIR_EraseRootFromParent_Done,
     /* 199528 */   // Label 3984: @199528
     /* 199528 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(199584), // Rule ID 2643 //
     /* 199533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 199541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 199544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 199547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 199555 */     // MIs[0] pattern
     /* 199555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 199558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 199563 */     // MIs[0] imm4
     /* 199563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 199566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 199571 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1796:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 199571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 199574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 199576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 199578 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 199580 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 199582 */     GIR_RootConstrainSelectedInstOperands,
     /* 199583 */     // GIR_Coverage, 2643,
     /* 199583 */     GIR_EraseRootFromParent_Done,
     /* 199584 */   // Label 3985: @199584
     /* 199584 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(199640), // Rule ID 2652 //
     /* 199589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 199597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199611 */     // MIs[0] pattern
     /* 199611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 199614 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 199619 */     // MIs[0] imm4
     /* 199619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 199622 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 199627 */     // (intrinsic_wo_chain:{ *:[i32] } 2002:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 199627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 199630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199634 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 199636 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 199638 */     GIR_RootConstrainSelectedInstOperands,
     /* 199639 */     // GIR_Coverage, 2652,
     /* 199639 */     GIR_EraseRootFromParent_Done,
     /* 199640 */   // Label 3986: @199640
     /* 199640 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(199696), // Rule ID 2653 //
     /* 199645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 199653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199667 */     // MIs[0] pattern
     /* 199667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 199670 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 199675 */     // MIs[0] imm4
     /* 199675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 199678 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 199683 */     // (intrinsic_wo_chain:{ *:[i64] } 1792:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 199683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 199686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199690 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 199692 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 199694 */     GIR_RootConstrainSelectedInstOperands,
     /* 199695 */     // GIR_Coverage, 2653,
     /* 199695 */     GIR_EraseRootFromParent_Done,
     /* 199696 */   // Label 3987: @199696
     /* 199696 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(199752), // Rule ID 9911 //
     /* 199701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 199709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199723 */     // MIs[0] pattern
     /* 199723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 199726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 199731 */     // MIs[0] imm4
     /* 199731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 199734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 199739 */     // (intrinsic_wo_chain:{ *:[i32] } 1988:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 199739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 199742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199746 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 199748 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 199750 */     GIR_RootConstrainSelectedInstOperands,
     /* 199751 */     // GIR_Coverage, 9911,
     /* 199751 */     GIR_EraseRootFromParent_Done,
     /* 199752 */   // Label 3988: @199752
     /* 199752 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(199808), // Rule ID 9912 //
     /* 199757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 199765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199779 */     // MIs[0] pattern
     /* 199779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 199782 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 199787 */     // MIs[0] imm4
     /* 199787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 199790 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 199795 */     // (intrinsic_wo_chain:{ *:[i64] } 2003:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 199795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 199798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199802 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 199804 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 199806 */     GIR_RootConstrainSelectedInstOperands,
     /* 199807 */     // GIR_Coverage, 9912,
     /* 199807 */     GIR_EraseRootFromParent_Done,
     /* 199808 */   // Label 3989: @199808
     /* 199808 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(199864), // Rule ID 9913 //
     /* 199813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 199821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199835 */     // MIs[0] pattern
     /* 199835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 199838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 199843 */     // MIs[0] imm4
     /* 199843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 199846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 199851 */     // (intrinsic_wo_chain:{ *:[i64] } 1758:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 199851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 199854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199858 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 199860 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 199862 */     GIR_RootConstrainSelectedInstOperands,
     /* 199863 */     // GIR_Coverage, 9913,
     /* 199863 */     GIR_EraseRootFromParent_Done,
     /* 199864 */   // Label 3990: @199864
     /* 199864 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(199920), // Rule ID 9914 //
     /* 199869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 199877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199891 */     // MIs[0] pattern
     /* 199891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 199894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 199899 */     // MIs[0] imm4
     /* 199899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 199902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 199907 */     // (intrinsic_wo_chain:{ *:[i64] } 1989:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 199907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 199910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199914 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 199916 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 199918 */     GIR_RootConstrainSelectedInstOperands,
     /* 199919 */     // GIR_Coverage, 9914,
     /* 199919 */     GIR_EraseRootFromParent_Done,
     /* 199920 */   // Label 3991: @199920
     /* 199920 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(199976), // Rule ID 9917 //
     /* 199925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 199933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199947 */     // MIs[0] pattern
     /* 199947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 199950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 199955 */     // MIs[0] imm4
     /* 199955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 199958 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 199963 */     // (intrinsic_wo_chain:{ *:[i32] } 2008:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 199963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 199966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 199968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199970 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 199972 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 199974 */     GIR_RootConstrainSelectedInstOperands,
     /* 199975 */     // GIR_Coverage, 9917,
     /* 199975 */     GIR_EraseRootFromParent_Done,
     /* 199976 */   // Label 3992: @199976
     /* 199976 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(200032), // Rule ID 9920 //
     /* 199981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 199989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200003 */     // MIs[0] pattern
     /* 200003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200011 */     // MIs[0] imm4
     /* 200011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200019 */     // (intrinsic_wo_chain:{ *:[i32] } 1994:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 200022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200026 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200028 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200030 */     GIR_RootConstrainSelectedInstOperands,
     /* 200031 */     // GIR_Coverage, 9920,
     /* 200031 */     GIR_EraseRootFromParent_Done,
     /* 200032 */   // Label 3993: @200032
     /* 200032 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(200088), // Rule ID 9921 //
     /* 200037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 200045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200059 */     // MIs[0] pattern
     /* 200059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200062 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200067 */     // MIs[0] imm4
     /* 200067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200070 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200075 */     // (intrinsic_wo_chain:{ *:[i64] } 1798:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 200078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200082 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200084 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200086 */     GIR_RootConstrainSelectedInstOperands,
     /* 200087 */     // GIR_Coverage, 9921,
     /* 200087 */     GIR_EraseRootFromParent_Done,
     /* 200088 */   // Label 3994: @200088
     /* 200088 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(200144), // Rule ID 9922 //
     /* 200093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 200101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200115 */     // MIs[0] pattern
     /* 200115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200123 */     // MIs[0] imm4
     /* 200123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200131 */     // (intrinsic_wo_chain:{ *:[i64] } 2009:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 200134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200138 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200140 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200142 */     GIR_RootConstrainSelectedInstOperands,
     /* 200143 */     // GIR_Coverage, 9922,
     /* 200143 */     GIR_EraseRootFromParent_Done,
     /* 200144 */   // Label 3995: @200144
     /* 200144 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(200200), // Rule ID 9923 //
     /* 200149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 200157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200171 */     // MIs[0] pattern
     /* 200171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200179 */     // MIs[0] imm4
     /* 200179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200187 */     // (intrinsic_wo_chain:{ *:[i64] } 1764:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 200190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200194 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200196 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200198 */     GIR_RootConstrainSelectedInstOperands,
     /* 200199 */     // GIR_Coverage, 9923,
     /* 200199 */     GIR_EraseRootFromParent_Done,
     /* 200200 */   // Label 3996: @200200
     /* 200200 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(200256), // Rule ID 9924 //
     /* 200205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 200213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200227 */     // MIs[0] pattern
     /* 200227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200235 */     // MIs[0] imm4
     /* 200235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200243 */     // (intrinsic_wo_chain:{ *:[i64] } 1995:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 200246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200250 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200252 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200254 */     GIR_RootConstrainSelectedInstOperands,
     /* 200255 */     // GIR_Coverage, 9924,
     /* 200255 */     GIR_EraseRootFromParent_Done,
     /* 200256 */   // Label 3997: @200256
     /* 200256 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(200312), // Rule ID 9927 //
     /* 200261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 200269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200283 */     // MIs[0] pattern
     /* 200283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200291 */     // MIs[0] imm4
     /* 200291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200299 */     // (intrinsic_wo_chain:{ *:[i32] } 2014:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 200302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200306 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200308 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200310 */     GIR_RootConstrainSelectedInstOperands,
     /* 200311 */     // GIR_Coverage, 9927,
     /* 200311 */     GIR_EraseRootFromParent_Done,
     /* 200312 */   // Label 3998: @200312
     /* 200312 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(200368), // Rule ID 9930 //
     /* 200317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 200325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200339 */     // MIs[0] pattern
     /* 200339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200347 */     // MIs[0] imm4
     /* 200347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200355 */     // (intrinsic_wo_chain:{ *:[i32] } 2000:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 200358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200362 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200364 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200366 */     GIR_RootConstrainSelectedInstOperands,
     /* 200367 */     // GIR_Coverage, 9930,
     /* 200367 */     GIR_EraseRootFromParent_Done,
     /* 200368 */   // Label 3999: @200368
     /* 200368 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(200424), // Rule ID 9931 //
     /* 200373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 200381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200395 */     // MIs[0] pattern
     /* 200395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200403 */     // MIs[0] imm4
     /* 200403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200411 */     // (intrinsic_wo_chain:{ *:[i64] } 1804:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 200414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200418 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200420 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200422 */     GIR_RootConstrainSelectedInstOperands,
     /* 200423 */     // GIR_Coverage, 9931,
     /* 200423 */     GIR_EraseRootFromParent_Done,
     /* 200424 */   // Label 4000: @200424
     /* 200424 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(200480), // Rule ID 9932 //
     /* 200429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 200437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200451 */     // MIs[0] pattern
     /* 200451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200459 */     // MIs[0] imm4
     /* 200459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200467 */     // (intrinsic_wo_chain:{ *:[i64] } 2015:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 200470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200474 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200476 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200478 */     GIR_RootConstrainSelectedInstOperands,
     /* 200479 */     // GIR_Coverage, 9932,
     /* 200479 */     GIR_EraseRootFromParent_Done,
     /* 200480 */   // Label 4001: @200480
     /* 200480 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(200536), // Rule ID 9933 //
     /* 200485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 200493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200507 */     // MIs[0] pattern
     /* 200507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200515 */     // MIs[0] imm4
     /* 200515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200523 */     // (intrinsic_wo_chain:{ *:[i64] } 1770:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 200526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200530 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200532 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200534 */     GIR_RootConstrainSelectedInstOperands,
     /* 200535 */     // GIR_Coverage, 9933,
     /* 200535 */     GIR_EraseRootFromParent_Done,
     /* 200536 */   // Label 4002: @200536
     /* 200536 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(200592), // Rule ID 9934 //
     /* 200541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 200549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200563 */     // MIs[0] pattern
     /* 200563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200571 */     // MIs[0] imm4
     /* 200571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200579 */     // (intrinsic_wo_chain:{ *:[i64] } 2001:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 200582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200586 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200588 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200590 */     GIR_RootConstrainSelectedInstOperands,
     /* 200591 */     // GIR_Coverage, 9934,
     /* 200591 */     GIR_EraseRootFromParent_Done,
     /* 200592 */   // Label 4003: @200592
     /* 200592 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(200648), // Rule ID 9937 //
     /* 200597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 200605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200619 */     // MIs[0] pattern
     /* 200619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200622 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200627 */     // MIs[0] imm4
     /* 200627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200630 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200635 */     // (intrinsic_wo_chain:{ *:[i32] } 2005:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 200638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200642 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200644 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200646 */     GIR_RootConstrainSelectedInstOperands,
     /* 200647 */     // GIR_Coverage, 9937,
     /* 200647 */     GIR_EraseRootFromParent_Done,
     /* 200648 */   // Label 4004: @200648
     /* 200648 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(200704), // Rule ID 9940 //
     /* 200653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 200661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200675 */     // MIs[0] pattern
     /* 200675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200678 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200683 */     // MIs[0] imm4
     /* 200683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200691 */     // (intrinsic_wo_chain:{ *:[i32] } 1991:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 200694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200698 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200700 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200702 */     GIR_RootConstrainSelectedInstOperands,
     /* 200703 */     // GIR_Coverage, 9940,
     /* 200703 */     GIR_EraseRootFromParent_Done,
     /* 200704 */   // Label 4005: @200704
     /* 200704 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(200760), // Rule ID 9941 //
     /* 200709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 200717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200731 */     // MIs[0] pattern
     /* 200731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200739 */     // MIs[0] imm4
     /* 200739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200747 */     // (intrinsic_wo_chain:{ *:[i64] } 1795:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 200750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200754 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200756 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200758 */     GIR_RootConstrainSelectedInstOperands,
     /* 200759 */     // GIR_Coverage, 9941,
     /* 200759 */     GIR_EraseRootFromParent_Done,
     /* 200760 */   // Label 4006: @200760
     /* 200760 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(200816), // Rule ID 9942 //
     /* 200765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 200773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200787 */     // MIs[0] pattern
     /* 200787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200790 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200795 */     // MIs[0] imm4
     /* 200795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200803 */     // (intrinsic_wo_chain:{ *:[i64] } 2006:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 200806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200810 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200812 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200814 */     GIR_RootConstrainSelectedInstOperands,
     /* 200815 */     // GIR_Coverage, 9942,
     /* 200815 */     GIR_EraseRootFromParent_Done,
     /* 200816 */   // Label 4007: @200816
     /* 200816 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(200872), // Rule ID 9943 //
     /* 200821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 200829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200843 */     // MIs[0] pattern
     /* 200843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200851 */     // MIs[0] imm4
     /* 200851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200859 */     // (intrinsic_wo_chain:{ *:[i64] } 1761:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 200862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200866 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200868 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200870 */     GIR_RootConstrainSelectedInstOperands,
     /* 200871 */     // GIR_Coverage, 9943,
     /* 200871 */     GIR_EraseRootFromParent_Done,
     /* 200872 */   // Label 4008: @200872
     /* 200872 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(200928), // Rule ID 9944 //
     /* 200877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 200885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200899 */     // MIs[0] pattern
     /* 200899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200907 */     // MIs[0] imm4
     /* 200907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200910 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200915 */     // (intrinsic_wo_chain:{ *:[i64] } 1992:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 200918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200922 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200924 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200926 */     GIR_RootConstrainSelectedInstOperands,
     /* 200927 */     // GIR_Coverage, 9944,
     /* 200927 */     GIR_EraseRootFromParent_Done,
     /* 200928 */   // Label 4009: @200928
     /* 200928 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(200984), // Rule ID 9945 //
     /* 200933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 200941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 200947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200955 */     // MIs[0] pattern
     /* 200955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200958 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200963 */     // MIs[0] imm4
     /* 200963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200966 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200971 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2007:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 200974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 200978 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200980 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200982 */     GIR_RootConstrainSelectedInstOperands,
     /* 200983 */     // GIR_Coverage, 9945,
     /* 200983 */     GIR_EraseRootFromParent_Done,
     /* 200984 */   // Label 4010: @200984
     /* 200984 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(201040), // Rule ID 9946 //
     /* 200989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 200997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201011 */     // MIs[0] pattern
     /* 201011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201019 */     // MIs[0] imm4
     /* 201019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201027 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1762:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 201030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201034 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201036 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201038 */     GIR_RootConstrainSelectedInstOperands,
     /* 201039 */     // GIR_Coverage, 9946,
     /* 201039 */     GIR_EraseRootFromParent_Done,
     /* 201040 */   // Label 4011: @201040
     /* 201040 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(201096), // Rule ID 9947 //
     /* 201045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 201053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201067 */     // MIs[0] pattern
     /* 201067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201070 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201075 */     // MIs[0] imm4
     /* 201075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201083 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1993:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 201086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201090 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201092 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201094 */     GIR_RootConstrainSelectedInstOperands,
     /* 201095 */     // GIR_Coverage, 9947,
     /* 201095 */     GIR_EraseRootFromParent_Done,
     /* 201096 */   // Label 4012: @201096
     /* 201096 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(201152), // Rule ID 9948 //
     /* 201101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 201109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201123 */     // MIs[0] pattern
     /* 201123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201131 */     // MIs[0] imm4
     /* 201131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201134 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 201142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201146 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201148 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201150 */     GIR_RootConstrainSelectedInstOperands,
     /* 201151 */     // GIR_Coverage, 9948,
     /* 201151 */     GIR_EraseRootFromParent_Done,
     /* 201152 */   // Label 4013: @201152
     /* 201152 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(201208), // Rule ID 9949 //
     /* 201157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 201165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201179 */     // MIs[0] pattern
     /* 201179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201187 */     // MIs[0] imm4
     /* 201187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201190 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201195 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2013:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 201198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201202 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201204 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201206 */     GIR_RootConstrainSelectedInstOperands,
     /* 201207 */     // GIR_Coverage, 9949,
     /* 201207 */     GIR_EraseRootFromParent_Done,
     /* 201208 */   // Label 4014: @201208
     /* 201208 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(201264), // Rule ID 9950 //
     /* 201213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 201221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201235 */     // MIs[0] pattern
     /* 201235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201243 */     // MIs[0] imm4
     /* 201243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201251 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1768:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 201254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201258 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201260 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201262 */     GIR_RootConstrainSelectedInstOperands,
     /* 201263 */     // GIR_Coverage, 9950,
     /* 201263 */     GIR_EraseRootFromParent_Done,
     /* 201264 */   // Label 4015: @201264
     /* 201264 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(201320), // Rule ID 9951 //
     /* 201269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 201277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201291 */     // MIs[0] pattern
     /* 201291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201299 */     // MIs[0] imm4
     /* 201299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201302 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201307 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1999:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 201310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201314 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201316 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201318 */     GIR_RootConstrainSelectedInstOperands,
     /* 201319 */     // GIR_Coverage, 9951,
     /* 201319 */     GIR_EraseRootFromParent_Done,
     /* 201320 */   // Label 4016: @201320
     /* 201320 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(201376), // Rule ID 9952 //
     /* 201325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 201333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201347 */     // MIs[0] pattern
     /* 201347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201355 */     // MIs[0] imm4
     /* 201355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201363 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1793:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 201366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201370 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201372 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201374 */     GIR_RootConstrainSelectedInstOperands,
     /* 201375 */     // GIR_Coverage, 9952,
     /* 201375 */     GIR_EraseRootFromParent_Done,
     /* 201376 */   // Label 4017: @201376
     /* 201376 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(201432), // Rule ID 9953 //
     /* 201381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 201389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201403 */     // MIs[0] pattern
     /* 201403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201411 */     // MIs[0] imm4
     /* 201411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201414 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201419 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2004:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 201422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201426 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201428 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201430 */     GIR_RootConstrainSelectedInstOperands,
     /* 201431 */     // GIR_Coverage, 9953,
     /* 201431 */     GIR_EraseRootFromParent_Done,
     /* 201432 */   // Label 4018: @201432
     /* 201432 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(201488), // Rule ID 9954 //
     /* 201437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 201445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201459 */     // MIs[0] pattern
     /* 201459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201467 */     // MIs[0] imm4
     /* 201467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201470 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201475 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 201478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201482 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201484 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201486 */     GIR_RootConstrainSelectedInstOperands,
     /* 201487 */     // GIR_Coverage, 9954,
     /* 201487 */     GIR_EraseRootFromParent_Done,
     /* 201488 */   // Label 4019: @201488
     /* 201488 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(201544), // Rule ID 9955 //
     /* 201493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 201501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 201504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 201507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201515 */     // MIs[0] pattern
     /* 201515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201523 */     // MIs[0] imm4
     /* 201523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1990:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 201534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201538 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201540 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201542 */     GIR_RootConstrainSelectedInstOperands,
     /* 201543 */     // GIR_Coverage, 9955,
     /* 201543 */     GIR_EraseRootFromParent_Done,
     /* 201544 */   // Label 4020: @201544
     /* 201544 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(201634), // Rule ID 47 //
     /* 201549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 201552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 201557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 201560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 201563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 201566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 201569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 201589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 201593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 201597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 201602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 201606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201610 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 201614 */     // MIs[2] Operand 1
     /* 201614 */     // No operand predicates
     /* 201614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201616 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 201616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 201619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 201629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 201632 */     GIR_RootConstrainSelectedInstOperands,
     /* 201633 */     // GIR_Coverage, 47,
     /* 201633 */     GIR_EraseRootFromParent_Done,
     /* 201634 */   // Label 4021: @201634
     /* 201634 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(201724), // Rule ID 48 //
     /* 201639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 201642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 201647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 201650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 201653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 201656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 201659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 201679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 201683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 201687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 201692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 201696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201700 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 201704 */     // MIs[2] Operand 1
     /* 201704 */     // No operand predicates
     /* 201704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201706 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 201706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 201709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 201719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 201722 */     GIR_RootConstrainSelectedInstOperands,
     /* 201723 */     // GIR_Coverage, 48,
     /* 201723 */     GIR_EraseRootFromParent_Done,
     /* 201724 */   // Label 4022: @201724
     /* 201724 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(201814), // Rule ID 49 //
     /* 201729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 201732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 201737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 201740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 201743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 201746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 201749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 201769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 201773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 201777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 201782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 201786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201790 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 201794 */     // MIs[2] Operand 1
     /* 201794 */     // No operand predicates
     /* 201794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201796 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 201796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 201799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 201809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 201812 */     GIR_RootConstrainSelectedInstOperands,
     /* 201813 */     // GIR_Coverage, 49,
     /* 201813 */     GIR_EraseRootFromParent_Done,
     /* 201814 */   // Label 4023: @201814
     /* 201814 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(201904), // Rule ID 50 //
     /* 201819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 201822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 201827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 201830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 201833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 201836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 201839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 201851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 201859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 201863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 201867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 201872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 201876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201880 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 201884 */     // MIs[2] Operand 1
     /* 201884 */     // No operand predicates
     /* 201884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201886 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 201886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 201889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 201899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 201902 */     GIR_RootConstrainSelectedInstOperands,
     /* 201903 */     // GIR_Coverage, 50,
     /* 201903 */     GIR_EraseRootFromParent_Done,
     /* 201904 */   // Label 4024: @201904
     /* 201904 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(201994), // Rule ID 51 //
     /* 201909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 201912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 201917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 201920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 201923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 201926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 201929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 201945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 201949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 201953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 201957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 201962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 201966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 201970 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 201974 */     // MIs[2] Operand 1
     /* 201974 */     // No operand predicates
     /* 201974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 201976 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 201976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 201979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 201983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 201985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 201989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 201992 */     GIR_RootConstrainSelectedInstOperands,
     /* 201993 */     // GIR_Coverage, 51,
     /* 201993 */     GIR_EraseRootFromParent_Done,
     /* 201994 */   // Label 4025: @201994
     /* 201994 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(202084), // Rule ID 52 //
     /* 201999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 202007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202060 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202064 */     // MIs[2] Operand 1
     /* 202064 */     // No operand predicates
     /* 202064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202066 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 202069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202082 */     GIR_RootConstrainSelectedInstOperands,
     /* 202083 */     // GIR_Coverage, 52,
     /* 202083 */     GIR_EraseRootFromParent_Done,
     /* 202084 */   // Label 4026: @202084
     /* 202084 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(202174), // Rule ID 53 //
     /* 202089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 202097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202150 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202154 */     // MIs[2] Operand 1
     /* 202154 */     // No operand predicates
     /* 202154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202156 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 202159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202172 */     GIR_RootConstrainSelectedInstOperands,
     /* 202173 */     // GIR_Coverage, 53,
     /* 202173 */     GIR_EraseRootFromParent_Done,
     /* 202174 */   // Label 4027: @202174
     /* 202174 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(202264), // Rule ID 54 //
     /* 202179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 202187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202240 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202244 */     // MIs[2] Operand 1
     /* 202244 */     // No operand predicates
     /* 202244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202246 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 202249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202262 */     GIR_RootConstrainSelectedInstOperands,
     /* 202263 */     // GIR_Coverage, 54,
     /* 202263 */     GIR_EraseRootFromParent_Done,
     /* 202264 */   // Label 4028: @202264
     /* 202264 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(202354), // Rule ID 2063 //
     /* 202269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 202272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 202277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 202280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 202283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202330 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202334 */     // MIs[2] Operand 1
     /* 202334 */     // No operand predicates
     /* 202334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202336 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 202339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202352 */     GIR_RootConstrainSelectedInstOperands,
     /* 202353 */     // GIR_Coverage, 2063,
     /* 202353 */     GIR_EraseRootFromParent_Done,
     /* 202354 */   // Label 4029: @202354
     /* 202354 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(202444), // Rule ID 2064 //
     /* 202359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 202362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 202367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 202370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 202373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202420 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202424 */     // MIs[2] Operand 1
     /* 202424 */     // No operand predicates
     /* 202424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202426 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 202429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202442 */     GIR_RootConstrainSelectedInstOperands,
     /* 202443 */     // GIR_Coverage, 2064,
     /* 202443 */     GIR_EraseRootFromParent_Done,
     /* 202444 */   // Label 4030: @202444
     /* 202444 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(202534), // Rule ID 2070 //
     /* 202449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 202452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 202457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 202460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 202463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202510 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202514 */     // MIs[2] Operand 1
     /* 202514 */     // No operand predicates
     /* 202514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202516 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 202519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202532 */     GIR_RootConstrainSelectedInstOperands,
     /* 202533 */     // GIR_Coverage, 2070,
     /* 202533 */     GIR_EraseRootFromParent_Done,
     /* 202534 */   // Label 4031: @202534
     /* 202534 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(202624), // Rule ID 2071 //
     /* 202539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 202542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 202547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 202550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 202553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202600 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202604 */     // MIs[2] Operand 1
     /* 202604 */     // No operand predicates
     /* 202604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202606 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 202609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202622 */     GIR_RootConstrainSelectedInstOperands,
     /* 202623 */     // GIR_Coverage, 2071,
     /* 202623 */     GIR_EraseRootFromParent_Done,
     /* 202624 */   // Label 4032: @202624
     /* 202624 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(202714), // Rule ID 2066 //
     /* 202629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 202632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 202637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 202646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 202649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 202669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 202673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202690 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 202694 */     // MIs[2] Operand 1
     /* 202694 */     // No operand predicates
     /* 202694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202696 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 202699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202712 */     GIR_RootConstrainSelectedInstOperands,
     /* 202713 */     // GIR_Coverage, 2066,
     /* 202713 */     GIR_EraseRootFromParent_Done,
     /* 202714 */   // Label 4033: @202714
     /* 202714 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(202804), // Rule ID 2067 //
     /* 202719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 202722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 202727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 202736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 202739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 202759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 202763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202780 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 202784 */     // MIs[2] Operand 1
     /* 202784 */     // No operand predicates
     /* 202784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202786 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 202789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202802 */     GIR_RootConstrainSelectedInstOperands,
     /* 202803 */     // GIR_Coverage, 2067,
     /* 202803 */     GIR_EraseRootFromParent_Done,
     /* 202804 */   // Label 4034: @202804
     /* 202804 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(202894), // Rule ID 2073 //
     /* 202809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 202812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 202817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 202826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 202829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 202849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 202853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202870 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 202874 */     // MIs[2] Operand 1
     /* 202874 */     // No operand predicates
     /* 202874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202876 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 202879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202892 */     GIR_RootConstrainSelectedInstOperands,
     /* 202893 */     // GIR_Coverage, 2073,
     /* 202893 */     GIR_EraseRootFromParent_Done,
     /* 202894 */   // Label 4035: @202894
     /* 202894 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(202984), // Rule ID 2074 //
     /* 202899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 202902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 202907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 202916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 202919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 202939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 202943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 202964 */     // MIs[2] Operand 1
     /* 202964 */     // No operand predicates
     /* 202964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202966 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 202969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202982 */     GIR_RootConstrainSelectedInstOperands,
     /* 202983 */     // GIR_Coverage, 2074,
     /* 202983 */     GIR_EraseRootFromParent_Done,
     /* 202984 */   // Label 4036: @202984
     /* 202984 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(203074), // Rule ID 2068 //
     /* 202989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 202992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 202997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 203009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 203029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203050 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203054 */     // MIs[2] Operand 1
     /* 203054 */     // No operand predicates
     /* 203054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203056 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 203059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203072 */     GIR_RootConstrainSelectedInstOperands,
     /* 203073 */     // GIR_Coverage, 2068,
     /* 203073 */     GIR_EraseRootFromParent_Done,
     /* 203074 */   // Label 4037: @203074
     /* 203074 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(203164), // Rule ID 2075 //
     /* 203079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 203099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 203119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203140 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203144 */     // MIs[2] Operand 1
     /* 203144 */     // No operand predicates
     /* 203144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203146 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 203149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203162 */     GIR_RootConstrainSelectedInstOperands,
     /* 203163 */     // GIR_Coverage, 2075,
     /* 203163 */     GIR_EraseRootFromParent_Done,
     /* 203164 */   // Label 4038: @203164
     /* 203164 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(203241), // Rule ID 2772 //
     /* 203169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 203177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 203189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 203213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203221 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 203225 */     // MIs[2] Operand 1
     /* 203225 */     // No operand predicates
     /* 203225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203227 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 203227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 203230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203239 */     GIR_RootConstrainSelectedInstOperands,
     /* 203240 */     // GIR_Coverage, 2772,
     /* 203240 */     GIR_EraseRootFromParent_Done,
     /* 203241 */   // Label 4039: @203241
     /* 203241 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(203318), // Rule ID 2773 //
     /* 203246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 203254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 203266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 203290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203298 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 203302 */     // MIs[2] Operand 1
     /* 203302 */     // No operand predicates
     /* 203302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203304 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 203304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 203307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203316 */     GIR_RootConstrainSelectedInstOperands,
     /* 203317 */     // GIR_Coverage, 2773,
     /* 203317 */     GIR_EraseRootFromParent_Done,
     /* 203318 */   // Label 4040: @203318
     /* 203318 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(203395), // Rule ID 2774 //
     /* 203323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 203331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 203343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 203367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203375 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 203379 */     // MIs[2] Operand 1
     /* 203379 */     // No operand predicates
     /* 203379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203381 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 203381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 203384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203393 */     GIR_RootConstrainSelectedInstOperands,
     /* 203394 */     // GIR_Coverage, 2774,
     /* 203394 */     GIR_EraseRootFromParent_Done,
     /* 203395 */   // Label 4041: @203395
     /* 203395 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(203472), // Rule ID 2775 //
     /* 203400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 203408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 203420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 203444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203452 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 203456 */     // MIs[2] Operand 1
     /* 203456 */     // No operand predicates
     /* 203456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203458 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 203458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 203461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203470 */     GIR_RootConstrainSelectedInstOperands,
     /* 203471 */     // GIR_Coverage, 2775,
     /* 203471 */     GIR_EraseRootFromParent_Done,
     /* 203472 */   // Label 4042: @203472
     /* 203472 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(203549), // Rule ID 2776 //
     /* 203477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 203485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 203491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 203497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 203521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203529 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 203533 */     // MIs[2] Operand 1
     /* 203533 */     // No operand predicates
     /* 203533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203535 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 203535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 203538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203547 */     GIR_RootConstrainSelectedInstOperands,
     /* 203548 */     // GIR_Coverage, 2776,
     /* 203548 */     GIR_EraseRootFromParent_Done,
     /* 203549 */   // Label 4043: @203549
     /* 203549 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(203626), // Rule ID 2777 //
     /* 203554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 203562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 203568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 203574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 203598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203606 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 203610 */     // MIs[2] Operand 1
     /* 203610 */     // No operand predicates
     /* 203610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203612 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 203612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 203615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203624 */     GIR_RootConstrainSelectedInstOperands,
     /* 203625 */     // GIR_Coverage, 2777,
     /* 203625 */     GIR_EraseRootFromParent_Done,
     /* 203626 */   // Label 4044: @203626
     /* 203626 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(203703), // Rule ID 7798 //
     /* 203631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 203639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 203651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 203675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203683 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 203687 */     // MIs[2] Operand 1
     /* 203687 */     // No operand predicates
     /* 203687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203689 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 203689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 203692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203701 */     GIR_RootConstrainSelectedInstOperands,
     /* 203702 */     // GIR_Coverage, 7798,
     /* 203702 */     GIR_EraseRootFromParent_Done,
     /* 203703 */   // Label 4045: @203703
     /* 203703 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(203780), // Rule ID 7799 //
     /* 203708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 203716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 203728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 203752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203760 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 203764 */     // MIs[2] Operand 1
     /* 203764 */     // No operand predicates
     /* 203764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203766 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 203766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 203769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203778 */     GIR_RootConstrainSelectedInstOperands,
     /* 203779 */     // GIR_Coverage, 7799,
     /* 203779 */     GIR_EraseRootFromParent_Done,
     /* 203780 */   // Label 4046: @203780
     /* 203780 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(203857), // Rule ID 7800 //
     /* 203785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 203793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 203805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 203829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203837 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 203841 */     // MIs[2] Operand 1
     /* 203841 */     // No operand predicates
     /* 203841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203843 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 203843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 203846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203855 */     GIR_RootConstrainSelectedInstOperands,
     /* 203856 */     // GIR_Coverage, 7800,
     /* 203856 */     GIR_EraseRootFromParent_Done,
     /* 203857 */   // Label 4047: @203857
     /* 203857 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(203934), // Rule ID 7801 //
     /* 203862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 203870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 203882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 203906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203914 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 203918 */     // MIs[2] Operand 1
     /* 203918 */     // No operand predicates
     /* 203918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203920 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 203920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 203923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 203932 */     GIR_RootConstrainSelectedInstOperands,
     /* 203933 */     // GIR_Coverage, 7801,
     /* 203933 */     GIR_EraseRootFromParent_Done,
     /* 203934 */   // Label 4048: @203934
     /* 203934 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(204011), // Rule ID 7802 //
     /* 203939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 203947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 203953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 203959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 203983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203991 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 203995 */     // MIs[2] Operand 1
     /* 203995 */     // No operand predicates
     /* 203995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203997 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 203997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 204000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204009 */     GIR_RootConstrainSelectedInstOperands,
     /* 204010 */     // GIR_Coverage, 7802,
     /* 204010 */     GIR_EraseRootFromParent_Done,
     /* 204011 */   // Label 4049: @204011
     /* 204011 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(204088), // Rule ID 7803 //
     /* 204016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204068 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204072 */     // MIs[2] Operand 1
     /* 204072 */     // No operand predicates
     /* 204072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204074 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 204074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 204077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204086 */     GIR_RootConstrainSelectedInstOperands,
     /* 204087 */     // GIR_Coverage, 7803,
     /* 204087 */     GIR_EraseRootFromParent_Done,
     /* 204088 */   // Label 4050: @204088
     /* 204088 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(204165), // Rule ID 7804 //
     /* 204093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 204101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204145 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204149 */     // MIs[2] Operand 1
     /* 204149 */     // No operand predicates
     /* 204149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204151 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 204151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 204154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204163 */     GIR_RootConstrainSelectedInstOperands,
     /* 204164 */     // GIR_Coverage, 7804,
     /* 204164 */     GIR_EraseRootFromParent_Done,
     /* 204165 */   // Label 4051: @204165
     /* 204165 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(204242), // Rule ID 7805 //
     /* 204170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 204178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204222 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 204226 */     // MIs[2] Operand 1
     /* 204226 */     // No operand predicates
     /* 204226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204228 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 204228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 204231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204240 */     GIR_RootConstrainSelectedInstOperands,
     /* 204241 */     // GIR_Coverage, 7805,
     /* 204241 */     GIR_EraseRootFromParent_Done,
     /* 204242 */   // Label 4052: @204242
     /* 204242 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(204319), // Rule ID 7806 //
     /* 204247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 204255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204299 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204303 */     // MIs[2] Operand 1
     /* 204303 */     // No operand predicates
     /* 204303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204305 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 204305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 204308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204317 */     GIR_RootConstrainSelectedInstOperands,
     /* 204318 */     // GIR_Coverage, 7806,
     /* 204318 */     GIR_EraseRootFromParent_Done,
     /* 204319 */   // Label 4053: @204319
     /* 204319 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(204396), // Rule ID 7807 //
     /* 204324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 204332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204376 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 204380 */     // MIs[2] Operand 1
     /* 204380 */     // No operand predicates
     /* 204380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204382 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 204382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 204385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204394 */     GIR_RootConstrainSelectedInstOperands,
     /* 204395 */     // GIR_Coverage, 7807,
     /* 204395 */     GIR_EraseRootFromParent_Done,
     /* 204396 */   // Label 4054: @204396
     /* 204396 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(204473), // Rule ID 7808 //
     /* 204401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 204409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204453 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204457 */     // MIs[2] Operand 1
     /* 204457 */     // No operand predicates
     /* 204457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204459 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 204459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 204462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204471 */     GIR_RootConstrainSelectedInstOperands,
     /* 204472 */     // GIR_Coverage, 7808,
     /* 204472 */     GIR_EraseRootFromParent_Done,
     /* 204473 */   // Label 4055: @204473
     /* 204473 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(204550), // Rule ID 7809 //
     /* 204478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 204486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204530 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 204534 */     // MIs[2] Operand 1
     /* 204534 */     // No operand predicates
     /* 204534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204536 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 204536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 204539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204548 */     GIR_RootConstrainSelectedInstOperands,
     /* 204549 */     // GIR_Coverage, 7809,
     /* 204549 */     GIR_EraseRootFromParent_Done,
     /* 204550 */   // Label 4056: @204550
     /* 204550 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(204627), // Rule ID 7810 //
     /* 204555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 204563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204607 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204611 */     // MIs[2] Operand 1
     /* 204611 */     // No operand predicates
     /* 204611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204613 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 204613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 204616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204625 */     GIR_RootConstrainSelectedInstOperands,
     /* 204626 */     // GIR_Coverage, 7810,
     /* 204626 */     GIR_EraseRootFromParent_Done,
     /* 204627 */   // Label 4057: @204627
     /* 204627 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(204704), // Rule ID 7811 //
     /* 204632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 204640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204684 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204688 */     // MIs[2] Operand 1
     /* 204688 */     // No operand predicates
     /* 204688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204690 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 204690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 204693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204702 */     GIR_RootConstrainSelectedInstOperands,
     /* 204703 */     // GIR_Coverage, 7811,
     /* 204703 */     GIR_EraseRootFromParent_Done,
     /* 204704 */   // Label 4058: @204704
     /* 204704 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(204781), // Rule ID 7812 //
     /* 204709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 204717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204761 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204765 */     // MIs[2] Operand 1
     /* 204765 */     // No operand predicates
     /* 204765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204767 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 204767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 204770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204779 */     GIR_RootConstrainSelectedInstOperands,
     /* 204780 */     // GIR_Coverage, 7812,
     /* 204780 */     GIR_EraseRootFromParent_Done,
     /* 204781 */   // Label 4059: @204781
     /* 204781 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(204858), // Rule ID 7813 //
     /* 204786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 204794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204838 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204842 */     // MIs[2] Operand 1
     /* 204842 */     // No operand predicates
     /* 204842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204844 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 204844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 204847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204856 */     GIR_RootConstrainSelectedInstOperands,
     /* 204857 */     // GIR_Coverage, 7813,
     /* 204857 */     GIR_EraseRootFromParent_Done,
     /* 204858 */   // Label 4060: @204858
     /* 204858 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(204935), // Rule ID 7814 //
     /* 204863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 204871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204915 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204919 */     // MIs[2] Operand 1
     /* 204919 */     // No operand predicates
     /* 204919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204921 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 204921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 204924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204933 */     GIR_RootConstrainSelectedInstOperands,
     /* 204934 */     // GIR_Coverage, 7814,
     /* 204934 */     GIR_EraseRootFromParent_Done,
     /* 204935 */   // Label 4061: @204935
     /* 204935 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(205012), // Rule ID 7815 //
     /* 204940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 204948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204992 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204996 */     // MIs[2] Operand 1
     /* 204996 */     // No operand predicates
     /* 204996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204998 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 204998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 205001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205010 */     GIR_RootConstrainSelectedInstOperands,
     /* 205011 */     // GIR_Coverage, 7815,
     /* 205011 */     GIR_EraseRootFromParent_Done,
     /* 205012 */   // Label 4062: @205012
     /* 205012 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(205089), // Rule ID 7816 //
     /* 205017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205069 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 205073 */     // MIs[2] Operand 1
     /* 205073 */     // No operand predicates
     /* 205073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205075 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 205075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 205078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205087 */     GIR_RootConstrainSelectedInstOperands,
     /* 205088 */     // GIR_Coverage, 7816,
     /* 205088 */     GIR_EraseRootFromParent_Done,
     /* 205089 */   // Label 4063: @205089
     /* 205089 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(205166), // Rule ID 7817 //
     /* 205094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205146 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205150 */     // MIs[2] Operand 1
     /* 205150 */     // No operand predicates
     /* 205150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205152 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 205152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 205155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205164 */     GIR_RootConstrainSelectedInstOperands,
     /* 205165 */     // GIR_Coverage, 7817,
     /* 205165 */     GIR_EraseRootFromParent_Done,
     /* 205166 */   // Label 4064: @205166
     /* 205166 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(205243), // Rule ID 7818 //
     /* 205171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205223 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 205227 */     // MIs[2] Operand 1
     /* 205227 */     // No operand predicates
     /* 205227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205229 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 205232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205241 */     GIR_RootConstrainSelectedInstOperands,
     /* 205242 */     // GIR_Coverage, 7818,
     /* 205242 */     GIR_EraseRootFromParent_Done,
     /* 205243 */   // Label 4065: @205243
     /* 205243 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(205320), // Rule ID 7819 //
     /* 205248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205300 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205304 */     // MIs[2] Operand 1
     /* 205304 */     // No operand predicates
     /* 205304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205306 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 205306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 205309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205318 */     GIR_RootConstrainSelectedInstOperands,
     /* 205319 */     // GIR_Coverage, 7819,
     /* 205319 */     GIR_EraseRootFromParent_Done,
     /* 205320 */   // Label 4066: @205320
     /* 205320 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(205397), // Rule ID 7820 //
     /* 205325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205377 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 205381 */     // MIs[2] Operand 1
     /* 205381 */     // No operand predicates
     /* 205381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205383 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 205383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 205386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205395 */     GIR_RootConstrainSelectedInstOperands,
     /* 205396 */     // GIR_Coverage, 7820,
     /* 205396 */     GIR_EraseRootFromParent_Done,
     /* 205397 */   // Label 4067: @205397
     /* 205397 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(205474), // Rule ID 7821 //
     /* 205402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205454 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205458 */     // MIs[2] Operand 1
     /* 205458 */     // No operand predicates
     /* 205458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205460 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 205460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 205463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205472 */     GIR_RootConstrainSelectedInstOperands,
     /* 205473 */     // GIR_Coverage, 7821,
     /* 205473 */     GIR_EraseRootFromParent_Done,
     /* 205474 */   // Label 4068: @205474
     /* 205474 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(205551), // Rule ID 7822 //
     /* 205479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 205487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205531 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 205535 */     // MIs[2] Operand 1
     /* 205535 */     // No operand predicates
     /* 205535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205537 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 205537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 205540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205549 */     GIR_RootConstrainSelectedInstOperands,
     /* 205550 */     // GIR_Coverage, 7822,
     /* 205550 */     GIR_EraseRootFromParent_Done,
     /* 205551 */   // Label 4069: @205551
     /* 205551 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(205628), // Rule ID 7823 //
     /* 205556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 205564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205608 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205612 */     // MIs[2] Operand 1
     /* 205612 */     // No operand predicates
     /* 205612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205614 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 205614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 205617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205626 */     GIR_RootConstrainSelectedInstOperands,
     /* 205627 */     // GIR_Coverage, 7823,
     /* 205627 */     GIR_EraseRootFromParent_Done,
     /* 205628 */   // Label 4070: @205628
     /* 205628 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(205705), // Rule ID 7824 //
     /* 205633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 205641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205685 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 205689 */     // MIs[2] Operand 1
     /* 205689 */     // No operand predicates
     /* 205689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205691 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 205694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205703 */     GIR_RootConstrainSelectedInstOperands,
     /* 205704 */     // GIR_Coverage, 7824,
     /* 205704 */     GIR_EraseRootFromParent_Done,
     /* 205705 */   // Label 4071: @205705
     /* 205705 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(205782), // Rule ID 7825 //
     /* 205710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 205718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205762 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205766 */     // MIs[2] Operand 1
     /* 205766 */     // No operand predicates
     /* 205766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205768 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 205768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 205771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205780 */     GIR_RootConstrainSelectedInstOperands,
     /* 205781 */     // GIR_Coverage, 7825,
     /* 205781 */     GIR_EraseRootFromParent_Done,
     /* 205782 */   // Label 4072: @205782
     /* 205782 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(205859), // Rule ID 7826 //
     /* 205787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 205795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205839 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 205843 */     // MIs[2] Operand 1
     /* 205843 */     // No operand predicates
     /* 205843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205845 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 205845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 205848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205857 */     GIR_RootConstrainSelectedInstOperands,
     /* 205858 */     // GIR_Coverage, 7826,
     /* 205858 */     GIR_EraseRootFromParent_Done,
     /* 205859 */   // Label 4073: @205859
     /* 205859 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(205936), // Rule ID 7827 //
     /* 205864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 205872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205916 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205920 */     // MIs[2] Operand 1
     /* 205920 */     // No operand predicates
     /* 205920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205922 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 205922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 205925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205934 */     GIR_RootConstrainSelectedInstOperands,
     /* 205935 */     // GIR_Coverage, 7827,
     /* 205935 */     GIR_EraseRootFromParent_Done,
     /* 205936 */   // Label 4074: @205936
     /* 205936 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(206013), // Rule ID 7828 //
     /* 205941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 205949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205993 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 205997 */     // MIs[2] Operand 1
     /* 205997 */     // No operand predicates
     /* 205997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205999 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 205999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 206002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206011 */     GIR_RootConstrainSelectedInstOperands,
     /* 206012 */     // GIR_Coverage, 7828,
     /* 206012 */     GIR_EraseRootFromParent_Done,
     /* 206013 */   // Label 4075: @206013
     /* 206013 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(206090), // Rule ID 7829 //
     /* 206018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206070 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206074 */     // MIs[2] Operand 1
     /* 206074 */     // No operand predicates
     /* 206074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206076 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 206079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206088 */     GIR_RootConstrainSelectedInstOperands,
     /* 206089 */     // GIR_Coverage, 7829,
     /* 206089 */     GIR_EraseRootFromParent_Done,
     /* 206090 */   // Label 4076: @206090
     /* 206090 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(206167), // Rule ID 7830 //
     /* 206095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206147 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206151 */     // MIs[2] Operand 1
     /* 206151 */     // No operand predicates
     /* 206151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206153 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 206156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206165 */     GIR_RootConstrainSelectedInstOperands,
     /* 206166 */     // GIR_Coverage, 7830,
     /* 206166 */     GIR_EraseRootFromParent_Done,
     /* 206167 */   // Label 4077: @206167
     /* 206167 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(206244), // Rule ID 7831 //
     /* 206172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206224 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206228 */     // MIs[2] Operand 1
     /* 206228 */     // No operand predicates
     /* 206228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206230 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 206233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206242 */     GIR_RootConstrainSelectedInstOperands,
     /* 206243 */     // GIR_Coverage, 7831,
     /* 206243 */     GIR_EraseRootFromParent_Done,
     /* 206244 */   // Label 4078: @206244
     /* 206244 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(206321), // Rule ID 7832 //
     /* 206249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206301 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206305 */     // MIs[2] Operand 1
     /* 206305 */     // No operand predicates
     /* 206305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206307 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 206310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206319 */     GIR_RootConstrainSelectedInstOperands,
     /* 206320 */     // GIR_Coverage, 7832,
     /* 206320 */     GIR_EraseRootFromParent_Done,
     /* 206321 */   // Label 4079: @206321
     /* 206321 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(206398), // Rule ID 7833 //
     /* 206326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206378 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206382 */     // MIs[2] Operand 1
     /* 206382 */     // No operand predicates
     /* 206382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206384 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 206384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 206387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206396 */     GIR_RootConstrainSelectedInstOperands,
     /* 206397 */     // GIR_Coverage, 7833,
     /* 206397 */     GIR_EraseRootFromParent_Done,
     /* 206398 */   // Label 4080: @206398
     /* 206398 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(206475), // Rule ID 7834 //
     /* 206403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 206411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206455 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206459 */     // MIs[2] Operand 1
     /* 206459 */     // No operand predicates
     /* 206459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206461 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 206464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206473 */     GIR_RootConstrainSelectedInstOperands,
     /* 206474 */     // GIR_Coverage, 7834,
     /* 206474 */     GIR_EraseRootFromParent_Done,
     /* 206475 */   // Label 4081: @206475
     /* 206475 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(206552), // Rule ID 7835 //
     /* 206480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 206488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206532 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206536 */     // MIs[2] Operand 1
     /* 206536 */     // No operand predicates
     /* 206536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206538 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 206541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206550 */     GIR_RootConstrainSelectedInstOperands,
     /* 206551 */     // GIR_Coverage, 7835,
     /* 206551 */     GIR_EraseRootFromParent_Done,
     /* 206552 */   // Label 4082: @206552
     /* 206552 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(206629), // Rule ID 7836 //
     /* 206557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 206565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206609 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206613 */     // MIs[2] Operand 1
     /* 206613 */     // No operand predicates
     /* 206613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206615 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 206618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206627 */     GIR_RootConstrainSelectedInstOperands,
     /* 206628 */     // GIR_Coverage, 7836,
     /* 206628 */     GIR_EraseRootFromParent_Done,
     /* 206629 */   // Label 4083: @206629
     /* 206629 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(206706), // Rule ID 7837 //
     /* 206634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 206642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206686 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206690 */     // MIs[2] Operand 1
     /* 206690 */     // No operand predicates
     /* 206690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206692 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 206695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206704 */     GIR_RootConstrainSelectedInstOperands,
     /* 206705 */     // GIR_Coverage, 7837,
     /* 206705 */     GIR_EraseRootFromParent_Done,
     /* 206706 */   // Label 4084: @206706
     /* 206706 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(206783), // Rule ID 7838 //
     /* 206711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 206719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206763 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206767 */     // MIs[2] Operand 1
     /* 206767 */     // No operand predicates
     /* 206767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206769 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 206772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206781 */     GIR_RootConstrainSelectedInstOperands,
     /* 206782 */     // GIR_Coverage, 7838,
     /* 206782 */     GIR_EraseRootFromParent_Done,
     /* 206783 */   // Label 4085: @206783
     /* 206783 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(206860), // Rule ID 7839 //
     /* 206788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 206796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206840 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206844 */     // MIs[2] Operand 1
     /* 206844 */     // No operand predicates
     /* 206844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206846 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 206846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 206849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206858 */     GIR_RootConstrainSelectedInstOperands,
     /* 206859 */     // GIR_Coverage, 7839,
     /* 206859 */     GIR_EraseRootFromParent_Done,
     /* 206860 */   // Label 4086: @206860
     /* 206860 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(206916), // Rule ID 55 //
     /* 206865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 206868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 206873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 206876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 206882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 206886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 206890 */     // MIs[0] Operand 3
     /* 206890 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 206901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 206905 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 206905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 206908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 206912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 206914 */     GIR_RootConstrainSelectedInstOperands,
     /* 206915 */     // GIR_Coverage, 55,
     /* 206915 */     GIR_EraseRootFromParent_Done,
     /* 206916 */   // Label 4087: @206916
     /* 206916 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(206972), // Rule ID 56 //
     /* 206921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 206924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 206929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 206932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 206938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 206942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 206946 */     // MIs[0] Operand 3
     /* 206946 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 206957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 206961 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 206961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 206964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 206968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 206970 */     GIR_RootConstrainSelectedInstOperands,
     /* 206971 */     // GIR_Coverage, 56,
     /* 206971 */     GIR_EraseRootFromParent_Done,
     /* 206972 */   // Label 4088: @206972
     /* 206972 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(207028), // Rule ID 57 //
     /* 206977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 206980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 206985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 206988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 206994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 206998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207002 */     // MIs[0] Operand 3
     /* 207002 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 207013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 207017 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 207017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 207020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 207026 */     GIR_RootConstrainSelectedInstOperands,
     /* 207027 */     // GIR_Coverage, 57,
     /* 207027 */     GIR_EraseRootFromParent_Done,
     /* 207028 */   // Label 4089: @207028
     /* 207028 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(207084), // Rule ID 58 //
     /* 207033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 207036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 207041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 207044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 207050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207058 */     // MIs[0] Operand 3
     /* 207058 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 207069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 207073 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 207073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 207076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 207082 */     GIR_RootConstrainSelectedInstOperands,
     /* 207083 */     // GIR_Coverage, 58,
     /* 207083 */     GIR_EraseRootFromParent_Done,
     /* 207084 */   // Label 4090: @207084
     /* 207084 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(207139), // Rule ID 2790 //
     /* 207089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 207097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207118 */     // MIs[0] imm
     /* 207118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 207126 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1528:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 207126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 207129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 207133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 207135 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 207137 */     GIR_RootConstrainSelectedInstOperands,
     /* 207138 */     // GIR_Coverage, 2790,
     /* 207138 */     GIR_EraseRootFromParent_Done,
     /* 207139 */   // Label 4091: @207139
     /* 207139 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(207194), // Rule ID 2791 //
     /* 207144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 207152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207173 */     // MIs[0] imm
     /* 207173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 207181 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1528:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 207181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 207184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 207188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 207190 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 207192 */     GIR_RootConstrainSelectedInstOperands,
     /* 207193 */     // GIR_Coverage, 2791,
     /* 207193 */     GIR_EraseRootFromParent_Done,
     /* 207194 */   // Label 4092: @207194
     /* 207194 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(207249), // Rule ID 2792 //
     /* 207199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 207207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207228 */     // MIs[0] imm
     /* 207228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 207236 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1528:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 207236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 207239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 207243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 207245 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 207247 */     GIR_RootConstrainSelectedInstOperands,
     /* 207248 */     // GIR_Coverage, 2792,
     /* 207248 */     GIR_EraseRootFromParent_Done,
     /* 207249 */   // Label 4093: @207249
     /* 207249 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(207304), // Rule ID 3543 //
     /* 207254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 207262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 207271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207283 */     // MIs[0] Idx
     /* 207283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 207291 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1614:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 207291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 207294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 207298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 207300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 207302 */     GIR_RootConstrainSelectedInstOperands,
     /* 207303 */     // GIR_Coverage, 3543,
     /* 207303 */     GIR_EraseRootFromParent_Done,
     /* 207304 */   // Label 4094: @207304
     /* 207304 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(207359), // Rule ID 3544 //
     /* 207309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 207317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 207326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207338 */     // MIs[0] Idx
     /* 207338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207341 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 207346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1614:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 207346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 207349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 207353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 207355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 207357 */     GIR_RootConstrainSelectedInstOperands,
     /* 207358 */     // GIR_Coverage, 3544,
     /* 207358 */     GIR_EraseRootFromParent_Done,
     /* 207359 */   // Label 4095: @207359
     /* 207359 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(207414), // Rule ID 3545 //
     /* 207364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 207372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 207381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207393 */     // MIs[0] Idx
     /* 207393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 207401 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1614:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 207401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 207404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 207408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 207410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 207412 */     GIR_RootConstrainSelectedInstOperands,
     /* 207413 */     // GIR_Coverage, 3545,
     /* 207413 */     GIR_EraseRootFromParent_Done,
     /* 207414 */   // Label 4096: @207414
     /* 207414 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(207469), // Rule ID 3825 //
     /* 207419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 207422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 207427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 207430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 207433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 207436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 207448 */     // MIs[0] imm
     /* 207448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 207456 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 207456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 207459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 207461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 207463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 207465 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 207467 */     GIR_RootConstrainSelectedInstOperands,
     /* 207468 */     // GIR_Coverage, 3825,
     /* 207468 */     GIR_EraseRootFromParent_Done,
     /* 207469 */   // Label 4097: @207469
     /* 207469 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(207516), // Rule ID 2844 //
     /* 207474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 207482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207495 */     // MIs[0] idx
     /* 207495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 207503 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1464:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 207503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 207506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207512 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 207514 */     GIR_RootConstrainSelectedInstOperands,
     /* 207515 */     // GIR_Coverage, 2844,
     /* 207515 */     GIR_EraseRootFromParent_Done,
     /* 207516 */   // Label 4098: @207516
     /* 207516 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(207563), // Rule ID 2845 //
     /* 207521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 207529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207542 */     // MIs[0] idx
     /* 207542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207545 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 207550 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1464:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 207550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 207553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207559 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 207561 */     GIR_RootConstrainSelectedInstOperands,
     /* 207562 */     // GIR_Coverage, 2845,
     /* 207562 */     GIR_EraseRootFromParent_Done,
     /* 207563 */   // Label 4099: @207563
     /* 207563 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(207610), // Rule ID 2846 //
     /* 207568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 207576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207589 */     // MIs[0] idx
     /* 207589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 207597 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1464:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 207597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 207600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207606 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 207608 */     GIR_RootConstrainSelectedInstOperands,
     /* 207609 */     // GIR_Coverage, 2846,
     /* 207609 */     GIR_EraseRootFromParent_Done,
     /* 207610 */   // Label 4100: @207610
     /* 207610 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(207657), // Rule ID 2995 //
     /* 207615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 207623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207636 */     // MIs[0] Op3
     /* 207636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207639 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 207644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1595:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 207644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 207647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207655 */     GIR_RootConstrainSelectedInstOperands,
     /* 207656 */     // GIR_Coverage, 2995,
     /* 207656 */     GIR_EraseRootFromParent_Done,
     /* 207657 */   // Label 4101: @207657
     /* 207657 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(207704), // Rule ID 2996 //
     /* 207662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 207670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207683 */     // MIs[0] Op3
     /* 207683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 207691 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1595:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 207691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 207694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207702 */     GIR_RootConstrainSelectedInstOperands,
     /* 207703 */     // GIR_Coverage, 2996,
     /* 207703 */     GIR_EraseRootFromParent_Done,
     /* 207704 */   // Label 4102: @207704
     /* 207704 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(207751), // Rule ID 2997 //
     /* 207709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 207717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207730 */     // MIs[0] Op3
     /* 207730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207733 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 207738 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1595:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 207738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 207741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207749 */     GIR_RootConstrainSelectedInstOperands,
     /* 207750 */     // GIR_Coverage, 2997,
     /* 207750 */     GIR_EraseRootFromParent_Done,
     /* 207751 */   // Label 4103: @207751
     /* 207751 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(207798), // Rule ID 2998 //
     /* 207756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 207764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207777 */     // MIs[0] Op3
     /* 207777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 207785 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1741:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 207785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 207788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207796 */     GIR_RootConstrainSelectedInstOperands,
     /* 207797 */     // GIR_Coverage, 2998,
     /* 207797 */     GIR_EraseRootFromParent_Done,
     /* 207798 */   // Label 4104: @207798
     /* 207798 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(207845), // Rule ID 2999 //
     /* 207803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 207811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207824 */     // MIs[0] Op3
     /* 207824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207827 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 207832 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1741:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 207832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 207835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207841 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207843 */     GIR_RootConstrainSelectedInstOperands,
     /* 207844 */     // GIR_Coverage, 2999,
     /* 207844 */     GIR_EraseRootFromParent_Done,
     /* 207845 */   // Label 4105: @207845
     /* 207845 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(207892), // Rule ID 3047 //
     /* 207850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 207858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207871 */     // MIs[0] Op3
     /* 207871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207874 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 207879 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 207879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 207882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207890 */     GIR_RootConstrainSelectedInstOperands,
     /* 207891 */     // GIR_Coverage, 3047,
     /* 207891 */     GIR_EraseRootFromParent_Done,
     /* 207892 */   // Label 4106: @207892
     /* 207892 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(207939), // Rule ID 3049 //
     /* 207897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 207905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207918 */     // MIs[0] Op3
     /* 207918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 207926 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 207926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 207929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207935 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207937 */     GIR_RootConstrainSelectedInstOperands,
     /* 207938 */     // GIR_Coverage, 3049,
     /* 207938 */     GIR_EraseRootFromParent_Done,
     /* 207939 */   // Label 4107: @207939
     /* 207939 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(207986), // Rule ID 3051 //
     /* 207944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 207952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207965 */     // MIs[0] Op3
     /* 207965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 207973 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 207973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 207976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 207978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 207984 */     GIR_RootConstrainSelectedInstOperands,
     /* 207985 */     // GIR_Coverage, 3051,
     /* 207985 */     GIR_EraseRootFromParent_Done,
     /* 207986 */   // Label 4108: @207986
     /* 207986 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(208033), // Rule ID 3053 //
     /* 207991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 207999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208012 */     // MIs[0] Op3
     /* 208012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208015 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 208020 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1852:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 208020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 208023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 208025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208031 */     GIR_RootConstrainSelectedInstOperands,
     /* 208032 */     // GIR_Coverage, 3053,
     /* 208032 */     GIR_EraseRootFromParent_Done,
     /* 208033 */   // Label 4109: @208033
     /* 208033 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(208080), // Rule ID 3075 //
     /* 208038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 208046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208059 */     // MIs[0] Op3
     /* 208059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208062 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208067 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1832:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 208070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208078 */     GIR_RootConstrainSelectedInstOperands,
     /* 208079 */     // GIR_Coverage, 3075,
     /* 208079 */     GIR_EraseRootFromParent_Done,
     /* 208080 */   // Label 4110: @208080
     /* 208080 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(208127), // Rule ID 3076 //
     /* 208085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 208093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208106 */     // MIs[0] Op3
     /* 208106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208109 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 208114 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1832:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 208114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 208117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208125 */     GIR_RootConstrainSelectedInstOperands,
     /* 208126 */     // GIR_Coverage, 3076,
     /* 208126 */     GIR_EraseRootFromParent_Done,
     /* 208127 */   // Label 4111: @208127
     /* 208127 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(208174), // Rule ID 3077 //
     /* 208132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 208140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208153 */     // MIs[0] Op3
     /* 208153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208156 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 208161 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1832:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 208161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 208164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208172 */     GIR_RootConstrainSelectedInstOperands,
     /* 208173 */     // GIR_Coverage, 3077,
     /* 208173 */     GIR_EraseRootFromParent_Done,
     /* 208174 */   // Label 4112: @208174
     /* 208174 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(208221), // Rule ID 3146 //
     /* 208179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 208187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208200 */     // MIs[0] Op3
     /* 208200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208203 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208208 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2133:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 208211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208219 */     GIR_RootConstrainSelectedInstOperands,
     /* 208220 */     // GIR_Coverage, 3146,
     /* 208220 */     GIR_EraseRootFromParent_Done,
     /* 208221 */   // Label 4113: @208221
     /* 208221 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(208268), // Rule ID 3147 //
     /* 208226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 208234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208247 */     // MIs[0] Op3
     /* 208247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208250 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 208255 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2133:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 208255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 208258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208266 */     GIR_RootConstrainSelectedInstOperands,
     /* 208267 */     // GIR_Coverage, 3147,
     /* 208267 */     GIR_EraseRootFromParent_Done,
     /* 208268 */   // Label 4114: @208268
     /* 208268 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(208315), // Rule ID 3148 //
     /* 208273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 208281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208294 */     // MIs[0] Op3
     /* 208294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208297 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 208302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2133:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 208302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 208305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208313 */     GIR_RootConstrainSelectedInstOperands,
     /* 208314 */     // GIR_Coverage, 3148,
     /* 208314 */     GIR_EraseRootFromParent_Done,
     /* 208315 */   // Label 4115: @208315
     /* 208315 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(208362), // Rule ID 3149 //
     /* 208320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 208328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208341 */     // MIs[0] Op3
     /* 208341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 208349 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2133:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 208349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 208352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208360 */     GIR_RootConstrainSelectedInstOperands,
     /* 208361 */     // GIR_Coverage, 3149,
     /* 208361 */     GIR_EraseRootFromParent_Done,
     /* 208362 */   // Label 4116: @208362
     /* 208362 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(208409), // Rule ID 3528 //
     /* 208367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 208375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208388 */     // MIs[0] Op3
     /* 208388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208391 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 208396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1343:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 208396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 208399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208407 */     GIR_RootConstrainSelectedInstOperands,
     /* 208408 */     // GIR_Coverage, 3528,
     /* 208408 */     GIR_EraseRootFromParent_Done,
     /* 208409 */   // Label 4117: @208409
     /* 208409 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(208456), // Rule ID 3576 //
     /* 208414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 208417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 208422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208435 */     // MIs[0] Op3
     /* 208435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208438 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 208443 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1582:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 208443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 208446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208452 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208454 */     GIR_RootConstrainSelectedInstOperands,
     /* 208455 */     // GIR_Coverage, 3576,
     /* 208455 */     GIR_EraseRootFromParent_Done,
     /* 208456 */   // Label 4118: @208456
     /* 208456 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(208503), // Rule ID 3577 //
     /* 208461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 208464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 208469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208482 */     // MIs[0] Op3
     /* 208482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208485 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 208490 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1582:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 208490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 208493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208499 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208501 */     GIR_RootConstrainSelectedInstOperands,
     /* 208502 */     // GIR_Coverage, 3577,
     /* 208502 */     GIR_EraseRootFromParent_Done,
     /* 208503 */   // Label 4119: @208503
     /* 208503 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(208550), // Rule ID 3578 //
     /* 208508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 208511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 208516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208529 */     // MIs[0] Op3
     /* 208529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 208537 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1582:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 208537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 208540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208548 */     GIR_RootConstrainSelectedInstOperands,
     /* 208549 */     // GIR_Coverage, 3578,
     /* 208549 */     GIR_EraseRootFromParent_Done,
     /* 208550 */   // Label 4120: @208550
     /* 208550 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(208597), // Rule ID 3579 //
     /* 208555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 208558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 208563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208576 */     // MIs[0] Op3
     /* 208576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208579 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 208584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1583:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 208584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 208587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208595 */     GIR_RootConstrainSelectedInstOperands,
     /* 208596 */     // GIR_Coverage, 3579,
     /* 208596 */     GIR_EraseRootFromParent_Done,
     /* 208597 */   // Label 4121: @208597
     /* 208597 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(208644), // Rule ID 3580 //
     /* 208602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 208605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 208610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208623 */     // MIs[0] Op3
     /* 208623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 208631 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1583:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 208631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 208634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208642 */     GIR_RootConstrainSelectedInstOperands,
     /* 208643 */     // GIR_Coverage, 3580,
     /* 208643 */     GIR_EraseRootFromParent_Done,
     /* 208644 */   // Label 4122: @208644
     /* 208644 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(208691), // Rule ID 3581 //
     /* 208649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 208652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 208657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208670 */     // MIs[0] Op3
     /* 208670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208673 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 208678 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1583:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 208678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 208681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208689 */     GIR_RootConstrainSelectedInstOperands,
     /* 208690 */     // GIR_Coverage, 3581,
     /* 208690 */     GIR_EraseRootFromParent_Done,
     /* 208691 */   // Label 4123: @208691
     /* 208691 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(208738), // Rule ID 11236 //
     /* 208696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 208704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208717 */     // MIs[0] Op3
     /* 208717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208720 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 208725 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1782:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 208725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 208728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208736 */     GIR_RootConstrainSelectedInstOperands,
     /* 208737 */     // GIR_Coverage, 11236,
     /* 208737 */     GIR_EraseRootFromParent_Done,
     /* 208738 */   // Label 4124: @208738
     /* 208738 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(208785), // Rule ID 11237 //
     /* 208743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 208751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208764 */     // MIs[0] Op3
     /* 208764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208767 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 208772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1782:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 208772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 208775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208783 */     GIR_RootConstrainSelectedInstOperands,
     /* 208784 */     // GIR_Coverage, 11237,
     /* 208784 */     GIR_EraseRootFromParent_Done,
     /* 208785 */   // Label 4125: @208785
     /* 208785 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(208832), // Rule ID 11238 //
     /* 208790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 208798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208811 */     // MIs[0] Op3
     /* 208811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208814 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 208819 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1782:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 208819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 208822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208830 */     GIR_RootConstrainSelectedInstOperands,
     /* 208831 */     // GIR_Coverage, 11238,
     /* 208831 */     GIR_EraseRootFromParent_Done,
     /* 208832 */   // Label 4126: @208832
     /* 208832 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(208879), // Rule ID 11239 //
     /* 208837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 208845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208858 */     // MIs[0] Op3
     /* 208858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208861 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 208866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1813:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 208866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 208869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208877 */     GIR_RootConstrainSelectedInstOperands,
     /* 208878 */     // GIR_Coverage, 11239,
     /* 208878 */     GIR_EraseRootFromParent_Done,
     /* 208879 */   // Label 4127: @208879
     /* 208879 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(208926), // Rule ID 11240 //
     /* 208884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 208892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208905 */     // MIs[0] Op3
     /* 208905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208908 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 208913 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1813:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 208913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 208916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208924 */     GIR_RootConstrainSelectedInstOperands,
     /* 208925 */     // GIR_Coverage, 11240,
     /* 208925 */     GIR_EraseRootFromParent_Done,
     /* 208926 */   // Label 4128: @208926
     /* 208926 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(208973), // Rule ID 11241 //
     /* 208931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 208939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208952 */     // MIs[0] Op3
     /* 208952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 208960 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1813:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 208960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 208963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208969 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208971 */     GIR_RootConstrainSelectedInstOperands,
     /* 208972 */     // GIR_Coverage, 11241,
     /* 208972 */     GIR_EraseRootFromParent_Done,
     /* 208973 */   // Label 4129: @208973
     /* 208973 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(209020), // Rule ID 11264 //
     /* 208978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 208986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208999 */     // MIs[0] Op3
     /* 208999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209007 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1743:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 209010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209018 */     GIR_RootConstrainSelectedInstOperands,
     /* 209019 */     // GIR_Coverage, 11264,
     /* 209019 */     GIR_EraseRootFromParent_Done,
     /* 209020 */   // Label 4130: @209020
     /* 209020 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(209067), // Rule ID 11265 //
     /* 209025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 209033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209046 */     // MIs[0] Op3
     /* 209046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209049 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209054 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1743:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 209057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209065 */     GIR_RootConstrainSelectedInstOperands,
     /* 209066 */     // GIR_Coverage, 11265,
     /* 209066 */     GIR_EraseRootFromParent_Done,
     /* 209067 */   // Label 4131: @209067
     /* 209067 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(209114), // Rule ID 11266 //
     /* 209072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 209080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209093 */     // MIs[0] Op3
     /* 209093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209101 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1979:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 209104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209112 */     GIR_RootConstrainSelectedInstOperands,
     /* 209113 */     // GIR_Coverage, 11266,
     /* 209113 */     GIR_EraseRootFromParent_Done,
     /* 209114 */   // Label 4132: @209114
     /* 209114 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(209161), // Rule ID 11267 //
     /* 209119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 209127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209140 */     // MIs[0] Op3
     /* 209140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209148 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1979:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 209151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209159 */     GIR_RootConstrainSelectedInstOperands,
     /* 209160 */     // GIR_Coverage, 11267,
     /* 209160 */     GIR_EraseRootFromParent_Done,
     /* 209161 */   // Label 4133: @209161
     /* 209161 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(209208), // Rule ID 11268 //
     /* 209166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 209174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209187 */     // MIs[0] Op3
     /* 209187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209190 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209195 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1981:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 209198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209206 */     GIR_RootConstrainSelectedInstOperands,
     /* 209207 */     // GIR_Coverage, 11268,
     /* 209207 */     GIR_EraseRootFromParent_Done,
     /* 209208 */   // Label 4134: @209208
     /* 209208 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(209255), // Rule ID 11269 //
     /* 209213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 209221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209234 */     // MIs[0] Op3
     /* 209234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209237 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209242 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1981:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 209245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209253 */     GIR_RootConstrainSelectedInstOperands,
     /* 209254 */     // GIR_Coverage, 11269,
     /* 209254 */     GIR_EraseRootFromParent_Done,
     /* 209255 */   // Label 4135: @209255
     /* 209255 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(209302), // Rule ID 11270 //
     /* 209260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 209268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209281 */     // MIs[0] Op3
     /* 209281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209284 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209289 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1788:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 209292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209300 */     GIR_RootConstrainSelectedInstOperands,
     /* 209301 */     // GIR_Coverage, 11270,
     /* 209301 */     GIR_EraseRootFromParent_Done,
     /* 209302 */   // Label 4136: @209302
     /* 209302 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(209349), // Rule ID 11271 //
     /* 209307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 209315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209328 */     // MIs[0] Op3
     /* 209328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209331 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209336 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1788:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 209339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209347 */     GIR_RootConstrainSelectedInstOperands,
     /* 209348 */     // GIR_Coverage, 11271,
     /* 209348 */     GIR_EraseRootFromParent_Done,
     /* 209349 */   // Label 4137: @209349
     /* 209349 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(209396), // Rule ID 11272 //
     /* 209354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 209362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209375 */     // MIs[0] Op3
     /* 209375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209383 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1790:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 209386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209394 */     GIR_RootConstrainSelectedInstOperands,
     /* 209395 */     // GIR_Coverage, 11272,
     /* 209395 */     GIR_EraseRootFromParent_Done,
     /* 209396 */   // Label 4138: @209396
     /* 209396 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(209443), // Rule ID 11273 //
     /* 209401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 209409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209422 */     // MIs[0] Op3
     /* 209422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209425 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209430 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1790:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 209433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209441 */     GIR_RootConstrainSelectedInstOperands,
     /* 209442 */     // GIR_Coverage, 11273,
     /* 209442 */     GIR_EraseRootFromParent_Done,
     /* 209443 */   // Label 4139: @209443
     /* 209443 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(209490), // Rule ID 11517 //
     /* 209448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 209456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209469 */     // MIs[0] Op3
     /* 209469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209472 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 209477 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1848:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 209477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 209480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209488 */     GIR_RootConstrainSelectedInstOperands,
     /* 209489 */     // GIR_Coverage, 11517,
     /* 209489 */     GIR_EraseRootFromParent_Done,
     /* 209490 */   // Label 4140: @209490
     /* 209490 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(209537), // Rule ID 11518 //
     /* 209495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 209503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 209509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209516 */     // MIs[0] Op3
     /* 209516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 209524 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1848:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 209524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 209527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209535 */     GIR_RootConstrainSelectedInstOperands,
     /* 209536 */     // GIR_Coverage, 11518,
     /* 209536 */     GIR_EraseRootFromParent_Done,
     /* 209537 */   // Label 4141: @209537
     /* 209537 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(209584), // Rule ID 11519 //
     /* 209542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 209550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 209556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209563 */     // MIs[0] Op3
     /* 209563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 209571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1848:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 209571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 209574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209582 */     GIR_RootConstrainSelectedInstOperands,
     /* 209583 */     // GIR_Coverage, 11519,
     /* 209583 */     GIR_EraseRootFromParent_Done,
     /* 209584 */   // Label 4142: @209584
     /* 209584 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(209631), // Rule ID 11520 //
     /* 209589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 209597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 209603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209610 */     // MIs[0] Op3
     /* 209610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209613 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 209618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1848:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 209618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 209621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209629 */     GIR_RootConstrainSelectedInstOperands,
     /* 209630 */     // GIR_Coverage, 11520,
     /* 209630 */     GIR_EraseRootFromParent_Done,
     /* 209631 */   // Label 4143: @209631
     /* 209631 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(209678), // Rule ID 11521 //
     /* 209636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 209644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209657 */     // MIs[0] Op3
     /* 209657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 209665 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2039:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 209665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 209668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209676 */     GIR_RootConstrainSelectedInstOperands,
     /* 209677 */     // GIR_Coverage, 11521,
     /* 209677 */     GIR_EraseRootFromParent_Done,
     /* 209678 */   // Label 4144: @209678
     /* 209678 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(209725), // Rule ID 11523 //
     /* 209683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 209691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 209697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209704 */     // MIs[0] Op3
     /* 209704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209707 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 209712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2039:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 209712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 209715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209723 */     GIR_RootConstrainSelectedInstOperands,
     /* 209724 */     // GIR_Coverage, 11523,
     /* 209724 */     GIR_EraseRootFromParent_Done,
     /* 209725 */   // Label 4145: @209725
     /* 209725 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(209772), // Rule ID 11525 //
     /* 209730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 209738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 209744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209751 */     // MIs[0] Op3
     /* 209751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209754 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 209759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2039:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 209759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 209762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209770 */     GIR_RootConstrainSelectedInstOperands,
     /* 209771 */     // GIR_Coverage, 11525,
     /* 209771 */     GIR_EraseRootFromParent_Done,
     /* 209772 */   // Label 4146: @209772
     /* 209772 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(209819), // Rule ID 11527 //
     /* 209777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 209785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 209791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209798 */     // MIs[0] Op3
     /* 209798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209801 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 209806 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2039:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 209806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 209809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209817 */     GIR_RootConstrainSelectedInstOperands,
     /* 209818 */     // GIR_Coverage, 11527,
     /* 209818 */     GIR_EraseRootFromParent_Done,
     /* 209819 */   // Label 4147: @209819
     /* 209819 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(209866), // Rule ID 11529 //
     /* 209824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 209832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 209838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209845 */     // MIs[0] Op3
     /* 209845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209848 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 209853 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1828:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 209853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 209856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209864 */     GIR_RootConstrainSelectedInstOperands,
     /* 209865 */     // GIR_Coverage, 11529,
     /* 209865 */     GIR_EraseRootFromParent_Done,
     /* 209866 */   // Label 4148: @209866
     /* 209866 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(209913), // Rule ID 11530 //
     /* 209871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 209879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 209885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209892 */     // MIs[0] Op3
     /* 209892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 209900 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1828:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 209900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 209903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209911 */     GIR_RootConstrainSelectedInstOperands,
     /* 209912 */     // GIR_Coverage, 11530,
     /* 209912 */     GIR_EraseRootFromParent_Done,
     /* 209913 */   // Label 4149: @209913
     /* 209913 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(209960), // Rule ID 11531 //
     /* 209918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 209926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 209932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209939 */     // MIs[0] Op3
     /* 209939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209942 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 209947 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1828:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 209947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 209950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209958 */     GIR_RootConstrainSelectedInstOperands,
     /* 209959 */     // GIR_Coverage, 11531,
     /* 209959 */     GIR_EraseRootFromParent_Done,
     /* 209960 */   // Label 4150: @209960
     /* 209960 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(210007), // Rule ID 11532 //
     /* 209965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 209973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 209979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209986 */     // MIs[0] Op3
     /* 209986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209989 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 209994 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1828:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 209994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 209997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210005 */     GIR_RootConstrainSelectedInstOperands,
     /* 210006 */     // GIR_Coverage, 11532,
     /* 210006 */     GIR_EraseRootFromParent_Done,
     /* 210007 */   // Label 4151: @210007
     /* 210007 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(210054), // Rule ID 11607 //
     /* 210012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210033 */     // MIs[0] Op3
     /* 210033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210036 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210041 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2048:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 210044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210052 */     GIR_RootConstrainSelectedInstOperands,
     /* 210053 */     // GIR_Coverage, 11607,
     /* 210053 */     GIR_EraseRootFromParent_Done,
     /* 210054 */   // Label 4152: @210054
     /* 210054 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(210101), // Rule ID 11609 //
     /* 210059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210080 */     // MIs[0] Op3
     /* 210080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210088 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2048:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 210091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210099 */     GIR_RootConstrainSelectedInstOperands,
     /* 210100 */     // GIR_Coverage, 11609,
     /* 210100 */     GIR_EraseRootFromParent_Done,
     /* 210101 */   // Label 4153: @210101
     /* 210101 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(210148), // Rule ID 11611 //
     /* 210106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210127 */     // MIs[0] Op3
     /* 210127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210135 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2048:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 210138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210146 */     GIR_RootConstrainSelectedInstOperands,
     /* 210147 */     // GIR_Coverage, 11611,
     /* 210147 */     GIR_EraseRootFromParent_Done,
     /* 210148 */   // Label 4154: @210148
     /* 210148 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(210195), // Rule ID 11613 //
     /* 210153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210174 */     // MIs[0] Op3
     /* 210174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 210182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2048:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 210182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 210185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210193 */     GIR_RootConstrainSelectedInstOperands,
     /* 210194 */     // GIR_Coverage, 11613,
     /* 210194 */     GIR_EraseRootFromParent_Done,
     /* 210195 */   // Label 4155: @210195
     /* 210195 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(210242), // Rule ID 11615 //
     /* 210200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 210208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210221 */     // MIs[0] Op3
     /* 210221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210224 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210229 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 210232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210240 */     GIR_RootConstrainSelectedInstOperands,
     /* 210241 */     // GIR_Coverage, 11615,
     /* 210241 */     GIR_EraseRootFromParent_Done,
     /* 210242 */   // Label 4156: @210242
     /* 210242 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(210289), // Rule ID 11616 //
     /* 210247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 210255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210268 */     // MIs[0] Op3
     /* 210268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210276 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 210279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210287 */     GIR_RootConstrainSelectedInstOperands,
     /* 210288 */     // GIR_Coverage, 11616,
     /* 210288 */     GIR_EraseRootFromParent_Done,
     /* 210289 */   // Label 4157: @210289
     /* 210289 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(210336), // Rule ID 11617 //
     /* 210294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 210302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210315 */     // MIs[0] Op3
     /* 210315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210323 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 210326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210334 */     GIR_RootConstrainSelectedInstOperands,
     /* 210335 */     // GIR_Coverage, 11617,
     /* 210335 */     GIR_EraseRootFromParent_Done,
     /* 210336 */   // Label 4158: @210336
     /* 210336 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(210383), // Rule ID 11618 //
     /* 210341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 210349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210362 */     // MIs[0] Op3
     /* 210362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210365 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 210370 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1849:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 210370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 210373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210381 */     GIR_RootConstrainSelectedInstOperands,
     /* 210382 */     // GIR_Coverage, 11618,
     /* 210382 */     GIR_EraseRootFromParent_Done,
     /* 210383 */   // Label 4159: @210383
     /* 210383 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(210430), // Rule ID 11623 //
     /* 210388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 210396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210409 */     // MIs[0] Op3
     /* 210409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210412 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210417 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2041:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 210420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210428 */     GIR_RootConstrainSelectedInstOperands,
     /* 210429 */     // GIR_Coverage, 11623,
     /* 210429 */     GIR_EraseRootFromParent_Done,
     /* 210430 */   // Label 4160: @210430
     /* 210430 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(210477), // Rule ID 11624 //
     /* 210435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 210443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210456 */     // MIs[0] Op3
     /* 210456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2041:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 210467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210475 */     GIR_RootConstrainSelectedInstOperands,
     /* 210476 */     // GIR_Coverage, 11624,
     /* 210476 */     GIR_EraseRootFromParent_Done,
     /* 210477 */   // Label 4161: @210477
     /* 210477 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(210524), // Rule ID 11625 //
     /* 210482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 210490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210503 */     // MIs[0] Op3
     /* 210503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210511 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2041:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 210514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210522 */     GIR_RootConstrainSelectedInstOperands,
     /* 210523 */     // GIR_Coverage, 11625,
     /* 210523 */     GIR_EraseRootFromParent_Done,
     /* 210524 */   // Label 4162: @210524
     /* 210524 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(210571), // Rule ID 11626 //
     /* 210529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 210537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210550 */     // MIs[0] Op3
     /* 210550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210553 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 210558 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2041:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 210558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 210561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210569 */     GIR_RootConstrainSelectedInstOperands,
     /* 210570 */     // GIR_Coverage, 11626,
     /* 210570 */     GIR_EraseRootFromParent_Done,
     /* 210571 */   // Label 4163: @210571
     /* 210571 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(210618), // Rule ID 11686 //
     /* 210576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 210584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210597 */     // MIs[0] Op3
     /* 210597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210605 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 210608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210616 */     GIR_RootConstrainSelectedInstOperands,
     /* 210617 */     // GIR_Coverage, 11686,
     /* 210617 */     GIR_EraseRootFromParent_Done,
     /* 210618 */   // Label 4164: @210618
     /* 210618 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(210665), // Rule ID 11687 //
     /* 210623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 210631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210644 */     // MIs[0] Op3
     /* 210644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210647 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 210655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210663 */     GIR_RootConstrainSelectedInstOperands,
     /* 210664 */     // GIR_Coverage, 11687,
     /* 210664 */     GIR_EraseRootFromParent_Done,
     /* 210665 */   // Label 4165: @210665
     /* 210665 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(210712), // Rule ID 11688 //
     /* 210670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 210678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210691 */     // MIs[0] Op3
     /* 210691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210699 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 210702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210710 */     GIR_RootConstrainSelectedInstOperands,
     /* 210711 */     // GIR_Coverage, 11688,
     /* 210711 */     GIR_EraseRootFromParent_Done,
     /* 210712 */   // Label 4166: @210712
     /* 210712 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(210759), // Rule ID 11689 //
     /* 210717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 210725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210738 */     // MIs[0] Op3
     /* 210738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210741 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210746 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1705:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 210749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210757 */     GIR_RootConstrainSelectedInstOperands,
     /* 210758 */     // GIR_Coverage, 11689,
     /* 210758 */     GIR_EraseRootFromParent_Done,
     /* 210759 */   // Label 4167: @210759
     /* 210759 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(210806), // Rule ID 11690 //
     /* 210764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 210772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210785 */     // MIs[0] Op3
     /* 210785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1705:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 210796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210804 */     GIR_RootConstrainSelectedInstOperands,
     /* 210805 */     // GIR_Coverage, 11690,
     /* 210805 */     GIR_EraseRootFromParent_Done,
     /* 210806 */   // Label 4168: @210806
     /* 210806 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(210853), // Rule ID 11691 //
     /* 210811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 210819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210832 */     // MIs[0] Op3
     /* 210832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1705:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 210843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210851 */     GIR_RootConstrainSelectedInstOperands,
     /* 210852 */     // GIR_Coverage, 11691,
     /* 210852 */     GIR_EraseRootFromParent_Done,
     /* 210853 */   // Label 4169: @210853
     /* 210853 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(210900), // Rule ID 11692 //
     /* 210858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 210866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210879 */     // MIs[0] Op3
     /* 210879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210882 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210887 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1663:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 210890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210898 */     GIR_RootConstrainSelectedInstOperands,
     /* 210899 */     // GIR_Coverage, 11692,
     /* 210899 */     GIR_EraseRootFromParent_Done,
     /* 210900 */   // Label 4170: @210900
     /* 210900 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(210947), // Rule ID 11693 //
     /* 210905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 210913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210926 */     // MIs[0] Op3
     /* 210926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210929 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210934 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1663:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 210937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210945 */     GIR_RootConstrainSelectedInstOperands,
     /* 210946 */     // GIR_Coverage, 11693,
     /* 210946 */     GIR_EraseRootFromParent_Done,
     /* 210947 */   // Label 4171: @210947
     /* 210947 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(210994), // Rule ID 11694 //
     /* 210952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 210960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210973 */     // MIs[0] Op3
     /* 210973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210976 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210981 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1663:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 210984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210992 */     GIR_RootConstrainSelectedInstOperands,
     /* 210993 */     // GIR_Coverage, 11694,
     /* 210993 */     GIR_EraseRootFromParent_Done,
     /* 210994 */   // Label 4172: @210994
     /* 210994 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(211041), // Rule ID 11695 //
     /* 210999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 211007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211020 */     // MIs[0] Op3
     /* 211020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211028 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1830:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 211031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211039 */     GIR_RootConstrainSelectedInstOperands,
     /* 211040 */     // GIR_Coverage, 11695,
     /* 211040 */     GIR_EraseRootFromParent_Done,
     /* 211041 */   // Label 4173: @211041
     /* 211041 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(211088), // Rule ID 11696 //
     /* 211046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 211054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211067 */     // MIs[0] Op3
     /* 211067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211070 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211075 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1830:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 211078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211086 */     GIR_RootConstrainSelectedInstOperands,
     /* 211087 */     // GIR_Coverage, 11696,
     /* 211087 */     GIR_EraseRootFromParent_Done,
     /* 211088 */   // Label 4174: @211088
     /* 211088 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(211135), // Rule ID 11697 //
     /* 211093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 211101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211114 */     // MIs[0] Op3
     /* 211114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211122 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1830:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 211125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211131 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211133 */     GIR_RootConstrainSelectedInstOperands,
     /* 211134 */     // GIR_Coverage, 11697,
     /* 211134 */     GIR_EraseRootFromParent_Done,
     /* 211135 */   // Label 4175: @211135
     /* 211135 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(211182), // Rule ID 11698 //
     /* 211140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 211148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211161 */     // MIs[0] Op3
     /* 211161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211164 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211169 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1820:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 211172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211180 */     GIR_RootConstrainSelectedInstOperands,
     /* 211181 */     // GIR_Coverage, 11698,
     /* 211181 */     GIR_EraseRootFromParent_Done,
     /* 211182 */   // Label 4176: @211182
     /* 211182 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(211229), // Rule ID 11699 //
     /* 211187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 211195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211208 */     // MIs[0] Op3
     /* 211208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211211 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1820:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 211219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211227 */     GIR_RootConstrainSelectedInstOperands,
     /* 211228 */     // GIR_Coverage, 11699,
     /* 211228 */     GIR_EraseRootFromParent_Done,
     /* 211229 */   // Label 4177: @211229
     /* 211229 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(211276), // Rule ID 11700 //
     /* 211234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 211242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211255 */     // MIs[0] Op3
     /* 211255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1820:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 211266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211274 */     GIR_RootConstrainSelectedInstOperands,
     /* 211275 */     // GIR_Coverage, 11700,
     /* 211275 */     GIR_EraseRootFromParent_Done,
     /* 211276 */   // Label 4178: @211276
     /* 211276 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(211323), // Rule ID 11701 //
     /* 211281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 211289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211302 */     // MIs[0] Op3
     /* 211302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211310 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2025:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 211313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211321 */     GIR_RootConstrainSelectedInstOperands,
     /* 211322 */     // GIR_Coverage, 11701,
     /* 211322 */     GIR_EraseRootFromParent_Done,
     /* 211323 */   // Label 4179: @211323
     /* 211323 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(211370), // Rule ID 11702 //
     /* 211328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 211336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211349 */     // MIs[0] Op3
     /* 211349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211357 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2025:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 211360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211368 */     GIR_RootConstrainSelectedInstOperands,
     /* 211369 */     // GIR_Coverage, 11702,
     /* 211369 */     GIR_EraseRootFromParent_Done,
     /* 211370 */   // Label 4180: @211370
     /* 211370 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(211417), // Rule ID 11703 //
     /* 211375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 211383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211396 */     // MIs[0] Op3
     /* 211396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2025:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 211407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211415 */     GIR_RootConstrainSelectedInstOperands,
     /* 211416 */     // GIR_Coverage, 11703,
     /* 211416 */     GIR_EraseRootFromParent_Done,
     /* 211417 */   // Label 4181: @211417
     /* 211417 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(211464), // Rule ID 11704 //
     /* 211422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 211430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211443 */     // MIs[0] Op3
     /* 211443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211451 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2022:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 211454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211462 */     GIR_RootConstrainSelectedInstOperands,
     /* 211463 */     // GIR_Coverage, 11704,
     /* 211463 */     GIR_EraseRootFromParent_Done,
     /* 211464 */   // Label 4182: @211464
     /* 211464 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(211511), // Rule ID 11705 //
     /* 211469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 211477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211490 */     // MIs[0] Op3
     /* 211490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211493 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211498 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2022:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 211501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211507 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211509 */     GIR_RootConstrainSelectedInstOperands,
     /* 211510 */     // GIR_Coverage, 11705,
     /* 211510 */     GIR_EraseRootFromParent_Done,
     /* 211511 */   // Label 4183: @211511
     /* 211511 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(211558), // Rule ID 11706 //
     /* 211516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 211524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211537 */     // MIs[0] Op3
     /* 211537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211540 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211545 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2022:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 211548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211556 */     GIR_RootConstrainSelectedInstOperands,
     /* 211557 */     // GIR_Coverage, 11706,
     /* 211557 */     GIR_EraseRootFromParent_Done,
     /* 211558 */   // Label 4184: @211558
     /* 211558 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(211625), // Rule ID 2595 //
     /* 211563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 211571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 211580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 211583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 211595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211597 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2032:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 211600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 211604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 211609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 211611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 211614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 211619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 211621 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 211623 */     GIR_RootConstrainSelectedInstOperands,
     /* 211624 */     // GIR_Coverage, 2595,
     /* 211624 */     GIR_EraseRootFromParent_Done,
     /* 211625 */   // Label 4185: @211625
     /* 211625 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(211692), // Rule ID 7637 //
     /* 211630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 211633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 211638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 211647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 211650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 211662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211664 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1296:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 211667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 211671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 211676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 211678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 211681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 211686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 211688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 211690 */     GIR_RootConstrainSelectedInstOperands,
     /* 211691 */     // GIR_Coverage, 7637,
     /* 211691 */     GIR_EraseRootFromParent_Done,
     /* 211692 */   // Label 4186: @211692
     /* 211692 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(211759), // Rule ID 7639 //
     /* 211697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 211700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 211705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 211714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 211717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 211729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1296:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 211734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 211738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 211743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 211745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 211748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 211753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 211755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 211757 */     GIR_RootConstrainSelectedInstOperands,
     /* 211758 */     // GIR_Coverage, 7639,
     /* 211758 */     GIR_EraseRootFromParent_Done,
     /* 211759 */   // Label 4187: @211759
     /* 211759 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(211826), // Rule ID 7641 //
     /* 211764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 211767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 211772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 211781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 211784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 211796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1296:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 211801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 211805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 211810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 211812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 211815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 211820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 211822 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 211824 */     GIR_RootConstrainSelectedInstOperands,
     /* 211825 */     // GIR_Coverage, 7641,
     /* 211825 */     GIR_EraseRootFromParent_Done,
     /* 211826 */   // Label 4188: @211826
     /* 211826 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(211893), // Rule ID 7643 //
     /* 211831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 211834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 211839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 211848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 211851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 211863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211865 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1296:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 211865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 211868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 211872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 211877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 211879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 211882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 211887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 211889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 211891 */     GIR_RootConstrainSelectedInstOperands,
     /* 211892 */     // GIR_Coverage, 7643,
     /* 211892 */     GIR_EraseRootFromParent_Done,
     /* 211893 */   // Label 4189: @211893
     /* 211893 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(211960), // Rule ID 7673 //
     /* 211898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 211901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 211906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 211915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 211918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 211930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211932 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1316:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 211935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 211939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 211944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 211946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 211949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 211954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 211956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 211958 */     GIR_RootConstrainSelectedInstOperands,
     /* 211959 */     // GIR_Coverage, 7673,
     /* 211959 */     GIR_EraseRootFromParent_Done,
     /* 211960 */   // Label 4190: @211960
     /* 211960 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(212027), // Rule ID 7675 //
     /* 211965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 211968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 211973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 211982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 211985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 211997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211999 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1316:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 212016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212025 */     GIR_RootConstrainSelectedInstOperands,
     /* 212026 */     // GIR_Coverage, 7675,
     /* 212026 */     GIR_EraseRootFromParent_Done,
     /* 212027 */   // Label 4191: @212027
     /* 212027 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(212094), // Rule ID 7677 //
     /* 212032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 212040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212066 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1316:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 212083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212092 */     GIR_RootConstrainSelectedInstOperands,
     /* 212093 */     // GIR_Coverage, 7677,
     /* 212093 */     GIR_EraseRootFromParent_Done,
     /* 212094 */   // Label 4192: @212094
     /* 212094 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(212161), // Rule ID 7679 //
     /* 212099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 212107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212133 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1316:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 212150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212159 */     GIR_RootConstrainSelectedInstOperands,
     /* 212160 */     // GIR_Coverage, 7679,
     /* 212160 */     GIR_EraseRootFromParent_Done,
     /* 212161 */   // Label 4193: @212161
     /* 212161 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(212228), // Rule ID 7685 //
     /* 212166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 212174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 212186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 212217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212226 */     GIR_RootConstrainSelectedInstOperands,
     /* 212227 */     // GIR_Coverage, 7685,
     /* 212227 */     GIR_EraseRootFromParent_Done,
     /* 212228 */   // Label 4194: @212228
     /* 212228 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(212295), // Rule ID 7687 //
     /* 212233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 212241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212267 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 212284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212293 */     GIR_RootConstrainSelectedInstOperands,
     /* 212294 */     // GIR_Coverage, 7687,
     /* 212294 */     GIR_EraseRootFromParent_Done,
     /* 212295 */   // Label 4195: @212295
     /* 212295 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(212362), // Rule ID 7689 //
     /* 212300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 212308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 212351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212360 */     GIR_RootConstrainSelectedInstOperands,
     /* 212361 */     // GIR_Coverage, 7689,
     /* 212361 */     GIR_EraseRootFromParent_Done,
     /* 212362 */   // Label 4196: @212362
     /* 212362 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(212429), // Rule ID 7691 //
     /* 212367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 212375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212401 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 212418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212427 */     GIR_RootConstrainSelectedInstOperands,
     /* 212428 */     // GIR_Coverage, 7691,
     /* 212428 */     GIR_EraseRootFromParent_Done,
     /* 212429 */   // Label 4197: @212429
     /* 212429 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(212496), // Rule ID 11399 //
     /* 212434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 212442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212468 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 212485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212494 */     GIR_RootConstrainSelectedInstOperands,
     /* 212495 */     // GIR_Coverage, 11399,
     /* 212495 */     GIR_EraseRootFromParent_Done,
     /* 212496 */   // Label 4198: @212496
     /* 212496 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(212563), // Rule ID 11401 //
     /* 212501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 212509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 212521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212535 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1745:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 212552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212561 */     GIR_RootConstrainSelectedInstOperands,
     /* 212562 */     // GIR_Coverage, 11401,
     /* 212562 */     GIR_EraseRootFromParent_Done,
     /* 212563 */   // Label 4199: @212563
     /* 212563 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(212630), // Rule ID 11403 //
     /* 212568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 212576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212602 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 212619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212628 */     GIR_RootConstrainSelectedInstOperands,
     /* 212629 */     // GIR_Coverage, 11403,
     /* 212629 */     GIR_EraseRootFromParent_Done,
     /* 212630 */   // Label 4200: @212630
     /* 212630 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(212697), // Rule ID 11405 //
     /* 212635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 212643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212669 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 212686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212695 */     GIR_RootConstrainSelectedInstOperands,
     /* 212696 */     // GIR_Coverage, 11405,
     /* 212696 */     GIR_EraseRootFromParent_Done,
     /* 212697 */   // Label 4201: @212697
     /* 212697 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(212764), // Rule ID 11407 //
     /* 212702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 212710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212736 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1745:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 212753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212762 */     GIR_RootConstrainSelectedInstOperands,
     /* 212763 */     // GIR_Coverage, 11407,
     /* 212763 */     GIR_EraseRootFromParent_Done,
     /* 212764 */   // Label 4202: @212764
     /* 212764 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(212831), // Rule ID 11413 //
     /* 212769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 212777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 212789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212803 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1805:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 212820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212829 */     GIR_RootConstrainSelectedInstOperands,
     /* 212830 */     // GIR_Coverage, 11413,
     /* 212830 */     GIR_EraseRootFromParent_Done,
     /* 212831 */   // Label 4203: @212831
     /* 212831 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(212898), // Rule ID 11415 //
     /* 212836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 212844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212870 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1805:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 212887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212896 */     GIR_RootConstrainSelectedInstOperands,
     /* 212897 */     // GIR_Coverage, 11415,
     /* 212897 */     GIR_EraseRootFromParent_Done,
     /* 212898 */   // Label 4204: @212898
     /* 212898 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(212965), // Rule ID 11417 //
     /* 212903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 212911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212937 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1805:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 212954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212963 */     GIR_RootConstrainSelectedInstOperands,
     /* 212964 */     // GIR_Coverage, 11417,
     /* 212964 */     GIR_EraseRootFromParent_Done,
     /* 212965 */   // Label 4205: @212965
     /* 212965 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(213032), // Rule ID 11419 //
     /* 212970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 212978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213004 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1805:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 213021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213030 */     GIR_RootConstrainSelectedInstOperands,
     /* 213031 */     // GIR_Coverage, 11419,
     /* 213031 */     GIR_EraseRootFromParent_Done,
     /* 213032 */   // Label 4206: @213032
     /* 213032 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(213086), // Rule ID 30 //
     /* 213037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 213040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 213045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 213054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 213057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213073 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 213073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 213076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213084 */     GIR_RootConstrainSelectedInstOperands,
     /* 213085 */     // GIR_Coverage, 30,
     /* 213085 */     GIR_EraseRootFromParent_Done,
     /* 213086 */   // Label 4207: @213086
     /* 213086 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(213140), // Rule ID 31 //
     /* 213091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 213094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 213099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 213108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 213111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213127 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 213127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 213130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213138 */     GIR_RootConstrainSelectedInstOperands,
     /* 213139 */     // GIR_Coverage, 31,
     /* 213139 */     GIR_EraseRootFromParent_Done,
     /* 213140 */   // Label 4208: @213140
     /* 213140 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(213194), // Rule ID 32 //
     /* 213145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 213148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 213153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 213162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 213165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213181 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 213181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 213184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213192 */     GIR_RootConstrainSelectedInstOperands,
     /* 213193 */     // GIR_Coverage, 32,
     /* 213193 */     GIR_EraseRootFromParent_Done,
     /* 213194 */   // Label 4209: @213194
     /* 213194 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(213248), // Rule ID 39 //
     /* 213199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 213202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 213207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 213210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 213213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 213216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 213219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213235 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 213235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 213238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213246 */     GIR_RootConstrainSelectedInstOperands,
     /* 213247 */     // GIR_Coverage, 39,
     /* 213247 */     GIR_EraseRootFromParent_Done,
     /* 213248 */   // Label 4210: @213248
     /* 213248 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(213302), // Rule ID 40 //
     /* 213253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 213256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 213261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 213270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 213273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213289 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 213289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 213292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213300 */     GIR_RootConstrainSelectedInstOperands,
     /* 213301 */     // GIR_Coverage, 40,
     /* 213301 */     GIR_EraseRootFromParent_Done,
     /* 213302 */   // Label 4211: @213302
     /* 213302 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(213356), // Rule ID 41 //
     /* 213307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 213310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 213315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 213318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 213321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 213324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 213327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213343 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 213343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 213346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213354 */     GIR_RootConstrainSelectedInstOperands,
     /* 213355 */     // GIR_Coverage, 41,
     /* 213355 */     GIR_EraseRootFromParent_Done,
     /* 213356 */   // Label 4212: @213356
     /* 213356 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(213410), // Rule ID 42 //
     /* 213361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 213364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 213369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 213378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 213381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213397 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 213397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 213400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213408 */     GIR_RootConstrainSelectedInstOperands,
     /* 213409 */     // GIR_Coverage, 42,
     /* 213409 */     GIR_EraseRootFromParent_Done,
     /* 213410 */   // Label 4213: @213410
     /* 213410 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(213464), // Rule ID 43 //
     /* 213415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 213418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 213423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 213426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 213429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 213432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 213435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213451 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 213451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 213454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213462 */     GIR_RootConstrainSelectedInstOperands,
     /* 213463 */     // GIR_Coverage, 43,
     /* 213463 */     GIR_EraseRootFromParent_Done,
     /* 213464 */   // Label 4214: @213464
     /* 213464 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(213518), // Rule ID 44 //
     /* 213469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 213472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 213477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 213486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 213489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213505 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 213505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 213508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213516 */     GIR_RootConstrainSelectedInstOperands,
     /* 213517 */     // GIR_Coverage, 44,
     /* 213517 */     GIR_EraseRootFromParent_Done,
     /* 213518 */   // Label 4215: @213518
     /* 213518 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(213572), // Rule ID 45 //
     /* 213523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 213526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 213531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 213534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 213537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 213540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 213543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213559 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 213559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 213562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213570 */     GIR_RootConstrainSelectedInstOperands,
     /* 213571 */     // GIR_Coverage, 45,
     /* 213571 */     GIR_EraseRootFromParent_Done,
     /* 213572 */   // Label 4216: @213572
     /* 213572 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(213626), // Rule ID 46 //
     /* 213577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 213580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 213585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 213594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 213597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213613 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 213613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 213616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213624 */     GIR_RootConstrainSelectedInstOperands,
     /* 213625 */     // GIR_Coverage, 46,
     /* 213625 */     GIR_EraseRootFromParent_Done,
     /* 213626 */   // Label 4217: @213626
     /* 213626 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(213680), // Rule ID 1580 //
     /* 213631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 213634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 213639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 213642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 213645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 213648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 213651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213667 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 213667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 213670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213678 */     GIR_RootConstrainSelectedInstOperands,
     /* 213679 */     // GIR_Coverage, 1580,
     /* 213679 */     GIR_EraseRootFromParent_Done,
     /* 213680 */   // Label 4218: @213680
     /* 213680 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(213734), // Rule ID 1581 //
     /* 213685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 213688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 213693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 213699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 213702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 213705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213721 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 213721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 213724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213732 */     GIR_RootConstrainSelectedInstOperands,
     /* 213733 */     // GIR_Coverage, 1581,
     /* 213733 */     GIR_EraseRootFromParent_Done,
     /* 213734 */   // Label 4219: @213734
     /* 213734 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(213788), // Rule ID 1582 //
     /* 213739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 213742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 213747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 213750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 213753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 213756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 213759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213775 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 213775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 213778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213786 */     GIR_RootConstrainSelectedInstOperands,
     /* 213787 */     // GIR_Coverage, 1582,
     /* 213787 */     GIR_EraseRootFromParent_Done,
     /* 213788 */   // Label 4220: @213788
     /* 213788 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(213842), // Rule ID 1583 //
     /* 213793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 213796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 213801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 213810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 213813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213829 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 213829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 213832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213840 */     GIR_RootConstrainSelectedInstOperands,
     /* 213841 */     // GIR_Coverage, 1583,
     /* 213841 */     GIR_EraseRootFromParent_Done,
     /* 213842 */   // Label 4221: @213842
     /* 213842 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(213896), // Rule ID 1584 //
     /* 213847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 213850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 213855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 213858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 213861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 213864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 213867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213883 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 213883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 213886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213894 */     GIR_RootConstrainSelectedInstOperands,
     /* 213895 */     // GIR_Coverage, 1584,
     /* 213895 */     GIR_EraseRootFromParent_Done,
     /* 213896 */   // Label 4222: @213896
     /* 213896 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(213950), // Rule ID 1585 //
     /* 213901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 213904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 213909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 213915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 213918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 213921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213937 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 213937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 213940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213948 */     GIR_RootConstrainSelectedInstOperands,
     /* 213949 */     // GIR_Coverage, 1585,
     /* 213949 */     GIR_EraseRootFromParent_Done,
     /* 213950 */   // Label 4223: @213950
     /* 213950 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(214004), // Rule ID 1586 //
     /* 213955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 213958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 213963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 213966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 213969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 213972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 213975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213991 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 213991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 213994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214002 */     GIR_RootConstrainSelectedInstOperands,
     /* 214003 */     // GIR_Coverage, 1586,
     /* 214003 */     GIR_EraseRootFromParent_Done,
     /* 214004 */   // Label 4224: @214004
     /* 214004 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(214058), // Rule ID 1587 //
     /* 214009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 214026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214045 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 214048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214056 */     GIR_RootConstrainSelectedInstOperands,
     /* 214057 */     // GIR_Coverage, 1587,
     /* 214057 */     GIR_EraseRootFromParent_Done,
     /* 214058 */   // Label 4225: @214058
     /* 214058 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(214112), // Rule ID 2298 //
     /* 214063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 214071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214099 */     // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 214102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214110 */     GIR_RootConstrainSelectedInstOperands,
     /* 214111 */     // GIR_Coverage, 2298,
     /* 214111 */     GIR_EraseRootFromParent_Done,
     /* 214112 */   // Label 4226: @214112
     /* 214112 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(214166), // Rule ID 2299 //
     /* 214117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 214125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214153 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 214156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214164 */     GIR_RootConstrainSelectedInstOperands,
     /* 214165 */     // GIR_Coverage, 2299,
     /* 214165 */     GIR_EraseRootFromParent_Done,
     /* 214166 */   // Label 4227: @214166
     /* 214166 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(214220), // Rule ID 2300 //
     /* 214171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 214179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214207 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 214210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214218 */     GIR_RootConstrainSelectedInstOperands,
     /* 214219 */     // GIR_Coverage, 2300,
     /* 214219 */     GIR_EraseRootFromParent_Done,
     /* 214220 */   // Label 4228: @214220
     /* 214220 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(214274), // Rule ID 2301 //
     /* 214225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 214233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 214242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214261 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 214264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214272 */     GIR_RootConstrainSelectedInstOperands,
     /* 214273 */     // GIR_Coverage, 2301,
     /* 214273 */     GIR_EraseRootFromParent_Done,
     /* 214274 */   // Label 4229: @214274
     /* 214274 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(214328), // Rule ID 2302 //
     /* 214279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 214287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 214296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214315 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 214318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214326 */     GIR_RootConstrainSelectedInstOperands,
     /* 214327 */     // GIR_Coverage, 2302,
     /* 214327 */     GIR_EraseRootFromParent_Done,
     /* 214328 */   // Label 4230: @214328
     /* 214328 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(214382), // Rule ID 2303 //
     /* 214333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 214341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 214350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214369 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 214372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214380 */     GIR_RootConstrainSelectedInstOperands,
     /* 214381 */     // GIR_Coverage, 2303,
     /* 214381 */     GIR_EraseRootFromParent_Done,
     /* 214382 */   // Label 4231: @214382
     /* 214382 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(214436), // Rule ID 2304 //
     /* 214387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 214395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 214404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214423 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 214426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214434 */     GIR_RootConstrainSelectedInstOperands,
     /* 214435 */     // GIR_Coverage, 2304,
     /* 214435 */     GIR_EraseRootFromParent_Done,
     /* 214436 */   // Label 4232: @214436
     /* 214436 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(214493), // Rule ID 3631 //
     /* 214441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 214444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 214449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 214452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 214458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 214461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 214465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 214477 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 214477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 214480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 214484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 214486 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 214488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214491 */     GIR_RootConstrainSelectedInstOperands,
     /* 214492 */     // GIR_Coverage, 3631,
     /* 214492 */     GIR_EraseRootFromParent_Done,
     /* 214493 */   // Label 4233: @214493
     /* 214493 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(214550), // Rule ID 3632 //
     /* 214498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 214501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 214506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 214509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 214515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 214518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 214522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 214534 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 214534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 214537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 214541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 214543 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 214545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214548 */     GIR_RootConstrainSelectedInstOperands,
     /* 214549 */     // GIR_Coverage, 3632,
     /* 214549 */     GIR_EraseRootFromParent_Done,
     /* 214550 */   // Label 4234: @214550
     /* 214550 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(214607), // Rule ID 3633 //
     /* 214555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 214558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 214563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 214566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 214572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 214575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 214579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 214591 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 214591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 214594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 214598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 214600 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 214602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214605 */     GIR_RootConstrainSelectedInstOperands,
     /* 214606 */     // GIR_Coverage, 3633,
     /* 214606 */     GIR_EraseRootFromParent_Done,
     /* 214607 */   // Label 4235: @214607
     /* 214607 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(214664), // Rule ID 3634 //
     /* 214612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 214615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 214620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 214623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 214629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 214632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 214636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 214648 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 214648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 214651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 214655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 214657 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 214659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 214662 */     GIR_RootConstrainSelectedInstOperands,
     /* 214663 */     // GIR_Coverage, 3634,
     /* 214663 */     GIR_EraseRootFromParent_Done,
     /* 214664 */   // Label 4236: @214664
     /* 214664 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(214718), // Rule ID 3797 //
     /* 214669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 214672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 214677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 214683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 214686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 214689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214705 */     // (intrinsic_wo_chain:{ *:[v2i64] } 530:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 214705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 214708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 214710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 214712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 214714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 214716 */     GIR_RootConstrainSelectedInstOperands,
     /* 214717 */     // GIR_Coverage, 3797,
     /* 214717 */     GIR_EraseRootFromParent_Done,
     /* 214718 */   // Label 4237: @214718
     /* 214718 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(214772), // Rule ID 3798 //
     /* 214723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 214726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 214731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 214737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 214740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 214743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214759 */     // (intrinsic_wo_chain:{ *:[v2i64] } 531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 214759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 214762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 214764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 214766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 214768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 214770 */     GIR_RootConstrainSelectedInstOperands,
     /* 214771 */     // GIR_Coverage, 3798,
     /* 214771 */     GIR_EraseRootFromParent_Done,
     /* 214772 */   // Label 4238: @214772
     /* 214772 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(214826), // Rule ID 3799 //
     /* 214777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 214780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 214785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 214791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 214794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 214797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214813 */     // (intrinsic_wo_chain:{ *:[v2i64] } 533:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 214813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 214816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 214818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 214820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 214822 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 214824 */     GIR_RootConstrainSelectedInstOperands,
     /* 214825 */     // GIR_Coverage, 3799,
     /* 214825 */     GIR_EraseRootFromParent_Done,
     /* 214826 */   // Label 4239: @214826
     /* 214826 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(214880), // Rule ID 3800 //
     /* 214831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 214834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 214839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 214842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 214845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 214848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 214851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214867 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 214867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 214870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 214874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 214876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 214878 */     GIR_RootConstrainSelectedInstOperands,
     /* 214879 */     // GIR_Coverage, 3800,
     /* 214879 */     GIR_EraseRootFromParent_Done,
     /* 214880 */   // Label 4240: @214880
     /* 214880 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(214934), // Rule ID 3801 //
     /* 214885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 214888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 214893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 214899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214921 */     // (intrinsic_wo_chain:{ *:[v8i16] } 518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 214921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 214924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 214928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 214930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 214932 */     GIR_RootConstrainSelectedInstOperands,
     /* 214933 */     // GIR_Coverage, 3801,
     /* 214933 */     GIR_EraseRootFromParent_Done,
     /* 214934 */   // Label 4241: @214934
     /* 214934 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(214988), // Rule ID 3802 //
     /* 214939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 214942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 214947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 214956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214975 */     // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 214975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 214978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 214982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 214984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 214986 */     GIR_RootConstrainSelectedInstOperands,
     /* 214987 */     // GIR_Coverage, 3802,
     /* 214987 */     GIR_EraseRootFromParent_Done,
     /* 214988 */   // Label 4242: @214988
     /* 214988 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(215042), // Rule ID 3803 //
     /* 214993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 214996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 215001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215029 */     // (intrinsic_wo_chain:{ *:[v2i64] } 518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215040 */     GIR_RootConstrainSelectedInstOperands,
     /* 215041 */     // GIR_Coverage, 3803,
     /* 215041 */     GIR_EraseRootFromParent_Done,
     /* 215042 */   // Label 4243: @215042
     /* 215042 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(215096), // Rule ID 3812 //
     /* 215047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 215061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 215064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 215067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215083 */     // (intrinsic_wo_chain:{ *:[v16i8] } 516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 215083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215094 */     GIR_RootConstrainSelectedInstOperands,
     /* 215095 */     // GIR_Coverage, 3812,
     /* 215095 */     GIR_EraseRootFromParent_Done,
     /* 215096 */   // Label 4244: @215096
     /* 215096 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(215150), // Rule ID 3813 //
     /* 215101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215137 */     // (intrinsic_wo_chain:{ *:[v8i16] } 516:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 215137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215148 */     GIR_RootConstrainSelectedInstOperands,
     /* 215149 */     // GIR_Coverage, 3813,
     /* 215149 */     GIR_EraseRootFromParent_Done,
     /* 215150 */   // Label 4245: @215150
     /* 215150 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(215204), // Rule ID 3814 //
     /* 215155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215191 */     // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 215191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215202 */     GIR_RootConstrainSelectedInstOperands,
     /* 215203 */     // GIR_Coverage, 3814,
     /* 215203 */     GIR_EraseRootFromParent_Done,
     /* 215204 */   // Label 4246: @215204
     /* 215204 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(215258), // Rule ID 3815 //
     /* 215209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215245 */     // (intrinsic_wo_chain:{ *:[v2i64] } 516:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215256 */     GIR_RootConstrainSelectedInstOperands,
     /* 215257 */     // GIR_Coverage, 3815,
     /* 215257 */     GIR_EraseRootFromParent_Done,
     /* 215258 */   // Label 4247: @215258
     /* 215258 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(215312), // Rule ID 3816 //
     /* 215263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 215271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 215277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 215280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 215283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215299 */     // (intrinsic_wo_chain:{ *:[v16i8] } 517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 215299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215310 */     GIR_RootConstrainSelectedInstOperands,
     /* 215311 */     // GIR_Coverage, 3816,
     /* 215311 */     GIR_EraseRootFromParent_Done,
     /* 215312 */   // Label 4248: @215312
     /* 215312 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(215366), // Rule ID 3817 //
     /* 215317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 215325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215353 */     // (intrinsic_wo_chain:{ *:[v8i16] } 517:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 215353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215364 */     GIR_RootConstrainSelectedInstOperands,
     /* 215365 */     // GIR_Coverage, 3817,
     /* 215365 */     GIR_EraseRootFromParent_Done,
     /* 215366 */   // Label 4249: @215366
     /* 215366 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(215420), // Rule ID 3818 //
     /* 215371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 215379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215407 */     // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 215407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215418 */     GIR_RootConstrainSelectedInstOperands,
     /* 215419 */     // GIR_Coverage, 3818,
     /* 215419 */     GIR_EraseRootFromParent_Done,
     /* 215420 */   // Label 4250: @215420
     /* 215420 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(215474), // Rule ID 3819 //
     /* 215425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 215433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215461 */     // (intrinsic_wo_chain:{ *:[v2i64] } 517:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215472 */     GIR_RootConstrainSelectedInstOperands,
     /* 215473 */     // GIR_Coverage, 3819,
     /* 215473 */     GIR_EraseRootFromParent_Done,
     /* 215474 */   // Label 4251: @215474
     /* 215474 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(215528), // Rule ID 3820 //
     /* 215479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 215487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 215493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 215496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 215499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215515 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 215515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215526 */     GIR_RootConstrainSelectedInstOperands,
     /* 215527 */     // GIR_Coverage, 3820,
     /* 215527 */     GIR_EraseRootFromParent_Done,
     /* 215528 */   // Label 4252: @215528
     /* 215528 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(215582), // Rule ID 3821 //
     /* 215533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 215541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215569 */     // (intrinsic_wo_chain:{ *:[v8i16] } 515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 215569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215580 */     GIR_RootConstrainSelectedInstOperands,
     /* 215581 */     // GIR_Coverage, 3821,
     /* 215581 */     GIR_EraseRootFromParent_Done,
     /* 215582 */   // Label 4253: @215582
     /* 215582 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(215636), // Rule ID 3822 //
     /* 215587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 215595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215623 */     // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 215623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215634 */     GIR_RootConstrainSelectedInstOperands,
     /* 215635 */     // GIR_Coverage, 3822,
     /* 215635 */     GIR_EraseRootFromParent_Done,
     /* 215636 */   // Label 4254: @215636
     /* 215636 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(215690), // Rule ID 3823 //
     /* 215641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 215649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215677 */     // (intrinsic_wo_chain:{ *:[v2i64] } 515:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215688 */     GIR_RootConstrainSelectedInstOperands,
     /* 215689 */     // GIR_Coverage, 3823,
     /* 215689 */     GIR_EraseRootFromParent_Done,
     /* 215690 */   // Label 4255: @215690
     /* 215690 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(215744), // Rule ID 3827 //
     /* 215695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 215698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 215703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215731 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 215731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 215734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 215738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 215740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 215742 */     GIR_RootConstrainSelectedInstOperands,
     /* 215743 */     // GIR_Coverage, 3827,
     /* 215743 */     GIR_EraseRootFromParent_Done,
     /* 215744 */   // Label 4256: @215744
     /* 215744 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(215798), // Rule ID 3828 //
     /* 215749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 215752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 215757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215785 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 215785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 215788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 215790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215796 */     GIR_RootConstrainSelectedInstOperands,
     /* 215797 */     // GIR_Coverage, 3828,
     /* 215797 */     GIR_EraseRootFromParent_Done,
     /* 215798 */   // Label 4257: @215798
     /* 215798 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(215852), // Rule ID 3829 //
     /* 215803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 215806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 215811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215839 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 215839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 215842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 215844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215850 */     GIR_RootConstrainSelectedInstOperands,
     /* 215851 */     // GIR_Coverage, 3829,
     /* 215851 */     GIR_EraseRootFromParent_Done,
     /* 215852 */   // Label 4258: @215852
     /* 215852 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(215909), // Rule ID 3846 //
     /* 215857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 215860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 215865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 215868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 215871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215893 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 215893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 215896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215907 */     GIR_RootConstrainSelectedInstOperands,
     /* 215908 */     // GIR_Coverage, 3846,
     /* 215908 */     GIR_EraseRootFromParent_Done,
     /* 215909 */   // Label 4259: @215909
     /* 215909 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(215966), // Rule ID 3847 //
     /* 215914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 215917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 215922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 215925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 215928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215950 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 215950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 215953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 215964 */     GIR_RootConstrainSelectedInstOperands,
     /* 215965 */     // GIR_Coverage, 3847,
     /* 215965 */     GIR_EraseRootFromParent_Done,
     /* 215966 */   // Label 4260: @215966
     /* 215966 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(216023), // Rule ID 3848 //
     /* 215971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 215974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 215979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 215982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 215985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216007 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 216007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 216010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216021 */     GIR_RootConstrainSelectedInstOperands,
     /* 216022 */     // GIR_Coverage, 3848,
     /* 216022 */     GIR_EraseRootFromParent_Done,
     /* 216023 */   // Label 4261: @216023
     /* 216023 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(216080), // Rule ID 3849 //
     /* 216028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216064 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 216064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 216067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216073 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216078 */     GIR_RootConstrainSelectedInstOperands,
     /* 216079 */     // GIR_Coverage, 3849,
     /* 216079 */     GIR_EraseRootFromParent_Done,
     /* 216080 */   // Label 4262: @216080
     /* 216080 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(216137), // Rule ID 3854 //
     /* 216085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216121 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 216121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 216124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216135 */     GIR_RootConstrainSelectedInstOperands,
     /* 216136 */     // GIR_Coverage, 3854,
     /* 216136 */     GIR_EraseRootFromParent_Done,
     /* 216137 */   // Label 4263: @216137
     /* 216137 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(216194), // Rule ID 3855 //
     /* 216142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216178 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 216178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 216181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216187 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216192 */     GIR_RootConstrainSelectedInstOperands,
     /* 216193 */     // GIR_Coverage, 3855,
     /* 216193 */     GIR_EraseRootFromParent_Done,
     /* 216194 */   // Label 4264: @216194
     /* 216194 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(216251), // Rule ID 3856 //
     /* 216199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216235 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 216235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 216238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216249 */     GIR_RootConstrainSelectedInstOperands,
     /* 216250 */     // GIR_Coverage, 3856,
     /* 216250 */     GIR_EraseRootFromParent_Done,
     /* 216251 */   // Label 4265: @216251
     /* 216251 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(216308), // Rule ID 3857 //
     /* 216256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216292 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 216292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 216295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216306 */     GIR_RootConstrainSelectedInstOperands,
     /* 216307 */     // GIR_Coverage, 3857,
     /* 216307 */     GIR_EraseRootFromParent_Done,
     /* 216308 */   // Label 4266: @216308
     /* 216308 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(216365), // Rule ID 3862 //
     /* 216313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 216330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 216333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216349 */     // (intrinsic_wo_chain:{ *:[v2f32] } 757:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 216349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 216352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216363 */     GIR_RootConstrainSelectedInstOperands,
     /* 216364 */     // GIR_Coverage, 3862,
     /* 216364 */     GIR_EraseRootFromParent_Done,
     /* 216365 */   // Label 4267: @216365
     /* 216365 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(216422), // Rule ID 3863 //
     /* 216370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 216387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 216390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216406 */     // (intrinsic_wo_chain:{ *:[v2f32] } 760:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 216406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 216409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216420 */     GIR_RootConstrainSelectedInstOperands,
     /* 216421 */     // GIR_Coverage, 3863,
     /* 216421 */     GIR_EraseRootFromParent_Done,
     /* 216422 */   // Label 4268: @216422
     /* 216422 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(216479), // Rule ID 3864 //
     /* 216427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 216444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 216447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216463 */     // (intrinsic_wo_chain:{ *:[v2f32] } 758:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 216463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 216466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216477 */     GIR_RootConstrainSelectedInstOperands,
     /* 216478 */     // GIR_Coverage, 3864,
     /* 216478 */     GIR_EraseRootFromParent_Done,
     /* 216479 */   // Label 4269: @216479
     /* 216479 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(216536), // Rule ID 3865 //
     /* 216484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 216495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 216498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 216501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 216504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216520 */     // (intrinsic_wo_chain:{ *:[v2f32] } 759:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 216520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 216523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216529 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216534 */     GIR_RootConstrainSelectedInstOperands,
     /* 216535 */     // GIR_Coverage, 3865,
     /* 216535 */     GIR_EraseRootFromParent_Done,
     /* 216536 */   // Label 4270: @216536
     /* 216536 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(216593), // Rule ID 3866 //
     /* 216541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216577 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 216577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 216580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216591 */     GIR_RootConstrainSelectedInstOperands,
     /* 216592 */     // GIR_Coverage, 3866,
     /* 216592 */     GIR_EraseRootFromParent_Done,
     /* 216593 */   // Label 4271: @216593
     /* 216593 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(216650), // Rule ID 3867 //
     /* 216598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216634 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 216634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 216637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216648 */     GIR_RootConstrainSelectedInstOperands,
     /* 216649 */     // GIR_Coverage, 3867,
     /* 216649 */     GIR_EraseRootFromParent_Done,
     /* 216650 */   // Label 4272: @216650
     /* 216650 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(216707), // Rule ID 3868 //
     /* 216655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216691 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 216691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 216694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216705 */     GIR_RootConstrainSelectedInstOperands,
     /* 216706 */     // GIR_Coverage, 3868,
     /* 216706 */     GIR_EraseRootFromParent_Done,
     /* 216707 */   // Label 4273: @216707
     /* 216707 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(216764), // Rule ID 3869 //
     /* 216712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216748 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 216748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 216751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216757 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216762 */     GIR_RootConstrainSelectedInstOperands,
     /* 216763 */     // GIR_Coverage, 3869,
     /* 216763 */     GIR_EraseRootFromParent_Done,
     /* 216764 */   // Label 4274: @216764
     /* 216764 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(216821), // Rule ID 3870 //
     /* 216769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216805 */     // (intrinsic_wo_chain:{ *:[v2f64] } 757:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 216805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 216808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216819 */     GIR_RootConstrainSelectedInstOperands,
     /* 216820 */     // GIR_Coverage, 3870,
     /* 216820 */     GIR_EraseRootFromParent_Done,
     /* 216821 */   // Label 4275: @216821
     /* 216821 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(216878), // Rule ID 3871 //
     /* 216826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216862 */     // (intrinsic_wo_chain:{ *:[v2f64] } 760:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 216862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 216865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216871 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216876 */     GIR_RootConstrainSelectedInstOperands,
     /* 216877 */     // GIR_Coverage, 3871,
     /* 216877 */     GIR_EraseRootFromParent_Done,
     /* 216878 */   // Label 4276: @216878
     /* 216878 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(216935), // Rule ID 3872 //
     /* 216883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216919 */     // (intrinsic_wo_chain:{ *:[v2f64] } 758:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 216919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 216922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216933 */     GIR_RootConstrainSelectedInstOperands,
     /* 216934 */     // GIR_Coverage, 3872,
     /* 216934 */     GIR_EraseRootFromParent_Done,
     /* 216935 */   // Label 4277: @216935
     /* 216935 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(216992), // Rule ID 3873 //
     /* 216940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216976 */     // (intrinsic_wo_chain:{ *:[v2f64] } 759:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 216976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 216979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216990 */     GIR_RootConstrainSelectedInstOperands,
     /* 216991 */     // GIR_Coverage, 3873,
     /* 216991 */     GIR_EraseRootFromParent_Done,
     /* 216992 */   // Label 4278: @216992
     /* 216992 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(217046), // Rule ID 5208 //
     /* 216997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 217000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 217005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 217014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217033 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 217033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 217036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217044 */     GIR_RootConstrainSelectedInstOperands,
     /* 217045 */     // GIR_Coverage, 5208,
     /* 217045 */     GIR_EraseRootFromParent_Done,
     /* 217046 */   // Label 4279: @217046
     /* 217046 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(217100), // Rule ID 5209 //
     /* 217051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 217054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 217059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 217068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217087 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 217087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 217090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217098 */     GIR_RootConstrainSelectedInstOperands,
     /* 217099 */     // GIR_Coverage, 5209,
     /* 217099 */     GIR_EraseRootFromParent_Done,
     /* 217100 */   // Label 4280: @217100
     /* 217100 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(217151), // Rule ID 5561 //
     /* 217105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 217110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 217113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 217116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 217119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 217122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217138 */     // (intrinsic_wo_chain:{ *:[v8i8] } 720:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 217138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 217141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 217149 */     GIR_RootConstrainSelectedInstOperands,
     /* 217150 */     // GIR_Coverage, 5561,
     /* 217150 */     GIR_EraseRootFromParent_Done,
     /* 217151 */   // Label 4281: @217151
     /* 217151 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(217202), // Rule ID 5562 //
     /* 217156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 217161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 217164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 217167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 217170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 217173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217189 */     // (intrinsic_wo_chain:{ *:[v16i8] } 720:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 217189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 217192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 217198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 217200 */     GIR_RootConstrainSelectedInstOperands,
     /* 217201 */     // GIR_Coverage, 5562,
     /* 217201 */     GIR_EraseRootFromParent_Done,
     /* 217202 */   // Label 4282: @217202
     /* 217202 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(217244), // Rule ID 2690 //
     /* 217207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 217215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 217221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217231 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1904:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 217234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217242 */     GIR_RootConstrainSelectedInstOperands,
     /* 217243 */     // GIR_Coverage, 2690,
     /* 217243 */     GIR_EraseRootFromParent_Done,
     /* 217244 */   // Label 4283: @217244
     /* 217244 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(217286), // Rule ID 2691 //
     /* 217249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 217257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217273 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1904:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 217276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217284 */     GIR_RootConstrainSelectedInstOperands,
     /* 217285 */     // GIR_Coverage, 2691,
     /* 217285 */     GIR_EraseRootFromParent_Done,
     /* 217286 */   // Label 4284: @217286
     /* 217286 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(217328), // Rule ID 2692 //
     /* 217291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 217299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217315 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1904:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 217318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217326 */     GIR_RootConstrainSelectedInstOperands,
     /* 217327 */     // GIR_Coverage, 2692,
     /* 217327 */     GIR_EraseRootFromParent_Done,
     /* 217328 */   // Label 4285: @217328
     /* 217328 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(217370), // Rule ID 2693 //
     /* 217333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 217341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217357 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1904:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 217360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217368 */     GIR_RootConstrainSelectedInstOperands,
     /* 217369 */     // GIR_Coverage, 2693,
     /* 217369 */     GIR_EraseRootFromParent_Done,
     /* 217370 */   // Label 4286: @217370
     /* 217370 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(217412), // Rule ID 2694 //
     /* 217375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 217383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217399 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1904:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 217402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217410 */     GIR_RootConstrainSelectedInstOperands,
     /* 217411 */     // GIR_Coverage, 2694,
     /* 217411 */     GIR_EraseRootFromParent_Done,
     /* 217412 */   // Label 4287: @217412
     /* 217412 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(217454), // Rule ID 2695 //
     /* 217417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 217425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217441 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1904:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 217444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217452 */     GIR_RootConstrainSelectedInstOperands,
     /* 217453 */     // GIR_Coverage, 2695,
     /* 217453 */     GIR_EraseRootFromParent_Done,
     /* 217454 */   // Label 4288: @217454
     /* 217454 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(217496), // Rule ID 2696 //
     /* 217459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 217467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217483 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1904:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 217486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217494 */     GIR_RootConstrainSelectedInstOperands,
     /* 217495 */     // GIR_Coverage, 2696,
     /* 217495 */     GIR_EraseRootFromParent_Done,
     /* 217496 */   // Label 4289: @217496
     /* 217496 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(217538), // Rule ID 2735 //
     /* 217501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 217509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 217515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 217518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 217521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 217525 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1250:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 217525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 217528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217536 */     GIR_RootConstrainSelectedInstOperands,
     /* 217537 */     // GIR_Coverage, 2735,
     /* 217537 */     GIR_EraseRootFromParent_Done,
     /* 217538 */   // Label 4290: @217538
     /* 217538 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(217580), // Rule ID 2736 //
     /* 217543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 217551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 217554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 217557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 217560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 217563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 217567 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1250:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 217567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 217570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217578 */     GIR_RootConstrainSelectedInstOperands,
     /* 217579 */     // GIR_Coverage, 2736,
     /* 217579 */     GIR_EraseRootFromParent_Done,
     /* 217580 */   // Label 4291: @217580
     /* 217580 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(217622), // Rule ID 2737 //
     /* 217585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 217593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 217596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 217602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 217605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 217609 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1250:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 217609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 217612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217620 */     GIR_RootConstrainSelectedInstOperands,
     /* 217621 */     // GIR_Coverage, 2737,
     /* 217621 */     GIR_EraseRootFromParent_Done,
     /* 217622 */   // Label 4292: @217622
     /* 217622 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(217664), // Rule ID 2738 //
     /* 217627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 217635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 217638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 217644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 217647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 217651 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1250:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 217651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 217654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217662 */     GIR_RootConstrainSelectedInstOperands,
     /* 217663 */     // GIR_Coverage, 2738,
     /* 217663 */     GIR_EraseRootFromParent_Done,
     /* 217664 */   // Label 4293: @217664
     /* 217664 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(217706), // Rule ID 2739 //
     /* 217669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 217677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 217680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 217683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 217686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 217689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 217693 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1250:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 217693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 217696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217704 */     GIR_RootConstrainSelectedInstOperands,
     /* 217705 */     // GIR_Coverage, 2739,
     /* 217705 */     GIR_EraseRootFromParent_Done,
     /* 217706 */   // Label 4294: @217706
     /* 217706 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(217748), // Rule ID 2778 //
     /* 217711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 217719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 217725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217735 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 217735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 217738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217746 */     GIR_RootConstrainSelectedInstOperands,
     /* 217747 */     // GIR_Coverage, 2778,
     /* 217747 */     GIR_EraseRootFromParent_Done,
     /* 217748 */   // Label 4295: @217748
     /* 217748 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(217790), // Rule ID 2780 //
     /* 217753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 217761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217777 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 217777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 217780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217788 */     GIR_RootConstrainSelectedInstOperands,
     /* 217789 */     // GIR_Coverage, 2780,
     /* 217789 */     GIR_EraseRootFromParent_Done,
     /* 217790 */   // Label 4296: @217790
     /* 217790 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(217832), // Rule ID 2782 //
     /* 217795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 217803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217819 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 217819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 217822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217830 */     GIR_RootConstrainSelectedInstOperands,
     /* 217831 */     // GIR_Coverage, 2782,
     /* 217831 */     GIR_EraseRootFromParent_Done,
     /* 217832 */   // Label 4297: @217832
     /* 217832 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(217874), // Rule ID 2784 //
     /* 217837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 217845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 217851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217861 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1523:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 217864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217872 */     GIR_RootConstrainSelectedInstOperands,
     /* 217873 */     // GIR_Coverage, 2784,
     /* 217873 */     GIR_EraseRootFromParent_Done,
     /* 217874 */   // Label 4298: @217874
     /* 217874 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(217916), // Rule ID 2785 //
     /* 217879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 217887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 217893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217903 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1523:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 217903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 217906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217914 */     GIR_RootConstrainSelectedInstOperands,
     /* 217915 */     // GIR_Coverage, 2785,
     /* 217915 */     GIR_EraseRootFromParent_Done,
     /* 217916 */   // Label 4299: @217916
     /* 217916 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(217958), // Rule ID 2786 //
     /* 217921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 217929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 217935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 217941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217945 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1523:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 217945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 217948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217956 */     GIR_RootConstrainSelectedInstOperands,
     /* 217957 */     // GIR_Coverage, 2786,
     /* 217957 */     GIR_EraseRootFromParent_Done,
     /* 217958 */   // Label 4300: @217958
     /* 217958 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(218000), // Rule ID 2855 //
     /* 217963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 217971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 217980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 217983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217987 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1385:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 217987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 217990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217998 */     GIR_RootConstrainSelectedInstOperands,
     /* 217999 */     // GIR_Coverage, 2855,
     /* 217999 */     GIR_EraseRootFromParent_Done,
     /* 218000 */   // Label 4301: @218000
     /* 218000 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(218042), // Rule ID 2856 //
     /* 218005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 218013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218029 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1386:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 218032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218040 */     GIR_RootConstrainSelectedInstOperands,
     /* 218041 */     // GIR_Coverage, 2856,
     /* 218041 */     GIR_EraseRootFromParent_Done,
     /* 218042 */   // Label 4302: @218042
     /* 218042 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(218084), // Rule ID 2857 //
     /* 218047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 218055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218071 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1381:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 218074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218082 */     GIR_RootConstrainSelectedInstOperands,
     /* 218083 */     // GIR_Coverage, 2857,
     /* 218083 */     GIR_EraseRootFromParent_Done,
     /* 218084 */   // Label 4303: @218084
     /* 218084 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(218126), // Rule ID 2858 //
     /* 218089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 218097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218113 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1382:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 218116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218124 */     GIR_RootConstrainSelectedInstOperands,
     /* 218125 */     // GIR_Coverage, 2858,
     /* 218125 */     GIR_EraseRootFromParent_Done,
     /* 218126 */   // Label 4304: @218126
     /* 218126 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(218168), // Rule ID 2859 //
     /* 218131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 218139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218155 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1388:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 218158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218166 */     GIR_RootConstrainSelectedInstOperands,
     /* 218167 */     // GIR_Coverage, 2859,
     /* 218167 */     GIR_EraseRootFromParent_Done,
     /* 218168 */   // Label 4305: @218168
     /* 218168 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(218210), // Rule ID 2860 //
     /* 218173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 218181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218197 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1352:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 218200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218208 */     GIR_RootConstrainSelectedInstOperands,
     /* 218209 */     // GIR_Coverage, 2860,
     /* 218209 */     GIR_EraseRootFromParent_Done,
     /* 218210 */   // Label 4306: @218210
     /* 218210 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(218252), // Rule ID 2861 //
     /* 218215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 218223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218239 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1352:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 218242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218250 */     GIR_RootConstrainSelectedInstOperands,
     /* 218251 */     // GIR_Coverage, 2861,
     /* 218251 */     GIR_EraseRootFromParent_Done,
     /* 218252 */   // Label 4307: @218252
     /* 218252 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(218294), // Rule ID 2862 //
     /* 218257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 218265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218281 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1352:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 218284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218292 */     GIR_RootConstrainSelectedInstOperands,
     /* 218293 */     // GIR_Coverage, 2862,
     /* 218293 */     GIR_EraseRootFromParent_Done,
     /* 218294 */   // Label 4308: @218294
     /* 218294 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(218336), // Rule ID 2873 //
     /* 218299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 218307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218323 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1374:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 218326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218334 */     GIR_RootConstrainSelectedInstOperands,
     /* 218335 */     // GIR_Coverage, 2873,
     /* 218335 */     GIR_EraseRootFromParent_Done,
     /* 218336 */   // Label 4309: @218336
     /* 218336 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(218378), // Rule ID 2875 //
     /* 218341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 218349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218365 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1372:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 218368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218376 */     GIR_RootConstrainSelectedInstOperands,
     /* 218377 */     // GIR_Coverage, 2875,
     /* 218377 */     GIR_EraseRootFromParent_Done,
     /* 218378 */   // Label 4310: @218378
     /* 218378 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(218420), // Rule ID 2883 //
     /* 218383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 218391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 218400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218407 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1409:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 218410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218418 */     GIR_RootConstrainSelectedInstOperands,
     /* 218419 */     // GIR_Coverage, 2883,
     /* 218419 */     GIR_EraseRootFromParent_Done,
     /* 218420 */   // Label 4311: @218420
     /* 218420 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(218462), // Rule ID 2884 //
     /* 218425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 218433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218449 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1409:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 218452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218460 */     GIR_RootConstrainSelectedInstOperands,
     /* 218461 */     // GIR_Coverage, 2884,
     /* 218461 */     GIR_EraseRootFromParent_Done,
     /* 218462 */   // Label 4312: @218462
     /* 218462 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(218504), // Rule ID 2885 //
     /* 218467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 218475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218491 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1409:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 218494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218502 */     GIR_RootConstrainSelectedInstOperands,
     /* 218503 */     // GIR_Coverage, 2885,
     /* 218503 */     GIR_EraseRootFromParent_Done,
     /* 218504 */   // Label 4313: @218504
     /* 218504 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(218546), // Rule ID 2889 //
     /* 218509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 218517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218533 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1387:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 218536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218544 */     GIR_RootConstrainSelectedInstOperands,
     /* 218545 */     // GIR_Coverage, 2889,
     /* 218545 */     GIR_EraseRootFromParent_Done,
     /* 218546 */   // Label 4314: @218546
     /* 218546 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(218588), // Rule ID 2934 //
     /* 218551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 218559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218575 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1692:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 218578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218586 */     GIR_RootConstrainSelectedInstOperands,
     /* 218587 */     // GIR_Coverage, 2934,
     /* 218587 */     GIR_EraseRootFromParent_Done,
     /* 218588 */   // Label 4315: @218588
     /* 218588 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(218630), // Rule ID 2935 //
     /* 218593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 218601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218617 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1692:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 218620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218628 */     GIR_RootConstrainSelectedInstOperands,
     /* 218629 */     // GIR_Coverage, 2935,
     /* 218629 */     GIR_EraseRootFromParent_Done,
     /* 218630 */   // Label 4316: @218630
     /* 218630 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(218672), // Rule ID 2964 //
     /* 218635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 218643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 218646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 218649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218659 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1808:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 218659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 218662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 218664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218670 */     GIR_RootConstrainSelectedInstOperands,
     /* 218671 */     // GIR_Coverage, 2964,
     /* 218671 */     GIR_EraseRootFromParent_Done,
     /* 218672 */   // Label 4317: @218672
     /* 218672 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(218714), // Rule ID 2965 //
     /* 218677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 218685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218701 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1808:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 218704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 218706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218712 */     GIR_RootConstrainSelectedInstOperands,
     /* 218713 */     // GIR_Coverage, 2965,
     /* 218713 */     GIR_EraseRootFromParent_Done,
     /* 218714 */   // Label 4318: @218714
     /* 218714 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(218756), // Rule ID 2966 //
     /* 218719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 218727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218743 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1808:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 218746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 218748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218754 */     GIR_RootConstrainSelectedInstOperands,
     /* 218755 */     // GIR_Coverage, 2966,
     /* 218755 */     GIR_EraseRootFromParent_Done,
     /* 218756 */   // Label 4319: @218756
     /* 218756 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(218798), // Rule ID 2967 //
     /* 218761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 218769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218785 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1808:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 218788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 218790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218796 */     GIR_RootConstrainSelectedInstOperands,
     /* 218797 */     // GIR_Coverage, 2967,
     /* 218797 */     GIR_EraseRootFromParent_Done,
     /* 218798 */   // Label 4320: @218798
     /* 218798 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(218840), // Rule ID 2968 //
     /* 218803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 218811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218827 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1729:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 218827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 218830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 218832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218838 */     GIR_RootConstrainSelectedInstOperands,
     /* 218839 */     // GIR_Coverage, 2968,
     /* 218839 */     GIR_EraseRootFromParent_Done,
     /* 218840 */   // Label 4321: @218840
     /* 218840 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(218882), // Rule ID 2969 //
     /* 218845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 218853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218869 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1729:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 218872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 218874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218880 */     GIR_RootConstrainSelectedInstOperands,
     /* 218881 */     // GIR_Coverage, 2969,
     /* 218881 */     GIR_EraseRootFromParent_Done,
     /* 218882 */   // Label 4322: @218882
     /* 218882 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(218924), // Rule ID 2970 //
     /* 218887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 218895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218911 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1729:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 218914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 218916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218922 */     GIR_RootConstrainSelectedInstOperands,
     /* 218923 */     // GIR_Coverage, 2970,
     /* 218923 */     GIR_EraseRootFromParent_Done,
     /* 218924 */   // Label 4323: @218924
     /* 218924 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(218966), // Rule ID 3000 //
     /* 218929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 218937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 218940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218953 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1703:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 218953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 218956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218964 */     GIR_RootConstrainSelectedInstOperands,
     /* 218965 */     // GIR_Coverage, 3000,
     /* 218965 */     GIR_EraseRootFromParent_Done,
     /* 218966 */   // Label 4324: @218966
     /* 218966 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(219008), // Rule ID 3002 //
     /* 218971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 218979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218995 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1703:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 218998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219006 */     GIR_RootConstrainSelectedInstOperands,
     /* 219007 */     // GIR_Coverage, 3002,
     /* 219007 */     GIR_EraseRootFromParent_Done,
     /* 219008 */   // Label 4325: @219008
     /* 219008 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(219050), // Rule ID 3004 //
     /* 219013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 219021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219037 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1703:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 219040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219048 */     GIR_RootConstrainSelectedInstOperands,
     /* 219049 */     // GIR_Coverage, 3004,
     /* 219049 */     GIR_EraseRootFromParent_Done,
     /* 219050 */   // Label 4326: @219050
     /* 219050 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(219092), // Rule ID 3006 //
     /* 219055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 219063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219079 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1703:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 219082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219090 */     GIR_RootConstrainSelectedInstOperands,
     /* 219091 */     // GIR_Coverage, 3006,
     /* 219091 */     GIR_EraseRootFromParent_Done,
     /* 219092 */   // Label 4327: @219092
     /* 219092 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(219134), // Rule ID 3008 //
     /* 219097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 219105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219121 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1673:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 219124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219132 */     GIR_RootConstrainSelectedInstOperands,
     /* 219133 */     // GIR_Coverage, 3008,
     /* 219133 */     GIR_EraseRootFromParent_Done,
     /* 219134 */   // Label 4328: @219134
     /* 219134 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(219176), // Rule ID 3009 //
     /* 219139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 219147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219163 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1673:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 219166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219174 */     GIR_RootConstrainSelectedInstOperands,
     /* 219175 */     // GIR_Coverage, 3009,
     /* 219175 */     GIR_EraseRootFromParent_Done,
     /* 219176 */   // Label 4329: @219176
     /* 219176 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(219218), // Rule ID 3010 //
     /* 219181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 219189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219205 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1673:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 219208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219216 */     GIR_RootConstrainSelectedInstOperands,
     /* 219217 */     // GIR_Coverage, 3010,
     /* 219217 */     GIR_EraseRootFromParent_Done,
     /* 219218 */   // Label 4330: @219218
     /* 219218 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(219260), // Rule ID 3011 //
     /* 219223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 219231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219247 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2032:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 219250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219258 */     GIR_RootConstrainSelectedInstOperands,
     /* 219259 */     // GIR_Coverage, 3011,
     /* 219259 */     GIR_EraseRootFromParent_Done,
     /* 219260 */   // Label 4331: @219260
     /* 219260 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(219302), // Rule ID 3012 //
     /* 219265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 219273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 219279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 219282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219289 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1745:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 219292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219300 */     GIR_RootConstrainSelectedInstOperands,
     /* 219301 */     // GIR_Coverage, 3012,
     /* 219301 */     GIR_EraseRootFromParent_Done,
     /* 219302 */   // Label 4332: @219302
     /* 219302 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(219344), // Rule ID 3013 //
     /* 219307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 219315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 219324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219331 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 219334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219342 */     GIR_RootConstrainSelectedInstOperands,
     /* 219343 */     // GIR_Coverage, 3013,
     /* 219343 */     GIR_EraseRootFromParent_Done,
     /* 219344 */   // Label 4333: @219344
     /* 219344 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(219386), // Rule ID 3014 //
     /* 219349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 219357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 219376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219384 */     GIR_RootConstrainSelectedInstOperands,
     /* 219385 */     // GIR_Coverage, 3014,
     /* 219385 */     GIR_EraseRootFromParent_Done,
     /* 219386 */   // Label 4334: @219386
     /* 219386 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(219428), // Rule ID 3015 //
     /* 219391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 219399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219415 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1745:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 219418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219426 */     GIR_RootConstrainSelectedInstOperands,
     /* 219427 */     // GIR_Coverage, 3015,
     /* 219427 */     GIR_EraseRootFromParent_Done,
     /* 219428 */   // Label 4335: @219428
     /* 219428 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(219470), // Rule ID 3032 //
     /* 219433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 219441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 219447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219457 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1338:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 219460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219468 */     GIR_RootConstrainSelectedInstOperands,
     /* 219469 */     // GIR_Coverage, 3032,
     /* 219469 */     GIR_EraseRootFromParent_Done,
     /* 219470 */   // Label 4336: @219470
     /* 219470 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(219512), // Rule ID 3033 //
     /* 219475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 219483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219499 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1338:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 219502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219510 */     GIR_RootConstrainSelectedInstOperands,
     /* 219511 */     // GIR_Coverage, 3033,
     /* 219511 */     GIR_EraseRootFromParent_Done,
     /* 219512 */   // Label 4337: @219512
     /* 219512 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(219554), // Rule ID 3034 //
     /* 219517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 219525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1338:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 219544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219552 */     GIR_RootConstrainSelectedInstOperands,
     /* 219553 */     // GIR_Coverage, 3034,
     /* 219553 */     GIR_EraseRootFromParent_Done,
     /* 219554 */   // Label 4338: @219554
     /* 219554 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(219596), // Rule ID 3035 //
     /* 219559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 219567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219583 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1338:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 219586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219594 */     GIR_RootConstrainSelectedInstOperands,
     /* 219595 */     // GIR_Coverage, 3035,
     /* 219595 */     GIR_EraseRootFromParent_Done,
     /* 219596 */   // Label 4339: @219596
     /* 219596 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(219638), // Rule ID 3059 //
     /* 219601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 219609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 219615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219625 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1666:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 219628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219636 */     GIR_RootConstrainSelectedInstOperands,
     /* 219637 */     // GIR_Coverage, 3059,
     /* 219637 */     GIR_EraseRootFromParent_Done,
     /* 219638 */   // Label 4340: @219638
     /* 219638 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(219680), // Rule ID 3061 //
     /* 219643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 219651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219667 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1666:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 219670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219678 */     GIR_RootConstrainSelectedInstOperands,
     /* 219679 */     // GIR_Coverage, 3061,
     /* 219679 */     GIR_EraseRootFromParent_Done,
     /* 219680 */   // Label 4341: @219680
     /* 219680 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(219722), // Rule ID 3063 //
     /* 219685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 219693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219709 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1666:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 219712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219720 */     GIR_RootConstrainSelectedInstOperands,
     /* 219721 */     // GIR_Coverage, 3063,
     /* 219721 */     GIR_EraseRootFromParent_Done,
     /* 219722 */   // Label 4342: @219722
     /* 219722 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(219764), // Rule ID 3065 //
     /* 219727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 219735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219751 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1666:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 219754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219762 */     GIR_RootConstrainSelectedInstOperands,
     /* 219763 */     // GIR_Coverage, 3065,
     /* 219763 */     GIR_EraseRootFromParent_Done,
     /* 219764 */   // Label 4343: @219764
     /* 219764 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(219806), // Rule ID 3067 //
     /* 219769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 219777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219793 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1667:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 219796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219804 */     GIR_RootConstrainSelectedInstOperands,
     /* 219805 */     // GIR_Coverage, 3067,
     /* 219805 */     GIR_EraseRootFromParent_Done,
     /* 219806 */   // Label 4344: @219806
     /* 219806 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(219848), // Rule ID 3068 //
     /* 219811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 219819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1667:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 219838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219846 */     GIR_RootConstrainSelectedInstOperands,
     /* 219847 */     // GIR_Coverage, 3068,
     /* 219847 */     GIR_EraseRootFromParent_Done,
     /* 219848 */   // Label 4345: @219848
     /* 219848 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(219890), // Rule ID 3069 //
     /* 219853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 219861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219877 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1667:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 219880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219888 */     GIR_RootConstrainSelectedInstOperands,
     /* 219889 */     // GIR_Coverage, 3069,
     /* 219889 */     GIR_EraseRootFromParent_Done,
     /* 219890 */   // Label 4346: @219890
     /* 219890 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(219932), // Rule ID 3070 //
     /* 219895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 219903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219919 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1230:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 219922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219930 */     GIR_RootConstrainSelectedInstOperands,
     /* 219931 */     // GIR_Coverage, 3070,
     /* 219931 */     GIR_EraseRootFromParent_Done,
     /* 219932 */   // Label 4347: @219932
     /* 219932 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(219974), // Rule ID 3071 //
     /* 219937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 219945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1230:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 219964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219972 */     GIR_RootConstrainSelectedInstOperands,
     /* 219973 */     // GIR_Coverage, 3071,
     /* 219973 */     GIR_EraseRootFromParent_Done,
     /* 219974 */   // Label 4348: @219974
     /* 219974 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(220016), // Rule ID 3081 //
     /* 219979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 219987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 219993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220003 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1237:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 220006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220014 */     GIR_RootConstrainSelectedInstOperands,
     /* 220015 */     // GIR_Coverage, 3081,
     /* 220015 */     GIR_EraseRootFromParent_Done,
     /* 220016 */   // Label 4349: @220016
     /* 220016 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(220058), // Rule ID 3082 //
     /* 220021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 220029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220045 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1237:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 220048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220056 */     GIR_RootConstrainSelectedInstOperands,
     /* 220057 */     // GIR_Coverage, 3082,
     /* 220057 */     GIR_EraseRootFromParent_Done,
     /* 220058 */   // Label 4350: @220058
     /* 220058 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(220100), // Rule ID 3083 //
     /* 220063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 220071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220087 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1237:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 220090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220098 */     GIR_RootConstrainSelectedInstOperands,
     /* 220099 */     // GIR_Coverage, 3083,
     /* 220099 */     GIR_EraseRootFromParent_Done,
     /* 220100 */   // Label 4351: @220100
     /* 220100 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(220142), // Rule ID 3100 //
     /* 220105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220129 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1296:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 220129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 220132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220140 */     GIR_RootConstrainSelectedInstOperands,
     /* 220141 */     // GIR_Coverage, 3100,
     /* 220141 */     GIR_EraseRootFromParent_Done,
     /* 220142 */   // Label 4352: @220142
     /* 220142 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(220184), // Rule ID 3101 //
     /* 220147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220171 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1296:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 220171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 220174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220182 */     GIR_RootConstrainSelectedInstOperands,
     /* 220183 */     // GIR_Coverage, 3101,
     /* 220183 */     GIR_EraseRootFromParent_Done,
     /* 220184 */   // Label 4353: @220184
     /* 220184 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(220226), // Rule ID 3102 //
     /* 220189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220213 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1296:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 220213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 220216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220224 */     GIR_RootConstrainSelectedInstOperands,
     /* 220225 */     // GIR_Coverage, 3102,
     /* 220225 */     GIR_EraseRootFromParent_Done,
     /* 220226 */   // Label 4354: @220226
     /* 220226 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(220268), // Rule ID 3103 //
     /* 220231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220255 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1296:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 220255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 220258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220266 */     GIR_RootConstrainSelectedInstOperands,
     /* 220267 */     // GIR_Coverage, 3103,
     /* 220267 */     GIR_EraseRootFromParent_Done,
     /* 220268 */   // Label 4355: @220268
     /* 220268 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(220310), // Rule ID 3138 //
     /* 220273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 220281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220297 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1337:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 220300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220308 */     GIR_RootConstrainSelectedInstOperands,
     /* 220309 */     // GIR_Coverage, 3138,
     /* 220309 */     GIR_EraseRootFromParent_Done,
     /* 220310 */   // Label 4356: @220310
     /* 220310 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(220352), // Rule ID 3140 //
     /* 220315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 220323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1337:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 220342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220350 */     GIR_RootConstrainSelectedInstOperands,
     /* 220351 */     // GIR_Coverage, 3140,
     /* 220351 */     GIR_EraseRootFromParent_Done,
     /* 220352 */   // Label 4357: @220352
     /* 220352 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(220394), // Rule ID 3142 //
     /* 220357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 220365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220381 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1337:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 220384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220392 */     GIR_RootConstrainSelectedInstOperands,
     /* 220393 */     // GIR_Coverage, 3142,
     /* 220393 */     GIR_EraseRootFromParent_Done,
     /* 220394 */   // Label 4358: @220394
     /* 220394 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(220436), // Rule ID 3144 //
     /* 220399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 220407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220423 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1337:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 220426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220434 */     GIR_RootConstrainSelectedInstOperands,
     /* 220435 */     // GIR_Coverage, 3144,
     /* 220435 */     GIR_EraseRootFromParent_Done,
     /* 220436 */   // Label 4359: @220436
     /* 220436 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(220481), // Rule ID 3183 //
     /* 220441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 220449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 220465 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1301:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 220468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 220479 */     GIR_RootConstrainSelectedInstOperands,
     /* 220480 */     // GIR_Coverage, 3183,
     /* 220480 */     GIR_EraseRootFromParent_Done,
     /* 220481 */   // Label 4360: @220481
     /* 220481 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(220526), // Rule ID 3184 //
     /* 220486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 220494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 220510 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1301:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 220513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220521 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 220524 */     GIR_RootConstrainSelectedInstOperands,
     /* 220525 */     // GIR_Coverage, 3184,
     /* 220525 */     GIR_EraseRootFromParent_Done,
     /* 220526 */   // Label 4361: @220526
     /* 220526 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(220571), // Rule ID 3185 //
     /* 220531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 220539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 220555 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1301:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 220558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220566 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 220569 */     GIR_RootConstrainSelectedInstOperands,
     /* 220570 */     // GIR_Coverage, 3185,
     /* 220570 */     GIR_EraseRootFromParent_Done,
     /* 220571 */   // Label 4362: @220571
     /* 220571 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(220616), // Rule ID 3186 //
     /* 220576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 220584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 220587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 220600 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1303:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 220603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 220614 */     GIR_RootConstrainSelectedInstOperands,
     /* 220615 */     // GIR_Coverage, 3186,
     /* 220615 */     GIR_EraseRootFromParent_Done,
     /* 220616 */   // Label 4363: @220616
     /* 220616 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(220661), // Rule ID 3187 //
     /* 220621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 220629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 220645 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1303:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 220648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220654 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 220659 */     GIR_RootConstrainSelectedInstOperands,
     /* 220660 */     // GIR_Coverage, 3187,
     /* 220660 */     GIR_EraseRootFromParent_Done,
     /* 220661 */   // Label 4364: @220661
     /* 220661 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(220706), // Rule ID 3188 //
     /* 220666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 220674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 220690 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1303:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 220693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 220704 */     GIR_RootConstrainSelectedInstOperands,
     /* 220705 */     // GIR_Coverage, 3188,
     /* 220705 */     GIR_EraseRootFromParent_Done,
     /* 220706 */   // Label 4365: @220706
     /* 220706 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(220748), // Rule ID 3243 //
     /* 220711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 220719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 220722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 220735 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1347:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 220735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 220738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220746 */     GIR_RootConstrainSelectedInstOperands,
     /* 220747 */     // GIR_Coverage, 3243,
     /* 220747 */     GIR_EraseRootFromParent_Done,
     /* 220748 */   // Label 4366: @220748
     /* 220748 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(220790), // Rule ID 3244 //
     /* 220753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 220761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 220764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 220777 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1347:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 220777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 220780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220788 */     GIR_RootConstrainSelectedInstOperands,
     /* 220789 */     // GIR_Coverage, 3244,
     /* 220789 */     GIR_EraseRootFromParent_Done,
     /* 220790 */   // Label 4367: @220790
     /* 220790 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(220832), // Rule ID 3245 //
     /* 220795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 220803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 220806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 220819 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1347:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 220819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 220822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 220824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220830 */     GIR_RootConstrainSelectedInstOperands,
     /* 220831 */     // GIR_Coverage, 3245,
     /* 220831 */     GIR_EraseRootFromParent_Done,
     /* 220832 */   // Label 4368: @220832
     /* 220832 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(220874), // Rule ID 3297 //
     /* 220837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 220845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220861 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1253:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 220864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220872 */     GIR_RootConstrainSelectedInstOperands,
     /* 220873 */     // GIR_Coverage, 3297,
     /* 220873 */     GIR_EraseRootFromParent_Done,
     /* 220874 */   // Label 4369: @220874
     /* 220874 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(220916), // Rule ID 3298 //
     /* 220879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 220887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220903 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1253:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 220906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220914 */     GIR_RootConstrainSelectedInstOperands,
     /* 220915 */     // GIR_Coverage, 3298,
     /* 220915 */     GIR_EraseRootFromParent_Done,
     /* 220916 */   // Label 4370: @220916
     /* 220916 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(220958), // Rule ID 3299 //
     /* 220921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 220929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220945 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1253:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 220948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220956 */     GIR_RootConstrainSelectedInstOperands,
     /* 220957 */     // GIR_Coverage, 3299,
     /* 220957 */     GIR_EraseRootFromParent_Done,
     /* 220958 */   // Label 4371: @220958
     /* 220958 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(221000), // Rule ID 3300 //
     /* 220963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 220971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220987 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1253:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 220990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220998 */     GIR_RootConstrainSelectedInstOperands,
     /* 220999 */     // GIR_Coverage, 3300,
     /* 220999 */     GIR_EraseRootFromParent_Done,
     /* 221000 */   // Label 4372: @221000
     /* 221000 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(221042), // Rule ID 3309 //
     /* 221005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 221013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221029 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1255:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 221032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221040 */     GIR_RootConstrainSelectedInstOperands,
     /* 221041 */     // GIR_Coverage, 3309,
     /* 221041 */     GIR_EraseRootFromParent_Done,
     /* 221042 */   // Label 4373: @221042
     /* 221042 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(221084), // Rule ID 3310 //
     /* 221047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 221055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221071 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1255:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 221074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221082 */     GIR_RootConstrainSelectedInstOperands,
     /* 221083 */     // GIR_Coverage, 3310,
     /* 221083 */     GIR_EraseRootFromParent_Done,
     /* 221084 */   // Label 4374: @221084
     /* 221084 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(221126), // Rule ID 3311 //
     /* 221089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 221097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221113 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1255:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 221116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221124 */     GIR_RootConstrainSelectedInstOperands,
     /* 221125 */     // GIR_Coverage, 3311,
     /* 221125 */     GIR_EraseRootFromParent_Done,
     /* 221126 */   // Label 4375: @221126
     /* 221126 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(221168), // Rule ID 3350 //
     /* 221131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221155 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1292:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 221158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221166 */     GIR_RootConstrainSelectedInstOperands,
     /* 221167 */     // GIR_Coverage, 3350,
     /* 221167 */     GIR_EraseRootFromParent_Done,
     /* 221168 */   // Label 4376: @221168
     /* 221168 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(221210), // Rule ID 3351 //
     /* 221173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221197 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1292:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 221200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221208 */     GIR_RootConstrainSelectedInstOperands,
     /* 221209 */     // GIR_Coverage, 3351,
     /* 221209 */     GIR_EraseRootFromParent_Done,
     /* 221210 */   // Label 4377: @221210
     /* 221210 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(221252), // Rule ID 3352 //
     /* 221215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221239 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1292:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 221242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221250 */     GIR_RootConstrainSelectedInstOperands,
     /* 221251 */     // GIR_Coverage, 3352,
     /* 221251 */     GIR_EraseRootFromParent_Done,
     /* 221252 */   // Label 4378: @221252
     /* 221252 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(221294), // Rule ID 3353 //
     /* 221257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221281 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1292:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 221284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221292 */     GIR_RootConstrainSelectedInstOperands,
     /* 221293 */     // GIR_Coverage, 3353,
     /* 221293 */     GIR_EraseRootFromParent_Done,
     /* 221294 */   // Label 4379: @221294
     /* 221294 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(221336), // Rule ID 3354 //
     /* 221299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221323 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1292:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 221326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221334 */     GIR_RootConstrainSelectedInstOperands,
     /* 221335 */     // GIR_Coverage, 3354,
     /* 221335 */     GIR_EraseRootFromParent_Done,
     /* 221336 */   // Label 4380: @221336
     /* 221336 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(221378), // Rule ID 3355 //
     /* 221341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221365 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1292:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 221368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221376 */     GIR_RootConstrainSelectedInstOperands,
     /* 221377 */     // GIR_Coverage, 3355,
     /* 221377 */     GIR_EraseRootFromParent_Done,
     /* 221378 */   // Label 4381: @221378
     /* 221378 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(221420), // Rule ID 3356 //
     /* 221383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221407 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1292:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 221410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221418 */     GIR_RootConstrainSelectedInstOperands,
     /* 221419 */     // GIR_Coverage, 3356,
     /* 221419 */     GIR_EraseRootFromParent_Done,
     /* 221420 */   // Label 4382: @221420
     /* 221420 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(221462), // Rule ID 3439 //
     /* 221425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 221433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 221442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 221445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221449 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1284:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 221449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 221452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221460 */     GIR_RootConstrainSelectedInstOperands,
     /* 221461 */     // GIR_Coverage, 3439,
     /* 221461 */     GIR_EraseRootFromParent_Done,
     /* 221462 */   // Label 4383: @221462
     /* 221462 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(221504), // Rule ID 3440 //
     /* 221467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 221475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 221484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 221487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221491 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1283:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 221491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 221494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 221496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221502 */     GIR_RootConstrainSelectedInstOperands,
     /* 221503 */     // GIR_Coverage, 3440,
     /* 221503 */     GIR_EraseRootFromParent_Done,
     /* 221504 */   // Label 4384: @221504
     /* 221504 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(221546), // Rule ID 3441 //
     /* 221509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 221517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 221526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 221529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221533 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1279:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 221533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 221536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221544 */     GIR_RootConstrainSelectedInstOperands,
     /* 221545 */     // GIR_Coverage, 3441,
     /* 221545 */     GIR_EraseRootFromParent_Done,
     /* 221546 */   // Label 4385: @221546
     /* 221546 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(221591), // Rule ID 3443 //
     /* 221551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 221554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 221559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221575 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1586:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 221578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221589 */     GIR_RootConstrainSelectedInstOperands,
     /* 221590 */     // GIR_Coverage, 3443,
     /* 221590 */     GIR_EraseRootFromParent_Done,
     /* 221591 */   // Label 4386: @221591
     /* 221591 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(221636), // Rule ID 3444 //
     /* 221596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 221599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 221604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221620 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1586:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 221623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221634 */     GIR_RootConstrainSelectedInstOperands,
     /* 221635 */     // GIR_Coverage, 3444,
     /* 221635 */     GIR_EraseRootFromParent_Done,
     /* 221636 */   // Label 4387: @221636
     /* 221636 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(221678), // Rule ID 3445 //
     /* 221641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 221644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 221649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221665 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1531:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 221668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221676 */     GIR_RootConstrainSelectedInstOperands,
     /* 221677 */     // GIR_Coverage, 3445,
     /* 221677 */     GIR_EraseRootFromParent_Done,
     /* 221678 */   // Label 4388: @221678
     /* 221678 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(221720), // Rule ID 3446 //
     /* 221683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 221686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 221691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221707 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1531:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 221710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221718 */     GIR_RootConstrainSelectedInstOperands,
     /* 221719 */     // GIR_Coverage, 3446,
     /* 221719 */     GIR_EraseRootFromParent_Done,
     /* 221720 */   // Label 4389: @221720
     /* 221720 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(221762), // Rule ID 3451 //
     /* 221725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 221728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 221733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221749 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1737:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 221752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221760 */     GIR_RootConstrainSelectedInstOperands,
     /* 221761 */     // GIR_Coverage, 3451,
     /* 221761 */     GIR_EraseRootFromParent_Done,
     /* 221762 */   // Label 4390: @221762
     /* 221762 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(221804), // Rule ID 3490 //
     /* 221767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 221770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 221775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221791 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1360:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 221794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221802 */     GIR_RootConstrainSelectedInstOperands,
     /* 221803 */     // GIR_Coverage, 3490,
     /* 221803 */     GIR_EraseRootFromParent_Done,
     /* 221804 */   // Label 4391: @221804
     /* 221804 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(221846), // Rule ID 3492 //
     /* 221809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 221812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 221817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221833 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1360:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 221836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221844 */     GIR_RootConstrainSelectedInstOperands,
     /* 221845 */     // GIR_Coverage, 3492,
     /* 221845 */     GIR_EraseRootFromParent_Done,
     /* 221846 */   // Label 4392: @221846
     /* 221846 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(221888), // Rule ID 3494 //
     /* 221851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 221854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 221859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221875 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1360:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 221878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221886 */     GIR_RootConstrainSelectedInstOperands,
     /* 221887 */     // GIR_Coverage, 3494,
     /* 221887 */     GIR_EraseRootFromParent_Done,
     /* 221888 */   // Label 4393: @221888
     /* 221888 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(221930), // Rule ID 3496 //
     /* 221893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 221896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 221901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221917 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1698:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 221920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221928 */     GIR_RootConstrainSelectedInstOperands,
     /* 221929 */     // GIR_Coverage, 3496,
     /* 221929 */     GIR_EraseRootFromParent_Done,
     /* 221930 */   // Label 4394: @221930
     /* 221930 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(221972), // Rule ID 3623 //
     /* 221935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 221938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 221943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 221949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221959 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1682:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 221962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221970 */     GIR_RootConstrainSelectedInstOperands,
     /* 221971 */     // GIR_Coverage, 3623,
     /* 221971 */     GIR_EraseRootFromParent_Done,
     /* 221972 */   // Label 4395: @221972
     /* 221972 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(222014), // Rule ID 3625 //
     /* 221977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 221980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 221985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222001 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1682:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 222004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222012 */     GIR_RootConstrainSelectedInstOperands,
     /* 222013 */     // GIR_Coverage, 3625,
     /* 222013 */     GIR_EraseRootFromParent_Done,
     /* 222014 */   // Label 4396: @222014
     /* 222014 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(222056), // Rule ID 3627 //
     /* 222019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 222022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 222027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1682:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 222046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222054 */     GIR_RootConstrainSelectedInstOperands,
     /* 222055 */     // GIR_Coverage, 3627,
     /* 222055 */     GIR_EraseRootFromParent_Done,
     /* 222056 */   // Label 4397: @222056
     /* 222056 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(222098), // Rule ID 3629 //
     /* 222061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 222064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 222069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222085 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1682:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 222088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222096 */     GIR_RootConstrainSelectedInstOperands,
     /* 222097 */     // GIR_Coverage, 3629,
     /* 222097 */     GIR_EraseRootFromParent_Done,
     /* 222098 */   // Label 4398: @222098
     /* 222098 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(222140), // Rule ID 7423 //
     /* 222103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222127 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1891:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 222130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222138 */     GIR_RootConstrainSelectedInstOperands,
     /* 222139 */     // GIR_Coverage, 7423,
     /* 222139 */     GIR_EraseRootFromParent_Done,
     /* 222140 */   // Label 4399: @222140
     /* 222140 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(222182), // Rule ID 7425 //
     /* 222145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222169 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1891:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 222172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222180 */     GIR_RootConstrainSelectedInstOperands,
     /* 222181 */     // GIR_Coverage, 7425,
     /* 222181 */     GIR_EraseRootFromParent_Done,
     /* 222182 */   // Label 4400: @222182
     /* 222182 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(222224), // Rule ID 7427 //
     /* 222187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1891:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 222214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222222 */     GIR_RootConstrainSelectedInstOperands,
     /* 222223 */     // GIR_Coverage, 7427,
     /* 222223 */     GIR_EraseRootFromParent_Done,
     /* 222224 */   // Label 4401: @222224
     /* 222224 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(222266), // Rule ID 7429 //
     /* 222229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222253 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1891:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 222256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222264 */     GIR_RootConstrainSelectedInstOperands,
     /* 222265 */     // GIR_Coverage, 7429,
     /* 222265 */     GIR_EraseRootFromParent_Done,
     /* 222266 */   // Label 4402: @222266
     /* 222266 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(222308), // Rule ID 7447 //
     /* 222271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 222279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222295 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1276:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 222298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222306 */     GIR_RootConstrainSelectedInstOperands,
     /* 222307 */     // GIR_Coverage, 7447,
     /* 222307 */     GIR_EraseRootFromParent_Done,
     /* 222308 */   // Label 4403: @222308
     /* 222308 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(222350), // Rule ID 7448 //
     /* 222313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 222321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1276:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 222340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222348 */     GIR_RootConstrainSelectedInstOperands,
     /* 222349 */     // GIR_Coverage, 7448,
     /* 222349 */     GIR_EraseRootFromParent_Done,
     /* 222350 */   // Label 4404: @222350
     /* 222350 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(222392), // Rule ID 7449 //
     /* 222355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 222363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222379 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1276:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 222382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222390 */     GIR_RootConstrainSelectedInstOperands,
     /* 222391 */     // GIR_Coverage, 7449,
     /* 222391 */     GIR_EraseRootFromParent_Done,
     /* 222392 */   // Label 4405: @222392
     /* 222392 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(222434), // Rule ID 7450 //
     /* 222397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 222405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 222424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222432 */     GIR_RootConstrainSelectedInstOperands,
     /* 222433 */     // GIR_Coverage, 7450,
     /* 222433 */     GIR_EraseRootFromParent_Done,
     /* 222434 */   // Label 4406: @222434
     /* 222434 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(222476), // Rule ID 7563 //
     /* 222439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 222447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222463 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1738:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 222466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222474 */     GIR_RootConstrainSelectedInstOperands,
     /* 222475 */     // GIR_Coverage, 7563,
     /* 222475 */     GIR_EraseRootFromParent_Done,
     /* 222476 */   // Label 4407: @222476
     /* 222476 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(222518), // Rule ID 7564 //
     /* 222481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 222489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222505 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1738:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 222508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222516 */     GIR_RootConstrainSelectedInstOperands,
     /* 222517 */     // GIR_Coverage, 7564,
     /* 222517 */     GIR_EraseRootFromParent_Done,
     /* 222518 */   // Label 4408: @222518
     /* 222518 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(222560), // Rule ID 7565 //
     /* 222523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 222531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222547 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1738:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 222550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222558 */     GIR_RootConstrainSelectedInstOperands,
     /* 222559 */     // GIR_Coverage, 7565,
     /* 222559 */     GIR_EraseRootFromParent_Done,
     /* 222560 */   // Label 4409: @222560
     /* 222560 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(222602), // Rule ID 7566 //
     /* 222565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 222573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222589 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1738:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 222592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222600 */     GIR_RootConstrainSelectedInstOperands,
     /* 222601 */     // GIR_Coverage, 7566,
     /* 222601 */     GIR_EraseRootFromParent_Done,
     /* 222602 */   // Label 4410: @222602
     /* 222602 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(222644), // Rule ID 7567 //
     /* 222607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 222615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222631 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1976:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 222634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222642 */     GIR_RootConstrainSelectedInstOperands,
     /* 222643 */     // GIR_Coverage, 7567,
     /* 222643 */     GIR_EraseRootFromParent_Done,
     /* 222644 */   // Label 4411: @222644
     /* 222644 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(222686), // Rule ID 7568 //
     /* 222649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 222657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222673 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1976:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 222676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222684 */     GIR_RootConstrainSelectedInstOperands,
     /* 222685 */     // GIR_Coverage, 7568,
     /* 222685 */     GIR_EraseRootFromParent_Done,
     /* 222686 */   // Label 4412: @222686
     /* 222686 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(222728), // Rule ID 7569 //
     /* 222691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 222699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222715 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1976:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 222718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222726 */     GIR_RootConstrainSelectedInstOperands,
     /* 222727 */     // GIR_Coverage, 7569,
     /* 222727 */     GIR_EraseRootFromParent_Done,
     /* 222728 */   // Label 4413: @222728
     /* 222728 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(222770), // Rule ID 7570 //
     /* 222733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 222741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222757 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1976:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 222760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222768 */     GIR_RootConstrainSelectedInstOperands,
     /* 222769 */     // GIR_Coverage, 7570,
     /* 222769 */     GIR_EraseRootFromParent_Done,
     /* 222770 */   // Label 4414: @222770
     /* 222770 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(222812), // Rule ID 7579 //
     /* 222775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 222783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 222802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222810 */     GIR_RootConstrainSelectedInstOperands,
     /* 222811 */     // GIR_Coverage, 7579,
     /* 222811 */     GIR_EraseRootFromParent_Done,
     /* 222812 */   // Label 4415: @222812
     /* 222812 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(222854), // Rule ID 7580 //
     /* 222817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 222825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222841 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 222844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222852 */     GIR_RootConstrainSelectedInstOperands,
     /* 222853 */     // GIR_Coverage, 7580,
     /* 222853 */     GIR_EraseRootFromParent_Done,
     /* 222854 */   // Label 4416: @222854
     /* 222854 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(222896), // Rule ID 7581 //
     /* 222859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 222867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222883 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 222886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222894 */     GIR_RootConstrainSelectedInstOperands,
     /* 222895 */     // GIR_Coverage, 7581,
     /* 222895 */     GIR_EraseRootFromParent_Done,
     /* 222896 */   // Label 4417: @222896
     /* 222896 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(222938), // Rule ID 7582 //
     /* 222901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 222909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222925 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 222928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222936 */     GIR_RootConstrainSelectedInstOperands,
     /* 222937 */     // GIR_Coverage, 7582,
     /* 222937 */     GIR_EraseRootFromParent_Done,
     /* 222938 */   // Label 4418: @222938
     /* 222938 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(222980), // Rule ID 7583 //
     /* 222943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 222951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222967 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1941:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 222970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222978 */     GIR_RootConstrainSelectedInstOperands,
     /* 222979 */     // GIR_Coverage, 7583,
     /* 222979 */     GIR_EraseRootFromParent_Done,
     /* 222980 */   // Label 4419: @222980
     /* 222980 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(223022), // Rule ID 7584 //
     /* 222985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 222993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1941:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 223012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223020 */     GIR_RootConstrainSelectedInstOperands,
     /* 223021 */     // GIR_Coverage, 7584,
     /* 223021 */     GIR_EraseRootFromParent_Done,
     /* 223022 */   // Label 4420: @223022
     /* 223022 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(223064), // Rule ID 7669 //
     /* 223027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223051 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1316:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 223051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 223054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223062 */     GIR_RootConstrainSelectedInstOperands,
     /* 223063 */     // GIR_Coverage, 7669,
     /* 223063 */     GIR_EraseRootFromParent_Done,
     /* 223064 */   // Label 4421: @223064
     /* 223064 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(223106), // Rule ID 7670 //
     /* 223069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 223086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223093 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1316:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 223093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 223096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223104 */     GIR_RootConstrainSelectedInstOperands,
     /* 223105 */     // GIR_Coverage, 7670,
     /* 223105 */     GIR_EraseRootFromParent_Done,
     /* 223106 */   // Label 4422: @223106
     /* 223106 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(223148), // Rule ID 7671 //
     /* 223111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223135 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1316:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 223135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 223138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223146 */     GIR_RootConstrainSelectedInstOperands,
     /* 223147 */     // GIR_Coverage, 7671,
     /* 223147 */     GIR_EraseRootFromParent_Done,
     /* 223148 */   // Label 4423: @223148
     /* 223148 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(223190), // Rule ID 7672 //
     /* 223153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223177 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1316:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 223177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 223180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223188 */     GIR_RootConstrainSelectedInstOperands,
     /* 223189 */     // GIR_Coverage, 7672,
     /* 223189 */     GIR_EraseRootFromParent_Done,
     /* 223190 */   // Label 4424: @223190
     /* 223190 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(223232), // Rule ID 7681 //
     /* 223195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 223203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223219 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 223219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 223222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223230 */     GIR_RootConstrainSelectedInstOperands,
     /* 223231 */     // GIR_Coverage, 7681,
     /* 223231 */     GIR_EraseRootFromParent_Done,
     /* 223232 */   // Label 4425: @223232
     /* 223232 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(223274), // Rule ID 7682 //
     /* 223237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 223245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 223254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223261 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 223261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 223264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223272 */     GIR_RootConstrainSelectedInstOperands,
     /* 223273 */     // GIR_Coverage, 7682,
     /* 223273 */     GIR_EraseRootFromParent_Done,
     /* 223274 */   // Label 4426: @223274
     /* 223274 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(223316), // Rule ID 7683 //
     /* 223279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 223287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223303 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 223303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 223306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223314 */     GIR_RootConstrainSelectedInstOperands,
     /* 223315 */     // GIR_Coverage, 7683,
     /* 223315 */     GIR_EraseRootFromParent_Done,
     /* 223316 */   // Label 4427: @223316
     /* 223316 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(223358), // Rule ID 7684 //
     /* 223321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 223329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223345 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 223345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 223348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223356 */     GIR_RootConstrainSelectedInstOperands,
     /* 223357 */     // GIR_Coverage, 7684,
     /* 223357 */     GIR_EraseRootFromParent_Done,
     /* 223358 */   // Label 4428: @223358
     /* 223358 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(223400), // Rule ID 7763 //
     /* 223363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 223371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223387 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1669:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 223390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223398 */     GIR_RootConstrainSelectedInstOperands,
     /* 223399 */     // GIR_Coverage, 7763,
     /* 223399 */     GIR_EraseRootFromParent_Done,
     /* 223400 */   // Label 4429: @223400
     /* 223400 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(223442), // Rule ID 7764 //
     /* 223405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 223413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223429 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1669:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 223432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223440 */     GIR_RootConstrainSelectedInstOperands,
     /* 223441 */     // GIR_Coverage, 7764,
     /* 223441 */     GIR_EraseRootFromParent_Done,
     /* 223442 */   // Label 4430: @223442
     /* 223442 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(223484), // Rule ID 7765 //
     /* 223447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 223455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223471 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1669:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 223474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223482 */     GIR_RootConstrainSelectedInstOperands,
     /* 223483 */     // GIR_Coverage, 7765,
     /* 223483 */     GIR_EraseRootFromParent_Done,
     /* 223484 */   // Label 4431: @223484
     /* 223484 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(223526), // Rule ID 7766 //
     /* 223489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 223497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223513 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1669:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 223516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223524 */     GIR_RootConstrainSelectedInstOperands,
     /* 223525 */     // GIR_Coverage, 7766,
     /* 223525 */     GIR_EraseRootFromParent_Done,
     /* 223526 */   // Label 4432: @223526
     /* 223526 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(223568), // Rule ID 7767 //
     /* 223531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 223539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223555 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1919:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 223558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223566 */     GIR_RootConstrainSelectedInstOperands,
     /* 223567 */     // GIR_Coverage, 7767,
     /* 223567 */     GIR_EraseRootFromParent_Done,
     /* 223568 */   // Label 4433: @223568
     /* 223568 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(223610), // Rule ID 7768 //
     /* 223573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 223581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223597 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1919:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 223600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223608 */     GIR_RootConstrainSelectedInstOperands,
     /* 223609 */     // GIR_Coverage, 7768,
     /* 223609 */     GIR_EraseRootFromParent_Done,
     /* 223610 */   // Label 4434: @223610
     /* 223610 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(223652), // Rule ID 7769 //
     /* 223615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 223623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223639 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1919:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 223642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223650 */     GIR_RootConstrainSelectedInstOperands,
     /* 223651 */     // GIR_Coverage, 7769,
     /* 223651 */     GIR_EraseRootFromParent_Done,
     /* 223652 */   // Label 4435: @223652
     /* 223652 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(223694), // Rule ID 7770 //
     /* 223657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 223665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1919:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 223684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223692 */     GIR_RootConstrainSelectedInstOperands,
     /* 223693 */     // GIR_Coverage, 7770,
     /* 223693 */     GIR_EraseRootFromParent_Done,
     /* 223694 */   // Label 4436: @223694
     /* 223694 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(223736), // Rule ID 7966 //
     /* 223699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 223707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223723 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1525:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 223726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223734 */     GIR_RootConstrainSelectedInstOperands,
     /* 223735 */     // GIR_Coverage, 7966,
     /* 223735 */     GIR_EraseRootFromParent_Done,
     /* 223736 */   // Label 4437: @223736
     /* 223736 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(223778), // Rule ID 7968 //
     /* 223741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 223749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223765 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1525:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 223768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223776 */     GIR_RootConstrainSelectedInstOperands,
     /* 223777 */     // GIR_Coverage, 7968,
     /* 223777 */     GIR_EraseRootFromParent_Done,
     /* 223778 */   // Label 4438: @223778
     /* 223778 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(223820), // Rule ID 7970 //
     /* 223783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 223791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223807 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1525:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 223810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223818 */     GIR_RootConstrainSelectedInstOperands,
     /* 223819 */     // GIR_Coverage, 7970,
     /* 223819 */     GIR_EraseRootFromParent_Done,
     /* 223820 */   // Label 4439: @223820
     /* 223820 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(223862), // Rule ID 7978 //
     /* 223825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 223833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223849 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1527:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 223852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223860 */     GIR_RootConstrainSelectedInstOperands,
     /* 223861 */     // GIR_Coverage, 7978,
     /* 223861 */     GIR_EraseRootFromParent_Done,
     /* 223862 */   // Label 4440: @223862
     /* 223862 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(223904), // Rule ID 7980 //
     /* 223867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 223875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223891 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1527:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 223894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223902 */     GIR_RootConstrainSelectedInstOperands,
     /* 223903 */     // GIR_Coverage, 7980,
     /* 223903 */     GIR_EraseRootFromParent_Done,
     /* 223904 */   // Label 4441: @223904
     /* 223904 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(223946), // Rule ID 7982 //
     /* 223909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 223917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223933 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1527:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 223936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223944 */     GIR_RootConstrainSelectedInstOperands,
     /* 223945 */     // GIR_Coverage, 7982,
     /* 223945 */     GIR_EraseRootFromParent_Done,
     /* 223946 */   // Label 4442: @223946
     /* 223946 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(223988), // Rule ID 8020 //
     /* 223951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 223959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223975 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1344:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 223978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223986 */     GIR_RootConstrainSelectedInstOperands,
     /* 223987 */     // GIR_Coverage, 8020,
     /* 223987 */     GIR_EraseRootFromParent_Done,
     /* 223988 */   // Label 4443: @223988
     /* 223988 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(224030), // Rule ID 8021 //
     /* 223993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 224001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224017 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1344:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 224020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224028 */     GIR_RootConstrainSelectedInstOperands,
     /* 224029 */     // GIR_Coverage, 8021,
     /* 224029 */     GIR_EraseRootFromParent_Done,
     /* 224030 */   // Label 4444: @224030
     /* 224030 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(224072), // Rule ID 8022 //
     /* 224035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 224043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224059 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1344:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 224062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224070 */     GIR_RootConstrainSelectedInstOperands,
     /* 224071 */     // GIR_Coverage, 8022,
     /* 224071 */     GIR_EraseRootFromParent_Done,
     /* 224072 */   // Label 4445: @224072
     /* 224072 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(224114), // Rule ID 8023 //
     /* 224077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 224085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224101 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1466:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 224104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224112 */     GIR_RootConstrainSelectedInstOperands,
     /* 224113 */     // GIR_Coverage, 8023,
     /* 224113 */     GIR_EraseRootFromParent_Done,
     /* 224114 */   // Label 4446: @224114
     /* 224114 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(224156), // Rule ID 8024 //
     /* 224119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 224127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224143 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1466:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 224146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224154 */     GIR_RootConstrainSelectedInstOperands,
     /* 224155 */     // GIR_Coverage, 8024,
     /* 224155 */     GIR_EraseRootFromParent_Done,
     /* 224156 */   // Label 4447: @224156
     /* 224156 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(224198), // Rule ID 8025 //
     /* 224161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 224169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224185 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1466:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 224188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224196 */     GIR_RootConstrainSelectedInstOperands,
     /* 224197 */     // GIR_Coverage, 8025,
     /* 224197 */     GIR_EraseRootFromParent_Done,
     /* 224198 */   // Label 4448: @224198
     /* 224198 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(224240), // Rule ID 8026 //
     /* 224203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 224211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224227 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1405:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 224230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224238 */     GIR_RootConstrainSelectedInstOperands,
     /* 224239 */     // GIR_Coverage, 8026,
     /* 224239 */     GIR_EraseRootFromParent_Done,
     /* 224240 */   // Label 4449: @224240
     /* 224240 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(224282), // Rule ID 8027 //
     /* 224245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 224253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224269 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1405:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 224272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224280 */     GIR_RootConstrainSelectedInstOperands,
     /* 224281 */     // GIR_Coverage, 8027,
     /* 224281 */     GIR_EraseRootFromParent_Done,
     /* 224282 */   // Label 4450: @224282
     /* 224282 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(224324), // Rule ID 8028 //
     /* 224287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 224295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224311 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1405:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 224314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224322 */     GIR_RootConstrainSelectedInstOperands,
     /* 224323 */     // GIR_Coverage, 8028,
     /* 224323 */     GIR_EraseRootFromParent_Done,
     /* 224324 */   // Label 4451: @224324
     /* 224324 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(224366), // Rule ID 8029 //
     /* 224329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 224337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224353 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1403:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 224356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224364 */     GIR_RootConstrainSelectedInstOperands,
     /* 224365 */     // GIR_Coverage, 8029,
     /* 224365 */     GIR_EraseRootFromParent_Done,
     /* 224366 */   // Label 4452: @224366
     /* 224366 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(224408), // Rule ID 8030 //
     /* 224371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 224379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224395 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1403:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 224398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224406 */     GIR_RootConstrainSelectedInstOperands,
     /* 224407 */     // GIR_Coverage, 8030,
     /* 224407 */     GIR_EraseRootFromParent_Done,
     /* 224408 */   // Label 4453: @224408
     /* 224408 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(224450), // Rule ID 8031 //
     /* 224413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 224421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224437 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1403:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 224440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224448 */     GIR_RootConstrainSelectedInstOperands,
     /* 224449 */     // GIR_Coverage, 8031,
     /* 224449 */     GIR_EraseRootFromParent_Done,
     /* 224450 */   // Label 4454: @224450
     /* 224450 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(224492), // Rule ID 8068 //
     /* 224455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 224463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224479 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1345:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 224482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224490 */     GIR_RootConstrainSelectedInstOperands,
     /* 224491 */     // GIR_Coverage, 8068,
     /* 224491 */     GIR_EraseRootFromParent_Done,
     /* 224492 */   // Label 4455: @224492
     /* 224492 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(224534), // Rule ID 8070 //
     /* 224497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 224505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 224508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 224514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 224517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224521 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1345:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 224521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 224524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224532 */     GIR_RootConstrainSelectedInstOperands,
     /* 224533 */     // GIR_Coverage, 8070,
     /* 224533 */     GIR_EraseRootFromParent_Done,
     /* 224534 */   // Label 4456: @224534
     /* 224534 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(224576), // Rule ID 8072 //
     /* 224539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 224547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 224550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 224556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 224559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224563 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1345:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 224563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 224566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224574 */     GIR_RootConstrainSelectedInstOperands,
     /* 224575 */     // GIR_Coverage, 8072,
     /* 224575 */     GIR_EraseRootFromParent_Done,
     /* 224576 */   // Label 4457: @224576
     /* 224576 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(224618), // Rule ID 8074 //
     /* 224581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 224589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224605 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1345:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 224608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224616 */     GIR_RootConstrainSelectedInstOperands,
     /* 224617 */     // GIR_Coverage, 8074,
     /* 224617 */     GIR_EraseRootFromParent_Done,
     /* 224618 */   // Label 4458: @224618
     /* 224618 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(224660), // Rule ID 8076 //
     /* 224623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 224631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 224634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 224640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 224643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224647 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1345:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 224647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 224650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224658 */     GIR_RootConstrainSelectedInstOperands,
     /* 224659 */     // GIR_Coverage, 8076,
     /* 224659 */     GIR_EraseRootFromParent_Done,
     /* 224660 */   // Label 4459: @224660
     /* 224660 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(224702), // Rule ID 8078 //
     /* 224665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 224673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224689 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1345:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 224692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224700 */     GIR_RootConstrainSelectedInstOperands,
     /* 224701 */     // GIR_Coverage, 8078,
     /* 224701 */     GIR_EraseRootFromParent_Done,
     /* 224702 */   // Label 4460: @224702
     /* 224702 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(224744), // Rule ID 8080 //
     /* 224707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 224715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224731 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1467:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 224734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224742 */     GIR_RootConstrainSelectedInstOperands,
     /* 224743 */     // GIR_Coverage, 8080,
     /* 224743 */     GIR_EraseRootFromParent_Done,
     /* 224744 */   // Label 4461: @224744
     /* 224744 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(224786), // Rule ID 8081 //
     /* 224749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 224757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 224760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 224766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 224769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224773 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1467:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 224773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 224776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224784 */     GIR_RootConstrainSelectedInstOperands,
     /* 224785 */     // GIR_Coverage, 8081,
     /* 224785 */     GIR_EraseRootFromParent_Done,
     /* 224786 */   // Label 4462: @224786
     /* 224786 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(224828), // Rule ID 8082 //
     /* 224791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 224799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 224802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 224808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 224811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224815 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1467:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 224815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 224818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224826 */     GIR_RootConstrainSelectedInstOperands,
     /* 224827 */     // GIR_Coverage, 8082,
     /* 224827 */     GIR_EraseRootFromParent_Done,
     /* 224828 */   // Label 4463: @224828
     /* 224828 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(224870), // Rule ID 8083 //
     /* 224833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 224841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224857 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1467:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 224860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224868 */     GIR_RootConstrainSelectedInstOperands,
     /* 224869 */     // GIR_Coverage, 8083,
     /* 224869 */     GIR_EraseRootFromParent_Done,
     /* 224870 */   // Label 4464: @224870
     /* 224870 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(224912), // Rule ID 8084 //
     /* 224875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 224883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 224886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 224892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 224895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224899 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1467:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 224899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 224902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224910 */     GIR_RootConstrainSelectedInstOperands,
     /* 224911 */     // GIR_Coverage, 8084,
     /* 224911 */     GIR_EraseRootFromParent_Done,
     /* 224912 */   // Label 4465: @224912
     /* 224912 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(224954), // Rule ID 8085 //
     /* 224917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 224925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224941 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1467:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 224944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224952 */     GIR_RootConstrainSelectedInstOperands,
     /* 224953 */     // GIR_Coverage, 8085,
     /* 224953 */     GIR_EraseRootFromParent_Done,
     /* 224954 */   // Label 4466: @224954
     /* 224954 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(224996), // Rule ID 8338 //
     /* 224959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 224967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 224970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 224976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 224979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 224983 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1285:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 224983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 224986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 224988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224994 */     GIR_RootConstrainSelectedInstOperands,
     /* 224995 */     // GIR_Coverage, 8338,
     /* 224995 */     GIR_EraseRootFromParent_Done,
     /* 224996 */   // Label 4467: @224996
     /* 224996 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(225038), // Rule ID 8340 //
     /* 225001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 225009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225025 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1281:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 225028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225036 */     GIR_RootConstrainSelectedInstOperands,
     /* 225037 */     // GIR_Coverage, 8340,
     /* 225037 */     GIR_EraseRootFromParent_Done,
     /* 225038 */   // Label 4468: @225038
     /* 225038 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(225080), // Rule ID 8341 //
     /* 225043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225067 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1278:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225078 */     GIR_RootConstrainSelectedInstOperands,
     /* 225079 */     // GIR_Coverage, 8341,
     /* 225079 */     GIR_EraseRootFromParent_Done,
     /* 225080 */   // Label 4469: @225080
     /* 225080 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(225122), // Rule ID 8342 //
     /* 225085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 225096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 225102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 225105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225109 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1278:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 225109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225120 */     GIR_RootConstrainSelectedInstOperands,
     /* 225121 */     // GIR_Coverage, 8342,
     /* 225121 */     GIR_EraseRootFromParent_Done,
     /* 225122 */   // Label 4470: @225122
     /* 225122 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(225164), // Rule ID 8343 //
     /* 225127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 225138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 225144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 225147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225151 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1278:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 225151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225162 */     GIR_RootConstrainSelectedInstOperands,
     /* 225163 */     // GIR_Coverage, 8343,
     /* 225163 */     GIR_EraseRootFromParent_Done,
     /* 225164 */   // Label 4471: @225164
     /* 225164 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(225206), // Rule ID 8344 //
     /* 225169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 225180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 225189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225193 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 225193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225204 */     GIR_RootConstrainSelectedInstOperands,
     /* 225205 */     // GIR_Coverage, 8344,
     /* 225205 */     GIR_EraseRootFromParent_Done,
     /* 225206 */   // Label 4472: @225206
     /* 225206 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(225248), // Rule ID 8345 //
     /* 225211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 225222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 225225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 225228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 225231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225235 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1278:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 225235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225246 */     GIR_RootConstrainSelectedInstOperands,
     /* 225247 */     // GIR_Coverage, 8345,
     /* 225247 */     GIR_EraseRootFromParent_Done,
     /* 225248 */   // Label 4473: @225248
     /* 225248 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(225290), // Rule ID 8366 //
     /* 225253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 225261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225277 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1336:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 225280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225288 */     GIR_RootConstrainSelectedInstOperands,
     /* 225289 */     // GIR_Coverage, 8366,
     /* 225289 */     GIR_EraseRootFromParent_Done,
     /* 225290 */   // Label 4474: @225290
     /* 225290 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(225332), // Rule ID 8367 //
     /* 225295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 225303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 225306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 225312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 225315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225319 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1336:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 225319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 225322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225330 */     GIR_RootConstrainSelectedInstOperands,
     /* 225331 */     // GIR_Coverage, 8367,
     /* 225331 */     GIR_EraseRootFromParent_Done,
     /* 225332 */   // Label 4475: @225332
     /* 225332 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(225374), // Rule ID 8368 //
     /* 225337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 225345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 225348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 225354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 225357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225361 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1336:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 225361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 225364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225372 */     GIR_RootConstrainSelectedInstOperands,
     /* 225373 */     // GIR_Coverage, 8368,
     /* 225373 */     GIR_EraseRootFromParent_Done,
     /* 225374 */   // Label 4476: @225374
     /* 225374 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(225416), // Rule ID 8369 //
     /* 225379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 225387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 225390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 225399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225403 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1336:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 225403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 225406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225414 */     GIR_RootConstrainSelectedInstOperands,
     /* 225415 */     // GIR_Coverage, 8369,
     /* 225415 */     GIR_EraseRootFromParent_Done,
     /* 225416 */   // Label 4477: @225416
     /* 225416 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(225458), // Rule ID 8370 //
     /* 225421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 225429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 225432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 225435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 225438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 225441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225445 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1336:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 225445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 225448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225456 */     GIR_RootConstrainSelectedInstOperands,
     /* 225457 */     // GIR_Coverage, 8370,
     /* 225457 */     GIR_EraseRootFromParent_Done,
     /* 225458 */   // Label 4478: @225458
     /* 225458 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(225500), // Rule ID 8386 //
     /* 225463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 225471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225487 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1607:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 225490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225498 */     GIR_RootConstrainSelectedInstOperands,
     /* 225499 */     // GIR_Coverage, 8386,
     /* 225499 */     GIR_EraseRootFromParent_Done,
     /* 225500 */   // Label 4479: @225500
     /* 225500 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(225542), // Rule ID 8387 //
     /* 225505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 225513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 225516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 225522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 225525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225529 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1607:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 225529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 225532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225540 */     GIR_RootConstrainSelectedInstOperands,
     /* 225541 */     // GIR_Coverage, 8387,
     /* 225541 */     GIR_EraseRootFromParent_Done,
     /* 225542 */   // Label 4480: @225542
     /* 225542 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(225584), // Rule ID 8388 //
     /* 225547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 225555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 225558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 225564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 225567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225571 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1607:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 225571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 225574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225582 */     GIR_RootConstrainSelectedInstOperands,
     /* 225583 */     // GIR_Coverage, 8388,
     /* 225583 */     GIR_EraseRootFromParent_Done,
     /* 225584 */   // Label 4481: @225584
     /* 225584 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(225626), // Rule ID 8389 //
     /* 225589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 225597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 225600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 225609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225613 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1607:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 225613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 225616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225624 */     GIR_RootConstrainSelectedInstOperands,
     /* 225625 */     // GIR_Coverage, 8389,
     /* 225625 */     GIR_EraseRootFromParent_Done,
     /* 225626 */   // Label 4482: @225626
     /* 225626 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(225668), // Rule ID 8390 //
     /* 225631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 225639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 225642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 225645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 225648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 225651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225655 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1607:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 225655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 225658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225666 */     GIR_RootConstrainSelectedInstOperands,
     /* 225667 */     // GIR_Coverage, 8390,
     /* 225667 */     GIR_EraseRootFromParent_Done,
     /* 225668 */   // Label 4483: @225668
     /* 225668 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(225710), // Rule ID 8391 //
     /* 225673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 225681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225697 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1603:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 225700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225708 */     GIR_RootConstrainSelectedInstOperands,
     /* 225709 */     // GIR_Coverage, 8391,
     /* 225709 */     GIR_EraseRootFromParent_Done,
     /* 225710 */   // Label 4484: @225710
     /* 225710 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(225752), // Rule ID 8392 //
     /* 225715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 225723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 225726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 225732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 225735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225739 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1603:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 225739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 225742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225750 */     GIR_RootConstrainSelectedInstOperands,
     /* 225751 */     // GIR_Coverage, 8392,
     /* 225751 */     GIR_EraseRootFromParent_Done,
     /* 225752 */   // Label 4485: @225752
     /* 225752 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(225794), // Rule ID 8393 //
     /* 225757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 225765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 225768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 225774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 225777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225781 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1603:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 225781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 225784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225792 */     GIR_RootConstrainSelectedInstOperands,
     /* 225793 */     // GIR_Coverage, 8393,
     /* 225793 */     GIR_EraseRootFromParent_Done,
     /* 225794 */   // Label 4486: @225794
     /* 225794 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(225836), // Rule ID 8394 //
     /* 225799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 225807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 225810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 225819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225823 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1603:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 225823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 225826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225834 */     GIR_RootConstrainSelectedInstOperands,
     /* 225835 */     // GIR_Coverage, 8394,
     /* 225835 */     GIR_EraseRootFromParent_Done,
     /* 225836 */   // Label 4487: @225836
     /* 225836 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(225878), // Rule ID 8395 //
     /* 225841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 225849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 225852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 225855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 225858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 225861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225865 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1603:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 225865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 225868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225876 */     GIR_RootConstrainSelectedInstOperands,
     /* 225877 */     // GIR_Coverage, 8395,
     /* 225877 */     GIR_EraseRootFromParent_Done,
     /* 225878 */   // Label 4488: @225878
     /* 225878 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(225920), // Rule ID 8396 //
     /* 225883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 225891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225907 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1601:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 225910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225918 */     GIR_RootConstrainSelectedInstOperands,
     /* 225919 */     // GIR_Coverage, 8396,
     /* 225919 */     GIR_EraseRootFromParent_Done,
     /* 225920 */   // Label 4489: @225920
     /* 225920 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(225962), // Rule ID 8397 //
     /* 225925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 225933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 225936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 225942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 225945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225949 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1601:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 225949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 225952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225960 */     GIR_RootConstrainSelectedInstOperands,
     /* 225961 */     // GIR_Coverage, 8397,
     /* 225961 */     GIR_EraseRootFromParent_Done,
     /* 225962 */   // Label 4490: @225962
     /* 225962 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(226004), // Rule ID 8398 //
     /* 225967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 225975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 225978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 225984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 225987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225991 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1601:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 225991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 225994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226002 */     GIR_RootConstrainSelectedInstOperands,
     /* 226003 */     // GIR_Coverage, 8398,
     /* 226003 */     GIR_EraseRootFromParent_Done,
     /* 226004 */   // Label 4491: @226004
     /* 226004 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(226046), // Rule ID 8399 //
     /* 226009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226033 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1601:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226044 */     GIR_RootConstrainSelectedInstOperands,
     /* 226045 */     // GIR_Coverage, 8399,
     /* 226045 */     GIR_EraseRootFromParent_Done,
     /* 226046 */   // Label 4492: @226046
     /* 226046 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(226088), // Rule ID 8400 //
     /* 226051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226075 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1601:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226086 */     GIR_RootConstrainSelectedInstOperands,
     /* 226087 */     // GIR_Coverage, 8400,
     /* 226087 */     GIR_EraseRootFromParent_Done,
     /* 226088 */   // Label 4493: @226088
     /* 226088 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(226130), // Rule ID 8401 //
     /* 226093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226117 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1597:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226128 */     GIR_RootConstrainSelectedInstOperands,
     /* 226129 */     // GIR_Coverage, 8401,
     /* 226129 */     GIR_EraseRootFromParent_Done,
     /* 226130 */   // Label 4494: @226130
     /* 226130 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(226172), // Rule ID 8402 //
     /* 226135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226159 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1597:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226170 */     GIR_RootConstrainSelectedInstOperands,
     /* 226171 */     // GIR_Coverage, 8402,
     /* 226171 */     GIR_EraseRootFromParent_Done,
     /* 226172 */   // Label 4495: @226172
     /* 226172 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(226214), // Rule ID 8403 //
     /* 226177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226201 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1597:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226212 */     GIR_RootConstrainSelectedInstOperands,
     /* 226213 */     // GIR_Coverage, 8403,
     /* 226213 */     GIR_EraseRootFromParent_Done,
     /* 226214 */   // Label 4496: @226214
     /* 226214 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(226256), // Rule ID 8404 //
     /* 226219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226243 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1597:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226254 */     GIR_RootConstrainSelectedInstOperands,
     /* 226255 */     // GIR_Coverage, 8404,
     /* 226255 */     GIR_EraseRootFromParent_Done,
     /* 226256 */   // Label 4497: @226256
     /* 226256 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(226298), // Rule ID 8405 //
     /* 226261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226285 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1597:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226296 */     GIR_RootConstrainSelectedInstOperands,
     /* 226297 */     // GIR_Coverage, 8405,
     /* 226297 */     GIR_EraseRootFromParent_Done,
     /* 226298 */   // Label 4498: @226298
     /* 226298 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(226340), // Rule ID 8413 //
     /* 226303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 226311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 226323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226327 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1294:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 226327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 226330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226338 */     GIR_RootConstrainSelectedInstOperands,
     /* 226339 */     // GIR_Coverage, 8413,
     /* 226339 */     GIR_EraseRootFromParent_Done,
     /* 226340 */   // Label 4499: @226340
     /* 226340 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(226382), // Rule ID 8414 //
     /* 226345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 226353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1294:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 226369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 226372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226380 */     GIR_RootConstrainSelectedInstOperands,
     /* 226381 */     // GIR_Coverage, 8414,
     /* 226381 */     GIR_EraseRootFromParent_Done,
     /* 226382 */   // Label 4500: @226382
     /* 226382 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(226424), // Rule ID 8415 //
     /* 226387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 226395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226411 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1294:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 226411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 226414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226422 */     GIR_RootConstrainSelectedInstOperands,
     /* 226423 */     // GIR_Coverage, 8415,
     /* 226423 */     GIR_EraseRootFromParent_Done,
     /* 226424 */   // Label 4501: @226424
     /* 226424 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(226466), // Rule ID 8416 //
     /* 226429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 226437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226453 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1294:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 226456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226464 */     GIR_RootConstrainSelectedInstOperands,
     /* 226465 */     // GIR_Coverage, 8416,
     /* 226465 */     GIR_EraseRootFromParent_Done,
     /* 226466 */   // Label 4502: @226466
     /* 226466 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(226508), // Rule ID 8417 //
     /* 226471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 226479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226495 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1294:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 226495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 226498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226506 */     GIR_RootConstrainSelectedInstOperands,
     /* 226507 */     // GIR_Coverage, 8417,
     /* 226507 */     GIR_EraseRootFromParent_Done,
     /* 226508 */   // Label 4503: @226508
     /* 226508 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(226550), // Rule ID 8418 //
     /* 226513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 226521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226537 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1294:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 226537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 226540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226548 */     GIR_RootConstrainSelectedInstOperands,
     /* 226549 */     // GIR_Coverage, 8418,
     /* 226549 */     GIR_EraseRootFromParent_Done,
     /* 226550 */   // Label 4504: @226550
     /* 226550 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(226592), // Rule ID 8419 //
     /* 226555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 226563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226579 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1294:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 226579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 226582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226590 */     GIR_RootConstrainSelectedInstOperands,
     /* 226591 */     // GIR_Coverage, 8419,
     /* 226591 */     GIR_EraseRootFromParent_Done,
     /* 226592 */   // Label 4505: @226592
     /* 226592 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(226637), // Rule ID 9115 //
     /* 226597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 226605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 226621 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1315:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 226624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 226635 */     GIR_RootConstrainSelectedInstOperands,
     /* 226636 */     // GIR_Coverage, 9115,
     /* 226636 */     GIR_EraseRootFromParent_Done,
     /* 226637 */   // Label 4506: @226637
     /* 226637 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(226682), // Rule ID 9116 //
     /* 226642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 226650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 226666 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 226669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 226680 */     GIR_RootConstrainSelectedInstOperands,
     /* 226681 */     // GIR_Coverage, 9116,
     /* 226681 */     GIR_EraseRootFromParent_Done,
     /* 226682 */   // Label 4507: @226682
     /* 226682 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(226727), // Rule ID 9117 //
     /* 226687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 226695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 226711 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 226714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 226725 */     GIR_RootConstrainSelectedInstOperands,
     /* 226726 */     // GIR_Coverage, 9117,
     /* 226726 */     GIR_EraseRootFromParent_Done,
     /* 226727 */   // Label 4508: @226727
     /* 226727 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(226772), // Rule ID 9118 //
     /* 226732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 226740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 226756 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1305:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 226759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226765 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 226770 */     GIR_RootConstrainSelectedInstOperands,
     /* 226771 */     // GIR_Coverage, 9118,
     /* 226771 */     GIR_EraseRootFromParent_Done,
     /* 226772 */   // Label 4509: @226772
     /* 226772 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(226817), // Rule ID 9119 //
     /* 226777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 226785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 226801 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1305:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 226804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 226815 */     GIR_RootConstrainSelectedInstOperands,
     /* 226816 */     // GIR_Coverage, 9119,
     /* 226816 */     GIR_EraseRootFromParent_Done,
     /* 226817 */   // Label 4510: @226817
     /* 226817 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(226862), // Rule ID 9120 //
     /* 226822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 226830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 226846 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1305:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 226849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 226860 */     GIR_RootConstrainSelectedInstOperands,
     /* 226861 */     // GIR_Coverage, 9120,
     /* 226861 */     GIR_EraseRootFromParent_Done,
     /* 226862 */   // Label 4511: @226862
     /* 226862 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(226907), // Rule ID 9121 //
     /* 226867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 226875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 226891 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1313:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 226894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226902 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 226905 */     GIR_RootConstrainSelectedInstOperands,
     /* 226906 */     // GIR_Coverage, 9121,
     /* 226906 */     GIR_EraseRootFromParent_Done,
     /* 226907 */   // Label 4512: @226907
     /* 226907 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(226952), // Rule ID 9122 //
     /* 226912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 226920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 226936 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1313:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 226939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 226950 */     GIR_RootConstrainSelectedInstOperands,
     /* 226951 */     // GIR_Coverage, 9122,
     /* 226951 */     GIR_EraseRootFromParent_Done,
     /* 226952 */   // Label 4513: @226952
     /* 226952 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(226997), // Rule ID 9123 //
     /* 226957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 226965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 226981 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1313:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 226981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 226984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 226995 */     GIR_RootConstrainSelectedInstOperands,
     /* 226996 */     // GIR_Coverage, 9123,
     /* 226996 */     GIR_EraseRootFromParent_Done,
     /* 226997 */   // Label 4514: @226997
     /* 226997 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(227042), // Rule ID 9124 //
     /* 227002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 227010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227026 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1310:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 227029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227040 */     GIR_RootConstrainSelectedInstOperands,
     /* 227041 */     // GIR_Coverage, 9124,
     /* 227041 */     GIR_EraseRootFromParent_Done,
     /* 227042 */   // Label 4515: @227042
     /* 227042 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(227087), // Rule ID 9125 //
     /* 227047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 227055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227071 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1310:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 227074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227085 */     GIR_RootConstrainSelectedInstOperands,
     /* 227086 */     // GIR_Coverage, 9125,
     /* 227086 */     GIR_EraseRootFromParent_Done,
     /* 227087 */   // Label 4516: @227087
     /* 227087 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(227132), // Rule ID 9126 //
     /* 227092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 227100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227116 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1310:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 227119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227130 */     GIR_RootConstrainSelectedInstOperands,
     /* 227131 */     // GIR_Coverage, 9126,
     /* 227131 */     GIR_EraseRootFromParent_Done,
     /* 227132 */   // Label 4517: @227132
     /* 227132 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(227177), // Rule ID 9127 //
     /* 227137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 227145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227161 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1309:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 227164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227175 */     GIR_RootConstrainSelectedInstOperands,
     /* 227176 */     // GIR_Coverage, 9127,
     /* 227176 */     GIR_EraseRootFromParent_Done,
     /* 227177 */   // Label 4518: @227177
     /* 227177 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(227222), // Rule ID 9128 //
     /* 227182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 227190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227206 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1309:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 227209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227220 */     GIR_RootConstrainSelectedInstOperands,
     /* 227221 */     // GIR_Coverage, 9128,
     /* 227221 */     GIR_EraseRootFromParent_Done,
     /* 227222 */   // Label 4519: @227222
     /* 227222 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(227267), // Rule ID 9129 //
     /* 227227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 227235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227251 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1309:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 227254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227265 */     GIR_RootConstrainSelectedInstOperands,
     /* 227266 */     // GIR_Coverage, 9129,
     /* 227266 */     GIR_EraseRootFromParent_Done,
     /* 227267 */   // Label 4520: @227267
     /* 227267 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(227312), // Rule ID 9130 //
     /* 227272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 227280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227296 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1307:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 227299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227310 */     GIR_RootConstrainSelectedInstOperands,
     /* 227311 */     // GIR_Coverage, 9130,
     /* 227311 */     GIR_EraseRootFromParent_Done,
     /* 227312 */   // Label 4521: @227312
     /* 227312 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(227357), // Rule ID 9131 //
     /* 227317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 227325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227341 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1307:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 227344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227355 */     GIR_RootConstrainSelectedInstOperands,
     /* 227356 */     // GIR_Coverage, 9131,
     /* 227356 */     GIR_EraseRootFromParent_Done,
     /* 227357 */   // Label 4522: @227357
     /* 227357 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(227402), // Rule ID 9132 //
     /* 227362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 227370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227386 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1307:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 227389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227395 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227400 */     GIR_RootConstrainSelectedInstOperands,
     /* 227401 */     // GIR_Coverage, 9132,
     /* 227401 */     GIR_EraseRootFromParent_Done,
     /* 227402 */   // Label 4523: @227402
     /* 227402 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(227447), // Rule ID 9133 //
     /* 227407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 227415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227431 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1311:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 227434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227445 */     GIR_RootConstrainSelectedInstOperands,
     /* 227446 */     // GIR_Coverage, 9133,
     /* 227446 */     GIR_EraseRootFromParent_Done,
     /* 227447 */   // Label 4524: @227447
     /* 227447 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(227492), // Rule ID 9134 //
     /* 227452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 227460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227476 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1311:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 227479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227490 */     GIR_RootConstrainSelectedInstOperands,
     /* 227491 */     // GIR_Coverage, 9134,
     /* 227491 */     GIR_EraseRootFromParent_Done,
     /* 227492 */   // Label 4525: @227492
     /* 227492 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(227537), // Rule ID 9135 //
     /* 227497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 227505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227521 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1311:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 227524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227535 */     GIR_RootConstrainSelectedInstOperands,
     /* 227536 */     // GIR_Coverage, 9135,
     /* 227536 */     GIR_EraseRootFromParent_Done,
     /* 227537 */   // Label 4526: @227537
     /* 227537 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(227582), // Rule ID 9136 //
     /* 227542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 227550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227566 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1312:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 227569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227580 */     GIR_RootConstrainSelectedInstOperands,
     /* 227581 */     // GIR_Coverage, 9136,
     /* 227581 */     GIR_EraseRootFromParent_Done,
     /* 227582 */   // Label 4527: @227582
     /* 227582 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(227627), // Rule ID 9137 //
     /* 227587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 227595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227611 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1312:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 227614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227620 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227625 */     GIR_RootConstrainSelectedInstOperands,
     /* 227626 */     // GIR_Coverage, 9137,
     /* 227626 */     GIR_EraseRootFromParent_Done,
     /* 227627 */   // Label 4528: @227627
     /* 227627 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(227672), // Rule ID 9138 //
     /* 227632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 227640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227656 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1312:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 227659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227665 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227670 */     GIR_RootConstrainSelectedInstOperands,
     /* 227671 */     // GIR_Coverage, 9138,
     /* 227671 */     GIR_EraseRootFromParent_Done,
     /* 227672 */   // Label 4529: @227672
     /* 227672 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(227714), // Rule ID 9535 //
     /* 227677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 227685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227701 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1348:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 227704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227712 */     GIR_RootConstrainSelectedInstOperands,
     /* 227713 */     // GIR_Coverage, 9535,
     /* 227713 */     GIR_EraseRootFromParent_Done,
     /* 227714 */   // Label 4530: @227714
     /* 227714 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(227756), // Rule ID 9536 //
     /* 227719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 227727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227743 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1348:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 227746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227754 */     GIR_RootConstrainSelectedInstOperands,
     /* 227755 */     // GIR_Coverage, 9536,
     /* 227755 */     GIR_EraseRootFromParent_Done,
     /* 227756 */   // Label 4531: @227756
     /* 227756 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(227798), // Rule ID 9537 //
     /* 227761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 227769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 227772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227785 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1348:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 227788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227796 */     GIR_RootConstrainSelectedInstOperands,
     /* 227797 */     // GIR_Coverage, 9537,
     /* 227797 */     GIR_EraseRootFromParent_Done,
     /* 227798 */   // Label 4532: @227798
     /* 227798 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(227840), // Rule ID 10075 //
     /* 227803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 227811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227827 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1579:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 227830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227838 */     GIR_RootConstrainSelectedInstOperands,
     /* 227839 */     // GIR_Coverage, 10075,
     /* 227839 */     GIR_EraseRootFromParent_Done,
     /* 227840 */   // Label 4533: @227840
     /* 227840 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(227882), // Rule ID 10076 //
     /* 227845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 227853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227869 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1579:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 227872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227880 */     GIR_RootConstrainSelectedInstOperands,
     /* 227881 */     // GIR_Coverage, 10076,
     /* 227881 */     GIR_EraseRootFromParent_Done,
     /* 227882 */   // Label 4534: @227882
     /* 227882 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(227924), // Rule ID 10077 //
     /* 227887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 227895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227911 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1579:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 227914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227922 */     GIR_RootConstrainSelectedInstOperands,
     /* 227923 */     // GIR_Coverage, 10077,
     /* 227923 */     GIR_EraseRootFromParent_Done,
     /* 227924 */   // Label 4535: @227924
     /* 227924 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(227966), // Rule ID 10078 //
     /* 227929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 227937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227953 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1579:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 227956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227964 */     GIR_RootConstrainSelectedInstOperands,
     /* 227965 */     // GIR_Coverage, 10078,
     /* 227965 */     GIR_EraseRootFromParent_Done,
     /* 227966 */   // Label 4536: @227966
     /* 227966 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(228008), // Rule ID 10079 //
     /* 227971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 227979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227995 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1576:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 227998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228006 */     GIR_RootConstrainSelectedInstOperands,
     /* 228007 */     // GIR_Coverage, 10079,
     /* 228007 */     GIR_EraseRootFromParent_Done,
     /* 228008 */   // Label 4537: @228008
     /* 228008 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(228050), // Rule ID 10080 //
     /* 228013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228037 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1576:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 228040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228048 */     GIR_RootConstrainSelectedInstOperands,
     /* 228049 */     // GIR_Coverage, 10080,
     /* 228049 */     GIR_EraseRootFromParent_Done,
     /* 228050 */   // Label 4538: @228050
     /* 228050 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(228092), // Rule ID 10081 //
     /* 228055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228079 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1576:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 228082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228090 */     GIR_RootConstrainSelectedInstOperands,
     /* 228091 */     // GIR_Coverage, 10081,
     /* 228091 */     GIR_EraseRootFromParent_Done,
     /* 228092 */   // Label 4539: @228092
     /* 228092 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(228134), // Rule ID 10082 //
     /* 228097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1576:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 228124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228132 */     GIR_RootConstrainSelectedInstOperands,
     /* 228133 */     // GIR_Coverage, 10082,
     /* 228133 */     GIR_EraseRootFromParent_Done,
     /* 228134 */   // Label 4540: @228134
     /* 228134 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(228176), // Rule ID 10095 //
     /* 228139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 228147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228163 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1581:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 228166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228174 */     GIR_RootConstrainSelectedInstOperands,
     /* 228175 */     // GIR_Coverage, 10095,
     /* 228175 */     GIR_EraseRootFromParent_Done,
     /* 228176 */   // Label 4541: @228176
     /* 228176 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(228218), // Rule ID 10096 //
     /* 228181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 228189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228205 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1581:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 228208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228216 */     GIR_RootConstrainSelectedInstOperands,
     /* 228217 */     // GIR_Coverage, 10096,
     /* 228217 */     GIR_EraseRootFromParent_Done,
     /* 228218 */   // Label 4542: @228218
     /* 228218 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(228260), // Rule ID 10097 //
     /* 228223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 228231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228247 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1581:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 228250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228258 */     GIR_RootConstrainSelectedInstOperands,
     /* 228259 */     // GIR_Coverage, 10097,
     /* 228259 */     GIR_EraseRootFromParent_Done,
     /* 228260 */   // Label 4543: @228260
     /* 228260 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(228302), // Rule ID 10098 //
     /* 228265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 228273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228289 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1578:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 228292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228300 */     GIR_RootConstrainSelectedInstOperands,
     /* 228301 */     // GIR_Coverage, 10098,
     /* 228301 */     GIR_EraseRootFromParent_Done,
     /* 228302 */   // Label 4544: @228302
     /* 228302 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(228344), // Rule ID 10099 //
     /* 228307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 228315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228331 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1578:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 228334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228342 */     GIR_RootConstrainSelectedInstOperands,
     /* 228343 */     // GIR_Coverage, 10099,
     /* 228343 */     GIR_EraseRootFromParent_Done,
     /* 228344 */   // Label 4545: @228344
     /* 228344 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(228386), // Rule ID 10100 //
     /* 228349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 228357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1578:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 228376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228384 */     GIR_RootConstrainSelectedInstOperands,
     /* 228385 */     // GIR_Coverage, 10100,
     /* 228385 */     GIR_EraseRootFromParent_Done,
     /* 228386 */   // Label 4546: @228386
     /* 228386 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(228428), // Rule ID 10127 //
     /* 228391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 228399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228415 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 228415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 228418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228426 */     GIR_RootConstrainSelectedInstOperands,
     /* 228427 */     // GIR_Coverage, 10127,
     /* 228427 */     GIR_EraseRootFromParent_Done,
     /* 228428 */   // Label 4547: @228428
     /* 228428 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(228470), // Rule ID 10131 //
     /* 228433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 228441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228457 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1376:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 228457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 228460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228468 */     GIR_RootConstrainSelectedInstOperands,
     /* 228469 */     // GIR_Coverage, 10131,
     /* 228469 */     GIR_EraseRootFromParent_Done,
     /* 228470 */   // Label 4548: @228470
     /* 228470 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(228512), // Rule ID 10135 //
     /* 228475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 228483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228499 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1375:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 228499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 228502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228510 */     GIR_RootConstrainSelectedInstOperands,
     /* 228511 */     // GIR_Coverage, 10135,
     /* 228511 */     GIR_EraseRootFromParent_Done,
     /* 228512 */   // Label 4549: @228512
     /* 228512 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(228554), // Rule ID 10139 //
     /* 228517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 228525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228541 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1377:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 228541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 228544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228552 */     GIR_RootConstrainSelectedInstOperands,
     /* 228553 */     // GIR_Coverage, 10139,
     /* 228553 */     GIR_EraseRootFromParent_Done,
     /* 228554 */   // Label 4550: @228554
     /* 228554 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(228596), // Rule ID 10143 //
     /* 228559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 228567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228583 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1689:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 228586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228594 */     GIR_RootConstrainSelectedInstOperands,
     /* 228595 */     // GIR_Coverage, 10143,
     /* 228595 */     GIR_EraseRootFromParent_Done,
     /* 228596 */   // Label 4551: @228596
     /* 228596 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(228638), // Rule ID 10144 //
     /* 228601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 228609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228625 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1936:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 228628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228636 */     GIR_RootConstrainSelectedInstOperands,
     /* 228637 */     // GIR_Coverage, 10144,
     /* 228637 */     GIR_EraseRootFromParent_Done,
     /* 228638 */   // Label 4552: @228638
     /* 228638 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(228680), // Rule ID 10145 //
     /* 228643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 228651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228667 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1933:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 228670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228678 */     GIR_RootConstrainSelectedInstOperands,
     /* 228679 */     // GIR_Coverage, 10145,
     /* 228679 */     GIR_EraseRootFromParent_Done,
     /* 228680 */   // Label 4553: @228680
     /* 228680 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(228722), // Rule ID 10149 //
     /* 228685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 228693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228709 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1688:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 228712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228720 */     GIR_RootConstrainSelectedInstOperands,
     /* 228721 */     // GIR_Coverage, 10149,
     /* 228721 */     GIR_EraseRootFromParent_Done,
     /* 228722 */   // Label 4554: @228722
     /* 228722 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(228764), // Rule ID 10153 //
     /* 228727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 228735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 228744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228751 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1686:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 228754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228762 */     GIR_RootConstrainSelectedInstOperands,
     /* 228763 */     // GIR_Coverage, 10153,
     /* 228763 */     GIR_EraseRootFromParent_Done,
     /* 228764 */   // Label 4555: @228764
     /* 228764 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(228806), // Rule ID 10157 //
     /* 228769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 228777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228793 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1687:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 228796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228804 */     GIR_RootConstrainSelectedInstOperands,
     /* 228805 */     // GIR_Coverage, 10157,
     /* 228805 */     GIR_EraseRootFromParent_Done,
     /* 228806 */   // Label 4556: @228806
     /* 228806 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(228848), // Rule ID 10161 //
     /* 228811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 228819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228835 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1935:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 228838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228846 */     GIR_RootConstrainSelectedInstOperands,
     /* 228847 */     // GIR_Coverage, 10161,
     /* 228847 */     GIR_EraseRootFromParent_Done,
     /* 228848 */   // Label 4557: @228848
     /* 228848 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(228890), // Rule ID 10165 //
     /* 228853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 228861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228877 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1934:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 228880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228888 */     GIR_RootConstrainSelectedInstOperands,
     /* 228889 */     // GIR_Coverage, 10165,
     /* 228889 */     GIR_EraseRootFromParent_Done,
     /* 228890 */   // Label 4558: @228890
     /* 228890 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(228932), // Rule ID 10175 //
     /* 228895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 228903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228919 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1391:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 228919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 228922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228930 */     GIR_RootConstrainSelectedInstOperands,
     /* 228931 */     // GIR_Coverage, 10175,
     /* 228931 */     GIR_EraseRootFromParent_Done,
     /* 228932 */   // Label 4559: @228932
     /* 228932 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(228974), // Rule ID 10176 //
     /* 228937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 228945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228961 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1398:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 228961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 228964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228972 */     GIR_RootConstrainSelectedInstOperands,
     /* 228973 */     // GIR_Coverage, 10176,
     /* 228973 */     GIR_EraseRootFromParent_Done,
     /* 228974 */   // Label 4560: @228974
     /* 228974 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(229016), // Rule ID 10177 //
     /* 228979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 228987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 228996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229003 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1393:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 229006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229014 */     GIR_RootConstrainSelectedInstOperands,
     /* 229015 */     // GIR_Coverage, 10177,
     /* 229015 */     GIR_EraseRootFromParent_Done,
     /* 229016 */   // Label 4561: @229016
     /* 229016 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(229058), // Rule ID 10181 //
     /* 229021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 229029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229045 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1390:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 229048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229056 */     GIR_RootConstrainSelectedInstOperands,
     /* 229057 */     // GIR_Coverage, 10181,
     /* 229057 */     GIR_EraseRootFromParent_Done,
     /* 229058 */   // Label 4562: @229058
     /* 229058 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(229100), // Rule ID 10185 //
     /* 229063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 229071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229087 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1392:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 229090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229098 */     GIR_RootConstrainSelectedInstOperands,
     /* 229099 */     // GIR_Coverage, 10185,
     /* 229099 */     GIR_EraseRootFromParent_Done,
     /* 229100 */   // Label 4563: @229100
     /* 229100 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(229142), // Rule ID 10189 //
     /* 229105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 229113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229129 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1397:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 229132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229140 */     GIR_RootConstrainSelectedInstOperands,
     /* 229141 */     // GIR_Coverage, 10189,
     /* 229141 */     GIR_EraseRootFromParent_Done,
     /* 229142 */   // Label 4564: @229142
     /* 229142 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(229184), // Rule ID 10193 //
     /* 229147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 229155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229171 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1399:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 229174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229182 */     GIR_RootConstrainSelectedInstOperands,
     /* 229183 */     // GIR_Coverage, 10193,
     /* 229183 */     GIR_EraseRootFromParent_Done,
     /* 229184 */   // Label 4565: @229184
     /* 229184 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(229226), // Rule ID 10197 //
     /* 229189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 229197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229213 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1400:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 229216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229224 */     GIR_RootConstrainSelectedInstOperands,
     /* 229225 */     // GIR_Coverage, 10197,
     /* 229225 */     GIR_EraseRootFromParent_Done,
     /* 229226 */   // Label 4566: @229226
     /* 229226 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(229268), // Rule ID 11174 //
     /* 229231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 229234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 229239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1975:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 229258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229266 */     GIR_RootConstrainSelectedInstOperands,
     /* 229267 */     // GIR_Coverage, 11174,
     /* 229267 */     GIR_EraseRootFromParent_Done,
     /* 229268 */   // Label 4567: @229268
     /* 229268 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(229310), // Rule ID 11175 //
     /* 229273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 229276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 229281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229297 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 229300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229308 */     GIR_RootConstrainSelectedInstOperands,
     /* 229309 */     // GIR_Coverage, 11175,
     /* 229309 */     GIR_EraseRootFromParent_Done,
     /* 229310 */   // Label 4568: @229310
     /* 229310 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(229352), // Rule ID 11177 //
     /* 229315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 229318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 229323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229339 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1461:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 229342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229350 */     GIR_RootConstrainSelectedInstOperands,
     /* 229351 */     // GIR_Coverage, 11177,
     /* 229351 */     GIR_EraseRootFromParent_Done,
     /* 229352 */   // Label 4569: @229352
     /* 229352 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(229394), // Rule ID 11178 //
     /* 229357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 229360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 229365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229381 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1461:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 229384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229392 */     GIR_RootConstrainSelectedInstOperands,
     /* 229393 */     // GIR_Coverage, 11178,
     /* 229393 */     GIR_EraseRootFromParent_Done,
     /* 229394 */   // Label 4570: @229394
     /* 229394 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(229436), // Rule ID 11232 //
     /* 229399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 229407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229423 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1810:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 229426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229434 */     GIR_RootConstrainSelectedInstOperands,
     /* 229435 */     // GIR_Coverage, 11232,
     /* 229435 */     GIR_EraseRootFromParent_Done,
     /* 229436 */   // Label 4571: @229436
     /* 229436 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(229478), // Rule ID 11233 //
     /* 229441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 229449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229465 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 229468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229476 */     GIR_RootConstrainSelectedInstOperands,
     /* 229477 */     // GIR_Coverage, 11233,
     /* 229477 */     GIR_EraseRootFromParent_Done,
     /* 229478 */   // Label 4572: @229478
     /* 229478 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(229520), // Rule ID 11234 //
     /* 229483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 229491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229507 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1810:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 229510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229518 */     GIR_RootConstrainSelectedInstOperands,
     /* 229519 */     // GIR_Coverage, 11234,
     /* 229519 */     GIR_EraseRootFromParent_Done,
     /* 229520 */   // Label 4573: @229520
     /* 229520 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(229562), // Rule ID 11235 //
     /* 229525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 229533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229549 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1810:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 229552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229560 */     GIR_RootConstrainSelectedInstOperands,
     /* 229561 */     // GIR_Coverage, 11235,
     /* 229561 */     GIR_EraseRootFromParent_Done,
     /* 229562 */   // Label 4574: @229562
     /* 229562 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(229604), // Rule ID 11288 //
     /* 229567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 229575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229591 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 229594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229602 */     GIR_RootConstrainSelectedInstOperands,
     /* 229603 */     // GIR_Coverage, 11288,
     /* 229603 */     GIR_EraseRootFromParent_Done,
     /* 229604 */   // Label 4575: @229604
     /* 229604 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(229646), // Rule ID 11289 //
     /* 229609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 229617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229633 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 229636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229644 */     GIR_RootConstrainSelectedInstOperands,
     /* 229645 */     // GIR_Coverage, 11289,
     /* 229645 */     GIR_EraseRootFromParent_Done,
     /* 229646 */   // Label 4576: @229646
     /* 229646 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(229688), // Rule ID 11290 //
     /* 229651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 229659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229675 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 229678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229684 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229686 */     GIR_RootConstrainSelectedInstOperands,
     /* 229687 */     // GIR_Coverage, 11290,
     /* 229687 */     GIR_EraseRootFromParent_Done,
     /* 229688 */   // Label 4577: @229688
     /* 229688 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(229730), // Rule ID 11291 //
     /* 229693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 229701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229717 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1967:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 229720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229728 */     GIR_RootConstrainSelectedInstOperands,
     /* 229729 */     // GIR_Coverage, 11291,
     /* 229729 */     GIR_EraseRootFromParent_Done,
     /* 229730 */   // Label 4578: @229730
     /* 229730 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(229772), // Rule ID 11292 //
     /* 229735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 229743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1967:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 229762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229770 */     GIR_RootConstrainSelectedInstOperands,
     /* 229771 */     // GIR_Coverage, 11292,
     /* 229771 */     GIR_EraseRootFromParent_Done,
     /* 229772 */   // Label 4579: @229772
     /* 229772 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(229814), // Rule ID 11293 //
     /* 229777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 229785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229801 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1967:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 229804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229812 */     GIR_RootConstrainSelectedInstOperands,
     /* 229813 */     // GIR_Coverage, 11293,
     /* 229813 */     GIR_EraseRootFromParent_Done,
     /* 229814 */   // Label 4580: @229814
     /* 229814 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(229856), // Rule ID 11294 //
     /* 229819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 229827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229843 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 229846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229854 */     GIR_RootConstrainSelectedInstOperands,
     /* 229855 */     // GIR_Coverage, 11294,
     /* 229855 */     GIR_EraseRootFromParent_Done,
     /* 229856 */   // Label 4581: @229856
     /* 229856 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(229898), // Rule ID 11295 //
     /* 229861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 229869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229885 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 229888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229896 */     GIR_RootConstrainSelectedInstOperands,
     /* 229897 */     // GIR_Coverage, 11295,
     /* 229897 */     GIR_EraseRootFromParent_Done,
     /* 229898 */   // Label 4582: @229898
     /* 229898 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(229940), // Rule ID 11296 //
     /* 229903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 229911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 229930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229938 */     GIR_RootConstrainSelectedInstOperands,
     /* 229939 */     // GIR_Coverage, 11296,
     /* 229939 */     GIR_EraseRootFromParent_Done,
     /* 229940 */   // Label 4583: @229940
     /* 229940 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(229982), // Rule ID 11297 //
     /* 229945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 229953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229969 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1733:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 229972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229980 */     GIR_RootConstrainSelectedInstOperands,
     /* 229981 */     // GIR_Coverage, 11297,
     /* 229981 */     GIR_EraseRootFromParent_Done,
     /* 229982 */   // Label 4584: @229982
     /* 229982 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(230024), // Rule ID 11298 //
     /* 229987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 229995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230011 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1733:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 230014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230022 */     GIR_RootConstrainSelectedInstOperands,
     /* 230023 */     // GIR_Coverage, 11298,
     /* 230023 */     GIR_EraseRootFromParent_Done,
     /* 230024 */   // Label 4585: @230024
     /* 230024 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(230066), // Rule ID 11299 //
     /* 230029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 230037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230053 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1733:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 230056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230064 */     GIR_RootConstrainSelectedInstOperands,
     /* 230065 */     // GIR_Coverage, 11299,
     /* 230065 */     GIR_EraseRootFromParent_Done,
     /* 230066 */   // Label 4586: @230066
     /* 230066 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(230108), // Rule ID 11300 //
     /* 230071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 230079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230095 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1735:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 230098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230106 */     GIR_RootConstrainSelectedInstOperands,
     /* 230107 */     // GIR_Coverage, 11300,
     /* 230107 */     GIR_EraseRootFromParent_Done,
     /* 230108 */   // Label 4587: @230108
     /* 230108 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(230150), // Rule ID 11301 //
     /* 230113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 230121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230137 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1735:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 230140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230148 */     GIR_RootConstrainSelectedInstOperands,
     /* 230149 */     // GIR_Coverage, 11301,
     /* 230149 */     GIR_EraseRootFromParent_Done,
     /* 230150 */   // Label 4588: @230150
     /* 230150 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(230192), // Rule ID 11302 //
     /* 230155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 230163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230179 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1735:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 230182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230190 */     GIR_RootConstrainSelectedInstOperands,
     /* 230191 */     // GIR_Coverage, 11302,
     /* 230191 */     GIR_EraseRootFromParent_Done,
     /* 230192 */   // Label 4589: @230192
     /* 230192 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(230234), // Rule ID 11303 //
     /* 230197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 230205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1971:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 230224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230232 */     GIR_RootConstrainSelectedInstOperands,
     /* 230233 */     // GIR_Coverage, 11303,
     /* 230233 */     GIR_EraseRootFromParent_Done,
     /* 230234 */   // Label 4590: @230234
     /* 230234 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(230276), // Rule ID 11304 //
     /* 230239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 230247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230263 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1971:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 230266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230274 */     GIR_RootConstrainSelectedInstOperands,
     /* 230275 */     // GIR_Coverage, 11304,
     /* 230275 */     GIR_EraseRootFromParent_Done,
     /* 230276 */   // Label 4591: @230276
     /* 230276 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(230318), // Rule ID 11305 //
     /* 230281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 230289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230305 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1971:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 230308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230316 */     GIR_RootConstrainSelectedInstOperands,
     /* 230317 */     // GIR_Coverage, 11305,
     /* 230317 */     GIR_EraseRootFromParent_Done,
     /* 230318 */   // Label 4592: @230318
     /* 230318 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(230360), // Rule ID 11306 //
     /* 230323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 230331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230347 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1973:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 230350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230358 */     GIR_RootConstrainSelectedInstOperands,
     /* 230359 */     // GIR_Coverage, 11306,
     /* 230359 */     GIR_EraseRootFromParent_Done,
     /* 230360 */   // Label 4593: @230360
     /* 230360 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(230402), // Rule ID 11307 //
     /* 230365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 230373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1973:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 230392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230400 */     GIR_RootConstrainSelectedInstOperands,
     /* 230401 */     // GIR_Coverage, 11307,
     /* 230401 */     GIR_EraseRootFromParent_Done,
     /* 230402 */   // Label 4594: @230402
     /* 230402 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(230444), // Rule ID 11308 //
     /* 230407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 230415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230431 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1973:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 230434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230442 */     GIR_RootConstrainSelectedInstOperands,
     /* 230443 */     // GIR_Coverage, 11308,
     /* 230443 */     GIR_EraseRootFromParent_Done,
     /* 230444 */   // Label 4595: @230444
     /* 230444 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(230486), // Rule ID 11317 //
     /* 230449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 230457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230473 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1771:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 230476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230484 */     GIR_RootConstrainSelectedInstOperands,
     /* 230485 */     // GIR_Coverage, 11317,
     /* 230485 */     GIR_EraseRootFromParent_Done,
     /* 230486 */   // Label 4596: @230486
     /* 230486 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(230528), // Rule ID 11318 //
     /* 230491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 230499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1771:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 230518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230526 */     GIR_RootConstrainSelectedInstOperands,
     /* 230527 */     // GIR_Coverage, 11318,
     /* 230527 */     GIR_EraseRootFromParent_Done,
     /* 230528 */   // Label 4597: @230528
     /* 230528 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(230570), // Rule ID 11319 //
     /* 230533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 230541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230557 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1771:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 230560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230568 */     GIR_RootConstrainSelectedInstOperands,
     /* 230569 */     // GIR_Coverage, 11319,
     /* 230569 */     GIR_EraseRootFromParent_Done,
     /* 230570 */   // Label 4598: @230570
     /* 230570 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(230612), // Rule ID 11320 //
     /* 230575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 230583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230599 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1774:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 230602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230610 */     GIR_RootConstrainSelectedInstOperands,
     /* 230611 */     // GIR_Coverage, 11320,
     /* 230611 */     GIR_EraseRootFromParent_Done,
     /* 230612 */   // Label 4599: @230612
     /* 230612 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(230654), // Rule ID 11321 //
     /* 230617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 230625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230641 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1774:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 230644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230652 */     GIR_RootConstrainSelectedInstOperands,
     /* 230653 */     // GIR_Coverage, 11321,
     /* 230653 */     GIR_EraseRootFromParent_Done,
     /* 230654 */   // Label 4600: @230654
     /* 230654 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(230696), // Rule ID 11322 //
     /* 230659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 230667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230683 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1774:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 230686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230694 */     GIR_RootConstrainSelectedInstOperands,
     /* 230695 */     // GIR_Coverage, 11322,
     /* 230695 */     GIR_EraseRootFromParent_Done,
     /* 230696 */   // Label 4601: @230696
     /* 230696 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(230738), // Rule ID 11323 //
     /* 230701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 230709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230725 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1776:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 230728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230736 */     GIR_RootConstrainSelectedInstOperands,
     /* 230737 */     // GIR_Coverage, 11323,
     /* 230737 */     GIR_EraseRootFromParent_Done,
     /* 230738 */   // Label 4602: @230738
     /* 230738 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(230780), // Rule ID 11324 //
     /* 230743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 230751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1776:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 230770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230778 */     GIR_RootConstrainSelectedInstOperands,
     /* 230779 */     // GIR_Coverage, 11324,
     /* 230779 */     GIR_EraseRootFromParent_Done,
     /* 230780 */   // Label 4603: @230780
     /* 230780 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(230822), // Rule ID 11325 //
     /* 230785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 230793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1776:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 230812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230820 */     GIR_RootConstrainSelectedInstOperands,
     /* 230821 */     // GIR_Coverage, 11325,
     /* 230821 */     GIR_EraseRootFromParent_Done,
     /* 230822 */   // Label 4604: @230822
     /* 230822 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(230864), // Rule ID 11326 //
     /* 230827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 230835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230851 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1779:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 230854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230862 */     GIR_RootConstrainSelectedInstOperands,
     /* 230863 */     // GIR_Coverage, 11326,
     /* 230863 */     GIR_EraseRootFromParent_Done,
     /* 230864 */   // Label 4605: @230864
     /* 230864 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(230906), // Rule ID 11327 //
     /* 230869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 230877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230893 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1779:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 230896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230902 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230904 */     GIR_RootConstrainSelectedInstOperands,
     /* 230905 */     // GIR_Coverage, 11327,
     /* 230905 */     GIR_EraseRootFromParent_Done,
     /* 230906 */   // Label 4606: @230906
     /* 230906 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(230948), // Rule ID 11328 //
     /* 230911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 230919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230935 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1779:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 230938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230946 */     GIR_RootConstrainSelectedInstOperands,
     /* 230947 */     // GIR_Coverage, 11328,
     /* 230947 */     GIR_EraseRootFromParent_Done,
     /* 230948 */   // Label 4607: @230948
     /* 230948 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(230990), // Rule ID 11329 //
     /* 230953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 230961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230977 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1773:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 230980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230988 */     GIR_RootConstrainSelectedInstOperands,
     /* 230989 */     // GIR_Coverage, 11329,
     /* 230989 */     GIR_EraseRootFromParent_Done,
     /* 230990 */   // Label 4608: @230990
     /* 230990 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(231032), // Rule ID 11330 //
     /* 230995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 231003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231019 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1773:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 231022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231030 */     GIR_RootConstrainSelectedInstOperands,
     /* 231031 */     // GIR_Coverage, 11330,
     /* 231031 */     GIR_EraseRootFromParent_Done,
     /* 231032 */   // Label 4609: @231032
     /* 231032 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(231074), // Rule ID 11331 //
     /* 231037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 231045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231061 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1773:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 231064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231072 */     GIR_RootConstrainSelectedInstOperands,
     /* 231073 */     // GIR_Coverage, 11331,
     /* 231073 */     GIR_EraseRootFromParent_Done,
     /* 231074 */   // Label 4610: @231074
     /* 231074 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(231116), // Rule ID 11332 //
     /* 231079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 231087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231103 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1778:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 231106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231114 */     GIR_RootConstrainSelectedInstOperands,
     /* 231115 */     // GIR_Coverage, 11332,
     /* 231115 */     GIR_EraseRootFromParent_Done,
     /* 231116 */   // Label 4611: @231116
     /* 231116 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(231158), // Rule ID 11333 //
     /* 231121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 231129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231145 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1778:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 231148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231156 */     GIR_RootConstrainSelectedInstOperands,
     /* 231157 */     // GIR_Coverage, 11333,
     /* 231157 */     GIR_EraseRootFromParent_Done,
     /* 231158 */   // Label 4612: @231158
     /* 231158 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(231200), // Rule ID 11334 //
     /* 231163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 231171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231187 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1778:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 231190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231198 */     GIR_RootConstrainSelectedInstOperands,
     /* 231199 */     // GIR_Coverage, 11334,
     /* 231199 */     GIR_EraseRootFromParent_Done,
     /* 231200 */   // Label 4613: @231200
     /* 231200 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(231242), // Rule ID 11335 //
     /* 231205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 231213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231229 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1946:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 231232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231240 */     GIR_RootConstrainSelectedInstOperands,
     /* 231241 */     // GIR_Coverage, 11335,
     /* 231241 */     GIR_EraseRootFromParent_Done,
     /* 231242 */   // Label 4614: @231242
     /* 231242 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(231284), // Rule ID 11337 //
     /* 231247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 231255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231271 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1946:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 231274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231282 */     GIR_RootConstrainSelectedInstOperands,
     /* 231283 */     // GIR_Coverage, 11337,
     /* 231283 */     GIR_EraseRootFromParent_Done,
     /* 231284 */   // Label 4615: @231284
     /* 231284 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(231326), // Rule ID 11339 //
     /* 231289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 231297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231313 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1946:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 231316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231322 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231324 */     GIR_RootConstrainSelectedInstOperands,
     /* 231325 */     // GIR_Coverage, 11339,
     /* 231325 */     GIR_EraseRootFromParent_Done,
     /* 231326 */   // Label 4616: @231326
     /* 231326 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(231368), // Rule ID 11341 //
     /* 231331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 231339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 231345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231355 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1946:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 231358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231366 */     GIR_RootConstrainSelectedInstOperands,
     /* 231367 */     // GIR_Coverage, 11341,
     /* 231367 */     GIR_EraseRootFromParent_Done,
     /* 231368 */   // Label 4617: @231368
     /* 231368 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(231410), // Rule ID 11343 //
     /* 231373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 231381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231397 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1706:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 231400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231408 */     GIR_RootConstrainSelectedInstOperands,
     /* 231409 */     // GIR_Coverage, 11343,
     /* 231409 */     GIR_EraseRootFromParent_Done,
     /* 231410 */   // Label 4618: @231410
     /* 231410 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(231452), // Rule ID 11344 //
     /* 231415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 231423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231439 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1706:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 231442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231450 */     GIR_RootConstrainSelectedInstOperands,
     /* 231451 */     // GIR_Coverage, 11344,
     /* 231451 */     GIR_EraseRootFromParent_Done,
     /* 231452 */   // Label 4619: @231452
     /* 231452 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(231494), // Rule ID 11345 //
     /* 231457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 231465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231481 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1706:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 231484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231492 */     GIR_RootConstrainSelectedInstOperands,
     /* 231493 */     // GIR_Coverage, 11345,
     /* 231493 */     GIR_EraseRootFromParent_Done,
     /* 231494 */   // Label 4620: @231494
     /* 231494 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(231536), // Rule ID 11346 //
     /* 231499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 231507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 231513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231523 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1706:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 231526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231534 */     GIR_RootConstrainSelectedInstOperands,
     /* 231535 */     // GIR_Coverage, 11346,
     /* 231535 */     GIR_EraseRootFromParent_Done,
     /* 231536 */   // Label 4621: @231536
     /* 231536 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(231578), // Rule ID 11347 //
     /* 231541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 231549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231565 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1947:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 231568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231576 */     GIR_RootConstrainSelectedInstOperands,
     /* 231577 */     // GIR_Coverage, 11347,
     /* 231577 */     GIR_EraseRootFromParent_Done,
     /* 231578 */   // Label 4622: @231578
     /* 231578 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(231620), // Rule ID 11348 //
     /* 231583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 231591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231607 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1947:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 231610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231616 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231618 */     GIR_RootConstrainSelectedInstOperands,
     /* 231619 */     // GIR_Coverage, 11348,
     /* 231619 */     GIR_EraseRootFromParent_Done,
     /* 231620 */   // Label 4623: @231620
     /* 231620 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(231662), // Rule ID 11349 //
     /* 231625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 231633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231649 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1947:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 231652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231660 */     GIR_RootConstrainSelectedInstOperands,
     /* 231661 */     // GIR_Coverage, 11349,
     /* 231661 */     GIR_EraseRootFromParent_Done,
     /* 231662 */   // Label 4624: @231662
     /* 231662 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(231704), // Rule ID 11350 //
     /* 231667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 231675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 231681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231691 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1947:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 231694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231702 */     GIR_RootConstrainSelectedInstOperands,
     /* 231703 */     // GIR_Coverage, 11350,
     /* 231703 */     GIR_EraseRootFromParent_Done,
     /* 231704 */   // Label 4625: @231704
     /* 231704 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(231746), // Rule ID 11351 //
     /* 231709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 231717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231733 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1841:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 231736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231744 */     GIR_RootConstrainSelectedInstOperands,
     /* 231745 */     // GIR_Coverage, 11351,
     /* 231745 */     GIR_EraseRootFromParent_Done,
     /* 231746 */   // Label 4626: @231746
     /* 231746 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(231788), // Rule ID 11353 //
     /* 231751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 231759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231775 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 231778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231786 */     GIR_RootConstrainSelectedInstOperands,
     /* 231787 */     // GIR_Coverage, 11353,
     /* 231787 */     GIR_EraseRootFromParent_Done,
     /* 231788 */   // Label 4627: @231788
     /* 231788 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(231830), // Rule ID 11355 //
     /* 231793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 231801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231817 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 231820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231828 */     GIR_RootConstrainSelectedInstOperands,
     /* 231829 */     // GIR_Coverage, 11355,
     /* 231829 */     GIR_EraseRootFromParent_Done,
     /* 231830 */   // Label 4628: @231830
     /* 231830 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(231872), // Rule ID 11357 //
     /* 231835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 231843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 231849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 231855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231859 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1841:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 231859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 231862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231870 */     GIR_RootConstrainSelectedInstOperands,
     /* 231871 */     // GIR_Coverage, 11357,
     /* 231871 */     GIR_EraseRootFromParent_Done,
     /* 231872 */   // Label 4629: @231872
     /* 231872 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(231914), // Rule ID 11359 //
     /* 231877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 231885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231901 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2033:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 231904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231912 */     GIR_RootConstrainSelectedInstOperands,
     /* 231913 */     // GIR_Coverage, 11359,
     /* 231913 */     GIR_EraseRootFromParent_Done,
     /* 231914 */   // Label 4630: @231914
     /* 231914 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(231956), // Rule ID 11361 //
     /* 231919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 231927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231943 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2033:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 231946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231954 */     GIR_RootConstrainSelectedInstOperands,
     /* 231955 */     // GIR_Coverage, 11361,
     /* 231955 */     GIR_EraseRootFromParent_Done,
     /* 231956 */   // Label 4631: @231956
     /* 231956 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(231998), // Rule ID 11363 //
     /* 231961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 231969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 231975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231985 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2033:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 231988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231994 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231996 */     GIR_RootConstrainSelectedInstOperands,
     /* 231997 */     // GIR_Coverage, 11363,
     /* 231997 */     GIR_EraseRootFromParent_Done,
     /* 231998 */   // Label 4632: @231998
     /* 231998 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(232040), // Rule ID 11365 //
     /* 232003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 232011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232027 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2033:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 232030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232038 */     GIR_RootConstrainSelectedInstOperands,
     /* 232039 */     // GIR_Coverage, 11365,
     /* 232039 */     GIR_EraseRootFromParent_Done,
     /* 232040 */   // Label 4633: @232040
     /* 232040 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(232082), // Rule ID 11367 //
     /* 232045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232069 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1707:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 232072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232080 */     GIR_RootConstrainSelectedInstOperands,
     /* 232081 */     // GIR_Coverage, 11367,
     /* 232081 */     GIR_EraseRootFromParent_Done,
     /* 232082 */   // Label 4634: @232082
     /* 232082 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(232124), // Rule ID 11368 //
     /* 232087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232111 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1707:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 232114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232122 */     GIR_RootConstrainSelectedInstOperands,
     /* 232123 */     // GIR_Coverage, 11368,
     /* 232123 */     GIR_EraseRootFromParent_Done,
     /* 232124 */   // Label 4635: @232124
     /* 232124 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(232166), // Rule ID 11369 //
     /* 232129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232153 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1707:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 232156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232164 */     GIR_RootConstrainSelectedInstOperands,
     /* 232165 */     // GIR_Coverage, 11369,
     /* 232165 */     GIR_EraseRootFromParent_Done,
     /* 232166 */   // Label 4636: @232166
     /* 232166 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(232208), // Rule ID 11370 //
     /* 232171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232195 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1707:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 232198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232206 */     GIR_RootConstrainSelectedInstOperands,
     /* 232207 */     // GIR_Coverage, 11370,
     /* 232207 */     GIR_EraseRootFromParent_Done,
     /* 232208 */   // Label 4637: @232208
     /* 232208 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(232250), // Rule ID 11371 //
     /* 232213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 232221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232237 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1948:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 232240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232248 */     GIR_RootConstrainSelectedInstOperands,
     /* 232249 */     // GIR_Coverage, 11371,
     /* 232249 */     GIR_EraseRootFromParent_Done,
     /* 232250 */   // Label 4638: @232250
     /* 232250 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(232292), // Rule ID 11372 //
     /* 232255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 232263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232279 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1948:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 232282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232290 */     GIR_RootConstrainSelectedInstOperands,
     /* 232291 */     // GIR_Coverage, 11372,
     /* 232291 */     GIR_EraseRootFromParent_Done,
     /* 232292 */   // Label 4639: @232292
     /* 232292 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(232334), // Rule ID 11373 //
     /* 232297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 232305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232321 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1948:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 232324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232332 */     GIR_RootConstrainSelectedInstOperands,
     /* 232333 */     // GIR_Coverage, 11373,
     /* 232333 */     GIR_EraseRootFromParent_Done,
     /* 232334 */   // Label 4640: @232334
     /* 232334 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(232376), // Rule ID 11374 //
     /* 232339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 232347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232363 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1948:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 232366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232374 */     GIR_RootConstrainSelectedInstOperands,
     /* 232375 */     // GIR_Coverage, 11374,
     /* 232375 */     GIR_EraseRootFromParent_Done,
     /* 232376 */   // Label 4641: @232376
     /* 232376 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(232418), // Rule ID 11375 //
     /* 232381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 232389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232405 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1923:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 232408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232416 */     GIR_RootConstrainSelectedInstOperands,
     /* 232417 */     // GIR_Coverage, 11375,
     /* 232417 */     GIR_EraseRootFromParent_Done,
     /* 232418 */   // Label 4642: @232418
     /* 232418 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(232460), // Rule ID 11376 //
     /* 232423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 232431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232447 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1923:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 232450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232458 */     GIR_RootConstrainSelectedInstOperands,
     /* 232459 */     // GIR_Coverage, 11376,
     /* 232459 */     GIR_EraseRootFromParent_Done,
     /* 232460 */   // Label 4643: @232460
     /* 232460 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(232502), // Rule ID 11377 //
     /* 232465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 232473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232489 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1923:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 232492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232500 */     GIR_RootConstrainSelectedInstOperands,
     /* 232501 */     // GIR_Coverage, 11377,
     /* 232501 */     GIR_EraseRootFromParent_Done,
     /* 232502 */   // Label 4644: @232502
     /* 232502 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(232544), // Rule ID 11378 //
     /* 232507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 232515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232531 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1238:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 232534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232542 */     GIR_RootConstrainSelectedInstOperands,
     /* 232543 */     // GIR_Coverage, 11378,
     /* 232543 */     GIR_EraseRootFromParent_Done,
     /* 232544 */   // Label 4645: @232544
     /* 232544 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(232586), // Rule ID 11379 //
     /* 232549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 232557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232573 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1238:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 232576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232584 */     GIR_RootConstrainSelectedInstOperands,
     /* 232585 */     // GIR_Coverage, 11379,
     /* 232585 */     GIR_EraseRootFromParent_Done,
     /* 232586 */   // Label 4646: @232586
     /* 232586 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(232628), // Rule ID 11380 //
     /* 232591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 232599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232615 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1238:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 232618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232626 */     GIR_RootConstrainSelectedInstOperands,
     /* 232627 */     // GIR_Coverage, 11380,
     /* 232627 */     GIR_EraseRootFromParent_Done,
     /* 232628 */   // Label 4647: @232628
     /* 232628 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(232670), // Rule ID 11381 //
     /* 232633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 232641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232657 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1238:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 232660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232668 */     GIR_RootConstrainSelectedInstOperands,
     /* 232669 */     // GIR_Coverage, 11381,
     /* 232669 */     GIR_EraseRootFromParent_Done,
     /* 232670 */   // Label 4648: @232670
     /* 232670 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(232712), // Rule ID 11382 //
     /* 232675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 232683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232699 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1717:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 232702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232710 */     GIR_RootConstrainSelectedInstOperands,
     /* 232711 */     // GIR_Coverage, 11382,
     /* 232711 */     GIR_EraseRootFromParent_Done,
     /* 232712 */   // Label 4649: @232712
     /* 232712 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(232754), // Rule ID 11383 //
     /* 232717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 232725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232741 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1717:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 232744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232752 */     GIR_RootConstrainSelectedInstOperands,
     /* 232753 */     // GIR_Coverage, 11383,
     /* 232753 */     GIR_EraseRootFromParent_Done,
     /* 232754 */   // Label 4650: @232754
     /* 232754 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(232796), // Rule ID 11384 //
     /* 232759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 232767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232783 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1717:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 232786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232794 */     GIR_RootConstrainSelectedInstOperands,
     /* 232795 */     // GIR_Coverage, 11384,
     /* 232795 */     GIR_EraseRootFromParent_Done,
     /* 232796 */   // Label 4651: @232796
     /* 232796 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(232838), // Rule ID 11385 //
     /* 232801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 232809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232825 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1717:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 232828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232836 */     GIR_RootConstrainSelectedInstOperands,
     /* 232837 */     // GIR_Coverage, 11385,
     /* 232837 */     GIR_EraseRootFromParent_Done,
     /* 232838 */   // Label 4652: @232838
     /* 232838 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(232880), // Rule ID 11386 //
     /* 232843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 232851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232867 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1955:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 232870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232878 */     GIR_RootConstrainSelectedInstOperands,
     /* 232879 */     // GIR_Coverage, 11386,
     /* 232879 */     GIR_EraseRootFromParent_Done,
     /* 232880 */   // Label 4653: @232880
     /* 232880 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(232922), // Rule ID 11387 //
     /* 232885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 232893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1955:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 232912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232920 */     GIR_RootConstrainSelectedInstOperands,
     /* 232921 */     // GIR_Coverage, 11387,
     /* 232921 */     GIR_EraseRootFromParent_Done,
     /* 232922 */   // Label 4654: @232922
     /* 232922 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(232964), // Rule ID 11388 //
     /* 232927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 232935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1955:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 232954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232962 */     GIR_RootConstrainSelectedInstOperands,
     /* 232963 */     // GIR_Coverage, 11388,
     /* 232963 */     GIR_EraseRootFromParent_Done,
     /* 232964 */   // Label 4655: @232964
     /* 232964 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(233006), // Rule ID 11389 //
     /* 232969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 232977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1955:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 232996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233004 */     GIR_RootConstrainSelectedInstOperands,
     /* 233005 */     // GIR_Coverage, 11389,
     /* 233005 */     GIR_EraseRootFromParent_Done,
     /* 233006 */   // Label 4656: @233006
     /* 233006 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(233048), // Rule ID 11390 //
     /* 233011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233035 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1726:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 233038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233046 */     GIR_RootConstrainSelectedInstOperands,
     /* 233047 */     // GIR_Coverage, 11390,
     /* 233047 */     GIR_EraseRootFromParent_Done,
     /* 233048 */   // Label 4657: @233048
     /* 233048 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(233090), // Rule ID 11391 //
     /* 233053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1726:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 233080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233088 */     GIR_RootConstrainSelectedInstOperands,
     /* 233089 */     // GIR_Coverage, 11391,
     /* 233089 */     GIR_EraseRootFromParent_Done,
     /* 233090 */   // Label 4658: @233090
     /* 233090 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(233132), // Rule ID 11392 //
     /* 233095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233119 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1726:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 233122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233130 */     GIR_RootConstrainSelectedInstOperands,
     /* 233131 */     // GIR_Coverage, 11392,
     /* 233131 */     GIR_EraseRootFromParent_Done,
     /* 233132 */   // Label 4659: @233132
     /* 233132 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(233174), // Rule ID 11393 //
     /* 233137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1726:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 233164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233172 */     GIR_RootConstrainSelectedInstOperands,
     /* 233173 */     // GIR_Coverage, 11393,
     /* 233173 */     GIR_EraseRootFromParent_Done,
     /* 233174 */   // Label 4660: @233174
     /* 233174 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(233216), // Rule ID 11394 //
     /* 233179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 233187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233203 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1964:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 233206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233214 */     GIR_RootConstrainSelectedInstOperands,
     /* 233215 */     // GIR_Coverage, 11394,
     /* 233215 */     GIR_EraseRootFromParent_Done,
     /* 233216 */   // Label 4661: @233216
     /* 233216 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(233258), // Rule ID 11395 //
     /* 233221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 233229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1964:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 233248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233256 */     GIR_RootConstrainSelectedInstOperands,
     /* 233257 */     // GIR_Coverage, 11395,
     /* 233257 */     GIR_EraseRootFromParent_Done,
     /* 233258 */   // Label 4662: @233258
     /* 233258 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(233300), // Rule ID 11396 //
     /* 233263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 233271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233287 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1964:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 233290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233298 */     GIR_RootConstrainSelectedInstOperands,
     /* 233299 */     // GIR_Coverage, 11396,
     /* 233299 */     GIR_EraseRootFromParent_Done,
     /* 233300 */   // Label 4663: @233300
     /* 233300 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(233342), // Rule ID 11397 //
     /* 233305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 233313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233329 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1964:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 233332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233340 */     GIR_RootConstrainSelectedInstOperands,
     /* 233341 */     // GIR_Coverage, 11397,
     /* 233341 */     GIR_EraseRootFromParent_Done,
     /* 233342 */   // Label 4664: @233342
     /* 233342 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(233384), // Rule ID 11398 //
     /* 233347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 233355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 233364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233371 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 233374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233382 */     GIR_RootConstrainSelectedInstOperands,
     /* 233383 */     // GIR_Coverage, 11398,
     /* 233383 */     GIR_EraseRootFromParent_Done,
     /* 233384 */   // Label 4665: @233384
     /* 233384 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(233426), // Rule ID 11409 //
     /* 233389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 233397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 233406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233413 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1805:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 233416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233424 */     GIR_RootConstrainSelectedInstOperands,
     /* 233425 */     // GIR_Coverage, 11409,
     /* 233425 */     GIR_EraseRootFromParent_Done,
     /* 233426 */   // Label 4666: @233426
     /* 233426 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(233468), // Rule ID 11410 //
     /* 233431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 233439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 233448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233455 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1805:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 233458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233466 */     GIR_RootConstrainSelectedInstOperands,
     /* 233467 */     // GIR_Coverage, 11410,
     /* 233467 */     GIR_EraseRootFromParent_Done,
     /* 233468 */   // Label 4667: @233468
     /* 233468 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(233510), // Rule ID 11411 //
     /* 233473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 233481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 233490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233497 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1805:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 233500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233508 */     GIR_RootConstrainSelectedInstOperands,
     /* 233509 */     // GIR_Coverage, 11411,
     /* 233509 */     GIR_EraseRootFromParent_Done,
     /* 233510 */   // Label 4668: @233510
     /* 233510 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(233552), // Rule ID 11412 //
     /* 233515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 233523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 233532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233539 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1805:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 233542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233550 */     GIR_RootConstrainSelectedInstOperands,
     /* 233551 */     // GIR_Coverage, 11412,
     /* 233551 */     GIR_EraseRootFromParent_Done,
     /* 233552 */   // Label 4669: @233552
     /* 233552 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(233594), // Rule ID 11421 //
     /* 233557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 233565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233581 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1746:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 233584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233592 */     GIR_RootConstrainSelectedInstOperands,
     /* 233593 */     // GIR_Coverage, 11421,
     /* 233593 */     GIR_EraseRootFromParent_Done,
     /* 233594 */   // Label 4670: @233594
     /* 233594 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(233636), // Rule ID 11422 //
     /* 233599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 233607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233623 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1746:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 233626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233634 */     GIR_RootConstrainSelectedInstOperands,
     /* 233635 */     // GIR_Coverage, 11422,
     /* 233635 */     GIR_EraseRootFromParent_Done,
     /* 233636 */   // Label 4671: @233636
     /* 233636 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(233678), // Rule ID 11423 //
     /* 233641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 233649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233665 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 233668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233676 */     GIR_RootConstrainSelectedInstOperands,
     /* 233677 */     // GIR_Coverage, 11423,
     /* 233677 */     GIR_EraseRootFromParent_Done,
     /* 233678 */   // Label 4672: @233678
     /* 233678 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(233720), // Rule ID 11424 //
     /* 233683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 233691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233707 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1746:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 233710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233718 */     GIR_RootConstrainSelectedInstOperands,
     /* 233719 */     // GIR_Coverage, 11424,
     /* 233719 */     GIR_EraseRootFromParent_Done,
     /* 233720 */   // Label 4673: @233720
     /* 233720 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(233762), // Rule ID 11425 //
     /* 233725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 233733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233749 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1982:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 233752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233760 */     GIR_RootConstrainSelectedInstOperands,
     /* 233761 */     // GIR_Coverage, 11425,
     /* 233761 */     GIR_EraseRootFromParent_Done,
     /* 233762 */   // Label 4674: @233762
     /* 233762 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(233804), // Rule ID 11426 //
     /* 233767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 233775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233791 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1982:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 233794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233802 */     GIR_RootConstrainSelectedInstOperands,
     /* 233803 */     // GIR_Coverage, 11426,
     /* 233803 */     GIR_EraseRootFromParent_Done,
     /* 233804 */   // Label 4675: @233804
     /* 233804 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(233846), // Rule ID 11427 //
     /* 233809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 233817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233833 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1982:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 233836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233844 */     GIR_RootConstrainSelectedInstOperands,
     /* 233845 */     // GIR_Coverage, 11427,
     /* 233845 */     GIR_EraseRootFromParent_Done,
     /* 233846 */   // Label 4676: @233846
     /* 233846 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(233888), // Rule ID 11428 //
     /* 233851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 233859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233875 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1982:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 233878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233886 */     GIR_RootConstrainSelectedInstOperands,
     /* 233887 */     // GIR_Coverage, 11428,
     /* 233887 */     GIR_EraseRootFromParent_Done,
     /* 233888 */   // Label 4677: @233888
     /* 233888 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(233930), // Rule ID 11429 //
     /* 233893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 233901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233917 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1833:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 233920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233928 */     GIR_RootConstrainSelectedInstOperands,
     /* 233929 */     // GIR_Coverage, 11429,
     /* 233929 */     GIR_EraseRootFromParent_Done,
     /* 233930 */   // Label 4678: @233930
     /* 233930 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(233972), // Rule ID 11430 //
     /* 233935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 233943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233959 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 233962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233970 */     GIR_RootConstrainSelectedInstOperands,
     /* 233971 */     // GIR_Coverage, 11430,
     /* 233971 */     GIR_EraseRootFromParent_Done,
     /* 233972 */   // Label 4679: @233972
     /* 233972 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(234014), // Rule ID 11431 //
     /* 233977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 233985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234001 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 234004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234012 */     GIR_RootConstrainSelectedInstOperands,
     /* 234013 */     // GIR_Coverage, 11431,
     /* 234013 */     GIR_EraseRootFromParent_Done,
     /* 234014 */   // Label 4680: @234014
     /* 234014 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(234056), // Rule ID 11432 //
     /* 234019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 234027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234043 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1833:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 234046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234054 */     GIR_RootConstrainSelectedInstOperands,
     /* 234055 */     // GIR_Coverage, 11432,
     /* 234055 */     GIR_EraseRootFromParent_Done,
     /* 234056 */   // Label 4681: @234056
     /* 234056 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(234098), // Rule ID 11433 //
     /* 234061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234085 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2026:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 234088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234096 */     GIR_RootConstrainSelectedInstOperands,
     /* 234097 */     // GIR_Coverage, 11433,
     /* 234097 */     GIR_EraseRootFromParent_Done,
     /* 234098 */   // Label 4682: @234098
     /* 234098 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(234140), // Rule ID 11434 //
     /* 234103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234127 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2026:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 234130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234138 */     GIR_RootConstrainSelectedInstOperands,
     /* 234139 */     // GIR_Coverage, 11434,
     /* 234139 */     GIR_EraseRootFromParent_Done,
     /* 234140 */   // Label 4683: @234140
     /* 234140 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(234182), // Rule ID 11435 //
     /* 234145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2026:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 234172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234180 */     GIR_RootConstrainSelectedInstOperands,
     /* 234181 */     // GIR_Coverage, 11435,
     /* 234181 */     GIR_EraseRootFromParent_Done,
     /* 234182 */   // Label 4684: @234182
     /* 234182 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(234224), // Rule ID 11436 //
     /* 234187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234211 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2026:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 234214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234222 */     GIR_RootConstrainSelectedInstOperands,
     /* 234223 */     // GIR_Coverage, 11436,
     /* 234223 */     GIR_EraseRootFromParent_Done,
     /* 234224 */   // Label 4685: @234224
     /* 234224 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(234266), // Rule ID 11437 //
     /* 234229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 234237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234253 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1897:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 234256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234264 */     GIR_RootConstrainSelectedInstOperands,
     /* 234265 */     // GIR_Coverage, 11437,
     /* 234265 */     GIR_EraseRootFromParent_Done,
     /* 234266 */   // Label 4686: @234266
     /* 234266 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(234308), // Rule ID 11438 //
     /* 234271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 234279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234295 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1897:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 234298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234306 */     GIR_RootConstrainSelectedInstOperands,
     /* 234307 */     // GIR_Coverage, 11438,
     /* 234307 */     GIR_EraseRootFromParent_Done,
     /* 234308 */   // Label 4687: @234308
     /* 234308 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(234350), // Rule ID 11439 //
     /* 234313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 234321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234337 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1897:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 234340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234348 */     GIR_RootConstrainSelectedInstOperands,
     /* 234349 */     // GIR_Coverage, 11439,
     /* 234349 */     GIR_EraseRootFromParent_Done,
     /* 234350 */   // Label 4688: @234350
     /* 234350 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(234392), // Rule ID 11440 //
     /* 234355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 234363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234379 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1897:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 234382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234390 */     GIR_RootConstrainSelectedInstOperands,
     /* 234391 */     // GIR_Coverage, 11440,
     /* 234391 */     GIR_EraseRootFromParent_Done,
     /* 234392 */   // Label 4689: @234392
     /* 234392 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(234434), // Rule ID 11441 //
     /* 234397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 234405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234421 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 234424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234432 */     GIR_RootConstrainSelectedInstOperands,
     /* 234433 */     // GIR_Coverage, 11441,
     /* 234433 */     GIR_EraseRootFromParent_Done,
     /* 234434 */   // Label 4690: @234434
     /* 234434 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(234476), // Rule ID 11442 //
     /* 234439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 234447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234463 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 234466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234474 */     GIR_RootConstrainSelectedInstOperands,
     /* 234475 */     // GIR_Coverage, 11442,
     /* 234475 */     GIR_EraseRootFromParent_Done,
     /* 234476 */   // Label 4691: @234476
     /* 234476 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(234518), // Rule ID 11443 //
     /* 234481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 234489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234505 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 234508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234516 */     GIR_RootConstrainSelectedInstOperands,
     /* 234517 */     // GIR_Coverage, 11443,
     /* 234517 */     GIR_EraseRootFromParent_Done,
     /* 234518 */   // Label 4692: @234518
     /* 234518 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(234560), // Rule ID 11444 //
     /* 234523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 234531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234547 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 234550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234558 */     GIR_RootConstrainSelectedInstOperands,
     /* 234559 */     // GIR_Coverage, 11444,
     /* 234559 */     GIR_EraseRootFromParent_Done,
     /* 234560 */   // Label 4693: @234560
     /* 234560 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(234602), // Rule ID 11445 //
     /* 234565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 234573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234589 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1836:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 234592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234600 */     GIR_RootConstrainSelectedInstOperands,
     /* 234601 */     // GIR_Coverage, 11445,
     /* 234601 */     GIR_EraseRootFromParent_Done,
     /* 234602 */   // Label 4694: @234602
     /* 234602 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(234644), // Rule ID 11446 //
     /* 234607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 234615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234631 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1836:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 234634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234642 */     GIR_RootConstrainSelectedInstOperands,
     /* 234643 */     // GIR_Coverage, 11446,
     /* 234643 */     GIR_EraseRootFromParent_Done,
     /* 234644 */   // Label 4695: @234644
     /* 234644 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(234686), // Rule ID 11447 //
     /* 234649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 234657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234673 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1836:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 234676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234684 */     GIR_RootConstrainSelectedInstOperands,
     /* 234685 */     // GIR_Coverage, 11447,
     /* 234685 */     GIR_EraseRootFromParent_Done,
     /* 234686 */   // Label 4696: @234686
     /* 234686 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(234728), // Rule ID 11448 //
     /* 234691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 234699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234715 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1836:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 234718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234726 */     GIR_RootConstrainSelectedInstOperands,
     /* 234727 */     // GIR_Coverage, 11448,
     /* 234727 */     GIR_EraseRootFromParent_Done,
     /* 234728 */   // Label 4697: @234728
     /* 234728 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(234770), // Rule ID 11449 //
     /* 234733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 234741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234757 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2029:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 234760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234768 */     GIR_RootConstrainSelectedInstOperands,
     /* 234769 */     // GIR_Coverage, 11449,
     /* 234769 */     GIR_EraseRootFromParent_Done,
     /* 234770 */   // Label 4698: @234770
     /* 234770 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(234812), // Rule ID 11450 //
     /* 234775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 234783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234799 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2029:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 234802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234810 */     GIR_RootConstrainSelectedInstOperands,
     /* 234811 */     // GIR_Coverage, 11450,
     /* 234811 */     GIR_EraseRootFromParent_Done,
     /* 234812 */   // Label 4699: @234812
     /* 234812 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(234854), // Rule ID 11451 //
     /* 234817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 234825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234841 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2029:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 234844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234852 */     GIR_RootConstrainSelectedInstOperands,
     /* 234853 */     // GIR_Coverage, 11451,
     /* 234853 */     GIR_EraseRootFromParent_Done,
     /* 234854 */   // Label 4700: @234854
     /* 234854 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(234896), // Rule ID 11452 //
     /* 234859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 234867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234883 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2029:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 234886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234892 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234894 */     GIR_RootConstrainSelectedInstOperands,
     /* 234895 */     // GIR_Coverage, 11452,
     /* 234895 */     GIR_EraseRootFromParent_Done,
     /* 234896 */   // Label 4701: @234896
     /* 234896 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(234938), // Rule ID 11453 //
     /* 234901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 234909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234925 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1843:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 234928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234936 */     GIR_RootConstrainSelectedInstOperands,
     /* 234937 */     // GIR_Coverage, 11453,
     /* 234937 */     GIR_EraseRootFromParent_Done,
     /* 234938 */   // Label 4702: @234938
     /* 234938 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(234980), // Rule ID 11454 //
     /* 234943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 234951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234967 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 234970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234978 */     GIR_RootConstrainSelectedInstOperands,
     /* 234979 */     // GIR_Coverage, 11454,
     /* 234979 */     GIR_EraseRootFromParent_Done,
     /* 234980 */   // Label 4703: @234980
     /* 234980 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(235022), // Rule ID 11455 //
     /* 234985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 234993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235009 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 235012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235020 */     GIR_RootConstrainSelectedInstOperands,
     /* 235021 */     // GIR_Coverage, 11455,
     /* 235021 */     GIR_EraseRootFromParent_Done,
     /* 235022 */   // Label 4704: @235022
     /* 235022 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(235064), // Rule ID 11456 //
     /* 235027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 235035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235051 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1843:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 235054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235060 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235062 */     GIR_RootConstrainSelectedInstOperands,
     /* 235063 */     // GIR_Coverage, 11456,
     /* 235063 */     GIR_EraseRootFromParent_Done,
     /* 235064 */   // Label 4705: @235064
     /* 235064 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(235106), // Rule ID 11457 //
     /* 235069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235093 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2034:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 235096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235104 */     GIR_RootConstrainSelectedInstOperands,
     /* 235105 */     // GIR_Coverage, 11457,
     /* 235105 */     GIR_EraseRootFromParent_Done,
     /* 235106 */   // Label 4706: @235106
     /* 235106 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(235148), // Rule ID 11458 //
     /* 235111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235135 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2034:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 235138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235146 */     GIR_RootConstrainSelectedInstOperands,
     /* 235147 */     // GIR_Coverage, 11458,
     /* 235147 */     GIR_EraseRootFromParent_Done,
     /* 235148 */   // Label 4707: @235148
     /* 235148 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(235190), // Rule ID 11459 //
     /* 235153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2034:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 235180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235188 */     GIR_RootConstrainSelectedInstOperands,
     /* 235189 */     // GIR_Coverage, 11459,
     /* 235189 */     GIR_EraseRootFromParent_Done,
     /* 235190 */   // Label 4708: @235190
     /* 235190 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(235232), // Rule ID 11460 //
     /* 235195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235219 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2034:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 235222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235230 */     GIR_RootConstrainSelectedInstOperands,
     /* 235231 */     // GIR_Coverage, 11460,
     /* 235231 */     GIR_EraseRootFromParent_Done,
     /* 235232 */   // Label 4709: @235232
     /* 235232 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(235274), // Rule ID 11461 //
     /* 235237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 235245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235261 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1827:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 235264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235272 */     GIR_RootConstrainSelectedInstOperands,
     /* 235273 */     // GIR_Coverage, 11461,
     /* 235273 */     GIR_EraseRootFromParent_Done,
     /* 235274 */   // Label 4710: @235274
     /* 235274 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(235316), // Rule ID 11462 //
     /* 235279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 235287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235303 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1827:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 235306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235314 */     GIR_RootConstrainSelectedInstOperands,
     /* 235315 */     // GIR_Coverage, 11462,
     /* 235315 */     GIR_EraseRootFromParent_Done,
     /* 235316 */   // Label 4711: @235316
     /* 235316 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(235358), // Rule ID 11463 //
     /* 235321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 235329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235345 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1827:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 235348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235356 */     GIR_RootConstrainSelectedInstOperands,
     /* 235357 */     // GIR_Coverage, 11463,
     /* 235357 */     GIR_EraseRootFromParent_Done,
     /* 235358 */   // Label 4712: @235358
     /* 235358 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(235400), // Rule ID 11464 //
     /* 235363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 235371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235387 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1827:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 235390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235398 */     GIR_RootConstrainSelectedInstOperands,
     /* 235399 */     // GIR_Coverage, 11464,
     /* 235399 */     GIR_EraseRootFromParent_Done,
     /* 235400 */   // Label 4713: @235400
     /* 235400 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(235442), // Rule ID 11465 //
     /* 235405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 235413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235429 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2023:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 235432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235440 */     GIR_RootConstrainSelectedInstOperands,
     /* 235441 */     // GIR_Coverage, 11465,
     /* 235441 */     GIR_EraseRootFromParent_Done,
     /* 235442 */   // Label 4714: @235442
     /* 235442 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(235484), // Rule ID 11466 //
     /* 235447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 235455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2023:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 235474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235482 */     GIR_RootConstrainSelectedInstOperands,
     /* 235483 */     // GIR_Coverage, 11466,
     /* 235483 */     GIR_EraseRootFromParent_Done,
     /* 235484 */   // Label 4715: @235484
     /* 235484 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(235526), // Rule ID 11467 //
     /* 235489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 235497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235513 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2023:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 235516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235524 */     GIR_RootConstrainSelectedInstOperands,
     /* 235525 */     // GIR_Coverage, 11467,
     /* 235525 */     GIR_EraseRootFromParent_Done,
     /* 235526 */   // Label 4716: @235526
     /* 235526 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(235568), // Rule ID 11468 //
     /* 235531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 235539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235555 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2023:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 235558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235566 */     GIR_RootConstrainSelectedInstOperands,
     /* 235567 */     // GIR_Coverage, 11468,
     /* 235567 */     GIR_EraseRootFromParent_Done,
     /* 235568 */   // Label 4717: @235568
     /* 235568 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(235610), // Rule ID 11469 //
     /* 235573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 235581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235597 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1814:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 235600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235608 */     GIR_RootConstrainSelectedInstOperands,
     /* 235609 */     // GIR_Coverage, 11469,
     /* 235609 */     GIR_EraseRootFromParent_Done,
     /* 235610 */   // Label 4718: @235610
     /* 235610 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(235652), // Rule ID 11470 //
     /* 235615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 235623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235639 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1814:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 235642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235650 */     GIR_RootConstrainSelectedInstOperands,
     /* 235651 */     // GIR_Coverage, 11470,
     /* 235651 */     GIR_EraseRootFromParent_Done,
     /* 235652 */   // Label 4719: @235652
     /* 235652 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(235694), // Rule ID 11471 //
     /* 235657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 235665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235681 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1814:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 235684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235692 */     GIR_RootConstrainSelectedInstOperands,
     /* 235693 */     // GIR_Coverage, 11471,
     /* 235693 */     GIR_EraseRootFromParent_Done,
     /* 235694 */   // Label 4720: @235694
     /* 235694 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(235736), // Rule ID 11472 //
     /* 235699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 235707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235723 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1814:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 235726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235734 */     GIR_RootConstrainSelectedInstOperands,
     /* 235735 */     // GIR_Coverage, 11472,
     /* 235735 */     GIR_EraseRootFromParent_Done,
     /* 235736 */   // Label 4721: @235736
     /* 235736 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(235778), // Rule ID 11473 //
     /* 235741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 235749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235765 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2016:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 235768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235776 */     GIR_RootConstrainSelectedInstOperands,
     /* 235777 */     // GIR_Coverage, 11473,
     /* 235777 */     GIR_EraseRootFromParent_Done,
     /* 235778 */   // Label 4722: @235778
     /* 235778 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(235820), // Rule ID 11474 //
     /* 235783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 235791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235807 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2016:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 235810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235818 */     GIR_RootConstrainSelectedInstOperands,
     /* 235819 */     // GIR_Coverage, 11474,
     /* 235819 */     GIR_EraseRootFromParent_Done,
     /* 235820 */   // Label 4723: @235820
     /* 235820 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(235862), // Rule ID 11475 //
     /* 235825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 235833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235849 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2016:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 235852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235860 */     GIR_RootConstrainSelectedInstOperands,
     /* 235861 */     // GIR_Coverage, 11475,
     /* 235861 */     GIR_EraseRootFromParent_Done,
     /* 235862 */   // Label 4724: @235862
     /* 235862 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(235904), // Rule ID 11476 //
     /* 235867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 235875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2016:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 235894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235902 */     GIR_RootConstrainSelectedInstOperands,
     /* 235903 */     // GIR_Coverage, 11476,
     /* 235903 */     GIR_EraseRootFromParent_Done,
     /* 235904 */   // Label 4725: @235904
     /* 235904 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(235946), // Rule ID 11639 //
     /* 235909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 235917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235933 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1916:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 235936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235944 */     GIR_RootConstrainSelectedInstOperands,
     /* 235945 */     // GIR_Coverage, 11639,
     /* 235945 */     GIR_EraseRootFromParent_Done,
     /* 235946 */   // Label 4726: @235946
     /* 235946 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(235988), // Rule ID 11641 //
     /* 235951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 235959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235975 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1916:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 235978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 235980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235986 */     GIR_RootConstrainSelectedInstOperands,
     /* 235987 */     // GIR_Coverage, 11641,
     /* 235987 */     GIR_EraseRootFromParent_Done,
     /* 235988 */   // Label 4727: @235988
     /* 235988 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(236030), // Rule ID 11643 //
     /* 235993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 236001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236017 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1916:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 236020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236028 */     GIR_RootConstrainSelectedInstOperands,
     /* 236029 */     // GIR_Coverage, 11643,
     /* 236029 */     GIR_EraseRootFromParent_Done,
     /* 236030 */   // Label 4728: @236030
     /* 236030 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(236072), // Rule ID 11645 //
     /* 236035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 236043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1916:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 236062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236070 */     GIR_RootConstrainSelectedInstOperands,
     /* 236071 */     // GIR_Coverage, 11645,
     /* 236071 */     GIR_EraseRootFromParent_Done,
     /* 236072 */   // Label 4729: @236072
     /* 236072 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(236114), // Rule ID 11647 //
     /* 236077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 236085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1668:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 236104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236112 */     GIR_RootConstrainSelectedInstOperands,
     /* 236113 */     // GIR_Coverage, 11647,
     /* 236113 */     GIR_EraseRootFromParent_Done,
     /* 236114 */   // Label 4730: @236114
     /* 236114 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(236156), // Rule ID 11648 //
     /* 236119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 236127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1668:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 236146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236154 */     GIR_RootConstrainSelectedInstOperands,
     /* 236155 */     // GIR_Coverage, 11648,
     /* 236155 */     GIR_EraseRootFromParent_Done,
     /* 236156 */   // Label 4731: @236156
     /* 236156 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(236198), // Rule ID 11649 //
     /* 236161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 236169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236185 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1668:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 236188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236196 */     GIR_RootConstrainSelectedInstOperands,
     /* 236197 */     // GIR_Coverage, 11649,
     /* 236197 */     GIR_EraseRootFromParent_Done,
     /* 236198 */   // Label 4732: @236198
     /* 236198 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(236240), // Rule ID 11650 //
     /* 236203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 236211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1917:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 236230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236238 */     GIR_RootConstrainSelectedInstOperands,
     /* 236239 */     // GIR_Coverage, 11650,
     /* 236239 */     GIR_EraseRootFromParent_Done,
     /* 236240 */   // Label 4733: @236240
     /* 236240 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(236282), // Rule ID 11651 //
     /* 236245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 236253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1917:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 236272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236280 */     GIR_RootConstrainSelectedInstOperands,
     /* 236281 */     // GIR_Coverage, 11651,
     /* 236281 */     GIR_EraseRootFromParent_Done,
     /* 236282 */   // Label 4734: @236282
     /* 236282 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(236324), // Rule ID 11652 //
     /* 236287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 236295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1917:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 236314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236322 */     GIR_RootConstrainSelectedInstOperands,
     /* 236323 */     // GIR_Coverage, 11652,
     /* 236323 */     GIR_EraseRootFromParent_Done,
     /* 236324 */   // Label 4735: @236324
     /* 236324 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(236366), // Rule ID 11653 //
     /* 236329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 236337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1918:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 236356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236364 */     GIR_RootConstrainSelectedInstOperands,
     /* 236365 */     // GIR_Coverage, 11653,
     /* 236365 */     GIR_EraseRootFromParent_Done,
     /* 236366 */   // Label 4736: @236366
     /* 236366 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(236408), // Rule ID 11654 //
     /* 236371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 236379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236395 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1918:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 236398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236406 */     GIR_RootConstrainSelectedInstOperands,
     /* 236407 */     // GIR_Coverage, 11654,
     /* 236407 */     GIR_EraseRootFromParent_Done,
     /* 236408 */   // Label 4737: @236408
     /* 236408 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(236450), // Rule ID 11655 //
     /* 236413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 236421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236437 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1918:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 236440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236448 */     GIR_RootConstrainSelectedInstOperands,
     /* 236449 */     // GIR_Coverage, 11655,
     /* 236449 */     GIR_EraseRootFromParent_Done,
     /* 236450 */   // Label 4738: @236450
     /* 236450 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(236492), // Rule ID 11656 //
     /* 236455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 236463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236479 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1231:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 236482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236490 */     GIR_RootConstrainSelectedInstOperands,
     /* 236491 */     // GIR_Coverage, 11656,
     /* 236491 */     GIR_EraseRootFromParent_Done,
     /* 236492 */   // Label 4739: @236492
     /* 236492 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(236534), // Rule ID 11657 //
     /* 236497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 236505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236521 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1231:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 236524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236532 */     GIR_RootConstrainSelectedInstOperands,
     /* 236533 */     // GIR_Coverage, 11657,
     /* 236533 */     GIR_EraseRootFromParent_Done,
     /* 236534 */   // Label 4740: @236534
     /* 236534 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(236576), // Rule ID 11658 //
     /* 236539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 236547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1680:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 236566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236574 */     GIR_RootConstrainSelectedInstOperands,
     /* 236575 */     // GIR_Coverage, 11658,
     /* 236575 */     GIR_EraseRootFromParent_Done,
     /* 236576 */   // Label 4741: @236576
     /* 236576 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(236618), // Rule ID 11659 //
     /* 236581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 236589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236605 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1680:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 236608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236616 */     GIR_RootConstrainSelectedInstOperands,
     /* 236617 */     // GIR_Coverage, 11659,
     /* 236617 */     GIR_EraseRootFromParent_Done,
     /* 236618 */   // Label 4742: @236618
     /* 236618 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(236660), // Rule ID 11660 //
     /* 236623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 236631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1681:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 236650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236658 */     GIR_RootConstrainSelectedInstOperands,
     /* 236659 */     // GIR_Coverage, 11660,
     /* 236659 */     GIR_EraseRootFromParent_Done,
     /* 236660 */   // Label 4743: @236660
     /* 236660 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(236702), // Rule ID 11661 //
     /* 236665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 236673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236689 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1681:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 236692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236700 */     GIR_RootConstrainSelectedInstOperands,
     /* 236701 */     // GIR_Coverage, 11661,
     /* 236701 */     GIR_EraseRootFromParent_Done,
     /* 236702 */   // Label 4744: @236702
     /* 236702 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(236744), // Rule ID 11716 //
     /* 236707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 236715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236731 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1649:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 236734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236742 */     GIR_RootConstrainSelectedInstOperands,
     /* 236743 */     // GIR_Coverage, 11716,
     /* 236743 */     GIR_EraseRootFromParent_Done,
     /* 236744 */   // Label 4745: @236744
     /* 236744 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(236786), // Rule ID 11717 //
     /* 236749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 236757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236773 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1649:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 236776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236784 */     GIR_RootConstrainSelectedInstOperands,
     /* 236785 */     // GIR_Coverage, 11717,
     /* 236785 */     GIR_EraseRootFromParent_Done,
     /* 236786 */   // Label 4746: @236786
     /* 236786 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(236828), // Rule ID 11718 //
     /* 236791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 236799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236815 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1649:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 236818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236826 */     GIR_RootConstrainSelectedInstOperands,
     /* 236827 */     // GIR_Coverage, 11718,
     /* 236827 */     GIR_EraseRootFromParent_Done,
     /* 236828 */   // Label 4747: @236828
     /* 236828 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(236870), // Rule ID 11719 //
     /* 236833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 236841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236857 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1890:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 236860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236868 */     GIR_RootConstrainSelectedInstOperands,
     /* 236869 */     // GIR_Coverage, 11719,
     /* 236869 */     GIR_EraseRootFromParent_Done,
     /* 236870 */   // Label 4748: @236870
     /* 236870 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(236912), // Rule ID 11720 //
     /* 236875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 236883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236899 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1890:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 236902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236910 */     GIR_RootConstrainSelectedInstOperands,
     /* 236911 */     // GIR_Coverage, 11720,
     /* 236911 */     GIR_EraseRootFromParent_Done,
     /* 236912 */   // Label 4749: @236912
     /* 236912 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(236954), // Rule ID 11721 //
     /* 236917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 236925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236941 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1890:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 236944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236952 */     GIR_RootConstrainSelectedInstOperands,
     /* 236953 */     // GIR_Coverage, 11721,
     /* 236953 */     GIR_EraseRootFromParent_Done,
     /* 236954 */   // Label 4750: @236954
     /* 236954 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(236996), // Rule ID 11722 //
     /* 236959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 236967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236983 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1665:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 236986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236994 */     GIR_RootConstrainSelectedInstOperands,
     /* 236995 */     // GIR_Coverage, 11722,
     /* 236995 */     GIR_EraseRootFromParent_Done,
     /* 236996 */   // Label 4751: @236996
     /* 236996 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(237038), // Rule ID 11723 //
     /* 237001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 237009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237025 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1665:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 237028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237036 */     GIR_RootConstrainSelectedInstOperands,
     /* 237037 */     // GIR_Coverage, 11723,
     /* 237037 */     GIR_EraseRootFromParent_Done,
     /* 237038 */   // Label 4752: @237038
     /* 237038 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(237080), // Rule ID 11724 //
     /* 237043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 237051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237067 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1665:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 237070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237078 */     GIR_RootConstrainSelectedInstOperands,
     /* 237079 */     // GIR_Coverage, 11724,
     /* 237079 */     GIR_EraseRootFromParent_Done,
     /* 237080 */   // Label 4753: @237080
     /* 237080 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(237125), // Rule ID 11737 //
     /* 237085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 237088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 237093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 237096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237109 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 237112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237123 */     GIR_RootConstrainSelectedInstOperands,
     /* 237124 */     // GIR_Coverage, 11737,
     /* 237124 */     GIR_EraseRootFromParent_Done,
     /* 237125 */   // Label 4754: @237125
     /* 237125 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(237170), // Rule ID 11738 //
     /* 237130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 237133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 237138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 237141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237154 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 237157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237168 */     GIR_RootConstrainSelectedInstOperands,
     /* 237169 */     // GIR_Coverage, 11738,
     /* 237169 */     GIR_EraseRootFromParent_Done,
     /* 237170 */   // Label 4755: @237170
     /* 237170 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(237212), // Rule ID 11739 //
     /* 237175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 237183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237199 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1340:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 237202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237210 */     GIR_RootConstrainSelectedInstOperands,
     /* 237211 */     // GIR_Coverage, 11739,
     /* 237211 */     GIR_EraseRootFromParent_Done,
     /* 237212 */   // Label 4756: @237212
     /* 237212 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(237254), // Rule ID 11740 //
     /* 237217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 237225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237241 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1340:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 237244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237252 */     GIR_RootConstrainSelectedInstOperands,
     /* 237253 */     // GIR_Coverage, 11740,
     /* 237253 */     GIR_EraseRootFromParent_Done,
     /* 237254 */   // Label 4757: @237254
     /* 237254 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(237296), // Rule ID 11741 //
     /* 237259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 237267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237283 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1340:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 237286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237294 */     GIR_RootConstrainSelectedInstOperands,
     /* 237295 */     // GIR_Coverage, 11741,
     /* 237295 */     GIR_EraseRootFromParent_Done,
     /* 237296 */   // Label 4758: @237296
     /* 237296 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(237338), // Rule ID 11742 //
     /* 237301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 237309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237325 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1340:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 237328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237336 */     GIR_RootConstrainSelectedInstOperands,
     /* 237337 */     // GIR_Coverage, 11742,
     /* 237337 */     GIR_EraseRootFromParent_Done,
     /* 237338 */   // Label 4759: @237338
     /* 237338 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(237380), // Rule ID 11758 //
     /* 237343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 237351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237367 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1423:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 237370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237378 */     GIR_RootConstrainSelectedInstOperands,
     /* 237379 */     // GIR_Coverage, 11758,
     /* 237379 */     GIR_EraseRootFromParent_Done,
     /* 237380 */   // Label 4760: @237380
     /* 237380 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(237422), // Rule ID 11759 //
     /* 237385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 237393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237409 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1423:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 237409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 237412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237420 */     GIR_RootConstrainSelectedInstOperands,
     /* 237421 */     // GIR_Coverage, 11759,
     /* 237421 */     GIR_EraseRootFromParent_Done,
     /* 237422 */   // Label 4761: @237422
     /* 237422 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(237464), // Rule ID 11760 //
     /* 237427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 237435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237451 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1423:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 237451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 237454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237462 */     GIR_RootConstrainSelectedInstOperands,
     /* 237463 */     // GIR_Coverage, 11760,
     /* 237463 */     GIR_EraseRootFromParent_Done,
     /* 237464 */   // Label 4762: @237464
     /* 237464 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(237506), // Rule ID 11761 //
     /* 237469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 237477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237493 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1441:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 237496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237504 */     GIR_RootConstrainSelectedInstOperands,
     /* 237505 */     // GIR_Coverage, 11761,
     /* 237505 */     GIR_EraseRootFromParent_Done,
     /* 237506 */   // Label 4763: @237506
     /* 237506 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(237548), // Rule ID 11762 //
     /* 237511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 237519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237535 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1441:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 237535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 237538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237546 */     GIR_RootConstrainSelectedInstOperands,
     /* 237547 */     // GIR_Coverage, 11762,
     /* 237547 */     GIR_EraseRootFromParent_Done,
     /* 237548 */   // Label 4764: @237548
     /* 237548 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(237590), // Rule ID 11763 //
     /* 237553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 237561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237577 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1441:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 237577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 237580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237588 */     GIR_RootConstrainSelectedInstOperands,
     /* 237589 */     // GIR_Coverage, 11763,
     /* 237589 */     GIR_EraseRootFromParent_Done,
     /* 237590 */   // Label 4765: @237590
     /* 237590 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(237632), // Rule ID 11764 //
     /* 237595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 237603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237619 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1426:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 237622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237630 */     GIR_RootConstrainSelectedInstOperands,
     /* 237631 */     // GIR_Coverage, 11764,
     /* 237631 */     GIR_EraseRootFromParent_Done,
     /* 237632 */   // Label 4766: @237632
     /* 237632 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(237674), // Rule ID 11765 //
     /* 237637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 237645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237661 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1426:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 237661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 237664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237672 */     GIR_RootConstrainSelectedInstOperands,
     /* 237673 */     // GIR_Coverage, 11765,
     /* 237673 */     GIR_EraseRootFromParent_Done,
     /* 237674 */   // Label 4767: @237674
     /* 237674 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(237716), // Rule ID 11766 //
     /* 237679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 237687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237703 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1426:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 237703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 237706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237714 */     GIR_RootConstrainSelectedInstOperands,
     /* 237715 */     // GIR_Coverage, 11766,
     /* 237715 */     GIR_EraseRootFromParent_Done,
     /* 237716 */   // Label 4768: @237716
     /* 237716 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(237758), // Rule ID 11767 //
     /* 237721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 237729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237745 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1444:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 237748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237756 */     GIR_RootConstrainSelectedInstOperands,
     /* 237757 */     // GIR_Coverage, 11767,
     /* 237757 */     GIR_EraseRootFromParent_Done,
     /* 237758 */   // Label 4769: @237758
     /* 237758 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(237800), // Rule ID 11768 //
     /* 237763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 237771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237787 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1444:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 237787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 237790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237798 */     GIR_RootConstrainSelectedInstOperands,
     /* 237799 */     // GIR_Coverage, 11768,
     /* 237799 */     GIR_EraseRootFromParent_Done,
     /* 237800 */   // Label 4770: @237800
     /* 237800 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(237842), // Rule ID 11769 //
     /* 237805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 237813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237829 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1444:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 237829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 237832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237840 */     GIR_RootConstrainSelectedInstOperands,
     /* 237841 */     // GIR_Coverage, 11769,
     /* 237841 */     GIR_EraseRootFromParent_Done,
     /* 237842 */   // Label 4771: @237842
     /* 237842 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(237884), // Rule ID 11774 //
     /* 237847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 237855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237871 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 237874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237882 */     GIR_RootConstrainSelectedInstOperands,
     /* 237883 */     // GIR_Coverage, 11774,
     /* 237883 */     GIR_EraseRootFromParent_Done,
     /* 237884 */   // Label 4772: @237884
     /* 237884 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(237926), // Rule ID 11775 //
     /* 237889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 237897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237913 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1452:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 237916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237924 */     GIR_RootConstrainSelectedInstOperands,
     /* 237925 */     // GIR_Coverage, 11775,
     /* 237925 */     GIR_EraseRootFromParent_Done,
     /* 237926 */   // Label 4773: @237926
     /* 237926 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(237968), // Rule ID 11776 //
     /* 237931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 237939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237955 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1457:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 237958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237966 */     GIR_RootConstrainSelectedInstOperands,
     /* 237967 */     // GIR_Coverage, 11776,
     /* 237967 */     GIR_EraseRootFromParent_Done,
     /* 237968 */   // Label 4774: @237968
     /* 237968 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(238010), // Rule ID 11777 //
     /* 237973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 237981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237997 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1459:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 238000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238008 */     GIR_RootConstrainSelectedInstOperands,
     /* 238009 */     // GIR_Coverage, 11777,
     /* 238009 */     GIR_EraseRootFromParent_Done,
     /* 238010 */   // Label 4775: @238010
     /* 238010 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(238052), // Rule ID 11778 //
     /* 238015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238039 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1257:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238050 */     GIR_RootConstrainSelectedInstOperands,
     /* 238051 */     // GIR_Coverage, 11778,
     /* 238051 */     GIR_EraseRootFromParent_Done,
     /* 238052 */   // Label 4776: @238052
     /* 238052 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(238094), // Rule ID 11780 //
     /* 238057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238081 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1257:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238092 */     GIR_RootConstrainSelectedInstOperands,
     /* 238093 */     // GIR_Coverage, 11780,
     /* 238093 */     GIR_EraseRootFromParent_Done,
     /* 238094 */   // Label 4777: @238094
     /* 238094 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(238136), // Rule ID 11782 //
     /* 238099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238123 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238134 */     GIR_RootConstrainSelectedInstOperands,
     /* 238135 */     // GIR_Coverage, 11782,
     /* 238135 */     GIR_EraseRootFromParent_Done,
     /* 238136 */   // Label 4778: @238136
     /* 238136 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(238178), // Rule ID 11784 //
     /* 238141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238165 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238176 */     GIR_RootConstrainSelectedInstOperands,
     /* 238177 */     // GIR_Coverage, 11784,
     /* 238177 */     GIR_EraseRootFromParent_Done,
     /* 238178 */   // Label 4779: @238178
     /* 238178 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(238220), // Rule ID 11786 //
     /* 238183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 238191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238207 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1286:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 238210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238218 */     GIR_RootConstrainSelectedInstOperands,
     /* 238219 */     // GIR_Coverage, 11786,
     /* 238219 */     GIR_EraseRootFromParent_Done,
     /* 238220 */   // Label 4780: @238220
     /* 238220 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(238262), // Rule ID 11788 //
     /* 238225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 238233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238249 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1286:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 238252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238260 */     GIR_RootConstrainSelectedInstOperands,
     /* 238261 */     // GIR_Coverage, 11788,
     /* 238261 */     GIR_EraseRootFromParent_Done,
     /* 238262 */   // Label 4781: @238262
     /* 238262 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(238304), // Rule ID 11790 //
     /* 238267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 238275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238291 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1286:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 238294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238302 */     GIR_RootConstrainSelectedInstOperands,
     /* 238303 */     // GIR_Coverage, 11790,
     /* 238303 */     GIR_EraseRootFromParent_Done,
     /* 238304 */   // Label 4782: @238304
     /* 238304 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(238346), // Rule ID 11792 //
     /* 238309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 238317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238333 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1286:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 238336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238344 */     GIR_RootConstrainSelectedInstOperands,
     /* 238345 */     // GIR_Coverage, 11792,
     /* 238345 */     GIR_EraseRootFromParent_Done,
     /* 238346 */   // Label 4783: @238346
     /* 238346 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(238388), // Rule ID 11794 //
     /* 238351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 238359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238375 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1287:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 238378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238386 */     GIR_RootConstrainSelectedInstOperands,
     /* 238387 */     // GIR_Coverage, 11794,
     /* 238387 */     GIR_EraseRootFromParent_Done,
     /* 238388 */   // Label 4784: @238388
     /* 238388 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(238430), // Rule ID 11795 //
     /* 238393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 238401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238417 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1287:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 238420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238428 */     GIR_RootConstrainSelectedInstOperands,
     /* 238429 */     // GIR_Coverage, 11795,
     /* 238429 */     GIR_EraseRootFromParent_Done,
     /* 238430 */   // Label 4785: @238430
     /* 238430 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(238472), // Rule ID 11796 //
     /* 238435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 238443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1287:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 238462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238470 */     GIR_RootConstrainSelectedInstOperands,
     /* 238471 */     // GIR_Coverage, 11796,
     /* 238471 */     GIR_EraseRootFromParent_Done,
     /* 238472 */   // Label 4786: @238472
     /* 238472 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(238514), // Rule ID 11797 //
     /* 238477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 238485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238501 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1287:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 238504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238512 */     GIR_RootConstrainSelectedInstOperands,
     /* 238513 */     // GIR_Coverage, 11797,
     /* 238513 */     GIR_EraseRootFromParent_Done,
     /* 238514 */   // Label 4787: @238514
     /* 238514 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(238556), // Rule ID 11798 //
     /* 238519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 238527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238543 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1288:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 238546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238554 */     GIR_RootConstrainSelectedInstOperands,
     /* 238555 */     // GIR_Coverage, 11798,
     /* 238555 */     GIR_EraseRootFromParent_Done,
     /* 238556 */   // Label 4788: @238556
     /* 238556 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(238598), // Rule ID 11799 //
     /* 238561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 238569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238585 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1288:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 238588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238596 */     GIR_RootConstrainSelectedInstOperands,
     /* 238597 */     // GIR_Coverage, 11799,
     /* 238597 */     GIR_EraseRootFromParent_Done,
     /* 238598 */   // Label 4789: @238598
     /* 238598 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(238640), // Rule ID 11800 //
     /* 238603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 238611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238627 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1288:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 238630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238638 */     GIR_RootConstrainSelectedInstOperands,
     /* 238639 */     // GIR_Coverage, 11800,
     /* 238639 */     GIR_EraseRootFromParent_Done,
     /* 238640 */   // Label 4790: @238640
     /* 238640 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(238682), // Rule ID 11801 //
     /* 238645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 238653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238669 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1288:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 238672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238680 */     GIR_RootConstrainSelectedInstOperands,
     /* 238681 */     // GIR_Coverage, 11801,
     /* 238681 */     GIR_EraseRootFromParent_Done,
     /* 238682 */   // Label 4791: @238682
     /* 238682 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(238724), // Rule ID 11802 //
     /* 238687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 238695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238711 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1598:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 238714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238722 */     GIR_RootConstrainSelectedInstOperands,
     /* 238723 */     // GIR_Coverage, 11802,
     /* 238723 */     GIR_EraseRootFromParent_Done,
     /* 238724 */   // Label 4792: @238724
     /* 238724 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(238766), // Rule ID 11804 //
     /* 238729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 238737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238753 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1598:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 238756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238764 */     GIR_RootConstrainSelectedInstOperands,
     /* 238765 */     // GIR_Coverage, 11804,
     /* 238765 */     GIR_EraseRootFromParent_Done,
     /* 238766 */   // Label 4793: @238766
     /* 238766 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(238808), // Rule ID 11806 //
     /* 238771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 238779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238795 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1598:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 238798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238806 */     GIR_RootConstrainSelectedInstOperands,
     /* 238807 */     // GIR_Coverage, 11806,
     /* 238807 */     GIR_EraseRootFromParent_Done,
     /* 238808 */   // Label 4794: @238808
     /* 238808 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(238850), // Rule ID 11808 //
     /* 238813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 238821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238837 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1598:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 238840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238848 */     GIR_RootConstrainSelectedInstOperands,
     /* 238849 */     // GIR_Coverage, 11808,
     /* 238849 */     GIR_EraseRootFromParent_Done,
     /* 238850 */   // Label 4795: @238850
     /* 238850 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(238892), // Rule ID 11897 //
     /* 238855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 238858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 238863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238879 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1929:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 238882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238890 */     GIR_RootConstrainSelectedInstOperands,
     /* 238891 */     // GIR_Coverage, 11897,
     /* 238891 */     GIR_EraseRootFromParent_Done,
     /* 238892 */   // Label 4796: @238892
     /* 238892 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(238934), // Rule ID 11899 //
     /* 238897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 238900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 238905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1929:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 238924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238932 */     GIR_RootConstrainSelectedInstOperands,
     /* 238933 */     // GIR_Coverage, 11899,
     /* 238933 */     GIR_EraseRootFromParent_Done,
     /* 238934 */   // Label 4797: @238934
     /* 238934 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(238976), // Rule ID 11901 //
     /* 238939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 238942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 238947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238963 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1929:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 238966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238974 */     GIR_RootConstrainSelectedInstOperands,
     /* 238975 */     // GIR_Coverage, 11901,
     /* 238975 */     GIR_EraseRootFromParent_Done,
     /* 238976 */   // Label 4798: @238976
     /* 238976 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(239018), // Rule ID 11903 //
     /* 238981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 238984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 238989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239005 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1929:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 239008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239016 */     GIR_RootConstrainSelectedInstOperands,
     /* 239017 */     // GIR_Coverage, 11903,
     /* 239017 */     GIR_EraseRootFromParent_Done,
     /* 239018 */   // Label 4799: @239018
     /* 239018 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(239060), // Rule ID 11905 //
     /* 239023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 239031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239047 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1407:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 239050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239058 */     GIR_RootConstrainSelectedInstOperands,
     /* 239059 */     // GIR_Coverage, 11905,
     /* 239059 */     GIR_EraseRootFromParent_Done,
     /* 239060 */   // Label 4800: @239060
     /* 239060 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(239102), // Rule ID 11907 //
     /* 239065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 239073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239089 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 239092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239100 */     GIR_RootConstrainSelectedInstOperands,
     /* 239101 */     // GIR_Coverage, 11907,
     /* 239101 */     GIR_EraseRootFromParent_Done,
     /* 239102 */   // Label 4801: @239102
     /* 239102 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(239144), // Rule ID 12070 //
     /* 239107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239131 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1905:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 239134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239142 */     GIR_RootConstrainSelectedInstOperands,
     /* 239143 */     // GIR_Coverage, 12070,
     /* 239143 */     GIR_EraseRootFromParent_Done,
     /* 239144 */   // Label 4802: @239144
     /* 239144 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(239186), // Rule ID 12071 //
     /* 239149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239173 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1905:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 239176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239184 */     GIR_RootConstrainSelectedInstOperands,
     /* 239185 */     // GIR_Coverage, 12071,
     /* 239185 */     GIR_EraseRootFromParent_Done,
     /* 239186 */   // Label 4803: @239186
     /* 239186 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(239228), // Rule ID 12072 //
     /* 239191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239215 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1905:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 239218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239226 */     GIR_RootConstrainSelectedInstOperands,
     /* 239227 */     // GIR_Coverage, 12072,
     /* 239227 */     GIR_EraseRootFromParent_Done,
     /* 239228 */   // Label 4804: @239228
     /* 239228 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(239270), // Rule ID 12073 //
     /* 239233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239257 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1905:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 239260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239268 */     GIR_RootConstrainSelectedInstOperands,
     /* 239269 */     // GIR_Coverage, 12073,
     /* 239269 */     GIR_EraseRootFromParent_Done,
     /* 239270 */   // Label 4805: @239270
     /* 239270 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(239312), // Rule ID 12074 //
     /* 239275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239299 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1905:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 239302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239310 */     GIR_RootConstrainSelectedInstOperands,
     /* 239311 */     // GIR_Coverage, 12074,
     /* 239311 */     GIR_EraseRootFromParent_Done,
     /* 239312 */   // Label 4806: @239312
     /* 239312 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(239354), // Rule ID 12075 //
     /* 239317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239341 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1905:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 239344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239352 */     GIR_RootConstrainSelectedInstOperands,
     /* 239353 */     // GIR_Coverage, 12075,
     /* 239353 */     GIR_EraseRootFromParent_Done,
     /* 239354 */   // Label 4807: @239354
     /* 239354 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(239396), // Rule ID 12076 //
     /* 239359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239383 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1905:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 239386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239394 */     GIR_RootConstrainSelectedInstOperands,
     /* 239395 */     // GIR_Coverage, 12076,
     /* 239395 */     GIR_EraseRootFromParent_Done,
     /* 239396 */   // Label 4808: @239396
     /* 239396 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(239438), // Rule ID 12421 //
     /* 239401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 239409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239425 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1357:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 239428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239436 */     GIR_RootConstrainSelectedInstOperands,
     /* 239437 */     // GIR_Coverage, 12421,
     /* 239437 */     GIR_EraseRootFromParent_Done,
     /* 239438 */   // Label 4809: @239438
     /* 239438 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(239480), // Rule ID 12422 //
     /* 239443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 239451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239467 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1357:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 239470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239478 */     GIR_RootConstrainSelectedInstOperands,
     /* 239479 */     // GIR_Coverage, 12422,
     /* 239479 */     GIR_EraseRootFromParent_Done,
     /* 239480 */   // Label 4810: @239480
     /* 239480 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(239522), // Rule ID 12423 //
     /* 239485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 239493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239509 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1357:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 239512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239520 */     GIR_RootConstrainSelectedInstOperands,
     /* 239521 */     // GIR_Coverage, 12423,
     /* 239521 */     GIR_EraseRootFromParent_Done,
     /* 239522 */   // Label 4811: @239522
     /* 239522 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(239564), // Rule ID 12424 //
     /* 239527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 239535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239551 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 239554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239562 */     GIR_RootConstrainSelectedInstOperands,
     /* 239563 */     // GIR_Coverage, 12424,
     /* 239563 */     GIR_EraseRootFromParent_Done,
     /* 239564 */   // Label 4812: @239564
     /* 239564 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(239606), // Rule ID 12425 //
     /* 239569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 239577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239593 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 239596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239604 */     GIR_RootConstrainSelectedInstOperands,
     /* 239605 */     // GIR_Coverage, 12425,
     /* 239605 */     GIR_EraseRootFromParent_Done,
     /* 239606 */   // Label 4813: @239606
     /* 239606 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(239648), // Rule ID 12426 //
     /* 239611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 239619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239635 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 239638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239646 */     GIR_RootConstrainSelectedInstOperands,
     /* 239647 */     // GIR_Coverage, 12426,
     /* 239647 */     GIR_EraseRootFromParent_Done,
     /* 239648 */   // Label 4814: @239648
     /* 239648 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(239690), // Rule ID 12427 //
     /* 239653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 239661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239677 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1356:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 239680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239688 */     GIR_RootConstrainSelectedInstOperands,
     /* 239689 */     // GIR_Coverage, 12427,
     /* 239689 */     GIR_EraseRootFromParent_Done,
     /* 239690 */   // Label 4815: @239690
     /* 239690 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(239732), // Rule ID 12430 //
     /* 239695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 239703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 239706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 239712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 239715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239719 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1356:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 239719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 239722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239730 */     GIR_RootConstrainSelectedInstOperands,
     /* 239731 */     // GIR_Coverage, 12430,
     /* 239731 */     GIR_EraseRootFromParent_Done,
     /* 239732 */   // Label 4816: @239732
     /* 239732 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(239774), // Rule ID 12433 //
     /* 239737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 239745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 239748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 239754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 239757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239761 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1356:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 239761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 239764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239772 */     GIR_RootConstrainSelectedInstOperands,
     /* 239773 */     // GIR_Coverage, 12433,
     /* 239773 */     GIR_EraseRootFromParent_Done,
     /* 239774 */   // Label 4817: @239774
     /* 239774 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(239816), // Rule ID 12436 //
     /* 239779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 239787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239803 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1356:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 239806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239814 */     GIR_RootConstrainSelectedInstOperands,
     /* 239815 */     // GIR_Coverage, 12436,
     /* 239815 */     GIR_EraseRootFromParent_Done,
     /* 239816 */   // Label 4818: @239816
     /* 239816 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(239858), // Rule ID 12439 //
     /* 239821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 239829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 239832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 239838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 239841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239845 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1356:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 239845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 239848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239856 */     GIR_RootConstrainSelectedInstOperands,
     /* 239857 */     // GIR_Coverage, 12439,
     /* 239857 */     GIR_EraseRootFromParent_Done,
     /* 239858 */   // Label 4819: @239858
     /* 239858 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(239900), // Rule ID 12442 //
     /* 239863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 239871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239887 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1356:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 239890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239898 */     GIR_RootConstrainSelectedInstOperands,
     /* 239899 */     // GIR_Coverage, 12442,
     /* 239899 */     GIR_EraseRootFromParent_Done,
     /* 239900 */   // Label 4820: @239900
     /* 239900 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(239942), // Rule ID 12445 //
     /* 239905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 239913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239929 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1358:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 239932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239940 */     GIR_RootConstrainSelectedInstOperands,
     /* 239941 */     // GIR_Coverage, 12445,
     /* 239941 */     GIR_EraseRootFromParent_Done,
     /* 239942 */   // Label 4821: @239942
     /* 239942 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(239984), // Rule ID 12448 //
     /* 239947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 239955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 239958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 239964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 239967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239971 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1358:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 239971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 239974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239982 */     GIR_RootConstrainSelectedInstOperands,
     /* 239983 */     // GIR_Coverage, 12448,
     /* 239983 */     GIR_EraseRootFromParent_Done,
     /* 239984 */   // Label 4822: @239984
     /* 239984 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(240026), // Rule ID 12451 //
     /* 239989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 239992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 239997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 240000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 240006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 240009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240013 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 240013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 240016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240024 */     GIR_RootConstrainSelectedInstOperands,
     /* 240025 */     // GIR_Coverage, 12451,
     /* 240025 */     GIR_EraseRootFromParent_Done,
     /* 240026 */   // Label 4823: @240026
     /* 240026 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(240068), // Rule ID 12454 //
     /* 240031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240055 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1358:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 240058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240066 */     GIR_RootConstrainSelectedInstOperands,
     /* 240067 */     // GIR_Coverage, 12454,
     /* 240067 */     GIR_EraseRootFromParent_Done,
     /* 240068 */   // Label 4824: @240068
     /* 240068 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(240110), // Rule ID 12457 //
     /* 240073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 240084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 240090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 240093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240097 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 240097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 240100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240108 */     GIR_RootConstrainSelectedInstOperands,
     /* 240109 */     // GIR_Coverage, 12457,
     /* 240109 */     GIR_EraseRootFromParent_Done,
     /* 240110 */   // Label 4825: @240110
     /* 240110 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(240152), // Rule ID 12460 //
     /* 240115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240139 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 240142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240150 */     GIR_RootConstrainSelectedInstOperands,
     /* 240151 */     // GIR_Coverage, 12460,
     /* 240151 */     GIR_EraseRootFromParent_Done,
     /* 240152 */   // Label 4826: @240152
     /* 240152 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(240295), // Rule ID 5563 //
     /* 240157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 240160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 240165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 240168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 240171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 240174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240178 */     // MIs[0] idx
     /* 240178 */     // No operand predicates
     /* 240178 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 240178 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 240181 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240185 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 240192 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 240195 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240199 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240204 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 240207 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 240211 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 240214 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240219 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240224 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 240229 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 240232 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240236 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 240243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 240246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 240258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 240262 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 240265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 240280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 240283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 240285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 240288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 240291 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 240293 */     GIR_RootConstrainSelectedInstOperands,
     /* 240294 */     // GIR_Coverage, 5563,
     /* 240294 */     GIR_EraseRootFromParent_Done,
     /* 240295 */   // Label 4827: @240295
     /* 240295 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(240386), // Rule ID 5564 //
     /* 240300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 240303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 240308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 240311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 240314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 240317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240321 */     // MIs[0] idx
     /* 240321 */     // No operand predicates
     /* 240321 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 240321 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 240324 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240328 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 240335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 240338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 240350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 240354 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 240357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 240372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 240375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 240377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 240380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 240382 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 240384 */     GIR_RootConstrainSelectedInstOperands,
     /* 240385 */     // GIR_Coverage, 5564,
     /* 240385 */     GIR_EraseRootFromParent_Done,
     /* 240386 */   // Label 4828: @240386
     /* 240386 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(240477), // Rule ID 5565 //
     /* 240391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 240394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 240399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 240402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 240405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 240408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240412 */     // MIs[0] idx
     /* 240412 */     // No operand predicates
     /* 240412 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 240412 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 240415 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240419 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 240426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 240429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240438 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 240441 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 240445 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 240448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 240463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 240466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 240468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 240470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 240473 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 240475 */     GIR_RootConstrainSelectedInstOperands,
     /* 240476 */     // GIR_Coverage, 5565,
     /* 240476 */     GIR_EraseRootFromParent_Done,
     /* 240477 */   // Label 4829: @240477
     /* 240477 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(240516), // Rule ID 5566 //
     /* 240482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 240485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 240490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 240493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 240496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 240499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240503 */     // MIs[0] idx
     /* 240503 */     // No operand predicates
     /* 240503 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 240503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 240506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 240508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 240510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 240512 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 240514 */     GIR_RootConstrainSelectedInstOperands,
     /* 240515 */     // GIR_Coverage, 5566,
     /* 240515 */     GIR_EraseRootFromParent_Done,
     /* 240516 */   // Label 4830: @240516
     /* 240516 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(240659), // Rule ID 5567 //
     /* 240521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 240524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 240529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 240532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 240535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 240538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240542 */     // MIs[0] idx
     /* 240542 */     // No operand predicates
     /* 240542 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 240542 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 240545 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240549 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 240556 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 240559 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240563 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240568 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 240571 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 240575 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 240578 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240583 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240588 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 240593 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 240596 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240600 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 240607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 240610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240619 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 240622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 240626 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 240629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 240644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 240647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 240649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 240652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 240655 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 240657 */     GIR_RootConstrainSelectedInstOperands,
     /* 240658 */     // GIR_Coverage, 5567,
     /* 240658 */     GIR_EraseRootFromParent_Done,
     /* 240659 */   // Label 4831: @240659
     /* 240659 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(240750), // Rule ID 5568 //
     /* 240664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 240667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 240672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 240675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 240678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 240681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240685 */     // MIs[0] idx
     /* 240685 */     // No operand predicates
     /* 240685 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 240685 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 240688 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240692 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 240699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 240702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240711 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 240714 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 240718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 240721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 240736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 240739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 240741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 240744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 240746 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 240748 */     GIR_RootConstrainSelectedInstOperands,
     /* 240749 */     // GIR_Coverage, 5568,
     /* 240749 */     GIR_EraseRootFromParent_Done,
     /* 240750 */   // Label 4832: @240750
     /* 240750 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(240841), // Rule ID 5569 //
     /* 240755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 240758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 240763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 240766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 240769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 240772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240776 */     // MIs[0] idx
     /* 240776 */     // No operand predicates
     /* 240776 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 240776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 240779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 240790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 240793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240802 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 240805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 240809 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 240812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 240827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 240830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 240832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 240834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 240837 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 240839 */     GIR_RootConstrainSelectedInstOperands,
     /* 240840 */     // GIR_Coverage, 5569,
     /* 240840 */     GIR_EraseRootFromParent_Done,
     /* 240841 */   // Label 4833: @240841
     /* 240841 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(240880), // Rule ID 5570 //
     /* 240846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 240849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 240854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 240857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 240860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 240863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240867 */     // MIs[0] idx
     /* 240867 */     // No operand predicates
     /* 240867 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 240867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 240870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 240872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 240874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 240876 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 240878 */     GIR_RootConstrainSelectedInstOperands,
     /* 240879 */     // GIR_Coverage, 5570,
     /* 240879 */     GIR_EraseRootFromParent_Done,
     /* 240880 */   // Label 4834: @240880
     /* 240880 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(241023), // Rule ID 5571 //
     /* 240885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 240888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 240893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 240896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 240899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 240902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240906 */     // MIs[0] idx
     /* 240906 */     // No operand predicates
     /* 240906 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 240906 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 240909 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240913 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 240920 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 240923 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240927 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240932 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 240935 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 240939 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 240942 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240947 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240952 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 240957 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 240960 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240964 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 240971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 240974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240983 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 240986 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 240990 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 240993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 241019 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241021 */     GIR_RootConstrainSelectedInstOperands,
     /* 241022 */     // GIR_Coverage, 5571,
     /* 241022 */     GIR_EraseRootFromParent_Done,
     /* 241023 */   // Label 4835: @241023
     /* 241023 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(241114), // Rule ID 5572 //
     /* 241028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241049 */     // MIs[0] idx
     /* 241049 */     // No operand predicates
     /* 241049 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241049 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241052 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241056 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241075 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241078 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241082 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241110 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241112 */     GIR_RootConstrainSelectedInstOperands,
     /* 241113 */     // GIR_Coverage, 5572,
     /* 241113 */     GIR_EraseRootFromParent_Done,
     /* 241114 */   // Label 4836: @241114
     /* 241114 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(241205), // Rule ID 5573 //
     /* 241119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241140 */     // MIs[0] idx
     /* 241140 */     // No operand predicates
     /* 241140 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241140 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241143 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241147 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241166 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241169 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241173 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241201 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241203 */     GIR_RootConstrainSelectedInstOperands,
     /* 241204 */     // GIR_Coverage, 5573,
     /* 241204 */     GIR_EraseRootFromParent_Done,
     /* 241205 */   // Label 4837: @241205
     /* 241205 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(241244), // Rule ID 5574 //
     /* 241210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241231 */     // MIs[0] idx
     /* 241231 */     // No operand predicates
     /* 241231 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241240 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241242 */     GIR_RootConstrainSelectedInstOperands,
     /* 241243 */     // GIR_Coverage, 5574,
     /* 241243 */     GIR_EraseRootFromParent_Done,
     /* 241244 */   // Label 4838: @241244
     /* 241244 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(241283), // Rule ID 5575 //
     /* 241249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 241257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 241263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241270 */     // MIs[0] idx
     /* 241270 */     // No operand predicates
     /* 241270 */     // (intrinsic_wo_chain:{ *:[v16i8] } 772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 241270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 241273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241279 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241281 */     GIR_RootConstrainSelectedInstOperands,
     /* 241282 */     // GIR_Coverage, 5575,
     /* 241282 */     GIR_EraseRootFromParent_Done,
     /* 241283 */   // Label 4839: @241283
     /* 241283 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(241374), // Rule ID 5576 //
     /* 241288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 241296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 241302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241309 */     // MIs[0] idx
     /* 241309 */     // No operand predicates
     /* 241309 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 241309 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241312 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241316 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241335 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241342 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 241363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241370 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241372 */     GIR_RootConstrainSelectedInstOperands,
     /* 241373 */     // GIR_Coverage, 5576,
     /* 241373 */     GIR_EraseRootFromParent_Done,
     /* 241374 */   // Label 4840: @241374
     /* 241374 */   GIM_Reject,
     /* 241375 */ // Label 3964: @241375
     /* 241375 */ GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(248486),
     /* 241380 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 241383 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(241430), // Rule ID 2956 //
     /* 241388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 241396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 241411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241415 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1589:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 241415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 241418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241426 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241428 */     GIR_RootConstrainSelectedInstOperands,
     /* 241429 */     // GIR_Coverage, 2956,
     /* 241429 */     GIR_EraseRootFromParent_Done,
     /* 241430 */   // Label 4842: @241430
     /* 241430 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(241477), // Rule ID 2958 //
     /* 241435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 241443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241462 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1589:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 241462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 241465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241471 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241473 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241475 */     GIR_RootConstrainSelectedInstOperands,
     /* 241476 */     // GIR_Coverage, 2958,
     /* 241476 */     GIR_EraseRootFromParent_Done,
     /* 241477 */   // Label 4843: @241477
     /* 241477 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(241524), // Rule ID 2960 //
     /* 241482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 241490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 241505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241509 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1589:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 241509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 241512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241520 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241522 */     GIR_RootConstrainSelectedInstOperands,
     /* 241523 */     // GIR_Coverage, 2960,
     /* 241523 */     GIR_EraseRootFromParent_Done,
     /* 241524 */   // Label 4844: @241524
     /* 241524 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(241571), // Rule ID 2962 //
     /* 241529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 241537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1589:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 241556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 241559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241567 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241569 */     GIR_RootConstrainSelectedInstOperands,
     /* 241570 */     // GIR_Coverage, 2962,
     /* 241570 */     GIR_EraseRootFromParent_Done,
     /* 241571 */   // Label 4845: @241571
     /* 241571 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(241618), // Rule ID 7519 //
     /* 241576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 241584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 241599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241603 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1592:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 241603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 241606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241614 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241616 */     GIR_RootConstrainSelectedInstOperands,
     /* 241617 */     // GIR_Coverage, 7519,
     /* 241617 */     GIR_EraseRootFromParent_Done,
     /* 241618 */   // Label 4846: @241618
     /* 241618 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(241665), // Rule ID 7521 //
     /* 241623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 241631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 241646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241650 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1592:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 241650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 241653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241661 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241663 */     GIR_RootConstrainSelectedInstOperands,
     /* 241664 */     // GIR_Coverage, 7521,
     /* 241664 */     GIR_EraseRootFromParent_Done,
     /* 241665 */   // Label 4847: @241665
     /* 241665 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(241712), // Rule ID 7523 //
     /* 241670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 241678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 241693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241697 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1592:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 241697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 241700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241708 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241710 */     GIR_RootConstrainSelectedInstOperands,
     /* 241711 */     // GIR_Coverage, 7523,
     /* 241711 */     GIR_EraseRootFromParent_Done,
     /* 241712 */   // Label 4848: @241712
     /* 241712 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(241759), // Rule ID 7525 //
     /* 241717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 241725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 241740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1592:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 241744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 241747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241755 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 241757 */     GIR_RootConstrainSelectedInstOperands,
     /* 241758 */     // GIR_Coverage, 7525,
     /* 241758 */     GIR_EraseRootFromParent_Done,
     /* 241759 */   // Label 4849: @241759
     /* 241759 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(241839), // Rule ID 5683 //
     /* 241764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 241769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 241775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 241778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 241781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 241784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 241796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 241800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 241804 */     // MIs[1] Operand 1
     /* 241804 */     // No operand predicates
     /* 241804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 241812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 241816 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 241820 */     // MIs[2] Operand 1
     /* 241820 */     // No operand predicates
     /* 241820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 241822 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 241822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 241825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 241827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 241829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 241832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 241834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 241837 */     GIR_RootConstrainSelectedInstOperands,
     /* 241838 */     // GIR_Coverage, 5683,
     /* 241838 */     GIR_EraseRootFromParent_Done,
     /* 241839 */   // Label 4850: @241839
     /* 241839 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(241919), // Rule ID 5684 //
     /* 241844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 241849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 241858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 241861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 241864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 241876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 241880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 241884 */     // MIs[1] Operand 1
     /* 241884 */     // No operand predicates
     /* 241884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 241892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 241896 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 241900 */     // MIs[2] Operand 1
     /* 241900 */     // No operand predicates
     /* 241900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 241902 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 241902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 241905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 241907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 241909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 241912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 241914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 241917 */     GIR_RootConstrainSelectedInstOperands,
     /* 241918 */     // GIR_Coverage, 5684,
     /* 241918 */     GIR_EraseRootFromParent_Done,
     /* 241919 */   // Label 4851: @241919
     /* 241919 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(241999), // Rule ID 5685 //
     /* 241924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 241929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 241932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 241935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 241938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 241941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 241944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 241956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 241960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 241964 */     // MIs[1] Operand 1
     /* 241964 */     // No operand predicates
     /* 241964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 241972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 241976 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 241980 */     // MIs[2] Operand 1
     /* 241980 */     // No operand predicates
     /* 241980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 241982 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 241982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 241985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 241987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 241989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 241992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 241994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 241997 */     GIR_RootConstrainSelectedInstOperands,
     /* 241998 */     // GIR_Coverage, 5685,
     /* 241998 */     GIR_EraseRootFromParent_Done,
     /* 241999 */   // Label 4852: @241999
     /* 241999 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(242079), // Rule ID 5686 //
     /* 242004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 242009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 242012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 242015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 242018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 242021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 242024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 242036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 242044 */     // MIs[1] Operand 1
     /* 242044 */     // No operand predicates
     /* 242044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 242052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 242060 */     // MIs[2] Operand 1
     /* 242060 */     // No operand predicates
     /* 242060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 242062 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 242062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 242065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 242067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 242072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 242074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 242077 */     GIR_RootConstrainSelectedInstOperands,
     /* 242078 */     // GIR_Coverage, 5686,
     /* 242078 */     GIR_EraseRootFromParent_Done,
     /* 242079 */   // Label 4853: @242079
     /* 242079 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(242143), // Rule ID 3830 //
     /* 242084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 242087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 242092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 242101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242120 */     // MIs[0] imm
     /* 242120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 242128 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 242128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 242131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 242133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 242137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 242139 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 242141 */     GIR_RootConstrainSelectedInstOperands,
     /* 242142 */     // GIR_Coverage, 3830,
     /* 242142 */     GIR_EraseRootFromParent_Done,
     /* 242143 */   // Label 4854: @242143
     /* 242143 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(242207), // Rule ID 3831 //
     /* 242148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 242151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 242156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 242165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242184 */     // MIs[0] imm
     /* 242184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242187 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 242192 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 242192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 242195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 242197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 242201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 242203 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 242205 */     GIR_RootConstrainSelectedInstOperands,
     /* 242206 */     // GIR_Coverage, 3831,
     /* 242206 */     GIR_EraseRootFromParent_Done,
     /* 242207 */   // Label 4855: @242207
     /* 242207 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(242271), // Rule ID 3832 //
     /* 242212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 242215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 242220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 242229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242248 */     // MIs[0] imm
     /* 242248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 242256 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 242256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 242259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 242261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 242265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 242267 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 242269 */     GIR_RootConstrainSelectedInstOperands,
     /* 242270 */     // GIR_Coverage, 3832,
     /* 242270 */     GIR_EraseRootFromParent_Done,
     /* 242271 */   // Label 4856: @242271
     /* 242271 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(242335), // Rule ID 3833 //
     /* 242276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 242279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 242284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 242293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242312 */     // MIs[0] imm
     /* 242312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 242320 */     // (intrinsic_wo_chain:{ *:[v4i32] } 540:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 242320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 242323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 242325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 242329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 242331 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 242333 */     GIR_RootConstrainSelectedInstOperands,
     /* 242334 */     // GIR_Coverage, 3833,
     /* 242334 */     GIR_EraseRootFromParent_Done,
     /* 242335 */   // Label 4857: @242335
     /* 242335 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(242387), // Rule ID 2841 //
     /* 242340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 242348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 242354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242364 */     // MIs[0] idx
     /* 242364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242367 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 242372 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1448:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 242372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 242375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242381 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242383 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 242385 */     GIR_RootConstrainSelectedInstOperands,
     /* 242386 */     // GIR_Coverage, 2841,
     /* 242386 */     GIR_EraseRootFromParent_Done,
     /* 242387 */   // Label 4858: @242387
     /* 242387 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(242439), // Rule ID 2842 //
     /* 242392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 242400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242416 */     // MIs[0] idx
     /* 242416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 242424 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1448:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 242427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242435 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 242437 */     GIR_RootConstrainSelectedInstOperands,
     /* 242438 */     // GIR_Coverage, 2842,
     /* 242438 */     GIR_EraseRootFromParent_Done,
     /* 242439 */   // Label 4859: @242439
     /* 242439 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(242491), // Rule ID 2843 //
     /* 242444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 242452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 242458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242468 */     // MIs[0] idx
     /* 242468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 242476 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1448:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 242476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 242479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242487 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 242489 */     GIR_RootConstrainSelectedInstOperands,
     /* 242490 */     // GIR_Coverage, 2843,
     /* 242490 */     GIR_EraseRootFromParent_Done,
     /* 242491 */   // Label 4860: @242491
     /* 242491 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(242543), // Rule ID 2971 //
     /* 242496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 242499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 242504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 242510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242520 */     // MIs[0] Op4
     /* 242520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242523 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 242528 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1588:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 242528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 242531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242539 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242541 */     GIR_RootConstrainSelectedInstOperands,
     /* 242542 */     // GIR_Coverage, 2971,
     /* 242542 */     GIR_EraseRootFromParent_Done,
     /* 242543 */   // Label 4861: @242543
     /* 242543 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(242595), // Rule ID 2972 //
     /* 242548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 242551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 242556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242572 */     // MIs[0] Op4
     /* 242572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 242580 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1588:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 242580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 242583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242591 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242593 */     GIR_RootConstrainSelectedInstOperands,
     /* 242594 */     // GIR_Coverage, 2972,
     /* 242594 */     GIR_EraseRootFromParent_Done,
     /* 242595 */   // Label 4862: @242595
     /* 242595 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(242647), // Rule ID 2973 //
     /* 242600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 242603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 242608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 242614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242624 */     // MIs[0] Op4
     /* 242624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 242632 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1588:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 242632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 242635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242641 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242643 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242645 */     GIR_RootConstrainSelectedInstOperands,
     /* 242646 */     // GIR_Coverage, 2973,
     /* 242646 */     GIR_EraseRootFromParent_Done,
     /* 242647 */   // Label 4863: @242647
     /* 242647 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(242699), // Rule ID 2974 //
     /* 242652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 242655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 242660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242676 */     // MIs[0] Op4
     /* 242676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 242684 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1730:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 242684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 242687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242695 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242697 */     GIR_RootConstrainSelectedInstOperands,
     /* 242698 */     // GIR_Coverage, 2974,
     /* 242698 */     GIR_EraseRootFromParent_Done,
     /* 242699 */   // Label 4864: @242699
     /* 242699 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(242751), // Rule ID 2975 //
     /* 242704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 242707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 242712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 242718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242728 */     // MIs[0] Op4
     /* 242728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 242736 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1730:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 242736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 242739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242747 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242749 */     GIR_RootConstrainSelectedInstOperands,
     /* 242750 */     // GIR_Coverage, 2975,
     /* 242750 */     GIR_EraseRootFromParent_Done,
     /* 242751 */   // Label 4865: @242751
     /* 242751 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(242803), // Rule ID 2978 //
     /* 242756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 242764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242780 */     // MIs[0] Op4
     /* 242780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 242788 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 242788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 242791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242799 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242801 */     GIR_RootConstrainSelectedInstOperands,
     /* 242802 */     // GIR_Coverage, 2978,
     /* 242802 */     GIR_EraseRootFromParent_Done,
     /* 242803 */   // Label 4866: @242803
     /* 242803 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(242855), // Rule ID 2979 //
     /* 242808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 242816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 242822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242832 */     // MIs[0] Op4
     /* 242832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 242840 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 242840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 242843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242851 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242853 */     GIR_RootConstrainSelectedInstOperands,
     /* 242854 */     // GIR_Coverage, 2979,
     /* 242854 */     GIR_EraseRootFromParent_Done,
     /* 242855 */   // Label 4867: @242855
     /* 242855 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(242907), // Rule ID 3453 //
     /* 242860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 242863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 242868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242884 */     // MIs[0] Op4
     /* 242884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242887 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 242892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2043:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 242892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 242895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242903 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242905 */     GIR_RootConstrainSelectedInstOperands,
     /* 242906 */     // GIR_Coverage, 3453,
     /* 242906 */     GIR_EraseRootFromParent_Done,
     /* 242907 */   // Label 4868: @242907
     /* 242907 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(242959), // Rule ID 3497 //
     /* 242912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 242915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 242920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242936 */     // MIs[0] Op4
     /* 242936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 242944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1697:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 242944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 242947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242955 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242957 */     GIR_RootConstrainSelectedInstOperands,
     /* 242958 */     // GIR_Coverage, 3497,
     /* 242958 */     GIR_EraseRootFromParent_Done,
     /* 242959 */   // Label 4869: @242959
     /* 242959 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(243011), // Rule ID 7589 //
     /* 242964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 242972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242988 */     // MIs[0] Op4
     /* 242988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242991 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 242996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 242996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 242999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243007 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243009 */     GIR_RootConstrainSelectedInstOperands,
     /* 243010 */     // GIR_Coverage, 7589,
     /* 243010 */     GIR_EraseRootFromParent_Done,
     /* 243011 */   // Label 4870: @243011
     /* 243011 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(243063), // Rule ID 7590 //
     /* 243016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 243024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243040 */     // MIs[0] Op4
     /* 243040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243048 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 243048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 243051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243059 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243061 */     GIR_RootConstrainSelectedInstOperands,
     /* 243062 */     // GIR_Coverage, 7590,
     /* 243062 */     GIR_EraseRootFromParent_Done,
     /* 243063 */   // Label 4871: @243063
     /* 243063 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(243115), // Rule ID 8230 //
     /* 243068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 243076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243092 */     // MIs[0] idx
     /* 243092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243100 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1455:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 243100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 243103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243111 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243113 */     GIR_RootConstrainSelectedInstOperands,
     /* 243114 */     // GIR_Coverage, 8230,
     /* 243114 */     GIR_EraseRootFromParent_Done,
     /* 243115 */   // Label 4872: @243115
     /* 243115 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(243167), // Rule ID 8231 //
     /* 243120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 243128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243144 */     // MIs[0] idx
     /* 243144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243152 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1455:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 243155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243163 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243165 */     GIR_RootConstrainSelectedInstOperands,
     /* 243166 */     // GIR_Coverage, 8231,
     /* 243166 */     GIR_EraseRootFromParent_Done,
     /* 243167 */   // Label 4873: @243167
     /* 243167 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(243219), // Rule ID 8232 //
     /* 243172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 243180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243196 */     // MIs[0] idx
     /* 243196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243199 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243204 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1455:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 243204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 243207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243213 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243215 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243217 */     GIR_RootConstrainSelectedInstOperands,
     /* 243218 */     // GIR_Coverage, 8232,
     /* 243218 */     GIR_EraseRootFromParent_Done,
     /* 243219 */   // Label 4874: @243219
     /* 243219 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(243271), // Rule ID 11176 //
     /* 243224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 243227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 243232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243248 */     // MIs[0] Op4
     /* 243248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243256 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1892:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 243259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243267 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243269 */     GIR_RootConstrainSelectedInstOperands,
     /* 243270 */     // GIR_Coverage, 11176,
     /* 243270 */     GIR_EraseRootFromParent_Done,
     /* 243271 */   // Label 4875: @243271
     /* 243271 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(243323), // Rule ID 11223 //
     /* 243276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 243284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243300 */     // MIs[0] Op4
     /* 243300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1591:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 243308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 243311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243319 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243321 */     GIR_RootConstrainSelectedInstOperands,
     /* 243322 */     // GIR_Coverage, 11223,
     /* 243322 */     GIR_EraseRootFromParent_Done,
     /* 243323 */   // Label 4876: @243323
     /* 243323 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(243375), // Rule ID 11224 //
     /* 243328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 243336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243352 */     // MIs[0] Op4
     /* 243352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243360 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1591:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 243363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243371 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243373 */     GIR_RootConstrainSelectedInstOperands,
     /* 243374 */     // GIR_Coverage, 11224,
     /* 243374 */     GIR_EraseRootFromParent_Done,
     /* 243375 */   // Label 4877: @243375
     /* 243375 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(243427), // Rule ID 11225 //
     /* 243380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 243388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243404 */     // MIs[0] Op4
     /* 243404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243412 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1591:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 243412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 243415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243423 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243425 */     GIR_RootConstrainSelectedInstOperands,
     /* 243426 */     // GIR_Coverage, 11225,
     /* 243426 */     GIR_EraseRootFromParent_Done,
     /* 243427 */   // Label 4878: @243427
     /* 243427 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(243479), // Rule ID 11226 //
     /* 243432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 243440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243456 */     // MIs[0] Op4
     /* 243456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1809:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 243464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 243467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243475 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243477 */     GIR_RootConstrainSelectedInstOperands,
     /* 243478 */     // GIR_Coverage, 11226,
     /* 243478 */     GIR_EraseRootFromParent_Done,
     /* 243479 */   // Label 4879: @243479
     /* 243479 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(243531), // Rule ID 11227 //
     /* 243484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 243492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243508 */     // MIs[0] Op4
     /* 243508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243516 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1809:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 243519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243527 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243529 */     GIR_RootConstrainSelectedInstOperands,
     /* 243530 */     // GIR_Coverage, 11227,
     /* 243530 */     GIR_EraseRootFromParent_Done,
     /* 243531 */   // Label 4880: @243531
     /* 243531 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(243583), // Rule ID 11228 //
     /* 243536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 243544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243560 */     // MIs[0] Op4
     /* 243560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243568 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1809:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 243568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 243571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243579 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243581 */     GIR_RootConstrainSelectedInstOperands,
     /* 243582 */     // GIR_Coverage, 11228,
     /* 243582 */     GIR_EraseRootFromParent_Done,
     /* 243583 */   // Label 4881: @243583
     /* 243583 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(243635), // Rule ID 11229 //
     /* 243588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 243596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243612 */     // MIs[0] Op4
     /* 243612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243620 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 243620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 243623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243631 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243633 */     GIR_RootConstrainSelectedInstOperands,
     /* 243634 */     // GIR_Coverage, 11229,
     /* 243634 */     GIR_EraseRootFromParent_Done,
     /* 243635 */   // Label 4882: @243635
     /* 243635 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(243687), // Rule ID 11230 //
     /* 243640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 243648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243664 */     // MIs[0] Op4
     /* 243664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243667 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243672 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 243675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243683 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243685 */     GIR_RootConstrainSelectedInstOperands,
     /* 243686 */     // GIR_Coverage, 11230,
     /* 243686 */     GIR_EraseRootFromParent_Done,
     /* 243687 */   // Label 4883: @243687
     /* 243687 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(243739), // Rule ID 11231 //
     /* 243692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 243700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243716 */     // MIs[0] Op4
     /* 243716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 243724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 243727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243735 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243737 */     GIR_RootConstrainSelectedInstOperands,
     /* 243738 */     // GIR_Coverage, 11231,
     /* 243738 */     GIR_EraseRootFromParent_Done,
     /* 243739 */   // Label 4884: @243739
     /* 243739 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(243791), // Rule ID 11274 //
     /* 243744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 243752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243768 */     // MIs[0] Op4
     /* 243768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1732:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 243776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 243779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243787 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243789 */     GIR_RootConstrainSelectedInstOperands,
     /* 243790 */     // GIR_Coverage, 11274,
     /* 243790 */     GIR_EraseRootFromParent_Done,
     /* 243791 */   // Label 4885: @243791
     /* 243791 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(243843), // Rule ID 11275 //
     /* 243796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 243804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243820 */     // MIs[0] Op4
     /* 243820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243823 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243828 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1732:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 243831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243839 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243841 */     GIR_RootConstrainSelectedInstOperands,
     /* 243842 */     // GIR_Coverage, 11275,
     /* 243842 */     GIR_EraseRootFromParent_Done,
     /* 243843 */   // Label 4886: @243843
     /* 243843 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(243895), // Rule ID 11276 //
     /* 243848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 243856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243872 */     // MIs[0] Op4
     /* 243872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 243880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 243883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243891 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243893 */     GIR_RootConstrainSelectedInstOperands,
     /* 243894 */     // GIR_Coverage, 11276,
     /* 243894 */     GIR_EraseRootFromParent_Done,
     /* 243895 */   // Label 4887: @243895
     /* 243895 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(243947), // Rule ID 11277 //
     /* 243900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 243908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243924 */     // MIs[0] Op4
     /* 243924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243932 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1968:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 243935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243943 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243945 */     GIR_RootConstrainSelectedInstOperands,
     /* 243946 */     // GIR_Coverage, 11277,
     /* 243946 */     GIR_EraseRootFromParent_Done,
     /* 243947 */   // Label 4888: @243947
     /* 243947 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(243999), // Rule ID 11278 //
     /* 243952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 243960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243976 */     // MIs[0] Op4
     /* 243976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1970:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 243984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 243987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243995 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243997 */     GIR_RootConstrainSelectedInstOperands,
     /* 243998 */     // GIR_Coverage, 11278,
     /* 243998 */     GIR_EraseRootFromParent_Done,
     /* 243999 */   // Label 4889: @243999
     /* 243999 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(244051), // Rule ID 11279 //
     /* 244004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 244012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244028 */     // MIs[0] Op4
     /* 244028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244036 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1970:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 244039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244047 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244049 */     GIR_RootConstrainSelectedInstOperands,
     /* 244050 */     // GIR_Coverage, 11279,
     /* 244050 */     GIR_EraseRootFromParent_Done,
     /* 244051 */   // Label 4890: @244051
     /* 244051 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(244103), // Rule ID 11280 //
     /* 244056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 244064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244080 */     // MIs[0] Op4
     /* 244080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1734:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 244091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244099 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244101 */     GIR_RootConstrainSelectedInstOperands,
     /* 244102 */     // GIR_Coverage, 11280,
     /* 244102 */     GIR_EraseRootFromParent_Done,
     /* 244103 */   // Label 4891: @244103
     /* 244103 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(244155), // Rule ID 11281 //
     /* 244108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 244116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244132 */     // MIs[0] Op4
     /* 244132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244140 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1734:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 244143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244151 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244153 */     GIR_RootConstrainSelectedInstOperands,
     /* 244154 */     // GIR_Coverage, 11281,
     /* 244154 */     GIR_EraseRootFromParent_Done,
     /* 244155 */   // Label 4892: @244155
     /* 244155 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(244207), // Rule ID 11282 //
     /* 244160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 244168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244184 */     // MIs[0] Op4
     /* 244184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244187 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1736:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 244195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244203 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244205 */     GIR_RootConstrainSelectedInstOperands,
     /* 244206 */     // GIR_Coverage, 11282,
     /* 244206 */     GIR_EraseRootFromParent_Done,
     /* 244207 */   // Label 4893: @244207
     /* 244207 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(244259), // Rule ID 11283 //
     /* 244212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 244220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244236 */     // MIs[0] Op4
     /* 244236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244239 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1736:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 244247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244255 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244257 */     GIR_RootConstrainSelectedInstOperands,
     /* 244258 */     // GIR_Coverage, 11283,
     /* 244258 */     GIR_EraseRootFromParent_Done,
     /* 244259 */   // Label 4894: @244259
     /* 244259 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(244311), // Rule ID 11284 //
     /* 244264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 244272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244288 */     // MIs[0] Op4
     /* 244288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1972:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 244299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244307 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244309 */     GIR_RootConstrainSelectedInstOperands,
     /* 244310 */     // GIR_Coverage, 11284,
     /* 244310 */     GIR_EraseRootFromParent_Done,
     /* 244311 */   // Label 4895: @244311
     /* 244311 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(244363), // Rule ID 11285 //
     /* 244316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 244324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244340 */     // MIs[0] Op4
     /* 244340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244348 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1972:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 244351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244359 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244361 */     GIR_RootConstrainSelectedInstOperands,
     /* 244362 */     // GIR_Coverage, 11285,
     /* 244362 */     GIR_EraseRootFromParent_Done,
     /* 244363 */   // Label 4896: @244363
     /* 244363 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(244415), // Rule ID 11286 //
     /* 244368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 244376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244392 */     // MIs[0] Op4
     /* 244392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244400 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1974:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 244403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244411 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244413 */     GIR_RootConstrainSelectedInstOperands,
     /* 244414 */     // GIR_Coverage, 11286,
     /* 244414 */     GIR_EraseRootFromParent_Done,
     /* 244415 */   // Label 4897: @244415
     /* 244415 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(244467), // Rule ID 11287 //
     /* 244420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 244428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244444 */     // MIs[0] Op4
     /* 244444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244447 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244452 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1974:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 244455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244463 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244465 */     GIR_RootConstrainSelectedInstOperands,
     /* 244466 */     // GIR_Coverage, 11287,
     /* 244466 */     GIR_EraseRootFromParent_Done,
     /* 244467 */   // Label 4898: @244467
     /* 244467 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(244519), // Rule ID 11309 //
     /* 244472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 244480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244496 */     // MIs[0] Op4
     /* 244496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244504 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1772:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 244507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244515 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244517 */     GIR_RootConstrainSelectedInstOperands,
     /* 244518 */     // GIR_Coverage, 11309,
     /* 244518 */     GIR_EraseRootFromParent_Done,
     /* 244519 */   // Label 4899: @244519
     /* 244519 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(244571), // Rule ID 11310 //
     /* 244524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 244532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244548 */     // MIs[0] Op4
     /* 244548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244551 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1772:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 244559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244567 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244569 */     GIR_RootConstrainSelectedInstOperands,
     /* 244570 */     // GIR_Coverage, 11310,
     /* 244570 */     GIR_EraseRootFromParent_Done,
     /* 244571 */   // Label 4900: @244571
     /* 244571 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(244623), // Rule ID 11311 //
     /* 244576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 244584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244600 */     // MIs[0] Op4
     /* 244600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244608 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1775:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 244611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244619 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244621 */     GIR_RootConstrainSelectedInstOperands,
     /* 244622 */     // GIR_Coverage, 11311,
     /* 244622 */     GIR_EraseRootFromParent_Done,
     /* 244623 */   // Label 4901: @244623
     /* 244623 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(244675), // Rule ID 11312 //
     /* 244628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 244636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244652 */     // MIs[0] Op4
     /* 244652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244660 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1775:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 244663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244671 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244673 */     GIR_RootConstrainSelectedInstOperands,
     /* 244674 */     // GIR_Coverage, 11312,
     /* 244674 */     GIR_EraseRootFromParent_Done,
     /* 244675 */   // Label 4902: @244675
     /* 244675 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(244727), // Rule ID 11313 //
     /* 244680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 244688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244704 */     // MIs[0] Op4
     /* 244704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244707 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1777:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 244715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244723 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244725 */     GIR_RootConstrainSelectedInstOperands,
     /* 244726 */     // GIR_Coverage, 11313,
     /* 244726 */     GIR_EraseRootFromParent_Done,
     /* 244727 */   // Label 4903: @244727
     /* 244727 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(244779), // Rule ID 11314 //
     /* 244732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 244740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244756 */     // MIs[0] Op4
     /* 244756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244759 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1777:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 244767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244775 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244777 */     GIR_RootConstrainSelectedInstOperands,
     /* 244778 */     // GIR_Coverage, 11314,
     /* 244778 */     GIR_EraseRootFromParent_Done,
     /* 244779 */   // Label 4904: @244779
     /* 244779 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(244831), // Rule ID 11315 //
     /* 244784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 244792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244808 */     // MIs[0] Op4
     /* 244808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244816 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1780:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 244819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244827 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244829 */     GIR_RootConstrainSelectedInstOperands,
     /* 244830 */     // GIR_Coverage, 11315,
     /* 244830 */     GIR_EraseRootFromParent_Done,
     /* 244831 */   // Label 4905: @244831
     /* 244831 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(244883), // Rule ID 11316 //
     /* 244836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 244844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244860 */     // MIs[0] Op4
     /* 244860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244863 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1780:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 244871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244877 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244879 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244881 */     GIR_RootConstrainSelectedInstOperands,
     /* 244882 */     // GIR_Coverage, 11316,
     /* 244882 */     GIR_EraseRootFromParent_Done,
     /* 244883 */   // Label 4906: @244883
     /* 244883 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(244935), // Rule ID 11770 //
     /* 244888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 244896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244912 */     // MIs[0] Op4
     /* 244912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244920 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1451:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 244923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244931 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244933 */     GIR_RootConstrainSelectedInstOperands,
     /* 244934 */     // GIR_Coverage, 11770,
     /* 244934 */     GIR_EraseRootFromParent_Done,
     /* 244935 */   // Label 4907: @244935
     /* 244935 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(244987), // Rule ID 11771 //
     /* 244940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 244948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244964 */     // MIs[0] Op4
     /* 244964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244972 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1453:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 244975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244983 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244985 */     GIR_RootConstrainSelectedInstOperands,
     /* 244986 */     // GIR_Coverage, 11771,
     /* 244986 */     GIR_EraseRootFromParent_Done,
     /* 244987 */   // Label 4908: @244987
     /* 244987 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(245039), // Rule ID 11772 //
     /* 244992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 245000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245016 */     // MIs[0] Op4
     /* 245016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245024 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1458:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 245027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245035 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245037 */     GIR_RootConstrainSelectedInstOperands,
     /* 245038 */     // GIR_Coverage, 11772,
     /* 245038 */     GIR_EraseRootFromParent_Done,
     /* 245039 */   // Label 4909: @245039
     /* 245039 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(245091), // Rule ID 11773 //
     /* 245044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 245052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245068 */     // MIs[0] Op4
     /* 245068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245076 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1460:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 245079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245087 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245089 */     GIR_RootConstrainSelectedInstOperands,
     /* 245090 */     // GIR_Coverage, 11773,
     /* 245090 */     GIR_EraseRootFromParent_Done,
     /* 245091 */   // Label 4910: @245091
     /* 245091 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(245143), // Rule ID 11906 //
     /* 245096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 245099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 245104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245120 */     // MIs[0] Op4
     /* 245120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245128 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1406:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 245131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245139 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245141 */     GIR_RootConstrainSelectedInstOperands,
     /* 245142 */     // GIR_Coverage, 11906,
     /* 245142 */     GIR_EraseRootFromParent_Done,
     /* 245143 */   // Label 4911: @245143
     /* 245143 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(245195), // Rule ID 11908 //
     /* 245148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 245151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 245156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245172 */     // MIs[0] Op4
     /* 245172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245180 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1944:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 245183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245191 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245193 */     GIR_RootConstrainSelectedInstOperands,
     /* 245194 */     // GIR_Coverage, 11908,
     /* 245194 */     GIR_EraseRootFromParent_Done,
     /* 245195 */   // Label 4912: @245195
     /* 245195 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(245242), // Rule ID 2820 //
     /* 245200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 245208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 245223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245227 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 245227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 245230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245238 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245240 */     GIR_RootConstrainSelectedInstOperands,
     /* 245241 */     // GIR_Coverage, 2820,
     /* 245241 */     GIR_EraseRootFromParent_Done,
     /* 245242 */   // Label 4913: @245242
     /* 245242 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(245289), // Rule ID 2823 //
     /* 245247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 245255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 245258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 245264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 245267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 245270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245274 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 245274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 245277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245283 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245285 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245287 */     GIR_RootConstrainSelectedInstOperands,
     /* 245288 */     // GIR_Coverage, 2823,
     /* 245288 */     GIR_EraseRootFromParent_Done,
     /* 245289 */   // Label 4914: @245289
     /* 245289 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(245336), // Rule ID 2826 //
     /* 245294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 245302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 245305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 245311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 245314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 245317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245321 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 245321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 245324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245332 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245334 */     GIR_RootConstrainSelectedInstOperands,
     /* 245335 */     // GIR_Coverage, 2826,
     /* 245335 */     GIR_EraseRootFromParent_Done,
     /* 245336 */   // Label 4915: @245336
     /* 245336 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(245383), // Rule ID 2829 //
     /* 245341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 245349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 245364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245368 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 245368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 245371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245379 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245381 */     GIR_RootConstrainSelectedInstOperands,
     /* 245382 */     // GIR_Coverage, 2829,
     /* 245382 */     GIR_EraseRootFromParent_Done,
     /* 245383 */   // Label 4916: @245383
     /* 245383 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(245430), // Rule ID 2832 //
     /* 245388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 245396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 245399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 245405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 245408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 245411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245415 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 245415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 245418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245426 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245428 */     GIR_RootConstrainSelectedInstOperands,
     /* 245429 */     // GIR_Coverage, 2832,
     /* 245429 */     GIR_EraseRootFromParent_Done,
     /* 245430 */   // Label 4917: @245430
     /* 245430 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(245477), // Rule ID 2835 //
     /* 245435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 245443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 245458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245462 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 245462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 245465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245471 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245473 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245475 */     GIR_RootConstrainSelectedInstOperands,
     /* 245476 */     // GIR_Coverage, 2835,
     /* 245476 */     GIR_EraseRootFromParent_Done,
     /* 245477 */   // Label 4918: @245477
     /* 245477 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(245524), // Rule ID 2838 //
     /* 245482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 245490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 245505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245509 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1410:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 245509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 245512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245520 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245522 */     GIR_RootConstrainSelectedInstOperands,
     /* 245523 */     // GIR_Coverage, 2838,
     /* 245523 */     GIR_EraseRootFromParent_Done,
     /* 245524 */   // Label 4919: @245524
     /* 245524 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(245571), // Rule ID 2839 //
     /* 245529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 245537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 245552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245556 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1410:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 245556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 245559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245567 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245569 */     GIR_RootConstrainSelectedInstOperands,
     /* 245570 */     // GIR_Coverage, 2839,
     /* 245570 */     GIR_EraseRootFromParent_Done,
     /* 245571 */   // Label 4920: @245571
     /* 245571 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(245618), // Rule ID 2840 //
     /* 245576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 245584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 245599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245603 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1410:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 245603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 245606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245614 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245616 */     GIR_RootConstrainSelectedInstOperands,
     /* 245617 */     // GIR_Coverage, 2840,
     /* 245617 */     GIR_EraseRootFromParent_Done,
     /* 245618 */   // Label 4921: @245618
     /* 245618 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(245665), // Rule ID 2936 //
     /* 245623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 245631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 245634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 245646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245650 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1585:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 245650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 245653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245661 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245663 */     GIR_RootConstrainSelectedInstOperands,
     /* 245664 */     // GIR_Coverage, 2936,
     /* 245664 */     GIR_EraseRootFromParent_Done,
     /* 245665 */   // Label 4922: @245665
     /* 245665 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(245712), // Rule ID 2939 //
     /* 245670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 245678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 245693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245697 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1585:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 245697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 245700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245708 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245710 */     GIR_RootConstrainSelectedInstOperands,
     /* 245711 */     // GIR_Coverage, 2939,
     /* 245711 */     GIR_EraseRootFromParent_Done,
     /* 245712 */   // Label 4923: @245712
     /* 245712 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(245759), // Rule ID 2942 //
     /* 245717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 245725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 245740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1585:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 245744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 245747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245755 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245757 */     GIR_RootConstrainSelectedInstOperands,
     /* 245758 */     // GIR_Coverage, 2942,
     /* 245758 */     GIR_EraseRootFromParent_Done,
     /* 245759 */   // Label 4924: @245759
     /* 245759 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(245806), // Rule ID 2945 //
     /* 245764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 245772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 245787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245791 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1585:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 245791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 245794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245802 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245804 */     GIR_RootConstrainSelectedInstOperands,
     /* 245805 */     // GIR_Coverage, 2945,
     /* 245805 */     GIR_EraseRootFromParent_Done,
     /* 245806 */   // Label 4925: @245806
     /* 245806 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(245853), // Rule ID 2948 //
     /* 245811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 245819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 245822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 245834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245838 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1587:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 245838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 245841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245849 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245851 */     GIR_RootConstrainSelectedInstOperands,
     /* 245852 */     // GIR_Coverage, 2948,
     /* 245852 */     GIR_EraseRootFromParent_Done,
     /* 245853 */   // Label 4926: @245853
     /* 245853 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(245900), // Rule ID 2950 //
     /* 245858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 245866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 245881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245885 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1587:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 245885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 245888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245896 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245898 */     GIR_RootConstrainSelectedInstOperands,
     /* 245899 */     // GIR_Coverage, 2950,
     /* 245899 */     GIR_EraseRootFromParent_Done,
     /* 245900 */   // Label 4927: @245900
     /* 245900 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(245947), // Rule ID 2952 //
     /* 245905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 245913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 245928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245932 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1587:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 245932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 245935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245943 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245945 */     GIR_RootConstrainSelectedInstOperands,
     /* 245946 */     // GIR_Coverage, 2952,
     /* 245946 */     GIR_EraseRootFromParent_Done,
     /* 245947 */   // Label 4928: @245947
     /* 245947 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(245994), // Rule ID 2954 //
     /* 245952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 245960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 245975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245979 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1587:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 245979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 245982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245990 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245992 */     GIR_RootConstrainSelectedInstOperands,
     /* 245993 */     // GIR_Coverage, 2954,
     /* 245993 */     GIR_EraseRootFromParent_Done,
     /* 245994 */   // Label 4929: @245994
     /* 245994 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(246041), // Rule ID 7499 //
     /* 245999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1593:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 246029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246037 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246039 */     GIR_RootConstrainSelectedInstOperands,
     /* 246040 */     // GIR_Coverage, 7499,
     /* 246040 */     GIR_EraseRootFromParent_Done,
     /* 246041 */   // Label 4930: @246041
     /* 246041 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(246088), // Rule ID 7502 //
     /* 246046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246073 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1593:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 246073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 246076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246084 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246086 */     GIR_RootConstrainSelectedInstOperands,
     /* 246087 */     // GIR_Coverage, 7502,
     /* 246087 */     GIR_EraseRootFromParent_Done,
     /* 246088 */   // Label 4931: @246088
     /* 246088 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(246135), // Rule ID 7505 //
     /* 246093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246120 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1593:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 246120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 246123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246131 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246133 */     GIR_RootConstrainSelectedInstOperands,
     /* 246134 */     // GIR_Coverage, 7505,
     /* 246134 */     GIR_EraseRootFromParent_Done,
     /* 246135 */   // Label 4932: @246135
     /* 246135 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(246182), // Rule ID 7508 //
     /* 246140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246167 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1593:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 246167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 246170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246178 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246180 */     GIR_RootConstrainSelectedInstOperands,
     /* 246181 */     // GIR_Coverage, 7508,
     /* 246181 */     GIR_EraseRootFromParent_Done,
     /* 246182 */   // Label 4933: @246182
     /* 246182 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(246229), // Rule ID 7511 //
     /* 246187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 246195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246214 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1590:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 246217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246225 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246227 */     GIR_RootConstrainSelectedInstOperands,
     /* 246228 */     // GIR_Coverage, 7511,
     /* 246228 */     GIR_EraseRootFromParent_Done,
     /* 246229 */   // Label 4934: @246229
     /* 246229 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(246276), // Rule ID 7513 //
     /* 246234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 246242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246261 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1590:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 246261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 246264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246272 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246274 */     GIR_RootConstrainSelectedInstOperands,
     /* 246275 */     // GIR_Coverage, 7513,
     /* 246275 */     GIR_EraseRootFromParent_Done,
     /* 246276 */   // Label 4935: @246276
     /* 246276 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(246323), // Rule ID 7515 //
     /* 246281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 246289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246308 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1590:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 246308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 246311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246319 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246321 */     GIR_RootConstrainSelectedInstOperands,
     /* 246322 */     // GIR_Coverage, 7515,
     /* 246322 */     GIR_EraseRootFromParent_Done,
     /* 246323 */   // Label 4936: @246323
     /* 246323 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(246370), // Rule ID 7517 //
     /* 246328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 246336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246355 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1590:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 246355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 246358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246366 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246368 */     GIR_RootConstrainSelectedInstOperands,
     /* 246369 */     // GIR_Coverage, 7517,
     /* 246369 */     GIR_EraseRootFromParent_Done,
     /* 246370 */   // Label 4937: @246370
     /* 246370 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(246417), // Rule ID 8143 //
     /* 246375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 246383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246402 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1454:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 246402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 246405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246413 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246415 */     GIR_RootConstrainSelectedInstOperands,
     /* 246416 */     // GIR_Coverage, 8143,
     /* 246416 */     GIR_EraseRootFromParent_Done,
     /* 246417 */   // Label 4938: @246417
     /* 246417 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(246464), // Rule ID 8146 //
     /* 246422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 246430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 246433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 246439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 246442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 246445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246449 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1454:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 246449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 246452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246460 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246462 */     GIR_RootConstrainSelectedInstOperands,
     /* 246463 */     // GIR_Coverage, 8146,
     /* 246463 */     GIR_EraseRootFromParent_Done,
     /* 246464 */   // Label 4939: @246464
     /* 246464 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(246511), // Rule ID 8149 //
     /* 246469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 246477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 246480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 246486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 246489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 246492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246496 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1454:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 246496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 246499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246507 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246509 */     GIR_RootConstrainSelectedInstOperands,
     /* 246510 */     // GIR_Coverage, 8149,
     /* 246510 */     GIR_EraseRootFromParent_Done,
     /* 246511 */   // Label 4940: @246511
     /* 246511 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(246558), // Rule ID 8152 //
     /* 246516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 246524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246543 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1454:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 246543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 246546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246554 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246556 */     GIR_RootConstrainSelectedInstOperands,
     /* 246557 */     // GIR_Coverage, 8152,
     /* 246557 */     GIR_EraseRootFromParent_Done,
     /* 246558 */   // Label 4941: @246558
     /* 246558 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(246605), // Rule ID 8155 //
     /* 246563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 246571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 246574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 246580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 246583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 246586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246590 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1454:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 246590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 246593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246599 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246601 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246603 */     GIR_RootConstrainSelectedInstOperands,
     /* 246604 */     // GIR_Coverage, 8155,
     /* 246604 */     GIR_EraseRootFromParent_Done,
     /* 246605 */   // Label 4942: @246605
     /* 246605 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(246652), // Rule ID 8158 //
     /* 246610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 246618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246637 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1454:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 246637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 246640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246646 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246648 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246650 */     GIR_RootConstrainSelectedInstOperands,
     /* 246651 */     // GIR_Coverage, 8158,
     /* 246651 */     GIR_EraseRootFromParent_Done,
     /* 246652 */   // Label 4943: @246652
     /* 246652 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(246699), // Rule ID 8161 //
     /* 246657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 246665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246684 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1470:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 246684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 246687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246695 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246697 */     GIR_RootConstrainSelectedInstOperands,
     /* 246698 */     // GIR_Coverage, 8161,
     /* 246698 */     GIR_EraseRootFromParent_Done,
     /* 246699 */   // Label 4944: @246699
     /* 246699 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(246746), // Rule ID 8162 //
     /* 246704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 246712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 246715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 246721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 246724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 246727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246731 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 246731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 246734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246742 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246744 */     GIR_RootConstrainSelectedInstOperands,
     /* 246745 */     // GIR_Coverage, 8162,
     /* 246745 */     GIR_EraseRootFromParent_Done,
     /* 246746 */   // Label 4945: @246746
     /* 246746 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(246793), // Rule ID 8163 //
     /* 246751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 246759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 246762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 246768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 246771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 246774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246778 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 246778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 246781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246789 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246791 */     GIR_RootConstrainSelectedInstOperands,
     /* 246792 */     // GIR_Coverage, 8163,
     /* 246792 */     GIR_EraseRootFromParent_Done,
     /* 246793 */   // Label 4946: @246793
     /* 246793 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(246840), // Rule ID 8164 //
     /* 246798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 246806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246825 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 246825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 246828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246836 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246838 */     GIR_RootConstrainSelectedInstOperands,
     /* 246839 */     // GIR_Coverage, 8164,
     /* 246839 */     GIR_EraseRootFromParent_Done,
     /* 246840 */   // Label 4947: @246840
     /* 246840 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(246887), // Rule ID 8165 //
     /* 246845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 246853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 246856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 246862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 246865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 246868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246872 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 246872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 246875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246883 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246885 */     GIR_RootConstrainSelectedInstOperands,
     /* 246886 */     // GIR_Coverage, 8165,
     /* 246886 */     GIR_EraseRootFromParent_Done,
     /* 246887 */   // Label 4948: @246887
     /* 246887 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(246934), // Rule ID 8166 //
     /* 246892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 246900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246919 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 246919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 246922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246930 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246932 */     GIR_RootConstrainSelectedInstOperands,
     /* 246933 */     // GIR_Coverage, 8166,
     /* 246933 */     GIR_EraseRootFromParent_Done,
     /* 246934 */   // Label 4949: @246934
     /* 246934 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(246981), // Rule ID 8167 //
     /* 246939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 246947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246966 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1472:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 246966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 246969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246977 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246979 */     GIR_RootConstrainSelectedInstOperands,
     /* 246980 */     // GIR_Coverage, 8167,
     /* 246980 */     GIR_EraseRootFromParent_Done,
     /* 246981 */   // Label 4950: @246981
     /* 246981 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(247028), // Rule ID 8168 //
     /* 246986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 246994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 246997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 247003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 247006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 247009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247013 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1472:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 247013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 247016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247024 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247026 */     GIR_RootConstrainSelectedInstOperands,
     /* 247027 */     // GIR_Coverage, 8168,
     /* 247027 */     GIR_EraseRootFromParent_Done,
     /* 247028 */   // Label 4951: @247028
     /* 247028 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(247075), // Rule ID 8169 //
     /* 247033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 247044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 247050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 247053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 247056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247060 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1472:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 247060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 247063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247071 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247073 */     GIR_RootConstrainSelectedInstOperands,
     /* 247074 */     // GIR_Coverage, 8169,
     /* 247074 */     GIR_EraseRootFromParent_Done,
     /* 247075 */   // Label 4952: @247075
     /* 247075 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(247122), // Rule ID 8170 //
     /* 247080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247107 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 247110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247118 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247120 */     GIR_RootConstrainSelectedInstOperands,
     /* 247121 */     // GIR_Coverage, 8170,
     /* 247121 */     GIR_EraseRootFromParent_Done,
     /* 247122 */   // Label 4953: @247122
     /* 247122 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(247169), // Rule ID 8171 //
     /* 247127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 247138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 247144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 247147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 247150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247154 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1472:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 247154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 247157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247165 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247167 */     GIR_RootConstrainSelectedInstOperands,
     /* 247168 */     // GIR_Coverage, 8171,
     /* 247168 */     GIR_EraseRootFromParent_Done,
     /* 247169 */   // Label 4954: @247169
     /* 247169 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(247216), // Rule ID 8172 //
     /* 247174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247201 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1472:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 247204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247212 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247214 */     GIR_RootConstrainSelectedInstOperands,
     /* 247215 */     // GIR_Coverage, 8172,
     /* 247215 */     GIR_EraseRootFromParent_Done,
     /* 247216 */   // Label 4955: @247216
     /* 247216 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(247263), // Rule ID 8173 //
     /* 247221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 247229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247248 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1462:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 247251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247259 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247261 */     GIR_RootConstrainSelectedInstOperands,
     /* 247262 */     // GIR_Coverage, 8173,
     /* 247262 */     GIR_EraseRootFromParent_Done,
     /* 247263 */   // Label 4956: @247263
     /* 247263 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(247310), // Rule ID 8174 //
     /* 247268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 247276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247295 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1462:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 247298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247306 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247308 */     GIR_RootConstrainSelectedInstOperands,
     /* 247309 */     // GIR_Coverage, 8174,
     /* 247309 */     GIR_EraseRootFromParent_Done,
     /* 247310 */   // Label 4957: @247310
     /* 247310 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(247357), // Rule ID 8175 //
     /* 247315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 247323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247342 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1462:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 247345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247353 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247355 */     GIR_RootConstrainSelectedInstOperands,
     /* 247356 */     // GIR_Coverage, 8175,
     /* 247356 */     GIR_EraseRootFromParent_Done,
     /* 247357 */   // Label 4958: @247357
     /* 247357 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(247404), // Rule ID 8176 //
     /* 247362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 247370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247389 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1469:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 247392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247400 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247402 */     GIR_RootConstrainSelectedInstOperands,
     /* 247403 */     // GIR_Coverage, 8176,
     /* 247403 */     GIR_EraseRootFromParent_Done,
     /* 247404 */   // Label 4959: @247404
     /* 247404 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(247451), // Rule ID 8177 //
     /* 247409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 247417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247436 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1469:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 247439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247447 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247449 */     GIR_RootConstrainSelectedInstOperands,
     /* 247450 */     // GIR_Coverage, 8177,
     /* 247450 */     GIR_EraseRootFromParent_Done,
     /* 247451 */   // Label 4960: @247451
     /* 247451 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(247498), // Rule ID 8178 //
     /* 247456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 247464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247483 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1469:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 247486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247494 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247496 */     GIR_RootConstrainSelectedInstOperands,
     /* 247497 */     // GIR_Coverage, 8178,
     /* 247497 */     GIR_EraseRootFromParent_Done,
     /* 247498 */   // Label 4961: @247498
     /* 247498 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(247545), // Rule ID 8179 //
     /* 247503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 247511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247530 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1474:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 247533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247541 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247543 */     GIR_RootConstrainSelectedInstOperands,
     /* 247544 */     // GIR_Coverage, 8179,
     /* 247544 */     GIR_EraseRootFromParent_Done,
     /* 247545 */   // Label 4962: @247545
     /* 247545 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(247592), // Rule ID 8180 //
     /* 247550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 247558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247577 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 247580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247588 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247590 */     GIR_RootConstrainSelectedInstOperands,
     /* 247591 */     // GIR_Coverage, 8180,
     /* 247591 */     GIR_EraseRootFromParent_Done,
     /* 247592 */   // Label 4963: @247592
     /* 247592 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(247639), // Rule ID 8181 //
     /* 247597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 247605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247624 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1474:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 247627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247633 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247635 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247637 */     GIR_RootConstrainSelectedInstOperands,
     /* 247638 */     // GIR_Coverage, 8181,
     /* 247638 */     GIR_EraseRootFromParent_Done,
     /* 247639 */   // Label 4964: @247639
     /* 247639 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(247686), // Rule ID 8182 //
     /* 247644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 247652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247671 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1456:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 247674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247680 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247682 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247684 */     GIR_RootConstrainSelectedInstOperands,
     /* 247685 */     // GIR_Coverage, 8182,
     /* 247685 */     GIR_EraseRootFromParent_Done,
     /* 247686 */   // Label 4965: @247686
     /* 247686 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(247733), // Rule ID 8185 //
     /* 247691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 247699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 247702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 247708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 247711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 247714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247718 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1456:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 247718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 247721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247729 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247731 */     GIR_RootConstrainSelectedInstOperands,
     /* 247732 */     // GIR_Coverage, 8185,
     /* 247732 */     GIR_EraseRootFromParent_Done,
     /* 247733 */   // Label 4966: @247733
     /* 247733 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(247780), // Rule ID 8188 //
     /* 247738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 247746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 247749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 247755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 247758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 247761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247765 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 247765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 247768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247776 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247778 */     GIR_RootConstrainSelectedInstOperands,
     /* 247779 */     // GIR_Coverage, 8188,
     /* 247779 */     GIR_EraseRootFromParent_Done,
     /* 247780 */   // Label 4967: @247780
     /* 247780 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(247827), // Rule ID 8191 //
     /* 247785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 247793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247812 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1456:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 247815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247821 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247823 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247825 */     GIR_RootConstrainSelectedInstOperands,
     /* 247826 */     // GIR_Coverage, 8191,
     /* 247826 */     GIR_EraseRootFromParent_Done,
     /* 247827 */   // Label 4968: @247827
     /* 247827 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(247874), // Rule ID 8194 //
     /* 247832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 247840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 247843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 247849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 247852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 247855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247859 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 247859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 247862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247870 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247872 */     GIR_RootConstrainSelectedInstOperands,
     /* 247873 */     // GIR_Coverage, 8194,
     /* 247873 */     GIR_EraseRootFromParent_Done,
     /* 247874 */   // Label 4969: @247874
     /* 247874 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(247921), // Rule ID 8197 //
     /* 247879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 247887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247906 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 247909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247917 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247919 */     GIR_RootConstrainSelectedInstOperands,
     /* 247920 */     // GIR_Coverage, 8197,
     /* 247920 */     GIR_EraseRootFromParent_Done,
     /* 247921 */   // Label 4970: @247921
     /* 247921 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(247968), // Rule ID 8200 //
     /* 247926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 247934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247953 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1471:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 247956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247964 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247966 */     GIR_RootConstrainSelectedInstOperands,
     /* 247967 */     // GIR_Coverage, 8200,
     /* 247967 */     GIR_EraseRootFromParent_Done,
     /* 247968 */   // Label 4971: @247968
     /* 247968 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(248015), // Rule ID 8203 //
     /* 247973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 247981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 247984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 247990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 247993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 247996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248000 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1471:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 248003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248009 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248011 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248013 */     GIR_RootConstrainSelectedInstOperands,
     /* 248014 */     // GIR_Coverage, 8203,
     /* 248014 */     GIR_EraseRootFromParent_Done,
     /* 248015 */   // Label 4972: @248015
     /* 248015 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(248062), // Rule ID 8206 //
     /* 248020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248047 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 248050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248058 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248060 */     GIR_RootConstrainSelectedInstOperands,
     /* 248061 */     // GIR_Coverage, 8206,
     /* 248061 */     GIR_EraseRootFromParent_Done,
     /* 248062 */   // Label 4973: @248062
     /* 248062 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(248109), // Rule ID 8209 //
     /* 248067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248094 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 248097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248105 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248107 */     GIR_RootConstrainSelectedInstOperands,
     /* 248108 */     // GIR_Coverage, 8209,
     /* 248108 */     GIR_EraseRootFromParent_Done,
     /* 248109 */   // Label 4974: @248109
     /* 248109 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(248156), // Rule ID 8212 //
     /* 248114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248141 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 248144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248152 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248154 */     GIR_RootConstrainSelectedInstOperands,
     /* 248155 */     // GIR_Coverage, 8212,
     /* 248155 */     GIR_EraseRootFromParent_Done,
     /* 248156 */   // Label 4975: @248156
     /* 248156 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(248203), // Rule ID 8215 //
     /* 248161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248188 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 248191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248199 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248201 */     GIR_RootConstrainSelectedInstOperands,
     /* 248202 */     // GIR_Coverage, 8215,
     /* 248202 */     GIR_EraseRootFromParent_Done,
     /* 248203 */   // Label 4976: @248203
     /* 248203 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(248250), // Rule ID 8218 //
     /* 248208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 248216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248235 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1473:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 248238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248246 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248248 */     GIR_RootConstrainSelectedInstOperands,
     /* 248249 */     // GIR_Coverage, 8218,
     /* 248249 */     GIR_EraseRootFromParent_Done,
     /* 248250 */   // Label 4977: @248250
     /* 248250 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(248297), // Rule ID 8220 //
     /* 248255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 248263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248282 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1473:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 248285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248293 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248295 */     GIR_RootConstrainSelectedInstOperands,
     /* 248296 */     // GIR_Coverage, 8220,
     /* 248296 */     GIR_EraseRootFromParent_Done,
     /* 248297 */   // Label 4978: @248297
     /* 248297 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(248344), // Rule ID 8222 //
     /* 248302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 248310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248329 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1473:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 248332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248340 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248342 */     GIR_RootConstrainSelectedInstOperands,
     /* 248343 */     // GIR_Coverage, 8222,
     /* 248343 */     GIR_EraseRootFromParent_Done,
     /* 248344 */   // Label 4979: @248344
     /* 248344 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(248391), // Rule ID 8224 //
     /* 248349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 248357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248376 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 248379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248387 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248389 */     GIR_RootConstrainSelectedInstOperands,
     /* 248390 */     // GIR_Coverage, 8224,
     /* 248390 */     GIR_EraseRootFromParent_Done,
     /* 248391 */   // Label 4980: @248391
     /* 248391 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(248438), // Rule ID 8226 //
     /* 248396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 248404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248423 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1473:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 248426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248434 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248436 */     GIR_RootConstrainSelectedInstOperands,
     /* 248437 */     // GIR_Coverage, 8226,
     /* 248437 */     GIR_EraseRootFromParent_Done,
     /* 248438 */   // Label 4981: @248438
     /* 248438 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(248485), // Rule ID 8228 //
     /* 248443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 248451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248470 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1473:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 248473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248481 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248483 */     GIR_RootConstrainSelectedInstOperands,
     /* 248484 */     // GIR_Coverage, 8228,
     /* 248484 */     GIR_EraseRootFromParent_Done,
     /* 248485 */   // Label 4982: @248485
     /* 248485 */   GIM_Reject,
     /* 248486 */ // Label 4841: @248486
     /* 248486 */ GIM_Reject,
     /* 248487 */ // Label 36: @248487
     /* 248487 */ GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(248565),
     /* 248492 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 248495 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(248517), // Rule ID 78 //
     /* 248500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 248503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 248508 */     // (intrinsic_void 2152:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 248508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 248511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248515 */     GIR_RootConstrainSelectedInstOperands,
     /* 248516 */     // GIR_Coverage, 78,
     /* 248516 */     GIR_EraseRootFromParent_Done,
     /* 248517 */   // Label 4984: @248517
     /* 248517 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(248542), // Rule ID 2377 //
     /* 248522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 248530 */     // (intrinsic_void 1702:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 248530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 248533 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 248536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248540 */     GIR_RootConstrainSelectedInstOperands,
     /* 248541 */     // GIR_Coverage, 2377,
     /* 248541 */     GIR_EraseRootFromParent_Done,
     /* 248542 */   // Label 4985: @248542
     /* 248542 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(248564), // Rule ID 7083 //
     /* 248547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 248552 */     // (intrinsic_void 500:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 248552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 248555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 248558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248562 */     GIR_RootConstrainSelectedInstOperands,
     /* 248563 */     // GIR_Coverage, 7083,
     /* 248563 */     GIR_EraseRootFromParent_Done,
     /* 248564 */   // Label 4986: @248564
     /* 248564 */   GIM_Reject,
     /* 248565 */ // Label 4983: @248565
     /* 248565 */ GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(249165),
     /* 248570 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 248573 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(248605), // Rule ID 79 //
     /* 248578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 248581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 248586 */     // MIs[0] imm
     /* 248586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 248594 */     // (intrinsic_void 2151:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 248594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 248597 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 248599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248603 */     GIR_RootConstrainSelectedInstOperands,
     /* 248604 */     // GIR_Coverage, 79,
     /* 248604 */     GIR_EraseRootFromParent_Done,
     /* 248605 */   // Label 4988: @248605
     /* 248605 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(248630), // Rule ID 227 //
     /* 248610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 248615 */     // MIs[0] imm
     /* 248615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 248623 */     // (intrinsic_void 498:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 248623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 248626 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 248628 */     GIR_RootConstrainSelectedInstOperands,
     /* 248629 */     // GIR_Coverage, 227,
     /* 248629 */     GIR_EraseRootFromParent_Done,
     /* 248630 */   // Label 4989: @248630
     /* 248630 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(248655), // Rule ID 228 //
     /* 248635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 248640 */     // MIs[0] imm
     /* 248640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248643 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 248648 */     // (intrinsic_void 557:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 248648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 248651 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 248653 */     GIR_RootConstrainSelectedInstOperands,
     /* 248654 */     // GIR_Coverage, 228,
     /* 248654 */     GIR_EraseRootFromParent_Done,
     /* 248655 */   // Label 4990: @248655
     /* 248655 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(248687), // Rule ID 3615 //
     /* 248660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 248663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 248668 */     // MIs[0] imm
     /* 248668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 248671 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 248676 */     // (intrinsic_void 1208:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 248676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 248679 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 248681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248685 */     GIR_RootConstrainSelectedInstOperands,
     /* 248686 */     // GIR_Coverage, 3615,
     /* 248686 */     GIR_EraseRootFromParent_Done,
     /* 248687 */   // Label 4991: @248687
     /* 248687 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(248727), // Rule ID 16 //
     /* 248692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 248697 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 248700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 248704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 248708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 248712 */     // MIs[1] Operand 1
     /* 248712 */     // No operand predicates
     /* 248712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248714 */     // (intrinsic_void 556:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 248714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 248717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 248720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248725 */     GIR_RootConstrainSelectedInstOperands,
     /* 248726 */     // GIR_Coverage, 16,
     /* 248726 */     GIR_EraseRootFromParent_Done,
     /* 248727 */   // Label 4992: @248727
     /* 248727 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(248767), // Rule ID 17 //
     /* 248732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 248737 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 248740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 248744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 248748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 248752 */     // MIs[1] Operand 1
     /* 248752 */     // No operand predicates
     /* 248752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248754 */     // (intrinsic_void 544:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 248754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 248757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 248760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248765 */     GIR_RootConstrainSelectedInstOperands,
     /* 248766 */     // GIR_Coverage, 17,
     /* 248766 */     GIR_EraseRootFromParent_Done,
     /* 248767 */   // Label 4993: @248767
     /* 248767 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(248807), // Rule ID 18 //
     /* 248772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 248777 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 248780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 248784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 248788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 248792 */     // MIs[1] Operand 1
     /* 248792 */     // No operand predicates
     /* 248792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248794 */     // (intrinsic_void 545:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 248794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 248797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 248800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248805 */     GIR_RootConstrainSelectedInstOperands,
     /* 248806 */     // GIR_Coverage, 18,
     /* 248806 */     GIR_EraseRootFromParent_Done,
     /* 248807 */   // Label 4994: @248807
     /* 248807 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(248847), // Rule ID 19 //
     /* 248812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 248817 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 248820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 248824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 248828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 248832 */     // MIs[1] Operand 1
     /* 248832 */     // No operand predicates
     /* 248832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 248834 */     // (intrinsic_void 560:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 248834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 248837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 248840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 248845 */     GIR_RootConstrainSelectedInstOperands,
     /* 248846 */     // GIR_Coverage, 19,
     /* 248846 */     GIR_EraseRootFromParent_Done,
     /* 248847 */   // Label 4995: @248847
     /* 248847 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(248871), // Rule ID 72 //
     /* 248852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 248857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 248860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248864 */     // (intrinsic_w_chain:{ *:[i64] } 553:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 248864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 248867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 248869 */     GIR_RootConstrainSelectedInstOperands,
     /* 248870 */     // GIR_Coverage, 72,
     /* 248870 */     GIR_EraseRootFromParent_Done,
     /* 248871 */   // Label 4996: @248871
     /* 248871 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(248895), // Rule ID 74 //
     /* 248876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 248881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 248884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248888 */     // (intrinsic_w_chain:{ *:[i64] } 554:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 248888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 248891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 248893 */     GIR_RootConstrainSelectedInstOperands,
     /* 248894 */     // GIR_Coverage, 74,
     /* 248894 */     GIR_EraseRootFromParent_Done,
     /* 248895 */   // Label 4997: @248895
     /* 248895 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(248926), // Rule ID 77 //
     /* 248900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 248903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 248908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 248911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248915 */     // (intrinsic_w_chain:{ *:[i64] } 2153:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 248915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 248918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 248920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248924 */     GIR_RootConstrainSelectedInstOperands,
     /* 248925 */     // GIR_Coverage, 77,
     /* 248925 */     GIR_EraseRootFromParent_Done,
     /* 248926 */   // Label 4998: @248926
     /* 248926 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(248953), // Rule ID 80 //
     /* 248931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 248934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 248939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 248942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 248946 */     // (intrinsic_w_chain:{ *:[i64] } 2154:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 248946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 248949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 248951 */     GIR_RootConstrainSelectedInstOperands,
     /* 248952 */     // GIR_Coverage, 80,
     /* 248952 */     GIR_EraseRootFromParent_Done,
     /* 248953 */   // Label 4999: @248953
     /* 248953 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(248984), // Rule ID 2376 //
     /* 248958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 248961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 248966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 248969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 248973 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1652:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 248973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 248976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 248978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 248982 */     GIR_RootConstrainSelectedInstOperands,
     /* 248983 */     // GIR_Coverage, 2376,
     /* 248983 */     GIR_EraseRootFromParent_Done,
     /* 248984 */   // Label 5000: @248984
     /* 248984 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(249024), // Rule ID 12683 //
     /* 248989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 248992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 248997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249004 */     // (intrinsic_w_chain:{ *:[i64] } 881:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 249004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 249007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 249009 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 249019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 249022 */     GIR_RootConstrainSelectedInstOperands,
     /* 249023 */     // GIR_Coverage, 12683,
     /* 249023 */     GIR_EraseRootFromParent_Done,
     /* 249024 */   // Label 5001: @249024
     /* 249024 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(249058), // Rule ID 2378 //
     /* 249029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 249037 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 249040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 249044 */     // (intrinsic_void 2132:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 249044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 249047 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 249049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 249052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249056 */     GIR_RootConstrainSelectedInstOperands,
     /* 249057 */     // GIR_Coverage, 2378,
     /* 249057 */     GIR_EraseRootFromParent_Done,
     /* 249058 */   // Label 5002: @249058
     /* 249058 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(249081), // Rule ID 73 //
     /* 249063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 249068 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249071 */     // (intrinsic_void 780:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 249071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 249074 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249076 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 249079 */     GIR_RootConstrainSelectedInstOperands,
     /* 249080 */     // GIR_Coverage, 73,
     /* 249080 */     GIR_EraseRootFromParent_Done,
     /* 249081 */   // Label 5003: @249081
     /* 249081 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(249104), // Rule ID 75 //
     /* 249086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 249091 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249094 */     // (intrinsic_void 782:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 249094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 249097 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 249102 */     GIR_RootConstrainSelectedInstOperands,
     /* 249103 */     // GIR_Coverage, 75,
     /* 249103 */     GIR_EraseRootFromParent_Done,
     /* 249104 */   // Label 5004: @249104
     /* 249104 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(249131), // Rule ID 76 //
     /* 249109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 249114 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249117 */     // (intrinsic_void 781:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 249117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 249120 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 249125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249129 */     GIR_RootConstrainSelectedInstOperands,
     /* 249130 */     // GIR_Coverage, 76,
     /* 249130 */     GIR_EraseRootFromParent_Done,
     /* 249131 */   // Label 5005: @249131
     /* 249131 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(249164), // Rule ID 12682 //
     /* 249136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 249139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 249144 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249147 */     // (intrinsic_void 956:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 249147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 249150 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 249160 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249162 */     GIR_RootConstrainSelectedInstOperands,
     /* 249163 */     // GIR_Coverage, 12682,
     /* 249163 */     GIR_EraseRootFromParent_Done,
     /* 249164 */   // Label 5006: @249164
     /* 249164 */   GIM_Reject,
     /* 249165 */ // Label 4987: @249165
     /* 249165 */ GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(250136),
     /* 249170 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 249173 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(249249), // Rule ID 7049 //
     /* 249178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 249183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249190 */     // MIs[0] addr
     /* 249190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 249202 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 249202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 249209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 249218 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 249224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 249227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 249238 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249243 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249248 */     // GIR_Coverage, 7049,
     /* 249248 */     GIR_EraseRootFromParent_Done,
     /* 249249 */   // Label 5008: @249249
     /* 249249 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(249325), // Rule ID 7050 //
     /* 249254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 249259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249266 */     // MIs[0] addr
     /* 249266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 249278 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 249278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 249285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 249294 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 249300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 249303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 249314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249324 */     // GIR_Coverage, 7050,
     /* 249324 */     GIR_EraseRootFromParent_Done,
     /* 249325 */   // Label 5009: @249325
     /* 249325 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(249401), // Rule ID 7051 //
     /* 249330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 249335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249342 */     // MIs[0] addr
     /* 249342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 249354 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 249354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 249361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 249370 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 249376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 249379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 249390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249400 */     // GIR_Coverage, 7051,
     /* 249400 */     GIR_EraseRootFromParent_Done,
     /* 249401 */   // Label 5010: @249401
     /* 249401 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(249443), // Rule ID 7052 //
     /* 249406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 249411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249418 */     // MIs[0] addr
     /* 249418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249426 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 249430 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 249430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 249433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 249435 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 249437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249441 */     GIR_RootConstrainSelectedInstOperands,
     /* 249442 */     // GIR_Coverage, 7052,
     /* 249442 */     GIR_EraseRootFromParent_Done,
     /* 249443 */   // Label 5011: @249443
     /* 249443 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(249519), // Rule ID 7056 //
     /* 249448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 249453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249460 */     // MIs[0] addr
     /* 249460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249468 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 249472 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 249472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 249479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249484 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 249488 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 249494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 249497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 249508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249518 */     // GIR_Coverage, 7056,
     /* 249518 */     GIR_EraseRootFromParent_Done,
     /* 249519 */   // Label 5012: @249519
     /* 249519 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(249595), // Rule ID 7057 //
     /* 249524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 249529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249536 */     // MIs[0] addr
     /* 249536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249544 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 249548 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 249548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 249555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249560 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 249564 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 249570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 249573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 249584 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249594 */     // GIR_Coverage, 7057,
     /* 249594 */     GIR_EraseRootFromParent_Done,
     /* 249595 */   // Label 5013: @249595
     /* 249595 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(249671), // Rule ID 7058 //
     /* 249600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 249605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249612 */     // MIs[0] addr
     /* 249612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249620 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 249624 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 249624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 249631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 249640 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 249646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 249649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 249660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249670 */     // GIR_Coverage, 7058,
     /* 249670 */     GIR_EraseRootFromParent_Done,
     /* 249671 */   // Label 5014: @249671
     /* 249671 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(249713), // Rule ID 7059 //
     /* 249676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 249681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249688 */     // MIs[0] addr
     /* 249688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 249700 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 249700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 249703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 249705 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 249707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249711 */     GIR_RootConstrainSelectedInstOperands,
     /* 249712 */     // GIR_Coverage, 7059,
     /* 249712 */     GIR_EraseRootFromParent_Done,
     /* 249713 */   // Label 5015: @249713
     /* 249713 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(249753), // Rule ID 20 //
     /* 249718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 249721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 249726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 249732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249740 */     // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 249740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 249743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 249745 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 249747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249751 */     GIR_RootConstrainSelectedInstOperands,
     /* 249752 */     // GIR_Coverage, 20,
     /* 249752 */     GIR_EraseRootFromParent_Done,
     /* 249753 */   // Label 5016: @249753
     /* 249753 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(249793), // Rule ID 2375 //
     /* 249758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 249766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 249769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 249776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 249780 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1653:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 249780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 249783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 249785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 249787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249791 */     GIR_RootConstrainSelectedInstOperands,
     /* 249792 */     // GIR_Coverage, 2375,
     /* 249792 */     GIR_EraseRootFromParent_Done,
     /* 249793 */   // Label 5017: @249793
     /* 249793 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(249833), // Rule ID 2486 //
     /* 249798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 249801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 249806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 249809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 249812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249820 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 249820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 249823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 249825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249831 */     GIR_RootConstrainSelectedInstOperands,
     /* 249832 */     // GIR_Coverage, 2486,
     /* 249832 */     GIR_EraseRootFromParent_Done,
     /* 249833 */   // Label 5018: @249833
     /* 249833 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(249873), // Rule ID 2487 //
     /* 249838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 249841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 249846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 249849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 249852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249860 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 249860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 249863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 249865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249871 */     GIR_RootConstrainSelectedInstOperands,
     /* 249872 */     // GIR_Coverage, 2487,
     /* 249872 */     GIR_EraseRootFromParent_Done,
     /* 249873 */   // Label 5019: @249873
     /* 249873 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(249913), // Rule ID 6938 //
     /* 249878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 249881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 249886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 249889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 249892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 249900 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 249900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 249903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 249905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249911 */     GIR_RootConstrainSelectedInstOperands,
     /* 249912 */     // GIR_Coverage, 6938,
     /* 249912 */     GIR_EraseRootFromParent_Done,
     /* 249913 */   // Label 5020: @249913
     /* 249913 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(249953), // Rule ID 6939 //
     /* 249918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 249921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 249926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 249929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 249932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 249940 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 249940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 249943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 249945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 249947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249951 */     GIR_RootConstrainSelectedInstOperands,
     /* 249952 */     // GIR_Coverage, 6939,
     /* 249952 */     GIR_EraseRootFromParent_Done,
     /* 249953 */   // Label 5021: @249953
     /* 249953 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(249989), // Rule ID 3568 //
     /* 249958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 249961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 249966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 249972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249976 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 249976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 249979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249987 */     GIR_RootConstrainSelectedInstOperands,
     /* 249988 */     // GIR_Coverage, 3568,
     /* 249988 */     GIR_EraseRootFromParent_Done,
     /* 249989 */   // Label 5022: @249989
     /* 249989 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(250027), // Rule ID 3982 //
     /* 249994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 249997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 250002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250012 */     // (intrinsic_w_chain:{ *:[i64] } 559:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 250012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 250015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 250023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 250025 */     GIR_RootConstrainSelectedInstOperands,
     /* 250026 */     // GIR_Coverage, 3982,
     /* 250026 */     GIR_EraseRootFromParent_Done,
     /* 250027 */   // Label 5023: @250027
     /* 250027 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(250063), // Rule ID 12417 //
     /* 250032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 250040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250050 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1479:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 250053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250061 */     GIR_RootConstrainSelectedInstOperands,
     /* 250062 */     // GIR_Coverage, 12417,
     /* 250062 */     GIR_EraseRootFromParent_Done,
     /* 250063 */   // Label 5024: @250063
     /* 250063 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(250099), // Rule ID 12418 //
     /* 250068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 250076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250086 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1483:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 250089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250097 */     GIR_RootConstrainSelectedInstOperands,
     /* 250098 */     // GIR_Coverage, 12418,
     /* 250098 */     GIR_EraseRootFromParent_Done,
     /* 250099 */   // Label 5025: @250099
     /* 250099 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(250135), // Rule ID 12419 //
     /* 250104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 250112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250122 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 250125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250133 */     GIR_RootConstrainSelectedInstOperands,
     /* 250134 */     // GIR_Coverage, 12419,
     /* 250134 */     GIR_EraseRootFromParent_Done,
     /* 250135 */   // Label 5026: @250135
     /* 250135 */   GIM_Reject,
     /* 250136 */ // Label 5007: @250136
     /* 250136 */ GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(254108),
     /* 250141 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 250144 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(250241), // Rule ID 7067 //
     /* 250149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 250154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 250168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 250172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 250176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 250180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 250184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 250188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 250192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250197 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 250208 */     // MIs[0] addr
     /* 250208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250216 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 250220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 250222 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 250222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 250225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 250227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 250231 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 250233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 250239 */     GIR_RootConstrainSelectedInstOperands,
     /* 250240 */     // GIR_Coverage, 7067,
     /* 250240 */     GIR_EraseRootFromParent_Done,
     /* 250241 */   // Label 5028: @250241
     /* 250241 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(250338), // Rule ID 7068 //
     /* 250246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 250251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 250265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 250269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 250273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 250277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 250281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 250285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 250289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250294 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 250305 */     // MIs[0] addr
     /* 250305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250313 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 250317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 250319 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 250319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 250322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 250324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 250328 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 250330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 250336 */     GIR_RootConstrainSelectedInstOperands,
     /* 250337 */     // GIR_Coverage, 7068,
     /* 250337 */     GIR_EraseRootFromParent_Done,
     /* 250338 */   // Label 5029: @250338
     /* 250338 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(250435), // Rule ID 7077 //
     /* 250343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 250348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 250362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 250366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 250370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 250374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 250378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 250382 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 250386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250391 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 250402 */     // MIs[0] addr
     /* 250402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250410 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 250414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 250416 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 250416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 250419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 250421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 250425 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 250427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 250433 */     GIR_RootConstrainSelectedInstOperands,
     /* 250434 */     // GIR_Coverage, 7077,
     /* 250434 */     GIR_EraseRootFromParent_Done,
     /* 250435 */   // Label 5030: @250435
     /* 250435 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(250532), // Rule ID 7078 //
     /* 250440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 250445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 250459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 250463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 250467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 250471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 250475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 250479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 250483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250488 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 250499 */     // MIs[0] addr
     /* 250499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250507 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 250511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 250513 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 250513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 250516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 250518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 250522 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 250524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 250530 */     GIR_RootConstrainSelectedInstOperands,
     /* 250531 */     // GIR_Coverage, 7078,
     /* 250531 */     GIR_EraseRootFromParent_Done,
     /* 250532 */   // Label 5031: @250532
     /* 250532 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(250643), // Rule ID 7070 //
     /* 250537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 250542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 250556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 250560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 250564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 250568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250573 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 250584 */     // MIs[0] addr
     /* 250584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250592 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 250596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 250598 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 250598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 250605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250610 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 250616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250621 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 250629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 250631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250634 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 250636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 250641 */     GIR_RootConstrainSelectedInstOperands,
     /* 250642 */     // GIR_Coverage, 7070,
     /* 250642 */     GIR_EraseRootFromParent_Done,
     /* 250643 */   // Label 5032: @250643
     /* 250643 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(250754), // Rule ID 7071 //
     /* 250648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 250653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 250667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 250671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 250675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 250679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250684 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 250695 */     // MIs[0] addr
     /* 250695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250703 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 250707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 250709 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 250709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 250716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250721 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 250727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 250740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 250742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250745 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 250747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 250752 */     GIR_RootConstrainSelectedInstOperands,
     /* 250753 */     // GIR_Coverage, 7071,
     /* 250753 */     GIR_EraseRootFromParent_Done,
     /* 250754 */   // Label 5033: @250754
     /* 250754 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(250865), // Rule ID 7072 //
     /* 250759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 250764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 250778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 250782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 250786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 250790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250795 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 250806 */     // MIs[0] addr
     /* 250806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250814 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 250818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 250820 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 250820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 250827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250832 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 250838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 250851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 250853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250856 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 250858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 250863 */     GIR_RootConstrainSelectedInstOperands,
     /* 250864 */     // GIR_Coverage, 7072,
     /* 250864 */     GIR_EraseRootFromParent_Done,
     /* 250865 */   // Label 5034: @250865
     /* 250865 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(250976), // Rule ID 7080 //
     /* 250870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 250875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 250889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 250893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 250897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 250901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250906 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 250917 */     // MIs[0] addr
     /* 250917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250925 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 250929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 250931 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 250931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 250938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250943 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 250949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 250962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 250964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250967 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 250969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 250974 */     GIR_RootConstrainSelectedInstOperands,
     /* 250975 */     // GIR_Coverage, 7080,
     /* 250975 */     GIR_EraseRootFromParent_Done,
     /* 250976 */   // Label 5035: @250976
     /* 250976 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(251087), // Rule ID 7081 //
     /* 250981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 250986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251017 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 251028 */     // MIs[0] addr
     /* 251028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 251040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251042 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251054 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 251073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251078 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251085 */     GIR_RootConstrainSelectedInstOperands,
     /* 251086 */     // GIR_Coverage, 7081,
     /* 251086 */     GIR_EraseRootFromParent_Done,
     /* 251087 */   // Label 5036: @251087
     /* 251087 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(251198), // Rule ID 7082 //
     /* 251092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251128 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 251139 */     // MIs[0] addr
     /* 251139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251147 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 251151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251153 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251165 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 251184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251189 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251196 */     GIR_RootConstrainSelectedInstOperands,
     /* 251197 */     // GIR_Coverage, 7082,
     /* 251197 */     GIR_EraseRootFromParent_Done,
     /* 251198 */   // Label 5037: @251198
     /* 251198 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(251249), // Rule ID 70 //
     /* 251203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 251208 */     // MIs[0] ptr
     /* 251208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 251212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 251216 */     // MIs[0] accessinfo
     /* 251216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 251219 */     // MIs[0] fixed_shadow
     /* 251219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 251222 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 251222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 251225 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 251227 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 251229 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 251231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 251234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 251237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 251240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 251243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251247 */     GIR_RootConstrainSelectedInstOperands,
     /* 251248 */     // GIR_Coverage, 70,
     /* 251248 */     GIR_EraseRootFromParent_Done,
     /* 251249 */   // Label 5038: @251249
     /* 251249 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(251300), // Rule ID 71 //
     /* 251254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 251259 */     // MIs[0] ptr
     /* 251259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 251263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 251267 */     // MIs[0] accessinfo
     /* 251267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 251270 */     // MIs[0] fixed_shadow
     /* 251270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 251273 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 251273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 251276 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 251278 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 251280 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 251282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 251285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 251288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 251291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 251294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251298 */     GIR_RootConstrainSelectedInstOperands,
     /* 251299 */     // GIR_Coverage, 71,
     /* 251299 */     GIR_EraseRootFromParent_Done,
     /* 251300 */   // Label 5039: @251300
     /* 251300 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(251369), // Rule ID 7069 //
     /* 251305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251337 */     // MIs[0] addr
     /* 251337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251345 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 251349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251351 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 251354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 251360 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251367 */     GIR_RootConstrainSelectedInstOperands,
     /* 251368 */     // GIR_Coverage, 7069,
     /* 251368 */     GIR_EraseRootFromParent_Done,
     /* 251369 */   // Label 5040: @251369
     /* 251369 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(251438), // Rule ID 7079 //
     /* 251374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251406 */     // MIs[0] addr
     /* 251406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 251418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251420 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 251423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 251429 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251436 */     GIR_RootConstrainSelectedInstOperands,
     /* 251437 */     // GIR_Coverage, 7079,
     /* 251437 */     GIR_EraseRootFromParent_Done,
     /* 251438 */   // Label 5041: @251438
     /* 251438 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(251476), // Rule ID 3592 //
     /* 251443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 251446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 251451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251457 */     // MIs[0] tile
     /* 251457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251465 */     // (intrinsic_void 1005:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 251468 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 251472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251474 */     GIR_RootConstrainSelectedInstOperands,
     /* 251475 */     // GIR_Coverage, 3592,
     /* 251475 */     GIR_EraseRootFromParent_Done,
     /* 251476 */   // Label 5042: @251476
     /* 251476 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(251514), // Rule ID 3596 //
     /* 251481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 251484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 251489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 251492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251495 */     // MIs[0] tile
     /* 251495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251503 */     // (intrinsic_void 1005:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 251503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 251506 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 251510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251512 */     GIR_RootConstrainSelectedInstOperands,
     /* 251513 */     // GIR_Coverage, 3596,
     /* 251513 */     GIR_EraseRootFromParent_Done,
     /* 251514 */   // Label 5043: @251514
     /* 251514 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(251552), // Rule ID 3600 //
     /* 251519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 251522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 251527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 251530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251533 */     // MIs[0] tile
     /* 251533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 251541 */     // (intrinsic_void 1009:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 251541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 251544 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 251548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251550 */     GIR_RootConstrainSelectedInstOperands,
     /* 251551 */     // GIR_Coverage, 3600,
     /* 251551 */     GIR_EraseRootFromParent_Done,
     /* 251552 */   // Label 5044: @251552
     /* 251552 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(251590), // Rule ID 3768 //
     /* 251557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 251560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 251565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 251568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251571 */     // MIs[0] tile
     /* 251571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 251579 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 251579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 251582 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 251586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251588 */     GIR_RootConstrainSelectedInstOperands,
     /* 251589 */     // GIR_Coverage, 3768,
     /* 251589 */     GIR_EraseRootFromParent_Done,
     /* 251590 */   // Label 5045: @251590
     /* 251590 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(251628), // Rule ID 3772 //
     /* 251595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 251598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 251603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 251606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251609 */     // MIs[0] tile
     /* 251609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251617 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 251617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 251620 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 251624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251626 */     GIR_RootConstrainSelectedInstOperands,
     /* 251627 */     // GIR_Coverage, 3772,
     /* 251627 */     GIR_EraseRootFromParent_Done,
     /* 251628 */   // Label 5046: @251628
     /* 251628 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(251666), // Rule ID 3776 //
     /* 251633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 251636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 251641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 251644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251647 */     // MIs[0] tile
     /* 251647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251650 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 251655 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 251655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 251658 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 251662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251664 */     GIR_RootConstrainSelectedInstOperands,
     /* 251665 */     // GIR_Coverage, 3776,
     /* 251665 */     GIR_EraseRootFromParent_Done,
     /* 251666 */   // Label 5047: @251666
     /* 251666 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(251704), // Rule ID 3780 //
     /* 251671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 251674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 251679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 251682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251685 */     // MIs[0] tile
     /* 251685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251688 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251693 */     // (intrinsic_void 906:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 251693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 251696 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 251700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251702 */     GIR_RootConstrainSelectedInstOperands,
     /* 251703 */     // GIR_Coverage, 3780,
     /* 251703 */     GIR_EraseRootFromParent_Done,
     /* 251704 */   // Label 5048: @251704
     /* 251704 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(251742), // Rule ID 12496 //
     /* 251709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 251712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 251717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251723 */     // MIs[0] tile
     /* 251723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251731 */     // (intrinsic_void 1013:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 251734 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 251738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251740 */     GIR_RootConstrainSelectedInstOperands,
     /* 251741 */     // GIR_Coverage, 12496,
     /* 251741 */     GIR_EraseRootFromParent_Done,
     /* 251742 */   // Label 5049: @251742
     /* 251742 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(251780), // Rule ID 12500 //
     /* 251747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 251750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 251755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251761 */     // MIs[0] tile
     /* 251761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251764 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251769 */     // (intrinsic_void 1056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 251772 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 251776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251778 */     GIR_RootConstrainSelectedInstOperands,
     /* 251779 */     // GIR_Coverage, 12500,
     /* 251779 */     GIR_EraseRootFromParent_Done,
     /* 251780 */   // Label 5050: @251780
     /* 251780 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(251818), // Rule ID 12504 //
     /* 251785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 251788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 251793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251799 */     // MIs[0] tile
     /* 251799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251807 */     // (intrinsic_void 1064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 251810 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 251814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251816 */     GIR_RootConstrainSelectedInstOperands,
     /* 251817 */     // GIR_Coverage, 12504,
     /* 251817 */     GIR_EraseRootFromParent_Done,
     /* 251818 */   // Label 5051: @251818
     /* 251818 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(251856), // Rule ID 12508 //
     /* 251823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 251826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 251831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251837 */     // MIs[0] tile
     /* 251837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251840 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251845 */     // (intrinsic_void 1172:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 251848 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 251852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251854 */     GIR_RootConstrainSelectedInstOperands,
     /* 251855 */     // GIR_Coverage, 12508,
     /* 251855 */     GIR_EraseRootFromParent_Done,
     /* 251856 */   // Label 5052: @251856
     /* 251856 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(251894), // Rule ID 12512 //
     /* 251861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 251864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 251869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251875 */     // MIs[0] tile
     /* 251875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251878 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251883 */     // (intrinsic_void 1180:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 251886 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 251890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251892 */     GIR_RootConstrainSelectedInstOperands,
     /* 251893 */     // GIR_Coverage, 12512,
     /* 251893 */     GIR_EraseRootFromParent_Done,
     /* 251894 */   // Label 5053: @251894
     /* 251894 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(251932), // Rule ID 12516 //
     /* 251899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 251902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 251907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251913 */     // MIs[0] tile
     /* 251913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251921 */     // (intrinsic_void 1138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 251924 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 251928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251930 */     GIR_RootConstrainSelectedInstOperands,
     /* 251931 */     // GIR_Coverage, 12516,
     /* 251931 */     GIR_EraseRootFromParent_Done,
     /* 251932 */   // Label 5054: @251932
     /* 251932 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(251970), // Rule ID 12520 //
     /* 251937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 251940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 251945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251951 */     // MIs[0] tile
     /* 251951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251959 */     // (intrinsic_void 1146:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 251959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 251962 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 251964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 251966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 251968 */     GIR_RootConstrainSelectedInstOperands,
     /* 251969 */     // GIR_Coverage, 12520,
     /* 251969 */     GIR_EraseRootFromParent_Done,
     /* 251970 */   // Label 5055: @251970
     /* 251970 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(252008), // Rule ID 12524 //
     /* 251975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 251978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 251983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 251986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251989 */     // MIs[0] tile
     /* 251989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 251992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 251997 */     // (intrinsic_void 1013:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 251997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 252000 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252006 */     GIR_RootConstrainSelectedInstOperands,
     /* 252007 */     // GIR_Coverage, 12524,
     /* 252007 */     GIR_EraseRootFromParent_Done,
     /* 252008 */   // Label 5056: @252008
     /* 252008 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(252046), // Rule ID 12528 //
     /* 252013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 252021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252027 */     // MIs[0] tile
     /* 252027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252035 */     // (intrinsic_void 1138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 252038 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252044 */     GIR_RootConstrainSelectedInstOperands,
     /* 252045 */     // GIR_Coverage, 12528,
     /* 252045 */     GIR_EraseRootFromParent_Done,
     /* 252046 */   // Label 5057: @252046
     /* 252046 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(252084), // Rule ID 12532 //
     /* 252051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 252059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252065 */     // MIs[0] tile
     /* 252065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252073 */     // (intrinsic_void 1146:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 252076 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252082 */     GIR_RootConstrainSelectedInstOperands,
     /* 252083 */     // GIR_Coverage, 12532,
     /* 252083 */     GIR_EraseRootFromParent_Done,
     /* 252084 */   // Label 5058: @252084
     /* 252084 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(252122), // Rule ID 12536 //
     /* 252089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 252097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252103 */     // MIs[0] tile
     /* 252103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252106 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252111 */     // (intrinsic_void 1017:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 252114 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252120 */     GIR_RootConstrainSelectedInstOperands,
     /* 252121 */     // GIR_Coverage, 12536,
     /* 252121 */     GIR_EraseRootFromParent_Done,
     /* 252122 */   // Label 5059: @252122
     /* 252122 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(252160), // Rule ID 12540 //
     /* 252127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 252135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252141 */     // MIs[0] tile
     /* 252141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252144 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252149 */     // (intrinsic_void 1060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 252152 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252158 */     GIR_RootConstrainSelectedInstOperands,
     /* 252159 */     // GIR_Coverage, 12540,
     /* 252159 */     GIR_EraseRootFromParent_Done,
     /* 252160 */   // Label 5060: @252160
     /* 252160 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(252198), // Rule ID 12544 //
     /* 252165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 252173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252179 */     // MIs[0] tile
     /* 252179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252187 */     // (intrinsic_void 1068:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 252190 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252196 */     GIR_RootConstrainSelectedInstOperands,
     /* 252197 */     // GIR_Coverage, 12544,
     /* 252197 */     GIR_EraseRootFromParent_Done,
     /* 252198 */   // Label 5061: @252198
     /* 252198 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(252236), // Rule ID 12548 //
     /* 252203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 252211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252217 */     // MIs[0] tile
     /* 252217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252225 */     // (intrinsic_void 1142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 252228 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252234 */     GIR_RootConstrainSelectedInstOperands,
     /* 252235 */     // GIR_Coverage, 12548,
     /* 252235 */     GIR_EraseRootFromParent_Done,
     /* 252236 */   // Label 5062: @252236
     /* 252236 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(252274), // Rule ID 12552 //
     /* 252241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 252249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252255 */     // MIs[0] tile
     /* 252255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252258 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252263 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 252266 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252272 */     GIR_RootConstrainSelectedInstOperands,
     /* 252273 */     // GIR_Coverage, 12552,
     /* 252273 */     GIR_EraseRootFromParent_Done,
     /* 252274 */   // Label 5063: @252274
     /* 252274 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(252312), // Rule ID 12556 //
     /* 252279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 252287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252293 */     // MIs[0] tile
     /* 252293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252301 */     // (intrinsic_void 1176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 252304 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252310 */     GIR_RootConstrainSelectedInstOperands,
     /* 252311 */     // GIR_Coverage, 12556,
     /* 252311 */     GIR_EraseRootFromParent_Done,
     /* 252312 */   // Label 5064: @252312
     /* 252312 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(252350), // Rule ID 12560 //
     /* 252317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 252325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252331 */     // MIs[0] tile
     /* 252331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252339 */     // (intrinsic_void 1184:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 252342 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252348 */     GIR_RootConstrainSelectedInstOperands,
     /* 252349 */     // GIR_Coverage, 12560,
     /* 252349 */     GIR_EraseRootFromParent_Done,
     /* 252350 */   // Label 5065: @252350
     /* 252350 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(252388), // Rule ID 13006 //
     /* 252355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 252363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252369 */     // MIs[0] tile
     /* 252369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252377 */     // (intrinsic_void 914:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 252377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 252380 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252386 */     GIR_RootConstrainSelectedInstOperands,
     /* 252387 */     // GIR_Coverage, 13006,
     /* 252387 */     GIR_EraseRootFromParent_Done,
     /* 252388 */   // Label 5066: @252388
     /* 252388 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(252426), // Rule ID 13010 //
     /* 252393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 252401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252407 */     // MIs[0] tile
     /* 252407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252415 */     // (intrinsic_void 910:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 252415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 252418 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252424 */     GIR_RootConstrainSelectedInstOperands,
     /* 252425 */     // GIR_Coverage, 13010,
     /* 252425 */     GIR_EraseRootFromParent_Done,
     /* 252426 */   // Label 5067: @252426
     /* 252426 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(252464), // Rule ID 13014 //
     /* 252431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 252434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 252439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252445 */     // MIs[0] tile
     /* 252445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252448 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 252453 */     // (intrinsic_void 910:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 252453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 252456 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252462 */     GIR_RootConstrainSelectedInstOperands,
     /* 252463 */     // GIR_Coverage, 13014,
     /* 252463 */     GIR_EraseRootFromParent_Done,
     /* 252464 */   // Label 5068: @252464
     /* 252464 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(252502), // Rule ID 13018 //
     /* 252469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 252472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 252477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252483 */     // MIs[0] tile
     /* 252483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252491 */     // (intrinsic_void 910:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 252491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 252494 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252500 */     GIR_RootConstrainSelectedInstOperands,
     /* 252501 */     // GIR_Coverage, 13018,
     /* 252501 */     GIR_EraseRootFromParent_Done,
     /* 252502 */   // Label 5069: @252502
     /* 252502 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(252556), // Rule ID 8782 //
     /* 252507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 252510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 252515 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 252518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252522 */     // MIs[0] base
     /* 252522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252530 */     // MIs[0] prfop
     /* 252530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 252533 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 252538 */     // (intrinsic_void 1620:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 252538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 252541 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 252543 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 252545 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 252547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252554 */     GIR_RootConstrainSelectedInstOperands,
     /* 252555 */     // GIR_Coverage, 8782,
     /* 252555 */     GIR_EraseRootFromParent_Done,
     /* 252556 */   // Label 5070: @252556
     /* 252556 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(252610), // Rule ID 8785 //
     /* 252561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 252564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 252569 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 252572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252576 */     // MIs[0] base
     /* 252576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252584 */     // MIs[0] prfop
     /* 252584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 252587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 252592 */     // (intrinsic_void 1620:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 252592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 252595 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 252597 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 252599 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 252601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252608 */     GIR_RootConstrainSelectedInstOperands,
     /* 252609 */     // GIR_Coverage, 8785,
     /* 252609 */     GIR_EraseRootFromParent_Done,
     /* 252610 */   // Label 5071: @252610
     /* 252610 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(252664), // Rule ID 8788 //
     /* 252615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 252618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 252623 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 252626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252630 */     // MIs[0] base
     /* 252630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252638 */     // MIs[0] prfop
     /* 252638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 252641 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 252646 */     // (intrinsic_void 1620:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 252646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 252649 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 252651 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 252653 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 252655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252662 */     GIR_RootConstrainSelectedInstOperands,
     /* 252663 */     // GIR_Coverage, 8788,
     /* 252663 */     GIR_EraseRootFromParent_Done,
     /* 252664 */   // Label 5072: @252664
     /* 252664 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(252718), // Rule ID 8791 //
     /* 252669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 252672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 252677 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 252680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 252684 */     // MIs[0] base
     /* 252684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252692 */     // MIs[0] prfop
     /* 252692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 252695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 252700 */     // (intrinsic_void 1620:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 252700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 252703 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 252705 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 252707 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 252709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 252712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252716 */     GIR_RootConstrainSelectedInstOperands,
     /* 252717 */     // GIR_Coverage, 8791,
     /* 252717 */     GIR_EraseRootFromParent_Done,
     /* 252718 */   // Label 5073: @252718
     /* 252718 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(252772), // Rule ID 15 //
     /* 252723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 252728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 252731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 252734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 252737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 252749 */     // MIs[1] Operand 1
     /* 252749 */     // No operand predicates
     /* 252749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252755 */     // (intrinsic_w_chain:{ *:[i64] } 1218:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 252755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 252758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 252760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 252763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 252765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252770 */     GIR_RootConstrainSelectedInstOperands,
     /* 252771 */     // GIR_Coverage, 15,
     /* 252771 */     GIR_EraseRootFromParent_Done,
     /* 252772 */   // Label 5074: @252772
     /* 252772 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(252840), // Rule ID 68 //
     /* 252777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 252782 */     // MIs[0] Operand 1
     /* 252782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 252786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 252790 */     // MIs[0] ptr
     /* 252790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 252798 */     // MIs[0] accessinfo
     /* 252798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 252801 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 252801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252805 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252811 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 252815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 252818 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 252820 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 252822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 252825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 252828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 252831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 252834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252838 */     GIR_RootConstrainSelectedInstOperands,
     /* 252839 */     // GIR_Coverage, 68,
     /* 252839 */     GIR_EraseRootFromParent_Done,
     /* 252840 */   // Label 5075: @252840
     /* 252840 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(252908), // Rule ID 69 //
     /* 252845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 252850 */     // MIs[0] Operand 1
     /* 252850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 252854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 252858 */     // MIs[0] ptr
     /* 252858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 252862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 252866 */     // MIs[0] accessinfo
     /* 252866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 252869 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 252869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252873 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252879 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 252883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 252886 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 252888 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 252890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 252893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 252896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 252899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 252902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252906 */     GIR_RootConstrainSelectedInstOperands,
     /* 252907 */     // GIR_Coverage, 69,
     /* 252907 */     GIR_EraseRootFromParent_Done,
     /* 252908 */   // Label 5076: @252908
     /* 252908 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(252988), // Rule ID 7063 //
     /* 252913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 252918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252932 */     // MIs[0] addr
     /* 252932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252940 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 252944 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 252944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252956 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 252962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 252975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252980 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252986 */     GIR_RootConstrainSelectedInstOperands,
     /* 252987 */     // GIR_Coverage, 7063,
     /* 252987 */     GIR_EraseRootFromParent_Done,
     /* 252988 */   // Label 5077: @252988
     /* 252988 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(253068), // Rule ID 7064 //
     /* 252993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 252998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253012 */     // MIs[0] addr
     /* 253012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253020 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 253024 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253036 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 253055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253060 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253066 */     GIR_RootConstrainSelectedInstOperands,
     /* 253067 */     // GIR_Coverage, 7064,
     /* 253067 */     GIR_EraseRootFromParent_Done,
     /* 253068 */   // Label 5078: @253068
     /* 253068 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(253148), // Rule ID 7065 //
     /* 253073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253092 */     // MIs[0] addr
     /* 253092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 253104 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253116 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 253135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253140 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253146 */     GIR_RootConstrainSelectedInstOperands,
     /* 253147 */     // GIR_Coverage, 7065,
     /* 253147 */     GIR_EraseRootFromParent_Done,
     /* 253148 */   // Label 5079: @253148
     /* 253148 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(253199), // Rule ID 7066 //
     /* 253153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253172 */     // MIs[0] addr
     /* 253172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253180 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 253184 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 253184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 253187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253189 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 253191 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253197 */     GIR_RootConstrainSelectedInstOperands,
     /* 253198 */     // GIR_Coverage, 7066,
     /* 253198 */     GIR_EraseRootFromParent_Done,
     /* 253199 */   // Label 5080: @253199
     /* 253199 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(253279), // Rule ID 7073 //
     /* 253204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 253209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253223 */     // MIs[0] addr
     /* 253223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253231 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 253235 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253247 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 253266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253271 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253277 */     GIR_RootConstrainSelectedInstOperands,
     /* 253278 */     // GIR_Coverage, 7073,
     /* 253278 */     GIR_EraseRootFromParent_Done,
     /* 253279 */   // Label 5081: @253279
     /* 253279 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(253359), // Rule ID 7074 //
     /* 253284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 253289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253303 */     // MIs[0] addr
     /* 253303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253311 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 253315 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253327 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 253346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253351 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253357 */     GIR_RootConstrainSelectedInstOperands,
     /* 253358 */     // GIR_Coverage, 7074,
     /* 253358 */     GIR_EraseRootFromParent_Done,
     /* 253359 */   // Label 5082: @253359
     /* 253359 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(253439), // Rule ID 7075 //
     /* 253364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 253369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253383 */     // MIs[0] addr
     /* 253383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253391 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 253395 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253407 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253418 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 253426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253431 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253437 */     GIR_RootConstrainSelectedInstOperands,
     /* 253438 */     // GIR_Coverage, 7075,
     /* 253438 */     GIR_EraseRootFromParent_Done,
     /* 253439 */   // Label 5083: @253439
     /* 253439 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(253490), // Rule ID 7076 //
     /* 253444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 253449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253463 */     // MIs[0] addr
     /* 253463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253471 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 253475 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 253475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 253478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253480 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 253482 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253488 */     GIR_RootConstrainSelectedInstOperands,
     /* 253489 */     // GIR_Coverage, 7076,
     /* 253489 */     GIR_EraseRootFromParent_Done,
     /* 253490 */   // Label 5084: @253490
     /* 253490 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(253539), // Rule ID 2479 //
     /* 253495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 253498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 253503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 253506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 253509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 253512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253524 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 253524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 253527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 253531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 253533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253537 */     GIR_RootConstrainSelectedInstOperands,
     /* 253538 */     // GIR_Coverage, 2479,
     /* 253538 */     GIR_EraseRootFromParent_Done,
     /* 253539 */   // Label 5085: @253539
     /* 253539 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(253588), // Rule ID 2480 //
     /* 253544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 253547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 253552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 253555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 253558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 253561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253573 */     // (intrinsic_w_chain:{ *:[v16i8] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 253573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 253576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 253580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 253582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253586 */     GIR_RootConstrainSelectedInstOperands,
     /* 253587 */     // GIR_Coverage, 2480,
     /* 253587 */     GIR_EraseRootFromParent_Done,
     /* 253588 */   // Label 5086: @253588
     /* 253588 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(253637), // Rule ID 2481 //
     /* 253593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 253596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 253601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 253604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 253607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 253610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 253614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 253622 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 253622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 253625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 253629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 253631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253635 */     GIR_RootConstrainSelectedInstOperands,
     /* 253636 */     // GIR_Coverage, 2481,
     /* 253636 */     GIR_EraseRootFromParent_Done,
     /* 253637 */   // Label 5087: @253637
     /* 253637 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(253690), // Rule ID 8668 //
     /* 253642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 253650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 253656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253664 */     // MIs[0] base
     /* 253664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253672 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1553:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 253675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 253677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 253679 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 253681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253688 */     GIR_RootConstrainSelectedInstOperands,
     /* 253689 */     // GIR_Coverage, 8668,
     /* 253689 */     GIR_EraseRootFromParent_Done,
     /* 253690 */   // Label 5088: @253690
     /* 253690 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(253743), // Rule ID 8671 //
     /* 253695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 253703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 253709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253717 */     // MIs[0] base
     /* 253717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253725 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1553:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 253728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 253730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 253732 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 253734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253741 */     GIR_RootConstrainSelectedInstOperands,
     /* 253742 */     // GIR_Coverage, 8671,
     /* 253742 */     GIR_EraseRootFromParent_Done,
     /* 253743 */   // Label 5089: @253743
     /* 253743 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(253796), // Rule ID 8680 //
     /* 253748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 253756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 253762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253770 */     // MIs[0] base
     /* 253770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253778 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1552:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 253781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 253783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 253785 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 253787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253794 */     GIR_RootConstrainSelectedInstOperands,
     /* 253795 */     // GIR_Coverage, 8680,
     /* 253795 */     GIR_EraseRootFromParent_Done,
     /* 253796 */   // Label 5090: @253796
     /* 253796 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(253849), // Rule ID 8683 //
     /* 253801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 253809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 253815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253823 */     // MIs[0] base
     /* 253823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253831 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1552:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 253834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 253836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 253838 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 253840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253843 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253847 */     GIR_RootConstrainSelectedInstOperands,
     /* 253848 */     // GIR_Coverage, 8683,
     /* 253848 */     GIR_EraseRootFromParent_Done,
     /* 253849 */   // Label 5091: @253849
     /* 253849 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(253895), // Rule ID 137 //
     /* 253854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 253857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 253862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 253865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 253868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253872 */     // MIs[0] Rn
     /* 253872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253884 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 253884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 253887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 253891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 253893 */     GIR_RootConstrainSelectedInstOperands,
     /* 253894 */     // GIR_Coverage, 137,
     /* 253894 */     GIR_EraseRootFromParent_Done,
     /* 253895 */   // Label 5092: @253895
     /* 253895 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(253948), // Rule ID 8674 //
     /* 253900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 253908 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 253911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 253914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253922 */     // MIs[0] base
     /* 253922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253930 */     // (intrinsic_void 1873:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 253933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 253935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 253937 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 253939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253946 */     GIR_RootConstrainSelectedInstOperands,
     /* 253947 */     // GIR_Coverage, 8674,
     /* 253947 */     GIR_EraseRootFromParent_Done,
     /* 253948 */   // Label 5093: @253948
     /* 253948 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(254001), // Rule ID 8677 //
     /* 253953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 253961 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 253964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 253967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253975 */     // MIs[0] base
     /* 253975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253983 */     // (intrinsic_void 1873:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 253986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 253988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 253990 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 253992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253999 */     GIR_RootConstrainSelectedInstOperands,
     /* 254000 */     // GIR_Coverage, 8677,
     /* 254000 */     GIR_EraseRootFromParent_Done,
     /* 254001 */   // Label 5094: @254001
     /* 254001 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(254054), // Rule ID 8686 //
     /* 254006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 254014 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 254017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254028 */     // MIs[0] base
     /* 254028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254036 */     // (intrinsic_void 1869:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 254039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 254041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254043 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254052 */     GIR_RootConstrainSelectedInstOperands,
     /* 254053 */     // GIR_Coverage, 8686,
     /* 254053 */     GIR_EraseRootFromParent_Done,
     /* 254054 */   // Label 5095: @254054
     /* 254054 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(254107), // Rule ID 8689 //
     /* 254059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 254067 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 254070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254081 */     // MIs[0] base
     /* 254081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254089 */     // (intrinsic_void 1869:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 254092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 254094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254096 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254105 */     GIR_RootConstrainSelectedInstOperands,
     /* 254106 */     // GIR_Coverage, 8689,
     /* 254106 */     GIR_EraseRootFromParent_Done,
     /* 254107 */   // Label 5096: @254107
     /* 254107 */   GIM_Reject,
     /* 254108 */ // Label 5027: @254108
     /* 254108 */ GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(256813),
     /* 254113 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 254116 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(254187), // Rule ID 3404 //
     /* 254121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 254129 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 254132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 254138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 254150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 254158 */     // MIs[1] Operand 1
     /* 254158 */     // No operand predicates
     /* 254158 */     // MIs[0] prfop
     /* 254158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 254161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254168 */     // (intrinsic_void 1622:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 254168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 254171 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 254173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 254175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 254180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254185 */     GIR_RootConstrainSelectedInstOperands,
     /* 254186 */     // GIR_Coverage, 3404,
     /* 254186 */     GIR_EraseRootFromParent_Done,
     /* 254187 */   // Label 5098: @254187
     /* 254187 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(254258), // Rule ID 3417 //
     /* 254192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 254200 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 254203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 254209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 254221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 254229 */     // MIs[1] Operand 1
     /* 254229 */     // No operand predicates
     /* 254229 */     // MIs[0] prfop
     /* 254229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 254232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254239 */     // (intrinsic_void 1622:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 254239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 254242 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 254244 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 254246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 254251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254256 */     GIR_RootConstrainSelectedInstOperands,
     /* 254257 */     // GIR_Coverage, 3417,
     /* 254257 */     GIR_EraseRootFromParent_Done,
     /* 254258 */   // Label 5099: @254258
     /* 254258 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(254317), // Rule ID 3604 //
     /* 254263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 254266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 254271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 254277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254280 */     // MIs[0] tile
     /* 254280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254300 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 254300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 254303 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254305 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 254307 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 254309 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 254311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254315 */     GIR_RootConstrainSelectedInstOperands,
     /* 254316 */     // GIR_Coverage, 3604,
     /* 254316 */     GIR_EraseRootFromParent_Done,
     /* 254317 */   // Label 5100: @254317
     /* 254317 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(254376), // Rule ID 3605 //
     /* 254322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 254325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 254330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 254336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254339 */     // MIs[0] tile
     /* 254339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 254347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254359 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 254359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 254362 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254364 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 254366 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 254368 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 254370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254374 */     GIR_RootConstrainSelectedInstOperands,
     /* 254375 */     // GIR_Coverage, 3605,
     /* 254375 */     GIR_EraseRootFromParent_Done,
     /* 254376 */   // Label 5101: @254376
     /* 254376 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(254435), // Rule ID 12477 //
     /* 254381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 254384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 254389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 254395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254398 */     // MIs[0] tile
     /* 254398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 254406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254418 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 254418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 254421 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254423 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 254425 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 254427 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 254429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254433 */     GIR_RootConstrainSelectedInstOperands,
     /* 254434 */     // GIR_Coverage, 12477,
     /* 254434 */     GIR_EraseRootFromParent_Done,
     /* 254435 */   // Label 5102: @254435
     /* 254435 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(254494), // Rule ID 12478 //
     /* 254440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 254443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 254448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 254454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254457 */     // MIs[0] tile
     /* 254457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 254460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 254465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254477 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 254477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 254480 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 254482 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 254484 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 254486 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 254488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254492 */     GIR_RootConstrainSelectedInstOperands,
     /* 254493 */     // GIR_Coverage, 12478,
     /* 254493 */     GIR_EraseRootFromParent_Done,
     /* 254494 */   // Label 5103: @254494
     /* 254494 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(254554), // Rule ID 3402 //
     /* 254499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 254507 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 254510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254517 */     // MIs[0] Rn
     /* 254517 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254529 */     // MIs[0] prfop
     /* 254529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 254532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254537 */     // (intrinsic_void 1624:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 254537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 254540 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 254542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 254544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254552 */     GIR_RootConstrainSelectedInstOperands,
     /* 254553 */     // GIR_Coverage, 3402,
     /* 254553 */     GIR_EraseRootFromParent_Done,
     /* 254554 */   // Label 5104: @254554
     /* 254554 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(254614), // Rule ID 3403 //
     /* 254559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 254567 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 254570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254577 */     // MIs[0] Rn
     /* 254577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254589 */     // MIs[0] prfop
     /* 254589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 254592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254597 */     // (intrinsic_void 1623:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 254597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 254600 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 254602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 254604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254612 */     GIR_RootConstrainSelectedInstOperands,
     /* 254613 */     // GIR_Coverage, 3403,
     /* 254613 */     GIR_EraseRootFromParent_Done,
     /* 254614 */   // Label 5105: @254614
     /* 254614 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(254674), // Rule ID 3414 //
     /* 254619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 254627 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 254630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254637 */     // MIs[0] Rn
     /* 254637 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254649 */     // MIs[0] prfop
     /* 254649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 254652 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254657 */     // (intrinsic_void 1624:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 254657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 254660 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 254662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 254664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254672 */     GIR_RootConstrainSelectedInstOperands,
     /* 254673 */     // GIR_Coverage, 3414,
     /* 254673 */     GIR_EraseRootFromParent_Done,
     /* 254674 */   // Label 5106: @254674
     /* 254674 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(254734), // Rule ID 3415 //
     /* 254679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 254687 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 254690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254697 */     // MIs[0] Rn
     /* 254697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254709 */     // MIs[0] prfop
     /* 254709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 254712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254717 */     // (intrinsic_void 1623:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 254717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 254720 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 254722 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 254724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254732 */     GIR_RootConstrainSelectedInstOperands,
     /* 254733 */     // GIR_Coverage, 3415,
     /* 254733 */     GIR_EraseRootFromParent_Done,
     /* 254734 */   // Label 5107: @254734
     /* 254734 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(254794), // Rule ID 3416 //
     /* 254739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 254747 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 254750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254757 */     // MIs[0] Rn
     /* 254757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254769 */     // MIs[0] prfop
     /* 254769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 254772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254777 */     // (intrinsic_void 1621:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 254777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 254780 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 254782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 254784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254792 */     GIR_RootConstrainSelectedInstOperands,
     /* 254793 */     // GIR_Coverage, 3416,
     /* 254793 */     GIR_EraseRootFromParent_Done,
     /* 254794 */   // Label 5108: @254794
     /* 254794 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(254854), // Rule ID 8794 //
     /* 254799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 254807 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 254810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254817 */     // MIs[0] Rn
     /* 254817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254829 */     // MIs[0] prfop
     /* 254829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 254832 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254837 */     // (intrinsic_void 1632:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 254837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 254840 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 254842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 254844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254852 */     GIR_RootConstrainSelectedInstOperands,
     /* 254853 */     // GIR_Coverage, 8794,
     /* 254853 */     GIR_EraseRootFromParent_Done,
     /* 254854 */   // Label 5109: @254854
     /* 254854 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(254914), // Rule ID 8795 //
     /* 254859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 254867 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 254870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254877 */     // MIs[0] Rn
     /* 254877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254889 */     // MIs[0] prfop
     /* 254889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 254892 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254897 */     // (intrinsic_void 1631:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 254897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 254900 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 254902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 254904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254912 */     GIR_RootConstrainSelectedInstOperands,
     /* 254913 */     // GIR_Coverage, 8795,
     /* 254913 */     GIR_EraseRootFromParent_Done,
     /* 254914 */   // Label 5110: @254914
     /* 254914 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(254974), // Rule ID 8796 //
     /* 254919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 254927 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 254930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254937 */     // MIs[0] Rn
     /* 254937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254949 */     // MIs[0] prfop
     /* 254949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 254952 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254957 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 254957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 254960 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 254962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 254964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 254968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254972 */     GIR_RootConstrainSelectedInstOperands,
     /* 254973 */     // GIR_Coverage, 8796,
     /* 254973 */     GIR_EraseRootFromParent_Done,
     /* 254974 */   // Label 5111: @254974
     /* 254974 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(255034), // Rule ID 8797 //
     /* 254979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 254987 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 254990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254997 */     // MIs[0] Rn
     /* 254997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255009 */     // MIs[0] prfop
     /* 255009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255017 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 255017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 255020 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255032 */     GIR_RootConstrainSelectedInstOperands,
     /* 255033 */     // GIR_Coverage, 8797,
     /* 255033 */     GIR_EraseRootFromParent_Done,
     /* 255034 */   // Label 5112: @255034
     /* 255034 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(255094), // Rule ID 8798 //
     /* 255039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 255047 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255057 */     // MIs[0] Rn
     /* 255057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255069 */     // MIs[0] prfop
     /* 255069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255077 */     // (intrinsic_void 1628:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 255077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 255080 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255092 */     GIR_RootConstrainSelectedInstOperands,
     /* 255093 */     // GIR_Coverage, 8798,
     /* 255093 */     GIR_EraseRootFromParent_Done,
     /* 255094 */   // Label 5113: @255094
     /* 255094 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(255154), // Rule ID 8799 //
     /* 255099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 255107 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255117 */     // MIs[0] Rn
     /* 255117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255129 */     // MIs[0] prfop
     /* 255129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255132 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255137 */     // (intrinsic_void 1627:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 255137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 255140 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255152 */     GIR_RootConstrainSelectedInstOperands,
     /* 255153 */     // GIR_Coverage, 8799,
     /* 255153 */     GIR_EraseRootFromParent_Done,
     /* 255154 */   // Label 5114: @255154
     /* 255154 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(255214), // Rule ID 8800 //
     /* 255159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 255167 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255177 */     // MIs[0] Rn
     /* 255177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255189 */     // MIs[0] prfop
     /* 255189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255192 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255197 */     // (intrinsic_void 1632:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 255197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 255200 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255212 */     GIR_RootConstrainSelectedInstOperands,
     /* 255213 */     // GIR_Coverage, 8800,
     /* 255213 */     GIR_EraseRootFromParent_Done,
     /* 255214 */   // Label 5115: @255214
     /* 255214 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(255274), // Rule ID 8801 //
     /* 255219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 255227 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255237 */     // MIs[0] Rn
     /* 255237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255249 */     // MIs[0] prfop
     /* 255249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255257 */     // (intrinsic_void 1631:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 255257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 255260 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255272 */     GIR_RootConstrainSelectedInstOperands,
     /* 255273 */     // GIR_Coverage, 8801,
     /* 255273 */     GIR_EraseRootFromParent_Done,
     /* 255274 */   // Label 5116: @255274
     /* 255274 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(255334), // Rule ID 8802 //
     /* 255279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 255287 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255297 */     // MIs[0] Rn
     /* 255297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255309 */     // MIs[0] prfop
     /* 255309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255312 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255317 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 255317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 255320 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255332 */     GIR_RootConstrainSelectedInstOperands,
     /* 255333 */     // GIR_Coverage, 8802,
     /* 255333 */     GIR_EraseRootFromParent_Done,
     /* 255334 */   // Label 5117: @255334
     /* 255334 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(255394), // Rule ID 8803 //
     /* 255339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 255347 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255357 */     // MIs[0] Rn
     /* 255357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255369 */     // MIs[0] prfop
     /* 255369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255377 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 255377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 255380 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255392 */     GIR_RootConstrainSelectedInstOperands,
     /* 255393 */     // GIR_Coverage, 8803,
     /* 255393 */     GIR_EraseRootFromParent_Done,
     /* 255394 */   // Label 5118: @255394
     /* 255394 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(255454), // Rule ID 8804 //
     /* 255399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 255407 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255417 */     // MIs[0] Rn
     /* 255417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255429 */     // MIs[0] prfop
     /* 255429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255437 */     // (intrinsic_void 1628:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 255437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 255440 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255452 */     GIR_RootConstrainSelectedInstOperands,
     /* 255453 */     // GIR_Coverage, 8804,
     /* 255453 */     GIR_EraseRootFromParent_Done,
     /* 255454 */   // Label 5119: @255454
     /* 255454 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(255514), // Rule ID 8805 //
     /* 255459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 255467 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255477 */     // MIs[0] Rn
     /* 255477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255489 */     // MIs[0] prfop
     /* 255489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255497 */     // (intrinsic_void 1627:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 255497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 255500 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255512 */     GIR_RootConstrainSelectedInstOperands,
     /* 255513 */     // GIR_Coverage, 8805,
     /* 255513 */     GIR_EraseRootFromParent_Done,
     /* 255514 */   // Label 5120: @255514
     /* 255514 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(255574), // Rule ID 8806 //
     /* 255519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 255527 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255537 */     // MIs[0] Rn
     /* 255537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255549 */     // MIs[0] prfop
     /* 255549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255557 */     // (intrinsic_void 1629:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 255557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 255560 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255572 */     GIR_RootConstrainSelectedInstOperands,
     /* 255573 */     // GIR_Coverage, 8806,
     /* 255573 */     GIR_EraseRootFromParent_Done,
     /* 255574 */   // Label 5121: @255574
     /* 255574 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(255634), // Rule ID 8807 //
     /* 255579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 255587 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255597 */     // MIs[0] Rn
     /* 255597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255609 */     // MIs[0] prfop
     /* 255609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255617 */     // (intrinsic_void 1633:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 255617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 255620 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255632 */     GIR_RootConstrainSelectedInstOperands,
     /* 255633 */     // GIR_Coverage, 8807,
     /* 255633 */     GIR_EraseRootFromParent_Done,
     /* 255634 */   // Label 5122: @255634
     /* 255634 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(255694), // Rule ID 8808 //
     /* 255639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 255647 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255657 */     // MIs[0] Rn
     /* 255657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255669 */     // MIs[0] prfop
     /* 255669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255677 */     // (intrinsic_void 1625:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 255677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 255680 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255682 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255692 */     GIR_RootConstrainSelectedInstOperands,
     /* 255693 */     // GIR_Coverage, 8808,
     /* 255693 */     GIR_EraseRootFromParent_Done,
     /* 255694 */   // Label 5123: @255694
     /* 255694 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(255752), // Rule ID 2365 //
     /* 255699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 255702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 255707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 255710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 255713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 255716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 255719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255735 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 255735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 255738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 255742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 255744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 255746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255750 */     GIR_RootConstrainSelectedInstOperands,
     /* 255751 */     // GIR_Coverage, 2365,
     /* 255751 */     GIR_EraseRootFromParent_Done,
     /* 255752 */   // Label 5124: @255752
     /* 255752 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(255810), // Rule ID 2366 //
     /* 255757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 255760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 255765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 255768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 255771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 255774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 255777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255793 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 255793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 255796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 255800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 255802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 255804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255808 */     GIR_RootConstrainSelectedInstOperands,
     /* 255809 */     // GIR_Coverage, 2366,
     /* 255809 */     GIR_EraseRootFromParent_Done,
     /* 255810 */   // Label 5125: @255810
     /* 255810 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(255868), // Rule ID 2367 //
     /* 255815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 255818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 255823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 255826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 255829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 255832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 255835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255851 */     // (intrinsic_w_chain:{ *:[v4f32] } 621:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 255851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 255854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 255858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 255860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 255862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255866 */     GIR_RootConstrainSelectedInstOperands,
     /* 255867 */     // GIR_Coverage, 2367,
     /* 255867 */     GIR_EraseRootFromParent_Done,
     /* 255868 */   // Label 5126: @255868
     /* 255868 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(255926), // Rule ID 2368 //
     /* 255873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 255876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 255881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 255884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 255887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 255890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 255893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255909 */     // (intrinsic_w_chain:{ *:[v4f32] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 255909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 255912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 255916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 255918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 255920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255924 */     GIR_RootConstrainSelectedInstOperands,
     /* 255925 */     // GIR_Coverage, 2368,
     /* 255925 */     GIR_EraseRootFromParent_Done,
     /* 255926 */   // Label 5127: @255926
     /* 255926 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(255984), // Rule ID 2369 //
     /* 255931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 255934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 255939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 255942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 255945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 255948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 255951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 255967 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 255967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 255970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 255972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 255974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 255976 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 255978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255982 */     GIR_RootConstrainSelectedInstOperands,
     /* 255983 */     // GIR_Coverage, 2369,
     /* 255983 */     GIR_EraseRootFromParent_Done,
     /* 255984 */   // Label 5128: @255984
     /* 255984 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(256042), // Rule ID 2370 //
     /* 255989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 255992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 255997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256025 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 256028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256040 */     GIR_RootConstrainSelectedInstOperands,
     /* 256041 */     // GIR_Coverage, 2370,
     /* 256041 */     GIR_EraseRootFromParent_Done,
     /* 256042 */   // Label 5129: @256042
     /* 256042 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(256100), // Rule ID 2371 //
     /* 256047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 256050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 256055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 256058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 256067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256083 */     // (intrinsic_w_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 256083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 256086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256098 */     GIR_RootConstrainSelectedInstOperands,
     /* 256099 */     // GIR_Coverage, 2371,
     /* 256099 */     GIR_EraseRootFromParent_Done,
     /* 256100 */   // Label 5130: @256100
     /* 256100 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(256158), // Rule ID 2372 //
     /* 256105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 256108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 256113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256141 */     // (intrinsic_w_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 256144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256156 */     GIR_RootConstrainSelectedInstOperands,
     /* 256157 */     // GIR_Coverage, 2372,
     /* 256157 */     GIR_EraseRootFromParent_Done,
     /* 256158 */   // Label 5131: @256158
     /* 256158 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(256216), // Rule ID 2373 //
     /* 256163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 256166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 256171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 256174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 256177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 256183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256199 */     // (intrinsic_w_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 256199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 256202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256214 */     GIR_RootConstrainSelectedInstOperands,
     /* 256215 */     // GIR_Coverage, 2373,
     /* 256215 */     GIR_EraseRootFromParent_Done,
     /* 256216 */   // Label 5132: @256216
     /* 256216 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(256274), // Rule ID 2374 //
     /* 256221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 256224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 256229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256257 */     // (intrinsic_w_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 256260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256272 */     GIR_RootConstrainSelectedInstOperands,
     /* 256273 */     // GIR_Coverage, 2374,
     /* 256273 */     GIR_EraseRootFromParent_Done,
     /* 256274 */   // Label 5133: @256274
     /* 256274 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(256332), // Rule ID 2482 //
     /* 256279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 256282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 256287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 256290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 256293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 256296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 256299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256315 */     // (intrinsic_w_chain:{ *:[v16i8] } 614:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 256315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 256318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256320 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 256322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256330 */     GIR_RootConstrainSelectedInstOperands,
     /* 256331 */     // GIR_Coverage, 2482,
     /* 256331 */     GIR_EraseRootFromParent_Done,
     /* 256332 */   // Label 5134: @256332
     /* 256332 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(256388), // Rule ID 13035 //
     /* 256337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 256342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 256351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256363 */     // MIs[0] addr
     /* 256363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 256367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256371 */     // (intrinsic_w_chain:{ *:[i32] } 1224:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 256371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 256374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256376 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 256378 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 256380 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 256382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256386 */     GIR_RootConstrainSelectedInstOperands,
     /* 256387 */     // GIR_Coverage, 13035,
     /* 256387 */     GIR_EraseRootFromParent_Done,
     /* 256388 */   // Label 5135: @256388
     /* 256388 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(256444), // Rule ID 13036 //
     /* 256393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 256398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 256401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 256404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 256407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 256411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256419 */     // MIs[0] addr
     /* 256419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 256423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 256427 */     // (intrinsic_w_chain:{ *:[i32] } 1226:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 256427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 256430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 256432 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 256434 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 256436 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 256438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256442 */     GIR_RootConstrainSelectedInstOperands,
     /* 256443 */     // GIR_Coverage, 13036,
     /* 256443 */     GIR_EraseRootFromParent_Done,
     /* 256444 */   // Label 5136: @256444
     /* 256444 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(256490), // Rule ID 3450 //
     /* 256449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 256452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 256457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256473 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1489:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 256476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256488 */     GIR_RootConstrainSelectedInstOperands,
     /* 256489 */     // GIR_Coverage, 3450,
     /* 256489 */     GIR_EraseRootFromParent_Done,
     /* 256490 */   // Label 5137: @256490
     /* 256490 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(256536), // Rule ID 3572 //
     /* 256495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 256498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 256503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256519 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1491:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 256522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256534 */     GIR_RootConstrainSelectedInstOperands,
     /* 256535 */     // GIR_Coverage, 3572,
     /* 256535 */     GIR_EraseRootFromParent_Done,
     /* 256536 */   // Label 5138: @256536
     /* 256536 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(256582), // Rule ID 12464 //
     /* 256541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 256544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 256549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256565 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1501:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 256568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256580 */     GIR_RootConstrainSelectedInstOperands,
     /* 256581 */     // GIR_Coverage, 12464,
     /* 256581 */     GIR_EraseRootFromParent_Done,
     /* 256582 */   // Label 5139: @256582
     /* 256582 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(256628), // Rule ID 12468 //
     /* 256587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 256590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 256595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256611 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1493:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 256614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256620 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256626 */     GIR_RootConstrainSelectedInstOperands,
     /* 256627 */     // GIR_Coverage, 12468,
     /* 256627 */     GIR_EraseRootFromParent_Done,
     /* 256628 */   // Label 5140: @256628
     /* 256628 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(256674), // Rule ID 12469 //
     /* 256633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 256636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 256641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256657 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1495:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 256660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256672 */     GIR_RootConstrainSelectedInstOperands,
     /* 256673 */     // GIR_Coverage, 12469,
     /* 256673 */     GIR_EraseRootFromParent_Done,
     /* 256674 */   // Label 5141: @256674
     /* 256674 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(256720), // Rule ID 12470 //
     /* 256679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 256682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 256687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256703 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1497:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 256706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256718 */     GIR_RootConstrainSelectedInstOperands,
     /* 256719 */     // GIR_Coverage, 12470,
     /* 256719 */     GIR_EraseRootFromParent_Done,
     /* 256720 */   // Label 5142: @256720
     /* 256720 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(256766), // Rule ID 12471 //
     /* 256725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 256728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 256733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256749 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1499:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 256752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256764 */     GIR_RootConstrainSelectedInstOperands,
     /* 256765 */     // GIR_Coverage, 12471,
     /* 256765 */     GIR_EraseRootFromParent_Done,
     /* 256766 */   // Label 5143: @256766
     /* 256766 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(256812), // Rule ID 12472 //
     /* 256771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 256774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 256779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256795 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1489:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 256798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256810 */     GIR_RootConstrainSelectedInstOperands,
     /* 256811 */     // GIR_Coverage, 12472,
     /* 256811 */     GIR_EraseRootFromParent_Done,
     /* 256812 */   // Label 5144: @256812
     /* 256812 */   GIM_Reject,
     /* 256813 */ // Label 5097: @256813
     /* 256813 */ GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(259806),
     /* 256818 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 256821 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(256889), // Rule ID 2509 //
     /* 256826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 256834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 256862 */     // MIs[0] Idx
     /* 256862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 256865 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 256870 */     // (intrinsic_w_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 256870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 256873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256881 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 256883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256887 */     GIR_RootConstrainSelectedInstOperands,
     /* 256888 */     // GIR_Coverage, 2509,
     /* 256888 */     GIR_EraseRootFromParent_Done,
     /* 256889 */   // Label 5146: @256889
     /* 256889 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(256957), // Rule ID 2510 //
     /* 256894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 256902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 256930 */     // MIs[0] Idx
     /* 256930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 256933 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 256938 */     // (intrinsic_w_chain:{ *:[v4f32] } 622:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 256938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 256941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256949 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 256951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256955 */     GIR_RootConstrainSelectedInstOperands,
     /* 256956 */     // GIR_Coverage, 2510,
     /* 256956 */     GIR_EraseRootFromParent_Done,
     /* 256957 */   // Label 5147: @256957
     /* 256957 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(257025), // Rule ID 2511 //
     /* 256962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 256965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 256970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 256973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 256976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256998 */     // MIs[0] Idx
     /* 256998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 257006 */     // (intrinsic_w_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 257009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257017 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257023 */     GIR_RootConstrainSelectedInstOperands,
     /* 257024 */     // GIR_Coverage, 2511,
     /* 257024 */     GIR_EraseRootFromParent_Done,
     /* 257025 */   // Label 5148: @257025
     /* 257025 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(257093), // Rule ID 2512 //
     /* 257030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 257033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 257038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257066 */     // MIs[0] Idx
     /* 257066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 257074 */     // (intrinsic_w_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 257077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257085 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257091 */     GIR_RootConstrainSelectedInstOperands,
     /* 257092 */     // GIR_Coverage, 2512,
     /* 257092 */     GIR_EraseRootFromParent_Done,
     /* 257093 */   // Label 5149: @257093
     /* 257093 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(257161), // Rule ID 2513 //
     /* 257098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 257101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 257106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 257109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 257134 */     // MIs[0] Idx
     /* 257134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 257142 */     // (intrinsic_w_chain:{ *:[v4f16] } 616:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 257145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257151 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257153 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257159 */     GIR_RootConstrainSelectedInstOperands,
     /* 257160 */     // GIR_Coverage, 2513,
     /* 257160 */     GIR_EraseRootFromParent_Done,
     /* 257161 */   // Label 5150: @257161
     /* 257161 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(257229), // Rule ID 2514 //
     /* 257166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 257169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 257174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 257202 */     // MIs[0] Idx
     /* 257202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257205 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 257210 */     // (intrinsic_w_chain:{ *:[v8f16] } 616:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 257213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257219 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257221 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257227 */     GIR_RootConstrainSelectedInstOperands,
     /* 257228 */     // GIR_Coverage, 2514,
     /* 257228 */     GIR_EraseRootFromParent_Done,
     /* 257229 */   // Label 5151: @257229
     /* 257229 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(257297), // Rule ID 6940 //
     /* 257234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 257242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 257270 */     // MIs[0] Idx
     /* 257270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257273 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 257278 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 257281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257287 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257289 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257295 */     GIR_RootConstrainSelectedInstOperands,
     /* 257296 */     // GIR_Coverage, 6940,
     /* 257296 */     GIR_EraseRootFromParent_Done,
     /* 257297 */   // Label 5152: @257297
     /* 257297 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(257365), // Rule ID 6941 //
     /* 257302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 257310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 257338 */     // MIs[0] Idx
     /* 257338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257341 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 257346 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 257349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257357 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257363 */     GIR_RootConstrainSelectedInstOperands,
     /* 257364 */     // GIR_Coverage, 6941,
     /* 257364 */     GIR_EraseRootFromParent_Done,
     /* 257365 */   // Label 5153: @257365
     /* 257365 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(257433), // Rule ID 6942 //
     /* 257370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 257378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 257406 */     // MIs[0] Idx
     /* 257406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257409 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 257414 */     // (intrinsic_w_chain:{ *:[v4f32] } 626:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 257417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257425 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257431 */     GIR_RootConstrainSelectedInstOperands,
     /* 257432 */     // GIR_Coverage, 6942,
     /* 257432 */     GIR_EraseRootFromParent_Done,
     /* 257433 */   // Label 5154: @257433
     /* 257433 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(257501), // Rule ID 6943 //
     /* 257438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 257446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 257474 */     // MIs[0] Idx
     /* 257474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 257482 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 257485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257493 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257499 */     GIR_RootConstrainSelectedInstOperands,
     /* 257500 */     // GIR_Coverage, 6943,
     /* 257500 */     GIR_EraseRootFromParent_Done,
     /* 257501 */   // Label 5155: @257501
     /* 257501 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(257561), // Rule ID 3584 //
     /* 257506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 257509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 257514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 257520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 257526 */     // MIs[0] tile
     /* 257526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257529 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 257534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257542 */     // (intrinsic_void 918:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 257542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 257545 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 257549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 257551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 257553 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 257555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257559 */     GIR_RootConstrainSelectedInstOperands,
     /* 257560 */     // GIR_Coverage, 3584,
     /* 257560 */     GIR_EraseRootFromParent_Done,
     /* 257561 */   // Label 5156: @257561
     /* 257561 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(257621), // Rule ID 3585 //
     /* 257566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 257569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 257574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 257577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 257580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 257586 */     // MIs[0] tile
     /* 257586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 257594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257602 */     // (intrinsic_void 872:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 257602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 257605 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 257609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 257611 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 257613 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 257615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257619 */     GIR_RootConstrainSelectedInstOperands,
     /* 257620 */     // GIR_Coverage, 3585,
     /* 257620 */     GIR_EraseRootFromParent_Done,
     /* 257621 */   // Label 5157: @257621
     /* 257621 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(257681), // Rule ID 3586 //
     /* 257626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 257629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 257634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 257640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 257646 */     // MIs[0] tile
     /* 257646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257649 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 257654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257662 */     // (intrinsic_void 918:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 257662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 257665 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 257669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 257671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 257673 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 257675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257679 */     GIR_RootConstrainSelectedInstOperands,
     /* 257680 */     // GIR_Coverage, 3586,
     /* 257680 */     GIR_EraseRootFromParent_Done,
     /* 257681 */   // Label 5158: @257681
     /* 257681 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(257741), // Rule ID 3587 //
     /* 257686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 257689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 257694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 257697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 257700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 257706 */     // MIs[0] tile
     /* 257706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257709 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 257714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257722 */     // (intrinsic_void 871:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 257722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 257725 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 257729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 257731 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 257733 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 257735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257739 */     GIR_RootConstrainSelectedInstOperands,
     /* 257740 */     // GIR_Coverage, 3587,
     /* 257740 */     GIR_EraseRootFromParent_Done,
     /* 257741 */   // Label 5159: @257741
     /* 257741 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(257801), // Rule ID 3588 //
     /* 257746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 257749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 257754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 257760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 257766 */     // MIs[0] tile
     /* 257766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 257774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257782 */     // (intrinsic_void 918:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 257782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 257785 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 257789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 257791 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 257793 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 257795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257799 */     GIR_RootConstrainSelectedInstOperands,
     /* 257800 */     // GIR_Coverage, 3588,
     /* 257800 */     GIR_EraseRootFromParent_Done,
     /* 257801 */   // Label 5160: @257801
     /* 257801 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(257861), // Rule ID 3589 //
     /* 257806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 257809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 257814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 257817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 257820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 257826 */     // MIs[0] tile
     /* 257826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257829 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 257834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257842 */     // (intrinsic_void 1021:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 257842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 257845 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 257849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 257851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 257853 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 257855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257859 */     GIR_RootConstrainSelectedInstOperands,
     /* 257860 */     // GIR_Coverage, 3589,
     /* 257860 */     GIR_EraseRootFromParent_Done,
     /* 257861 */   // Label 5161: @257861
     /* 257861 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(257921), // Rule ID 3590 //
     /* 257866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 257869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 257874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 257880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 257886 */     // MIs[0] tile
     /* 257886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257889 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 257894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257902 */     // (intrinsic_void 1021:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 257902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 257905 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 257909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 257911 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 257913 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 257915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257919 */     GIR_RootConstrainSelectedInstOperands,
     /* 257920 */     // GIR_Coverage, 3590,
     /* 257920 */     GIR_EraseRootFromParent_Done,
     /* 257921 */   // Label 5162: @257921
     /* 257921 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(257981), // Rule ID 3591 //
     /* 257926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 257929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 257934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 257940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 257946 */     // MIs[0] tile
     /* 257946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 257949 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 257954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 257962 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 257962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 257965 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 257967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 257969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 257971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 257973 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 257975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257979 */     GIR_RootConstrainSelectedInstOperands,
     /* 257980 */     // GIR_Coverage, 3591,
     /* 257980 */     GIR_EraseRootFromParent_Done,
     /* 257981 */   // Label 5163: @257981
     /* 257981 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(258041), // Rule ID 3685 //
     /* 257986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 257989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 257994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258006 */     // MIs[0] tile
     /* 258006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258022 */     // (intrinsic_void 1022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 258022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 258025 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258033 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258039 */     GIR_RootConstrainSelectedInstOperands,
     /* 258040 */     // GIR_Coverage, 3685,
     /* 258040 */     GIR_EraseRootFromParent_Done,
     /* 258041 */   // Label 5164: @258041
     /* 258041 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(258101), // Rule ID 3686 //
     /* 258046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 258049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 258054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 258060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258066 */     // MIs[0] tile
     /* 258066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258082 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 258082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 258085 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258093 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258099 */     GIR_RootConstrainSelectedInstOperands,
     /* 258100 */     // GIR_Coverage, 3686,
     /* 258100 */     GIR_EraseRootFromParent_Done,
     /* 258101 */   // Label 5165: @258101
     /* 258101 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(258161), // Rule ID 12479 //
     /* 258106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 258114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 258120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258126 */     // MIs[0] tile
     /* 258126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258142 */     // (intrinsic_void 921:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 258142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 258145 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258151 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258153 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258159 */     GIR_RootConstrainSelectedInstOperands,
     /* 258160 */     // GIR_Coverage, 12479,
     /* 258160 */     GIR_EraseRootFromParent_Done,
     /* 258161 */   // Label 5166: @258161
     /* 258161 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(258221), // Rule ID 12480 //
     /* 258166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 258169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 258174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 258180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 258186 */     // MIs[0] tile
     /* 258186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258202 */     // (intrinsic_void 921:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 258202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 258205 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258213 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258219 */     GIR_RootConstrainSelectedInstOperands,
     /* 258220 */     // GIR_Coverage, 12480,
     /* 258220 */     GIR_EraseRootFromParent_Done,
     /* 258221 */   // Label 5167: @258221
     /* 258221 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(258281), // Rule ID 12481 //
     /* 258226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 258234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258246 */     // MIs[0] tile
     /* 258246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258249 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258262 */     // (intrinsic_void 923:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 258262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 258265 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258273 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258279 */     GIR_RootConstrainSelectedInstOperands,
     /* 258280 */     // GIR_Coverage, 12481,
     /* 258280 */     GIR_EraseRootFromParent_Done,
     /* 258281 */   // Label 5168: @258281
     /* 258281 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(258341), // Rule ID 12482 //
     /* 258286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 258294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258306 */     // MIs[0] tile
     /* 258306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258309 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258322 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 258325 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258333 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258339 */     GIR_RootConstrainSelectedInstOperands,
     /* 258340 */     // GIR_Coverage, 12482,
     /* 258340 */     GIR_EraseRootFromParent_Done,
     /* 258341 */   // Label 5169: @258341
     /* 258341 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(258401), // Rule ID 12483 //
     /* 258346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 258354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258366 */     // MIs[0] tile
     /* 258366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258382 */     // (intrinsic_void 1154:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 258385 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258393 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258399 */     GIR_RootConstrainSelectedInstOperands,
     /* 258400 */     // GIR_Coverage, 12483,
     /* 258400 */     GIR_EraseRootFromParent_Done,
     /* 258401 */   // Label 5170: @258401
     /* 258401 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(258461), // Rule ID 12484 //
     /* 258406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 258414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258426 */     // MIs[0] tile
     /* 258426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258442 */     // (intrinsic_void 1156:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 258445 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258453 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258459 */     GIR_RootConstrainSelectedInstOperands,
     /* 258460 */     // GIR_Coverage, 12484,
     /* 258460 */     GIR_EraseRootFromParent_Done,
     /* 258461 */   // Label 5171: @258461
     /* 258461 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(258521), // Rule ID 12485 //
     /* 258466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 258474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258486 */     // MIs[0] tile
     /* 258486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258489 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258502 */     // (intrinsic_void 1072:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 258505 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258513 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258519 */     GIR_RootConstrainSelectedInstOperands,
     /* 258520 */     // GIR_Coverage, 12485,
     /* 258520 */     GIR_EraseRootFromParent_Done,
     /* 258521 */   // Label 5172: @258521
     /* 258521 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(258581), // Rule ID 12486 //
     /* 258526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 258534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258546 */     // MIs[0] tile
     /* 258546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258549 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258562 */     // (intrinsic_void 1073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 258565 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258573 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258579 */     GIR_RootConstrainSelectedInstOperands,
     /* 258580 */     // GIR_Coverage, 12486,
     /* 258580 */     GIR_EraseRootFromParent_Done,
     /* 258581 */   // Label 5173: @258581
     /* 258581 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(258641), // Rule ID 12487 //
     /* 258586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 258594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258606 */     // MIs[0] tile
     /* 258606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258622 */     // (intrinsic_void 1188:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 258625 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258633 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258639 */     GIR_RootConstrainSelectedInstOperands,
     /* 258640 */     // GIR_Coverage, 12487,
     /* 258640 */     GIR_EraseRootFromParent_Done,
     /* 258641 */   // Label 5174: @258641
     /* 258641 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(258701), // Rule ID 12488 //
     /* 258646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 258654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258666 */     // MIs[0] tile
     /* 258666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258669 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258682 */     // (intrinsic_void 1189:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 258685 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258693 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258699 */     GIR_RootConstrainSelectedInstOperands,
     /* 258700 */     // GIR_Coverage, 12488,
     /* 258700 */     GIR_EraseRootFromParent_Done,
     /* 258701 */   // Label 5175: @258701
     /* 258701 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(258761), // Rule ID 12489 //
     /* 258706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 258709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 258714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258726 */     // MIs[0] tile
     /* 258726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258742 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 258742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 258745 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258751 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258753 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258759 */     GIR_RootConstrainSelectedInstOperands,
     /* 258760 */     // GIR_Coverage, 12489,
     /* 258760 */     GIR_EraseRootFromParent_Done,
     /* 258761 */   // Label 5176: @258761
     /* 258761 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(258821), // Rule ID 12490 //
     /* 258766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 258769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 258774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258786 */     // MIs[0] tile
     /* 258786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258802 */     // (intrinsic_void 1154:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 258802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 258805 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258813 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258819 */     GIR_RootConstrainSelectedInstOperands,
     /* 258820 */     // GIR_Coverage, 12490,
     /* 258820 */     GIR_EraseRootFromParent_Done,
     /* 258821 */   // Label 5177: @258821
     /* 258821 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(258881), // Rule ID 12491 //
     /* 258826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 258829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 258834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258846 */     // MIs[0] tile
     /* 258846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258862 */     // (intrinsic_void 1156:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 258862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 258865 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258871 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258873 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258879 */     GIR_RootConstrainSelectedInstOperands,
     /* 258880 */     // GIR_Coverage, 12491,
     /* 258880 */     GIR_EraseRootFromParent_Done,
     /* 258881 */   // Label 5178: @258881
     /* 258881 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(258941), // Rule ID 12492 //
     /* 258886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 258889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 258894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258906 */     // MIs[0] tile
     /* 258906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258922 */     // (intrinsic_void 1072:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 258922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 258925 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258933 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258939 */     GIR_RootConstrainSelectedInstOperands,
     /* 258940 */     // GIR_Coverage, 12492,
     /* 258940 */     GIR_EraseRootFromParent_Done,
     /* 258941 */   // Label 5179: @258941
     /* 258941 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(259001), // Rule ID 12493 //
     /* 258946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 258949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 258954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258966 */     // MIs[0] tile
     /* 258966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258982 */     // (intrinsic_void 1073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 258982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 258985 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258993 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258999 */     GIR_RootConstrainSelectedInstOperands,
     /* 259000 */     // GIR_Coverage, 12493,
     /* 259000 */     GIR_EraseRootFromParent_Done,
     /* 259001 */   // Label 5180: @259001
     /* 259001 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(259061), // Rule ID 12494 //
     /* 259006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 259014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259026 */     // MIs[0] tile
     /* 259026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259029 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259042 */     // (intrinsic_void 1188:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 259045 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259053 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259059 */     GIR_RootConstrainSelectedInstOperands,
     /* 259060 */     // GIR_Coverage, 12494,
     /* 259060 */     GIR_EraseRootFromParent_Done,
     /* 259061 */   // Label 5181: @259061
     /* 259061 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(259121), // Rule ID 12495 //
     /* 259066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 259074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259086 */     // MIs[0] tile
     /* 259086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259102 */     // (intrinsic_void 1189:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 259105 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259111 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259113 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259119 */     GIR_RootConstrainSelectedInstOperands,
     /* 259120 */     // GIR_Coverage, 12495,
     /* 259120 */     GIR_EraseRootFromParent_Done,
     /* 259121 */   // Label 5182: @259121
     /* 259121 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(259181), // Rule ID 12860 //
     /* 259126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 259134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 259140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 259146 */     // MIs[0] tile
     /* 259146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259162 */     // (intrinsic_void 800:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 259162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 259165 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259173 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259179 */     GIR_RootConstrainSelectedInstOperands,
     /* 259180 */     // GIR_Coverage, 12860,
     /* 259180 */     GIR_EraseRootFromParent_Done,
     /* 259181 */   // Label 5183: @259181
     /* 259181 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(259241), // Rule ID 12861 //
     /* 259186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 259194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259206 */     // MIs[0] tile
     /* 259206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259209 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259222 */     // (intrinsic_void 1024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 259225 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259233 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259239 */     GIR_RootConstrainSelectedInstOperands,
     /* 259240 */     // GIR_Coverage, 12861,
     /* 259240 */     GIR_EraseRootFromParent_Done,
     /* 259241 */   // Label 5184: @259241
     /* 259241 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(259301), // Rule ID 12862 //
     /* 259246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 259254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259266 */     // MIs[0] tile
     /* 259266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259282 */     // (intrinsic_void 1155:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 259285 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259293 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259299 */     GIR_RootConstrainSelectedInstOperands,
     /* 259300 */     // GIR_Coverage, 12862,
     /* 259300 */     GIR_EraseRootFromParent_Done,
     /* 259301 */   // Label 5185: @259301
     /* 259301 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(259361), // Rule ID 12863 //
     /* 259306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 259314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259326 */     // MIs[0] tile
     /* 259326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259342 */     // (intrinsic_void 1157:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 259345 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259353 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259359 */     GIR_RootConstrainSelectedInstOperands,
     /* 259360 */     // GIR_Coverage, 12863,
     /* 259360 */     GIR_EraseRootFromParent_Done,
     /* 259361 */   // Label 5186: @259361
     /* 259361 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(259421), // Rule ID 12974 //
     /* 259366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 259369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 259374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259386 */     // MIs[0] tile
     /* 259386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259389 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 259394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259402 */     // (intrinsic_void 921:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 259402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 259405 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259411 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259413 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259419 */     GIR_RootConstrainSelectedInstOperands,
     /* 259420 */     // GIR_Coverage, 12974,
     /* 259420 */     GIR_EraseRootFromParent_Done,
     /* 259421 */   // Label 5187: @259421
     /* 259421 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(259469), // Rule ID 3571 //
     /* 259426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 259434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259450 */     // MIs[0] Op4
     /* 259450 */     // No operand predicates
     /* 259450 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1492:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 259450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 259453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259461 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259467 */     GIR_RootConstrainSelectedInstOperands,
     /* 259468 */     // GIR_Coverage, 3571,
     /* 259468 */     GIR_EraseRootFromParent_Done,
     /* 259469 */   // Label 5188: @259469
     /* 259469 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(259517), // Rule ID 3573 //
     /* 259474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 259482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259498 */     // MIs[0] Op4
     /* 259498 */     // No operand predicates
     /* 259498 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1494:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 259498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 259501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259507 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259509 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259515 */     GIR_RootConstrainSelectedInstOperands,
     /* 259516 */     // GIR_Coverage, 3573,
     /* 259516 */     GIR_EraseRootFromParent_Done,
     /* 259517 */   // Label 5189: @259517
     /* 259517 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(259565), // Rule ID 3574 //
     /* 259522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 259525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 259530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259546 */     // MIs[0] Op4
     /* 259546 */     // No operand predicates
     /* 259546 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1490:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 259546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 259549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259557 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259563 */     GIR_RootConstrainSelectedInstOperands,
     /* 259564 */     // GIR_Coverage, 3574,
     /* 259564 */     GIR_EraseRootFromParent_Done,
     /* 259565 */   // Label 5190: @259565
     /* 259565 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(259613), // Rule ID 3575 //
     /* 259570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 259573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 259578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259594 */     // MIs[0] Op4
     /* 259594 */     // No operand predicates
     /* 259594 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1490:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 259594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 259597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259605 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259611 */     GIR_RootConstrainSelectedInstOperands,
     /* 259612 */     // GIR_Coverage, 3575,
     /* 259612 */     GIR_EraseRootFromParent_Done,
     /* 259613 */   // Label 5191: @259613
     /* 259613 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(259661), // Rule ID 12463 //
     /* 259618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 259626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259642 */     // MIs[0] Op4
     /* 259642 */     // No operand predicates
     /* 259642 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1502:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 259642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 259645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259653 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259659 */     GIR_RootConstrainSelectedInstOperands,
     /* 259660 */     // GIR_Coverage, 12463,
     /* 259660 */     GIR_EraseRootFromParent_Done,
     /* 259661 */   // Label 5192: @259661
     /* 259661 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(259709), // Rule ID 12465 //
     /* 259666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 259674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259690 */     // MIs[0] Op4
     /* 259690 */     // No operand predicates
     /* 259690 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1496:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 259690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 259693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259701 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259707 */     GIR_RootConstrainSelectedInstOperands,
     /* 259708 */     // GIR_Coverage, 12465,
     /* 259708 */     GIR_EraseRootFromParent_Done,
     /* 259709 */   // Label 5193: @259709
     /* 259709 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(259757), // Rule ID 12466 //
     /* 259714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 259722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259738 */     // MIs[0] Op4
     /* 259738 */     // No operand predicates
     /* 259738 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1498:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 259738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 259741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259749 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259755 */     GIR_RootConstrainSelectedInstOperands,
     /* 259756 */     // GIR_Coverage, 12466,
     /* 259756 */     GIR_EraseRootFromParent_Done,
     /* 259757 */   // Label 5194: @259757
     /* 259757 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(259805), // Rule ID 12467 //
     /* 259762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 259765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 259770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259786 */     // MIs[0] Op4
     /* 259786 */     // No operand predicates
     /* 259786 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1500:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 259786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 259789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259797 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259803 */     GIR_RootConstrainSelectedInstOperands,
     /* 259804 */     // GIR_Coverage, 12467,
     /* 259804 */     GIR_EraseRootFromParent_Done,
     /* 259805 */   // Label 5195: @259805
     /* 259805 */   GIM_Reject,
     /* 259806 */ // Label 5145: @259806
     /* 259806 */ GIM_Reject,
     /* 259807 */ // Label 37: @259807
     /* 259807 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5200*/ GIMT_Encode4(260096),
     /* 259818 */ /*GILLT_s64*//*Label 5196*/ GIMT_Encode4(259850), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 259830 */ /*GILLT_v2s64*//*Label 5197*/ GIMT_Encode4(259910), GIMT_Encode4(0),
     /* 259838 */ /*GILLT_v4s32*//*Label 5198*/ GIMT_Encode4(259972), GIMT_Encode4(0),
     /* 259846 */ /*GILLT_v8s16*//*Label 5199*/ GIMT_Encode4(260034),
     /* 259850 */ // Label 5196: @259850
     /* 259850 */ GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(259909), // Rule ID 6452 //
     /* 259855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 259858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 259862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259866 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 259866 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 259869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259873 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 259880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259888 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 259890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 259893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 259898 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 259903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 259908 */   // GIR_Coverage, 6452,
     /* 259908 */   GIR_EraseRootFromParent_Done,
     /* 259909 */ // Label 5201: @259909
     /* 259909 */ GIM_Reject,
     /* 259910 */ // Label 5197: @259910
     /* 259910 */ GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(259971),
     /* 259915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 259918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259922 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(259949), // Rule ID 6324 //
     /* 259927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 259934 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 259934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 259937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 259944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259947 */     GIR_RootConstrainSelectedInstOperands,
     /* 259948 */     // GIR_Coverage, 6324,
     /* 259948 */     GIR_EraseRootFromParent_Done,
     /* 259949 */   // Label 5203: @259949
     /* 259949 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(259970), // Rule ID 6317 //
     /* 259954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259958 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 259958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 259961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 259965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 259968 */     GIR_RootConstrainSelectedInstOperands,
     /* 259969 */     // GIR_Coverage, 6317,
     /* 259969 */     GIR_EraseRootFromParent_Done,
     /* 259970 */   // Label 5204: @259970
     /* 259970 */   GIM_Reject,
     /* 259971 */ // Label 5202: @259971
     /* 259971 */ GIM_Reject,
     /* 259972 */ // Label 5198: @259972
     /* 259972 */ GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(260033),
     /* 259977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 259980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259984 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(260011), // Rule ID 6321 //
     /* 259989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 259996 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 259996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 259999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 260006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260009 */     GIR_RootConstrainSelectedInstOperands,
     /* 260010 */     // GIR_Coverage, 6321,
     /* 260010 */     GIR_EraseRootFromParent_Done,
     /* 260011 */   // Label 5206: @260011
     /* 260011 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(260032), // Rule ID 6314 //
     /* 260016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260020 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 260020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 260023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 260027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260030 */     GIR_RootConstrainSelectedInstOperands,
     /* 260031 */     // GIR_Coverage, 6314,
     /* 260031 */     GIR_EraseRootFromParent_Done,
     /* 260032 */   // Label 5207: @260032
     /* 260032 */   GIM_Reject,
     /* 260033 */ // Label 5205: @260033
     /* 260033 */ GIM_Reject,
     /* 260034 */ // Label 5199: @260034
     /* 260034 */ GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(260095),
     /* 260039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 260042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260046 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(260073), // Rule ID 6318 //
     /* 260051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 260058 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 260058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 260061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 260068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260071 */     GIR_RootConstrainSelectedInstOperands,
     /* 260072 */     // GIR_Coverage, 6318,
     /* 260072 */     GIR_EraseRootFromParent_Done,
     /* 260073 */   // Label 5209: @260073
     /* 260073 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(260094), // Rule ID 6311 //
     /* 260078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260082 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 260082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 260085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 260089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260092 */     GIR_RootConstrainSelectedInstOperands,
     /* 260093 */     // GIR_Coverage, 6311,
     /* 260093 */     GIR_EraseRootFromParent_Done,
     /* 260094 */   // Label 5210: @260094
     /* 260094 */   GIM_Reject,
     /* 260095 */ // Label 5208: @260095
     /* 260095 */ GIM_Reject,
     /* 260096 */ // Label 5200: @260096
     /* 260096 */ GIM_Reject,
     /* 260097 */ // Label 38: @260097
     /* 260097 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5215*/ GIMT_Encode4(261533),
     /* 260108 */ /*GILLT_s32*//*Label 5211*/ GIMT_Encode4(260140), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 260120 */ /*GILLT_v2s32*//*Label 5212*/ GIMT_Encode4(260179), GIMT_Encode4(0),
     /* 260128 */ /*GILLT_v4s16*//*Label 5213*/ GIMT_Encode4(260535), GIMT_Encode4(0),
     /* 260136 */ /*GILLT_v8s8*//*Label 5214*/ GIMT_Encode4(261034),
     /* 260140 */ // Label 5211: @260140
     /* 260140 */ GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(260178), // Rule ID 6473 //
     /* 260145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 260148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 260152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 260156 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 260156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260161 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 260167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 260172 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 260177 */   // GIR_Coverage, 6473,
     /* 260177 */   GIR_EraseRootFromParent_Done,
     /* 260178 */ // Label 5216: @260178
     /* 260178 */ GIM_Reject,
     /* 260179 */ // Label 5212: @260179
     /* 260179 */ GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(260534),
     /* 260184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260191 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(260269), // Rule ID 5405 //
     /* 260196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 260204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 260212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 260216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 260224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 260233 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 260239 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 260241 */     // MIs[1] Operand 2
     /* 260241 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 260252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 260254 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 260254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 260257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 260263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 260267 */     GIR_RootConstrainSelectedInstOperands,
     /* 260268 */     // GIR_Coverage, 5405,
     /* 260268 */     GIR_EraseRootFromParent_Done,
     /* 260269 */   // Label 5218: @260269
     /* 260269 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(260340), // Rule ID 5401 //
     /* 260274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 260282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 260290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 260294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 260302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260312 */     // MIs[1] Operand 2
     /* 260312 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 260323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260325 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 260325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 260328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 260334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 260338 */     GIR_RootConstrainSelectedInstOperands,
     /* 260339 */     // GIR_Coverage, 5401,
     /* 260339 */     GIR_EraseRootFromParent_Done,
     /* 260340 */   // Label 5219: @260340
     /* 260340 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(260411), // Rule ID 5403 //
     /* 260345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 260353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 260361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 260365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 260373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260383 */     // MIs[1] Operand 2
     /* 260383 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 260394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260396 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 260396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 260399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 260405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 260409 */     GIR_RootConstrainSelectedInstOperands,
     /* 260410 */     // GIR_Coverage, 5403,
     /* 260410 */     GIR_EraseRootFromParent_Done,
     /* 260411 */   // Label 5220: @260411
     /* 260411 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(260464), // Rule ID 2153 //
     /* 260416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 260419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 260427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260436 */     // MIs[1] imm
     /* 260436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 260440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260444 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 260448 */     // MIs[2] Operand 1
     /* 260448 */     // No operand predicates
     /* 260448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260450 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 260450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 260453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 260459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 260462 */     GIR_RootConstrainSelectedInstOperands,
     /* 260463 */     // GIR_Coverage, 2153,
     /* 260463 */     GIR_EraseRootFromParent_Done,
     /* 260464 */   // Label 5221: @260464
     /* 260464 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(260514), // Rule ID 6299 //
     /* 260469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 260477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260486 */     // MIs[1] imm
     /* 260486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 260490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260494 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 260498 */     // MIs[2] Operand 1
     /* 260498 */     // No operand predicates
     /* 260498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260500 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 260500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 260503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 260509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 260512 */     GIR_RootConstrainSelectedInstOperands,
     /* 260513 */     // GIR_Coverage, 6299,
     /* 260513 */     GIR_EraseRootFromParent_Done,
     /* 260514 */   // Label 5222: @260514
     /* 260514 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(260533), // Rule ID 1092 //
     /* 260519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 260522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260526 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 260526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 260531 */     GIR_RootConstrainSelectedInstOperands,
     /* 260532 */     // GIR_Coverage, 1092,
     /* 260532 */     GIR_Done,
     /* 260533 */   // Label 5223: @260533
     /* 260533 */   GIM_Reject,
     /* 260534 */ // Label 5217: @260534
     /* 260534 */ GIM_Reject,
     /* 260535 */ // Label 5213: @260535
     /* 260535 */ GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(261033),
     /* 260540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 260543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260547 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(260625), // Rule ID 5399 //
     /* 260552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 260560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 260564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 260568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 260572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 260576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 260580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 260589 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 260595 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 260597 */     // MIs[1] Operand 2
     /* 260597 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 260608 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 260610 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 260610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 260613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 260619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 260623 */     GIR_RootConstrainSelectedInstOperands,
     /* 260624 */     // GIR_Coverage, 5399,
     /* 260624 */     GIR_EraseRootFromParent_Done,
     /* 260625 */   // Label 5225: @260625
     /* 260625 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(260696), // Rule ID 5395 //
     /* 260630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 260638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 260642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 260646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 260650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 260654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 260658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260668 */     // MIs[1] Operand 2
     /* 260668 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 260679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260681 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 260681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 260684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 260690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 260694 */     GIR_RootConstrainSelectedInstOperands,
     /* 260695 */     // GIR_Coverage, 5395,
     /* 260695 */     GIR_EraseRootFromParent_Done,
     /* 260696 */   // Label 5226: @260696
     /* 260696 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(260767), // Rule ID 5397 //
     /* 260701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 260709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 260713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 260717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 260721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 260725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 260729 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260739 */     // MIs[1] Operand 2
     /* 260739 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 260750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260752 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 260752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 260755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 260761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 260765 */     GIR_RootConstrainSelectedInstOperands,
     /* 260766 */     // GIR_Coverage, 5397,
     /* 260766 */     GIR_EraseRootFromParent_Done,
     /* 260767 */   // Label 5227: @260767
     /* 260767 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(260859), // Rule ID 5521 //
     /* 260772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 260780 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 260787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 260791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 260795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 260799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 260812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 260816 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260820 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260825 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 260827 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 260827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 260830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 260834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260839 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 260843 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 260847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 260849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 260852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260857 */     GIR_RootConstrainSelectedInstOperands,
     /* 260858 */     // GIR_Coverage, 5521,
     /* 260858 */     GIR_EraseRootFromParent_Done,
     /* 260859 */   // Label 5228: @260859
     /* 260859 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(260912), // Rule ID 2152 //
     /* 260864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 260867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 260875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 260879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260884 */     // MIs[1] imm
     /* 260884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 260888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260892 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 260896 */     // MIs[2] Operand 1
     /* 260896 */     // No operand predicates
     /* 260896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260898 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 260898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 260901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 260907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 260910 */     GIR_RootConstrainSelectedInstOperands,
     /* 260911 */     // GIR_Coverage, 2152,
     /* 260911 */     GIR_EraseRootFromParent_Done,
     /* 260912 */   // Label 5229: @260912
     /* 260912 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(260962), // Rule ID 6298 //
     /* 260917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 260925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 260929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260934 */     // MIs[1] imm
     /* 260934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 260938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 260942 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 260946 */     // MIs[2] Operand 1
     /* 260946 */     // No operand predicates
     /* 260946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 260948 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 260948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 260951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 260957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 260960 */     GIR_RootConstrainSelectedInstOperands,
     /* 260961 */     // GIR_Coverage, 6298,
     /* 260961 */     GIR_EraseRootFromParent_Done,
     /* 260962 */   // Label 5230: @260962
     /* 260962 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(261013), // Rule ID 5549 //
     /* 260967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 260975 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 260978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 260982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 260986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 260998 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 260998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 261001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 261007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 261011 */     GIR_RootConstrainSelectedInstOperands,
     /* 261012 */     // GIR_Coverage, 5549,
     /* 261012 */     GIR_EraseRootFromParent_Done,
     /* 261013 */   // Label 5231: @261013
     /* 261013 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(261032), // Rule ID 1091 //
     /* 261018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261025 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 261025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 261030 */     GIR_RootConstrainSelectedInstOperands,
     /* 261031 */     // GIR_Coverage, 1091,
     /* 261031 */     GIR_Done,
     /* 261032 */   // Label 5232: @261032
     /* 261032 */   GIM_Reject,
     /* 261033 */ // Label 5224: @261033
     /* 261033 */ GIM_Reject,
     /* 261034 */ // Label 5214: @261034
     /* 261034 */ GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(261532),
     /* 261039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261046 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(261124), // Rule ID 5393 //
     /* 261051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 261071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 261079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 261088 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 261094 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 261096 */     // MIs[1] Operand 2
     /* 261096 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 261107 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 261109 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 261109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 261112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261122 */     GIR_RootConstrainSelectedInstOperands,
     /* 261123 */     // GIR_Coverage, 5393,
     /* 261123 */     GIR_EraseRootFromParent_Done,
     /* 261124 */   // Label 5234: @261124
     /* 261124 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(261195), // Rule ID 5389 //
     /* 261129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 261149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 261157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261167 */     // MIs[1] Operand 2
     /* 261167 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 261178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261180 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 261180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 261183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261193 */     GIR_RootConstrainSelectedInstOperands,
     /* 261194 */     // GIR_Coverage, 5389,
     /* 261194 */     GIR_EraseRootFromParent_Done,
     /* 261195 */   // Label 5235: @261195
     /* 261195 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(261266), // Rule ID 5391 //
     /* 261200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 261220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 261228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261233 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261238 */     // MIs[1] Operand 2
     /* 261238 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 261249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261251 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 261251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 261254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261264 */     GIR_RootConstrainSelectedInstOperands,
     /* 261265 */     // GIR_Coverage, 5391,
     /* 261265 */     GIR_EraseRootFromParent_Done,
     /* 261266 */   // Label 5236: @261266
     /* 261266 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(261358), // Rule ID 5494 //
     /* 261271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 261279 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 261286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 261298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 261311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 261315 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261319 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 261326 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 261326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 261329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 261333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 261342 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 261346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 261348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 261351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261356 */     GIR_RootConstrainSelectedInstOperands,
     /* 261357 */     // GIR_Coverage, 5494,
     /* 261357 */     GIR_EraseRootFromParent_Done,
     /* 261358 */   // Label 5237: @261358
     /* 261358 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(261411), // Rule ID 2151 //
     /* 261363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 261374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261383 */     // MIs[1] imm
     /* 261383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261391 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 261395 */     // MIs[2] Operand 1
     /* 261395 */     // No operand predicates
     /* 261395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261397 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 261397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 261400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261409 */     GIR_RootConstrainSelectedInstOperands,
     /* 261410 */     // GIR_Coverage, 2151,
     /* 261410 */     GIR_EraseRootFromParent_Done,
     /* 261411 */   // Label 5238: @261411
     /* 261411 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(261461), // Rule ID 6297 //
     /* 261416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261433 */     // MIs[1] imm
     /* 261433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261441 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 261445 */     // MIs[2] Operand 1
     /* 261445 */     // No operand predicates
     /* 261445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261447 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 261447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 261450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261459 */     GIR_RootConstrainSelectedInstOperands,
     /* 261460 */     // GIR_Coverage, 6297,
     /* 261460 */     GIR_EraseRootFromParent_Done,
     /* 261461 */   // Label 5239: @261461
     /* 261461 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(261512), // Rule ID 5548 //
     /* 261466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 261474 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 261481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 261485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261497 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 261497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 261500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 261506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 261510 */     GIR_RootConstrainSelectedInstOperands,
     /* 261511 */     // GIR_Coverage, 5548,
     /* 261511 */     GIR_EraseRootFromParent_Done,
     /* 261512 */   // Label 5240: @261512
     /* 261512 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(261531), // Rule ID 1090 //
     /* 261517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261524 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 261524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 261529 */     GIR_RootConstrainSelectedInstOperands,
     /* 261530 */     // GIR_Coverage, 1090,
     /* 261530 */     GIR_Done,
     /* 261531 */   // Label 5241: @261531
     /* 261531 */   GIM_Reject,
     /* 261532 */ // Label 5233: @261532
     /* 261532 */ GIM_Reject,
     /* 261533 */ // Label 5215: @261533
     /* 261533 */ GIM_Reject,
     /* 261534 */ // Label 39: @261534
     /* 261534 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5244*/ GIMT_Encode4(261653),
     /* 261545 */ /*GILLT_s32*//*Label 5242*/ GIMT_Encode4(261553),
     /* 261549 */ /*GILLT_s64*//*Label 5243*/ GIMT_Encode4(261573),
     /* 261553 */ // Label 5242: @261553
     /* 261553 */ GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(261572), // Rule ID 81 //
     /* 261558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261562 */   // MIs[0] Operand 1
     /* 261562 */   // No operand predicates
     /* 261562 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 261562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 261565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261567 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 261570 */   GIR_RootConstrainSelectedInstOperands,
     /* 261571 */   // GIR_Coverage, 81,
     /* 261571 */   GIR_EraseRootFromParent_Done,
     /* 261572 */ // Label 5245: @261572
     /* 261572 */ GIM_Reject,
     /* 261573 */ // Label 5243: @261573
     /* 261573 */ GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(261633), // Rule ID 3886 //
     /* 261578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 261581 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 261585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 261589 */   // MIs[0] Operand 1
     /* 261589 */   // No operand predicates
     /* 261589 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 261589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 261592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 261596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261601 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 261606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 261608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 261611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 261622 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 261627 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261632 */   // GIR_Coverage, 3886,
     /* 261632 */   GIR_EraseRootFromParent_Done,
     /* 261633 */ // Label 5246: @261633
     /* 261633 */ GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(261652), // Rule ID 82 //
     /* 261638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 261642 */   // MIs[0] Operand 1
     /* 261642 */   // No operand predicates
     /* 261642 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 261642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 261645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261647 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 261650 */   GIR_RootConstrainSelectedInstOperands,
     /* 261651 */   // GIR_Coverage, 82,
     /* 261651 */   GIR_EraseRootFromParent_Done,
     /* 261652 */ // Label 5247: @261652
     /* 261652 */ GIM_Reject,
     /* 261653 */ // Label 5244: @261653
     /* 261653 */ GIM_Reject,
     /* 261654 */ // Label 40: @261654
     /* 261654 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5251*/ GIMT_Encode4(261894),
     /* 261665 */ /*GILLT_s16*//*Label 5248*/ GIMT_Encode4(261677),
     /* 261669 */ /*GILLT_s32*//*Label 5249*/ GIMT_Encode4(261729),
     /* 261673 */ /*GILLT_s64*//*Label 5250*/ GIMT_Encode4(261842),
     /* 261677 */ // Label 5248: @261677
     /* 261677 */ GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(261700), // Rule ID 506 //
     /* 261682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 261685 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 261689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 261693 */   // MIs[0] Operand 1
     /* 261693 */   // No operand predicates
     /* 261693 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 261693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 261696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261698 */   GIR_RootConstrainSelectedInstOperands,
     /* 261699 */   // GIR_Coverage, 506,
     /* 261699 */   GIR_EraseRootFromParent_Done,
     /* 261700 */ // Label 5252: @261700
     /* 261700 */ GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(261728), // Rule ID 688 //
     /* 261705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 261708 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 261712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 261716 */   // MIs[0] Operand 1
     /* 261716 */   // No operand predicates
     /* 261716 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 261716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 261719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261721 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 261726 */   GIR_RootConstrainSelectedInstOperands,
     /* 261727 */   // GIR_Coverage, 688,
     /* 261727 */   GIR_EraseRootFromParent_Done,
     /* 261728 */ // Label 5253: @261728
     /* 261728 */ GIM_Reject,
     /* 261729 */ // Label 5249: @261729
     /* 261729 */ GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(261752), // Rule ID 507 //
     /* 261734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 261737 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 261741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 261745 */   // MIs[0] Operand 1
     /* 261745 */   // No operand predicates
     /* 261745 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 261745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 261748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261750 */   GIR_RootConstrainSelectedInstOperands,
     /* 261751 */   // GIR_Coverage, 507,
     /* 261751 */   GIR_EraseRootFromParent_Done,
     /* 261752 */ // Label 5254: @261752
     /* 261752 */ GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(261780), // Rule ID 689 //
     /* 261757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 261760 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 261764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 261768 */   // MIs[0] Operand 1
     /* 261768 */   // No operand predicates
     /* 261768 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 261768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 261771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261773 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 261778 */   GIR_RootConstrainSelectedInstOperands,
     /* 261779 */   // GIR_Coverage, 689,
     /* 261779 */   GIR_EraseRootFromParent_Done,
     /* 261780 */ // Label 5255: @261780
     /* 261780 */ GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(261841), // Rule ID 5978 //
     /* 261785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261788 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 261792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 261796 */   // MIs[0] Operand 1
     /* 261796 */   // No operand predicates
     /* 261796 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 261796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 261799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 261803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261808 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 261813 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 261816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 261818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 261821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261823 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 261830 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 261835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261840 */   // GIR_Coverage, 5978,
     /* 261840 */   GIR_EraseRootFromParent_Done,
     /* 261841 */ // Label 5256: @261841
     /* 261841 */ GIM_Reject,
     /* 261842 */ // Label 5250: @261842
     /* 261842 */ GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(261865), // Rule ID 508 //
     /* 261847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 261850 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 261854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261858 */   // MIs[0] Operand 1
     /* 261858 */   // No operand predicates
     /* 261858 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 261858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 261861 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261863 */   GIR_RootConstrainSelectedInstOperands,
     /* 261864 */   // GIR_Coverage, 508,
     /* 261864 */   GIR_EraseRootFromParent_Done,
     /* 261865 */ // Label 5257: @261865
     /* 261865 */ GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(261893), // Rule ID 690 //
     /* 261870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 261873 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 261877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261881 */   // MIs[0] Operand 1
     /* 261881 */   // No operand predicates
     /* 261881 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 261881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 261884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261886 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 261891 */   GIR_RootConstrainSelectedInstOperands,
     /* 261892 */   // GIR_Coverage, 690,
     /* 261892 */   GIR_EraseRootFromParent_Done,
     /* 261893 */ // Label 5258: @261893
     /* 261893 */ GIM_Reject,
     /* 261894 */ // Label 5251: @261894
     /* 261894 */ GIM_Reject,
     /* 261895 */ // Label 41: @261895
     /* 261895 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5264*/ GIMT_Encode4(263792),
     /* 261906 */ /*GILLT_s32*//*Label 5259*/ GIMT_Encode4(261942),
     /* 261910 */ /*GILLT_s64*//*Label 5260*/ GIMT_Encode4(263383), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 261922 */ /*GILLT_v2s64*//*Label 5261*/ GIMT_Encode4(263606), GIMT_Encode4(0),
     /* 261930 */ /*GILLT_v4s32*//*Label 5262*/ GIMT_Encode4(263668), GIMT_Encode4(0),
     /* 261938 */ /*GILLT_v8s16*//*Label 5263*/ GIMT_Encode4(263730),
     /* 261942 */ // Label 5259: @261942
     /* 261942 */ GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(262062), // Rule ID 13037 //
     /* 261947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 261950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261954 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 261962 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261965 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 261970 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 261974 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261979 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261981 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 261981 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 261984 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 261988 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261993 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 261997 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 261999 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262002 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262006 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262013 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262016 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262020 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262025 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262028 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262031 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 262034 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262039 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262044 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 262049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 262052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262060 */   GIR_RootConstrainSelectedInstOperands,
     /* 262061 */   // GIR_Coverage, 13037,
     /* 262061 */   GIR_EraseRootFromParent_Done,
     /* 262062 */ // Label 5265: @262062
     /* 262062 */ GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(262182), // Rule ID 13039 //
     /* 262067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 262070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262074 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262078 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262082 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262085 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 262090 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 262094 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262099 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262101 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262101 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 262104 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 262108 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262113 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262119 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262122 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262126 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262145 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262148 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262151 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 262154 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262159 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262164 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 262169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 262172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262180 */   GIR_RootConstrainSelectedInstOperands,
     /* 262181 */   // GIR_Coverage, 13039,
     /* 262181 */   GIR_EraseRootFromParent_Done,
     /* 262182 */ // Label 5266: @262182
     /* 262182 */ GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(262302), // Rule ID 13041 //
     /* 262187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 262190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262194 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262198 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262202 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262205 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 262210 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262214 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262219 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262221 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262221 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 262224 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 262228 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262233 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262239 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262242 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262246 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262253 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262256 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262260 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262265 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262268 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262271 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 262274 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262279 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262284 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 262292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262300 */   GIR_RootConstrainSelectedInstOperands,
     /* 262301 */   // GIR_Coverage, 13041,
     /* 262301 */   GIR_EraseRootFromParent_Done,
     /* 262302 */ // Label 5267: @262302
     /* 262302 */ GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(262422), // Rule ID 13043 //
     /* 262307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 262310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262314 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262318 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262322 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262325 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 262330 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262334 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262339 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262341 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262341 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 262344 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 262348 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262353 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262359 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262362 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262366 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262373 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262376 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262380 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262385 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262388 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262391 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 262394 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262399 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262404 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 262412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262420 */   GIR_RootConstrainSelectedInstOperands,
     /* 262421 */   // GIR_Coverage, 13043,
     /* 262421 */   GIR_EraseRootFromParent_Done,
     /* 262422 */ // Label 5268: @262422
     /* 262422 */ GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(262542), // Rule ID 13059 //
     /* 262427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 262430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262434 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262438 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262442 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262445 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 262450 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 262454 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262459 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262461 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262461 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 262464 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 262468 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262473 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262479 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262482 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262486 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262493 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262496 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262500 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262505 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262508 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262511 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 262514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262519 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262524 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 262529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 262532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262540 */   GIR_RootConstrainSelectedInstOperands,
     /* 262541 */   // GIR_Coverage, 13059,
     /* 262541 */   GIR_EraseRootFromParent_Done,
     /* 262542 */ // Label 5269: @262542
     /* 262542 */ GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(262662), // Rule ID 13061 //
     /* 262547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 262550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262554 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262562 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262565 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 262570 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 262574 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262579 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262581 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262581 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 262584 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 262588 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262593 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262599 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262602 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262606 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262613 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262616 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262620 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262625 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262628 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262631 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 262634 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262639 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262644 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 262649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 262652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262660 */   GIR_RootConstrainSelectedInstOperands,
     /* 262661 */   // GIR_Coverage, 13061,
     /* 262661 */   GIR_EraseRootFromParent_Done,
     /* 262662 */ // Label 5270: @262662
     /* 262662 */ GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(262782), // Rule ID 13063 //
     /* 262667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 262670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262674 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262678 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262682 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262685 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 262690 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262694 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262699 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262701 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262701 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 262704 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 262708 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262713 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262719 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262722 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262726 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262745 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262748 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262751 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 262754 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262759 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262764 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 262772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262774 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262780 */   GIR_RootConstrainSelectedInstOperands,
     /* 262781 */   // GIR_Coverage, 13063,
     /* 262781 */   GIR_EraseRootFromParent_Done,
     /* 262782 */ // Label 5271: @262782
     /* 262782 */ GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(262902), // Rule ID 13065 //
     /* 262787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 262790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262794 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262798 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262802 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262805 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 262810 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262814 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262819 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262821 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262821 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 262824 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 262828 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262833 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262839 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262842 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262846 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262865 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262868 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262871 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 262874 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262879 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262884 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 262892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262900 */   GIR_RootConstrainSelectedInstOperands,
     /* 262901 */   // GIR_Coverage, 13065,
     /* 262901 */   GIR_EraseRootFromParent_Done,
     /* 262902 */ // Label 5272: @262902
     /* 262902 */ GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(263022), // Rule ID 13069 //
     /* 262907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 262910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262914 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262918 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262922 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262925 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 262930 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 262934 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262939 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262941 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262941 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 262944 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 262948 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262953 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262959 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262962 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262966 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262973 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262976 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262980 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262985 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262988 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262991 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 262994 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262999 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263004 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263014 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263020 */   GIR_RootConstrainSelectedInstOperands,
     /* 263021 */   // GIR_Coverage, 13069,
     /* 263021 */   GIR_EraseRootFromParent_Done,
     /* 263022 */ // Label 5273: @263022
     /* 263022 */ GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(263142), // Rule ID 13071 //
     /* 263027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263034 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263038 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263042 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263045 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 263050 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 263054 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263059 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263061 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263061 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263064 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 263068 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263073 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263079 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263082 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263086 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263105 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263108 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263111 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263114 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263119 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263124 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263140 */   GIR_RootConstrainSelectedInstOperands,
     /* 263141 */   // GIR_Coverage, 13071,
     /* 263141 */   GIR_EraseRootFromParent_Done,
     /* 263142 */ // Label 5274: @263142
     /* 263142 */ GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(263262), // Rule ID 13073 //
     /* 263147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263154 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263158 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263162 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263165 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 263170 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263174 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263179 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263181 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263181 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263184 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 263188 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263193 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263199 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263202 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263206 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263213 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263216 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263220 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263225 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263228 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263231 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263234 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263239 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263244 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263254 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263260 */   GIR_RootConstrainSelectedInstOperands,
     /* 263261 */   // GIR_Coverage, 13073,
     /* 263261 */   GIR_EraseRootFromParent_Done,
     /* 263262 */ // Label 5275: @263262
     /* 263262 */ GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(263382), // Rule ID 13075 //
     /* 263267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263274 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263282 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263285 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 263290 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263294 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263299 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263301 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263301 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263304 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 263308 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263313 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263319 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263322 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263326 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263331 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263333 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263336 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263340 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263345 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263348 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263351 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263354 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263359 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263364 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263374 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263380 */   GIR_RootConstrainSelectedInstOperands,
     /* 263381 */   // GIR_Coverage, 13075,
     /* 263381 */   GIR_EraseRootFromParent_Done,
     /* 263382 */ // Label 5276: @263382
     /* 263382 */ GIM_Reject,
     /* 263383 */ // Label 5260: @263383
     /* 263383 */ GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(263605),
     /* 263388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 263391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 263395 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(263449), // Rule ID 5632 //
     /* 263400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 263408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 263412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 263416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 263425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263429 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 263433 */     // MIs[2] Operand 1
     /* 263433 */     // No operand predicates
     /* 263433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263435 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 263435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 263438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 263447 */     GIR_RootConstrainSelectedInstOperands,
     /* 263448 */     // GIR_Coverage, 5632,
     /* 263448 */     GIR_EraseRootFromParent_Done,
     /* 263449 */   // Label 5278: @263449
     /* 263449 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(263528), // Rule ID 11151 //
     /* 263454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 263465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 263469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 263473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 263477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263481 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 263485 */     // MIs[2] Operand 1
     /* 263485 */     // No operand predicates
     /* 263485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263487 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 263487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 263490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 263494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263499 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 263505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 263518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 263526 */     GIR_RootConstrainSelectedInstOperands,
     /* 263527 */     // GIR_Coverage, 11151,
     /* 263527 */     GIR_EraseRootFromParent_Done,
     /* 263528 */   // Label 5279: @263528
     /* 263528 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(263604), // Rule ID 6454 //
     /* 263533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263537 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 263537 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 263540 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263544 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 263554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263563 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 263570 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 263573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 263583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 263591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 263602 */     GIR_RootConstrainSelectedInstOperands,
     /* 263603 */     // GIR_Coverage, 6454,
     /* 263603 */     GIR_EraseRootFromParent_Done,
     /* 263604 */   // Label 5280: @263604
     /* 263604 */   GIM_Reject,
     /* 263605 */ // Label 5277: @263605
     /* 263605 */ GIM_Reject,
     /* 263606 */ // Label 5261: @263606
     /* 263606 */ GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(263667),
     /* 263611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 263614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263618 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(263645), // Rule ID 6326 //
     /* 263623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 263630 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 263630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 263633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263643 */     GIR_RootConstrainSelectedInstOperands,
     /* 263644 */     // GIR_Coverage, 6326,
     /* 263644 */     GIR_EraseRootFromParent_Done,
     /* 263645 */   // Label 5282: @263645
     /* 263645 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(263666), // Rule ID 6315 //
     /* 263650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263654 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 263654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 263657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263664 */     GIR_RootConstrainSelectedInstOperands,
     /* 263665 */     // GIR_Coverage, 6315,
     /* 263665 */     GIR_EraseRootFromParent_Done,
     /* 263666 */   // Label 5283: @263666
     /* 263666 */   GIM_Reject,
     /* 263667 */ // Label 5281: @263667
     /* 263667 */ GIM_Reject,
     /* 263668 */ // Label 5262: @263668
     /* 263668 */ GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(263729),
     /* 263673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 263676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263680 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(263707), // Rule ID 6323 //
     /* 263685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 263692 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 263692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 263695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263705 */     GIR_RootConstrainSelectedInstOperands,
     /* 263706 */     // GIR_Coverage, 6323,
     /* 263706 */     GIR_EraseRootFromParent_Done,
     /* 263707 */   // Label 5285: @263707
     /* 263707 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(263728), // Rule ID 6312 //
     /* 263712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263716 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 263716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 263719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263726 */     GIR_RootConstrainSelectedInstOperands,
     /* 263727 */     // GIR_Coverage, 6312,
     /* 263727 */     GIR_EraseRootFromParent_Done,
     /* 263728 */   // Label 5286: @263728
     /* 263728 */   GIM_Reject,
     /* 263729 */ // Label 5284: @263729
     /* 263729 */ GIM_Reject,
     /* 263730 */ // Label 5263: @263730
     /* 263730 */ GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(263791),
     /* 263735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 263738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263742 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(263769), // Rule ID 6320 //
     /* 263747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 263754 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 263754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 263757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 263764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263767 */     GIR_RootConstrainSelectedInstOperands,
     /* 263768 */     // GIR_Coverage, 6320,
     /* 263768 */     GIR_EraseRootFromParent_Done,
     /* 263769 */   // Label 5288: @263769
     /* 263769 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(263790), // Rule ID 6309 //
     /* 263774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263778 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 263778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 263781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 263785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263788 */     GIR_RootConstrainSelectedInstOperands,
     /* 263789 */     // GIR_Coverage, 6309,
     /* 263789 */     GIR_EraseRootFromParent_Done,
     /* 263790 */   // Label 5289: @263790
     /* 263790 */   GIM_Reject,
     /* 263791 */ // Label 5287: @263791
     /* 263791 */ GIM_Reject,
     /* 263792 */ // Label 5264: @263792
     /* 263792 */ GIM_Reject,
     /* 263793 */ // Label 42: @263793
     /* 263793 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5295*/ GIMT_Encode4(265446),
     /* 263804 */ /*GILLT_s32*//*Label 5290*/ GIMT_Encode4(263884),
     /* 263808 */ /*GILLT_s64*//*Label 5291*/ GIMT_Encode4(264378), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 263860 */ /*GILLT_nxv2s64*//*Label 5292*/ GIMT_Encode4(265020), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 263872 */ /*GILLT_nxv4s32*//*Label 5293*/ GIMT_Encode4(265229), GIMT_Encode4(0),
     /* 263880 */ /*GILLT_nxv8s16*//*Label 5294*/ GIMT_Encode4(265373),
     /* 263884 */ // Label 5290: @263884
     /* 263884 */ GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(264377),
     /* 263889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 263892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263896 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(263961), // Rule ID 5627 //
     /* 263901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 263909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 263913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 263917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 263926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263930 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 263934 */     // MIs[2] Operand 1
     /* 263934 */     // No operand predicates
     /* 263934 */     // MIs[0] Operand 2
     /* 263934 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 263945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 263947 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 263947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 263956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 263959 */     GIR_RootConstrainSelectedInstOperands,
     /* 263960 */     // GIR_Coverage, 5627,
     /* 263960 */     GIR_EraseRootFromParent_Done,
     /* 263961 */   // Label 5297: @263961
     /* 263961 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(264026), // Rule ID 5629 //
     /* 263966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 263974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 263978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 263982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 263991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 263995 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 263999 */     // MIs[2] Operand 1
     /* 263999 */     // No operand predicates
     /* 263999 */     // MIs[0] Operand 2
     /* 263999 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264012 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 264012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264024 */     GIR_RootConstrainSelectedInstOperands,
     /* 264025 */     // GIR_Coverage, 5629,
     /* 264025 */     GIR_EraseRootFromParent_Done,
     /* 264026 */   // Label 5298: @264026
     /* 264026 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(264091), // Rule ID 5631 //
     /* 264031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264060 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 264064 */     // MIs[2] Operand 1
     /* 264064 */     // No operand predicates
     /* 264064 */     // MIs[0] Operand 2
     /* 264064 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264077 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 264077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264089 */     GIR_RootConstrainSelectedInstOperands,
     /* 264090 */     // GIR_Coverage, 5631,
     /* 264090 */     GIR_EraseRootFromParent_Done,
     /* 264091 */   // Label 5299: @264091
     /* 264091 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(264181), // Rule ID 11147 //
     /* 264096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 264111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264123 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 264127 */     // MIs[2] Operand 1
     /* 264127 */     // No operand predicates
     /* 264127 */     // MIs[0] Operand 2
     /* 264127 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 264138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264140 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 264140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 264147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264152 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 264158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 264171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 264179 */     GIR_RootConstrainSelectedInstOperands,
     /* 264180 */     // GIR_Coverage, 11147,
     /* 264180 */     GIR_EraseRootFromParent_Done,
     /* 264181 */   // Label 5300: @264181
     /* 264181 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(264271), // Rule ID 11149 //
     /* 264186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 264201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264213 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 264217 */     // MIs[2] Operand 1
     /* 264217 */     // No operand predicates
     /* 264217 */     // MIs[0] Operand 2
     /* 264217 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264230 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 264230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 264233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 264237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264242 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 264248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 264269 */     GIR_RootConstrainSelectedInstOperands,
     /* 264270 */     // GIR_Coverage, 11149,
     /* 264270 */     GIR_EraseRootFromParent_Done,
     /* 264271 */   // Label 5301: @264271
     /* 264271 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(264306), // Rule ID 6459 //
     /* 264276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264280 */     // MIs[0] Operand 2
     /* 264280 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264291 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 264291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 264294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264296 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 264298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 264304 */     GIR_RootConstrainSelectedInstOperands,
     /* 264305 */     // GIR_Coverage, 6459,
     /* 264305 */     GIR_EraseRootFromParent_Done,
     /* 264306 */   // Label 5302: @264306
     /* 264306 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(264341), // Rule ID 6460 //
     /* 264311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264315 */     // MIs[0] Operand 2
     /* 264315 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 264326 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 264326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 264329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264331 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 264333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 264339 */     GIR_RootConstrainSelectedInstOperands,
     /* 264340 */     // GIR_Coverage, 6460,
     /* 264340 */     GIR_EraseRootFromParent_Done,
     /* 264341 */   // Label 5303: @264341
     /* 264341 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(264376), // Rule ID 6461 //
     /* 264346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264350 */     // MIs[0] Operand 2
     /* 264350 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 264361 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 264361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 264364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264366 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 264368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264374 */     GIR_RootConstrainSelectedInstOperands,
     /* 264375 */     // GIR_Coverage, 6461,
     /* 264375 */     GIR_EraseRootFromParent_Done,
     /* 264376 */   // Label 5304: @264376
     /* 264376 */   GIM_Reject,
     /* 264377 */ // Label 5296: @264377
     /* 264377 */ GIM_Reject,
     /* 264378 */ // Label 5291: @264378
     /* 264378 */ GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(265019),
     /* 264383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 264386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264390 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(264467), // Rule ID 5633 //
     /* 264395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 264403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 264419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 264423 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 264432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264436 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 264440 */     // MIs[3] Operand 1
     /* 264440 */     // No operand predicates
     /* 264440 */     // MIs[0] Operand 2
     /* 264440 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 264451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 264453 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 264453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 264456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 264462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 264465 */     GIR_RootConstrainSelectedInstOperands,
     /* 264466 */     // GIR_Coverage, 5633,
     /* 264466 */     GIR_EraseRootFromParent_Done,
     /* 264467 */   // Label 5306: @264467
     /* 264467 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(264544), // Rule ID 5634 //
     /* 264472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 264480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 264500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 264509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264513 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 264517 */     // MIs[3] Operand 1
     /* 264517 */     // No operand predicates
     /* 264517 */     // MIs[0] Operand 2
     /* 264517 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 264530 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 264530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 264533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 264539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 264542 */     GIR_RootConstrainSelectedInstOperands,
     /* 264543 */     // GIR_Coverage, 5634,
     /* 264543 */     GIR_EraseRootFromParent_Done,
     /* 264544 */   // Label 5307: @264544
     /* 264544 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(264646), // Rule ID 11148 //
     /* 264549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 264560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 264576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 264580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 264584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264588 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 264592 */     // MIs[3] Operand 1
     /* 264592 */     // No operand predicates
     /* 264592 */     // MIs[0] Operand 2
     /* 264592 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 264603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 264605 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 264605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 264612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264617 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 264623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 264636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 264644 */     GIR_RootConstrainSelectedInstOperands,
     /* 264645 */     // GIR_Coverage, 11148,
     /* 264645 */     GIR_EraseRootFromParent_Done,
     /* 264646 */   // Label 5308: @264646
     /* 264646 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(264748), // Rule ID 11150 //
     /* 264651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 264662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 264666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 264670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 264678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 264682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 264686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264690 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 264694 */     // MIs[3] Operand 1
     /* 264694 */     // No operand predicates
     /* 264694 */     // MIs[0] Operand 2
     /* 264694 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 264707 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 264707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 264710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 264714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264719 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 264725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 264738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 264746 */     GIR_RootConstrainSelectedInstOperands,
     /* 264747 */     // GIR_Coverage, 11150,
     /* 264747 */     GIR_EraseRootFromParent_Done,
     /* 264748 */   // Label 5309: @264748
     /* 264748 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(264813), // Rule ID 5628 //
     /* 264753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 264765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264782 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 264786 */     // MIs[2] Operand 1
     /* 264786 */     // No operand predicates
     /* 264786 */     // MIs[0] Operand 2
     /* 264786 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 264797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264799 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 264799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 264802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264811 */     GIR_RootConstrainSelectedInstOperands,
     /* 264812 */     // GIR_Coverage, 5628,
     /* 264812 */     GIR_EraseRootFromParent_Done,
     /* 264813 */   // Label 5310: @264813
     /* 264813 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(264878), // Rule ID 5630 //
     /* 264818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264847 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 264851 */     // MIs[2] Operand 1
     /* 264851 */     // No operand predicates
     /* 264851 */     // MIs[0] Operand 2
     /* 264851 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264864 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 264864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 264867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264876 */     GIR_RootConstrainSelectedInstOperands,
     /* 264877 */     // GIR_Coverage, 5630,
     /* 264877 */     GIR_EraseRootFromParent_Done,
     /* 264878 */   // Label 5311: @264878
     /* 264878 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(264913), // Rule ID 6455 //
     /* 264883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264887 */     // MIs[0] Operand 2
     /* 264887 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 264898 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 264898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 264901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264903 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 264905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 264911 */     GIR_RootConstrainSelectedInstOperands,
     /* 264912 */     // GIR_Coverage, 6455,
     /* 264912 */     GIR_EraseRootFromParent_Done,
     /* 264913 */   // Label 5312: @264913
     /* 264913 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(264948), // Rule ID 6456 //
     /* 264918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264922 */     // MIs[0] Operand 2
     /* 264922 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264933 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 264933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 264936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 264940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 264946 */     GIR_RootConstrainSelectedInstOperands,
     /* 264947 */     // GIR_Coverage, 6456,
     /* 264947 */     GIR_EraseRootFromParent_Done,
     /* 264948 */   // Label 5313: @264948
     /* 264948 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(264983), // Rule ID 6457 //
     /* 264953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264957 */     // MIs[0] Operand 2
     /* 264957 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 264968 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 264968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 264971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264973 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 264975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 264981 */     GIR_RootConstrainSelectedInstOperands,
     /* 264982 */     // GIR_Coverage, 6457,
     /* 264982 */     GIR_EraseRootFromParent_Done,
     /* 264983 */   // Label 5314: @264983
     /* 264983 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(265018), // Rule ID 6458 //
     /* 264988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264992 */     // MIs[0] Operand 2
     /* 264992 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 265003 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 265003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265008 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265016 */     GIR_RootConstrainSelectedInstOperands,
     /* 265017 */     // GIR_Coverage, 6458,
     /* 265017 */     GIR_EraseRootFromParent_Done,
     /* 265018 */   // Label 5315: @265018
     /* 265018 */   GIM_Reject,
     /* 265019 */ // Label 5305: @265019
     /* 265019 */ GIM_Reject,
     /* 265020 */ // Label 5292: @265020
     /* 265020 */ GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(265228),
     /* 265025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 265028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265032 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(265097), // Rule ID 10431 //
     /* 265037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265040 */     // MIs[0] Operand 2
     /* 265040 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 265051 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 265051 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 265054 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 265058 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265063 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 265066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 265071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 265085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 265093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 265095 */     GIR_RootConstrainSelectedInstOperands,
     /* 265096 */     // GIR_Coverage, 10431,
     /* 265096 */     GIR_EraseRootFromParent_Done,
     /* 265097 */   // Label 5317: @265097
     /* 265097 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(265162), // Rule ID 10432 //
     /* 265102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265105 */     // MIs[0] Operand 2
     /* 265105 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265116 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 265116 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 265119 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 265123 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265128 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 265131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 265136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 265150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 265158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 265160 */     GIR_RootConstrainSelectedInstOperands,
     /* 265161 */     // GIR_Coverage, 10432,
     /* 265161 */     GIR_EraseRootFromParent_Done,
     /* 265162 */   // Label 5318: @265162
     /* 265162 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(265227), // Rule ID 10433 //
     /* 265167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265170 */     // MIs[0] Operand 2
     /* 265170 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265181 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 265181 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 265184 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 265188 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265193 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 265196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 265201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 265215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 265223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 265225 */     GIR_RootConstrainSelectedInstOperands,
     /* 265226 */     // GIR_Coverage, 10433,
     /* 265226 */     GIR_EraseRootFromParent_Done,
     /* 265227 */   // Label 5319: @265227
     /* 265227 */   GIM_Reject,
     /* 265228 */ // Label 5316: @265228
     /* 265228 */ GIM_Reject,
     /* 265229 */ // Label 5293: @265229
     /* 265229 */ GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(265372),
     /* 265234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 265237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265241 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(265306), // Rule ID 10434 //
     /* 265246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265249 */     // MIs[0] Operand 2
     /* 265249 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265260 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 265260 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 265263 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 265267 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265272 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 265275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 265280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 265294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 265302 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 265304 */     GIR_RootConstrainSelectedInstOperands,
     /* 265305 */     // GIR_Coverage, 10434,
     /* 265305 */     GIR_EraseRootFromParent_Done,
     /* 265306 */   // Label 5321: @265306
     /* 265306 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(265371), // Rule ID 10435 //
     /* 265311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265314 */     // MIs[0] Operand 2
     /* 265314 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265325 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 265325 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 265328 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 265332 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265337 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 265340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 265345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 265359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 265367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 265369 */     GIR_RootConstrainSelectedInstOperands,
     /* 265370 */     // GIR_Coverage, 10435,
     /* 265370 */     GIR_EraseRootFromParent_Done,
     /* 265371 */   // Label 5322: @265371
     /* 265371 */   GIM_Reject,
     /* 265372 */ // Label 5320: @265372
     /* 265372 */ GIM_Reject,
     /* 265373 */ // Label 5294: @265373
     /* 265373 */ GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(265445), // Rule ID 10436 //
     /* 265378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 265384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265388 */   // MIs[0] Operand 2
     /* 265388 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265399 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 265399 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 265402 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 265406 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265411 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 265414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265416 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 265419 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265423 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 265433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265435 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265438 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 265441 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 265443 */   GIR_RootConstrainSelectedInstOperands,
     /* 265444 */   // GIR_Coverage, 10436,
     /* 265444 */   GIR_EraseRootFromParent_Done,
     /* 265445 */ // Label 5323: @265445
     /* 265445 */ GIM_Reject,
     /* 265446 */ // Label 5295: @265446
     /* 265446 */ GIM_Reject,
     /* 265447 */ // Label 43: @265447
     /* 265447 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5328*/ GIMT_Encode4(268225),
     /* 265458 */ /*GILLT_s32*//*Label 5324*/ GIMT_Encode4(265494), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 265474 */ /*GILLT_v2s64*//*Label 5325*/ GIMT_Encode4(267295), GIMT_Encode4(0),
     /* 265482 */ /*GILLT_v4s32*//*Label 5326*/ GIMT_Encode4(267605), GIMT_Encode4(0),
     /* 265490 */ /*GILLT_v8s16*//*Label 5327*/ GIMT_Encode4(267915),
     /* 265494 */ // Label 5324: @265494
     /* 265494 */ GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(265644), // Rule ID 13046 //
     /* 265499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 265502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265506 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265510 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265514 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265517 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 265522 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 265526 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265531 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265533 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 265533 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 265536 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 265540 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265545 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265549 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 265551 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 265554 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265558 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265565 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265568 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265572 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265577 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 265580 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 265583 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 265586 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265591 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265596 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 265601 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 265604 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265608 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265613 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 265620 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 265625 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265638 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265643 */   // GIR_Coverage, 13046,
     /* 265643 */   GIR_EraseRootFromParent_Done,
     /* 265644 */ // Label 5329: @265644
     /* 265644 */ GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(265794), // Rule ID 13048 //
     /* 265649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 265652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265656 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265664 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265667 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 265672 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 265676 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265681 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265683 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 265683 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 265686 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 265690 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265695 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 265701 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 265704 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265708 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265715 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265718 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265722 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265727 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 265730 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 265733 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 265736 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265741 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265746 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 265751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 265754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265763 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 265770 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 265775 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265788 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265793 */   // GIR_Coverage, 13048,
     /* 265793 */   GIR_EraseRootFromParent_Done,
     /* 265794 */ // Label 5330: @265794
     /* 265794 */ GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(265944), // Rule ID 13050 //
     /* 265799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 265802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265806 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265810 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265814 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265817 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 265822 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 265826 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265831 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265833 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 265833 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 265836 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 265840 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265845 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 265851 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 265854 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265858 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265863 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 265865 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 265868 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 265872 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265877 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 265880 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 265883 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 265886 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265891 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265896 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 265901 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 265904 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265908 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265913 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 265920 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 265925 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 265935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265938 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265943 */   // GIR_Coverage, 13050,
     /* 265943 */   GIR_EraseRootFromParent_Done,
     /* 265944 */ // Label 5331: @265944
     /* 265944 */ GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(266094), // Rule ID 13052 //
     /* 265949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 265952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265956 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 265964 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 265967 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 265972 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 265976 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265981 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265983 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 265983 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 265986 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 265990 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265995 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 265999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266001 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266004 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266008 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266015 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266018 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266022 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266027 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266030 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266033 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 266036 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266041 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266046 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266051 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266054 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266058 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266063 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266070 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266075 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266085 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266088 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266093 */   // GIR_Coverage, 13052,
     /* 266093 */   GIR_EraseRootFromParent_Done,
     /* 266094 */ // Label 5332: @266094
     /* 266094 */ GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(266244), // Rule ID 13079 //
     /* 266099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266106 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266110 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266114 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266117 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 266122 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 266126 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266131 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266133 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266133 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 266136 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 266140 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266145 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266151 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266154 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266158 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266165 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266168 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266172 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266177 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266180 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266183 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 266186 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266191 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266196 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266213 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266220 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266225 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266235 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266238 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266243 */   // GIR_Coverage, 13079,
     /* 266243 */   GIR_EraseRootFromParent_Done,
     /* 266244 */ // Label 5333: @266244
     /* 266244 */ GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(266394), // Rule ID 13081 //
     /* 266249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266256 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266260 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266264 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266267 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 266272 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 266276 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266283 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266283 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 266286 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 266290 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266295 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266301 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266304 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266308 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266315 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266318 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266322 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266327 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266330 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266333 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 266336 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266341 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266346 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266363 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266370 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266375 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266385 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266393 */   // GIR_Coverage, 13081,
     /* 266393 */   GIR_EraseRootFromParent_Done,
     /* 266394 */ // Label 5334: @266394
     /* 266394 */ GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(266544), // Rule ID 13083 //
     /* 266399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 266402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266406 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266410 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266414 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266417 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 266422 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 266426 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266433 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266433 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 266436 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 266440 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266445 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266451 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266454 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266458 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266465 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266468 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266472 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266477 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266480 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266483 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 266486 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266491 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266496 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266513 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266520 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266525 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266538 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266543 */   // GIR_Coverage, 13083,
     /* 266543 */   GIR_EraseRootFromParent_Done,
     /* 266544 */ // Label 5335: @266544
     /* 266544 */ GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(266694), // Rule ID 13085 //
     /* 266549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 266552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266556 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266564 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266567 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 266572 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 266576 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266581 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266583 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266583 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 266586 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 266590 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266595 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266601 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266604 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266608 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266615 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266618 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266622 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266627 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266630 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266633 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 266636 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266641 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266646 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266663 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266670 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266675 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266688 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266693 */   // GIR_Coverage, 13085,
     /* 266693 */   GIR_EraseRootFromParent_Done,
     /* 266694 */ // Label 5336: @266694
     /* 266694 */ GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(266844), // Rule ID 13089 //
     /* 266699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266706 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266710 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266714 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266717 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 266722 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 266726 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266731 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266733 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266733 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 266736 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 266740 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266745 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266751 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266754 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266758 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266765 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266768 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266772 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266777 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266780 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266783 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 266786 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266791 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266796 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266813 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266820 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266825 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266835 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266838 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266843 */   // GIR_Coverage, 13089,
     /* 266843 */   GIR_EraseRootFromParent_Done,
     /* 266844 */ // Label 5337: @266844
     /* 266844 */ GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(266994), // Rule ID 13091 //
     /* 266849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266856 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266860 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266864 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266867 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 266872 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 266876 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266881 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266883 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266883 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 266886 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 266890 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266895 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266901 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266904 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266908 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266915 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266918 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266922 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266927 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266930 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266933 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 266936 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266941 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266946 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266963 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266970 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266975 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266985 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266988 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266993 */   // GIR_Coverage, 13091,
     /* 266993 */   GIR_EraseRootFromParent_Done,
     /* 266994 */ // Label 5338: @266994
     /* 266994 */ GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(267144), // Rule ID 13093 //
     /* 266999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267006 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267010 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267014 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267017 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 267022 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267026 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267031 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267033 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267033 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267036 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 267040 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267045 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267051 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267054 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267058 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267065 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267068 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267072 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267077 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267080 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267083 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267086 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267091 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267096 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267101 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267104 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267108 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267113 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267120 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267125 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267143 */   // GIR_Coverage, 13093,
     /* 267143 */   GIR_EraseRootFromParent_Done,
     /* 267144 */ // Label 5339: @267144
     /* 267144 */ GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(267294), // Rule ID 13095 //
     /* 267149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267156 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267160 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267164 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267167 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 267172 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267176 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267181 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267183 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267183 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267186 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 267190 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267195 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267201 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267204 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267208 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267215 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267218 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267222 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267227 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267230 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267233 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267236 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267241 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267246 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267251 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267254 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267258 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267263 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267270 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267275 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267288 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267293 */   // GIR_Coverage, 13095,
     /* 267293 */   GIR_EraseRootFromParent_Done,
     /* 267294 */ // Label 5340: @267294
     /* 267294 */ GIM_Reject,
     /* 267295 */ // Label 5325: @267295
     /* 267295 */ GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(267604),
     /* 267300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 267303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267307 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(267372), // Rule ID 702 //
     /* 267312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267323 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 267326 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 267331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 267335 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 267339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 267348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 267355 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 267355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 267358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 267365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 267370 */     GIR_RootConstrainSelectedInstOperands,
     /* 267371 */     // GIR_Coverage, 702,
     /* 267371 */     GIR_EraseRootFromParent_Done,
     /* 267372 */   // Label 5342: @267372
     /* 267372 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(267437), // Rule ID 1704 //
     /* 267377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267388 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 267391 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 267396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 267400 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 267404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 267413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 267420 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 267420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 267423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 267430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 267435 */     GIR_RootConstrainSelectedInstOperands,
     /* 267436 */     // GIR_Coverage, 1704,
     /* 267436 */     GIR_EraseRootFromParent_Done,
     /* 267437 */   // Label 5343: @267437
     /* 267437 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(267496), // Rule ID 700 //
     /* 267442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267453 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 267456 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 267461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 267465 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 267469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267481 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 267481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 267484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 267494 */     GIR_RootConstrainSelectedInstOperands,
     /* 267495 */     // GIR_Coverage, 700,
     /* 267495 */     GIR_EraseRootFromParent_Done,
     /* 267496 */   // Label 5344: @267496
     /* 267496 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(267555), // Rule ID 1702 //
     /* 267501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267512 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 267515 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 267520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 267524 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 267528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267540 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 267540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 267543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 267553 */     GIR_RootConstrainSelectedInstOperands,
     /* 267554 */     // GIR_Coverage, 1702,
     /* 267554 */     GIR_EraseRootFromParent_Done,
     /* 267555 */   // Label 5345: @267555
     /* 267555 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(267582), // Rule ID 6325 //
     /* 267560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 267567 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 267567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 267570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 267577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267580 */     GIR_RootConstrainSelectedInstOperands,
     /* 267581 */     // GIR_Coverage, 6325,
     /* 267581 */     GIR_EraseRootFromParent_Done,
     /* 267582 */   // Label 5346: @267582
     /* 267582 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(267603), // Rule ID 6316 //
     /* 267587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267591 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 267591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 267594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 267598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267601 */     GIR_RootConstrainSelectedInstOperands,
     /* 267602 */     // GIR_Coverage, 6316,
     /* 267602 */     GIR_EraseRootFromParent_Done,
     /* 267603 */   // Label 5347: @267603
     /* 267603 */   GIM_Reject,
     /* 267604 */ // Label 5341: @267604
     /* 267604 */ GIM_Reject,
     /* 267605 */ // Label 5326: @267605
     /* 267605 */ GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(267914),
     /* 267610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 267613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267617 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(267682), // Rule ID 698 //
     /* 267622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267633 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 267636 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 267641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267645 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 267649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 267658 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 267665 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 267665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 267668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 267675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 267680 */     GIR_RootConstrainSelectedInstOperands,
     /* 267681 */     // GIR_Coverage, 698,
     /* 267681 */     GIR_EraseRootFromParent_Done,
     /* 267682 */   // Label 5349: @267682
     /* 267682 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(267747), // Rule ID 1700 //
     /* 267687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267698 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 267701 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 267706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267710 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 267714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267716 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 267723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 267730 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 267730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 267733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 267740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 267745 */     GIR_RootConstrainSelectedInstOperands,
     /* 267746 */     // GIR_Coverage, 1700,
     /* 267746 */     GIR_EraseRootFromParent_Done,
     /* 267747 */   // Label 5350: @267747
     /* 267747 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(267806), // Rule ID 696 //
     /* 267752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267763 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 267766 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 267771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267775 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 267779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267791 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 267791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 267794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 267804 */     GIR_RootConstrainSelectedInstOperands,
     /* 267805 */     // GIR_Coverage, 696,
     /* 267805 */     GIR_EraseRootFromParent_Done,
     /* 267806 */   // Label 5351: @267806
     /* 267806 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(267865), // Rule ID 1698 //
     /* 267811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267822 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 267825 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 267830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267834 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 267838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267850 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 267850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 267853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 267863 */     GIR_RootConstrainSelectedInstOperands,
     /* 267864 */     // GIR_Coverage, 1698,
     /* 267864 */     GIR_EraseRootFromParent_Done,
     /* 267865 */   // Label 5352: @267865
     /* 267865 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(267892), // Rule ID 6322 //
     /* 267870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 267877 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 267877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 267880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 267887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267890 */     GIR_RootConstrainSelectedInstOperands,
     /* 267891 */     // GIR_Coverage, 6322,
     /* 267891 */     GIR_EraseRootFromParent_Done,
     /* 267892 */   // Label 5353: @267892
     /* 267892 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(267913), // Rule ID 6313 //
     /* 267897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267901 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 267901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 267904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 267908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 267911 */     GIR_RootConstrainSelectedInstOperands,
     /* 267912 */     // GIR_Coverage, 6313,
     /* 267912 */     GIR_EraseRootFromParent_Done,
     /* 267913 */   // Label 5354: @267913
     /* 267913 */   GIM_Reject,
     /* 267914 */ // Label 5348: @267914
     /* 267914 */ GIM_Reject,
     /* 267915 */ // Label 5327: @267915
     /* 267915 */ GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(268224),
     /* 267920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 267923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267927 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(267992), // Rule ID 694 //
     /* 267932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 267935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267943 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 267946 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 267951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267955 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 267959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 267968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 267975 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 267975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 267978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 267985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 267990 */     GIR_RootConstrainSelectedInstOperands,
     /* 267991 */     // GIR_Coverage, 694,
     /* 267991 */     GIR_EraseRootFromParent_Done,
     /* 267992 */   // Label 5356: @267992
     /* 267992 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(268057), // Rule ID 1696 //
     /* 267997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268008 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268011 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268020 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 268024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268026 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268040 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 268043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268055 */     GIR_RootConstrainSelectedInstOperands,
     /* 268056 */     // GIR_Coverage, 1696,
     /* 268056 */     GIR_EraseRootFromParent_Done,
     /* 268057 */   // Label 5357: @268057
     /* 268057 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(268116), // Rule ID 692 //
     /* 268062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268073 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268076 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268085 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 268089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268101 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 268101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 268104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268114 */     GIR_RootConstrainSelectedInstOperands,
     /* 268115 */     // GIR_Coverage, 692,
     /* 268115 */     GIR_EraseRootFromParent_Done,
     /* 268116 */   // Label 5358: @268116
     /* 268116 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(268175), // Rule ID 1694 //
     /* 268121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268132 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268135 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268144 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 268148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268160 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 268160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 268163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268173 */     GIR_RootConstrainSelectedInstOperands,
     /* 268174 */     // GIR_Coverage, 1694,
     /* 268174 */     GIR_EraseRootFromParent_Done,
     /* 268175 */   // Label 5359: @268175
     /* 268175 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(268202), // Rule ID 6319 //
     /* 268180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268187 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 268187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 268190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268200 */     GIR_RootConstrainSelectedInstOperands,
     /* 268201 */     // GIR_Coverage, 6319,
     /* 268201 */     GIR_EraseRootFromParent_Done,
     /* 268202 */   // Label 5360: @268202
     /* 268202 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(268223), // Rule ID 6310 //
     /* 268207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268211 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 268211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 268214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268221 */     GIR_RootConstrainSelectedInstOperands,
     /* 268222 */     // GIR_Coverage, 6310,
     /* 268222 */     GIR_EraseRootFromParent_Done,
     /* 268223 */   // Label 5361: @268223
     /* 268223 */   GIM_Reject,
     /* 268224 */ // Label 5355: @268224
     /* 268224 */ GIM_Reject,
     /* 268225 */ // Label 5328: @268225
     /* 268225 */ GIM_Reject,
     /* 268226 */ // Label 44: @268226
     /* 268226 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5367*/ GIMT_Encode4(269005),
     /* 268237 */ /*GILLT_s32*//*Label 5362*/ GIMT_Encode4(268273),
     /* 268241 */ /*GILLT_s64*//*Label 5363*/ GIMT_Encode4(268405), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 268253 */ /*GILLT_v2s64*//*Label 5364*/ GIMT_Encode4(268578), GIMT_Encode4(0),
     /* 268261 */ /*GILLT_v4s32*//*Label 5365*/ GIMT_Encode4(268723), GIMT_Encode4(0),
     /* 268269 */ /*GILLT_v8s16*//*Label 5366*/ GIMT_Encode4(268864),
     /* 268273 */ // Label 5362: @268273
     /* 268273 */ GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(268404),
     /* 268278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 268281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268292 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(268329), // Rule ID 3916 //
     /* 268297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 268305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 268309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268316 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 268316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 268319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 268327 */     GIR_RootConstrainSelectedInstOperands,
     /* 268328 */     // GIR_Coverage, 3916,
     /* 268328 */     GIR_EraseRootFromParent_Done,
     /* 268329 */   // Label 5369: @268329
     /* 268329 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(268366), // Rule ID 3917 //
     /* 268334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 268342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 268346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268353 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 268353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 268356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 268364 */     GIR_RootConstrainSelectedInstOperands,
     /* 268365 */     // GIR_Coverage, 3917,
     /* 268365 */     GIR_EraseRootFromParent_Done,
     /* 268366 */   // Label 5370: @268366
     /* 268366 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(268403), // Rule ID 3915 //
     /* 268371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 268379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 268383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268390 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 268390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 268393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 268401 */     GIR_RootConstrainSelectedInstOperands,
     /* 268402 */     // GIR_Coverage, 3915,
     /* 268402 */     GIR_EraseRootFromParent_Done,
     /* 268403 */   // Label 5371: @268403
     /* 268403 */   GIM_Reject,
     /* 268404 */ // Label 5368: @268404
     /* 268404 */ GIM_Reject,
     /* 268405 */ // Label 5363: @268405
     /* 268405 */ GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(268577),
     /* 268410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 268413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268424 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(268492), // Rule ID 3918 //
     /* 268429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 268437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 268441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268448 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 268448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 268451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 268455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 268463 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 268467 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 268470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 268483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268490 */     GIR_RootConstrainSelectedInstOperands,
     /* 268491 */     // GIR_Coverage, 3918,
     /* 268491 */     GIR_EraseRootFromParent_Done,
     /* 268492 */   // Label 5373: @268492
     /* 268492 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(268560), // Rule ID 3919 //
     /* 268497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 268505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 268509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268516 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 268516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 268519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 268523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268528 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 268531 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 268535 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 268538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 268551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268558 */     GIR_RootConstrainSelectedInstOperands,
     /* 268559 */     // GIR_Coverage, 3919,
     /* 268559 */     GIR_EraseRootFromParent_Done,
     /* 268560 */   // Label 5374: @268560
     /* 268560 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(268576), // Rule ID 120 //
     /* 268565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268569 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 268569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 268574 */     GIR_RootConstrainSelectedInstOperands,
     /* 268575 */     // GIR_Coverage, 120,
     /* 268575 */     GIR_Done,
     /* 268576 */   // Label 5375: @268576
     /* 268576 */   GIM_Reject,
     /* 268577 */ // Label 5372: @268577
     /* 268577 */ GIM_Reject,
     /* 268578 */ // Label 5364: @268578
     /* 268578 */ GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(268722),
     /* 268583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 268586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 268589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268593 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(268657), // Rule ID 6308 //
     /* 268598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 268606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 268610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 268619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 268623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 268627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 268631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268635 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 268639 */     // MIs[3] Operand 1
     /* 268639 */     // No operand predicates
     /* 268639 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 268641 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 268641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 268644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 268650 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 268655 */     GIR_RootConstrainSelectedInstOperands,
     /* 268656 */     // GIR_Coverage, 6308,
     /* 268656 */     GIR_EraseRootFromParent_Done,
     /* 268657 */   // Label 5377: @268657
     /* 268657 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(268721), // Rule ID 6305 //
     /* 268662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 268670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 268674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 268683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 268687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 268691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 268695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268699 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 268703 */     // MIs[3] Operand 1
     /* 268703 */     // No operand predicates
     /* 268703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 268705 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 268705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 268708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 268714 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 268719 */     GIR_RootConstrainSelectedInstOperands,
     /* 268720 */     // GIR_Coverage, 6305,
     /* 268720 */     GIR_EraseRootFromParent_Done,
     /* 268721 */   // Label 5378: @268721
     /* 268721 */   GIM_Reject,
     /* 268722 */ // Label 5376: @268722
     /* 268722 */ GIM_Reject,
     /* 268723 */ // Label 5365: @268723
     /* 268723 */ GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(268863),
     /* 268728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 268731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 268734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268738 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(268800), // Rule ID 6307 //
     /* 268743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 268751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 268755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 268764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 268768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 268772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 268776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268780 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 268784 */     // MIs[3] Operand 1
     /* 268784 */     // No operand predicates
     /* 268784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 268786 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 268786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 268789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 268795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 268798 */     GIR_RootConstrainSelectedInstOperands,
     /* 268799 */     // GIR_Coverage, 6307,
     /* 268799 */     GIR_EraseRootFromParent_Done,
     /* 268800 */   // Label 5380: @268800
     /* 268800 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(268862), // Rule ID 6304 //
     /* 268805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 268813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 268817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 268826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 268830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 268834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 268838 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268842 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 268846 */     // MIs[3] Operand 1
     /* 268846 */     // No operand predicates
     /* 268846 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 268848 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 268848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 268851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 268857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 268860 */     GIR_RootConstrainSelectedInstOperands,
     /* 268861 */     // GIR_Coverage, 6304,
     /* 268861 */     GIR_EraseRootFromParent_Done,
     /* 268862 */   // Label 5381: @268862
     /* 268862 */   GIM_Reject,
     /* 268863 */ // Label 5379: @268863
     /* 268863 */ GIM_Reject,
     /* 268864 */ // Label 5366: @268864
     /* 268864 */ GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(269004),
     /* 268869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 268872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 268875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268879 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(268941), // Rule ID 6306 //
     /* 268884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 268892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 268896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 268905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 268909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 268913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 268917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268921 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 268925 */     // MIs[3] Operand 1
     /* 268925 */     // No operand predicates
     /* 268925 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 268927 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 268927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 268930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 268936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 268939 */     GIR_RootConstrainSelectedInstOperands,
     /* 268940 */     // GIR_Coverage, 6306,
     /* 268940 */     GIR_EraseRootFromParent_Done,
     /* 268941 */   // Label 5383: @268941
     /* 268941 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(269003), // Rule ID 6303 //
     /* 268946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 268954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 268958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 268967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 268971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 268975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 268979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268983 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 268987 */     // MIs[3] Operand 1
     /* 268987 */     // No operand predicates
     /* 268987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 268989 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 268989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 268992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 268998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 269001 */     GIR_RootConstrainSelectedInstOperands,
     /* 269002 */     // GIR_Coverage, 6303,
     /* 269002 */     GIR_EraseRootFromParent_Done,
     /* 269003 */   // Label 5384: @269003
     /* 269003 */   GIM_Reject,
     /* 269004 */ // Label 5382: @269004
     /* 269004 */ GIM_Reject,
     /* 269005 */ // Label 5367: @269005
     /* 269005 */ GIM_Reject,
     /* 269006 */ // Label 45: @269006
     /* 269006 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5387*/ GIMT_Encode4(269398),
     /* 269017 */ /*GILLT_s32*//*Label 5385*/ GIMT_Encode4(269025),
     /* 269021 */ /*GILLT_s64*//*Label 5386*/ GIMT_Encode4(269191),
     /* 269025 */ // Label 5385: @269025
     /* 269025 */ GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(269190),
     /* 269030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 269033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269044 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(269078), // Rule ID 4005 //
     /* 269049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 269061 */     // MIs[1] Operand 1
     /* 269061 */     // No operand predicates
     /* 269061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269063 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 269063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 269066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 269073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 269076 */     GIR_RootConstrainSelectedInstOperands,
     /* 269077 */     // GIR_Coverage, 4005,
     /* 269077 */     GIR_EraseRootFromParent_Done,
     /* 269078 */   // Label 5389: @269078
     /* 269078 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(269115), // Rule ID 3922 //
     /* 269083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 269091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269102 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 269105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269113 */     GIR_RootConstrainSelectedInstOperands,
     /* 269114 */     // GIR_Coverage, 3922,
     /* 269114 */     GIR_EraseRootFromParent_Done,
     /* 269115 */   // Label 5390: @269115
     /* 269115 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(269152), // Rule ID 3923 //
     /* 269120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269139 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 269142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269150 */     GIR_RootConstrainSelectedInstOperands,
     /* 269151 */     // GIR_Coverage, 3923,
     /* 269151 */     GIR_EraseRootFromParent_Done,
     /* 269152 */   // Label 5391: @269152
     /* 269152 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(269189), // Rule ID 3921 //
     /* 269157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269176 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 269179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269187 */     GIR_RootConstrainSelectedInstOperands,
     /* 269188 */     // GIR_Coverage, 3921,
     /* 269188 */     GIR_EraseRootFromParent_Done,
     /* 269189 */   // Label 5392: @269189
     /* 269189 */   GIM_Reject,
     /* 269190 */ // Label 5388: @269190
     /* 269190 */ GIM_Reject,
     /* 269191 */ // Label 5386: @269191
     /* 269191 */ GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(269397),
     /* 269196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 269199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269210 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(269244), // Rule ID 4006 //
     /* 269215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 269227 */     // MIs[1] Operand 1
     /* 269227 */     // No operand predicates
     /* 269227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269229 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 269229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 269232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 269239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 269242 */     GIR_RootConstrainSelectedInstOperands,
     /* 269243 */     // GIR_Coverage, 4006,
     /* 269243 */     GIR_EraseRootFromParent_Done,
     /* 269244 */   // Label 5394: @269244
     /* 269244 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(269312), // Rule ID 3924 //
     /* 269249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269268 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 269268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 269271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 269275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269280 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 269283 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269287 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 269290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 269303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269310 */     GIR_RootConstrainSelectedInstOperands,
     /* 269311 */     // GIR_Coverage, 3924,
     /* 269311 */     GIR_EraseRootFromParent_Done,
     /* 269312 */   // Label 5395: @269312
     /* 269312 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(269380), // Rule ID 3925 //
     /* 269317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269336 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 269336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 269339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 269343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269348 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 269351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269355 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 269358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 269371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269378 */     GIR_RootConstrainSelectedInstOperands,
     /* 269379 */     // GIR_Coverage, 3925,
     /* 269379 */     GIR_EraseRootFromParent_Done,
     /* 269380 */   // Label 5396: @269380
     /* 269380 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(269396), // Rule ID 121 //
     /* 269385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269389 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 269389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 269394 */     GIR_RootConstrainSelectedInstOperands,
     /* 269395 */     // GIR_Coverage, 121,
     /* 269395 */     GIR_Done,
     /* 269396 */   // Label 5397: @269396
     /* 269396 */   GIM_Reject,
     /* 269397 */ // Label 5393: @269397
     /* 269397 */ GIM_Reject,
     /* 269398 */ // Label 5387: @269398
     /* 269398 */ GIM_Reject,
     /* 269399 */ // Label 46: @269399
     /* 269399 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5400*/ GIMT_Encode4(270174),
     /* 269410 */ /*GILLT_s32*//*Label 5398*/ GIMT_Encode4(269418),
     /* 269414 */ /*GILLT_s64*//*Label 5399*/ GIMT_Encode4(269724),
     /* 269418 */ // Label 5398: @269418
     /* 269418 */ GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(269723),
     /* 269423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 269426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269433 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(269497), // Rule ID 6468 //
     /* 269438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 269446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269455 */     // MIs[1] Operand 2
     /* 269455 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 269466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269474 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 269478 */     // MIs[2] Operand 1
     /* 269478 */     // No operand predicates
     /* 269478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 269480 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 269480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 269483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 269489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 269492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 269495 */     GIR_RootConstrainSelectedInstOperands,
     /* 269496 */     // GIR_Coverage, 6468,
     /* 269496 */     GIR_EraseRootFromParent_Done,
     /* 269497 */   // Label 5402: @269497
     /* 269497 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(269561), // Rule ID 6470 //
     /* 269502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 269510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269519 */     // MIs[1] Operand 2
     /* 269519 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 269530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269538 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 269542 */     // MIs[2] Operand 1
     /* 269542 */     // No operand predicates
     /* 269542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 269544 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 269544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 269547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 269553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 269556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 269559 */     GIR_RootConstrainSelectedInstOperands,
     /* 269560 */     // GIR_Coverage, 6470,
     /* 269560 */     GIR_EraseRootFromParent_Done,
     /* 269561 */   // Label 5403: @269561
     /* 269561 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(269599), // Rule ID 4003 //
     /* 269566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 269582 */     // MIs[1] Operand 1
     /* 269582 */     // No operand predicates
     /* 269582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269584 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 269584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 269587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 269594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 269597 */     GIR_RootConstrainSelectedInstOperands,
     /* 269598 */     // GIR_Coverage, 4003,
     /* 269598 */     GIR_EraseRootFromParent_Done,
     /* 269599 */   // Label 5404: @269599
     /* 269599 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(269640), // Rule ID 2426 //
     /* 269604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 269616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269627 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 269630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269638 */     GIR_RootConstrainSelectedInstOperands,
     /* 269639 */     // GIR_Coverage, 2426,
     /* 269639 */     GIR_EraseRootFromParent_Done,
     /* 269640 */   // Label 5405: @269640
     /* 269640 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(269681), // Rule ID 2427 //
     /* 269645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269668 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 269671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269679 */     GIR_RootConstrainSelectedInstOperands,
     /* 269680 */     // GIR_Coverage, 2427,
     /* 269680 */     GIR_EraseRootFromParent_Done,
     /* 269681 */   // Label 5406: @269681
     /* 269681 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(269722), // Rule ID 2425 //
     /* 269686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269709 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 269712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269720 */     GIR_RootConstrainSelectedInstOperands,
     /* 269721 */     // GIR_Coverage, 2425,
     /* 269721 */     GIR_EraseRootFromParent_Done,
     /* 269722 */   // Label 5407: @269722
     /* 269722 */   GIM_Reject,
     /* 269723 */ // Label 5401: @269723
     /* 269723 */ GIM_Reject,
     /* 269724 */ // Label 5399: @269724
     /* 269724 */ GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(270173),
     /* 269729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 269732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269739 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(269803), // Rule ID 6469 //
     /* 269744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 269752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 269756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269761 */     // MIs[1] Operand 2
     /* 269761 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 269772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269780 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 269784 */     // MIs[2] Operand 1
     /* 269784 */     // No operand predicates
     /* 269784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 269786 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 269786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 269789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 269795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 269798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 269801 */     GIR_RootConstrainSelectedInstOperands,
     /* 269802 */     // GIR_Coverage, 6469,
     /* 269802 */     GIR_EraseRootFromParent_Done,
     /* 269803 */   // Label 5409: @269803
     /* 269803 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(269867), // Rule ID 6471 //
     /* 269808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 269816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 269820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269825 */     // MIs[1] Operand 2
     /* 269825 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 269836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269844 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 269848 */     // MIs[2] Operand 1
     /* 269848 */     // No operand predicates
     /* 269848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 269850 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 269850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 269853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 269859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 269862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 269865 */     GIR_RootConstrainSelectedInstOperands,
     /* 269866 */     // GIR_Coverage, 6471,
     /* 269866 */     GIR_EraseRootFromParent_Done,
     /* 269867 */   // Label 5410: @269867
     /* 269867 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(269970), // Rule ID 6472 //
     /* 269872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269897 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 269901 */     // MIs[2] Operand 1
     /* 269901 */     // No operand predicates
     /* 269901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 269903 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 269903 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 269906 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 269910 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 269917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 269920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 269924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269929 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 269932 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 269936 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 269939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 269957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 269965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 269968 */     GIR_RootConstrainSelectedInstOperands,
     /* 269969 */     // GIR_Coverage, 6472,
     /* 269969 */     GIR_EraseRootFromParent_Done,
     /* 269970 */   // Label 5411: @269970
     /* 269970 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(270008), // Rule ID 4004 //
     /* 269975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 269991 */     // MIs[1] Operand 1
     /* 269991 */     // No operand predicates
     /* 269991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269993 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 269993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 269996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 270006 */     GIR_RootConstrainSelectedInstOperands,
     /* 270007 */     // GIR_Coverage, 4004,
     /* 270007 */     GIR_EraseRootFromParent_Done,
     /* 270008 */   // Label 5412: @270008
     /* 270008 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(270080), // Rule ID 2428 //
     /* 270013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270036 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270048 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270051 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270055 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 270071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270078 */     GIR_RootConstrainSelectedInstOperands,
     /* 270079 */     // GIR_Coverage, 2428,
     /* 270079 */     GIR_EraseRootFromParent_Done,
     /* 270080 */   // Label 5413: @270080
     /* 270080 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(270152), // Rule ID 2429 //
     /* 270085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270108 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270120 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270123 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270127 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 270143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270150 */     GIR_RootConstrainSelectedInstOperands,
     /* 270151 */     // GIR_Coverage, 2429,
     /* 270151 */     GIR_EraseRootFromParent_Done,
     /* 270152 */   // Label 5414: @270152
     /* 270152 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(270172), // Rule ID 119 //
     /* 270157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270165 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 270165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 270170 */     GIR_RootConstrainSelectedInstOperands,
     /* 270171 */     // GIR_Coverage, 119,
     /* 270171 */     GIR_Done,
     /* 270172 */   // Label 5415: @270172
     /* 270172 */   GIM_Reject,
     /* 270173 */ // Label 5408: @270173
     /* 270173 */ GIM_Reject,
     /* 270174 */ // Label 5400: @270174
     /* 270174 */ GIM_Reject,
     /* 270175 */ // Label 47: @270175
     /* 270175 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5418*/ GIMT_Encode4(270304),
     /* 270186 */ /*GILLT_s32*//*Label 5416*/ GIMT_Encode4(270194),
     /* 270190 */ /*GILLT_s64*//*Label 5417*/ GIMT_Encode4(270249),
     /* 270194 */ // Label 5416: @270194
     /* 270194 */ GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(270248), // Rule ID 188 //
     /* 270199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 270202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 270205 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 270208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270220 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 270224 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270228 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270232 */   // MIs[1] Operand 1
     /* 270232 */   // No operand predicates
     /* 270232 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270234 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 270234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 270237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270239 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270241 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 270243 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270246 */   GIR_RootConstrainSelectedInstOperands,
     /* 270247 */   // GIR_Coverage, 188,
     /* 270247 */   GIR_EraseRootFromParent_Done,
     /* 270248 */ // Label 5419: @270248
     /* 270248 */ GIM_Reject,
     /* 270249 */ // Label 5417: @270249
     /* 270249 */ GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(270303), // Rule ID 189 //
     /* 270254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 270257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270260 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 270263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270275 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 270279 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270283 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 270287 */   // MIs[1] Operand 1
     /* 270287 */   // No operand predicates
     /* 270287 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270289 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 270289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 270292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270294 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270296 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 270298 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270301 */   GIR_RootConstrainSelectedInstOperands,
     /* 270302 */   // GIR_Coverage, 189,
     /* 270302 */   GIR_EraseRootFromParent_Done,
     /* 270303 */ // Label 5420: @270303
     /* 270303 */ GIM_Reject,
     /* 270304 */ // Label 5418: @270304
     /* 270304 */ GIM_Reject,
     /* 270305 */ // Label 48: @270305
     /* 270305 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5423*/ GIMT_Encode4(270797),
     /* 270316 */ /*GILLT_s32*//*Label 5421*/ GIMT_Encode4(270324),
     /* 270320 */ /*GILLT_s64*//*Label 5422*/ GIMT_Encode4(270540),
     /* 270324 */ // Label 5421: @270324
     /* 270324 */ GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(270539),
     /* 270329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 270332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270339 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(270378), // Rule ID 184 //
     /* 270344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 270352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 270365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270367 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 270367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 270370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270376 */     GIR_RootConstrainSelectedInstOperands,
     /* 270377 */     // GIR_Coverage, 184,
     /* 270377 */     GIR_EraseRootFromParent_Done,
     /* 270378 */   // Label 5425: @270378
     /* 270378 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(270415), // Rule ID 3999 //
     /* 270383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270399 */     // MIs[1] Operand 1
     /* 270399 */     // No operand predicates
     /* 270399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270401 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 270401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 270404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270413 */     GIR_RootConstrainSelectedInstOperands,
     /* 270414 */     // GIR_Coverage, 3999,
     /* 270414 */     GIR_EraseRootFromParent_Done,
     /* 270415 */   // Label 5426: @270415
     /* 270415 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(270456), // Rule ID 3928 //
     /* 270420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 270432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270443 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 270446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270454 */     GIR_RootConstrainSelectedInstOperands,
     /* 270455 */     // GIR_Coverage, 3928,
     /* 270455 */     GIR_EraseRootFromParent_Done,
     /* 270456 */   // Label 5427: @270456
     /* 270456 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(270497), // Rule ID 3929 //
     /* 270461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270484 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 270487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270495 */     GIR_RootConstrainSelectedInstOperands,
     /* 270496 */     // GIR_Coverage, 3929,
     /* 270496 */     GIR_EraseRootFromParent_Done,
     /* 270497 */   // Label 5428: @270497
     /* 270497 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(270538), // Rule ID 3927 //
     /* 270502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270525 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 270528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270536 */     GIR_RootConstrainSelectedInstOperands,
     /* 270537 */     // GIR_Coverage, 3927,
     /* 270537 */     GIR_EraseRootFromParent_Done,
     /* 270538 */   // Label 5429: @270538
     /* 270538 */   GIM_Reject,
     /* 270539 */ // Label 5424: @270539
     /* 270539 */ GIM_Reject,
     /* 270540 */ // Label 5422: @270540
     /* 270540 */ GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(270796),
     /* 270545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 270548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270555 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(270594), // Rule ID 187 //
     /* 270560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 270568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 270581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270583 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 270583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 270586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270592 */     GIR_RootConstrainSelectedInstOperands,
     /* 270593 */     // GIR_Coverage, 187,
     /* 270593 */     GIR_EraseRootFromParent_Done,
     /* 270594 */   // Label 5431: @270594
     /* 270594 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(270631), // Rule ID 4000 //
     /* 270599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 270615 */     // MIs[1] Operand 1
     /* 270615 */     // No operand predicates
     /* 270615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270617 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 270617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 270620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270624 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270629 */     GIR_RootConstrainSelectedInstOperands,
     /* 270630 */     // GIR_Coverage, 4000,
     /* 270630 */     GIR_EraseRootFromParent_Done,
     /* 270631 */   // Label 5432: @270631
     /* 270631 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(270703), // Rule ID 3930 //
     /* 270636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270659 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270671 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270678 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 270694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270701 */     GIR_RootConstrainSelectedInstOperands,
     /* 270702 */     // GIR_Coverage, 3930,
     /* 270702 */     GIR_EraseRootFromParent_Done,
     /* 270703 */   // Label 5433: @270703
     /* 270703 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(270775), // Rule ID 3931 //
     /* 270708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270731 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270743 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270750 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 270766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270773 */     GIR_RootConstrainSelectedInstOperands,
     /* 270774 */     // GIR_Coverage, 3931,
     /* 270774 */     GIR_EraseRootFromParent_Done,
     /* 270775 */   // Label 5434: @270775
     /* 270775 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(270795), // Rule ID 122 //
     /* 270780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270788 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 270788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 270793 */     GIR_RootConstrainSelectedInstOperands,
     /* 270794 */     // GIR_Coverage, 122,
     /* 270794 */     GIR_Done,
     /* 270795 */   // Label 5435: @270795
     /* 270795 */   GIM_Reject,
     /* 270796 */ // Label 5430: @270796
     /* 270796 */ GIM_Reject,
     /* 270797 */ // Label 5423: @270797
     /* 270797 */ GIM_Reject,
     /* 270798 */ // Label 49: @270798
     /* 270798 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 5443*/ GIMT_Encode4(275373),
     /* 270809 */ /*GILLT_v2s32*//*Label 5436*/ GIMT_Encode4(270837),
     /* 270813 */ /*GILLT_v2s64*//*Label 5437*/ GIMT_Encode4(271485),
     /* 270817 */ /*GILLT_v4s16*//*Label 5438*/ GIMT_Encode4(272133),
     /* 270821 */ /*GILLT_v4s32*//*Label 5439*/ GIMT_Encode4(272781),
     /* 270825 */ /*GILLT_v8s8*//*Label 5440*/ GIMT_Encode4(273429),
     /* 270829 */ /*GILLT_v8s16*//*Label 5441*/ GIMT_Encode4(274077),
     /* 270833 */ /*GILLT_v16s8*//*Label 5442*/ GIMT_Encode4(274725),
     /* 270837 */ // Label 5436: @270837
     /* 270837 */ GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(271484),
     /* 270842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 270845 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 270848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270852 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(270889), // Rule ID 5152 //
     /* 270857 */     // MIs[0] Operand 1
     /* 270857 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 270862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270866 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270872 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270880 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 270880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 270883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270887 */     GIR_RootConstrainSelectedInstOperands,
     /* 270888 */     // GIR_Coverage, 5152,
     /* 270888 */     GIR_EraseRootFromParent_Done,
     /* 270889 */   // Label 5445: @270889
     /* 270889 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(270926), // Rule ID 5159 //
     /* 270894 */     // MIs[0] Operand 1
     /* 270894 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 270899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270903 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270909 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270917 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 270917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 270920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270924 */     GIR_RootConstrainSelectedInstOperands,
     /* 270925 */     // GIR_Coverage, 5159,
     /* 270925 */     GIR_EraseRootFromParent_Done,
     /* 270926 */   // Label 5446: @270926
     /* 270926 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(270963), // Rule ID 5166 //
     /* 270931 */     // MIs[0] Operand 1
     /* 270931 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 270936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270940 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270946 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270954 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 270954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 270957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270961 */     GIR_RootConstrainSelectedInstOperands,
     /* 270962 */     // GIR_Coverage, 5166,
     /* 270962 */     GIR_EraseRootFromParent_Done,
     /* 270963 */   // Label 5447: @270963
     /* 270963 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(271000), // Rule ID 5173 //
     /* 270968 */     // MIs[0] Operand 1
     /* 270968 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 270973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270977 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 270983 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 270985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270991 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 270991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 270994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270998 */     GIR_RootConstrainSelectedInstOperands,
     /* 270999 */     // GIR_Coverage, 5173,
     /* 270999 */     GIR_EraseRootFromParent_Done,
     /* 271000 */   // Label 5448: @271000
     /* 271000 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(271037), // Rule ID 5180 //
     /* 271005 */     // MIs[0] Operand 1
     /* 271005 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 271010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271014 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271020 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271028 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 271028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 271031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271035 */     GIR_RootConstrainSelectedInstOperands,
     /* 271036 */     // GIR_Coverage, 5180,
     /* 271036 */     GIR_EraseRootFromParent_Done,
     /* 271037 */   // Label 5449: @271037
     /* 271037 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(271074), // Rule ID 5117 //
     /* 271042 */     // MIs[0] Operand 1
     /* 271042 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 271047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271055 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271061 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271065 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 271065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 271068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271072 */     GIR_RootConstrainSelectedInstOperands,
     /* 271073 */     // GIR_Coverage, 5117,
     /* 271073 */     GIR_EraseRootFromParent_Done,
     /* 271074 */   // Label 5450: @271074
     /* 271074 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(271111), // Rule ID 5124 //
     /* 271079 */     // MIs[0] Operand 1
     /* 271079 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271092 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271098 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271102 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 271102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 271105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271109 */     GIR_RootConstrainSelectedInstOperands,
     /* 271110 */     // GIR_Coverage, 5124,
     /* 271110 */     GIR_EraseRootFromParent_Done,
     /* 271111 */   // Label 5451: @271111
     /* 271111 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(271148), // Rule ID 5131 //
     /* 271116 */     // MIs[0] Operand 1
     /* 271116 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271129 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271135 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271139 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 271139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 271142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271146 */     GIR_RootConstrainSelectedInstOperands,
     /* 271147 */     // GIR_Coverage, 5131,
     /* 271147 */     GIR_EraseRootFromParent_Done,
     /* 271148 */   // Label 5452: @271148
     /* 271148 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(271185), // Rule ID 5138 //
     /* 271153 */     // MIs[0] Operand 1
     /* 271153 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 271158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271166 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271172 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271176 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 271176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 271179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271183 */     GIR_RootConstrainSelectedInstOperands,
     /* 271184 */     // GIR_Coverage, 5138,
     /* 271184 */     GIR_EraseRootFromParent_Done,
     /* 271185 */   // Label 5453: @271185
     /* 271185 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(271222), // Rule ID 5145 //
     /* 271190 */     // MIs[0] Operand 1
     /* 271190 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 271195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271203 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271209 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271213 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 271213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 271216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271220 */     GIR_RootConstrainSelectedInstOperands,
     /* 271221 */     // GIR_Coverage, 5145,
     /* 271221 */     GIR_EraseRootFromParent_Done,
     /* 271222 */   // Label 5454: @271222
     /* 271222 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(271251), // Rule ID 5054 //
     /* 271227 */     // MIs[0] Operand 1
     /* 271227 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 271232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271240 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 271240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 271243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271249 */     GIR_RootConstrainSelectedInstOperands,
     /* 271250 */     // GIR_Coverage, 5054,
     /* 271250 */     GIR_EraseRootFromParent_Done,
     /* 271251 */   // Label 5455: @271251
     /* 271251 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(271280), // Rule ID 5061 //
     /* 271256 */     // MIs[0] Operand 1
     /* 271256 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271269 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 271269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 271272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271278 */     GIR_RootConstrainSelectedInstOperands,
     /* 271279 */     // GIR_Coverage, 5061,
     /* 271279 */     GIR_EraseRootFromParent_Done,
     /* 271280 */   // Label 5456: @271280
     /* 271280 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(271309), // Rule ID 5068 //
     /* 271285 */     // MIs[0] Operand 1
     /* 271285 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271298 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 271298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 271301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271307 */     GIR_RootConstrainSelectedInstOperands,
     /* 271308 */     // GIR_Coverage, 5068,
     /* 271308 */     GIR_EraseRootFromParent_Done,
     /* 271309 */   // Label 5457: @271309
     /* 271309 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(271338), // Rule ID 5075 //
     /* 271314 */     // MIs[0] Operand 1
     /* 271314 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 271319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271327 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 271327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 271330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271336 */     GIR_RootConstrainSelectedInstOperands,
     /* 271337 */     // GIR_Coverage, 5075,
     /* 271337 */     GIR_EraseRootFromParent_Done,
     /* 271338 */   // Label 5458: @271338
     /* 271338 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(271367), // Rule ID 5082 //
     /* 271343 */     // MIs[0] Operand 1
     /* 271343 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 271348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271356 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 271356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 271359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271365 */     GIR_RootConstrainSelectedInstOperands,
     /* 271366 */     // GIR_Coverage, 5082,
     /* 271366 */     GIR_EraseRootFromParent_Done,
     /* 271367 */   // Label 5459: @271367
     /* 271367 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(271396), // Rule ID 5089 //
     /* 271372 */     // MIs[0] Operand 1
     /* 271372 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 271377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271385 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 271385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 271388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271394 */     GIR_RootConstrainSelectedInstOperands,
     /* 271395 */     // GIR_Coverage, 5089,
     /* 271395 */     GIR_EraseRootFromParent_Done,
     /* 271396 */   // Label 5460: @271396
     /* 271396 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(271425), // Rule ID 5096 //
     /* 271401 */     // MIs[0] Operand 1
     /* 271401 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 271406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271414 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 271414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 271417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271423 */     GIR_RootConstrainSelectedInstOperands,
     /* 271424 */     // GIR_Coverage, 5096,
     /* 271424 */     GIR_EraseRootFromParent_Done,
     /* 271425 */   // Label 5461: @271425
     /* 271425 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(271454), // Rule ID 5103 //
     /* 271430 */     // MIs[0] Operand 1
     /* 271430 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 271435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271443 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 271443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 271446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271452 */     GIR_RootConstrainSelectedInstOperands,
     /* 271453 */     // GIR_Coverage, 5103,
     /* 271453 */     GIR_EraseRootFromParent_Done,
     /* 271454 */   // Label 5462: @271454
     /* 271454 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(271483), // Rule ID 5110 //
     /* 271459 */     // MIs[0] Operand 1
     /* 271459 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 271464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271472 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 271472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 271475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271481 */     GIR_RootConstrainSelectedInstOperands,
     /* 271482 */     // GIR_Coverage, 5110,
     /* 271482 */     GIR_EraseRootFromParent_Done,
     /* 271483 */   // Label 5463: @271483
     /* 271483 */   GIM_Reject,
     /* 271484 */ // Label 5444: @271484
     /* 271484 */ GIM_Reject,
     /* 271485 */ // Label 5437: @271485
     /* 271485 */ GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(272132),
     /* 271490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 271493 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 271496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271500 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(271537), // Rule ID 5154 //
     /* 271505 */     // MIs[0] Operand 1
     /* 271505 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 271510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271514 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271520 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271528 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 271528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 271531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271535 */     GIR_RootConstrainSelectedInstOperands,
     /* 271536 */     // GIR_Coverage, 5154,
     /* 271536 */     GIR_EraseRootFromParent_Done,
     /* 271537 */   // Label 5465: @271537
     /* 271537 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(271574), // Rule ID 5161 //
     /* 271542 */     // MIs[0] Operand 1
     /* 271542 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271551 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271557 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271565 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 271565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 271568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271572 */     GIR_RootConstrainSelectedInstOperands,
     /* 271573 */     // GIR_Coverage, 5161,
     /* 271573 */     GIR_EraseRootFromParent_Done,
     /* 271574 */   // Label 5466: @271574
     /* 271574 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(271611), // Rule ID 5168 //
     /* 271579 */     // MIs[0] Operand 1
     /* 271579 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271588 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271594 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271602 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 271602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 271605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271609 */     GIR_RootConstrainSelectedInstOperands,
     /* 271610 */     // GIR_Coverage, 5168,
     /* 271610 */     GIR_EraseRootFromParent_Done,
     /* 271611 */   // Label 5467: @271611
     /* 271611 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(271648), // Rule ID 5175 //
     /* 271616 */     // MIs[0] Operand 1
     /* 271616 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 271621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271625 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271631 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271639 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 271639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 271642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271646 */     GIR_RootConstrainSelectedInstOperands,
     /* 271647 */     // GIR_Coverage, 5175,
     /* 271647 */     GIR_EraseRootFromParent_Done,
     /* 271648 */   // Label 5468: @271648
     /* 271648 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(271685), // Rule ID 5182 //
     /* 271653 */     // MIs[0] Operand 1
     /* 271653 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 271658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271662 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271668 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271676 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 271676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 271679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271683 */     GIR_RootConstrainSelectedInstOperands,
     /* 271684 */     // GIR_Coverage, 5182,
     /* 271684 */     GIR_EraseRootFromParent_Done,
     /* 271685 */   // Label 5469: @271685
     /* 271685 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(271722), // Rule ID 5119 //
     /* 271690 */     // MIs[0] Operand 1
     /* 271690 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 271695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271703 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271709 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271713 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 271713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 271716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271720 */     GIR_RootConstrainSelectedInstOperands,
     /* 271721 */     // GIR_Coverage, 5119,
     /* 271721 */     GIR_EraseRootFromParent_Done,
     /* 271722 */   // Label 5470: @271722
     /* 271722 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(271759), // Rule ID 5126 //
     /* 271727 */     // MIs[0] Operand 1
     /* 271727 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271740 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271746 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271750 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 271750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 271753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271757 */     GIR_RootConstrainSelectedInstOperands,
     /* 271758 */     // GIR_Coverage, 5126,
     /* 271758 */     GIR_EraseRootFromParent_Done,
     /* 271759 */   // Label 5471: @271759
     /* 271759 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(271796), // Rule ID 5133 //
     /* 271764 */     // MIs[0] Operand 1
     /* 271764 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271777 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271783 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271787 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 271787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 271790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271794 */     GIR_RootConstrainSelectedInstOperands,
     /* 271795 */     // GIR_Coverage, 5133,
     /* 271795 */     GIR_EraseRootFromParent_Done,
     /* 271796 */   // Label 5472: @271796
     /* 271796 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(271833), // Rule ID 5140 //
     /* 271801 */     // MIs[0] Operand 1
     /* 271801 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 271806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271814 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271820 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271824 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 271824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 271827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271831 */     GIR_RootConstrainSelectedInstOperands,
     /* 271832 */     // GIR_Coverage, 5140,
     /* 271832 */     GIR_EraseRootFromParent_Done,
     /* 271833 */   // Label 5473: @271833
     /* 271833 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(271870), // Rule ID 5147 //
     /* 271838 */     // MIs[0] Operand 1
     /* 271838 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 271843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271851 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271857 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271861 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 271861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 271864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271868 */     GIR_RootConstrainSelectedInstOperands,
     /* 271869 */     // GIR_Coverage, 5147,
     /* 271869 */     GIR_EraseRootFromParent_Done,
     /* 271870 */   // Label 5474: @271870
     /* 271870 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(271899), // Rule ID 5056 //
     /* 271875 */     // MIs[0] Operand 1
     /* 271875 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 271880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271888 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 271888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 271891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271897 */     GIR_RootConstrainSelectedInstOperands,
     /* 271898 */     // GIR_Coverage, 5056,
     /* 271898 */     GIR_EraseRootFromParent_Done,
     /* 271899 */   // Label 5475: @271899
     /* 271899 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(271928), // Rule ID 5063 //
     /* 271904 */     // MIs[0] Operand 1
     /* 271904 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271917 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 271917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 271920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271926 */     GIR_RootConstrainSelectedInstOperands,
     /* 271927 */     // GIR_Coverage, 5063,
     /* 271927 */     GIR_EraseRootFromParent_Done,
     /* 271928 */   // Label 5476: @271928
     /* 271928 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(271957), // Rule ID 5070 //
     /* 271933 */     // MIs[0] Operand 1
     /* 271933 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271946 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 271946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 271949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271955 */     GIR_RootConstrainSelectedInstOperands,
     /* 271956 */     // GIR_Coverage, 5070,
     /* 271956 */     GIR_EraseRootFromParent_Done,
     /* 271957 */   // Label 5477: @271957
     /* 271957 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(271986), // Rule ID 5077 //
     /* 271962 */     // MIs[0] Operand 1
     /* 271962 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 271967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 271975 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 271975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 271978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271984 */     GIR_RootConstrainSelectedInstOperands,
     /* 271985 */     // GIR_Coverage, 5077,
     /* 271985 */     GIR_EraseRootFromParent_Done,
     /* 271986 */   // Label 5478: @271986
     /* 271986 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(272015), // Rule ID 5084 //
     /* 271991 */     // MIs[0] Operand 1
     /* 271991 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 271996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272004 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 272004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 272007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272013 */     GIR_RootConstrainSelectedInstOperands,
     /* 272014 */     // GIR_Coverage, 5084,
     /* 272014 */     GIR_EraseRootFromParent_Done,
     /* 272015 */   // Label 5479: @272015
     /* 272015 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(272044), // Rule ID 5091 //
     /* 272020 */     // MIs[0] Operand 1
     /* 272020 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 272025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272033 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 272033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 272036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272042 */     GIR_RootConstrainSelectedInstOperands,
     /* 272043 */     // GIR_Coverage, 5091,
     /* 272043 */     GIR_EraseRootFromParent_Done,
     /* 272044 */   // Label 5480: @272044
     /* 272044 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(272073), // Rule ID 5098 //
     /* 272049 */     // MIs[0] Operand 1
     /* 272049 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 272054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272062 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 272062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 272065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272071 */     GIR_RootConstrainSelectedInstOperands,
     /* 272072 */     // GIR_Coverage, 5098,
     /* 272072 */     GIR_EraseRootFromParent_Done,
     /* 272073 */   // Label 5481: @272073
     /* 272073 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(272102), // Rule ID 5105 //
     /* 272078 */     // MIs[0] Operand 1
     /* 272078 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 272083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272091 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 272091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 272094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272100 */     GIR_RootConstrainSelectedInstOperands,
     /* 272101 */     // GIR_Coverage, 5105,
     /* 272101 */     GIR_EraseRootFromParent_Done,
     /* 272102 */   // Label 5482: @272102
     /* 272102 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(272131), // Rule ID 5112 //
     /* 272107 */     // MIs[0] Operand 1
     /* 272107 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 272112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272120 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 272120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 272123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272129 */     GIR_RootConstrainSelectedInstOperands,
     /* 272130 */     // GIR_Coverage, 5112,
     /* 272130 */     GIR_EraseRootFromParent_Done,
     /* 272131 */   // Label 5483: @272131
     /* 272131 */   GIM_Reject,
     /* 272132 */ // Label 5464: @272132
     /* 272132 */ GIM_Reject,
     /* 272133 */ // Label 5438: @272133
     /* 272133 */ GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(272780),
     /* 272138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 272141 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 272144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272148 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(272185), // Rule ID 5150 //
     /* 272153 */     // MIs[0] Operand 1
     /* 272153 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272162 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272168 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272176 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 272176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 272179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272183 */     GIR_RootConstrainSelectedInstOperands,
     /* 272184 */     // GIR_Coverage, 5150,
     /* 272184 */     GIR_EraseRootFromParent_Done,
     /* 272185 */   // Label 5485: @272185
     /* 272185 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(272222), // Rule ID 5157 //
     /* 272190 */     // MIs[0] Operand 1
     /* 272190 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272199 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272205 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272213 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 272213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 272216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272220 */     GIR_RootConstrainSelectedInstOperands,
     /* 272221 */     // GIR_Coverage, 5157,
     /* 272221 */     GIR_EraseRootFromParent_Done,
     /* 272222 */   // Label 5486: @272222
     /* 272222 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(272259), // Rule ID 5164 //
     /* 272227 */     // MIs[0] Operand 1
     /* 272227 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272236 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272242 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272250 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 272250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 272253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272257 */     GIR_RootConstrainSelectedInstOperands,
     /* 272258 */     // GIR_Coverage, 5164,
     /* 272258 */     GIR_EraseRootFromParent_Done,
     /* 272259 */   // Label 5487: @272259
     /* 272259 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(272296), // Rule ID 5171 //
     /* 272264 */     // MIs[0] Operand 1
     /* 272264 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 272269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272273 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272279 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272287 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 272287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 272290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272294 */     GIR_RootConstrainSelectedInstOperands,
     /* 272295 */     // GIR_Coverage, 5171,
     /* 272295 */     GIR_EraseRootFromParent_Done,
     /* 272296 */   // Label 5488: @272296
     /* 272296 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(272333), // Rule ID 5178 //
     /* 272301 */     // MIs[0] Operand 1
     /* 272301 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 272306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272310 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272316 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272324 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 272324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 272327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272331 */     GIR_RootConstrainSelectedInstOperands,
     /* 272332 */     // GIR_Coverage, 5178,
     /* 272332 */     GIR_EraseRootFromParent_Done,
     /* 272333 */   // Label 5489: @272333
     /* 272333 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(272370), // Rule ID 5115 //
     /* 272338 */     // MIs[0] Operand 1
     /* 272338 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272351 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272357 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272361 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 272361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 272364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272368 */     GIR_RootConstrainSelectedInstOperands,
     /* 272369 */     // GIR_Coverage, 5115,
     /* 272369 */     GIR_EraseRootFromParent_Done,
     /* 272370 */   // Label 5490: @272370
     /* 272370 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(272407), // Rule ID 5122 //
     /* 272375 */     // MIs[0] Operand 1
     /* 272375 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272388 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272394 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272398 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 272398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 272401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272405 */     GIR_RootConstrainSelectedInstOperands,
     /* 272406 */     // GIR_Coverage, 5122,
     /* 272406 */     GIR_EraseRootFromParent_Done,
     /* 272407 */   // Label 5491: @272407
     /* 272407 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(272444), // Rule ID 5129 //
     /* 272412 */     // MIs[0] Operand 1
     /* 272412 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272425 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272431 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272435 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 272435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 272438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272442 */     GIR_RootConstrainSelectedInstOperands,
     /* 272443 */     // GIR_Coverage, 5129,
     /* 272443 */     GIR_EraseRootFromParent_Done,
     /* 272444 */   // Label 5492: @272444
     /* 272444 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(272481), // Rule ID 5136 //
     /* 272449 */     // MIs[0] Operand 1
     /* 272449 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 272454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272462 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272468 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272472 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 272472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 272475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272479 */     GIR_RootConstrainSelectedInstOperands,
     /* 272480 */     // GIR_Coverage, 5136,
     /* 272480 */     GIR_EraseRootFromParent_Done,
     /* 272481 */   // Label 5493: @272481
     /* 272481 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(272518), // Rule ID 5143 //
     /* 272486 */     // MIs[0] Operand 1
     /* 272486 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 272491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272499 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272505 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272509 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 272509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 272512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272516 */     GIR_RootConstrainSelectedInstOperands,
     /* 272517 */     // GIR_Coverage, 5143,
     /* 272517 */     GIR_EraseRootFromParent_Done,
     /* 272518 */   // Label 5494: @272518
     /* 272518 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(272547), // Rule ID 5052 //
     /* 272523 */     // MIs[0] Operand 1
     /* 272523 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272536 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 272536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 272539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272545 */     GIR_RootConstrainSelectedInstOperands,
     /* 272546 */     // GIR_Coverage, 5052,
     /* 272546 */     GIR_EraseRootFromParent_Done,
     /* 272547 */   // Label 5495: @272547
     /* 272547 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(272576), // Rule ID 5059 //
     /* 272552 */     // MIs[0] Operand 1
     /* 272552 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272565 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 272565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 272568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272574 */     GIR_RootConstrainSelectedInstOperands,
     /* 272575 */     // GIR_Coverage, 5059,
     /* 272575 */     GIR_EraseRootFromParent_Done,
     /* 272576 */   // Label 5496: @272576
     /* 272576 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(272605), // Rule ID 5066 //
     /* 272581 */     // MIs[0] Operand 1
     /* 272581 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272594 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 272594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 272597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272603 */     GIR_RootConstrainSelectedInstOperands,
     /* 272604 */     // GIR_Coverage, 5066,
     /* 272604 */     GIR_EraseRootFromParent_Done,
     /* 272605 */   // Label 5497: @272605
     /* 272605 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(272634), // Rule ID 5073 //
     /* 272610 */     // MIs[0] Operand 1
     /* 272610 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 272615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272623 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 272623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 272626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272632 */     GIR_RootConstrainSelectedInstOperands,
     /* 272633 */     // GIR_Coverage, 5073,
     /* 272633 */     GIR_EraseRootFromParent_Done,
     /* 272634 */   // Label 5498: @272634
     /* 272634 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(272663), // Rule ID 5080 //
     /* 272639 */     // MIs[0] Operand 1
     /* 272639 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 272644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272652 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 272652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 272655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272661 */     GIR_RootConstrainSelectedInstOperands,
     /* 272662 */     // GIR_Coverage, 5080,
     /* 272662 */     GIR_EraseRootFromParent_Done,
     /* 272663 */   // Label 5499: @272663
     /* 272663 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(272692), // Rule ID 5087 //
     /* 272668 */     // MIs[0] Operand 1
     /* 272668 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 272673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272681 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 272681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 272684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272690 */     GIR_RootConstrainSelectedInstOperands,
     /* 272691 */     // GIR_Coverage, 5087,
     /* 272691 */     GIR_EraseRootFromParent_Done,
     /* 272692 */   // Label 5500: @272692
     /* 272692 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(272721), // Rule ID 5094 //
     /* 272697 */     // MIs[0] Operand 1
     /* 272697 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 272702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272710 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 272710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 272713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272719 */     GIR_RootConstrainSelectedInstOperands,
     /* 272720 */     // GIR_Coverage, 5094,
     /* 272720 */     GIR_EraseRootFromParent_Done,
     /* 272721 */   // Label 5501: @272721
     /* 272721 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(272750), // Rule ID 5101 //
     /* 272726 */     // MIs[0] Operand 1
     /* 272726 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 272731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272739 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 272739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 272742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272748 */     GIR_RootConstrainSelectedInstOperands,
     /* 272749 */     // GIR_Coverage, 5101,
     /* 272749 */     GIR_EraseRootFromParent_Done,
     /* 272750 */   // Label 5502: @272750
     /* 272750 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(272779), // Rule ID 5108 //
     /* 272755 */     // MIs[0] Operand 1
     /* 272755 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 272760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272768 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 272768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 272771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272777 */     GIR_RootConstrainSelectedInstOperands,
     /* 272778 */     // GIR_Coverage, 5108,
     /* 272778 */     GIR_EraseRootFromParent_Done,
     /* 272779 */   // Label 5503: @272779
     /* 272779 */   GIM_Reject,
     /* 272780 */ // Label 5484: @272780
     /* 272780 */ GIM_Reject,
     /* 272781 */ // Label 5439: @272781
     /* 272781 */ GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(273428),
     /* 272786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 272789 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 272792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272796 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(272833), // Rule ID 5153 //
     /* 272801 */     // MIs[0] Operand 1
     /* 272801 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272810 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272816 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272824 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 272824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 272827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272831 */     GIR_RootConstrainSelectedInstOperands,
     /* 272832 */     // GIR_Coverage, 5153,
     /* 272832 */     GIR_EraseRootFromParent_Done,
     /* 272833 */   // Label 5505: @272833
     /* 272833 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(272870), // Rule ID 5160 //
     /* 272838 */     // MIs[0] Operand 1
     /* 272838 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272847 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272853 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272861 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 272861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 272864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272868 */     GIR_RootConstrainSelectedInstOperands,
     /* 272869 */     // GIR_Coverage, 5160,
     /* 272869 */     GIR_EraseRootFromParent_Done,
     /* 272870 */   // Label 5506: @272870
     /* 272870 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(272907), // Rule ID 5167 //
     /* 272875 */     // MIs[0] Operand 1
     /* 272875 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272884 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272890 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272898 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 272898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 272901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272905 */     GIR_RootConstrainSelectedInstOperands,
     /* 272906 */     // GIR_Coverage, 5167,
     /* 272906 */     GIR_EraseRootFromParent_Done,
     /* 272907 */   // Label 5507: @272907
     /* 272907 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(272944), // Rule ID 5174 //
     /* 272912 */     // MIs[0] Operand 1
     /* 272912 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 272917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272921 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272927 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272935 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 272935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 272938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272942 */     GIR_RootConstrainSelectedInstOperands,
     /* 272943 */     // GIR_Coverage, 5174,
     /* 272943 */     GIR_EraseRootFromParent_Done,
     /* 272944 */   // Label 5508: @272944
     /* 272944 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(272981), // Rule ID 5181 //
     /* 272949 */     // MIs[0] Operand 1
     /* 272949 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 272954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272958 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272964 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272972 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 272972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 272975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272979 */     GIR_RootConstrainSelectedInstOperands,
     /* 272980 */     // GIR_Coverage, 5181,
     /* 272980 */     GIR_EraseRootFromParent_Done,
     /* 272981 */   // Label 5509: @272981
     /* 272981 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(273018), // Rule ID 5118 //
     /* 272986 */     // MIs[0] Operand 1
     /* 272986 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 272995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272999 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273005 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273009 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 273009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 273012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273016 */     GIR_RootConstrainSelectedInstOperands,
     /* 273017 */     // GIR_Coverage, 5118,
     /* 273017 */     GIR_EraseRootFromParent_Done,
     /* 273018 */   // Label 5510: @273018
     /* 273018 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(273055), // Rule ID 5125 //
     /* 273023 */     // MIs[0] Operand 1
     /* 273023 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273036 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273042 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273046 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 273046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 273049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273053 */     GIR_RootConstrainSelectedInstOperands,
     /* 273054 */     // GIR_Coverage, 5125,
     /* 273054 */     GIR_EraseRootFromParent_Done,
     /* 273055 */   // Label 5511: @273055
     /* 273055 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(273092), // Rule ID 5132 //
     /* 273060 */     // MIs[0] Operand 1
     /* 273060 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273073 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273079 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273083 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 273083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 273086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273090 */     GIR_RootConstrainSelectedInstOperands,
     /* 273091 */     // GIR_Coverage, 5132,
     /* 273091 */     GIR_EraseRootFromParent_Done,
     /* 273092 */   // Label 5512: @273092
     /* 273092 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(273129), // Rule ID 5139 //
     /* 273097 */     // MIs[0] Operand 1
     /* 273097 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273110 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273116 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273120 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 273120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 273123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273127 */     GIR_RootConstrainSelectedInstOperands,
     /* 273128 */     // GIR_Coverage, 5139,
     /* 273128 */     GIR_EraseRootFromParent_Done,
     /* 273129 */   // Label 5513: @273129
     /* 273129 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(273166), // Rule ID 5146 //
     /* 273134 */     // MIs[0] Operand 1
     /* 273134 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273147 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273153 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273157 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 273157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 273160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273164 */     GIR_RootConstrainSelectedInstOperands,
     /* 273165 */     // GIR_Coverage, 5146,
     /* 273165 */     GIR_EraseRootFromParent_Done,
     /* 273166 */   // Label 5514: @273166
     /* 273166 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(273195), // Rule ID 5055 //
     /* 273171 */     // MIs[0] Operand 1
     /* 273171 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273184 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 273184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 273187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273193 */     GIR_RootConstrainSelectedInstOperands,
     /* 273194 */     // GIR_Coverage, 5055,
     /* 273194 */     GIR_EraseRootFromParent_Done,
     /* 273195 */   // Label 5515: @273195
     /* 273195 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(273224), // Rule ID 5062 //
     /* 273200 */     // MIs[0] Operand 1
     /* 273200 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273213 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 273213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 273216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273222 */     GIR_RootConstrainSelectedInstOperands,
     /* 273223 */     // GIR_Coverage, 5062,
     /* 273223 */     GIR_EraseRootFromParent_Done,
     /* 273224 */   // Label 5516: @273224
     /* 273224 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(273253), // Rule ID 5069 //
     /* 273229 */     // MIs[0] Operand 1
     /* 273229 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273242 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 273242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 273245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273251 */     GIR_RootConstrainSelectedInstOperands,
     /* 273252 */     // GIR_Coverage, 5069,
     /* 273252 */     GIR_EraseRootFromParent_Done,
     /* 273253 */   // Label 5517: @273253
     /* 273253 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(273282), // Rule ID 5076 //
     /* 273258 */     // MIs[0] Operand 1
     /* 273258 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 273263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273271 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 273271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 273274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273280 */     GIR_RootConstrainSelectedInstOperands,
     /* 273281 */     // GIR_Coverage, 5076,
     /* 273281 */     GIR_EraseRootFromParent_Done,
     /* 273282 */   // Label 5518: @273282
     /* 273282 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(273311), // Rule ID 5083 //
     /* 273287 */     // MIs[0] Operand 1
     /* 273287 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 273292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273300 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 273300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 273303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273309 */     GIR_RootConstrainSelectedInstOperands,
     /* 273310 */     // GIR_Coverage, 5083,
     /* 273310 */     GIR_EraseRootFromParent_Done,
     /* 273311 */   // Label 5519: @273311
     /* 273311 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(273340), // Rule ID 5090 //
     /* 273316 */     // MIs[0] Operand 1
     /* 273316 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273329 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 273329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 273332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273338 */     GIR_RootConstrainSelectedInstOperands,
     /* 273339 */     // GIR_Coverage, 5090,
     /* 273339 */     GIR_EraseRootFromParent_Done,
     /* 273340 */   // Label 5520: @273340
     /* 273340 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(273369), // Rule ID 5097 //
     /* 273345 */     // MIs[0] Operand 1
     /* 273345 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273358 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 273358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 273361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273367 */     GIR_RootConstrainSelectedInstOperands,
     /* 273368 */     // GIR_Coverage, 5097,
     /* 273368 */     GIR_EraseRootFromParent_Done,
     /* 273369 */   // Label 5521: @273369
     /* 273369 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(273398), // Rule ID 5104 //
     /* 273374 */     // MIs[0] Operand 1
     /* 273374 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 273379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273387 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 273387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 273390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273396 */     GIR_RootConstrainSelectedInstOperands,
     /* 273397 */     // GIR_Coverage, 5104,
     /* 273397 */     GIR_EraseRootFromParent_Done,
     /* 273398 */   // Label 5522: @273398
     /* 273398 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(273427), // Rule ID 5111 //
     /* 273403 */     // MIs[0] Operand 1
     /* 273403 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 273408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273416 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 273416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 273419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273425 */     GIR_RootConstrainSelectedInstOperands,
     /* 273426 */     // GIR_Coverage, 5111,
     /* 273426 */     GIR_EraseRootFromParent_Done,
     /* 273427 */   // Label 5523: @273427
     /* 273427 */   GIM_Reject,
     /* 273428 */ // Label 5504: @273428
     /* 273428 */ GIM_Reject,
     /* 273429 */ // Label 5440: @273429
     /* 273429 */ GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(274076),
     /* 273434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 273437 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 273440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273444 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(273481), // Rule ID 5148 //
     /* 273449 */     // MIs[0] Operand 1
     /* 273449 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273458 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273464 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273472 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 273472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 273475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273479 */     GIR_RootConstrainSelectedInstOperands,
     /* 273480 */     // GIR_Coverage, 5148,
     /* 273480 */     GIR_EraseRootFromParent_Done,
     /* 273481 */   // Label 5525: @273481
     /* 273481 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(273518), // Rule ID 5155 //
     /* 273486 */     // MIs[0] Operand 1
     /* 273486 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273495 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273501 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273509 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 273509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 273512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273516 */     GIR_RootConstrainSelectedInstOperands,
     /* 273517 */     // GIR_Coverage, 5155,
     /* 273517 */     GIR_EraseRootFromParent_Done,
     /* 273518 */   // Label 5526: @273518
     /* 273518 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(273555), // Rule ID 5162 //
     /* 273523 */     // MIs[0] Operand 1
     /* 273523 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273532 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273538 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273546 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 273546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 273549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273553 */     GIR_RootConstrainSelectedInstOperands,
     /* 273554 */     // GIR_Coverage, 5162,
     /* 273554 */     GIR_EraseRootFromParent_Done,
     /* 273555 */   // Label 5527: @273555
     /* 273555 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(273592), // Rule ID 5169 //
     /* 273560 */     // MIs[0] Operand 1
     /* 273560 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273569 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273575 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273583 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 273583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 273586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273590 */     GIR_RootConstrainSelectedInstOperands,
     /* 273591 */     // GIR_Coverage, 5169,
     /* 273591 */     GIR_EraseRootFromParent_Done,
     /* 273592 */   // Label 5528: @273592
     /* 273592 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(273629), // Rule ID 5176 //
     /* 273597 */     // MIs[0] Operand 1
     /* 273597 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273606 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273612 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273620 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 273620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 273623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273627 */     GIR_RootConstrainSelectedInstOperands,
     /* 273628 */     // GIR_Coverage, 5176,
     /* 273628 */     GIR_EraseRootFromParent_Done,
     /* 273629 */   // Label 5529: @273629
     /* 273629 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(273666), // Rule ID 5113 //
     /* 273634 */     // MIs[0] Operand 1
     /* 273634 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273647 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273653 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273657 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 273657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 273660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273664 */     GIR_RootConstrainSelectedInstOperands,
     /* 273665 */     // GIR_Coverage, 5113,
     /* 273665 */     GIR_EraseRootFromParent_Done,
     /* 273666 */   // Label 5530: @273666
     /* 273666 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(273703), // Rule ID 5120 //
     /* 273671 */     // MIs[0] Operand 1
     /* 273671 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273684 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273690 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273694 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 273694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 273697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273701 */     GIR_RootConstrainSelectedInstOperands,
     /* 273702 */     // GIR_Coverage, 5120,
     /* 273702 */     GIR_EraseRootFromParent_Done,
     /* 273703 */   // Label 5531: @273703
     /* 273703 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(273740), // Rule ID 5127 //
     /* 273708 */     // MIs[0] Operand 1
     /* 273708 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273721 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273727 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273731 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 273731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 273734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273738 */     GIR_RootConstrainSelectedInstOperands,
     /* 273739 */     // GIR_Coverage, 5127,
     /* 273739 */     GIR_EraseRootFromParent_Done,
     /* 273740 */   // Label 5532: @273740
     /* 273740 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(273777), // Rule ID 5134 //
     /* 273745 */     // MIs[0] Operand 1
     /* 273745 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273758 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273764 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273768 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 273768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 273771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273775 */     GIR_RootConstrainSelectedInstOperands,
     /* 273776 */     // GIR_Coverage, 5134,
     /* 273776 */     GIR_EraseRootFromParent_Done,
     /* 273777 */   // Label 5533: @273777
     /* 273777 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(273814), // Rule ID 5141 //
     /* 273782 */     // MIs[0] Operand 1
     /* 273782 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273795 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273801 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273805 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 273805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 273808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273812 */     GIR_RootConstrainSelectedInstOperands,
     /* 273813 */     // GIR_Coverage, 5141,
     /* 273813 */     GIR_EraseRootFromParent_Done,
     /* 273814 */   // Label 5534: @273814
     /* 273814 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(273843), // Rule ID 5050 //
     /* 273819 */     // MIs[0] Operand 1
     /* 273819 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273832 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 273832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 273835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273841 */     GIR_RootConstrainSelectedInstOperands,
     /* 273842 */     // GIR_Coverage, 5050,
     /* 273842 */     GIR_EraseRootFromParent_Done,
     /* 273843 */   // Label 5535: @273843
     /* 273843 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(273872), // Rule ID 5057 //
     /* 273848 */     // MIs[0] Operand 1
     /* 273848 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273861 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 273861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 273864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273870 */     GIR_RootConstrainSelectedInstOperands,
     /* 273871 */     // GIR_Coverage, 5057,
     /* 273871 */     GIR_EraseRootFromParent_Done,
     /* 273872 */   // Label 5536: @273872
     /* 273872 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(273901), // Rule ID 5064 //
     /* 273877 */     // MIs[0] Operand 1
     /* 273877 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273890 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 273890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 273893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273899 */     GIR_RootConstrainSelectedInstOperands,
     /* 273900 */     // GIR_Coverage, 5064,
     /* 273900 */     GIR_EraseRootFromParent_Done,
     /* 273901 */   // Label 5537: @273901
     /* 273901 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(273930), // Rule ID 5071 //
     /* 273906 */     // MIs[0] Operand 1
     /* 273906 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 273911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273919 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 273919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 273922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273928 */     GIR_RootConstrainSelectedInstOperands,
     /* 273929 */     // GIR_Coverage, 5071,
     /* 273929 */     GIR_EraseRootFromParent_Done,
     /* 273930 */   // Label 5538: @273930
     /* 273930 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(273959), // Rule ID 5078 //
     /* 273935 */     // MIs[0] Operand 1
     /* 273935 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 273940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273948 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 273948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 273951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273957 */     GIR_RootConstrainSelectedInstOperands,
     /* 273958 */     // GIR_Coverage, 5078,
     /* 273958 */     GIR_EraseRootFromParent_Done,
     /* 273959 */   // Label 5539: @273959
     /* 273959 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(273988), // Rule ID 5085 //
     /* 273964 */     // MIs[0] Operand 1
     /* 273964 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273977 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 273977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 273980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273986 */     GIR_RootConstrainSelectedInstOperands,
     /* 273987 */     // GIR_Coverage, 5085,
     /* 273987 */     GIR_EraseRootFromParent_Done,
     /* 273988 */   // Label 5540: @273988
     /* 273988 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(274017), // Rule ID 5092 //
     /* 273993 */     // MIs[0] Operand 1
     /* 273993 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274006 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 274006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 274009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274015 */     GIR_RootConstrainSelectedInstOperands,
     /* 274016 */     // GIR_Coverage, 5092,
     /* 274016 */     GIR_EraseRootFromParent_Done,
     /* 274017 */   // Label 5541: @274017
     /* 274017 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(274046), // Rule ID 5099 //
     /* 274022 */     // MIs[0] Operand 1
     /* 274022 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 274027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274035 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 274035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 274038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274044 */     GIR_RootConstrainSelectedInstOperands,
     /* 274045 */     // GIR_Coverage, 5099,
     /* 274045 */     GIR_EraseRootFromParent_Done,
     /* 274046 */   // Label 5542: @274046
     /* 274046 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(274075), // Rule ID 5106 //
     /* 274051 */     // MIs[0] Operand 1
     /* 274051 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 274056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274064 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 274064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 274067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274073 */     GIR_RootConstrainSelectedInstOperands,
     /* 274074 */     // GIR_Coverage, 5106,
     /* 274074 */     GIR_EraseRootFromParent_Done,
     /* 274075 */   // Label 5543: @274075
     /* 274075 */   GIM_Reject,
     /* 274076 */ // Label 5524: @274076
     /* 274076 */ GIM_Reject,
     /* 274077 */ // Label 5441: @274077
     /* 274077 */ GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(274724),
     /* 274082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274085 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 274088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274092 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(274129), // Rule ID 5151 //
     /* 274097 */     // MIs[0] Operand 1
     /* 274097 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274106 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274112 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274120 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 274120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 274123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274127 */     GIR_RootConstrainSelectedInstOperands,
     /* 274128 */     // GIR_Coverage, 5151,
     /* 274128 */     GIR_EraseRootFromParent_Done,
     /* 274129 */   // Label 5545: @274129
     /* 274129 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(274166), // Rule ID 5158 //
     /* 274134 */     // MIs[0] Operand 1
     /* 274134 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274143 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274149 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274157 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 274157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 274160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274164 */     GIR_RootConstrainSelectedInstOperands,
     /* 274165 */     // GIR_Coverage, 5158,
     /* 274165 */     GIR_EraseRootFromParent_Done,
     /* 274166 */   // Label 5546: @274166
     /* 274166 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(274203), // Rule ID 5165 //
     /* 274171 */     // MIs[0] Operand 1
     /* 274171 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274180 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274186 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274194 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 274194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 274197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274201 */     GIR_RootConstrainSelectedInstOperands,
     /* 274202 */     // GIR_Coverage, 5165,
     /* 274202 */     GIR_EraseRootFromParent_Done,
     /* 274203 */   // Label 5547: @274203
     /* 274203 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(274240), // Rule ID 5172 //
     /* 274208 */     // MIs[0] Operand 1
     /* 274208 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274217 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274223 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274231 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 274231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 274234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274238 */     GIR_RootConstrainSelectedInstOperands,
     /* 274239 */     // GIR_Coverage, 5172,
     /* 274239 */     GIR_EraseRootFromParent_Done,
     /* 274240 */   // Label 5548: @274240
     /* 274240 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(274277), // Rule ID 5179 //
     /* 274245 */     // MIs[0] Operand 1
     /* 274245 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274254 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274260 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274268 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 274268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 274271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274275 */     GIR_RootConstrainSelectedInstOperands,
     /* 274276 */     // GIR_Coverage, 5179,
     /* 274276 */     GIR_EraseRootFromParent_Done,
     /* 274277 */   // Label 5549: @274277
     /* 274277 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(274314), // Rule ID 5116 //
     /* 274282 */     // MIs[0] Operand 1
     /* 274282 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274295 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274301 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274305 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 274305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 274308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274312 */     GIR_RootConstrainSelectedInstOperands,
     /* 274313 */     // GIR_Coverage, 5116,
     /* 274313 */     GIR_EraseRootFromParent_Done,
     /* 274314 */   // Label 5550: @274314
     /* 274314 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(274351), // Rule ID 5123 //
     /* 274319 */     // MIs[0] Operand 1
     /* 274319 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274332 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274338 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274342 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 274342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 274345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274349 */     GIR_RootConstrainSelectedInstOperands,
     /* 274350 */     // GIR_Coverage, 5123,
     /* 274350 */     GIR_EraseRootFromParent_Done,
     /* 274351 */   // Label 5551: @274351
     /* 274351 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(274388), // Rule ID 5130 //
     /* 274356 */     // MIs[0] Operand 1
     /* 274356 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274369 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274375 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274379 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 274379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 274382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274386 */     GIR_RootConstrainSelectedInstOperands,
     /* 274387 */     // GIR_Coverage, 5130,
     /* 274387 */     GIR_EraseRootFromParent_Done,
     /* 274388 */   // Label 5552: @274388
     /* 274388 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(274425), // Rule ID 5137 //
     /* 274393 */     // MIs[0] Operand 1
     /* 274393 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274406 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274412 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274416 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 274416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 274419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274423 */     GIR_RootConstrainSelectedInstOperands,
     /* 274424 */     // GIR_Coverage, 5137,
     /* 274424 */     GIR_EraseRootFromParent_Done,
     /* 274425 */   // Label 5553: @274425
     /* 274425 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(274462), // Rule ID 5144 //
     /* 274430 */     // MIs[0] Operand 1
     /* 274430 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274443 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274449 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274453 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 274453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 274456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274460 */     GIR_RootConstrainSelectedInstOperands,
     /* 274461 */     // GIR_Coverage, 5144,
     /* 274461 */     GIR_EraseRootFromParent_Done,
     /* 274462 */   // Label 5554: @274462
     /* 274462 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(274491), // Rule ID 5053 //
     /* 274467 */     // MIs[0] Operand 1
     /* 274467 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274480 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 274480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 274483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274489 */     GIR_RootConstrainSelectedInstOperands,
     /* 274490 */     // GIR_Coverage, 5053,
     /* 274490 */     GIR_EraseRootFromParent_Done,
     /* 274491 */   // Label 5555: @274491
     /* 274491 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(274520), // Rule ID 5060 //
     /* 274496 */     // MIs[0] Operand 1
     /* 274496 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274509 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 274509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 274512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274518 */     GIR_RootConstrainSelectedInstOperands,
     /* 274519 */     // GIR_Coverage, 5060,
     /* 274519 */     GIR_EraseRootFromParent_Done,
     /* 274520 */   // Label 5556: @274520
     /* 274520 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(274549), // Rule ID 5067 //
     /* 274525 */     // MIs[0] Operand 1
     /* 274525 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274538 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 274538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 274541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274547 */     GIR_RootConstrainSelectedInstOperands,
     /* 274548 */     // GIR_Coverage, 5067,
     /* 274548 */     GIR_EraseRootFromParent_Done,
     /* 274549 */   // Label 5557: @274549
     /* 274549 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(274578), // Rule ID 5074 //
     /* 274554 */     // MIs[0] Operand 1
     /* 274554 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 274559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274567 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 274567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 274570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274576 */     GIR_RootConstrainSelectedInstOperands,
     /* 274577 */     // GIR_Coverage, 5074,
     /* 274577 */     GIR_EraseRootFromParent_Done,
     /* 274578 */   // Label 5558: @274578
     /* 274578 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(274607), // Rule ID 5081 //
     /* 274583 */     // MIs[0] Operand 1
     /* 274583 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 274588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274596 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 274596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 274599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274605 */     GIR_RootConstrainSelectedInstOperands,
     /* 274606 */     // GIR_Coverage, 5081,
     /* 274606 */     GIR_EraseRootFromParent_Done,
     /* 274607 */   // Label 5559: @274607
     /* 274607 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(274636), // Rule ID 5088 //
     /* 274612 */     // MIs[0] Operand 1
     /* 274612 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274625 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 274625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 274628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274634 */     GIR_RootConstrainSelectedInstOperands,
     /* 274635 */     // GIR_Coverage, 5088,
     /* 274635 */     GIR_EraseRootFromParent_Done,
     /* 274636 */   // Label 5560: @274636
     /* 274636 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(274665), // Rule ID 5095 //
     /* 274641 */     // MIs[0] Operand 1
     /* 274641 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274654 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 274654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 274657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274663 */     GIR_RootConstrainSelectedInstOperands,
     /* 274664 */     // GIR_Coverage, 5095,
     /* 274664 */     GIR_EraseRootFromParent_Done,
     /* 274665 */   // Label 5561: @274665
     /* 274665 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(274694), // Rule ID 5102 //
     /* 274670 */     // MIs[0] Operand 1
     /* 274670 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 274675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274683 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 274683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 274686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274692 */     GIR_RootConstrainSelectedInstOperands,
     /* 274693 */     // GIR_Coverage, 5102,
     /* 274693 */     GIR_EraseRootFromParent_Done,
     /* 274694 */   // Label 5562: @274694
     /* 274694 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(274723), // Rule ID 5109 //
     /* 274699 */     // MIs[0] Operand 1
     /* 274699 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 274704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274712 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 274712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 274715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274721 */     GIR_RootConstrainSelectedInstOperands,
     /* 274722 */     // GIR_Coverage, 5109,
     /* 274722 */     GIR_EraseRootFromParent_Done,
     /* 274723 */   // Label 5563: @274723
     /* 274723 */   GIM_Reject,
     /* 274724 */ // Label 5544: @274724
     /* 274724 */ GIM_Reject,
     /* 274725 */ // Label 5442: @274725
     /* 274725 */ GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(275372),
     /* 274730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 274733 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274740 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(274777), // Rule ID 5149 //
     /* 274745 */     // MIs[0] Operand 1
     /* 274745 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274754 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274760 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274768 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 274768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 274771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274775 */     GIR_RootConstrainSelectedInstOperands,
     /* 274776 */     // GIR_Coverage, 5149,
     /* 274776 */     GIR_EraseRootFromParent_Done,
     /* 274777 */   // Label 5565: @274777
     /* 274777 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(274814), // Rule ID 5156 //
     /* 274782 */     // MIs[0] Operand 1
     /* 274782 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274791 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274797 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274805 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 274805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 274808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274812 */     GIR_RootConstrainSelectedInstOperands,
     /* 274813 */     // GIR_Coverage, 5156,
     /* 274813 */     GIR_EraseRootFromParent_Done,
     /* 274814 */   // Label 5566: @274814
     /* 274814 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(274851), // Rule ID 5163 //
     /* 274819 */     // MIs[0] Operand 1
     /* 274819 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274828 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274834 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274842 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 274842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 274845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274849 */     GIR_RootConstrainSelectedInstOperands,
     /* 274850 */     // GIR_Coverage, 5163,
     /* 274850 */     GIR_EraseRootFromParent_Done,
     /* 274851 */   // Label 5567: @274851
     /* 274851 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(274888), // Rule ID 5170 //
     /* 274856 */     // MIs[0] Operand 1
     /* 274856 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274865 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274871 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274879 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 274879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 274882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274886 */     GIR_RootConstrainSelectedInstOperands,
     /* 274887 */     // GIR_Coverage, 5170,
     /* 274887 */     GIR_EraseRootFromParent_Done,
     /* 274888 */   // Label 5568: @274888
     /* 274888 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(274925), // Rule ID 5177 //
     /* 274893 */     // MIs[0] Operand 1
     /* 274893 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274902 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274908 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274916 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 274916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 274919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274923 */     GIR_RootConstrainSelectedInstOperands,
     /* 274924 */     // GIR_Coverage, 5177,
     /* 274924 */     GIR_EraseRootFromParent_Done,
     /* 274925 */   // Label 5569: @274925
     /* 274925 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(274962), // Rule ID 5114 //
     /* 274930 */     // MIs[0] Operand 1
     /* 274930 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274943 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274949 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274953 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 274953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 274956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274960 */     GIR_RootConstrainSelectedInstOperands,
     /* 274961 */     // GIR_Coverage, 5114,
     /* 274961 */     GIR_EraseRootFromParent_Done,
     /* 274962 */   // Label 5570: @274962
     /* 274962 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(274999), // Rule ID 5121 //
     /* 274967 */     // MIs[0] Operand 1
     /* 274967 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274980 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274986 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274990 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 274990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 274993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274997 */     GIR_RootConstrainSelectedInstOperands,
     /* 274998 */     // GIR_Coverage, 5121,
     /* 274998 */     GIR_EraseRootFromParent_Done,
     /* 274999 */   // Label 5571: @274999
     /* 274999 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(275036), // Rule ID 5128 //
     /* 275004 */     // MIs[0] Operand 1
     /* 275004 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275017 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275023 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275027 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 275027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 275030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275034 */     GIR_RootConstrainSelectedInstOperands,
     /* 275035 */     // GIR_Coverage, 5128,
     /* 275035 */     GIR_EraseRootFromParent_Done,
     /* 275036 */   // Label 5572: @275036
     /* 275036 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(275073), // Rule ID 5135 //
     /* 275041 */     // MIs[0] Operand 1
     /* 275041 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275054 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275060 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275064 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 275064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 275067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275071 */     GIR_RootConstrainSelectedInstOperands,
     /* 275072 */     // GIR_Coverage, 5135,
     /* 275072 */     GIR_EraseRootFromParent_Done,
     /* 275073 */   // Label 5573: @275073
     /* 275073 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(275110), // Rule ID 5142 //
     /* 275078 */     // MIs[0] Operand 1
     /* 275078 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275091 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275097 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275101 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 275101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 275104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275108 */     GIR_RootConstrainSelectedInstOperands,
     /* 275109 */     // GIR_Coverage, 5142,
     /* 275109 */     GIR_EraseRootFromParent_Done,
     /* 275110 */   // Label 5574: @275110
     /* 275110 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(275139), // Rule ID 5051 //
     /* 275115 */     // MIs[0] Operand 1
     /* 275115 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275128 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 275131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275137 */     GIR_RootConstrainSelectedInstOperands,
     /* 275138 */     // GIR_Coverage, 5051,
     /* 275138 */     GIR_EraseRootFromParent_Done,
     /* 275139 */   // Label 5575: @275139
     /* 275139 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(275168), // Rule ID 5058 //
     /* 275144 */     // MIs[0] Operand 1
     /* 275144 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275157 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 275160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275166 */     GIR_RootConstrainSelectedInstOperands,
     /* 275167 */     // GIR_Coverage, 5058,
     /* 275167 */     GIR_EraseRootFromParent_Done,
     /* 275168 */   // Label 5576: @275168
     /* 275168 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(275197), // Rule ID 5065 //
     /* 275173 */     // MIs[0] Operand 1
     /* 275173 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275186 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 275189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275195 */     GIR_RootConstrainSelectedInstOperands,
     /* 275196 */     // GIR_Coverage, 5065,
     /* 275196 */     GIR_EraseRootFromParent_Done,
     /* 275197 */   // Label 5577: @275197
     /* 275197 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(275226), // Rule ID 5072 //
     /* 275202 */     // MIs[0] Operand 1
     /* 275202 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 275207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275215 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 275218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275224 */     GIR_RootConstrainSelectedInstOperands,
     /* 275225 */     // GIR_Coverage, 5072,
     /* 275225 */     GIR_EraseRootFromParent_Done,
     /* 275226 */   // Label 5578: @275226
     /* 275226 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(275255), // Rule ID 5079 //
     /* 275231 */     // MIs[0] Operand 1
     /* 275231 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 275236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275244 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 275247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275253 */     GIR_RootConstrainSelectedInstOperands,
     /* 275254 */     // GIR_Coverage, 5079,
     /* 275254 */     GIR_EraseRootFromParent_Done,
     /* 275255 */   // Label 5579: @275255
     /* 275255 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(275284), // Rule ID 5086 //
     /* 275260 */     // MIs[0] Operand 1
     /* 275260 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275273 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 275273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 275276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275282 */     GIR_RootConstrainSelectedInstOperands,
     /* 275283 */     // GIR_Coverage, 5086,
     /* 275283 */     GIR_EraseRootFromParent_Done,
     /* 275284 */   // Label 5580: @275284
     /* 275284 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(275313), // Rule ID 5093 //
     /* 275289 */     // MIs[0] Operand 1
     /* 275289 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275302 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 275302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 275305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275311 */     GIR_RootConstrainSelectedInstOperands,
     /* 275312 */     // GIR_Coverage, 5093,
     /* 275312 */     GIR_EraseRootFromParent_Done,
     /* 275313 */   // Label 5581: @275313
     /* 275313 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(275342), // Rule ID 5100 //
     /* 275318 */     // MIs[0] Operand 1
     /* 275318 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 275323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275331 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 275331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 275334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275340 */     GIR_RootConstrainSelectedInstOperands,
     /* 275341 */     // GIR_Coverage, 5100,
     /* 275341 */     GIR_EraseRootFromParent_Done,
     /* 275342 */   // Label 5582: @275342
     /* 275342 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(275371), // Rule ID 5107 //
     /* 275347 */     // MIs[0] Operand 1
     /* 275347 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 275352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275360 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 275360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 275363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275369 */     GIR_RootConstrainSelectedInstOperands,
     /* 275370 */     // GIR_Coverage, 5107,
     /* 275370 */     GIR_EraseRootFromParent_Done,
     /* 275371 */   // Label 5583: @275371
     /* 275371 */   GIM_Reject,
     /* 275372 */ // Label 5564: @275372
     /* 275372 */ GIM_Reject,
     /* 275373 */ // Label 5443: @275373
     /* 275373 */ GIM_Reject,
     /* 275374 */ // Label 50: @275374
     /* 275374 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5596*/ GIMT_Encode4(276418),
     /* 275385 */ /*GILLT_nxv1s1*//*Label 5584*/ GIMT_Encode4(275433),
     /* 275389 */ /*GILLT_nxv2s1*//*Label 5585*/ GIMT_Encode4(275462),
     /* 275393 */ /*GILLT_nxv2s16*//*Label 5586*/ GIMT_Encode4(275491),
     /* 275397 */ /*GILLT_nxv2s32*//*Label 5587*/ GIMT_Encode4(275576),
     /* 275401 */ /*GILLT_nxv2s64*//*Label 5588*/ GIMT_Encode4(275661),
     /* 275405 */ /*GILLT_nxv4s1*//*Label 5589*/ GIMT_Encode4(275827),
     /* 275409 */ /*GILLT_nxv4s16*//*Label 5590*/ GIMT_Encode4(275856),
     /* 275413 */ /*GILLT_nxv4s32*//*Label 5591*/ GIMT_Encode4(275941),
     /* 275417 */ /*GILLT_nxv8s1*//*Label 5592*/ GIMT_Encode4(276107),
     /* 275421 */ /*GILLT_nxv8s16*//*Label 5593*/ GIMT_Encode4(276136),
     /* 275425 */ /*GILLT_nxv16s1*//*Label 5594*/ GIMT_Encode4(276302),
     /* 275429 */ /*GILLT_nxv16s8*//*Label 5595*/ GIMT_Encode4(276331),
     /* 275433 */ // Label 5584: @275433
     /* 275433 */ GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(275461), // Rule ID 8380 //
     /* 275438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 275444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 275447 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 275450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 275454 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 275454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 275459 */   GIR_RootConstrainSelectedInstOperands,
     /* 275460 */   // GIR_Coverage, 8380,
     /* 275460 */   GIR_Done,
     /* 275461 */ // Label 5597: @275461
     /* 275461 */ GIM_Reject,
     /* 275462 */ // Label 5585: @275462
     /* 275462 */ GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(275490), // Rule ID 8379 //
     /* 275467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 275476 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 275479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 275483 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 275483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 275488 */   GIR_RootConstrainSelectedInstOperands,
     /* 275489 */   // GIR_Coverage, 8379,
     /* 275489 */   GIR_Done,
     /* 275490 */ // Label 5598: @275490
     /* 275490 */ GIM_Reject,
     /* 275491 */ // Label 5586: @275491
     /* 275491 */ GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(275575),
     /* 275496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 275502 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 275505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275509 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(275559), // Rule ID 3152 //
     /* 275514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 275525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 275529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 275533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 275537 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 275541 */     // MIs[2] Operand 1
     /* 275541 */     // No operand predicates
     /* 275541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275543 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 275543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 275546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 275548 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 275550 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 275552 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 275557 */     GIR_RootConstrainSelectedInstOperands,
     /* 275558 */     // GIR_Coverage, 3152,
     /* 275558 */     GIR_EraseRootFromParent_Done,
     /* 275559 */   // Label 5600: @275559
     /* 275559 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(275574), // Rule ID 2732 //
     /* 275564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275567 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 275567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 275572 */     GIR_RootConstrainSelectedInstOperands,
     /* 275573 */     // GIR_Coverage, 2732,
     /* 275573 */     GIR_Done,
     /* 275574 */   // Label 5601: @275574
     /* 275574 */   GIM_Reject,
     /* 275575 */ // Label 5599: @275575
     /* 275575 */ GIM_Reject,
     /* 275576 */ // Label 5587: @275576
     /* 275576 */ GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(275660),
     /* 275581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 275587 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 275590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275594 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(275644), // Rule ID 3154 //
     /* 275599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 275610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 275614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 275618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 275622 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 275626 */     // MIs[2] Operand 1
     /* 275626 */     // No operand predicates
     /* 275626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275628 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 275628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 275631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 275633 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 275635 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 275637 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 275642 */     GIR_RootConstrainSelectedInstOperands,
     /* 275643 */     // GIR_Coverage, 3154,
     /* 275643 */     GIR_EraseRootFromParent_Done,
     /* 275644 */   // Label 5603: @275644
     /* 275644 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(275659), // Rule ID 2733 //
     /* 275649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275652 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 275652 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 275657 */     GIR_RootConstrainSelectedInstOperands,
     /* 275658 */     // GIR_Coverage, 2733,
     /* 275658 */     GIR_Done,
     /* 275659 */   // Label 5604: @275659
     /* 275659 */   GIM_Reject,
     /* 275660 */ // Label 5602: @275660
     /* 275660 */ GIM_Reject,
     /* 275661 */ // Label 5588: @275661
     /* 275661 */ GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(275826),
     /* 275666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 275672 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(275729), // Rule ID 3155 //
     /* 275677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 275683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 275695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 275699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 275703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 275707 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 275711 */     // MIs[2] Operand 1
     /* 275711 */     // No operand predicates
     /* 275711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275713 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 275713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 275716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 275718 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 275720 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 275722 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 275727 */     GIR_RootConstrainSelectedInstOperands,
     /* 275728 */     // GIR_Coverage, 3155,
     /* 275728 */     GIR_EraseRootFromParent_Done,
     /* 275729 */   // Label 5606: @275729
     /* 275729 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(275781), // Rule ID 7430 //
     /* 275734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 275749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 275753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 275757 */     // MIs[0] Op2
     /* 275757 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 275762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275764 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 275764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 275767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 275769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 275771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 275775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 275779 */     GIR_RootConstrainSelectedInstOperands,
     /* 275780 */     // GIR_Coverage, 7430,
     /* 275780 */     GIR_EraseRootFromParent_Done,
     /* 275781 */   // Label 5607: @275781
     /* 275781 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(275803), // Rule ID 2728 //
     /* 275786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 275792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275796 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 275796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 275801 */     GIR_RootConstrainSelectedInstOperands,
     /* 275802 */     // GIR_Coverage, 2728,
     /* 275802 */     GIR_Done,
     /* 275803 */   // Label 5608: @275803
     /* 275803 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(275825), // Rule ID 2734 //
     /* 275808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 275814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275818 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 275818 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 275823 */     GIR_RootConstrainSelectedInstOperands,
     /* 275824 */     // GIR_Coverage, 2734,
     /* 275824 */     GIR_Done,
     /* 275825 */   // Label 5609: @275825
     /* 275825 */   GIM_Reject,
     /* 275826 */ // Label 5605: @275826
     /* 275826 */ GIM_Reject,
     /* 275827 */ // Label 5589: @275827
     /* 275827 */ GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(275855), // Rule ID 8378 //
     /* 275832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 275838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 275841 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 275844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 275848 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 275848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 275853 */   GIR_RootConstrainSelectedInstOperands,
     /* 275854 */   // GIR_Coverage, 8378,
     /* 275854 */   GIR_Done,
     /* 275855 */ // Label 5610: @275855
     /* 275855 */ GIM_Reject,
     /* 275856 */ // Label 5590: @275856
     /* 275856 */ GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(275940),
     /* 275861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 275864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 275867 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 275870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275874 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(275924), // Rule ID 3151 //
     /* 275879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 275890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 275894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 275898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 275902 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 275906 */     // MIs[2] Operand 1
     /* 275906 */     // No operand predicates
     /* 275906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275908 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 275908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 275911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 275913 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 275915 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 275917 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 275922 */     GIR_RootConstrainSelectedInstOperands,
     /* 275923 */     // GIR_Coverage, 3151,
     /* 275923 */     GIR_EraseRootFromParent_Done,
     /* 275924 */   // Label 5612: @275924
     /* 275924 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(275939), // Rule ID 2730 //
     /* 275929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275932 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 275932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 275937 */     GIR_RootConstrainSelectedInstOperands,
     /* 275938 */     // GIR_Coverage, 2730,
     /* 275938 */     GIR_Done,
     /* 275939 */   // Label 5613: @275939
     /* 275939 */   GIM_Reject,
     /* 275940 */ // Label 5611: @275940
     /* 275940 */ GIM_Reject,
     /* 275941 */ // Label 5591: @275941
     /* 275941 */ GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(276106),
     /* 275946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 275949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 275952 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(276009), // Rule ID 3153 //
     /* 275957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 275960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 275963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 275975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 275979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 275983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 275987 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 275991 */     // MIs[2] Operand 1
     /* 275991 */     // No operand predicates
     /* 275991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 275993 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 275993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 275996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 275998 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 276000 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 276002 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 276007 */     GIR_RootConstrainSelectedInstOperands,
     /* 276008 */     // GIR_Coverage, 3153,
     /* 276008 */     GIR_EraseRootFromParent_Done,
     /* 276009 */   // Label 5615: @276009
     /* 276009 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(276061), // Rule ID 7428 //
     /* 276014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 276017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 276029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 276033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276037 */     // MIs[0] Op2
     /* 276037 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 276042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276044 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 276044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 276047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 276049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 276051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 276055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 276059 */     GIR_RootConstrainSelectedInstOperands,
     /* 276060 */     // GIR_Coverage, 7428,
     /* 276060 */     GIR_EraseRootFromParent_Done,
     /* 276061 */   // Label 5616: @276061
     /* 276061 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(276083), // Rule ID 2727 //
     /* 276066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 276069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 276072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276076 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 276076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 276081 */     GIR_RootConstrainSelectedInstOperands,
     /* 276082 */     // GIR_Coverage, 2727,
     /* 276082 */     GIR_Done,
     /* 276083 */   // Label 5617: @276083
     /* 276083 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(276105), // Rule ID 2731 //
     /* 276088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 276091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 276094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276098 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 276098 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 276103 */     GIR_RootConstrainSelectedInstOperands,
     /* 276104 */     // GIR_Coverage, 2731,
     /* 276104 */     GIR_Done,
     /* 276105 */   // Label 5618: @276105
     /* 276105 */   GIM_Reject,
     /* 276106 */ // Label 5614: @276106
     /* 276106 */ GIM_Reject,
     /* 276107 */ // Label 5592: @276107
     /* 276107 */ GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(276135), // Rule ID 8377 //
     /* 276112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 276115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 276118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276121 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 276128 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 276128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 276133 */   GIR_RootConstrainSelectedInstOperands,
     /* 276134 */   // GIR_Coverage, 8377,
     /* 276134 */   GIR_Done,
     /* 276135 */ // Label 5619: @276135
     /* 276135 */ GIM_Reject,
     /* 276136 */ // Label 5593: @276136
     /* 276136 */ GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(276301),
     /* 276141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 276144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276147 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(276204), // Rule ID 3150 //
     /* 276152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 276155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 276158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 276170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 276174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 276178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 276182 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 276186 */     // MIs[2] Operand 1
     /* 276186 */     // No operand predicates
     /* 276186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 276188 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 276188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 276191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 276193 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 276195 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 276197 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 276202 */     GIR_RootConstrainSelectedInstOperands,
     /* 276203 */     // GIR_Coverage, 3150,
     /* 276203 */     GIR_EraseRootFromParent_Done,
     /* 276204 */   // Label 5621: @276204
     /* 276204 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(276256), // Rule ID 7426 //
     /* 276209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 276212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 276224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 276228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276232 */     // MIs[0] Op2
     /* 276232 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 276237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276239 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 276239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 276242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 276244 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 276246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 276250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 276254 */     GIR_RootConstrainSelectedInstOperands,
     /* 276255 */     // GIR_Coverage, 7426,
     /* 276255 */     GIR_EraseRootFromParent_Done,
     /* 276256 */   // Label 5622: @276256
     /* 276256 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(276278), // Rule ID 2726 //
     /* 276261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 276264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 276267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276271 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 276271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 276276 */     GIR_RootConstrainSelectedInstOperands,
     /* 276277 */     // GIR_Coverage, 2726,
     /* 276277 */     GIR_Done,
     /* 276278 */   // Label 5623: @276278
     /* 276278 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(276300), // Rule ID 2729 //
     /* 276283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 276286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 276289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276293 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 276293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 276298 */     GIR_RootConstrainSelectedInstOperands,
     /* 276299 */     // GIR_Coverage, 2729,
     /* 276299 */     GIR_Done,
     /* 276300 */   // Label 5624: @276300
     /* 276300 */   GIM_Reject,
     /* 276301 */ // Label 5620: @276301
     /* 276301 */ GIM_Reject,
     /* 276302 */ // Label 5594: @276302
     /* 276302 */ GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(276330), // Rule ID 8376 //
     /* 276307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 276310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 276313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276316 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 276323 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 276323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 276328 */   GIR_RootConstrainSelectedInstOperands,
     /* 276329 */   // GIR_Coverage, 8376,
     /* 276329 */   GIR_Done,
     /* 276330 */ // Label 5625: @276330
     /* 276330 */ GIM_Reject,
     /* 276331 */ // Label 5595: @276331
     /* 276331 */ GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(276417),
     /* 276336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 276339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 276342 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(276394), // Rule ID 7424 //
     /* 276347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 276350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 276362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 276366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 276370 */     // MIs[0] Op2
     /* 276370 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 276375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276377 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 276380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 276382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 276384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 276388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 276392 */     GIR_RootConstrainSelectedInstOperands,
     /* 276393 */     // GIR_Coverage, 7424,
     /* 276393 */     GIR_EraseRootFromParent_Done,
     /* 276394 */   // Label 5627: @276394
     /* 276394 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(276416), // Rule ID 2725 //
     /* 276399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 276402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276409 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 276414 */     GIR_RootConstrainSelectedInstOperands,
     /* 276415 */     // GIR_Coverage, 2725,
     /* 276415 */     GIR_Done,
     /* 276416 */   // Label 5628: @276416
     /* 276416 */   GIM_Reject,
     /* 276417 */ // Label 5626: @276417
     /* 276417 */ GIM_Reject,
     /* 276418 */ // Label 5596: @276418
     /* 276418 */ GIM_Reject,
     /* 276419 */ // Label 51: @276419
     /* 276419 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5633*/ GIMT_Encode4(276902),
     /* 276430 */ /*GILLT_s64*//*Label 5629*/ GIMT_Encode4(276466), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 276450 */ /*GILLT_v4s32*//*Label 5630*/ GIMT_Encode4(276497), GIMT_Encode4(0),
     /* 276458 */ /*GILLT_v8s16*//*Label 5631*/ GIMT_Encode4(276632),
     /* 276462 */ /*GILLT_v16s8*//*Label 5632*/ GIMT_Encode4(276767),
     /* 276466 */ // Label 5629: @276466
     /* 276466 */ GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(276496), // Rule ID 128 //
     /* 276471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 276474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 276477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 276481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 276485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 276489 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 276489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 276494 */   GIR_RootConstrainSelectedInstOperands,
     /* 276495 */   // GIR_Coverage, 128,
     /* 276495 */   GIR_Done,
     /* 276496 */ // Label 5634: @276496
     /* 276496 */ GIM_Reject,
     /* 276497 */ // Label 5630: @276497
     /* 276497 */ GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(276631), // Rule ID 6482 //
     /* 276502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276520 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 276520 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 276523 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 276527 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276532 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 276536 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 276540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 276542 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 276545 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276549 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276554 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 276560 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276565 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276570 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 276573 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276577 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276582 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 276588 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276593 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 276601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 276605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276610 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 276613 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 276616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 276618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 276621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 276629 */   GIR_RootConstrainSelectedInstOperands,
     /* 276630 */   // GIR_Coverage, 6482,
     /* 276630 */   GIR_EraseRootFromParent_Done,
     /* 276631 */ // Label 5635: @276631
     /* 276631 */ GIM_Reject,
     /* 276632 */ // Label 5631: @276632
     /* 276632 */ GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(276766), // Rule ID 6481 //
     /* 276637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 276640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 276643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276655 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 276655 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 276658 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 276662 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276667 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 276671 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 276675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 276677 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 276680 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276684 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276689 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 276695 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276700 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276705 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 276708 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276712 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276717 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 276723 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276728 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 276736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 276740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276745 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 276748 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 276751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 276753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 276756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276758 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 276764 */   GIR_RootConstrainSelectedInstOperands,
     /* 276765 */   // GIR_Coverage, 6481,
     /* 276765 */   GIR_EraseRootFromParent_Done,
     /* 276766 */ // Label 5636: @276766
     /* 276766 */ GIM_Reject,
     /* 276767 */ // Label 5632: @276767
     /* 276767 */ GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(276901), // Rule ID 6480 //
     /* 276772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 276775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 276778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276786 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276790 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 276790 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 276793 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 276797 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276802 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 276806 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 276810 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 276812 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 276815 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276819 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276824 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 276830 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276835 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276840 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 276843 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 276847 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276852 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 276858 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276863 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276868 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 276871 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 276875 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 276880 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 276883 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 276886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 276888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 276891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276893 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 276896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 276899 */   GIR_RootConstrainSelectedInstOperands,
     /* 276900 */   // GIR_Coverage, 6480,
     /* 276900 */   GIR_EraseRootFromParent_Done,
     /* 276901 */ // Label 5637: @276901
     /* 276901 */ GIM_Reject,
     /* 276902 */ // Label 5633: @276902
     /* 276902 */ GIM_Reject,
     /* 276903 */ // Label 52: @276903
     /* 276903 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5642*/ GIMT_Encode4(277386),
     /* 276914 */ /*GILLT_s64*//*Label 5638*/ GIMT_Encode4(276950), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 276934 */ /*GILLT_v4s32*//*Label 5639*/ GIMT_Encode4(276981), GIMT_Encode4(0),
     /* 276942 */ /*GILLT_v8s16*//*Label 5640*/ GIMT_Encode4(277116),
     /* 276946 */ /*GILLT_v16s8*//*Label 5641*/ GIMT_Encode4(277251),
     /* 276950 */ // Label 5638: @276950
     /* 276950 */ GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(276980), // Rule ID 127 //
     /* 276955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 276958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 276961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 276965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 276969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 276973 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 276973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 276978 */   GIR_RootConstrainSelectedInstOperands,
     /* 276979 */   // GIR_Coverage, 127,
     /* 276979 */   GIR_Done,
     /* 276980 */ // Label 5643: @276980
     /* 276980 */ GIM_Reject,
     /* 276981 */ // Label 5639: @276981
     /* 276981 */ GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(277115), // Rule ID 6479 //
     /* 276986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 276989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277000 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277004 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 277004 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 277007 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 277011 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277016 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 277020 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 277024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 277026 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 277029 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277033 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277038 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 277044 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277049 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277054 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 277057 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277061 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277066 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 277072 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277077 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 277085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 277089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277094 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277097 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 277100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 277105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277107 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277110 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 277113 */   GIR_RootConstrainSelectedInstOperands,
     /* 277114 */   // GIR_Coverage, 6479,
     /* 277114 */   GIR_EraseRootFromParent_Done,
     /* 277115 */ // Label 5644: @277115
     /* 277115 */ GIM_Reject,
     /* 277116 */ // Label 5640: @277116
     /* 277116 */ GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(277250), // Rule ID 6478 //
     /* 277121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 277127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277139 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 277139 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 277142 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 277146 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277151 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 277155 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 277159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 277161 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 277164 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277168 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277173 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 277179 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277184 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277189 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 277192 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277196 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277201 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 277207 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277212 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 277220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 277224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277229 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277232 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 277235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 277240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277242 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277245 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 277248 */   GIR_RootConstrainSelectedInstOperands,
     /* 277249 */   // GIR_Coverage, 6478,
     /* 277249 */   GIR_EraseRootFromParent_Done,
     /* 277250 */ // Label 5645: @277250
     /* 277250 */ GIM_Reject,
     /* 277251 */ // Label 5641: @277251
     /* 277251 */ GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(277385), // Rule ID 6477 //
     /* 277256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 277259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 277262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277274 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 277274 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 277277 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 277281 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277286 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 277290 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 277294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 277296 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 277299 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277303 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277308 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 277314 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277319 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277324 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 277327 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277331 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277336 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 277342 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277347 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 277355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 277359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277364 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 277367 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 277370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 277375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277377 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 277383 */   GIR_RootConstrainSelectedInstOperands,
     /* 277384 */   // GIR_Coverage, 6477,
     /* 277384 */   GIR_EraseRootFromParent_Done,
     /* 277385 */ // Label 5646: @277385
     /* 277385 */ GIM_Reject,
     /* 277386 */ // Label 5642: @277386
     /* 277386 */ GIM_Reject,
     /* 277387 */ // Label 53: @277387
     /* 277387 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5658*/ GIMT_Encode4(277816),
     /* 277398 */ /*GILLT_v2s32*//*Label 5647*/ GIMT_Encode4(277474),
     /* 277402 */ /*GILLT_v2s64*//*Label 5648*/ GIMT_Encode4(277508),
     /* 277406 */ /*GILLT_v4s16*//*Label 5649*/ GIMT_Encode4(277542),
     /* 277410 */ /*GILLT_v4s32*//*Label 5650*/ GIMT_Encode4(277576),
     /* 277414 */ /*GILLT_v8s8*//*Label 5651*/ GIMT_Encode4(277610),
     /* 277418 */ /*GILLT_v8s16*//*Label 5652*/ GIMT_Encode4(277644),
     /* 277422 */ /*GILLT_v16s8*//*Label 5653*/ GIMT_Encode4(277678), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277442 */ /*GILLT_nxv2s64*//*Label 5654*/ GIMT_Encode4(277712), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277454 */ /*GILLT_nxv4s32*//*Label 5655*/ GIMT_Encode4(277738), GIMT_Encode4(0),
     /* 277462 */ /*GILLT_nxv8s16*//*Label 5656*/ GIMT_Encode4(277764), GIMT_Encode4(0),
     /* 277470 */ /*GILLT_nxv16s8*//*Label 5657*/ GIMT_Encode4(277790),
     /* 277474 */ // Label 5647: @277474
     /* 277474 */ GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(277507), // Rule ID 4999 //
     /* 277479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 277485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 277488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277500 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 277500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 277505 */   GIR_RootConstrainSelectedInstOperands,
     /* 277506 */   // GIR_Coverage, 4999,
     /* 277506 */   GIR_Done,
     /* 277507 */ // Label 5659: @277507
     /* 277507 */ GIM_Reject,
     /* 277508 */ // Label 5648: @277508
     /* 277508 */ GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(277541), // Rule ID 5003 //
     /* 277513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277534 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 277534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 277539 */   GIR_RootConstrainSelectedInstOperands,
     /* 277540 */   // GIR_Coverage, 5003,
     /* 277540 */   GIR_Done,
     /* 277541 */ // Label 5660: @277541
     /* 277541 */ GIM_Reject,
     /* 277542 */ // Label 5649: @277542
     /* 277542 */ GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(277575), // Rule ID 4998 //
     /* 277547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 277553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 277556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277568 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 277568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 277573 */   GIR_RootConstrainSelectedInstOperands,
     /* 277574 */   // GIR_Coverage, 4998,
     /* 277574 */   GIR_Done,
     /* 277575 */ // Label 5661: @277575
     /* 277575 */ GIM_Reject,
     /* 277576 */ // Label 5650: @277576
     /* 277576 */ GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(277609), // Rule ID 5002 //
     /* 277581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 277590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277602 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 277602 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 277607 */   GIR_RootConstrainSelectedInstOperands,
     /* 277608 */   // GIR_Coverage, 5002,
     /* 277608 */   GIR_Done,
     /* 277609 */ // Label 5662: @277609
     /* 277609 */ GIM_Reject,
     /* 277610 */ // Label 5651: @277610
     /* 277610 */ GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(277643), // Rule ID 4997 //
     /* 277615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 277621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 277624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277636 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 277636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 277641 */   GIR_RootConstrainSelectedInstOperands,
     /* 277642 */   // GIR_Coverage, 4997,
     /* 277642 */   GIR_Done,
     /* 277643 */ // Label 5663: @277643
     /* 277643 */ GIM_Reject,
     /* 277644 */ // Label 5652: @277644
     /* 277644 */ GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(277677), // Rule ID 5001 //
     /* 277649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 277655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 277658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277670 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 277670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 277675 */   GIR_RootConstrainSelectedInstOperands,
     /* 277676 */   // GIR_Coverage, 5001,
     /* 277676 */   GIR_Done,
     /* 277677 */ // Label 5664: @277677
     /* 277677 */ GIM_Reject,
     /* 277678 */ // Label 5653: @277678
     /* 277678 */ GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(277711), // Rule ID 5000 //
     /* 277683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 277689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 277692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277704 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 277704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 277709 */   GIR_RootConstrainSelectedInstOperands,
     /* 277710 */   // GIR_Coverage, 5000,
     /* 277710 */   GIR_Done,
     /* 277711 */ // Label 5665: @277711
     /* 277711 */ GIM_Reject,
     /* 277712 */ // Label 5654: @277712
     /* 277712 */ GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(277737), // Rule ID 7382 //
     /* 277717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 277720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 277723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 277726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277730 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 277730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 277735 */   GIR_RootConstrainSelectedInstOperands,
     /* 277736 */   // GIR_Coverage, 7382,
     /* 277736 */   GIR_Done,
     /* 277737 */ // Label 5666: @277737
     /* 277737 */ GIM_Reject,
     /* 277738 */ // Label 5655: @277738
     /* 277738 */ GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(277763), // Rule ID 7381 //
     /* 277743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 277746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 277749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277756 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 277756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 277761 */   GIR_RootConstrainSelectedInstOperands,
     /* 277762 */   // GIR_Coverage, 7381,
     /* 277762 */   GIR_Done,
     /* 277763 */ // Label 5667: @277763
     /* 277763 */ GIM_Reject,
     /* 277764 */ // Label 5656: @277764
     /* 277764 */ GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(277789), // Rule ID 7380 //
     /* 277769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 277772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 277775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 277778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277782 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 277782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 277787 */   GIR_RootConstrainSelectedInstOperands,
     /* 277788 */   // GIR_Coverage, 7380,
     /* 277788 */   GIR_Done,
     /* 277789 */ // Label 5668: @277789
     /* 277789 */ GIM_Reject,
     /* 277790 */ // Label 5657: @277790
     /* 277790 */ GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(277815), // Rule ID 7379 //
     /* 277795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 277798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 277801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 277804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277808 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 277808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 277813 */   GIR_RootConstrainSelectedInstOperands,
     /* 277814 */   // GIR_Coverage, 7379,
     /* 277814 */   GIR_Done,
     /* 277815 */ // Label 5669: @277815
     /* 277815 */ GIM_Reject,
     /* 277816 */ // Label 5658: @277816
     /* 277816 */ GIM_Reject,
     /* 277817 */ // Label 54: @277817
     /* 277817 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5681*/ GIMT_Encode4(278246),
     /* 277828 */ /*GILLT_v2s32*//*Label 5670*/ GIMT_Encode4(277904),
     /* 277832 */ /*GILLT_v2s64*//*Label 5671*/ GIMT_Encode4(277938),
     /* 277836 */ /*GILLT_v4s16*//*Label 5672*/ GIMT_Encode4(277972),
     /* 277840 */ /*GILLT_v4s32*//*Label 5673*/ GIMT_Encode4(278006),
     /* 277844 */ /*GILLT_v8s8*//*Label 5674*/ GIMT_Encode4(278040),
     /* 277848 */ /*GILLT_v8s16*//*Label 5675*/ GIMT_Encode4(278074),
     /* 277852 */ /*GILLT_v16s8*//*Label 5676*/ GIMT_Encode4(278108), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277872 */ /*GILLT_nxv2s64*//*Label 5677*/ GIMT_Encode4(278142), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277884 */ /*GILLT_nxv4s32*//*Label 5678*/ GIMT_Encode4(278168), GIMT_Encode4(0),
     /* 277892 */ /*GILLT_nxv8s16*//*Label 5679*/ GIMT_Encode4(278194), GIMT_Encode4(0),
     /* 277900 */ /*GILLT_nxv16s8*//*Label 5680*/ GIMT_Encode4(278220),
     /* 277904 */ // Label 5670: @277904
     /* 277904 */ GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(277937), // Rule ID 2468 //
     /* 277909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 277915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 277918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277930 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 277930 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 277935 */   GIR_RootConstrainSelectedInstOperands,
     /* 277936 */   // GIR_Coverage, 2468,
     /* 277936 */   GIR_Done,
     /* 277937 */ // Label 5682: @277937
     /* 277937 */ GIM_Reject,
     /* 277938 */ // Label 5671: @277938
     /* 277938 */ GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(277971), // Rule ID 2472 //
     /* 277943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277964 */   // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 277964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 277969 */   GIR_RootConstrainSelectedInstOperands,
     /* 277970 */   // GIR_Coverage, 2472,
     /* 277970 */   GIR_Done,
     /* 277971 */ // Label 5683: @277971
     /* 277971 */ GIM_Reject,
     /* 277972 */ // Label 5672: @277972
     /* 277972 */ GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(278005), // Rule ID 2467 //
     /* 277977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 277983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 277986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277994 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277998 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 277998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 278003 */   GIR_RootConstrainSelectedInstOperands,
     /* 278004 */   // GIR_Coverage, 2467,
     /* 278004 */   GIR_Done,
     /* 278005 */ // Label 5684: @278005
     /* 278005 */ GIM_Reject,
     /* 278006 */ // Label 5673: @278006
     /* 278006 */ GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(278039), // Rule ID 2471 //
     /* 278011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278032 */   // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 278032 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 278037 */   GIR_RootConstrainSelectedInstOperands,
     /* 278038 */   // GIR_Coverage, 2471,
     /* 278038 */   GIR_Done,
     /* 278039 */ // Label 5685: @278039
     /* 278039 */ GIM_Reject,
     /* 278040 */ // Label 5674: @278040
     /* 278040 */ GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(278073), // Rule ID 2466 //
     /* 278045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 278051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 278054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278066 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 278066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 278071 */   GIR_RootConstrainSelectedInstOperands,
     /* 278072 */   // GIR_Coverage, 2466,
     /* 278072 */   GIR_Done,
     /* 278073 */ // Label 5686: @278073
     /* 278073 */ GIM_Reject,
     /* 278074 */ // Label 5675: @278074
     /* 278074 */ GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(278107), // Rule ID 2470 //
     /* 278079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278096 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278100 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 278100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 278105 */   GIR_RootConstrainSelectedInstOperands,
     /* 278106 */   // GIR_Coverage, 2470,
     /* 278106 */   GIR_Done,
     /* 278107 */ // Label 5687: @278107
     /* 278107 */ GIM_Reject,
     /* 278108 */ // Label 5676: @278108
     /* 278108 */ GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(278141), // Rule ID 2469 //
     /* 278113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 278119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 278122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278134 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 278134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 278139 */   GIR_RootConstrainSelectedInstOperands,
     /* 278140 */   // GIR_Coverage, 2469,
     /* 278140 */   GIR_Done,
     /* 278141 */ // Label 5688: @278141
     /* 278141 */ GIM_Reject,
     /* 278142 */ // Label 5677: @278142
     /* 278142 */ GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(278167), // Rule ID 7378 //
     /* 278147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 278150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 278153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 278156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278160 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 278160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 278165 */   GIR_RootConstrainSelectedInstOperands,
     /* 278166 */   // GIR_Coverage, 7378,
     /* 278166 */   GIR_Done,
     /* 278167 */ // Label 5689: @278167
     /* 278167 */ GIM_Reject,
     /* 278168 */ // Label 5678: @278168
     /* 278168 */ GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(278193), // Rule ID 7377 //
     /* 278173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 278176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 278179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 278182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278186 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 278186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 278191 */   GIR_RootConstrainSelectedInstOperands,
     /* 278192 */   // GIR_Coverage, 7377,
     /* 278192 */   GIR_Done,
     /* 278193 */ // Label 5690: @278193
     /* 278193 */ GIM_Reject,
     /* 278194 */ // Label 5679: @278194
     /* 278194 */ GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(278219), // Rule ID 7376 //
     /* 278199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 278202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 278205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 278208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278212 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 278212 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 278217 */   GIR_RootConstrainSelectedInstOperands,
     /* 278218 */   // GIR_Coverage, 7376,
     /* 278218 */   GIR_Done,
     /* 278219 */ // Label 5691: @278219
     /* 278219 */ GIM_Reject,
     /* 278220 */ // Label 5680: @278220
     /* 278220 */ GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(278245), // Rule ID 7375 //
     /* 278225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 278228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 278231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 278234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278238 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 278238 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 278243 */   GIR_RootConstrainSelectedInstOperands,
     /* 278244 */   // GIR_Coverage, 7375,
     /* 278244 */   GIR_Done,
     /* 278245 */ // Label 5692: @278245
     /* 278245 */ GIM_Reject,
     /* 278246 */ // Label 5681: @278246
     /* 278246 */ GIM_Reject,
     /* 278247 */ // Label 55: @278247
     /* 278247 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5704*/ GIMT_Encode4(278676),
     /* 278258 */ /*GILLT_v2s32*//*Label 5693*/ GIMT_Encode4(278334),
     /* 278262 */ /*GILLT_v2s64*//*Label 5694*/ GIMT_Encode4(278368),
     /* 278266 */ /*GILLT_v4s16*//*Label 5695*/ GIMT_Encode4(278402),
     /* 278270 */ /*GILLT_v4s32*//*Label 5696*/ GIMT_Encode4(278436),
     /* 278274 */ /*GILLT_v8s8*//*Label 5697*/ GIMT_Encode4(278470),
     /* 278278 */ /*GILLT_v8s16*//*Label 5698*/ GIMT_Encode4(278504),
     /* 278282 */ /*GILLT_v16s8*//*Label 5699*/ GIMT_Encode4(278538), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 278302 */ /*GILLT_nxv2s64*//*Label 5700*/ GIMT_Encode4(278572), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 278314 */ /*GILLT_nxv4s32*//*Label 5701*/ GIMT_Encode4(278598), GIMT_Encode4(0),
     /* 278322 */ /*GILLT_nxv8s16*//*Label 5702*/ GIMT_Encode4(278624), GIMT_Encode4(0),
     /* 278330 */ /*GILLT_nxv16s8*//*Label 5703*/ GIMT_Encode4(278650),
     /* 278334 */ // Label 5693: @278334
     /* 278334 */ GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(278367), // Rule ID 5013 //
     /* 278339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 278345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 278348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278360 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 278360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 278365 */   GIR_RootConstrainSelectedInstOperands,
     /* 278366 */   // GIR_Coverage, 5013,
     /* 278366 */   GIR_Done,
     /* 278367 */ // Label 5705: @278367
     /* 278367 */ GIM_Reject,
     /* 278368 */ // Label 5694: @278368
     /* 278368 */ GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(278401), // Rule ID 5017 //
     /* 278373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 278382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278394 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 278394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 278399 */   GIR_RootConstrainSelectedInstOperands,
     /* 278400 */   // GIR_Coverage, 5017,
     /* 278400 */   GIR_Done,
     /* 278401 */ // Label 5706: @278401
     /* 278401 */ GIM_Reject,
     /* 278402 */ // Label 5695: @278402
     /* 278402 */ GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(278435), // Rule ID 5012 //
     /* 278407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 278413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 278416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278424 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278428 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 278428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 278433 */   GIR_RootConstrainSelectedInstOperands,
     /* 278434 */   // GIR_Coverage, 5012,
     /* 278434 */   GIR_Done,
     /* 278435 */ // Label 5707: @278435
     /* 278435 */ GIM_Reject,
     /* 278436 */ // Label 5696: @278436
     /* 278436 */ GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(278469), // Rule ID 5016 //
     /* 278441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278462 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 278462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 278467 */   GIR_RootConstrainSelectedInstOperands,
     /* 278468 */   // GIR_Coverage, 5016,
     /* 278468 */   GIR_Done,
     /* 278469 */ // Label 5708: @278469
     /* 278469 */ GIM_Reject,
     /* 278470 */ // Label 5697: @278470
     /* 278470 */ GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(278503), // Rule ID 5011 //
     /* 278475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 278481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 278484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278496 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 278496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 278501 */   GIR_RootConstrainSelectedInstOperands,
     /* 278502 */   // GIR_Coverage, 5011,
     /* 278502 */   GIR_Done,
     /* 278503 */ // Label 5709: @278503
     /* 278503 */ GIM_Reject,
     /* 278504 */ // Label 5698: @278504
     /* 278504 */ GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(278537), // Rule ID 5015 //
     /* 278509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278530 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 278530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 278535 */   GIR_RootConstrainSelectedInstOperands,
     /* 278536 */   // GIR_Coverage, 5015,
     /* 278536 */   GIR_Done,
     /* 278537 */ // Label 5710: @278537
     /* 278537 */ GIM_Reject,
     /* 278538 */ // Label 5699: @278538
     /* 278538 */ GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(278571), // Rule ID 5014 //
     /* 278543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 278549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 278552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278560 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278564 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 278564 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 278569 */   GIR_RootConstrainSelectedInstOperands,
     /* 278570 */   // GIR_Coverage, 5014,
     /* 278570 */   GIR_Done,
     /* 278571 */ // Label 5711: @278571
     /* 278571 */ GIM_Reject,
     /* 278572 */ // Label 5700: @278572
     /* 278572 */ GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(278597), // Rule ID 7390 //
     /* 278577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 278580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 278583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 278586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278590 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 278590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 278595 */   GIR_RootConstrainSelectedInstOperands,
     /* 278596 */   // GIR_Coverage, 7390,
     /* 278596 */   GIR_Done,
     /* 278597 */ // Label 5712: @278597
     /* 278597 */ GIM_Reject,
     /* 278598 */ // Label 5701: @278598
     /* 278598 */ GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(278623), // Rule ID 7389 //
     /* 278603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 278606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 278609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 278612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278616 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 278616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 278621 */   GIR_RootConstrainSelectedInstOperands,
     /* 278622 */   // GIR_Coverage, 7389,
     /* 278622 */   GIR_Done,
     /* 278623 */ // Label 5713: @278623
     /* 278623 */ GIM_Reject,
     /* 278624 */ // Label 5702: @278624
     /* 278624 */ GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(278649), // Rule ID 7388 //
     /* 278629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 278632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 278635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 278638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278642 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 278642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 278647 */   GIR_RootConstrainSelectedInstOperands,
     /* 278648 */   // GIR_Coverage, 7388,
     /* 278648 */   GIR_Done,
     /* 278649 */ // Label 5714: @278649
     /* 278649 */ GIM_Reject,
     /* 278650 */ // Label 5703: @278650
     /* 278650 */ GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(278675), // Rule ID 7387 //
     /* 278655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 278658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 278661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 278664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 278668 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 278668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 278673 */   GIR_RootConstrainSelectedInstOperands,
     /* 278674 */   // GIR_Coverage, 7387,
     /* 278674 */   GIR_Done,
     /* 278675 */ // Label 5715: @278675
     /* 278675 */ GIM_Reject,
     /* 278676 */ // Label 5704: @278676
     /* 278676 */ GIM_Reject,
     /* 278677 */ // Label 56: @278677
     /* 278677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5727*/ GIMT_Encode4(279106),
     /* 278688 */ /*GILLT_v2s32*//*Label 5716*/ GIMT_Encode4(278764),
     /* 278692 */ /*GILLT_v2s64*//*Label 5717*/ GIMT_Encode4(278798),
     /* 278696 */ /*GILLT_v4s16*//*Label 5718*/ GIMT_Encode4(278832),
     /* 278700 */ /*GILLT_v4s32*//*Label 5719*/ GIMT_Encode4(278866),
     /* 278704 */ /*GILLT_v8s8*//*Label 5720*/ GIMT_Encode4(278900),
     /* 278708 */ /*GILLT_v8s16*//*Label 5721*/ GIMT_Encode4(278934),
     /* 278712 */ /*GILLT_v16s8*//*Label 5722*/ GIMT_Encode4(278968), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 278732 */ /*GILLT_nxv2s64*//*Label 5723*/ GIMT_Encode4(279002), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 278744 */ /*GILLT_nxv4s32*//*Label 5724*/ GIMT_Encode4(279028), GIMT_Encode4(0),
     /* 278752 */ /*GILLT_nxv8s16*//*Label 5725*/ GIMT_Encode4(279054), GIMT_Encode4(0),
     /* 278760 */ /*GILLT_nxv16s8*//*Label 5726*/ GIMT_Encode4(279080),
     /* 278764 */ // Label 5716: @278764
     /* 278764 */ GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(278797), // Rule ID 5006 //
     /* 278769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 278775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 278778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278786 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278790 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 278790 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 278795 */   GIR_RootConstrainSelectedInstOperands,
     /* 278796 */   // GIR_Coverage, 5006,
     /* 278796 */   GIR_Done,
     /* 278797 */ // Label 5728: @278797
     /* 278797 */ GIM_Reject,
     /* 278798 */ // Label 5717: @278798
     /* 278798 */ GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(278831), // Rule ID 5010 //
     /* 278803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 278812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278824 */   // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 278824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 278829 */   GIR_RootConstrainSelectedInstOperands,
     /* 278830 */   // GIR_Coverage, 5010,
     /* 278830 */   GIR_Done,
     /* 278831 */ // Label 5729: @278831
     /* 278831 */ GIM_Reject,
     /* 278832 */ // Label 5718: @278832
     /* 278832 */ GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(278865), // Rule ID 5005 //
     /* 278837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 278843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 278846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278858 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 278858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 278863 */   GIR_RootConstrainSelectedInstOperands,
     /* 278864 */   // GIR_Coverage, 5005,
     /* 278864 */   GIR_Done,
     /* 278865 */ // Label 5730: @278865
     /* 278865 */ GIM_Reject,
     /* 278866 */ // Label 5719: @278866
     /* 278866 */ GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(278899), // Rule ID 5009 //
     /* 278871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278892 */   // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 278892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 278897 */   GIR_RootConstrainSelectedInstOperands,
     /* 278898 */   // GIR_Coverage, 5009,
     /* 278898 */   GIR_Done,
     /* 278899 */ // Label 5731: @278899
     /* 278899 */ GIM_Reject,
     /* 278900 */ // Label 5720: @278900
     /* 278900 */ GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(278933), // Rule ID 5004 //
     /* 278905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 278911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 278914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278922 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278926 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 278926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 278931 */   GIR_RootConstrainSelectedInstOperands,
     /* 278932 */   // GIR_Coverage, 5004,
     /* 278932 */   GIR_Done,
     /* 278933 */ // Label 5732: @278933
     /* 278933 */ GIM_Reject,
     /* 278934 */ // Label 5721: @278934
     /* 278934 */ GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(278967), // Rule ID 5008 //
     /* 278939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278960 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 278960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 278965 */   GIR_RootConstrainSelectedInstOperands,
     /* 278966 */   // GIR_Coverage, 5008,
     /* 278966 */   GIR_Done,
     /* 278967 */ // Label 5733: @278967
     /* 278967 */ GIM_Reject,
     /* 278968 */ // Label 5722: @278968
     /* 278968 */ GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(279001), // Rule ID 5007 //
     /* 278973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 278979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 278982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278990 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278994 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 278994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 278999 */   GIR_RootConstrainSelectedInstOperands,
     /* 279000 */   // GIR_Coverage, 5007,
     /* 279000 */   GIR_Done,
     /* 279001 */ // Label 5734: @279001
     /* 279001 */ GIM_Reject,
     /* 279002 */ // Label 5723: @279002
     /* 279002 */ GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(279027), // Rule ID 7386 //
     /* 279007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 279013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 279016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279020 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 279020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 279025 */   GIR_RootConstrainSelectedInstOperands,
     /* 279026 */   // GIR_Coverage, 7386,
     /* 279026 */   GIR_Done,
     /* 279027 */ // Label 5735: @279027
     /* 279027 */ GIM_Reject,
     /* 279028 */ // Label 5724: @279028
     /* 279028 */ GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(279053), // Rule ID 7385 //
     /* 279033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 279039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279046 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 279046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 279051 */   GIR_RootConstrainSelectedInstOperands,
     /* 279052 */   // GIR_Coverage, 7385,
     /* 279052 */   GIR_Done,
     /* 279053 */ // Label 5736: @279053
     /* 279053 */ GIM_Reject,
     /* 279054 */ // Label 5725: @279054
     /* 279054 */ GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(279079), // Rule ID 7384 //
     /* 279059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 279065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 279068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279072 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 279072 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 279077 */   GIR_RootConstrainSelectedInstOperands,
     /* 279078 */   // GIR_Coverage, 7384,
     /* 279078 */   GIR_Done,
     /* 279079 */ // Label 5737: @279079
     /* 279079 */ GIM_Reject,
     /* 279080 */ // Label 5726: @279080
     /* 279080 */ GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(279105), // Rule ID 7383 //
     /* 279085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 279091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 279094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279098 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 279098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 279103 */   GIR_RootConstrainSelectedInstOperands,
     /* 279104 */   // GIR_Coverage, 7383,
     /* 279104 */   GIR_Done,
     /* 279105 */ // Label 5738: @279105
     /* 279105 */ GIM_Reject,
     /* 279106 */ // Label 5727: @279106
     /* 279106 */ GIM_Reject,
     /* 279107 */ // Label 57: @279107
     /* 279107 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5750*/ GIMT_Encode4(280904),
     /* 279118 */ /*GILLT_s16*//*Label 5739*/ GIMT_Encode4(279202),
     /* 279122 */ /*GILLT_s32*//*Label 5740*/ GIMT_Encode4(279428),
     /* 279126 */ /*GILLT_s64*//*Label 5741*/ GIMT_Encode4(279782), GIMT_Encode4(0),
     /* 279134 */ /*GILLT_v2s32*//*Label 5742*/ GIMT_Encode4(279954),
     /* 279138 */ /*GILLT_v2s64*//*Label 5743*/ GIMT_Encode4(279992),
     /* 279142 */ /*GILLT_v4s16*//*Label 5744*/ GIMT_Encode4(280168),
     /* 279146 */ /*GILLT_v4s32*//*Label 5745*/ GIMT_Encode4(280206), GIMT_Encode4(0),
     /* 279154 */ /*GILLT_v8s16*//*Label 5746*/ GIMT_Encode4(280382), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 279178 */ /*GILLT_nxv2s64*//*Label 5747*/ GIMT_Encode4(280826), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 279190 */ /*GILLT_nxv4s32*//*Label 5748*/ GIMT_Encode4(280852), GIMT_Encode4(0),
     /* 279198 */ /*GILLT_nxv8s16*//*Label 5749*/ GIMT_Encode4(280878),
     /* 279202 */ // Label 5739: @279202
     /* 279202 */ GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(279427),
     /* 279207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 279213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279217 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(279308), // Rule ID 6870 //
     /* 279222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279243 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279255 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279259 */     // MIs[2] Rn
     /* 279259 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 279264 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 279268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279270 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 279270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279282 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 279288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 279301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279306 */     GIR_RootConstrainSelectedInstOperands,
     /* 279307 */     // GIR_Coverage, 6870,
     /* 279307 */     GIR_EraseRootFromParent_Done,
     /* 279308 */   // Label 5752: @279308
     /* 279308 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(279399), // Rule ID 13851 //
     /* 279313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 279325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279334 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 279338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279346 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279350 */     // MIs[2] Rn
     /* 279350 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 279355 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 279359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279361 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 279361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279373 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 279379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 279392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279397 */     GIR_RootConstrainSelectedInstOperands,
     /* 279398 */     // GIR_Coverage, 13851,
     /* 279398 */     GIR_EraseRootFromParent_Done,
     /* 279399 */   // Label 5753: @279399
     /* 279399 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(279426), // Rule ID 584 //
     /* 279404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279415 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 279415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 279420 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 279424 */     GIR_RootConstrainSelectedInstOperands,
     /* 279425 */     // GIR_Coverage, 584,
     /* 279425 */     GIR_Done,
     /* 279426 */   // Label 5754: @279426
     /* 279426 */   GIM_Reject,
     /* 279427 */ // Label 5751: @279427
     /* 279427 */ GIM_Reject,
     /* 279428 */ // Label 5740: @279428
     /* 279428 */ GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(279781),
     /* 279433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 279436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 279439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279443 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(279534), // Rule ID 6868 //
     /* 279448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 279460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279469 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279485 */     // MIs[2] Rn
     /* 279485 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 279490 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 279494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279496 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 279496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279508 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 279514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 279527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279532 */     GIR_RootConstrainSelectedInstOperands,
     /* 279533 */     // GIR_Coverage, 6868,
     /* 279533 */     GIR_EraseRootFromParent_Done,
     /* 279534 */   // Label 5756: @279534
     /* 279534 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(279598), // Rule ID 13022 //
     /* 279539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 279551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279560 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279576 */     // MIs[2] Rn
     /* 279576 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 279581 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 279585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279587 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 279587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 279590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 279596 */     GIR_RootConstrainSelectedInstOperands,
     /* 279597 */     // GIR_Coverage, 13022,
     /* 279597 */     GIR_EraseRootFromParent_Done,
     /* 279598 */   // Label 5757: @279598
     /* 279598 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(279689), // Rule ID 13849 //
     /* 279603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 279615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279624 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 279628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279640 */     // MIs[2] Rn
     /* 279640 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 279645 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 279649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279651 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 279651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279663 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 279669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 279682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279687 */     GIR_RootConstrainSelectedInstOperands,
     /* 279688 */     // GIR_Coverage, 13849,
     /* 279688 */     GIR_EraseRootFromParent_Done,
     /* 279689 */   // Label 5758: @279689
     /* 279689 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(279753), // Rule ID 15524 //
     /* 279694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 279706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279715 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 279719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279731 */     // MIs[2] Rn
     /* 279731 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 279736 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 279740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279742 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 279742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 279745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 279751 */     GIR_RootConstrainSelectedInstOperands,
     /* 279752 */     // GIR_Coverage, 15524,
     /* 279752 */     GIR_EraseRootFromParent_Done,
     /* 279753 */   // Label 5759: @279753
     /* 279753 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(279780), // Rule ID 586 //
     /* 279758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279769 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 279769 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 279774 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 279778 */     GIR_RootConstrainSelectedInstOperands,
     /* 279779 */     // GIR_Coverage, 586,
     /* 279779 */     GIR_Done,
     /* 279780 */   // Label 5760: @279780
     /* 279780 */   GIM_Reject,
     /* 279781 */ // Label 5755: @279781
     /* 279781 */ GIM_Reject,
     /* 279782 */ // Label 5741: @279782
     /* 279782 */ GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(279953),
     /* 279787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 279790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 279793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279797 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(279861), // Rule ID 6866 //
     /* 279802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279823 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 279827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279839 */     // MIs[2] Rn
     /* 279839 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 279844 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 279848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279850 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 279850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 279853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 279859 */     GIR_RootConstrainSelectedInstOperands,
     /* 279860 */     // GIR_Coverage, 6866,
     /* 279860 */     GIR_EraseRootFromParent_Done,
     /* 279861 */   // Label 5762: @279861
     /* 279861 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(279925), // Rule ID 13847 //
     /* 279866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 279882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279887 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 279891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 279895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 279899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 279903 */     // MIs[2] Rn
     /* 279903 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 279908 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 279912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279914 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 279914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 279917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 279923 */     GIR_RootConstrainSelectedInstOperands,
     /* 279924 */     // GIR_Coverage, 13847,
     /* 279924 */     GIR_EraseRootFromParent_Done,
     /* 279925 */   // Label 5763: @279925
     /* 279925 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(279952), // Rule ID 588 //
     /* 279930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279941 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 279941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 279946 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 279950 */     GIR_RootConstrainSelectedInstOperands,
     /* 279951 */     // GIR_Coverage, 588,
     /* 279951 */     GIR_Done,
     /* 279952 */   // Label 5764: @279952
     /* 279952 */   GIM_Reject,
     /* 279953 */ // Label 5761: @279953
     /* 279953 */ GIM_Reject,
     /* 279954 */ // Label 5742: @279954
     /* 279954 */ GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(279991), // Rule ID 1196 //
     /* 279959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 279965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 279968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279980 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 279980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 279985 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 279989 */   GIR_RootConstrainSelectedInstOperands,
     /* 279990 */   // GIR_Coverage, 1196,
     /* 279990 */   GIR_Done,
     /* 279991 */ // Label 5765: @279991
     /* 279991 */ GIM_Reject,
     /* 279992 */ // Label 5743: @279992
     /* 279992 */ GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(280167),
     /* 279997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 280003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280007 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(280073), // Rule ID 6888 //
     /* 280012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 280020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 280028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 280046 */     // MIs[2] Rn
     /* 280046 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 280051 */     // MIs[2] Rm
     /* 280051 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280058 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 280058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 280061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 280071 */     GIR_RootConstrainSelectedInstOperands,
     /* 280072 */     // GIR_Coverage, 6888,
     /* 280072 */     GIR_EraseRootFromParent_Done,
     /* 280073 */   // Label 5767: @280073
     /* 280073 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(280139), // Rule ID 13859 //
     /* 280078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 280086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 280094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 280112 */     // MIs[2] Rn
     /* 280112 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 280117 */     // MIs[2] Rm
     /* 280117 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280124 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 280124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 280127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 280137 */     GIR_RootConstrainSelectedInstOperands,
     /* 280138 */     // GIR_Coverage, 13859,
     /* 280138 */     GIR_EraseRootFromParent_Done,
     /* 280139 */   // Label 5768: @280139
     /* 280139 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(280166), // Rule ID 1200 //
     /* 280144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280155 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 280155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 280160 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 280164 */     GIR_RootConstrainSelectedInstOperands,
     /* 280165 */     // GIR_Coverage, 1200,
     /* 280165 */     GIR_Done,
     /* 280166 */   // Label 5769: @280166
     /* 280166 */   GIM_Reject,
     /* 280167 */ // Label 5766: @280167
     /* 280167 */ GIM_Reject,
     /* 280168 */ // Label 5744: @280168
     /* 280168 */ GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(280205), // Rule ID 1192 //
     /* 280173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 280179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 280182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280194 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 280194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 280199 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 280203 */   GIR_RootConstrainSelectedInstOperands,
     /* 280204 */   // GIR_Coverage, 1192,
     /* 280204 */   GIR_Done,
     /* 280205 */ // Label 5770: @280205
     /* 280205 */ GIM_Reject,
     /* 280206 */ // Label 5745: @280206
     /* 280206 */ GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(280381),
     /* 280211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280221 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(280287), // Rule ID 6889 //
     /* 280226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 280234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 280260 */     // MIs[2] Rn
     /* 280260 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 280265 */     // MIs[2] Rm
     /* 280265 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280272 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 280272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 280275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 280285 */     GIR_RootConstrainSelectedInstOperands,
     /* 280286 */     // GIR_Coverage, 6889,
     /* 280286 */     GIR_EraseRootFromParent_Done,
     /* 280287 */   // Label 5772: @280287
     /* 280287 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(280353), // Rule ID 13860 //
     /* 280292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 280300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 280326 */     // MIs[2] Rn
     /* 280326 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 280331 */     // MIs[2] Rm
     /* 280331 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280338 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 280338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 280341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 280351 */     GIR_RootConstrainSelectedInstOperands,
     /* 280352 */     // GIR_Coverage, 13860,
     /* 280352 */     GIR_EraseRootFromParent_Done,
     /* 280353 */   // Label 5773: @280353
     /* 280353 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(280380), // Rule ID 1198 //
     /* 280358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280369 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 280369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 280374 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 280378 */     GIR_RootConstrainSelectedInstOperands,
     /* 280379 */     // GIR_Coverage, 1198,
     /* 280379 */     GIR_Done,
     /* 280380 */   // Label 5774: @280380
     /* 280380 */   GIM_Reject,
     /* 280381 */ // Label 5771: @280381
     /* 280381 */ GIM_Reject,
     /* 280382 */ // Label 5746: @280382
     /* 280382 */ GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(280825),
     /* 280387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280397 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(280466), // Rule ID 6890 //
     /* 280402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 280413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 280439 */     // MIs[2] Rn
     /* 280439 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 280444 */     // MIs[2] Rm
     /* 280444 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280451 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 280451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 280454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 280464 */     GIR_RootConstrainSelectedInstOperands,
     /* 280465 */     // GIR_Coverage, 6890,
     /* 280465 */     GIR_EraseRootFromParent_Done,
     /* 280466 */   // Label 5776: @280466
     /* 280466 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(280535), // Rule ID 13861 //
     /* 280471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 280474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 280482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 280504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 280508 */     // MIs[2] Rn
     /* 280508 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 280513 */     // MIs[2] Rm
     /* 280513 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280520 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 280520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 280523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 280533 */     GIR_RootConstrainSelectedInstOperands,
     /* 280534 */     // GIR_Coverage, 13861,
     /* 280534 */     GIR_EraseRootFromParent_Done,
     /* 280535 */   // Label 5777: @280535
     /* 280535 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(280562), // Rule ID 1194 //
     /* 280540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 280543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280551 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 280551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 280556 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 280560 */     GIR_RootConstrainSelectedInstOperands,
     /* 280561 */     // GIR_Coverage, 1194,
     /* 280561 */     GIR_Done,
     /* 280562 */   // Label 5778: @280562
     /* 280562 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(280824), // Rule ID 6959 //
     /* 280567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 280570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280578 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 280578 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 280581 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 280585 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280590 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 280594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 280596 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 280599 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 280603 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280608 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 280612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 280614 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 280617 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 280621 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280626 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 280629 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 280632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 280634 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 280637 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280641 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280646 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 280652 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280657 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280662 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 280665 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 280669 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280674 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 280677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 280679 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 280682 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280686 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280691 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 280697 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280702 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280707 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 280710 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 280714 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280719 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 280722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 280724 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 280727 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 280731 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280736 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 280739 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 280742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280744 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 280747 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 280751 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280756 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 280759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280761 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 280764 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280768 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 280778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280787 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280790 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280793 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 280796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 280814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 280816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 280822 */     GIR_RootConstrainSelectedInstOperands,
     /* 280823 */     // GIR_Coverage, 6959,
     /* 280823 */     GIR_EraseRootFromParent_Done,
     /* 280824 */   // Label 5779: @280824
     /* 280824 */   GIM_Reject,
     /* 280825 */ // Label 5775: @280825
     /* 280825 */ GIM_Reject,
     /* 280826 */ // Label 5747: @280826
     /* 280826 */ GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(280851), // Rule ID 2815 //
     /* 280831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 280837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 280840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280844 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 280844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 280849 */   GIR_RootConstrainSelectedInstOperands,
     /* 280850 */   // GIR_Coverage, 2815,
     /* 280850 */   GIR_Done,
     /* 280851 */ // Label 5780: @280851
     /* 280851 */ GIM_Reject,
     /* 280852 */ // Label 5748: @280852
     /* 280852 */ GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(280877), // Rule ID 2813 //
     /* 280857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 280863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 280866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280870 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 280870 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 280875 */   GIR_RootConstrainSelectedInstOperands,
     /* 280876 */   // GIR_Coverage, 2813,
     /* 280876 */   GIR_Done,
     /* 280877 */ // Label 5781: @280877
     /* 280877 */ GIM_Reject,
     /* 280878 */ // Label 5749: @280878
     /* 280878 */ GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(280903), // Rule ID 2811 //
     /* 280883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 280889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 280892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280896 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 280896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 280901 */   GIR_RootConstrainSelectedInstOperands,
     /* 280902 */   // GIR_Coverage, 2811,
     /* 280902 */   GIR_Done,
     /* 280903 */ // Label 5782: @280903
     /* 280903 */ GIM_Reject,
     /* 280904 */ // Label 5750: @280904
     /* 280904 */ GIM_Reject,
     /* 280905 */ // Label 58: @280905
     /* 280905 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5794*/ GIMT_Encode4(281642),
     /* 280916 */ /*GILLT_s16*//*Label 5783*/ GIMT_Encode4(281000),
     /* 280920 */ /*GILLT_s32*//*Label 5784*/ GIMT_Encode4(281038),
     /* 280924 */ /*GILLT_s64*//*Label 5785*/ GIMT_Encode4(281076), GIMT_Encode4(0),
     /* 280932 */ /*GILLT_v2s32*//*Label 5786*/ GIMT_Encode4(281114),
     /* 280936 */ /*GILLT_v2s64*//*Label 5787*/ GIMT_Encode4(281152),
     /* 280940 */ /*GILLT_v4s16*//*Label 5788*/ GIMT_Encode4(281190),
     /* 280944 */ /*GILLT_v4s32*//*Label 5789*/ GIMT_Encode4(281228), GIMT_Encode4(0),
     /* 280952 */ /*GILLT_v8s16*//*Label 5790*/ GIMT_Encode4(281266), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 280976 */ /*GILLT_nxv2s64*//*Label 5791*/ GIMT_Encode4(281564), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 280988 */ /*GILLT_nxv4s32*//*Label 5792*/ GIMT_Encode4(281590), GIMT_Encode4(0),
     /* 280996 */ /*GILLT_nxv8s16*//*Label 5793*/ GIMT_Encode4(281616),
     /* 281000 */ // Label 5783: @281000
     /* 281000 */ GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(281037), // Rule ID 632 //
     /* 281005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 281014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281026 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 281026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 281031 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 281035 */   GIR_RootConstrainSelectedInstOperands,
     /* 281036 */   // GIR_Coverage, 632,
     /* 281036 */   GIR_Done,
     /* 281037 */ // Label 5795: @281037
     /* 281037 */ GIM_Reject,
     /* 281038 */ // Label 5784: @281038
     /* 281038 */ GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(281075), // Rule ID 634 //
     /* 281043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 281046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 281049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 281052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281064 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 281064 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 281069 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 281073 */   GIR_RootConstrainSelectedInstOperands,
     /* 281074 */   // GIR_Coverage, 634,
     /* 281074 */   GIR_Done,
     /* 281075 */ // Label 5796: @281075
     /* 281075 */ GIM_Reject,
     /* 281076 */ // Label 5785: @281076
     /* 281076 */ GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(281113), // Rule ID 636 //
     /* 281081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 281084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 281087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 281090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281102 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 281102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 281107 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 281111 */   GIR_RootConstrainSelectedInstOperands,
     /* 281112 */   // GIR_Coverage, 636,
     /* 281112 */   GIR_Done,
     /* 281113 */ // Label 5797: @281113
     /* 281113 */ GIM_Reject,
     /* 281114 */ // Label 5786: @281114
     /* 281114 */ GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(281151), // Rule ID 1336 //
     /* 281119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 281125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 281128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281136 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281140 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 281140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 281145 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 281149 */   GIR_RootConstrainSelectedInstOperands,
     /* 281150 */   // GIR_Coverage, 1336,
     /* 281150 */   GIR_Done,
     /* 281151 */ // Label 5798: @281151
     /* 281151 */ GIM_Reject,
     /* 281152 */ // Label 5787: @281152
     /* 281152 */ GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(281189), // Rule ID 1340 //
     /* 281157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 281163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 281166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281174 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281178 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 281178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 281183 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 281187 */   GIR_RootConstrainSelectedInstOperands,
     /* 281188 */   // GIR_Coverage, 1340,
     /* 281188 */   GIR_Done,
     /* 281189 */ // Label 5799: @281189
     /* 281189 */ GIM_Reject,
     /* 281190 */ // Label 5788: @281190
     /* 281190 */ GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(281227), // Rule ID 1332 //
     /* 281195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 281201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 281204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281216 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 281216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 281221 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 281225 */   GIR_RootConstrainSelectedInstOperands,
     /* 281226 */   // GIR_Coverage, 1332,
     /* 281226 */   GIR_Done,
     /* 281227 */ // Label 5800: @281227
     /* 281227 */ GIM_Reject,
     /* 281228 */ // Label 5789: @281228
     /* 281228 */ GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(281265), // Rule ID 1338 //
     /* 281233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 281239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 281242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281254 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 281254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 281259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 281263 */   GIR_RootConstrainSelectedInstOperands,
     /* 281264 */   // GIR_Coverage, 1338,
     /* 281264 */   GIR_Done,
     /* 281265 */ // Label 5801: @281265
     /* 281265 */ GIM_Reject,
     /* 281266 */ // Label 5790: @281266
     /* 281266 */ GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(281563),
     /* 281271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 281277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281289 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(281308), // Rule ID 1334 //
     /* 281294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281297 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 281297 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 281302 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 281306 */     GIR_RootConstrainSelectedInstOperands,
     /* 281307 */     // GIR_Coverage, 1334,
     /* 281307 */     GIR_Done,
     /* 281308 */   // Label 5803: @281308
     /* 281308 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(281562), // Rule ID 6965 //
     /* 281313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 281316 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 281316 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 281319 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 281323 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281328 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 281334 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 281337 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 281341 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281346 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 281352 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 281355 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 281359 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281364 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 281367 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 281370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 281372 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 281375 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281379 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281384 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281390 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281395 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281400 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 281403 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 281407 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281412 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 281415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 281417 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 281420 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281424 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281429 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281435 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281440 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281445 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 281448 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 281452 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281457 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 281460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 281462 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 281465 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 281469 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281474 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 281477 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 281480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281482 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 281485 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 281489 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281494 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 281497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281499 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 281502 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281506 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281525 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281528 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281531 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 281534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 281552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 281560 */     GIR_RootConstrainSelectedInstOperands,
     /* 281561 */     // GIR_Coverage, 6965,
     /* 281561 */     GIR_EraseRootFromParent_Done,
     /* 281562 */   // Label 5804: @281562
     /* 281562 */   GIM_Reject,
     /* 281563 */ // Label 5802: @281563
     /* 281563 */ GIM_Reject,
     /* 281564 */ // Label 5791: @281564
     /* 281564 */ GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(281589), // Rule ID 8129 //
     /* 281569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 281575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 281578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281582 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 281582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 281587 */   GIR_RootConstrainSelectedInstOperands,
     /* 281588 */   // GIR_Coverage, 8129,
     /* 281588 */   GIR_Done,
     /* 281589 */ // Label 5805: @281589
     /* 281589 */ GIM_Reject,
     /* 281590 */ // Label 5792: @281590
     /* 281590 */ GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(281615), // Rule ID 8127 //
     /* 281595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 281601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 281604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281608 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 281608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 281613 */   GIR_RootConstrainSelectedInstOperands,
     /* 281614 */   // GIR_Coverage, 8127,
     /* 281614 */   GIR_Done,
     /* 281615 */ // Label 5806: @281615
     /* 281615 */ GIM_Reject,
     /* 281616 */ // Label 5793: @281616
     /* 281616 */ GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(281641), // Rule ID 8125 //
     /* 281621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 281627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 281630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281634 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 281634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 281639 */   GIR_RootConstrainSelectedInstOperands,
     /* 281640 */   // GIR_Coverage, 8125,
     /* 281640 */   GIR_Done,
     /* 281641 */ // Label 5807: @281641
     /* 281641 */ GIM_Reject,
     /* 281642 */ // Label 5794: @281642
     /* 281642 */ GIM_Reject,
     /* 281643 */ // Label 59: @281643
     /* 281643 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5819*/ GIMT_Encode4(285738),
     /* 281654 */ /*GILLT_s16*//*Label 5808*/ GIMT_Encode4(281738),
     /* 281658 */ /*GILLT_s32*//*Label 5809*/ GIMT_Encode4(282380),
     /* 281662 */ /*GILLT_s64*//*Label 5810*/ GIMT_Encode4(283010), GIMT_Encode4(0),
     /* 281670 */ /*GILLT_v2s32*//*Label 5811*/ GIMT_Encode4(283640),
     /* 281674 */ /*GILLT_v2s64*//*Label 5812*/ GIMT_Encode4(284170),
     /* 281678 */ /*GILLT_v4s16*//*Label 5813*/ GIMT_Encode4(284528),
     /* 281682 */ /*GILLT_v4s32*//*Label 5814*/ GIMT_Encode4(284870), GIMT_Encode4(0),
     /* 281690 */ /*GILLT_v8s16*//*Label 5815*/ GIMT_Encode4(285228), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281714 */ /*GILLT_nxv2s64*//*Label 5816*/ GIMT_Encode4(285660), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281726 */ /*GILLT_nxv4s32*//*Label 5817*/ GIMT_Encode4(285686), GIMT_Encode4(0),
     /* 281734 */ /*GILLT_nxv8s16*//*Label 5818*/ GIMT_Encode4(285712),
     /* 281738 */ // Label 5808: @281738
     /* 281738 */ GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(282379),
     /* 281743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 281749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281753 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(281866), // Rule ID 6192 //
     /* 281758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281782 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 281786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 281790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281815 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281819 */     // MIs[3] Operand 1
     /* 281819 */     // No operand predicates
     /* 281819 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281821 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 281824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281833 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 281839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 281852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 281861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 281864 */     GIR_RootConstrainSelectedInstOperands,
     /* 281865 */     // GIR_Coverage, 6192,
     /* 281865 */     GIR_EraseRootFromParent_Done,
     /* 281866 */   // Label 5821: @281866
     /* 281866 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(281979), // Rule ID 13822 //
     /* 281871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 281874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281903 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281907 */     // MIs[2] Operand 1
     /* 281907 */     // No operand predicates
     /* 281907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 281911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281915 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281919 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 281923 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281928 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 281932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281934 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 281937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281946 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 281952 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 281965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 281974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281977 */     GIR_RootConstrainSelectedInstOperands,
     /* 281978 */     // GIR_Coverage, 13822,
     /* 281978 */     GIR_EraseRootFromParent_Done,
     /* 281979 */   // Label 5822: @281979
     /* 281979 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(282058), // Rule ID 13759 //
     /* 281984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282008 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282018 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 282018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 282021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282030 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 282036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 282049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 282053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282056 */     GIR_RootConstrainSelectedInstOperands,
     /* 282057 */     // GIR_Coverage, 13759,
     /* 282057 */     GIR_EraseRootFromParent_Done,
     /* 282058 */   // Label 5823: @282058
     /* 282058 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(282137), // Rule ID 4782 //
     /* 282063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 282066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282091 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282097 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 282097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 282100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282109 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 282115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 282128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 282132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282135 */     GIR_RootConstrainSelectedInstOperands,
     /* 282136 */     // GIR_Coverage, 4782,
     /* 282136 */     GIR_EraseRootFromParent_Done,
     /* 282137 */   // Label 5824: @282137
     /* 282137 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(282200), // Rule ID 13374 //
     /* 282142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 282145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 282166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282174 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282178 */     // MIs[2] Operand 1
     /* 282178 */     // No operand predicates
     /* 282178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282184 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 282184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 282187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 282191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 282195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282198 */     GIR_RootConstrainSelectedInstOperands,
     /* 282199 */     // GIR_Coverage, 13374,
     /* 282199 */     GIR_EraseRootFromParent_Done,
     /* 282200 */   // Label 5825: @282200
     /* 282200 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(282263), // Rule ID 2005 //
     /* 282205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 282208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 282233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282241 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282245 */     // MIs[2] Operand 1
     /* 282245 */     // No operand predicates
     /* 282245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282247 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 282247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 282250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 282254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 282258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282261 */     GIR_RootConstrainSelectedInstOperands,
     /* 282262 */     // GIR_Coverage, 2005,
     /* 282262 */     GIR_EraseRootFromParent_Done,
     /* 282263 */   // Label 5826: @282263
     /* 282263 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(282307), // Rule ID 4787 //
     /* 282268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 282271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282294 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 282294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 282297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 282303 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 282305 */     GIR_RootConstrainSelectedInstOperands,
     /* 282306 */     // GIR_Coverage, 4787,
     /* 282306 */     GIR_EraseRootFromParent_Done,
     /* 282307 */   // Label 5827: @282307
     /* 282307 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(282351), // Rule ID 13764 //
     /* 282312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 282315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 282331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282338 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 282338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 282341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 282347 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 282349 */     GIR_RootConstrainSelectedInstOperands,
     /* 282350 */     // GIR_Coverage, 13764,
     /* 282350 */     GIR_EraseRootFromParent_Done,
     /* 282351 */   // Label 5828: @282351
     /* 282351 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(282378), // Rule ID 620 //
     /* 282356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 282359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282367 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 282367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 282372 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 282376 */     GIR_RootConstrainSelectedInstOperands,
     /* 282377 */     // GIR_Coverage, 620,
     /* 282377 */     GIR_Done,
     /* 282378 */   // Label 5829: @282378
     /* 282378 */   GIM_Reject,
     /* 282379 */ // Label 5820: @282379
     /* 282379 */ GIM_Reject,
     /* 282380 */ // Label 5809: @282380
     /* 282380 */ GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(283009),
     /* 282385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 282388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 282391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282395 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(282508), // Rule ID 6194 //
     /* 282400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282424 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 282432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 282453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 282461 */     // MIs[3] Operand 1
     /* 282461 */     // No operand predicates
     /* 282461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282463 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 282463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282475 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 282494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 282503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 282506 */     GIR_RootConstrainSelectedInstOperands,
     /* 282507 */     // GIR_Coverage, 6194,
     /* 282507 */     GIR_EraseRootFromParent_Done,
     /* 282508 */   // Label 5831: @282508
     /* 282508 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(282621), // Rule ID 13824 //
     /* 282513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282545 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 282549 */     // MIs[2] Operand 1
     /* 282549 */     // No operand predicates
     /* 282549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 282553 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282557 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282561 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 282565 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282570 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 282574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282576 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 282576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282588 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 282594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 282607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 282616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282619 */     GIR_RootConstrainSelectedInstOperands,
     /* 282620 */     // GIR_Coverage, 13824,
     /* 282620 */     GIR_EraseRootFromParent_Done,
     /* 282621 */   // Label 5832: @282621
     /* 282621 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(282697), // Rule ID 13761 //
     /* 282626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282647 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282657 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 282657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282669 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 282675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 282688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 282692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282695 */     GIR_RootConstrainSelectedInstOperands,
     /* 282696 */     // GIR_Coverage, 13761,
     /* 282696 */     GIR_EraseRootFromParent_Done,
     /* 282697 */   // Label 5833: @282697
     /* 282697 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(282773), // Rule ID 4784 //
     /* 282702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282727 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 282731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282733 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 282733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282745 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 282751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 282764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 282768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282771 */     GIR_RootConstrainSelectedInstOperands,
     /* 282772 */     // GIR_Coverage, 4784,
     /* 282772 */     GIR_EraseRootFromParent_Done,
     /* 282773 */   // Label 5834: @282773
     /* 282773 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(282836), // Rule ID 13376 //
     /* 282778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282810 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 282814 */     // MIs[2] Operand 1
     /* 282814 */     // No operand predicates
     /* 282814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282820 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 282820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 282823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 282827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 282831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282834 */     GIR_RootConstrainSelectedInstOperands,
     /* 282835 */     // GIR_Coverage, 13376,
     /* 282835 */     GIR_EraseRootFromParent_Done,
     /* 282836 */   // Label 5835: @282836
     /* 282836 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(282899), // Rule ID 2007 //
     /* 282841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282877 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 282881 */     // MIs[2] Operand 1
     /* 282881 */     // No operand predicates
     /* 282881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282883 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 282883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 282886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 282890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 282894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282897 */     GIR_RootConstrainSelectedInstOperands,
     /* 282898 */     // GIR_Coverage, 2007,
     /* 282898 */     GIR_EraseRootFromParent_Done,
     /* 282899 */   // Label 5836: @282899
     /* 282899 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(282940), // Rule ID 4788 //
     /* 282904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282927 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 282927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 282930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 282936 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 282938 */     GIR_RootConstrainSelectedInstOperands,
     /* 282939 */     // GIR_Coverage, 4788,
     /* 282939 */     GIR_EraseRootFromParent_Done,
     /* 282940 */   // Label 5837: @282940
     /* 282940 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(282981), // Rule ID 13765 //
     /* 282945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 282953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 282957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282968 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 282968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 282971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 282977 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 282979 */     GIR_RootConstrainSelectedInstOperands,
     /* 282980 */     // GIR_Coverage, 13765,
     /* 282980 */     GIR_EraseRootFromParent_Done,
     /* 282981 */   // Label 5838: @282981
     /* 282981 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(283008), // Rule ID 622 //
     /* 282986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 282989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282997 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 282997 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 283002 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 283006 */     GIR_RootConstrainSelectedInstOperands,
     /* 283007 */     // GIR_Coverage, 622,
     /* 283007 */     GIR_Done,
     /* 283008 */   // Label 5839: @283008
     /* 283008 */   GIM_Reject,
     /* 283009 */ // Label 5830: @283009
     /* 283009 */ GIM_Reject,
     /* 283010 */ // Label 5810: @283010
     /* 283010 */ GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(283639),
     /* 283015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 283018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 283021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283025 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(283138), // Rule ID 6196 //
     /* 283030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283054 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 283083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283087 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 283091 */     // MIs[3] Operand 1
     /* 283091 */     // No operand predicates
     /* 283091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283093 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 283093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283105 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 283124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 283133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 283136 */     GIR_RootConstrainSelectedInstOperands,
     /* 283137 */     // GIR_Coverage, 6196,
     /* 283137 */     GIR_EraseRootFromParent_Done,
     /* 283138 */   // Label 5841: @283138
     /* 283138 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(283251), // Rule ID 13826 //
     /* 283143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283175 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 283179 */     // MIs[2] Operand 1
     /* 283179 */     // No operand predicates
     /* 283179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 283183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283187 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283191 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 283195 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283200 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 283204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283206 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 283206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283218 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 283237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 283246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283249 */     GIR_RootConstrainSelectedInstOperands,
     /* 283250 */     // GIR_Coverage, 13826,
     /* 283250 */     GIR_EraseRootFromParent_Done,
     /* 283251 */   // Label 5842: @283251
     /* 283251 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(283327), // Rule ID 13763 //
     /* 283256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283277 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283287 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 283287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283299 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 283305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 283318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 283322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283325 */     GIR_RootConstrainSelectedInstOperands,
     /* 283326 */     // GIR_Coverage, 13763,
     /* 283326 */     GIR_EraseRootFromParent_Done,
     /* 283327 */   // Label 5843: @283327
     /* 283327 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(283403), // Rule ID 4786 //
     /* 283332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283357 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283363 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 283363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283375 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 283381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 283394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283401 */     GIR_RootConstrainSelectedInstOperands,
     /* 283402 */     // GIR_Coverage, 4786,
     /* 283402 */     GIR_EraseRootFromParent_Done,
     /* 283403 */   // Label 5844: @283403
     /* 283403 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(283466), // Rule ID 13378 //
     /* 283408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283440 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 283444 */     // MIs[2] Operand 1
     /* 283444 */     // No operand predicates
     /* 283444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283450 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 283450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 283453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 283457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 283461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283464 */     GIR_RootConstrainSelectedInstOperands,
     /* 283465 */     // GIR_Coverage, 13378,
     /* 283465 */     GIR_EraseRootFromParent_Done,
     /* 283466 */   // Label 5845: @283466
     /* 283466 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(283529), // Rule ID 2009 //
     /* 283471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283507 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 283511 */     // MIs[2] Operand 1
     /* 283511 */     // No operand predicates
     /* 283511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283513 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 283513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 283516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 283524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283527 */     GIR_RootConstrainSelectedInstOperands,
     /* 283528 */     // GIR_Coverage, 2009,
     /* 283528 */     GIR_EraseRootFromParent_Done,
     /* 283529 */   // Label 5846: @283529
     /* 283529 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(283570), // Rule ID 4789 //
     /* 283534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 283546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283557 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 283557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 283560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 283566 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 283568 */     GIR_RootConstrainSelectedInstOperands,
     /* 283569 */     // GIR_Coverage, 4789,
     /* 283569 */     GIR_EraseRootFromParent_Done,
     /* 283570 */   // Label 5847: @283570
     /* 283570 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(283611), // Rule ID 13766 //
     /* 283575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 283587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 283591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283598 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 283598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 283601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 283607 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 283609 */     GIR_RootConstrainSelectedInstOperands,
     /* 283610 */     // GIR_Coverage, 13766,
     /* 283610 */     GIR_EraseRootFromParent_Done,
     /* 283611 */   // Label 5848: @283611
     /* 283611 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(283638), // Rule ID 624 //
     /* 283616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283627 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 283627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 283632 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 283636 */     GIR_RootConstrainSelectedInstOperands,
     /* 283637 */     // GIR_Coverage, 624,
     /* 283637 */     GIR_Done,
     /* 283638 */   // Label 5849: @283638
     /* 283638 */   GIM_Reject,
     /* 283639 */ // Label 5840: @283639
     /* 283639 */ GIM_Reject,
     /* 283640 */ // Label 5811: @283640
     /* 283640 */ GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(284169),
     /* 283645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283655 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(283741), // Rule ID 13367 //
     /* 283660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 283671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 283679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 283683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 283700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283704 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283708 */     // MIs[3] Operand 1
     /* 283708 */     // No operand predicates
     /* 283708 */     // MIs[1] Operand 2
     /* 283708 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 283719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283725 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 283725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 283728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 283732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 283736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 283739 */     GIR_RootConstrainSelectedInstOperands,
     /* 283740 */     // GIR_Coverage, 13367,
     /* 283740 */     GIR_EraseRootFromParent_Done,
     /* 283741 */   // Label 5851: @283741
     /* 283741 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(283827), // Rule ID 1998 //
     /* 283746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 283761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 283769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 283773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 283790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283794 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283798 */     // MIs[3] Operand 1
     /* 283798 */     // No operand predicates
     /* 283798 */     // MIs[1] Operand 2
     /* 283798 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 283809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 283811 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 283811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 283814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 283822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 283825 */     GIR_RootConstrainSelectedInstOperands,
     /* 283826 */     // GIR_Coverage, 1998,
     /* 283826 */     GIR_EraseRootFromParent_Done,
     /* 283827 */   // Label 5852: @283827
     /* 283827 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(283890), // Rule ID 13368 //
     /* 283832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 283843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283864 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283868 */     // MIs[2] Operand 1
     /* 283868 */     // No operand predicates
     /* 283868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283874 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 283874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 283877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 283881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 283885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283888 */     GIR_RootConstrainSelectedInstOperands,
     /* 283889 */     // GIR_Coverage, 13368,
     /* 283889 */     GIR_EraseRootFromParent_Done,
     /* 283890 */   // Label 5853: @283890
     /* 283890 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(283953), // Rule ID 1999 //
     /* 283895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 283906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 283910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283931 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283935 */     // MIs[2] Operand 1
     /* 283935 */     // No operand predicates
     /* 283935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283937 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 283937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 283940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 283948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283951 */     GIR_RootConstrainSelectedInstOperands,
     /* 283952 */     // GIR_Coverage, 1999,
     /* 283952 */     GIR_EraseRootFromParent_Done,
     /* 283953 */   // Label 5854: @283953
     /* 283953 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(284047), // Rule ID 13828 //
     /* 283958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 283966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 283970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283981 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 283981 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 283984 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283988 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 283998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284007 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 284010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284014 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 284017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 284035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284045 */     GIR_RootConstrainSelectedInstOperands,
     /* 284046 */     // GIR_Coverage, 13828,
     /* 284046 */     GIR_EraseRootFromParent_Done,
     /* 284047 */   // Label 5855: @284047
     /* 284047 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(284141), // Rule ID 6198 //
     /* 284052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 284064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284075 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 284075 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 284078 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284082 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 284092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284101 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 284104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284108 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 284111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 284129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284139 */     GIR_RootConstrainSelectedInstOperands,
     /* 284140 */     // GIR_Coverage, 6198,
     /* 284140 */     GIR_EraseRootFromParent_Done,
     /* 284141 */   // Label 5856: @284141
     /* 284141 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(284168), // Rule ID 1316 //
     /* 284146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284157 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 284157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 284162 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284166 */     GIR_RootConstrainSelectedInstOperands,
     /* 284167 */     // GIR_Coverage, 1316,
     /* 284167 */     GIR_Done,
     /* 284168 */   // Label 5857: @284168
     /* 284168 */   GIM_Reject,
     /* 284169 */ // Label 5850: @284169
     /* 284169 */ GIM_Reject,
     /* 284170 */ // Label 5812: @284170
     /* 284170 */ GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(284527),
     /* 284175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284185 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(284248), // Rule ID 13372 //
     /* 284190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 284201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284222 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 284226 */     // MIs[2] Operand 1
     /* 284226 */     // No operand predicates
     /* 284226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284232 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 284232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 284235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284246 */     GIR_RootConstrainSelectedInstOperands,
     /* 284247 */     // GIR_Coverage, 13372,
     /* 284247 */     GIR_EraseRootFromParent_Done,
     /* 284248 */   // Label 5859: @284248
     /* 284248 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(284311), // Rule ID 2003 //
     /* 284253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 284268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284289 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 284293 */     // MIs[2] Operand 1
     /* 284293 */     // No operand predicates
     /* 284293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284295 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 284295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 284298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284309 */     GIR_RootConstrainSelectedInstOperands,
     /* 284310 */     // GIR_Coverage, 2003,
     /* 284310 */     GIR_EraseRootFromParent_Done,
     /* 284311 */   // Label 5860: @284311
     /* 284311 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(284405), // Rule ID 13832 //
     /* 284316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 284324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 284328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284339 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 284339 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 284342 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284346 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 284356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 284368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284372 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 284375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 284393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284403 */     GIR_RootConstrainSelectedInstOperands,
     /* 284404 */     // GIR_Coverage, 13832,
     /* 284404 */     GIR_EraseRootFromParent_Done,
     /* 284405 */   // Label 5861: @284405
     /* 284405 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(284499), // Rule ID 6202 //
     /* 284410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 284422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 284426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284433 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 284433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 284436 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284440 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 284450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284459 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 284462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284466 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 284469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 284487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284497 */     GIR_RootConstrainSelectedInstOperands,
     /* 284498 */     // GIR_Coverage, 6202,
     /* 284498 */     GIR_EraseRootFromParent_Done,
     /* 284499 */   // Label 5862: @284499
     /* 284499 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(284526), // Rule ID 1320 //
     /* 284504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284515 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 284515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 284520 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284524 */     GIR_RootConstrainSelectedInstOperands,
     /* 284525 */     // GIR_Coverage, 1320,
     /* 284525 */     GIR_Done,
     /* 284526 */   // Label 5863: @284526
     /* 284526 */   GIM_Reject,
     /* 284527 */ // Label 5858: @284527
     /* 284527 */ GIM_Reject,
     /* 284528 */ // Label 5813: @284528
     /* 284528 */ GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(284869),
     /* 284533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284543 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(284629), // Rule ID 13361 //
     /* 284548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 284559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 284571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 284584 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284588 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284592 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 284596 */     // MIs[3] Operand 1
     /* 284596 */     // No operand predicates
     /* 284596 */     // MIs[1] Operand 2
     /* 284596 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 284607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284613 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 284613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 284616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284627 */     GIR_RootConstrainSelectedInstOperands,
     /* 284628 */     // GIR_Coverage, 13361,
     /* 284628 */     GIR_EraseRootFromParent_Done,
     /* 284629 */   // Label 5865: @284629
     /* 284629 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(284715), // Rule ID 1992 //
     /* 284634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 284649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 284661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284669 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 284674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284682 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 284686 */     // MIs[3] Operand 1
     /* 284686 */     // No operand predicates
     /* 284686 */     // MIs[1] Operand 2
     /* 284686 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 284697 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284699 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 284699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 284702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 284710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284713 */     GIR_RootConstrainSelectedInstOperands,
     /* 284714 */     // GIR_Coverage, 1992,
     /* 284714 */     GIR_EraseRootFromParent_Done,
     /* 284715 */   // Label 5866: @284715
     /* 284715 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(284778), // Rule ID 13362 //
     /* 284720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 284731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 284744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284752 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 284756 */     // MIs[2] Operand 1
     /* 284756 */     // No operand predicates
     /* 284756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284762 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 284762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 284765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284776 */     GIR_RootConstrainSelectedInstOperands,
     /* 284777 */     // GIR_Coverage, 13362,
     /* 284777 */     GIR_EraseRootFromParent_Done,
     /* 284778 */   // Label 5867: @284778
     /* 284778 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(284841), // Rule ID 1993 //
     /* 284783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 284798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 284811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284819 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 284823 */     // MIs[2] Operand 1
     /* 284823 */     // No operand predicates
     /* 284823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284825 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 284825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 284828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284839 */     GIR_RootConstrainSelectedInstOperands,
     /* 284840 */     // GIR_Coverage, 1993,
     /* 284840 */     GIR_EraseRootFromParent_Done,
     /* 284841 */   // Label 5868: @284841
     /* 284841 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(284868), // Rule ID 1312 //
     /* 284846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284857 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 284857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 284862 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284866 */     GIR_RootConstrainSelectedInstOperands,
     /* 284867 */     // GIR_Coverage, 1312,
     /* 284867 */     GIR_Done,
     /* 284868 */   // Label 5869: @284868
     /* 284868 */   GIM_Reject,
     /* 284869 */ // Label 5864: @284869
     /* 284869 */ GIM_Reject,
     /* 284870 */ // Label 5814: @284870
     /* 284870 */ GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(285227),
     /* 284875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284885 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(284948), // Rule ID 13370 //
     /* 284890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 284901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284922 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284926 */     // MIs[2] Operand 1
     /* 284926 */     // No operand predicates
     /* 284926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284932 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 284932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 284935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 284939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 284943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284946 */     GIR_RootConstrainSelectedInstOperands,
     /* 284947 */     // GIR_Coverage, 13370,
     /* 284947 */     GIR_EraseRootFromParent_Done,
     /* 284948 */   // Label 5871: @284948
     /* 284948 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(285011), // Rule ID 2001 //
     /* 284953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 284964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 284968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 284993 */     // MIs[2] Operand 1
     /* 284993 */     // No operand predicates
     /* 284993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284995 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 284995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 284998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285000 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 285009 */     GIR_RootConstrainSelectedInstOperands,
     /* 285010 */     // GIR_Coverage, 2001,
     /* 285010 */     GIR_EraseRootFromParent_Done,
     /* 285011 */   // Label 5872: @285011
     /* 285011 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(285105), // Rule ID 13830 //
     /* 285016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 285024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285039 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 285039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 285042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 285053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 285056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285065 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 285068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285072 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 285075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 285093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 285097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285103 */     GIR_RootConstrainSelectedInstOperands,
     /* 285104 */     // GIR_Coverage, 13830,
     /* 285104 */     GIR_EraseRootFromParent_Done,
     /* 285105 */   // Label 5873: @285105
     /* 285105 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(285199), // Rule ID 6200 //
     /* 285110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 285122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285133 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 285133 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 285136 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285140 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 285147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 285150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285159 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 285162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285166 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 285169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 285187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285197 */     GIR_RootConstrainSelectedInstOperands,
     /* 285198 */     // GIR_Coverage, 6200,
     /* 285198 */     GIR_EraseRootFromParent_Done,
     /* 285199 */   // Label 5874: @285199
     /* 285199 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(285226), // Rule ID 1318 //
     /* 285204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285215 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 285215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 285220 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285224 */     GIR_RootConstrainSelectedInstOperands,
     /* 285225 */     // GIR_Coverage, 1318,
     /* 285225 */     GIR_Done,
     /* 285226 */   // Label 5875: @285226
     /* 285226 */   GIM_Reject,
     /* 285227 */ // Label 5870: @285227
     /* 285227 */ GIM_Reject,
     /* 285228 */ // Label 5815: @285228
     /* 285228 */ GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(285659),
     /* 285233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285243 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(285306), // Rule ID 13364 //
     /* 285248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 285259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 285272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 285284 */     // MIs[2] Operand 1
     /* 285284 */     // No operand predicates
     /* 285284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285290 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 285290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 285293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 285297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 285304 */     GIR_RootConstrainSelectedInstOperands,
     /* 285305 */     // GIR_Coverage, 13364,
     /* 285305 */     GIR_EraseRootFromParent_Done,
     /* 285306 */   // Label 5877: @285306
     /* 285306 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(285369), // Rule ID 1995 //
     /* 285311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 285326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 285339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285347 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 285351 */     // MIs[2] Operand 1
     /* 285351 */     // No operand predicates
     /* 285351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 285353 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 285353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 285356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 285367 */     GIR_RootConstrainSelectedInstOperands,
     /* 285368 */     // GIR_Coverage, 1995,
     /* 285368 */     GIR_EraseRootFromParent_Done,
     /* 285369 */   // Label 5878: @285369
     /* 285369 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(285396), // Rule ID 1314 //
     /* 285374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285385 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 285385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 285390 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285394 */     GIR_RootConstrainSelectedInstOperands,
     /* 285395 */     // GIR_Coverage, 1314,
     /* 285395 */     GIR_Done,
     /* 285396 */   // Label 5879: @285396
     /* 285396 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(285658), // Rule ID 6963 //
     /* 285401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 285404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285412 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 285412 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 285415 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 285419 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285424 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 285428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 285430 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 285433 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 285437 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285442 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 285446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 285448 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 285451 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 285455 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285460 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 285463 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 285466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 285468 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 285471 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285475 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285480 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285486 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285491 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285496 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 285499 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 285503 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285508 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 285511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 285513 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 285516 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285520 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285525 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285531 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285536 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285541 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 285544 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 285548 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285553 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 285556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 285558 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 285561 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 285565 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285570 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 285573 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 285576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285578 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 285581 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 285585 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285590 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 285593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285595 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 285598 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285602 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 285609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 285612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285621 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 285624 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 285627 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 285630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 285648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 285656 */     GIR_RootConstrainSelectedInstOperands,
     /* 285657 */     // GIR_Coverage, 6963,
     /* 285657 */     GIR_EraseRootFromParent_Done,
     /* 285658 */   // Label 5880: @285658
     /* 285658 */   GIM_Reject,
     /* 285659 */ // Label 5876: @285659
     /* 285659 */ GIM_Reject,
     /* 285660 */ // Label 5816: @285660
     /* 285660 */ GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(285685), // Rule ID 8135 //
     /* 285665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 285671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 285674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285678 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 285678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 285683 */   GIR_RootConstrainSelectedInstOperands,
     /* 285684 */   // GIR_Coverage, 8135,
     /* 285684 */   GIR_Done,
     /* 285685 */ // Label 5881: @285685
     /* 285685 */ GIM_Reject,
     /* 285686 */ // Label 5817: @285686
     /* 285686 */ GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(285711), // Rule ID 8133 //
     /* 285691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 285697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 285700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285704 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 285704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 285709 */   GIR_RootConstrainSelectedInstOperands,
     /* 285710 */   // GIR_Coverage, 8133,
     /* 285710 */   GIR_Done,
     /* 285711 */ // Label 5882: @285711
     /* 285711 */ GIM_Reject,
     /* 285712 */ // Label 5818: @285712
     /* 285712 */ GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(285737), // Rule ID 8131 //
     /* 285717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 285723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 285726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285730 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 285730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 285735 */   GIR_RootConstrainSelectedInstOperands,
     /* 285736 */   // GIR_Coverage, 8131,
     /* 285736 */   GIR_Done,
     /* 285737 */ // Label 5883: @285737
     /* 285737 */ GIM_Reject,
     /* 285738 */ // Label 5819: @285738
     /* 285738 */ GIM_Reject,
     /* 285739 */ // Label 60: @285739
     /* 285739 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5892*/ GIMT_Encode4(302011),
     /* 285750 */ /*GILLT_s16*//*Label 5884*/ GIMT_Encode4(285790),
     /* 285754 */ /*GILLT_s32*//*Label 5885*/ GIMT_Encode4(288794),
     /* 285758 */ /*GILLT_s64*//*Label 5886*/ GIMT_Encode4(291942), GIMT_Encode4(0),
     /* 285766 */ /*GILLT_v2s32*//*Label 5887*/ GIMT_Encode4(295090),
     /* 285770 */ /*GILLT_v2s64*//*Label 5888*/ GIMT_Encode4(296611),
     /* 285774 */ /*GILLT_v4s16*//*Label 5889*/ GIMT_Encode4(298132),
     /* 285778 */ /*GILLT_v4s32*//*Label 5890*/ GIMT_Encode4(299311), GIMT_Encode4(0),
     /* 285786 */ /*GILLT_v8s16*//*Label 5891*/ GIMT_Encode4(300832),
     /* 285790 */ // Label 5884: @285790
     /* 285790 */ GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(288793),
     /* 285795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 285798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 285801 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 285804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285808 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(285958), // Rule ID 4844 //
     /* 285813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 285816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285837 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285853 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285862 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 285866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 285870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285874 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 285878 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285885 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 285885 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 285888 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285892 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285897 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 285903 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285908 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 285916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285925 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 285931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 285944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 285956 */     GIR_RootConstrainSelectedInstOperands,
     /* 285957 */     // GIR_Coverage, 4844,
     /* 285957 */     GIR_EraseRootFromParent_Done,
     /* 285958 */   // Label 5894: @285958
     /* 285958 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(286105), // Rule ID 4808 //
     /* 285963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 285966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285987 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 285999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 286003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286011 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286015 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286019 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286024 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 286028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286034 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 286034 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 286037 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286041 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286046 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 286052 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286074 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 286080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 286093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 286101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286103 */     GIR_RootConstrainSelectedInstOperands,
     /* 286104 */     // GIR_Coverage, 4808,
     /* 286104 */     GIR_EraseRootFromParent_Done,
     /* 286105 */   // Label 5895: @286105
     /* 286105 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(286252), // Rule ID 13772 //
     /* 286110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 286125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 286129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286146 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286158 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286162 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286166 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286171 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 286175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286179 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286181 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 286181 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 286184 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286188 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286193 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 286199 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286204 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286221 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 286227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 286240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 286248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286250 */     GIR_RootConstrainSelectedInstOperands,
     /* 286251 */     // GIR_Coverage, 13772,
     /* 286251 */     GIR_EraseRootFromParent_Done,
     /* 286252 */   // Label 5896: @286252
     /* 286252 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(286383), // Rule ID 6030 //
     /* 286257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286281 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 286297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286305 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286309 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286313 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 286318 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 286322 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286326 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286330 */     // MIs[4] Operand 1
     /* 286330 */     // No operand predicates
     /* 286330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286334 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 286336 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 286336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286348 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 286354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 286367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 286378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 286381 */     GIR_RootConstrainSelectedInstOperands,
     /* 286382 */     // GIR_Coverage, 6030,
     /* 286382 */     GIR_EraseRootFromParent_Done,
     /* 286383 */   // Label 5897: @286383
     /* 286383 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(286514), // Rule ID 6062 //
     /* 286388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 286412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286420 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286424 */     // MIs[2] Operand 1
     /* 286424 */     // No operand predicates
     /* 286424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286432 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 286436 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 286440 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286444 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286448 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 286452 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286457 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 286461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286465 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 286467 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 286467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286479 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 286485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 286498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286512 */     GIR_RootConstrainSelectedInstOperands,
     /* 286513 */     // GIR_Coverage, 6062,
     /* 286513 */     GIR_EraseRootFromParent_Done,
     /* 286514 */   // Label 5898: @286514
     /* 286514 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(286645), // Rule ID 6126 //
     /* 286519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 286534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 286538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286555 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286567 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286571 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286575 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 286580 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 286584 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286588 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286592 */     // MIs[4] Operand 1
     /* 286592 */     // No operand predicates
     /* 286592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286596 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 286598 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 286598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286610 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 286616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286621 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 286629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 286640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 286643 */     GIR_RootConstrainSelectedInstOperands,
     /* 286644 */     // GIR_Coverage, 6126,
     /* 286644 */     GIR_EraseRootFromParent_Done,
     /* 286645 */   // Label 5899: @286645
     /* 286645 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(286776), // Rule ID 6094 //
     /* 286650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 286665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 286669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 286686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286694 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286698 */     // MIs[3] Operand 1
     /* 286698 */     // No operand predicates
     /* 286698 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 286702 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286706 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286710 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 286714 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286719 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 286723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286727 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 286729 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 286729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286741 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 286747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286752 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 286760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 286764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286774 */     GIR_RootConstrainSelectedInstOperands,
     /* 286775 */     // GIR_Coverage, 6094,
     /* 286775 */     GIR_EraseRootFromParent_Done,
     /* 286776 */   // Label 5900: @286776
     /* 286776 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(286911), // Rule ID 2447 //
     /* 286781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286805 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286821 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286830 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 286834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286840 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 286840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 286843 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286847 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286852 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 286858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286863 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286880 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 286886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 286899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 286907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 286909 */     GIR_RootConstrainSelectedInstOperands,
     /* 286910 */     // GIR_Coverage, 2447,
     /* 286910 */     GIR_EraseRootFromParent_Done,
     /* 286911 */   // Label 5901: @286911
     /* 286911 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(287030), // Rule ID 5998 //
     /* 286916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286940 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 286965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286973 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286977 */     // MIs[3] Operand 1
     /* 286977 */     // No operand predicates
     /* 286977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286983 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 286983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286995 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 287001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 287014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287028 */     GIR_RootConstrainSelectedInstOperands,
     /* 287029 */     // GIR_Coverage, 5998,
     /* 287029 */     GIR_EraseRootFromParent_Done,
     /* 287030 */   // Label 5902: @287030
     /* 287030 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(287149), // Rule ID 2529 //
     /* 287035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 287038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 287059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287067 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 287071 */     // MIs[2] Operand 1
     /* 287071 */     // No operand predicates
     /* 287071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 287075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287079 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287083 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 287087 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287092 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 287096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287102 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 287102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 287105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287114 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 287120 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 287133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287147 */     GIR_RootConstrainSelectedInstOperands,
     /* 287148 */     // GIR_Coverage, 2529,
     /* 287148 */     GIR_EraseRootFromParent_Done,
     /* 287149 */   // Label 5903: @287149
     /* 287149 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(287249), // Rule ID 4806 //
     /* 287154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287178 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 287194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287205 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 287205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 287208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287217 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 287223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 287236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287247 */     GIR_RootConstrainSelectedInstOperands,
     /* 287248 */     // GIR_Coverage, 4806,
     /* 287248 */     GIR_EraseRootFromParent_Done,
     /* 287249 */   // Label 5904: @287249
     /* 287249 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(287349), // Rule ID 4842 //
     /* 287254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287278 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 287290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 287298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287305 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 287305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 287308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287317 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 287323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 287336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 287343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 287347 */     GIR_RootConstrainSelectedInstOperands,
     /* 287348 */     // GIR_Coverage, 4842,
     /* 287348 */     GIR_EraseRootFromParent_Done,
     /* 287349 */   // Label 5905: @287349
     /* 287349 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(287446), // Rule ID 13768 //
     /* 287354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 287369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287390 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 287394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287404 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 287404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 287407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287416 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 287422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 287435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287444 */     GIR_RootConstrainSelectedInstOperands,
     /* 287445 */     // GIR_Coverage, 13768,
     /* 287445 */     GIR_EraseRootFromParent_Done,
     /* 287446 */   // Label 5906: @287446
     /* 287446 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(287546), // Rule ID 13770 //
     /* 287451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 287466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287492 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 287496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287502 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 287502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 287505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287514 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 287520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 287533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287544 */     GIR_RootConstrainSelectedInstOperands,
     /* 287545 */     // GIR_Coverage, 13770,
     /* 287545 */     GIR_EraseRootFromParent_Done,
     /* 287546 */   // Label 5907: @287546
     /* 287546 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(287646), // Rule ID 4840 //
     /* 287551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287579 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 287587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 287595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287602 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 287602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 287605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287614 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 287620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 287633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 287644 */     GIR_RootConstrainSelectedInstOperands,
     /* 287645 */     // GIR_Coverage, 4840,
     /* 287645 */     GIR_EraseRootFromParent_Done,
     /* 287646 */   // Label 5908: @287646
     /* 287646 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(287743), // Rule ID 4804 //
     /* 287651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 287654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 287670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287691 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 287695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287701 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 287701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 287704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287713 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 287719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 287732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 287741 */     GIR_RootConstrainSelectedInstOperands,
     /* 287742 */     // GIR_Coverage, 4804,
     /* 287742 */     GIR_EraseRootFromParent_Done,
     /* 287743 */   // Label 5909: @287743
     /* 287743 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(287827), // Rule ID 6060 //
     /* 287748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 287751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 287772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287780 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 287784 */     // MIs[2] Operand 1
     /* 287784 */     // No operand predicates
     /* 287784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 287788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287792 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 287796 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287807 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 287807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 287810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 287818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287825 */     GIR_RootConstrainSelectedInstOperands,
     /* 287826 */     // GIR_Coverage, 6060,
     /* 287826 */     GIR_EraseRootFromParent_Done,
     /* 287827 */   // Label 5910: @287827
     /* 287827 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(287908), // Rule ID 6092 //
     /* 287832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 287835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 287847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 287868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287876 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 287880 */     // MIs[3] Operand 1
     /* 287880 */     // No operand predicates
     /* 287880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287890 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 287890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 287893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287906 */     GIR_RootConstrainSelectedInstOperands,
     /* 287907 */     // GIR_Coverage, 6092,
     /* 287907 */     GIR_EraseRootFromParent_Done,
     /* 287908 */   // Label 5911: @287908
     /* 287908 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(287992), // Rule ID 6124 //
     /* 287913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 287916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 287928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 287945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 287954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287962 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 287966 */     // MIs[3] Operand 1
     /* 287966 */     // No operand predicates
     /* 287966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287972 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 287972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 287975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 287979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287990 */     GIR_RootConstrainSelectedInstOperands,
     /* 287991 */     // GIR_Coverage, 6124,
     /* 287991 */     GIR_EraseRootFromParent_Done,
     /* 287992 */   // Label 5912: @287992
     /* 287992 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(288073), // Rule ID 6028 //
     /* 287997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 288016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288045 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288049 */     // MIs[3] Operand 1
     /* 288049 */     // No operand predicates
     /* 288049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288055 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 288055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 288058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288071 */     GIR_RootConstrainSelectedInstOperands,
     /* 288072 */     // GIR_Coverage, 6028,
     /* 288072 */     GIR_EraseRootFromParent_Done,
     /* 288073 */   // Label 5913: @288073
     /* 288073 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(288158), // Rule ID 2445 //
     /* 288078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 288081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288102 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288116 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 288116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 288119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288128 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 288134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 288147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288156 */     GIR_RootConstrainSelectedInstOperands,
     /* 288157 */     // GIR_Coverage, 2445,
     /* 288157 */     GIR_EraseRootFromParent_Done,
     /* 288158 */   // Label 5914: @288158
     /* 288158 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(288243), // Rule ID 2443 //
     /* 288163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 288166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288191 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288201 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 288201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 288204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288213 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 288219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 288232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288241 */     GIR_RootConstrainSelectedInstOperands,
     /* 288242 */     // GIR_Coverage, 2443,
     /* 288242 */     GIR_EraseRootFromParent_Done,
     /* 288243 */   // Label 5915: @288243
     /* 288243 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(288312), // Rule ID 2527 //
     /* 288248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288284 */     // MIs[2] Operand 1
     /* 288284 */     // No operand predicates
     /* 288284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288294 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 288294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 288297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288310 */     GIR_RootConstrainSelectedInstOperands,
     /* 288311 */     // GIR_Coverage, 2527,
     /* 288311 */     GIR_EraseRootFromParent_Done,
     /* 288312 */   // Label 5916: @288312
     /* 288312 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(288381), // Rule ID 5996 //
     /* 288317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288353 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288357 */     // MIs[2] Operand 1
     /* 288357 */     // No operand predicates
     /* 288357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288363 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 288363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 288366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 288368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 288370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288379 */     GIR_RootConstrainSelectedInstOperands,
     /* 288380 */     // GIR_Coverage, 5996,
     /* 288380 */     GIR_EraseRootFromParent_Done,
     /* 288381 */   // Label 5917: @288381
     /* 288381 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(288446), // Rule ID 4860 //
     /* 288386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 288401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 288414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 288422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288429 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 288429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 288432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 288444 */     GIR_RootConstrainSelectedInstOperands,
     /* 288445 */     // GIR_Coverage, 4860,
     /* 288445 */     GIR_EraseRootFromParent_Done,
     /* 288446 */   // Label 5918: @288446
     /* 288446 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(288511), // Rule ID 13788 //
     /* 288451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 288470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 288479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 288487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288494 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 288494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 288497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 288505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 288509 */     GIR_RootConstrainSelectedInstOperands,
     /* 288510 */     // GIR_Coverage, 13788,
     /* 288510 */     GIR_EraseRootFromParent_Done,
     /* 288511 */   // Label 5919: @288511
     /* 288511 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(288561), // Rule ID 4857 //
     /* 288516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 288531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288546 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 288546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 288549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288559 */     GIR_RootConstrainSelectedInstOperands,
     /* 288560 */     // GIR_Coverage, 4857,
     /* 288560 */     GIR_EraseRootFromParent_Done,
     /* 288561 */   // Label 5920: @288561
     /* 288561 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(288611), // Rule ID 13214 //
     /* 288566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 288569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 288581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288596 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 288596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 288599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288609 */     GIR_RootConstrainSelectedInstOperands,
     /* 288610 */     // GIR_Coverage, 13214,
     /* 288610 */     GIR_EraseRootFromParent_Done,
     /* 288611 */   // Label 5921: @288611
     /* 288611 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(288661), // Rule ID 644 //
     /* 288616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 288619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 288635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288646 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 288646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 288649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288659 */     GIR_RootConstrainSelectedInstOperands,
     /* 288660 */     // GIR_Coverage, 644,
     /* 288660 */     GIR_EraseRootFromParent_Done,
     /* 288661 */   // Label 5922: @288661
     /* 288661 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(288711), // Rule ID 13785 //
     /* 288666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 288685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288696 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 288696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 288699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 288707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 288709 */     GIR_RootConstrainSelectedInstOperands,
     /* 288710 */     // GIR_Coverage, 13785,
     /* 288710 */     GIR_EraseRootFromParent_Done,
     /* 288711 */   // Label 5923: @288711
     /* 288711 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(288761), // Rule ID 656 //
     /* 288716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 288719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 288739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288746 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 288746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 288749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 288755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 288759 */     GIR_RootConstrainSelectedInstOperands,
     /* 288760 */     // GIR_Coverage, 656,
     /* 288760 */     GIR_EraseRootFromParent_Done,
     /* 288761 */   // Label 5924: @288761
     /* 288761 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(288792), // Rule ID 638 //
     /* 288766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 288769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 288781 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 288781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 288786 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288790 */     GIR_RootConstrainSelectedInstOperands,
     /* 288791 */     // GIR_Coverage, 638,
     /* 288791 */     GIR_Done,
     /* 288792 */   // Label 5925: @288792
     /* 288792 */   GIM_Reject,
     /* 288793 */ // Label 5893: @288793
     /* 288793 */ GIM_Reject,
     /* 288794 */ // Label 5885: @288794
     /* 288794 */ GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(291941),
     /* 288799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 288802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 288805 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 288808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288812 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(288962), // Rule ID 4850 //
     /* 288817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288841 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288866 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 288870 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 288874 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288878 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 288882 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288887 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288889 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 288889 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 288892 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288896 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288901 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 288907 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288912 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 288920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288929 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 288935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 288948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 288956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 288960 */     GIR_RootConstrainSelectedInstOperands,
     /* 288961 */     // GIR_Coverage, 4850,
     /* 288961 */     GIR_EraseRootFromParent_Done,
     /* 288962 */   // Label 5927: @288962
     /* 288962 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(289109), // Rule ID 4814 //
     /* 288967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 288978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288991 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 288995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 289011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289015 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289019 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 289023 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289028 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 289032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289038 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 289038 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 289041 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289045 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289050 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 289056 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289078 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 289084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 289097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 289105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 289107 */     GIR_RootConstrainSelectedInstOperands,
     /* 289108 */     // GIR_Coverage, 4814,
     /* 289108 */     GIR_EraseRootFromParent_Done,
     /* 289109 */   // Label 5928: @289109
     /* 289109 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(289256), // Rule ID 13778 //
     /* 289114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 289117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289150 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 289154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 289158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289162 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289166 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 289170 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289175 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 289179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289185 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 289185 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 289188 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289192 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289197 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 289203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289225 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 289231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 289244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 289252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 289254 */     GIR_RootConstrainSelectedInstOperands,
     /* 289255 */     // GIR_Coverage, 13778,
     /* 289255 */     GIR_EraseRootFromParent_Done,
     /* 289256 */   // Label 5929: @289256
     /* 289256 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(289387), // Rule ID 6046 //
     /* 289261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289285 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 289301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 289305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289309 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289313 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 289317 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 289326 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289330 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289334 */     // MIs[4] Operand 1
     /* 289334 */     // No operand predicates
     /* 289334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289338 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 289340 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289352 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 289358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 289371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 289382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 289385 */     GIR_RootConstrainSelectedInstOperands,
     /* 289386 */     // GIR_Coverage, 6046,
     /* 289386 */     GIR_EraseRootFromParent_Done,
     /* 289387 */   // Label 5930: @289387
     /* 289387 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(289518), // Rule ID 6078 //
     /* 289392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289424 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289428 */     // MIs[2] Operand 1
     /* 289428 */     // No operand predicates
     /* 289428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 289432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289436 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 289440 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 289444 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289448 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289452 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 289456 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289461 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 289465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289469 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 289471 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289483 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 289489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 289502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289516 */     GIR_RootConstrainSelectedInstOperands,
     /* 289517 */     // GIR_Coverage, 6078,
     /* 289517 */     GIR_EraseRootFromParent_Done,
     /* 289518 */   // Label 5931: @289518
     /* 289518 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(289649), // Rule ID 6142 //
     /* 289523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289550 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289559 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 289563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 289567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289571 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289575 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 289579 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289584 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 289588 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289592 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289596 */     // MIs[4] Operand 1
     /* 289596 */     // No operand predicates
     /* 289596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289600 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 289602 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289614 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 289620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 289633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 289644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 289647 */     GIR_RootConstrainSelectedInstOperands,
     /* 289648 */     // GIR_Coverage, 6142,
     /* 289648 */     GIR_EraseRootFromParent_Done,
     /* 289649 */   // Label 5932: @289649
     /* 289649 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(289780), // Rule ID 6110 //
     /* 289654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289681 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 289694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289698 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289702 */     // MIs[3] Operand 1
     /* 289702 */     // No operand predicates
     /* 289702 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 289706 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289710 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289714 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 289718 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289723 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 289727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289731 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 289733 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289745 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 289751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 289764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 289768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289778 */     GIR_RootConstrainSelectedInstOperands,
     /* 289779 */     // GIR_Coverage, 6110,
     /* 289779 */     GIR_EraseRootFromParent_Done,
     /* 289780 */   // Label 5933: @289780
     /* 289780 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(289915), // Rule ID 2453 //
     /* 289785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 289788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289809 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289834 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 289838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289844 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 289844 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 289847 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289851 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289856 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 289862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289884 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 289890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 289903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 289911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 289913 */     GIR_RootConstrainSelectedInstOperands,
     /* 289914 */     // GIR_Coverage, 2453,
     /* 289914 */     GIR_EraseRootFromParent_Done,
     /* 289915 */   // Label 5934: @289915
     /* 289915 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(290034), // Rule ID 6014 //
     /* 289920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289944 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289960 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 289973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289977 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289981 */     // MIs[3] Operand 1
     /* 289981 */     // No operand predicates
     /* 289981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289985 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289987 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 289987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289999 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 290005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 290018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290032 */     GIR_RootConstrainSelectedInstOperands,
     /* 290033 */     // GIR_Coverage, 6014,
     /* 290033 */     GIR_EraseRootFromParent_Done,
     /* 290034 */   // Label 5935: @290034
     /* 290034 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(290153), // Rule ID 2545 //
     /* 290039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290071 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290075 */     // MIs[2] Operand 1
     /* 290075 */     // No operand predicates
     /* 290075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290083 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290087 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 290091 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290096 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 290100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290106 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 290109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290118 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 290124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 290137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290151 */     GIR_RootConstrainSelectedInstOperands,
     /* 290152 */     // GIR_Coverage, 2545,
     /* 290152 */     GIR_EraseRootFromParent_Done,
     /* 290153 */   // Label 5936: @290153
     /* 290153 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(290253), // Rule ID 4812 //
     /* 290158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 290161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290182 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 290198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290209 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 290209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 290212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290221 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 290227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 290240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290251 */     GIR_RootConstrainSelectedInstOperands,
     /* 290252 */     // GIR_Coverage, 4812,
     /* 290252 */     GIR_EraseRootFromParent_Done,
     /* 290253 */   // Label 5937: @290253
     /* 290253 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(290353), // Rule ID 4848 //
     /* 290258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 290261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290282 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 290294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 290302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290309 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 290309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 290312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290321 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 290327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 290340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 290347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 290351 */     GIR_RootConstrainSelectedInstOperands,
     /* 290352 */     // GIR_Coverage, 4848,
     /* 290352 */     GIR_EraseRootFromParent_Done,
     /* 290353 */   // Label 5938: @290353
     /* 290353 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(290450), // Rule ID 13774 //
     /* 290358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 290361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290394 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290408 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 290408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 290411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290420 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 290426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 290439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290448 */     GIR_RootConstrainSelectedInstOperands,
     /* 290449 */     // GIR_Coverage, 13774,
     /* 290449 */     GIR_EraseRootFromParent_Done,
     /* 290450 */   // Label 5939: @290450
     /* 290450 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(290550), // Rule ID 13776 //
     /* 290455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 290458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290496 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290506 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 290506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 290509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290518 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 290524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 290537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290548 */     GIR_RootConstrainSelectedInstOperands,
     /* 290549 */     // GIR_Coverage, 13776,
     /* 290549 */     GIR_EraseRootFromParent_Done,
     /* 290550 */   // Label 5940: @290550
     /* 290550 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(290650), // Rule ID 4846 //
     /* 290555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 290558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290583 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 290591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 290599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290606 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 290606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 290609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290618 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 290624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 290637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 290648 */     GIR_RootConstrainSelectedInstOperands,
     /* 290649 */     // GIR_Coverage, 4846,
     /* 290649 */     GIR_EraseRootFromParent_Done,
     /* 290650 */   // Label 5941: @290650
     /* 290650 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(290747), // Rule ID 4810 //
     /* 290655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 290658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290695 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290705 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 290705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 290708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290717 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 290723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 290736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290745 */     GIR_RootConstrainSelectedInstOperands,
     /* 290746 */     // GIR_Coverage, 4810,
     /* 290746 */     GIR_EraseRootFromParent_Done,
     /* 290747 */   // Label 5942: @290747
     /* 290747 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(290825), // Rule ID 6164 //
     /* 290752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 290789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290793 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290797 */     // MIs[3] Operand 1
     /* 290797 */     // No operand predicates
     /* 290797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290807 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 290810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290823 */     GIR_RootConstrainSelectedInstOperands,
     /* 290824 */     // GIR_Coverage, 6164,
     /* 290824 */     GIR_EraseRootFromParent_Done,
     /* 290825 */   // Label 5943: @290825
     /* 290825 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(290909), // Rule ID 6076 //
     /* 290830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290862 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290866 */     // MIs[2] Operand 1
     /* 290866 */     // No operand predicates
     /* 290866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290870 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290874 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 290878 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290887 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290889 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 290892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 290900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290907 */     GIR_RootConstrainSelectedInstOperands,
     /* 290908 */     // GIR_Coverage, 6076,
     /* 290908 */     GIR_EraseRootFromParent_Done,
     /* 290909 */   // Label 5944: @290909
     /* 290909 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(290990), // Rule ID 6108 //
     /* 290914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 290941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290958 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 290962 */     // MIs[3] Operand 1
     /* 290962 */     // No operand predicates
     /* 290962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 290970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290972 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 290972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 290975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290988 */     GIR_RootConstrainSelectedInstOperands,
     /* 290989 */     // GIR_Coverage, 6108,
     /* 290989 */     GIR_EraseRootFromParent_Done,
     /* 290990 */   // Label 5945: @290990
     /* 290990 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(291074), // Rule ID 6140 //
     /* 290995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291044 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291048 */     // MIs[3] Operand 1
     /* 291048 */     // No operand predicates
     /* 291048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291052 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291054 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 291054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 291057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 291065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291072 */     GIR_RootConstrainSelectedInstOperands,
     /* 291073 */     // GIR_Coverage, 6140,
     /* 291073 */     GIR_EraseRootFromParent_Done,
     /* 291074 */   // Label 5946: @291074
     /* 291074 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(291152), // Rule ID 6186 //
     /* 291079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 291120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291124 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291128 */     // MIs[3] Operand 1
     /* 291128 */     // No operand predicates
     /* 291128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291134 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 291134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 291137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291150 */     GIR_RootConstrainSelectedInstOperands,
     /* 291151 */     // GIR_Coverage, 6186,
     /* 291151 */     GIR_EraseRootFromParent_Done,
     /* 291152 */   // Label 5947: @291152
     /* 291152 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(291233), // Rule ID 6044 //
     /* 291157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291205 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291209 */     // MIs[3] Operand 1
     /* 291209 */     // No operand predicates
     /* 291209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291215 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 291215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 291218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291231 */     GIR_RootConstrainSelectedInstOperands,
     /* 291232 */     // GIR_Coverage, 6044,
     /* 291232 */     GIR_EraseRootFromParent_Done,
     /* 291233 */   // Label 5948: @291233
     /* 291233 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(291318), // Rule ID 2451 //
     /* 291238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 291241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291262 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291276 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 291276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 291279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291288 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 291294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 291307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 291314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291316 */     GIR_RootConstrainSelectedInstOperands,
     /* 291317 */     // GIR_Coverage, 2451,
     /* 291317 */     GIR_EraseRootFromParent_Done,
     /* 291318 */   // Label 5949: @291318
     /* 291318 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(291403), // Rule ID 2449 //
     /* 291323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 291326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291351 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291361 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 291361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 291364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291373 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 291379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 291392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291401 */     GIR_RootConstrainSelectedInstOperands,
     /* 291402 */     // GIR_Coverage, 2449,
     /* 291402 */     GIR_EraseRootFromParent_Done,
     /* 291403 */   // Label 5950: @291403
     /* 291403 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(291472), // Rule ID 2543 //
     /* 291408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291440 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291444 */     // MIs[2] Operand 1
     /* 291444 */     // No operand predicates
     /* 291444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291454 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 291454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 291457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291470 */     GIR_RootConstrainSelectedInstOperands,
     /* 291471 */     // GIR_Coverage, 2543,
     /* 291471 */     GIR_EraseRootFromParent_Done,
     /* 291472 */   // Label 5951: @291472
     /* 291472 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(291541), // Rule ID 6012 //
     /* 291477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 291496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291513 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 291517 */     // MIs[2] Operand 1
     /* 291517 */     // No operand predicates
     /* 291517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291523 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 291523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 291526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291539 */     GIR_RootConstrainSelectedInstOperands,
     /* 291540 */     // GIR_Coverage, 6012,
     /* 291540 */     GIR_EraseRootFromParent_Done,
     /* 291541 */   // Label 5952: @291541
     /* 291541 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(291603), // Rule ID 4861 //
     /* 291546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 291571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 291579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291586 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 291586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 291589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 291595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 291597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 291601 */     GIR_RootConstrainSelectedInstOperands,
     /* 291602 */     // GIR_Coverage, 4861,
     /* 291602 */     GIR_EraseRootFromParent_Done,
     /* 291603 */   // Label 5953: @291603
     /* 291603 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(291665), // Rule ID 13789 //
     /* 291608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 291633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 291641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291648 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 291648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 291651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 291657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 291659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 291663 */     GIR_RootConstrainSelectedInstOperands,
     /* 291664 */     // GIR_Coverage, 13789,
     /* 291664 */     GIR_EraseRootFromParent_Done,
     /* 291665 */   // Label 5954: @291665
     /* 291665 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(291712), // Rule ID 4858 //
     /* 291670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291697 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 291697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 291700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 291706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 291708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291710 */     GIR_RootConstrainSelectedInstOperands,
     /* 291711 */     // GIR_Coverage, 4858,
     /* 291711 */     GIR_EraseRootFromParent_Done,
     /* 291712 */   // Label 5955: @291712
     /* 291712 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(291762), // Rule ID 13216 //
     /* 291717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 291720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291747 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 291747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 291750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291760 */     GIR_RootConstrainSelectedInstOperands,
     /* 291761 */     // GIR_Coverage, 13216,
     /* 291761 */     GIR_EraseRootFromParent_Done,
     /* 291762 */   // Label 5956: @291762
     /* 291762 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(291812), // Rule ID 646 //
     /* 291767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 291770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291797 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 291797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 291800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291810 */     GIR_RootConstrainSelectedInstOperands,
     /* 291811 */     // GIR_Coverage, 646,
     /* 291811 */     GIR_EraseRootFromParent_Done,
     /* 291812 */   // Label 5957: @291812
     /* 291812 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(291859), // Rule ID 13786 //
     /* 291817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291844 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 291844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 291847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 291853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 291855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291857 */     GIR_RootConstrainSelectedInstOperands,
     /* 291858 */     // GIR_Coverage, 13786,
     /* 291858 */     GIR_EraseRootFromParent_Done,
     /* 291859 */   // Label 5958: @291859
     /* 291859 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(291909), // Rule ID 658 //
     /* 291864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 291867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 291887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291894 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 291894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 291897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 291903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 291907 */     GIR_RootConstrainSelectedInstOperands,
     /* 291908 */     // GIR_Coverage, 658,
     /* 291908 */     GIR_EraseRootFromParent_Done,
     /* 291909 */   // Label 5959: @291909
     /* 291909 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(291940), // Rule ID 640 //
     /* 291914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 291917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 291929 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 291929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 291934 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 291938 */     GIR_RootConstrainSelectedInstOperands,
     /* 291939 */     // GIR_Coverage, 640,
     /* 291939 */     GIR_Done,
     /* 291940 */   // Label 5960: @291940
     /* 291940 */   GIM_Reject,
     /* 291941 */ // Label 5926: @291941
     /* 291941 */ GIM_Reject,
     /* 291942 */ // Label 5886: @291942
     /* 291942 */ GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(295089),
     /* 291947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 291950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 291953 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 291956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291960 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(292110), // Rule ID 4856 //
     /* 291965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 291968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 291980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291989 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292014 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 292022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292026 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 292030 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292035 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292037 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 292037 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 292040 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292044 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292049 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 292055 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292060 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 292068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292077 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 292083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 292096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 292104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 292108 */     GIR_RootConstrainSelectedInstOperands,
     /* 292109 */     // GIR_Coverage, 4856,
     /* 292109 */     GIR_EraseRootFromParent_Done,
     /* 292110 */   // Label 5962: @292110
     /* 292110 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(292257), // Rule ID 4820 //
     /* 292115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 292118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292139 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 292155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 292159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292163 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292167 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 292171 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292176 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 292180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292184 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292186 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 292186 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 292189 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292193 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292198 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 292204 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 292217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292226 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 292232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 292245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 292253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292255 */     GIR_RootConstrainSelectedInstOperands,
     /* 292256 */     // GIR_Coverage, 4820,
     /* 292256 */     GIR_EraseRootFromParent_Done,
     /* 292257 */   // Label 5963: @292257
     /* 292257 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(292404), // Rule ID 13784 //
     /* 292262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 292265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 292277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292298 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 292306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292310 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292314 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 292318 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292323 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 292327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292333 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 292333 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 292336 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292340 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292345 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 292351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 292364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292373 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 292379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 292392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 292400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292402 */     GIR_RootConstrainSelectedInstOperands,
     /* 292403 */     // GIR_Coverage, 13784,
     /* 292403 */     GIR_EraseRootFromParent_Done,
     /* 292404 */   // Label 5964: @292404
     /* 292404 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(292535), // Rule ID 6050 //
     /* 292409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292433 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 292449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 292453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292457 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292461 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 292465 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292470 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 292474 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292478 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 292482 */     // MIs[4] Operand 1
     /* 292482 */     // No operand predicates
     /* 292482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292486 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 292488 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 292488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 292491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292500 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 292506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 292519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 292530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 292533 */     GIR_RootConstrainSelectedInstOperands,
     /* 292534 */     // GIR_Coverage, 6050,
     /* 292534 */     GIR_EraseRootFromParent_Done,
     /* 292535 */   // Label 5965: @292535
     /* 292535 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(292666), // Rule ID 6082 //
     /* 292540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292572 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 292576 */     // MIs[2] Operand 1
     /* 292576 */     // No operand predicates
     /* 292576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 292580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292584 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 292588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 292592 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292596 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292600 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 292604 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292609 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 292613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292617 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 292619 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 292619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 292622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292631 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 292637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 292650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292664 */     GIR_RootConstrainSelectedInstOperands,
     /* 292665 */     // GIR_Coverage, 6082,
     /* 292665 */     GIR_EraseRootFromParent_Done,
     /* 292666 */   // Label 5966: @292666
     /* 292666 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(292797), // Rule ID 6146 //
     /* 292671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 292686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292707 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 292715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292719 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292723 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 292727 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 292736 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292740 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 292744 */     // MIs[4] Operand 1
     /* 292744 */     // No operand predicates
     /* 292744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292748 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 292750 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 292750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 292753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292762 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 292768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 292781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 292792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 292795 */     GIR_RootConstrainSelectedInstOperands,
     /* 292796 */     // GIR_Coverage, 6146,
     /* 292796 */     GIR_EraseRootFromParent_Done,
     /* 292797 */   // Label 5967: @292797
     /* 292797 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(292928), // Rule ID 6114 //
     /* 292802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 292817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292846 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 292850 */     // MIs[3] Operand 1
     /* 292850 */     // No operand predicates
     /* 292850 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 292854 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292858 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292862 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 292866 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292871 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 292875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292879 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 292881 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 292881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 292884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292893 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 292899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 292912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292926 */     GIR_RootConstrainSelectedInstOperands,
     /* 292927 */     // GIR_Coverage, 6114,
     /* 292927 */     GIR_EraseRootFromParent_Done,
     /* 292928 */   // Label 5968: @292928
     /* 292928 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(293063), // Rule ID 2459 //
     /* 292933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 292936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292957 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 292973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292982 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292992 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 292992 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 292995 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292999 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293004 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 293010 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 293023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293032 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 293038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 293051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293061 */     GIR_RootConstrainSelectedInstOperands,
     /* 293062 */     // GIR_Coverage, 2459,
     /* 293062 */     GIR_EraseRootFromParent_Done,
     /* 293063 */   // Label 5969: @293063
     /* 293063 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(293182), // Rule ID 6018 //
     /* 293068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293092 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293125 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 293129 */     // MIs[3] Operand 1
     /* 293129 */     // No operand predicates
     /* 293129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293135 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 293135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 293138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293147 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 293153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 293166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293180 */     GIR_RootConstrainSelectedInstOperands,
     /* 293181 */     // GIR_Coverage, 6018,
     /* 293181 */     GIR_EraseRootFromParent_Done,
     /* 293182 */   // Label 5970: @293182
     /* 293182 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(293301), // Rule ID 2549 //
     /* 293187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293219 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 293223 */     // MIs[2] Operand 1
     /* 293223 */     // No operand predicates
     /* 293223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293231 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293235 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293239 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293244 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 293248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293254 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 293254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 293257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293266 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 293272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 293285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293299 */     GIR_RootConstrainSelectedInstOperands,
     /* 293300 */     // GIR_Coverage, 2549,
     /* 293300 */     GIR_EraseRootFromParent_Done,
     /* 293301 */   // Label 5971: @293301
     /* 293301 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(293401), // Rule ID 4818 //
     /* 293306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293330 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 293346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293357 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 293357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 293360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293369 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 293375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 293388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293399 */     GIR_RootConstrainSelectedInstOperands,
     /* 293400 */     // GIR_Coverage, 4818,
     /* 293400 */     GIR_EraseRootFromParent_Done,
     /* 293401 */   // Label 5972: @293401
     /* 293401 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(293501), // Rule ID 4854 //
     /* 293406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 293442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 293450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293457 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 293457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 293460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293469 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 293475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 293488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 293495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 293499 */     GIR_RootConstrainSelectedInstOperands,
     /* 293500 */     // GIR_Coverage, 4854,
     /* 293500 */     GIR_EraseRootFromParent_Done,
     /* 293501 */   // Label 5973: @293501
     /* 293501 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(293598), // Rule ID 13780 //
     /* 293506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 293521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293542 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293556 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 293556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 293559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293568 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 293574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 293587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293596 */     GIR_RootConstrainSelectedInstOperands,
     /* 293597 */     // GIR_Coverage, 13780,
     /* 293597 */     GIR_EraseRootFromParent_Done,
     /* 293598 */   // Label 5974: @293598
     /* 293598 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(293698), // Rule ID 13782 //
     /* 293603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 293618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293644 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293654 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 293654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 293657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293666 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 293672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 293685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293696 */     GIR_RootConstrainSelectedInstOperands,
     /* 293697 */     // GIR_Coverage, 13782,
     /* 293697 */     GIR_EraseRootFromParent_Done,
     /* 293698 */   // Label 5975: @293698
     /* 293698 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(293798), // Rule ID 4852 //
     /* 293703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293731 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 293739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 293747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293754 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 293754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 293757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293766 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 293772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 293785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 293796 */     GIR_RootConstrainSelectedInstOperands,
     /* 293797 */     // GIR_Coverage, 4852,
     /* 293797 */     GIR_EraseRootFromParent_Done,
     /* 293798 */   // Label 5976: @293798
     /* 293798 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(293895), // Rule ID 4816 //
     /* 293803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 293822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293843 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293853 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 293853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 293856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293865 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 293871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 293884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293893 */     GIR_RootConstrainSelectedInstOperands,
     /* 293894 */     // GIR_Coverage, 4816,
     /* 293894 */     GIR_EraseRootFromParent_Done,
     /* 293895 */   // Label 5977: @293895
     /* 293895 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(293973), // Rule ID 6168 //
     /* 293900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 293937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293941 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293945 */     // MIs[3] Operand 1
     /* 293945 */     // No operand predicates
     /* 293945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293955 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 293958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293971 */     GIR_RootConstrainSelectedInstOperands,
     /* 293972 */     // GIR_Coverage, 6168,
     /* 293972 */     GIR_EraseRootFromParent_Done,
     /* 293973 */   // Label 5978: @293973
     /* 293973 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(294057), // Rule ID 6080 //
     /* 293978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 293993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294010 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 294014 */     // MIs[2] Operand 1
     /* 294014 */     // No operand predicates
     /* 294014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294022 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 294026 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294035 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294037 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 294037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 294040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 294048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294055 */     GIR_RootConstrainSelectedInstOperands,
     /* 294056 */     // GIR_Coverage, 6080,
     /* 294056 */     GIR_EraseRootFromParent_Done,
     /* 294057 */   // Label 5979: @294057
     /* 294057 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(294138), // Rule ID 6112 //
     /* 294062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 294077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 294089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294106 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 294110 */     // MIs[3] Operand 1
     /* 294110 */     // No operand predicates
     /* 294110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294120 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 294120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 294123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294136 */     GIR_RootConstrainSelectedInstOperands,
     /* 294137 */     // GIR_Coverage, 6112,
     /* 294137 */     GIR_EraseRootFromParent_Done,
     /* 294138 */   // Label 5980: @294138
     /* 294138 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(294222), // Rule ID 6144 //
     /* 294143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 294158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 294175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294179 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294192 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 294196 */     // MIs[3] Operand 1
     /* 294196 */     // No operand predicates
     /* 294196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294202 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 294202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 294205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 294213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294220 */     GIR_RootConstrainSelectedInstOperands,
     /* 294221 */     // GIR_Coverage, 6144,
     /* 294221 */     GIR_EraseRootFromParent_Done,
     /* 294222 */   // Label 5981: @294222
     /* 294222 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(294300), // Rule ID 6190 //
     /* 294227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 294243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 294259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 294268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294272 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294276 */     // MIs[3] Operand 1
     /* 294276 */     // No operand predicates
     /* 294276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294282 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 294285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294298 */     GIR_RootConstrainSelectedInstOperands,
     /* 294299 */     // GIR_Coverage, 6190,
     /* 294299 */     GIR_EraseRootFromParent_Done,
     /* 294300 */   // Label 5982: @294300
     /* 294300 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(294381), // Rule ID 6048 //
     /* 294305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 294324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 294336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294353 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 294357 */     // MIs[3] Operand 1
     /* 294357 */     // No operand predicates
     /* 294357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294363 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 294363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 294366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294379 */     GIR_RootConstrainSelectedInstOperands,
     /* 294380 */     // GIR_Coverage, 6048,
     /* 294380 */     GIR_EraseRootFromParent_Done,
     /* 294381 */   // Label 5983: @294381
     /* 294381 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(294466), // Rule ID 2457 //
     /* 294386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 294401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294410 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294424 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 294424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 294427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294436 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 294442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 294455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 294462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294464 */     GIR_RootConstrainSelectedInstOperands,
     /* 294465 */     // GIR_Coverage, 2457,
     /* 294465 */     GIR_EraseRootFromParent_Done,
     /* 294466 */   // Label 5984: @294466
     /* 294466 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(294551), // Rule ID 2455 //
     /* 294471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 294490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294499 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294509 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 294509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 294512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294521 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 294527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 294540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294549 */     GIR_RootConstrainSelectedInstOperands,
     /* 294550 */     // GIR_Coverage, 2455,
     /* 294550 */     GIR_EraseRootFromParent_Done,
     /* 294551 */   // Label 5985: @294551
     /* 294551 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(294620), // Rule ID 2547 //
     /* 294556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 294571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294588 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 294592 */     // MIs[2] Operand 1
     /* 294592 */     // No operand predicates
     /* 294592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294602 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 294602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 294605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294618 */     GIR_RootConstrainSelectedInstOperands,
     /* 294619 */     // GIR_Coverage, 2547,
     /* 294619 */     GIR_EraseRootFromParent_Done,
     /* 294620 */   // Label 5986: @294620
     /* 294620 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(294689), // Rule ID 6016 //
     /* 294625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 294644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294661 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 294665 */     // MIs[2] Operand 1
     /* 294665 */     // No operand predicates
     /* 294665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294671 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 294671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 294674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294687 */     GIR_RootConstrainSelectedInstOperands,
     /* 294688 */     // GIR_Coverage, 6016,
     /* 294688 */     GIR_EraseRootFromParent_Done,
     /* 294689 */   // Label 5987: @294689
     /* 294689 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(294751), // Rule ID 4862 //
     /* 294694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 294706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 294719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 294727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294734 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 294734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 294737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 294743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 294745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 294749 */     GIR_RootConstrainSelectedInstOperands,
     /* 294750 */     // GIR_Coverage, 4862,
     /* 294750 */     GIR_EraseRootFromParent_Done,
     /* 294751 */   // Label 5988: @294751
     /* 294751 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(294813), // Rule ID 13790 //
     /* 294756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 294772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 294781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 294789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294796 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 294796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 294799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 294805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 294807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 294811 */     GIR_RootConstrainSelectedInstOperands,
     /* 294812 */     // GIR_Coverage, 13790,
     /* 294812 */     GIR_EraseRootFromParent_Done,
     /* 294813 */   // Label 5989: @294813
     /* 294813 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(294860), // Rule ID 4859 //
     /* 294818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 294830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294845 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 294845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 294848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 294854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 294856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294858 */     GIR_RootConstrainSelectedInstOperands,
     /* 294859 */     // GIR_Coverage, 4859,
     /* 294859 */     GIR_EraseRootFromParent_Done,
     /* 294860 */   // Label 5990: @294860
     /* 294860 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(294910), // Rule ID 13218 //
     /* 294865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 294880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294895 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 294895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 294898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294908 */     GIR_RootConstrainSelectedInstOperands,
     /* 294909 */     // GIR_Coverage, 13218,
     /* 294909 */     GIR_EraseRootFromParent_Done,
     /* 294910 */   // Label 5991: @294910
     /* 294910 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(294960), // Rule ID 648 //
     /* 294915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 294934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294945 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 294945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 294948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294958 */     GIR_RootConstrainSelectedInstOperands,
     /* 294959 */     // GIR_Coverage, 648,
     /* 294959 */     GIR_EraseRootFromParent_Done,
     /* 294960 */   // Label 5992: @294960
     /* 294960 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(295007), // Rule ID 13787 //
     /* 294965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 294981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294992 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 294992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 294995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 295003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295005 */     GIR_RootConstrainSelectedInstOperands,
     /* 295006 */     // GIR_Coverage, 13787,
     /* 295006 */     GIR_EraseRootFromParent_Done,
     /* 295007 */   // Label 5993: @295007
     /* 295007 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(295057), // Rule ID 660 //
     /* 295012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 295035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295042 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 295042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 295045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295047 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 295055 */     GIR_RootConstrainSelectedInstOperands,
     /* 295056 */     // GIR_Coverage, 660,
     /* 295056 */     GIR_EraseRootFromParent_Done,
     /* 295057 */   // Label 5994: @295057
     /* 295057 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(295088), // Rule ID 642 //
     /* 295062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295077 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 295077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 295082 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295086 */     GIR_RootConstrainSelectedInstOperands,
     /* 295087 */     // GIR_Coverage, 642,
     /* 295087 */     GIR_Done,
     /* 295088 */   // Label 5995: @295088
     /* 295088 */   GIM_Reject,
     /* 295089 */ // Label 5961: @295089
     /* 295089 */ GIM_Reject,
     /* 295090 */ // Label 5887: @295090
     /* 295090 */ GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(296610),
     /* 295095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 295098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 295101 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 295104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295108 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(295186), // Rule ID 6148 //
     /* 295113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 295150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295154 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295158 */     // MIs[3] Operand 1
     /* 295158 */     // No operand predicates
     /* 295158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295168 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 295171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295184 */     GIR_RootConstrainSelectedInstOperands,
     /* 295185 */     // GIR_Coverage, 6148,
     /* 295185 */     GIR_EraseRootFromParent_Done,
     /* 295186 */   // Label 5997: @295186
     /* 295186 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(295270), // Rule ID 6064 //
     /* 295191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295223 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295227 */     // MIs[2] Operand 1
     /* 295227 */     // No operand predicates
     /* 295227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 295231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295235 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 295239 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295248 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295250 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 295253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 295261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295268 */     GIR_RootConstrainSelectedInstOperands,
     /* 295269 */     // GIR_Coverage, 6064,
     /* 295269 */     GIR_EraseRootFromParent_Done,
     /* 295270 */   // Label 5998: @295270
     /* 295270 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(295351), // Rule ID 6096 //
     /* 295275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 295290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295311 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295315 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295319 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295323 */     // MIs[3] Operand 1
     /* 295323 */     // No operand predicates
     /* 295323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295333 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 295336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295349 */     GIR_RootConstrainSelectedInstOperands,
     /* 295350 */     // GIR_Coverage, 6096,
     /* 295350 */     GIR_EraseRootFromParent_Done,
     /* 295351 */   // Label 5999: @295351
     /* 295351 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(295435), // Rule ID 6128 //
     /* 295356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 295371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295405 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295409 */     // MIs[3] Operand 1
     /* 295409 */     // No operand predicates
     /* 295409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295415 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 295418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295433 */     GIR_RootConstrainSelectedInstOperands,
     /* 295434 */     // GIR_Coverage, 6128,
     /* 295434 */     GIR_EraseRootFromParent_Done,
     /* 295435 */   // Label 6000: @295435
     /* 295435 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(295513), // Rule ID 6170 //
     /* 295440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 295481 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295485 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295489 */     // MIs[3] Operand 1
     /* 295489 */     // No operand predicates
     /* 295489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295495 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 295498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295511 */     GIR_RootConstrainSelectedInstOperands,
     /* 295512 */     // GIR_Coverage, 6170,
     /* 295512 */     GIR_EraseRootFromParent_Done,
     /* 295513 */   // Label 6001: @295513
     /* 295513 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(295594), // Rule ID 6032 //
     /* 295518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 295537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295566 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295570 */     // MIs[3] Operand 1
     /* 295570 */     // No operand predicates
     /* 295570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295576 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 295579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295592 */     GIR_RootConstrainSelectedInstOperands,
     /* 295593 */     // GIR_Coverage, 6032,
     /* 295593 */     GIR_EraseRootFromParent_Done,
     /* 295594 */   // Label 6002: @295594
     /* 295594 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(295663), // Rule ID 2531 //
     /* 295599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295631 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295635 */     // MIs[2] Operand 1
     /* 295635 */     // No operand predicates
     /* 295635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295645 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 295648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295661 */     GIR_RootConstrainSelectedInstOperands,
     /* 295662 */     // GIR_Coverage, 2531,
     /* 295662 */     GIR_EraseRootFromParent_Done,
     /* 295663 */   // Label 6003: @295663
     /* 295663 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(295732), // Rule ID 6000 //
     /* 295668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 295683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295704 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295708 */     // MIs[2] Operand 1
     /* 295708 */     // No operand predicates
     /* 295708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295714 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 295717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295730 */     GIR_RootConstrainSelectedInstOperands,
     /* 295731 */     // GIR_Coverage, 6000,
     /* 295731 */     GIR_EraseRootFromParent_Done,
     /* 295732 */   // Label 6004: @295732
     /* 295732 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(295825), // Rule ID 6152 //
     /* 295737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 295745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295776 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 295776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 295779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 295783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295788 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 295791 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295795 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 295798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 295811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295823 */     GIR_RootConstrainSelectedInstOperands,
     /* 295824 */     // GIR_Coverage, 6152,
     /* 295824 */     GIR_EraseRootFromParent_Done,
     /* 295825 */   // Label 6005: @295825
     /* 295825 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(295924), // Rule ID 6066 //
     /* 295830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 295841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 295862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295873 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 295873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 295876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 295880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295885 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 295888 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295892 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 295895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 295908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 295916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 295922 */     GIR_RootConstrainSelectedInstOperands,
     /* 295923 */     // GIR_Coverage, 6066,
     /* 295923 */     GIR_EraseRootFromParent_Done,
     /* 295924 */   // Label 6006: @295924
     /* 295924 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(296020), // Rule ID 6098 //
     /* 295929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 295944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 295952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295971 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 295971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 295974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 295978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295983 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 295986 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295990 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 295993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 296006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296018 */     GIR_RootConstrainSelectedInstOperands,
     /* 296019 */     // GIR_Coverage, 6098,
     /* 296019 */     GIR_EraseRootFromParent_Done,
     /* 296020 */   // Label 6007: @296020
     /* 296020 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(296119), // Rule ID 6130 //
     /* 296025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 296040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 296053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296068 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 296068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 296075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296080 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 296083 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296087 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 296090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 296103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296117 */     GIR_RootConstrainSelectedInstOperands,
     /* 296118 */     // GIR_Coverage, 6130,
     /* 296118 */     GIR_EraseRootFromParent_Done,
     /* 296119 */   // Label 6008: @296119
     /* 296119 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(296212), // Rule ID 6174 //
     /* 296124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 296136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296163 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 296163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 296170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296175 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 296178 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296182 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 296185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 296198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296210 */     GIR_RootConstrainSelectedInstOperands,
     /* 296211 */     // GIR_Coverage, 6174,
     /* 296211 */     GIR_EraseRootFromParent_Done,
     /* 296212 */   // Label 6009: @296212
     /* 296212 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(296308), // Rule ID 6034 //
     /* 296217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 296236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 296244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296259 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 296259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 296266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296271 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 296274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296278 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 296281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 296294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296306 */     GIR_RootConstrainSelectedInstOperands,
     /* 296307 */     // GIR_Coverage, 6034,
     /* 296307 */     GIR_EraseRootFromParent_Done,
     /* 296308 */   // Label 6010: @296308
     /* 296308 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(296392), // Rule ID 2533 //
     /* 296313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 296324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296343 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 296343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 296350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296355 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 296358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296362 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 296365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 296378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296390 */     GIR_RootConstrainSelectedInstOperands,
     /* 296391 */     // GIR_Coverage, 2533,
     /* 296391 */     GIR_EraseRootFromParent_Done,
     /* 296392 */   // Label 6011: @296392
     /* 296392 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(296442), // Rule ID 13248 //
     /* 296397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 296412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296427 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 296427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 296430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296440 */     GIR_RootConstrainSelectedInstOperands,
     /* 296441 */     // GIR_Coverage, 13248,
     /* 296441 */     GIR_EraseRootFromParent_Done,
     /* 296442 */   // Label 6012: @296442
     /* 296442 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(296526), // Rule ID 6002 //
     /* 296447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 296462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296477 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 296477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 296480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 296484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296489 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 296492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296496 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 296499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 296512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 296524 */     GIR_RootConstrainSelectedInstOperands,
     /* 296525 */     // GIR_Coverage, 6002,
     /* 296525 */     GIR_EraseRootFromParent_Done,
     /* 296526 */   // Label 6013: @296526
     /* 296526 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(296576), // Rule ID 1301 //
     /* 296531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 296550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296561 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 296561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 296564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296574 */     GIR_RootConstrainSelectedInstOperands,
     /* 296575 */     // GIR_Coverage, 1301,
     /* 296575 */     GIR_EraseRootFromParent_Done,
     /* 296576 */   // Label 6014: @296576
     /* 296576 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(296609), // Rule ID 1291 //
     /* 296581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296596 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 296596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 296599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 296607 */     GIR_RootConstrainSelectedInstOperands,
     /* 296608 */     // GIR_Coverage, 1291,
     /* 296608 */     GIR_EraseRootFromParent_Done,
     /* 296609 */   // Label 6015: @296609
     /* 296609 */   GIM_Reject,
     /* 296610 */ // Label 5996: @296610
     /* 296610 */ GIM_Reject,
     /* 296611 */ // Label 5888: @296611
     /* 296611 */ GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(298131),
     /* 296616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 296622 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 296625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296629 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(296707), // Rule ID 6160 //
     /* 296634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 296642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 296671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296675 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296679 */     // MIs[3] Operand 1
     /* 296679 */     // No operand predicates
     /* 296679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296689 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 296692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 296705 */     GIR_RootConstrainSelectedInstOperands,
     /* 296706 */     // GIR_Coverage, 6160,
     /* 296706 */     GIR_EraseRootFromParent_Done,
     /* 296707 */   // Label 6017: @296707
     /* 296707 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(296791), // Rule ID 6072 //
     /* 296712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 296723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296748 */     // MIs[2] Operand 1
     /* 296748 */     // No operand predicates
     /* 296748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296756 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296760 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296771 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 296774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 296782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 296789 */     GIR_RootConstrainSelectedInstOperands,
     /* 296790 */     // GIR_Coverage, 6072,
     /* 296790 */     GIR_EraseRootFromParent_Done,
     /* 296791 */   // Label 6018: @296791
     /* 296791 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(296872), // Rule ID 6104 //
     /* 296796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 296819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 296836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296840 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296844 */     // MIs[3] Operand 1
     /* 296844 */     // No operand predicates
     /* 296844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296854 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 296857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 296870 */     GIR_RootConstrainSelectedInstOperands,
     /* 296871 */     // GIR_Coverage, 6104,
     /* 296871 */     GIR_EraseRootFromParent_Done,
     /* 296872 */   // Label 6019: @296872
     /* 296872 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(296956), // Rule ID 6136 //
     /* 296877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 296905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296909 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 296922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296926 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296930 */     // MIs[3] Operand 1
     /* 296930 */     // No operand predicates
     /* 296930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296936 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 296936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 296939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 296954 */     GIR_RootConstrainSelectedInstOperands,
     /* 296955 */     // GIR_Coverage, 6136,
     /* 296955 */     GIR_EraseRootFromParent_Done,
     /* 296956 */   // Label 6020: @296956
     /* 296956 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(297034), // Rule ID 6182 //
     /* 296961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 296973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 297002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297006 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297010 */     // MIs[3] Operand 1
     /* 297010 */     // No operand predicates
     /* 297010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297014 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297016 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 297019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297023 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297032 */     GIR_RootConstrainSelectedInstOperands,
     /* 297033 */     // GIR_Coverage, 6182,
     /* 297033 */     GIR_EraseRootFromParent_Done,
     /* 297034 */   // Label 6021: @297034
     /* 297034 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(297115), // Rule ID 6040 //
     /* 297039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 297066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297070 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297083 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297087 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297091 */     // MIs[3] Operand 1
     /* 297091 */     // No operand predicates
     /* 297091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297095 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297097 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 297100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297113 */     GIR_RootConstrainSelectedInstOperands,
     /* 297114 */     // GIR_Coverage, 6040,
     /* 297114 */     GIR_EraseRootFromParent_Done,
     /* 297115 */   // Label 6022: @297115
     /* 297115 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(297184), // Rule ID 2539 //
     /* 297120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 297131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297152 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297156 */     // MIs[2] Operand 1
     /* 297156 */     // No operand predicates
     /* 297156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297166 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 297169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 297182 */     GIR_RootConstrainSelectedInstOperands,
     /* 297183 */     // GIR_Coverage, 2539,
     /* 297183 */     GIR_EraseRootFromParent_Done,
     /* 297184 */   // Label 6023: @297184
     /* 297184 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(297253), // Rule ID 6008 //
     /* 297189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 297204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297225 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297229 */     // MIs[2] Operand 1
     /* 297229 */     // No operand predicates
     /* 297229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297235 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 297238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 297251 */     GIR_RootConstrainSelectedInstOperands,
     /* 297252 */     // GIR_Coverage, 6008,
     /* 297252 */     GIR_EraseRootFromParent_Done,
     /* 297253 */   // Label 6024: @297253
     /* 297253 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(297346), // Rule ID 6162 //
     /* 297258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 297266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297282 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297297 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 297297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 297304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297309 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 297312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297316 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 297319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 297332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297344 */     GIR_RootConstrainSelectedInstOperands,
     /* 297345 */     // GIR_Coverage, 6162,
     /* 297345 */     GIR_EraseRootFromParent_Done,
     /* 297346 */   // Label 6025: @297346
     /* 297346 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(297445), // Rule ID 6074 //
     /* 297351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 297362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297394 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 297394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 297401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297406 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 297409 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297413 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 297416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 297429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 297437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297443 */     GIR_RootConstrainSelectedInstOperands,
     /* 297444 */     // GIR_Coverage, 6074,
     /* 297444 */     GIR_EraseRootFromParent_Done,
     /* 297445 */   // Label 6026: @297445
     /* 297445 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(297541), // Rule ID 6106 //
     /* 297450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 297473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297492 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 297492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 297499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297504 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 297507 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297511 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 297514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 297527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297539 */     GIR_RootConstrainSelectedInstOperands,
     /* 297540 */     // GIR_Coverage, 6106,
     /* 297540 */     GIR_EraseRootFromParent_Done,
     /* 297541 */   // Label 6027: @297541
     /* 297541 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(297640), // Rule ID 6138 //
     /* 297546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 297574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297589 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 297589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 297596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297601 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 297604 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297608 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 297611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 297624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 297632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297638 */     GIR_RootConstrainSelectedInstOperands,
     /* 297639 */     // GIR_Coverage, 6138,
     /* 297639 */     GIR_EraseRootFromParent_Done,
     /* 297640 */   // Label 6028: @297640
     /* 297640 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(297733), // Rule ID 6184 //
     /* 297645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 297657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297673 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297684 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 297684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 297691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297696 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 297699 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297703 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 297706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 297719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297731 */     GIR_RootConstrainSelectedInstOperands,
     /* 297732 */     // GIR_Coverage, 6184,
     /* 297732 */     GIR_EraseRootFromParent_Done,
     /* 297733 */   // Label 6029: @297733
     /* 297733 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(297829), // Rule ID 6042 //
     /* 297738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 297765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297780 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 297780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 297787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297792 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 297795 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297799 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 297802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 297815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297827 */     GIR_RootConstrainSelectedInstOperands,
     /* 297828 */     // GIR_Coverage, 6042,
     /* 297828 */     GIR_EraseRootFromParent_Done,
     /* 297829 */   // Label 6030: @297829
     /* 297829 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(297913), // Rule ID 2541 //
     /* 297834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 297845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297864 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 297864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 297871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297876 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 297879 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297883 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 297886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 297899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 297911 */     GIR_RootConstrainSelectedInstOperands,
     /* 297912 */     // GIR_Coverage, 2541,
     /* 297912 */     GIR_EraseRootFromParent_Done,
     /* 297913 */   // Label 6031: @297913
     /* 297913 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(297963), // Rule ID 13252 //
     /* 297918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297948 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 297948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 297951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297961 */     GIR_RootConstrainSelectedInstOperands,
     /* 297962 */     // GIR_Coverage, 13252,
     /* 297962 */     GIR_EraseRootFromParent_Done,
     /* 297963 */   // Label 6032: @297963
     /* 297963 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(298047), // Rule ID 6010 //
     /* 297968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 297983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297998 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 297998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 298005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298010 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 298013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298017 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 298020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 298033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298045 */     GIR_RootConstrainSelectedInstOperands,
     /* 298046 */     // GIR_Coverage, 6010,
     /* 298046 */     GIR_EraseRootFromParent_Done,
     /* 298047 */   // Label 6033: @298047
     /* 298047 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(298097), // Rule ID 1305 //
     /* 298052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298082 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 298082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 298085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298095 */     GIR_RootConstrainSelectedInstOperands,
     /* 298096 */     // GIR_Coverage, 1305,
     /* 298096 */     GIR_EraseRootFromParent_Done,
     /* 298097 */   // Label 6034: @298097
     /* 298097 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(298130), // Rule ID 1295 //
     /* 298102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298117 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 298117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 298120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 298128 */     GIR_RootConstrainSelectedInstOperands,
     /* 298129 */     // GIR_Coverage, 1295,
     /* 298129 */     GIR_EraseRootFromParent_Done,
     /* 298130 */   // Label 6035: @298130
     /* 298130 */   GIM_Reject,
     /* 298131 */ // Label 6016: @298131
     /* 298131 */ GIM_Reject,
     /* 298132 */ // Label 5889: @298132
     /* 298132 */ GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(299310),
     /* 298137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298143 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 298146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298150 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(298234), // Rule ID 6056 //
     /* 298155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 298158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298187 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298191 */     // MIs[2] Operand 1
     /* 298191 */     // No operand predicates
     /* 298191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 298195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298199 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298203 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298212 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298214 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 298214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 298217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 298225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298232 */     GIR_RootConstrainSelectedInstOperands,
     /* 298233 */     // GIR_Coverage, 6056,
     /* 298233 */     GIR_EraseRootFromParent_Done,
     /* 298234 */   // Label 6037: @298234
     /* 298234 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(298315), // Rule ID 6088 //
     /* 298239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 298242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298283 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298287 */     // MIs[3] Operand 1
     /* 298287 */     // No operand predicates
     /* 298287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298297 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 298297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 298300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298313 */     GIR_RootConstrainSelectedInstOperands,
     /* 298314 */     // GIR_Coverage, 6088,
     /* 298314 */     GIR_EraseRootFromParent_Done,
     /* 298315 */   // Label 6038: @298315
     /* 298315 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(298399), // Rule ID 6120 //
     /* 298320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 298323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298369 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298373 */     // MIs[3] Operand 1
     /* 298373 */     // No operand predicates
     /* 298373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298379 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 298379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 298382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298397 */     GIR_RootConstrainSelectedInstOperands,
     /* 298398 */     // GIR_Coverage, 6120,
     /* 298398 */     GIR_EraseRootFromParent_Done,
     /* 298399 */   // Label 6039: @298399
     /* 298399 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(298480), // Rule ID 6024 //
     /* 298404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 298407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298439 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298452 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298456 */     // MIs[3] Operand 1
     /* 298456 */     // No operand predicates
     /* 298456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298462 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 298462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 298465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298478 */     GIR_RootConstrainSelectedInstOperands,
     /* 298479 */     // GIR_Coverage, 6024,
     /* 298479 */     GIR_EraseRootFromParent_Done,
     /* 298480 */   // Label 6040: @298480
     /* 298480 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(298549), // Rule ID 2523 //
     /* 298485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 298488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298517 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298521 */     // MIs[2] Operand 1
     /* 298521 */     // No operand predicates
     /* 298521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298531 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 298531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 298534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298547 */     GIR_RootConstrainSelectedInstOperands,
     /* 298548 */     // GIR_Coverage, 2523,
     /* 298548 */     GIR_EraseRootFromParent_Done,
     /* 298549 */   // Label 6041: @298549
     /* 298549 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(298618), // Rule ID 5992 //
     /* 298554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 298557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 298569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 298582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298590 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 298594 */     // MIs[2] Operand 1
     /* 298594 */     // No operand predicates
     /* 298594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298600 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 298600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 298603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298616 */     GIR_RootConstrainSelectedInstOperands,
     /* 298617 */     // GIR_Coverage, 5992,
     /* 298617 */     GIR_EraseRootFromParent_Done,
     /* 298618 */   // Label 6042: @298618
     /* 298618 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(298717), // Rule ID 6058 //
     /* 298623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 298626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 298634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 298638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 298643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298666 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 298666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 298669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 298673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298678 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 298681 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298685 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 298688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 298698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 298701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 298709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298715 */     GIR_RootConstrainSelectedInstOperands,
     /* 298716 */     // GIR_Coverage, 6058,
     /* 298716 */     GIR_EraseRootFromParent_Done,
     /* 298717 */   // Label 6043: @298717
     /* 298717 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(298813), // Rule ID 6090 //
     /* 298722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 298725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 298745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 298749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 298754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298764 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 298764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 298767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 298771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298776 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 298779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298783 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 298786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 298796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 298799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298811 */     GIR_RootConstrainSelectedInstOperands,
     /* 298812 */     // GIR_Coverage, 6090,
     /* 298812 */     GIR_EraseRootFromParent_Done,
     /* 298813 */   // Label 6044: @298813
     /* 298813 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(298912), // Rule ID 6122 //
     /* 298818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 298821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 298846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 298850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 298855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298861 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 298861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 298864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 298868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298873 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 298876 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298880 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 298883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 298893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 298896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 298910 */     GIR_RootConstrainSelectedInstOperands,
     /* 298911 */     // GIR_Coverage, 6122,
     /* 298911 */     GIR_EraseRootFromParent_Done,
     /* 298912 */   // Label 6045: @298912
     /* 298912 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(299008), // Rule ID 6026 //
     /* 298917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 298920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 298944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 298948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 298953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298959 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 298959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 298962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 298966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298971 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 298974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298978 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 298981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 298991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 298994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299006 */     GIR_RootConstrainSelectedInstOperands,
     /* 299007 */     // GIR_Coverage, 6026,
     /* 299007 */     GIR_EraseRootFromParent_Done,
     /* 299008 */   // Label 6046: @299008
     /* 299008 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(299092), // Rule ID 2525 //
     /* 299013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 299016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 299024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 299033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299043 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 299043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 299046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 299050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299055 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 299058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299062 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 299065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 299075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 299078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299090 */     GIR_RootConstrainSelectedInstOperands,
     /* 299091 */     // GIR_Coverage, 2525,
     /* 299091 */     GIR_EraseRootFromParent_Done,
     /* 299092 */   // Label 6047: @299092
     /* 299092 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(299142), // Rule ID 13244 //
     /* 299097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 299100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 299112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299127 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 299127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 299130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299140 */     GIR_RootConstrainSelectedInstOperands,
     /* 299141 */     // GIR_Coverage, 13244,
     /* 299141 */     GIR_EraseRootFromParent_Done,
     /* 299142 */   // Label 6048: @299142
     /* 299142 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(299226), // Rule ID 5994 //
     /* 299147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 299150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 299162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 299171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299177 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 299177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 299180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 299184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299189 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 299192 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299196 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 299199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 299209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 299212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299224 */     GIR_RootConstrainSelectedInstOperands,
     /* 299225 */     // GIR_Coverage, 5994,
     /* 299225 */     GIR_EraseRootFromParent_Done,
     /* 299226 */   // Label 6049: @299226
     /* 299226 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(299276), // Rule ID 1297 //
     /* 299231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 299234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 299250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299261 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 299261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 299264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299274 */     GIR_RootConstrainSelectedInstOperands,
     /* 299275 */     // GIR_Coverage, 1297,
     /* 299275 */     GIR_EraseRootFromParent_Done,
     /* 299276 */   // Label 6050: @299276
     /* 299276 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(299309), // Rule ID 1287 //
     /* 299281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 299284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299296 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 299296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 299299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 299307 */     GIR_RootConstrainSelectedInstOperands,
     /* 299308 */     // GIR_Coverage, 1287,
     /* 299308 */     GIR_EraseRootFromParent_Done,
     /* 299309 */   // Label 6051: @299309
     /* 299309 */   GIM_Reject,
     /* 299310 */ // Label 6036: @299310
     /* 299310 */ GIM_Reject,
     /* 299311 */ // Label 5890: @299311
     /* 299311 */ GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(300831),
     /* 299316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 299322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 299325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299329 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(299407), // Rule ID 6154 //
     /* 299334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 299371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299375 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299379 */     // MIs[3] Operand 1
     /* 299379 */     // No operand predicates
     /* 299379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299389 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 299392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299405 */     GIR_RootConstrainSelectedInstOperands,
     /* 299406 */     // GIR_Coverage, 6154,
     /* 299406 */     GIR_EraseRootFromParent_Done,
     /* 299407 */   // Label 6053: @299407
     /* 299407 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(299491), // Rule ID 6068 //
     /* 299412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299444 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299448 */     // MIs[2] Operand 1
     /* 299448 */     // No operand predicates
     /* 299448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 299452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299456 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299460 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299471 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 299474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 299482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299489 */     GIR_RootConstrainSelectedInstOperands,
     /* 299490 */     // GIR_Coverage, 6068,
     /* 299490 */     GIR_EraseRootFromParent_Done,
     /* 299491 */   // Label 6054: @299491
     /* 299491 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(299572), // Rule ID 6100 //
     /* 299496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299540 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299544 */     // MIs[3] Operand 1
     /* 299544 */     // No operand predicates
     /* 299544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299554 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 299557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299570 */     GIR_RootConstrainSelectedInstOperands,
     /* 299571 */     // GIR_Coverage, 6100,
     /* 299571 */     GIR_EraseRootFromParent_Done,
     /* 299572 */   // Label 6055: @299572
     /* 299572 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(299656), // Rule ID 6132 //
     /* 299577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299626 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299630 */     // MIs[3] Operand 1
     /* 299630 */     // No operand predicates
     /* 299630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299636 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 299639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299654 */     GIR_RootConstrainSelectedInstOperands,
     /* 299655 */     // GIR_Coverage, 6132,
     /* 299655 */     GIR_EraseRootFromParent_Done,
     /* 299656 */   // Label 6056: @299656
     /* 299656 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(299734), // Rule ID 6176 //
     /* 299661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 299702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299706 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299710 */     // MIs[3] Operand 1
     /* 299710 */     // No operand predicates
     /* 299710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299716 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 299719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299732 */     GIR_RootConstrainSelectedInstOperands,
     /* 299733 */     // GIR_Coverage, 6176,
     /* 299733 */     GIR_EraseRootFromParent_Done,
     /* 299734 */   // Label 6057: @299734
     /* 299734 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(299815), // Rule ID 6036 //
     /* 299739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299787 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299791 */     // MIs[3] Operand 1
     /* 299791 */     // No operand predicates
     /* 299791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299797 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 299800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299813 */     GIR_RootConstrainSelectedInstOperands,
     /* 299814 */     // GIR_Coverage, 6036,
     /* 299814 */     GIR_EraseRootFromParent_Done,
     /* 299815 */   // Label 6058: @299815
     /* 299815 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(299884), // Rule ID 2535 //
     /* 299820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299852 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299856 */     // MIs[2] Operand 1
     /* 299856 */     // No operand predicates
     /* 299856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299866 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 299869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299882 */     GIR_RootConstrainSelectedInstOperands,
     /* 299883 */     // GIR_Coverage, 2535,
     /* 299883 */     GIR_EraseRootFromParent_Done,
     /* 299884 */   // Label 6059: @299884
     /* 299884 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(299953), // Rule ID 6004 //
     /* 299889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299925 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299929 */     // MIs[2] Operand 1
     /* 299929 */     // No operand predicates
     /* 299929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299935 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 299938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299951 */     GIR_RootConstrainSelectedInstOperands,
     /* 299952 */     // GIR_Coverage, 6004,
     /* 299952 */     GIR_EraseRootFromParent_Done,
     /* 299953 */   // Label 6060: @299953
     /* 299953 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(300046), // Rule ID 6158 //
     /* 299958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 299966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 299970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 299982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299997 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 299997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300009 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300012 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300016 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 300032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300044 */     GIR_RootConstrainSelectedInstOperands,
     /* 300045 */     // GIR_Coverage, 6158,
     /* 300045 */     GIR_EraseRootFromParent_Done,
     /* 300046 */   // Label 6061: @300046
     /* 300046 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(300145), // Rule ID 6070 //
     /* 300051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300094 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300106 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300109 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300113 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300116 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300121 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 300129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 300137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300143 */     GIR_RootConstrainSelectedInstOperands,
     /* 300144 */     // GIR_Coverage, 6070,
     /* 300144 */     GIR_EraseRootFromParent_Done,
     /* 300145 */   // Label 6062: @300145
     /* 300145 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(300241), // Rule ID 6102 //
     /* 300150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 300173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300192 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300204 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300207 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300211 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 300227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300239 */     GIR_RootConstrainSelectedInstOperands,
     /* 300240 */     // GIR_Coverage, 6102,
     /* 300240 */     GIR_EraseRootFromParent_Done,
     /* 300241 */   // Label 6063: @300241
     /* 300241 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(300340), // Rule ID 6134 //
     /* 300246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 300274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300289 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300301 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300304 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300308 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 300324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300338 */     GIR_RootConstrainSelectedInstOperands,
     /* 300339 */     // GIR_Coverage, 6134,
     /* 300339 */     GIR_EraseRootFromParent_Done,
     /* 300340 */   // Label 6064: @300340
     /* 300340 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(300433), // Rule ID 6180 //
     /* 300345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300384 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300396 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300399 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300403 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 300419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300431 */     GIR_RootConstrainSelectedInstOperands,
     /* 300432 */     // GIR_Coverage, 6180,
     /* 300432 */     GIR_EraseRootFromParent_Done,
     /* 300433 */   // Label 6065: @300433
     /* 300433 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(300529), // Rule ID 6038 //
     /* 300438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 300465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300480 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300492 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300495 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300499 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 300515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300527 */     GIR_RootConstrainSelectedInstOperands,
     /* 300528 */     // GIR_Coverage, 6038,
     /* 300528 */     GIR_EraseRootFromParent_Done,
     /* 300529 */   // Label 6066: @300529
     /* 300529 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(300613), // Rule ID 2537 //
     /* 300534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300564 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300576 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300579 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300583 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 300599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300611 */     GIR_RootConstrainSelectedInstOperands,
     /* 300612 */     // GIR_Coverage, 2537,
     /* 300612 */     GIR_EraseRootFromParent_Done,
     /* 300613 */   // Label 6067: @300613
     /* 300613 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(300663), // Rule ID 13250 //
     /* 300618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300648 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 300648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 300651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300661 */     GIR_RootConstrainSelectedInstOperands,
     /* 300662 */     // GIR_Coverage, 13250,
     /* 300662 */     GIR_EraseRootFromParent_Done,
     /* 300663 */   // Label 6068: @300663
     /* 300663 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(300747), // Rule ID 6006 //
     /* 300668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300698 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300710 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300717 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 300733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300745 */     GIR_RootConstrainSelectedInstOperands,
     /* 300746 */     // GIR_Coverage, 6006,
     /* 300746 */     GIR_EraseRootFromParent_Done,
     /* 300747 */   // Label 6069: @300747
     /* 300747 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(300797), // Rule ID 1303 //
     /* 300752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300782 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 300782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 300785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300795 */     GIR_RootConstrainSelectedInstOperands,
     /* 300796 */     // GIR_Coverage, 1303,
     /* 300796 */     GIR_EraseRootFromParent_Done,
     /* 300797 */   // Label 6070: @300797
     /* 300797 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(300830), // Rule ID 1293 //
     /* 300802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300817 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 300817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 300820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 300828 */     GIR_RootConstrainSelectedInstOperands,
     /* 300829 */     // GIR_Coverage, 1293,
     /* 300829 */     GIR_EraseRootFromParent_Done,
     /* 300830 */   // Label 6071: @300830
     /* 300830 */   GIM_Reject,
     /* 300831 */ // Label 6052: @300831
     /* 300831 */ GIM_Reject,
     /* 300832 */ // Label 5891: @300832
     /* 300832 */ GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(302010),
     /* 300837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 300843 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 300846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300850 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(300934), // Rule ID 6052 //
     /* 300855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 300858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 300883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300887 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300891 */     // MIs[2] Operand 1
     /* 300891 */     // No operand predicates
     /* 300891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 300895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300899 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300903 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300914 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 300914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 300917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 300925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 300932 */     GIR_RootConstrainSelectedInstOperands,
     /* 300933 */     // GIR_Coverage, 6052,
     /* 300933 */     GIR_EraseRootFromParent_Done,
     /* 300934 */   // Label 6073: @300934
     /* 300934 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(301015), // Rule ID 6084 //
     /* 300939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 300942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300983 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300987 */     // MIs[3] Operand 1
     /* 300987 */     // No operand predicates
     /* 300987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300997 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 300997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 301000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301013 */     GIR_RootConstrainSelectedInstOperands,
     /* 301014 */     // GIR_Coverage, 6084,
     /* 301014 */     GIR_EraseRootFromParent_Done,
     /* 301015 */   // Label 6074: @301015
     /* 301015 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(301099), // Rule ID 6116 //
     /* 301020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 301048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 301061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301069 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 301073 */     // MIs[3] Operand 1
     /* 301073 */     // No operand predicates
     /* 301073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301079 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 301079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 301082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301097 */     GIR_RootConstrainSelectedInstOperands,
     /* 301098 */     // GIR_Coverage, 6116,
     /* 301098 */     GIR_EraseRootFromParent_Done,
     /* 301099 */   // Label 6075: @301099
     /* 301099 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(301180), // Rule ID 6020 //
     /* 301104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 301131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 301144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301152 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 301156 */     // MIs[3] Operand 1
     /* 301156 */     // No operand predicates
     /* 301156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301162 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 301162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 301165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301169 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301178 */     GIR_RootConstrainSelectedInstOperands,
     /* 301179 */     // GIR_Coverage, 6020,
     /* 301179 */     GIR_EraseRootFromParent_Done,
     /* 301180 */   // Label 6076: @301180
     /* 301180 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(301249), // Rule ID 2519 //
     /* 301185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 301196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 301209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301217 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 301221 */     // MIs[2] Operand 1
     /* 301221 */     // No operand predicates
     /* 301221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301231 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 301231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 301234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301247 */     GIR_RootConstrainSelectedInstOperands,
     /* 301248 */     // GIR_Coverage, 2519,
     /* 301248 */     GIR_EraseRootFromParent_Done,
     /* 301249 */   // Label 6077: @301249
     /* 301249 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(301318), // Rule ID 5988 //
     /* 301254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 301269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 301282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301290 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 301294 */     // MIs[2] Operand 1
     /* 301294 */     // No operand predicates
     /* 301294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301300 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 301300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 301303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301316 */     GIR_RootConstrainSelectedInstOperands,
     /* 301317 */     // GIR_Coverage, 5988,
     /* 301317 */     GIR_EraseRootFromParent_Done,
     /* 301318 */   // Label 6078: @301318
     /* 301318 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(301417), // Rule ID 6054 //
     /* 301323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 301338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 301343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301366 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 301369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301378 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301381 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301385 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 301388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 301398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 301401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 301409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301415 */     GIR_RootConstrainSelectedInstOperands,
     /* 301416 */     // GIR_Coverage, 6054,
     /* 301416 */     GIR_EraseRootFromParent_Done,
     /* 301417 */   // Label 6079: @301417
     /* 301417 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(301513), // Rule ID 6086 //
     /* 301422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 301449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 301454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301464 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 301467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301476 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301479 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301483 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 301486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 301496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 301499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301511 */     GIR_RootConstrainSelectedInstOperands,
     /* 301512 */     // GIR_Coverage, 6086,
     /* 301512 */     GIR_EraseRootFromParent_Done,
     /* 301513 */   // Label 6080: @301513
     /* 301513 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(301612), // Rule ID 6118 //
     /* 301518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 301550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 301555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301561 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 301564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301573 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301576 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301580 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 301583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 301593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 301596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301610 */     GIR_RootConstrainSelectedInstOperands,
     /* 301611 */     // GIR_Coverage, 6118,
     /* 301611 */     GIR_EraseRootFromParent_Done,
     /* 301612 */   // Label 6081: @301612
     /* 301612 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(301708), // Rule ID 6022 //
     /* 301617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 301648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 301653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301659 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 301662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301671 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301678 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 301681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 301691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 301694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301706 */     GIR_RootConstrainSelectedInstOperands,
     /* 301707 */     // GIR_Coverage, 6022,
     /* 301707 */     GIR_EraseRootFromParent_Done,
     /* 301708 */   // Label 6082: @301708
     /* 301708 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(301792), // Rule ID 2521 //
     /* 301713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 301728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 301733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301743 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 301746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301755 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 301765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 301775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 301778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301790 */     GIR_RootConstrainSelectedInstOperands,
     /* 301791 */     // GIR_Coverage, 2521,
     /* 301791 */     GIR_EraseRootFromParent_Done,
     /* 301792 */   // Label 6083: @301792
     /* 301792 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(301842), // Rule ID 13246 //
     /* 301797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301827 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 301827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 301830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301840 */     GIR_RootConstrainSelectedInstOperands,
     /* 301841 */     // GIR_Coverage, 13246,
     /* 301841 */     GIR_EraseRootFromParent_Done,
     /* 301842 */   // Label 6084: @301842
     /* 301842 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(301926), // Rule ID 5990 //
     /* 301847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 301866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 301871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301877 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 301880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301889 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301896 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 301899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 301909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 301912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301916 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301924 */     GIR_RootConstrainSelectedInstOperands,
     /* 301925 */     // GIR_Coverage, 5990,
     /* 301925 */     GIR_EraseRootFromParent_Done,
     /* 301926 */   // Label 6085: @301926
     /* 301926 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(301976), // Rule ID 1299 //
     /* 301931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301961 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 301961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 301964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301974 */     GIR_RootConstrainSelectedInstOperands,
     /* 301975 */     // GIR_Coverage, 1299,
     /* 301975 */     GIR_EraseRootFromParent_Done,
     /* 301976 */   // Label 6086: @301976
     /* 301976 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(302009), // Rule ID 1289 //
     /* 301981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 301984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301996 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 301996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 301999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 302007 */     GIR_RootConstrainSelectedInstOperands,
     /* 302008 */     // GIR_Coverage, 1289,
     /* 302008 */     GIR_EraseRootFromParent_Done,
     /* 302009 */   // Label 6087: @302009
     /* 302009 */   GIM_Reject,
     /* 302010 */ // Label 6072: @302010
     /* 302010 */ GIM_Reject,
     /* 302011 */ // Label 5892: @302011
     /* 302011 */ GIM_Reject,
     /* 302012 */ // Label 61: @302012
     /* 302012 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6096*/ GIMT_Encode4(302627),
     /* 302023 */ /*GILLT_s16*//*Label 6088*/ GIMT_Encode4(302063),
     /* 302027 */ /*GILLT_s32*//*Label 6089*/ GIMT_Encode4(302101),
     /* 302031 */ /*GILLT_s64*//*Label 6090*/ GIMT_Encode4(302139), GIMT_Encode4(0),
     /* 302039 */ /*GILLT_v2s32*//*Label 6091*/ GIMT_Encode4(302177),
     /* 302043 */ /*GILLT_v2s64*//*Label 6092*/ GIMT_Encode4(302215),
     /* 302047 */ /*GILLT_v4s16*//*Label 6093*/ GIMT_Encode4(302253),
     /* 302051 */ /*GILLT_v4s32*//*Label 6094*/ GIMT_Encode4(302291), GIMT_Encode4(0),
     /* 302059 */ /*GILLT_v8s16*//*Label 6095*/ GIMT_Encode4(302329),
     /* 302063 */ // Label 6088: @302063
     /* 302063 */ GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(302100), // Rule ID 590 //
     /* 302068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 302074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 302077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302089 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 302089 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 302094 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302098 */   GIR_RootConstrainSelectedInstOperands,
     /* 302099 */   // GIR_Coverage, 590,
     /* 302099 */   GIR_Done,
     /* 302100 */ // Label 6097: @302100
     /* 302100 */ GIM_Reject,
     /* 302101 */ // Label 6089: @302101
     /* 302101 */ GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(302138), // Rule ID 592 //
     /* 302106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 302115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302123 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302127 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 302127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 302132 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302136 */   GIR_RootConstrainSelectedInstOperands,
     /* 302137 */   // GIR_Coverage, 592,
     /* 302137 */   GIR_Done,
     /* 302138 */ // Label 6098: @302138
     /* 302138 */ GIM_Reject,
     /* 302139 */ // Label 6090: @302139
     /* 302139 */ GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(302176), // Rule ID 594 //
     /* 302144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 302153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302165 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 302165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 302170 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302174 */   GIR_RootConstrainSelectedInstOperands,
     /* 302175 */   // GIR_Coverage, 594,
     /* 302175 */   GIR_Done,
     /* 302176 */ // Label 6099: @302176
     /* 302176 */ GIM_Reject,
     /* 302177 */ // Label 6091: @302177
     /* 302177 */ GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(302214), // Rule ID 1221 //
     /* 302182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302203 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 302203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 302208 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302212 */   GIR_RootConstrainSelectedInstOperands,
     /* 302213 */   // GIR_Coverage, 1221,
     /* 302213 */   GIR_Done,
     /* 302214 */ // Label 6100: @302214
     /* 302214 */ GIM_Reject,
     /* 302215 */ // Label 6092: @302215
     /* 302215 */ GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(302252), // Rule ID 1225 //
     /* 302220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 302229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302241 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 302241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 302246 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302250 */   GIR_RootConstrainSelectedInstOperands,
     /* 302251 */   // GIR_Coverage, 1225,
     /* 302251 */   GIR_Done,
     /* 302252 */ // Label 6101: @302252
     /* 302252 */ GIM_Reject,
     /* 302253 */ // Label 6093: @302253
     /* 302253 */ GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(302290), // Rule ID 1217 //
     /* 302258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302279 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 302279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 302284 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302288 */   GIR_RootConstrainSelectedInstOperands,
     /* 302289 */   // GIR_Coverage, 1217,
     /* 302289 */   GIR_Done,
     /* 302290 */ // Label 6102: @302290
     /* 302290 */ GIM_Reject,
     /* 302291 */ // Label 6094: @302291
     /* 302291 */ GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(302328), // Rule ID 1223 //
     /* 302296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 302305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302317 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 302317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 302322 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302326 */   GIR_RootConstrainSelectedInstOperands,
     /* 302327 */   // GIR_Coverage, 1223,
     /* 302327 */   GIR_Done,
     /* 302328 */ // Label 6103: @302328
     /* 302328 */ GIM_Reject,
     /* 302329 */ // Label 6095: @302329
     /* 302329 */ GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(302626),
     /* 302334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 302340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302352 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(302371), // Rule ID 1219 //
     /* 302357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302360 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 302360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 302365 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302369 */     GIR_RootConstrainSelectedInstOperands,
     /* 302370 */     // GIR_Coverage, 1219,
     /* 302370 */     GIR_Done,
     /* 302371 */   // Label 6105: @302371
     /* 302371 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(302625), // Rule ID 6961 //
     /* 302376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 302379 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 302379 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 302382 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 302386 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302391 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 302395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 302397 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 302400 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 302404 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302409 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 302413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 302415 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 302418 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 302422 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302427 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 302430 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 302433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 302435 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 302438 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302442 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302447 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 302453 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302458 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302463 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 302466 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 302470 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302475 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 302478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 302480 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 302483 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302487 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302492 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 302498 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302503 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302508 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 302511 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 302515 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302520 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 302523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 302525 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 302528 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 302532 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302537 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 302540 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 302543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 302545 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 302548 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 302552 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302557 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 302560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 302562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 302565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 302569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 302576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 302583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302588 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 302591 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 302594 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 302597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 302615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 302623 */     GIR_RootConstrainSelectedInstOperands,
     /* 302624 */     // GIR_Coverage, 6961,
     /* 302624 */     GIR_EraseRootFromParent_Done,
     /* 302625 */   // Label 6106: @302625
     /* 302625 */   GIM_Reject,
     /* 302626 */ // Label 6104: @302626
     /* 302626 */ GIM_Reject,
     /* 302627 */ // Label 6096: @302627
     /* 302627 */ GIM_Reject,
     /* 302628 */ // Label 62: @302628
     /* 302628 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6115*/ GIMT_Encode4(306134),
     /* 302639 */ /*GILLT_s16*//*Label 6107*/ GIMT_Encode4(302679),
     /* 302643 */ /*GILLT_s32*//*Label 6108*/ GIMT_Encode4(303847),
     /* 302647 */ /*GILLT_s64*//*Label 6109*/ GIMT_Encode4(304870), GIMT_Encode4(0),
     /* 302655 */ /*GILLT_v2s32*//*Label 6110*/ GIMT_Encode4(305893),
     /* 302659 */ /*GILLT_v2s64*//*Label 6111*/ GIMT_Encode4(305920),
     /* 302663 */ /*GILLT_v4s16*//*Label 6112*/ GIMT_Encode4(305947),
     /* 302667 */ /*GILLT_v4s32*//*Label 6113*/ GIMT_Encode4(306027), GIMT_Encode4(0),
     /* 302675 */ /*GILLT_v8s16*//*Label 6114*/ GIMT_Encode4(306054),
     /* 302679 */ // Label 6107: @302679
     /* 302679 */ GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(303846),
     /* 302684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 302687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302691 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(302849), // Rule ID 4826 //
     /* 302696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 302707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 302711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 302715 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 302719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302735 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302740 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 302744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 302748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302752 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302756 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 302760 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302765 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 302769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302776 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 302776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 302779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302788 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 302794 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302799 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 302807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302816 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 302822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 302835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 302843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 302847 */     GIR_RootConstrainSelectedInstOperands,
     /* 302848 */     // GIR_Coverage, 4826,
     /* 302848 */     GIR_EraseRootFromParent_Done,
     /* 302849 */   // Label 6117: @302849
     /* 302849 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(303007), // Rule ID 4825 //
     /* 302854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 302865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 302869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 302873 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 302877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302898 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 302902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 302906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302910 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302914 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 302918 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302923 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 302927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302934 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 302934 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 302937 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302941 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302946 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 302952 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302957 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 302965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302974 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 302980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 302993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 303001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 303005 */     GIR_RootConstrainSelectedInstOperands,
     /* 303006 */     // GIR_Coverage, 4825,
     /* 303006 */     GIR_EraseRootFromParent_Done,
     /* 303007 */   // Label 6118: @303007
     /* 303007 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(303118), // Rule ID 4824 //
     /* 303012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 303023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 303031 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 303035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303056 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303072 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 303072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 303075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303084 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 303090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 303103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 303116 */     GIR_RootConstrainSelectedInstOperands,
     /* 303117 */     // GIR_Coverage, 4824,
     /* 303117 */     GIR_EraseRootFromParent_Done,
     /* 303118 */   // Label 6119: @303118
     /* 303118 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(303229), // Rule ID 4822 //
     /* 303123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 303134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 303142 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 303146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303172 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303183 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 303183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 303186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303195 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 303201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 303214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 303227 */     GIR_RootConstrainSelectedInstOperands,
     /* 303228 */     // GIR_Coverage, 4822,
     /* 303228 */     GIR_EraseRootFromParent_Done,
     /* 303229 */   // Label 6120: @303229
     /* 303229 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(303340), // Rule ID 4823 //
     /* 303234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 303245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 303253 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 303257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303269 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303278 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303294 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 303294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 303297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303306 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 303312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 303325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 303338 */     GIR_RootConstrainSelectedInstOperands,
     /* 303339 */     // GIR_Coverage, 4823,
     /* 303339 */     GIR_EraseRootFromParent_Done,
     /* 303340 */   // Label 6121: @303340
     /* 303340 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(303451), // Rule ID 4821 //
     /* 303345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 303356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 303364 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 303368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303394 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303405 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 303405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 303408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303417 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 303423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 303436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 303449 */     GIR_RootConstrainSelectedInstOperands,
     /* 303450 */     // GIR_Coverage, 4821,
     /* 303450 */     GIR_EraseRootFromParent_Done,
     /* 303451 */   // Label 6122: @303451
     /* 303451 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(303515), // Rule ID 650 //
     /* 303456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 303467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 303475 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 303479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303496 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 303496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 303499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 303513 */     GIR_RootConstrainSelectedInstOperands,
     /* 303514 */     // GIR_Coverage, 650,
     /* 303514 */     GIR_EraseRootFromParent_Done,
     /* 303515 */   // Label 6123: @303515
     /* 303515 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(303579), // Rule ID 649 //
     /* 303520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 303531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 303539 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 303543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303560 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 303560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 303563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 303577 */     GIR_RootConstrainSelectedInstOperands,
     /* 303578 */     // GIR_Coverage, 649,
     /* 303578 */     GIR_EraseRootFromParent_Done,
     /* 303579 */   // Label 6124: @303579
     /* 303579 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(303630), // Rule ID 626 //
     /* 303584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 303595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 303603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303615 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 303615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 303618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303628 */     GIR_RootConstrainSelectedInstOperands,
     /* 303629 */     // GIR_Coverage, 626,
     /* 303629 */     GIR_EraseRootFromParent_Done,
     /* 303630 */   // Label 6125: @303630
     /* 303630 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(303681), // Rule ID 625 //
     /* 303635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 303646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 303654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303666 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 303666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 303669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303679 */     GIR_RootConstrainSelectedInstOperands,
     /* 303680 */     // GIR_Coverage, 625,
     /* 303680 */     GIR_EraseRootFromParent_Done,
     /* 303681 */   // Label 6126: @303681
     /* 303681 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(303700), // Rule ID 524 //
     /* 303686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303693 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 303693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 303698 */     GIR_RootConstrainSelectedInstOperands,
     /* 303699 */     // GIR_Coverage, 524,
     /* 303699 */     GIR_Done,
     /* 303700 */   // Label 6127: @303700
     /* 303700 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(303845), // Rule ID 6328 //
     /* 303705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303709 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 303709 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 303712 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303716 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 303723 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 303726 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303730 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303735 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 303738 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 303742 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 303745 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303750 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303755 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303760 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 303763 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303767 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303772 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 303775 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 303780 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 303783 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 303787 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303792 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 303795 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 303800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303814 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 303817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303827 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 303834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303844 */     // GIR_Coverage, 6328,
     /* 303844 */     GIR_EraseRootFromParent_Done,
     /* 303845 */   // Label 6128: @303845
     /* 303845 */   GIM_Reject,
     /* 303846 */ // Label 6116: @303846
     /* 303846 */ GIM_Reject,
     /* 303847 */ // Label 6108: @303847
     /* 303847 */ GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(304869),
     /* 303852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303859 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(304017), // Rule ID 4832 //
     /* 303864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 303875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 303883 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 303887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303908 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 303916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303920 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303924 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 303928 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303933 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 303937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303944 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 303944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 303947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303956 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 303962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 303975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303984 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 303990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 304003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 304011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 304015 */     GIR_RootConstrainSelectedInstOperands,
     /* 304016 */     // GIR_Coverage, 4832,
     /* 304016 */     GIR_EraseRootFromParent_Done,
     /* 304017 */   // Label 6130: @304017
     /* 304017 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(304175), // Rule ID 4831 //
     /* 304022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 304033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 304041 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 304045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304066 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 304070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 304074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 304086 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304091 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 304095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304102 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 304102 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 304105 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304109 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304114 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 304120 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304125 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304142 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 304148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 304161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 304169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 304173 */     GIR_RootConstrainSelectedInstOperands,
     /* 304174 */     // GIR_Coverage, 4831,
     /* 304174 */     GIR_EraseRootFromParent_Done,
     /* 304175 */   // Label 6131: @304175
     /* 304175 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(304286), // Rule ID 4830 //
     /* 304180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 304191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 304199 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 304203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304215 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304224 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 304228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304240 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 304240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304252 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 304258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 304271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 304284 */     GIR_RootConstrainSelectedInstOperands,
     /* 304285 */     // GIR_Coverage, 4830,
     /* 304285 */     GIR_EraseRootFromParent_Done,
     /* 304286 */   // Label 6132: @304286
     /* 304286 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(304397), // Rule ID 4828 //
     /* 304291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 304302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 304310 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 304314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304340 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 304344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304351 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 304351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304363 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 304369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 304382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 304395 */     GIR_RootConstrainSelectedInstOperands,
     /* 304396 */     // GIR_Coverage, 4828,
     /* 304396 */     GIR_EraseRootFromParent_Done,
     /* 304397 */   // Label 6133: @304397
     /* 304397 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(304508), // Rule ID 4829 //
     /* 304402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 304413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 304421 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 304425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304446 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 304450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304462 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 304462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304474 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 304480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 304493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 304506 */     GIR_RootConstrainSelectedInstOperands,
     /* 304507 */     // GIR_Coverage, 4829,
     /* 304507 */     GIR_EraseRootFromParent_Done,
     /* 304508 */   // Label 6134: @304508
     /* 304508 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(304619), // Rule ID 4827 //
     /* 304513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 304524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 304532 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 304536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304562 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 304566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304573 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 304573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 304576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304585 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 304591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 304604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 304617 */     GIR_RootConstrainSelectedInstOperands,
     /* 304618 */     // GIR_Coverage, 4827,
     /* 304618 */     GIR_EraseRootFromParent_Done,
     /* 304619 */   // Label 6135: @304619
     /* 304619 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(304683), // Rule ID 652 //
     /* 304624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 304635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 304643 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 304647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304664 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 304664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 304667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 304681 */     GIR_RootConstrainSelectedInstOperands,
     /* 304682 */     // GIR_Coverage, 652,
     /* 304682 */     GIR_EraseRootFromParent_Done,
     /* 304683 */   // Label 6136: @304683
     /* 304683 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(304747), // Rule ID 651 //
     /* 304688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 304699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 304707 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 304711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304728 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 304728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 304731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 304745 */     GIR_RootConstrainSelectedInstOperands,
     /* 304746 */     // GIR_Coverage, 651,
     /* 304746 */     GIR_EraseRootFromParent_Done,
     /* 304747 */   // Label 6137: @304747
     /* 304747 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(304798), // Rule ID 628 //
     /* 304752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 304763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 304771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304783 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 304783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 304786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304796 */     GIR_RootConstrainSelectedInstOperands,
     /* 304797 */     // GIR_Coverage, 628,
     /* 304797 */     GIR_EraseRootFromParent_Done,
     /* 304798 */   // Label 6138: @304798
     /* 304798 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(304849), // Rule ID 627 //
     /* 304803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 304814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 304822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304834 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 304834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 304837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304847 */     GIR_RootConstrainSelectedInstOperands,
     /* 304848 */     // GIR_Coverage, 627,
     /* 304848 */     GIR_EraseRootFromParent_Done,
     /* 304849 */   // Label 6139: @304849
     /* 304849 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(304868), // Rule ID 525 //
     /* 304854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304861 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 304861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 304866 */     GIR_RootConstrainSelectedInstOperands,
     /* 304867 */     // GIR_Coverage, 525,
     /* 304867 */     GIR_Done,
     /* 304868 */   // Label 6140: @304868
     /* 304868 */   GIM_Reject,
     /* 304869 */ // Label 6129: @304869
     /* 304869 */ GIM_Reject,
     /* 304870 */ // Label 6109: @304870
     /* 304870 */ GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(305892),
     /* 304875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304882 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(305040), // Rule ID 4838 //
     /* 304887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 304898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 304902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304906 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 304910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304931 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 304935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 304939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304943 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304947 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 304951 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304956 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 304960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304967 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 304967 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 304970 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304974 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304979 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 304985 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304990 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 304998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305007 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 305026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 305034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 305038 */     GIR_RootConstrainSelectedInstOperands,
     /* 305039 */     // GIR_Coverage, 4838,
     /* 305039 */     GIR_EraseRootFromParent_Done,
     /* 305040 */   // Label 6142: @305040
     /* 305040 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(305198), // Rule ID 4837 //
     /* 305045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 305056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305064 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 305068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305084 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305089 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 305093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 305097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305101 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305105 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 305109 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305114 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 305118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305125 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 305125 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 305128 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305132 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305137 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 305143 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305148 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305165 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 305184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 305192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 305196 */     GIR_RootConstrainSelectedInstOperands,
     /* 305197 */     // GIR_Coverage, 4837,
     /* 305197 */     GIR_EraseRootFromParent_Done,
     /* 305198 */   // Label 6143: @305198
     /* 305198 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(305309), // Rule ID 4836 //
     /* 305203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 305214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305222 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 305226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305247 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 305251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305263 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 305263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305275 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 305294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 305303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 305307 */     GIR_RootConstrainSelectedInstOperands,
     /* 305308 */     // GIR_Coverage, 4836,
     /* 305308 */     GIR_EraseRootFromParent_Done,
     /* 305309 */   // Label 6144: @305309
     /* 305309 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(305420), // Rule ID 4834 //
     /* 305314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 305325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305333 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 305337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305363 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 305367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305374 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 305374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305386 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 305392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 305405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 305418 */     GIR_RootConstrainSelectedInstOperands,
     /* 305419 */     // GIR_Coverage, 4834,
     /* 305419 */     GIR_EraseRootFromParent_Done,
     /* 305420 */   // Label 6145: @305420
     /* 305420 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(305531), // Rule ID 4835 //
     /* 305425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 305436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305444 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 305448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305460 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305469 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 305473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305485 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 305485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305497 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 305516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 305525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 305529 */     GIR_RootConstrainSelectedInstOperands,
     /* 305530 */     // GIR_Coverage, 4835,
     /* 305530 */     GIR_EraseRootFromParent_Done,
     /* 305531 */   // Label 6146: @305531
     /* 305531 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(305642), // Rule ID 4833 //
     /* 305536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 305547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305555 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 305559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305585 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 305589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305596 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 305596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305608 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 305614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 305627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 305640 */     GIR_RootConstrainSelectedInstOperands,
     /* 305641 */     // GIR_Coverage, 4833,
     /* 305641 */     GIR_EraseRootFromParent_Done,
     /* 305642 */   // Label 6147: @305642
     /* 305642 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(305706), // Rule ID 654 //
     /* 305647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 305658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305666 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 305670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305687 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 305687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 305690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 305700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 305704 */     GIR_RootConstrainSelectedInstOperands,
     /* 305705 */     // GIR_Coverage, 654,
     /* 305705 */     GIR_EraseRootFromParent_Done,
     /* 305706 */   // Label 6148: @305706
     /* 305706 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(305770), // Rule ID 653 //
     /* 305711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 305722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305730 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 305734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305751 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 305751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 305754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 305764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 305768 */     GIR_RootConstrainSelectedInstOperands,
     /* 305769 */     // GIR_Coverage, 653,
     /* 305769 */     GIR_EraseRootFromParent_Done,
     /* 305770 */   // Label 6149: @305770
     /* 305770 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(305821), // Rule ID 630 //
     /* 305775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 305786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305806 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 305806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 305809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 305819 */     GIR_RootConstrainSelectedInstOperands,
     /* 305820 */     // GIR_Coverage, 630,
     /* 305820 */     GIR_EraseRootFromParent_Done,
     /* 305821 */   // Label 6150: @305821
     /* 305821 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(305872), // Rule ID 629 //
     /* 305826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 305837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 305841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305857 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 305857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 305860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 305870 */     GIR_RootConstrainSelectedInstOperands,
     /* 305871 */     // GIR_Coverage, 629,
     /* 305871 */     GIR_EraseRootFromParent_Done,
     /* 305872 */   // Label 6151: @305872
     /* 305872 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(305891), // Rule ID 526 //
     /* 305877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 305880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305884 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 305884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 305889 */     GIR_RootConstrainSelectedInstOperands,
     /* 305890 */     // GIR_Coverage, 526,
     /* 305890 */     GIR_Done,
     /* 305891 */   // Label 6152: @305891
     /* 305891 */   GIM_Reject,
     /* 305892 */ // Label 6141: @305892
     /* 305892 */ GIM_Reject,
     /* 305893 */ // Label 6110: @305893
     /* 305893 */ GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(305919), // Rule ID 853 //
     /* 305898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 305904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305912 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 305912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 305917 */   GIR_RootConstrainSelectedInstOperands,
     /* 305918 */   // GIR_Coverage, 853,
     /* 305918 */   GIR_Done,
     /* 305919 */ // Label 6153: @305919
     /* 305919 */ GIM_Reject,
     /* 305920 */ // Label 6111: @305920
     /* 305920 */ GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(305946), // Rule ID 855 //
     /* 305925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305939 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 305939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 305944 */   GIR_RootConstrainSelectedInstOperands,
     /* 305945 */   // GIR_Coverage, 855,
     /* 305945 */   GIR_Done,
     /* 305946 */ // Label 6154: @305946
     /* 305946 */ GIM_Reject,
     /* 305947 */ // Label 6112: @305947
     /* 305947 */ GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(306026),
     /* 305952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305963 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(305978), // Rule ID 851 //
     /* 305968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305971 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 305971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 305976 */     GIR_RootConstrainSelectedInstOperands,
     /* 305977 */     // GIR_Coverage, 851,
     /* 305977 */     GIR_Done,
     /* 305978 */   // Label 6156: @305978
     /* 305978 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(306025), // Rule ID 6331 //
     /* 305983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305986 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 305986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 305989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 305993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305998 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 306008 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 306011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 306016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306023 */     GIR_RootConstrainSelectedInstOperands,
     /* 306024 */     // GIR_Coverage, 6331,
     /* 306024 */     GIR_EraseRootFromParent_Done,
     /* 306025 */   // Label 6157: @306025
     /* 306025 */   GIM_Reject,
     /* 306026 */ // Label 6155: @306026
     /* 306026 */ GIM_Reject,
     /* 306027 */ // Label 6113: @306027
     /* 306027 */ GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(306053), // Rule ID 854 //
     /* 306032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306046 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 306046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 306051 */   GIR_RootConstrainSelectedInstOperands,
     /* 306052 */   // GIR_Coverage, 854,
     /* 306052 */   GIR_Done,
     /* 306053 */ // Label 6158: @306053
     /* 306053 */ GIM_Reject,
     /* 306054 */ // Label 6114: @306054
     /* 306054 */ GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(306133),
     /* 306059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306070 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(306085), // Rule ID 852 //
     /* 306075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306078 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 306078 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 306083 */     GIR_RootConstrainSelectedInstOperands,
     /* 306084 */     // GIR_Coverage, 852,
     /* 306084 */     GIR_Done,
     /* 306085 */   // Label 6160: @306085
     /* 306085 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(306132), // Rule ID 6332 //
     /* 306090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306093 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 306093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 306100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306105 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 306115 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 306118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 306120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 306123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306130 */     GIR_RootConstrainSelectedInstOperands,
     /* 306131 */     // GIR_Coverage, 6332,
     /* 306131 */     GIR_EraseRootFromParent_Done,
     /* 306132 */   // Label 6161: @306132
     /* 306132 */   GIM_Reject,
     /* 306133 */ // Label 6159: @306133
     /* 306133 */ GIM_Reject,
     /* 306134 */ // Label 6115: @306134
     /* 306134 */ GIM_Reject,
     /* 306135 */ // Label 63: @306135
     /* 306135 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6166*/ GIMT_Encode4(306382),
     /* 306146 */ /*GILLT_s32*//*Label 6162*/ GIMT_Encode4(306174),
     /* 306150 */ /*GILLT_s64*//*Label 6163*/ GIMT_Encode4(306205), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 306162 */ /*GILLT_v2s64*//*Label 6164*/ GIMT_Encode4(306266), GIMT_Encode4(0),
     /* 306170 */ /*GILLT_v4s32*//*Label 6165*/ GIMT_Encode4(306324),
     /* 306174 */ // Label 6162: @306174
     /* 306174 */ GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(306204), // Rule ID 516 //
     /* 306179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 306185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306193 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 306193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 306198 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306202 */   GIR_RootConstrainSelectedInstOperands,
     /* 306203 */   // GIR_Coverage, 516,
     /* 306203 */   GIR_Done,
     /* 306204 */ // Label 6167: @306204
     /* 306204 */ GIM_Reject,
     /* 306205 */ // Label 6163: @306205
     /* 306205 */ GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(306235), // Rule ID 514 //
     /* 306210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 306216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306224 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 306224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 306229 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306233 */   GIR_RootConstrainSelectedInstOperands,
     /* 306234 */   // GIR_Coverage, 514,
     /* 306234 */   GIR_Done,
     /* 306235 */ // Label 6168: @306235
     /* 306235 */ GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(306265), // Rule ID 518 //
     /* 306240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306254 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 306254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 306259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306263 */   GIR_RootConstrainSelectedInstOperands,
     /* 306264 */   // GIR_Coverage, 518,
     /* 306264 */   GIR_Done,
     /* 306265 */ // Label 6169: @306265
     /* 306265 */ GIM_Reject,
     /* 306266 */ // Label 6164: @306266
     /* 306266 */ GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(306323),
     /* 306271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 306274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306278 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(306302), // Rule ID 4881 //
     /* 306283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 306290 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 306290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 306293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 306300 */     GIR_RootConstrainSelectedInstOperands,
     /* 306301 */     // GIR_Coverage, 4881,
     /* 306301 */     GIR_EraseRootFromParent_Done,
     /* 306302 */   // Label 6171: @306302
     /* 306302 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(306322), // Rule ID 4879 //
     /* 306307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306311 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 306311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 306316 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306320 */     GIR_RootConstrainSelectedInstOperands,
     /* 306321 */     // GIR_Coverage, 4879,
     /* 306321 */     GIR_Done,
     /* 306322 */   // Label 6172: @306322
     /* 306322 */   GIM_Reject,
     /* 306323 */ // Label 6170: @306323
     /* 306323 */ GIM_Reject,
     /* 306324 */ // Label 6165: @306324
     /* 306324 */ GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(306381),
     /* 306329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 306332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306336 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(306360), // Rule ID 4885 //
     /* 306341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 306348 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 306348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 306351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 306358 */     GIR_RootConstrainSelectedInstOperands,
     /* 306359 */     // GIR_Coverage, 4885,
     /* 306359 */     GIR_EraseRootFromParent_Done,
     /* 306360 */   // Label 6174: @306360
     /* 306360 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(306380), // Rule ID 4883 //
     /* 306365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306369 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 306369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 306374 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306378 */     GIR_RootConstrainSelectedInstOperands,
     /* 306379 */     // GIR_Coverage, 4883,
     /* 306379 */     GIR_Done,
     /* 306380 */   // Label 6175: @306380
     /* 306380 */   GIM_Reject,
     /* 306381 */ // Label 6173: @306381
     /* 306381 */ GIM_Reject,
     /* 306382 */ // Label 6166: @306382
     /* 306382 */ GIM_Reject,
     /* 306383 */ // Label 64: @306383
     /* 306383 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6180*/ GIMT_Encode4(306570),
     /* 306394 */ /*GILLT_s16*//*Label 6176*/ GIMT_Encode4(306422),
     /* 306398 */ /*GILLT_s32*//*Label 6177*/ GIMT_Encode4(306483), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 306410 */ /*GILLT_v2s32*//*Label 6178*/ GIMT_Encode4(306514), GIMT_Encode4(0),
     /* 306418 */ /*GILLT_v4s16*//*Label 6179*/ GIMT_Encode4(306542),
     /* 306422 */ // Label 6176: @306422
     /* 306422 */ GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(306452), // Rule ID 510 //
     /* 306427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306441 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 306441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 306446 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306450 */   GIR_RootConstrainSelectedInstOperands,
     /* 306451 */   // GIR_Coverage, 510,
     /* 306451 */   GIR_Done,
     /* 306452 */ // Label 6181: @306452
     /* 306452 */ GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(306482), // Rule ID 520 //
     /* 306457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306471 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 306471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 306476 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306480 */   GIR_RootConstrainSelectedInstOperands,
     /* 306481 */   // GIR_Coverage, 520,
     /* 306481 */   GIR_Done,
     /* 306482 */ // Label 6182: @306482
     /* 306482 */ GIM_Reject,
     /* 306483 */ // Label 6177: @306483
     /* 306483 */ GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(306513), // Rule ID 512 //
     /* 306488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306502 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 306502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 306507 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306511 */   GIR_RootConstrainSelectedInstOperands,
     /* 306512 */   // GIR_Coverage, 512,
     /* 306512 */   GIR_Done,
     /* 306513 */ // Label 6183: @306513
     /* 306513 */ GIM_Reject,
     /* 306514 */ // Label 6178: @306514
     /* 306514 */ GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(306541), // Rule ID 4889 //
     /* 306519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306530 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 306530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 306535 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306539 */   GIR_RootConstrainSelectedInstOperands,
     /* 306540 */   // GIR_Coverage, 4889,
     /* 306540 */   GIR_Done,
     /* 306541 */ // Label 6184: @306541
     /* 306541 */ GIM_Reject,
     /* 306542 */ // Label 6179: @306542
     /* 306542 */ GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(306569), // Rule ID 4891 //
     /* 306547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306558 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 306558 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 306563 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306567 */   GIR_RootConstrainSelectedInstOperands,
     /* 306568 */   // GIR_Coverage, 4891,
     /* 306568 */   GIR_Done,
     /* 306569 */ // Label 6185: @306569
     /* 306569 */ GIM_Reject,
     /* 306570 */ // Label 6180: @306570
     /* 306570 */ GIM_Reject,
     /* 306571 */ // Label 65: @306571
     /* 306571 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6193*/ GIMT_Encode4(307633),
     /* 306582 */ /*GILLT_s32*//*Label 6186*/ GIMT_Encode4(306618),
     /* 306586 */ /*GILLT_s64*//*Label 6187*/ GIMT_Encode4(307005), GIMT_Encode4(0),
     /* 306594 */ /*GILLT_v2s32*//*Label 6188*/ GIMT_Encode4(307392),
     /* 306598 */ /*GILLT_v2s64*//*Label 6189*/ GIMT_Encode4(307466),
     /* 306602 */ /*GILLT_v4s16*//*Label 6190*/ GIMT_Encode4(307540),
     /* 306606 */ /*GILLT_v4s32*//*Label 6191*/ GIMT_Encode4(307571), GIMT_Encode4(0),
     /* 306614 */ /*GILLT_v8s16*//*Label 6192*/ GIMT_Encode4(307602),
     /* 306618 */ // Label 6186: @306618
     /* 306618 */ GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(306655), // Rule ID 4628 //
     /* 306623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306630 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306634 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 306638 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306642 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306644 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 306644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 306647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306649 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306653 */   GIR_RootConstrainSelectedInstOperands,
     /* 306654 */   // GIR_Coverage, 4628,
     /* 306654 */   GIR_EraseRootFromParent_Done,
     /* 306655 */ // Label 6194: @306655
     /* 306655 */ GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(306692), // Rule ID 4630 //
     /* 306660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 306675 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 306679 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306681 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 306681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 306684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306686 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306690 */   GIR_RootConstrainSelectedInstOperands,
     /* 306691 */   // GIR_Coverage, 4630,
     /* 306691 */   GIR_EraseRootFromParent_Done,
     /* 306692 */ // Label 6195: @306692
     /* 306692 */ GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(306729), // Rule ID 4648 //
     /* 306697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 306712 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306716 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306718 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 306718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 306721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306723 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306727 */   GIR_RootConstrainSelectedInstOperands,
     /* 306728 */   // GIR_Coverage, 4648,
     /* 306728 */   GIR_EraseRootFromParent_Done,
     /* 306729 */ // Label 6196: @306729
     /* 306729 */ GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(306766), // Rule ID 4650 //
     /* 306734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306741 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306745 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 306749 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 306753 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306755 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 306755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 306758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306760 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306764 */   GIR_RootConstrainSelectedInstOperands,
     /* 306765 */   // GIR_Coverage, 4650,
     /* 306765 */   GIR_EraseRootFromParent_Done,
     /* 306766 */ // Label 6197: @306766
     /* 306766 */ GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(306803), // Rule ID 4688 //
     /* 306771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306778 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306782 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 306786 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306790 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306792 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 306792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 306795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306797 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306801 */   GIR_RootConstrainSelectedInstOperands,
     /* 306802 */   // GIR_Coverage, 4688,
     /* 306802 */   GIR_EraseRootFromParent_Done,
     /* 306803 */ // Label 6198: @306803
     /* 306803 */ GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(306840), // Rule ID 4690 //
     /* 306808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306815 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 306823 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 306827 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306829 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 306829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 306832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306834 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306838 */   GIR_RootConstrainSelectedInstOperands,
     /* 306839 */   // GIR_Coverage, 4690,
     /* 306839 */   GIR_EraseRootFromParent_Done,
     /* 306840 */ // Label 6199: @306840
     /* 306840 */ GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(306877), // Rule ID 4668 //
     /* 306845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306852 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 306860 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306864 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306866 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 306866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 306869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306871 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306875 */   GIR_RootConstrainSelectedInstOperands,
     /* 306876 */   // GIR_Coverage, 4668,
     /* 306876 */   GIR_EraseRootFromParent_Done,
     /* 306877 */ // Label 6200: @306877
     /* 306877 */ GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(306914), // Rule ID 4670 //
     /* 306882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306889 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306893 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 306897 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 306901 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306903 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 306903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 306906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306908 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306912 */   GIR_RootConstrainSelectedInstOperands,
     /* 306913 */   // GIR_Coverage, 4670,
     /* 306913 */   GIR_EraseRootFromParent_Done,
     /* 306914 */ // Label 6201: @306914
     /* 306914 */ GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(306944), // Rule ID 395 //
     /* 306919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 306925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306933 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 306933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 306938 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306942 */   GIR_RootConstrainSelectedInstOperands,
     /* 306943 */   // GIR_Coverage, 395,
     /* 306943 */   GIR_Done,
     /* 306944 */ // Label 6202: @306944
     /* 306944 */ GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(306974), // Rule ID 399 //
     /* 306949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306963 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 306963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 306968 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306972 */   GIR_RootConstrainSelectedInstOperands,
     /* 306973 */   // GIR_Coverage, 399,
     /* 306973 */   GIR_Done,
     /* 306974 */ // Label 6203: @306974
     /* 306974 */ GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(307004), // Rule ID 403 //
     /* 306979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 306989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306993 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 306993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 306998 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307002 */   GIR_RootConstrainSelectedInstOperands,
     /* 307003 */   // GIR_Coverage, 403,
     /* 307003 */   GIR_Done,
     /* 307004 */ // Label 6204: @307004
     /* 307004 */ GIM_Reject,
     /* 307005 */ // Label 6187: @307005
     /* 307005 */ GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(307042), // Rule ID 4629 //
     /* 307010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 307025 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307029 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307031 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 307031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 307034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307036 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307040 */   GIR_RootConstrainSelectedInstOperands,
     /* 307041 */   // GIR_Coverage, 4629,
     /* 307041 */   GIR_EraseRootFromParent_Done,
     /* 307042 */ // Label 6205: @307042
     /* 307042 */ GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(307079), // Rule ID 4631 //
     /* 307047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307054 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307058 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 307062 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307066 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307068 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 307068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 307071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307073 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307077 */   GIR_RootConstrainSelectedInstOperands,
     /* 307078 */   // GIR_Coverage, 4631,
     /* 307078 */   GIR_EraseRootFromParent_Done,
     /* 307079 */ // Label 6206: @307079
     /* 307079 */ GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(307116), // Rule ID 4649 //
     /* 307084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 307099 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307105 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 307105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 307108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307110 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307114 */   GIR_RootConstrainSelectedInstOperands,
     /* 307115 */   // GIR_Coverage, 4649,
     /* 307115 */   GIR_EraseRootFromParent_Done,
     /* 307116 */ // Label 6207: @307116
     /* 307116 */ GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(307153), // Rule ID 4651 //
     /* 307121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 307136 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307140 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307142 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 307142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 307145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307147 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307151 */   GIR_RootConstrainSelectedInstOperands,
     /* 307152 */   // GIR_Coverage, 4651,
     /* 307152 */   GIR_EraseRootFromParent_Done,
     /* 307153 */ // Label 6208: @307153
     /* 307153 */ GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(307190), // Rule ID 4689 //
     /* 307158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307165 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307169 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 307173 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307177 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307179 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 307179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 307182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307184 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307188 */   GIR_RootConstrainSelectedInstOperands,
     /* 307189 */   // GIR_Coverage, 4689,
     /* 307189 */   GIR_EraseRootFromParent_Done,
     /* 307190 */ // Label 6209: @307190
     /* 307190 */ GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(307227), // Rule ID 4691 //
     /* 307195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307202 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307206 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 307210 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307214 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307216 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 307216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 307219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307221 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307225 */   GIR_RootConstrainSelectedInstOperands,
     /* 307226 */   // GIR_Coverage, 4691,
     /* 307226 */   GIR_EraseRootFromParent_Done,
     /* 307227 */ // Label 6210: @307227
     /* 307227 */ GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(307264), // Rule ID 4669 //
     /* 307232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307239 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307243 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 307247 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307251 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307253 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 307253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 307256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307258 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307262 */   GIR_RootConstrainSelectedInstOperands,
     /* 307263 */   // GIR_Coverage, 4669,
     /* 307263 */   GIR_EraseRootFromParent_Done,
     /* 307264 */ // Label 6211: @307264
     /* 307264 */ GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(307301), // Rule ID 4671 //
     /* 307269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307276 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307280 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 307284 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307288 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307290 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 307290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 307293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307295 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307299 */   GIR_RootConstrainSelectedInstOperands,
     /* 307300 */   // GIR_Coverage, 4671,
     /* 307300 */   GIR_EraseRootFromParent_Done,
     /* 307301 */ // Label 6212: @307301
     /* 307301 */ GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(307331), // Rule ID 397 //
     /* 307306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307320 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 307320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 307325 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307329 */   GIR_RootConstrainSelectedInstOperands,
     /* 307330 */   // GIR_Coverage, 397,
     /* 307330 */   GIR_Done,
     /* 307331 */ // Label 6213: @307331
     /* 307331 */ GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(307361), // Rule ID 401 //
     /* 307336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307350 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 307350 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 307355 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307359 */   GIR_RootConstrainSelectedInstOperands,
     /* 307360 */   // GIR_Coverage, 401,
     /* 307360 */   GIR_Done,
     /* 307361 */ // Label 6214: @307361
     /* 307361 */ GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(307391), // Rule ID 405 //
     /* 307366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 307376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307380 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 307380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 307385 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307389 */   GIR_RootConstrainSelectedInstOperands,
     /* 307390 */   // GIR_Coverage, 405,
     /* 307390 */   GIR_Done,
     /* 307391 */ // Label 6215: @307391
     /* 307391 */ GIM_Reject,
     /* 307392 */ // Label 6188: @307392
     /* 307392 */ GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(307422), // Rule ID 836 //
     /* 307397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 307403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307411 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 307411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 307416 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307420 */   GIR_RootConstrainSelectedInstOperands,
     /* 307421 */   // GIR_Coverage, 836,
     /* 307421 */   GIR_Done,
     /* 307422 */ // Label 6216: @307422
     /* 307422 */ GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(307465), // Rule ID 13029 //
     /* 307427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307437 */   // (fp_to_sint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZSv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
     /* 307437 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 307440 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 307444 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307449 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 307453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 307455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 307458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307460 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307463 */   GIR_RootConstrainSelectedInstOperands,
     /* 307464 */   // GIR_Coverage, 13029,
     /* 307464 */   GIR_EraseRootFromParent_Done,
     /* 307465 */ // Label 6217: @307465
     /* 307465 */ GIM_Reject,
     /* 307466 */ // Label 6189: @307466
     /* 307466 */ GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(307496), // Rule ID 840 //
     /* 307471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307485 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 307485 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 307490 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307494 */   GIR_RootConstrainSelectedInstOperands,
     /* 307495 */   // GIR_Coverage, 840,
     /* 307495 */   GIR_Done,
     /* 307496 */ // Label 6218: @307496
     /* 307496 */ GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(307539), // Rule ID 13027 //
     /* 307501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 307507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307511 */   // (fp_to_sint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZSv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
     /* 307511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 307514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 307518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307523 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 307527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 307529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 307532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307537 */   GIR_RootConstrainSelectedInstOperands,
     /* 307538 */   // GIR_Coverage, 13027,
     /* 307538 */   GIR_EraseRootFromParent_Done,
     /* 307539 */ // Label 6219: @307539
     /* 307539 */ GIM_Reject,
     /* 307540 */ // Label 6190: @307540
     /* 307540 */ GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(307570), // Rule ID 832 //
     /* 307545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 307551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307559 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 307559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 307564 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307568 */   GIR_RootConstrainSelectedInstOperands,
     /* 307569 */   // GIR_Coverage, 832,
     /* 307569 */   GIR_Done,
     /* 307570 */ // Label 6220: @307570
     /* 307570 */ GIM_Reject,
     /* 307571 */ // Label 6191: @307571
     /* 307571 */ GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(307601), // Rule ID 838 //
     /* 307576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307590 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 307590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 307595 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307599 */   GIR_RootConstrainSelectedInstOperands,
     /* 307600 */   // GIR_Coverage, 838,
     /* 307600 */   GIR_Done,
     /* 307601 */ // Label 6221: @307601
     /* 307601 */ GIM_Reject,
     /* 307602 */ // Label 6192: @307602
     /* 307602 */ GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(307632), // Rule ID 834 //
     /* 307607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307621 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 307621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 307626 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307630 */   GIR_RootConstrainSelectedInstOperands,
     /* 307631 */   // GIR_Coverage, 834,
     /* 307631 */   GIR_Done,
     /* 307632 */ // Label 6222: @307632
     /* 307632 */ GIM_Reject,
     /* 307633 */ // Label 6193: @307633
     /* 307633 */ GIM_Reject,
     /* 307634 */ // Label 66: @307634
     /* 307634 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6230*/ GIMT_Encode4(308696),
     /* 307645 */ /*GILLT_s32*//*Label 6223*/ GIMT_Encode4(307681),
     /* 307649 */ /*GILLT_s64*//*Label 6224*/ GIMT_Encode4(308068), GIMT_Encode4(0),
     /* 307657 */ /*GILLT_v2s32*//*Label 6225*/ GIMT_Encode4(308455),
     /* 307661 */ /*GILLT_v2s64*//*Label 6226*/ GIMT_Encode4(308529),
     /* 307665 */ /*GILLT_v4s16*//*Label 6227*/ GIMT_Encode4(308603),
     /* 307669 */ /*GILLT_v4s32*//*Label 6228*/ GIMT_Encode4(308634), GIMT_Encode4(0),
     /* 307677 */ /*GILLT_v8s16*//*Label 6229*/ GIMT_Encode4(308665),
     /* 307681 */ // Label 6223: @307681
     /* 307681 */ GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(307718), // Rule ID 4638 //
     /* 307686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 307693 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307697 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 307701 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307705 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307707 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 307707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 307710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307712 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307716 */   GIR_RootConstrainSelectedInstOperands,
     /* 307717 */   // GIR_Coverage, 4638,
     /* 307717 */   GIR_EraseRootFromParent_Done,
     /* 307718 */ // Label 6231: @307718
     /* 307718 */ GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(307755), // Rule ID 4640 //
     /* 307723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 307730 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307734 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 307738 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307742 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307744 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 307744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 307747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307749 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307753 */   GIR_RootConstrainSelectedInstOperands,
     /* 307754 */   // GIR_Coverage, 4640,
     /* 307754 */   GIR_EraseRootFromParent_Done,
     /* 307755 */ // Label 6232: @307755
     /* 307755 */ GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(307792), // Rule ID 4658 //
     /* 307760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 307767 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307771 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 307775 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307781 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 307781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 307784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307786 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307790 */   GIR_RootConstrainSelectedInstOperands,
     /* 307791 */   // GIR_Coverage, 4658,
     /* 307791 */   GIR_EraseRootFromParent_Done,
     /* 307792 */ // Label 6233: @307792
     /* 307792 */ GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(307829), // Rule ID 4660 //
     /* 307797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 307804 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 307812 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307816 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307818 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 307818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 307821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307823 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307827 */   GIR_RootConstrainSelectedInstOperands,
     /* 307828 */   // GIR_Coverage, 4660,
     /* 307828 */   GIR_EraseRootFromParent_Done,
     /* 307829 */ // Label 6234: @307829
     /* 307829 */ GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(307866), // Rule ID 4698 //
     /* 307834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 307841 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307845 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 307849 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307853 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307855 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 307855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 307858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307860 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307864 */   GIR_RootConstrainSelectedInstOperands,
     /* 307865 */   // GIR_Coverage, 4698,
     /* 307865 */   GIR_EraseRootFromParent_Done,
     /* 307866 */ // Label 6235: @307866
     /* 307866 */ GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(307903), // Rule ID 4700 //
     /* 307871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 307878 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 307886 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307890 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307892 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 307892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 307895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307897 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307901 */   GIR_RootConstrainSelectedInstOperands,
     /* 307902 */   // GIR_Coverage, 4700,
     /* 307902 */   GIR_EraseRootFromParent_Done,
     /* 307903 */ // Label 6236: @307903
     /* 307903 */ GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(307940), // Rule ID 4678 //
     /* 307908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 307915 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307919 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 307923 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307927 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307929 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 307929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 307932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307934 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307938 */   GIR_RootConstrainSelectedInstOperands,
     /* 307939 */   // GIR_Coverage, 4678,
     /* 307939 */   GIR_EraseRootFromParent_Done,
     /* 307940 */ // Label 6237: @307940
     /* 307940 */ GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(307977), // Rule ID 4680 //
     /* 307945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 307948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 307952 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307956 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 307960 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307964 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307966 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 307966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 307969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307971 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307975 */   GIR_RootConstrainSelectedInstOperands,
     /* 307976 */   // GIR_Coverage, 4680,
     /* 307976 */   GIR_EraseRootFromParent_Done,
     /* 307977 */ // Label 6238: @307977
     /* 307977 */ GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(308007), // Rule ID 407 //
     /* 307982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 307992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307996 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 307996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 308001 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308005 */   GIR_RootConstrainSelectedInstOperands,
     /* 308006 */   // GIR_Coverage, 407,
     /* 308006 */   GIR_Done,
     /* 308007 */ // Label 6239: @308007
     /* 308007 */ GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(308037), // Rule ID 411 //
     /* 308012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 308022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308026 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 308026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 308031 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308035 */   GIR_RootConstrainSelectedInstOperands,
     /* 308036 */   // GIR_Coverage, 411,
     /* 308036 */   GIR_Done,
     /* 308037 */ // Label 6240: @308037
     /* 308037 */ GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(308067), // Rule ID 415 //
     /* 308042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 308052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308056 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 308056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 308061 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308065 */   GIR_RootConstrainSelectedInstOperands,
     /* 308066 */   // GIR_Coverage, 415,
     /* 308066 */   GIR_Done,
     /* 308067 */ // Label 6241: @308067
     /* 308067 */ GIM_Reject,
     /* 308068 */ // Label 6224: @308068
     /* 308068 */ GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(308105), // Rule ID 4639 //
     /* 308073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 308080 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308084 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 308088 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308092 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308094 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 308094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 308097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308099 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308103 */   GIR_RootConstrainSelectedInstOperands,
     /* 308104 */   // GIR_Coverage, 4639,
     /* 308104 */   GIR_EraseRootFromParent_Done,
     /* 308105 */ // Label 6242: @308105
     /* 308105 */ GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(308142), // Rule ID 4641 //
     /* 308110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 308117 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308121 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 308125 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308129 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308131 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 308131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 308134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308136 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308140 */   GIR_RootConstrainSelectedInstOperands,
     /* 308141 */   // GIR_Coverage, 4641,
     /* 308141 */   GIR_EraseRootFromParent_Done,
     /* 308142 */ // Label 6243: @308142
     /* 308142 */ GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(308179), // Rule ID 4659 //
     /* 308147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 308154 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308158 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 308162 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308166 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308168 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 308168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 308171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308173 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308177 */   GIR_RootConstrainSelectedInstOperands,
     /* 308178 */   // GIR_Coverage, 4659,
     /* 308178 */   GIR_EraseRootFromParent_Done,
     /* 308179 */ // Label 6244: @308179
     /* 308179 */ GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(308216), // Rule ID 4661 //
     /* 308184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 308191 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308195 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 308199 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308203 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308205 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 308205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 308208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308210 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308214 */   GIR_RootConstrainSelectedInstOperands,
     /* 308215 */   // GIR_Coverage, 4661,
     /* 308215 */   GIR_EraseRootFromParent_Done,
     /* 308216 */ // Label 6245: @308216
     /* 308216 */ GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(308253), // Rule ID 4699 //
     /* 308221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 308228 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 308236 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308240 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308242 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 308242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 308245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308247 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308251 */   GIR_RootConstrainSelectedInstOperands,
     /* 308252 */   // GIR_Coverage, 4699,
     /* 308252 */   GIR_EraseRootFromParent_Done,
     /* 308253 */ // Label 6246: @308253
     /* 308253 */ GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(308290), // Rule ID 4701 //
     /* 308258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 308265 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308269 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 308273 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308277 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308279 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 308279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 308282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308284 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308288 */   GIR_RootConstrainSelectedInstOperands,
     /* 308289 */   // GIR_Coverage, 4701,
     /* 308289 */   GIR_EraseRootFromParent_Done,
     /* 308290 */ // Label 6247: @308290
     /* 308290 */ GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(308327), // Rule ID 4679 //
     /* 308295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 308302 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308306 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 308310 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308316 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 308316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 308319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308321 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308325 */   GIR_RootConstrainSelectedInstOperands,
     /* 308326 */   // GIR_Coverage, 4679,
     /* 308326 */   GIR_EraseRootFromParent_Done,
     /* 308327 */ // Label 6248: @308327
     /* 308327 */ GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(308364), // Rule ID 4681 //
     /* 308332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 308339 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 308347 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308351 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308353 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 308353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 308356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308358 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308362 */   GIR_RootConstrainSelectedInstOperands,
     /* 308363 */   // GIR_Coverage, 4681,
     /* 308363 */   GIR_EraseRootFromParent_Done,
     /* 308364 */ // Label 6249: @308364
     /* 308364 */ GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(308394), // Rule ID 409 //
     /* 308369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 308379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308383 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 308383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 308388 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308392 */   GIR_RootConstrainSelectedInstOperands,
     /* 308393 */   // GIR_Coverage, 409,
     /* 308393 */   GIR_Done,
     /* 308394 */ // Label 6250: @308394
     /* 308394 */ GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(308424), // Rule ID 413 //
     /* 308399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 308409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308413 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 308413 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 308418 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308422 */   GIR_RootConstrainSelectedInstOperands,
     /* 308423 */   // GIR_Coverage, 413,
     /* 308423 */   GIR_Done,
     /* 308424 */ // Label 6251: @308424
     /* 308424 */ GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(308454), // Rule ID 417 //
     /* 308429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 308439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308443 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 308443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 308448 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308452 */   GIR_RootConstrainSelectedInstOperands,
     /* 308453 */   // GIR_Coverage, 417,
     /* 308453 */   GIR_Done,
     /* 308454 */ // Label 6252: @308454
     /* 308454 */ GIM_Reject,
     /* 308455 */ // Label 6225: @308455
     /* 308455 */ GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(308485), // Rule ID 846 //
     /* 308460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 308466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308474 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 308474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 308479 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308483 */   GIR_RootConstrainSelectedInstOperands,
     /* 308484 */   // GIR_Coverage, 846,
     /* 308484 */   GIR_Done,
     /* 308485 */ // Label 6253: @308485
     /* 308485 */ GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(308528), // Rule ID 13030 //
     /* 308490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308500 */   // (fp_to_uint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZUv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
     /* 308500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 308503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 308507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308512 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 308516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 308518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 308521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308526 */   GIR_RootConstrainSelectedInstOperands,
     /* 308527 */   // GIR_Coverage, 13030,
     /* 308527 */   GIR_EraseRootFromParent_Done,
     /* 308528 */ // Label 6254: @308528
     /* 308528 */ GIM_Reject,
     /* 308529 */ // Label 6226: @308529
     /* 308529 */ GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(308559), // Rule ID 850 //
     /* 308534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308548 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 308548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 308553 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308557 */   GIR_RootConstrainSelectedInstOperands,
     /* 308558 */   // GIR_Coverage, 850,
     /* 308558 */   GIR_Done,
     /* 308559 */ // Label 6255: @308559
     /* 308559 */ GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(308602), // Rule ID 13028 //
     /* 308564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 308570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308574 */   // (fp_to_uint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZUv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
     /* 308574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 308577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 308581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308586 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 308590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 308592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 308595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308600 */   GIR_RootConstrainSelectedInstOperands,
     /* 308601 */   // GIR_Coverage, 13028,
     /* 308601 */   GIR_EraseRootFromParent_Done,
     /* 308602 */ // Label 6256: @308602
     /* 308602 */ GIM_Reject,
     /* 308603 */ // Label 6227: @308603
     /* 308603 */ GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(308633), // Rule ID 842 //
     /* 308608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 308614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308622 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 308622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 308627 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308631 */   GIR_RootConstrainSelectedInstOperands,
     /* 308632 */   // GIR_Coverage, 842,
     /* 308632 */   GIR_Done,
     /* 308633 */ // Label 6257: @308633
     /* 308633 */ GIM_Reject,
     /* 308634 */ // Label 6228: @308634
     /* 308634 */ GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(308664), // Rule ID 848 //
     /* 308639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308653 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 308653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 308658 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308662 */   GIR_RootConstrainSelectedInstOperands,
     /* 308663 */   // GIR_Coverage, 848,
     /* 308663 */   GIR_Done,
     /* 308664 */ // Label 6258: @308664
     /* 308664 */ GIM_Reject,
     /* 308665 */ // Label 6229: @308665
     /* 308665 */ GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(308695), // Rule ID 844 //
     /* 308670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308684 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 308684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 308689 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308693 */   GIR_RootConstrainSelectedInstOperands,
     /* 308694 */   // GIR_Coverage, 844,
     /* 308694 */   GIR_Done,
     /* 308695 */ // Label 6259: @308695
     /* 308695 */ GIM_Reject,
     /* 308696 */ // Label 6230: @308696
     /* 308696 */ GIM_Reject,
     /* 308697 */ // Label 67: @308697
     /* 308697 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6268*/ GIMT_Encode4(313093),
     /* 308708 */ /*GILLT_s16*//*Label 6260*/ GIMT_Encode4(308748),
     /* 308712 */ /*GILLT_s32*//*Label 6261*/ GIMT_Encode4(309029),
     /* 308716 */ /*GILLT_s64*//*Label 6262*/ GIMT_Encode4(310945), GIMT_Encode4(0),
     /* 308724 */ /*GILLT_v2s32*//*Label 6263*/ GIMT_Encode4(312849),
     /* 308728 */ /*GILLT_v2s64*//*Label 6264*/ GIMT_Encode4(312923),
     /* 308732 */ /*GILLT_v4s16*//*Label 6265*/ GIMT_Encode4(313000),
     /* 308736 */ /*GILLT_v4s32*//*Label 6266*/ GIMT_Encode4(313031), GIMT_Encode4(0),
     /* 308744 */ /*GILLT_v8s16*//*Label 6267*/ GIMT_Encode4(313062),
     /* 308748 */ // Label 6260: @308748
     /* 308748 */ GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(308851), // Rule ID 5298 //
     /* 308753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 308756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308763 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308767 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 308771 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308775 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308779 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308783 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308787 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308791 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308796 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308800 */   // MIs[1] Operand 2
     /* 308800 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 308811 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308813 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 308813 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308816 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308820 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308825 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 308831 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308836 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 308844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308846 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308849 */   GIR_RootConstrainSelectedInstOperands,
     /* 308850 */   // GIR_Coverage, 5298,
     /* 308850 */   GIR_EraseRootFromParent_Done,
     /* 308851 */ // Label 6269: @308851
     /* 308851 */ GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(308908), // Rule ID 5289 //
     /* 308856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 308859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308866 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 308874 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308878 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308880 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 308880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 308883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 308887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308892 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 308898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 308901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308903 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308906 */   GIR_RootConstrainSelectedInstOperands,
     /* 308907 */   // GIR_Coverage, 5289,
     /* 308907 */   GIR_EraseRootFromParent_Done,
     /* 308908 */ // Label 6270: @308908
     /* 308908 */ GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(308938), // Rule ID 443 //
     /* 308913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 308927 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 308927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 308932 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308936 */   GIR_RootConstrainSelectedInstOperands,
     /* 308937 */   // GIR_Coverage, 443,
     /* 308937 */   GIR_Done,
     /* 308938 */ // Label 6271: @308938
     /* 308938 */ GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(308968), // Rule ID 449 //
     /* 308943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 308957 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 308957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 308962 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308966 */   GIR_RootConstrainSelectedInstOperands,
     /* 308967 */   // GIR_Coverage, 449,
     /* 308967 */   GIR_Done,
     /* 308968 */ // Label 6272: @308968
     /* 308968 */ GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(308998), // Rule ID 491 //
     /* 308973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 308976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308987 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 308987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 308992 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308996 */   GIR_RootConstrainSelectedInstOperands,
     /* 308997 */   // GIR_Coverage, 491,
     /* 308997 */   GIR_Done,
     /* 308998 */ // Label 6273: @308998
     /* 308998 */ GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(309028), // Rule ID 495 //
     /* 309003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 309006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 309009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309017 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 309017 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 309022 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309026 */   GIR_RootConstrainSelectedInstOperands,
     /* 309027 */   // GIR_Coverage, 495,
     /* 309027 */   GIR_Done,
     /* 309028 */ // Label 6274: @309028
     /* 309028 */ GIM_Reject,
     /* 309029 */ // Label 6261: @309029
     /* 309029 */ GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(309267), // Rule ID 6333 //
     /* 309034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 309037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309044 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309048 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 309052 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309055 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 309062 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309066 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309068 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 309075 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 309075 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 309078 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 309082 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 309097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 309102 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 309109 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 309112 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309116 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 309123 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 309126 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309130 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309135 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 309138 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 309141 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 309144 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309149 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309154 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 309159 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 309162 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 309166 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309171 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 309174 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 309177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 309179 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 309182 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309186 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309191 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 309198 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309203 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309208 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 309211 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 309215 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309220 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 309223 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 309226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309228 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 309231 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309235 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309240 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 309247 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309252 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 309260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309265 */   GIR_RootConstrainSelectedInstOperands,
     /* 309266 */   // GIR_Coverage, 6333,
     /* 309266 */   GIR_EraseRootFromParent_Done,
     /* 309267 */ // Label 6275: @309267
     /* 309267 */ GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(309505), // Rule ID 6334 //
     /* 309272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 309275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309282 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309286 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 309290 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309293 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 309300 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309304 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309306 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 309313 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 309313 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 309316 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 309320 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 309335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 309340 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 309347 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 309350 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309354 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 309361 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 309364 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309368 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309373 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 309376 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 309379 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 309382 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309387 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309392 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 309397 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 309400 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 309404 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309409 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 309412 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 309415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 309417 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 309420 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309424 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309429 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 309436 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309441 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309446 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 309449 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 309453 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309458 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 309461 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 309464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309466 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 309469 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309473 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309478 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 309485 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309490 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 309498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309503 */   GIR_RootConstrainSelectedInstOperands,
     /* 309504 */   // GIR_Coverage, 6334,
     /* 309504 */   GIR_EraseRootFromParent_Done,
     /* 309505 */ // Label 6276: @309505
     /* 309505 */ GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(309694), // Rule ID 6337 //
     /* 309510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 309513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309520 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309524 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 309528 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309531 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 309538 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309542 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309544 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 309551 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 309551 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 309554 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 309558 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309563 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 309573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 309578 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 309585 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 309588 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309592 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 309599 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 309602 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309606 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309611 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 309614 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 309617 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 309620 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309625 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309630 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309635 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 309638 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 309642 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309647 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 309650 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 309653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309655 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 309658 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309662 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309667 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 309674 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309679 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 309687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309689 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309692 */   GIR_RootConstrainSelectedInstOperands,
     /* 309693 */   // GIR_Coverage, 6337,
     /* 309693 */   GIR_EraseRootFromParent_Done,
     /* 309694 */ // Label 6277: @309694
     /* 309694 */ GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(309883), // Rule ID 6338 //
     /* 309699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 309702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309709 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309713 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 309717 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309720 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 309727 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309731 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309733 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 309740 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 309740 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 309743 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 309747 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 309762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 309767 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 309774 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 309777 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309781 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 309788 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 309791 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309795 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309800 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 309803 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 309806 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 309809 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309814 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309819 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309824 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 309827 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 309831 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309836 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 309839 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 309842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309844 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 309847 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309851 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309856 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 309863 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309868 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 309876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309878 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309881 */   GIR_RootConstrainSelectedInstOperands,
     /* 309882 */   // GIR_Coverage, 6338,
     /* 309882 */   GIR_EraseRootFromParent_Done,
     /* 309883 */ // Label 6278: @309883
     /* 309883 */ GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(310116), // Rule ID 6335 //
     /* 309888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 309891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 309894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309898 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 309906 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 309909 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 309916 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 309920 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309922 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 309929 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 309929 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 309932 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 309936 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 309946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 309951 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 309956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 309958 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 309961 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309965 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 309972 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 309975 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309979 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309984 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 309987 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 309990 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 309993 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309998 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310003 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 310008 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 310011 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 310015 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310020 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 310023 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 310026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 310028 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 310031 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310035 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310040 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 310047 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310052 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310057 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 310060 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 310064 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310069 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 310072 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 310075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310089 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 310096 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 310109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310114 */   GIR_RootConstrainSelectedInstOperands,
     /* 310115 */   // GIR_Coverage, 6335,
     /* 310115 */   GIR_EraseRootFromParent_Done,
     /* 310116 */ // Label 6279: @310116
     /* 310116 */ GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(310349), // Rule ID 6336 //
     /* 310121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 310124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310131 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310135 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 310139 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 310142 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 310149 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 310153 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310155 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 310162 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 310162 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 310165 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 310169 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 310184 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 310189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 310191 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 310194 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 310198 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 310205 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 310208 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 310212 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310217 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 310220 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 310223 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 310226 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310231 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310236 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 310241 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 310244 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 310248 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310253 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 310256 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 310259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 310261 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 310264 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310268 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310273 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 310280 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310285 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310290 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 310293 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 310297 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310302 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 310305 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 310308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310322 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 310329 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310334 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 310342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310344 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310347 */   GIR_RootConstrainSelectedInstOperands,
     /* 310348 */   // GIR_Coverage, 6336,
     /* 310348 */   GIR_EraseRootFromParent_Done,
     /* 310349 */ // Label 6280: @310349
     /* 310349 */ GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(310533), // Rule ID 6339 //
     /* 310354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 310357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310364 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310368 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 310372 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 310375 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 310382 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 310386 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310388 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 310395 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 310395 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 310398 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 310402 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 310417 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 310422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 310424 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 310427 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 310431 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 310438 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 310441 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 310445 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310450 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 310453 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 310456 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 310459 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310464 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310469 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310474 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 310477 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 310481 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310486 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 310489 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 310492 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310506 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 310513 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310518 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 310526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310531 */   GIR_RootConstrainSelectedInstOperands,
     /* 310532 */   // GIR_Coverage, 6339,
     /* 310532 */   GIR_EraseRootFromParent_Done,
     /* 310533 */ // Label 6281: @310533
     /* 310533 */ GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(310717), // Rule ID 6340 //
     /* 310538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 310541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310548 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310552 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 310556 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 310559 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 310566 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 310570 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310572 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 310579 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 310579 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 310582 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 310586 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 310601 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 310606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 310608 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 310611 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 310615 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 310622 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 310625 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 310629 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310634 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 310637 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 310640 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 310643 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310648 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310653 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310658 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 310661 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 310665 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310670 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 310673 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 310676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 310678 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310681 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310685 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310690 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 310697 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310702 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 310710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310712 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310715 */   GIR_RootConstrainSelectedInstOperands,
     /* 310716 */   // GIR_Coverage, 6340,
     /* 310716 */   GIR_EraseRootFromParent_Done,
     /* 310717 */ // Label 6282: @310717
     /* 310717 */ GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(310797), // Rule ID 5294 //
     /* 310722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 310725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310732 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310740 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310744 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310748 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310753 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310757 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310759 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 310759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310771 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 310777 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310782 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 310790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310792 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310795 */   GIR_RootConstrainSelectedInstOperands,
     /* 310796 */   // GIR_Coverage, 5294,
     /* 310796 */   GIR_EraseRootFromParent_Done,
     /* 310797 */ // Label 6283: @310797
     /* 310797 */ GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(310854), // Rule ID 5277 //
     /* 310802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 310805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310812 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 310820 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310824 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310826 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 310826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 310829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 310833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310838 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 310847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310849 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310852 */   GIR_RootConstrainSelectedInstOperands,
     /* 310853 */   // GIR_Coverage, 5277,
     /* 310853 */   GIR_EraseRootFromParent_Done,
     /* 310854 */ // Label 6284: @310854
     /* 310854 */ GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(310884), // Rule ID 445 //
     /* 310859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310873 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 310873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 310878 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310882 */   GIR_RootConstrainSelectedInstOperands,
     /* 310883 */   // GIR_Coverage, 445,
     /* 310883 */   GIR_Done,
     /* 310884 */ // Label 6285: @310884
     /* 310884 */ GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(310914), // Rule ID 451 //
     /* 310889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310903 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 310903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 310908 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310912 */   GIR_RootConstrainSelectedInstOperands,
     /* 310913 */   // GIR_Coverage, 451,
     /* 310913 */   GIR_Done,
     /* 310914 */ // Label 6286: @310914
     /* 310914 */ GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(310944), // Rule ID 497 //
     /* 310919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 310922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310933 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 310933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 310938 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310942 */   GIR_RootConstrainSelectedInstOperands,
     /* 310943 */   // GIR_Coverage, 497,
     /* 310943 */   GIR_Done,
     /* 310944 */ // Label 6287: @310944
     /* 310944 */ GIM_Reject,
     /* 310945 */ // Label 6262: @310945
     /* 310945 */ GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(311131), // Rule ID 6345 //
     /* 310950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 310953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310960 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310964 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 310968 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 310971 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 310975 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 310979 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310981 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 310988 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 310988 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 310991 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 310995 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 311005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 311010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 311015 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 311020 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 311022 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 311025 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 311029 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 311036 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 311039 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 311043 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311048 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 311051 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 311054 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 311057 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311062 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311067 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311072 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 311075 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 311079 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311084 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 311087 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 311090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 311092 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311099 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311104 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 311111 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311116 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 311124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311129 */   GIR_RootConstrainSelectedInstOperands,
     /* 311130 */   // GIR_Coverage, 6345,
     /* 311130 */   GIR_EraseRootFromParent_Done,
     /* 311131 */ // Label 6288: @311131
     /* 311131 */ GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(311317), // Rule ID 6346 //
     /* 311136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 311139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311146 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311150 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 311154 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 311157 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 311161 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 311165 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311167 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 311174 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 311174 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 311177 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 311181 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 311191 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 311196 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 311201 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 311206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 311208 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 311211 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 311215 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 311222 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 311225 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 311229 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311234 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 311237 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 311240 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 311243 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311248 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311253 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311258 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 311261 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 311265 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311270 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 311273 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 311276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 311278 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311281 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311285 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311290 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 311297 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311302 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 311310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311315 */   GIR_RootConstrainSelectedInstOperands,
     /* 311316 */   // GIR_Coverage, 6346,
     /* 311316 */   GIR_EraseRootFromParent_Done,
     /* 311317 */ // Label 6289: @311317
     /* 311317 */ GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(311555), // Rule ID 6341 //
     /* 311322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 311325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311332 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311336 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 311340 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 311343 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 311350 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 311354 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311356 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 311363 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 311363 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 311366 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 311370 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 311380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 311385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 311390 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 311395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 311397 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 311400 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 311404 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 311411 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 311414 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 311418 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311423 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 311426 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 311429 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 311432 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311437 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311442 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311447 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 311450 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 311454 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311459 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 311462 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 311465 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 311467 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 311470 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311474 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311479 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 311486 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311491 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311496 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 311499 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 311503 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311508 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 311511 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 311514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 311516 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311519 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311523 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311528 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 311535 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311540 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 311548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311553 */   GIR_RootConstrainSelectedInstOperands,
     /* 311554 */   // GIR_Coverage, 6341,
     /* 311554 */   GIR_EraseRootFromParent_Done,
     /* 311555 */ // Label 6290: @311555
     /* 311555 */ GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(311793), // Rule ID 6342 //
     /* 311560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 311563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311570 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311574 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 311578 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 311581 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 311588 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 311592 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311594 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 311601 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 311601 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 311604 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 311608 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 311618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 311623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 311628 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 311633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 311635 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 311638 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 311642 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 311649 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 311652 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 311656 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311661 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 311664 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 311667 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 311670 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311675 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311680 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311685 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 311688 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 311692 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311697 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 311700 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 311703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 311705 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 311708 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311712 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311717 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 311724 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311729 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311734 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 311737 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 311741 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311746 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 311749 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 311752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 311754 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311757 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311761 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311766 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 311773 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311778 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 311786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311788 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311791 */   GIR_RootConstrainSelectedInstOperands,
     /* 311792 */   // GIR_Coverage, 6342,
     /* 311792 */   GIR_EraseRootFromParent_Done,
     /* 311793 */ // Label 6291: @311793
     /* 311793 */ GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(311974), // Rule ID 6347 //
     /* 311798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 311801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311808 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311812 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 311816 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 311819 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 311823 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 311827 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311829 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 311836 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 311836 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 311839 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 311843 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311848 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 311853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 311858 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 311863 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 311865 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 311868 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 311872 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 311879 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 311882 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 311886 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311891 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 311894 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 311897 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 311900 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311905 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311910 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311915 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 311918 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 311922 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311927 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 311930 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 311933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 311935 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 311938 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311942 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311947 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 311954 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311959 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 311967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311972 */   GIR_RootConstrainSelectedInstOperands,
     /* 311973 */   // GIR_Coverage, 6347,
     /* 311973 */   GIR_EraseRootFromParent_Done,
     /* 311974 */ // Label 6292: @311974
     /* 311974 */ GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(312155), // Rule ID 6348 //
     /* 311979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 311982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311989 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311993 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 311997 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 312000 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 312004 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 312008 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312010 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 312017 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 312017 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 312020 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 312024 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 312034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 312039 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 312044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 312046 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 312049 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 312053 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 312060 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 312063 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 312067 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312072 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 312075 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 312078 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 312081 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312086 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312091 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312096 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 312099 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 312103 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312108 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 312111 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 312114 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 312116 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312119 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312123 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312128 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 312135 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312140 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 312148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312153 */   GIR_RootConstrainSelectedInstOperands,
     /* 312154 */   // GIR_Coverage, 6348,
     /* 312154 */   GIR_EraseRootFromParent_Done,
     /* 312155 */ // Label 6293: @312155
     /* 312155 */ GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(312388), // Rule ID 6343 //
     /* 312160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 312163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 312178 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 312181 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 312188 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 312192 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312194 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 312201 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 312201 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 312204 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 312208 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 312218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 312223 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 312228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 312230 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 312233 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 312237 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 312244 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 312247 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 312251 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312256 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 312259 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 312262 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 312265 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312270 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312275 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312280 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 312283 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 312287 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312292 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 312295 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 312298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 312300 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 312303 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312307 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312312 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 312319 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312324 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312329 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 312332 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 312336 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312341 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 312344 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 312347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 312349 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312356 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312361 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 312368 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312373 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 312381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312386 */   GIR_RootConstrainSelectedInstOperands,
     /* 312387 */   // GIR_Coverage, 6343,
     /* 312387 */   GIR_EraseRootFromParent_Done,
     /* 312388 */ // Label 6294: @312388
     /* 312388 */ GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(312621), // Rule ID 6344 //
     /* 312393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 312396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312403 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312407 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 312411 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 312414 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 312421 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 312425 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312427 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 312434 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 312434 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 312437 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 312441 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 312451 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 312456 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 312461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 312463 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 312466 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 312470 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 312477 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 312480 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 312484 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312489 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 312492 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 312495 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 312498 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312503 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312508 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312513 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 312516 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 312520 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312525 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 312528 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 312531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 312533 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 312536 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312540 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312545 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 312552 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312557 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312562 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 312565 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 312569 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312574 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 312577 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 312580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 312582 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312585 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312589 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312594 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 312601 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312606 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 312614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312619 */   GIR_RootConstrainSelectedInstOperands,
     /* 312620 */   // GIR_Coverage, 6344,
     /* 312620 */   GIR_EraseRootFromParent_Done,
     /* 312621 */ // Label 6295: @312621
     /* 312621 */ GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(312701), // Rule ID 5296 //
     /* 312626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 312629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312636 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312640 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312644 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312648 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312652 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312657 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312661 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312663 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 312663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312675 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 312681 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312686 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 312694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312696 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312699 */   GIR_RootConstrainSelectedInstOperands,
     /* 312700 */   // GIR_Coverage, 5296,
     /* 312700 */   GIR_EraseRootFromParent_Done,
     /* 312701 */ // Label 6296: @312701
     /* 312701 */ GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(312758), // Rule ID 5273 //
     /* 312706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 312709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312716 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312720 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 312724 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312728 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312730 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 312730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 312733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 312737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312742 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 312751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312756 */   GIR_RootConstrainSelectedInstOperands,
     /* 312757 */   // GIR_Coverage, 5273,
     /* 312757 */   GIR_EraseRootFromParent_Done,
     /* 312758 */ // Label 6297: @312758
     /* 312758 */ GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(312788), // Rule ID 447 //
     /* 312763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312777 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 312777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 312782 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312786 */   GIR_RootConstrainSelectedInstOperands,
     /* 312787 */   // GIR_Coverage, 447,
     /* 312787 */   GIR_Done,
     /* 312788 */ // Label 6298: @312788
     /* 312788 */ GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(312818), // Rule ID 453 //
     /* 312793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312807 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 312807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 312812 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312816 */   GIR_RootConstrainSelectedInstOperands,
     /* 312817 */   // GIR_Coverage, 453,
     /* 312817 */   GIR_Done,
     /* 312818 */ // Label 6299: @312818
     /* 312818 */ GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(312848), // Rule ID 493 //
     /* 312823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 312826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312837 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 312837 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 312842 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312846 */   GIR_RootConstrainSelectedInstOperands,
     /* 312847 */   // GIR_Coverage, 493,
     /* 312847 */   GIR_Done,
     /* 312848 */ // Label 6300: @312848
     /* 312848 */ GIM_Reject,
     /* 312849 */ // Label 6263: @312849
     /* 312849 */ GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(312879), // Rule ID 1010 //
     /* 312854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312868 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 312868 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 312873 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312877 */   GIR_RootConstrainSelectedInstOperands,
     /* 312878 */   // GIR_Coverage, 1010,
     /* 312878 */   GIR_Done,
     /* 312879 */ // Label 6301: @312879
     /* 312879 */ GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(312922), // Rule ID 13025 //
     /* 312884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312894 */   // (sint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (SCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
     /* 312894 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 312897 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 312901 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312906 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 312910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 312915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312920 */   GIR_RootConstrainSelectedInstOperands,
     /* 312921 */   // GIR_Coverage, 13025,
     /* 312921 */   GIR_EraseRootFromParent_Done,
     /* 312922 */ // Label 6302: @312922
     /* 312922 */ GIM_Reject,
     /* 312923 */ // Label 6264: @312923
     /* 312923 */ GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(312953), // Rule ID 1014 //
     /* 312928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312942 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 312942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 312947 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312951 */   GIR_RootConstrainSelectedInstOperands,
     /* 312952 */   // GIR_Coverage, 1014,
     /* 312952 */   GIR_Done,
     /* 312953 */ // Label 6303: @312953
     /* 312953 */ GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(312999), // Rule ID 13023 //
     /* 312958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312968 */   // (sint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (SCVTFv2f64:{ *:[v2f64] } (SSHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
     /* 312968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 312971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 312975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312980 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 312984 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 312987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 312992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312997 */   GIR_RootConstrainSelectedInstOperands,
     /* 312998 */   // GIR_Coverage, 13023,
     /* 312998 */   GIR_EraseRootFromParent_Done,
     /* 312999 */ // Label 6304: @312999
     /* 312999 */ GIM_Reject,
     /* 313000 */ // Label 6265: @313000
     /* 313000 */ GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(313030), // Rule ID 1006 //
     /* 313005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313019 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 313019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 313024 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313028 */   GIR_RootConstrainSelectedInstOperands,
     /* 313029 */   // GIR_Coverage, 1006,
     /* 313029 */   GIR_Done,
     /* 313030 */ // Label 6305: @313030
     /* 313030 */ GIM_Reject,
     /* 313031 */ // Label 6266: @313031
     /* 313031 */ GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(313061), // Rule ID 1012 //
     /* 313036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313050 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 313050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 313055 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313059 */   GIR_RootConstrainSelectedInstOperands,
     /* 313060 */   // GIR_Coverage, 1012,
     /* 313060 */   GIR_Done,
     /* 313061 */ // Label 6306: @313061
     /* 313061 */ GIM_Reject,
     /* 313062 */ // Label 6267: @313062
     /* 313062 */ GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(313092), // Rule ID 1008 //
     /* 313067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313081 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 313081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 313086 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313090 */   GIR_RootConstrainSelectedInstOperands,
     /* 313091 */   // GIR_Coverage, 1008,
     /* 313091 */   GIR_Done,
     /* 313092 */ // Label 6307: @313092
     /* 313092 */ GIM_Reject,
     /* 313093 */ // Label 6268: @313093
     /* 313093 */ GIM_Reject,
     /* 313094 */ // Label 68: @313094
     /* 313094 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6316*/ GIMT_Encode4(316868),
     /* 313105 */ /*GILLT_s16*//*Label 6308*/ GIMT_Encode4(313145),
     /* 313109 */ /*GILLT_s32*//*Label 6309*/ GIMT_Encode4(313430),
     /* 313113 */ /*GILLT_s64*//*Label 6310*/ GIMT_Encode4(314758), GIMT_Encode4(0),
     /* 313121 */ /*GILLT_v2s32*//*Label 6311*/ GIMT_Encode4(316624),
     /* 313125 */ /*GILLT_v2s64*//*Label 6312*/ GIMT_Encode4(316698),
     /* 313129 */ /*GILLT_v4s16*//*Label 6313*/ GIMT_Encode4(316775),
     /* 313133 */ /*GILLT_v4s32*//*Label 6314*/ GIMT_Encode4(316806), GIMT_Encode4(0),
     /* 313141 */ /*GILLT_v8s16*//*Label 6315*/ GIMT_Encode4(316837),
     /* 313145 */ // Label 6308: @313145
     /* 313145 */ GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(313252), // Rule ID 5299 //
     /* 313150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 313153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313160 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313164 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 313168 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313172 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 313176 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313180 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313184 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313188 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313192 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313197 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313201 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 313212 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313214 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 313214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 313217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313226 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 313232 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313237 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 313245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313247 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313250 */   GIR_RootConstrainSelectedInstOperands,
     /* 313251 */   // GIR_Coverage, 5299,
     /* 313251 */   GIR_EraseRootFromParent_Done,
     /* 313252 */ // Label 6317: @313252
     /* 313252 */ GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(313309), // Rule ID 5293 //
     /* 313257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 313260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313267 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313271 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 313275 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313279 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313281 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 313281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 313284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 313288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313293 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 313299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 313302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313304 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313307 */   GIR_RootConstrainSelectedInstOperands,
     /* 313308 */   // GIR_Coverage, 5293,
     /* 313308 */   GIR_EraseRootFromParent_Done,
     /* 313309 */ // Label 6318: @313309
     /* 313309 */ GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(313339), // Rule ID 467 //
     /* 313314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313328 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 313328 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 313333 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313337 */   GIR_RootConstrainSelectedInstOperands,
     /* 313338 */   // GIR_Coverage, 467,
     /* 313338 */   GIR_Done,
     /* 313339 */ // Label 6319: @313339
     /* 313339 */ GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(313369), // Rule ID 473 //
     /* 313344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313358 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 313358 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 313363 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313367 */   GIR_RootConstrainSelectedInstOperands,
     /* 313368 */   // GIR_Coverage, 473,
     /* 313368 */   GIR_Done,
     /* 313369 */ // Label 6320: @313369
     /* 313369 */ GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(313399), // Rule ID 499 //
     /* 313374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 313377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313388 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 313388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 313393 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313397 */   GIR_RootConstrainSelectedInstOperands,
     /* 313398 */   // GIR_Coverage, 499,
     /* 313398 */   GIR_Done,
     /* 313399 */ // Label 6321: @313399
     /* 313399 */ GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(313429), // Rule ID 503 //
     /* 313404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 313407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313418 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 313418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 313423 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313427 */   GIR_RootConstrainSelectedInstOperands,
     /* 313428 */   // GIR_Coverage, 503,
     /* 313428 */   GIR_Done,
     /* 313429 */ // Label 6322: @313429
     /* 313429 */ GIM_Reject,
     /* 313430 */ // Label 6309: @313430
     /* 313430 */ GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(313570), // Rule ID 5300 //
     /* 313435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 313438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313445 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313449 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 313453 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313456 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 313463 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313467 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313469 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 313476 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 313476 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 313479 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 313483 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 313503 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313508 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 313510 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 313513 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313517 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313536 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 313539 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 313542 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 313545 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313550 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313555 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 313560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 313563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313568 */   GIR_RootConstrainSelectedInstOperands,
     /* 313569 */   // GIR_Coverage, 5300,
     /* 313569 */   GIR_EraseRootFromParent_Done,
     /* 313570 */ // Label 6323: @313570
     /* 313570 */ GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(313710), // Rule ID 5301 //
     /* 313575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 313578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313585 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313589 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 313593 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313596 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 313603 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313607 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313609 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 313616 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 313616 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 313619 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 313623 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 313643 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313648 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 313650 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 313653 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313657 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313676 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 313679 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 313682 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 313685 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313690 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313695 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 313700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 313703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313705 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313708 */   GIR_RootConstrainSelectedInstOperands,
     /* 313709 */   // GIR_Coverage, 5301,
     /* 313709 */   GIR_EraseRootFromParent_Done,
     /* 313710 */ // Label 6324: @313710
     /* 313710 */ GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(313850), // Rule ID 5304 //
     /* 313715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 313718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313725 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313729 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 313733 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313736 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 313743 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313747 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313749 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 313756 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 313756 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 313759 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 313763 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 313783 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 313790 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 313793 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313797 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313816 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 313819 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 313822 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 313825 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313830 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 313843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313848 */   GIR_RootConstrainSelectedInstOperands,
     /* 313849 */   // GIR_Coverage, 5304,
     /* 313849 */   GIR_EraseRootFromParent_Done,
     /* 313850 */ // Label 6325: @313850
     /* 313850 */ GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(313990), // Rule ID 5305 //
     /* 313855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 313858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313865 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313869 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 313873 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313876 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 313883 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313887 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313889 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 313896 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 313896 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 313899 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 313903 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 313923 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 313930 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 313933 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313937 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313956 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 313959 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 313962 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 313965 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313970 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313975 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 313983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313985 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313988 */   GIR_RootConstrainSelectedInstOperands,
     /* 313989 */   // GIR_Coverage, 5305,
     /* 313989 */   GIR_EraseRootFromParent_Done,
     /* 313990 */ // Label 6326: @313990
     /* 313990 */ GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(314125), // Rule ID 5302 //
     /* 313995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 313998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314005 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 314013 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314016 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 314023 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314027 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314029 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 314036 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 314036 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 314039 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 314043 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314058 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 314065 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 314068 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314072 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314079 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314082 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314086 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314091 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 314094 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 314097 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 314100 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314105 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314110 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 314115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 314118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314120 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314123 */   GIR_RootConstrainSelectedInstOperands,
     /* 314124 */   // GIR_Coverage, 5302,
     /* 314124 */   GIR_EraseRootFromParent_Done,
     /* 314125 */ // Label 6327: @314125
     /* 314125 */ GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(314260), // Rule ID 5303 //
     /* 314130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 314133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314140 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314144 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 314148 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314151 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 314158 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314162 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314164 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 314171 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 314171 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 314174 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 314178 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314188 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314193 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314198 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 314200 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 314203 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314207 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314226 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 314229 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 314232 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 314235 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314240 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314245 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 314250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 314253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314255 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314258 */   GIR_RootConstrainSelectedInstOperands,
     /* 314259 */   // GIR_Coverage, 5303,
     /* 314259 */   GIR_EraseRootFromParent_Done,
     /* 314260 */ // Label 6328: @314260
     /* 314260 */ GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(314395), // Rule ID 5306 //
     /* 314265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 314268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314275 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314279 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 314283 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314286 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 314293 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314297 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314299 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 314306 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 314306 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 314309 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 314313 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314328 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 314335 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 314338 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314342 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314349 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314356 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314361 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 314364 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 314367 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 314370 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314375 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314380 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 314388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314393 */   GIR_RootConstrainSelectedInstOperands,
     /* 314394 */   // GIR_Coverage, 5306,
     /* 314394 */   GIR_EraseRootFromParent_Done,
     /* 314395 */ // Label 6329: @314395
     /* 314395 */ GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(314530), // Rule ID 5307 //
     /* 314400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 314403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314410 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314414 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 314418 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314421 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 314428 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314432 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314434 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 314441 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 314441 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 314444 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 314448 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314463 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 314470 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 314473 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314477 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314496 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 314499 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 314502 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 314505 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314510 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 314523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314528 */   GIR_RootConstrainSelectedInstOperands,
     /* 314529 */   // GIR_Coverage, 5307,
     /* 314529 */   GIR_EraseRootFromParent_Done,
     /* 314530 */ // Label 6330: @314530
     /* 314530 */ GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(314610), // Rule ID 5295 //
     /* 314535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 314538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314545 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314549 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314553 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314557 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314561 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314566 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314570 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314572 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 314572 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314575 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314579 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314584 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314590 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314595 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 314603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314608 */   GIR_RootConstrainSelectedInstOperands,
     /* 314609 */   // GIR_Coverage, 5295,
     /* 314609 */   GIR_EraseRootFromParent_Done,
     /* 314610 */ // Label 6331: @314610
     /* 314610 */ GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(314667), // Rule ID 5285 //
     /* 314615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 314618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314625 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314629 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 314633 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314637 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314639 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 314639 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314642 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 314646 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314651 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 314657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 314660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314665 */   GIR_RootConstrainSelectedInstOperands,
     /* 314666 */   // GIR_Coverage, 5285,
     /* 314666 */   GIR_EraseRootFromParent_Done,
     /* 314667 */ // Label 6332: @314667
     /* 314667 */ GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(314697), // Rule ID 469 //
     /* 314672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314686 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 314686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 314691 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314695 */   GIR_RootConstrainSelectedInstOperands,
     /* 314696 */   // GIR_Coverage, 469,
     /* 314696 */   GIR_Done,
     /* 314697 */ // Label 6333: @314697
     /* 314697 */ GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(314727), // Rule ID 475 //
     /* 314702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314716 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 314716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 314721 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314725 */   GIR_RootConstrainSelectedInstOperands,
     /* 314726 */   // GIR_Coverage, 475,
     /* 314726 */   GIR_Done,
     /* 314727 */ // Label 6334: @314727
     /* 314727 */ GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(314757), // Rule ID 505 //
     /* 314732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 314735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314746 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 314746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 314751 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314755 */   GIR_RootConstrainSelectedInstOperands,
     /* 314756 */   // GIR_Coverage, 505,
     /* 314756 */   GIR_Done,
     /* 314757 */ // Label 6335: @314757
     /* 314757 */ GIM_Reject,
     /* 314758 */ // Label 6310: @314758
     /* 314758 */ GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(314895), // Rule ID 5316 //
     /* 314763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 314766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314773 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314777 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 314781 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314784 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 314788 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314792 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314794 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 314801 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 314801 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 314804 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 314808 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 314823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 314828 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314833 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 314835 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 314838 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314842 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314861 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 314864 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 314867 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 314870 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314875 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314880 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 314888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314890 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314893 */   GIR_RootConstrainSelectedInstOperands,
     /* 314894 */   // GIR_Coverage, 5316,
     /* 314894 */   GIR_EraseRootFromParent_Done,
     /* 314895 */ // Label 6336: @314895
     /* 314895 */ GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(315032), // Rule ID 5317 //
     /* 314900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 314903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314910 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314914 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 314918 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314921 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 314925 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314929 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314931 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 314938 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 314938 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 314941 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 314945 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 314960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 314965 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 314972 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 314975 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314979 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 314989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314998 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 315001 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 315004 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 315007 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315012 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315017 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 315025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315027 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315030 */   GIR_RootConstrainSelectedInstOperands,
     /* 315031 */   // GIR_Coverage, 5317,
     /* 315031 */   GIR_EraseRootFromParent_Done,
     /* 315032 */ // Label 6337: @315032
     /* 315032 */ GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(315172), // Rule ID 5308 //
     /* 315037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 315040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315047 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315051 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 315055 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315058 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 315065 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315071 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 315078 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 315078 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 315081 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 315085 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 315105 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 315112 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315115 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315119 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315126 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315129 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315133 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315138 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 315141 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 315144 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 315147 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315152 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315157 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 315162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 315165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315167 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315170 */   GIR_RootConstrainSelectedInstOperands,
     /* 315171 */   // GIR_Coverage, 5308,
     /* 315171 */   GIR_EraseRootFromParent_Done,
     /* 315172 */ // Label 6338: @315172
     /* 315172 */ GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(315312), // Rule ID 5309 //
     /* 315177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 315180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315187 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315191 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 315195 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315198 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 315205 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315209 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315211 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 315218 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 315218 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 315221 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 315225 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315230 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 315245 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 315252 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315255 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315259 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315266 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315269 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315273 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315278 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 315281 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 315284 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 315287 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315292 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315297 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 315302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 315305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315307 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315310 */   GIR_RootConstrainSelectedInstOperands,
     /* 315311 */   // GIR_Coverage, 5309,
     /* 315311 */   GIR_EraseRootFromParent_Done,
     /* 315312 */ // Label 6339: @315312
     /* 315312 */ GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(315452), // Rule ID 5312 //
     /* 315317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 315320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315327 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315331 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 315335 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315338 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 315345 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315349 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315351 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 315358 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 315358 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 315361 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 315365 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 315385 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 315392 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315395 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315399 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315404 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315418 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 315421 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 315424 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 315427 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315432 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315437 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 315445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315450 */   GIR_RootConstrainSelectedInstOperands,
     /* 315451 */   // GIR_Coverage, 5312,
     /* 315451 */   GIR_EraseRootFromParent_Done,
     /* 315452 */ // Label 6340: @315452
     /* 315452 */ GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(315592), // Rule ID 5313 //
     /* 315457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 315460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 315475 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315478 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 315485 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315489 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315491 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 315498 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 315498 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 315501 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 315505 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315510 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 315525 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 315532 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315535 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315539 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315558 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 315561 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 315564 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 315567 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315572 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315577 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 315585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315590 */   GIR_RootConstrainSelectedInstOperands,
     /* 315591 */   // GIR_Coverage, 5313,
     /* 315591 */   GIR_EraseRootFromParent_Done,
     /* 315592 */ // Label 6341: @315592
     /* 315592 */ GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(315724), // Rule ID 5318 //
     /* 315597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 315600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315607 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315611 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 315615 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315618 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 315622 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315626 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315628 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 315635 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 315635 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 315638 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 315642 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 315657 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 315664 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315667 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315671 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315678 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315681 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315685 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315690 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 315693 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 315696 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 315699 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315704 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315709 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 315717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315722 */   GIR_RootConstrainSelectedInstOperands,
     /* 315723 */   // GIR_Coverage, 5318,
     /* 315723 */   GIR_EraseRootFromParent_Done,
     /* 315724 */ // Label 6342: @315724
     /* 315724 */ GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(315856), // Rule ID 5319 //
     /* 315729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 315732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315739 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315743 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 315747 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315750 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 315754 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315758 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315760 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 315767 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 315767 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 315770 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 315774 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 315789 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 315796 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315799 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315803 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315810 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315813 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315817 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315822 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 315825 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 315828 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 315831 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315836 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315841 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 315849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315854 */   GIR_RootConstrainSelectedInstOperands,
     /* 315855 */   // GIR_Coverage, 5319,
     /* 315855 */   GIR_EraseRootFromParent_Done,
     /* 315856 */ // Label 6343: @315856
     /* 315856 */ GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(315991), // Rule ID 5310 //
     /* 315861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 315864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315871 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 315879 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315882 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 315889 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315893 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315895 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 315902 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 315902 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 315905 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 315909 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315914 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 315924 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 315931 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315934 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315938 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315943 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315945 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315948 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315952 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315957 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 315960 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 315963 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 315966 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315971 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315976 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 315981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 315984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315989 */   GIR_RootConstrainSelectedInstOperands,
     /* 315990 */   // GIR_Coverage, 5310,
     /* 315990 */   GIR_EraseRootFromParent_Done,
     /* 315991 */ // Label 6344: @315991
     /* 315991 */ GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(316126), // Rule ID 5311 //
     /* 315996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 315999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316006 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316010 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 316014 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316017 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 316024 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316028 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316030 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 316037 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 316037 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 316040 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 316044 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316059 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 316066 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 316069 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316073 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316080 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316083 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316087 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316092 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 316095 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 316098 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 316101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316106 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316111 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 316116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 316119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316121 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316124 */   GIR_RootConstrainSelectedInstOperands,
     /* 316125 */   // GIR_Coverage, 5311,
     /* 316125 */   GIR_EraseRootFromParent_Done,
     /* 316126 */ // Label 6345: @316126
     /* 316126 */ GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(316261), // Rule ID 5314 //
     /* 316131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 316134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316141 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316145 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 316149 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316152 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316159 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316163 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316165 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 316172 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 316172 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 316175 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 316179 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316194 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 316201 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 316204 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316208 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316227 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 316230 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 316233 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 316236 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316241 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316246 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 316254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316256 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316259 */   GIR_RootConstrainSelectedInstOperands,
     /* 316260 */   // GIR_Coverage, 5314,
     /* 316260 */   GIR_EraseRootFromParent_Done,
     /* 316261 */ // Label 6346: @316261
     /* 316261 */ GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(316396), // Rule ID 5315 //
     /* 316266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 316269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316276 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316280 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 316284 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316287 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316294 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316298 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316300 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 316307 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 316307 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 316310 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 316314 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316329 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 316336 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 316339 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316343 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316348 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316350 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316353 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316357 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316362 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 316365 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 316368 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 316371 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316376 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316381 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 316389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316394 */   GIR_RootConstrainSelectedInstOperands,
     /* 316395 */   // GIR_Coverage, 5315,
     /* 316395 */   GIR_EraseRootFromParent_Done,
     /* 316396 */ // Label 6347: @316396
     /* 316396 */ GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(316476), // Rule ID 5297 //
     /* 316401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 316404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316411 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316415 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316419 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316423 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316427 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316432 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316436 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316438 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 316438 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316441 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316445 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316450 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316456 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316461 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 316469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316474 */   GIR_RootConstrainSelectedInstOperands,
     /* 316475 */   // GIR_Coverage, 5297,
     /* 316475 */   GIR_EraseRootFromParent_Done,
     /* 316476 */ // Label 6348: @316476
     /* 316476 */ GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(316533), // Rule ID 5281 //
     /* 316481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 316484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316491 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316495 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 316499 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316503 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316505 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 316505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 316512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316517 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 316523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 316526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316531 */   GIR_RootConstrainSelectedInstOperands,
     /* 316532 */   // GIR_Coverage, 5281,
     /* 316532 */   GIR_EraseRootFromParent_Done,
     /* 316533 */ // Label 6349: @316533
     /* 316533 */ GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(316563), // Rule ID 471 //
     /* 316538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316552 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 316552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 316557 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316561 */   GIR_RootConstrainSelectedInstOperands,
     /* 316562 */   // GIR_Coverage, 471,
     /* 316562 */   GIR_Done,
     /* 316563 */ // Label 6350: @316563
     /* 316563 */ GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(316593), // Rule ID 477 //
     /* 316568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316582 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 316582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 316587 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316591 */   GIR_RootConstrainSelectedInstOperands,
     /* 316592 */   // GIR_Coverage, 477,
     /* 316592 */   GIR_Done,
     /* 316593 */ // Label 6351: @316593
     /* 316593 */ GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(316623), // Rule ID 501 //
     /* 316598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 316601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316612 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 316612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 316617 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316621 */   GIR_RootConstrainSelectedInstOperands,
     /* 316622 */   // GIR_Coverage, 501,
     /* 316622 */   GIR_Done,
     /* 316623 */ // Label 6352: @316623
     /* 316623 */ GIM_Reject,
     /* 316624 */ // Label 6311: @316624
     /* 316624 */ GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(316654), // Rule ID 1071 //
     /* 316629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316643 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 316643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 316648 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316652 */   GIR_RootConstrainSelectedInstOperands,
     /* 316653 */   // GIR_Coverage, 1071,
     /* 316653 */   GIR_Done,
     /* 316654 */ // Label 6353: @316654
     /* 316654 */ GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(316697), // Rule ID 13026 //
     /* 316659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316669 */   // (uint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (UCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
     /* 316669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 316672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 316676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316681 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 316685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 316687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 316690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316695 */   GIR_RootConstrainSelectedInstOperands,
     /* 316696 */   // GIR_Coverage, 13026,
     /* 316696 */   GIR_EraseRootFromParent_Done,
     /* 316697 */ // Label 6354: @316697
     /* 316697 */ GIM_Reject,
     /* 316698 */ // Label 6312: @316698
     /* 316698 */ GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(316728), // Rule ID 1075 //
     /* 316703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316717 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 316717 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 316722 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316726 */   GIR_RootConstrainSelectedInstOperands,
     /* 316727 */   // GIR_Coverage, 1075,
     /* 316727 */   GIR_Done,
     /* 316728 */ // Label 6355: @316728
     /* 316728 */ GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(316774), // Rule ID 13024 //
     /* 316733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316743 */   // (uint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (UCVTFv2f64:{ *:[v2f64] } (USHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
     /* 316743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 316746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 316750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316755 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 316759 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 316762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 316764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 316767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316772 */   GIR_RootConstrainSelectedInstOperands,
     /* 316773 */   // GIR_Coverage, 13024,
     /* 316773 */   GIR_EraseRootFromParent_Done,
     /* 316774 */ // Label 6356: @316774
     /* 316774 */ GIM_Reject,
     /* 316775 */ // Label 6313: @316775
     /* 316775 */ GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(316805), // Rule ID 1067 //
     /* 316780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 316783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316794 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 316794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 316799 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316803 */   GIR_RootConstrainSelectedInstOperands,
     /* 316804 */   // GIR_Coverage, 1067,
     /* 316804 */   GIR_Done,
     /* 316805 */ // Label 6357: @316805
     /* 316805 */ GIM_Reject,
     /* 316806 */ // Label 6314: @316806
     /* 316806 */ GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(316836), // Rule ID 1073 //
     /* 316811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316825 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 316825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 316830 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316834 */   GIR_RootConstrainSelectedInstOperands,
     /* 316835 */   // GIR_Coverage, 1073,
     /* 316835 */   GIR_Done,
     /* 316836 */ // Label 6358: @316836
     /* 316836 */ GIM_Reject,
     /* 316837 */ // Label 6315: @316837
     /* 316837 */ GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(316867), // Rule ID 1069 //
     /* 316842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 316845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316856 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 316856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 316861 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316865 */   GIR_RootConstrainSelectedInstOperands,
     /* 316866 */   // GIR_Coverage, 1069,
     /* 316866 */   GIR_Done,
     /* 316867 */ // Label 6359: @316867
     /* 316867 */ GIM_Reject,
     /* 316868 */ // Label 6316: @316868
     /* 316868 */ GIM_Reject,
     /* 316869 */ // Label 69: @316869
     /* 316869 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6367*/ GIMT_Encode4(317188),
     /* 316880 */ /*GILLT_s32*//*Label 6360*/ GIMT_Encode4(316916),
     /* 316884 */ /*GILLT_s64*//*Label 6361*/ GIMT_Encode4(316989), GIMT_Encode4(0),
     /* 316892 */ /*GILLT_v2s32*//*Label 6362*/ GIMT_Encode4(317062),
     /* 316896 */ /*GILLT_v2s64*//*Label 6363*/ GIMT_Encode4(317086),
     /* 316900 */ /*GILLT_v4s16*//*Label 6364*/ GIMT_Encode4(317110),
     /* 316904 */ /*GILLT_v4s32*//*Label 6365*/ GIMT_Encode4(317137), GIMT_Encode4(0),
     /* 316912 */ /*GILLT_v8s16*//*Label 6366*/ GIMT_Encode4(317161),
     /* 316916 */ // Label 6360: @316916
     /* 316916 */ GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(316942), // Rule ID 4562 //
     /* 316921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 316924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 316927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316931 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 316931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 316936 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316940 */   GIR_RootConstrainSelectedInstOperands,
     /* 316941 */   // GIR_Coverage, 4562,
     /* 316941 */   GIR_Done,
     /* 316942 */ // Label 6368: @316942
     /* 316942 */ GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(316965), // Rule ID 4564 //
     /* 316947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316954 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 316954 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 316959 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316963 */   GIR_RootConstrainSelectedInstOperands,
     /* 316964 */   // GIR_Coverage, 4564,
     /* 316964 */   GIR_Done,
     /* 316965 */ // Label 6369: @316965
     /* 316965 */ GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(316988), // Rule ID 4566 //
     /* 316970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316977 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 316977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 316982 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316986 */   GIR_RootConstrainSelectedInstOperands,
     /* 316987 */   // GIR_Coverage, 4566,
     /* 316987 */   GIR_Done,
     /* 316988 */ // Label 6370: @316988
     /* 316988 */ GIM_Reject,
     /* 316989 */ // Label 6361: @316989
     /* 316989 */ GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(317015), // Rule ID 4563 //
     /* 316994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 316997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 317000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317004 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 317004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 317009 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317013 */   GIR_RootConstrainSelectedInstOperands,
     /* 317014 */   // GIR_Coverage, 4563,
     /* 317014 */   GIR_Done,
     /* 317015 */ // Label 6371: @317015
     /* 317015 */ GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(317038), // Rule ID 4565 //
     /* 317020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317027 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 317027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 317032 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317036 */   GIR_RootConstrainSelectedInstOperands,
     /* 317037 */   // GIR_Coverage, 4565,
     /* 317037 */   GIR_Done,
     /* 317038 */ // Label 6372: @317038
     /* 317038 */ GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(317061), // Rule ID 4567 //
     /* 317043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317050 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 317050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 317055 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317059 */   GIR_RootConstrainSelectedInstOperands,
     /* 317060 */   // GIR_Coverage, 4567,
     /* 317060 */   GIR_Done,
     /* 317061 */ // Label 6373: @317061
     /* 317061 */ GIM_Reject,
     /* 317062 */ // Label 6362: @317062
     /* 317062 */ GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(317085), // Rule ID 4903 //
     /* 317067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317074 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 317074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 317079 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317083 */   GIR_RootConstrainSelectedInstOperands,
     /* 317084 */   // GIR_Coverage, 4903,
     /* 317084 */   GIR_Done,
     /* 317085 */ // Label 6374: @317085
     /* 317085 */ GIM_Reject,
     /* 317086 */ // Label 6363: @317086
     /* 317086 */ GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(317109), // Rule ID 4905 //
     /* 317091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317098 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 317098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 317103 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317107 */   GIR_RootConstrainSelectedInstOperands,
     /* 317108 */   // GIR_Coverage, 4905,
     /* 317108 */   GIR_Done,
     /* 317109 */ // Label 6375: @317109
     /* 317109 */ GIM_Reject,
     /* 317110 */ // Label 6364: @317110
     /* 317110 */ GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(317136), // Rule ID 4898 //
     /* 317115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 317121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317125 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 317125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 317130 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317134 */   GIR_RootConstrainSelectedInstOperands,
     /* 317135 */   // GIR_Coverage, 4898,
     /* 317135 */   GIR_Done,
     /* 317136 */ // Label 6376: @317136
     /* 317136 */ GIM_Reject,
     /* 317137 */ // Label 6365: @317137
     /* 317137 */ GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(317160), // Rule ID 4904 //
     /* 317142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317149 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 317149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 317154 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317158 */   GIR_RootConstrainSelectedInstOperands,
     /* 317159 */   // GIR_Coverage, 4904,
     /* 317159 */   GIR_Done,
     /* 317160 */ // Label 6377: @317160
     /* 317160 */ GIM_Reject,
     /* 317161 */ // Label 6366: @317161
     /* 317161 */ GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(317187), // Rule ID 4899 //
     /* 317166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317176 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 317176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 317181 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317185 */   GIR_RootConstrainSelectedInstOperands,
     /* 317186 */   // GIR_Coverage, 4899,
     /* 317186 */   GIR_Done,
     /* 317187 */ // Label 6378: @317187
     /* 317187 */ GIM_Reject,
     /* 317188 */ // Label 6367: @317188
     /* 317188 */ GIM_Reject,
     /* 317189 */ // Label 70: @317189
     /* 317189 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6386*/ GIMT_Encode4(317508),
     /* 317200 */ /*GILLT_s32*//*Label 6379*/ GIMT_Encode4(317236),
     /* 317204 */ /*GILLT_s64*//*Label 6380*/ GIMT_Encode4(317309), GIMT_Encode4(0),
     /* 317212 */ /*GILLT_v2s32*//*Label 6381*/ GIMT_Encode4(317382),
     /* 317216 */ /*GILLT_v2s64*//*Label 6382*/ GIMT_Encode4(317406),
     /* 317220 */ /*GILLT_v4s16*//*Label 6383*/ GIMT_Encode4(317430),
     /* 317224 */ /*GILLT_v4s32*//*Label 6384*/ GIMT_Encode4(317457), GIMT_Encode4(0),
     /* 317232 */ /*GILLT_v8s16*//*Label 6385*/ GIMT_Encode4(317481),
     /* 317236 */ // Label 6379: @317236
     /* 317236 */ GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(317262), // Rule ID 4586 //
     /* 317241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 317247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317251 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 317251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 317256 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317260 */   GIR_RootConstrainSelectedInstOperands,
     /* 317261 */   // GIR_Coverage, 4586,
     /* 317261 */   GIR_Done,
     /* 317262 */ // Label 6387: @317262
     /* 317262 */ GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(317285), // Rule ID 4588 //
     /* 317267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317274 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 317274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 317279 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317283 */   GIR_RootConstrainSelectedInstOperands,
     /* 317284 */   // GIR_Coverage, 4588,
     /* 317284 */   GIR_Done,
     /* 317285 */ // Label 6388: @317285
     /* 317285 */ GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(317308), // Rule ID 4590 //
     /* 317290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317297 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 317297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 317302 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317306 */   GIR_RootConstrainSelectedInstOperands,
     /* 317307 */   // GIR_Coverage, 4590,
     /* 317307 */   GIR_Done,
     /* 317308 */ // Label 6389: @317308
     /* 317308 */ GIM_Reject,
     /* 317309 */ // Label 6380: @317309
     /* 317309 */ GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(317335), // Rule ID 4587 //
     /* 317314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 317320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317324 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 317324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 317329 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317333 */   GIR_RootConstrainSelectedInstOperands,
     /* 317334 */   // GIR_Coverage, 4587,
     /* 317334 */   GIR_Done,
     /* 317335 */ // Label 6390: @317335
     /* 317335 */ GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(317358), // Rule ID 4589 //
     /* 317340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317347 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 317347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 317352 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317356 */   GIR_RootConstrainSelectedInstOperands,
     /* 317357 */   // GIR_Coverage, 4589,
     /* 317357 */   GIR_Done,
     /* 317358 */ // Label 6391: @317358
     /* 317358 */ GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(317381), // Rule ID 4591 //
     /* 317363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317370 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 317370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 317375 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317379 */   GIR_RootConstrainSelectedInstOperands,
     /* 317380 */   // GIR_Coverage, 4591,
     /* 317380 */   GIR_Done,
     /* 317381 */ // Label 6392: @317381
     /* 317381 */ GIM_Reject,
     /* 317382 */ // Label 6381: @317382
     /* 317382 */ GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(317405), // Rule ID 4913 //
     /* 317387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317394 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 317394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 317399 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317403 */   GIR_RootConstrainSelectedInstOperands,
     /* 317404 */   // GIR_Coverage, 4913,
     /* 317404 */   GIR_Done,
     /* 317405 */ // Label 6393: @317405
     /* 317405 */ GIM_Reject,
     /* 317406 */ // Label 6382: @317406
     /* 317406 */ GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(317429), // Rule ID 4915 //
     /* 317411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317418 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 317418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 317423 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317427 */   GIR_RootConstrainSelectedInstOperands,
     /* 317428 */   // GIR_Coverage, 4915,
     /* 317428 */   GIR_Done,
     /* 317429 */ // Label 6394: @317429
     /* 317429 */ GIM_Reject,
     /* 317430 */ // Label 6383: @317430
     /* 317430 */ GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(317456), // Rule ID 4908 //
     /* 317435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 317441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317445 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 317445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 317450 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317454 */   GIR_RootConstrainSelectedInstOperands,
     /* 317455 */   // GIR_Coverage, 4908,
     /* 317455 */   GIR_Done,
     /* 317456 */ // Label 6395: @317456
     /* 317456 */ GIM_Reject,
     /* 317457 */ // Label 6384: @317457
     /* 317457 */ GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(317480), // Rule ID 4914 //
     /* 317462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317469 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 317469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 317474 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317478 */   GIR_RootConstrainSelectedInstOperands,
     /* 317479 */   // GIR_Coverage, 4914,
     /* 317479 */   GIR_Done,
     /* 317480 */ // Label 6396: @317480
     /* 317480 */ GIM_Reject,
     /* 317481 */ // Label 6385: @317481
     /* 317481 */ GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(317507), // Rule ID 4909 //
     /* 317486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317496 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 317496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 317501 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317505 */   GIR_RootConstrainSelectedInstOperands,
     /* 317506 */   // GIR_Coverage, 4909,
     /* 317506 */   GIR_Done,
     /* 317507 */ // Label 6397: @317507
     /* 317507 */ GIM_Reject,
     /* 317508 */ // Label 6386: @317508
     /* 317508 */ GIM_Reject,
     /* 317509 */ // Label 71: @317509
     /* 317509 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6406*/ GIMT_Encode4(318365),
     /* 317520 */ /*GILLT_s16*//*Label 6398*/ GIMT_Encode4(317560),
     /* 317524 */ /*GILLT_s32*//*Label 6399*/ GIMT_Encode4(317779),
     /* 317528 */ /*GILLT_s64*//*Label 6400*/ GIMT_Encode4(317853), GIMT_Encode4(0),
     /* 317536 */ /*GILLT_v2s32*//*Label 6401*/ GIMT_Encode4(317927),
     /* 317540 */ /*GILLT_v2s64*//*Label 6402*/ GIMT_Encode4(318001),
     /* 317544 */ /*GILLT_v4s16*//*Label 6403*/ GIMT_Encode4(318075),
     /* 317548 */ /*GILLT_v4s32*//*Label 6404*/ GIMT_Encode4(318183), GIMT_Encode4(0),
     /* 317556 */ /*GILLT_v8s16*//*Label 6405*/ GIMT_Encode4(318257),
     /* 317560 */ // Label 6398: @317560
     /* 317560 */ GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(317778),
     /* 317565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 317568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317572 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(317613), // Rule ID 5184 //
     /* 317577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 317580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 317588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 317596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317598 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 317598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 317601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 317611 */     GIR_RootConstrainSelectedInstOperands,
     /* 317612 */     // GIR_Coverage, 5184,
     /* 317612 */     GIR_EraseRootFromParent_Done,
     /* 317613 */   // Label 6408: @317613
     /* 317613 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(317632), // Rule ID 521 //
     /* 317618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317625 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 317625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 317630 */     GIR_RootConstrainSelectedInstOperands,
     /* 317631 */     // GIR_Coverage, 521,
     /* 317631 */     GIR_Done,
     /* 317632 */   // Label 6409: @317632
     /* 317632 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(317777), // Rule ID 6327 //
     /* 317637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317641 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 317641 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 317644 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317648 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 317655 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 317658 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317662 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317667 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 317670 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 317674 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 317677 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317682 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317687 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317692 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 317695 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317699 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317704 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 317707 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317712 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317715 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 317719 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317724 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 317727 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 317732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317746 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317759 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 317766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317776 */     // GIR_Coverage, 6327,
     /* 317776 */     GIR_EraseRootFromParent_Done,
     /* 317777 */   // Label 6410: @317777
     /* 317777 */   GIM_Reject,
     /* 317778 */ // Label 6407: @317778
     /* 317778 */ GIM_Reject,
     /* 317779 */ // Label 6399: @317779
     /* 317779 */ GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(317852),
     /* 317784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317791 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(317832), // Rule ID 5185 //
     /* 317796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 317807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 317811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 317815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317817 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 317817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 317820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 317830 */     GIR_RootConstrainSelectedInstOperands,
     /* 317831 */     // GIR_Coverage, 5185,
     /* 317831 */     GIR_EraseRootFromParent_Done,
     /* 317832 */   // Label 6412: @317832
     /* 317832 */   GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(317851), // Rule ID 522 //
     /* 317837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317844 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 317844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 317849 */     GIR_RootConstrainSelectedInstOperands,
     /* 317850 */     // GIR_Coverage, 522,
     /* 317850 */     GIR_Done,
     /* 317851 */   // Label 6413: @317851
     /* 317851 */   GIM_Reject,
     /* 317852 */ // Label 6411: @317852
     /* 317852 */ GIM_Reject,
     /* 317853 */ // Label 6400: @317853
     /* 317853 */ GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(317926),
     /* 317858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317865 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(317906), // Rule ID 5186 //
     /* 317870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 317881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317891 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 317891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 317894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 317904 */     GIR_RootConstrainSelectedInstOperands,
     /* 317905 */     // GIR_Coverage, 5186,
     /* 317905 */     GIR_EraseRootFromParent_Done,
     /* 317906 */   // Label 6415: @317906
     /* 317906 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(317925), // Rule ID 523 //
     /* 317911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317918 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 317918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 317923 */     GIR_RootConstrainSelectedInstOperands,
     /* 317924 */     // GIR_Coverage, 523,
     /* 317924 */     GIR_Done,
     /* 317925 */   // Label 6416: @317925
     /* 317925 */   GIM_Reject,
     /* 317926 */ // Label 6414: @317926
     /* 317926 */ GIM_Reject,
     /* 317927 */ // Label 6401: @317927
     /* 317927 */ GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(318000),
     /* 317932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317939 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(317980), // Rule ID 4977 //
     /* 317944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 317955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 317963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317965 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 317965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 317968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 317978 */     GIR_RootConstrainSelectedInstOperands,
     /* 317979 */     // GIR_Coverage, 4977,
     /* 317979 */     GIR_EraseRootFromParent_Done,
     /* 317980 */   // Label 6418: @317980
     /* 317980 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(317999), // Rule ID 761 //
     /* 317985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317992 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 317992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 317997 */     GIR_RootConstrainSelectedInstOperands,
     /* 317998 */     // GIR_Coverage, 761,
     /* 317998 */     GIR_Done,
     /* 317999 */   // Label 6419: @317999
     /* 317999 */   GIM_Reject,
     /* 318000 */ // Label 6417: @318000
     /* 318000 */ GIM_Reject,
     /* 318001 */ // Label 6402: @318001
     /* 318001 */ GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(318074),
     /* 318006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318013 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(318054), // Rule ID 4979 //
     /* 318018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 318029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 318037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318039 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 318039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 318042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 318052 */     GIR_RootConstrainSelectedInstOperands,
     /* 318053 */     // GIR_Coverage, 4979,
     /* 318053 */     GIR_EraseRootFromParent_Done,
     /* 318054 */   // Label 6421: @318054
     /* 318054 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(318073), // Rule ID 763 //
     /* 318059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318066 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 318066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 318071 */     GIR_RootConstrainSelectedInstOperands,
     /* 318072 */     // GIR_Coverage, 763,
     /* 318072 */     GIR_Done,
     /* 318073 */   // Label 6422: @318073
     /* 318073 */   GIM_Reject,
     /* 318074 */ // Label 6420: @318074
     /* 318074 */ GIM_Reject,
     /* 318075 */ // Label 6403: @318075
     /* 318075 */ GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(318182),
     /* 318080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 318083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318087 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(318128), // Rule ID 4980 //
     /* 318092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 318095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 318103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 318107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 318111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318113 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 318113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 318116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 318126 */     GIR_RootConstrainSelectedInstOperands,
     /* 318127 */     // GIR_Coverage, 4980,
     /* 318127 */     GIR_EraseRootFromParent_Done,
     /* 318128 */   // Label 6424: @318128
     /* 318128 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(318147), // Rule ID 759 //
     /* 318133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 318136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318140 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 318140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 318145 */     GIR_RootConstrainSelectedInstOperands,
     /* 318146 */     // GIR_Coverage, 759,
     /* 318146 */     GIR_Done,
     /* 318147 */   // Label 6425: @318147
     /* 318147 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(318181), // Rule ID 6329 //
     /* 318152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318159 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 318159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 318162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318166 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 318176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 318179 */     GIR_RootConstrainSelectedInstOperands,
     /* 318180 */     // GIR_Coverage, 6329,
     /* 318180 */     GIR_EraseRootFromParent_Done,
     /* 318181 */   // Label 6426: @318181
     /* 318181 */   GIM_Reject,
     /* 318182 */ // Label 6423: @318182
     /* 318182 */ GIM_Reject,
     /* 318183 */ // Label 6404: @318183
     /* 318183 */ GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(318256),
     /* 318188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318195 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(318236), // Rule ID 4978 //
     /* 318200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 318211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 318219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318221 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 318221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 318224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 318234 */     GIR_RootConstrainSelectedInstOperands,
     /* 318235 */     // GIR_Coverage, 4978,
     /* 318235 */     GIR_EraseRootFromParent_Done,
     /* 318236 */   // Label 6428: @318236
     /* 318236 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(318255), // Rule ID 762 //
     /* 318241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318248 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 318248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 318253 */     GIR_RootConstrainSelectedInstOperands,
     /* 318254 */     // GIR_Coverage, 762,
     /* 318254 */     GIR_Done,
     /* 318255 */   // Label 6429: @318255
     /* 318255 */   GIM_Reject,
     /* 318256 */ // Label 6427: @318256
     /* 318256 */ GIM_Reject,
     /* 318257 */ // Label 6405: @318257
     /* 318257 */ GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(318364),
     /* 318262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 318265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318269 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(318310), // Rule ID 4981 //
     /* 318274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 318277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 318285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 318289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 318293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318295 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 318295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 318298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 318308 */     GIR_RootConstrainSelectedInstOperands,
     /* 318309 */     // GIR_Coverage, 4981,
     /* 318309 */     GIR_EraseRootFromParent_Done,
     /* 318310 */   // Label 6431: @318310
     /* 318310 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(318329), // Rule ID 760 //
     /* 318315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 318318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318322 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 318322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 318327 */     GIR_RootConstrainSelectedInstOperands,
     /* 318328 */     // GIR_Coverage, 760,
     /* 318328 */     GIR_Done,
     /* 318329 */   // Label 6432: @318329
     /* 318329 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(318363), // Rule ID 6330 //
     /* 318334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318341 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 318341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 318344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318348 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 318358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 318361 */     GIR_RootConstrainSelectedInstOperands,
     /* 318362 */     // GIR_Coverage, 6330,
     /* 318362 */     GIR_EraseRootFromParent_Done,
     /* 318363 */   // Label 6433: @318363
     /* 318363 */   GIM_Reject,
     /* 318364 */ // Label 6430: @318364
     /* 318364 */ GIM_Reject,
     /* 318365 */ // Label 6406: @318365
     /* 318365 */ GIM_Reject,
     /* 318366 */ // Label 72: @318366
     /* 318366 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6442*/ GIMT_Encode4(318647),
     /* 318377 */ /*GILLT_s16*//*Label 6434*/ GIMT_Encode4(318417),
     /* 318381 */ /*GILLT_s32*//*Label 6435*/ GIMT_Encode4(318444),
     /* 318385 */ /*GILLT_s64*//*Label 6436*/ GIMT_Encode4(318468), GIMT_Encode4(0),
     /* 318393 */ /*GILLT_v2s32*//*Label 6437*/ GIMT_Encode4(318492),
     /* 318397 */ /*GILLT_v2s64*//*Label 6438*/ GIMT_Encode4(318523),
     /* 318401 */ /*GILLT_v4s16*//*Label 6439*/ GIMT_Encode4(318554),
     /* 318405 */ /*GILLT_v4s32*//*Label 6440*/ GIMT_Encode4(318585), GIMT_Encode4(0),
     /* 318413 */ /*GILLT_v8s16*//*Label 6441*/ GIMT_Encode4(318616),
     /* 318417 */ // Label 6434: @318417
     /* 318417 */ GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(318443), // Rule ID 4802 //
     /* 318422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 318425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 318428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318432 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 318432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 318435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318437 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 318439 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 318441 */   GIR_RootConstrainSelectedInstOperands,
     /* 318442 */   // GIR_Coverage, 4802,
     /* 318442 */   GIR_EraseRootFromParent_Done,
     /* 318443 */ // Label 6443: @318443
     /* 318443 */ GIM_Reject,
     /* 318444 */ // Label 6435: @318444
     /* 318444 */ GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(318467), // Rule ID 4799 //
     /* 318449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318456 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 318456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 318459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318461 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 318463 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 318465 */   GIR_RootConstrainSelectedInstOperands,
     /* 318466 */   // GIR_Coverage, 4799,
     /* 318466 */   GIR_EraseRootFromParent_Done,
     /* 318467 */ // Label 6444: @318467
     /* 318467 */ GIM_Reject,
     /* 318468 */ // Label 6436: @318468
     /* 318468 */ GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(318491), // Rule ID 4796 //
     /* 318473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318480 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 318480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 318483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318485 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 318487 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 318489 */   GIR_RootConstrainSelectedInstOperands,
     /* 318490 */   // GIR_Coverage, 4796,
     /* 318490 */   GIR_EraseRootFromParent_Done,
     /* 318491 */ // Label 6445: @318491
     /* 318491 */ GIM_Reject,
     /* 318492 */ // Label 6437: @318492
     /* 318492 */ GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(318522), // Rule ID 4990 //
     /* 318497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318511 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 318511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 318514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318516 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318518 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318520 */   GIR_RootConstrainSelectedInstOperands,
     /* 318521 */   // GIR_Coverage, 4990,
     /* 318521 */   GIR_EraseRootFromParent_Done,
     /* 318522 */ // Label 6446: @318522
     /* 318522 */ GIM_Reject,
     /* 318523 */ // Label 6438: @318523
     /* 318523 */ GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(318553), // Rule ID 4984 //
     /* 318528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318542 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 318542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 318545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318547 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318549 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318551 */   GIR_RootConstrainSelectedInstOperands,
     /* 318552 */   // GIR_Coverage, 4984,
     /* 318552 */   GIR_EraseRootFromParent_Done,
     /* 318553 */ // Label 6447: @318553
     /* 318553 */ GIM_Reject,
     /* 318554 */ // Label 6439: @318554
     /* 318554 */ GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(318584), // Rule ID 4996 //
     /* 318559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 318562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 318565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318573 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 318573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 318576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318578 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318580 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318582 */   GIR_RootConstrainSelectedInstOperands,
     /* 318583 */   // GIR_Coverage, 4996,
     /* 318583 */   GIR_EraseRootFromParent_Done,
     /* 318584 */ // Label 6448: @318584
     /* 318584 */ GIM_Reject,
     /* 318585 */ // Label 6440: @318585
     /* 318585 */ GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(318615), // Rule ID 4987 //
     /* 318590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318604 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 318604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 318607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318609 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318611 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318613 */   GIR_RootConstrainSelectedInstOperands,
     /* 318614 */   // GIR_Coverage, 4987,
     /* 318614 */   GIR_EraseRootFromParent_Done,
     /* 318615 */ // Label 6449: @318615
     /* 318615 */ GIM_Reject,
     /* 318616 */ // Label 6441: @318616
     /* 318616 */ GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(318646), // Rule ID 4993 //
     /* 318621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 318624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 318627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318635 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 318635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 318638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318640 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318642 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318644 */   GIR_RootConstrainSelectedInstOperands,
     /* 318645 */   // GIR_Coverage, 4993,
     /* 318645 */   GIR_EraseRootFromParent_Done,
     /* 318646 */ // Label 6450: @318646
     /* 318646 */ GIM_Reject,
     /* 318647 */ // Label 6442: @318647
     /* 318647 */ GIM_Reject,
     /* 318648 */ // Label 73: @318648
     /* 318648 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6459*/ GIMT_Encode4(319025),
     /* 318659 */ /*GILLT_s16*//*Label 6451*/ GIMT_Encode4(318699),
     /* 318663 */ /*GILLT_s32*//*Label 6452*/ GIMT_Encode4(318737),
     /* 318667 */ /*GILLT_s64*//*Label 6453*/ GIMT_Encode4(318775), GIMT_Encode4(0),
     /* 318675 */ /*GILLT_v2s32*//*Label 6454*/ GIMT_Encode4(318835),
     /* 318679 */ /*GILLT_v2s64*//*Label 6455*/ GIMT_Encode4(318873),
     /* 318683 */ /*GILLT_v4s16*//*Label 6456*/ GIMT_Encode4(318911),
     /* 318687 */ /*GILLT_v4s32*//*Label 6457*/ GIMT_Encode4(318949), GIMT_Encode4(0),
     /* 318695 */ /*GILLT_v8s16*//*Label 6458*/ GIMT_Encode4(318987),
     /* 318699 */ // Label 6451: @318699
     /* 318699 */ GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(318736), // Rule ID 608 //
     /* 318704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 318707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 318710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 318713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318725 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 318725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 318730 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318734 */   GIR_RootConstrainSelectedInstOperands,
     /* 318735 */   // GIR_Coverage, 608,
     /* 318735 */   GIR_Done,
     /* 318736 */ // Label 6460: @318736
     /* 318736 */ GIM_Reject,
     /* 318737 */ // Label 6452: @318737
     /* 318737 */ GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(318774), // Rule ID 610 //
     /* 318742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 318751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318763 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 318763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 318768 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318772 */   GIR_RootConstrainSelectedInstOperands,
     /* 318773 */   // GIR_Coverage, 610,
     /* 318773 */   GIR_Done,
     /* 318774 */ // Label 6461: @318774
     /* 318774 */ GIM_Reject,
     /* 318775 */ // Label 6453: @318775
     /* 318775 */ GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(318834),
     /* 318780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 318786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318798 */   GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(318817), // Rule ID 612 //
     /* 318803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318806 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 318806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 318811 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318815 */     GIR_RootConstrainSelectedInstOperands,
     /* 318816 */     // GIR_Coverage, 612,
     /* 318816 */     GIR_Done,
     /* 318817 */   // Label 6463: @318817
     /* 318817 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(318833), // Rule ID 4793 //
     /* 318822 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 318822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 318827 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318831 */     GIR_RootConstrainSelectedInstOperands,
     /* 318832 */     // GIR_Coverage, 4793,
     /* 318832 */     GIR_Done,
     /* 318833 */   // Label 6464: @318833
     /* 318833 */   GIM_Reject,
     /* 318834 */ // Label 6462: @318834
     /* 318834 */ GIM_Reject,
     /* 318835 */ // Label 6454: @318835
     /* 318835 */ GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(318872), // Rule ID 1266 //
     /* 318840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 318849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318861 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 318861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 318866 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318870 */   GIR_RootConstrainSelectedInstOperands,
     /* 318871 */   // GIR_Coverage, 1266,
     /* 318871 */   GIR_Done,
     /* 318872 */ // Label 6465: @318872
     /* 318872 */ GIM_Reject,
     /* 318873 */ // Label 6455: @318873
     /* 318873 */ GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(318910), // Rule ID 1270 //
     /* 318878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 318887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318899 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 318899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 318904 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318908 */   GIR_RootConstrainSelectedInstOperands,
     /* 318909 */   // GIR_Coverage, 1270,
     /* 318909 */   GIR_Done,
     /* 318910 */ // Label 6466: @318910
     /* 318910 */ GIM_Reject,
     /* 318911 */ // Label 6456: @318911
     /* 318911 */ GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(318948), // Rule ID 1262 //
     /* 318916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 318919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 318922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 318925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318937 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 318937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 318942 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318946 */   GIR_RootConstrainSelectedInstOperands,
     /* 318947 */   // GIR_Coverage, 1262,
     /* 318947 */   GIR_Done,
     /* 318948 */ // Label 6467: @318948
     /* 318948 */ GIM_Reject,
     /* 318949 */ // Label 6457: @318949
     /* 318949 */ GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(318986), // Rule ID 1268 //
     /* 318954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 318963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318971 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318975 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 318975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 318980 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318984 */   GIR_RootConstrainSelectedInstOperands,
     /* 318985 */   // GIR_Coverage, 1268,
     /* 318985 */   GIR_Done,
     /* 318986 */ // Label 6468: @318986
     /* 318986 */ GIM_Reject,
     /* 318987 */ // Label 6458: @318987
     /* 318987 */ GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(319024), // Rule ID 1264 //
     /* 318992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 318995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 318998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 319001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319013 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 319013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 319018 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319022 */   GIR_RootConstrainSelectedInstOperands,
     /* 319023 */   // GIR_Coverage, 1264,
     /* 319023 */   GIR_Done,
     /* 319024 */ // Label 6469: @319024
     /* 319024 */ GIM_Reject,
     /* 319025 */ // Label 6459: @319025
     /* 319025 */ GIM_Reject,
     /* 319026 */ // Label 74: @319026
     /* 319026 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6478*/ GIMT_Encode4(319403),
     /* 319037 */ /*GILLT_s16*//*Label 6470*/ GIMT_Encode4(319077),
     /* 319041 */ /*GILLT_s32*//*Label 6471*/ GIMT_Encode4(319115),
     /* 319045 */ /*GILLT_s64*//*Label 6472*/ GIMT_Encode4(319153), GIMT_Encode4(0),
     /* 319053 */ /*GILLT_v2s32*//*Label 6473*/ GIMT_Encode4(319213),
     /* 319057 */ /*GILLT_v2s64*//*Label 6474*/ GIMT_Encode4(319251),
     /* 319061 */ /*GILLT_v4s16*//*Label 6475*/ GIMT_Encode4(319289),
     /* 319065 */ /*GILLT_v4s32*//*Label 6476*/ GIMT_Encode4(319327), GIMT_Encode4(0),
     /* 319073 */ /*GILLT_v8s16*//*Label 6477*/ GIMT_Encode4(319365),
     /* 319077 */ // Label 6470: @319077
     /* 319077 */ GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(319114), // Rule ID 596 //
     /* 319082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 319085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 319088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 319091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319099 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319103 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 319103 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 319108 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319112 */   GIR_RootConstrainSelectedInstOperands,
     /* 319113 */   // GIR_Coverage, 596,
     /* 319113 */   GIR_Done,
     /* 319114 */ // Label 6479: @319114
     /* 319114 */ GIM_Reject,
     /* 319115 */ // Label 6471: @319115
     /* 319115 */ GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(319152), // Rule ID 598 //
     /* 319120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 319129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319141 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 319141 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 319146 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319150 */   GIR_RootConstrainSelectedInstOperands,
     /* 319151 */   // GIR_Coverage, 598,
     /* 319151 */   GIR_Done,
     /* 319152 */ // Label 6480: @319152
     /* 319152 */ GIM_Reject,
     /* 319153 */ // Label 6472: @319153
     /* 319153 */ GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(319212),
     /* 319158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 319161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 319164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319176 */   GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(319195), // Rule ID 600 //
     /* 319181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319184 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 319184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 319189 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319193 */     GIR_RootConstrainSelectedInstOperands,
     /* 319194 */     // GIR_Coverage, 600,
     /* 319194 */     GIR_Done,
     /* 319195 */   // Label 6482: @319195
     /* 319195 */   GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(319211), // Rule ID 4792 //
     /* 319200 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 319200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 319205 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319209 */     GIR_RootConstrainSelectedInstOperands,
     /* 319210 */     // GIR_Coverage, 4792,
     /* 319210 */     GIR_Done,
     /* 319211 */   // Label 6483: @319211
     /* 319211 */   GIM_Reject,
     /* 319212 */ // Label 6481: @319212
     /* 319212 */ GIM_Reject,
     /* 319213 */ // Label 6473: @319213
     /* 319213 */ GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(319250), // Rule ID 1236 //
     /* 319218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 319227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319239 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 319239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 319244 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319248 */   GIR_RootConstrainSelectedInstOperands,
     /* 319249 */   // GIR_Coverage, 1236,
     /* 319249 */   GIR_Done,
     /* 319250 */ // Label 6484: @319250
     /* 319250 */ GIM_Reject,
     /* 319251 */ // Label 6474: @319251
     /* 319251 */ GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(319288), // Rule ID 1240 //
     /* 319256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 319265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319277 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 319277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 319282 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319286 */   GIR_RootConstrainSelectedInstOperands,
     /* 319287 */   // GIR_Coverage, 1240,
     /* 319287 */   GIR_Done,
     /* 319288 */ // Label 6485: @319288
     /* 319288 */ GIM_Reject,
     /* 319289 */ // Label 6475: @319289
     /* 319289 */ GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(319326), // Rule ID 1232 //
     /* 319294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 319297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 319300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 319303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319315 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 319315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 319320 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319324 */   GIR_RootConstrainSelectedInstOperands,
     /* 319325 */   // GIR_Coverage, 1232,
     /* 319325 */   GIR_Done,
     /* 319326 */ // Label 6486: @319326
     /* 319326 */ GIM_Reject,
     /* 319327 */ // Label 6476: @319327
     /* 319327 */ GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(319364), // Rule ID 1238 //
     /* 319332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 319341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319353 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 319353 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 319358 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319362 */   GIR_RootConstrainSelectedInstOperands,
     /* 319363 */   // GIR_Coverage, 1238,
     /* 319363 */   GIR_Done,
     /* 319364 */ // Label 6487: @319364
     /* 319364 */ GIM_Reject,
     /* 319365 */ // Label 6477: @319365
     /* 319365 */ GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(319402), // Rule ID 1234 //
     /* 319370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 319373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 319376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 319379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319391 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 319391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 319396 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319400 */   GIR_RootConstrainSelectedInstOperands,
     /* 319401 */   // GIR_Coverage, 1234,
     /* 319401 */   GIR_Done,
     /* 319402 */ // Label 6488: @319402
     /* 319402 */ GIM_Reject,
     /* 319403 */ // Label 6478: @319403
     /* 319403 */ GIM_Reject,
     /* 319404 */ // Label 75: @319404
     /* 319404 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6497*/ GIMT_Encode4(319753),
     /* 319415 */ /*GILLT_s16*//*Label 6489*/ GIMT_Encode4(319455),
     /* 319419 */ /*GILLT_s32*//*Label 6490*/ GIMT_Encode4(319493),
     /* 319423 */ /*GILLT_s64*//*Label 6491*/ GIMT_Encode4(319528), GIMT_Encode4(0),
     /* 319431 */ /*GILLT_v2s32*//*Label 6492*/ GIMT_Encode4(319563),
     /* 319435 */ /*GILLT_v2s64*//*Label 6493*/ GIMT_Encode4(319601),
     /* 319439 */ /*GILLT_v4s16*//*Label 6494*/ GIMT_Encode4(319639),
     /* 319443 */ /*GILLT_v4s32*//*Label 6495*/ GIMT_Encode4(319677), GIMT_Encode4(0),
     /* 319451 */ /*GILLT_v8s16*//*Label 6496*/ GIMT_Encode4(319715),
     /* 319455 */ // Label 6489: @319455
     /* 319455 */ GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(319492), // Rule ID 4800 //
     /* 319460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 319463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 319466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 319469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319481 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 319481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 319486 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319490 */   GIR_RootConstrainSelectedInstOperands,
     /* 319491 */   // GIR_Coverage, 4800,
     /* 319491 */   GIR_Done,
     /* 319492 */ // Label 6498: @319492
     /* 319492 */ GIM_Reject,
     /* 319493 */ // Label 6490: @319493
     /* 319493 */ GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(319527), // Rule ID 4797 //
     /* 319498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 319504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319516 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 319516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 319521 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319525 */   GIR_RootConstrainSelectedInstOperands,
     /* 319526 */   // GIR_Coverage, 4797,
     /* 319526 */   GIR_Done,
     /* 319527 */ // Label 6499: @319527
     /* 319527 */ GIM_Reject,
     /* 319528 */ // Label 6491: @319528
     /* 319528 */ GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(319562), // Rule ID 4794 //
     /* 319533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 319536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 319539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319551 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 319551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 319556 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319560 */   GIR_RootConstrainSelectedInstOperands,
     /* 319561 */   // GIR_Coverage, 4794,
     /* 319561 */   GIR_Done,
     /* 319562 */ // Label 6500: @319562
     /* 319562 */ GIM_Reject,
     /* 319563 */ // Label 6492: @319563
     /* 319563 */ GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(319600), // Rule ID 4988 //
     /* 319568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 319577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319589 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 319589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 319594 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319598 */   GIR_RootConstrainSelectedInstOperands,
     /* 319599 */   // GIR_Coverage, 4988,
     /* 319599 */   GIR_Done,
     /* 319600 */ // Label 6501: @319600
     /* 319600 */ GIM_Reject,
     /* 319601 */ // Label 6493: @319601
     /* 319601 */ GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(319638), // Rule ID 4982 //
     /* 319606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 319615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319627 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 319627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 319632 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319636 */   GIR_RootConstrainSelectedInstOperands,
     /* 319637 */   // GIR_Coverage, 4982,
     /* 319637 */   GIR_Done,
     /* 319638 */ // Label 6502: @319638
     /* 319638 */ GIM_Reject,
     /* 319639 */ // Label 6494: @319639
     /* 319639 */ GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(319676), // Rule ID 4994 //
     /* 319644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 319647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 319650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 319653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319665 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 319665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 319670 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319674 */   GIR_RootConstrainSelectedInstOperands,
     /* 319675 */   // GIR_Coverage, 4994,
     /* 319675 */   GIR_Done,
     /* 319676 */ // Label 6503: @319676
     /* 319676 */ GIM_Reject,
     /* 319677 */ // Label 6495: @319677
     /* 319677 */ GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(319714), // Rule ID 4985 //
     /* 319682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 319691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319703 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 319703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 319708 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319712 */   GIR_RootConstrainSelectedInstOperands,
     /* 319713 */   // GIR_Coverage, 4985,
     /* 319713 */   GIR_Done,
     /* 319714 */ // Label 6504: @319714
     /* 319714 */ GIM_Reject,
     /* 319715 */ // Label 6496: @319715
     /* 319715 */ GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(319752), // Rule ID 4991 //
     /* 319720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 319723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 319726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 319729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319737 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319741 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 319741 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 319746 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319750 */   GIR_RootConstrainSelectedInstOperands,
     /* 319751 */   // GIR_Coverage, 4991,
     /* 319751 */   GIR_Done,
     /* 319752 */ // Label 6505: @319752
     /* 319752 */ GIM_Reject,
     /* 319753 */ // Label 6497: @319753
     /* 319753 */ GIM_Reject,
     /* 319754 */ // Label 76: @319754
     /* 319754 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6514*/ GIMT_Encode4(320103),
     /* 319765 */ /*GILLT_s16*//*Label 6506*/ GIMT_Encode4(319805),
     /* 319769 */ /*GILLT_s32*//*Label 6507*/ GIMT_Encode4(319843),
     /* 319773 */ /*GILLT_s64*//*Label 6508*/ GIMT_Encode4(319878), GIMT_Encode4(0),
     /* 319781 */ /*GILLT_v2s32*//*Label 6509*/ GIMT_Encode4(319913),
     /* 319785 */ /*GILLT_v2s64*//*Label 6510*/ GIMT_Encode4(319951),
     /* 319789 */ /*GILLT_v4s16*//*Label 6511*/ GIMT_Encode4(319989),
     /* 319793 */ /*GILLT_v4s32*//*Label 6512*/ GIMT_Encode4(320027), GIMT_Encode4(0),
     /* 319801 */ /*GILLT_v8s16*//*Label 6513*/ GIMT_Encode4(320065),
     /* 319805 */ // Label 6506: @319805
     /* 319805 */ GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(319842), // Rule ID 4801 //
     /* 319810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 319813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 319816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 319819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319831 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 319831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 319836 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319840 */   GIR_RootConstrainSelectedInstOperands,
     /* 319841 */   // GIR_Coverage, 4801,
     /* 319841 */   GIR_Done,
     /* 319842 */ // Label 6515: @319842
     /* 319842 */ GIM_Reject,
     /* 319843 */ // Label 6507: @319843
     /* 319843 */ GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(319877), // Rule ID 4798 //
     /* 319848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 319854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319866 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 319866 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 319871 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319875 */   GIR_RootConstrainSelectedInstOperands,
     /* 319876 */   // GIR_Coverage, 4798,
     /* 319876 */   GIR_Done,
     /* 319877 */ // Label 6516: @319877
     /* 319877 */ GIM_Reject,
     /* 319878 */ // Label 6508: @319878
     /* 319878 */ GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(319912), // Rule ID 4795 //
     /* 319883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 319886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 319889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319901 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 319901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 319906 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319910 */   GIR_RootConstrainSelectedInstOperands,
     /* 319911 */   // GIR_Coverage, 4795,
     /* 319911 */   GIR_Done,
     /* 319912 */ // Label 6517: @319912
     /* 319912 */ GIM_Reject,
     /* 319913 */ // Label 6509: @319913
     /* 319913 */ GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(319950), // Rule ID 4989 //
     /* 319918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 319927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319939 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 319939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 319944 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319948 */   GIR_RootConstrainSelectedInstOperands,
     /* 319949 */   // GIR_Coverage, 4989,
     /* 319949 */   GIR_Done,
     /* 319950 */ // Label 6518: @319950
     /* 319950 */ GIM_Reject,
     /* 319951 */ // Label 6510: @319951
     /* 319951 */ GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(319988), // Rule ID 4983 //
     /* 319956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 319965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319977 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 319977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 319982 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319986 */   GIR_RootConstrainSelectedInstOperands,
     /* 319987 */   // GIR_Coverage, 4983,
     /* 319987 */   GIR_Done,
     /* 319988 */ // Label 6519: @319988
     /* 319988 */ GIM_Reject,
     /* 319989 */ // Label 6511: @319989
     /* 319989 */ GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(320026), // Rule ID 4995 //
     /* 319994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 319997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 320003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320015 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 320015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 320020 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320024 */   GIR_RootConstrainSelectedInstOperands,
     /* 320025 */   // GIR_Coverage, 4995,
     /* 320025 */   GIR_Done,
     /* 320026 */ // Label 6520: @320026
     /* 320026 */ GIM_Reject,
     /* 320027 */ // Label 6512: @320027
     /* 320027 */ GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(320064), // Rule ID 4986 //
     /* 320032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 320041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320053 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 320053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 320058 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320062 */   GIR_RootConstrainSelectedInstOperands,
     /* 320063 */   // GIR_Coverage, 4986,
     /* 320063 */   GIR_Done,
     /* 320064 */ // Label 6521: @320064
     /* 320064 */ GIM_Reject,
     /* 320065 */ // Label 6513: @320065
     /* 320065 */ GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(320102), // Rule ID 4992 //
     /* 320070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 320079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320091 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 320091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 320096 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320100 */   GIR_RootConstrainSelectedInstOperands,
     /* 320101 */   // GIR_Coverage, 4992,
     /* 320101 */   GIR_Done,
     /* 320102 */ // Label 6522: @320102
     /* 320102 */ GIM_Reject,
     /* 320103 */ // Label 6514: @320103
     /* 320103 */ GIM_Reject,
     /* 320104 */ // Label 77: @320104
     /* 320104 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6531*/ GIMT_Encode4(320806),
     /* 320115 */ /*GILLT_s16*//*Label 6523*/ GIMT_Encode4(320155),
     /* 320119 */ /*GILLT_s32*//*Label 6524*/ GIMT_Encode4(320193),
     /* 320123 */ /*GILLT_s64*//*Label 6525*/ GIMT_Encode4(320231), GIMT_Encode4(0),
     /* 320131 */ /*GILLT_v2s32*//*Label 6526*/ GIMT_Encode4(320291),
     /* 320135 */ /*GILLT_v2s64*//*Label 6527*/ GIMT_Encode4(320394),
     /* 320139 */ /*GILLT_v4s16*//*Label 6528*/ GIMT_Encode4(320497),
     /* 320143 */ /*GILLT_v4s32*//*Label 6529*/ GIMT_Encode4(320600), GIMT_Encode4(0),
     /* 320151 */ /*GILLT_v8s16*//*Label 6530*/ GIMT_Encode4(320703),
     /* 320155 */ // Label 6523: @320155
     /* 320155 */ GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(320192), // Rule ID 614 //
     /* 320160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 320166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 320169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320181 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 320181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 320186 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320190 */   GIR_RootConstrainSelectedInstOperands,
     /* 320191 */   // GIR_Coverage, 614,
     /* 320191 */   GIR_Done,
     /* 320192 */ // Label 6532: @320192
     /* 320192 */ GIM_Reject,
     /* 320193 */ // Label 6524: @320193
     /* 320193 */ GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(320230), // Rule ID 616 //
     /* 320198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 320201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 320207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320219 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 320219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 320224 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320228 */   GIR_RootConstrainSelectedInstOperands,
     /* 320229 */   // GIR_Coverage, 616,
     /* 320229 */   GIR_Done,
     /* 320230 */ // Label 6533: @320230
     /* 320230 */ GIM_Reject,
     /* 320231 */ // Label 6525: @320231
     /* 320231 */ GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(320290),
     /* 320236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 320242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320254 */   GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(320273), // Rule ID 618 //
     /* 320259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 320262 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 320262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 320267 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320271 */     GIR_RootConstrainSelectedInstOperands,
     /* 320272 */     // GIR_Coverage, 618,
     /* 320272 */     GIR_Done,
     /* 320273 */   // Label 6535: @320273
     /* 320273 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(320289), // Rule ID 4791 //
     /* 320278 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 320278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 320283 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320287 */     GIR_RootConstrainSelectedInstOperands,
     /* 320288 */     // GIR_Coverage, 4791,
     /* 320288 */     GIR_Done,
     /* 320289 */   // Label 6536: @320289
     /* 320289 */   GIM_Reject,
     /* 320290 */ // Label 6534: @320290
     /* 320290 */ GIM_Reject,
     /* 320291 */ // Label 6526: @320291
     /* 320291 */ GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(320393),
     /* 320296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 320302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320306 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(320365), // Rule ID 2357 //
     /* 320311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 320314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 320322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 320339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320350 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 320350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 320353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320363 */     GIR_RootConstrainSelectedInstOperands,
     /* 320364 */     // GIR_Coverage, 2357,
     /* 320364 */     GIR_EraseRootFromParent_Done,
     /* 320365 */   // Label 6538: @320365
     /* 320365 */   GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(320392), // Rule ID 1281 //
     /* 320370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320381 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 320381 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 320386 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320390 */     GIR_RootConstrainSelectedInstOperands,
     /* 320391 */     // GIR_Coverage, 1281,
     /* 320391 */     GIR_Done,
     /* 320392 */   // Label 6539: @320392
     /* 320392 */   GIM_Reject,
     /* 320393 */ // Label 6537: @320393
     /* 320393 */ GIM_Reject,
     /* 320394 */ // Label 6527: @320394
     /* 320394 */ GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(320496),
     /* 320399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 320405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320409 */   GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(320468), // Rule ID 2363 //
     /* 320414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 320417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 320425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 320442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320453 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 320453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 320456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320466 */     GIR_RootConstrainSelectedInstOperands,
     /* 320467 */     // GIR_Coverage, 2363,
     /* 320467 */     GIR_EraseRootFromParent_Done,
     /* 320468 */   // Label 6541: @320468
     /* 320468 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(320495), // Rule ID 1285 //
     /* 320473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320484 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 320484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 320489 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320493 */     GIR_RootConstrainSelectedInstOperands,
     /* 320494 */     // GIR_Coverage, 1285,
     /* 320494 */     GIR_Done,
     /* 320495 */   // Label 6542: @320495
     /* 320495 */   GIM_Reject,
     /* 320496 */ // Label 6540: @320496
     /* 320496 */ GIM_Reject,
     /* 320497 */ // Label 6528: @320497
     /* 320497 */ GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(320599),
     /* 320502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 320508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320512 */   GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(320571), // Rule ID 2351 //
     /* 320517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 320520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 320528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 320545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320556 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 320556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 320559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320569 */     GIR_RootConstrainSelectedInstOperands,
     /* 320570 */     // GIR_Coverage, 2351,
     /* 320570 */     GIR_EraseRootFromParent_Done,
     /* 320571 */   // Label 6544: @320571
     /* 320571 */   GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(320598), // Rule ID 1277 //
     /* 320576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320587 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 320587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 320592 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320596 */     GIR_RootConstrainSelectedInstOperands,
     /* 320597 */     // GIR_Coverage, 1277,
     /* 320597 */     GIR_Done,
     /* 320598 */   // Label 6545: @320598
     /* 320598 */   GIM_Reject,
     /* 320599 */ // Label 6543: @320599
     /* 320599 */ GIM_Reject,
     /* 320600 */ // Label 6529: @320600
     /* 320600 */ GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(320702),
     /* 320605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 320611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320615 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(320674), // Rule ID 2360 //
     /* 320620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 320623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 320631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 320648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320659 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 320659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 320662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320672 */     GIR_RootConstrainSelectedInstOperands,
     /* 320673 */     // GIR_Coverage, 2360,
     /* 320673 */     GIR_EraseRootFromParent_Done,
     /* 320674 */   // Label 6547: @320674
     /* 320674 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(320701), // Rule ID 1283 //
     /* 320679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320690 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 320690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 320695 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320699 */     GIR_RootConstrainSelectedInstOperands,
     /* 320700 */     // GIR_Coverage, 1283,
     /* 320700 */     GIR_Done,
     /* 320701 */   // Label 6548: @320701
     /* 320701 */   GIM_Reject,
     /* 320702 */ // Label 6546: @320702
     /* 320702 */ GIM_Reject,
     /* 320703 */ // Label 6530: @320703
     /* 320703 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(320805),
     /* 320708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 320714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320718 */   GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(320777), // Rule ID 2354 //
     /* 320723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 320726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 320734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 320751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320762 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 320762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 320765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320775 */     GIR_RootConstrainSelectedInstOperands,
     /* 320776 */     // GIR_Coverage, 2354,
     /* 320776 */     GIR_EraseRootFromParent_Done,
     /* 320777 */   // Label 6550: @320777
     /* 320777 */   GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(320804), // Rule ID 1279 //
     /* 320782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320793 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 320793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 320798 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320802 */     GIR_RootConstrainSelectedInstOperands,
     /* 320803 */     // GIR_Coverage, 1279,
     /* 320803 */     GIR_Done,
     /* 320804 */   // Label 6551: @320804
     /* 320804 */   GIM_Reject,
     /* 320805 */ // Label 6549: @320805
     /* 320805 */ GIM_Reject,
     /* 320806 */ // Label 6531: @320806
     /* 320806 */ GIM_Reject,
     /* 320807 */ // Label 78: @320807
     /* 320807 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6560*/ GIMT_Encode4(321509),
     /* 320818 */ /*GILLT_s16*//*Label 6552*/ GIMT_Encode4(320858),
     /* 320822 */ /*GILLT_s32*//*Label 6553*/ GIMT_Encode4(320896),
     /* 320826 */ /*GILLT_s64*//*Label 6554*/ GIMT_Encode4(320934), GIMT_Encode4(0),
     /* 320834 */ /*GILLT_v2s32*//*Label 6555*/ GIMT_Encode4(320994),
     /* 320838 */ /*GILLT_v2s64*//*Label 6556*/ GIMT_Encode4(321097),
     /* 320842 */ /*GILLT_v4s16*//*Label 6557*/ GIMT_Encode4(321200),
     /* 320846 */ /*GILLT_v4s32*//*Label 6558*/ GIMT_Encode4(321303), GIMT_Encode4(0),
     /* 320854 */ /*GILLT_v8s16*//*Label 6559*/ GIMT_Encode4(321406),
     /* 320858 */ // Label 6552: @320858
     /* 320858 */ GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(320895), // Rule ID 602 //
     /* 320863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 320869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 320872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320884 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 320884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 320889 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320893 */   GIR_RootConstrainSelectedInstOperands,
     /* 320894 */   // GIR_Coverage, 602,
     /* 320894 */   GIR_Done,
     /* 320895 */ // Label 6561: @320895
     /* 320895 */ GIM_Reject,
     /* 320896 */ // Label 6553: @320896
     /* 320896 */ GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(320933), // Rule ID 604 //
     /* 320901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 320904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 320910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320922 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 320922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 320927 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320931 */   GIR_RootConstrainSelectedInstOperands,
     /* 320932 */   // GIR_Coverage, 604,
     /* 320932 */   GIR_Done,
     /* 320933 */ // Label 6562: @320933
     /* 320933 */ GIM_Reject,
     /* 320934 */ // Label 6554: @320934
     /* 320934 */ GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(320993),
     /* 320939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 320945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320957 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(320976), // Rule ID 606 //
     /* 320962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 320965 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 320965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 320970 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320974 */     GIR_RootConstrainSelectedInstOperands,
     /* 320975 */     // GIR_Coverage, 606,
     /* 320975 */     GIR_Done,
     /* 320976 */   // Label 6564: @320976
     /* 320976 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(320992), // Rule ID 4790 //
     /* 320981 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 320981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 320986 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320990 */     GIR_RootConstrainSelectedInstOperands,
     /* 320991 */     // GIR_Coverage, 4790,
     /* 320991 */     GIR_Done,
     /* 320992 */   // Label 6565: @320992
     /* 320992 */   GIM_Reject,
     /* 320993 */ // Label 6563: @320993
     /* 320993 */ GIM_Reject,
     /* 320994 */ // Label 6555: @320994
     /* 320994 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(321096),
     /* 320999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 321005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321009 */   GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(321068), // Rule ID 2342 //
     /* 321014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 321017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 321025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 321042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321046 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321053 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 321053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 321056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321066 */     GIR_RootConstrainSelectedInstOperands,
     /* 321067 */     // GIR_Coverage, 2342,
     /* 321067 */     GIR_EraseRootFromParent_Done,
     /* 321068 */   // Label 6567: @321068
     /* 321068 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(321095), // Rule ID 1251 //
     /* 321073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321084 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 321084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 321089 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321093 */     GIR_RootConstrainSelectedInstOperands,
     /* 321094 */     // GIR_Coverage, 1251,
     /* 321094 */     GIR_Done,
     /* 321095 */   // Label 6568: @321095
     /* 321095 */   GIM_Reject,
     /* 321096 */ // Label 6566: @321096
     /* 321096 */ GIM_Reject,
     /* 321097 */ // Label 6556: @321097
     /* 321097 */ GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(321199),
     /* 321102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 321108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321112 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(321171), // Rule ID 2348 //
     /* 321117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 321120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 321128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 321145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321149 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321156 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 321156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 321159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321169 */     GIR_RootConstrainSelectedInstOperands,
     /* 321170 */     // GIR_Coverage, 2348,
     /* 321170 */     GIR_EraseRootFromParent_Done,
     /* 321171 */   // Label 6570: @321171
     /* 321171 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(321198), // Rule ID 1255 //
     /* 321176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321187 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 321187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 321192 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321196 */     GIR_RootConstrainSelectedInstOperands,
     /* 321197 */     // GIR_Coverage, 1255,
     /* 321197 */     GIR_Done,
     /* 321198 */   // Label 6571: @321198
     /* 321198 */   GIM_Reject,
     /* 321199 */ // Label 6569: @321199
     /* 321199 */ GIM_Reject,
     /* 321200 */ // Label 6557: @321200
     /* 321200 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(321302),
     /* 321205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 321211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321215 */   GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(321274), // Rule ID 2336 //
     /* 321220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 321223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 321231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 321248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321259 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 321259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 321262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321272 */     GIR_RootConstrainSelectedInstOperands,
     /* 321273 */     // GIR_Coverage, 2336,
     /* 321273 */     GIR_EraseRootFromParent_Done,
     /* 321274 */   // Label 6573: @321274
     /* 321274 */   GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(321301), // Rule ID 1247 //
     /* 321279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321290 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 321290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 321295 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321299 */     GIR_RootConstrainSelectedInstOperands,
     /* 321300 */     // GIR_Coverage, 1247,
     /* 321300 */     GIR_Done,
     /* 321301 */   // Label 6574: @321301
     /* 321301 */   GIM_Reject,
     /* 321302 */ // Label 6572: @321302
     /* 321302 */ GIM_Reject,
     /* 321303 */ // Label 6558: @321303
     /* 321303 */ GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(321405),
     /* 321308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 321314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321318 */   GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(321377), // Rule ID 2345 //
     /* 321323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 321326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 321334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 321351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321362 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 321362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 321365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321375 */     GIR_RootConstrainSelectedInstOperands,
     /* 321376 */     // GIR_Coverage, 2345,
     /* 321376 */     GIR_EraseRootFromParent_Done,
     /* 321377 */   // Label 6576: @321377
     /* 321377 */   GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(321404), // Rule ID 1253 //
     /* 321382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321393 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 321393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 321398 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321402 */     GIR_RootConstrainSelectedInstOperands,
     /* 321403 */     // GIR_Coverage, 1253,
     /* 321403 */     GIR_Done,
     /* 321404 */   // Label 6577: @321404
     /* 321404 */   GIM_Reject,
     /* 321405 */ // Label 6575: @321405
     /* 321405 */ GIM_Reject,
     /* 321406 */ // Label 6559: @321406
     /* 321406 */ GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(321508),
     /* 321411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 321417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321421 */   GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(321480), // Rule ID 2339 //
     /* 321426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 321429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 321437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 321454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321458 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321465 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 321465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 321468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321478 */     GIR_RootConstrainSelectedInstOperands,
     /* 321479 */     // GIR_Coverage, 2339,
     /* 321479 */     GIR_EraseRootFromParent_Done,
     /* 321480 */   // Label 6579: @321480
     /* 321480 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(321507), // Rule ID 1249 //
     /* 321485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321496 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 321496 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 321501 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321505 */     GIR_RootConstrainSelectedInstOperands,
     /* 321506 */     // GIR_Coverage, 1249,
     /* 321506 */     GIR_Done,
     /* 321507 */   // Label 6580: @321507
     /* 321507 */   GIM_Reject,
     /* 321508 */ // Label 6578: @321508
     /* 321508 */ GIM_Reject,
     /* 321509 */ // Label 6560: @321509
     /* 321509 */ GIM_Reject,
     /* 321510 */ // Label 79: @321510
     /* 321510 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6589*/ GIMT_Encode4(321913),
     /* 321521 */ /*GILLT_s32*//*Label 6581*/ GIMT_Encode4(321561),
     /* 321525 */ /*GILLT_s64*//*Label 6582*/ GIMT_Encode4(321635), GIMT_Encode4(0),
     /* 321533 */ /*GILLT_v2s32*//*Label 6583*/ GIMT_Encode4(321709), GIMT_Encode4(0),
     /* 321541 */ /*GILLT_v4s16*//*Label 6584*/ GIMT_Encode4(321743),
     /* 321545 */ /*GILLT_v4s32*//*Label 6585*/ GIMT_Encode4(321777),
     /* 321549 */ /*GILLT_v8s8*//*Label 6586*/ GIMT_Encode4(321811),
     /* 321553 */ /*GILLT_v8s16*//*Label 6587*/ GIMT_Encode4(321845),
     /* 321557 */ /*GILLT_v16s8*//*Label 6588*/ GIMT_Encode4(321879),
     /* 321561 */ // Label 6581: @321561
     /* 321561 */ GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(321634),
     /* 321566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 321572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321580 */   GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(321614), // Rule ID 2319 //
     /* 321585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 321588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 321600 */     // MIs[1] Operand 1
     /* 321600 */     // No operand predicates
     /* 321600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321602 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 321602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 321605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 321612 */     GIR_RootConstrainSelectedInstOperands,
     /* 321613 */     // GIR_Coverage, 2319,
     /* 321613 */     GIR_EraseRootFromParent_Done,
     /* 321614 */   // Label 6591: @321614
     /* 321614 */   GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(321633), // Rule ID 2318 //
     /* 321619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 321622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321626 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 321626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 321631 */     GIR_RootConstrainSelectedInstOperands,
     /* 321632 */     // GIR_Coverage, 2318,
     /* 321632 */     GIR_Done,
     /* 321633 */   // Label 6592: @321633
     /* 321633 */   GIM_Reject,
     /* 321634 */ // Label 6590: @321634
     /* 321634 */ GIM_Reject,
     /* 321635 */ // Label 6582: @321635
     /* 321635 */ GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(321708),
     /* 321640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 321646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321654 */   GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(321688), // Rule ID 2321 //
     /* 321659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 321662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 321674 */     // MIs[1] Operand 1
     /* 321674 */     // No operand predicates
     /* 321674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321676 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 321676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 321679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 321686 */     GIR_RootConstrainSelectedInstOperands,
     /* 321687 */     // GIR_Coverage, 2321,
     /* 321687 */     GIR_EraseRootFromParent_Done,
     /* 321688 */   // Label 6594: @321688
     /* 321688 */   GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(321707), // Rule ID 2320 //
     /* 321693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 321696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321700 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 321700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 321705 */     GIR_RootConstrainSelectedInstOperands,
     /* 321706 */     // GIR_Coverage, 2320,
     /* 321706 */     GIR_Done,
     /* 321707 */   // Label 6595: @321707
     /* 321707 */   GIM_Reject,
     /* 321708 */ // Label 6593: @321708
     /* 321708 */ GIM_Reject,
     /* 321709 */ // Label 6583: @321709
     /* 321709 */ GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(321742), // Rule ID 1407 //
     /* 321714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 321723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321735 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 321735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 321740 */   GIR_RootConstrainSelectedInstOperands,
     /* 321741 */   // GIR_Coverage, 1407,
     /* 321741 */   GIR_Done,
     /* 321742 */ // Label 6596: @321742
     /* 321742 */ GIM_Reject,
     /* 321743 */ // Label 6584: @321743
     /* 321743 */ GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(321776), // Rule ID 1405 //
     /* 321748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 321757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321769 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 321769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 321774 */   GIR_RootConstrainSelectedInstOperands,
     /* 321775 */   // GIR_Coverage, 1405,
     /* 321775 */   GIR_Done,
     /* 321776 */ // Label 6597: @321776
     /* 321776 */ GIM_Reject,
     /* 321777 */ // Label 6585: @321777
     /* 321777 */ GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(321810), // Rule ID 1408 //
     /* 321782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 321791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321799 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321803 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 321803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 321808 */   GIR_RootConstrainSelectedInstOperands,
     /* 321809 */   // GIR_Coverage, 1408,
     /* 321809 */   GIR_Done,
     /* 321810 */ // Label 6598: @321810
     /* 321810 */ GIM_Reject,
     /* 321811 */ // Label 6586: @321811
     /* 321811 */ GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(321844), // Rule ID 1403 //
     /* 321816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 321822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 321825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321837 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 321837 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 321842 */   GIR_RootConstrainSelectedInstOperands,
     /* 321843 */   // GIR_Coverage, 1403,
     /* 321843 */   GIR_Done,
     /* 321844 */ // Label 6599: @321844
     /* 321844 */ GIM_Reject,
     /* 321845 */ // Label 6587: @321845
     /* 321845 */ GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(321878), // Rule ID 1406 //
     /* 321850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 321859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321871 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 321871 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 321876 */   GIR_RootConstrainSelectedInstOperands,
     /* 321877 */   // GIR_Coverage, 1406,
     /* 321877 */   GIR_Done,
     /* 321878 */ // Label 6600: @321878
     /* 321878 */ GIM_Reject,
     /* 321879 */ // Label 6588: @321879
     /* 321879 */ GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(321912), // Rule ID 1404 //
     /* 321884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 321890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 321893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321905 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 321905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 321910 */   GIR_RootConstrainSelectedInstOperands,
     /* 321911 */   // GIR_Coverage, 1404,
     /* 321911 */   GIR_Done,
     /* 321912 */ // Label 6601: @321912
     /* 321912 */ GIM_Reject,
     /* 321913 */ // Label 6589: @321913
     /* 321913 */ GIM_Reject,
     /* 321914 */ // Label 80: @321914
     /* 321914 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6610*/ GIMT_Encode4(322317),
     /* 321925 */ /*GILLT_s32*//*Label 6602*/ GIMT_Encode4(321965),
     /* 321929 */ /*GILLT_s64*//*Label 6603*/ GIMT_Encode4(322039), GIMT_Encode4(0),
     /* 321937 */ /*GILLT_v2s32*//*Label 6604*/ GIMT_Encode4(322113), GIMT_Encode4(0),
     /* 321945 */ /*GILLT_v4s16*//*Label 6605*/ GIMT_Encode4(322147),
     /* 321949 */ /*GILLT_v4s32*//*Label 6606*/ GIMT_Encode4(322181),
     /* 321953 */ /*GILLT_v8s8*//*Label 6607*/ GIMT_Encode4(322215),
     /* 321957 */ /*GILLT_v8s16*//*Label 6608*/ GIMT_Encode4(322249),
     /* 321961 */ /*GILLT_v16s8*//*Label 6609*/ GIMT_Encode4(322283),
     /* 321965 */ // Label 6602: @321965
     /* 321965 */ GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(322038),
     /* 321970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 321976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321984 */   GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(322018), // Rule ID 2315 //
     /* 321989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 321992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 322004 */     // MIs[1] Operand 1
     /* 322004 */     // No operand predicates
     /* 322004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322006 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 322006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 322009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 322016 */     GIR_RootConstrainSelectedInstOperands,
     /* 322017 */     // GIR_Coverage, 2315,
     /* 322017 */     GIR_EraseRootFromParent_Done,
     /* 322018 */   // Label 6612: @322018
     /* 322018 */   GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(322037), // Rule ID 2314 //
     /* 322023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 322026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322030 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 322030 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 322035 */     GIR_RootConstrainSelectedInstOperands,
     /* 322036 */     // GIR_Coverage, 2314,
     /* 322036 */     GIR_Done,
     /* 322037 */   // Label 6613: @322037
     /* 322037 */   GIM_Reject,
     /* 322038 */ // Label 6611: @322038
     /* 322038 */ GIM_Reject,
     /* 322039 */ // Label 6603: @322039
     /* 322039 */ GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(322112),
     /* 322044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 322050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322058 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(322092), // Rule ID 2317 //
     /* 322063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 322066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 322078 */     // MIs[1] Operand 1
     /* 322078 */     // No operand predicates
     /* 322078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322080 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 322080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 322083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 322090 */     GIR_RootConstrainSelectedInstOperands,
     /* 322091 */     // GIR_Coverage, 2317,
     /* 322091 */     GIR_EraseRootFromParent_Done,
     /* 322092 */   // Label 6615: @322092
     /* 322092 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(322111), // Rule ID 2316 //
     /* 322097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 322100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322104 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 322104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 322109 */     GIR_RootConstrainSelectedInstOperands,
     /* 322110 */     // GIR_Coverage, 2316,
     /* 322110 */     GIR_Done,
     /* 322111 */   // Label 6616: @322111
     /* 322111 */   GIM_Reject,
     /* 322112 */ // Label 6614: @322112
     /* 322112 */ GIM_Reject,
     /* 322113 */ // Label 6604: @322113
     /* 322113 */ GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(322146), // Rule ID 1395 //
     /* 322118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 322127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322139 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 322139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 322144 */   GIR_RootConstrainSelectedInstOperands,
     /* 322145 */   // GIR_Coverage, 1395,
     /* 322145 */   GIR_Done,
     /* 322146 */ // Label 6617: @322146
     /* 322146 */ GIM_Reject,
     /* 322147 */ // Label 6605: @322147
     /* 322147 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(322180), // Rule ID 1393 //
     /* 322152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 322161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322169 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322173 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 322173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 322178 */   GIR_RootConstrainSelectedInstOperands,
     /* 322179 */   // GIR_Coverage, 1393,
     /* 322179 */   GIR_Done,
     /* 322180 */ // Label 6618: @322180
     /* 322180 */ GIM_Reject,
     /* 322181 */ // Label 6606: @322181
     /* 322181 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(322214), // Rule ID 1396 //
     /* 322186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 322195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322207 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 322207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 322212 */   GIR_RootConstrainSelectedInstOperands,
     /* 322213 */   // GIR_Coverage, 1396,
     /* 322213 */   GIR_Done,
     /* 322214 */ // Label 6619: @322214
     /* 322214 */ GIM_Reject,
     /* 322215 */ // Label 6607: @322215
     /* 322215 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(322248), // Rule ID 1391 //
     /* 322220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 322226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 322229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322241 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 322241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 322246 */   GIR_RootConstrainSelectedInstOperands,
     /* 322247 */   // GIR_Coverage, 1391,
     /* 322247 */   GIR_Done,
     /* 322248 */ // Label 6620: @322248
     /* 322248 */ GIM_Reject,
     /* 322249 */ // Label 6608: @322249
     /* 322249 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(322282), // Rule ID 1394 //
     /* 322254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 322263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322275 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 322275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 322280 */   GIR_RootConstrainSelectedInstOperands,
     /* 322281 */   // GIR_Coverage, 1394,
     /* 322281 */   GIR_Done,
     /* 322282 */ // Label 6621: @322282
     /* 322282 */ GIM_Reject,
     /* 322283 */ // Label 6609: @322283
     /* 322283 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(322316), // Rule ID 1392 //
     /* 322288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 322294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 322297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322309 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 322309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 322314 */   GIR_RootConstrainSelectedInstOperands,
     /* 322315 */   // GIR_Coverage, 1392,
     /* 322315 */   GIR_Done,
     /* 322316 */ // Label 6622: @322316
     /* 322316 */ GIM_Reject,
     /* 322317 */ // Label 6610: @322317
     /* 322317 */ GIM_Reject,
     /* 322318 */ // Label 81: @322318
     /* 322318 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6631*/ GIMT_Encode4(322721),
     /* 322329 */ /*GILLT_s32*//*Label 6623*/ GIMT_Encode4(322369),
     /* 322333 */ /*GILLT_s64*//*Label 6624*/ GIMT_Encode4(322443), GIMT_Encode4(0),
     /* 322341 */ /*GILLT_v2s32*//*Label 6625*/ GIMT_Encode4(322517), GIMT_Encode4(0),
     /* 322349 */ /*GILLT_v4s16*//*Label 6626*/ GIMT_Encode4(322551),
     /* 322353 */ /*GILLT_v4s32*//*Label 6627*/ GIMT_Encode4(322585),
     /* 322357 */ /*GILLT_v8s8*//*Label 6628*/ GIMT_Encode4(322619),
     /* 322361 */ /*GILLT_v8s16*//*Label 6629*/ GIMT_Encode4(322653),
     /* 322365 */ /*GILLT_v16s8*//*Label 6630*/ GIMT_Encode4(322687),
     /* 322369 */ // Label 6623: @322369
     /* 322369 */ GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(322442),
     /* 322374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 322380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322388 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(322422), // Rule ID 2327 //
     /* 322393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 322396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 322408 */     // MIs[1] Operand 1
     /* 322408 */     // No operand predicates
     /* 322408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322410 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 322410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 322413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322415 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 322420 */     GIR_RootConstrainSelectedInstOperands,
     /* 322421 */     // GIR_Coverage, 2327,
     /* 322421 */     GIR_EraseRootFromParent_Done,
     /* 322422 */   // Label 6633: @322422
     /* 322422 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(322441), // Rule ID 2326 //
     /* 322427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 322430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322434 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 322434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 322439 */     GIR_RootConstrainSelectedInstOperands,
     /* 322440 */     // GIR_Coverage, 2326,
     /* 322440 */     GIR_Done,
     /* 322441 */   // Label 6634: @322441
     /* 322441 */   GIM_Reject,
     /* 322442 */ // Label 6632: @322442
     /* 322442 */ GIM_Reject,
     /* 322443 */ // Label 6624: @322443
     /* 322443 */ GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(322516),
     /* 322448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 322454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322462 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(322496), // Rule ID 2329 //
     /* 322467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 322470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 322482 */     // MIs[1] Operand 1
     /* 322482 */     // No operand predicates
     /* 322482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322484 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 322484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 322487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 322494 */     GIR_RootConstrainSelectedInstOperands,
     /* 322495 */     // GIR_Coverage, 2329,
     /* 322495 */     GIR_EraseRootFromParent_Done,
     /* 322496 */   // Label 6636: @322496
     /* 322496 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(322515), // Rule ID 2328 //
     /* 322501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 322504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322508 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 322508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 322513 */     GIR_RootConstrainSelectedInstOperands,
     /* 322514 */     // GIR_Coverage, 2328,
     /* 322514 */     GIR_Done,
     /* 322515 */   // Label 6637: @322515
     /* 322515 */   GIM_Reject,
     /* 322516 */ // Label 6635: @322516
     /* 322516 */ GIM_Reject,
     /* 322517 */ // Label 6625: @322517
     /* 322517 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(322550), // Rule ID 1530 //
     /* 322522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 322531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322543 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 322543 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 322548 */   GIR_RootConstrainSelectedInstOperands,
     /* 322549 */   // GIR_Coverage, 1530,
     /* 322549 */   GIR_Done,
     /* 322550 */ // Label 6638: @322550
     /* 322550 */ GIM_Reject,
     /* 322551 */ // Label 6626: @322551
     /* 322551 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(322584), // Rule ID 1528 //
     /* 322556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 322565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322573 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322577 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 322577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 322582 */   GIR_RootConstrainSelectedInstOperands,
     /* 322583 */   // GIR_Coverage, 1528,
     /* 322583 */   GIR_Done,
     /* 322584 */ // Label 6639: @322584
     /* 322584 */ GIM_Reject,
     /* 322585 */ // Label 6627: @322585
     /* 322585 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(322618), // Rule ID 1531 //
     /* 322590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 322599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322607 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322611 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 322611 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 322616 */   GIR_RootConstrainSelectedInstOperands,
     /* 322617 */   // GIR_Coverage, 1531,
     /* 322617 */   GIR_Done,
     /* 322618 */ // Label 6640: @322618
     /* 322618 */ GIM_Reject,
     /* 322619 */ // Label 6628: @322619
     /* 322619 */ GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(322652), // Rule ID 1526 //
     /* 322624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 322630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 322633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322641 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322645 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 322645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 322650 */   GIR_RootConstrainSelectedInstOperands,
     /* 322651 */   // GIR_Coverage, 1526,
     /* 322651 */   GIR_Done,
     /* 322652 */ // Label 6641: @322652
     /* 322652 */ GIM_Reject,
     /* 322653 */ // Label 6629: @322653
     /* 322653 */ GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(322686), // Rule ID 1529 //
     /* 322658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 322667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322679 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 322679 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 322684 */   GIR_RootConstrainSelectedInstOperands,
     /* 322685 */   // GIR_Coverage, 1529,
     /* 322685 */   GIR_Done,
     /* 322686 */ // Label 6642: @322686
     /* 322686 */ GIM_Reject,
     /* 322687 */ // Label 6630: @322687
     /* 322687 */ GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(322720), // Rule ID 1527 //
     /* 322692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 322698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 322701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322709 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322713 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 322713 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 322718 */   GIR_RootConstrainSelectedInstOperands,
     /* 322719 */   // GIR_Coverage, 1527,
     /* 322719 */   GIR_Done,
     /* 322720 */ // Label 6643: @322720
     /* 322720 */ GIM_Reject,
     /* 322721 */ // Label 6631: @322721
     /* 322721 */ GIM_Reject,
     /* 322722 */ // Label 82: @322722
     /* 322722 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6652*/ GIMT_Encode4(323125),
     /* 322733 */ /*GILLT_s32*//*Label 6644*/ GIMT_Encode4(322773),
     /* 322737 */ /*GILLT_s64*//*Label 6645*/ GIMT_Encode4(322847), GIMT_Encode4(0),
     /* 322745 */ /*GILLT_v2s32*//*Label 6646*/ GIMT_Encode4(322921), GIMT_Encode4(0),
     /* 322753 */ /*GILLT_v4s16*//*Label 6647*/ GIMT_Encode4(322955),
     /* 322757 */ /*GILLT_v4s32*//*Label 6648*/ GIMT_Encode4(322989),
     /* 322761 */ /*GILLT_v8s8*//*Label 6649*/ GIMT_Encode4(323023),
     /* 322765 */ /*GILLT_v8s16*//*Label 6650*/ GIMT_Encode4(323057),
     /* 322769 */ /*GILLT_v16s8*//*Label 6651*/ GIMT_Encode4(323091),
     /* 322773 */ // Label 6644: @322773
     /* 322773 */ GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(322846),
     /* 322778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 322784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322792 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(322826), // Rule ID 2323 //
     /* 322797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 322800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 322812 */     // MIs[1] Operand 1
     /* 322812 */     // No operand predicates
     /* 322812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322814 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 322814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 322817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 322824 */     GIR_RootConstrainSelectedInstOperands,
     /* 322825 */     // GIR_Coverage, 2323,
     /* 322825 */     GIR_EraseRootFromParent_Done,
     /* 322826 */   // Label 6654: @322826
     /* 322826 */   GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(322845), // Rule ID 2322 //
     /* 322831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 322834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322838 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 322838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 322843 */     GIR_RootConstrainSelectedInstOperands,
     /* 322844 */     // GIR_Coverage, 2322,
     /* 322844 */     GIR_Done,
     /* 322845 */   // Label 6655: @322845
     /* 322845 */   GIM_Reject,
     /* 322846 */ // Label 6653: @322846
     /* 322846 */ GIM_Reject,
     /* 322847 */ // Label 6645: @322847
     /* 322847 */ GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(322920),
     /* 322852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 322858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322866 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(322900), // Rule ID 2325 //
     /* 322871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 322874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 322886 */     // MIs[1] Operand 1
     /* 322886 */     // No operand predicates
     /* 322886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322888 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 322888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 322891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 322898 */     GIR_RootConstrainSelectedInstOperands,
     /* 322899 */     // GIR_Coverage, 2325,
     /* 322899 */     GIR_EraseRootFromParent_Done,
     /* 322900 */   // Label 6657: @322900
     /* 322900 */   GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(322919), // Rule ID 2324 //
     /* 322905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 322908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 322912 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 322912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 322917 */     GIR_RootConstrainSelectedInstOperands,
     /* 322918 */     // GIR_Coverage, 2324,
     /* 322918 */     GIR_Done,
     /* 322919 */   // Label 6658: @322919
     /* 322919 */   GIM_Reject,
     /* 322920 */ // Label 6656: @322920
     /* 322920 */ GIM_Reject,
     /* 322921 */ // Label 6646: @322921
     /* 322921 */ GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(322954), // Rule ID 1518 //
     /* 322926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 322935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322947 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 322947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 322952 */   GIR_RootConstrainSelectedInstOperands,
     /* 322953 */   // GIR_Coverage, 1518,
     /* 322953 */   GIR_Done,
     /* 322954 */ // Label 6659: @322954
     /* 322954 */ GIM_Reject,
     /* 322955 */ // Label 6647: @322955
     /* 322955 */ GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(322988), // Rule ID 1516 //
     /* 322960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 322969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322981 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 322981 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 322986 */   GIR_RootConstrainSelectedInstOperands,
     /* 322987 */   // GIR_Coverage, 1516,
     /* 322987 */   GIR_Done,
     /* 322988 */ // Label 6660: @322988
     /* 322988 */ GIM_Reject,
     /* 322989 */ // Label 6648: @322989
     /* 322989 */ GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(323022), // Rule ID 1519 //
     /* 322994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323015 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 323015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 323020 */   GIR_RootConstrainSelectedInstOperands,
     /* 323021 */   // GIR_Coverage, 1519,
     /* 323021 */   GIR_Done,
     /* 323022 */ // Label 6661: @323022
     /* 323022 */ GIM_Reject,
     /* 323023 */ // Label 6649: @323023
     /* 323023 */ GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(323056), // Rule ID 1514 //
     /* 323028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 323034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 323037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323049 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 323049 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 323054 */   GIR_RootConstrainSelectedInstOperands,
     /* 323055 */   // GIR_Coverage, 1514,
     /* 323055 */   GIR_Done,
     /* 323056 */ // Label 6662: @323056
     /* 323056 */ GIM_Reject,
     /* 323057 */ // Label 6650: @323057
     /* 323057 */ GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(323090), // Rule ID 1517 //
     /* 323062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323083 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 323083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 323088 */   GIR_RootConstrainSelectedInstOperands,
     /* 323089 */   // GIR_Coverage, 1517,
     /* 323089 */   GIR_Done,
     /* 323090 */ // Label 6663: @323090
     /* 323090 */ GIM_Reject,
     /* 323091 */ // Label 6651: @323091
     /* 323091 */ GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(323124), // Rule ID 1515 //
     /* 323096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 323102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 323105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323117 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 323117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 323122 */   GIR_RootConstrainSelectedInstOperands,
     /* 323123 */   // GIR_Coverage, 1515,
     /* 323123 */   GIR_Done,
     /* 323124 */ // Label 6664: @323124
     /* 323124 */ GIM_Reject,
     /* 323125 */ // Label 6652: @323125
     /* 323125 */ GIM_Reject,
     /* 323126 */ // Label 83: @323126
     /* 323126 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6674*/ GIMT_Encode4(323940),
     /* 323137 */ /*GILLT_s32*//*Label 6665*/ GIMT_Encode4(323177),
     /* 323141 */ /*GILLT_s64*//*Label 6666*/ GIMT_Encode4(323204), GIMT_Encode4(0),
     /* 323149 */ /*GILLT_v2s32*//*Label 6667*/ GIMT_Encode4(323283),
     /* 323153 */ /*GILLT_v2s64*//*Label 6668*/ GIMT_Encode4(323310),
     /* 323157 */ /*GILLT_v4s16*//*Label 6669*/ GIMT_Encode4(323493),
     /* 323161 */ /*GILLT_v4s32*//*Label 6670*/ GIMT_Encode4(323520),
     /* 323165 */ /*GILLT_v8s8*//*Label 6671*/ GIMT_Encode4(323703),
     /* 323169 */ /*GILLT_v8s16*//*Label 6672*/ GIMT_Encode4(323730),
     /* 323173 */ /*GILLT_v16s8*//*Label 6673*/ GIMT_Encode4(323913),
     /* 323177 */ // Label 6665: @323177
     /* 323177 */ GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(323203), // Rule ID 2308 //
     /* 323182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 323185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 323192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 323196 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 323196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 323201 */   GIR_RootConstrainSelectedInstOperands,
     /* 323202 */   // GIR_Coverage, 2308,
     /* 323202 */   GIR_Done,
     /* 323203 */ // Label 6675: @323203
     /* 323203 */ GIM_Reject,
     /* 323204 */ // Label 6666: @323204
     /* 323204 */ GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(323282),
     /* 323209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323212 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(323235), // Rule ID 1645 //
     /* 323217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323228 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 323228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 323233 */     GIR_RootConstrainSelectedInstOperands,
     /* 323234 */     // GIR_Coverage, 1645,
     /* 323234 */     GIR_Done,
     /* 323235 */   // Label 6677: @323235
     /* 323235 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(323258), // Rule ID 2309 //
     /* 323240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 323243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 323247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 323251 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 323251 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 323256 */     GIR_RootConstrainSelectedInstOperands,
     /* 323257 */     // GIR_Coverage, 2309,
     /* 323257 */     GIR_Done,
     /* 323258 */   // Label 6678: @323258
     /* 323258 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(323281), // Rule ID 2505 //
     /* 323263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 323266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323274 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 323274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 323279 */     GIR_RootConstrainSelectedInstOperands,
     /* 323280 */     // GIR_Coverage, 2505,
     /* 323280 */     GIR_Done,
     /* 323281 */   // Label 6679: @323281
     /* 323281 */   GIM_Reject,
     /* 323282 */ // Label 6676: @323282
     /* 323282 */ GIM_Reject,
     /* 323283 */ // Label 6667: @323283
     /* 323283 */ GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(323309), // Rule ID 707 //
     /* 323288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323302 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 323302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 323307 */   GIR_RootConstrainSelectedInstOperands,
     /* 323308 */   // GIR_Coverage, 707,
     /* 323308 */   GIR_Done,
     /* 323309 */ // Label 6680: @323309
     /* 323309 */ GIM_Reject,
     /* 323310 */ // Label 6668: @323310
     /* 323310 */ GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(323492),
     /* 323315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323322 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(323400), // Rule ID 4868 //
     /* 323327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 323335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 323343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 323351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 323359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 323363 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323369 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 323376 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 323383 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 323383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 323386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 323393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 323398 */     GIR_RootConstrainSelectedInstOperands,
     /* 323399 */     // GIR_Coverage, 4868,
     /* 323399 */     GIR_EraseRootFromParent_Done,
     /* 323400 */   // Label 6682: @323400
     /* 323400 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(323472), // Rule ID 4867 //
     /* 323405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 323413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 323421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 323429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 323442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 323446 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323450 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323457 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 323457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 323460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 323466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 323470 */     GIR_RootConstrainSelectedInstOperands,
     /* 323471 */     // GIR_Coverage, 4867,
     /* 323471 */     GIR_EraseRootFromParent_Done,
     /* 323472 */   // Label 6683: @323472
     /* 323472 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(323491), // Rule ID 709 //
     /* 323477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323484 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 323484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 323489 */     GIR_RootConstrainSelectedInstOperands,
     /* 323490 */     // GIR_Coverage, 709,
     /* 323490 */     GIR_Done,
     /* 323491 */   // Label 6684: @323491
     /* 323491 */   GIM_Reject,
     /* 323492 */ // Label 6681: @323492
     /* 323492 */ GIM_Reject,
     /* 323493 */ // Label 6669: @323493
     /* 323493 */ GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(323519), // Rule ID 705 //
     /* 323498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323512 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 323512 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 323517 */   GIR_RootConstrainSelectedInstOperands,
     /* 323518 */   // GIR_Coverage, 705,
     /* 323518 */   GIR_Done,
     /* 323519 */ // Label 6685: @323519
     /* 323519 */ GIM_Reject,
     /* 323520 */ // Label 6670: @323520
     /* 323520 */ GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(323702),
     /* 323525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323532 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(323610), // Rule ID 4866 //
     /* 323537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 323545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 323561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 323569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 323573 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323579 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 323586 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 323593 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 323593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 323596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 323603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 323608 */     GIR_RootConstrainSelectedInstOperands,
     /* 323609 */     // GIR_Coverage, 4866,
     /* 323609 */     GIR_EraseRootFromParent_Done,
     /* 323610 */   // Label 6687: @323610
     /* 323610 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(323682), // Rule ID 4865 //
     /* 323615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 323623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 323639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 323652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 323656 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323660 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323665 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323667 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 323667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 323670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 323676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 323680 */     GIR_RootConstrainSelectedInstOperands,
     /* 323681 */     // GIR_Coverage, 4865,
     /* 323681 */     GIR_EraseRootFromParent_Done,
     /* 323682 */   // Label 6688: @323682
     /* 323682 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(323701), // Rule ID 708 //
     /* 323687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323694 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 323694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 323699 */     GIR_RootConstrainSelectedInstOperands,
     /* 323700 */     // GIR_Coverage, 708,
     /* 323700 */     GIR_Done,
     /* 323701 */   // Label 6689: @323701
     /* 323701 */   GIM_Reject,
     /* 323702 */ // Label 6686: @323702
     /* 323702 */ GIM_Reject,
     /* 323703 */ // Label 6671: @323703
     /* 323703 */ GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(323729), // Rule ID 703 //
     /* 323708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 323714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323722 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 323722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 323727 */   GIR_RootConstrainSelectedInstOperands,
     /* 323728 */   // GIR_Coverage, 703,
     /* 323728 */   GIR_Done,
     /* 323729 */ // Label 6690: @323729
     /* 323729 */ GIM_Reject,
     /* 323730 */ // Label 6672: @323730
     /* 323730 */ GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(323912),
     /* 323735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323742 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(323820), // Rule ID 4864 //
     /* 323747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 323755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 323771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 323775 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 323779 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 323783 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 323787 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 323796 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 323803 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 323803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 323806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 323813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 323818 */     GIR_RootConstrainSelectedInstOperands,
     /* 323819 */     // GIR_Coverage, 4864,
     /* 323819 */     GIR_EraseRootFromParent_Done,
     /* 323820 */   // Label 6692: @323820
     /* 323820 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(323892), // Rule ID 4863 //
     /* 323825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 323833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 323849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 323853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 323862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 323866 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 323870 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323877 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 323877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 323880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 323886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 323890 */     GIR_RootConstrainSelectedInstOperands,
     /* 323891 */     // GIR_Coverage, 4863,
     /* 323891 */     GIR_EraseRootFromParent_Done,
     /* 323892 */   // Label 6693: @323892
     /* 323892 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(323911), // Rule ID 706 //
     /* 323897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323904 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 323904 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 323909 */     GIR_RootConstrainSelectedInstOperands,
     /* 323910 */     // GIR_Coverage, 706,
     /* 323910 */     GIR_Done,
     /* 323911 */   // Label 6694: @323911
     /* 323911 */   GIM_Reject,
     /* 323912 */ // Label 6691: @323912
     /* 323912 */ GIM_Reject,
     /* 323913 */ // Label 6673: @323913
     /* 323913 */ GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(323939), // Rule ID 704 //
     /* 323918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 323924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323932 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 323932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 323937 */   GIR_RootConstrainSelectedInstOperands,
     /* 323938 */   // GIR_Coverage, 704,
     /* 323938 */   GIR_Done,
     /* 323939 */ // Label 6695: @323939
     /* 323939 */ GIM_Reject,
     /* 323940 */ // Label 6674: @323940
     /* 323940 */ GIM_Reject,
     /* 323941 */ // Label 84: @323941
     /* 323941 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6698*/ GIMT_Encode4(324106),
     /* 323952 */ /*GILLT_s32*//*Label 6696*/ GIMT_Encode4(323960),
     /* 323956 */ /*GILLT_s64*//*Label 6697*/ GIMT_Encode4(324033),
     /* 323960 */ // Label 6696: @323960
     /* 323960 */ GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(323986), // Rule ID 4709 //
     /* 323965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 323975 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 323975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 323980 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323984 */   GIR_RootConstrainSelectedInstOperands,
     /* 323985 */   // GIR_Coverage, 4709,
     /* 323985 */   GIR_Done,
     /* 323986 */ // Label 6699: @323986
     /* 323986 */ GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(324009), // Rule ID 4715 //
     /* 323991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 323998 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 323998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 324003 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324007 */   GIR_RootConstrainSelectedInstOperands,
     /* 324008 */   // GIR_Coverage, 4715,
     /* 324008 */   GIR_Done,
     /* 324009 */ // Label 6700: @324009
     /* 324009 */ GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(324032), // Rule ID 4717 //
     /* 324014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 324021 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 324021 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 324026 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324030 */   GIR_RootConstrainSelectedInstOperands,
     /* 324031 */   // GIR_Coverage, 4717,
     /* 324031 */   GIR_Done,
     /* 324032 */ // Label 6701: @324032
     /* 324032 */ GIM_Reject,
     /* 324033 */ // Label 6697: @324033
     /* 324033 */ GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(324059), // Rule ID 4711 //
     /* 324038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324048 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 324048 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 324053 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324057 */   GIR_RootConstrainSelectedInstOperands,
     /* 324058 */   // GIR_Coverage, 4711,
     /* 324058 */   GIR_Done,
     /* 324059 */ // Label 6702: @324059
     /* 324059 */ GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(324082), // Rule ID 4719 //
     /* 324064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324071 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 324071 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 324076 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324080 */   GIR_RootConstrainSelectedInstOperands,
     /* 324081 */   // GIR_Coverage, 4719,
     /* 324081 */   GIR_Done,
     /* 324082 */ // Label 6703: @324082
     /* 324082 */ GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(324105), // Rule ID 4721 //
     /* 324087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324094 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 324094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 324099 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324103 */   GIR_RootConstrainSelectedInstOperands,
     /* 324104 */   // GIR_Coverage, 4721,
     /* 324104 */   GIR_Done,
     /* 324105 */ // Label 6704: @324105
     /* 324105 */ GIM_Reject,
     /* 324106 */ // Label 6698: @324106
     /* 324106 */ GIM_Reject,
     /* 324107 */ // Label 85: @324107
     /* 324107 */ GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(324205),
     /* 324112 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 324115 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6709*/ GIMT_Encode4(324204),
     /* 324126 */   /*GILLT_s16*//*Label 6706*/ GIMT_Encode4(324138),
     /* 324130 */   /*GILLT_s32*//*Label 6707*/ GIMT_Encode4(324162),
     /* 324134 */   /*GILLT_s64*//*Label 6708*/ GIMT_Encode4(324183),
     /* 324138 */   // Label 6706: @324138
     /* 324138 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(324161), // Rule ID 4713 //
     /* 324143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324150 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 324150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 324155 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324159 */     GIR_RootConstrainSelectedInstOperands,
     /* 324160 */     // GIR_Coverage, 4713,
     /* 324160 */     GIR_Done,
     /* 324161 */   // Label 6710: @324161
     /* 324161 */   GIM_Reject,
     /* 324162 */   // Label 6707: @324162
     /* 324162 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(324182), // Rule ID 4723 //
     /* 324167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324171 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 324171 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 324176 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324180 */     GIR_RootConstrainSelectedInstOperands,
     /* 324181 */     // GIR_Coverage, 4723,
     /* 324181 */     GIR_Done,
     /* 324182 */   // Label 6711: @324182
     /* 324182 */   GIM_Reject,
     /* 324183 */   // Label 6708: @324183
     /* 324183 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(324203), // Rule ID 4725 //
     /* 324188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 324192 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 324192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 324197 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324201 */     GIR_RootConstrainSelectedInstOperands,
     /* 324202 */     // GIR_Coverage, 4725,
     /* 324202 */     GIR_Done,
     /* 324203 */   // Label 6712: @324203
     /* 324203 */   GIM_Reject,
     /* 324204 */   // Label 6709: @324204
     /* 324204 */   GIM_Reject,
     /* 324205 */ // Label 6705: @324205
     /* 324205 */ GIM_Reject,
     /* 324206 */ // Label 86: @324206
     /* 324206 */ GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(324221), // Rule ID 225 //
     /* 324211 */   // MIs[0] addr
     /* 324211 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 324214 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 324214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 324219 */   GIR_RootConstrainSelectedInstOperands,
     /* 324220 */   // GIR_Coverage, 225,
     /* 324220 */   GIR_Done,
     /* 324221 */ // Label 6713: @324221
     /* 324221 */ GIM_Reject,
     /* 324222 */ // Label 87: @324222
     /* 324222 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 6725*/ GIMT_Encode4(329593),
     /* 324233 */ /*GILLT_s64*//*Label 6714*/ GIMT_Encode4(324305), GIMT_Encode4(0),
     /* 324241 */ /*GILLT_v2s32*//*Label 6715*/ GIMT_Encode4(324707), GIMT_Encode4(0),
     /* 324249 */ /*GILLT_v4s16*//*Label 6716*/ GIMT_Encode4(325109), GIMT_Encode4(0),
     /* 324257 */ /*GILLT_v8s8*//*Label 6717*/ GIMT_Encode4(325511), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 324269 */ /*GILLT_nxv1s1*//*Label 6718*/ GIMT_Encode4(325691),
     /* 324273 */ /*GILLT_nxv2s1*//*Label 6719*/ GIMT_Encode4(327954),
     /* 324277 */ /*GILLT_nxv2s16*//*Label 6720*/ GIMT_Encode4(328809),
     /* 324281 */ /*GILLT_nxv2s32*//*Label 6721*/ GIMT_Encode4(329096), GIMT_Encode4(0),
     /* 324289 */ /*GILLT_nxv4s1*//*Label 6722*/ GIMT_Encode4(329166),
     /* 324293 */ /*GILLT_nxv4s16*//*Label 6723*/ GIMT_Encode4(329453), GIMT_Encode4(0),
     /* 324301 */ /*GILLT_nxv8s1*//*Label 6724*/ GIMT_Encode4(329523),
     /* 324305 */ // Label 6714: @324305
     /* 324305 */ GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(324706),
     /* 324310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324317 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(324369), // Rule ID 5555 //
     /* 324322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 324330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324334 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 324336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324341 */     // MIs[0] Operand 2
     /* 324341 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 324352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324354 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 324354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 324357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 324363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 324367 */     GIR_RootConstrainSelectedInstOperands,
     /* 324368 */     // GIR_Coverage, 5555,
     /* 324368 */     GIR_EraseRootFromParent_Done,
     /* 324369 */   // Label 6727: @324369
     /* 324369 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(324421), // Rule ID 5558 //
     /* 324374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 324382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324386 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 324388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324393 */     // MIs[0] Operand 2
     /* 324393 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 324404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324406 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 324406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 324409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 324415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 324419 */     GIR_RootConstrainSelectedInstOperands,
     /* 324420 */     // GIR_Coverage, 5558,
     /* 324420 */     GIR_EraseRootFromParent_Done,
     /* 324421 */   // Label 6728: @324421
     /* 324421 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(324489), // Rule ID 5434 //
     /* 324426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324430 */     // MIs[0] Operand 2
     /* 324430 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 324441 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 324441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 324448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 324457 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 324461 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 324464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324471 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 324478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324488 */     // GIR_Coverage, 5434,
     /* 324488 */     GIR_EraseRootFromParent_Done,
     /* 324489 */   // Label 6729: @324489
     /* 324489 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(324557), // Rule ID 5439 //
     /* 324494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324498 */     // MIs[0] Operand 2
     /* 324498 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 324509 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 324509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 324516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324521 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 324525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 324529 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 324532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324539 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 324546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324556 */     // GIR_Coverage, 5439,
     /* 324556 */     GIR_EraseRootFromParent_Done,
     /* 324557 */   // Label 6730: @324557
     /* 324557 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(324599), // Rule ID 6844 //
     /* 324562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324566 */     // MIs[0] Operand 2
     /* 324566 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 324577 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 324577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324582 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 324588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324598 */     // GIR_Coverage, 6844,
     /* 324598 */     GIR_EraseRootFromParent_Done,
     /* 324599 */   // Label 6731: @324599
     /* 324599 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(324641), // Rule ID 6845 //
     /* 324604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324608 */     // MIs[0] Operand 2
     /* 324608 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 324619 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 324619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324624 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 324630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324640 */     // GIR_Coverage, 6845,
     /* 324640 */     GIR_EraseRootFromParent_Done,
     /* 324641 */   // Label 6732: @324641
     /* 324641 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(324705), // Rule ID 6849 //
     /* 324646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324650 */     // MIs[0] Operand 2
     /* 324650 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 324661 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 324661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 324668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 324677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 324680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324687 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 324694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324704 */     // GIR_Coverage, 6849,
     /* 324704 */     GIR_EraseRootFromParent_Done,
     /* 324705 */   // Label 6733: @324705
     /* 324705 */   GIM_Reject,
     /* 324706 */ // Label 6726: @324706
     /* 324706 */ GIM_Reject,
     /* 324707 */ // Label 6715: @324707
     /* 324707 */ GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(325108),
     /* 324712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324719 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(324771), // Rule ID 5554 //
     /* 324724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 324732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324736 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 324738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324743 */     // MIs[0] Operand 2
     /* 324743 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 324754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324756 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 324756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 324759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 324765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 324769 */     GIR_RootConstrainSelectedInstOperands,
     /* 324770 */     // GIR_Coverage, 5554,
     /* 324770 */     GIR_EraseRootFromParent_Done,
     /* 324771 */   // Label 6735: @324771
     /* 324771 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(324823), // Rule ID 5557 //
     /* 324776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 324784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324788 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 324790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324795 */     // MIs[0] Operand 2
     /* 324795 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 324806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324808 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 324808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 324811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 324817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 324821 */     GIR_RootConstrainSelectedInstOperands,
     /* 324822 */     // GIR_Coverage, 5557,
     /* 324822 */     GIR_EraseRootFromParent_Done,
     /* 324823 */   // Label 6736: @324823
     /* 324823 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(324891), // Rule ID 5424 //
     /* 324828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324832 */     // MIs[0] Operand 2
     /* 324832 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 324843 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 324843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 324850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324855 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 324859 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 324863 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 324866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324873 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 324880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324890 */     // GIR_Coverage, 5424,
     /* 324890 */     GIR_EraseRootFromParent_Done,
     /* 324891 */   // Label 6737: @324891
     /* 324891 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(324959), // Rule ID 5429 //
     /* 324896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324900 */     // MIs[0] Operand 2
     /* 324900 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 324911 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 324911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 324918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324923 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 324927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 324931 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 324934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 324936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324941 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 324948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324958 */     // GIR_Coverage, 5429,
     /* 324958 */     GIR_EraseRootFromParent_Done,
     /* 324959 */   // Label 6738: @324959
     /* 324959 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(325001), // Rule ID 6841 //
     /* 324964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324968 */     // MIs[0] Operand 2
     /* 324968 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 324979 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 324979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 324982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324984 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 324990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325000 */     // GIR_Coverage, 6841,
     /* 325000 */     GIR_EraseRootFromParent_Done,
     /* 325001 */   // Label 6739: @325001
     /* 325001 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(325043), // Rule ID 6843 //
     /* 325006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325010 */     // MIs[0] Operand 2
     /* 325010 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 325021 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 325021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325026 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 325032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325042 */     // GIR_Coverage, 6843,
     /* 325042 */     GIR_EraseRootFromParent_Done,
     /* 325043 */   // Label 6740: @325043
     /* 325043 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(325107), // Rule ID 6848 //
     /* 325048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325052 */     // MIs[0] Operand 2
     /* 325052 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 325063 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 325063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 325070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325075 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325079 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 325082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325089 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325106 */     // GIR_Coverage, 6848,
     /* 325106 */     GIR_EraseRootFromParent_Done,
     /* 325107 */   // Label 6741: @325107
     /* 325107 */   GIM_Reject,
     /* 325108 */ // Label 6734: @325108
     /* 325108 */ GIM_Reject,
     /* 325109 */ // Label 6716: @325109
     /* 325109 */ GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(325510),
     /* 325114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325121 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(325173), // Rule ID 5553 //
     /* 325126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 325134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 325138 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 325140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325145 */     // MIs[0] Operand 2
     /* 325145 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 325156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325158 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 325158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 325161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 325167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 325171 */     GIR_RootConstrainSelectedInstOperands,
     /* 325172 */     // GIR_Coverage, 5553,
     /* 325172 */     GIR_EraseRootFromParent_Done,
     /* 325173 */   // Label 6743: @325173
     /* 325173 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(325225), // Rule ID 5556 //
     /* 325178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 325186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 325190 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 325192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325197 */     // MIs[0] Operand 2
     /* 325197 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 325208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325210 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 325210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 325213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 325219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 325223 */     GIR_RootConstrainSelectedInstOperands,
     /* 325224 */     // GIR_Coverage, 5556,
     /* 325224 */     GIR_EraseRootFromParent_Done,
     /* 325225 */   // Label 6744: @325225
     /* 325225 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(325293), // Rule ID 5414 //
     /* 325230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325234 */     // MIs[0] Operand 2
     /* 325234 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 325245 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 325245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 325252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325257 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325265 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 325268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325275 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325292 */     // GIR_Coverage, 5414,
     /* 325292 */     GIR_EraseRootFromParent_Done,
     /* 325293 */   // Label 6745: @325293
     /* 325293 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(325361), // Rule ID 5419 //
     /* 325298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325302 */     // MIs[0] Operand 2
     /* 325302 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 325313 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 325313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 325320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325333 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 325336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325343 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325360 */     // GIR_Coverage, 5419,
     /* 325360 */     GIR_EraseRootFromParent_Done,
     /* 325361 */   // Label 6746: @325361
     /* 325361 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(325403), // Rule ID 6839 //
     /* 325366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325370 */     // MIs[0] Operand 2
     /* 325370 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 325381 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 325381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325386 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 325392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325397 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325402 */     // GIR_Coverage, 6839,
     /* 325402 */     GIR_EraseRootFromParent_Done,
     /* 325403 */   // Label 6747: @325403
     /* 325403 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(325445), // Rule ID 6842 //
     /* 325408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325412 */     // MIs[0] Operand 2
     /* 325412 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 325423 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 325423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325428 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 325434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325444 */     // GIR_Coverage, 6842,
     /* 325444 */     GIR_EraseRootFromParent_Done,
     /* 325445 */   // Label 6748: @325445
     /* 325445 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(325509), // Rule ID 6847 //
     /* 325450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325454 */     // MIs[0] Operand 2
     /* 325454 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 325465 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 325465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 325472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325481 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 325484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325491 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325508 */     // GIR_Coverage, 6847,
     /* 325508 */     GIR_EraseRootFromParent_Done,
     /* 325509 */   // Label 6749: @325509
     /* 325509 */   GIM_Reject,
     /* 325510 */ // Label 6742: @325510
     /* 325510 */ GIM_Reject,
     /* 325511 */ // Label 6717: @325511
     /* 325511 */ GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(325690),
     /* 325516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 325519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325527 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(325591), // Rule ID 5409 //
     /* 325532 */     // MIs[0] Operand 2
     /* 325532 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 325543 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 325543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 325550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 325566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325573 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325590 */     // GIR_Coverage, 5409,
     /* 325590 */     GIR_EraseRootFromParent_Done,
     /* 325591 */   // Label 6751: @325591
     /* 325591 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(325629), // Rule ID 6840 //
     /* 325596 */     // MIs[0] Operand 2
     /* 325596 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 325607 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 325607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325612 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 325618 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325628 */     // GIR_Coverage, 6840,
     /* 325628 */     GIR_EraseRootFromParent_Done,
     /* 325629 */   // Label 6752: @325629
     /* 325629 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(325689), // Rule ID 6846 //
     /* 325634 */     // MIs[0] Operand 2
     /* 325634 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 325645 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 325645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 325652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325657 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325661 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 325664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325671 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 325678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325688 */     // GIR_Coverage, 6846,
     /* 325688 */     GIR_EraseRootFromParent_Done,
     /* 325689 */   // Label 6753: @325689
     /* 325689 */   GIM_Reject,
     /* 325690 */ // Label 6750: @325690
     /* 325690 */ GIM_Reject,
     /* 325691 */ // Label 6718: @325691
     /* 325691 */ GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(325726), // Rule ID 8902 //
     /* 325696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 325699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 325702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 325706 */   // MIs[0] Operand 2
     /* 325706 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 325717 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 325717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 325720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 325722 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 325724 */   GIR_RootConstrainSelectedInstOperands,
     /* 325725 */   // GIR_Coverage, 8902,
     /* 325725 */   GIR_EraseRootFromParent_Done,
     /* 325726 */ // Label 6754: @325726
     /* 325726 */ GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(325761), // Rule ID 8903 //
     /* 325731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 325734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 325737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 325741 */   // MIs[0] Operand 2
     /* 325741 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 325752 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 325752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 325755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 325757 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 325759 */   GIR_RootConstrainSelectedInstOperands,
     /* 325760 */   // GIR_Coverage, 8903,
     /* 325760 */   GIR_EraseRootFromParent_Done,
     /* 325761 */ // Label 6755: @325761
     /* 325761 */ GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(325815), // Rule ID 8910 //
     /* 325766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 325769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 325772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 325776 */   // MIs[0] Operand 2
     /* 325776 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 325787 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 325787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 325790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 325794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325799 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 325803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 325808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 325810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325813 */   GIR_RootConstrainSelectedInstOperands,
     /* 325814 */   // GIR_Coverage, 8910,
     /* 325814 */   GIR_EraseRootFromParent_Done,
     /* 325815 */ // Label 6756: @325815
     /* 325815 */ GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(325869), // Rule ID 8911 //
     /* 325820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 325823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 325826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 325830 */   // MIs[0] Operand 2
     /* 325830 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 325841 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 325841 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 325844 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 325848 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325853 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 325857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 325862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 325864 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325867 */   GIR_RootConstrainSelectedInstOperands,
     /* 325868 */   // GIR_Coverage, 8911,
     /* 325868 */   GIR_EraseRootFromParent_Done,
     /* 325869 */ // Label 6757: @325869
     /* 325869 */ GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(325923), // Rule ID 8912 //
     /* 325874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 325877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 325880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 325884 */   // MIs[0] Operand 2
     /* 325884 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 325895 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 325895 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 325898 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 325902 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325907 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 325911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 325916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 325918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325921 */   GIR_RootConstrainSelectedInstOperands,
     /* 325922 */   // GIR_Coverage, 8912,
     /* 325922 */   GIR_EraseRootFromParent_Done,
     /* 325923 */ // Label 6758: @325923
     /* 325923 */ GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(325977), // Rule ID 8913 //
     /* 325928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 325931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 325934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 325938 */   // MIs[0] Operand 2
     /* 325938 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 325949 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 325949 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 325952 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 325956 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325961 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 325965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 325967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 325970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 325972 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325975 */   GIR_RootConstrainSelectedInstOperands,
     /* 325976 */   // GIR_Coverage, 8913,
     /* 325976 */   GIR_EraseRootFromParent_Done,
     /* 325977 */ // Label 6759: @325977
     /* 325977 */ GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(326048), // Rule ID 8922 //
     /* 325982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 325985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 325988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 325992 */   // MIs[0] Operand 2
     /* 325992 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 326003 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 326003 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 326006 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326010 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326015 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 326019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326021 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 326024 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326028 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326033 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 326043 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326046 */   GIR_RootConstrainSelectedInstOperands,
     /* 326047 */   // GIR_Coverage, 8922,
     /* 326047 */   GIR_EraseRootFromParent_Done,
     /* 326048 */ // Label 6760: @326048
     /* 326048 */ GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(326119), // Rule ID 8923 //
     /* 326053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 326056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 326059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 326063 */   // MIs[0] Operand 2
     /* 326063 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 326074 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 326074 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 326077 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326081 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326086 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 326090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326092 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 326095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326099 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326104 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 326114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326117 */   GIR_RootConstrainSelectedInstOperands,
     /* 326118 */   // GIR_Coverage, 8923,
     /* 326118 */   GIR_EraseRootFromParent_Done,
     /* 326119 */ // Label 6761: @326119
     /* 326119 */ GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(326190), // Rule ID 8924 //
     /* 326124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 326127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 326130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 326134 */   // MIs[0] Operand 2
     /* 326134 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 326145 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 326145 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 326148 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326152 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326157 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 326161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326163 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 326166 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326170 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326175 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 326185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326188 */   GIR_RootConstrainSelectedInstOperands,
     /* 326189 */   // GIR_Coverage, 8924,
     /* 326189 */   GIR_EraseRootFromParent_Done,
     /* 326190 */ // Label 6762: @326190
     /* 326190 */ GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(326261), // Rule ID 8925 //
     /* 326195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 326198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 326201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 326205 */   // MIs[0] Operand 2
     /* 326205 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 326216 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 326216 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 326219 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326223 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326228 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 326232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326234 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 326237 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326241 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326246 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 326256 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326259 */   GIR_RootConstrainSelectedInstOperands,
     /* 326260 */   // GIR_Coverage, 8925,
     /* 326260 */   GIR_EraseRootFromParent_Done,
     /* 326261 */ // Label 6763: @326261
     /* 326261 */ GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(326332), // Rule ID 8926 //
     /* 326266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 326269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 326272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 326276 */   // MIs[0] Operand 2
     /* 326276 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 326287 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 326287 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 326290 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326294 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326299 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 326303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326305 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 326308 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326312 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326317 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 326327 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326330 */   GIR_RootConstrainSelectedInstOperands,
     /* 326331 */   // GIR_Coverage, 8926,
     /* 326331 */   GIR_EraseRootFromParent_Done,
     /* 326332 */ // Label 6764: @326332
     /* 326332 */ GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(326403), // Rule ID 8927 //
     /* 326337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 326340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 326343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 326347 */   // MIs[0] Operand 2
     /* 326347 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 326358 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 326358 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 326361 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326365 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326370 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 326374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326376 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 326379 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326383 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326388 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326391 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 326398 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326401 */   GIR_RootConstrainSelectedInstOperands,
     /* 326402 */   // GIR_Coverage, 8927,
     /* 326402 */   GIR_EraseRootFromParent_Done,
     /* 326403 */ // Label 6765: @326403
     /* 326403 */ GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(326474), // Rule ID 8928 //
     /* 326408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 326411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 326414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 326418 */   // MIs[0] Operand 2
     /* 326418 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 326429 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 326429 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 326432 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326436 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326441 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 326445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326447 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 326450 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326454 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326459 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 326469 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326472 */   GIR_RootConstrainSelectedInstOperands,
     /* 326473 */   // GIR_Coverage, 8928,
     /* 326473 */   GIR_EraseRootFromParent_Done,
     /* 326474 */ // Label 6766: @326474
     /* 326474 */ GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(326545), // Rule ID 8929 //
     /* 326479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 326482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 326485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 326489 */   // MIs[0] Operand 2
     /* 326489 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 326500 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 326500 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 326503 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326507 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326512 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 326516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 326521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326530 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 326540 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326543 */   GIR_RootConstrainSelectedInstOperands,
     /* 326544 */   // GIR_Coverage, 8929,
     /* 326544 */   GIR_EraseRootFromParent_Done,
     /* 326545 */ // Label 6767: @326545
     /* 326545 */ GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(326633), // Rule ID 8938 //
     /* 326550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 326553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 326556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 326560 */   // MIs[0] Operand 2
     /* 326560 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 326571 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 326571 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 326574 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326578 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326583 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 326587 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326589 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 326592 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326596 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326601 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326604 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 326609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326618 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326621 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 326628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326631 */   GIR_RootConstrainSelectedInstOperands,
     /* 326632 */   // GIR_Coverage, 8938,
     /* 326632 */   GIR_EraseRootFromParent_Done,
     /* 326633 */ // Label 6768: @326633
     /* 326633 */ GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(326721), // Rule ID 8939 //
     /* 326638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 326641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 326644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 326648 */   // MIs[0] Operand 2
     /* 326648 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 326659 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 326659 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 326662 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326666 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326671 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 326675 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326677 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 326680 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326684 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326689 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326694 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 326697 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326701 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326706 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 326716 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326719 */   GIR_RootConstrainSelectedInstOperands,
     /* 326720 */   // GIR_Coverage, 8939,
     /* 326720 */   GIR_EraseRootFromParent_Done,
     /* 326721 */ // Label 6769: @326721
     /* 326721 */ GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(326809), // Rule ID 8940 //
     /* 326726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 326729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 326732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 326736 */   // MIs[0] Operand 2
     /* 326736 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 326747 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 326747 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 326750 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326754 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326759 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 326763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326765 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 326768 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326772 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326777 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 326785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326794 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 326804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326807 */   GIR_RootConstrainSelectedInstOperands,
     /* 326808 */   // GIR_Coverage, 8940,
     /* 326808 */   GIR_EraseRootFromParent_Done,
     /* 326809 */ // Label 6770: @326809
     /* 326809 */ GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(326897), // Rule ID 8941 //
     /* 326814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 326817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 326820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 326824 */   // MIs[0] Operand 2
     /* 326824 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 326835 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 326835 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 326838 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326842 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326847 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 326851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326853 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 326856 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326860 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326865 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326870 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 326873 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326877 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326882 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 326892 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326895 */   GIR_RootConstrainSelectedInstOperands,
     /* 326896 */   // GIR_Coverage, 8941,
     /* 326896 */   GIR_EraseRootFromParent_Done,
     /* 326897 */ // Label 6771: @326897
     /* 326897 */ GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(326985), // Rule ID 8942 //
     /* 326902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 326905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 326908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 326912 */   // MIs[0] Operand 2
     /* 326912 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 326923 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 326923 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 326926 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326930 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326935 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 326939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326941 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 326944 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 326948 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326953 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326958 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 326961 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326965 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326970 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 326975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 326978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 326980 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326983 */   GIR_RootConstrainSelectedInstOperands,
     /* 326984 */   // GIR_Coverage, 8942,
     /* 326984 */   GIR_EraseRootFromParent_Done,
     /* 326985 */ // Label 6772: @326985
     /* 326985 */ GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(327073), // Rule ID 8943 //
     /* 326990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 326993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 326996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 327000 */   // MIs[0] Operand 2
     /* 327000 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 327011 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 327011 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 327014 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327018 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327023 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 327027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327029 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 327032 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327036 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327041 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 327049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327058 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 327068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327071 */   GIR_RootConstrainSelectedInstOperands,
     /* 327072 */   // GIR_Coverage, 8943,
     /* 327072 */   GIR_EraseRootFromParent_Done,
     /* 327073 */ // Label 6773: @327073
     /* 327073 */ GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(327161), // Rule ID 8944 //
     /* 327078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 327081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 327084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 327088 */   // MIs[0] Operand 2
     /* 327088 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 327099 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 327099 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 327102 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327106 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327111 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 327115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327117 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 327120 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327124 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327129 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327134 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 327137 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327141 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327146 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 327156 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327159 */   GIR_RootConstrainSelectedInstOperands,
     /* 327160 */   // GIR_Coverage, 8944,
     /* 327160 */   GIR_EraseRootFromParent_Done,
     /* 327161 */ // Label 6774: @327161
     /* 327161 */ GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(327249), // Rule ID 8945 //
     /* 327166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 327169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 327172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 327176 */   // MIs[0] Operand 2
     /* 327176 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 327187 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 327187 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 327190 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327194 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327199 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 327203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327205 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 327208 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327212 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327217 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 327225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327234 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 327244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327247 */   GIR_RootConstrainSelectedInstOperands,
     /* 327248 */   // GIR_Coverage, 8945,
     /* 327248 */   GIR_EraseRootFromParent_Done,
     /* 327249 */ // Label 6775: @327249
     /* 327249 */ GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(327337), // Rule ID 8946 //
     /* 327254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 327257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 327260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 327264 */   // MIs[0] Operand 2
     /* 327264 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 327275 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 327275 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 327278 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327282 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327287 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 327291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327293 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 327296 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327300 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327305 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 327313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327322 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 327332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327335 */   GIR_RootConstrainSelectedInstOperands,
     /* 327336 */   // GIR_Coverage, 8946,
     /* 327336 */   GIR_EraseRootFromParent_Done,
     /* 327337 */ // Label 6776: @327337
     /* 327337 */ GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(327425), // Rule ID 8947 //
     /* 327342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 327345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 327348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 327352 */   // MIs[0] Operand 2
     /* 327352 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 327363 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 327363 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 327366 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327370 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327375 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 327379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327381 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 327384 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327388 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327393 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 327401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327410 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327413 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 327420 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327423 */   GIR_RootConstrainSelectedInstOperands,
     /* 327424 */   // GIR_Coverage, 8947,
     /* 327424 */   GIR_EraseRootFromParent_Done,
     /* 327425 */ // Label 6777: @327425
     /* 327425 */ GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(327513), // Rule ID 8948 //
     /* 327430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 327433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 327436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 327440 */   // MIs[0] Operand 2
     /* 327440 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 327451 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 327451 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 327454 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327458 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327463 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 327467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327469 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 327472 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327476 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327481 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 327489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327498 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 327508 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327511 */   GIR_RootConstrainSelectedInstOperands,
     /* 327512 */   // GIR_Coverage, 8948,
     /* 327512 */   GIR_EraseRootFromParent_Done,
     /* 327513 */ // Label 6778: @327513
     /* 327513 */ GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(327601), // Rule ID 8949 //
     /* 327518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 327521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 327524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 327528 */   // MIs[0] Operand 2
     /* 327528 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 327539 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 327539 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 327542 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327546 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327551 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 327555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327557 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 327560 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327564 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327569 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 327577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327586 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 327596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327599 */   GIR_RootConstrainSelectedInstOperands,
     /* 327600 */   // GIR_Coverage, 8949,
     /* 327600 */   GIR_EraseRootFromParent_Done,
     /* 327601 */ // Label 6779: @327601
     /* 327601 */ GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(327689), // Rule ID 8950 //
     /* 327606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 327609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 327612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 327616 */   // MIs[0] Operand 2
     /* 327616 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 327627 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 327627 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 327630 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327634 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327639 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 327643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327645 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 327648 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327652 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327657 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 327665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327674 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327677 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 327684 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327687 */   GIR_RootConstrainSelectedInstOperands,
     /* 327688 */   // GIR_Coverage, 8950,
     /* 327688 */   GIR_EraseRootFromParent_Done,
     /* 327689 */ // Label 6780: @327689
     /* 327689 */ GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(327777), // Rule ID 8951 //
     /* 327694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 327697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 327700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 327704 */   // MIs[0] Operand 2
     /* 327704 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 327715 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 327715 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 327718 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327722 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327727 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 327731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327733 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 327736 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327740 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327745 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327750 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 327753 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327757 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327762 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 327772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327775 */   GIR_RootConstrainSelectedInstOperands,
     /* 327776 */   // GIR_Coverage, 8951,
     /* 327776 */   GIR_EraseRootFromParent_Done,
     /* 327777 */ // Label 6781: @327777
     /* 327777 */ GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(327865), // Rule ID 8952 //
     /* 327782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 327785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 327788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 327792 */   // MIs[0] Operand 2
     /* 327792 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 327803 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 327803 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 327806 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327810 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327815 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 327819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327821 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 327824 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327828 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327833 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327836 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 327841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327850 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 327860 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327863 */   GIR_RootConstrainSelectedInstOperands,
     /* 327864 */   // GIR_Coverage, 8952,
     /* 327864 */   GIR_EraseRootFromParent_Done,
     /* 327865 */ // Label 6782: @327865
     /* 327865 */ GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(327953), // Rule ID 8953 //
     /* 327870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 327873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 327876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 327880 */   // MIs[0] Operand 2
     /* 327880 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 327891 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 327891 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 327894 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327898 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327903 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 327907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 327909 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 327912 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327916 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327921 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 327929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327938 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 327943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 327946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 327948 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327951 */   GIR_RootConstrainSelectedInstOperands,
     /* 327952 */   // GIR_Coverage, 8953,
     /* 327952 */   GIR_EraseRootFromParent_Done,
     /* 327953 */ // Label 6783: @327953
     /* 327953 */ GIM_Reject,
     /* 327954 */ // Label 6719: @327954
     /* 327954 */ GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(327989), // Rule ID 8904 //
     /* 327959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 327962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 327965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 327969 */   // MIs[0] Operand 2
     /* 327969 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 327980 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 327980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 327983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 327985 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 327987 */   GIR_RootConstrainSelectedInstOperands,
     /* 327988 */   // GIR_Coverage, 8904,
     /* 327988 */   GIR_EraseRootFromParent_Done,
     /* 327989 */ // Label 6784: @327989
     /* 327989 */ GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(328024), // Rule ID 8905 //
     /* 327994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 327997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 328000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 328004 */   // MIs[0] Operand 2
     /* 328004 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 328015 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 328015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 328020 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 328022 */   GIR_RootConstrainSelectedInstOperands,
     /* 328023 */   // GIR_Coverage, 8905,
     /* 328023 */   GIR_EraseRootFromParent_Done,
     /* 328024 */ // Label 6785: @328024
     /* 328024 */ GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(328078), // Rule ID 8914 //
     /* 328029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 328035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 328039 */   // MIs[0] Operand 2
     /* 328039 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328050 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 328050 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 328053 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328057 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328062 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 328066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 328073 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328076 */   GIR_RootConstrainSelectedInstOperands,
     /* 328077 */   // GIR_Coverage, 8914,
     /* 328077 */   GIR_EraseRootFromParent_Done,
     /* 328078 */ // Label 6786: @328078
     /* 328078 */ GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(328132), // Rule ID 8915 //
     /* 328083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 328089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 328093 */   // MIs[0] Operand 2
     /* 328093 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 328104 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 328104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 328107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328116 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 328120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 328127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328130 */   GIR_RootConstrainSelectedInstOperands,
     /* 328131 */   // GIR_Coverage, 8915,
     /* 328131 */   GIR_EraseRootFromParent_Done,
     /* 328132 */ // Label 6787: @328132
     /* 328132 */ GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(328186), // Rule ID 8916 //
     /* 328137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 328143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 328147 */   // MIs[0] Operand 2
     /* 328147 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 328158 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 328158 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 328161 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328165 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328170 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 328174 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 328181 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328184 */   GIR_RootConstrainSelectedInstOperands,
     /* 328185 */   // GIR_Coverage, 8916,
     /* 328185 */   GIR_EraseRootFromParent_Done,
     /* 328186 */ // Label 6788: @328186
     /* 328186 */ GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(328240), // Rule ID 8917 //
     /* 328191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 328197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 328201 */   // MIs[0] Operand 2
     /* 328201 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 328212 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 328212 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 328215 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328219 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328224 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 328228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 328235 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328238 */   GIR_RootConstrainSelectedInstOperands,
     /* 328239 */   // GIR_Coverage, 8917,
     /* 328239 */   GIR_EraseRootFromParent_Done,
     /* 328240 */ // Label 6789: @328240
     /* 328240 */ GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(328311), // Rule ID 8930 //
     /* 328245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 328251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 328255 */   // MIs[0] Operand 2
     /* 328255 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328266 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 328266 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 328269 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328273 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328278 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 328282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 328284 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 328287 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328291 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328296 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 328306 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328309 */   GIR_RootConstrainSelectedInstOperands,
     /* 328310 */   // GIR_Coverage, 8930,
     /* 328310 */   GIR_EraseRootFromParent_Done,
     /* 328311 */ // Label 6790: @328311
     /* 328311 */ GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(328382), // Rule ID 8931 //
     /* 328316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 328322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 328326 */   // MIs[0] Operand 2
     /* 328326 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 328337 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 328337 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 328340 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328344 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328349 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 328353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 328355 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 328358 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328362 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328367 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 328377 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328380 */   GIR_RootConstrainSelectedInstOperands,
     /* 328381 */   // GIR_Coverage, 8931,
     /* 328381 */   GIR_EraseRootFromParent_Done,
     /* 328382 */ // Label 6791: @328382
     /* 328382 */ GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(328453), // Rule ID 8932 //
     /* 328387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 328393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 328397 */   // MIs[0] Operand 2
     /* 328397 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 328408 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 328408 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 328411 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328415 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328420 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 328424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 328426 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 328429 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328433 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328438 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 328448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328451 */   GIR_RootConstrainSelectedInstOperands,
     /* 328452 */   // GIR_Coverage, 8932,
     /* 328452 */   GIR_EraseRootFromParent_Done,
     /* 328453 */ // Label 6792: @328453
     /* 328453 */ GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(328524), // Rule ID 8933 //
     /* 328458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 328464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 328468 */   // MIs[0] Operand 2
     /* 328468 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 328479 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 328479 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 328482 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328486 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328491 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 328495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 328497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 328500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328509 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 328519 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328522 */   GIR_RootConstrainSelectedInstOperands,
     /* 328523 */   // GIR_Coverage, 8933,
     /* 328523 */   GIR_EraseRootFromParent_Done,
     /* 328524 */ // Label 6793: @328524
     /* 328524 */ GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(328595), // Rule ID 8934 //
     /* 328529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 328535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 328539 */   // MIs[0] Operand 2
     /* 328539 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 328550 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 328550 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 328553 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328557 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328562 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 328566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 328568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 328571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328580 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 328590 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328593 */   GIR_RootConstrainSelectedInstOperands,
     /* 328594 */   // GIR_Coverage, 8934,
     /* 328594 */   GIR_EraseRootFromParent_Done,
     /* 328595 */ // Label 6794: @328595
     /* 328595 */ GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(328666), // Rule ID 8935 //
     /* 328600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 328606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 328610 */   // MIs[0] Operand 2
     /* 328610 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 328621 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 328621 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 328624 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328628 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328633 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 328637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 328639 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 328642 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328646 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328651 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 328661 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328664 */   GIR_RootConstrainSelectedInstOperands,
     /* 328665 */   // GIR_Coverage, 8935,
     /* 328665 */   GIR_EraseRootFromParent_Done,
     /* 328666 */ // Label 6795: @328666
     /* 328666 */ GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(328737), // Rule ID 8936 //
     /* 328671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 328677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 328681 */   // MIs[0] Operand 2
     /* 328681 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 328692 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 328692 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 328695 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328699 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328704 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 328708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 328710 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 328713 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328717 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328722 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 328730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 328732 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328735 */   GIR_RootConstrainSelectedInstOperands,
     /* 328736 */   // GIR_Coverage, 8936,
     /* 328736 */   GIR_EraseRootFromParent_Done,
     /* 328737 */ // Label 6796: @328737
     /* 328737 */ GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(328808), // Rule ID 8937 //
     /* 328742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 328748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 328752 */   // MIs[0] Operand 2
     /* 328752 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 328763 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 328763 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 328766 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328770 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328775 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 328779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 328781 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 328784 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328788 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328793 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 328796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 328801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 328803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328806 */   GIR_RootConstrainSelectedInstOperands,
     /* 328807 */   // GIR_Coverage, 8937,
     /* 328807 */   GIR_EraseRootFromParent_Done,
     /* 328808 */ // Label 6797: @328808
     /* 328808 */ GIM_Reject,
     /* 328809 */ // Label 6720: @328809
     /* 328809 */ GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(328844), // Rule ID 8954 //
     /* 328814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 328820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 328824 */   // MIs[0] Operand 2
     /* 328824 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328835 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 328835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 328838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 328840 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 328842 */   GIR_RootConstrainSelectedInstOperands,
     /* 328843 */   // GIR_Coverage, 8954,
     /* 328843 */   GIR_EraseRootFromParent_Done,
     /* 328844 */ // Label 6798: @328844
     /* 328844 */ GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(328879), // Rule ID 8955 //
     /* 328849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 328855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 328859 */   // MIs[0] Operand 2
     /* 328859 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 328870 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 328870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 328873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 328875 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 328877 */   GIR_RootConstrainSelectedInstOperands,
     /* 328878 */   // GIR_Coverage, 8955,
     /* 328878 */   GIR_EraseRootFromParent_Done,
     /* 328879 */ // Label 6799: @328879
     /* 328879 */ GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(328933), // Rule ID 8960 //
     /* 328884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 328890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 328894 */   // MIs[0] Operand 2
     /* 328894 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328905 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 328905 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 328908 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 328912 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328917 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 328921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 328926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 328928 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328931 */   GIR_RootConstrainSelectedInstOperands,
     /* 328932 */   // GIR_Coverage, 8960,
     /* 328932 */   GIR_EraseRootFromParent_Done,
     /* 328933 */ // Label 6800: @328933
     /* 328933 */ GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(328987), // Rule ID 8961 //
     /* 328938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 328944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 328948 */   // MIs[0] Operand 2
     /* 328948 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 328959 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 328959 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 328962 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 328966 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328971 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 328975 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 328980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 328982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328985 */   GIR_RootConstrainSelectedInstOperands,
     /* 328986 */   // GIR_Coverage, 8961,
     /* 328986 */   GIR_EraseRootFromParent_Done,
     /* 328987 */ // Label 6801: @328987
     /* 328987 */ GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(329041), // Rule ID 8962 //
     /* 328992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 328995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 328998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 329002 */   // MIs[0] Operand 2
     /* 329002 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 329013 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 329013 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 329016 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 329020 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329025 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 329029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 329034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 329036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329039 */   GIR_RootConstrainSelectedInstOperands,
     /* 329040 */   // GIR_Coverage, 8962,
     /* 329040 */   GIR_EraseRootFromParent_Done,
     /* 329041 */ // Label 6802: @329041
     /* 329041 */ GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(329095), // Rule ID 8963 //
     /* 329046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 329052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 329056 */   // MIs[0] Operand 2
     /* 329056 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 329067 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 329067 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 329070 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 329074 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329079 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 329083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 329088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 329090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329093 */   GIR_RootConstrainSelectedInstOperands,
     /* 329094 */   // GIR_Coverage, 8963,
     /* 329094 */   GIR_EraseRootFromParent_Done,
     /* 329095 */ // Label 6803: @329095
     /* 329095 */ GIM_Reject,
     /* 329096 */ // Label 6721: @329096
     /* 329096 */ GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(329165),
     /* 329101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 329104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 329108 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(329136), // Rule ID 8958 //
     /* 329113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329116 */     // MIs[0] Operand 2
     /* 329116 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329127 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 329127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 329130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 329132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 329134 */     GIR_RootConstrainSelectedInstOperands,
     /* 329135 */     // GIR_Coverage, 8958,
     /* 329135 */     GIR_EraseRootFromParent_Done,
     /* 329136 */   // Label 6805: @329136
     /* 329136 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(329164), // Rule ID 8959 //
     /* 329141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329144 */     // MIs[0] Operand 2
     /* 329144 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 329155 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 329155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 329158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 329160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 329162 */     GIR_RootConstrainSelectedInstOperands,
     /* 329163 */     // GIR_Coverage, 8959,
     /* 329163 */     GIR_EraseRootFromParent_Done,
     /* 329164 */   // Label 6806: @329164
     /* 329164 */   GIM_Reject,
     /* 329165 */ // Label 6804: @329165
     /* 329165 */ GIM_Reject,
     /* 329166 */ // Label 6722: @329166
     /* 329166 */ GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(329201), // Rule ID 8906 //
     /* 329171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 329177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329181 */   // MIs[0] Operand 2
     /* 329181 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329192 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 329192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329197 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 329199 */   GIR_RootConstrainSelectedInstOperands,
     /* 329200 */   // GIR_Coverage, 8906,
     /* 329200 */   GIR_EraseRootFromParent_Done,
     /* 329201 */ // Label 6807: @329201
     /* 329201 */ GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(329236), // Rule ID 8907 //
     /* 329206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 329212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329216 */   // MIs[0] Operand 2
     /* 329216 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 329227 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 329227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329232 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 329234 */   GIR_RootConstrainSelectedInstOperands,
     /* 329235 */   // GIR_Coverage, 8907,
     /* 329235 */   GIR_EraseRootFromParent_Done,
     /* 329236 */ // Label 6808: @329236
     /* 329236 */ GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(329290), // Rule ID 8918 //
     /* 329241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 329247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329251 */   // MIs[0] Operand 2
     /* 329251 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329262 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 329262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329274 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329288 */   GIR_RootConstrainSelectedInstOperands,
     /* 329289 */   // GIR_Coverage, 8918,
     /* 329289 */   GIR_EraseRootFromParent_Done,
     /* 329290 */ // Label 6809: @329290
     /* 329290 */ GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(329344), // Rule ID 8919 //
     /* 329295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 329301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329305 */   // MIs[0] Operand 2
     /* 329305 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 329316 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 329316 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329319 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329323 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329328 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329339 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329342 */   GIR_RootConstrainSelectedInstOperands,
     /* 329343 */   // GIR_Coverage, 8919,
     /* 329343 */   GIR_EraseRootFromParent_Done,
     /* 329344 */ // Label 6810: @329344
     /* 329344 */ GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(329398), // Rule ID 8920 //
     /* 329349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 329355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329359 */   // MIs[0] Operand 2
     /* 329359 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 329370 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 329370 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329373 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329377 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329382 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329396 */   GIR_RootConstrainSelectedInstOperands,
     /* 329397 */   // GIR_Coverage, 8920,
     /* 329397 */   GIR_EraseRootFromParent_Done,
     /* 329398 */ // Label 6811: @329398
     /* 329398 */ GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(329452), // Rule ID 8921 //
     /* 329403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 329409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329413 */   // MIs[0] Operand 2
     /* 329413 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 329424 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 329424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329436 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329450 */   GIR_RootConstrainSelectedInstOperands,
     /* 329451 */   // GIR_Coverage, 8921,
     /* 329451 */   GIR_EraseRootFromParent_Done,
     /* 329452 */ // Label 6812: @329452
     /* 329452 */ GIM_Reject,
     /* 329453 */ // Label 6723: @329453
     /* 329453 */ GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(329522),
     /* 329458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 329461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 329465 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(329493), // Rule ID 8956 //
     /* 329470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329473 */     // MIs[0] Operand 2
     /* 329473 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329484 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 329484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 329487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 329489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 329491 */     GIR_RootConstrainSelectedInstOperands,
     /* 329492 */     // GIR_Coverage, 8956,
     /* 329492 */     GIR_EraseRootFromParent_Done,
     /* 329493 */   // Label 6814: @329493
     /* 329493 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(329521), // Rule ID 8957 //
     /* 329498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329501 */     // MIs[0] Operand 2
     /* 329501 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 329512 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 329512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 329515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 329517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 329519 */     GIR_RootConstrainSelectedInstOperands,
     /* 329520 */     // GIR_Coverage, 8957,
     /* 329520 */     GIR_EraseRootFromParent_Done,
     /* 329521 */   // Label 6815: @329521
     /* 329521 */   GIM_Reject,
     /* 329522 */ // Label 6813: @329522
     /* 329522 */ GIM_Reject,
     /* 329523 */ // Label 6724: @329523
     /* 329523 */ GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(329592),
     /* 329528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 329531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329535 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(329563), // Rule ID 8908 //
     /* 329540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329543 */     // MIs[0] Operand 2
     /* 329543 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329554 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 329554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 329561 */     GIR_RootConstrainSelectedInstOperands,
     /* 329562 */     // GIR_Coverage, 8908,
     /* 329562 */     GIR_EraseRootFromParent_Done,
     /* 329563 */   // Label 6817: @329563
     /* 329563 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(329591), // Rule ID 8909 //
     /* 329568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329571 */     // MIs[0] Operand 2
     /* 329571 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 329582 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 329582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 329589 */     GIR_RootConstrainSelectedInstOperands,
     /* 329590 */     // GIR_Coverage, 8909,
     /* 329590 */     GIR_EraseRootFromParent_Done,
     /* 329591 */   // Label 6818: @329591
     /* 329591 */   GIM_Reject,
     /* 329592 */ // Label 6816: @329592
     /* 329592 */ GIM_Reject,
     /* 329593 */ // Label 6725: @329593
     /* 329593 */ GIM_Reject,
     /* 329594 */ // Label 88: @329594
     /* 329594 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6834*/ GIMT_Encode4(356990),
     /* 329605 */ /*GILLT_s64*//*Label 6819*/ GIMT_Encode4(329689), GIMT_Encode4(0),
     /* 329613 */ /*GILLT_v2s32*//*Label 6820*/ GIMT_Encode4(330399),
     /* 329617 */ /*GILLT_v2s64*//*Label 6821*/ GIMT_Encode4(333930),
     /* 329621 */ /*GILLT_v4s16*//*Label 6822*/ GIMT_Encode4(336759),
     /* 329625 */ /*GILLT_v4s32*//*Label 6823*/ GIMT_Encode4(340399),
     /* 329629 */ /*GILLT_v8s8*//*Label 6824*/ GIMT_Encode4(343063),
     /* 329633 */ /*GILLT_v8s16*//*Label 6825*/ GIMT_Encode4(344907),
     /* 329637 */ /*GILLT_v16s8*//*Label 6826*/ GIMT_Encode4(347882), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 329649 */ /*GILLT_nxv2s16*//*Label 6827*/ GIMT_Encode4(349462),
     /* 329653 */ /*GILLT_nxv2s32*//*Label 6828*/ GIMT_Encode4(349587),
     /* 329657 */ /*GILLT_nxv2s64*//*Label 6829*/ GIMT_Encode4(349712), GIMT_Encode4(0),
     /* 329665 */ /*GILLT_nxv4s16*//*Label 6830*/ GIMT_Encode4(351626),
     /* 329669 */ /*GILLT_nxv4s32*//*Label 6831*/ GIMT_Encode4(351778), GIMT_Encode4(0),
     /* 329677 */ /*GILLT_nxv8s16*//*Label 6832*/ GIMT_Encode4(353746), GIMT_Encode4(0),
     /* 329685 */ /*GILLT_nxv16s8*//*Label 6833*/ GIMT_Encode4(355940),
     /* 329689 */ // Label 6819: @329689
     /* 329689 */ GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(330398),
     /* 329694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 329700 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 329703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329707 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(329837), // Rule ID 5703 //
     /* 329712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329745 */     // MIs[2] Operand 1
     /* 329745 */     // No operand predicates
     /* 329745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 329749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329753 */     // MIs[3] Operand 1
     /* 329753 */     // No operand predicates
     /* 329753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329755 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 329755 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 329758 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329762 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329767 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 329770 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 329774 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 329777 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329782 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 329794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329799 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 329805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 329812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329819 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329836 */     // GIR_Coverage, 5703,
     /* 329836 */     GIR_EraseRootFromParent_Done,
     /* 329837 */   // Label 6836: @329837
     /* 329837 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(329998), // Rule ID 5704 //
     /* 329842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 329850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329875 */     // MIs[2] Operand 1
     /* 329875 */     // No operand predicates
     /* 329875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 329879 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 329883 */     // MIs[3] Operand 1
     /* 329883 */     // No operand predicates
     /* 329883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 329885 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 329885 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 329888 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329892 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329897 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 329900 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329904 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 329907 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329912 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329917 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 329920 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 329924 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329929 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 329932 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 329936 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 329939 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329944 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 329956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329961 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 329967 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 329970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 329973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329980 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329997 */     // GIR_Coverage, 5704,
     /* 329997 */     GIR_EraseRootFromParent_Done,
     /* 329998 */   // Label 6837: @329998
     /* 329998 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(330128), // Rule ID 5727 //
     /* 330003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 330011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 330015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 330032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 330036 */     // MIs[2] Operand 1
     /* 330036 */     // No operand predicates
     /* 330036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 330040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 330044 */     // MIs[3] Operand 1
     /* 330044 */     // No operand predicates
     /* 330044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330046 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 330046 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 330049 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330053 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330058 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 330061 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 330065 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 330068 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330073 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 330081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 330085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330090 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 330096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 330103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330110 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 330117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330127 */     // GIR_Coverage, 5727,
     /* 330127 */     GIR_EraseRootFromParent_Done,
     /* 330128 */   // Label 6838: @330128
     /* 330128 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(330289), // Rule ID 5728 //
     /* 330133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 330141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 330145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 330153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 330162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 330166 */     // MIs[2] Operand 1
     /* 330166 */     // No operand predicates
     /* 330166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 330170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 330174 */     // MIs[3] Operand 1
     /* 330174 */     // No operand predicates
     /* 330174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 330176 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 330176 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 330179 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330183 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330188 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 330191 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330195 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 330198 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330203 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330208 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 330211 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330215 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330220 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 330223 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 330227 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 330230 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330235 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 330243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 330247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330252 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 330258 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 330261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 330264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330271 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 330278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330288 */     // GIR_Coverage, 5728,
     /* 330288 */     GIR_EraseRootFromParent_Done,
     /* 330289 */   // Label 6839: @330289
     /* 330289 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(330325), // Rule ID 6620 //
     /* 330294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330312 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 330312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 330319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330324 */     // GIR_Coverage, 6620,
     /* 330324 */     GIR_EraseRootFromParent_Done,
     /* 330325 */   // Label 6840: @330325
     /* 330325 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(330361), // Rule ID 6622 //
     /* 330330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330348 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 330348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 330355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330360 */     // GIR_Coverage, 6622,
     /* 330360 */     GIR_EraseRootFromParent_Done,
     /* 330361 */   // Label 6841: @330361
     /* 330361 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(330397), // Rule ID 6624 //
     /* 330366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330384 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 330384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330387 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 330389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 330391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330396 */     // GIR_Coverage, 6624,
     /* 330396 */     GIR_EraseRootFromParent_Done,
     /* 330397 */   // Label 6842: @330397
     /* 330397 */   GIM_Reject,
     /* 330398 */ // Label 6835: @330398
     /* 330398 */ GIM_Reject,
     /* 330399 */ // Label 6820: @330399
     /* 330399 */ GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(333929),
     /* 330404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 330410 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 330413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330417 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(330526), // Rule ID 4253 //
     /* 330422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330426 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330432 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330442 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330445 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330449 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330459 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 330466 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 330466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 330469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 330473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330493 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 330515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330525 */     // GIR_Coverage, 4253,
     /* 330525 */     GIR_EraseRootFromParent_Done,
     /* 330526 */   // Label 6844: @330526
     /* 330526 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(330635), // Rule ID 4254 //
     /* 330531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330535 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330541 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330551 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330554 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330558 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 330575 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 330575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 330578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 330582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330602 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 330624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330634 */     // GIR_Coverage, 4254,
     /* 330634 */     GIR_EraseRootFromParent_Done,
     /* 330635 */   // Label 6845: @330635
     /* 330635 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(330744), // Rule ID 4361 //
     /* 330640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330644 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330650 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330660 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330667 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 330684 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 330684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 330687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 330691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330711 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 330733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330743 */     // GIR_Coverage, 4361,
     /* 330743 */     GIR_EraseRootFromParent_Done,
     /* 330744 */   // Label 6846: @330744
     /* 330744 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(330853), // Rule ID 4362 //
     /* 330749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330753 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 330759 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 330761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330769 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330776 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 330793 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 330793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 330796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 330800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330820 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 330842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330852 */     // GIR_Coverage, 4362,
     /* 330852 */     GIR_EraseRootFromParent_Done,
     /* 330853 */   // Label 6847: @330853
     /* 330853 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(330958), // Rule ID 4259 //
     /* 330858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330874 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330877 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330881 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 330898 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 330898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 330901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 330905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 330920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 330925 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 330931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 330936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 330941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 330947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330957 */     // GIR_Coverage, 4259,
     /* 330957 */     GIR_EraseRootFromParent_Done,
     /* 330958 */   // Label 6848: @330958
     /* 330958 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(331063), // Rule ID 4261 //
     /* 330963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 330971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 330975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 330979 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 330982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 330986 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 330990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 330994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 330996 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 331003 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 331003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 331010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 331025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 331030 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 331052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331062 */     // GIR_Coverage, 4261,
     /* 331062 */     GIR_EraseRootFromParent_Done,
     /* 331063 */   // Label 6849: @331063
     /* 331063 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(331168), // Rule ID 4367 //
     /* 331068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331084 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331087 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331091 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 331108 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 331108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 331115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 331130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 331135 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 331157 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331167 */     // GIR_Coverage, 4367,
     /* 331167 */     GIR_EraseRootFromParent_Done,
     /* 331168 */   // Label 6850: @331168
     /* 331168 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(331273), // Rule ID 4369 //
     /* 331173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331189 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331196 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 331213 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 331213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 331220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 331235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 331240 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 331262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331272 */     // GIR_Coverage, 4369,
     /* 331272 */     GIR_EraseRootFromParent_Done,
     /* 331273 */   // Label 6851: @331273
     /* 331273 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(331377), // Rule ID 4251 //
     /* 331278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331282 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 331288 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 331290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331298 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331305 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 331322 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 331322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 331329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331344 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 331366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331376 */     // GIR_Coverage, 4251,
     /* 331376 */     GIR_EraseRootFromParent_Done,
     /* 331377 */   // Label 6852: @331377
     /* 331377 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(331481), // Rule ID 4252 //
     /* 331382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331386 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 331392 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 331394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331402 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331405 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331409 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 331426 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 331426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 331433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331448 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 331470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331480 */     // GIR_Coverage, 4252,
     /* 331480 */     GIR_EraseRootFromParent_Done,
     /* 331481 */   // Label 6853: @331481
     /* 331481 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(331585), // Rule ID 4359 //
     /* 331486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331490 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 331496 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 331498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331506 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331513 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 331530 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 331530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 331537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331552 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 331574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331579 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331584 */     // GIR_Coverage, 4359,
     /* 331584 */     GIR_EraseRootFromParent_Done,
     /* 331585 */   // Label 6854: @331585
     /* 331585 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(331689), // Rule ID 4360 //
     /* 331590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331594 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 331600 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 331602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331610 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331613 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331617 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 331634 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 331634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 331641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331656 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 331678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331688 */     // GIR_Coverage, 4360,
     /* 331688 */     GIR_EraseRootFromParent_Done,
     /* 331689 */   // Label 6855: @331689
     /* 331689 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(331789), // Rule ID 4255 //
     /* 331694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331710 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331713 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331717 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 331734 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 331734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 331741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331756 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 331778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331788 */     // GIR_Coverage, 4255,
     /* 331788 */     GIR_EraseRootFromParent_Done,
     /* 331789 */   // Label 6856: @331789
     /* 331789 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(331889), // Rule ID 4257 //
     /* 331794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331810 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331813 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331817 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 331834 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 331834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 331841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331856 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 331878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331888 */     // GIR_Coverage, 4257,
     /* 331888 */     GIR_EraseRootFromParent_Done,
     /* 331889 */   // Label 6857: @331889
     /* 331889 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(331989), // Rule ID 4363 //
     /* 331894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 331902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 331906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 331910 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 331913 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 331917 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 331921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 331925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331927 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 331934 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 331934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 331941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 331951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 331956 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 331962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 331967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 331969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 331972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 331978 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331988 */     // GIR_Coverage, 4363,
     /* 331988 */     GIR_EraseRootFromParent_Done,
     /* 331989 */   // Label 6858: @331989
     /* 331989 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(332089), // Rule ID 4365 //
     /* 331994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 332002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 332006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 332010 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 332017 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 332021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 332034 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 332034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 332041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 332056 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 332072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 332078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332083 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332088 */     // GIR_Coverage, 4365,
     /* 332088 */     GIR_EraseRootFromParent_Done,
     /* 332089 */   // Label 6859: @332089
     /* 332089 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(332209), // Rule ID 6399 //
     /* 332094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 332105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 332109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 332113 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332116 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 332120 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 332127 */     // MIs[2] Rn
     /* 332127 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 332131 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 332136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332142 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 332142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 332145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 332163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332168 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332171 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 332174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 332178 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332191 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332198 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332203 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332208 */     // GIR_Coverage, 6399,
     /* 332208 */     GIR_EraseRootFromParent_Done,
     /* 332209 */   // Label 6860: @332209
     /* 332209 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(332329), // Rule ID 6401 //
     /* 332214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 332225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 332229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 332233 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332236 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 332240 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 332247 */     // MIs[2] Rn
     /* 332247 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 332251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 332256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332262 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 332262 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 332265 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332269 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 332283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332288 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332291 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 332294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 332298 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 332304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332311 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332318 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332323 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332328 */     // GIR_Coverage, 6401,
     /* 332328 */     GIR_EraseRootFromParent_Done,
     /* 332329 */   // Label 6861: @332329
     /* 332329 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(332459), // Rule ID 5697 //
     /* 332334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 332350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 332363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332367 */     // MIs[2] Operand 1
     /* 332367 */     // No operand predicates
     /* 332367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 332371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332375 */     // MIs[3] Operand 1
     /* 332375 */     // No operand predicates
     /* 332375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332377 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 332377 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332380 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332384 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332389 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332392 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 332396 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332399 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332404 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 332416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332421 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 332427 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 332434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332441 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332458 */     // GIR_Coverage, 5697,
     /* 332458 */     GIR_EraseRootFromParent_Done,
     /* 332459 */   // Label 6862: @332459
     /* 332459 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(332620), // Rule ID 5698 //
     /* 332464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 332480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 332493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332497 */     // MIs[2] Operand 1
     /* 332497 */     // No operand predicates
     /* 332497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 332501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332505 */     // MIs[3] Operand 1
     /* 332505 */     // No operand predicates
     /* 332505 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332507 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 332507 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 332510 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332514 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332519 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 332522 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332526 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 332529 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332534 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332539 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332542 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332546 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332551 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332554 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 332558 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332561 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332566 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 332578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332583 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 332589 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 332592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 332595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332602 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332619 */     // GIR_Coverage, 5698,
     /* 332619 */     GIR_EraseRootFromParent_Done,
     /* 332620 */   // Label 6863: @332620
     /* 332620 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(332750), // Rule ID 5721 //
     /* 332625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 332641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 332654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332658 */     // MIs[2] Operand 1
     /* 332658 */     // No operand predicates
     /* 332658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 332662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332666 */     // MIs[3] Operand 1
     /* 332666 */     // No operand predicates
     /* 332666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332668 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 332668 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332671 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332675 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332680 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332683 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 332687 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332690 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 332707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332712 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 332718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 332725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332732 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332749 */     // GIR_Coverage, 5721,
     /* 332749 */     GIR_EraseRootFromParent_Done,
     /* 332750 */   // Label 6864: @332750
     /* 332750 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(332911), // Rule ID 5722 //
     /* 332755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 332763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 332771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 332784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332788 */     // MIs[2] Operand 1
     /* 332788 */     // No operand predicates
     /* 332788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 332792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 332796 */     // MIs[3] Operand 1
     /* 332796 */     // No operand predicates
     /* 332796 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 332798 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 332798 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 332801 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332805 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332810 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 332813 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332817 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 332820 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332825 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332830 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332833 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 332837 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332842 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332845 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 332849 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 332852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332857 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 332865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 332869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332874 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 332880 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 332883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 332886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332893 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332910 */     // GIR_Coverage, 5722,
     /* 332910 */     GIR_EraseRootFromParent_Done,
     /* 332911 */   // Label 6865: @332911
     /* 332911 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(332977), // Rule ID 5652 //
     /* 332916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 332924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332934 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 332934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 332937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 332953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 332958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 332961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332966 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332971 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332976 */     // GIR_Coverage, 5652,
     /* 332976 */     GIR_EraseRootFromParent_Done,
     /* 332977 */   // Label 6866: @332977
     /* 332977 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(333043), // Rule ID 5664 //
     /* 332982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 332990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 332998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333000 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 333000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 333003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 333024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 333027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333042 */     // GIR_Coverage, 5664,
     /* 333042 */     GIR_EraseRootFromParent_Done,
     /* 333043 */   // Label 6867: @333043
     /* 333043 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(333178), // Rule ID 5672 //
     /* 333048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 333060 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 333064 */     // MIs[1] Operand 1
     /* 333064 */     // No operand predicates
     /* 333064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 333068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333072 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 333076 */     // MIs[2] Operand 1
     /* 333076 */     // No operand predicates
     /* 333076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333078 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 333078 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 333081 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333085 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333092 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 333095 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333099 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333104 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333107 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 333111 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333114 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333119 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333124 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 333136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333141 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 333147 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 333153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333160 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333177 */     // GIR_Coverage, 5672,
     /* 333177 */     GIR_EraseRootFromParent_Done,
     /* 333178 */   // Label 6868: @333178
     /* 333178 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(333310), // Rule ID 6407 //
     /* 333183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333195 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333198 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 333202 */     // MIs[1] Rn
     /* 333202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 333206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 333211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 333215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333219 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 333223 */     // MIs[2] Operand 1
     /* 333223 */     // No operand predicates
     /* 333223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333225 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 333225 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333228 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333232 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333237 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333240 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 333244 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333247 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333252 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 333264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333269 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 333275 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333279 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333292 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333304 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333309 */     // GIR_Coverage, 6407,
     /* 333309 */     GIR_EraseRootFromParent_Done,
     /* 333310 */   // Label 6869: @333310
     /* 333310 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(333442), // Rule ID 6408 //
     /* 333315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333327 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333330 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 333334 */     // MIs[1] Rn
     /* 333334 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 333338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 333343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 333347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333351 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 333355 */     // MIs[2] Operand 1
     /* 333355 */     // No operand predicates
     /* 333355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333357 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 333357 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333360 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333364 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333369 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333372 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 333376 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333384 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 333396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333401 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 333407 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333411 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 333417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333424 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333441 */     // GIR_Coverage, 6408,
     /* 333441 */     GIR_EraseRootFromParent_Done,
     /* 333442 */   // Label 6870: @333442
     /* 333442 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(333625), // Rule ID 5730 //
     /* 333447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 333455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 333459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 333468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333472 */     // MIs[2] Operand 1
     /* 333472 */     // No operand predicates
     /* 333472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333474 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 333474 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 333477 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333481 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333488 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333491 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333495 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333500 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333503 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 333507 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 333510 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333515 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333520 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333525 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 333528 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333532 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333539 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 333542 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333546 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333551 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333554 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 333558 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333561 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333566 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333571 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 333583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333588 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 333594 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 333597 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 333600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333607 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333624 */     // GIR_Coverage, 5730,
     /* 333624 */     GIR_EraseRootFromParent_Done,
     /* 333625 */   // Label 6871: @333625
     /* 333625 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(333803), // Rule ID 5675 //
     /* 333630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 333642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 333650 */     // MIs[1] Operand 1
     /* 333650 */     // No operand predicates
     /* 333650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333652 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 333652 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 333655 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333659 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333666 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 333669 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333673 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333678 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333681 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 333685 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 333688 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333693 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333698 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333703 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 333706 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333710 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333717 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 333720 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333724 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333729 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333732 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 333736 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333739 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 333761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333766 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 333772 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 333775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 333778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333785 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333802 */     // GIR_Coverage, 5675,
     /* 333802 */     GIR_EraseRootFromParent_Done,
     /* 333803 */   // Label 6872: @333803
     /* 333803 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(333928), // Rule ID 5678 //
     /* 333808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 333816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 333820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 333828 */     // MIs[1] Operand 1
     /* 333828 */     // No operand predicates
     /* 333828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333830 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 333830 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 333833 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333837 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 333844 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 333847 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333851 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333856 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333859 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 333863 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333866 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333871 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 333888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333893 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 333899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 333903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333910 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333927 */     // GIR_Coverage, 5678,
     /* 333927 */     GIR_EraseRootFromParent_Done,
     /* 333928 */   // Label 6873: @333928
     /* 333928 */   GIM_Reject,
     /* 333929 */ // Label 6843: @333929
     /* 333929 */ GIM_Reject,
     /* 333930 */ // Label 6821: @333930
     /* 333930 */ GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(336758),
     /* 333935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 333938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 333941 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333948 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(334057), // Rule ID 4277 //
     /* 333953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333957 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 333963 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 333965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 333969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 333973 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333976 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 333980 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 333984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 333988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 333990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 333997 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 333997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 334004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334024 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 334046 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334056 */     // GIR_Coverage, 4277,
     /* 334056 */     GIR_EraseRootFromParent_Done,
     /* 334057 */   // Label 6875: @334057
     /* 334057 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(334166), // Rule ID 4278 //
     /* 334062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334066 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334072 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334082 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334089 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334099 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 334106 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 334106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 334113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334133 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 334155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334165 */     // GIR_Coverage, 4278,
     /* 334165 */     GIR_EraseRootFromParent_Done,
     /* 334166 */   // Label 6876: @334166
     /* 334166 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(334275), // Rule ID 4385 //
     /* 334171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334175 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334181 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334191 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334194 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334198 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334208 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 334215 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 334215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 334222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334242 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 334264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334274 */     // GIR_Coverage, 4385,
     /* 334274 */     GIR_EraseRootFromParent_Done,
     /* 334275 */   // Label 6877: @334275
     /* 334275 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(334384), // Rule ID 4386 //
     /* 334280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334284 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334290 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334300 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334307 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334317 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 334324 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 334324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 334331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334351 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 334373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334383 */     // GIR_Coverage, 4386,
     /* 334383 */     GIR_EraseRootFromParent_Done,
     /* 334384 */   // Label 6878: @334384
     /* 334384 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(334489), // Rule ID 4283 //
     /* 334389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334405 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334408 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334412 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334422 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 334429 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 334429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 334436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334456 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 334478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334488 */     // GIR_Coverage, 4283,
     /* 334488 */     GIR_EraseRootFromParent_Done,
     /* 334489 */   // Label 6879: @334489
     /* 334489 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(334594), // Rule ID 4285 //
     /* 334494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334510 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334517 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334527 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 334534 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 334534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 334541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334561 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 334583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334593 */     // GIR_Coverage, 4285,
     /* 334593 */     GIR_EraseRootFromParent_Done,
     /* 334594 */   // Label 6880: @334594
     /* 334594 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(334699), // Rule ID 4391 //
     /* 334599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334615 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334618 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334622 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334632 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 334639 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 334639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 334646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334666 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 334688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334698 */     // GIR_Coverage, 4391,
     /* 334698 */     GIR_EraseRootFromParent_Done,
     /* 334699 */   // Label 6881: @334699
     /* 334699 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(334804), // Rule ID 4393 //
     /* 334704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334720 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334727 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 334744 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 334744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 334751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334771 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 334793 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334803 */     // GIR_Coverage, 4393,
     /* 334803 */     GIR_EraseRootFromParent_Done,
     /* 334804 */   // Label 6882: @334804
     /* 334804 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(334908), // Rule ID 4275 //
     /* 334809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334813 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334819 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334829 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334836 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334846 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 334853 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 334853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 334860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334875 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 334897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334907 */     // GIR_Coverage, 4275,
     /* 334907 */     GIR_EraseRootFromParent_Done,
     /* 334908 */   // Label 6883: @334908
     /* 334908 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(335012), // Rule ID 4276 //
     /* 334913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334917 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334923 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334933 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334936 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334940 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334950 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 334957 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 334957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 334964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334979 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 335001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335011 */     // GIR_Coverage, 4276,
     /* 335011 */     GIR_EraseRootFromParent_Done,
     /* 335012 */   // Label 6884: @335012
     /* 335012 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(335116), // Rule ID 4383 //
     /* 335017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335021 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335027 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335037 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335044 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 335061 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 335061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 335068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335083 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 335105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335115 */     // GIR_Coverage, 4383,
     /* 335115 */     GIR_EraseRootFromParent_Done,
     /* 335116 */   // Label 6885: @335116
     /* 335116 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(335220), // Rule ID 4384 //
     /* 335121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335125 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335131 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335141 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335144 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335148 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 335165 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 335165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 335172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335187 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 335209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335219 */     // GIR_Coverage, 4384,
     /* 335219 */     GIR_EraseRootFromParent_Done,
     /* 335220 */   // Label 6886: @335220
     /* 335220 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(335320), // Rule ID 4279 //
     /* 335225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335241 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335244 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335248 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335258 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 335265 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 335265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 335272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335287 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 335309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335319 */     // GIR_Coverage, 4279,
     /* 335319 */     GIR_EraseRootFromParent_Done,
     /* 335320 */   // Label 6887: @335320
     /* 335320 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(335420), // Rule ID 4281 //
     /* 335325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335341 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335344 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335348 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335358 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 335365 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 335365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 335372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335387 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 335409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335419 */     // GIR_Coverage, 4281,
     /* 335419 */     GIR_EraseRootFromParent_Done,
     /* 335420 */   // Label 6888: @335420
     /* 335420 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(335520), // Rule ID 4387 //
     /* 335425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335441 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335444 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335448 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 335465 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 335465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 335472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335487 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 335509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335519 */     // GIR_Coverage, 4387,
     /* 335519 */     GIR_EraseRootFromParent_Done,
     /* 335520 */   // Label 6889: @335520
     /* 335520 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(335620), // Rule ID 4389 //
     /* 335525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335541 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335544 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335548 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335558 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 335565 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 335565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 335572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335587 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 335609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335619 */     // GIR_Coverage, 4389,
     /* 335619 */     GIR_EraseRootFromParent_Done,
     /* 335620 */   // Label 6890: @335620
     /* 335620 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(335698), // Rule ID 1934 //
     /* 335625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 335628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335661 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 335665 */     // MIs[2] Operand 1
     /* 335665 */     // No operand predicates
     /* 335665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335669 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335673 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 335677 */     // MIs[3] Operand 1
     /* 335677 */     // No operand predicates
     /* 335677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335679 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 335679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 335682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 335686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 335689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 335696 */     GIR_RootConstrainSelectedInstOperands,
     /* 335697 */     // GIR_Coverage, 1934,
     /* 335697 */     GIR_EraseRootFromParent_Done,
     /* 335698 */   // Label 6891: @335698
     /* 335698 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(335789), // Rule ID 7355 //
     /* 335703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 335706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 335718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 335722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 335726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335730 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 335733 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 335740 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 335743 */     // MIs[2] Rn
     /* 335743 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 335747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 335752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335760 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 335764 */     // MIs[3] Operand 1
     /* 335764 */     // No operand predicates
     /* 335764 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335766 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15788>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 335766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 335769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 335773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 335776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 335780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 335787 */     GIR_RootConstrainSelectedInstOperands,
     /* 335788 */     // GIR_Coverage, 7355,
     /* 335788 */     GIR_EraseRootFromParent_Done,
     /* 335789 */   // Label 6892: @335789
     /* 335789 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(335856), // Rule ID 5701 //
     /* 335794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335827 */     // MIs[2] Operand 1
     /* 335827 */     // No operand predicates
     /* 335827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335835 */     // MIs[3] Operand 1
     /* 335835 */     // No operand predicates
     /* 335835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335837 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 335837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 335840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335842 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 335847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 335854 */     GIR_RootConstrainSelectedInstOperands,
     /* 335855 */     // GIR_Coverage, 5701,
     /* 335855 */     GIR_EraseRootFromParent_Done,
     /* 335856 */   // Label 6893: @335856
     /* 335856 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(335954), // Rule ID 5702 //
     /* 335861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 335877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335894 */     // MIs[2] Operand 1
     /* 335894 */     // No operand predicates
     /* 335894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335902 */     // MIs[3] Operand 1
     /* 335902 */     // No operand predicates
     /* 335902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 335904 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 335904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 335907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335916 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 335919 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 335923 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 335926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 335939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335941 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 335943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 335946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 335952 */     GIR_RootConstrainSelectedInstOperands,
     /* 335953 */     // GIR_Coverage, 5702,
     /* 335953 */     GIR_EraseRootFromParent_Done,
     /* 335954 */   // Label 6894: @335954
     /* 335954 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(336021), // Rule ID 5725 //
     /* 335959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 335967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 335988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 335992 */     // MIs[2] Operand 1
     /* 335992 */     // No operand predicates
     /* 335992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 335996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336000 */     // MIs[3] Operand 1
     /* 336000 */     // No operand predicates
     /* 336000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336002 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 336002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 336005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336007 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 336009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 336012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 336019 */     GIR_RootConstrainSelectedInstOperands,
     /* 336020 */     // GIR_Coverage, 5725,
     /* 336020 */     GIR_EraseRootFromParent_Done,
     /* 336021 */   // Label 6895: @336021
     /* 336021 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(336119), // Rule ID 5726 //
     /* 336026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 336042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336059 */     // MIs[2] Operand 1
     /* 336059 */     // No operand predicates
     /* 336059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336067 */     // MIs[3] Operand 1
     /* 336067 */     // No operand predicates
     /* 336067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336069 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 336069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336081 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 336084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336088 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 336091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 336104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336106 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 336108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 336111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 336117 */     GIR_RootConstrainSelectedInstOperands,
     /* 336118 */     // GIR_Coverage, 5726,
     /* 336118 */     GIR_EraseRootFromParent_Done,
     /* 336119 */   // Label 6896: @336119
     /* 336119 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(336185), // Rule ID 5656 //
     /* 336124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336142 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 336142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 336145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 336166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 336169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336184 */     // GIR_Coverage, 5656,
     /* 336184 */     GIR_EraseRootFromParent_Done,
     /* 336185 */   // Label 6897: @336185
     /* 336185 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(336251), // Rule ID 5666 //
     /* 336190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336208 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 336208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 336211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 336232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 336235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336250 */     // GIR_Coverage, 5666,
     /* 336250 */     GIR_EraseRootFromParent_Done,
     /* 336251 */   // Label 6898: @336251
     /* 336251 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(336329), // Rule ID 7354 //
     /* 336256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 336259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336271 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 336274 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 336281 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 336284 */     // MIs[1] Rn
     /* 336284 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 336288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 336293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 336297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336301 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 336305 */     // MIs[2] Operand 1
     /* 336305 */     // No operand predicates
     /* 336305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336307 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15788>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 336307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 336310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 336314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 336317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336327 */     GIR_RootConstrainSelectedInstOperands,
     /* 336328 */     // GIR_Coverage, 7354,
     /* 336328 */     GIR_EraseRootFromParent_Done,
     /* 336329 */   // Label 6899: @336329
     /* 336329 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(336398), // Rule ID 6390 //
     /* 336334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336346 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336349 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 336353 */     // MIs[1] Rn
     /* 336353 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 336357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 336362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 336366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336370 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 336374 */     // MIs[2] Operand 1
     /* 336374 */     // No operand predicates
     /* 336374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336376 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 336376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 336379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 336383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 336386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336396 */     GIR_RootConstrainSelectedInstOperands,
     /* 336397 */     // GIR_Coverage, 6390,
     /* 336397 */     GIR_EraseRootFromParent_Done,
     /* 336398 */   // Label 6900: @336398
     /* 336398 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(336467), // Rule ID 6391 //
     /* 336403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336415 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336418 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 336422 */     // MIs[1] Rn
     /* 336422 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 336426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 336431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 336435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336439 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 336443 */     // MIs[2] Operand 1
     /* 336443 */     // No operand predicates
     /* 336443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336445 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 336445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 336448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 336452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 336455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336465 */     GIR_RootConstrainSelectedInstOperands,
     /* 336466 */     // GIR_Coverage, 6391,
     /* 336466 */     GIR_EraseRootFromParent_Done,
     /* 336467 */   // Label 6901: @336467
     /* 336467 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(336516), // Rule ID 5673 //
     /* 336472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 336480 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 336484 */     // MIs[1] Operand 1
     /* 336484 */     // No operand predicates
     /* 336484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 336488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336492 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 336496 */     // MIs[2] Operand 1
     /* 336496 */     // No operand predicates
     /* 336496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336498 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 336498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 336501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 336505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 336508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 336514 */     GIR_RootConstrainSelectedInstOperands,
     /* 336515 */     // GIR_Coverage, 5673,
     /* 336515 */     GIR_EraseRootFromParent_Done,
     /* 336516 */   // Label 6902: @336516
     /* 336516 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(336617), // Rule ID 5731 //
     /* 336521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 336529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 336533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 336542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336546 */     // MIs[2] Operand 1
     /* 336546 */     // No operand predicates
     /* 336546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336548 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 336548 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336551 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336555 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336574 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 336581 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 336584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 336602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336604 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 336606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 336609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336615 */     GIR_RootConstrainSelectedInstOperands,
     /* 336616 */     // GIR_Coverage, 5731,
     /* 336616 */     GIR_EraseRootFromParent_Done,
     /* 336617 */   // Label 6903: @336617
     /* 336617 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(336661), // Rule ID 1930 //
     /* 336622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 336633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 336637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 336645 */     // MIs[1] Operand 1
     /* 336645 */     // No operand predicates
     /* 336645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336647 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 336647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 336650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 336654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 336657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 336659 */     GIR_RootConstrainSelectedInstOperands,
     /* 336660 */     // GIR_Coverage, 1930,
     /* 336660 */     GIR_EraseRootFromParent_Done,
     /* 336661 */   // Label 6904: @336661
     /* 336661 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(336757), // Rule ID 5677 //
     /* 336666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 336678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 336686 */     // MIs[1] Operand 1
     /* 336686 */     // No operand predicates
     /* 336686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336688 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 336688 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 336691 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336695 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 336705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336714 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 336721 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 336724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 336742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 336746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 336749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336755 */     GIR_RootConstrainSelectedInstOperands,
     /* 336756 */     // GIR_Coverage, 5677,
     /* 336756 */     GIR_EraseRootFromParent_Done,
     /* 336757 */   // Label 6905: @336757
     /* 336757 */   GIM_Reject,
     /* 336758 */ // Label 6874: @336758
     /* 336758 */ GIM_Reject,
     /* 336759 */ // Label 6822: @336759
     /* 336759 */ GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(340398),
     /* 336764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 336767 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(336893), // Rule ID 4217 //
     /* 336772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336786 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336792 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336802 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336805 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336809 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336816 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 336833 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 336833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 336836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 336840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336860 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 336882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336892 */     // GIR_Coverage, 4217,
     /* 336892 */     GIR_EraseRootFromParent_Done,
     /* 336893 */   // Label 6907: @336893
     /* 336893 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(337019), // Rule ID 4218 //
     /* 336898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 336901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 336904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336912 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336918 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336928 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336931 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336935 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336942 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336952 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 336959 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 336959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 336962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 336966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336986 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 337008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337013 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337018 */     // GIR_Coverage, 4218,
     /* 337018 */     GIR_EraseRootFromParent_Done,
     /* 337019 */   // Label 6908: @337019
     /* 337019 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(337138), // Rule ID 4325 //
     /* 337024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 337027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337038 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337044 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337054 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337057 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337061 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337071 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 337078 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 337078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 337085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337105 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 337127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337137 */     // GIR_Coverage, 4325,
     /* 337137 */     GIR_EraseRootFromParent_Done,
     /* 337138 */   // Label 6909: @337138
     /* 337138 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(337257), // Rule ID 4326 //
     /* 337143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 337146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337157 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337163 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337173 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337176 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337180 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337190 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 337197 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 337197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 337204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337224 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 337246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337256 */     // GIR_Coverage, 4326,
     /* 337256 */     GIR_EraseRootFromParent_Done,
     /* 337257 */   // Label 6910: @337257
     /* 337257 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(337379), // Rule ID 4223 //
     /* 337262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337288 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337291 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337295 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337302 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337312 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 337319 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 337319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 337326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337346 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 337368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337378 */     // GIR_Coverage, 4223,
     /* 337378 */     GIR_EraseRootFromParent_Done,
     /* 337379 */   // Label 6911: @337379
     /* 337379 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(337501), // Rule ID 4225 //
     /* 337384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337410 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337413 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337417 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337424 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 337441 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 337441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 337448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337468 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 337490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337500 */     // GIR_Coverage, 4225,
     /* 337500 */     GIR_EraseRootFromParent_Done,
     /* 337501 */   // Label 6912: @337501
     /* 337501 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(337616), // Rule ID 4331 //
     /* 337506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 337509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337532 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337535 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337539 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 337556 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 337556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 337563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337583 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 337605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337615 */     // GIR_Coverage, 4331,
     /* 337615 */     GIR_EraseRootFromParent_Done,
     /* 337616 */   // Label 6913: @337616
     /* 337616 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(337731), // Rule ID 4333 //
     /* 337621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 337624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337647 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337650 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337654 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 337671 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 337671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 337678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337698 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 337720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337725 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337730 */     // GIR_Coverage, 4333,
     /* 337730 */     GIR_EraseRootFromParent_Done,
     /* 337731 */   // Label 6914: @337731
     /* 337731 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(337852), // Rule ID 4215 //
     /* 337736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337750 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337756 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337766 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337769 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337773 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337780 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337790 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 337797 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 337797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 337804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337819 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 337841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337851 */     // GIR_Coverage, 4215,
     /* 337851 */     GIR_EraseRootFromParent_Done,
     /* 337852 */   // Label 6915: @337852
     /* 337852 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(337973), // Rule ID 4216 //
     /* 337857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 337860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337871 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337877 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337887 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337890 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337894 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337901 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 337918 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 337918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 337925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337940 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 337962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337972 */     // GIR_Coverage, 4216,
     /* 337972 */     GIR_EraseRootFromParent_Done,
     /* 337973 */   // Label 6916: @337973
     /* 337973 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(338087), // Rule ID 4323 //
     /* 337978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 337981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337992 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337998 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338008 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338011 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338015 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338019 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338025 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 338032 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 338032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 338039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338054 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338086 */     // GIR_Coverage, 4323,
     /* 338086 */     GIR_EraseRootFromParent_Done,
     /* 338087 */   // Label 6917: @338087
     /* 338087 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(338201), // Rule ID 4324 //
     /* 338092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338106 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338112 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338122 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338125 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338129 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 338146 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 338146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 338153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338168 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338200 */     // GIR_Coverage, 4324,
     /* 338200 */     GIR_EraseRootFromParent_Done,
     /* 338201 */   // Label 6918: @338201
     /* 338201 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(338318), // Rule ID 4219 //
     /* 338206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338232 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338235 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338239 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338246 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 338263 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 338263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 338270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338285 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338317 */     // GIR_Coverage, 4219,
     /* 338317 */     GIR_EraseRootFromParent_Done,
     /* 338318 */   // Label 6919: @338318
     /* 338318 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(338435), // Rule ID 4221 //
     /* 338323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338349 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338352 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338356 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338363 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338373 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 338380 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 338380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 338387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338402 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338434 */     // GIR_Coverage, 4221,
     /* 338434 */     GIR_EraseRootFromParent_Done,
     /* 338435 */   // Label 6920: @338435
     /* 338435 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(338545), // Rule ID 4327 //
     /* 338440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338466 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338469 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338473 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338483 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 338490 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 338490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 338497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338512 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338544 */     // GIR_Coverage, 4327,
     /* 338544 */     GIR_EraseRootFromParent_Done,
     /* 338545 */   // Label 6921: @338545
     /* 338545 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(338655), // Rule ID 4329 //
     /* 338550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338576 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338583 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 338600 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 338600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 338603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 338607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338622 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 338644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338654 */     // GIR_Coverage, 4329,
     /* 338654 */     GIR_EraseRootFromParent_Done,
     /* 338655 */   // Label 6922: @338655
     /* 338655 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(338785), // Rule ID 6403 //
     /* 338660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 338663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 338666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338689 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338692 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338696 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338703 */     // MIs[2] Rn
     /* 338703 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 338707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 338712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338718 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 338718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 338721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 338739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338744 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338747 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 338750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 338754 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 338774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338784 */     // GIR_Coverage, 6403,
     /* 338784 */     GIR_EraseRootFromParent_Done,
     /* 338785 */   // Label 6923: @338785
     /* 338785 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(338925), // Rule ID 5691 //
     /* 338790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 338808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 338816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 338829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338833 */     // MIs[2] Operand 1
     /* 338833 */     // No operand predicates
     /* 338833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 338837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338841 */     // MIs[3] Operand 1
     /* 338841 */     // No operand predicates
     /* 338841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338843 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 338843 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 338846 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338850 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338855 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 338858 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 338862 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 338865 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 338882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338887 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 338893 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 338897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 338900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338907 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 338914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338924 */     // GIR_Coverage, 5691,
     /* 338924 */     GIR_EraseRootFromParent_Done,
     /* 338925 */   // Label 6924: @338925
     /* 338925 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(339096), // Rule ID 5692 //
     /* 338930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 338933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 338948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 338956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 338969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338973 */     // MIs[2] Operand 1
     /* 338973 */     // No operand predicates
     /* 338973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 338977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338981 */     // MIs[3] Operand 1
     /* 338981 */     // No operand predicates
     /* 338981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 338983 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 338983 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 338986 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338990 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338995 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 338998 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339002 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 339005 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339010 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339015 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 339018 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339022 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339027 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 339030 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 339034 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339037 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339042 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 339054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339059 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 339065 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 339071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339078 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339095 */     // GIR_Coverage, 5692,
     /* 339095 */     GIR_EraseRootFromParent_Done,
     /* 339096 */   // Label 6925: @339096
     /* 339096 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(339236), // Rule ID 5715 //
     /* 339101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 339127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339144 */     // MIs[2] Operand 1
     /* 339144 */     // No operand predicates
     /* 339144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339152 */     // MIs[3] Operand 1
     /* 339152 */     // No operand predicates
     /* 339152 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339154 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 339154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 339157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339166 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 339169 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 339173 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 339193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 339204 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 339211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339218 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339235 */     // GIR_Coverage, 5715,
     /* 339235 */     GIR_EraseRootFromParent_Done,
     /* 339236 */   // Label 6926: @339236
     /* 339236 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(339407), // Rule ID 5716 //
     /* 339241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 339267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339284 */     // MIs[2] Operand 1
     /* 339284 */     // No operand predicates
     /* 339284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339292 */     // MIs[3] Operand 1
     /* 339292 */     // No operand predicates
     /* 339292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339294 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 339294 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 339297 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339301 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339306 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 339309 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339313 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 339316 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339321 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339326 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 339329 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339333 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339338 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 339341 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 339345 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339353 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 339365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339370 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 339376 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 339382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339406 */     // GIR_Coverage, 5716,
     /* 339406 */     GIR_EraseRootFromParent_Done,
     /* 339407 */   // Label 6927: @339407
     /* 339407 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(339486), // Rule ID 5646 //
     /* 339412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 339434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339440 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 339440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 339456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 339475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339485 */     // GIR_Coverage, 5646,
     /* 339485 */     GIR_EraseRootFromParent_Done,
     /* 339486 */   // Label 6928: @339486
     /* 339486 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(339562), // Rule ID 5648 //
     /* 339491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339519 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 339519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 339522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 339543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339561 */     // GIR_Coverage, 5648,
     /* 339561 */     GIR_EraseRootFromParent_Done,
     /* 339562 */   // Label 6929: @339562
     /* 339562 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(339638), // Rule ID 5658 //
     /* 339567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339595 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 339595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 339598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 339619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 339622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339632 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339637 */     // GIR_Coverage, 5658,
     /* 339637 */     GIR_EraseRootFromParent_Done,
     /* 339638 */   // Label 6930: @339638
     /* 339638 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(339783), // Rule ID 5670 //
     /* 339643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 339665 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 339669 */     // MIs[1] Operand 1
     /* 339669 */     // No operand predicates
     /* 339669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 339673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339677 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 339681 */     // MIs[2] Operand 1
     /* 339681 */     // No operand predicates
     /* 339681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339683 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 339683 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 339686 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339690 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 339700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339709 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 339712 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 339716 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339719 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339724 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 339741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339746 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 339752 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 339758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339765 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339782 */     // GIR_Coverage, 5670,
     /* 339782 */     GIR_EraseRootFromParent_Done,
     /* 339783 */   // Label 6931: @339783
     /* 339783 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(339932), // Rule ID 6406 //
     /* 339788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 339791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339810 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339813 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 339817 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339824 */     // MIs[1] Rn
     /* 339824 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 339828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 339833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 339837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339841 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 339845 */     // MIs[2] Operand 1
     /* 339845 */     // No operand predicates
     /* 339845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339847 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 339847 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 339850 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339854 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339859 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 339862 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 339866 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 339869 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339874 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 339886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339891 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 339897 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339901 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339914 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 339921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339931 */     // GIR_Coverage, 6406,
     /* 339931 */     GIR_EraseRootFromParent_Done,
     /* 339932 */   // Label 6932: @339932
     /* 339932 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(340074), // Rule ID 6409 //
     /* 339937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 339940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 339943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339959 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 339966 */     // MIs[1] Rn
     /* 339966 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 339970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 339975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 339979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339983 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 339987 */     // MIs[2] Operand 1
     /* 339987 */     // No operand predicates
     /* 339987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339989 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 339989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 339992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340001 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 340004 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 340008 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340011 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340016 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 340028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340033 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 340039 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340043 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340056 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340073 */     // GIR_Coverage, 6409,
     /* 340073 */     GIR_EraseRootFromParent_Done,
     /* 340074 */   // Label 6933: @340074
     /* 340074 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(340262), // Rule ID 5668 //
     /* 340079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 340109 */     // MIs[1] Operand 1
     /* 340109 */     // No operand predicates
     /* 340109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340111 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 340111 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 340114 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340118 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 340125 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 340128 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340132 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340137 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 340140 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 340144 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 340147 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340152 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340157 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340162 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 340165 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340169 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340176 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 340179 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340183 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340188 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340191 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 340195 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 340220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340225 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 340231 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 340234 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 340237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340244 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340261 */     // GIR_Coverage, 5668,
     /* 340261 */     GIR_EraseRootFromParent_Done,
     /* 340262 */   // Label 6934: @340262
     /* 340262 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(340397), // Rule ID 5679 //
     /* 340267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 340297 */     // MIs[1] Operand 1
     /* 340297 */     // No operand predicates
     /* 340297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340299 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 340299 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 340302 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340306 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340313 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 340316 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340320 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340325 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 340328 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 340332 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 340335 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340340 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340345 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 340357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340362 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 340368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 340372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340379 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 340386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340396 */     // GIR_Coverage, 5679,
     /* 340396 */     GIR_EraseRootFromParent_Done,
     /* 340397 */   // Label 6935: @340397
     /* 340397 */   GIM_Reject,
     /* 340398 */ // Label 6906: @340398
     /* 340398 */ GIM_Reject,
     /* 340399 */ // Label 6823: @340399
     /* 340399 */ GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(343062),
     /* 340404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 340407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340410 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340417 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(340526), // Rule ID 4241 //
     /* 340422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340426 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340432 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340442 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340445 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340449 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340459 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 340466 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 340466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 340469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 340473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340493 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 340515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340525 */     // GIR_Coverage, 4241,
     /* 340525 */     GIR_EraseRootFromParent_Done,
     /* 340526 */   // Label 6937: @340526
     /* 340526 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(340635), // Rule ID 4242 //
     /* 340531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340535 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340541 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340551 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340554 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340558 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340568 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 340575 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 340575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 340578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 340582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340602 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 340624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340634 */     // GIR_Coverage, 4242,
     /* 340634 */     GIR_EraseRootFromParent_Done,
     /* 340635 */   // Label 6938: @340635
     /* 340635 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(340744), // Rule ID 4349 //
     /* 340640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340644 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340650 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340660 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340663 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340667 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 340684 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 340684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 340687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 340691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340711 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 340733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340743 */     // GIR_Coverage, 4349,
     /* 340743 */     GIR_EraseRootFromParent_Done,
     /* 340744 */   // Label 6939: @340744
     /* 340744 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(340853), // Rule ID 4350 //
     /* 340749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340753 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340759 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340769 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340776 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340786 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 340793 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 340793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 340796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 340800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340820 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 340842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340852 */     // GIR_Coverage, 4350,
     /* 340852 */     GIR_EraseRootFromParent_Done,
     /* 340853 */   // Label 6940: @340853
     /* 340853 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(340958), // Rule ID 4247 //
     /* 340858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340874 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340877 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340881 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 340898 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 340898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 340901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 340905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340925 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 340947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340957 */     // GIR_Coverage, 4247,
     /* 340957 */     GIR_EraseRootFromParent_Done,
     /* 340958 */   // Label 6941: @340958
     /* 340958 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(341063), // Rule ID 4249 //
     /* 340963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340979 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340986 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340996 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 341003 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 341003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 341010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341030 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 341052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341062 */     // GIR_Coverage, 4249,
     /* 341062 */     GIR_EraseRootFromParent_Done,
     /* 341063 */   // Label 6942: @341063
     /* 341063 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(341168), // Rule ID 4355 //
     /* 341068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341084 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341087 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341091 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 341108 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 341108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 341115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341135 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 341157 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341167 */     // GIR_Coverage, 4355,
     /* 341167 */     GIR_EraseRootFromParent_Done,
     /* 341168 */   // Label 6943: @341168
     /* 341168 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(341273), // Rule ID 4357 //
     /* 341173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341189 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341196 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 341213 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 341213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 341220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341240 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 341262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341272 */     // GIR_Coverage, 4357,
     /* 341272 */     GIR_EraseRootFromParent_Done,
     /* 341273 */   // Label 6944: @341273
     /* 341273 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(341377), // Rule ID 4239 //
     /* 341278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341282 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341288 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341298 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341305 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 341322 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 341322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 341329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341344 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 341366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341376 */     // GIR_Coverage, 4239,
     /* 341376 */     GIR_EraseRootFromParent_Done,
     /* 341377 */   // Label 6945: @341377
     /* 341377 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(341481), // Rule ID 4240 //
     /* 341382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341386 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341392 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341402 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341405 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341409 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 341426 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 341426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 341433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341448 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 341470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341480 */     // GIR_Coverage, 4240,
     /* 341480 */     GIR_EraseRootFromParent_Done,
     /* 341481 */   // Label 6946: @341481
     /* 341481 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(341585), // Rule ID 4347 //
     /* 341486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341490 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341496 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341506 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341513 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 341530 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 341530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 341537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341552 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 341574 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341579 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341584 */     // GIR_Coverage, 4347,
     /* 341584 */     GIR_EraseRootFromParent_Done,
     /* 341585 */   // Label 6947: @341585
     /* 341585 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(341689), // Rule ID 4348 //
     /* 341590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341594 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341600 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341610 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341613 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341617 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 341634 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 341634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 341641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341656 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 341678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341688 */     // GIR_Coverage, 4348,
     /* 341688 */     GIR_EraseRootFromParent_Done,
     /* 341689 */   // Label 6948: @341689
     /* 341689 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(341789), // Rule ID 4243 //
     /* 341694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341710 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341713 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341717 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 341734 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 341734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 341741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341756 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 341778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341788 */     // GIR_Coverage, 4243,
     /* 341788 */     GIR_EraseRootFromParent_Done,
     /* 341789 */   // Label 6949: @341789
     /* 341789 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(341889), // Rule ID 4245 //
     /* 341794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341810 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341813 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341817 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 341834 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 341834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 341841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341856 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 341878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341888 */     // GIR_Coverage, 4245,
     /* 341888 */     GIR_EraseRootFromParent_Done,
     /* 341889 */   // Label 6950: @341889
     /* 341889 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(341989), // Rule ID 4351 //
     /* 341894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341910 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341913 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341917 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341927 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 341934 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 341934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 341941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341956 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 341978 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341988 */     // GIR_Coverage, 4351,
     /* 341988 */     GIR_EraseRootFromParent_Done,
     /* 341989 */   // Label 6951: @341989
     /* 341989 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(342089), // Rule ID 4353 //
     /* 341994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342010 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342017 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342027 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 342034 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 342034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 342037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 342041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342056 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 342078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342083 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342088 */     // GIR_Coverage, 4353,
     /* 342088 */     GIR_EraseRootFromParent_Done,
     /* 342089 */   // Label 6952: @342089
     /* 342089 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(342167), // Rule ID 1933 //
     /* 342094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 342134 */     // MIs[2] Operand 1
     /* 342134 */     // No operand predicates
     /* 342134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342142 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 342146 */     // MIs[3] Operand 1
     /* 342146 */     // No operand predicates
     /* 342146 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342148 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 342148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 342151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 342158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 342165 */     GIR_RootConstrainSelectedInstOperands,
     /* 342166 */     // GIR_Coverage, 1933,
     /* 342166 */     GIR_EraseRootFromParent_Done,
     /* 342167 */   // Label 6953: @342167
     /* 342167 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(342234), // Rule ID 5695 //
     /* 342172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342205 */     // MIs[2] Operand 1
     /* 342205 */     // No operand predicates
     /* 342205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342213 */     // MIs[3] Operand 1
     /* 342213 */     // No operand predicates
     /* 342213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342215 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 342215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 342218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342220 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 342222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 342225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 342232 */     GIR_RootConstrainSelectedInstOperands,
     /* 342233 */     // GIR_Coverage, 5695,
     /* 342233 */     GIR_EraseRootFromParent_Done,
     /* 342234 */   // Label 6954: @342234
     /* 342234 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(342332), // Rule ID 5696 //
     /* 342239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342272 */     // MIs[2] Operand 1
     /* 342272 */     // No operand predicates
     /* 342272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342280 */     // MIs[3] Operand 1
     /* 342280 */     // No operand predicates
     /* 342280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342282 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 342282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342294 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 342297 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342301 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 342304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 342317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342319 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 342321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 342324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 342330 */     GIR_RootConstrainSelectedInstOperands,
     /* 342331 */     // GIR_Coverage, 5696,
     /* 342331 */     GIR_EraseRootFromParent_Done,
     /* 342332 */   // Label 6955: @342332
     /* 342332 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(342399), // Rule ID 5719 //
     /* 342337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342370 */     // MIs[2] Operand 1
     /* 342370 */     // No operand predicates
     /* 342370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342378 */     // MIs[3] Operand 1
     /* 342378 */     // No operand predicates
     /* 342378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342380 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 342380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 342383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342385 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 342387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 342390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 342397 */     GIR_RootConstrainSelectedInstOperands,
     /* 342398 */     // GIR_Coverage, 5719,
     /* 342398 */     GIR_EraseRootFromParent_Done,
     /* 342399 */   // Label 6956: @342399
     /* 342399 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(342497), // Rule ID 5720 //
     /* 342404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342437 */     // MIs[2] Operand 1
     /* 342437 */     // No operand predicates
     /* 342437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342445 */     // MIs[3] Operand 1
     /* 342445 */     // No operand predicates
     /* 342445 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342447 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 342447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342459 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 342462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342466 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 342469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 342482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342484 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 342486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 342489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 342495 */     GIR_RootConstrainSelectedInstOperands,
     /* 342496 */     // GIR_Coverage, 5720,
     /* 342496 */     GIR_EraseRootFromParent_Done,
     /* 342497 */   // Label 6957: @342497
     /* 342497 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(342563), // Rule ID 5654 //
     /* 342502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342520 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 342520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 342523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 342544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 342547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342562 */     // GIR_Coverage, 5654,
     /* 342562 */     GIR_EraseRootFromParent_Done,
     /* 342563 */   // Label 6958: @342563
     /* 342563 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(342629), // Rule ID 5662 //
     /* 342568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342586 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 342586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 342589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 342610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 342613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342618 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342628 */     // GIR_Coverage, 5662,
     /* 342628 */     GIR_EraseRootFromParent_Done,
     /* 342629 */   // Label 6959: @342629
     /* 342629 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(342682), // Rule ID 5671 //
     /* 342634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 342646 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 342650 */     // MIs[1] Operand 1
     /* 342650 */     // No operand predicates
     /* 342650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 342654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342658 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 342662 */     // MIs[2] Operand 1
     /* 342662 */     // No operand predicates
     /* 342662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342664 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 342664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 342667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 342674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 342680 */     GIR_RootConstrainSelectedInstOperands,
     /* 342681 */     // GIR_Coverage, 5671,
     /* 342681 */     GIR_EraseRootFromParent_Done,
     /* 342682 */   // Label 6960: @342682
     /* 342682 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(342751), // Rule ID 6388 //
     /* 342687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342699 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342702 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 342706 */     // MIs[1] Rn
     /* 342706 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 342710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 342715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 342719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342723 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 342727 */     // MIs[2] Operand 1
     /* 342727 */     // No operand predicates
     /* 342727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342729 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 342729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 342732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 342739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342749 */     GIR_RootConstrainSelectedInstOperands,
     /* 342750 */     // GIR_Coverage, 6388,
     /* 342750 */     GIR_EraseRootFromParent_Done,
     /* 342751 */   // Label 6961: @342751
     /* 342751 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(342820), // Rule ID 6389 //
     /* 342756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342768 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342771 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 342775 */     // MIs[1] Rn
     /* 342775 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 342779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 342784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 342788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342792 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 342796 */     // MIs[2] Operand 1
     /* 342796 */     // No operand predicates
     /* 342796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342798 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 342798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 342801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 342808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342818 */     GIR_RootConstrainSelectedInstOperands,
     /* 342819 */     // GIR_Coverage, 6389,
     /* 342819 */     GIR_EraseRootFromParent_Done,
     /* 342820 */   // Label 6962: @342820
     /* 342820 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(342921), // Rule ID 5729 //
     /* 342825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 342833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 342837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 342846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342850 */     // MIs[2] Operand 1
     /* 342850 */     // No operand predicates
     /* 342850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342852 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 342852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 342855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 342873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342878 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342881 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 342885 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 342888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 342906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342908 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 342910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 342913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342919 */     GIR_RootConstrainSelectedInstOperands,
     /* 342920 */     // GIR_Coverage, 5729,
     /* 342920 */     GIR_EraseRootFromParent_Done,
     /* 342921 */   // Label 6963: @342921
     /* 342921 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(342965), // Rule ID 1929 //
     /* 342926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 342937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 342941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 342949 */     // MIs[1] Operand 1
     /* 342949 */     // No operand predicates
     /* 342949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342951 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 342951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 342954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 342958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 342961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 342963 */     GIR_RootConstrainSelectedInstOperands,
     /* 342964 */     // GIR_Coverage, 1929,
     /* 342964 */     GIR_EraseRootFromParent_Done,
     /* 342965 */   // Label 6964: @342965
     /* 342965 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(343061), // Rule ID 5676 //
     /* 342970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 342982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 342990 */     // MIs[1] Operand 1
     /* 342990 */     // No operand predicates
     /* 342990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342992 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 342992 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 342995 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342999 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 343006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 343009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343018 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343021 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 343025 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 343028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 343046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 343050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 343053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343059 */     GIR_RootConstrainSelectedInstOperands,
     /* 343060 */     // GIR_Coverage, 5676,
     /* 343060 */     GIR_EraseRootFromParent_Done,
     /* 343061 */   // Label 6965: @343061
     /* 343061 */   GIM_Reject,
     /* 343062 */ // Label 6936: @343062
     /* 343062 */ GIM_Reject,
     /* 343063 */ // Label 6824: @343063
     /* 343063 */ GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(344906),
     /* 343068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 343071 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(343197), // Rule ID 4181 //
     /* 343076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343090 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343096 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343106 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343109 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343113 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 343120 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343130 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 343137 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 343137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 343140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 343144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343164 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 343186 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 343196 */     // GIR_Coverage, 4181,
     /* 343196 */     GIR_EraseRootFromParent_Done,
     /* 343197 */   // Label 6967: @343197
     /* 343197 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(343323), // Rule ID 4182 //
     /* 343202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343216 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343222 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343232 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343235 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343239 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 343246 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 343263 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 343263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 343266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 343270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343290 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 343312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 343322 */     // GIR_Coverage, 4182,
     /* 343322 */     GIR_EraseRootFromParent_Done,
     /* 343323 */   // Label 6968: @343323
     /* 343323 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(343445), // Rule ID 4187 //
     /* 343328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343354 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343357 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343361 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 343368 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343378 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 343385 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 343385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 343388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 343392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343412 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 343434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 343444 */     // GIR_Coverage, 4187,
     /* 343444 */     GIR_EraseRootFromParent_Done,
     /* 343445 */   // Label 6969: @343445
     /* 343445 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(343567), // Rule ID 4189 //
     /* 343450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343476 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343479 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343483 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 343490 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 343507 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 343507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 343510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 343514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 343529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 343534 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 343556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 343566 */     // GIR_Coverage, 4189,
     /* 343566 */     GIR_EraseRootFromParent_Done,
     /* 343567 */   // Label 6970: @343567
     /* 343567 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(343688), // Rule ID 4179 //
     /* 343572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343586 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343592 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343602 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343605 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343609 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 343616 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 343633 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 343633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 343636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 343640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343655 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 343677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 343687 */     // GIR_Coverage, 4179,
     /* 343687 */     GIR_EraseRootFromParent_Done,
     /* 343688 */   // Label 6971: @343688
     /* 343688 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(343809), // Rule ID 4180 //
     /* 343693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343707 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 343713 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 343715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343723 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343726 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343730 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 343737 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343747 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 343754 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 343754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 343757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 343761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343776 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 343798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343803 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 343808 */     // GIR_Coverage, 4180,
     /* 343808 */     GIR_EraseRootFromParent_Done,
     /* 343809 */   // Label 6972: @343809
     /* 343809 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(343926), // Rule ID 4183 //
     /* 343814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343840 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343843 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343847 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 343854 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 343871 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 343871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 343874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 343878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343893 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 343915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 343925 */     // GIR_Coverage, 4183,
     /* 343925 */     GIR_EraseRootFromParent_Done,
     /* 343926 */   // Label 6973: @343926
     /* 343926 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(344043), // Rule ID 4185 //
     /* 343931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343957 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343960 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343964 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 343971 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343981 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 343988 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 343988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 343991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 343995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 344010 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 344032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 344042 */     // GIR_Coverage, 4185,
     /* 344042 */     GIR_EraseRootFromParent_Done,
     /* 344043 */   // Label 6974: @344043
     /* 344043 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(344183), // Rule ID 5709 //
     /* 344048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 344070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 344074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 344078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 344087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344091 */     // MIs[2] Operand 1
     /* 344091 */     // No operand predicates
     /* 344091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 344095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344099 */     // MIs[3] Operand 1
     /* 344099 */     // No operand predicates
     /* 344099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344101 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 344101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 344104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344113 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 344116 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 344120 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344123 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344128 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 344140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344145 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 344151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 344158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344165 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344182 */     // GIR_Coverage, 5709,
     /* 344182 */     GIR_EraseRootFromParent_Done,
     /* 344183 */   // Label 6975: @344183
     /* 344183 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(344354), // Rule ID 5710 //
     /* 344188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 344210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 344214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 344218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 344227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344231 */     // MIs[2] Operand 1
     /* 344231 */     // No operand predicates
     /* 344231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 344235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344239 */     // MIs[3] Operand 1
     /* 344239 */     // No operand predicates
     /* 344239 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 344241 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 344241 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 344244 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344248 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344253 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 344256 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344260 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 344263 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344268 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344273 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 344276 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344280 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344285 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 344288 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 344292 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344295 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344300 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 344312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344317 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 344323 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 344326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 344329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344336 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344353 */     // GIR_Coverage, 5710,
     /* 344353 */     GIR_EraseRootFromParent_Done,
     /* 344354 */   // Label 6976: @344354
     /* 344354 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(344433), // Rule ID 5641 //
     /* 344359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344387 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 344387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344399 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 344403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344432 */     // GIR_Coverage, 5641,
     /* 344432 */     GIR_EraseRootFromParent_Done,
     /* 344433 */   // Label 6977: @344433
     /* 344433 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(344582), // Rule ID 6405 //
     /* 344438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344460 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344463 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 344467 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 344474 */     // MIs[1] Rn
     /* 344474 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 344478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 344483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 344487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344491 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 344495 */     // MIs[2] Operand 1
     /* 344495 */     // No operand predicates
     /* 344495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344497 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 344497 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 344500 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344504 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344509 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 344512 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 344516 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344519 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344524 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 344536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344541 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 344547 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344551 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344564 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344581 */     // GIR_Coverage, 6405,
     /* 344581 */     GIR_EraseRootFromParent_Done,
     /* 344582 */   // Label 6978: @344582
     /* 344582 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(344717), // Rule ID 5680 //
     /* 344587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 344609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 344617 */     // MIs[1] Operand 1
     /* 344617 */     // No operand predicates
     /* 344617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344619 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 344619 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 344622 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344626 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344633 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 344636 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344640 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344645 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 344648 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 344652 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344655 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344665 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 344677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344682 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 344688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 344692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344699 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344716 */     // GIR_Coverage, 5680,
     /* 344716 */     GIR_EraseRootFromParent_Done,
     /* 344717 */   // Label 6979: @344717
     /* 344717 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(344905), // Rule ID 5681 //
     /* 344722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 344725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 344740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 344744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 344752 */     // MIs[1] Operand 1
     /* 344752 */     // No operand predicates
     /* 344752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344754 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 344754 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 344757 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344761 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 344768 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 344771 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344775 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344780 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 344783 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 344787 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 344790 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344795 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344800 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 344805 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 344808 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344812 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344819 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 344822 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344826 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344831 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 344834 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 344838 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344841 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344846 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344851 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 344863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344868 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 344874 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 344877 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 344880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344887 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344894 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344904 */     // GIR_Coverage, 5681,
     /* 344904 */     GIR_EraseRootFromParent_Done,
     /* 344905 */   // Label 6980: @344905
     /* 344905 */   GIM_Reject,
     /* 344906 */ // Label 6966: @344906
     /* 344906 */ GIM_Reject,
     /* 344907 */ // Label 6825: @344907
     /* 344907 */ GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(347881),
     /* 344912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344915 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(345041), // Rule ID 4205 //
     /* 344920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344934 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344940 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344950 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344953 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344957 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 344964 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344974 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 344981 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 344981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 344984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 344988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345008 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345030 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345040 */     // GIR_Coverage, 4205,
     /* 345040 */     GIR_EraseRootFromParent_Done,
     /* 345041 */   // Label 6982: @345041
     /* 345041 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(345167), // Rule ID 4206 //
     /* 345046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345060 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345066 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345076 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345079 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345083 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 345090 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345100 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 345107 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 345107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 345114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345134 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345166 */     // GIR_Coverage, 4206,
     /* 345166 */     GIR_EraseRootFromParent_Done,
     /* 345167 */   // Label 6983: @345167
     /* 345167 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(345286), // Rule ID 4313 //
     /* 345172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345186 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345192 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345202 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345209 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 345226 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 345226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 345233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345253 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345285 */     // GIR_Coverage, 4313,
     /* 345285 */     GIR_EraseRootFromParent_Done,
     /* 345286 */   // Label 6984: @345286
     /* 345286 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(345405), // Rule ID 4314 //
     /* 345291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345305 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345311 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345321 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345324 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345328 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345338 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 345345 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 345345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 345352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345372 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345404 */     // GIR_Coverage, 4314,
     /* 345404 */     GIR_EraseRootFromParent_Done,
     /* 345405 */   // Label 6985: @345405
     /* 345405 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(345527), // Rule ID 4211 //
     /* 345410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345436 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345439 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345443 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 345450 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345460 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 345467 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 345467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 345474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345494 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345526 */     // GIR_Coverage, 4211,
     /* 345526 */     GIR_EraseRootFromParent_Done,
     /* 345527 */   // Label 6986: @345527
     /* 345527 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(345649), // Rule ID 4213 //
     /* 345532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345558 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345561 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345565 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 345572 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345582 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 345589 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 345589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 345596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345616 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345648 */     // GIR_Coverage, 4213,
     /* 345648 */     GIR_EraseRootFromParent_Done,
     /* 345649 */   // Label 6987: @345649
     /* 345649 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(345764), // Rule ID 4319 //
     /* 345654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345680 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345687 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 345704 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 345704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 345711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345731 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345763 */     // GIR_Coverage, 4319,
     /* 345763 */     GIR_EraseRootFromParent_Done,
     /* 345764 */   // Label 6988: @345764
     /* 345764 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(345879), // Rule ID 4321 //
     /* 345769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 345772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345795 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345802 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 345819 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 345819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 345826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345846 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345878 */     // GIR_Coverage, 4321,
     /* 345878 */     GIR_EraseRootFromParent_Done,
     /* 345879 */   // Label 6989: @345879
     /* 345879 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(346000), // Rule ID 4203 //
     /* 345884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 345890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345898 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345904 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345914 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345917 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345921 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 345928 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345938 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 345945 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 345945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 345948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 345952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345967 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 345989 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345999 */     // GIR_Coverage, 4203,
     /* 345999 */     GIR_EraseRootFromParent_Done,
     /* 346000 */   // Label 6990: @346000
     /* 346000 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(346121), // Rule ID 4204 //
     /* 346005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346019 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346025 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346035 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346038 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346042 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 346049 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 346066 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 346066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 346073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346088 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346120 */     // GIR_Coverage, 4204,
     /* 346120 */     GIR_EraseRootFromParent_Done,
     /* 346121 */   // Label 6991: @346121
     /* 346121 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(346235), // Rule ID 4311 //
     /* 346126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346140 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346146 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346156 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346159 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346163 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346173 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 346180 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 346180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 346187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346202 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346234 */     // GIR_Coverage, 4311,
     /* 346234 */     GIR_EraseRootFromParent_Done,
     /* 346235 */   // Label 6992: @346235
     /* 346235 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(346349), // Rule ID 4312 //
     /* 346240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346254 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346260 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346270 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346273 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346277 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 346294 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 346294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 346301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346316 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346348 */     // GIR_Coverage, 4312,
     /* 346348 */     GIR_EraseRootFromParent_Done,
     /* 346349 */   // Label 6993: @346349
     /* 346349 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(346466), // Rule ID 4207 //
     /* 346354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346380 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346383 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346387 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 346394 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 346411 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 346411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 346418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346433 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346465 */     // GIR_Coverage, 4207,
     /* 346465 */     GIR_EraseRootFromParent_Done,
     /* 346466 */   // Label 6994: @346466
     /* 346466 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(346583), // Rule ID 4209 //
     /* 346471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346497 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346500 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346504 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 346511 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346519 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346521 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 346528 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 346528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 346535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346550 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346582 */     // GIR_Coverage, 4209,
     /* 346582 */     GIR_EraseRootFromParent_Done,
     /* 346583 */   // Label 6995: @346583
     /* 346583 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(346693), // Rule ID 4315 //
     /* 346588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346614 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346617 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346621 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 346638 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 346638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 346645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346660 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346692 */     // GIR_Coverage, 4315,
     /* 346692 */     GIR_EraseRootFromParent_Done,
     /* 346693 */   // Label 6996: @346693
     /* 346693 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(346803), // Rule ID 4317 //
     /* 346698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346724 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346731 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346741 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 346748 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 346748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 346751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 346755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346770 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 346792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 346802 */     // GIR_Coverage, 4317,
     /* 346802 */     GIR_EraseRootFromParent_Done,
     /* 346803 */   // Label 6997: @346803
     /* 346803 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(346891), // Rule ID 1932 //
     /* 346808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346854 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 346858 */     // MIs[2] Operand 1
     /* 346858 */     // No operand predicates
     /* 346858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346866 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 346870 */     // MIs[3] Operand 1
     /* 346870 */     // No operand predicates
     /* 346870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346872 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 346872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 346875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 346879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 346882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 346889 */     GIR_RootConstrainSelectedInstOperands,
     /* 346890 */     // GIR_Coverage, 1932,
     /* 346890 */     GIR_EraseRootFromParent_Done,
     /* 346891 */   // Label 6998: @346891
     /* 346891 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(346968), // Rule ID 5689 //
     /* 346896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346939 */     // MIs[2] Operand 1
     /* 346939 */     // No operand predicates
     /* 346939 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346943 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346947 */     // MIs[3] Operand 1
     /* 346947 */     // No operand predicates
     /* 346947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346949 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 346949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 346952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346954 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 346959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 346966 */     GIR_RootConstrainSelectedInstOperands,
     /* 346967 */     // GIR_Coverage, 5689,
     /* 346967 */     GIR_EraseRootFromParent_Done,
     /* 346968 */   // Label 6999: @346968
     /* 346968 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(347076), // Rule ID 5690 //
     /* 346973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 346976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 346979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 347003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 347012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347016 */     // MIs[2] Operand 1
     /* 347016 */     // No operand predicates
     /* 347016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 347020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347024 */     // MIs[3] Operand 1
     /* 347024 */     // No operand predicates
     /* 347024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347026 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 347026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347038 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 347041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347045 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 347048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 347061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347063 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 347065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 347068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 347074 */     GIR_RootConstrainSelectedInstOperands,
     /* 347075 */     // GIR_Coverage, 5690,
     /* 347075 */     GIR_EraseRootFromParent_Done,
     /* 347076 */   // Label 7000: @347076
     /* 347076 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(347153), // Rule ID 5713 //
     /* 347081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 347103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 347111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 347120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347124 */     // MIs[2] Operand 1
     /* 347124 */     // No operand predicates
     /* 347124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 347128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347132 */     // MIs[3] Operand 1
     /* 347132 */     // No operand predicates
     /* 347132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347134 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 347134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 347137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347139 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 347141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 347144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 347151 */     GIR_RootConstrainSelectedInstOperands,
     /* 347152 */     // GIR_Coverage, 5713,
     /* 347152 */     GIR_EraseRootFromParent_Done,
     /* 347153 */   // Label 7001: @347153
     /* 347153 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(347261), // Rule ID 5714 //
     /* 347158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 347180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 347188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 347197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347201 */     // MIs[2] Operand 1
     /* 347201 */     // No operand predicates
     /* 347201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 347205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347209 */     // MIs[3] Operand 1
     /* 347209 */     // No operand predicates
     /* 347209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347211 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 347211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347223 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 347226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 347233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 347246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347248 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 347250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 347253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 347259 */     GIR_RootConstrainSelectedInstOperands,
     /* 347260 */     // GIR_Coverage, 5714,
     /* 347260 */     GIR_EraseRootFromParent_Done,
     /* 347261 */   // Label 7002: @347261
     /* 347261 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(347340), // Rule ID 5644 //
     /* 347266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347294 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 347294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 347297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 347310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347339 */     // GIR_Coverage, 5644,
     /* 347339 */     GIR_EraseRootFromParent_Done,
     /* 347340 */   // Label 7003: @347340
     /* 347340 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(347416), // Rule ID 5650 //
     /* 347345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347373 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 347373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 347376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 347397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347410 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347415 */     // GIR_Coverage, 5650,
     /* 347415 */     GIR_EraseRootFromParent_Done,
     /* 347416 */   // Label 7004: @347416
     /* 347416 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(347492), // Rule ID 5660 //
     /* 347421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347449 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 347449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 347452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 347473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 347476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347491 */     // GIR_Coverage, 5660,
     /* 347491 */     GIR_EraseRootFromParent_Done,
     /* 347492 */   // Label 7005: @347492
     /* 347492 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(347555), // Rule ID 5669 //
     /* 347497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 347519 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 347523 */     // MIs[1] Operand 1
     /* 347523 */     // No operand predicates
     /* 347523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347531 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 347535 */     // MIs[2] Operand 1
     /* 347535 */     // No operand predicates
     /* 347535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347537 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 347537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 347540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 347547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 347553 */     GIR_RootConstrainSelectedInstOperands,
     /* 347554 */     // GIR_Coverage, 5669,
     /* 347554 */     GIR_EraseRootFromParent_Done,
     /* 347555 */   // Label 7006: @347555
     /* 347555 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(347641), // Rule ID 6387 //
     /* 347560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347585 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 347589 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 347596 */     // MIs[1] Rn
     /* 347596 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 347600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 347605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347613 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 347617 */     // MIs[2] Operand 1
     /* 347617 */     // No operand predicates
     /* 347617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347619 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 347619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 347622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347624 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 347626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 347629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347639 */     GIR_RootConstrainSelectedInstOperands,
     /* 347640 */     // GIR_Coverage, 6387,
     /* 347640 */     GIR_EraseRootFromParent_Done,
     /* 347641 */   // Label 7007: @347641
     /* 347641 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(347720), // Rule ID 6392 //
     /* 347646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347668 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347671 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 347675 */     // MIs[1] Rn
     /* 347675 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 347679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 347684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347692 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 347696 */     // MIs[2] Operand 1
     /* 347696 */     // No operand predicates
     /* 347696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347698 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 347698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 347701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 347705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 347708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347718 */     GIR_RootConstrainSelectedInstOperands,
     /* 347719 */     // GIR_Coverage, 6392,
     /* 347719 */     GIR_EraseRootFromParent_Done,
     /* 347720 */   // Label 7008: @347720
     /* 347720 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(347774), // Rule ID 1928 //
     /* 347725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 347750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 347758 */     // MIs[1] Operand 1
     /* 347758 */     // No operand predicates
     /* 347758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347760 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 347760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 347763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 347767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 347770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 347772 */     GIR_RootConstrainSelectedInstOperands,
     /* 347773 */     // GIR_Coverage, 1928,
     /* 347773 */     GIR_EraseRootFromParent_Done,
     /* 347774 */   // Label 7009: @347774
     /* 347774 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(347880), // Rule ID 5674 //
     /* 347779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 347782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 347801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 347809 */     // MIs[1] Operand 1
     /* 347809 */     // No operand predicates
     /* 347809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347811 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 347811 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 347814 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347818 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 347825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 347828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347837 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347840 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 347844 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 347847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 347862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 347865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 347872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347878 */     GIR_RootConstrainSelectedInstOperands,
     /* 347879 */     // GIR_Coverage, 5674,
     /* 347879 */     GIR_EraseRootFromParent_Done,
     /* 347880 */   // Label 7010: @347880
     /* 347880 */   GIM_Reject,
     /* 347881 */ // Label 6981: @347881
     /* 347881 */ GIM_Reject,
     /* 347882 */ // Label 6826: @347882
     /* 347882 */ GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(349461),
     /* 347887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 347890 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(348016), // Rule ID 4169 //
     /* 347895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347909 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347915 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347925 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347928 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347932 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347939 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347949 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 347956 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 347956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 347963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347983 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348005 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348015 */     // GIR_Coverage, 4169,
     /* 348015 */     GIR_EraseRootFromParent_Done,
     /* 348016 */   // Label 7012: @348016
     /* 348016 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(348142), // Rule ID 4170 //
     /* 348021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348035 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348041 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348051 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348054 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348058 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348065 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348075 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 348082 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 348082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 348089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348109 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348141 */     // GIR_Coverage, 4170,
     /* 348141 */     GIR_EraseRootFromParent_Done,
     /* 348142 */   // Label 7013: @348142
     /* 348142 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(348264), // Rule ID 4175 //
     /* 348147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348173 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348176 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348180 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348187 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348197 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 348204 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 348204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 348211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348231 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348263 */     // GIR_Coverage, 4175,
     /* 348263 */     GIR_EraseRootFromParent_Done,
     /* 348264 */   // Label 7014: @348264
     /* 348264 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(348386), // Rule ID 4177 //
     /* 348269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348295 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348298 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348302 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348309 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348319 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 348326 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 348326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 348333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348353 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348385 */     // GIR_Coverage, 4177,
     /* 348385 */     GIR_EraseRootFromParent_Done,
     /* 348386 */   // Label 7015: @348386
     /* 348386 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(348507), // Rule ID 4167 //
     /* 348391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348405 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348411 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348421 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348424 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348428 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348435 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 348452 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 348452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 348459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348474 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348496 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348501 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348506 */     // GIR_Coverage, 4167,
     /* 348506 */     GIR_EraseRootFromParent_Done,
     /* 348507 */   // Label 7016: @348507
     /* 348507 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(348628), // Rule ID 4168 //
     /* 348512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348526 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348532 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348542 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348545 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348549 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348556 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 348573 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 348573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 348580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348595 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348627 */     // GIR_Coverage, 4168,
     /* 348627 */     GIR_EraseRootFromParent_Done,
     /* 348628 */   // Label 7017: @348628
     /* 348628 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(348745), // Rule ID 4171 //
     /* 348633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348659 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348662 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348666 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348673 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348683 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 348690 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 348690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 348697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348712 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348744 */     // GIR_Coverage, 4171,
     /* 348744 */     GIR_EraseRootFromParent_Done,
     /* 348745 */   // Label 7018: @348745
     /* 348745 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(348862), // Rule ID 4173 //
     /* 348750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348776 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348779 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348783 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348790 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 348807 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 348807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 348814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348829 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348861 */     // GIR_Coverage, 4173,
     /* 348861 */     GIR_EraseRootFromParent_Done,
     /* 348862 */   // Label 7019: @348862
     /* 348862 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(348950), // Rule ID 1931 //
     /* 348867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 348896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 348900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348913 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 348917 */     // MIs[2] Operand 1
     /* 348917 */     // No operand predicates
     /* 348917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 348921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348925 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 348929 */     // MIs[3] Operand 1
     /* 348929 */     // No operand predicates
     /* 348929 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348931 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 348931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 348934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 348938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 348941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 348948 */     GIR_RootConstrainSelectedInstOperands,
     /* 348949 */     // GIR_Coverage, 1931,
     /* 348949 */     GIR_EraseRootFromParent_Done,
     /* 348950 */   // Label 7020: @348950
     /* 348950 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(349027), // Rule ID 5707 //
     /* 348955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 348981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 348985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348998 */     // MIs[2] Operand 1
     /* 348998 */     // No operand predicates
     /* 348998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 349002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349006 */     // MIs[3] Operand 1
     /* 349006 */     // No operand predicates
     /* 349006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349008 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 349008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 349011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349013 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 349015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 349018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 349022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 349025 */     GIR_RootConstrainSelectedInstOperands,
     /* 349026 */     // GIR_Coverage, 5707,
     /* 349026 */     GIR_EraseRootFromParent_Done,
     /* 349027 */   // Label 7021: @349027
     /* 349027 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(349135), // Rule ID 5708 //
     /* 349032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 349050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 349054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 349062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 349071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349075 */     // MIs[2] Operand 1
     /* 349075 */     // No operand predicates
     /* 349075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 349079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349083 */     // MIs[3] Operand 1
     /* 349083 */     // No operand predicates
     /* 349083 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 349085 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 349085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349097 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 349100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 349104 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 349107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 349120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349122 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 349124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 349127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 349133 */     GIR_RootConstrainSelectedInstOperands,
     /* 349134 */     // GIR_Coverage, 5708,
     /* 349134 */     GIR_EraseRootFromParent_Done,
     /* 349135 */   // Label 7022: @349135
     /* 349135 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(349214), // Rule ID 5639 //
     /* 349140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349168 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 349168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 349171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349180 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 349184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 349203 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349213 */     // GIR_Coverage, 5639,
     /* 349213 */     GIR_EraseRootFromParent_Done,
     /* 349214 */   // Label 7023: @349214
     /* 349214 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(349300), // Rule ID 6386 //
     /* 349219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 349237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349241 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349244 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 349248 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 349255 */     // MIs[1] Rn
     /* 349255 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 349259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 349264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 349268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349272 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 349276 */     // MIs[2] Operand 1
     /* 349276 */     // No operand predicates
     /* 349276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349278 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 349278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 349281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 349285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 349288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 349292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349298 */     GIR_RootConstrainSelectedInstOperands,
     /* 349299 */     // GIR_Coverage, 6386,
     /* 349299 */     GIR_EraseRootFromParent_Done,
     /* 349300 */   // Label 7024: @349300
     /* 349300 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(349354), // Rule ID 1927 //
     /* 349305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 349308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 349330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 349338 */     // MIs[1] Operand 1
     /* 349338 */     // No operand predicates
     /* 349338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349340 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 349340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 349343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 349347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 349350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 349352 */     GIR_RootConstrainSelectedInstOperands,
     /* 349353 */     // GIR_Coverage, 1927,
     /* 349353 */     GIR_EraseRootFromParent_Done,
     /* 349354 */   // Label 7025: @349354
     /* 349354 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(349460), // Rule ID 5682 //
     /* 349359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 349362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 349381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 349389 */     // MIs[1] Operand 1
     /* 349389 */     // No operand predicates
     /* 349389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349391 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 349391 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 349394 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 349398 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 349408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 349412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349417 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349420 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 349424 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 349427 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 349445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 349449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 349452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349458 */     GIR_RootConstrainSelectedInstOperands,
     /* 349459 */     // GIR_Coverage, 5682,
     /* 349459 */     GIR_EraseRootFromParent_Done,
     /* 349460 */   // Label 7026: @349460
     /* 349460 */   GIM_Reject,
     /* 349461 */ // Label 7011: @349461
     /* 349461 */ GIM_Reject,
     /* 349462 */ // Label 6827: @349462
     /* 349462 */ GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(349586), // Rule ID 11111 //
     /* 349467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 349473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349476 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349487 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349491 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 349491 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 349494 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 349498 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349503 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 349507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 349509 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 349512 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 349516 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349521 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 349524 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 349527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349529 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349532 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 349536 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349541 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 349544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 349553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349558 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349561 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 349564 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 349567 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 349570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 349575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 349577 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 349579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349582 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 349584 */   GIR_RootConstrainSelectedInstOperands,
     /* 349585 */   // GIR_Coverage, 11111,
     /* 349585 */   GIR_EraseRootFromParent_Done,
     /* 349586 */ // Label 7027: @349586
     /* 349586 */ GIM_Reject,
     /* 349587 */ // Label 6828: @349587
     /* 349587 */ GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(349711), // Rule ID 11114 //
     /* 349592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 349598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349601 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 349612 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 349616 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 349616 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 349619 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 349623 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349628 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 349632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 349634 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 349637 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 349641 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349646 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 349649 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 349652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349654 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349657 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 349661 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349666 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 349669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349671 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349674 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 349678 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349683 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349686 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 349689 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 349692 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 349695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 349700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 349702 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 349704 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349707 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 349709 */   GIR_RootConstrainSelectedInstOperands,
     /* 349710 */   // GIR_Coverage, 11114,
     /* 349710 */   GIR_EraseRootFromParent_Done,
     /* 349711 */ // Label 7028: @349711
     /* 349711 */ GIM_Reject,
     /* 349712 */ // Label 6829: @349712
     /* 349712 */ GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(351625),
     /* 349717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 349720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 349723 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349730 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(349839), // Rule ID 4301 //
     /* 349735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349739 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349745 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349755 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349758 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349762 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349772 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 349779 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 349779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 349782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 349786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349806 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 349828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349838 */     // GIR_Coverage, 4301,
     /* 349838 */     GIR_EraseRootFromParent_Done,
     /* 349839 */   // Label 7030: @349839
     /* 349839 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(349948), // Rule ID 4302 //
     /* 349844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349848 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349854 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349864 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349871 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349881 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 349888 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 349888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 349891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 349895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349915 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 349937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 349942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349947 */     // GIR_Coverage, 4302,
     /* 349947 */     GIR_EraseRootFromParent_Done,
     /* 349948 */   // Label 7031: @349948
     /* 349948 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(350057), // Rule ID 4409 //
     /* 349953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349957 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349963 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349973 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349976 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349980 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 349997 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 349997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 350000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 350004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350024 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 350046 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350056 */     // GIR_Coverage, 4409,
     /* 350056 */     GIR_EraseRootFromParent_Done,
     /* 350057 */   // Label 7032: @350057
     /* 350057 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(350166), // Rule ID 4410 //
     /* 350062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350066 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350072 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350082 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350089 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350099 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 350106 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 350106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 350109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 350113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350133 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 350155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350165 */     // GIR_Coverage, 4410,
     /* 350165 */     GIR_EraseRootFromParent_Done,
     /* 350166 */   // Label 7033: @350166
     /* 350166 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(350271), // Rule ID 4307 //
     /* 350171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350187 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350194 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350204 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 350211 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 350211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 350214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 350218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350238 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 350260 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350265 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350270 */     // GIR_Coverage, 4307,
     /* 350270 */     GIR_EraseRootFromParent_Done,
     /* 350271 */   // Label 7034: @350271
     /* 350271 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(350376), // Rule ID 4309 //
     /* 350276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350292 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350299 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350309 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 350316 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 350316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 350319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 350323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350343 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 350365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350375 */     // GIR_Coverage, 4309,
     /* 350375 */     GIR_EraseRootFromParent_Done,
     /* 350376 */   // Label 7035: @350376
     /* 350376 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(350481), // Rule ID 4415 //
     /* 350381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350397 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350400 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350404 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 350421 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 350421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 350424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 350428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350448 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 350470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350480 */     // GIR_Coverage, 4415,
     /* 350480 */     GIR_EraseRootFromParent_Done,
     /* 350481 */   // Label 7036: @350481
     /* 350481 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(350586), // Rule ID 4417 //
     /* 350486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350502 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350505 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350509 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350519 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 350526 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 350526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 350529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 350533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350553 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 350575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350585 */     // GIR_Coverage, 4417,
     /* 350585 */     GIR_EraseRootFromParent_Done,
     /* 350586 */   // Label 7037: @350586
     /* 350586 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(350690), // Rule ID 4299 //
     /* 350591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350595 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350601 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350611 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350614 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350618 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350628 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 350635 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 350635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 350638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 350642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350657 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 350679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350689 */     // GIR_Coverage, 4299,
     /* 350689 */     GIR_EraseRootFromParent_Done,
     /* 350690 */   // Label 7038: @350690
     /* 350690 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(350794), // Rule ID 4300 //
     /* 350695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350699 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350705 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350715 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350718 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350722 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 350739 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 350739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 350742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 350746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350761 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 350783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350793 */     // GIR_Coverage, 4300,
     /* 350793 */     GIR_EraseRootFromParent_Done,
     /* 350794 */   // Label 7039: @350794
     /* 350794 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(350898), // Rule ID 4407 //
     /* 350799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350803 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350809 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350819 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350822 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350826 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350836 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 350843 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 350843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 350846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 350850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350865 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 350887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350897 */     // GIR_Coverage, 4407,
     /* 350897 */     GIR_EraseRootFromParent_Done,
     /* 350898 */   // Label 7040: @350898
     /* 350898 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(351002), // Rule ID 4408 //
     /* 350903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350907 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350913 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350923 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350926 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350930 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350940 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 350947 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 350947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 350950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 350954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350969 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 350991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 350996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351001 */     // GIR_Coverage, 4408,
     /* 351001 */     GIR_EraseRootFromParent_Done,
     /* 351002 */   // Label 7041: @351002
     /* 351002 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(351102), // Rule ID 4303 //
     /* 351007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351023 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351030 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351040 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 351047 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 351047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 351050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 351054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351069 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 351091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351101 */     // GIR_Coverage, 4303,
     /* 351101 */     GIR_EraseRootFromParent_Done,
     /* 351102 */   // Label 7042: @351102
     /* 351102 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(351202), // Rule ID 4305 //
     /* 351107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351123 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351126 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351130 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351140 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 351147 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 351147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 351150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 351154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351169 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 351191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351201 */     // GIR_Coverage, 4305,
     /* 351201 */     GIR_EraseRootFromParent_Done,
     /* 351202 */   // Label 7043: @351202
     /* 351202 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(351302), // Rule ID 4411 //
     /* 351207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351223 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351230 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 351247 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 351247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 351250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 351254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351269 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 351291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351301 */     // GIR_Coverage, 4411,
     /* 351301 */     GIR_EraseRootFromParent_Done,
     /* 351302 */   // Label 7044: @351302
     /* 351302 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(351402), // Rule ID 4413 //
     /* 351307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351323 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351326 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351330 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 351347 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 351347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 351350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 351354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351369 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 351391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351401 */     // GIR_Coverage, 4413,
     /* 351401 */     GIR_EraseRootFromParent_Done,
     /* 351402 */   // Label 7045: @351402
     /* 351402 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(351513), // Rule ID 11110 //
     /* 351407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351418 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 351418 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 351421 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 351425 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351430 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 351434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 351436 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 351439 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 351443 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351448 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 351451 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 351454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351456 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351459 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 351463 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351468 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 351471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 351480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351485 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351488 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 351491 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 351494 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 351497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 351502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351504 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 351506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351509 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 351511 */     GIR_RootConstrainSelectedInstOperands,
     /* 351512 */     // GIR_Coverage, 11110,
     /* 351512 */     GIR_EraseRootFromParent_Done,
     /* 351513 */   // Label 7046: @351513
     /* 351513 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(351624), // Rule ID 11116 //
     /* 351518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351529 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 351529 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 351532 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 351536 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351541 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 351545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 351547 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 351550 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 351554 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351559 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 351562 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 351565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351567 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351570 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 351574 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351579 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 351582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 351591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351596 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351599 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 351602 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 351605 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 351608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 351613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351615 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 351617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351620 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 351622 */     GIR_RootConstrainSelectedInstOperands,
     /* 351623 */     // GIR_Coverage, 11116,
     /* 351623 */     GIR_EraseRootFromParent_Done,
     /* 351624 */   // Label 7047: @351624
     /* 351624 */   GIM_Reject,
     /* 351625 */ // Label 7029: @351625
     /* 351625 */ GIM_Reject,
     /* 351626 */ // Label 6830: @351626
     /* 351626 */ GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(351777), // Rule ID 11112 //
     /* 351631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 351637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351640 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351651 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351655 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 351655 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 351658 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351662 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351667 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 351673 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351678 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 351683 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 351686 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 351690 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351695 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 351698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 351700 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 351703 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 351707 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351712 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 351715 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 351718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351720 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351723 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 351727 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351732 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 351735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 351744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351749 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351752 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 351755 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 351758 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 351761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 351766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 351768 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 351770 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351773 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 351775 */   GIR_RootConstrainSelectedInstOperands,
     /* 351776 */   // GIR_Coverage, 11112,
     /* 351776 */   GIR_EraseRootFromParent_Done,
     /* 351777 */ // Label 7048: @351777
     /* 351777 */ GIM_Reject,
     /* 351778 */ // Label 6831: @351778
     /* 351778 */ GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(353745),
     /* 351783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 351786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351789 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351796 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(351905), // Rule ID 4265 //
     /* 351801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351805 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351811 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351821 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351824 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351828 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351838 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 351845 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 351845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 351848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 351852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351872 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 351894 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 351899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351904 */     // GIR_Coverage, 4265,
     /* 351904 */     GIR_EraseRootFromParent_Done,
     /* 351905 */   // Label 7050: @351905
     /* 351905 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(352014), // Rule ID 4266 //
     /* 351910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351914 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351920 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351930 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351933 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351937 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351947 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 351954 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 351954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 351957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 351961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351981 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 352003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352013 */     // GIR_Coverage, 4266,
     /* 352013 */     GIR_EraseRootFromParent_Done,
     /* 352014 */   // Label 7051: @352014
     /* 352014 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(352123), // Rule ID 4373 //
     /* 352019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352023 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352029 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352039 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352042 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352046 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 352063 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 352063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 352066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 352070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352090 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 352112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352122 */     // GIR_Coverage, 4373,
     /* 352122 */     GIR_EraseRootFromParent_Done,
     /* 352123 */   // Label 7052: @352123
     /* 352123 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(352232), // Rule ID 4374 //
     /* 352128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352132 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352138 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352148 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352151 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352155 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352165 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 352172 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 352172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 352175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 352179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352199 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 352221 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352231 */     // GIR_Coverage, 4374,
     /* 352231 */     GIR_EraseRootFromParent_Done,
     /* 352232 */   // Label 7053: @352232
     /* 352232 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(352337), // Rule ID 4271 //
     /* 352237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352253 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352260 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352270 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 352277 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 352277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 352280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 352284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352304 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 352326 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352336 */     // GIR_Coverage, 4271,
     /* 352336 */     GIR_EraseRootFromParent_Done,
     /* 352337 */   // Label 7054: @352337
     /* 352337 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(352442), // Rule ID 4273 //
     /* 352342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352358 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352361 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352365 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352375 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 352382 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 352382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 352385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 352389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352409 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 352431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352441 */     // GIR_Coverage, 4273,
     /* 352441 */     GIR_EraseRootFromParent_Done,
     /* 352442 */   // Label 7055: @352442
     /* 352442 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(352547), // Rule ID 4379 //
     /* 352447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352463 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352466 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352470 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352474 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352480 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 352487 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 352487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 352490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 352494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352514 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 352536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352546 */     // GIR_Coverage, 4379,
     /* 352546 */     GIR_EraseRootFromParent_Done,
     /* 352547 */   // Label 7056: @352547
     /* 352547 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(352652), // Rule ID 4381 //
     /* 352552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352568 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352575 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352585 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 352592 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 352592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 352595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 352599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352619 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 352641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352651 */     // GIR_Coverage, 4381,
     /* 352651 */     GIR_EraseRootFromParent_Done,
     /* 352652 */   // Label 7057: @352652
     /* 352652 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(352756), // Rule ID 4263 //
     /* 352657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352661 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352667 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352677 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352680 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352684 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 352701 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 352701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 352704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 352708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352723 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 352745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352755 */     // GIR_Coverage, 4263,
     /* 352755 */     GIR_EraseRootFromParent_Done,
     /* 352756 */   // Label 7058: @352756
     /* 352756 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(352860), // Rule ID 4264 //
     /* 352761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352765 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352771 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352781 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352784 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352788 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352798 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 352805 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 352805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 352808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 352812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352827 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 352849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352859 */     // GIR_Coverage, 4264,
     /* 352859 */     GIR_EraseRootFromParent_Done,
     /* 352860 */   // Label 7059: @352860
     /* 352860 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(352964), // Rule ID 4371 //
     /* 352865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352869 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352875 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352885 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352888 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352892 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352902 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 352909 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 352909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 352912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 352916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352931 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 352953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 352963 */     // GIR_Coverage, 4371,
     /* 352963 */     GIR_EraseRootFromParent_Done,
     /* 352964 */   // Label 7060: @352964
     /* 352964 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(353068), // Rule ID 4372 //
     /* 352969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352973 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352979 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352989 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352992 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352996 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353006 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 353013 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 353013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 353020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353035 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353067 */     // GIR_Coverage, 4372,
     /* 353067 */     GIR_EraseRootFromParent_Done,
     /* 353068 */   // Label 7061: @353068
     /* 353068 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(353168), // Rule ID 4267 //
     /* 353073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353089 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353092 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353096 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 353113 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 353113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 353120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353135 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353157 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353162 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353167 */     // GIR_Coverage, 4267,
     /* 353167 */     GIR_EraseRootFromParent_Done,
     /* 353168 */   // Label 7062: @353168
     /* 353168 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(353268), // Rule ID 4269 //
     /* 353173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353189 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353196 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353206 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 353213 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 353213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 353220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353235 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353267 */     // GIR_Coverage, 4269,
     /* 353267 */     GIR_EraseRootFromParent_Done,
     /* 353268 */   // Label 7063: @353268
     /* 353268 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(353368), // Rule ID 4375 //
     /* 353273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353289 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353292 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353296 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353306 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 353313 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 353313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 353320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353335 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353367 */     // GIR_Coverage, 4375,
     /* 353367 */     GIR_EraseRootFromParent_Done,
     /* 353368 */   // Label 7064: @353368
     /* 353368 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(353468), // Rule ID 4377 //
     /* 353373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353389 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353392 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353396 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 353413 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 353413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 353420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353435 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353457 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353467 */     // GIR_Coverage, 4377,
     /* 353467 */     GIR_EraseRootFromParent_Done,
     /* 353468 */   // Label 7065: @353468
     /* 353468 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(353606), // Rule ID 11109 //
     /* 353473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 353480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353484 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 353484 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 353487 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353491 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353496 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 353502 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 353507 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353512 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 353515 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 353519 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353524 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 353527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 353529 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 353532 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 353536 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353541 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 353544 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 353547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353549 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353552 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 353556 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353561 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 353564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 353573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353578 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353581 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 353584 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 353587 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 353590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 353595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353597 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 353599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353602 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 353604 */     GIR_RootConstrainSelectedInstOperands,
     /* 353605 */     // GIR_Coverage, 11109,
     /* 353605 */     GIR_EraseRootFromParent_Done,
     /* 353606 */   // Label 7066: @353606
     /* 353606 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(353744), // Rule ID 11115 //
     /* 353611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353622 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 353622 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 353625 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353629 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353634 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 353640 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 353645 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353650 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 353653 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 353657 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353662 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 353665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 353667 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 353670 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 353674 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353679 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 353682 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 353685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 353694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353699 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 353702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 353711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353719 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 353722 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 353725 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 353728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 353733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353735 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 353737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353740 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 353742 */     GIR_RootConstrainSelectedInstOperands,
     /* 353743 */     // GIR_Coverage, 11115,
     /* 353743 */     GIR_EraseRootFromParent_Done,
     /* 353744 */   // Label 7067: @353744
     /* 353744 */   GIM_Reject,
     /* 353745 */ // Label 7049: @353745
     /* 353745 */ GIM_Reject,
     /* 353746 */ // Label 6832: @353746
     /* 353746 */ GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(355939),
     /* 353751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353754 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(353880), // Rule ID 4229 //
     /* 353759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353773 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353779 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353789 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353792 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353796 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 353803 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353813 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 353820 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 353820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 353827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353847 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353869 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353874 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353879 */     // GIR_Coverage, 4229,
     /* 353879 */     GIR_EraseRootFromParent_Done,
     /* 353880 */   // Label 7069: @353880
     /* 353880 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(354006), // Rule ID 4230 //
     /* 353885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353899 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353905 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353915 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353918 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353922 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 353929 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 353946 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 353946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 353949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 353953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353973 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 353995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354005 */     // GIR_Coverage, 4230,
     /* 354005 */     GIR_EraseRootFromParent_Done,
     /* 354006 */   // Label 7070: @354006
     /* 354006 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(354125), // Rule ID 4337 //
     /* 354011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354025 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354031 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354041 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354044 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354048 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 354065 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 354065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 354072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354092 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354124 */     // GIR_Coverage, 4337,
     /* 354124 */     GIR_EraseRootFromParent_Done,
     /* 354125 */   // Label 7071: @354125
     /* 354125 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(354244), // Rule ID 4338 //
     /* 354130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354144 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354150 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354160 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354163 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354167 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 354184 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 354184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 354191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354211 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354238 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354243 */     // GIR_Coverage, 4338,
     /* 354243 */     GIR_EraseRootFromParent_Done,
     /* 354244 */   // Label 7072: @354244
     /* 354244 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(354366), // Rule ID 4235 //
     /* 354249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354275 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354278 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354282 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 354289 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354299 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 354306 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 354306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 354313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354333 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354365 */     // GIR_Coverage, 4235,
     /* 354365 */     GIR_EraseRootFromParent_Done,
     /* 354366 */   // Label 7073: @354366
     /* 354366 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(354488), // Rule ID 4237 //
     /* 354371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354397 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354400 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354404 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 354411 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 354428 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 354428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 354435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354455 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354487 */     // GIR_Coverage, 4237,
     /* 354487 */     GIR_EraseRootFromParent_Done,
     /* 354488 */   // Label 7074: @354488
     /* 354488 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(354603), // Rule ID 4343 //
     /* 354493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354519 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354522 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354526 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354536 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 354543 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 354543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 354550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354570 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354602 */     // GIR_Coverage, 4343,
     /* 354602 */     GIR_EraseRootFromParent_Done,
     /* 354603 */   // Label 7075: @354603
     /* 354603 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(354718), // Rule ID 4345 //
     /* 354608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354634 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354637 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354641 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 354658 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 354658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 354665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354685 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354717 */     // GIR_Coverage, 4345,
     /* 354717 */     GIR_EraseRootFromParent_Done,
     /* 354718 */   // Label 7076: @354718
     /* 354718 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(354839), // Rule ID 4227 //
     /* 354723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354737 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354743 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354753 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354756 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354760 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 354767 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354777 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 354784 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 354784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 354791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354806 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354838 */     // GIR_Coverage, 4227,
     /* 354838 */     GIR_EraseRootFromParent_Done,
     /* 354839 */   // Label 7077: @354839
     /* 354839 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(354960), // Rule ID 4228 //
     /* 354844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354858 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354864 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354874 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354877 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354881 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 354888 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 354905 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 354905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 354908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 354912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354927 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 354949 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 354959 */     // GIR_Coverage, 4228,
     /* 354959 */     GIR_EraseRootFromParent_Done,
     /* 354960 */   // Label 7078: @354960
     /* 354960 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(355074), // Rule ID 4335 //
     /* 354965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 354968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354979 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354985 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354995 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355002 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 355019 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 355019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 355022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 355026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355041 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 355063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355073 */     // GIR_Coverage, 4335,
     /* 355073 */     GIR_EraseRootFromParent_Done,
     /* 355074 */   // Label 7079: @355074
     /* 355074 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(355188), // Rule ID 4336 //
     /* 355079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355093 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355099 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355109 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355112 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355116 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 355133 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 355133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 355136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 355140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355155 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 355177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355182 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355187 */     // GIR_Coverage, 4336,
     /* 355187 */     GIR_EraseRootFromParent_Done,
     /* 355188 */   // Label 7080: @355188
     /* 355188 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(355305), // Rule ID 4231 //
     /* 355193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355219 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355222 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355226 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 355233 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 355250 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 355250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 355253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 355257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355272 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 355294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355304 */     // GIR_Coverage, 4231,
     /* 355304 */     GIR_EraseRootFromParent_Done,
     /* 355305 */   // Label 7081: @355305
     /* 355305 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(355422), // Rule ID 4233 //
     /* 355310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355336 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355339 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355343 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 355350 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355360 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 355367 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 355367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 355370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 355374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355389 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 355411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355421 */     // GIR_Coverage, 4233,
     /* 355421 */     GIR_EraseRootFromParent_Done,
     /* 355422 */   // Label 7082: @355422
     /* 355422 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(355532), // Rule ID 4339 //
     /* 355427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355453 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355456 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355460 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355470 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 355477 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 355477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 355480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 355484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355499 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 355521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355526 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355531 */     // GIR_Coverage, 4339,
     /* 355531 */     GIR_EraseRootFromParent_Done,
     /* 355532 */   // Label 7083: @355532
     /* 355532 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(355642), // Rule ID 4341 //
     /* 355537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355563 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355566 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355570 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 355587 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 355587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 355590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 355594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355609 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 355631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355641 */     // GIR_Coverage, 4341,
     /* 355641 */     GIR_EraseRootFromParent_Done,
     /* 355642 */   // Label 7084: @355642
     /* 355642 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(355790), // Rule ID 11108 //
     /* 355647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355668 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 355668 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 355671 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355675 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355680 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 355686 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355691 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355696 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 355699 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 355703 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355708 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 355711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 355713 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 355716 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 355720 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355725 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355728 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 355731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 355733 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 355736 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 355740 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355745 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 355748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 355753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 355757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355762 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355765 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355768 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 355771 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 355774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 355779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355781 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 355783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355786 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 355788 */     GIR_RootConstrainSelectedInstOperands,
     /* 355789 */     // GIR_Coverage, 11108,
     /* 355789 */     GIR_EraseRootFromParent_Done,
     /* 355790 */   // Label 7085: @355790
     /* 355790 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(355938), // Rule ID 11113 //
     /* 355795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355816 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 355816 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 355819 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355823 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355828 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 355834 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355839 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355844 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 355847 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 355851 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355856 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 355859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 355861 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 355864 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 355868 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355873 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355876 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 355879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 355881 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 355884 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 355888 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355893 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 355896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 355901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 355905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355910 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355913 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355916 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 355919 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 355922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 355927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355929 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 355931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355934 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 355936 */     GIR_RootConstrainSelectedInstOperands,
     /* 355937 */     // GIR_Coverage, 11113,
     /* 355937 */     GIR_EraseRootFromParent_Done,
     /* 355938 */   // Label 7086: @355938
     /* 355938 */   GIM_Reject,
     /* 355939 */ // Label 7068: @355939
     /* 355939 */ GIM_Reject,
     /* 355940 */ // Label 6833: @355940
     /* 355940 */ GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(356989),
     /* 355945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 355948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355951 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355958 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(356074), // Rule ID 4193 //
     /* 355963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355967 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355973 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355983 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355986 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355990 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 355997 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356007 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 356014 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 356014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 356021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356041 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356073 */     // GIR_Coverage, 4193,
     /* 356073 */     GIR_EraseRootFromParent_Done,
     /* 356074 */   // Label 7088: @356074
     /* 356074 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(356190), // Rule ID 4194 //
     /* 356079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356083 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356089 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356099 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356102 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356106 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356113 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356123 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 356130 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 356130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 356137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356157 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356189 */     // GIR_Coverage, 4194,
     /* 356189 */     GIR_EraseRootFromParent_Done,
     /* 356190 */   // Label 7089: @356190
     /* 356190 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(356302), // Rule ID 4199 //
     /* 356195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356211 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356214 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356218 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356225 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 356242 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 356242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 356249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356269 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356301 */     // GIR_Coverage, 4199,
     /* 356301 */     GIR_EraseRootFromParent_Done,
     /* 356302 */   // Label 7090: @356302
     /* 356302 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(356414), // Rule ID 4201 //
     /* 356307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356323 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356326 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356330 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356337 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356347 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 356354 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 356354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 356361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356381 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356413 */     // GIR_Coverage, 4201,
     /* 356413 */     GIR_EraseRootFromParent_Done,
     /* 356414 */   // Label 7091: @356414
     /* 356414 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(356525), // Rule ID 4191 //
     /* 356419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356423 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356429 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356439 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356442 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356446 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356453 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356463 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 356470 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 356470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 356477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356492 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356524 */     // GIR_Coverage, 4191,
     /* 356524 */     GIR_EraseRootFromParent_Done,
     /* 356525 */   // Label 7092: @356525
     /* 356525 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(356636), // Rule ID 4192 //
     /* 356530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356534 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356540 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356550 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356553 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356557 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356564 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356574 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 356581 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 356581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 356588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356603 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356635 */     // GIR_Coverage, 4192,
     /* 356635 */     GIR_EraseRootFromParent_Done,
     /* 356636 */   // Label 7093: @356636
     /* 356636 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(356743), // Rule ID 4195 //
     /* 356641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356657 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356660 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356664 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356671 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356675 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356681 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 356688 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 356688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 356695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356710 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356742 */     // GIR_Coverage, 4195,
     /* 356742 */     GIR_EraseRootFromParent_Done,
     /* 356743 */   // Label 7094: @356743
     /* 356743 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(356850), // Rule ID 4197 //
     /* 356748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356764 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356767 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356771 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356778 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356788 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 356795 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 356795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 356798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 356802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356817 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 356839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 356849 */     // GIR_Coverage, 4197,
     /* 356849 */     GIR_EraseRootFromParent_Done,
     /* 356850 */   // Label 7095: @356850
     /* 356850 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(356988), // Rule ID 11107 //
     /* 356855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 356862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356866 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 356866 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 356869 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356873 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356878 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 356884 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 356889 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356894 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 356897 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 356901 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356906 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 356909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 356911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 356914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 356918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356923 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 356926 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 356929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356931 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 356934 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 356938 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356943 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 356946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 356951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 356955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356960 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356963 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356966 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 356969 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 356972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 356977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356979 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 356981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 356986 */     GIR_RootConstrainSelectedInstOperands,
     /* 356987 */     // GIR_Coverage, 11107,
     /* 356987 */     GIR_EraseRootFromParent_Done,
     /* 356988 */   // Label 7096: @356988
     /* 356988 */   GIM_Reject,
     /* 356989 */ // Label 7087: @356989
     /* 356989 */ GIM_Reject,
     /* 356990 */ // Label 6834: @356990
     /* 356990 */ GIM_Reject,
     /* 356991 */ // Label 89: @356991
     /* 356991 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7100*/ GIMT_Encode4(359908),
     /* 357002 */ /*GILLT_s16*//*Label 7097*/ GIMT_Encode4(357014),
     /* 357006 */ /*GILLT_s32*//*Label 7098*/ GIMT_Encode4(357648),
     /* 357010 */ /*GILLT_s64*//*Label 7099*/ GIMT_Encode4(359241),
     /* 357014 */ // Label 7097: @357014
     /* 357014 */ GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(357058), // Rule ID 11156 //
     /* 357019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 357025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357032 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 357036 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 357036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357041 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 357047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357052 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357057 */   // GIR_Coverage, 11156,
     /* 357057 */   GIR_EraseRootFromParent_Done,
     /* 357058 */ // Label 7101: @357058
     /* 357058 */ GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(357102), // Rule ID 11157 //
     /* 357063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 357069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357076 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 357080 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 357080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357085 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 357091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357101 */   // GIR_Coverage, 11157,
     /* 357101 */   GIR_EraseRootFromParent_Done,
     /* 357102 */ // Label 7102: @357102
     /* 357102 */ GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(357146), // Rule ID 11158 //
     /* 357107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 357113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357120 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 357124 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 357124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357129 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 357135 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357145 */   // GIR_Coverage, 11158,
     /* 357145 */   GIR_EraseRootFromParent_Done,
     /* 357146 */ // Label 7103: @357146
     /* 357146 */ GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(357191), // Rule ID 5738 //
     /* 357151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 357154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357165 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 357169 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 357169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357174 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 357180 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357185 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357190 */   // GIR_Coverage, 5738,
     /* 357190 */   GIR_EraseRootFromParent_Done,
     /* 357191 */ // Label 7104: @357191
     /* 357191 */ GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(357236), // Rule ID 5741 //
     /* 357196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 357199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357210 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357214 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357218 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 357222 */   // MIs[1] Operand 1
     /* 357222 */   // No operand predicates
     /* 357222 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357224 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 357224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 357227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357229 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 357231 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 357234 */   GIR_RootConstrainSelectedInstOperands,
     /* 357235 */   // GIR_Coverage, 5741,
     /* 357235 */   GIR_EraseRootFromParent_Done,
     /* 357236 */ // Label 7105: @357236
     /* 357236 */ GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(357312), // Rule ID 11131 //
     /* 357241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 357247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357254 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357258 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357262 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 357266 */   // MIs[1] Operand 1
     /* 357266 */   // No operand predicates
     /* 357266 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357268 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 357268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 357271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 357275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357280 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 357284 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 357287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357294 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 357301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357306 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357311 */   // GIR_Coverage, 11131,
     /* 357311 */   GIR_EraseRootFromParent_Done,
     /* 357312 */ // Label 7106: @357312
     /* 357312 */ GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(357388), // Rule ID 11132 //
     /* 357317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 357323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357338 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 357342 */   // MIs[1] Operand 1
     /* 357342 */   // No operand predicates
     /* 357342 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357344 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 357344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 357347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 357351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357356 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 357360 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 357363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357370 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 357377 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357382 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357387 */   // GIR_Coverage, 11132,
     /* 357387 */   GIR_EraseRootFromParent_Done,
     /* 357388 */ // Label 7107: @357388
     /* 357388 */ GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(357464), // Rule ID 11133 //
     /* 357393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 357399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357406 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357410 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357414 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 357418 */   // MIs[1] Operand 1
     /* 357418 */   // No operand predicates
     /* 357418 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357420 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 357420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 357423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 357427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357432 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 357436 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 357439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357446 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 357453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357463 */   // GIR_Coverage, 11133,
     /* 357463 */   GIR_EraseRootFromParent_Done,
     /* 357464 */ // Label 7108: @357464
     /* 357464 */ GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(357525), // Rule ID 11121 //
     /* 357469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 357475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357486 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 357486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 357489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 357493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357498 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 357504 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 357508 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 357511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 357516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 357518 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357521 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 357523 */   GIR_RootConstrainSelectedInstOperands,
     /* 357524 */   // GIR_Coverage, 11121,
     /* 357524 */   GIR_EraseRootFromParent_Done,
     /* 357525 */ // Label 7109: @357525
     /* 357525 */ GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(357586), // Rule ID 11122 //
     /* 357530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 357536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357547 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 357547 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 357550 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 357554 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357559 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 357565 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 357569 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 357572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 357577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 357579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357582 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 357584 */   GIR_RootConstrainSelectedInstOperands,
     /* 357585 */   // GIR_Coverage, 11122,
     /* 357585 */   GIR_EraseRootFromParent_Done,
     /* 357586 */ // Label 7110: @357586
     /* 357586 */ GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(357647), // Rule ID 11123 //
     /* 357591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 357597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357608 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 357608 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 357611 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 357615 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357620 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 357626 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 357630 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 357633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 357638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 357640 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357643 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 357645 */   GIR_RootConstrainSelectedInstOperands,
     /* 357646 */   // GIR_Coverage, 11123,
     /* 357646 */   GIR_EraseRootFromParent_Done,
     /* 357647 */ // Label 7111: @357647
     /* 357647 */ GIM_Reject,
     /* 357648 */ // Label 7098: @357648
     /* 357648 */ GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(357693), // Rule ID 6913 //
     /* 357653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 357656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357667 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 357671 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 357671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357676 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 357682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357687 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357692 */   // GIR_Coverage, 6913,
     /* 357692 */   GIR_EraseRootFromParent_Done,
     /* 357693 */ // Label 7112: @357693
     /* 357693 */ GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(357738), // Rule ID 6914 //
     /* 357698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 357701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357712 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 357716 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 357716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357721 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 357727 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357732 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357737 */   // GIR_Coverage, 6914,
     /* 357737 */   GIR_EraseRootFromParent_Done,
     /* 357738 */ // Label 7113: @357738
     /* 357738 */ GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(357782), // Rule ID 11152 //
     /* 357743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 357749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357756 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 357760 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 357760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357765 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 357771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357776 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357781 */   // GIR_Coverage, 11152,
     /* 357781 */   GIR_EraseRootFromParent_Done,
     /* 357782 */ // Label 7114: @357782
     /* 357782 */ GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(357826), // Rule ID 11153 //
     /* 357787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 357793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357800 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 357804 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 357804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357809 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 357815 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357820 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357825 */   // GIR_Coverage, 11153,
     /* 357825 */   GIR_EraseRootFromParent_Done,
     /* 357826 */ // Label 7115: @357826
     /* 357826 */ GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(357870), // Rule ID 11154 //
     /* 357831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 357837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357844 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 357848 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 357848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357853 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 357859 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357864 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357869 */   // GIR_Coverage, 11154,
     /* 357869 */   GIR_EraseRootFromParent_Done,
     /* 357870 */ // Label 7116: @357870
     /* 357870 */ GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(357914), // Rule ID 11159 //
     /* 357875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 357881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357888 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 357892 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 357892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357897 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 357903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357908 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357913 */   // GIR_Coverage, 11159,
     /* 357913 */   GIR_EraseRootFromParent_Done,
     /* 357914 */ // Label 7117: @357914
     /* 357914 */ GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(357958), // Rule ID 11160 //
     /* 357919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 357925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357932 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 357936 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 357936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357941 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 357947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357952 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357957 */   // GIR_Coverage, 11160,
     /* 357957 */   GIR_EraseRootFromParent_Done,
     /* 357958 */ // Label 7118: @357958
     /* 357958 */ GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(358003), // Rule ID 5737 //
     /* 357963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 357966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357977 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 357981 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 357981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357986 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 357992 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358002 */   // GIR_Coverage, 5737,
     /* 358002 */   GIR_EraseRootFromParent_Done,
     /* 358003 */ // Label 7119: @358003
     /* 358003 */ GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(358076), // Rule ID 11137 //
     /* 358008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 358014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358021 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358025 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358029 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 358033 */   // MIs[1] Operand 1
     /* 358033 */   // No operand predicates
     /* 358033 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358035 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 358035 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 358038 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358042 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358047 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 358053 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358058 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 358066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358071 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 358074 */   GIR_RootConstrainSelectedInstOperands,
     /* 358075 */   // GIR_Coverage, 11137,
     /* 358075 */   GIR_EraseRootFromParent_Done,
     /* 358076 */ // Label 7120: @358076
     /* 358076 */ GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(358149), // Rule ID 11138 //
     /* 358081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 358087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358094 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358098 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358102 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 358106 */   // MIs[1] Operand 1
     /* 358106 */   // No operand predicates
     /* 358106 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358108 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 358108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 358111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358120 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 358126 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358131 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 358139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358144 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 358147 */   GIR_RootConstrainSelectedInstOperands,
     /* 358148 */   // GIR_Coverage, 11138,
     /* 358148 */   GIR_EraseRootFromParent_Done,
     /* 358149 */ // Label 7121: @358149
     /* 358149 */ GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(358222), // Rule ID 11139 //
     /* 358154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 358160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358167 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358171 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358175 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 358179 */   // MIs[1] Operand 1
     /* 358179 */   // No operand predicates
     /* 358179 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358181 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 358181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 358184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358193 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 358199 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358204 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 358212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358217 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 358220 */   GIR_RootConstrainSelectedInstOperands,
     /* 358221 */   // GIR_Coverage, 11139,
     /* 358221 */   GIR_EraseRootFromParent_Done,
     /* 358222 */ // Label 7122: @358222
     /* 358222 */ GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(358270), // Rule ID 1919 //
     /* 358227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 358230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 358233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358244 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358248 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358252 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 358256 */   // MIs[1] Operand 1
     /* 358256 */   // No operand predicates
     /* 358256 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358258 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 358258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 358261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358263 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 358265 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 358268 */   GIR_RootConstrainSelectedInstOperands,
     /* 358269 */   // GIR_Coverage, 1919,
     /* 358269 */   GIR_EraseRootFromParent_Done,
     /* 358270 */ // Label 7123: @358270
     /* 358270 */ GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(358318), // Rule ID 1920 //
     /* 358275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 358278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 358281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358292 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358296 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358300 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 358304 */   // MIs[1] Operand 1
     /* 358304 */   // No operand predicates
     /* 358304 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358306 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 358306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 358309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358311 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 358313 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 358316 */   GIR_RootConstrainSelectedInstOperands,
     /* 358317 */   // GIR_Coverage, 1920,
     /* 358317 */   GIR_EraseRootFromParent_Done,
     /* 358318 */ // Label 7124: @358318
     /* 358318 */ GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(358366), // Rule ID 1921 //
     /* 358323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 358326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 358329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358340 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358344 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358348 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 358352 */   // MIs[1] Operand 1
     /* 358352 */   // No operand predicates
     /* 358352 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358354 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 358354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 358357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358359 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 358361 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 358364 */   GIR_RootConstrainSelectedInstOperands,
     /* 358365 */   // GIR_Coverage, 1921,
     /* 358365 */   GIR_EraseRootFromParent_Done,
     /* 358366 */ // Label 7125: @358366
     /* 358366 */ GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(358414), // Rule ID 1923 //
     /* 358371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 358377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358388 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358392 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358396 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 358400 */   // MIs[1] Operand 1
     /* 358400 */   // No operand predicates
     /* 358400 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358402 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 358402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 358405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358407 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 358409 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 358412 */   GIR_RootConstrainSelectedInstOperands,
     /* 358413 */   // GIR_Coverage, 1923,
     /* 358413 */   GIR_EraseRootFromParent_Done,
     /* 358414 */ // Label 7126: @358414
     /* 358414 */ GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(358462), // Rule ID 1924 //
     /* 358419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 358425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358436 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358440 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358444 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 358448 */   // MIs[1] Operand 1
     /* 358448 */   // No operand predicates
     /* 358448 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358450 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 358450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 358453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358455 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 358457 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 358460 */   GIR_RootConstrainSelectedInstOperands,
     /* 358461 */   // GIR_Coverage, 1924,
     /* 358461 */   GIR_EraseRootFromParent_Done,
     /* 358462 */ // Label 7127: @358462
     /* 358462 */ GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(358510), // Rule ID 1925 //
     /* 358467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 358470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 358473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358484 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358488 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358492 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 358496 */   // MIs[1] Operand 1
     /* 358496 */   // No operand predicates
     /* 358496 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358498 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 358498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 358501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358503 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 358505 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 358508 */   GIR_RootConstrainSelectedInstOperands,
     /* 358509 */   // GIR_Coverage, 1925,
     /* 358509 */   GIR_EraseRootFromParent_Done,
     /* 358510 */ // Label 7128: @358510
     /* 358510 */ GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(358555), // Rule ID 5740 //
     /* 358515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 358518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358529 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358533 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358537 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 358541 */   // MIs[1] Operand 1
     /* 358541 */   // No operand predicates
     /* 358541 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358543 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 358543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 358546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358548 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 358550 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 358553 */   GIR_RootConstrainSelectedInstOperands,
     /* 358554 */   // GIR_Coverage, 5740,
     /* 358554 */   GIR_EraseRootFromParent_Done,
     /* 358555 */ // Label 7129: @358555
     /* 358555 */ GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(358631), // Rule ID 11127 //
     /* 358560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 358566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358573 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358581 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 358585 */   // MIs[1] Operand 1
     /* 358585 */   // No operand predicates
     /* 358585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358587 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 358587 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 358590 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 358594 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358599 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 358603 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 358606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358613 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 358620 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358625 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358630 */   // GIR_Coverage, 11127,
     /* 358630 */   GIR_EraseRootFromParent_Done,
     /* 358631 */ // Label 7130: @358631
     /* 358631 */ GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(358707), // Rule ID 11128 //
     /* 358636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 358642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358649 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358653 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358657 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 358661 */   // MIs[1] Operand 1
     /* 358661 */   // No operand predicates
     /* 358661 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358663 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 358663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 358666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 358670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358675 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 358679 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 358682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358689 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 358696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358701 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358706 */   // GIR_Coverage, 11128,
     /* 358706 */   GIR_EraseRootFromParent_Done,
     /* 358707 */ // Label 7131: @358707
     /* 358707 */ GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(358783), // Rule ID 11129 //
     /* 358712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 358718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358725 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358729 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358733 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 358737 */   // MIs[1] Operand 1
     /* 358737 */   // No operand predicates
     /* 358737 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358739 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 358739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 358742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 358746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358751 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 358755 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 358758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358765 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 358772 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358777 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358782 */   // GIR_Coverage, 11129,
     /* 358782 */   GIR_EraseRootFromParent_Done,
     /* 358783 */ // Label 7132: @358783
     /* 358783 */ GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(358859), // Rule ID 11134 //
     /* 358788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 358794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358801 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358805 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358809 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 358813 */   // MIs[1] Operand 1
     /* 358813 */   // No operand predicates
     /* 358813 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358815 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 358815 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 358818 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 358822 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358827 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 358831 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 358834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358841 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 358848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358858 */   // GIR_Coverage, 11134,
     /* 358858 */   GIR_EraseRootFromParent_Done,
     /* 358859 */ // Label 7133: @358859
     /* 358859 */ GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(358935), // Rule ID 11135 //
     /* 358864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 358870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358877 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 358881 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 358885 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 358889 */   // MIs[1] Operand 1
     /* 358889 */   // No operand predicates
     /* 358889 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 358891 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 358891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 358894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 358898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358903 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 358907 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 358910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358917 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 358924 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358929 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358934 */   // GIR_Coverage, 11135,
     /* 358934 */   GIR_EraseRootFromParent_Done,
     /* 358935 */ // Label 7134: @358935
     /* 358935 */ GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(358996), // Rule ID 11117 //
     /* 358940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 358946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358957 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 358957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 358960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 358964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358969 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 358975 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 358979 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 358982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 358987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 358989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358992 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 358994 */   GIR_RootConstrainSelectedInstOperands,
     /* 358995 */   // GIR_Coverage, 11117,
     /* 358995 */   GIR_EraseRootFromParent_Done,
     /* 358996 */ // Label 7135: @358996
     /* 358996 */ GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(359057), // Rule ID 11118 //
     /* 359001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 359007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 359014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359018 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 359018 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 359021 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 359025 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359030 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 359036 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 359040 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 359043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 359048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 359050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359053 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 359055 */   GIR_RootConstrainSelectedInstOperands,
     /* 359056 */   // GIR_Coverage, 11118,
     /* 359056 */   GIR_EraseRootFromParent_Done,
     /* 359057 */ // Label 7136: @359057
     /* 359057 */ GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(359118), // Rule ID 11119 //
     /* 359062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 359068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 359075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359079 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 359079 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 359082 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 359086 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359091 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 359097 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 359101 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 359104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 359109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 359111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359114 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 359116 */   GIR_RootConstrainSelectedInstOperands,
     /* 359117 */   // GIR_Coverage, 11119,
     /* 359117 */   GIR_EraseRootFromParent_Done,
     /* 359118 */ // Label 7137: @359118
     /* 359118 */ GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(359179), // Rule ID 11124 //
     /* 359123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 359129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359136 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359140 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 359140 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 359143 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 359147 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359152 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 359158 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 359162 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 359165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 359170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 359172 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359175 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 359177 */   GIR_RootConstrainSelectedInstOperands,
     /* 359178 */   // GIR_Coverage, 11124,
     /* 359178 */   GIR_EraseRootFromParent_Done,
     /* 359179 */ // Label 7138: @359179
     /* 359179 */ GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(359240), // Rule ID 11125 //
     /* 359184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 359190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 359197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359201 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 359201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 359204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 359208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359213 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 359219 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 359223 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 359226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 359231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 359233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359236 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 359238 */   GIR_RootConstrainSelectedInstOperands,
     /* 359239 */   // GIR_Coverage, 11125,
     /* 359239 */   GIR_EraseRootFromParent_Done,
     /* 359240 */ // Label 7139: @359240
     /* 359240 */ GIM_Reject,
     /* 359241 */ // Label 7099: @359241
     /* 359241 */ GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(359286), // Rule ID 6912 //
     /* 359246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359260 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 359264 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 359264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359269 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 359275 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359280 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359285 */   // GIR_Coverage, 6912,
     /* 359285 */   GIR_EraseRootFromParent_Done,
     /* 359286 */ // Label 7140: @359286
     /* 359286 */ GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(359330), // Rule ID 11155 //
     /* 359291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 359297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359304 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 359308 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 359308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359313 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 359319 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359324 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359329 */   // GIR_Coverage, 11155,
     /* 359329 */   GIR_EraseRootFromParent_Done,
     /* 359330 */ // Label 7141: @359330
     /* 359330 */ GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(359374), // Rule ID 11161 //
     /* 359335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 359341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359348 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 359352 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 359352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359357 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 359363 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359368 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359373 */   // GIR_Coverage, 11161,
     /* 359373 */   GIR_EraseRootFromParent_Done,
     /* 359374 */ // Label 7142: @359374
     /* 359374 */ GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(359419), // Rule ID 5736 //
     /* 359379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359393 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 359397 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 359397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359402 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 359408 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359413 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359418 */   // GIR_Coverage, 5736,
     /* 359418 */   GIR_EraseRootFromParent_Done,
     /* 359419 */ // Label 7143: @359419
     /* 359419 */ GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(359492), // Rule ID 11140 //
     /* 359424 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 359430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359437 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359441 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359445 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359449 */   // MIs[1] Operand 1
     /* 359449 */   // No operand predicates
     /* 359449 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359451 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 359451 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359454 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359458 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359463 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 359469 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359474 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 359482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 359484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359487 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 359490 */   GIR_RootConstrainSelectedInstOperands,
     /* 359491 */   // GIR_Coverage, 11140,
     /* 359491 */   GIR_EraseRootFromParent_Done,
     /* 359492 */ // Label 7144: @359492
     /* 359492 */ GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(359540), // Rule ID 1922 //
     /* 359497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 359500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359514 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359518 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359522 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 359526 */   // MIs[1] Operand 1
     /* 359526 */   // No operand predicates
     /* 359526 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359528 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 359528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 359531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 359533 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 359535 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 359538 */   GIR_RootConstrainSelectedInstOperands,
     /* 359539 */   // GIR_Coverage, 1922,
     /* 359539 */   GIR_EraseRootFromParent_Done,
     /* 359540 */ // Label 7145: @359540
     /* 359540 */ GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(359588), // Rule ID 1926 //
     /* 359545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359562 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359566 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359570 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359574 */   // MIs[1] Operand 1
     /* 359574 */   // No operand predicates
     /* 359574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359576 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 359576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 359579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 359581 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 359583 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 359586 */   GIR_RootConstrainSelectedInstOperands,
     /* 359587 */   // GIR_Coverage, 1926,
     /* 359587 */   GIR_EraseRootFromParent_Done,
     /* 359588 */ // Label 7146: @359588
     /* 359588 */ GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(359633), // Rule ID 5739 //
     /* 359593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359607 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359611 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359615 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359619 */   // MIs[1] Operand 1
     /* 359619 */   // No operand predicates
     /* 359619 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359621 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 359621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 359624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359626 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 359628 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 359631 */   GIR_RootConstrainSelectedInstOperands,
     /* 359632 */   // GIR_Coverage, 5739,
     /* 359632 */   GIR_EraseRootFromParent_Done,
     /* 359633 */ // Label 7147: @359633
     /* 359633 */ GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(359709), // Rule ID 11130 //
     /* 359638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 359644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359651 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359655 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359659 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 359663 */   // MIs[1] Operand 1
     /* 359663 */   // No operand predicates
     /* 359663 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359665 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 359665 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 359668 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 359672 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359677 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 359681 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 359684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359691 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 359698 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359703 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359708 */   // GIR_Coverage, 11130,
     /* 359708 */   GIR_EraseRootFromParent_Done,
     /* 359709 */ // Label 7148: @359709
     /* 359709 */ GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(359785), // Rule ID 11136 //
     /* 359714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 359720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359735 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 359739 */   // MIs[1] Operand 1
     /* 359739 */   // No operand predicates
     /* 359739 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359741 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 359741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 359744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 359748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359753 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 359757 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 359760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359767 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 359774 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359779 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359784 */   // GIR_Coverage, 11136,
     /* 359784 */   GIR_EraseRootFromParent_Done,
     /* 359785 */ // Label 7149: @359785
     /* 359785 */ GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(359846), // Rule ID 11120 //
     /* 359790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 359796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359807 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 359807 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 359810 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 359814 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359819 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 359825 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 359829 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 359832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 359837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 359839 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359842 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 359844 */   GIR_RootConstrainSelectedInstOperands,
     /* 359845 */   // GIR_Coverage, 11120,
     /* 359845 */   GIR_EraseRootFromParent_Done,
     /* 359846 */ // Label 7150: @359846
     /* 359846 */ GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(359907), // Rule ID 11126 //
     /* 359851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 359857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 359860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359868 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 359868 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 359871 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 359875 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359880 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 359886 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 359890 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 359893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 359898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 359900 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359903 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 359905 */   GIR_RootConstrainSelectedInstOperands,
     /* 359906 */   // GIR_Coverage, 11126,
     /* 359906 */   GIR_EraseRootFromParent_Done,
     /* 359907 */ // Label 7151: @359907
     /* 359907 */ GIM_Reject,
     /* 359908 */ // Label 7100: @359908
     /* 359908 */ GIM_Reject,
     /* 359909 */ // Label 90: @359909
     /* 359909 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7159*/ GIMT_Encode4(361614),
     /* 359920 */ /*GILLT_nxv2s16*//*Label 7152*/ GIMT_Encode4(359960),
     /* 359924 */ /*GILLT_nxv2s32*//*Label 7153*/ GIMT_Encode4(360255),
     /* 359928 */ /*GILLT_nxv2s64*//*Label 7154*/ GIMT_Encode4(360493), GIMT_Encode4(0),
     /* 359936 */ /*GILLT_nxv4s16*//*Label 7155*/ GIMT_Encode4(360750),
     /* 359940 */ /*GILLT_nxv4s32*//*Label 7156*/ GIMT_Encode4(360988), GIMT_Encode4(0),
     /* 359948 */ /*GILLT_nxv8s16*//*Label 7157*/ GIMT_Encode4(361245), GIMT_Encode4(0),
     /* 359956 */ /*GILLT_nxv16s8*//*Label 7158*/ GIMT_Encode4(361524),
     /* 359960 */ // Label 7152: @359960
     /* 359960 */ GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(360254),
     /* 359965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 359968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359972 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(360029), // Rule ID 2666 //
     /* 359977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 359992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360009 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 360013 */     // MIs[2] Operand 1
     /* 360013 */     // No operand predicates
     /* 360013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360015 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 360015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 360018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 360024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 360027 */     GIR_RootConstrainSelectedInstOperands,
     /* 360028 */     // GIR_Coverage, 2666,
     /* 360028 */     GIR_EraseRootFromParent_Done,
     /* 360029 */   // Label 7161: @360029
     /* 360029 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(360086), // Rule ID 2668 //
     /* 360034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 360049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360066 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 360070 */     // MIs[2] Operand 1
     /* 360070 */     // No operand predicates
     /* 360070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360072 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 360072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 360075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 360081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 360084 */     GIR_RootConstrainSelectedInstOperands,
     /* 360085 */     // GIR_Coverage, 2668,
     /* 360085 */     GIR_EraseRootFromParent_Done,
     /* 360086 */   // Label 7162: @360086
     /* 360086 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(360143), // Rule ID 8272 //
     /* 360091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 360106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360123 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 360127 */     // MIs[2] Operand 1
     /* 360127 */     // No operand predicates
     /* 360127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360129 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 360129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 360132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 360138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 360141 */     GIR_RootConstrainSelectedInstOperands,
     /* 360142 */     // GIR_Coverage, 8272,
     /* 360142 */     GIR_EraseRootFromParent_Done,
     /* 360143 */   // Label 7163: @360143
     /* 360143 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(360177), // Rule ID 8315 //
     /* 360148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 360159 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 360163 */     // MIs[1] Operand 1
     /* 360163 */     // No operand predicates
     /* 360163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360165 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 360165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 360168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360170 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 360175 */     GIR_RootConstrainSelectedInstOperands,
     /* 360176 */     // GIR_Coverage, 8315,
     /* 360176 */     GIR_EraseRootFromParent_Done,
     /* 360177 */   // Label 7164: @360177
     /* 360177 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(360253), // Rule ID 8293 //
     /* 360182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360189 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 360189 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 360192 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360196 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 360206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360215 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 360222 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 360225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 360243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360251 */     GIR_RootConstrainSelectedInstOperands,
     /* 360252 */     // GIR_Coverage, 8293,
     /* 360252 */     GIR_EraseRootFromParent_Done,
     /* 360253 */   // Label 7165: @360253
     /* 360253 */   GIM_Reject,
     /* 360254 */ // Label 7160: @360254
     /* 360254 */ GIM_Reject,
     /* 360255 */ // Label 7153: @360255
     /* 360255 */ GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(360492),
     /* 360260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 360263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360267 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(360324), // Rule ID 8281 //
     /* 360272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 360287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360304 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 360308 */     // MIs[2] Operand 1
     /* 360308 */     // No operand predicates
     /* 360308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360310 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 360310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 360313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 360319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 360322 */     GIR_RootConstrainSelectedInstOperands,
     /* 360323 */     // GIR_Coverage, 8281,
     /* 360323 */     GIR_EraseRootFromParent_Done,
     /* 360324 */   // Label 7167: @360324
     /* 360324 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(360381), // Rule ID 8290 //
     /* 360329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 360344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360361 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 360365 */     // MIs[2] Operand 1
     /* 360365 */     // No operand predicates
     /* 360365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360367 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 360367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 360370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 360376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 360379 */     GIR_RootConstrainSelectedInstOperands,
     /* 360380 */     // GIR_Coverage, 8290,
     /* 360380 */     GIR_EraseRootFromParent_Done,
     /* 360381 */   // Label 7168: @360381
     /* 360381 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(360415), // Rule ID 8317 //
     /* 360386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 360397 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 360401 */     // MIs[1] Operand 1
     /* 360401 */     // No operand predicates
     /* 360401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360403 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 360403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 360406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360408 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 360413 */     GIR_RootConstrainSelectedInstOperands,
     /* 360414 */     // GIR_Coverage, 8317,
     /* 360414 */     GIR_EraseRootFromParent_Done,
     /* 360415 */   // Label 7169: @360415
     /* 360415 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(360491), // Rule ID 8295 //
     /* 360420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360427 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 360427 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 360430 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360434 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 360444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360453 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 360460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 360463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 360478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 360481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360489 */     GIR_RootConstrainSelectedInstOperands,
     /* 360490 */     // GIR_Coverage, 8295,
     /* 360490 */     GIR_EraseRootFromParent_Done,
     /* 360491 */   // Label 7170: @360491
     /* 360491 */   GIM_Reject,
     /* 360492 */ // Label 7166: @360492
     /* 360492 */ GIM_Reject,
     /* 360493 */ // Label 7154: @360493
     /* 360493 */ GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(360749),
     /* 360498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 360501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360505 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(360562), // Rule ID 2663 //
     /* 360510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 360525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360542 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 360546 */     // MIs[2] Operand 1
     /* 360546 */     // No operand predicates
     /* 360546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360548 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 360548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 360551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 360557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 360560 */     GIR_RootConstrainSelectedInstOperands,
     /* 360561 */     // GIR_Coverage, 2663,
     /* 360561 */     GIR_EraseRootFromParent_Done,
     /* 360562 */   // Label 7172: @360562
     /* 360562 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(360619), // Rule ID 8287 //
     /* 360567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 360582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360599 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 360603 */     // MIs[2] Operand 1
     /* 360603 */     // No operand predicates
     /* 360603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360605 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 360605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 360608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 360614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 360617 */     GIR_RootConstrainSelectedInstOperands,
     /* 360618 */     // GIR_Coverage, 8287,
     /* 360618 */     GIR_EraseRootFromParent_Done,
     /* 360619 */   // Label 7173: @360619
     /* 360619 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(360653), // Rule ID 8318 //
     /* 360624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 360635 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 360639 */     // MIs[1] Operand 1
     /* 360639 */     // No operand predicates
     /* 360639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360641 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 360641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 360644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360646 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 360651 */     GIR_RootConstrainSelectedInstOperands,
     /* 360652 */     // GIR_Coverage, 8318,
     /* 360652 */     GIR_EraseRootFromParent_Done,
     /* 360653 */   // Label 7174: @360653
     /* 360653 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(360672), // Rule ID 2382 //
     /* 360658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 360665 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 360665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 360670 */     GIR_RootConstrainSelectedInstOperands,
     /* 360671 */     // GIR_Coverage, 2382,
     /* 360671 */     GIR_Done,
     /* 360672 */   // Label 7175: @360672
     /* 360672 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(360748), // Rule ID 8296 //
     /* 360677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360684 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 360684 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 360687 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360691 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 360701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360710 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 360717 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 360720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 360738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360746 */     GIR_RootConstrainSelectedInstOperands,
     /* 360747 */     // GIR_Coverage, 8296,
     /* 360747 */     GIR_EraseRootFromParent_Done,
     /* 360748 */   // Label 7176: @360748
     /* 360748 */   GIM_Reject,
     /* 360749 */ // Label 7171: @360749
     /* 360749 */ GIM_Reject,
     /* 360750 */ // Label 7155: @360750
     /* 360750 */ GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(360987),
     /* 360755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 360758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360762 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(360819), // Rule ID 2667 //
     /* 360767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 360782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360799 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 360803 */     // MIs[2] Operand 1
     /* 360803 */     // No operand predicates
     /* 360803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360805 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 360805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 360808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 360814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 360817 */     GIR_RootConstrainSelectedInstOperands,
     /* 360818 */     // GIR_Coverage, 2667,
     /* 360818 */     GIR_EraseRootFromParent_Done,
     /* 360819 */   // Label 7178: @360819
     /* 360819 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(360876), // Rule ID 8275 //
     /* 360824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 360839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360856 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 360860 */     // MIs[2] Operand 1
     /* 360860 */     // No operand predicates
     /* 360860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360862 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 360862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 360865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 360871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 360874 */     GIR_RootConstrainSelectedInstOperands,
     /* 360875 */     // GIR_Coverage, 8275,
     /* 360875 */     GIR_EraseRootFromParent_Done,
     /* 360876 */   // Label 7179: @360876
     /* 360876 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(360910), // Rule ID 8314 //
     /* 360881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 360892 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 360896 */     // MIs[1] Operand 1
     /* 360896 */     // No operand predicates
     /* 360896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360898 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 360898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 360901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360903 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 360908 */     GIR_RootConstrainSelectedInstOperands,
     /* 360909 */     // GIR_Coverage, 8314,
     /* 360909 */     GIR_EraseRootFromParent_Done,
     /* 360910 */   // Label 7180: @360910
     /* 360910 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(360986), // Rule ID 8292 //
     /* 360915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360922 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 360922 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 360925 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360929 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 360939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360948 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360951 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 360955 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 360958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 360976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360984 */     GIR_RootConstrainSelectedInstOperands,
     /* 360985 */     // GIR_Coverage, 8292,
     /* 360985 */     GIR_EraseRootFromParent_Done,
     /* 360986 */   // Label 7181: @360986
     /* 360986 */   GIM_Reject,
     /* 360987 */ // Label 7177: @360987
     /* 360987 */ GIM_Reject,
     /* 360988 */ // Label 7156: @360988
     /* 360988 */ GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(361244),
     /* 360993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 360996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361000 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(361057), // Rule ID 2660 //
     /* 361005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 361020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361037 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 361041 */     // MIs[2] Operand 1
     /* 361041 */     // No operand predicates
     /* 361041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361043 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 361043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 361046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 361048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 361052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 361055 */     GIR_RootConstrainSelectedInstOperands,
     /* 361056 */     // GIR_Coverage, 2660,
     /* 361056 */     GIR_EraseRootFromParent_Done,
     /* 361057 */   // Label 7183: @361057
     /* 361057 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(361114), // Rule ID 8284 //
     /* 361062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 361077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361094 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 361098 */     // MIs[2] Operand 1
     /* 361098 */     // No operand predicates
     /* 361098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361100 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 361100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 361103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 361105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 361109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 361112 */     GIR_RootConstrainSelectedInstOperands,
     /* 361113 */     // GIR_Coverage, 8284,
     /* 361113 */     GIR_EraseRootFromParent_Done,
     /* 361114 */   // Label 7184: @361114
     /* 361114 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(361148), // Rule ID 8316 //
     /* 361119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 361130 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 361134 */     // MIs[1] Operand 1
     /* 361134 */     // No operand predicates
     /* 361134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361136 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 361136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 361139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 361141 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 361146 */     GIR_RootConstrainSelectedInstOperands,
     /* 361147 */     // GIR_Coverage, 8316,
     /* 361147 */     GIR_EraseRootFromParent_Done,
     /* 361148 */   // Label 7185: @361148
     /* 361148 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(361167), // Rule ID 2381 //
     /* 361153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 361160 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 361160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 361165 */     GIR_RootConstrainSelectedInstOperands,
     /* 361166 */     // GIR_Coverage, 2381,
     /* 361166 */     GIR_Done,
     /* 361167 */   // Label 7186: @361167
     /* 361167 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(361243), // Rule ID 8294 //
     /* 361172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361179 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 361179 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 361182 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361186 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 361196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 361200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361205 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 361212 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 361215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 361233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 361235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361241 */     GIR_RootConstrainSelectedInstOperands,
     /* 361242 */     // GIR_Coverage, 8294,
     /* 361242 */     GIR_EraseRootFromParent_Done,
     /* 361243 */   // Label 7187: @361243
     /* 361243 */   GIM_Reject,
     /* 361244 */ // Label 7182: @361244
     /* 361244 */ GIM_Reject,
     /* 361245 */ // Label 7157: @361245
     /* 361245 */ GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(361309), // Rule ID 2657 //
     /* 361250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 361256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361260 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361264 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361268 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 361272 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361276 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361281 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361285 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361289 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 361293 */   // MIs[2] Operand 1
     /* 361293 */   // No operand predicates
     /* 361293 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361295 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 361295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 361298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 361300 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 361304 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 361307 */   GIR_RootConstrainSelectedInstOperands,
     /* 361308 */   // GIR_Coverage, 2657,
     /* 361308 */   GIR_EraseRootFromParent_Done,
     /* 361309 */ // Label 7188: @361309
     /* 361309 */ GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(361373), // Rule ID 8278 //
     /* 361314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 361320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361324 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361332 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 361336 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361340 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361345 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361349 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361353 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 361357 */   // MIs[2] Operand 1
     /* 361357 */   // No operand predicates
     /* 361357 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361359 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 361359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 361362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 361364 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 361368 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 361371 */   GIR_RootConstrainSelectedInstOperands,
     /* 361372 */   // GIR_Coverage, 8278,
     /* 361372 */   GIR_EraseRootFromParent_Done,
     /* 361373 */ // Label 7189: @361373
     /* 361373 */ GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(361414), // Rule ID 8313 //
     /* 361378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 361384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361388 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361392 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 361396 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 361400 */   // MIs[1] Operand 1
     /* 361400 */   // No operand predicates
     /* 361400 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361402 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 361402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 361405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 361407 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 361412 */   GIR_RootConstrainSelectedInstOperands,
     /* 361413 */   // GIR_Coverage, 8313,
     /* 361413 */   GIR_EraseRootFromParent_Done,
     /* 361414 */ // Label 7190: @361414
     /* 361414 */ GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(361440), // Rule ID 2380 //
     /* 361419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 361425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 361433 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 361433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 361438 */   GIR_RootConstrainSelectedInstOperands,
     /* 361439 */   // GIR_Coverage, 2380,
     /* 361439 */   GIR_Done,
     /* 361440 */ // Label 7191: @361440
     /* 361440 */ GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(361523), // Rule ID 8291 //
     /* 361445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 361451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361459 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 361459 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 361462 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361466 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361473 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 361476 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 361480 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361485 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361488 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 361492 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 361495 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361500 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361505 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 361513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 361515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361521 */   GIR_RootConstrainSelectedInstOperands,
     /* 361522 */   // GIR_Coverage, 8291,
     /* 361522 */   GIR_EraseRootFromParent_Done,
     /* 361523 */ // Label 7192: @361523
     /* 361523 */ GIM_Reject,
     /* 361524 */ // Label 7158: @361524
     /* 361524 */ GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(361613),
     /* 361529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 361532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361536 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(361593), // Rule ID 2654 //
     /* 361541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 361552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 361556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 361560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 361569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361573 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 361577 */     // MIs[2] Operand 1
     /* 361577 */     // No operand predicates
     /* 361577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361579 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 361579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 361582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 361584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 361588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 361591 */     GIR_RootConstrainSelectedInstOperands,
     /* 361592 */     // GIR_Coverage, 2654,
     /* 361592 */     GIR_EraseRootFromParent_Done,
     /* 361593 */   // Label 7194: @361593
     /* 361593 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(361612), // Rule ID 2379 //
     /* 361598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 361605 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 361605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 361610 */     GIR_RootConstrainSelectedInstOperands,
     /* 361611 */     // GIR_Coverage, 2379,
     /* 361611 */     GIR_Done,
     /* 361612 */   // Label 7195: @361612
     /* 361612 */   GIM_Reject,
     /* 361613 */ // Label 7193: @361613
     /* 361613 */ GIM_Reject,
     /* 361614 */ // Label 7159: @361614
     /* 361614 */ GIM_Reject,
     /* 361615 */ // Label 91: @361615
     /* 361615 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7198*/ GIMT_Encode4(361766),
     /* 361626 */ /*GILLT_s32*//*Label 7196*/ GIMT_Encode4(361634),
     /* 361630 */ /*GILLT_s64*//*Label 7197*/ GIMT_Encode4(361700),
     /* 361634 */ // Label 7196: @361634
     /* 361634 */ GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(361699),
     /* 361639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 361642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361650 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(361665), // Rule ID 2312 //
     /* 361655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 361658 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 361658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 361663 */     GIR_RootConstrainSelectedInstOperands,
     /* 361664 */     // GIR_Coverage, 2312,
     /* 361664 */     GIR_Done,
     /* 361665 */   // Label 7200: @361665
     /* 361665 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(361698), // Rule ID 3986 //
     /* 361670 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 361670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 361673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 361677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361682 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 361686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 361691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361696 */     GIR_RootConstrainSelectedInstOperands,
     /* 361697 */     // GIR_Coverage, 3986,
     /* 361697 */     GIR_EraseRootFromParent_Done,
     /* 361698 */   // Label 7201: @361698
     /* 361698 */   GIM_Reject,
     /* 361699 */ // Label 7199: @361699
     /* 361699 */ GIM_Reject,
     /* 361700 */ // Label 7197: @361700
     /* 361700 */ GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(361765),
     /* 361705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 361708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361716 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(361731), // Rule ID 2313 //
     /* 361721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 361724 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 361724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 361729 */     GIR_RootConstrainSelectedInstOperands,
     /* 361730 */     // GIR_Coverage, 2313,
     /* 361730 */     GIR_Done,
     /* 361731 */   // Label 7203: @361731
     /* 361731 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(361764), // Rule ID 3987 //
     /* 361736 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 361736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 361739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 361743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 361752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 361757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361762 */     GIR_RootConstrainSelectedInstOperands,
     /* 361763 */     // GIR_Coverage, 3987,
     /* 361763 */     GIR_EraseRootFromParent_Done,
     /* 361764 */   // Label 7204: @361764
     /* 361764 */   GIM_Reject,
     /* 361765 */ // Label 7202: @361765
     /* 361765 */ GIM_Reject,
     /* 361766 */ // Label 7198: @361766
     /* 361766 */ GIM_Reject,
     /* 361767 */ // Label 92: @361767
     /* 361767 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7213*/ GIMT_Encode4(362440),
     /* 361778 */ /*GILLT_s32*//*Label 7205*/ GIMT_Encode4(361818),
     /* 361782 */ /*GILLT_s64*//*Label 7206*/ GIMT_Encode4(362048), GIMT_Encode4(0),
     /* 361790 */ /*GILLT_v2s32*//*Label 7207*/ GIMT_Encode4(362278), GIMT_Encode4(0),
     /* 361798 */ /*GILLT_v4s16*//*Label 7208*/ GIMT_Encode4(362305),
     /* 361802 */ /*GILLT_v4s32*//*Label 7209*/ GIMT_Encode4(362332),
     /* 361806 */ /*GILLT_v8s8*//*Label 7210*/ GIMT_Encode4(362359),
     /* 361810 */ /*GILLT_v8s16*//*Label 7211*/ GIMT_Encode4(362386),
     /* 361814 */ /*GILLT_v16s8*//*Label 7212*/ GIMT_Encode4(362413),
     /* 361818 */ // Label 7205: @361818
     /* 361818 */ GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(362047),
     /* 361823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 361826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361830 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(361930), // Rule ID 3988 //
     /* 361835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 361843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 361847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 361851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 361859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 361863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 361871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 361875 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 361879 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 361883 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 361887 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 361891 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 361895 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361900 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 361904 */     // MIs[3] Rn
     /* 361904 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 361909 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 361913 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 361917 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 361919 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 361919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 361922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 361928 */     GIR_RootConstrainSelectedInstOperands,
     /* 361929 */     // GIR_Coverage, 3988,
     /* 361929 */     GIR_EraseRootFromParent_Done,
     /* 361930 */   // Label 7215: @361930
     /* 361930 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(362030), // Rule ID 13709 //
     /* 361935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 361943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 361947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 361951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 361955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 361959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 361963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 361967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 361971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 361975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 361979 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 361983 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 361992 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 361996 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 362000 */     // MIs[4] Rn
     /* 362000 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 362005 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 362009 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 362013 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 362017 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 362019 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 362019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 362022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 362028 */     GIR_RootConstrainSelectedInstOperands,
     /* 362029 */     // GIR_Coverage, 13709,
     /* 362029 */     GIR_EraseRootFromParent_Done,
     /* 362030 */   // Label 7216: @362030
     /* 362030 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(362046), // Rule ID 180 //
     /* 362035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362039 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 362039 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 362044 */     GIR_RootConstrainSelectedInstOperands,
     /* 362045 */     // GIR_Coverage, 180,
     /* 362045 */     GIR_Done,
     /* 362046 */   // Label 7217: @362046
     /* 362046 */   GIM_Reject,
     /* 362047 */ // Label 7214: @362047
     /* 362047 */ GIM_Reject,
     /* 362048 */ // Label 7206: @362048
     /* 362048 */ GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(362277),
     /* 362053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 362056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362060 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(362160), // Rule ID 3989 //
     /* 362065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 362073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 362077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 362089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 362093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 362097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 362101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 362105 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 362109 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 362113 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 362117 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 362121 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 362125 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362130 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 362134 */     // MIs[3] Rn
     /* 362134 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 362139 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 362143 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 362147 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 362149 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 362149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 362152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 362158 */     GIR_RootConstrainSelectedInstOperands,
     /* 362159 */     // GIR_Coverage, 3989,
     /* 362159 */     GIR_EraseRootFromParent_Done,
     /* 362160 */   // Label 7219: @362160
     /* 362160 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(362260), // Rule ID 13710 //
     /* 362165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 362173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 362177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 362185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 362189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 362193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 362197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 362201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 362205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 362209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 362213 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 362222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 362226 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 362230 */     // MIs[4] Rn
     /* 362230 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 362235 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 362239 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 362243 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 362247 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 362249 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 362249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 362252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 362258 */     GIR_RootConstrainSelectedInstOperands,
     /* 362259 */     // GIR_Coverage, 13710,
     /* 362259 */     GIR_EraseRootFromParent_Done,
     /* 362260 */   // Label 7220: @362260
     /* 362260 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(362276), // Rule ID 181 //
     /* 362265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362269 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 362269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 362274 */     GIR_RootConstrainSelectedInstOperands,
     /* 362275 */     // GIR_Coverage, 181,
     /* 362275 */     GIR_Done,
     /* 362276 */   // Label 7221: @362276
     /* 362276 */   GIM_Reject,
     /* 362277 */ // Label 7218: @362277
     /* 362277 */ GIM_Reject,
     /* 362278 */ // Label 7207: @362278
     /* 362278 */ GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(362304), // Rule ID 720 //
     /* 362283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 362289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362297 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 362297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 362302 */   GIR_RootConstrainSelectedInstOperands,
     /* 362303 */   // GIR_Coverage, 720,
     /* 362303 */   GIR_Done,
     /* 362304 */ // Label 7222: @362304
     /* 362304 */ GIM_Reject,
     /* 362305 */ // Label 7208: @362305
     /* 362305 */ GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(362331), // Rule ID 718 //
     /* 362310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 362316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362324 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 362324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 362329 */   GIR_RootConstrainSelectedInstOperands,
     /* 362330 */   // GIR_Coverage, 718,
     /* 362330 */   GIR_Done,
     /* 362331 */ // Label 7223: @362331
     /* 362331 */ GIM_Reject,
     /* 362332 */ // Label 7209: @362332
     /* 362332 */ GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(362358), // Rule ID 721 //
     /* 362337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362351 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 362351 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 362356 */   GIR_RootConstrainSelectedInstOperands,
     /* 362357 */   // GIR_Coverage, 721,
     /* 362357 */   GIR_Done,
     /* 362358 */ // Label 7224: @362358
     /* 362358 */ GIM_Reject,
     /* 362359 */ // Label 7210: @362359
     /* 362359 */ GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(362385), // Rule ID 716 //
     /* 362364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 362370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362378 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 362378 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 362383 */   GIR_RootConstrainSelectedInstOperands,
     /* 362384 */   // GIR_Coverage, 716,
     /* 362384 */   GIR_Done,
     /* 362385 */ // Label 7225: @362385
     /* 362385 */ GIM_Reject,
     /* 362386 */ // Label 7211: @362386
     /* 362386 */ GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(362412), // Rule ID 719 //
     /* 362391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362405 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 362405 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 362410 */   GIR_RootConstrainSelectedInstOperands,
     /* 362411 */   // GIR_Coverage, 719,
     /* 362411 */   GIR_Done,
     /* 362412 */ // Label 7226: @362412
     /* 362412 */ GIM_Reject,
     /* 362413 */ // Label 7212: @362413
     /* 362413 */ GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(362439), // Rule ID 717 //
     /* 362418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 362424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362432 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 362432 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 362437 */   GIR_RootConstrainSelectedInstOperands,
     /* 362438 */   // GIR_Coverage, 717,
     /* 362438 */   GIR_Done,
     /* 362439 */ // Label 7227: @362439
     /* 362439 */ GIM_Reject,
     /* 362440 */ // Label 7213: @362440
     /* 362440 */ GIM_Reject,
     /* 362441 */ // Label 93: @362441
     /* 362441 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7232*/ GIMT_Encode4(362600),
     /* 362452 */ /*GILLT_s32*//*Label 7228*/ GIMT_Encode4(362492),
     /* 362456 */ /*GILLT_s64*//*Label 7229*/ GIMT_Encode4(362519), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 362480 */ /*GILLT_v8s8*//*Label 7230*/ GIMT_Encode4(362546), GIMT_Encode4(0),
     /* 362488 */ /*GILLT_v16s8*//*Label 7231*/ GIMT_Encode4(362573),
     /* 362492 */ // Label 7228: @362492
     /* 362492 */ GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(362518), // Rule ID 2310 //
     /* 362497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 362500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 362503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362511 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 362511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 362516 */   GIR_RootConstrainSelectedInstOperands,
     /* 362517 */   // GIR_Coverage, 2310,
     /* 362517 */   GIR_Done,
     /* 362518 */ // Label 7233: @362518
     /* 362518 */ GIM_Reject,
     /* 362519 */ // Label 7229: @362519
     /* 362519 */ GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(362545), // Rule ID 2311 //
     /* 362524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 362527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 362530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362538 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 362538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 362543 */   GIR_RootConstrainSelectedInstOperands,
     /* 362544 */   // GIR_Coverage, 2311,
     /* 362544 */   GIR_Done,
     /* 362545 */ // Label 7234: @362545
     /* 362545 */ GIM_Reject,
     /* 362546 */ // Label 7230: @362546
     /* 362546 */ GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(362572), // Rule ID 757 //
     /* 362551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 362557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362565 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 362565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 362570 */   GIR_RootConstrainSelectedInstOperands,
     /* 362571 */   // GIR_Coverage, 757,
     /* 362571 */   GIR_Done,
     /* 362572 */ // Label 7235: @362572
     /* 362572 */ GIM_Reject,
     /* 362573 */ // Label 7231: @362573
     /* 362573 */ GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(362599), // Rule ID 758 //
     /* 362578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 362584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362592 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 362592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 362597 */   GIR_RootConstrainSelectedInstOperands,
     /* 362598 */   // GIR_Coverage, 758,
     /* 362598 */   GIR_Done,
     /* 362599 */ // Label 7236: @362599
     /* 362599 */ GIM_Reject,
     /* 362600 */ // Label 7232: @362600
     /* 362600 */ GIM_Reject,
     /* 362601 */ // Label 94: @362601
     /* 362601 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7244*/ GIMT_Encode4(362914),
     /* 362612 */ /*GILLT_s32*//*Label 7237*/ GIMT_Encode4(362648),
     /* 362616 */ /*GILLT_s64*//*Label 7238*/ GIMT_Encode4(362721), GIMT_Encode4(0),
     /* 362624 */ /*GILLT_v2s32*//*Label 7239*/ GIMT_Encode4(362794),
     /* 362628 */ /*GILLT_v2s64*//*Label 7240*/ GIMT_Encode4(362818),
     /* 362632 */ /*GILLT_v4s16*//*Label 7241*/ GIMT_Encode4(362842),
     /* 362636 */ /*GILLT_v4s32*//*Label 7242*/ GIMT_Encode4(362866), GIMT_Encode4(0),
     /* 362644 */ /*GILLT_v8s16*//*Label 7243*/ GIMT_Encode4(362890),
     /* 362648 */ // Label 7237: @362648
     /* 362648 */ GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(362720),
     /* 362653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 362656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362660 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(362703), // Rule ID 3992 //
     /* 362665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 362673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 362677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362686 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 362690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362692 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 362692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 362695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362701 */     GIR_RootConstrainSelectedInstOperands,
     /* 362702 */     // GIR_Coverage, 3992,
     /* 362702 */     GIR_EraseRootFromParent_Done,
     /* 362703 */   // Label 7246: @362703
     /* 362703 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(362719), // Rule ID 185 //
     /* 362708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362712 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 362712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 362717 */     GIR_RootConstrainSelectedInstOperands,
     /* 362718 */     // GIR_Coverage, 185,
     /* 362718 */     GIR_Done,
     /* 362719 */   // Label 7247: @362719
     /* 362719 */   GIM_Reject,
     /* 362720 */ // Label 7245: @362720
     /* 362720 */ GIM_Reject,
     /* 362721 */ // Label 7238: @362721
     /* 362721 */ GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(362793),
     /* 362726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 362729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362733 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(362776), // Rule ID 3993 //
     /* 362738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 362746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 362750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362759 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 362763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362765 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 362765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 362768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362774 */     GIR_RootConstrainSelectedInstOperands,
     /* 362775 */     // GIR_Coverage, 3993,
     /* 362775 */     GIR_EraseRootFromParent_Done,
     /* 362776 */   // Label 7249: @362776
     /* 362776 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(362792), // Rule ID 186 //
     /* 362781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362785 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 362785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 362790 */     GIR_RootConstrainSelectedInstOperands,
     /* 362791 */     // GIR_Coverage, 186,
     /* 362791 */     GIR_Done,
     /* 362792 */   // Label 7250: @362792
     /* 362792 */   GIM_Reject,
     /* 362793 */ // Label 7248: @362793
     /* 362793 */ GIM_Reject,
     /* 362794 */ // Label 7239: @362794
     /* 362794 */ GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(362817), // Rule ID 4967 //
     /* 362799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 362802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362810 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 362810 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 362815 */   GIR_RootConstrainSelectedInstOperands,
     /* 362816 */   // GIR_Coverage, 4967,
     /* 362816 */   GIR_Done,
     /* 362817 */ // Label 7251: @362817
     /* 362817 */ GIM_Reject,
     /* 362818 */ // Label 7240: @362818
     /* 362818 */ GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(362841), // Rule ID 4969 //
     /* 362823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 362826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362834 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 362834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 362839 */   GIR_RootConstrainSelectedInstOperands,
     /* 362840 */   // GIR_Coverage, 4969,
     /* 362840 */   GIR_Done,
     /* 362841 */ // Label 7252: @362841
     /* 362841 */ GIM_Reject,
     /* 362842 */ // Label 7241: @362842
     /* 362842 */ GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(362865), // Rule ID 4965 //
     /* 362847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 362850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362858 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 362858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 362863 */   GIR_RootConstrainSelectedInstOperands,
     /* 362864 */   // GIR_Coverage, 4965,
     /* 362864 */   GIR_Done,
     /* 362865 */ // Label 7253: @362865
     /* 362865 */ GIM_Reject,
     /* 362866 */ // Label 7242: @362866
     /* 362866 */ GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(362889), // Rule ID 4968 //
     /* 362871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362882 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 362882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 362887 */   GIR_RootConstrainSelectedInstOperands,
     /* 362888 */   // GIR_Coverage, 4968,
     /* 362888 */   GIR_Done,
     /* 362889 */ // Label 7254: @362889
     /* 362889 */ GIM_Reject,
     /* 362890 */ // Label 7243: @362890
     /* 362890 */ GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(362913), // Rule ID 4966 //
     /* 362895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362906 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 362906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 362911 */   GIR_RootConstrainSelectedInstOperands,
     /* 362912 */   // GIR_Coverage, 4966,
     /* 362912 */   GIR_Done,
     /* 362913 */ // Label 7255: @362913
     /* 362913 */ GIM_Reject,
     /* 362914 */ // Label 7244: @362914
     /* 362914 */ GIM_Reject,
     /* 362915 */ // Label 95: @362915
     /* 362915 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7260*/ GIMT_Encode4(363068),
     /* 362926 */ /*GILLT_s32*//*Label 7256*/ GIMT_Encode4(362966),
     /* 362930 */ /*GILLT_s64*//*Label 7257*/ GIMT_Encode4(362990), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 362954 */ /*GILLT_v8s8*//*Label 7258*/ GIMT_Encode4(363014), GIMT_Encode4(0),
     /* 362962 */ /*GILLT_v16s8*//*Label 7259*/ GIMT_Encode4(363041),
     /* 362966 */ // Label 7256: @362966
     /* 362966 */ GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(362989), // Rule ID 182 //
     /* 362971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 362974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362982 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 362982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 362987 */   GIR_RootConstrainSelectedInstOperands,
     /* 362988 */   // GIR_Coverage, 182,
     /* 362988 */   GIR_Done,
     /* 362989 */ // Label 7261: @362989
     /* 362989 */ GIM_Reject,
     /* 362990 */ // Label 7257: @362990
     /* 362990 */ GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(363013), // Rule ID 183 //
     /* 362995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 362998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363006 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 363006 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 363011 */   GIR_RootConstrainSelectedInstOperands,
     /* 363012 */   // GIR_Coverage, 183,
     /* 363012 */   GIR_Done,
     /* 363013 */ // Label 7262: @363013
     /* 363013 */ GIM_Reject,
     /* 363014 */ // Label 7258: @363014
     /* 363014 */ GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(363040), // Rule ID 967 //
     /* 363019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 363025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363033 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 363033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 363038 */   GIR_RootConstrainSelectedInstOperands,
     /* 363039 */   // GIR_Coverage, 967,
     /* 363039 */   GIR_Done,
     /* 363040 */ // Label 7263: @363040
     /* 363040 */ GIM_Reject,
     /* 363041 */ // Label 7259: @363041
     /* 363041 */ GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(363067), // Rule ID 968 //
     /* 363046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 363052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363060 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 363060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 363065 */   GIR_RootConstrainSelectedInstOperands,
     /* 363066 */   // GIR_Coverage, 968,
     /* 363066 */   GIR_Done,
     /* 363067 */ // Label 7264: @363067
     /* 363067 */ GIM_Reject,
     /* 363068 */ // Label 7260: @363068
     /* 363068 */ GIM_Reject,
     /* 363069 */ // Label 96: @363069
     /* 363069 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7273*/ GIMT_Encode4(363559),
     /* 363080 */ /*GILLT_s16*//*Label 7265*/ GIMT_Encode4(363120),
     /* 363084 */ /*GILLT_s32*//*Label 7266*/ GIMT_Encode4(363151),
     /* 363088 */ /*GILLT_s64*//*Label 7267*/ GIMT_Encode4(363182), GIMT_Encode4(0),
     /* 363096 */ /*GILLT_v2s32*//*Label 7268*/ GIMT_Encode4(363213),
     /* 363100 */ /*GILLT_v2s64*//*Label 7269*/ GIMT_Encode4(363244),
     /* 363104 */ /*GILLT_v4s16*//*Label 7270*/ GIMT_Encode4(363275),
     /* 363108 */ /*GILLT_v4s32*//*Label 7271*/ GIMT_Encode4(363306), GIMT_Encode4(0),
     /* 363116 */ /*GILLT_v8s16*//*Label 7272*/ GIMT_Encode4(363337),
     /* 363120 */ // Label 7265: @363120
     /* 363120 */ GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(363150), // Rule ID 552 //
     /* 363125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 363128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 363131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363139 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 363139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 363144 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363148 */   GIR_RootConstrainSelectedInstOperands,
     /* 363149 */   // GIR_Coverage, 552,
     /* 363149 */   GIR_Done,
     /* 363150 */ // Label 7274: @363150
     /* 363150 */ GIM_Reject,
     /* 363151 */ // Label 7266: @363151
     /* 363151 */ GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(363181), // Rule ID 554 //
     /* 363156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 363159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 363162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363170 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 363170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 363175 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363179 */   GIR_RootConstrainSelectedInstOperands,
     /* 363180 */   // GIR_Coverage, 554,
     /* 363180 */   GIR_Done,
     /* 363181 */ // Label 7275: @363181
     /* 363181 */ GIM_Reject,
     /* 363182 */ // Label 7267: @363182
     /* 363182 */ GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(363212), // Rule ID 556 //
     /* 363187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 363190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 363193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363201 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 363201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 363206 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363210 */   GIR_RootConstrainSelectedInstOperands,
     /* 363211 */   // GIR_Coverage, 556,
     /* 363211 */   GIR_Done,
     /* 363212 */ // Label 7276: @363212
     /* 363212 */ GIM_Reject,
     /* 363213 */ // Label 7268: @363213
     /* 363213 */ GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(363243), // Rule ID 906 //
     /* 363218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 363224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363232 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 363232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 363237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363241 */   GIR_RootConstrainSelectedInstOperands,
     /* 363242 */   // GIR_Coverage, 906,
     /* 363242 */   GIR_Done,
     /* 363243 */ // Label 7277: @363243
     /* 363243 */ GIM_Reject,
     /* 363244 */ // Label 7269: @363244
     /* 363244 */ GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(363274), // Rule ID 910 //
     /* 363249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363263 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 363263 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 363268 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363272 */   GIR_RootConstrainSelectedInstOperands,
     /* 363273 */   // GIR_Coverage, 910,
     /* 363273 */   GIR_Done,
     /* 363274 */ // Label 7278: @363274
     /* 363274 */ GIM_Reject,
     /* 363275 */ // Label 7270: @363275
     /* 363275 */ GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(363305), // Rule ID 902 //
     /* 363280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 363286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363294 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 363294 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 363299 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363303 */   GIR_RootConstrainSelectedInstOperands,
     /* 363304 */   // GIR_Coverage, 902,
     /* 363304 */   GIR_Done,
     /* 363305 */ // Label 7279: @363305
     /* 363305 */ GIM_Reject,
     /* 363306 */ // Label 7271: @363306
     /* 363306 */ GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(363336), // Rule ID 908 //
     /* 363311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363325 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 363325 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 363330 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363334 */   GIR_RootConstrainSelectedInstOperands,
     /* 363335 */   // GIR_Coverage, 908,
     /* 363335 */   GIR_Done,
     /* 363336 */ // Label 7280: @363336
     /* 363336 */ GIM_Reject,
     /* 363337 */ // Label 7272: @363337
     /* 363337 */ GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(363558),
     /* 363342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363353 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(363372), // Rule ID 904 //
     /* 363358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363361 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 363361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 363366 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363370 */     GIR_RootConstrainSelectedInstOperands,
     /* 363371 */     // GIR_Coverage, 904,
     /* 363371 */     GIR_Done,
     /* 363372 */   // Label 7282: @363372
     /* 363372 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(363557), // Rule ID 6945 //
     /* 363377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 363380 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 363380 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 363383 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 363387 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363392 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 363396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 363398 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 363401 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 363405 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363410 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 363413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 363415 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 363418 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363422 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363427 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 363433 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363438 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363443 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 363446 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 363450 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363455 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 363458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 363460 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 363463 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 363467 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363472 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 363475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 363477 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 363480 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 363484 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363489 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 363492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 363494 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 363497 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363501 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 363508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363520 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363523 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 363526 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 363529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 363547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 363555 */     GIR_RootConstrainSelectedInstOperands,
     /* 363556 */     // GIR_Coverage, 6945,
     /* 363556 */     GIR_EraseRootFromParent_Done,
     /* 363557 */   // Label 7283: @363557
     /* 363557 */   GIM_Reject,
     /* 363558 */ // Label 7281: @363558
     /* 363558 */ GIM_Reject,
     /* 363559 */ // Label 7273: @363559
     /* 363559 */ GIM_Reject,
     /* 363560 */ // Label 97: @363560
     /* 363560 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7292*/ GIMT_Encode4(363859),
     /* 363571 */ /*GILLT_s16*//*Label 7284*/ GIMT_Encode4(363611),
     /* 363575 */ /*GILLT_s32*//*Label 7285*/ GIMT_Encode4(363642),
     /* 363579 */ /*GILLT_s64*//*Label 7286*/ GIMT_Encode4(363673), GIMT_Encode4(0),
     /* 363587 */ /*GILLT_v2s32*//*Label 7287*/ GIMT_Encode4(363704),
     /* 363591 */ /*GILLT_v2s64*//*Label 7288*/ GIMT_Encode4(363735),
     /* 363595 */ /*GILLT_v4s16*//*Label 7289*/ GIMT_Encode4(363766),
     /* 363599 */ /*GILLT_v4s32*//*Label 7290*/ GIMT_Encode4(363797), GIMT_Encode4(0),
     /* 363607 */ /*GILLT_v8s16*//*Label 7291*/ GIMT_Encode4(363828),
     /* 363611 */ // Label 7284: @363611
     /* 363611 */ GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(363641), // Rule ID 570 //
     /* 363616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 363619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 363622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363630 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 363630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 363635 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363639 */   GIR_RootConstrainSelectedInstOperands,
     /* 363640 */   // GIR_Coverage, 570,
     /* 363640 */   GIR_Done,
     /* 363641 */ // Label 7293: @363641
     /* 363641 */ GIM_Reject,
     /* 363642 */ // Label 7285: @363642
     /* 363642 */ GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(363672), // Rule ID 572 //
     /* 363647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 363650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 363653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363661 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 363661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 363666 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363670 */   GIR_RootConstrainSelectedInstOperands,
     /* 363671 */   // GIR_Coverage, 572,
     /* 363671 */   GIR_Done,
     /* 363672 */ // Label 7294: @363672
     /* 363672 */ GIM_Reject,
     /* 363673 */ // Label 7286: @363673
     /* 363673 */ GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(363703), // Rule ID 574 //
     /* 363678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 363681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 363684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363692 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 363692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 363697 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363701 */   GIR_RootConstrainSelectedInstOperands,
     /* 363702 */   // GIR_Coverage, 574,
     /* 363702 */   GIR_Done,
     /* 363703 */ // Label 7295: @363703
     /* 363703 */ GIM_Reject,
     /* 363704 */ // Label 7287: @363704
     /* 363704 */ GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(363734), // Rule ID 953 //
     /* 363709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 363715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363723 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 363723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 363728 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363732 */   GIR_RootConstrainSelectedInstOperands,
     /* 363733 */   // GIR_Coverage, 953,
     /* 363733 */   GIR_Done,
     /* 363734 */ // Label 7296: @363734
     /* 363734 */ GIM_Reject,
     /* 363735 */ // Label 7288: @363735
     /* 363735 */ GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(363765), // Rule ID 957 //
     /* 363740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363754 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 363754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 363759 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363763 */   GIR_RootConstrainSelectedInstOperands,
     /* 363764 */   // GIR_Coverage, 957,
     /* 363764 */   GIR_Done,
     /* 363765 */ // Label 7297: @363765
     /* 363765 */ GIM_Reject,
     /* 363766 */ // Label 7289: @363766
     /* 363766 */ GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(363796), // Rule ID 949 //
     /* 363771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 363777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363785 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 363785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 363790 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363794 */   GIR_RootConstrainSelectedInstOperands,
     /* 363795 */   // GIR_Coverage, 949,
     /* 363795 */   GIR_Done,
     /* 363796 */ // Label 7298: @363796
     /* 363796 */ GIM_Reject,
     /* 363797 */ // Label 7290: @363797
     /* 363797 */ GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(363827), // Rule ID 955 //
     /* 363802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 363808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363816 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 363816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 363821 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363825 */   GIR_RootConstrainSelectedInstOperands,
     /* 363826 */   // GIR_Coverage, 955,
     /* 363826 */   GIR_Done,
     /* 363827 */ // Label 7299: @363827
     /* 363827 */ GIM_Reject,
     /* 363828 */ // Label 7291: @363828
     /* 363828 */ GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(363858), // Rule ID 951 //
     /* 363833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 363836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363847 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 363847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 363852 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363856 */   GIR_RootConstrainSelectedInstOperands,
     /* 363857 */   // GIR_Coverage, 951,
     /* 363857 */   GIR_Done,
     /* 363858 */ // Label 7300: @363858
     /* 363858 */ GIM_Reject,
     /* 363859 */ // Label 7292: @363859
     /* 363859 */ GIM_Reject,
     /* 363860 */ // Label 98: @363860
     /* 363860 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7309*/ GIMT_Encode4(364350),
     /* 363871 */ /*GILLT_s16*//*Label 7301*/ GIMT_Encode4(363911),
     /* 363875 */ /*GILLT_s32*//*Label 7302*/ GIMT_Encode4(363942),
     /* 363879 */ /*GILLT_s64*//*Label 7303*/ GIMT_Encode4(363973), GIMT_Encode4(0),
     /* 363887 */ /*GILLT_v2s32*//*Label 7304*/ GIMT_Encode4(364004),
     /* 363891 */ /*GILLT_v2s64*//*Label 7305*/ GIMT_Encode4(364035),
     /* 363895 */ /*GILLT_v4s16*//*Label 7306*/ GIMT_Encode4(364066),
     /* 363899 */ /*GILLT_v4s32*//*Label 7307*/ GIMT_Encode4(364097), GIMT_Encode4(0),
     /* 363907 */ /*GILLT_v8s16*//*Label 7308*/ GIMT_Encode4(364128),
     /* 363911 */ // Label 7301: @363911
     /* 363911 */ GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(363941), // Rule ID 540 //
     /* 363916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 363919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 363922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363930 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 363930 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 363935 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363939 */   GIR_RootConstrainSelectedInstOperands,
     /* 363940 */   // GIR_Coverage, 540,
     /* 363940 */   GIR_Done,
     /* 363941 */ // Label 7310: @363941
     /* 363941 */ GIM_Reject,
     /* 363942 */ // Label 7302: @363942
     /* 363942 */ GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(363972), // Rule ID 542 //
     /* 363947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 363950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 363953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363961 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 363961 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 363966 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 363970 */   GIR_RootConstrainSelectedInstOperands,
     /* 363971 */   // GIR_Coverage, 542,
     /* 363971 */   GIR_Done,
     /* 363972 */ // Label 7311: @363972
     /* 363972 */ GIM_Reject,
     /* 363973 */ // Label 7303: @363973
     /* 363973 */ GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(364003), // Rule ID 544 //
     /* 363978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 363981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 363984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363992 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 363992 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 363997 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364001 */   GIR_RootConstrainSelectedInstOperands,
     /* 364002 */   // GIR_Coverage, 544,
     /* 364002 */   GIR_Done,
     /* 364003 */ // Label 7312: @364003
     /* 364003 */ GIM_Reject,
     /* 364004 */ // Label 7304: @364004
     /* 364004 */ GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(364034), // Rule ID 886 //
     /* 364009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 364015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364023 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 364023 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 364028 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364032 */   GIR_RootConstrainSelectedInstOperands,
     /* 364033 */   // GIR_Coverage, 886,
     /* 364033 */   GIR_Done,
     /* 364034 */ // Label 7313: @364034
     /* 364034 */ GIM_Reject,
     /* 364035 */ // Label 7305: @364035
     /* 364035 */ GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(364065), // Rule ID 890 //
     /* 364040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364054 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 364054 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 364059 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364063 */   GIR_RootConstrainSelectedInstOperands,
     /* 364064 */   // GIR_Coverage, 890,
     /* 364064 */   GIR_Done,
     /* 364065 */ // Label 7314: @364065
     /* 364065 */ GIM_Reject,
     /* 364066 */ // Label 7306: @364066
     /* 364066 */ GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(364096), // Rule ID 882 //
     /* 364071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 364074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 364077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364085 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 364085 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 364090 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364094 */   GIR_RootConstrainSelectedInstOperands,
     /* 364095 */   // GIR_Coverage, 882,
     /* 364095 */   GIR_Done,
     /* 364096 */ // Label 7315: @364096
     /* 364096 */ GIM_Reject,
     /* 364097 */ // Label 7307: @364097
     /* 364097 */ GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(364127), // Rule ID 888 //
     /* 364102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 364108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364116 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 364116 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 364121 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364125 */   GIR_RootConstrainSelectedInstOperands,
     /* 364126 */   // GIR_Coverage, 888,
     /* 364126 */   GIR_Done,
     /* 364127 */ // Label 7316: @364127
     /* 364127 */ GIM_Reject,
     /* 364128 */ // Label 7308: @364128
     /* 364128 */ GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(364349),
     /* 364133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364144 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(364163), // Rule ID 884 //
     /* 364149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 364152 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 364152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 364157 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364161 */     GIR_RootConstrainSelectedInstOperands,
     /* 364162 */     // GIR_Coverage, 884,
     /* 364162 */     GIR_Done,
     /* 364163 */   // Label 7318: @364163
     /* 364163 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(364348), // Rule ID 6947 //
     /* 364168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 364171 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 364171 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 364174 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 364178 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364183 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 364187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 364189 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 364192 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 364196 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364201 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 364204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 364206 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 364209 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364213 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364218 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 364224 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364229 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364234 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 364237 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 364241 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364246 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 364249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 364251 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 364254 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 364258 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364263 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 364266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 364268 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 364271 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 364275 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364280 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 364283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364285 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 364288 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364292 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364314 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 364317 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 364320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 364338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 364346 */     GIR_RootConstrainSelectedInstOperands,
     /* 364347 */     // GIR_Coverage, 6947,
     /* 364347 */     GIR_EraseRootFromParent_Done,
     /* 364348 */   // Label 7319: @364348
     /* 364348 */   GIM_Reject,
     /* 364349 */ // Label 7317: @364349
     /* 364349 */ GIM_Reject,
     /* 364350 */ // Label 7309: @364350
     /* 364350 */ GIM_Reject,
     /* 364351 */ // Label 99: @364351
     /* 364351 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7328*/ GIMT_Encode4(364841),
     /* 364362 */ /*GILLT_s16*//*Label 7320*/ GIMT_Encode4(364402),
     /* 364366 */ /*GILLT_s32*//*Label 7321*/ GIMT_Encode4(364433),
     /* 364370 */ /*GILLT_s64*//*Label 7322*/ GIMT_Encode4(364464), GIMT_Encode4(0),
     /* 364378 */ /*GILLT_v2s32*//*Label 7323*/ GIMT_Encode4(364495),
     /* 364382 */ /*GILLT_v2s64*//*Label 7324*/ GIMT_Encode4(364526),
     /* 364386 */ /*GILLT_v4s16*//*Label 7325*/ GIMT_Encode4(364557),
     /* 364390 */ /*GILLT_v4s32*//*Label 7326*/ GIMT_Encode4(364588), GIMT_Encode4(0),
     /* 364398 */ /*GILLT_v8s16*//*Label 7327*/ GIMT_Encode4(364619),
     /* 364402 */ // Label 7320: @364402
     /* 364402 */ GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(364432), // Rule ID 558 //
     /* 364407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 364410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 364413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364421 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 364421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 364426 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364430 */   GIR_RootConstrainSelectedInstOperands,
     /* 364431 */   // GIR_Coverage, 558,
     /* 364431 */   GIR_Done,
     /* 364432 */ // Label 7329: @364432
     /* 364432 */ GIM_Reject,
     /* 364433 */ // Label 7321: @364433
     /* 364433 */ GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(364463), // Rule ID 560 //
     /* 364438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 364441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 364444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364452 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 364452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 364457 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364461 */   GIR_RootConstrainSelectedInstOperands,
     /* 364462 */   // GIR_Coverage, 560,
     /* 364462 */   GIR_Done,
     /* 364463 */ // Label 7330: @364463
     /* 364463 */ GIM_Reject,
     /* 364464 */ // Label 7322: @364464
     /* 364464 */ GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(364494), // Rule ID 562 //
     /* 364469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 364472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 364475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364483 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 364483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 364488 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364492 */   GIR_RootConstrainSelectedInstOperands,
     /* 364493 */   // GIR_Coverage, 562,
     /* 364493 */   GIR_Done,
     /* 364494 */ // Label 7331: @364494
     /* 364494 */ GIM_Reject,
     /* 364495 */ // Label 7323: @364495
     /* 364495 */ GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(364525), // Rule ID 916 //
     /* 364500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 364506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364514 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 364514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 364519 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364523 */   GIR_RootConstrainSelectedInstOperands,
     /* 364524 */   // GIR_Coverage, 916,
     /* 364524 */   GIR_Done,
     /* 364525 */ // Label 7332: @364525
     /* 364525 */ GIM_Reject,
     /* 364526 */ // Label 7324: @364526
     /* 364526 */ GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(364556), // Rule ID 920 //
     /* 364531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364545 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 364545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 364550 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364554 */   GIR_RootConstrainSelectedInstOperands,
     /* 364555 */   // GIR_Coverage, 920,
     /* 364555 */   GIR_Done,
     /* 364556 */ // Label 7333: @364556
     /* 364556 */ GIM_Reject,
     /* 364557 */ // Label 7325: @364557
     /* 364557 */ GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(364587), // Rule ID 912 //
     /* 364562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 364565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 364568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364576 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 364576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 364581 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364585 */   GIR_RootConstrainSelectedInstOperands,
     /* 364586 */   // GIR_Coverage, 912,
     /* 364586 */   GIR_Done,
     /* 364587 */ // Label 7334: @364587
     /* 364587 */ GIM_Reject,
     /* 364588 */ // Label 7326: @364588
     /* 364588 */ GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(364618), // Rule ID 918 //
     /* 364593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 364599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364607 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 364607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 364612 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364616 */   GIR_RootConstrainSelectedInstOperands,
     /* 364617 */   // GIR_Coverage, 918,
     /* 364617 */   GIR_Done,
     /* 364618 */ // Label 7335: @364618
     /* 364618 */ GIM_Reject,
     /* 364619 */ // Label 7327: @364619
     /* 364619 */ GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(364840),
     /* 364624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 364627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364635 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(364654), // Rule ID 914 //
     /* 364640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 364643 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 364643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 364648 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364652 */     GIR_RootConstrainSelectedInstOperands,
     /* 364653 */     // GIR_Coverage, 914,
     /* 364653 */     GIR_Done,
     /* 364654 */   // Label 7337: @364654
     /* 364654 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(364839), // Rule ID 6955 //
     /* 364659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 364662 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 364662 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 364665 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 364669 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364674 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 364678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 364680 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 364683 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 364687 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364692 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 364695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 364697 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 364700 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364704 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364709 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 364715 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364720 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364725 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 364728 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 364732 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364737 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 364740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 364742 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 364745 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 364749 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364754 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 364757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 364759 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 364762 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 364766 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364771 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 364774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 364779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364802 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364805 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 364808 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 364811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 364829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 364837 */     GIR_RootConstrainSelectedInstOperands,
     /* 364838 */     // GIR_Coverage, 6955,
     /* 364838 */     GIR_EraseRootFromParent_Done,
     /* 364839 */   // Label 7338: @364839
     /* 364839 */   GIM_Reject,
     /* 364840 */ // Label 7336: @364840
     /* 364840 */ GIM_Reject,
     /* 364841 */ // Label 7328: @364841
     /* 364841 */ GIM_Reject,
     /* 364842 */ // Label 100: @364842
     /* 364842 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7347*/ GIMT_Encode4(365332),
     /* 364853 */ /*GILLT_s16*//*Label 7339*/ GIMT_Encode4(364893),
     /* 364857 */ /*GILLT_s32*//*Label 7340*/ GIMT_Encode4(364924),
     /* 364861 */ /*GILLT_s64*//*Label 7341*/ GIMT_Encode4(364955), GIMT_Encode4(0),
     /* 364869 */ /*GILLT_v2s32*//*Label 7342*/ GIMT_Encode4(364986),
     /* 364873 */ /*GILLT_v2s64*//*Label 7343*/ GIMT_Encode4(365017),
     /* 364877 */ /*GILLT_v4s16*//*Label 7344*/ GIMT_Encode4(365048),
     /* 364881 */ /*GILLT_v4s32*//*Label 7345*/ GIMT_Encode4(365079), GIMT_Encode4(0),
     /* 364889 */ /*GILLT_v8s16*//*Label 7346*/ GIMT_Encode4(365110),
     /* 364893 */ // Label 7339: @364893
     /* 364893 */ GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(364923), // Rule ID 534 //
     /* 364898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 364901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 364904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364912 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 364912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 364917 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364921 */   GIR_RootConstrainSelectedInstOperands,
     /* 364922 */   // GIR_Coverage, 534,
     /* 364922 */   GIR_Done,
     /* 364923 */ // Label 7348: @364923
     /* 364923 */ GIM_Reject,
     /* 364924 */ // Label 7340: @364924
     /* 364924 */ GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(364954), // Rule ID 536 //
     /* 364929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 364932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 364935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364943 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 364943 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 364948 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364952 */   GIR_RootConstrainSelectedInstOperands,
     /* 364953 */   // GIR_Coverage, 536,
     /* 364953 */   GIR_Done,
     /* 364954 */ // Label 7349: @364954
     /* 364954 */ GIM_Reject,
     /* 364955 */ // Label 7341: @364955
     /* 364955 */ GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(364985), // Rule ID 538 //
     /* 364960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 364963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 364966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364974 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 364974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 364979 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 364983 */   GIR_RootConstrainSelectedInstOperands,
     /* 364984 */   // GIR_Coverage, 538,
     /* 364984 */   GIR_Done,
     /* 364985 */ // Label 7350: @364985
     /* 364985 */ GIM_Reject,
     /* 364986 */ // Label 7342: @364986
     /* 364986 */ GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(365016), // Rule ID 876 //
     /* 364991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 364997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365005 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 365005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 365010 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 365014 */   GIR_RootConstrainSelectedInstOperands,
     /* 365015 */   // GIR_Coverage, 876,
     /* 365015 */   GIR_Done,
     /* 365016 */ // Label 7351: @365016
     /* 365016 */ GIM_Reject,
     /* 365017 */ // Label 7343: @365017
     /* 365017 */ GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(365047), // Rule ID 880 //
     /* 365022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 365028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365036 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 365036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 365041 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 365045 */   GIR_RootConstrainSelectedInstOperands,
     /* 365046 */   // GIR_Coverage, 880,
     /* 365046 */   GIR_Done,
     /* 365047 */ // Label 7352: @365047
     /* 365047 */ GIM_Reject,
     /* 365048 */ // Label 7344: @365048
     /* 365048 */ GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(365078), // Rule ID 872 //
     /* 365053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 365059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365067 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 365067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 365072 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 365076 */   GIR_RootConstrainSelectedInstOperands,
     /* 365077 */   // GIR_Coverage, 872,
     /* 365077 */   GIR_Done,
     /* 365078 */ // Label 7353: @365078
     /* 365078 */ GIM_Reject,
     /* 365079 */ // Label 7345: @365079
     /* 365079 */ GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(365109), // Rule ID 878 //
     /* 365084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365098 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 365098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 365103 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 365107 */   GIR_RootConstrainSelectedInstOperands,
     /* 365108 */   // GIR_Coverage, 878,
     /* 365108 */   GIR_Done,
     /* 365109 */ // Label 7354: @365109
     /* 365109 */ GIM_Reject,
     /* 365110 */ // Label 7346: @365110
     /* 365110 */ GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(365331),
     /* 365115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365126 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(365145), // Rule ID 874 //
     /* 365131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 365134 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 365134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 365139 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 365143 */     GIR_RootConstrainSelectedInstOperands,
     /* 365144 */     // GIR_Coverage, 874,
     /* 365144 */     GIR_Done,
     /* 365145 */   // Label 7356: @365145
     /* 365145 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(365330), // Rule ID 6949 //
     /* 365150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 365153 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 365153 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 365156 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 365160 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365165 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 365169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 365171 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 365174 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 365178 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365183 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 365186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 365188 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 365191 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365195 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365200 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 365206 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365211 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365216 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 365219 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 365223 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365228 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 365231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 365233 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 365236 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 365240 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365245 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 365248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 365250 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 365253 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 365257 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365262 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 365265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 365267 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 365270 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365274 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365293 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365296 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 365299 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 365302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 365320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 365328 */     GIR_RootConstrainSelectedInstOperands,
     /* 365329 */     // GIR_Coverage, 6949,
     /* 365329 */     GIR_EraseRootFromParent_Done,
     /* 365330 */   // Label 7357: @365330
     /* 365330 */   GIM_Reject,
     /* 365331 */ // Label 7355: @365331
     /* 365331 */ GIM_Reject,
     /* 365332 */ // Label 7347: @365332
     /* 365332 */ GIM_Reject,
     /* 365333 */ // Label 101: @365333
     /* 365333 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7366*/ GIMT_Encode4(366458),
     /* 365344 */ /*GILLT_s16*//*Label 7358*/ GIMT_Encode4(365384),
     /* 365348 */ /*GILLT_s32*//*Label 7359*/ GIMT_Encode4(365610),
     /* 365352 */ /*GILLT_s64*//*Label 7360*/ GIMT_Encode4(365836), GIMT_Encode4(0),
     /* 365360 */ /*GILLT_v2s32*//*Label 7361*/ GIMT_Encode4(366008),
     /* 365364 */ /*GILLT_v2s64*//*Label 7362*/ GIMT_Encode4(366046),
     /* 365368 */ /*GILLT_v4s16*//*Label 7363*/ GIMT_Encode4(366084),
     /* 365372 */ /*GILLT_v4s32*//*Label 7364*/ GIMT_Encode4(366122), GIMT_Encode4(0),
     /* 365380 */ /*GILLT_v8s16*//*Label 7365*/ GIMT_Encode4(366160),
     /* 365384 */ // Label 7358: @365384
     /* 365384 */ GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(365609),
     /* 365389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 365392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 365395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365399 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(365490), // Rule ID 6869 //
     /* 365404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365425 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 365429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365441 */     // MIs[2] Rn
     /* 365441 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365446 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 365450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365452 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 365452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 365455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365464 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 365470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 365483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365488 */     GIR_RootConstrainSelectedInstOperands,
     /* 365489 */     // GIR_Coverage, 6869,
     /* 365489 */     GIR_EraseRootFromParent_Done,
     /* 365490 */   // Label 7368: @365490
     /* 365490 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(365581), // Rule ID 13850 //
     /* 365495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 365507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365516 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 365520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365532 */     // MIs[2] Rn
     /* 365532 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365537 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 365541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365543 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 365543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 365546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365555 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 365561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 365574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365579 */     GIR_RootConstrainSelectedInstOperands,
     /* 365580 */     // GIR_Coverage, 13850,
     /* 365580 */     GIR_EraseRootFromParent_Done,
     /* 365581 */   // Label 7369: @365581
     /* 365581 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(365608), // Rule ID 583 //
     /* 365586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 365589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365597 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 365597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 365602 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 365606 */     GIR_RootConstrainSelectedInstOperands,
     /* 365607 */     // GIR_Coverage, 583,
     /* 365607 */     GIR_Done,
     /* 365608 */   // Label 7370: @365608
     /* 365608 */   GIM_Reject,
     /* 365609 */ // Label 7367: @365609
     /* 365609 */ GIM_Reject,
     /* 365610 */ // Label 7359: @365610
     /* 365610 */ GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(365835),
     /* 365615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 365618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 365621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365625 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(365716), // Rule ID 6867 //
     /* 365630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365651 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 365655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365667 */     // MIs[2] Rn
     /* 365667 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365672 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 365676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365678 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 365678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 365681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365690 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 365696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 365709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365714 */     GIR_RootConstrainSelectedInstOperands,
     /* 365715 */     // GIR_Coverage, 6867,
     /* 365715 */     GIR_EraseRootFromParent_Done,
     /* 365716 */   // Label 7372: @365716
     /* 365716 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(365807), // Rule ID 13848 //
     /* 365721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365742 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 365746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365758 */     // MIs[2] Rn
     /* 365758 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365763 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 365767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365769 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 365769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 365772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 365776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365781 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 365787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 365800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365805 */     GIR_RootConstrainSelectedInstOperands,
     /* 365806 */     // GIR_Coverage, 13848,
     /* 365806 */     GIR_EraseRootFromParent_Done,
     /* 365807 */   // Label 7373: @365807
     /* 365807 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(365834), // Rule ID 585 //
     /* 365812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 365815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365823 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 365823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 365828 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 365832 */     GIR_RootConstrainSelectedInstOperands,
     /* 365833 */     // GIR_Coverage, 585,
     /* 365833 */     GIR_Done,
     /* 365834 */   // Label 7374: @365834
     /* 365834 */   GIM_Reject,
     /* 365835 */ // Label 7371: @365835
     /* 365835 */ GIM_Reject,
     /* 365836 */ // Label 7360: @365836
     /* 365836 */ GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(366007),
     /* 365841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 365844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 365847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365851 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(365915), // Rule ID 6865 //
     /* 365856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 365868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365877 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 365881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365893 */     // MIs[2] Rn
     /* 365893 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365898 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 365902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365904 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 365904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 365907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365913 */     GIR_RootConstrainSelectedInstOperands,
     /* 365914 */     // GIR_Coverage, 6865,
     /* 365914 */     GIR_EraseRootFromParent_Done,
     /* 365915 */   // Label 7376: @365915
     /* 365915 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(365979), // Rule ID 13846 //
     /* 365920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 365932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365941 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 365945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365957 */     // MIs[2] Rn
     /* 365957 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 365962 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 365966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365968 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 365968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 365971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 365973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 365977 */     GIR_RootConstrainSelectedInstOperands,
     /* 365978 */     // GIR_Coverage, 13846,
     /* 365978 */     GIR_EraseRootFromParent_Done,
     /* 365979 */   // Label 7377: @365979
     /* 365979 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(366006), // Rule ID 587 //
     /* 365984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 365987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365995 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 365995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 366000 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366004 */     GIR_RootConstrainSelectedInstOperands,
     /* 366005 */     // GIR_Coverage, 587,
     /* 366005 */     GIR_Done,
     /* 366006 */   // Label 7378: @366006
     /* 366006 */   GIM_Reject,
     /* 366007 */ // Label 7375: @366007
     /* 366007 */ GIM_Reject,
     /* 366008 */ // Label 7361: @366008
     /* 366008 */ GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(366045), // Rule ID 1195 //
     /* 366013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 366019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 366022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366030 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366034 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 366034 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 366039 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366043 */   GIR_RootConstrainSelectedInstOperands,
     /* 366044 */   // GIR_Coverage, 1195,
     /* 366044 */   GIR_Done,
     /* 366045 */ // Label 7379: @366045
     /* 366045 */ GIM_Reject,
     /* 366046 */ // Label 7362: @366046
     /* 366046 */ GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(366083), // Rule ID 1199 //
     /* 366051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 366057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 366060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366072 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 366072 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 366077 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366081 */   GIR_RootConstrainSelectedInstOperands,
     /* 366082 */   // GIR_Coverage, 1199,
     /* 366082 */   GIR_Done,
     /* 366083 */ // Label 7380: @366083
     /* 366083 */ GIM_Reject,
     /* 366084 */ // Label 7363: @366084
     /* 366084 */ GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(366121), // Rule ID 1191 //
     /* 366089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 366095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 366098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366106 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366110 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 366110 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 366115 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366119 */   GIR_RootConstrainSelectedInstOperands,
     /* 366120 */   // GIR_Coverage, 1191,
     /* 366120 */   GIR_Done,
     /* 366121 */ // Label 7381: @366121
     /* 366121 */ GIM_Reject,
     /* 366122 */ // Label 7364: @366122
     /* 366122 */ GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(366159), // Rule ID 1197 //
     /* 366127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 366136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366144 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366148 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 366148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 366153 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366157 */   GIR_RootConstrainSelectedInstOperands,
     /* 366158 */   // GIR_Coverage, 1197,
     /* 366158 */   GIR_Done,
     /* 366159 */ // Label 7382: @366159
     /* 366159 */ GIM_Reject,
     /* 366160 */ // Label 7365: @366160
     /* 366160 */ GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(366457),
     /* 366165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 366171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366179 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366183 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(366202), // Rule ID 1193 //
     /* 366188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366191 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 366191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 366196 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366200 */     GIR_RootConstrainSelectedInstOperands,
     /* 366201 */     // GIR_Coverage, 1193,
     /* 366201 */     GIR_Done,
     /* 366202 */   // Label 7384: @366202
     /* 366202 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(366456), // Rule ID 6958 //
     /* 366207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 366210 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 366210 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 366213 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 366217 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366222 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 366226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 366228 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 366231 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 366235 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366240 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 366244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 366246 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 366249 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 366253 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366258 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 366261 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 366264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 366266 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 366269 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366273 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366278 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 366284 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366289 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366294 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 366297 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 366301 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366306 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 366309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 366311 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 366314 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366318 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366323 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 366329 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366334 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366339 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 366342 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 366346 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366351 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 366354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 366356 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 366359 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 366363 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366368 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 366371 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 366374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 366376 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 366379 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 366383 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366388 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 366391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 366393 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 366396 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366400 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366419 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366422 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 366425 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 366428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 366446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 366454 */     GIR_RootConstrainSelectedInstOperands,
     /* 366455 */     // GIR_Coverage, 6958,
     /* 366455 */     GIR_EraseRootFromParent_Done,
     /* 366456 */   // Label 7385: @366456
     /* 366456 */   GIM_Reject,
     /* 366457 */ // Label 7383: @366457
     /* 366457 */ GIM_Reject,
     /* 366458 */ // Label 7366: @366458
     /* 366458 */ GIM_Reject,
     /* 366459 */ // Label 102: @366459
     /* 366459 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7394*/ GIMT_Encode4(367074),
     /* 366470 */ /*GILLT_s16*//*Label 7386*/ GIMT_Encode4(366510),
     /* 366474 */ /*GILLT_s32*//*Label 7387*/ GIMT_Encode4(366548),
     /* 366478 */ /*GILLT_s64*//*Label 7388*/ GIMT_Encode4(366586), GIMT_Encode4(0),
     /* 366486 */ /*GILLT_v2s32*//*Label 7389*/ GIMT_Encode4(366624),
     /* 366490 */ /*GILLT_v2s64*//*Label 7390*/ GIMT_Encode4(366662),
     /* 366494 */ /*GILLT_v4s16*//*Label 7391*/ GIMT_Encode4(366700),
     /* 366498 */ /*GILLT_v4s32*//*Label 7392*/ GIMT_Encode4(366738), GIMT_Encode4(0),
     /* 366506 */ /*GILLT_v8s16*//*Label 7393*/ GIMT_Encode4(366776),
     /* 366510 */ // Label 7386: @366510
     /* 366510 */ GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(366547), // Rule ID 631 //
     /* 366515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 366518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 366521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 366524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366536 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 366536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 366541 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366545 */   GIR_RootConstrainSelectedInstOperands,
     /* 366546 */   // GIR_Coverage, 631,
     /* 366546 */   GIR_Done,
     /* 366547 */ // Label 7395: @366547
     /* 366547 */ GIM_Reject,
     /* 366548 */ // Label 7387: @366548
     /* 366548 */ GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(366585), // Rule ID 633 //
     /* 366553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 366556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 366562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366574 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 366574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 366579 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366583 */   GIR_RootConstrainSelectedInstOperands,
     /* 366584 */   // GIR_Coverage, 633,
     /* 366584 */   GIR_Done,
     /* 366585 */ // Label 7396: @366585
     /* 366585 */ GIM_Reject,
     /* 366586 */ // Label 7388: @366586
     /* 366586 */ GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(366623), // Rule ID 635 //
     /* 366591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 366594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 366597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 366600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366612 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 366612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 366617 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366621 */   GIR_RootConstrainSelectedInstOperands,
     /* 366622 */   // GIR_Coverage, 635,
     /* 366622 */   GIR_Done,
     /* 366623 */ // Label 7397: @366623
     /* 366623 */ GIM_Reject,
     /* 366624 */ // Label 7389: @366624
     /* 366624 */ GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(366661), // Rule ID 1335 //
     /* 366629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 366635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 366638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366650 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 366650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 366655 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366659 */   GIR_RootConstrainSelectedInstOperands,
     /* 366660 */   // GIR_Coverage, 1335,
     /* 366660 */   GIR_Done,
     /* 366661 */ // Label 7398: @366661
     /* 366661 */ GIM_Reject,
     /* 366662 */ // Label 7390: @366662
     /* 366662 */ GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(366699), // Rule ID 1339 //
     /* 366667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 366673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 366676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366688 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 366688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 366693 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366697 */   GIR_RootConstrainSelectedInstOperands,
     /* 366698 */   // GIR_Coverage, 1339,
     /* 366698 */   GIR_Done,
     /* 366699 */ // Label 7399: @366699
     /* 366699 */ GIM_Reject,
     /* 366700 */ // Label 7391: @366700
     /* 366700 */ GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(366737), // Rule ID 1331 //
     /* 366705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 366711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 366714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366722 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366726 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 366726 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 366731 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366735 */   GIR_RootConstrainSelectedInstOperands,
     /* 366736 */   // GIR_Coverage, 1331,
     /* 366736 */   GIR_Done,
     /* 366737 */ // Label 7400: @366737
     /* 366737 */ GIM_Reject,
     /* 366738 */ // Label 7392: @366738
     /* 366738 */ GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(366775), // Rule ID 1337 //
     /* 366743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 366752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366760 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366764 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 366764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 366769 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366773 */   GIR_RootConstrainSelectedInstOperands,
     /* 366774 */   // GIR_Coverage, 1337,
     /* 366774 */   GIR_Done,
     /* 366775 */ // Label 7401: @366775
     /* 366775 */ GIM_Reject,
     /* 366776 */ // Label 7393: @366776
     /* 366776 */ GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(367073),
     /* 366781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 366787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366795 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366799 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(366818), // Rule ID 1333 //
     /* 366804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 366807 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 366807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 366812 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 366816 */     GIR_RootConstrainSelectedInstOperands,
     /* 366817 */     // GIR_Coverage, 1333,
     /* 366817 */     GIR_Done,
     /* 366818 */   // Label 7403: @366818
     /* 366818 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(367072), // Rule ID 6964 //
     /* 366823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 366826 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 366826 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 366829 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 366833 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366838 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 366842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 366844 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 366847 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 366851 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366856 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 366860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 366862 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 366865 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 366869 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366874 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 366877 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 366880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 366882 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 366885 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366889 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366894 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 366900 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366905 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366910 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 366913 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 366917 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366922 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 366925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 366927 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 366930 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366934 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366939 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 366945 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366950 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366955 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 366958 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 366962 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366967 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 366970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 366972 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 366975 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 366979 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366984 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 366987 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 366990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 366992 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 366995 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 366999 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367004 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 367007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 367009 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 367012 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367016 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 367023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 367026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367035 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 367038 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 367041 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 367044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367049 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 367062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 367070 */     GIR_RootConstrainSelectedInstOperands,
     /* 367071 */     // GIR_Coverage, 6964,
     /* 367071 */     GIR_EraseRootFromParent_Done,
     /* 367072 */   // Label 7404: @367072
     /* 367072 */   GIM_Reject,
     /* 367073 */ // Label 7402: @367073
     /* 367073 */ GIM_Reject,
     /* 367074 */ // Label 7394: @367074
     /* 367074 */ GIM_Reject,
     /* 367075 */ // Label 103: @367075
     /* 367075 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7413*/ GIMT_Encode4(370796),
     /* 367086 */ /*GILLT_s16*//*Label 7405*/ GIMT_Encode4(367126),
     /* 367090 */ /*GILLT_s32*//*Label 7406*/ GIMT_Encode4(367680),
     /* 367094 */ /*GILLT_s64*//*Label 7407*/ GIMT_Encode4(368228), GIMT_Encode4(0),
     /* 367102 */ /*GILLT_v2s32*//*Label 7408*/ GIMT_Encode4(368776),
     /* 367106 */ /*GILLT_v2s64*//*Label 7409*/ GIMT_Encode4(369306),
     /* 367110 */ /*GILLT_v4s16*//*Label 7410*/ GIMT_Encode4(369664),
     /* 367114 */ /*GILLT_v4s32*//*Label 7411*/ GIMT_Encode4(370006), GIMT_Encode4(0),
     /* 367122 */ /*GILLT_v8s16*//*Label 7412*/ GIMT_Encode4(370364),
     /* 367126 */ // Label 7405: @367126
     /* 367126 */ GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(367679),
     /* 367131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 367134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 367137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367141 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(367254), // Rule ID 6191 //
     /* 367146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 367149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367170 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367186 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 367199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367203 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 367207 */     // MIs[3] Operand 1
     /* 367207 */     // No operand predicates
     /* 367207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367209 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 367209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 367212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367221 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 367227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 367240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 367249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 367252 */     GIR_RootConstrainSelectedInstOperands,
     /* 367253 */     // GIR_Coverage, 6191,
     /* 367253 */     GIR_EraseRootFromParent_Done,
     /* 367254 */   // Label 7415: @367254
     /* 367254 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(367367), // Rule ID 13821 //
     /* 367259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 367262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367291 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 367295 */     // MIs[2] Operand 1
     /* 367295 */     // No operand predicates
     /* 367295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367299 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367303 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367307 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367311 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367316 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 367320 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367322 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 367322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 367325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367334 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 367340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 367353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 367362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 367365 */     GIR_RootConstrainSelectedInstOperands,
     /* 367366 */     // GIR_Coverage, 13821,
     /* 367366 */     GIR_EraseRootFromParent_Done,
     /* 367367 */   // Label 7416: @367367
     /* 367367 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(367446), // Rule ID 13758 //
     /* 367372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367396 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367406 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 367406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 367409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367418 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 367424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 367437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 367441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367444 */     GIR_RootConstrainSelectedInstOperands,
     /* 367445 */     // GIR_Coverage, 13758,
     /* 367445 */     GIR_EraseRootFromParent_Done,
     /* 367446 */   // Label 7417: @367446
     /* 367446 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(367525), // Rule ID 4781 //
     /* 367451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367479 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367485 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 367485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 367488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367497 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 367503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 367516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367523 */     GIR_RootConstrainSelectedInstOperands,
     /* 367524 */     // GIR_Coverage, 4781,
     /* 367524 */     GIR_EraseRootFromParent_Done,
     /* 367525 */   // Label 7418: @367525
     /* 367525 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(367588), // Rule ID 13373 //
     /* 367530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 367533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 367554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367562 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 367566 */     // MIs[2] Operand 1
     /* 367566 */     // No operand predicates
     /* 367566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367572 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 367572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 367575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 367579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 367583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 367586 */     GIR_RootConstrainSelectedInstOperands,
     /* 367587 */     // GIR_Coverage, 13373,
     /* 367587 */     GIR_EraseRootFromParent_Done,
     /* 367588 */   // Label 7419: @367588
     /* 367588 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(367651), // Rule ID 2004 //
     /* 367593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 367596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 367621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367629 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 367633 */     // MIs[2] Operand 1
     /* 367633 */     // No operand predicates
     /* 367633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367635 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 367635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 367638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 367646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 367649 */     GIR_RootConstrainSelectedInstOperands,
     /* 367650 */     // GIR_Coverage, 2004,
     /* 367650 */     GIR_EraseRootFromParent_Done,
     /* 367651 */   // Label 7420: @367651
     /* 367651 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(367678), // Rule ID 619 //
     /* 367656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367667 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 367667 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 367672 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367676 */     GIR_RootConstrainSelectedInstOperands,
     /* 367677 */     // GIR_Coverage, 619,
     /* 367677 */     GIR_Done,
     /* 367678 */   // Label 7421: @367678
     /* 367678 */   GIM_Reject,
     /* 367679 */ // Label 7414: @367679
     /* 367679 */ GIM_Reject,
     /* 367680 */ // Label 7406: @367680
     /* 367680 */ GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(368227),
     /* 367685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367695 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(367808), // Rule ID 6193 //
     /* 367700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367724 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 367753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367757 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367761 */     // MIs[3] Operand 1
     /* 367761 */     // No operand predicates
     /* 367761 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367763 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 367763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367775 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 367794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 367803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 367806 */     GIR_RootConstrainSelectedInstOperands,
     /* 367807 */     // GIR_Coverage, 6193,
     /* 367807 */     GIR_EraseRootFromParent_Done,
     /* 367808 */   // Label 7423: @367808
     /* 367808 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(367921), // Rule ID 13823 //
     /* 367813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367845 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367849 */     // MIs[2] Operand 1
     /* 367849 */     // No operand predicates
     /* 367849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 367853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367857 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367861 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367865 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367870 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 367874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367876 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 367876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367888 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 367894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 367907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 367916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 367919 */     GIR_RootConstrainSelectedInstOperands,
     /* 367920 */     // GIR_Coverage, 13823,
     /* 367920 */     GIR_EraseRootFromParent_Done,
     /* 367921 */   // Label 7424: @367921
     /* 367921 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(367997), // Rule ID 13760 //
     /* 367926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367947 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 367951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367957 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 367957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 367960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367969 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 367975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 367988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 367992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367995 */     GIR_RootConstrainSelectedInstOperands,
     /* 367996 */     // GIR_Coverage, 13760,
     /* 367996 */     GIR_EraseRootFromParent_Done,
     /* 367997 */   // Label 7425: @367997
     /* 367997 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(368073), // Rule ID 4783 //
     /* 368002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368027 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368033 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 368033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 368036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368045 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 368051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 368064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368066 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368071 */     GIR_RootConstrainSelectedInstOperands,
     /* 368072 */     // GIR_Coverage, 4783,
     /* 368072 */     GIR_EraseRootFromParent_Done,
     /* 368073 */   // Label 7426: @368073
     /* 368073 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(368136), // Rule ID 13375 //
     /* 368078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368110 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368114 */     // MIs[2] Operand 1
     /* 368114 */     // No operand predicates
     /* 368114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368120 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 368120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 368123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 368127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 368131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 368134 */     GIR_RootConstrainSelectedInstOperands,
     /* 368135 */     // GIR_Coverage, 13375,
     /* 368135 */     GIR_EraseRootFromParent_Done,
     /* 368136 */   // Label 7427: @368136
     /* 368136 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(368199), // Rule ID 2006 //
     /* 368141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368177 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368181 */     // MIs[2] Operand 1
     /* 368181 */     // No operand predicates
     /* 368181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368183 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 368183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 368186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 368194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 368197 */     GIR_RootConstrainSelectedInstOperands,
     /* 368198 */     // GIR_Coverage, 2006,
     /* 368198 */     GIR_EraseRootFromParent_Done,
     /* 368199 */   // Label 7428: @368199
     /* 368199 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(368226), // Rule ID 621 //
     /* 368204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368215 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 368215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 368220 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368224 */     GIR_RootConstrainSelectedInstOperands,
     /* 368225 */     // GIR_Coverage, 621,
     /* 368225 */     GIR_Done,
     /* 368226 */   // Label 7429: @368226
     /* 368226 */   GIM_Reject,
     /* 368227 */ // Label 7422: @368227
     /* 368227 */ GIM_Reject,
     /* 368228 */ // Label 7407: @368228
     /* 368228 */ GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(368775),
     /* 368233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 368236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 368239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368243 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(368356), // Rule ID 6195 //
     /* 368248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368272 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 368301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368305 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 368309 */     // MIs[3] Operand 1
     /* 368309 */     // No operand predicates
     /* 368309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368311 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 368311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 368314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368323 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 368329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 368342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 368354 */     GIR_RootConstrainSelectedInstOperands,
     /* 368355 */     // GIR_Coverage, 6195,
     /* 368355 */     GIR_EraseRootFromParent_Done,
     /* 368356 */   // Label 7431: @368356
     /* 368356 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(368469), // Rule ID 13825 //
     /* 368361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368393 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 368397 */     // MIs[2] Operand 1
     /* 368397 */     // No operand predicates
     /* 368397 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 368401 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368405 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368409 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 368413 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368418 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 368422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368424 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 368424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 368427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368436 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 368442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 368455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 368464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 368467 */     GIR_RootConstrainSelectedInstOperands,
     /* 368468 */     // GIR_Coverage, 13825,
     /* 368468 */     GIR_EraseRootFromParent_Done,
     /* 368469 */   // Label 7432: @368469
     /* 368469 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(368545), // Rule ID 13762 //
     /* 368474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368495 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368505 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 368505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 368508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368517 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 368523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 368536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 368540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368543 */     GIR_RootConstrainSelectedInstOperands,
     /* 368544 */     // GIR_Coverage, 13762,
     /* 368544 */     GIR_EraseRootFromParent_Done,
     /* 368545 */   // Label 7433: @368545
     /* 368545 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(368621), // Rule ID 4785 //
     /* 368550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368575 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 368579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 368581 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 368581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 368584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368593 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 368599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 368612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368619 */     GIR_RootConstrainSelectedInstOperands,
     /* 368620 */     // GIR_Coverage, 4785,
     /* 368620 */     GIR_EraseRootFromParent_Done,
     /* 368621 */   // Label 7434: @368621
     /* 368621 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(368684), // Rule ID 13377 //
     /* 368626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368658 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 368662 */     // MIs[2] Operand 1
     /* 368662 */     // No operand predicates
     /* 368662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368668 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 368668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 368671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 368675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 368679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 368682 */     GIR_RootConstrainSelectedInstOperands,
     /* 368683 */     // GIR_Coverage, 13377,
     /* 368683 */     GIR_EraseRootFromParent_Done,
     /* 368684 */   // Label 7435: @368684
     /* 368684 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(368747), // Rule ID 2008 //
     /* 368689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 368704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368725 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 368729 */     // MIs[2] Operand 1
     /* 368729 */     // No operand predicates
     /* 368729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368731 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 368731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 368734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 368742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 368745 */     GIR_RootConstrainSelectedInstOperands,
     /* 368746 */     // GIR_Coverage, 2008,
     /* 368746 */     GIR_EraseRootFromParent_Done,
     /* 368747 */   // Label 7436: @368747
     /* 368747 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(368774), // Rule ID 623 //
     /* 368752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368763 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 368763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 368768 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368772 */     GIR_RootConstrainSelectedInstOperands,
     /* 368773 */     // GIR_Coverage, 623,
     /* 368773 */     GIR_Done,
     /* 368774 */   // Label 7437: @368774
     /* 368774 */   GIM_Reject,
     /* 368775 */ // Label 7430: @368775
     /* 368775 */ GIM_Reject,
     /* 368776 */ // Label 7408: @368776
     /* 368776 */ GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(369305),
     /* 368781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 368784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 368787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368791 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(368877), // Rule ID 13365 //
     /* 368796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 368807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 368815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 368819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 368836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368840 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368844 */     // MIs[3] Operand 1
     /* 368844 */     // No operand predicates
     /* 368844 */     // MIs[1] Operand 2
     /* 368844 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 368855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368859 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368861 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 368861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 368864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 368868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 368875 */     GIR_RootConstrainSelectedInstOperands,
     /* 368876 */     // GIR_Coverage, 13365,
     /* 368876 */     GIR_EraseRootFromParent_Done,
     /* 368877 */   // Label 7439: @368877
     /* 368877 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(368963), // Rule ID 1996 //
     /* 368882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 368893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 368897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 368905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 368909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 368917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 368926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 368930 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 368934 */     // MIs[3] Operand 1
     /* 368934 */     // No operand predicates
     /* 368934 */     // MIs[1] Operand 2
     /* 368934 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 368945 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 368947 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 368947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 368950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 368952 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 368954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 368958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 368961 */     GIR_RootConstrainSelectedInstOperands,
     /* 368962 */     // GIR_Coverage, 1996,
     /* 368962 */     GIR_EraseRootFromParent_Done,
     /* 368963 */   // Label 7440: @368963
     /* 368963 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(369026), // Rule ID 13366 //
     /* 368968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 368979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 368987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 368996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369000 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369004 */     // MIs[2] Operand 1
     /* 369004 */     // No operand predicates
     /* 369004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369010 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 369010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 369013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369024 */     GIR_RootConstrainSelectedInstOperands,
     /* 369025 */     // GIR_Coverage, 13366,
     /* 369025 */     GIR_EraseRootFromParent_Done,
     /* 369026 */   // Label 7441: @369026
     /* 369026 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(369089), // Rule ID 1997 //
     /* 369031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 369046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369067 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 369071 */     // MIs[2] Operand 1
     /* 369071 */     // No operand predicates
     /* 369071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369073 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 369073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 369076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369087 */     GIR_RootConstrainSelectedInstOperands,
     /* 369088 */     // GIR_Coverage, 1997,
     /* 369088 */     GIR_EraseRootFromParent_Done,
     /* 369089 */   // Label 7442: @369089
     /* 369089 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(369183), // Rule ID 13827 //
     /* 369094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 369102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369117 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 369117 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 369120 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369124 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 369134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369143 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369150 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 369153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 369171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369181 */     GIR_RootConstrainSelectedInstOperands,
     /* 369182 */     // GIR_Coverage, 13827,
     /* 369182 */     GIR_EraseRootFromParent_Done,
     /* 369183 */   // Label 7443: @369183
     /* 369183 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(369277), // Rule ID 6197 //
     /* 369188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 369200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 369204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369211 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 369211 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 369214 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369218 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 369228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369237 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 369247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 369265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369275 */     GIR_RootConstrainSelectedInstOperands,
     /* 369276 */     // GIR_Coverage, 6197,
     /* 369276 */     GIR_EraseRootFromParent_Done,
     /* 369277 */   // Label 7444: @369277
     /* 369277 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(369304), // Rule ID 1315 //
     /* 369282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369293 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 369293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 369298 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369302 */     GIR_RootConstrainSelectedInstOperands,
     /* 369303 */     // GIR_Coverage, 1315,
     /* 369303 */     GIR_Done,
     /* 369304 */   // Label 7445: @369304
     /* 369304 */   GIM_Reject,
     /* 369305 */ // Label 7438: @369305
     /* 369305 */ GIM_Reject,
     /* 369306 */ // Label 7409: @369306
     /* 369306 */ GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(369663),
     /* 369311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 369314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 369317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369321 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(369384), // Rule ID 13371 //
     /* 369326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 369337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 369341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369358 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 369362 */     // MIs[2] Operand 1
     /* 369362 */     // No operand predicates
     /* 369362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369368 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 369368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 369371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369382 */     GIR_RootConstrainSelectedInstOperands,
     /* 369383 */     // GIR_Coverage, 13371,
     /* 369383 */     GIR_EraseRootFromParent_Done,
     /* 369384 */   // Label 7447: @369384
     /* 369384 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(369447), // Rule ID 2002 //
     /* 369389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 369404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 369408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369425 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 369429 */     // MIs[2] Operand 1
     /* 369429 */     // No operand predicates
     /* 369429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369431 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 369431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 369434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369445 */     GIR_RootConstrainSelectedInstOperands,
     /* 369446 */     // GIR_Coverage, 2002,
     /* 369446 */     GIR_EraseRootFromParent_Done,
     /* 369447 */   // Label 7448: @369447
     /* 369447 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(369541), // Rule ID 13831 //
     /* 369452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 369460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 369464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369475 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 369475 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 369478 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369482 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 369492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369501 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369508 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 369511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369516 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 369529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369539 */     GIR_RootConstrainSelectedInstOperands,
     /* 369540 */     // GIR_Coverage, 13831,
     /* 369540 */     GIR_EraseRootFromParent_Done,
     /* 369541 */   // Label 7449: @369541
     /* 369541 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(369635), // Rule ID 6201 //
     /* 369546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 369558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 369562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369569 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 369569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 369572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 369586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369595 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369598 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369602 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 369605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 369623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369633 */     GIR_RootConstrainSelectedInstOperands,
     /* 369634 */     // GIR_Coverage, 6201,
     /* 369634 */     GIR_EraseRootFromParent_Done,
     /* 369635 */   // Label 7450: @369635
     /* 369635 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(369662), // Rule ID 1319 //
     /* 369640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369651 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 369651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 369656 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369660 */     GIR_RootConstrainSelectedInstOperands,
     /* 369661 */     // GIR_Coverage, 1319,
     /* 369661 */     GIR_Done,
     /* 369662 */   // Label 7451: @369662
     /* 369662 */   GIM_Reject,
     /* 369663 */ // Label 7446: @369663
     /* 369663 */ GIM_Reject,
     /* 369664 */ // Label 7410: @369664
     /* 369664 */ GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(370005),
     /* 369669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 369672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 369675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369679 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(369765), // Rule ID 13359 //
     /* 369684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 369695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 369707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 369720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369728 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 369732 */     // MIs[3] Operand 1
     /* 369732 */     // No operand predicates
     /* 369732 */     // MIs[1] Operand 2
     /* 369732 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 369743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369749 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 369749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 369752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369763 */     GIR_RootConstrainSelectedInstOperands,
     /* 369764 */     // GIR_Coverage, 13359,
     /* 369764 */     GIR_EraseRootFromParent_Done,
     /* 369765 */   // Label 7453: @369765
     /* 369765 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(369851), // Rule ID 1990 //
     /* 369770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 369785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 369793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 369797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 369810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 369814 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369818 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 369822 */     // MIs[3] Operand 1
     /* 369822 */     // No operand predicates
     /* 369822 */     // MIs[1] Operand 2
     /* 369822 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 369833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369835 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 369835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 369838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 369846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 369849 */     GIR_RootConstrainSelectedInstOperands,
     /* 369850 */     // GIR_Coverage, 1990,
     /* 369850 */     GIR_EraseRootFromParent_Done,
     /* 369851 */   // Label 7454: @369851
     /* 369851 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(369914), // Rule ID 13360 //
     /* 369856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 369867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 369880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369888 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 369892 */     // MIs[2] Operand 1
     /* 369892 */     // No operand predicates
     /* 369892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369898 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 369898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 369901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 369905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369912 */     GIR_RootConstrainSelectedInstOperands,
     /* 369913 */     // GIR_Coverage, 13360,
     /* 369913 */     GIR_EraseRootFromParent_Done,
     /* 369914 */   // Label 7455: @369914
     /* 369914 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(369977), // Rule ID 1991 //
     /* 369919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 369934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 369947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369955 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 369959 */     // MIs[2] Operand 1
     /* 369959 */     // No operand predicates
     /* 369959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369961 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 369961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 369964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 369966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 369968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 369972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 369975 */     GIR_RootConstrainSelectedInstOperands,
     /* 369976 */     // GIR_Coverage, 1991,
     /* 369976 */     GIR_EraseRootFromParent_Done,
     /* 369977 */   // Label 7456: @369977
     /* 369977 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(370004), // Rule ID 1311 //
     /* 369982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369993 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 369993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 369998 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370002 */     GIR_RootConstrainSelectedInstOperands,
     /* 370003 */     // GIR_Coverage, 1311,
     /* 370003 */     GIR_Done,
     /* 370004 */   // Label 7457: @370004
     /* 370004 */   GIM_Reject,
     /* 370005 */ // Label 7452: @370005
     /* 370005 */ GIM_Reject,
     /* 370006 */ // Label 7411: @370006
     /* 370006 */ GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(370363),
     /* 370011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 370017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370021 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(370084), // Rule ID 13369 //
     /* 370026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 370037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370058 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 370062 */     // MIs[2] Operand 1
     /* 370062 */     // No operand predicates
     /* 370062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370068 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 370068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 370071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 370075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 370079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 370082 */     GIR_RootConstrainSelectedInstOperands,
     /* 370083 */     // GIR_Coverage, 13369,
     /* 370083 */     GIR_EraseRootFromParent_Done,
     /* 370084 */   // Label 7459: @370084
     /* 370084 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(370147), // Rule ID 2000 //
     /* 370089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 370104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370125 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 370129 */     // MIs[2] Operand 1
     /* 370129 */     // No operand predicates
     /* 370129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370131 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 370131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 370134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 370138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 370142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 370145 */     GIR_RootConstrainSelectedInstOperands,
     /* 370146 */     // GIR_Coverage, 2000,
     /* 370146 */     GIR_EraseRootFromParent_Done,
     /* 370147 */   // Label 7460: @370147
     /* 370147 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(370241), // Rule ID 13829 //
     /* 370152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 370160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370175 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 370175 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 370178 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370182 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 370189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 370192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370201 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370204 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 370208 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 370211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 370229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 370233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370239 */     GIR_RootConstrainSelectedInstOperands,
     /* 370240 */     // GIR_Coverage, 13829,
     /* 370240 */     GIR_EraseRootFromParent_Done,
     /* 370241 */   // Label 7461: @370241
     /* 370241 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(370335), // Rule ID 6199 //
     /* 370246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 370258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 370262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370269 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 370269 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 370272 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370276 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 370283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 370286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370295 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 370302 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 370305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 370323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 370327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370333 */     GIR_RootConstrainSelectedInstOperands,
     /* 370334 */     // GIR_Coverage, 6199,
     /* 370334 */     GIR_EraseRootFromParent_Done,
     /* 370335 */   // Label 7462: @370335
     /* 370335 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(370362), // Rule ID 1317 //
     /* 370340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370351 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 370351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 370356 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370360 */     GIR_RootConstrainSelectedInstOperands,
     /* 370361 */     // GIR_Coverage, 1317,
     /* 370361 */     GIR_Done,
     /* 370362 */   // Label 7463: @370362
     /* 370362 */   GIM_Reject,
     /* 370363 */ // Label 7458: @370363
     /* 370363 */ GIM_Reject,
     /* 370364 */ // Label 7412: @370364
     /* 370364 */ GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(370795),
     /* 370369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 370375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370379 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(370442), // Rule ID 13363 //
     /* 370384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 370387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 370395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 370408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370416 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 370420 */     // MIs[2] Operand 1
     /* 370420 */     // No operand predicates
     /* 370420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370426 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 370426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 370429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 370433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 370437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 370440 */     GIR_RootConstrainSelectedInstOperands,
     /* 370441 */     // GIR_Coverage, 13363,
     /* 370441 */     GIR_EraseRootFromParent_Done,
     /* 370442 */   // Label 7465: @370442
     /* 370442 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(370505), // Rule ID 1994 //
     /* 370447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 370450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 370462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 370475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370483 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 370487 */     // MIs[2] Operand 1
     /* 370487 */     // No operand predicates
     /* 370487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370489 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 370489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 370492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 370496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 370500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 370503 */     GIR_RootConstrainSelectedInstOperands,
     /* 370504 */     // GIR_Coverage, 1994,
     /* 370504 */     GIR_EraseRootFromParent_Done,
     /* 370505 */   // Label 7466: @370505
     /* 370505 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(370532), // Rule ID 1313 //
     /* 370510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 370513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370521 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 370521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 370526 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370530 */     GIR_RootConstrainSelectedInstOperands,
     /* 370531 */     // GIR_Coverage, 1313,
     /* 370531 */     GIR_Done,
     /* 370532 */   // Label 7467: @370532
     /* 370532 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(370794), // Rule ID 6962 //
     /* 370537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 370540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370548 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 370548 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 370551 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 370555 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370560 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 370564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 370566 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 370569 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 370573 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370578 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 370582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 370584 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 370587 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 370591 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370596 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 370599 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 370602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 370604 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 370607 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370611 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370616 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 370622 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370627 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370632 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 370635 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 370639 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370644 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 370647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 370649 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 370652 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370656 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370661 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370667 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370672 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370677 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 370680 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 370684 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370689 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 370692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 370694 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 370697 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 370701 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370706 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 370709 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 370712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 370714 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 370717 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 370721 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370726 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 370729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 370731 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370734 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370738 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 370745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370757 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370760 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 370763 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 370766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 370784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 370792 */     GIR_RootConstrainSelectedInstOperands,
     /* 370793 */     // GIR_Coverage, 6962,
     /* 370793 */     GIR_EraseRootFromParent_Done,
     /* 370794 */   // Label 7468: @370794
     /* 370794 */   GIM_Reject,
     /* 370795 */ // Label 7464: @370795
     /* 370795 */ GIM_Reject,
     /* 370796 */ // Label 7413: @370796
     /* 370796 */ GIM_Reject,
     /* 370797 */ // Label 104: @370797
     /* 370797 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7477*/ GIMT_Encode4(371412),
     /* 370808 */ /*GILLT_s16*//*Label 7469*/ GIMT_Encode4(370848),
     /* 370812 */ /*GILLT_s32*//*Label 7470*/ GIMT_Encode4(370886),
     /* 370816 */ /*GILLT_s64*//*Label 7471*/ GIMT_Encode4(370924), GIMT_Encode4(0),
     /* 370824 */ /*GILLT_v2s32*//*Label 7472*/ GIMT_Encode4(370962),
     /* 370828 */ /*GILLT_v2s64*//*Label 7473*/ GIMT_Encode4(371000),
     /* 370832 */ /*GILLT_v4s16*//*Label 7474*/ GIMT_Encode4(371038),
     /* 370836 */ /*GILLT_v4s32*//*Label 7475*/ GIMT_Encode4(371076), GIMT_Encode4(0),
     /* 370844 */ /*GILLT_v8s16*//*Label 7476*/ GIMT_Encode4(371114),
     /* 370848 */ // Label 7469: @370848
     /* 370848 */ GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(370885), // Rule ID 589 //
     /* 370853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 370856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 370859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370874 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 370874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 370879 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370883 */   GIR_RootConstrainSelectedInstOperands,
     /* 370884 */   // GIR_Coverage, 589,
     /* 370884 */   GIR_Done,
     /* 370885 */ // Label 7478: @370885
     /* 370885 */ GIM_Reject,
     /* 370886 */ // Label 7470: @370886
     /* 370886 */ GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(370923), // Rule ID 591 //
     /* 370891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370912 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 370912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 370917 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370921 */   GIR_RootConstrainSelectedInstOperands,
     /* 370922 */   // GIR_Coverage, 591,
     /* 370922 */   GIR_Done,
     /* 370923 */ // Label 7479: @370923
     /* 370923 */ GIM_Reject,
     /* 370924 */ // Label 7471: @370924
     /* 370924 */ GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(370961), // Rule ID 593 //
     /* 370929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 370935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 370938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370950 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 370950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 370955 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370959 */   GIR_RootConstrainSelectedInstOperands,
     /* 370960 */   // GIR_Coverage, 593,
     /* 370960 */   GIR_Done,
     /* 370961 */ // Label 7480: @370961
     /* 370961 */ GIM_Reject,
     /* 370962 */ // Label 7472: @370962
     /* 370962 */ GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(370999), // Rule ID 1220 //
     /* 370967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 370973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 370976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370988 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 370988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 370993 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370997 */   GIR_RootConstrainSelectedInstOperands,
     /* 370998 */   // GIR_Coverage, 1220,
     /* 370998 */   GIR_Done,
     /* 370999 */ // Label 7481: @370999
     /* 370999 */ GIM_Reject,
     /* 371000 */ // Label 7473: @371000
     /* 371000 */ GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(371037), // Rule ID 1224 //
     /* 371005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 371014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371026 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 371026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 371031 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371035 */   GIR_RootConstrainSelectedInstOperands,
     /* 371036 */   // GIR_Coverage, 1224,
     /* 371036 */   GIR_Done,
     /* 371037 */ // Label 7482: @371037
     /* 371037 */ GIM_Reject,
     /* 371038 */ // Label 7474: @371038
     /* 371038 */ GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(371075), // Rule ID 1216 //
     /* 371043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 371049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 371052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371064 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 371064 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 371069 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371073 */   GIR_RootConstrainSelectedInstOperands,
     /* 371074 */   // GIR_Coverage, 1216,
     /* 371074 */   GIR_Done,
     /* 371075 */ // Label 7483: @371075
     /* 371075 */ GIM_Reject,
     /* 371076 */ // Label 7475: @371076
     /* 371076 */ GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(371113), // Rule ID 1222 //
     /* 371081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 371090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371102 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 371102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 371107 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371111 */   GIR_RootConstrainSelectedInstOperands,
     /* 371112 */   // GIR_Coverage, 1222,
     /* 371112 */   GIR_Done,
     /* 371113 */ // Label 7484: @371113
     /* 371113 */ GIM_Reject,
     /* 371114 */ // Label 7476: @371114
     /* 371114 */ GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(371411),
     /* 371119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 371125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371137 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(371156), // Rule ID 1218 //
     /* 371142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371145 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 371145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 371150 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371154 */     GIR_RootConstrainSelectedInstOperands,
     /* 371155 */     // GIR_Coverage, 1218,
     /* 371155 */     GIR_Done,
     /* 371156 */   // Label 7486: @371156
     /* 371156 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(371410), // Rule ID 6960 //
     /* 371161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 371164 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 371164 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 371167 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 371171 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371176 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 371180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 371182 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 371185 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 371189 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371194 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 371198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 371200 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 371203 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 371207 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371212 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 371215 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 371218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 371220 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 371223 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371227 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371232 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371238 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371243 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371248 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 371251 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 371255 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371260 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 371263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 371265 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 371268 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371272 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371277 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371283 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371288 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371293 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 371296 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 371300 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371305 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 371308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 371310 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 371313 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 371317 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371322 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 371325 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 371328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 371330 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 371333 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 371337 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371342 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 371345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 371347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 371350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 371361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371376 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 371379 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 371382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 371400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 371408 */     GIR_RootConstrainSelectedInstOperands,
     /* 371409 */     // GIR_Coverage, 6960,
     /* 371409 */     GIR_EraseRootFromParent_Done,
     /* 371410 */   // Label 7487: @371410
     /* 371410 */   GIM_Reject,
     /* 371411 */ // Label 7485: @371411
     /* 371411 */ GIM_Reject,
     /* 371412 */ // Label 7477: @371412
     /* 371412 */ GIM_Reject,
     /* 371413 */ // Label 105: @371413
     /* 371413 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7496*/ GIMT_Encode4(387019),
     /* 371424 */ /*GILLT_s16*//*Label 7488*/ GIMT_Encode4(371464),
     /* 371428 */ /*GILLT_s32*//*Label 7489*/ GIMT_Encode4(374238),
     /* 371432 */ /*GILLT_s64*//*Label 7490*/ GIMT_Encode4(377168), GIMT_Encode4(0),
     /* 371440 */ /*GILLT_v2s32*//*Label 7491*/ GIMT_Encode4(380098),
     /* 371444 */ /*GILLT_v2s64*//*Label 7492*/ GIMT_Encode4(381619),
     /* 371448 */ /*GILLT_v4s16*//*Label 7493*/ GIMT_Encode4(383140),
     /* 371452 */ /*GILLT_v4s32*//*Label 7494*/ GIMT_Encode4(384319), GIMT_Encode4(0),
     /* 371460 */ /*GILLT_v8s16*//*Label 7495*/ GIMT_Encode4(385840),
     /* 371464 */ // Label 7488: @371464
     /* 371464 */ GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(374237),
     /* 371469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 371472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371475 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 371478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371482 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(371632), // Rule ID 4843 //
     /* 371487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 371490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371511 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371536 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 371544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371548 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 371552 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371559 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 371559 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 371562 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371566 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371571 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 371577 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371582 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371599 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 371605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 371618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 371626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 371630 */     GIR_RootConstrainSelectedInstOperands,
     /* 371631 */     // GIR_Coverage, 4843,
     /* 371631 */     GIR_EraseRootFromParent_Done,
     /* 371632 */   // Label 7498: @371632
     /* 371632 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(371779), // Rule ID 4807 //
     /* 371637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 371640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371661 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 371677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 371681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371685 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371689 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 371693 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371698 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 371702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371706 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371708 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 371708 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 371711 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371715 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371720 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 371726 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371731 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371748 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 371754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 371767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 371775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371777 */     GIR_RootConstrainSelectedInstOperands,
     /* 371778 */     // GIR_Coverage, 4807,
     /* 371778 */     GIR_EraseRootFromParent_Done,
     /* 371779 */   // Label 7499: @371779
     /* 371779 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(371926), // Rule ID 13771 //
     /* 371784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 371787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 371799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 371803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371820 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371832 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371836 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 371840 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371845 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 371849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371855 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 371855 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 371858 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371862 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371867 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 371873 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371878 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371895 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 371901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 371914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 371922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 371924 */     GIR_RootConstrainSelectedInstOperands,
     /* 371925 */     // GIR_Coverage, 13771,
     /* 371925 */     GIR_EraseRootFromParent_Done,
     /* 371926 */   // Label 7500: @371926
     /* 371926 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(372057), // Rule ID 6029 //
     /* 371931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371955 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 371967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 371971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 371975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371979 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371983 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 371987 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 371992 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 371996 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372000 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372004 */     // MIs[4] Operand 1
     /* 372004 */     // No operand predicates
     /* 372004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372008 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 372010 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 372010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372022 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 372028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 372041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 372052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 372055 */     GIR_RootConstrainSelectedInstOperands,
     /* 372056 */     // GIR_Coverage, 6029,
     /* 372056 */     GIR_EraseRootFromParent_Done,
     /* 372057 */   // Label 7501: @372057
     /* 372057 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(372188), // Rule ID 6061 //
     /* 372062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 372086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372094 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372098 */     // MIs[2] Operand 1
     /* 372098 */     // No operand predicates
     /* 372098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372106 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 372110 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 372114 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372118 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372122 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 372126 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372131 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 372135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372139 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 372141 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 372141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372153 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 372159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 372172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372186 */     GIR_RootConstrainSelectedInstOperands,
     /* 372187 */     // GIR_Coverage, 6061,
     /* 372187 */     GIR_EraseRootFromParent_Done,
     /* 372188 */   // Label 7502: @372188
     /* 372188 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(372319), // Rule ID 6125 //
     /* 372193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 372208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372229 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 372233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372241 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372245 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 372249 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 372254 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 372258 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372262 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372266 */     // MIs[4] Operand 1
     /* 372266 */     // No operand predicates
     /* 372266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372270 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 372272 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 372272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372284 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 372290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 372303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 372314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 372317 */     GIR_RootConstrainSelectedInstOperands,
     /* 372318 */     // GIR_Coverage, 6125,
     /* 372318 */     GIR_EraseRootFromParent_Done,
     /* 372319 */   // Label 7503: @372319
     /* 372319 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(372450), // Rule ID 6093 //
     /* 372324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 372339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 372343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372351 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 372360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372368 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372372 */     // MIs[3] Operand 1
     /* 372372 */     // No operand predicates
     /* 372372 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 372376 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372380 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372384 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 372388 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372393 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 372397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372401 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 372403 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 372403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372415 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 372421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 372434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372448 */     GIR_RootConstrainSelectedInstOperands,
     /* 372449 */     // GIR_Coverage, 6093,
     /* 372449 */     GIR_EraseRootFromParent_Done,
     /* 372450 */   // Label 7504: @372450
     /* 372450 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(372585), // Rule ID 2446 //
     /* 372455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372479 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372504 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 372508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372514 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 372514 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 372517 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372521 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372526 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 372532 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372554 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 372560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 372573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 372581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372583 */     GIR_RootConstrainSelectedInstOperands,
     /* 372584 */     // GIR_Coverage, 2446,
     /* 372584 */     GIR_EraseRootFromParent_Done,
     /* 372585 */   // Label 7505: @372585
     /* 372585 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(372704), // Rule ID 5997 //
     /* 372590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372614 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 372639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372647 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372651 */     // MIs[3] Operand 1
     /* 372651 */     // No operand predicates
     /* 372651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372657 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 372657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372669 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 372675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 372688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372702 */     GIR_RootConstrainSelectedInstOperands,
     /* 372703 */     // GIR_Coverage, 5997,
     /* 372703 */     GIR_EraseRootFromParent_Done,
     /* 372704 */   // Label 7506: @372704
     /* 372704 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(372823), // Rule ID 2528 //
     /* 372709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 372733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372741 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372745 */     // MIs[2] Operand 1
     /* 372745 */     // No operand predicates
     /* 372745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372753 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372757 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 372761 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372766 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 372770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372776 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 372776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372788 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 372794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372799 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 372807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 372811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372821 */     GIR_RootConstrainSelectedInstOperands,
     /* 372822 */     // GIR_Coverage, 2528,
     /* 372822 */     GIR_EraseRootFromParent_Done,
     /* 372823 */   // Label 7507: @372823
     /* 372823 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(372923), // Rule ID 4805 //
     /* 372828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372852 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 372868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372877 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372879 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 372879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372891 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 372897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 372910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 372921 */     GIR_RootConstrainSelectedInstOperands,
     /* 372922 */     // GIR_Coverage, 4805,
     /* 372922 */     GIR_EraseRootFromParent_Done,
     /* 372923 */   // Label 7508: @372923
     /* 372923 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(373023), // Rule ID 4841 //
     /* 372928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372952 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 372964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 372968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 372972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372979 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 372979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372991 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 372997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 373010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 373017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 373021 */     GIR_RootConstrainSelectedInstOperands,
     /* 373022 */     // GIR_Coverage, 4841,
     /* 373022 */     GIR_EraseRootFromParent_Done,
     /* 373023 */   // Label 7509: @373023
     /* 373023 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(373120), // Rule ID 13767 //
     /* 373028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 373031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 373043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373064 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 373068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373078 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 373078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373090 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 373096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 373109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 373118 */     GIR_RootConstrainSelectedInstOperands,
     /* 373119 */     // GIR_Coverage, 13767,
     /* 373119 */     GIR_EraseRootFromParent_Done,
     /* 373120 */   // Label 7510: @373120
     /* 373120 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(373220), // Rule ID 13769 //
     /* 373125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 373128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 373140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373166 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 373170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373176 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 373176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373188 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 373194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 373207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 373218 */     GIR_RootConstrainSelectedInstOperands,
     /* 373219 */     // GIR_Coverage, 13769,
     /* 373219 */     GIR_EraseRootFromParent_Done,
     /* 373220 */   // Label 7511: @373220
     /* 373220 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(373320), // Rule ID 4839 //
     /* 373225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 373228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373253 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 373261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 373269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373276 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 373276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373288 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 373294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 373307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 373318 */     GIR_RootConstrainSelectedInstOperands,
     /* 373319 */     // GIR_Coverage, 4839,
     /* 373319 */     GIR_EraseRootFromParent_Done,
     /* 373320 */   // Label 7512: @373320
     /* 373320 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(373417), // Rule ID 4803 //
     /* 373325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 373328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 373344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373365 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 373369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373375 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 373375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373387 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 373393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 373406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 373415 */     GIR_RootConstrainSelectedInstOperands,
     /* 373416 */     // GIR_Coverage, 4803,
     /* 373416 */     GIR_EraseRootFromParent_Done,
     /* 373417 */   // Label 7513: @373417
     /* 373417 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(373501), // Rule ID 6059 //
     /* 373422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 373446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373454 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373458 */     // MIs[2] Operand 1
     /* 373458 */     // No operand predicates
     /* 373458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373466 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 373470 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373479 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373481 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 373481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 373484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 373492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373499 */     GIR_RootConstrainSelectedInstOperands,
     /* 373500 */     // GIR_Coverage, 6059,
     /* 373500 */     GIR_EraseRootFromParent_Done,
     /* 373501 */   // Label 7514: @373501
     /* 373501 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(373582), // Rule ID 6091 //
     /* 373506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 373521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 373542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373550 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373554 */     // MIs[3] Operand 1
     /* 373554 */     // No operand predicates
     /* 373554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373564 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 373564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 373567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373580 */     GIR_RootConstrainSelectedInstOperands,
     /* 373581 */     // GIR_Coverage, 6091,
     /* 373581 */     GIR_EraseRootFromParent_Done,
     /* 373582 */   // Label 7515: @373582
     /* 373582 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(373666), // Rule ID 6123 //
     /* 373587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 373602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 373628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373636 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373640 */     // MIs[3] Operand 1
     /* 373640 */     // No operand predicates
     /* 373640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373644 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373646 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 373646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 373649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373664 */     GIR_RootConstrainSelectedInstOperands,
     /* 373665 */     // GIR_Coverage, 6123,
     /* 373665 */     GIR_EraseRootFromParent_Done,
     /* 373666 */   // Label 7516: @373666
     /* 373666 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(373747), // Rule ID 6027 //
     /* 373671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 373686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 373690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 373711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373719 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373723 */     // MIs[3] Operand 1
     /* 373723 */     // No operand predicates
     /* 373723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373727 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373729 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 373729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 373732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373745 */     GIR_RootConstrainSelectedInstOperands,
     /* 373746 */     // GIR_Coverage, 6027,
     /* 373746 */     GIR_EraseRootFromParent_Done,
     /* 373747 */   // Label 7517: @373747
     /* 373747 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(373832), // Rule ID 2444 //
     /* 373752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 373755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373776 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373790 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 373790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373802 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 373808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 373821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 373828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 373830 */     GIR_RootConstrainSelectedInstOperands,
     /* 373831 */     // GIR_Coverage, 2444,
     /* 373831 */     GIR_EraseRootFromParent_Done,
     /* 373832 */   // Label 7518: @373832
     /* 373832 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(373917), // Rule ID 2442 //
     /* 373837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 373840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373865 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373875 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 373875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373887 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 373893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 373906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 373915 */     GIR_RootConstrainSelectedInstOperands,
     /* 373916 */     // GIR_Coverage, 2442,
     /* 373916 */     GIR_EraseRootFromParent_Done,
     /* 373917 */   // Label 7519: @373917
     /* 373917 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(373986), // Rule ID 2526 //
     /* 373922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 373946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373954 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373958 */     // MIs[2] Operand 1
     /* 373958 */     // No operand predicates
     /* 373958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373968 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 373968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 373971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 373975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373984 */     GIR_RootConstrainSelectedInstOperands,
     /* 373985 */     // GIR_Coverage, 2526,
     /* 373985 */     GIR_EraseRootFromParent_Done,
     /* 373986 */   // Label 7520: @373986
     /* 373986 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(374055), // Rule ID 5995 //
     /* 373991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 373994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 374019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374027 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374031 */     // MIs[2] Operand 1
     /* 374031 */     // No operand predicates
     /* 374031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374037 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 374037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 374040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374053 */     GIR_RootConstrainSelectedInstOperands,
     /* 374054 */     // GIR_Coverage, 5995,
     /* 374054 */     GIR_EraseRootFromParent_Done,
     /* 374055 */   // Label 7521: @374055
     /* 374055 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(374105), // Rule ID 13213 //
     /* 374060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 374063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 374075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374090 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 374090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 374093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 374103 */     GIR_RootConstrainSelectedInstOperands,
     /* 374104 */     // GIR_Coverage, 13213,
     /* 374104 */     GIR_EraseRootFromParent_Done,
     /* 374105 */   // Label 7522: @374105
     /* 374105 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(374155), // Rule ID 643 //
     /* 374110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 374113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 374129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374140 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 374140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 374143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 374153 */     GIR_RootConstrainSelectedInstOperands,
     /* 374154 */     // GIR_Coverage, 643,
     /* 374154 */     GIR_EraseRootFromParent_Done,
     /* 374155 */   // Label 7523: @374155
     /* 374155 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(374205), // Rule ID 655 //
     /* 374160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 374163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 374175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 374183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374190 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 374190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 374193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 374199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 374203 */     GIR_RootConstrainSelectedInstOperands,
     /* 374204 */     // GIR_Coverage, 655,
     /* 374204 */     GIR_EraseRootFromParent_Done,
     /* 374205 */   // Label 7524: @374205
     /* 374205 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(374236), // Rule ID 637 //
     /* 374210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 374213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374225 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 374225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 374230 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374234 */     GIR_RootConstrainSelectedInstOperands,
     /* 374235 */     // GIR_Coverage, 637,
     /* 374235 */     GIR_Done,
     /* 374236 */   // Label 7525: @374236
     /* 374236 */   GIM_Reject,
     /* 374237 */ // Label 7497: @374237
     /* 374237 */ GIM_Reject,
     /* 374238 */ // Label 7489: @374238
     /* 374238 */ GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(377167),
     /* 374243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 374246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374249 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 374252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374256 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(374406), // Rule ID 4849 //
     /* 374261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374285 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 374289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374305 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374310 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 374314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 374318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374322 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 374326 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374333 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 374333 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 374336 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374340 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374345 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 374351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 374364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374373 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 374379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 374392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 374400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 374404 */     GIR_RootConstrainSelectedInstOperands,
     /* 374405 */     // GIR_Coverage, 4849,
     /* 374405 */     GIR_EraseRootFromParent_Done,
     /* 374406 */   // Label 7527: @374406
     /* 374406 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(374553), // Rule ID 4813 //
     /* 374411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374435 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 374439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374451 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374455 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374459 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374463 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 374467 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374472 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 374476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374480 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374482 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 374482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 374485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374494 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 374500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 374513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374522 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 374528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 374541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 374549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 374551 */     GIR_RootConstrainSelectedInstOperands,
     /* 374552 */     // GIR_Coverage, 4813,
     /* 374552 */     GIR_EraseRootFromParent_Done,
     /* 374553 */   // Label 7528: @374553
     /* 374553 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(374700), // Rule ID 13777 //
     /* 374558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 374561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374594 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 374598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374606 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374610 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 374614 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374619 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 374623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374629 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 374629 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 374632 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374636 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374641 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 374647 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374652 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 374660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374669 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 374675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 374688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 374696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 374698 */     GIR_RootConstrainSelectedInstOperands,
     /* 374699 */     // GIR_Coverage, 13777,
     /* 374699 */     GIR_EraseRootFromParent_Done,
     /* 374700 */   // Label 7529: @374700
     /* 374700 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(374831), // Rule ID 6045 //
     /* 374705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374729 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 374733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 374745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 374749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374753 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374757 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 374761 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374766 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 374770 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374774 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374778 */     // MIs[4] Operand 1
     /* 374778 */     // No operand predicates
     /* 374778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374782 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 374784 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 374787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374796 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 374802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 374815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 374826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 374829 */     GIR_RootConstrainSelectedInstOperands,
     /* 374830 */     // GIR_Coverage, 6045,
     /* 374830 */     GIR_EraseRootFromParent_Done,
     /* 374831 */   // Label 7530: @374831
     /* 374831 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(374962), // Rule ID 6077 //
     /* 374836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374868 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374872 */     // MIs[2] Operand 1
     /* 374872 */     // No operand predicates
     /* 374872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 374876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374880 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 374884 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 374888 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374892 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374896 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 374900 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374905 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 374909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374913 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 374915 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 374915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 374918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374927 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 374933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 374946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 374950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374960 */     GIR_RootConstrainSelectedInstOperands,
     /* 374961 */     // GIR_Coverage, 6077,
     /* 374961 */     GIR_EraseRootFromParent_Done,
     /* 374962 */   // Label 7531: @374962
     /* 374962 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(375093), // Rule ID 6141 //
     /* 374967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 374978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 374990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375003 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 375007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375015 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375019 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 375023 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375028 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 375032 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375036 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 375040 */     // MIs[4] Operand 1
     /* 375040 */     // No operand predicates
     /* 375040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375044 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 375046 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375058 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 375064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 375077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 375088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 375091 */     GIR_RootConstrainSelectedInstOperands,
     /* 375092 */     // GIR_Coverage, 6141,
     /* 375092 */     GIR_EraseRootFromParent_Done,
     /* 375093 */   // Label 7532: @375093
     /* 375093 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(375224), // Rule ID 6109 //
     /* 375098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375125 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375142 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 375146 */     // MIs[3] Operand 1
     /* 375146 */     // No operand predicates
     /* 375146 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 375150 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375154 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375158 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 375162 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375167 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 375171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375175 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 375177 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375189 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 375195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 375208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375222 */     GIR_RootConstrainSelectedInstOperands,
     /* 375223 */     // GIR_Coverage, 6109,
     /* 375223 */     GIR_EraseRootFromParent_Done,
     /* 375224 */   // Label 7533: @375224
     /* 375224 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(375359), // Rule ID 2452 //
     /* 375229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375253 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375269 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375278 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 375282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375288 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 375288 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 375291 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375295 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375300 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 375306 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375311 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375328 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 375334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 375347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 375355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 375357 */     GIR_RootConstrainSelectedInstOperands,
     /* 375358 */     // GIR_Coverage, 2452,
     /* 375358 */     GIR_EraseRootFromParent_Done,
     /* 375359 */   // Label 7534: @375359
     /* 375359 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(375478), // Rule ID 6013 //
     /* 375364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375388 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375408 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375421 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 375425 */     // MIs[3] Operand 1
     /* 375425 */     // No operand predicates
     /* 375425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375429 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375431 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375443 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 375449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 375462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 375476 */     GIR_RootConstrainSelectedInstOperands,
     /* 375477 */     // GIR_Coverage, 6013,
     /* 375477 */     GIR_EraseRootFromParent_Done,
     /* 375478 */   // Label 7535: @375478
     /* 375478 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(375597), // Rule ID 2544 //
     /* 375483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375515 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 375519 */     // MIs[2] Operand 1
     /* 375519 */     // No operand predicates
     /* 375519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 375523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375527 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375531 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 375535 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375540 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 375544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375550 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 375550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375562 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 375568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 375581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 375585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375595 */     GIR_RootConstrainSelectedInstOperands,
     /* 375596 */     // GIR_Coverage, 2544,
     /* 375596 */     GIR_EraseRootFromParent_Done,
     /* 375597 */   // Label 7536: @375597
     /* 375597 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(375697), // Rule ID 4811 //
     /* 375602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375626 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375653 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 375653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375665 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 375671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 375684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 375693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 375695 */     GIR_RootConstrainSelectedInstOperands,
     /* 375696 */     // GIR_Coverage, 4811,
     /* 375696 */     GIR_EraseRootFromParent_Done,
     /* 375697 */   // Label 7537: @375697
     /* 375697 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(375797), // Rule ID 4847 //
     /* 375702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375726 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 375730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 375738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 375746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375753 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 375753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375765 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 375771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 375784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 375791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 375795 */     GIR_RootConstrainSelectedInstOperands,
     /* 375796 */     // GIR_Coverage, 4847,
     /* 375796 */     GIR_EraseRootFromParent_Done,
     /* 375797 */   // Label 7538: @375797
     /* 375797 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(375894), // Rule ID 13773 //
     /* 375802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 375821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375838 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 375842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375852 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 375852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375864 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 375870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 375883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 375892 */     GIR_RootConstrainSelectedInstOperands,
     /* 375893 */     // GIR_Coverage, 13773,
     /* 375893 */     GIR_EraseRootFromParent_Done,
     /* 375894 */   // Label 7539: @375894
     /* 375894 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(375994), // Rule ID 13775 //
     /* 375899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 375910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375940 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 375944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375950 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 375950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 375953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375962 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 375968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 375981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 375992 */     GIR_RootConstrainSelectedInstOperands,
     /* 375993 */     // GIR_Coverage, 13775,
     /* 375993 */     GIR_EraseRootFromParent_Done,
     /* 375994 */   // Label 7540: @375994
     /* 375994 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(376094), // Rule ID 4845 //
     /* 375999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 376002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376027 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 376035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 376043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376050 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 376050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 376053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376062 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 376068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 376081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 376092 */     GIR_RootConstrainSelectedInstOperands,
     /* 376093 */     // GIR_Coverage, 4845,
     /* 376093 */     GIR_EraseRootFromParent_Done,
     /* 376094 */   // Label 7541: @376094
     /* 376094 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(376191), // Rule ID 4809 //
     /* 376099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 376102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376130 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376139 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 376143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376149 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 376149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 376152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376161 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 376167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 376180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 376189 */     GIR_RootConstrainSelectedInstOperands,
     /* 376190 */     // GIR_Coverage, 4809,
     /* 376190 */     GIR_EraseRootFromParent_Done,
     /* 376191 */   // Label 7542: @376191
     /* 376191 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(376269), // Rule ID 6163 //
     /* 376196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 376233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376237 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376241 */     // MIs[3] Operand 1
     /* 376241 */     // No operand predicates
     /* 376241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376249 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376251 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 376254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376267 */     GIR_RootConstrainSelectedInstOperands,
     /* 376268 */     // GIR_Coverage, 6163,
     /* 376268 */     GIR_EraseRootFromParent_Done,
     /* 376269 */   // Label 7543: @376269
     /* 376269 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(376353), // Rule ID 6075 //
     /* 376274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376306 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376310 */     // MIs[2] Operand 1
     /* 376310 */     // No operand predicates
     /* 376310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376318 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 376322 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376333 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 376336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 376344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376351 */     GIR_RootConstrainSelectedInstOperands,
     /* 376352 */     // GIR_Coverage, 6075,
     /* 376352 */     GIR_EraseRootFromParent_Done,
     /* 376353 */   // Label 7544: @376353
     /* 376353 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(376434), // Rule ID 6107 //
     /* 376358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376402 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376406 */     // MIs[3] Operand 1
     /* 376406 */     // No operand predicates
     /* 376406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376414 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376416 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 376419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376432 */     GIR_RootConstrainSelectedInstOperands,
     /* 376433 */     // GIR_Coverage, 6107,
     /* 376433 */     GIR_EraseRootFromParent_Done,
     /* 376434 */   // Label 7545: @376434
     /* 376434 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(376518), // Rule ID 6139 //
     /* 376439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376488 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376492 */     // MIs[3] Operand 1
     /* 376492 */     // No operand predicates
     /* 376492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376498 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 376501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376516 */     GIR_RootConstrainSelectedInstOperands,
     /* 376517 */     // GIR_Coverage, 6139,
     /* 376517 */     GIR_EraseRootFromParent_Done,
     /* 376518 */   // Label 7546: @376518
     /* 376518 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(376596), // Rule ID 6185 //
     /* 376523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 376564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376568 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376572 */     // MIs[3] Operand 1
     /* 376572 */     // No operand predicates
     /* 376572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376576 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376578 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 376581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376594 */     GIR_RootConstrainSelectedInstOperands,
     /* 376595 */     // GIR_Coverage, 6185,
     /* 376595 */     GIR_EraseRootFromParent_Done,
     /* 376596 */   // Label 7547: @376596
     /* 376596 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(376677), // Rule ID 6043 //
     /* 376601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 376620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376649 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376653 */     // MIs[3] Operand 1
     /* 376653 */     // No operand predicates
     /* 376653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376659 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 376662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376675 */     GIR_RootConstrainSelectedInstOperands,
     /* 376676 */     // GIR_Coverage, 6043,
     /* 376676 */     GIR_EraseRootFromParent_Done,
     /* 376677 */   // Label 7548: @376677
     /* 376677 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(376762), // Rule ID 2450 //
     /* 376682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 376685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376706 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376720 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 376720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 376723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376732 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 376738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 376751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 376758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 376760 */     GIR_RootConstrainSelectedInstOperands,
     /* 376761 */     // GIR_Coverage, 2450,
     /* 376761 */     GIR_EraseRootFromParent_Done,
     /* 376762 */   // Label 7549: @376762
     /* 376762 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(376847), // Rule ID 2448 //
     /* 376767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 376770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376795 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376805 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 376805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 376808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376817 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 376823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 376836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 376845 */     GIR_RootConstrainSelectedInstOperands,
     /* 376846 */     // GIR_Coverage, 2448,
     /* 376846 */     GIR_EraseRootFromParent_Done,
     /* 376847 */   // Label 7550: @376847
     /* 376847 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(376916), // Rule ID 2542 //
     /* 376852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376884 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376888 */     // MIs[2] Operand 1
     /* 376888 */     // No operand predicates
     /* 376888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376898 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 376901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 376907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376914 */     GIR_RootConstrainSelectedInstOperands,
     /* 376915 */     // GIR_Coverage, 2542,
     /* 376915 */     GIR_EraseRootFromParent_Done,
     /* 376916 */   // Label 7551: @376916
     /* 376916 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(376985), // Rule ID 6011 //
     /* 376921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376957 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 376961 */     // MIs[2] Operand 1
     /* 376961 */     // No operand predicates
     /* 376961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376967 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 376967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 376970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376983 */     GIR_RootConstrainSelectedInstOperands,
     /* 376984 */     // GIR_Coverage, 6011,
     /* 376984 */     GIR_EraseRootFromParent_Done,
     /* 376985 */   // Label 7552: @376985
     /* 376985 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(377035), // Rule ID 13215 //
     /* 376990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 376993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377020 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 377020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 377023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377033 */     GIR_RootConstrainSelectedInstOperands,
     /* 377034 */     // GIR_Coverage, 13215,
     /* 377034 */     GIR_EraseRootFromParent_Done,
     /* 377035 */   // Label 7553: @377035
     /* 377035 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(377085), // Rule ID 645 //
     /* 377040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 377043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377070 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 377070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 377073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377083 */     GIR_RootConstrainSelectedInstOperands,
     /* 377084 */     // GIR_Coverage, 645,
     /* 377084 */     GIR_EraseRootFromParent_Done,
     /* 377085 */   // Label 7554: @377085
     /* 377085 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(377135), // Rule ID 657 //
     /* 377090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 377093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 377105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 377113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377120 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 377120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 377123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 377129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 377133 */     GIR_RootConstrainSelectedInstOperands,
     /* 377134 */     // GIR_Coverage, 657,
     /* 377134 */     GIR_EraseRootFromParent_Done,
     /* 377135 */   // Label 7555: @377135
     /* 377135 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(377166), // Rule ID 639 //
     /* 377140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 377143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377155 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 377155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 377160 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 377164 */     GIR_RootConstrainSelectedInstOperands,
     /* 377165 */     // GIR_Coverage, 639,
     /* 377165 */     GIR_Done,
     /* 377166 */   // Label 7556: @377166
     /* 377166 */   GIM_Reject,
     /* 377167 */ // Label 7526: @377167
     /* 377167 */ GIM_Reject,
     /* 377168 */ // Label 7490: @377168
     /* 377168 */ GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(380097),
     /* 377173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 377176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 377179 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377186 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(377336), // Rule ID 4855 //
     /* 377191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 377194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377215 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377240 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377244 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 377248 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377252 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 377256 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377261 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377263 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 377263 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 377266 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377270 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377275 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 377281 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377303 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 377309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 377322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 377330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 377334 */     GIR_RootConstrainSelectedInstOperands,
     /* 377335 */     // GIR_Coverage, 4855,
     /* 377335 */     GIR_EraseRootFromParent_Done,
     /* 377336 */   // Label 7558: @377336
     /* 377336 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(377483), // Rule ID 4819 //
     /* 377341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 377344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377365 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 377381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 377385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377389 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377393 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377397 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377402 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 377406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377412 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 377412 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 377415 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377419 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377424 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 377430 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377435 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377452 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 377458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 377471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 377479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377481 */     GIR_RootConstrainSelectedInstOperands,
     /* 377482 */     // GIR_Coverage, 4819,
     /* 377482 */     GIR_EraseRootFromParent_Done,
     /* 377483 */   // Label 7559: @377483
     /* 377483 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(377630), // Rule ID 13783 //
     /* 377488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 377491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 377503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377515 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377524 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377536 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377540 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377544 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377549 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 377553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377559 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 377559 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 377562 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377566 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377571 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 377577 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377582 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377599 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 377605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 377618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 377626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377628 */     GIR_RootConstrainSelectedInstOperands,
     /* 377629 */     // GIR_Coverage, 13783,
     /* 377629 */     GIR_EraseRootFromParent_Done,
     /* 377630 */   // Label 7560: @377630
     /* 377630 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(377761), // Rule ID 6049 //
     /* 377635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377659 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 377675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 377679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377687 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377691 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377696 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 377700 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377704 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377708 */     // MIs[4] Operand 1
     /* 377708 */     // No operand predicates
     /* 377708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377712 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 377714 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 377714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377726 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 377732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 377745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 377756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 377759 */     GIR_RootConstrainSelectedInstOperands,
     /* 377760 */     // GIR_Coverage, 6049,
     /* 377760 */     GIR_EraseRootFromParent_Done,
     /* 377761 */   // Label 7561: @377761
     /* 377761 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(377892), // Rule ID 6081 //
     /* 377766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377798 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377802 */     // MIs[2] Operand 1
     /* 377802 */     // No operand predicates
     /* 377802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377810 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 377814 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 377818 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377822 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377826 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 377830 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377835 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 377839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377843 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 377845 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 377845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377857 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 377863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 377876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377890 */     GIR_RootConstrainSelectedInstOperands,
     /* 377891 */     // GIR_Coverage, 6081,
     /* 377891 */     GIR_EraseRootFromParent_Done,
     /* 377892 */   // Label 7562: @377892
     /* 377892 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(378023), // Rule ID 6145 //
     /* 377897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 377912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377933 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377945 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 377949 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377953 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377958 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 377962 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377966 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 377970 */     // MIs[4] Operand 1
     /* 377970 */     // No operand predicates
     /* 377970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377974 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 377976 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 377976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377988 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 377994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 378007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 378018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 378021 */     GIR_RootConstrainSelectedInstOperands,
     /* 378022 */     // GIR_Coverage, 6145,
     /* 378022 */     GIR_EraseRootFromParent_Done,
     /* 378023 */   // Label 7563: @378023
     /* 378023 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(378154), // Rule ID 6113 //
     /* 378028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 378043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378072 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 378076 */     // MIs[3] Operand 1
     /* 378076 */     // No operand predicates
     /* 378076 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 378080 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378084 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378088 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 378092 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378097 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 378101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378105 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 378107 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 378107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378119 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 378125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 378138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378152 */     GIR_RootConstrainSelectedInstOperands,
     /* 378153 */     // GIR_Coverage, 6113,
     /* 378153 */     GIR_EraseRootFromParent_Done,
     /* 378154 */   // Label 7564: @378154
     /* 378154 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(378289), // Rule ID 2458 //
     /* 378159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378183 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378208 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 378212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378218 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 378218 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 378221 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378225 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378230 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 378236 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378241 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378258 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 378264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 378277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 378285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378287 */     GIR_RootConstrainSelectedInstOperands,
     /* 378288 */     // GIR_Coverage, 2458,
     /* 378288 */     GIR_EraseRootFromParent_Done,
     /* 378289 */   // Label 7565: @378289
     /* 378289 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(378408), // Rule ID 6017 //
     /* 378294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378318 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378338 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378351 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 378355 */     // MIs[3] Operand 1
     /* 378355 */     // No operand predicates
     /* 378355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378359 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378361 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 378361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378373 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 378379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 378392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378406 */     GIR_RootConstrainSelectedInstOperands,
     /* 378407 */     // GIR_Coverage, 6017,
     /* 378407 */     GIR_EraseRootFromParent_Done,
     /* 378408 */   // Label 7566: @378408
     /* 378408 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(378527), // Rule ID 2548 //
     /* 378413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 378416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378445 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 378449 */     // MIs[2] Operand 1
     /* 378449 */     // No operand predicates
     /* 378449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378457 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378461 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 378465 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378470 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 378474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378480 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 378480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378492 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 378498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378503 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 378511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378525 */     GIR_RootConstrainSelectedInstOperands,
     /* 378526 */     // GIR_Coverage, 2548,
     /* 378526 */     GIR_EraseRootFromParent_Done,
     /* 378527 */   // Label 7567: @378527
     /* 378527 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(378627), // Rule ID 4817 //
     /* 378532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378556 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 378572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378583 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 378583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378595 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 378601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 378614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378625 */     GIR_RootConstrainSelectedInstOperands,
     /* 378626 */     // GIR_Coverage, 4817,
     /* 378626 */     GIR_EraseRootFromParent_Done,
     /* 378627 */   // Label 7568: @378627
     /* 378627 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(378727), // Rule ID 4853 //
     /* 378632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378656 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 378668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 378676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378683 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 378683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378695 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 378701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 378714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 378721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 378725 */     GIR_RootConstrainSelectedInstOperands,
     /* 378726 */     // GIR_Coverage, 4853,
     /* 378726 */     GIR_EraseRootFromParent_Done,
     /* 378727 */   // Label 7569: @378727
     /* 378727 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(378824), // Rule ID 13779 //
     /* 378732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 378747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378768 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 378772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378782 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 378782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378794 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 378800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 378813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378822 */     GIR_RootConstrainSelectedInstOperands,
     /* 378823 */     // GIR_Coverage, 13779,
     /* 378823 */     GIR_EraseRootFromParent_Done,
     /* 378824 */   // Label 7570: @378824
     /* 378824 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(378924), // Rule ID 13781 //
     /* 378829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 378844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378861 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378870 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 378874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378880 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 378880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378892 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 378898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 378911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378922 */     GIR_RootConstrainSelectedInstOperands,
     /* 378923 */     // GIR_Coverage, 13781,
     /* 378923 */     GIR_EraseRootFromParent_Done,
     /* 378924 */   // Label 7571: @378924
     /* 378924 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(379024), // Rule ID 4851 //
     /* 378929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 378948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378957 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 378965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 378973 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378980 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 378980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378992 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 378998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 379011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 379022 */     GIR_RootConstrainSelectedInstOperands,
     /* 379023 */     // GIR_Coverage, 4851,
     /* 379023 */     GIR_EraseRootFromParent_Done,
     /* 379024 */   // Label 7572: @379024
     /* 379024 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(379121), // Rule ID 4815 //
     /* 379029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 379048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 379060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379069 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 379073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379079 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 379079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379091 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 379097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 379110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379119 */     GIR_RootConstrainSelectedInstOperands,
     /* 379120 */     // GIR_Coverage, 4815,
     /* 379120 */     GIR_EraseRootFromParent_Done,
     /* 379121 */   // Label 7573: @379121
     /* 379121 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(379199), // Rule ID 6167 //
     /* 379126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 379138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 379154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 379163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379167 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379171 */     // MIs[3] Operand 1
     /* 379171 */     // No operand predicates
     /* 379171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379179 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379181 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 379181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 379184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379197 */     GIR_RootConstrainSelectedInstOperands,
     /* 379198 */     // GIR_Coverage, 6167,
     /* 379198 */     GIR_EraseRootFromParent_Done,
     /* 379199 */   // Label 7574: @379199
     /* 379199 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(379283), // Rule ID 6079 //
     /* 379204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 379219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379236 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 379240 */     // MIs[2] Operand 1
     /* 379240 */     // No operand predicates
     /* 379240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379248 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 379252 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379261 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379263 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 379263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 379266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 379274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379281 */     GIR_RootConstrainSelectedInstOperands,
     /* 379282 */     // GIR_Coverage, 6079,
     /* 379282 */     GIR_EraseRootFromParent_Done,
     /* 379283 */   // Label 7575: @379283
     /* 379283 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(379364), // Rule ID 6111 //
     /* 379288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 379303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 379315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379332 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 379336 */     // MIs[3] Operand 1
     /* 379336 */     // No operand predicates
     /* 379336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379344 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379346 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 379346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 379349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379362 */     GIR_RootConstrainSelectedInstOperands,
     /* 379363 */     // GIR_Coverage, 6111,
     /* 379363 */     GIR_EraseRootFromParent_Done,
     /* 379364 */   // Label 7576: @379364
     /* 379364 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(379448), // Rule ID 6143 //
     /* 379369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 379384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 379401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379418 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 379422 */     // MIs[3] Operand 1
     /* 379422 */     // No operand predicates
     /* 379422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379428 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 379428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 379431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 379439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379446 */     GIR_RootConstrainSelectedInstOperands,
     /* 379447 */     // GIR_Coverage, 6143,
     /* 379447 */     GIR_EraseRootFromParent_Done,
     /* 379448 */   // Label 7577: @379448
     /* 379448 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(379526), // Rule ID 6189 //
     /* 379453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 379469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 379485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 379494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379498 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379502 */     // MIs[3] Operand 1
     /* 379502 */     // No operand predicates
     /* 379502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379508 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 379508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 379511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379524 */     GIR_RootConstrainSelectedInstOperands,
     /* 379525 */     // GIR_Coverage, 6189,
     /* 379525 */     GIR_EraseRootFromParent_Done,
     /* 379526 */   // Label 7578: @379526
     /* 379526 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(379607), // Rule ID 6047 //
     /* 379531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 379550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 379562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379579 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 379583 */     // MIs[3] Operand 1
     /* 379583 */     // No operand predicates
     /* 379583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379589 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 379589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 379592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379605 */     GIR_RootConstrainSelectedInstOperands,
     /* 379606 */     // GIR_Coverage, 6047,
     /* 379606 */     GIR_EraseRootFromParent_Done,
     /* 379607 */   // Label 7579: @379607
     /* 379607 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(379692), // Rule ID 2456 //
     /* 379612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 379627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379636 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379650 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 379650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379662 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 379668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 379681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 379688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379690 */     GIR_RootConstrainSelectedInstOperands,
     /* 379691 */     // GIR_Coverage, 2456,
     /* 379691 */     GIR_EraseRootFromParent_Done,
     /* 379692 */   // Label 7580: @379692
     /* 379692 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(379777), // Rule ID 2454 //
     /* 379697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 379716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379725 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379735 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 379735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379747 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 379753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 379766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379775 */     GIR_RootConstrainSelectedInstOperands,
     /* 379776 */     // GIR_Coverage, 2454,
     /* 379776 */     GIR_EraseRootFromParent_Done,
     /* 379777 */   // Label 7581: @379777
     /* 379777 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(379846), // Rule ID 2546 //
     /* 379782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 379797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379814 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 379818 */     // MIs[2] Operand 1
     /* 379818 */     // No operand predicates
     /* 379818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379828 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 379828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 379831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379844 */     GIR_RootConstrainSelectedInstOperands,
     /* 379845 */     // GIR_Coverage, 2546,
     /* 379845 */     GIR_EraseRootFromParent_Done,
     /* 379846 */   // Label 7582: @379846
     /* 379846 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(379915), // Rule ID 6015 //
     /* 379851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 379870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379887 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 379891 */     // MIs[2] Operand 1
     /* 379891 */     // No operand predicates
     /* 379891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379897 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 379897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 379900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379913 */     GIR_RootConstrainSelectedInstOperands,
     /* 379914 */     // GIR_Coverage, 6015,
     /* 379914 */     GIR_EraseRootFromParent_Done,
     /* 379915 */   // Label 7583: @379915
     /* 379915 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(379965), // Rule ID 13217 //
     /* 379920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 379935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379950 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 379950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 379953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379963 */     GIR_RootConstrainSelectedInstOperands,
     /* 379964 */     // GIR_Coverage, 13217,
     /* 379964 */     GIR_EraseRootFromParent_Done,
     /* 379965 */   // Label 7584: @379965
     /* 379965 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(380015), // Rule ID 647 //
     /* 379970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 379989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 380000 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 380000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 380003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380013 */     GIR_RootConstrainSelectedInstOperands,
     /* 380014 */     // GIR_Coverage, 647,
     /* 380014 */     GIR_EraseRootFromParent_Done,
     /* 380015 */   // Label 7585: @380015
     /* 380015 */   GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(380065), // Rule ID 659 //
     /* 380020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 380035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 380043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 380050 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 380050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 380053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 380059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 380063 */     GIR_RootConstrainSelectedInstOperands,
     /* 380064 */     // GIR_Coverage, 659,
     /* 380064 */     GIR_EraseRootFromParent_Done,
     /* 380065 */   // Label 7586: @380065
     /* 380065 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(380096), // Rule ID 641 //
     /* 380070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380085 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 380085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 380090 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 380094 */     GIR_RootConstrainSelectedInstOperands,
     /* 380095 */     // GIR_Coverage, 641,
     /* 380095 */     GIR_Done,
     /* 380096 */   // Label 7587: @380096
     /* 380096 */   GIM_Reject,
     /* 380097 */ // Label 7557: @380097
     /* 380097 */ GIM_Reject,
     /* 380098 */ // Label 7491: @380098
     /* 380098 */ GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(381618),
     /* 380103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 380109 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 380112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380116 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(380194), // Rule ID 6147 //
     /* 380121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380149 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 380158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380162 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380166 */     // MIs[3] Operand 1
     /* 380166 */     // No operand predicates
     /* 380166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380176 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 380179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380192 */     GIR_RootConstrainSelectedInstOperands,
     /* 380193 */     // GIR_Coverage, 6147,
     /* 380193 */     GIR_EraseRootFromParent_Done,
     /* 380194 */   // Label 7589: @380194
     /* 380194 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(380278), // Rule ID 6063 //
     /* 380199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380231 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380235 */     // MIs[2] Operand 1
     /* 380235 */     // No operand predicates
     /* 380235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380239 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380243 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380247 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380256 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380258 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 380261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 380269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 380276 */     GIR_RootConstrainSelectedInstOperands,
     /* 380277 */     // GIR_Coverage, 6063,
     /* 380277 */     GIR_EraseRootFromParent_Done,
     /* 380278 */   // Label 7590: @380278
     /* 380278 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(380359), // Rule ID 6095 //
     /* 380283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380323 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380327 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380331 */     // MIs[3] Operand 1
     /* 380331 */     // No operand predicates
     /* 380331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380341 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 380344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380357 */     GIR_RootConstrainSelectedInstOperands,
     /* 380358 */     // GIR_Coverage, 6095,
     /* 380358 */     GIR_EraseRootFromParent_Done,
     /* 380359 */   // Label 7591: @380359
     /* 380359 */   GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(380443), // Rule ID 6127 //
     /* 380364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380413 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380417 */     // MIs[3] Operand 1
     /* 380417 */     // No operand predicates
     /* 380417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380421 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380423 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 380426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 380434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380441 */     GIR_RootConstrainSelectedInstOperands,
     /* 380442 */     // GIR_Coverage, 6127,
     /* 380442 */     GIR_EraseRootFromParent_Done,
     /* 380443 */   // Label 7592: @380443
     /* 380443 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(380521), // Rule ID 6169 //
     /* 380448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 380489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380493 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380497 */     // MIs[3] Operand 1
     /* 380497 */     // No operand predicates
     /* 380497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380503 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 380506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380519 */     GIR_RootConstrainSelectedInstOperands,
     /* 380520 */     // GIR_Coverage, 6169,
     /* 380520 */     GIR_EraseRootFromParent_Done,
     /* 380521 */   // Label 7593: @380521
     /* 380521 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(380602), // Rule ID 6031 //
     /* 380526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380574 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380578 */     // MIs[3] Operand 1
     /* 380578 */     // No operand predicates
     /* 380578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380584 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 380587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380600 */     GIR_RootConstrainSelectedInstOperands,
     /* 380601 */     // GIR_Coverage, 6031,
     /* 380601 */     GIR_EraseRootFromParent_Done,
     /* 380602 */   // Label 7594: @380602
     /* 380602 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(380671), // Rule ID 2530 //
     /* 380607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380639 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380643 */     // MIs[2] Operand 1
     /* 380643 */     // No operand predicates
     /* 380643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380653 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 380656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 380669 */     GIR_RootConstrainSelectedInstOperands,
     /* 380670 */     // GIR_Coverage, 2530,
     /* 380670 */     GIR_EraseRootFromParent_Done,
     /* 380671 */   // Label 7595: @380671
     /* 380671 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(380740), // Rule ID 5999 //
     /* 380676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 380691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380712 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380716 */     // MIs[2] Operand 1
     /* 380716 */     // No operand predicates
     /* 380716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380722 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 380725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380729 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 380738 */     GIR_RootConstrainSelectedInstOperands,
     /* 380739 */     // GIR_Coverage, 5999,
     /* 380739 */     GIR_EraseRootFromParent_Done,
     /* 380740 */   // Label 7596: @380740
     /* 380740 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(380833), // Rule ID 6151 //
     /* 380745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 380753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380784 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 380784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 380787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380796 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 380799 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380803 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 380806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 380819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380831 */     GIR_RootConstrainSelectedInstOperands,
     /* 380832 */     // GIR_Coverage, 6151,
     /* 380832 */     GIR_EraseRootFromParent_Done,
     /* 380833 */   // Label 7597: @380833
     /* 380833 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(380932), // Rule ID 6065 //
     /* 380838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 380849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380870 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380881 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 380881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 380884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380893 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 380896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380900 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 380903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 380916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 380924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380930 */     GIR_RootConstrainSelectedInstOperands,
     /* 380931 */     // GIR_Coverage, 6065,
     /* 380931 */     GIR_EraseRootFromParent_Done,
     /* 380932 */   // Label 7598: @380932
     /* 380932 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(381028), // Rule ID 6097 //
     /* 380937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 380952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 380960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 380977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380979 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 380979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 380982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380991 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 380994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380998 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 381001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 381014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381026 */     GIR_RootConstrainSelectedInstOperands,
     /* 381027 */     // GIR_Coverage, 6097,
     /* 381027 */     GIR_EraseRootFromParent_Done,
     /* 381028 */   // Label 7599: @381028
     /* 381028 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(381127), // Rule ID 6129 //
     /* 381033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 381061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381076 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 381076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 381079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381088 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 381091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381095 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 381098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 381111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381125 */     GIR_RootConstrainSelectedInstOperands,
     /* 381126 */     // GIR_Coverage, 6129,
     /* 381126 */     GIR_EraseRootFromParent_Done,
     /* 381127 */   // Label 7600: @381127
     /* 381127 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(381220), // Rule ID 6173 //
     /* 381132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 381144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381171 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 381171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 381174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381183 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 381186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381190 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 381193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 381206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381210 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381218 */     GIR_RootConstrainSelectedInstOperands,
     /* 381219 */     // GIR_Coverage, 6173,
     /* 381219 */     GIR_EraseRootFromParent_Done,
     /* 381220 */   // Label 7601: @381220
     /* 381220 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(381316), // Rule ID 6033 //
     /* 381225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 381252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381267 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 381267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 381270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381279 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 381282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381286 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 381289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 381302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381314 */     GIR_RootConstrainSelectedInstOperands,
     /* 381315 */     // GIR_Coverage, 6033,
     /* 381315 */     GIR_EraseRootFromParent_Done,
     /* 381316 */   // Label 7602: @381316
     /* 381316 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(381400), // Rule ID 2532 //
     /* 381321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 381332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381351 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 381351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 381354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381363 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 381366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381370 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 381373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 381386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381398 */     GIR_RootConstrainSelectedInstOperands,
     /* 381399 */     // GIR_Coverage, 2532,
     /* 381399 */     GIR_EraseRootFromParent_Done,
     /* 381400 */   // Label 7603: @381400
     /* 381400 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(381450), // Rule ID 13247 //
     /* 381405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381435 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 381435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 381438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381448 */     GIR_RootConstrainSelectedInstOperands,
     /* 381449 */     // GIR_Coverage, 13247,
     /* 381449 */     GIR_EraseRootFromParent_Done,
     /* 381450 */   // Label 7604: @381450
     /* 381450 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(381534), // Rule ID 6001 //
     /* 381455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 381470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381485 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 381485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 381488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381497 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 381500 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381504 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 381507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 381520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381532 */     GIR_RootConstrainSelectedInstOperands,
     /* 381533 */     // GIR_Coverage, 6001,
     /* 381533 */     GIR_EraseRootFromParent_Done,
     /* 381534 */   // Label 7605: @381534
     /* 381534 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(381584), // Rule ID 1300 //
     /* 381539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 381558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381569 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 381569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 381572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381582 */     GIR_RootConstrainSelectedInstOperands,
     /* 381583 */     // GIR_Coverage, 1300,
     /* 381583 */     GIR_EraseRootFromParent_Done,
     /* 381584 */   // Label 7606: @381584
     /* 381584 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(381617), // Rule ID 1290 //
     /* 381589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381604 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 381604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 381607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 381615 */     GIR_RootConstrainSelectedInstOperands,
     /* 381616 */     // GIR_Coverage, 1290,
     /* 381616 */     GIR_EraseRootFromParent_Done,
     /* 381617 */   // Label 7607: @381617
     /* 381617 */   GIM_Reject,
     /* 381618 */ // Label 7588: @381618
     /* 381618 */ GIM_Reject,
     /* 381619 */ // Label 7492: @381619
     /* 381619 */ GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(383139),
     /* 381624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 381630 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 381633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381637 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(381715), // Rule ID 6159 //
     /* 381642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 381650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 381679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381683 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 381687 */     // MIs[3] Operand 1
     /* 381687 */     // No operand predicates
     /* 381687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381697 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 381700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381713 */     GIR_RootConstrainSelectedInstOperands,
     /* 381714 */     // GIR_Coverage, 6159,
     /* 381714 */     GIR_EraseRootFromParent_Done,
     /* 381715 */   // Label 7609: @381715
     /* 381715 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(381799), // Rule ID 6071 //
     /* 381720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 381731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381752 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 381756 */     // MIs[2] Operand 1
     /* 381756 */     // No operand predicates
     /* 381756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381779 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 381782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 381790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381797 */     GIR_RootConstrainSelectedInstOperands,
     /* 381798 */     // GIR_Coverage, 6071,
     /* 381798 */     GIR_EraseRootFromParent_Done,
     /* 381799 */   // Label 7610: @381799
     /* 381799 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(381880), // Rule ID 6103 //
     /* 381804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 381827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381848 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 381852 */     // MIs[3] Operand 1
     /* 381852 */     // No operand predicates
     /* 381852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381860 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381862 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 381865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381878 */     GIR_RootConstrainSelectedInstOperands,
     /* 381879 */     // GIR_Coverage, 6103,
     /* 381879 */     GIR_EraseRootFromParent_Done,
     /* 381880 */   // Label 7611: @381880
     /* 381880 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(381964), // Rule ID 6135 //
     /* 381885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 381913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381934 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 381938 */     // MIs[3] Operand 1
     /* 381938 */     // No operand predicates
     /* 381938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381944 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 381947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381962 */     GIR_RootConstrainSelectedInstOperands,
     /* 381963 */     // GIR_Coverage, 6135,
     /* 381963 */     GIR_EraseRootFromParent_Done,
     /* 381964 */   // Label 7612: @381964
     /* 381964 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(382042), // Rule ID 6181 //
     /* 381969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 381981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 382010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382014 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382018 */     // MIs[3] Operand 1
     /* 382018 */     // No operand predicates
     /* 382018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382024 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 382024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 382027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 382040 */     GIR_RootConstrainSelectedInstOperands,
     /* 382041 */     // GIR_Coverage, 6181,
     /* 382041 */     GIR_EraseRootFromParent_Done,
     /* 382042 */   // Label 7613: @382042
     /* 382042 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(382123), // Rule ID 6039 //
     /* 382047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 382074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382095 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382099 */     // MIs[3] Operand 1
     /* 382099 */     // No operand predicates
     /* 382099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382105 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 382105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 382108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 382121 */     GIR_RootConstrainSelectedInstOperands,
     /* 382122 */     // GIR_Coverage, 6039,
     /* 382122 */     GIR_EraseRootFromParent_Done,
     /* 382123 */   // Label 7614: @382123
     /* 382123 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(382192), // Rule ID 2538 //
     /* 382128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 382139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382160 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382164 */     // MIs[2] Operand 1
     /* 382164 */     // No operand predicates
     /* 382164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382174 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 382174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 382177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382190 */     GIR_RootConstrainSelectedInstOperands,
     /* 382191 */     // GIR_Coverage, 2538,
     /* 382191 */     GIR_EraseRootFromParent_Done,
     /* 382192 */   // Label 7615: @382192
     /* 382192 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(382261), // Rule ID 6007 //
     /* 382197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 382212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382233 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382237 */     // MIs[2] Operand 1
     /* 382237 */     // No operand predicates
     /* 382237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382243 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 382243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 382246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382259 */     GIR_RootConstrainSelectedInstOperands,
     /* 382260 */     // GIR_Coverage, 6007,
     /* 382260 */     GIR_EraseRootFromParent_Done,
     /* 382261 */   // Label 7616: @382261
     /* 382261 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(382354), // Rule ID 6161 //
     /* 382266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 382274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 382278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 382290 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382305 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 382305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 382308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382317 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 382320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382324 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 382327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 382340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382352 */     GIR_RootConstrainSelectedInstOperands,
     /* 382353 */     // GIR_Coverage, 6161,
     /* 382353 */     GIR_EraseRootFromParent_Done,
     /* 382354 */   // Label 7617: @382354
     /* 382354 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(382453), // Rule ID 6073 //
     /* 382359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 382370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 382374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382402 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 382402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 382405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382414 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 382417 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382421 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 382424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 382437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 382445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382451 */     GIR_RootConstrainSelectedInstOperands,
     /* 382452 */     // GIR_Coverage, 6073,
     /* 382452 */     GIR_EraseRootFromParent_Done,
     /* 382453 */   // Label 7618: @382453
     /* 382453 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(382549), // Rule ID 6105 //
     /* 382458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 382481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 382485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382500 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 382500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 382503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382512 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 382515 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382519 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 382522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 382535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382547 */     GIR_RootConstrainSelectedInstOperands,
     /* 382548 */     // GIR_Coverage, 6105,
     /* 382548 */     GIR_EraseRootFromParent_Done,
     /* 382549 */   // Label 7619: @382549
     /* 382549 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(382648), // Rule ID 6137 //
     /* 382554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 382582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 382586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382597 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 382597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 382600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382609 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 382612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382616 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 382619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 382632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 382640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382646 */     GIR_RootConstrainSelectedInstOperands,
     /* 382647 */     // GIR_Coverage, 6137,
     /* 382647 */     GIR_EraseRootFromParent_Done,
     /* 382648 */   // Label 7620: @382648
     /* 382648 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(382741), // Rule ID 6183 //
     /* 382653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 382665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 382669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 382681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382692 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 382692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 382695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382704 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 382707 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382711 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 382714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 382727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382739 */     GIR_RootConstrainSelectedInstOperands,
     /* 382740 */     // GIR_Coverage, 6183,
     /* 382740 */     GIR_EraseRootFromParent_Done,
     /* 382741 */   // Label 7621: @382741
     /* 382741 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(382837), // Rule ID 6041 //
     /* 382746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 382773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 382777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382788 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 382788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 382791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382800 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 382803 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382807 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 382810 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 382823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382835 */     GIR_RootConstrainSelectedInstOperands,
     /* 382836 */     // GIR_Coverage, 6041,
     /* 382836 */     GIR_EraseRootFromParent_Done,
     /* 382837 */   // Label 7622: @382837
     /* 382837 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(382921), // Rule ID 2540 //
     /* 382842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 382853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 382857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382872 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 382872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 382875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382884 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 382887 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382891 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 382894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 382907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382919 */     GIR_RootConstrainSelectedInstOperands,
     /* 382920 */     // GIR_Coverage, 2540,
     /* 382920 */     GIR_EraseRootFromParent_Done,
     /* 382921 */   // Label 7623: @382921
     /* 382921 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(382971), // Rule ID 13251 //
     /* 382926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382956 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 382956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 382959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382969 */     GIR_RootConstrainSelectedInstOperands,
     /* 382970 */     // GIR_Coverage, 13251,
     /* 382970 */     GIR_EraseRootFromParent_Done,
     /* 382971 */   // Label 7624: @382971
     /* 382971 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(383055), // Rule ID 6009 //
     /* 382976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 382991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 382995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383006 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 383006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 383009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383018 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 383021 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383025 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 383028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 383041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383045 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383053 */     GIR_RootConstrainSelectedInstOperands,
     /* 383054 */     // GIR_Coverage, 6009,
     /* 383054 */     GIR_EraseRootFromParent_Done,
     /* 383055 */   // Label 7625: @383055
     /* 383055 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(383105), // Rule ID 1304 //
     /* 383060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 383090 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 383090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 383093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383103 */     GIR_RootConstrainSelectedInstOperands,
     /* 383104 */     // GIR_Coverage, 1304,
     /* 383104 */     GIR_EraseRootFromParent_Done,
     /* 383105 */   // Label 7626: @383105
     /* 383105 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(383138), // Rule ID 1294 //
     /* 383110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383125 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 383125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 383128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 383136 */     GIR_RootConstrainSelectedInstOperands,
     /* 383137 */     // GIR_Coverage, 1294,
     /* 383137 */     GIR_EraseRootFromParent_Done,
     /* 383138 */   // Label 7627: @383138
     /* 383138 */   GIM_Reject,
     /* 383139 */ // Label 7608: @383139
     /* 383139 */ GIM_Reject,
     /* 383140 */ // Label 7493: @383140
     /* 383140 */ GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(384318),
     /* 383145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 383151 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 383154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383158 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(383242), // Rule ID 6055 //
     /* 383163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 383174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 383187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 383191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383195 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 383199 */     // MIs[2] Operand 1
     /* 383199 */     // No operand predicates
     /* 383199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383207 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383211 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383222 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 383222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 383225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 383233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 383240 */     GIR_RootConstrainSelectedInstOperands,
     /* 383241 */     // GIR_Coverage, 6055,
     /* 383241 */     GIR_EraseRootFromParent_Done,
     /* 383242 */   // Label 7629: @383242
     /* 383242 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(383323), // Rule ID 6087 //
     /* 383247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 383270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 383283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383291 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 383295 */     // MIs[3] Operand 1
     /* 383295 */     // No operand predicates
     /* 383295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383305 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 383305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 383308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383321 */     GIR_RootConstrainSelectedInstOperands,
     /* 383322 */     // GIR_Coverage, 6087,
     /* 383322 */     GIR_EraseRootFromParent_Done,
     /* 383323 */   // Label 7630: @383323
     /* 383323 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(383407), // Rule ID 6119 //
     /* 383328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 383356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 383369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383373 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383377 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 383381 */     // MIs[3] Operand 1
     /* 383381 */     // No operand predicates
     /* 383381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383387 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 383387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 383390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 383398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383405 */     GIR_RootConstrainSelectedInstOperands,
     /* 383406 */     // GIR_Coverage, 6119,
     /* 383406 */     GIR_EraseRootFromParent_Done,
     /* 383407 */   // Label 7631: @383407
     /* 383407 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(383488), // Rule ID 6023 //
     /* 383412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 383439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 383452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383460 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 383464 */     // MIs[3] Operand 1
     /* 383464 */     // No operand predicates
     /* 383464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383470 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 383470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 383473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383486 */     GIR_RootConstrainSelectedInstOperands,
     /* 383487 */     // GIR_Coverage, 6023,
     /* 383487 */     GIR_EraseRootFromParent_Done,
     /* 383488 */   // Label 7632: @383488
     /* 383488 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(383557), // Rule ID 2522 //
     /* 383493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 383504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 383517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 383521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383525 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 383529 */     // MIs[2] Operand 1
     /* 383529 */     // No operand predicates
     /* 383529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383539 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 383539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 383542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 383555 */     GIR_RootConstrainSelectedInstOperands,
     /* 383556 */     // GIR_Coverage, 2522,
     /* 383556 */     GIR_EraseRootFromParent_Done,
     /* 383557 */   // Label 7633: @383557
     /* 383557 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(383626), // Rule ID 5991 //
     /* 383562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 383577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 383581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 383590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 383594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383598 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 383602 */     // MIs[2] Operand 1
     /* 383602 */     // No operand predicates
     /* 383602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383608 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 383608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 383611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 383624 */     GIR_RootConstrainSelectedInstOperands,
     /* 383625 */     // GIR_Coverage, 5991,
     /* 383625 */     GIR_EraseRootFromParent_Done,
     /* 383626 */   // Label 7634: @383626
     /* 383626 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(383725), // Rule ID 6057 //
     /* 383631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 383642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 383646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 383651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383674 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 383674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 383677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383686 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 383689 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383693 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 383696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 383706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 383709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 383717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383723 */     GIR_RootConstrainSelectedInstOperands,
     /* 383724 */     // GIR_Coverage, 6057,
     /* 383724 */     GIR_EraseRootFromParent_Done,
     /* 383725 */   // Label 7635: @383725
     /* 383725 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(383821), // Rule ID 6089 //
     /* 383730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 383753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 383762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383772 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 383772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 383775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383784 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 383787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383791 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 383794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383799 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 383804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 383807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383819 */     GIR_RootConstrainSelectedInstOperands,
     /* 383820 */     // GIR_Coverage, 6089,
     /* 383820 */     GIR_EraseRootFromParent_Done,
     /* 383821 */   // Label 7636: @383821
     /* 383821 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(383920), // Rule ID 6121 //
     /* 383826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 383854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 383863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383869 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 383869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 383872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383881 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 383884 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383888 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 383891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 383901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 383904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 383912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383918 */     GIR_RootConstrainSelectedInstOperands,
     /* 383919 */     // GIR_Coverage, 6121,
     /* 383919 */     GIR_EraseRootFromParent_Done,
     /* 383920 */   // Label 7637: @383920
     /* 383920 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(384016), // Rule ID 6025 //
     /* 383925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 383928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 383944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 383952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 383956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 383961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383967 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 383967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 383970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383979 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 383982 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383986 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 383989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 383999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 384002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384014 */     GIR_RootConstrainSelectedInstOperands,
     /* 384015 */     // GIR_Coverage, 6025,
     /* 384015 */     GIR_EraseRootFromParent_Done,
     /* 384016 */   // Label 7638: @384016
     /* 384016 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(384100), // Rule ID 2524 //
     /* 384021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 384024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 384032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 384041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384051 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 384051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 384054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384063 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 384066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384070 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 384073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 384083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 384086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384098 */     GIR_RootConstrainSelectedInstOperands,
     /* 384099 */     // GIR_Coverage, 2524,
     /* 384099 */     GIR_EraseRootFromParent_Done,
     /* 384100 */   // Label 7639: @384100
     /* 384100 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(384150), // Rule ID 13243 //
     /* 384105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 384108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 384120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384135 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 384135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 384138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384148 */     GIR_RootConstrainSelectedInstOperands,
     /* 384149 */     // GIR_Coverage, 13243,
     /* 384149 */     GIR_EraseRootFromParent_Done,
     /* 384150 */   // Label 7640: @384150
     /* 384150 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(384234), // Rule ID 5993 //
     /* 384155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 384158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 384170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 384174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 384179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384185 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 384185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 384188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384197 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 384200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384204 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 384207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 384217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 384220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384232 */     GIR_RootConstrainSelectedInstOperands,
     /* 384233 */     // GIR_Coverage, 5993,
     /* 384233 */     GIR_EraseRootFromParent_Done,
     /* 384234 */   // Label 7641: @384234
     /* 384234 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(384284), // Rule ID 1296 //
     /* 384239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 384242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 384258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384269 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 384269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 384272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384282 */     GIR_RootConstrainSelectedInstOperands,
     /* 384283 */     // GIR_Coverage, 1296,
     /* 384283 */     GIR_EraseRootFromParent_Done,
     /* 384284 */   // Label 7642: @384284
     /* 384284 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(384317), // Rule ID 1286 //
     /* 384289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 384292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384304 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 384304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 384307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 384315 */     GIR_RootConstrainSelectedInstOperands,
     /* 384316 */     // GIR_Coverage, 1286,
     /* 384316 */     GIR_EraseRootFromParent_Done,
     /* 384317 */   // Label 7643: @384317
     /* 384317 */   GIM_Reject,
     /* 384318 */ // Label 7628: @384318
     /* 384318 */ GIM_Reject,
     /* 384319 */ // Label 7494: @384319
     /* 384319 */ GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(385839),
     /* 384324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 384330 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 384333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384337 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(384415), // Rule ID 6153 //
     /* 384342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 384379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384383 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384387 */     // MIs[3] Operand 1
     /* 384387 */     // No operand predicates
     /* 384387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384397 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 384400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384413 */     GIR_RootConstrainSelectedInstOperands,
     /* 384414 */     // GIR_Coverage, 6153,
     /* 384414 */     GIR_EraseRootFromParent_Done,
     /* 384415 */   // Label 7645: @384415
     /* 384415 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(384499), // Rule ID 6067 //
     /* 384420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384452 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384456 */     // MIs[2] Operand 1
     /* 384456 */     // No operand predicates
     /* 384456 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 384460 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384464 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384468 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384477 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384479 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 384482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 384490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384497 */     GIR_RootConstrainSelectedInstOperands,
     /* 384498 */     // GIR_Coverage, 6067,
     /* 384498 */     GIR_EraseRootFromParent_Done,
     /* 384499 */   // Label 7646: @384499
     /* 384499 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(384580), // Rule ID 6099 //
     /* 384504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384531 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384535 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384548 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384552 */     // MIs[3] Operand 1
     /* 384552 */     // No operand predicates
     /* 384552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384560 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384562 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 384565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384578 */     GIR_RootConstrainSelectedInstOperands,
     /* 384579 */     // GIR_Coverage, 6099,
     /* 384579 */     GIR_EraseRootFromParent_Done,
     /* 384580 */   // Label 7647: @384580
     /* 384580 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(384664), // Rule ID 6131 //
     /* 384585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384634 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384638 */     // MIs[3] Operand 1
     /* 384638 */     // No operand predicates
     /* 384638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384644 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 384647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384662 */     GIR_RootConstrainSelectedInstOperands,
     /* 384663 */     // GIR_Coverage, 6131,
     /* 384663 */     GIR_EraseRootFromParent_Done,
     /* 384664 */   // Label 7648: @384664
     /* 384664 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(384742), // Rule ID 6175 //
     /* 384669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 384710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384714 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384718 */     // MIs[3] Operand 1
     /* 384718 */     // No operand predicates
     /* 384718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384724 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 384727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384740 */     GIR_RootConstrainSelectedInstOperands,
     /* 384741 */     // GIR_Coverage, 6175,
     /* 384741 */     GIR_EraseRootFromParent_Done,
     /* 384742 */   // Label 7649: @384742
     /* 384742 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(384823), // Rule ID 6035 //
     /* 384747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384795 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384799 */     // MIs[3] Operand 1
     /* 384799 */     // No operand predicates
     /* 384799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384805 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 384808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384821 */     GIR_RootConstrainSelectedInstOperands,
     /* 384822 */     // GIR_Coverage, 6035,
     /* 384822 */     GIR_EraseRootFromParent_Done,
     /* 384823 */   // Label 7650: @384823
     /* 384823 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(384892), // Rule ID 2534 //
     /* 384828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384860 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384864 */     // MIs[2] Operand 1
     /* 384864 */     // No operand predicates
     /* 384864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384874 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 384877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384890 */     GIR_RootConstrainSelectedInstOperands,
     /* 384891 */     // GIR_Coverage, 2534,
     /* 384891 */     GIR_EraseRootFromParent_Done,
     /* 384892 */   // Label 7651: @384892
     /* 384892 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(384961), // Rule ID 6003 //
     /* 384897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384937 */     // MIs[2] Operand 1
     /* 384937 */     // No operand predicates
     /* 384937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384943 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 384946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384959 */     GIR_RootConstrainSelectedInstOperands,
     /* 384960 */     // GIR_Coverage, 6003,
     /* 384960 */     GIR_EraseRootFromParent_Done,
     /* 384961 */   // Label 7652: @384961
     /* 384961 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(385054), // Rule ID 6157 //
     /* 384966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 384974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 384978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 384990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 384995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385005 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385017 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385020 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385024 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 385040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385052 */     GIR_RootConstrainSelectedInstOperands,
     /* 385053 */     // GIR_Coverage, 6157,
     /* 385053 */     GIR_EraseRootFromParent_Done,
     /* 385054 */   // Label 7653: @385054
     /* 385054 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(385153), // Rule ID 6069 //
     /* 385059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 385070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385091 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385102 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385114 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385117 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385121 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 385137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 385145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385151 */     GIR_RootConstrainSelectedInstOperands,
     /* 385152 */     // GIR_Coverage, 6069,
     /* 385152 */     GIR_EraseRootFromParent_Done,
     /* 385153 */   // Label 7654: @385153
     /* 385153 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(385249), // Rule ID 6101 //
     /* 385158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 385181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385200 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385212 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385215 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385219 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 385235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385247 */     GIR_RootConstrainSelectedInstOperands,
     /* 385248 */     // GIR_Coverage, 6101,
     /* 385248 */     GIR_EraseRootFromParent_Done,
     /* 385249 */   // Label 7655: @385249
     /* 385249 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(385348), // Rule ID 6133 //
     /* 385254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 385282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385297 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385309 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385316 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 385332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385346 */     GIR_RootConstrainSelectedInstOperands,
     /* 385347 */     // GIR_Coverage, 6133,
     /* 385347 */     GIR_EraseRootFromParent_Done,
     /* 385348 */   // Label 7656: @385348
     /* 385348 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(385441), // Rule ID 6179 //
     /* 385353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 385365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385392 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385404 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385407 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385411 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385414 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 385427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385439 */     GIR_RootConstrainSelectedInstOperands,
     /* 385440 */     // GIR_Coverage, 6179,
     /* 385440 */     GIR_EraseRootFromParent_Done,
     /* 385441 */   // Label 7657: @385441
     /* 385441 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(385537), // Rule ID 6037 //
     /* 385446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 385473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385488 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385500 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385503 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385507 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 385523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385535 */     GIR_RootConstrainSelectedInstOperands,
     /* 385536 */     // GIR_Coverage, 6037,
     /* 385536 */     GIR_EraseRootFromParent_Done,
     /* 385537 */   // Label 7658: @385537
     /* 385537 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(385621), // Rule ID 2536 //
     /* 385542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 385553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385572 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385584 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385591 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 385607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385619 */     GIR_RootConstrainSelectedInstOperands,
     /* 385620 */     // GIR_Coverage, 2536,
     /* 385620 */     GIR_EraseRootFromParent_Done,
     /* 385621 */   // Label 7659: @385621
     /* 385621 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(385671), // Rule ID 13249 //
     /* 385626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385656 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 385656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 385659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385669 */     GIR_RootConstrainSelectedInstOperands,
     /* 385670 */     // GIR_Coverage, 13249,
     /* 385670 */     GIR_EraseRootFromParent_Done,
     /* 385671 */   // Label 7660: @385671
     /* 385671 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(385755), // Rule ID 6005 //
     /* 385676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 385691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385706 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385725 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 385741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385753 */     GIR_RootConstrainSelectedInstOperands,
     /* 385754 */     // GIR_Coverage, 6005,
     /* 385754 */     GIR_EraseRootFromParent_Done,
     /* 385755 */   // Label 7661: @385755
     /* 385755 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(385805), // Rule ID 1302 //
     /* 385760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385790 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 385790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 385793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385803 */     GIR_RootConstrainSelectedInstOperands,
     /* 385804 */     // GIR_Coverage, 1302,
     /* 385804 */     GIR_EraseRootFromParent_Done,
     /* 385805 */   // Label 7662: @385805
     /* 385805 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(385838), // Rule ID 1292 //
     /* 385810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385825 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 385825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 385828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 385836 */     GIR_RootConstrainSelectedInstOperands,
     /* 385837 */     // GIR_Coverage, 1292,
     /* 385837 */     GIR_EraseRootFromParent_Done,
     /* 385838 */   // Label 7663: @385838
     /* 385838 */   GIM_Reject,
     /* 385839 */ // Label 7644: @385839
     /* 385839 */ GIM_Reject,
     /* 385840 */ // Label 7495: @385840
     /* 385840 */ GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(387018),
     /* 385845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 385851 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 385854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385858 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(385942), // Rule ID 6051 //
     /* 385863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 385866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 385874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 385887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 385891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385895 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 385899 */     // MIs[2] Operand 1
     /* 385899 */     // No operand predicates
     /* 385899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 385903 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385907 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385911 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385922 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 385922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 385925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 385933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 385940 */     GIR_RootConstrainSelectedInstOperands,
     /* 385941 */     // GIR_Coverage, 6051,
     /* 385941 */     GIR_EraseRootFromParent_Done,
     /* 385942 */   // Label 7665: @385942
     /* 385942 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(386023), // Rule ID 6083 //
     /* 385947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 385950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 385970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 385974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 385983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385991 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 385995 */     // MIs[3] Operand 1
     /* 385995 */     // No operand predicates
     /* 385995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386003 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386005 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 386005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 386008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386021 */     GIR_RootConstrainSelectedInstOperands,
     /* 386022 */     // GIR_Coverage, 6083,
     /* 386022 */     GIR_EraseRootFromParent_Done,
     /* 386023 */   // Label 7666: @386023
     /* 386023 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(386107), // Rule ID 6115 //
     /* 386028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 386031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 386056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 386069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386077 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386081 */     // MIs[3] Operand 1
     /* 386081 */     // No operand predicates
     /* 386081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386087 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 386087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 386090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386105 */     GIR_RootConstrainSelectedInstOperands,
     /* 386106 */     // GIR_Coverage, 6115,
     /* 386106 */     GIR_EraseRootFromParent_Done,
     /* 386107 */   // Label 7667: @386107
     /* 386107 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(386188), // Rule ID 6019 //
     /* 386112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 386115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 386139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 386152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386160 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386164 */     // MIs[3] Operand 1
     /* 386164 */     // No operand predicates
     /* 386164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386170 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 386170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 386173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386186 */     GIR_RootConstrainSelectedInstOperands,
     /* 386187 */     // GIR_Coverage, 6019,
     /* 386187 */     GIR_EraseRootFromParent_Done,
     /* 386188 */   // Label 7668: @386188
     /* 386188 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(386257), // Rule ID 2518 //
     /* 386193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 386196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 386204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 386217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386225 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386229 */     // MIs[2] Operand 1
     /* 386229 */     // No operand predicates
     /* 386229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386239 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 386239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 386242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386255 */     GIR_RootConstrainSelectedInstOperands,
     /* 386256 */     // GIR_Coverage, 2518,
     /* 386256 */     GIR_EraseRootFromParent_Done,
     /* 386257 */   // Label 7669: @386257
     /* 386257 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(386326), // Rule ID 5987 //
     /* 386262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 386265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 386277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 386290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386298 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386302 */     // MIs[2] Operand 1
     /* 386302 */     // No operand predicates
     /* 386302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386308 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 386308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 386311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386324 */     GIR_RootConstrainSelectedInstOperands,
     /* 386325 */     // GIR_Coverage, 5987,
     /* 386325 */     GIR_EraseRootFromParent_Done,
     /* 386326 */   // Label 7670: @386326
     /* 386326 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(386425), // Rule ID 6053 //
     /* 386331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 386334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 386351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386363 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386374 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 386377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386386 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386389 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386393 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 386396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 386406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 386409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 386417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386423 */     GIR_RootConstrainSelectedInstOperands,
     /* 386424 */     // GIR_Coverage, 6053,
     /* 386424 */     GIR_EraseRootFromParent_Done,
     /* 386425 */   // Label 7671: @386425
     /* 386425 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(386521), // Rule ID 6085 //
     /* 386430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 386433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 386453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 386462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386472 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 386475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386484 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386487 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386491 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 386494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386499 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 386504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 386507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386519 */     GIR_RootConstrainSelectedInstOperands,
     /* 386520 */     // GIR_Coverage, 6085,
     /* 386520 */     GIR_EraseRootFromParent_Done,
     /* 386521 */   // Label 7672: @386521
     /* 386521 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(386620), // Rule ID 6117 //
     /* 386526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 386529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 386554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 386563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386569 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 386572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386581 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386588 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 386591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 386601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 386604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386618 */     GIR_RootConstrainSelectedInstOperands,
     /* 386619 */     // GIR_Coverage, 6117,
     /* 386619 */     GIR_EraseRootFromParent_Done,
     /* 386620 */   // Label 7673: @386620
     /* 386620 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(386716), // Rule ID 6021 //
     /* 386625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 386628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 386652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 386656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 386661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386667 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 386670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386679 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386682 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386686 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 386689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 386699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 386702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386714 */     GIR_RootConstrainSelectedInstOperands,
     /* 386715 */     // GIR_Coverage, 6021,
     /* 386715 */     GIR_EraseRootFromParent_Done,
     /* 386716 */   // Label 7674: @386716
     /* 386716 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(386800), // Rule ID 2520 //
     /* 386721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 386724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 386741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386751 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 386754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386763 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386770 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 386773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 386783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 386786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386798 */     GIR_RootConstrainSelectedInstOperands,
     /* 386799 */     // GIR_Coverage, 2520,
     /* 386799 */     GIR_EraseRootFromParent_Done,
     /* 386800 */   // Label 7675: @386800
     /* 386800 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(386850), // Rule ID 13245 //
     /* 386805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 386808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386835 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 386835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 386838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386848 */     GIR_RootConstrainSelectedInstOperands,
     /* 386849 */     // GIR_Coverage, 13245,
     /* 386849 */     GIR_EraseRootFromParent_Done,
     /* 386850 */   // Label 7676: @386850
     /* 386850 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(386934), // Rule ID 5989 //
     /* 386855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 386858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 386874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 386879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386885 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 386888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386897 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386900 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386904 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 386907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 386917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 386920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386924 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386932 */     GIR_RootConstrainSelectedInstOperands,
     /* 386933 */     // GIR_Coverage, 5989,
     /* 386933 */     GIR_EraseRootFromParent_Done,
     /* 386934 */   // Label 7677: @386934
     /* 386934 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(386984), // Rule ID 1298 //
     /* 386939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 386942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386969 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 386969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 386972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386982 */     GIR_RootConstrainSelectedInstOperands,
     /* 386983 */     // GIR_Coverage, 1298,
     /* 386983 */     GIR_EraseRootFromParent_Done,
     /* 386984 */   // Label 7678: @386984
     /* 386984 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(387017), // Rule ID 1288 //
     /* 386989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 386992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387004 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 387004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 387007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 387015 */     GIR_RootConstrainSelectedInstOperands,
     /* 387016 */     // GIR_Coverage, 1288,
     /* 387016 */     GIR_EraseRootFromParent_Done,
     /* 387017 */   // Label 7679: @387017
     /* 387017 */   GIM_Reject,
     /* 387018 */ // Label 7664: @387018
     /* 387018 */ GIM_Reject,
     /* 387019 */ // Label 7496: @387019
     /* 387019 */ GIM_Reject,
     /* 387020 */ // Label 106: @387020
     /* 387020 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7688*/ GIMT_Encode4(387319),
     /* 387031 */ /*GILLT_s16*//*Label 7680*/ GIMT_Encode4(387071),
     /* 387035 */ /*GILLT_s32*//*Label 7681*/ GIMT_Encode4(387102),
     /* 387039 */ /*GILLT_s64*//*Label 7682*/ GIMT_Encode4(387133), GIMT_Encode4(0),
     /* 387047 */ /*GILLT_v2s32*//*Label 7683*/ GIMT_Encode4(387164),
     /* 387051 */ /*GILLT_v2s64*//*Label 7684*/ GIMT_Encode4(387195),
     /* 387055 */ /*GILLT_v4s16*//*Label 7685*/ GIMT_Encode4(387226),
     /* 387059 */ /*GILLT_v4s32*//*Label 7686*/ GIMT_Encode4(387257), GIMT_Encode4(0),
     /* 387067 */ /*GILLT_v8s16*//*Label 7687*/ GIMT_Encode4(387288),
     /* 387071 */ // Label 7680: @387071
     /* 387071 */ GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(387101), // Rule ID 569 //
     /* 387076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 387079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 387082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387090 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 387090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 387095 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387099 */   GIR_RootConstrainSelectedInstOperands,
     /* 387100 */   // GIR_Coverage, 569,
     /* 387100 */   GIR_Done,
     /* 387101 */ // Label 7689: @387101
     /* 387101 */ GIM_Reject,
     /* 387102 */ // Label 7681: @387102
     /* 387102 */ GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(387132), // Rule ID 571 //
     /* 387107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 387110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 387113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387121 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 387121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 387126 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387130 */   GIR_RootConstrainSelectedInstOperands,
     /* 387131 */   // GIR_Coverage, 571,
     /* 387131 */   GIR_Done,
     /* 387132 */ // Label 7690: @387132
     /* 387132 */ GIM_Reject,
     /* 387133 */ // Label 7682: @387133
     /* 387133 */ GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(387163), // Rule ID 573 //
     /* 387138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 387141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 387144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387152 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 387152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 387157 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387161 */   GIR_RootConstrainSelectedInstOperands,
     /* 387162 */   // GIR_Coverage, 573,
     /* 387162 */   GIR_Done,
     /* 387163 */ // Label 7691: @387163
     /* 387163 */ GIM_Reject,
     /* 387164 */ // Label 7683: @387164
     /* 387164 */ GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(387194), // Rule ID 952 //
     /* 387169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 387175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387183 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 387183 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 387188 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387192 */   GIR_RootConstrainSelectedInstOperands,
     /* 387193 */   // GIR_Coverage, 952,
     /* 387193 */   GIR_Done,
     /* 387194 */ // Label 7692: @387194
     /* 387194 */ GIM_Reject,
     /* 387195 */ // Label 7684: @387195
     /* 387195 */ GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(387225), // Rule ID 956 //
     /* 387200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387214 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 387214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 387219 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387223 */   GIR_RootConstrainSelectedInstOperands,
     /* 387224 */   // GIR_Coverage, 956,
     /* 387224 */   GIR_Done,
     /* 387225 */ // Label 7693: @387225
     /* 387225 */ GIM_Reject,
     /* 387226 */ // Label 7685: @387226
     /* 387226 */ GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(387256), // Rule ID 948 //
     /* 387231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387245 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 387245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 387250 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387254 */   GIR_RootConstrainSelectedInstOperands,
     /* 387255 */   // GIR_Coverage, 948,
     /* 387255 */   GIR_Done,
     /* 387256 */ // Label 7694: @387256
     /* 387256 */ GIM_Reject,
     /* 387257 */ // Label 7686: @387257
     /* 387257 */ GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(387287), // Rule ID 954 //
     /* 387262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387276 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 387276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 387281 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387285 */   GIR_RootConstrainSelectedInstOperands,
     /* 387286 */   // GIR_Coverage, 954,
     /* 387286 */   GIR_Done,
     /* 387287 */ // Label 7695: @387287
     /* 387287 */ GIM_Reject,
     /* 387288 */ // Label 7687: @387288
     /* 387288 */ GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(387318), // Rule ID 950 //
     /* 387293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387307 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 387307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 387312 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387316 */   GIR_RootConstrainSelectedInstOperands,
     /* 387317 */   // GIR_Coverage, 950,
     /* 387317 */   GIR_Done,
     /* 387318 */ // Label 7696: @387318
     /* 387318 */ GIM_Reject,
     /* 387319 */ // Label 7688: @387319
     /* 387319 */ GIM_Reject,
     /* 387320 */ // Label 107: @387320
     /* 387320 */ GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(387333), // Rule ID 6474 //
     /* 387325 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 387325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 387328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 387331 */   GIR_RootConstrainSelectedInstOperands,
     /* 387332 */   // GIR_Coverage, 6474,
     /* 387332 */   GIR_EraseRootFromParent_Done,
     /* 387333 */ // Label 7697: @387333
     /* 387333 */ GIM_Reject,
     /* 387334 */ // Label 108: @387334
     /* 387334 */ GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(387354), // Rule ID 6475 //
     /* 387339 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 387339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 387342 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 387352 */   GIR_RootConstrainSelectedInstOperands,
     /* 387353 */   // GIR_Coverage, 6475,
     /* 387353 */   GIR_EraseRootFromParent_Done,
     /* 387354 */ // Label 7698: @387354
     /* 387354 */ GIM_Reject,
     /* 387355 */ // Label 109: @387355
     /* 387355 */ GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(387379), // Rule ID 6476 //
     /* 387360 */   // MIs[0] kind
     /* 387360 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 387363 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 387368 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 387368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 387371 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 387377 */   GIR_RootConstrainSelectedInstOperands,
     /* 387378 */   // GIR_Coverage, 6476,
     /* 387378 */   GIR_EraseRootFromParent_Done,
     /* 387379 */ // Label 7699: @387379
     /* 387379 */ GIM_Reject,
     /* 387380 */ // Label 110: @387380
     /* 387380 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7703*/ GIMT_Encode4(387689),
     /* 387391 */ /*GILLT_s16*//*Label 7700*/ GIMT_Encode4(387403),
     /* 387395 */ /*GILLT_s32*//*Label 7701*/ GIMT_Encode4(387556),
     /* 387399 */ /*GILLT_s64*//*Label 7702*/ GIMT_Encode4(387661),
     /* 387403 */ // Label 7700: @387403
     /* 387403 */ GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(387504), // Rule ID 5581 //
     /* 387408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 387411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387422 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 387422 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 387425 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 387429 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387434 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 387438 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 387442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 387444 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 387447 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 387451 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387456 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 387459 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 387463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 387465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387477 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387484 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387489 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 387497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387499 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387502 */   GIR_RootConstrainSelectedInstOperands,
     /* 387503 */   // GIR_Coverage, 5581,
     /* 387503 */   GIR_EraseRootFromParent_Done,
     /* 387504 */ // Label 7704: @387504
     /* 387504 */ GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(387555), // Rule ID 5582 //
     /* 387509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 387512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387523 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 387523 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387526 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 387530 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387535 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 387539 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 387543 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 387548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387553 */   GIR_RootConstrainSelectedInstOperands,
     /* 387554 */   // GIR_Coverage, 5582,
     /* 387554 */   GIR_EraseRootFromParent_Done,
     /* 387555 */ // Label 7705: @387555
     /* 387555 */ GIM_Reject,
     /* 387556 */ // Label 7701: @387556
     /* 387556 */ GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(387633), // Rule ID 5583 //
     /* 387561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387572 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 387572 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 387575 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 387579 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387584 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 387588 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 387592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 387594 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 387597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387601 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387606 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 387613 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387618 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 387626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387628 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387631 */   GIR_RootConstrainSelectedInstOperands,
     /* 387632 */   // GIR_Coverage, 5583,
     /* 387632 */   GIR_EraseRootFromParent_Done,
     /* 387633 */ // Label 7706: @387633
     /* 387633 */ GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(387660), // Rule ID 5584 //
     /* 387638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 387641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387649 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 387649 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 387654 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387658 */   GIR_RootConstrainSelectedInstOperands,
     /* 387659 */   // GIR_Coverage, 5584,
     /* 387659 */   GIR_Done,
     /* 387660 */ // Label 7707: @387660
     /* 387660 */ GIM_Reject,
     /* 387661 */ // Label 7702: @387661
     /* 387661 */ GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(387688), // Rule ID 5585 //
     /* 387666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387677 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 387677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 387682 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387686 */   GIR_RootConstrainSelectedInstOperands,
     /* 387687 */   // GIR_Coverage, 5585,
     /* 387687 */   GIR_Done,
     /* 387688 */ // Label 7708: @387688
     /* 387688 */ GIM_Reject,
     /* 387689 */ // Label 7703: @387689
     /* 387689 */ GIM_Reject,
     /* 387690 */ // Label 111: @387690
     /* 387690 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7712*/ GIMT_Encode4(387860),
     /* 387701 */ /*GILLT_s16*//*Label 7709*/ GIMT_Encode4(387713),
     /* 387705 */ /*GILLT_s32*//*Label 7710*/ GIMT_Encode4(387774),
     /* 387709 */ /*GILLT_s64*//*Label 7711*/ GIMT_Encode4(387832),
     /* 387713 */ // Label 7709: @387713
     /* 387713 */ GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(387743), // Rule ID 1935 //
     /* 387718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387732 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 387732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 387737 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387741 */   GIR_RootConstrainSelectedInstOperands,
     /* 387742 */   // GIR_Coverage, 1935,
     /* 387742 */   GIR_Done,
     /* 387743 */ // Label 7713: @387743
     /* 387743 */ GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(387773), // Rule ID 1937 //
     /* 387748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387762 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 387762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 387767 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387771 */   GIR_RootConstrainSelectedInstOperands,
     /* 387772 */   // GIR_Coverage, 1937,
     /* 387772 */   GIR_Done,
     /* 387773 */ // Label 7714: @387773
     /* 387773 */ GIM_Reject,
     /* 387774 */ // Label 7710: @387774
     /* 387774 */ GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(387804), // Rule ID 1939 //
     /* 387779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387793 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 387793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 387798 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387802 */   GIR_RootConstrainSelectedInstOperands,
     /* 387803 */   // GIR_Coverage, 1939,
     /* 387803 */   GIR_Done,
     /* 387804 */ // Label 7715: @387804
     /* 387804 */ GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(387831), // Rule ID 5591 //
     /* 387809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 387812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387820 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 387820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 387825 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387829 */   GIR_RootConstrainSelectedInstOperands,
     /* 387830 */   // GIR_Coverage, 5591,
     /* 387830 */   GIR_Done,
     /* 387831 */ // Label 7716: @387831
     /* 387831 */ GIM_Reject,
     /* 387832 */ // Label 7711: @387832
     /* 387832 */ GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(387859), // Rule ID 5593 //
     /* 387837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387848 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 387848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 387853 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387857 */   GIR_RootConstrainSelectedInstOperands,
     /* 387858 */   // GIR_Coverage, 5593,
     /* 387858 */   GIR_Done,
     /* 387859 */ // Label 7717: @387859
     /* 387859 */ GIM_Reject,
     /* 387860 */ // Label 7712: @387860
     /* 387860 */ GIM_Reject,
     /* 387861 */ // Label 112: @387861
     /* 387861 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7721*/ GIMT_Encode4(388031),
     /* 387872 */ /*GILLT_s16*//*Label 7718*/ GIMT_Encode4(387884),
     /* 387876 */ /*GILLT_s32*//*Label 7719*/ GIMT_Encode4(387945),
     /* 387880 */ /*GILLT_s64*//*Label 7720*/ GIMT_Encode4(388003),
     /* 387884 */ // Label 7718: @387884
     /* 387884 */ GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(387914), // Rule ID 1947 //
     /* 387889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387903 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 387903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 387908 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387912 */   GIR_RootConstrainSelectedInstOperands,
     /* 387913 */   // GIR_Coverage, 1947,
     /* 387913 */   GIR_Done,
     /* 387914 */ // Label 7722: @387914
     /* 387914 */ GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(387944), // Rule ID 1949 //
     /* 387919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387933 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 387933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 387938 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387942 */   GIR_RootConstrainSelectedInstOperands,
     /* 387943 */   // GIR_Coverage, 1949,
     /* 387943 */   GIR_Done,
     /* 387944 */ // Label 7723: @387944
     /* 387944 */ GIM_Reject,
     /* 387945 */ // Label 7719: @387945
     /* 387945 */ GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(387975), // Rule ID 1951 //
     /* 387950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387964 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 387964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 387969 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 387973 */   GIR_RootConstrainSelectedInstOperands,
     /* 387974 */   // GIR_Coverage, 1951,
     /* 387974 */   GIR_Done,
     /* 387975 */ // Label 7724: @387975
     /* 387975 */ GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(388002), // Rule ID 5599 //
     /* 387980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 387983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387991 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 387991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 387996 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388000 */   GIR_RootConstrainSelectedInstOperands,
     /* 388001 */   // GIR_Coverage, 5599,
     /* 388001 */   GIR_Done,
     /* 388002 */ // Label 7725: @388002
     /* 388002 */ GIM_Reject,
     /* 388003 */ // Label 7720: @388003
     /* 388003 */ GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(388030), // Rule ID 5601 //
     /* 388008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388019 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 388019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 388024 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388028 */   GIR_RootConstrainSelectedInstOperands,
     /* 388029 */   // GIR_Coverage, 5601,
     /* 388029 */   GIR_Done,
     /* 388030 */ // Label 7726: @388030
     /* 388030 */ GIM_Reject,
     /* 388031 */ // Label 7721: @388031
     /* 388031 */ GIM_Reject,
     /* 388032 */ // Label 113: @388032
     /* 388032 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7730*/ GIMT_Encode4(388202),
     /* 388043 */ /*GILLT_s16*//*Label 7727*/ GIMT_Encode4(388055),
     /* 388047 */ /*GILLT_s32*//*Label 7728*/ GIMT_Encode4(388116),
     /* 388051 */ /*GILLT_s64*//*Label 7729*/ GIMT_Encode4(388174),
     /* 388055 */ // Label 7727: @388055
     /* 388055 */ GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(388085), // Rule ID 1941 //
     /* 388060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388074 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 388074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 388079 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388083 */   GIR_RootConstrainSelectedInstOperands,
     /* 388084 */   // GIR_Coverage, 1941,
     /* 388084 */   GIR_Done,
     /* 388085 */ // Label 7731: @388085
     /* 388085 */ GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(388115), // Rule ID 1943 //
     /* 388090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388104 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 388104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 388109 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388113 */   GIR_RootConstrainSelectedInstOperands,
     /* 388114 */   // GIR_Coverage, 1943,
     /* 388114 */   GIR_Done,
     /* 388115 */ // Label 7732: @388115
     /* 388115 */ GIM_Reject,
     /* 388116 */ // Label 7728: @388116
     /* 388116 */ GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(388146), // Rule ID 1945 //
     /* 388121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388135 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 388135 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 388140 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388144 */   GIR_RootConstrainSelectedInstOperands,
     /* 388145 */   // GIR_Coverage, 1945,
     /* 388145 */   GIR_Done,
     /* 388146 */ // Label 7733: @388146
     /* 388146 */ GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(388173), // Rule ID 5595 //
     /* 388151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388162 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 388162 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 388167 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388171 */   GIR_RootConstrainSelectedInstOperands,
     /* 388172 */   // GIR_Coverage, 5595,
     /* 388172 */   GIR_Done,
     /* 388173 */ // Label 7734: @388173
     /* 388173 */ GIM_Reject,
     /* 388174 */ // Label 7729: @388174
     /* 388174 */ GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(388201), // Rule ID 5597 //
     /* 388179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388190 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 388190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 388195 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388199 */   GIR_RootConstrainSelectedInstOperands,
     /* 388200 */   // GIR_Coverage, 5597,
     /* 388200 */   GIR_Done,
     /* 388201 */ // Label 7735: @388201
     /* 388201 */ GIM_Reject,
     /* 388202 */ // Label 7730: @388202
     /* 388202 */ GIM_Reject,
     /* 388203 */ // Label 114: @388203
     /* 388203 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7739*/ GIMT_Encode4(388373),
     /* 388214 */ /*GILLT_s16*//*Label 7736*/ GIMT_Encode4(388226),
     /* 388218 */ /*GILLT_s32*//*Label 7737*/ GIMT_Encode4(388287),
     /* 388222 */ /*GILLT_s64*//*Label 7738*/ GIMT_Encode4(388345),
     /* 388226 */ // Label 7736: @388226
     /* 388226 */ GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(388256), // Rule ID 1953 //
     /* 388231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388245 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 388245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 388250 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388254 */   GIR_RootConstrainSelectedInstOperands,
     /* 388255 */   // GIR_Coverage, 1953,
     /* 388255 */   GIR_Done,
     /* 388256 */ // Label 7740: @388256
     /* 388256 */ GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(388286), // Rule ID 1955 //
     /* 388261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388275 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 388275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 388280 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388284 */   GIR_RootConstrainSelectedInstOperands,
     /* 388285 */   // GIR_Coverage, 1955,
     /* 388285 */   GIR_Done,
     /* 388286 */ // Label 7741: @388286
     /* 388286 */ GIM_Reject,
     /* 388287 */ // Label 7737: @388287
     /* 388287 */ GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(388317), // Rule ID 1957 //
     /* 388292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388306 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 388306 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 388311 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388315 */   GIR_RootConstrainSelectedInstOperands,
     /* 388316 */   // GIR_Coverage, 1957,
     /* 388316 */   GIR_Done,
     /* 388317 */ // Label 7742: @388317
     /* 388317 */ GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(388344), // Rule ID 5603 //
     /* 388322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388333 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 388333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 388338 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388342 */   GIR_RootConstrainSelectedInstOperands,
     /* 388343 */   // GIR_Coverage, 5603,
     /* 388343 */   GIR_Done,
     /* 388344 */ // Label 7743: @388344
     /* 388344 */ GIM_Reject,
     /* 388345 */ // Label 7738: @388345
     /* 388345 */ GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(388372), // Rule ID 5605 //
     /* 388350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388361 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 388361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 388366 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 388370 */   GIR_RootConstrainSelectedInstOperands,
     /* 388371 */   // GIR_Coverage, 5605,
     /* 388371 */   GIR_Done,
     /* 388372 */ // Label 7744: @388372
     /* 388372 */ GIM_Reject,
     /* 388373 */ // Label 7739: @388373
     /* 388373 */ GIM_Reject,
     /* 388374 */ // Label 115: @388374
     /* 388374 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 7749*/ GIMT_Encode4(389502),
     /* 388385 */ /*GILLT_s8*//*Label 7745*/ GIMT_Encode4(388401),
     /* 388389 */ /*GILLT_s16*//*Label 7746*/ GIMT_Encode4(388448),
     /* 388393 */ /*GILLT_s32*//*Label 7747*/ GIMT_Encode4(388863),
     /* 388397 */ /*GILLT_s64*//*Label 7748*/ GIMT_Encode4(389316),
     /* 388401 */ // Label 7745: @388401
     /* 388401 */ GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(388424), // Rule ID 5850 //
     /* 388406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 388409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 388413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388417 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 388417 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 388422 */   GIR_RootConstrainSelectedInstOperands,
     /* 388423 */   // GIR_Coverage, 5850,
     /* 388423 */   GIR_Done,
     /* 388424 */ // Label 7750: @388424
     /* 388424 */ GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(388447), // Rule ID 5851 //
     /* 388429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 388432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 388436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388440 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 388440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 388445 */   GIR_RootConstrainSelectedInstOperands,
     /* 388446 */   // GIR_Coverage, 5851,
     /* 388446 */   GIR_Done,
     /* 388447 */ // Label 7751: @388447
     /* 388447 */ GIM_Reject,
     /* 388448 */ // Label 7746: @388448
     /* 388448 */ GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(388498), // Rule ID 5797 //
     /* 388453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388460 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 388468 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 388471 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 388476 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 388480 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388485 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388487 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 388487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 388490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388492 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 388496 */   GIR_RootConstrainSelectedInstOperands,
     /* 388497 */   // GIR_Coverage, 5797,
     /* 388497 */   GIR_EraseRootFromParent_Done,
     /* 388498 */ // Label 7752: @388498
     /* 388498 */ GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(388548), // Rule ID 5799 //
     /* 388503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388510 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388514 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 388518 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 388521 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 388526 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 388530 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388535 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388537 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 388537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 388540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388542 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 388546 */   GIR_RootConstrainSelectedInstOperands,
     /* 388547 */   // GIR_Coverage, 5799,
     /* 388547 */   GIR_EraseRootFromParent_Done,
     /* 388548 */ // Label 7753: @388548
     /* 388548 */ GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(388598), // Rule ID 5807 //
     /* 388553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388560 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388564 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 388568 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 388571 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 388576 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 388580 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388587 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 388587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 388590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388592 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 388596 */   GIR_RootConstrainSelectedInstOperands,
     /* 388597 */   // GIR_Coverage, 5807,
     /* 388597 */   GIR_EraseRootFromParent_Done,
     /* 388598 */ // Label 7754: @388598
     /* 388598 */ GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(388648), // Rule ID 5809 //
     /* 388603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 388618 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 388621 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 388626 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 388630 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388635 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388637 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 388637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 388640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388642 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 388646 */   GIR_RootConstrainSelectedInstOperands,
     /* 388647 */   // GIR_Coverage, 5809,
     /* 388647 */   GIR_EraseRootFromParent_Done,
     /* 388648 */ // Label 7755: @388648
     /* 388648 */ GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(388690), // Rule ID 5806 //
     /* 388653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388660 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388664 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 388668 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 388672 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388677 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388679 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 388679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 388682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388684 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388688 */   GIR_RootConstrainSelectedInstOperands,
     /* 388689 */   // GIR_Coverage, 5806,
     /* 388689 */   GIR_EraseRootFromParent_Done,
     /* 388690 */ // Label 7756: @388690
     /* 388690 */ GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(388732), // Rule ID 5808 //
     /* 388695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388702 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388706 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 388710 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 388714 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388721 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 388721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 388724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388726 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388730 */   GIR_RootConstrainSelectedInstOperands,
     /* 388731 */   // GIR_Coverage, 5808,
     /* 388731 */   GIR_EraseRootFromParent_Done,
     /* 388732 */ // Label 7757: @388732
     /* 388732 */ GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(388774), // Rule ID 5796 //
     /* 388737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388744 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388748 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 388752 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 388756 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388761 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388763 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 388763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 388766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388768 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388772 */   GIR_RootConstrainSelectedInstOperands,
     /* 388773 */   // GIR_Coverage, 5796,
     /* 388773 */   GIR_EraseRootFromParent_Done,
     /* 388774 */ // Label 7758: @388774
     /* 388774 */ GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(388816), // Rule ID 5798 //
     /* 388779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388786 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388790 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 388794 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 388798 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388803 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388805 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 388805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 388808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388810 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388814 */   GIR_RootConstrainSelectedInstOperands,
     /* 388815 */   // GIR_Coverage, 5798,
     /* 388815 */   GIR_EraseRootFromParent_Done,
     /* 388816 */ // Label 7759: @388816
     /* 388816 */ GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(388839), // Rule ID 5852 //
     /* 388821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388832 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 388832 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 388837 */   GIR_RootConstrainSelectedInstOperands,
     /* 388838 */   // GIR_Coverage, 5852,
     /* 388838 */   GIR_Done,
     /* 388839 */ // Label 7760: @388839
     /* 388839 */ GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(388862), // Rule ID 5853 //
     /* 388844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 388851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388855 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 388855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 388860 */   GIR_RootConstrainSelectedInstOperands,
     /* 388861 */   // GIR_Coverage, 5853,
     /* 388861 */   GIR_Done,
     /* 388862 */ // Label 7761: @388862
     /* 388862 */ GIM_Reject,
     /* 388863 */ // Label 7747: @388863
     /* 388863 */ GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(388913), // Rule ID 5801 //
     /* 388868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388875 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388879 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 388883 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 388886 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 388891 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 388895 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388900 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388902 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 388902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 388905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388907 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 388911 */   GIR_RootConstrainSelectedInstOperands,
     /* 388912 */   // GIR_Coverage, 5801,
     /* 388912 */   GIR_EraseRootFromParent_Done,
     /* 388913 */ // Label 7762: @388913
     /* 388913 */ GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(388963), // Rule ID 5803 //
     /* 388918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 388921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388925 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388929 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 388933 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 388936 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 388941 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 388945 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388950 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388952 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 388952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 388955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388957 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 388961 */   GIR_RootConstrainSelectedInstOperands,
     /* 388962 */   // GIR_Coverage, 5803,
     /* 388962 */   GIR_EraseRootFromParent_Done,
     /* 388963 */ // Label 7763: @388963
     /* 388963 */ GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(389013), // Rule ID 5811 //
     /* 388968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388975 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388979 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 388983 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 388986 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 388991 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 388995 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389000 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389002 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 389002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 389005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389007 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 389011 */   GIR_RootConstrainSelectedInstOperands,
     /* 389012 */   // GIR_Coverage, 5811,
     /* 389012 */   GIR_EraseRootFromParent_Done,
     /* 389013 */ // Label 7764: @389013
     /* 389013 */ GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(389063), // Rule ID 5813 //
     /* 389018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 389033 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 389036 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 389041 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 389045 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389050 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389052 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 389052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 389055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389057 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 389061 */   GIR_RootConstrainSelectedInstOperands,
     /* 389062 */   // GIR_Coverage, 5813,
     /* 389062 */   GIR_EraseRootFromParent_Done,
     /* 389063 */ // Label 7765: @389063
     /* 389063 */ GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(389105), // Rule ID 5810 //
     /* 389068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389075 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389079 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 389083 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389087 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389092 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389094 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 389094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 389097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389099 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389103 */   GIR_RootConstrainSelectedInstOperands,
     /* 389104 */   // GIR_Coverage, 5810,
     /* 389104 */   GIR_EraseRootFromParent_Done,
     /* 389105 */ // Label 7766: @389105
     /* 389105 */ GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(389147), // Rule ID 5812 //
     /* 389110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389117 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389121 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 389125 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389129 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389134 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389136 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 389136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 389139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389141 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389145 */   GIR_RootConstrainSelectedInstOperands,
     /* 389146 */   // GIR_Coverage, 5812,
     /* 389146 */   GIR_EraseRootFromParent_Done,
     /* 389147 */ // Label 7767: @389147
     /* 389147 */ GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(389189), // Rule ID 5800 //
     /* 389152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389159 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389163 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 389167 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389171 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389176 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389178 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 389178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 389181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389183 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389187 */   GIR_RootConstrainSelectedInstOperands,
     /* 389188 */   // GIR_Coverage, 5800,
     /* 389188 */   GIR_EraseRootFromParent_Done,
     /* 389189 */ // Label 7768: @389189
     /* 389189 */ GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(389231), // Rule ID 5802 //
     /* 389194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389201 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389205 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 389209 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389213 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389218 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389220 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 389220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 389223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389225 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389229 */   GIR_RootConstrainSelectedInstOperands,
     /* 389230 */   // GIR_Coverage, 5802,
     /* 389230 */   GIR_EraseRootFromParent_Done,
     /* 389231 */ // Label 7769: @389231
     /* 389231 */ GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(389292), // Rule ID 5854 //
     /* 389236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389247 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 389247 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 389250 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 389254 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389259 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 389263 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 389267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389274 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 389281 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389286 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389291 */   // GIR_Coverage, 5854,
     /* 389291 */   GIR_EraseRootFromParent_Done,
     /* 389292 */ // Label 7770: @389292
     /* 389292 */ GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(389315), // Rule ID 5855 //
     /* 389297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389308 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 389308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 389313 */   GIR_RootConstrainSelectedInstOperands,
     /* 389314 */   // GIR_Coverage, 5855,
     /* 389314 */   GIR_Done,
     /* 389315 */ // Label 7771: @389315
     /* 389315 */ GIM_Reject,
     /* 389316 */ // Label 7748: @389316
     /* 389316 */ GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(389501),
     /* 389321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389328 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(389371), // Rule ID 5805 //
     /* 389333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 389341 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 389344 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 389349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 389353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389360 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 389360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 389363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 389369 */     GIR_RootConstrainSelectedInstOperands,
     /* 389370 */     // GIR_Coverage, 5805,
     /* 389370 */     GIR_EraseRootFromParent_Done,
     /* 389371 */   // Label 7773: @389371
     /* 389371 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(389414), // Rule ID 5815 //
     /* 389376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 389384 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 389387 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 389392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 389396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389403 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 389403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 389406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 389412 */     GIR_RootConstrainSelectedInstOperands,
     /* 389413 */     // GIR_Coverage, 5815,
     /* 389413 */     GIR_EraseRootFromParent_Done,
     /* 389414 */   // Label 7774: @389414
     /* 389414 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(389449), // Rule ID 5814 //
     /* 389419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 389427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389438 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 389438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 389441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389447 */     GIR_RootConstrainSelectedInstOperands,
     /* 389448 */     // GIR_Coverage, 5814,
     /* 389448 */     GIR_EraseRootFromParent_Done,
     /* 389449 */   // Label 7775: @389449
     /* 389449 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(389484), // Rule ID 5804 //
     /* 389454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 389462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389473 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 389473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 389476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389482 */     GIR_RootConstrainSelectedInstOperands,
     /* 389483 */     // GIR_Coverage, 5804,
     /* 389483 */     GIR_EraseRootFromParent_Done,
     /* 389484 */   // Label 7776: @389484
     /* 389484 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(389500), // Rule ID 5856 //
     /* 389489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389493 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 389493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 389498 */     GIR_RootConstrainSelectedInstOperands,
     /* 389499 */     // GIR_Coverage, 5856,
     /* 389499 */     GIR_Done,
     /* 389500 */   // Label 7777: @389500
     /* 389500 */   GIM_Reject,
     /* 389501 */ // Label 7772: @389501
     /* 389501 */ GIM_Reject,
     /* 389502 */ // Label 7749: @389502
     /* 389502 */ GIM_Reject,
     /* 389503 */ // Label 116: @389503
     /* 389503 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7781*/ GIMT_Encode4(389705),
     /* 389514 */ /*GILLT_s8*//*Label 7778*/ GIMT_Encode4(389526),
     /* 389518 */ /*GILLT_s16*//*Label 7779*/ GIMT_Encode4(389573),
     /* 389522 */ /*GILLT_s32*//*Label 7780*/ GIMT_Encode4(389620),
     /* 389526 */ // Label 7778: @389526
     /* 389526 */ GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(389549), // Rule ID 5947 //
     /* 389531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 389534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 389538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389542 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 389542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 389547 */   GIR_RootConstrainSelectedInstOperands,
     /* 389548 */   // GIR_Coverage, 5947,
     /* 389548 */   GIR_Done,
     /* 389549 */ // Label 7782: @389549
     /* 389549 */ GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(389572), // Rule ID 5948 //
     /* 389554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 389557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 389561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389565 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 389565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 389570 */   GIR_RootConstrainSelectedInstOperands,
     /* 389571 */   // GIR_Coverage, 5948,
     /* 389571 */   GIR_Done,
     /* 389572 */ // Label 7783: @389572
     /* 389572 */ GIM_Reject,
     /* 389573 */ // Label 7779: @389573
     /* 389573 */ GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(389596), // Rule ID 5949 //
     /* 389578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389589 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 389589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 389594 */   GIR_RootConstrainSelectedInstOperands,
     /* 389595 */   // GIR_Coverage, 5949,
     /* 389595 */   GIR_Done,
     /* 389596 */ // Label 7784: @389596
     /* 389596 */ GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(389619), // Rule ID 5950 //
     /* 389601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389612 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 389612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 389617 */   GIR_RootConstrainSelectedInstOperands,
     /* 389618 */   // GIR_Coverage, 5950,
     /* 389618 */   GIR_Done,
     /* 389619 */ // Label 7785: @389619
     /* 389619 */ GIM_Reject,
     /* 389620 */ // Label 7780: @389620
     /* 389620 */ GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(389643), // Rule ID 5951 //
     /* 389625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389636 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 389636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 389641 */   GIR_RootConstrainSelectedInstOperands,
     /* 389642 */   // GIR_Coverage, 5951,
     /* 389642 */   GIR_Done,
     /* 389643 */ // Label 7786: @389643
     /* 389643 */ GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(389704), // Rule ID 5952 //
     /* 389648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389659 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 389659 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 389662 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 389666 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389671 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 389675 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 389679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389686 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 389693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389698 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389703 */   // GIR_Coverage, 5952,
     /* 389703 */   GIR_EraseRootFromParent_Done,
     /* 389704 */ // Label 7787: @389704
     /* 389704 */ GIM_Reject,
     /* 389705 */ // Label 7781: @389705
     /* 389705 */ GIM_Reject,
     /* 389706 */ // Label 117: @389706
     /* 389706 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7791*/ GIMT_Encode4(389908),
     /* 389717 */ /*GILLT_s8*//*Label 7788*/ GIMT_Encode4(389729),
     /* 389721 */ /*GILLT_s16*//*Label 7789*/ GIMT_Encode4(389776),
     /* 389725 */ /*GILLT_s32*//*Label 7790*/ GIMT_Encode4(389823),
     /* 389729 */ // Label 7788: @389729
     /* 389729 */ GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(389752), // Rule ID 5941 //
     /* 389734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 389737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 389741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389745 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 389745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 389750 */   GIR_RootConstrainSelectedInstOperands,
     /* 389751 */   // GIR_Coverage, 5941,
     /* 389751 */   GIR_Done,
     /* 389752 */ // Label 7792: @389752
     /* 389752 */ GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(389775), // Rule ID 5942 //
     /* 389757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 389760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 389764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389768 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 389768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 389773 */   GIR_RootConstrainSelectedInstOperands,
     /* 389774 */   // GIR_Coverage, 5942,
     /* 389774 */   GIR_Done,
     /* 389775 */ // Label 7793: @389775
     /* 389775 */ GIM_Reject,
     /* 389776 */ // Label 7789: @389776
     /* 389776 */ GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(389799), // Rule ID 5943 //
     /* 389781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389792 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 389792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 389797 */   GIR_RootConstrainSelectedInstOperands,
     /* 389798 */   // GIR_Coverage, 5943,
     /* 389798 */   GIR_Done,
     /* 389799 */ // Label 7794: @389799
     /* 389799 */ GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(389822), // Rule ID 5944 //
     /* 389804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 389807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389815 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 389815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 389820 */   GIR_RootConstrainSelectedInstOperands,
     /* 389821 */   // GIR_Coverage, 5944,
     /* 389821 */   GIR_Done,
     /* 389822 */ // Label 7795: @389822
     /* 389822 */ GIM_Reject,
     /* 389823 */ // Label 7790: @389823
     /* 389823 */ GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(389846), // Rule ID 5945 //
     /* 389828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389839 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 389839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 389844 */   GIR_RootConstrainSelectedInstOperands,
     /* 389845 */   // GIR_Coverage, 5945,
     /* 389845 */   GIR_Done,
     /* 389846 */ // Label 7796: @389846
     /* 389846 */ GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(389907), // Rule ID 5946 //
     /* 389851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 389854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389862 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 389862 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 389865 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 389869 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389874 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 389878 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 389882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389889 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 389896 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389901 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389906 */   // GIR_Coverage, 5946,
     /* 389906 */   GIR_EraseRootFromParent_Done,
     /* 389907 */ // Label 7797: @389907
     /* 389907 */ GIM_Reject,
     /* 389908 */ // Label 7791: @389908
     /* 389908 */ GIM_Reject,
     /* 389909 */ // Label 118: @389909
     /* 389909 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7801*/ GIMT_Encode4(390111),
     /* 389920 */ /*GILLT_s8*//*Label 7798*/ GIMT_Encode4(389932),
     /* 389924 */ /*GILLT_s16*//*Label 7799*/ GIMT_Encode4(389979),
     /* 389928 */ /*GILLT_s32*//*Label 7800*/ GIMT_Encode4(390026),
     /* 389932 */ // Label 7798: @389932
     /* 389932 */ GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(389955), // Rule ID 5935 //
     /* 389937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 389940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 389944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389948 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 389948 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 389953 */   GIR_RootConstrainSelectedInstOperands,
     /* 389954 */   // GIR_Coverage, 5935,
     /* 389954 */   GIR_Done,
     /* 389955 */ // Label 7802: @389955
     /* 389955 */ GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(389978), // Rule ID 5936 //
     /* 389960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 389963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 389967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389971 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 389971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 389976 */   GIR_RootConstrainSelectedInstOperands,
     /* 389977 */   // GIR_Coverage, 5936,
     /* 389977 */   GIR_Done,
     /* 389978 */ // Label 7803: @389978
     /* 389978 */ GIM_Reject,
     /* 389979 */ // Label 7799: @389979
     /* 389979 */ GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(390002), // Rule ID 5937 //
     /* 389984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389995 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 389995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 390000 */   GIR_RootConstrainSelectedInstOperands,
     /* 390001 */   // GIR_Coverage, 5937,
     /* 390001 */   GIR_Done,
     /* 390002 */ // Label 7804: @390002
     /* 390002 */ GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(390025), // Rule ID 5938 //
     /* 390007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390018 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 390018 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 390023 */   GIR_RootConstrainSelectedInstOperands,
     /* 390024 */   // GIR_Coverage, 5938,
     /* 390024 */   GIR_Done,
     /* 390025 */ // Label 7805: @390025
     /* 390025 */ GIM_Reject,
     /* 390026 */ // Label 7800: @390026
     /* 390026 */ GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(390049), // Rule ID 5939 //
     /* 390031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390042 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 390042 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 390047 */   GIR_RootConstrainSelectedInstOperands,
     /* 390048 */   // GIR_Coverage, 5939,
     /* 390048 */   GIR_Done,
     /* 390049 */ // Label 7806: @390049
     /* 390049 */ GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(390110), // Rule ID 5940 //
     /* 390054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390065 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 390065 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 390068 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 390072 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390077 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 390081 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 390085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390092 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 390099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390104 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390109 */   // GIR_Coverage, 5940,
     /* 390109 */   GIR_EraseRootFromParent_Done,
     /* 390110 */ // Label 7807: @390110
     /* 390110 */ GIM_Reject,
     /* 390111 */ // Label 7801: @390111
     /* 390111 */ GIM_Reject,
     /* 390112 */ // Label 119: @390112
     /* 390112 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7811*/ GIMT_Encode4(390314),
     /* 390123 */ /*GILLT_s8*//*Label 7808*/ GIMT_Encode4(390135),
     /* 390127 */ /*GILLT_s16*//*Label 7809*/ GIMT_Encode4(390182),
     /* 390131 */ /*GILLT_s32*//*Label 7810*/ GIMT_Encode4(390229),
     /* 390135 */ // Label 7808: @390135
     /* 390135 */ GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(390158), // Rule ID 5929 //
     /* 390140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 390143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 390147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390151 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 390151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 390156 */   GIR_RootConstrainSelectedInstOperands,
     /* 390157 */   // GIR_Coverage, 5929,
     /* 390157 */   GIR_Done,
     /* 390158 */ // Label 7812: @390158
     /* 390158 */ GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(390181), // Rule ID 5930 //
     /* 390163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 390166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 390170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390174 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 390174 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 390179 */   GIR_RootConstrainSelectedInstOperands,
     /* 390180 */   // GIR_Coverage, 5930,
     /* 390180 */   GIR_Done,
     /* 390181 */ // Label 7813: @390181
     /* 390181 */ GIM_Reject,
     /* 390182 */ // Label 7809: @390182
     /* 390182 */ GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(390205), // Rule ID 5931 //
     /* 390187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390198 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 390198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 390203 */   GIR_RootConstrainSelectedInstOperands,
     /* 390204 */   // GIR_Coverage, 5931,
     /* 390204 */   GIR_Done,
     /* 390205 */ // Label 7814: @390205
     /* 390205 */ GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(390228), // Rule ID 5932 //
     /* 390210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390221 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 390221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 390226 */   GIR_RootConstrainSelectedInstOperands,
     /* 390227 */   // GIR_Coverage, 5932,
     /* 390227 */   GIR_Done,
     /* 390228 */ // Label 7815: @390228
     /* 390228 */ GIM_Reject,
     /* 390229 */ // Label 7810: @390229
     /* 390229 */ GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(390252), // Rule ID 5933 //
     /* 390234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390245 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 390245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 390250 */   GIR_RootConstrainSelectedInstOperands,
     /* 390251 */   // GIR_Coverage, 5933,
     /* 390251 */   GIR_Done,
     /* 390252 */ // Label 7816: @390252
     /* 390252 */ GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(390313), // Rule ID 5934 //
     /* 390257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390268 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 390268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 390271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 390275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390280 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 390284 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 390288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 390293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390295 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 390302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390307 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390312 */   // GIR_Coverage, 5934,
     /* 390312 */   GIR_EraseRootFromParent_Done,
     /* 390313 */ // Label 7817: @390313
     /* 390313 */ GIM_Reject,
     /* 390314 */ // Label 7811: @390314
     /* 390314 */ GIM_Reject,
     /* 390315 */ // Label 120: @390315
     /* 390315 */ GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(390454),
     /* 390320 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 390323 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 390327 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(390361), // Rule ID 257 //
     /* 390332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 390339 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 390339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 390342 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 390344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 390349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 390354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 390359 */     GIR_RootConstrainSelectedInstOperands,
     /* 390360 */     // GIR_Coverage, 257,
     /* 390360 */     GIR_EraseRootFromParent_Done,
     /* 390361 */   // Label 7819: @390361
     /* 390361 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(390395), // Rule ID 258 //
     /* 390366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 390373 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 390373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 390376 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 390378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 390383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 390388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 390393 */     GIR_RootConstrainSelectedInstOperands,
     /* 390394 */     // GIR_Coverage, 258,
     /* 390394 */     GIR_EraseRootFromParent_Done,
     /* 390395 */   // Label 7820: @390395
     /* 390395 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(390424), // Rule ID 273 //
     /* 390400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 390407 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 390407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 390410 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 390412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 390417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 390422 */     GIR_RootConstrainSelectedInstOperands,
     /* 390423 */     // GIR_Coverage, 273,
     /* 390423 */     GIR_EraseRootFromParent_Done,
     /* 390424 */   // Label 7821: @390424
     /* 390424 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(390453), // Rule ID 294 //
     /* 390429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 390436 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 390436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 390439 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 390441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 390446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 390451 */     GIR_RootConstrainSelectedInstOperands,
     /* 390452 */     // GIR_Coverage, 294,
     /* 390452 */     GIR_EraseRootFromParent_Done,
     /* 390453 */   // Label 7822: @390453
     /* 390453 */   GIM_Reject,
     /* 390454 */ // Label 7818: @390454
     /* 390454 */ GIM_Reject,
     /* 390455 */ // Label 121: @390455
     /* 390455 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7835*/ GIMT_Encode4(390994),
     /* 390466 */ /*GILLT_s64*//*Label 7823*/ GIMT_Encode4(390550), GIMT_Encode4(0),
     /* 390474 */ /*GILLT_v2s32*//*Label 7824*/ GIMT_Encode4(390588),
     /* 390478 */ /*GILLT_v2s64*//*Label 7825*/ GIMT_Encode4(390626),
     /* 390482 */ /*GILLT_v4s16*//*Label 7826*/ GIMT_Encode4(390664),
     /* 390486 */ /*GILLT_v4s32*//*Label 7827*/ GIMT_Encode4(390702),
     /* 390490 */ /*GILLT_v8s8*//*Label 7828*/ GIMT_Encode4(390740),
     /* 390494 */ /*GILLT_v8s16*//*Label 7829*/ GIMT_Encode4(390778),
     /* 390498 */ /*GILLT_v16s8*//*Label 7830*/ GIMT_Encode4(390816), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 390518 */ /*GILLT_nxv2s64*//*Label 7831*/ GIMT_Encode4(390854), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 390530 */ /*GILLT_nxv4s32*//*Label 7832*/ GIMT_Encode4(390889), GIMT_Encode4(0),
     /* 390538 */ /*GILLT_nxv8s16*//*Label 7833*/ GIMT_Encode4(390924), GIMT_Encode4(0),
     /* 390546 */ /*GILLT_nxv16s8*//*Label 7834*/ GIMT_Encode4(390959),
     /* 390550 */ // Label 7823: @390550
     /* 390550 */ GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(390587), // Rule ID 5045 //
     /* 390555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 390561 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 390564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390572 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390576 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390580 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 390580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 390585 */   GIR_RootConstrainSelectedInstOperands,
     /* 390586 */   // GIR_Coverage, 5045,
     /* 390586 */   GIR_Done,
     /* 390587 */ // Label 7836: @390587
     /* 390587 */ GIM_Reject,
     /* 390588 */ // Label 7824: @390588
     /* 390588 */ GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(390625), // Rule ID 5044 //
     /* 390593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 390596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 390599 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 390602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390614 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390618 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 390618 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 390623 */   GIR_RootConstrainSelectedInstOperands,
     /* 390624 */   // GIR_Coverage, 5044,
     /* 390624 */   GIR_Done,
     /* 390625 */ // Label 7837: @390625
     /* 390625 */ GIM_Reject,
     /* 390626 */ // Label 7825: @390626
     /* 390626 */ GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(390663), // Rule ID 5049 //
     /* 390631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 390634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 390637 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 390640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390648 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390652 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390656 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 390656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 390661 */   GIR_RootConstrainSelectedInstOperands,
     /* 390662 */   // GIR_Coverage, 5049,
     /* 390662 */   GIR_Done,
     /* 390663 */ // Label 7838: @390663
     /* 390663 */ GIM_Reject,
     /* 390664 */ // Label 7826: @390664
     /* 390664 */ GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(390701), // Rule ID 5043 //
     /* 390669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 390672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 390675 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 390678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390690 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390694 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 390694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 390699 */   GIR_RootConstrainSelectedInstOperands,
     /* 390700 */   // GIR_Coverage, 5043,
     /* 390700 */   GIR_Done,
     /* 390701 */ // Label 7839: @390701
     /* 390701 */ GIM_Reject,
     /* 390702 */ // Label 7827: @390702
     /* 390702 */ GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(390739), // Rule ID 5048 //
     /* 390707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 390713 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 390716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390728 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390732 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 390732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 390737 */   GIR_RootConstrainSelectedInstOperands,
     /* 390738 */   // GIR_Coverage, 5048,
     /* 390738 */   GIR_Done,
     /* 390739 */ // Label 7840: @390739
     /* 390739 */ GIM_Reject,
     /* 390740 */ // Label 7828: @390740
     /* 390740 */ GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(390777), // Rule ID 5042 //
     /* 390745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 390748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 390751 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 390754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390766 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390770 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 390770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 390775 */   GIR_RootConstrainSelectedInstOperands,
     /* 390776 */   // GIR_Coverage, 5042,
     /* 390776 */   GIR_Done,
     /* 390777 */ // Label 7841: @390777
     /* 390777 */ GIM_Reject,
     /* 390778 */ // Label 7829: @390778
     /* 390778 */ GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(390815), // Rule ID 5047 //
     /* 390783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 390789 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 390792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390804 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390808 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 390808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 390813 */   GIR_RootConstrainSelectedInstOperands,
     /* 390814 */   // GIR_Coverage, 5047,
     /* 390814 */   GIR_Done,
     /* 390815 */ // Label 7842: @390815
     /* 390815 */ GIM_Reject,
     /* 390816 */ // Label 7830: @390816
     /* 390816 */ GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(390853), // Rule ID 5046 //
     /* 390821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 390824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 390827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 390830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390842 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390846 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 390846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 390851 */   GIR_RootConstrainSelectedInstOperands,
     /* 390852 */   // GIR_Coverage, 5046,
     /* 390852 */   GIR_Done,
     /* 390853 */ // Label 7843: @390853
     /* 390853 */ GIM_Reject,
     /* 390854 */ // Label 7831: @390854
     /* 390854 */ GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(390888), // Rule ID 11793 //
     /* 390859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 390862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 390868 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 390871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390875 */   // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 390875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 390878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 390880 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 390882 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 390884 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 390886 */   GIR_RootConstrainSelectedInstOperands,
     /* 390887 */   // GIR_Coverage, 11793,
     /* 390887 */   GIR_EraseRootFromParent_Done,
     /* 390888 */ // Label 7844: @390888
     /* 390888 */ GIM_Reject,
     /* 390889 */ // Label 7832: @390889
     /* 390889 */ GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(390923), // Rule ID 11791 //
     /* 390894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 390897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 390900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 390903 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 390906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390910 */   // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 390910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 390913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 390915 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 390917 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 390919 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 390921 */   GIR_RootConstrainSelectedInstOperands,
     /* 390922 */   // GIR_Coverage, 11791,
     /* 390922 */   GIR_EraseRootFromParent_Done,
     /* 390923 */ // Label 7845: @390923
     /* 390923 */ GIM_Reject,
     /* 390924 */ // Label 7833: @390924
     /* 390924 */ GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(390958), // Rule ID 11789 //
     /* 390929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 390932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 390935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 390938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 390941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390945 */   // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 390945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 390948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 390950 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 390952 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 390954 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 390956 */   GIR_RootConstrainSelectedInstOperands,
     /* 390957 */   // GIR_Coverage, 11789,
     /* 390957 */   GIR_EraseRootFromParent_Done,
     /* 390958 */ // Label 7846: @390958
     /* 390958 */ GIM_Reject,
     /* 390959 */ // Label 7834: @390959
     /* 390959 */ GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(390993), // Rule ID 11787 //
     /* 390964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 390967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 390970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 390973 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 390976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390980 */   // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 390980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 390983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 390985 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 390987 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 390989 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 390991 */   GIR_RootConstrainSelectedInstOperands,
     /* 390992 */   // GIR_Coverage, 11787,
     /* 390992 */   GIR_EraseRootFromParent_Done,
     /* 390993 */ // Label 7847: @390993
     /* 390993 */ GIM_Reject,
     /* 390994 */ // Label 7835: @390994
     /* 390994 */ GIM_Reject,
     /* 390995 */ // Label 122: @390995
     /* 390995 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 7856*/ GIMT_Encode4(392817),
     /* 391006 */ /*GILLT_s64*//*Label 7848*/ GIMT_Encode4(391042), GIMT_Encode4(0),
     /* 391014 */ /*GILLT_v2s32*//*Label 7849*/ GIMT_Encode4(391237),
     /* 391018 */ /*GILLT_v2s64*//*Label 7850*/ GIMT_Encode4(391484),
     /* 391022 */ /*GILLT_v4s16*//*Label 7851*/ GIMT_Encode4(391731),
     /* 391026 */ /*GILLT_v4s32*//*Label 7852*/ GIMT_Encode4(392007),
     /* 391030 */ /*GILLT_v8s8*//*Label 7853*/ GIMT_Encode4(392254),
     /* 391034 */ /*GILLT_v8s16*//*Label 7854*/ GIMT_Encode4(392399),
     /* 391038 */ /*GILLT_v16s8*//*Label 7855*/ GIMT_Encode4(392675),
     /* 391042 */ // Label 7848: @391042
     /* 391042 */ GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(391236),
     /* 391047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391054 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(391101), // Rule ID 6372 //
     /* 391059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 391067 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 391070 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 391074 */     // MIs[1] Rn
     /* 391074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 391078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 391083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391085 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 391085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 391088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 391090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 391099 */     GIR_RootConstrainSelectedInstOperands,
     /* 391100 */     // GIR_Coverage, 6372,
     /* 391100 */     GIR_EraseRootFromParent_Done,
     /* 391101 */   // Label 7858: @391101
     /* 391101 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(391148), // Rule ID 6383 //
     /* 391106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 391114 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 391117 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 391121 */     // MIs[1] Rn
     /* 391121 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 391125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 391130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391132 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 391132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 391135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 391137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 391146 */     GIR_RootConstrainSelectedInstOperands,
     /* 391147 */     // GIR_Coverage, 6383,
     /* 391147 */     GIR_EraseRootFromParent_Done,
     /* 391148 */   // Label 7859: @391148
     /* 391148 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(391195), // Rule ID 13116 //
     /* 391153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 391161 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 391164 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 391168 */     // MIs[1] Rn
     /* 391168 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 391172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 391177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391179 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 391179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 391182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 391184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 391193 */     GIR_RootConstrainSelectedInstOperands,
     /* 391194 */     // GIR_Coverage, 13116,
     /* 391194 */     GIR_EraseRootFromParent_Done,
     /* 391195 */   // Label 7860: @391195
     /* 391195 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(391215), // Rule ID 5607 //
     /* 391200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391204 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 391204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 391209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391214 */     // GIR_Coverage, 5607,
     /* 391214 */     GIR_Done,
     /* 391215 */   // Label 7861: @391215
     /* 391215 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(391235), // Rule ID 5608 //
     /* 391220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391224 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 391224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 391229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391234 */     // GIR_Coverage, 5608,
     /* 391234 */     GIR_Done,
     /* 391235 */   // Label 7862: @391235
     /* 391235 */   GIM_Reject,
     /* 391236 */ // Label 7857: @391236
     /* 391236 */ GIM_Reject,
     /* 391237 */ // Label 7849: @391237
     /* 391237 */ GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(391483),
     /* 391242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391249 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(391296), // Rule ID 6369 //
     /* 391254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 391262 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 391265 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 391269 */     // MIs[1] Rn
     /* 391269 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 391273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 391278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391280 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 391280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 391283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 391285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 391294 */     GIR_RootConstrainSelectedInstOperands,
     /* 391295 */     // GIR_Coverage, 6369,
     /* 391295 */     GIR_EraseRootFromParent_Done,
     /* 391296 */   // Label 7864: @391296
     /* 391296 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(391343), // Rule ID 6380 //
     /* 391301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 391309 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 391312 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 391316 */     // MIs[1] Rn
     /* 391316 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 391320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 391325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391327 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 391327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 391330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 391332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 391341 */     GIR_RootConstrainSelectedInstOperands,
     /* 391342 */     // GIR_Coverage, 6380,
     /* 391342 */     GIR_EraseRootFromParent_Done,
     /* 391343 */   // Label 7865: @391343
     /* 391343 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(391390), // Rule ID 13113 //
     /* 391348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 391356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 391359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 391363 */     // MIs[1] Rn
     /* 391363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 391367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 391372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391374 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 391374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 391377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 391379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 391388 */     GIR_RootConstrainSelectedInstOperands,
     /* 391389 */     // GIR_Coverage, 13113,
     /* 391389 */     GIR_EraseRootFromParent_Done,
     /* 391390 */   // Label 7866: @391390
     /* 391390 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(391409), // Rule ID 1909 //
     /* 391395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391402 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 391407 */     GIR_RootConstrainSelectedInstOperands,
     /* 391408 */     // GIR_Coverage, 1909,
     /* 391408 */     GIR_Done,
     /* 391409 */   // Label 7867: @391409
     /* 391409 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(391482), // Rule ID 5609 //
     /* 391414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391418 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391418 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 391421 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391425 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 391435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391444 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 391447 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391451 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 391454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 391472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391480 */     GIR_RootConstrainSelectedInstOperands,
     /* 391481 */     // GIR_Coverage, 5609,
     /* 391481 */     GIR_EraseRootFromParent_Done,
     /* 391482 */   // Label 7868: @391482
     /* 391482 */   GIM_Reject,
     /* 391483 */ // Label 7863: @391483
     /* 391483 */ GIM_Reject,
     /* 391484 */ // Label 7850: @391484
     /* 391484 */ GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(391730),
     /* 391489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391496 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(391543), // Rule ID 6371 //
     /* 391501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 391509 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 391512 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 391516 */     // MIs[1] Rn
     /* 391516 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 391520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 391525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391527 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 391527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 391530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 391532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 391541 */     GIR_RootConstrainSelectedInstOperands,
     /* 391542 */     // GIR_Coverage, 6371,
     /* 391542 */     GIR_EraseRootFromParent_Done,
     /* 391543 */   // Label 7870: @391543
     /* 391543 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(391590), // Rule ID 6382 //
     /* 391548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 391556 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 391559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 391563 */     // MIs[1] Rn
     /* 391563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 391567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 391572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391574 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 391574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 391577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 391579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 391588 */     GIR_RootConstrainSelectedInstOperands,
     /* 391589 */     // GIR_Coverage, 6382,
     /* 391589 */     GIR_EraseRootFromParent_Done,
     /* 391590 */   // Label 7871: @391590
     /* 391590 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(391637), // Rule ID 13115 //
     /* 391595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 391603 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 391606 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 391610 */     // MIs[1] Rn
     /* 391610 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 391614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 391619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391621 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 391621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 391624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 391626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 391635 */     GIR_RootConstrainSelectedInstOperands,
     /* 391636 */     // GIR_Coverage, 13115,
     /* 391636 */     GIR_EraseRootFromParent_Done,
     /* 391637 */   // Label 7872: @391637
     /* 391637 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(391656), // Rule ID 1911 //
     /* 391642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391649 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 391654 */     GIR_RootConstrainSelectedInstOperands,
     /* 391655 */     // GIR_Coverage, 1911,
     /* 391655 */     GIR_Done,
     /* 391656 */   // Label 7873: @391656
     /* 391656 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(391729), // Rule ID 5611 //
     /* 391661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391665 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391665 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 391668 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391672 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 391682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391691 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 391694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391698 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 391701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 391719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391727 */     GIR_RootConstrainSelectedInstOperands,
     /* 391728 */     // GIR_Coverage, 5611,
     /* 391728 */     GIR_EraseRootFromParent_Done,
     /* 391729 */   // Label 7874: @391729
     /* 391729 */   GIM_Reject,
     /* 391730 */ // Label 7869: @391730
     /* 391730 */ GIM_Reject,
     /* 391731 */ // Label 7851: @391731
     /* 391731 */ GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(391792), // Rule ID 6367 //
     /* 391736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391743 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391747 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 391751 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 391754 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 391758 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 391765 */   // MIs[1] Rn
     /* 391765 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 391769 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 391774 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391776 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 391776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 391779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 391781 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391785 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 391790 */   GIR_RootConstrainSelectedInstOperands,
     /* 391791 */   // GIR_Coverage, 6367,
     /* 391791 */   GIR_EraseRootFromParent_Done,
     /* 391792 */ // Label 7875: @391792
     /* 391792 */ GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(391846), // Rule ID 6384 //
     /* 391797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391804 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 391812 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 391815 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 391819 */   // MIs[1] Rn
     /* 391819 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 391823 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 391828 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391830 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 391830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 391833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 391835 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391839 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 391844 */   GIR_RootConstrainSelectedInstOperands,
     /* 391845 */   // GIR_Coverage, 6384,
     /* 391845 */   GIR_EraseRootFromParent_Done,
     /* 391846 */ // Label 7876: @391846
     /* 391846 */ GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(391900), // Rule ID 13111 //
     /* 391851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391858 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391862 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 391866 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 391869 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 391873 */   // MIs[1] Rn
     /* 391873 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 391877 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 391882 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391884 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 391884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 391887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 391889 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391893 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 391898 */   GIR_RootConstrainSelectedInstOperands,
     /* 391899 */   // GIR_Coverage, 13111,
     /* 391899 */   GIR_EraseRootFromParent_Done,
     /* 391900 */ // Label 7877: @391900
     /* 391900 */ GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(391926), // Rule ID 1907 //
     /* 391905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391919 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 391919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 391924 */   GIR_RootConstrainSelectedInstOperands,
     /* 391925 */   // GIR_Coverage, 1907,
     /* 391925 */   GIR_Done,
     /* 391926 */ // Label 7878: @391926
     /* 391926 */ GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(392006), // Rule ID 5612 //
     /* 391931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391942 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391942 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 391945 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391949 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391956 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 391959 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391963 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391968 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 391971 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391975 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391978 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391983 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391988 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 391996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391998 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392004 */   GIR_RootConstrainSelectedInstOperands,
     /* 392005 */   // GIR_Coverage, 5612,
     /* 392005 */   GIR_EraseRootFromParent_Done,
     /* 392006 */ // Label 7879: @392006
     /* 392006 */ GIM_Reject,
     /* 392007 */ // Label 7852: @392007
     /* 392007 */ GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(392253),
     /* 392012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392019 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(392066), // Rule ID 6370 //
     /* 392024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 392032 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 392035 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 392039 */     // MIs[1] Rn
     /* 392039 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 392043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 392048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392050 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 392050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 392053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 392055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 392064 */     GIR_RootConstrainSelectedInstOperands,
     /* 392065 */     // GIR_Coverage, 6370,
     /* 392065 */     GIR_EraseRootFromParent_Done,
     /* 392066 */   // Label 7881: @392066
     /* 392066 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(392113), // Rule ID 6381 //
     /* 392071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 392079 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 392082 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 392086 */     // MIs[1] Rn
     /* 392086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 392090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 392095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392097 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 392097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 392100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 392102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 392111 */     GIR_RootConstrainSelectedInstOperands,
     /* 392112 */     // GIR_Coverage, 6381,
     /* 392112 */     GIR_EraseRootFromParent_Done,
     /* 392113 */   // Label 7882: @392113
     /* 392113 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(392160), // Rule ID 13114 //
     /* 392118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 392126 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 392129 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 392133 */     // MIs[1] Rn
     /* 392133 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 392137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 392142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392144 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 392144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 392147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 392149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 392158 */     GIR_RootConstrainSelectedInstOperands,
     /* 392159 */     // GIR_Coverage, 13114,
     /* 392159 */     GIR_EraseRootFromParent_Done,
     /* 392160 */   // Label 7883: @392160
     /* 392160 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(392179), // Rule ID 1910 //
     /* 392165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392172 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 392177 */     GIR_RootConstrainSelectedInstOperands,
     /* 392178 */     // GIR_Coverage, 1910,
     /* 392178 */     GIR_Done,
     /* 392179 */   // Label 7884: @392179
     /* 392179 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(392252), // Rule ID 5610 //
     /* 392184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392188 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392188 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 392191 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 392195 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 392205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 392209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392214 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 392217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392221 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 392224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 392242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392250 */     GIR_RootConstrainSelectedInstOperands,
     /* 392251 */     // GIR_Coverage, 5610,
     /* 392251 */     GIR_EraseRootFromParent_Done,
     /* 392252 */   // Label 7885: @392252
     /* 392252 */   GIM_Reject,
     /* 392253 */ // Label 7880: @392253
     /* 392253 */ GIM_Reject,
     /* 392254 */ // Label 7853: @392254
     /* 392254 */ GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(392311), // Rule ID 13109 //
     /* 392259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 392262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392266 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392270 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 392274 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 392277 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 392281 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 392285 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392287 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 392294 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 392294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 392297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 392299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 392304 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 392309 */   GIR_RootConstrainSelectedInstOperands,
     /* 392310 */   // GIR_Coverage, 13109,
     /* 392310 */   GIR_EraseRootFromParent_Done,
     /* 392311 */ // Label 7886: @392311
     /* 392311 */ GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(392372), // Rule ID 6365 //
     /* 392316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 392331 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 392334 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 392338 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 392345 */   // MIs[1] Rn
     /* 392345 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 392349 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 392354 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392356 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 392356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 392359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 392361 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 392370 */   GIR_RootConstrainSelectedInstOperands,
     /* 392371 */   // GIR_Coverage, 6365,
     /* 392371 */   GIR_EraseRootFromParent_Done,
     /* 392372 */ // Label 7887: @392372
     /* 392372 */ GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(392398), // Rule ID 1905 //
     /* 392377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392391 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 392391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 392396 */   GIR_RootConstrainSelectedInstOperands,
     /* 392397 */   // GIR_Coverage, 1905,
     /* 392397 */   GIR_Done,
     /* 392398 */ // Label 7888: @392398
     /* 392398 */ GIM_Reject,
     /* 392399 */ // Label 7854: @392399
     /* 392399 */ GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(392460), // Rule ID 6368 //
     /* 392404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392411 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392415 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 392419 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 392422 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 392426 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 392433 */   // MIs[1] Rn
     /* 392433 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 392437 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 392442 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392444 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 392444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 392447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 392449 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392453 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 392458 */   GIR_RootConstrainSelectedInstOperands,
     /* 392459 */   // GIR_Coverage, 6368,
     /* 392459 */   GIR_EraseRootFromParent_Done,
     /* 392460 */ // Label 7889: @392460
     /* 392460 */ GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(392514), // Rule ID 6385 //
     /* 392465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392472 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392476 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 392480 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 392483 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 392487 */   // MIs[1] Rn
     /* 392487 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 392491 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 392496 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392498 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 392498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 392501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 392503 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392507 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 392512 */   GIR_RootConstrainSelectedInstOperands,
     /* 392513 */   // GIR_Coverage, 6385,
     /* 392513 */   GIR_EraseRootFromParent_Done,
     /* 392514 */ // Label 7890: @392514
     /* 392514 */ GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(392568), // Rule ID 13112 //
     /* 392519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392526 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392530 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 392534 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 392537 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 392541 */   // MIs[1] Rn
     /* 392541 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 392545 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 392550 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392552 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 392552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 392555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 392557 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392561 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 392566 */   GIR_RootConstrainSelectedInstOperands,
     /* 392567 */   // GIR_Coverage, 13112,
     /* 392567 */   GIR_EraseRootFromParent_Done,
     /* 392568 */ // Label 7891: @392568
     /* 392568 */ GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(392594), // Rule ID 1908 //
     /* 392573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392587 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 392587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 392592 */   GIR_RootConstrainSelectedInstOperands,
     /* 392593 */   // GIR_Coverage, 1908,
     /* 392593 */   GIR_Done,
     /* 392594 */ // Label 7892: @392594
     /* 392594 */ GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(392674), // Rule ID 5613 //
     /* 392599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392610 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 392610 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 392613 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 392617 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 392627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 392631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392636 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 392639 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392643 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 392646 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392651 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392656 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 392664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392672 */   GIR_RootConstrainSelectedInstOperands,
     /* 392673 */   // GIR_Coverage, 5613,
     /* 392673 */   GIR_EraseRootFromParent_Done,
     /* 392674 */ // Label 7893: @392674
     /* 392674 */ GIM_Reject,
     /* 392675 */ // Label 7855: @392675
     /* 392675 */ GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(392736), // Rule ID 6366 //
     /* 392680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392687 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392691 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 392695 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 392698 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 392702 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 392709 */   // MIs[1] Rn
     /* 392709 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 392713 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 392718 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392720 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 392720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 392723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 392725 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 392734 */   GIR_RootConstrainSelectedInstOperands,
     /* 392735 */   // GIR_Coverage, 6366,
     /* 392735 */   GIR_EraseRootFromParent_Done,
     /* 392736 */ // Label 7894: @392736
     /* 392736 */ GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(392790), // Rule ID 13110 //
     /* 392741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 392744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392748 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392752 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 392756 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 392759 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 392763 */   // MIs[1] Rn
     /* 392763 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 392767 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 392772 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392774 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 392774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 392777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 392779 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392783 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 392788 */   GIR_RootConstrainSelectedInstOperands,
     /* 392789 */   // GIR_Coverage, 13110,
     /* 392789 */   GIR_EraseRootFromParent_Done,
     /* 392790 */ // Label 7895: @392790
     /* 392790 */ GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(392816), // Rule ID 1906 //
     /* 392795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392809 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 392809 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 392814 */   GIR_RootConstrainSelectedInstOperands,
     /* 392815 */   // GIR_Coverage, 1906,
     /* 392815 */   GIR_Done,
     /* 392816 */ // Label 7896: @392816
     /* 392816 */ GIM_Reject,
     /* 392817 */ // Label 7856: @392817
     /* 392817 */ GIM_Reject,
     /* 392818 */ // Label 123: @392818
     /* 392818 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 7899*/ GIMT_Encode4(393072),
     /* 392829 */ /*GILLT_v4s16*//*Label 7897*/ GIMT_Encode4(392845), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392841 */ /*GILLT_v8s16*//*Label 7898*/ GIMT_Encode4(392931),
     /* 392845 */ // Label 7897: @392845
     /* 392845 */ GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(392930),
     /* 392850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 392856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392864 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(392898), // Rule ID 1915 //
     /* 392869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 392884 */     // MIs[1] Operand 1
     /* 392884 */     // No operand predicates
     /* 392884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392886 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 392886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 392889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 392896 */     GIR_RootConstrainSelectedInstOperands,
     /* 392897 */     // GIR_Coverage, 1915,
     /* 392897 */     GIR_EraseRootFromParent_Done,
     /* 392898 */   // Label 7901: @392898
     /* 392898 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(392929), // Rule ID 5614 //
     /* 392903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 392911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 392915 */     // MIs[1] Operand 1
     /* 392915 */     // No operand predicates
     /* 392915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392917 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 392917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 392920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 392927 */     GIR_RootConstrainSelectedInstOperands,
     /* 392928 */     // GIR_Coverage, 5614,
     /* 392928 */     GIR_EraseRootFromParent_Done,
     /* 392929 */   // Label 7902: @392929
     /* 392929 */   GIM_Reject,
     /* 392930 */ // Label 7900: @392930
     /* 392930 */ GIM_Reject,
     /* 392931 */ // Label 7898: @392931
     /* 392931 */ GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(393071),
     /* 392936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 392942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392946 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(392997), // Rule ID 6376 //
     /* 392951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 392959 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 392962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 392966 */     // MIs[1] Rn
     /* 392966 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 392970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 392975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 392979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392981 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 392981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 392984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 392986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 392995 */     GIR_RootConstrainSelectedInstOperands,
     /* 392996 */     // GIR_Coverage, 6376,
     /* 392996 */     GIR_EraseRootFromParent_Done,
     /* 392997 */   // Label 7904: @392997
     /* 392997 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(393035), // Rule ID 1916 //
     /* 393002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393021 */     // MIs[1] Operand 1
     /* 393021 */     // No operand predicates
     /* 393021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393023 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 393023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 393026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 393033 */     GIR_RootConstrainSelectedInstOperands,
     /* 393034 */     // GIR_Coverage, 1916,
     /* 393034 */     GIR_EraseRootFromParent_Done,
     /* 393035 */   // Label 7905: @393035
     /* 393035 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(393070), // Rule ID 5615 //
     /* 393040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 393056 */     // MIs[1] Operand 1
     /* 393056 */     // No operand predicates
     /* 393056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393058 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 393058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 393061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 393068 */     GIR_RootConstrainSelectedInstOperands,
     /* 393069 */     // GIR_Coverage, 5615,
     /* 393069 */     GIR_EraseRootFromParent_Done,
     /* 393070 */   // Label 7906: @393070
     /* 393070 */   GIM_Reject,
     /* 393071 */ // Label 7903: @393071
     /* 393071 */ GIM_Reject,
     /* 393072 */ // Label 7899: @393072
     /* 393072 */ GIM_Reject,
     /* 393073 */ // Label 124: @393073
     /* 393073 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 7909*/ GIMT_Encode4(393327),
     /* 393084 */ /*GILLT_v2s32*//*Label 7907*/ GIMT_Encode4(393100), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 393096 */ /*GILLT_v4s32*//*Label 7908*/ GIMT_Encode4(393186),
     /* 393100 */ // Label 7907: @393100
     /* 393100 */ GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(393185),
     /* 393105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 393111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393119 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(393153), // Rule ID 1913 //
     /* 393124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393139 */     // MIs[1] Operand 1
     /* 393139 */     // No operand predicates
     /* 393139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393141 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 393141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 393144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393146 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 393151 */     GIR_RootConstrainSelectedInstOperands,
     /* 393152 */     // GIR_Coverage, 1913,
     /* 393152 */     GIR_EraseRootFromParent_Done,
     /* 393153 */   // Label 7911: @393153
     /* 393153 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(393184), // Rule ID 5616 //
     /* 393158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393170 */     // MIs[1] Operand 1
     /* 393170 */     // No operand predicates
     /* 393170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393172 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 393172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 393175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 393182 */     GIR_RootConstrainSelectedInstOperands,
     /* 393183 */     // GIR_Coverage, 5616,
     /* 393183 */     GIR_EraseRootFromParent_Done,
     /* 393184 */   // Label 7912: @393184
     /* 393184 */   GIM_Reject,
     /* 393185 */ // Label 7910: @393185
     /* 393185 */ GIM_Reject,
     /* 393186 */ // Label 7908: @393186
     /* 393186 */ GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(393326),
     /* 393191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 393197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393201 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(393252), // Rule ID 6378 //
     /* 393206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 393214 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 393217 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 393221 */     // MIs[1] Rn
     /* 393221 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 393225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 393230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 393234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393236 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 393236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 393239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 393241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 393250 */     GIR_RootConstrainSelectedInstOperands,
     /* 393251 */     // GIR_Coverage, 6378,
     /* 393251 */     GIR_EraseRootFromParent_Done,
     /* 393252 */   // Label 7914: @393252
     /* 393252 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(393290), // Rule ID 1914 //
     /* 393257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393276 */     // MIs[1] Operand 1
     /* 393276 */     // No operand predicates
     /* 393276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393278 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 393278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 393281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 393288 */     GIR_RootConstrainSelectedInstOperands,
     /* 393289 */     // GIR_Coverage, 1914,
     /* 393289 */     GIR_EraseRootFromParent_Done,
     /* 393290 */   // Label 7915: @393290
     /* 393290 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(393325), // Rule ID 5617 //
     /* 393295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 393311 */     // MIs[1] Operand 1
     /* 393311 */     // No operand predicates
     /* 393311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393313 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 393313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 393316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393318 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 393323 */     GIR_RootConstrainSelectedInstOperands,
     /* 393324 */     // GIR_Coverage, 5617,
     /* 393324 */     GIR_EraseRootFromParent_Done,
     /* 393325 */   // Label 7916: @393325
     /* 393325 */   GIM_Reject,
     /* 393326 */ // Label 7913: @393326
     /* 393326 */ GIM_Reject,
     /* 393327 */ // Label 7909: @393327
     /* 393327 */ GIM_Reject,
     /* 393328 */ // Label 125: @393328
     /* 393328 */ GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(393473),
     /* 393333 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 393336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 393342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393346 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(393397), // Rule ID 6379 //
     /* 393351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 393359 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 393362 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 393366 */     // MIs[1] Rn
     /* 393366 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 393370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 393375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 393379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393381 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 393381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 393384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 393386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 393395 */     GIR_RootConstrainSelectedInstOperands,
     /* 393396 */     // GIR_Coverage, 6379,
     /* 393396 */     GIR_EraseRootFromParent_Done,
     /* 393397 */   // Label 7918: @393397
     /* 393397 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(393472),
     /* 393402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393406 */     GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(393440), // Rule ID 1912 //
     /* 393411 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393414 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393418 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393422 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 393426 */       // MIs[1] Operand 1
     /* 393426 */       // No operand predicates
     /* 393426 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393428 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 393428 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 393431 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393433 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393435 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 393438 */       GIR_RootConstrainSelectedInstOperands,
     /* 393439 */       // GIR_Coverage, 1912,
     /* 393439 */       GIR_EraseRootFromParent_Done,
     /* 393440 */     // Label 7920: @393440
     /* 393440 */     GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(393471), // Rule ID 5618 //
     /* 393445 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393449 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393453 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 393457 */       // MIs[1] Operand 1
     /* 393457 */       // No operand predicates
     /* 393457 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393459 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 393459 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 393462 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393464 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393466 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 393469 */       GIR_RootConstrainSelectedInstOperands,
     /* 393470 */       // GIR_Coverage, 5618,
     /* 393470 */       GIR_EraseRootFromParent_Done,
     /* 393471 */     // Label 7921: @393471
     /* 393471 */     GIM_Reject,
     /* 393472 */   // Label 7919: @393472
     /* 393472 */   GIM_Reject,
     /* 393473 */ // Label 7917: @393473
     /* 393473 */ GIM_Reject,
     /* 393474 */ // Label 126: @393474
     /* 393474 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 7924*/ GIMT_Encode4(393652),
     /* 393485 */ /*GILLT_v8s8*//*Label 7922*/ GIMT_Encode4(393497), GIMT_Encode4(0),
     /* 393493 */ /*GILLT_v16s8*//*Label 7923*/ GIMT_Encode4(393546),
     /* 393497 */ // Label 7922: @393497
     /* 393497 */ GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(393545), // Rule ID 1917 //
     /* 393502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 393511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393519 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393523 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393527 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 393531 */   // MIs[1] Operand 1
     /* 393531 */   // No operand predicates
     /* 393531 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393533 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 393533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 393536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393538 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393540 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 393543 */   GIR_RootConstrainSelectedInstOperands,
     /* 393544 */   // GIR_Coverage, 1917,
     /* 393544 */   GIR_EraseRootFromParent_Done,
     /* 393545 */ // Label 7925: @393545
     /* 393545 */ GIM_Reject,
     /* 393546 */ // Label 7923: @393546
     /* 393546 */ GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(393651),
     /* 393551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 393557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393561 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(393612), // Rule ID 6374 //
     /* 393566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 393574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 393577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 393581 */     // MIs[1] Rn
     /* 393581 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 393585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 393590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 393594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393596 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 393596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 393599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 393601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 393610 */     GIR_RootConstrainSelectedInstOperands,
     /* 393611 */     // GIR_Coverage, 6374,
     /* 393611 */     GIR_EraseRootFromParent_Done,
     /* 393612 */   // Label 7927: @393612
     /* 393612 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(393650), // Rule ID 1918 //
     /* 393617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 393628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 393636 */     // MIs[1] Operand 1
     /* 393636 */     // No operand predicates
     /* 393636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393638 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 393638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 393641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 393645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 393648 */     GIR_RootConstrainSelectedInstOperands,
     /* 393649 */     // GIR_Coverage, 1918,
     /* 393649 */     GIR_EraseRootFromParent_Done,
     /* 393650 */   // Label 7928: @393650
     /* 393650 */   GIM_Reject,
     /* 393651 */ // Label 7926: @393651
     /* 393651 */ GIM_Reject,
     /* 393652 */ // Label 7924: @393652
     /* 393652 */ GIM_Reject,
     /* 393653 */ // Label 127: @393653
     /* 393653 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7938*/ GIMT_Encode4(395302),
     /* 393664 */ /*GILLT_s64*//*Label 7929*/ GIMT_Encode4(393748), GIMT_Encode4(0),
     /* 393672 */ /*GILLT_v2s32*//*Label 7930*/ GIMT_Encode4(394069),
     /* 393676 */ /*GILLT_v2s64*//*Label 7931*/ GIMT_Encode4(394390),
     /* 393680 */ /*GILLT_v4s16*//*Label 7932*/ GIMT_Encode4(394473),
     /* 393684 */ /*GILLT_v4s32*//*Label 7933*/ GIMT_Encode4(394794),
     /* 393688 */ /*GILLT_v8s8*//*Label 7934*/ GIMT_Encode4(394877),
     /* 393692 */ /*GILLT_v8s16*//*Label 7935*/ GIMT_Encode4(395086),
     /* 393696 */ /*GILLT_v16s8*//*Label 7936*/ GIMT_Encode4(395169), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 393744 */ /*GILLT_nxv16s8*//*Label 7937*/ GIMT_Encode4(395255),
     /* 393748 */ // Label 7929: @393748
     /* 393748 */ GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(394068),
     /* 393753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 393759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393763 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(393878), // Rule ID 5435 //
     /* 393768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393785 */     // MIs[1] Operand 2
     /* 393785 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 393796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393804 */     // MIs[2] Rn
     /* 393804 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393809 */     // MIs[2] Operand 2
     /* 393809 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 393820 */     // MIs[0] imm
     /* 393820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 393824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393828 */     // MIs[3] Operand 1
     /* 393828 */     // No operand predicates
     /* 393828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393830 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 393830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 393837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393846 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 393853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 393855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 393858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393860 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 393867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393877 */     // GIR_Coverage, 5435,
     /* 393877 */     GIR_EraseRootFromParent_Done,
     /* 393878 */   // Label 7940: @393878
     /* 393878 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(393993), // Rule ID 5440 //
     /* 393883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393900 */     // MIs[1] Operand 2
     /* 393900 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 393911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 393915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 393919 */     // MIs[2] Rn
     /* 393919 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 393924 */     // MIs[2] Operand 2
     /* 393924 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 393935 */     // MIs[0] imm
     /* 393935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 393939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 393943 */     // MIs[3] Operand 1
     /* 393943 */     // No operand predicates
     /* 393943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 393945 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 393945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 393952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393957 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 393968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 393970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 393973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393975 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 393982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393992 */     // GIR_Coverage, 5440,
     /* 393992 */     GIR_EraseRootFromParent_Done,
     /* 393993 */   // Label 7941: @393993
     /* 393993 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(394030), // Rule ID 5432 //
     /* 393998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394006 */     // MIs[0] imm
     /* 394006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 394010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394014 */     // MIs[1] Operand 1
     /* 394014 */     // No operand predicates
     /* 394014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394016 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 394016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 394019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 394025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 394028 */     GIR_RootConstrainSelectedInstOperands,
     /* 394029 */     // GIR_Coverage, 5432,
     /* 394029 */     GIR_EraseRootFromParent_Done,
     /* 394030 */   // Label 7942: @394030
     /* 394030 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(394067), // Rule ID 5437 //
     /* 394035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394043 */     // MIs[0] imm
     /* 394043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 394047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394051 */     // MIs[1] Operand 1
     /* 394051 */     // No operand predicates
     /* 394051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394053 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 394053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 394056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 394062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 394065 */     GIR_RootConstrainSelectedInstOperands,
     /* 394066 */     // GIR_Coverage, 5437,
     /* 394066 */     GIR_EraseRootFromParent_Done,
     /* 394067 */   // Label 7943: @394067
     /* 394067 */   GIM_Reject,
     /* 394068 */ // Label 7939: @394068
     /* 394068 */ GIM_Reject,
     /* 394069 */ // Label 7930: @394069
     /* 394069 */ GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(394389),
     /* 394074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 394080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394084 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(394199), // Rule ID 5425 //
     /* 394089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 394097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394106 */     // MIs[1] Operand 2
     /* 394106 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 394117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 394125 */     // MIs[2] Rn
     /* 394125 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394130 */     // MIs[2] Operand 2
     /* 394130 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 394141 */     // MIs[0] imm
     /* 394141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 394145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394149 */     // MIs[3] Operand 1
     /* 394149 */     // No operand predicates
     /* 394149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394151 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 394151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 394158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394163 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394167 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 394174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394181 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 394188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394198 */     // GIR_Coverage, 5425,
     /* 394198 */     GIR_EraseRootFromParent_Done,
     /* 394199 */   // Label 7945: @394199
     /* 394199 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(394314), // Rule ID 5430 //
     /* 394204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 394212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394221 */     // MIs[1] Operand 2
     /* 394221 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 394232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 394240 */     // MIs[2] Rn
     /* 394240 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394245 */     // MIs[2] Operand 2
     /* 394245 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 394256 */     // MIs[0] imm
     /* 394256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 394260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394264 */     // MIs[3] Operand 1
     /* 394264 */     // No operand predicates
     /* 394264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394266 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 394266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 394273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394278 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 394289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394296 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 394303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394313 */     // GIR_Coverage, 5430,
     /* 394313 */     GIR_EraseRootFromParent_Done,
     /* 394314 */   // Label 7946: @394314
     /* 394314 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(394351), // Rule ID 5422 //
     /* 394319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394327 */     // MIs[0] imm
     /* 394327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 394331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394335 */     // MIs[1] Operand 1
     /* 394335 */     // No operand predicates
     /* 394335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394337 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 394337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 394340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 394346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 394349 */     GIR_RootConstrainSelectedInstOperands,
     /* 394350 */     // GIR_Coverage, 5422,
     /* 394350 */     GIR_EraseRootFromParent_Done,
     /* 394351 */   // Label 7947: @394351
     /* 394351 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(394388), // Rule ID 5427 //
     /* 394356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394364 */     // MIs[0] imm
     /* 394364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 394368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394372 */     // MIs[1] Operand 1
     /* 394372 */     // No operand predicates
     /* 394372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394374 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 394374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 394377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 394383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 394386 */     GIR_RootConstrainSelectedInstOperands,
     /* 394387 */     // GIR_Coverage, 5427,
     /* 394387 */     GIR_EraseRootFromParent_Done,
     /* 394388 */   // Label 7948: @394388
     /* 394388 */   GIM_Reject,
     /* 394389 */ // Label 7944: @394389
     /* 394389 */ GIM_Reject,
     /* 394390 */ // Label 7931: @394390
     /* 394390 */ GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(394472),
     /* 394395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 394401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394413 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(394442), // Rule ID 5433 //
     /* 394418 */     // MIs[0] imm
     /* 394418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 394422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394426 */     // MIs[1] Operand 1
     /* 394426 */     // No operand predicates
     /* 394426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394428 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 394428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 394431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 394437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 394440 */     GIR_RootConstrainSelectedInstOperands,
     /* 394441 */     // GIR_Coverage, 5433,
     /* 394441 */     GIR_EraseRootFromParent_Done,
     /* 394442 */   // Label 7950: @394442
     /* 394442 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(394471), // Rule ID 5438 //
     /* 394447 */     // MIs[0] imm
     /* 394447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 394451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394455 */     // MIs[1] Operand 1
     /* 394455 */     // No operand predicates
     /* 394455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394457 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 394457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 394460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 394466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 394469 */     GIR_RootConstrainSelectedInstOperands,
     /* 394470 */     // GIR_Coverage, 5438,
     /* 394470 */     GIR_EraseRootFromParent_Done,
     /* 394471 */   // Label 7951: @394471
     /* 394471 */   GIM_Reject,
     /* 394472 */ // Label 7949: @394472
     /* 394472 */ GIM_Reject,
     /* 394473 */ // Label 7932: @394473
     /* 394473 */ GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(394793),
     /* 394478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 394484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394488 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(394603), // Rule ID 5415 //
     /* 394493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 394501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394510 */     // MIs[1] Operand 2
     /* 394510 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 394521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 394529 */     // MIs[2] Rn
     /* 394529 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394534 */     // MIs[2] Operand 2
     /* 394534 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 394545 */     // MIs[0] imm
     /* 394545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 394549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394553 */     // MIs[3] Operand 1
     /* 394553 */     // No operand predicates
     /* 394553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394555 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 394555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 394562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394567 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394571 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 394578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394585 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 394592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394602 */     // GIR_Coverage, 5415,
     /* 394602 */     GIR_EraseRootFromParent_Done,
     /* 394603 */   // Label 7953: @394603
     /* 394603 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(394718), // Rule ID 5420 //
     /* 394608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 394616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394625 */     // MIs[1] Operand 2
     /* 394625 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 394636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 394644 */     // MIs[2] Rn
     /* 394644 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394649 */     // MIs[2] Operand 2
     /* 394649 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 394660 */     // MIs[0] imm
     /* 394660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 394664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394668 */     // MIs[3] Operand 1
     /* 394668 */     // No operand predicates
     /* 394668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394670 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 394670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 394677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394682 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 394693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394700 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 394707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394717 */     // GIR_Coverage, 5420,
     /* 394717 */     GIR_EraseRootFromParent_Done,
     /* 394718 */   // Label 7954: @394718
     /* 394718 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(394755), // Rule ID 5412 //
     /* 394723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394731 */     // MIs[0] imm
     /* 394731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 394735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394739 */     // MIs[1] Operand 1
     /* 394739 */     // No operand predicates
     /* 394739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394741 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 394741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 394744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 394750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 394753 */     GIR_RootConstrainSelectedInstOperands,
     /* 394754 */     // GIR_Coverage, 5412,
     /* 394754 */     GIR_EraseRootFromParent_Done,
     /* 394755 */   // Label 7955: @394755
     /* 394755 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(394792), // Rule ID 5417 //
     /* 394760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394768 */     // MIs[0] imm
     /* 394768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 394772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394776 */     // MIs[1] Operand 1
     /* 394776 */     // No operand predicates
     /* 394776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394778 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 394778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 394781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 394787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 394790 */     GIR_RootConstrainSelectedInstOperands,
     /* 394791 */     // GIR_Coverage, 5417,
     /* 394791 */     GIR_EraseRootFromParent_Done,
     /* 394792 */   // Label 7956: @394792
     /* 394792 */   GIM_Reject,
     /* 394793 */ // Label 7952: @394793
     /* 394793 */ GIM_Reject,
     /* 394794 */ // Label 7933: @394794
     /* 394794 */ GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(394876),
     /* 394799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 394805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394817 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(394846), // Rule ID 5423 //
     /* 394822 */     // MIs[0] imm
     /* 394822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 394826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394830 */     // MIs[1] Operand 1
     /* 394830 */     // No operand predicates
     /* 394830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394832 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 394832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 394835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 394841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 394844 */     GIR_RootConstrainSelectedInstOperands,
     /* 394845 */     // GIR_Coverage, 5423,
     /* 394845 */     GIR_EraseRootFromParent_Done,
     /* 394846 */   // Label 7958: @394846
     /* 394846 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(394875), // Rule ID 5428 //
     /* 394851 */     // MIs[0] imm
     /* 394851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 394855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394859 */     // MIs[1] Operand 1
     /* 394859 */     // No operand predicates
     /* 394859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394861 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 394861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 394864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 394868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 394870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 394873 */     GIR_RootConstrainSelectedInstOperands,
     /* 394874 */     // GIR_Coverage, 5428,
     /* 394874 */     GIR_EraseRootFromParent_Done,
     /* 394875 */   // Label 7959: @394875
     /* 394875 */   GIM_Reject,
     /* 394876 */ // Label 7957: @394876
     /* 394876 */ GIM_Reject,
     /* 394877 */ // Label 7934: @394877
     /* 394877 */ GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(395085),
     /* 394882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 394888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394892 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(395007), // Rule ID 5410 //
     /* 394897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 394905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394914 */     // MIs[1] Operand 2
     /* 394914 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 394925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 394929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 394933 */     // MIs[2] Rn
     /* 394933 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 394938 */     // MIs[2] Operand 2
     /* 394938 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 394949 */     // MIs[0] imm
     /* 394949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 394953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 394957 */     // MIs[3] Operand 1
     /* 394957 */     // No operand predicates
     /* 394957 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 394959 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 394959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 394966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394971 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394975 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 394982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394989 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 394996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395006 */     // GIR_Coverage, 5410,
     /* 395006 */     GIR_EraseRootFromParent_Done,
     /* 395007 */   // Label 7961: @395007
     /* 395007 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(395047), // Rule ID 1861 //
     /* 395012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395023 */     // MIs[0] imm
     /* 395023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 395027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395031 */     // MIs[1] Operand 1
     /* 395031 */     // No operand predicates
     /* 395031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395033 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 395033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 395036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 395042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 395045 */     GIR_RootConstrainSelectedInstOperands,
     /* 395046 */     // GIR_Coverage, 1861,
     /* 395046 */     GIR_EraseRootFromParent_Done,
     /* 395047 */   // Label 7962: @395047
     /* 395047 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(395084), // Rule ID 5407 //
     /* 395052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395060 */     // MIs[0] imm
     /* 395060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 395064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395068 */     // MIs[1] Operand 1
     /* 395068 */     // No operand predicates
     /* 395068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395070 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 395070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 395073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 395079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 395082 */     GIR_RootConstrainSelectedInstOperands,
     /* 395083 */     // GIR_Coverage, 5407,
     /* 395083 */     GIR_EraseRootFromParent_Done,
     /* 395084 */   // Label 7963: @395084
     /* 395084 */   GIM_Reject,
     /* 395085 */ // Label 7960: @395085
     /* 395085 */ GIM_Reject,
     /* 395086 */ // Label 7935: @395086
     /* 395086 */ GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(395168),
     /* 395091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395109 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(395138), // Rule ID 5413 //
     /* 395114 */     // MIs[0] imm
     /* 395114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 395118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395122 */     // MIs[1] Operand 1
     /* 395122 */     // No operand predicates
     /* 395122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395124 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 395124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 395127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 395133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 395136 */     GIR_RootConstrainSelectedInstOperands,
     /* 395137 */     // GIR_Coverage, 5413,
     /* 395137 */     GIR_EraseRootFromParent_Done,
     /* 395138 */   // Label 7965: @395138
     /* 395138 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(395167), // Rule ID 5418 //
     /* 395143 */     // MIs[0] imm
     /* 395143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 395147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395151 */     // MIs[1] Operand 1
     /* 395151 */     // No operand predicates
     /* 395151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395153 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 395153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 395156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 395162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 395165 */     GIR_RootConstrainSelectedInstOperands,
     /* 395166 */     // GIR_Coverage, 5418,
     /* 395166 */     GIR_EraseRootFromParent_Done,
     /* 395167 */   // Label 7966: @395167
     /* 395167 */   GIM_Reject,
     /* 395168 */ // Label 7964: @395168
     /* 395168 */ GIM_Reject,
     /* 395169 */ // Label 7936: @395169
     /* 395169 */ GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(395254),
     /* 395174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 395180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395192 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(395224), // Rule ID 1862 //
     /* 395197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395200 */     // MIs[0] imm
     /* 395200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 395204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395208 */     // MIs[1] Operand 1
     /* 395208 */     // No operand predicates
     /* 395208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395210 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 395210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 395213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 395219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 395222 */     GIR_RootConstrainSelectedInstOperands,
     /* 395223 */     // GIR_Coverage, 1862,
     /* 395223 */     GIR_EraseRootFromParent_Done,
     /* 395224 */   // Label 7968: @395224
     /* 395224 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(395253), // Rule ID 5408 //
     /* 395229 */     // MIs[0] imm
     /* 395229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 395233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395237 */     // MIs[1] Operand 1
     /* 395237 */     // No operand predicates
     /* 395237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395239 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 395239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 395242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395244 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 395246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 395248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 395251 */     GIR_RootConstrainSelectedInstOperands,
     /* 395252 */     // GIR_Coverage, 5408,
     /* 395252 */     GIR_EraseRootFromParent_Done,
     /* 395253 */   // Label 7969: @395253
     /* 395253 */   GIM_Reject,
     /* 395254 */ // Label 7967: @395254
     /* 395254 */ GIM_Reject,
     /* 395255 */ // Label 7937: @395255
     /* 395255 */ GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(395301), // Rule ID 2724 //
     /* 395260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 395263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 395266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 395269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395273 */   // MIs[0] Op3
     /* 395273 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 395277 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 395281 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 395285 */   // MIs[1] Operand 1
     /* 395285 */   // No operand predicates
     /* 395285 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395287 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 395287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 395290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 395292 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 395294 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 395296 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 395299 */   GIR_RootConstrainSelectedInstOperands,
     /* 395300 */   // GIR_Coverage, 2724,
     /* 395300 */   GIR_EraseRootFromParent_Done,
     /* 395301 */ // Label 7970: @395301
     /* 395301 */ GIM_Reject,
     /* 395302 */ // Label 7938: @395302
     /* 395302 */ GIM_Reject,
     /* 395303 */ // Label 128: @395303
     /* 395303 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7978*/ GIMT_Encode4(395641),
     /* 395314 */ /*GILLT_s32*//*Label 7971*/ GIMT_Encode4(395350),
     /* 395318 */ /*GILLT_s64*//*Label 7972*/ GIMT_Encode4(395388), GIMT_Encode4(0),
     /* 395326 */ /*GILLT_v2s32*//*Label 7973*/ GIMT_Encode4(395451),
     /* 395330 */ /*GILLT_v2s64*//*Label 7974*/ GIMT_Encode4(395489),
     /* 395334 */ /*GILLT_v4s16*//*Label 7975*/ GIMT_Encode4(395527),
     /* 395338 */ /*GILLT_v4s32*//*Label 7976*/ GIMT_Encode4(395565), GIMT_Encode4(0),
     /* 395346 */ /*GILLT_v8s16*//*Label 7977*/ GIMT_Encode4(395603),
     /* 395350 */ // Label 7971: @395350
     /* 395350 */ GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(395387), // Rule ID 1615 //
     /* 395355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 395364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395376 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 395376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 395381 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395385 */   GIR_RootConstrainSelectedInstOperands,
     /* 395386 */   // GIR_Coverage, 1615,
     /* 395386 */   GIR_Done,
     /* 395387 */ // Label 7979: @395387
     /* 395387 */ GIM_Reject,
     /* 395388 */ // Label 7972: @395388
     /* 395388 */ GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(395450),
     /* 395393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 395399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395411 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(395430), // Rule ID 1614 //
     /* 395416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395419 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 395419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 395424 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395428 */     GIR_RootConstrainSelectedInstOperands,
     /* 395429 */     // GIR_Coverage, 1614,
     /* 395429 */     GIR_Done,
     /* 395430 */   // Label 7981: @395430
     /* 395430 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(395449), // Rule ID 5188 //
     /* 395435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395438 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 395438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 395443 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395447 */     GIR_RootConstrainSelectedInstOperands,
     /* 395448 */     // GIR_Coverage, 5188,
     /* 395448 */     GIR_Done,
     /* 395449 */   // Label 7982: @395449
     /* 395449 */   GIM_Reject,
     /* 395450 */ // Label 7980: @395450
     /* 395450 */ GIM_Reject,
     /* 395451 */ // Label 7973: @395451
     /* 395451 */ GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(395488), // Rule ID 1203 //
     /* 395456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 395465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395477 */   // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 395477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 395482 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395486 */   GIR_RootConstrainSelectedInstOperands,
     /* 395487 */   // GIR_Coverage, 1203,
     /* 395487 */   GIR_Done,
     /* 395488 */ // Label 7983: @395488
     /* 395488 */ GIM_Reject,
     /* 395489 */ // Label 7974: @395489
     /* 395489 */ GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(395526), // Rule ID 1205 //
     /* 395494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 395503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395515 */   // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 395515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 395520 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395524 */   GIR_RootConstrainSelectedInstOperands,
     /* 395525 */   // GIR_Coverage, 1205,
     /* 395525 */   GIR_Done,
     /* 395526 */ // Label 7984: @395526
     /* 395526 */ GIM_Reject,
     /* 395527 */ // Label 7975: @395527
     /* 395527 */ GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(395564), // Rule ID 1201 //
     /* 395532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 395541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395553 */   // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 395553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 395558 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395562 */   GIR_RootConstrainSelectedInstOperands,
     /* 395563 */   // GIR_Coverage, 1201,
     /* 395563 */   GIR_Done,
     /* 395564 */ // Label 7985: @395564
     /* 395564 */ GIM_Reject,
     /* 395565 */ // Label 7976: @395565
     /* 395565 */ GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(395602), // Rule ID 1204 //
     /* 395570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 395579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395591 */   // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 395591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 395596 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395600 */   GIR_RootConstrainSelectedInstOperands,
     /* 395601 */   // GIR_Coverage, 1204,
     /* 395601 */   GIR_Done,
     /* 395602 */ // Label 7986: @395602
     /* 395602 */ GIM_Reject,
     /* 395603 */ // Label 7977: @395603
     /* 395603 */ GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(395640), // Rule ID 1202 //
     /* 395608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395629 */   // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 395629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 395634 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395638 */   GIR_RootConstrainSelectedInstOperands,
     /* 395639 */   // GIR_Coverage, 1202,
     /* 395639 */   GIR_Done,
     /* 395640 */ // Label 7987: @395640
     /* 395640 */ GIM_Reject,
     /* 395641 */ // Label 7978: @395641
     /* 395641 */ GIM_Reject,
     /* 395642 */ // Label 129: @395642
     /* 395642 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 7994*/ GIMT_Encode4(395871),
     /* 395653 */ /*GILLT_s64*//*Label 7988*/ GIMT_Encode4(395685), GIMT_Encode4(0),
     /* 395661 */ /*GILLT_v2s32*//*Label 7989*/ GIMT_Encode4(395716),
     /* 395665 */ /*GILLT_v2s64*//*Label 7990*/ GIMT_Encode4(395747),
     /* 395669 */ /*GILLT_v4s16*//*Label 7991*/ GIMT_Encode4(395778),
     /* 395673 */ /*GILLT_v4s32*//*Label 7992*/ GIMT_Encode4(395809), GIMT_Encode4(0),
     /* 395681 */ /*GILLT_v8s16*//*Label 7993*/ GIMT_Encode4(395840),
     /* 395685 */ // Label 7988: @395685
     /* 395685 */ GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(395715), // Rule ID 2504 //
     /* 395690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395704 */   // (AArch64fcmeqz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 395704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 395709 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395713 */   GIR_RootConstrainSelectedInstOperands,
     /* 395714 */   // GIR_Coverage, 2504,
     /* 395714 */   GIR_Done,
     /* 395715 */ // Label 7995: @395715
     /* 395715 */ GIM_Reject,
     /* 395716 */ // Label 7989: @395716
     /* 395716 */ GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(395746), // Rule ID 766 //
     /* 395721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395735 */   // (AArch64fcmeqz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 395735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 395740 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395744 */   GIR_RootConstrainSelectedInstOperands,
     /* 395745 */   // GIR_Coverage, 766,
     /* 395745 */   GIR_Done,
     /* 395746 */ // Label 7996: @395746
     /* 395746 */ GIM_Reject,
     /* 395747 */ // Label 7990: @395747
     /* 395747 */ GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(395777), // Rule ID 768 //
     /* 395752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395766 */   // (AArch64fcmeqz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 395766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 395771 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395775 */   GIR_RootConstrainSelectedInstOperands,
     /* 395776 */   // GIR_Coverage, 768,
     /* 395776 */   GIR_Done,
     /* 395777 */ // Label 7997: @395777
     /* 395777 */ GIM_Reject,
     /* 395778 */ // Label 7991: @395778
     /* 395778 */ GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(395808), // Rule ID 764 //
     /* 395783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395797 */   // (AArch64fcmeqz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 395797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 395802 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395806 */   GIR_RootConstrainSelectedInstOperands,
     /* 395807 */   // GIR_Coverage, 764,
     /* 395807 */   GIR_Done,
     /* 395808 */ // Label 7998: @395808
     /* 395808 */ GIM_Reject,
     /* 395809 */ // Label 7992: @395809
     /* 395809 */ GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(395839), // Rule ID 767 //
     /* 395814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395828 */   // (AArch64fcmeqz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 395828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 395833 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395837 */   GIR_RootConstrainSelectedInstOperands,
     /* 395838 */   // GIR_Coverage, 767,
     /* 395838 */   GIR_Done,
     /* 395839 */ // Label 7999: @395839
     /* 395839 */ GIM_Reject,
     /* 395840 */ // Label 7993: @395840
     /* 395840 */ GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(395870), // Rule ID 765 //
     /* 395845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395859 */   // (AArch64fcmeqz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 395859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 395864 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395868 */   GIR_RootConstrainSelectedInstOperands,
     /* 395869 */   // GIR_Coverage, 765,
     /* 395869 */   GIR_Done,
     /* 395870 */ // Label 8000: @395870
     /* 395870 */ GIM_Reject,
     /* 395871 */ // Label 7994: @395871
     /* 395871 */ GIM_Reject,
     /* 395872 */ // Label 130: @395872
     /* 395872 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8008*/ GIMT_Encode4(396535),
     /* 395883 */ /*GILLT_s32*//*Label 8001*/ GIMT_Encode4(395919),
     /* 395887 */ /*GILLT_s64*//*Label 8002*/ GIMT_Encode4(395957), GIMT_Encode4(0),
     /* 395895 */ /*GILLT_v2s32*//*Label 8003*/ GIMT_Encode4(396020),
     /* 395899 */ /*GILLT_v2s64*//*Label 8004*/ GIMT_Encode4(396123),
     /* 395903 */ /*GILLT_v4s16*//*Label 8005*/ GIMT_Encode4(396226),
     /* 395907 */ /*GILLT_v4s32*//*Label 8006*/ GIMT_Encode4(396329), GIMT_Encode4(0),
     /* 395915 */ /*GILLT_v8s16*//*Label 8007*/ GIMT_Encode4(396432),
     /* 395919 */ // Label 8001: @395919
     /* 395919 */ GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(395956), // Rule ID 1617 //
     /* 395924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 395933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395945 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 395945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 395950 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395954 */   GIR_RootConstrainSelectedInstOperands,
     /* 395955 */   // GIR_Coverage, 1617,
     /* 395955 */   GIR_Done,
     /* 395956 */ // Label 8009: @395956
     /* 395956 */ GIM_Reject,
     /* 395957 */ // Label 8002: @395957
     /* 395957 */ GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(396019),
     /* 395962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 395968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395980 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(395999), // Rule ID 1616 //
     /* 395985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395988 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 395988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 395993 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395997 */     GIR_RootConstrainSelectedInstOperands,
     /* 395998 */     // GIR_Coverage, 1616,
     /* 395998 */     GIR_Done,
     /* 395999 */   // Label 8011: @395999
     /* 395999 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(396018), // Rule ID 5189 //
     /* 396004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396007 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 396007 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 396012 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396016 */     GIR_RootConstrainSelectedInstOperands,
     /* 396017 */     // GIR_Coverage, 5189,
     /* 396017 */     GIR_Done,
     /* 396018 */   // Label 8012: @396018
     /* 396018 */   GIM_Reject,
     /* 396019 */ // Label 8010: @396019
     /* 396019 */ GIM_Reject,
     /* 396020 */ // Label 8003: @396020
     /* 396020 */ GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(396122),
     /* 396025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 396031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396035 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(396094), // Rule ID 1165 //
     /* 396040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 396051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 396068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396079 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 396079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 396082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396092 */     GIR_RootConstrainSelectedInstOperands,
     /* 396093 */     // GIR_Coverage, 1165,
     /* 396093 */     GIR_EraseRootFromParent_Done,
     /* 396094 */   // Label 8014: @396094
     /* 396094 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(396121), // Rule ID 1208 //
     /* 396099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396110 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 396110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 396115 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396119 */     GIR_RootConstrainSelectedInstOperands,
     /* 396120 */     // GIR_Coverage, 1208,
     /* 396120 */     GIR_Done,
     /* 396121 */   // Label 8015: @396121
     /* 396121 */   GIM_Reject,
     /* 396122 */ // Label 8013: @396122
     /* 396122 */ GIM_Reject,
     /* 396123 */ // Label 8004: @396123
     /* 396123 */ GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(396225),
     /* 396128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 396134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396138 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(396197), // Rule ID 1169 //
     /* 396143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 396154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 396171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396182 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 396182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 396185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396195 */     GIR_RootConstrainSelectedInstOperands,
     /* 396196 */     // GIR_Coverage, 1169,
     /* 396196 */     GIR_EraseRootFromParent_Done,
     /* 396197 */   // Label 8017: @396197
     /* 396197 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(396224), // Rule ID 1210 //
     /* 396202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396213 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 396213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 396218 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396222 */     GIR_RootConstrainSelectedInstOperands,
     /* 396223 */     // GIR_Coverage, 1210,
     /* 396223 */     GIR_Done,
     /* 396224 */   // Label 8018: @396224
     /* 396224 */   GIM_Reject,
     /* 396225 */ // Label 8016: @396225
     /* 396225 */ GIM_Reject,
     /* 396226 */ // Label 8005: @396226
     /* 396226 */ GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(396328),
     /* 396231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 396237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396241 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(396300), // Rule ID 1161 //
     /* 396246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 396257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 396274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396285 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 396285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 396288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396298 */     GIR_RootConstrainSelectedInstOperands,
     /* 396299 */     // GIR_Coverage, 1161,
     /* 396299 */     GIR_EraseRootFromParent_Done,
     /* 396300 */   // Label 8020: @396300
     /* 396300 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(396327), // Rule ID 1206 //
     /* 396305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396316 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 396316 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 396321 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396325 */     GIR_RootConstrainSelectedInstOperands,
     /* 396326 */     // GIR_Coverage, 1206,
     /* 396326 */     GIR_Done,
     /* 396327 */   // Label 8021: @396327
     /* 396327 */   GIM_Reject,
     /* 396328 */ // Label 8019: @396328
     /* 396328 */ GIM_Reject,
     /* 396329 */ // Label 8006: @396329
     /* 396329 */ GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(396431),
     /* 396334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 396340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396344 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(396403), // Rule ID 1167 //
     /* 396349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 396360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 396377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396388 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 396388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 396391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396401 */     GIR_RootConstrainSelectedInstOperands,
     /* 396402 */     // GIR_Coverage, 1167,
     /* 396402 */     GIR_EraseRootFromParent_Done,
     /* 396403 */   // Label 8023: @396403
     /* 396403 */   GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(396430), // Rule ID 1209 //
     /* 396408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396419 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 396419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 396424 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396428 */     GIR_RootConstrainSelectedInstOperands,
     /* 396429 */     // GIR_Coverage, 1209,
     /* 396429 */     GIR_Done,
     /* 396430 */   // Label 8024: @396430
     /* 396430 */   GIM_Reject,
     /* 396431 */ // Label 8022: @396431
     /* 396431 */ GIM_Reject,
     /* 396432 */ // Label 8007: @396432
     /* 396432 */ GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(396534),
     /* 396437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 396443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396447 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(396506), // Rule ID 1163 //
     /* 396452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 396463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 396480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396491 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 396491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 396494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396504 */     GIR_RootConstrainSelectedInstOperands,
     /* 396505 */     // GIR_Coverage, 1163,
     /* 396505 */     GIR_EraseRootFromParent_Done,
     /* 396506 */   // Label 8026: @396506
     /* 396506 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(396533), // Rule ID 1207 //
     /* 396511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396522 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 396522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 396527 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396531 */     GIR_RootConstrainSelectedInstOperands,
     /* 396532 */     // GIR_Coverage, 1207,
     /* 396532 */     GIR_Done,
     /* 396533 */   // Label 8027: @396533
     /* 396533 */   GIM_Reject,
     /* 396534 */ // Label 8025: @396534
     /* 396534 */ GIM_Reject,
     /* 396535 */ // Label 8008: @396535
     /* 396535 */ GIM_Reject,
     /* 396536 */ // Label 131: @396536
     /* 396536 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8034*/ GIMT_Encode4(396765),
     /* 396547 */ /*GILLT_s64*//*Label 8028*/ GIMT_Encode4(396579), GIMT_Encode4(0),
     /* 396555 */ /*GILLT_v2s32*//*Label 8029*/ GIMT_Encode4(396610),
     /* 396559 */ /*GILLT_v2s64*//*Label 8030*/ GIMT_Encode4(396641),
     /* 396563 */ /*GILLT_v4s16*//*Label 8031*/ GIMT_Encode4(396672),
     /* 396567 */ /*GILLT_v4s32*//*Label 8032*/ GIMT_Encode4(396703), GIMT_Encode4(0),
     /* 396575 */ /*GILLT_v8s16*//*Label 8033*/ GIMT_Encode4(396734),
     /* 396579 */ // Label 8028: @396579
     /* 396579 */ GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(396609), // Rule ID 5219 //
     /* 396584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396598 */   // (AArch64fcmgez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 396598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 396603 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396607 */   GIR_RootConstrainSelectedInstOperands,
     /* 396608 */   // GIR_Coverage, 5219,
     /* 396608 */   GIR_Done,
     /* 396609 */ // Label 8035: @396609
     /* 396609 */ GIM_Reject,
     /* 396610 */ // Label 8029: @396610
     /* 396610 */ GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(396640), // Rule ID 771 //
     /* 396615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396629 */   // (AArch64fcmgez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 396629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 396634 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396638 */   GIR_RootConstrainSelectedInstOperands,
     /* 396639 */   // GIR_Coverage, 771,
     /* 396639 */   GIR_Done,
     /* 396640 */ // Label 8036: @396640
     /* 396640 */ GIM_Reject,
     /* 396641 */ // Label 8030: @396641
     /* 396641 */ GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(396671), // Rule ID 773 //
     /* 396646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396660 */   // (AArch64fcmgez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 396660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 396665 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396669 */   GIR_RootConstrainSelectedInstOperands,
     /* 396670 */   // GIR_Coverage, 773,
     /* 396670 */   GIR_Done,
     /* 396671 */ // Label 8037: @396671
     /* 396671 */ GIM_Reject,
     /* 396672 */ // Label 8031: @396672
     /* 396672 */ GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(396702), // Rule ID 769 //
     /* 396677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396691 */   // (AArch64fcmgez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 396691 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 396696 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396700 */   GIR_RootConstrainSelectedInstOperands,
     /* 396701 */   // GIR_Coverage, 769,
     /* 396701 */   GIR_Done,
     /* 396702 */ // Label 8038: @396702
     /* 396702 */ GIM_Reject,
     /* 396703 */ // Label 8032: @396703
     /* 396703 */ GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(396733), // Rule ID 772 //
     /* 396708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396722 */   // (AArch64fcmgez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 396722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 396727 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396731 */   GIR_RootConstrainSelectedInstOperands,
     /* 396732 */   // GIR_Coverage, 772,
     /* 396732 */   GIR_Done,
     /* 396733 */ // Label 8039: @396733
     /* 396733 */ GIM_Reject,
     /* 396734 */ // Label 8033: @396734
     /* 396734 */ GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(396764), // Rule ID 770 //
     /* 396739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396753 */   // (AArch64fcmgez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 396753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 396758 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396762 */   GIR_RootConstrainSelectedInstOperands,
     /* 396763 */   // GIR_Coverage, 770,
     /* 396763 */   GIR_Done,
     /* 396764 */ // Label 8040: @396764
     /* 396764 */ GIM_Reject,
     /* 396765 */ // Label 8034: @396765
     /* 396765 */ GIM_Reject,
     /* 396766 */ // Label 132: @396766
     /* 396766 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8048*/ GIMT_Encode4(397429),
     /* 396777 */ /*GILLT_s32*//*Label 8041*/ GIMT_Encode4(396813),
     /* 396781 */ /*GILLT_s64*//*Label 8042*/ GIMT_Encode4(396851), GIMT_Encode4(0),
     /* 396789 */ /*GILLT_v2s32*//*Label 8043*/ GIMT_Encode4(396914),
     /* 396793 */ /*GILLT_v2s64*//*Label 8044*/ GIMT_Encode4(397017),
     /* 396797 */ /*GILLT_v4s16*//*Label 8045*/ GIMT_Encode4(397120),
     /* 396801 */ /*GILLT_v4s32*//*Label 8046*/ GIMT_Encode4(397223), GIMT_Encode4(0),
     /* 396809 */ /*GILLT_v8s16*//*Label 8047*/ GIMT_Encode4(397326),
     /* 396813 */ // Label 8041: @396813
     /* 396813 */ GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(396850), // Rule ID 1619 //
     /* 396818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 396827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396839 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 396839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 396844 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396848 */   GIR_RootConstrainSelectedInstOperands,
     /* 396849 */   // GIR_Coverage, 1619,
     /* 396849 */   GIR_Done,
     /* 396850 */ // Label 8049: @396850
     /* 396850 */ GIM_Reject,
     /* 396851 */ // Label 8042: @396851
     /* 396851 */ GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(396913),
     /* 396856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 396862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396874 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(396893), // Rule ID 1618 //
     /* 396879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396882 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 396882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 396887 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396891 */     GIR_RootConstrainSelectedInstOperands,
     /* 396892 */     // GIR_Coverage, 1618,
     /* 396892 */     GIR_Done,
     /* 396893 */   // Label 8051: @396893
     /* 396893 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(396912), // Rule ID 5190 //
     /* 396898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396901 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 396901 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 396906 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396910 */     GIR_RootConstrainSelectedInstOperands,
     /* 396911 */     // GIR_Coverage, 5190,
     /* 396911 */     GIR_Done,
     /* 396912 */   // Label 8052: @396912
     /* 396912 */   GIM_Reject,
     /* 396913 */ // Label 8050: @396913
     /* 396913 */ GIM_Reject,
     /* 396914 */ // Label 8043: @396914
     /* 396914 */ GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(397016),
     /* 396919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 396925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396929 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(396988), // Rule ID 1175 //
     /* 396934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 396945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 396962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396973 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 396973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 396976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396986 */     GIR_RootConstrainSelectedInstOperands,
     /* 396987 */     // GIR_Coverage, 1175,
     /* 396987 */     GIR_EraseRootFromParent_Done,
     /* 396988 */   // Label 8054: @396988
     /* 396988 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(397015), // Rule ID 1213 //
     /* 396993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397004 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 397004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 397009 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397013 */     GIR_RootConstrainSelectedInstOperands,
     /* 397014 */     // GIR_Coverage, 1213,
     /* 397014 */     GIR_Done,
     /* 397015 */   // Label 8055: @397015
     /* 397015 */   GIM_Reject,
     /* 397016 */ // Label 8053: @397016
     /* 397016 */ GIM_Reject,
     /* 397017 */ // Label 8044: @397017
     /* 397017 */ GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(397119),
     /* 397022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 397028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397032 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(397091), // Rule ID 1179 //
     /* 397037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 397048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 397065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397076 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 397076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 397079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397089 */     GIR_RootConstrainSelectedInstOperands,
     /* 397090 */     // GIR_Coverage, 1179,
     /* 397090 */     GIR_EraseRootFromParent_Done,
     /* 397091 */   // Label 8057: @397091
     /* 397091 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(397118), // Rule ID 1215 //
     /* 397096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397107 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 397107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 397112 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397116 */     GIR_RootConstrainSelectedInstOperands,
     /* 397117 */     // GIR_Coverage, 1215,
     /* 397117 */     GIR_Done,
     /* 397118 */   // Label 8058: @397118
     /* 397118 */   GIM_Reject,
     /* 397119 */ // Label 8056: @397119
     /* 397119 */ GIM_Reject,
     /* 397120 */ // Label 8045: @397120
     /* 397120 */ GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(397222),
     /* 397125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 397131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397135 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(397194), // Rule ID 1171 //
     /* 397140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 397151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 397168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397179 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 397179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 397182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397192 */     GIR_RootConstrainSelectedInstOperands,
     /* 397193 */     // GIR_Coverage, 1171,
     /* 397193 */     GIR_EraseRootFromParent_Done,
     /* 397194 */   // Label 8060: @397194
     /* 397194 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(397221), // Rule ID 1211 //
     /* 397199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397210 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 397210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 397215 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397219 */     GIR_RootConstrainSelectedInstOperands,
     /* 397220 */     // GIR_Coverage, 1211,
     /* 397220 */     GIR_Done,
     /* 397221 */   // Label 8061: @397221
     /* 397221 */   GIM_Reject,
     /* 397222 */ // Label 8059: @397222
     /* 397222 */ GIM_Reject,
     /* 397223 */ // Label 8046: @397223
     /* 397223 */ GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(397325),
     /* 397228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 397234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397238 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(397297), // Rule ID 1177 //
     /* 397243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 397254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 397271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397282 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 397282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 397285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397295 */     GIR_RootConstrainSelectedInstOperands,
     /* 397296 */     // GIR_Coverage, 1177,
     /* 397296 */     GIR_EraseRootFromParent_Done,
     /* 397297 */   // Label 8063: @397297
     /* 397297 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(397324), // Rule ID 1214 //
     /* 397302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397313 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 397313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 397318 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397322 */     GIR_RootConstrainSelectedInstOperands,
     /* 397323 */     // GIR_Coverage, 1214,
     /* 397323 */     GIR_Done,
     /* 397324 */   // Label 8064: @397324
     /* 397324 */   GIM_Reject,
     /* 397325 */ // Label 8062: @397325
     /* 397325 */ GIM_Reject,
     /* 397326 */ // Label 8047: @397326
     /* 397326 */ GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(397428),
     /* 397331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 397337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397341 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(397400), // Rule ID 1173 //
     /* 397346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 397357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 397374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397385 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 397385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 397388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397398 */     GIR_RootConstrainSelectedInstOperands,
     /* 397399 */     // GIR_Coverage, 1173,
     /* 397399 */     GIR_EraseRootFromParent_Done,
     /* 397400 */   // Label 8066: @397400
     /* 397400 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(397427), // Rule ID 1212 //
     /* 397405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397416 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 397416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 397421 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397425 */     GIR_RootConstrainSelectedInstOperands,
     /* 397426 */     // GIR_Coverage, 1212,
     /* 397426 */     GIR_Done,
     /* 397427 */   // Label 8067: @397427
     /* 397427 */   GIM_Reject,
     /* 397428 */ // Label 8065: @397428
     /* 397428 */ GIM_Reject,
     /* 397429 */ // Label 8048: @397429
     /* 397429 */ GIM_Reject,
     /* 397430 */ // Label 133: @397430
     /* 397430 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8074*/ GIMT_Encode4(397659),
     /* 397441 */ /*GILLT_s64*//*Label 8068*/ GIMT_Encode4(397473), GIMT_Encode4(0),
     /* 397449 */ /*GILLT_v2s32*//*Label 8069*/ GIMT_Encode4(397504),
     /* 397453 */ /*GILLT_v2s64*//*Label 8070*/ GIMT_Encode4(397535),
     /* 397457 */ /*GILLT_v4s16*//*Label 8071*/ GIMT_Encode4(397566),
     /* 397461 */ /*GILLT_v4s32*//*Label 8072*/ GIMT_Encode4(397597), GIMT_Encode4(0),
     /* 397469 */ /*GILLT_v8s16*//*Label 8073*/ GIMT_Encode4(397628),
     /* 397473 */ // Label 8068: @397473
     /* 397473 */ GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(397503), // Rule ID 5220 //
     /* 397478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 397484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397492 */   // (AArch64fcmgtz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 397492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 397497 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397501 */   GIR_RootConstrainSelectedInstOperands,
     /* 397502 */   // GIR_Coverage, 5220,
     /* 397502 */   GIR_Done,
     /* 397503 */ // Label 8075: @397503
     /* 397503 */ GIM_Reject,
     /* 397504 */ // Label 8069: @397504
     /* 397504 */ GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(397534), // Rule ID 776 //
     /* 397509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397523 */   // (AArch64fcmgtz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 397523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 397528 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397532 */   GIR_RootConstrainSelectedInstOperands,
     /* 397533 */   // GIR_Coverage, 776,
     /* 397533 */   GIR_Done,
     /* 397534 */ // Label 8076: @397534
     /* 397534 */ GIM_Reject,
     /* 397535 */ // Label 8070: @397535
     /* 397535 */ GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(397565), // Rule ID 778 //
     /* 397540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397554 */   // (AArch64fcmgtz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 397554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 397559 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397563 */   GIR_RootConstrainSelectedInstOperands,
     /* 397564 */   // GIR_Coverage, 778,
     /* 397564 */   GIR_Done,
     /* 397565 */ // Label 8077: @397565
     /* 397565 */ GIM_Reject,
     /* 397566 */ // Label 8071: @397566
     /* 397566 */ GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(397596), // Rule ID 774 //
     /* 397571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397585 */   // (AArch64fcmgtz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 397585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 397590 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397594 */   GIR_RootConstrainSelectedInstOperands,
     /* 397595 */   // GIR_Coverage, 774,
     /* 397595 */   GIR_Done,
     /* 397596 */ // Label 8078: @397596
     /* 397596 */ GIM_Reject,
     /* 397597 */ // Label 8072: @397597
     /* 397597 */ GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(397627), // Rule ID 777 //
     /* 397602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397616 */   // (AArch64fcmgtz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 397616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 397621 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397625 */   GIR_RootConstrainSelectedInstOperands,
     /* 397626 */   // GIR_Coverage, 777,
     /* 397626 */   GIR_Done,
     /* 397627 */ // Label 8079: @397627
     /* 397627 */ GIM_Reject,
     /* 397628 */ // Label 8073: @397628
     /* 397628 */ GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(397658), // Rule ID 775 //
     /* 397633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397647 */   // (AArch64fcmgtz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 397647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 397652 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397656 */   GIR_RootConstrainSelectedInstOperands,
     /* 397657 */   // GIR_Coverage, 775,
     /* 397657 */   GIR_Done,
     /* 397658 */ // Label 8080: @397658
     /* 397658 */ GIM_Reject,
     /* 397659 */ // Label 8074: @397659
     /* 397659 */ GIM_Reject,
     /* 397660 */ // Label 134: @397660
     /* 397660 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8087*/ GIMT_Encode4(397889),
     /* 397671 */ /*GILLT_s64*//*Label 8081*/ GIMT_Encode4(397703), GIMT_Encode4(0),
     /* 397679 */ /*GILLT_v2s32*//*Label 8082*/ GIMT_Encode4(397734),
     /* 397683 */ /*GILLT_v2s64*//*Label 8083*/ GIMT_Encode4(397765),
     /* 397687 */ /*GILLT_v4s16*//*Label 8084*/ GIMT_Encode4(397796),
     /* 397691 */ /*GILLT_v4s32*//*Label 8085*/ GIMT_Encode4(397827), GIMT_Encode4(0),
     /* 397699 */ /*GILLT_v8s16*//*Label 8086*/ GIMT_Encode4(397858),
     /* 397703 */ // Label 8081: @397703
     /* 397703 */ GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(397733), // Rule ID 5221 //
     /* 397708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 397714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397722 */   // (AArch64fcmlez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 397722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 397727 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397731 */   GIR_RootConstrainSelectedInstOperands,
     /* 397732 */   // GIR_Coverage, 5221,
     /* 397732 */   GIR_Done,
     /* 397733 */ // Label 8088: @397733
     /* 397733 */ GIM_Reject,
     /* 397734 */ // Label 8082: @397734
     /* 397734 */ GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(397764), // Rule ID 781 //
     /* 397739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397753 */   // (AArch64fcmlez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 397753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 397758 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397762 */   GIR_RootConstrainSelectedInstOperands,
     /* 397763 */   // GIR_Coverage, 781,
     /* 397763 */   GIR_Done,
     /* 397764 */ // Label 8089: @397764
     /* 397764 */ GIM_Reject,
     /* 397765 */ // Label 8083: @397765
     /* 397765 */ GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(397795), // Rule ID 783 //
     /* 397770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397784 */   // (AArch64fcmlez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 397784 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 397789 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397793 */   GIR_RootConstrainSelectedInstOperands,
     /* 397794 */   // GIR_Coverage, 783,
     /* 397794 */   GIR_Done,
     /* 397795 */ // Label 8090: @397795
     /* 397795 */ GIM_Reject,
     /* 397796 */ // Label 8084: @397796
     /* 397796 */ GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(397826), // Rule ID 779 //
     /* 397801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 397807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397815 */   // (AArch64fcmlez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 397815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 397820 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397824 */   GIR_RootConstrainSelectedInstOperands,
     /* 397825 */   // GIR_Coverage, 779,
     /* 397825 */   GIR_Done,
     /* 397826 */ // Label 8091: @397826
     /* 397826 */ GIM_Reject,
     /* 397827 */ // Label 8085: @397827
     /* 397827 */ GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(397857), // Rule ID 782 //
     /* 397832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397846 */   // (AArch64fcmlez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 397846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 397851 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397855 */   GIR_RootConstrainSelectedInstOperands,
     /* 397856 */   // GIR_Coverage, 782,
     /* 397856 */   GIR_Done,
     /* 397857 */ // Label 8092: @397857
     /* 397857 */ GIM_Reject,
     /* 397858 */ // Label 8086: @397858
     /* 397858 */ GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(397888), // Rule ID 780 //
     /* 397863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397877 */   // (AArch64fcmlez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 397877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 397882 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397886 */   GIR_RootConstrainSelectedInstOperands,
     /* 397887 */   // GIR_Coverage, 780,
     /* 397887 */   GIR_Done,
     /* 397888 */ // Label 8093: @397888
     /* 397888 */ GIM_Reject,
     /* 397889 */ // Label 8087: @397889
     /* 397889 */ GIM_Reject,
     /* 397890 */ // Label 135: @397890
     /* 397890 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8100*/ GIMT_Encode4(398119),
     /* 397901 */ /*GILLT_s64*//*Label 8094*/ GIMT_Encode4(397933), GIMT_Encode4(0),
     /* 397909 */ /*GILLT_v2s32*//*Label 8095*/ GIMT_Encode4(397964),
     /* 397913 */ /*GILLT_v2s64*//*Label 8096*/ GIMT_Encode4(397995),
     /* 397917 */ /*GILLT_v4s16*//*Label 8097*/ GIMT_Encode4(398026),
     /* 397921 */ /*GILLT_v4s32*//*Label 8098*/ GIMT_Encode4(398057), GIMT_Encode4(0),
     /* 397929 */ /*GILLT_v8s16*//*Label 8099*/ GIMT_Encode4(398088),
     /* 397933 */ // Label 8094: @397933
     /* 397933 */ GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(397963), // Rule ID 5222 //
     /* 397938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 397944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397952 */   // (AArch64fcmltz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 397952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 397957 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397961 */   GIR_RootConstrainSelectedInstOperands,
     /* 397962 */   // GIR_Coverage, 5222,
     /* 397962 */   GIR_Done,
     /* 397963 */ // Label 8101: @397963
     /* 397963 */ GIM_Reject,
     /* 397964 */ // Label 8095: @397964
     /* 397964 */ GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(397994), // Rule ID 786 //
     /* 397969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 397975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397983 */   // (AArch64fcmltz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 397983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 397988 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397992 */   GIR_RootConstrainSelectedInstOperands,
     /* 397993 */   // GIR_Coverage, 786,
     /* 397993 */   GIR_Done,
     /* 397994 */ // Label 8102: @397994
     /* 397994 */ GIM_Reject,
     /* 397995 */ // Label 8096: @397995
     /* 397995 */ GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(398025), // Rule ID 788 //
     /* 398000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398014 */   // (AArch64fcmltz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 398014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 398019 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398023 */   GIR_RootConstrainSelectedInstOperands,
     /* 398024 */   // GIR_Coverage, 788,
     /* 398024 */   GIR_Done,
     /* 398025 */ // Label 8103: @398025
     /* 398025 */ GIM_Reject,
     /* 398026 */ // Label 8097: @398026
     /* 398026 */ GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(398056), // Rule ID 784 //
     /* 398031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398045 */   // (AArch64fcmltz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 398045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 398050 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398054 */   GIR_RootConstrainSelectedInstOperands,
     /* 398055 */   // GIR_Coverage, 784,
     /* 398055 */   GIR_Done,
     /* 398056 */ // Label 8104: @398056
     /* 398056 */ GIM_Reject,
     /* 398057 */ // Label 8098: @398057
     /* 398057 */ GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(398087), // Rule ID 787 //
     /* 398062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398076 */   // (AArch64fcmltz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 398076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 398081 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398085 */   GIR_RootConstrainSelectedInstOperands,
     /* 398086 */   // GIR_Coverage, 787,
     /* 398086 */   GIR_Done,
     /* 398087 */ // Label 8105: @398087
     /* 398087 */ GIM_Reject,
     /* 398088 */ // Label 8099: @398088
     /* 398088 */ GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(398118), // Rule ID 785 //
     /* 398093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 398096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398107 */   // (AArch64fcmltz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 398107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 398112 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398116 */   GIR_RootConstrainSelectedInstOperands,
     /* 398117 */   // GIR_Coverage, 785,
     /* 398117 */   GIR_Done,
     /* 398118 */ // Label 8106: @398118
     /* 398118 */ GIM_Reject,
     /* 398119 */ // Label 8100: @398119
     /* 398119 */ GIM_Reject,
     /* 398120 */ // Label 136: @398120
     /* 398120 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8111*/ GIMT_Encode4(398273),
     /* 398131 */ /*GILLT_s32*//*Label 8107*/ GIMT_Encode4(398171),
     /* 398135 */ /*GILLT_s64*//*Label 8108*/ GIMT_Encode4(398195), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 398159 */ /*GILLT_v8s8*//*Label 8109*/ GIMT_Encode4(398219), GIMT_Encode4(0),
     /* 398167 */ /*GILLT_v16s8*//*Label 8110*/ GIMT_Encode4(398246),
     /* 398171 */ // Label 8107: @398171
     /* 398171 */ GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(398194), // Rule ID 3996 //
     /* 398176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 398179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 398183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 398187 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 398187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 398192 */   GIR_RootConstrainSelectedInstOperands,
     /* 398193 */   // GIR_Coverage, 3996,
     /* 398193 */   GIR_Done,
     /* 398194 */ // Label 8112: @398194
     /* 398194 */ GIM_Reject,
     /* 398195 */ // Label 8108: @398195
     /* 398195 */ GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(398218), // Rule ID 3997 //
     /* 398200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 398203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 398207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 398211 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 398211 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 398216 */   GIR_RootConstrainSelectedInstOperands,
     /* 398217 */   // GIR_Coverage, 3997,
     /* 398217 */   GIR_Done,
     /* 398218 */ // Label 8113: @398218
     /* 398218 */ GIM_Reject,
     /* 398219 */ // Label 8109: @398219
     /* 398219 */ GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(398245), // Rule ID 969 //
     /* 398224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398238 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 398238 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 398243 */   GIR_RootConstrainSelectedInstOperands,
     /* 398244 */   // GIR_Coverage, 969,
     /* 398244 */   GIR_Done,
     /* 398245 */ // Label 8114: @398245
     /* 398245 */ GIM_Reject,
     /* 398246 */ // Label 8110: @398246
     /* 398246 */ GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(398272), // Rule ID 970 //
     /* 398251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398265 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 398265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 398270 */   GIR_RootConstrainSelectedInstOperands,
     /* 398271 */   // GIR_Coverage, 970,
     /* 398271 */   GIR_Done,
     /* 398272 */ // Label 8115: @398272
     /* 398272 */ GIM_Reject,
     /* 398273 */ // Label 8111: @398273
     /* 398273 */ GIM_Reject,
     /* 398274 */ // Label 137: @398274
     /* 398274 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8120*/ GIMT_Encode4(398449),
     /* 398285 */ /*GILLT_v4s16*//*Label 8116*/ GIMT_Encode4(398305), GIMT_Encode4(0),
     /* 398293 */ /*GILLT_v8s8*//*Label 8117*/ GIMT_Encode4(398350),
     /* 398297 */ /*GILLT_v8s16*//*Label 8118*/ GIMT_Encode4(398377),
     /* 398301 */ /*GILLT_v16s8*//*Label 8119*/ GIMT_Encode4(398422),
     /* 398305 */ // Label 8116: @398305
     /* 398305 */ GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(398349),
     /* 398310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398321 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(398336), // Rule ID 973 //
     /* 398326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398329 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 398329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 398334 */     GIR_RootConstrainSelectedInstOperands,
     /* 398335 */     // GIR_Coverage, 973,
     /* 398335 */     GIR_Done,
     /* 398336 */   // Label 8122: @398336
     /* 398336 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(398348), // Rule ID 4941 //
     /* 398341 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 398341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 398346 */     GIR_RootConstrainSelectedInstOperands,
     /* 398347 */     // GIR_Coverage, 4941,
     /* 398347 */     GIR_Done,
     /* 398348 */   // Label 8123: @398348
     /* 398348 */   GIM_Reject,
     /* 398349 */ // Label 8121: @398349
     /* 398349 */ GIM_Reject,
     /* 398350 */ // Label 8117: @398350
     /* 398350 */ GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(398376), // Rule ID 971 //
     /* 398355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398369 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 398369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 398374 */   GIR_RootConstrainSelectedInstOperands,
     /* 398375 */   // GIR_Coverage, 971,
     /* 398375 */   GIR_Done,
     /* 398376 */ // Label 8124: @398376
     /* 398376 */ GIM_Reject,
     /* 398377 */ // Label 8118: @398377
     /* 398377 */ GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(398421),
     /* 398382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398393 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(398408), // Rule ID 974 //
     /* 398398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398401 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 398401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 398406 */     GIR_RootConstrainSelectedInstOperands,
     /* 398407 */     // GIR_Coverage, 974,
     /* 398407 */     GIR_Done,
     /* 398408 */   // Label 8126: @398408
     /* 398408 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(398420), // Rule ID 4943 //
     /* 398413 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 398413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 398418 */     GIR_RootConstrainSelectedInstOperands,
     /* 398419 */     // GIR_Coverage, 4943,
     /* 398419 */     GIR_Done,
     /* 398420 */   // Label 8127: @398420
     /* 398420 */   GIM_Reject,
     /* 398421 */ // Label 8125: @398421
     /* 398421 */ GIM_Reject,
     /* 398422 */ // Label 8119: @398422
     /* 398422 */ GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(398448), // Rule ID 972 //
     /* 398427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398441 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 398441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 398446 */   GIR_RootConstrainSelectedInstOperands,
     /* 398447 */   // GIR_Coverage, 972,
     /* 398447 */   GIR_Done,
     /* 398448 */ // Label 8128: @398448
     /* 398448 */ GIM_Reject,
     /* 398449 */ // Label 8120: @398449
     /* 398449 */ GIM_Reject,
     /* 398450 */ // Label 138: @398450
     /* 398450 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8135*/ GIMT_Encode4(398723),
     /* 398461 */ /*GILLT_v2s32*//*Label 8129*/ GIMT_Encode4(398489), GIMT_Encode4(0),
     /* 398469 */ /*GILLT_v4s16*//*Label 8130*/ GIMT_Encode4(398534),
     /* 398473 */ /*GILLT_v4s32*//*Label 8131*/ GIMT_Encode4(398579),
     /* 398477 */ /*GILLT_v8s8*//*Label 8132*/ GIMT_Encode4(398624),
     /* 398481 */ /*GILLT_v8s16*//*Label 8133*/ GIMT_Encode4(398651),
     /* 398485 */ /*GILLT_v16s8*//*Label 8134*/ GIMT_Encode4(398696),
     /* 398489 */ // Label 8129: @398489
     /* 398489 */ GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(398533),
     /* 398494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398505 */   GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(398520), // Rule ID 979 //
     /* 398510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398513 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 398513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 398518 */     GIR_RootConstrainSelectedInstOperands,
     /* 398519 */     // GIR_Coverage, 979,
     /* 398519 */     GIR_Done,
     /* 398520 */   // Label 8137: @398520
     /* 398520 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(398532), // Rule ID 4945 //
     /* 398525 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 398525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 398530 */     GIR_RootConstrainSelectedInstOperands,
     /* 398531 */     // GIR_Coverage, 4945,
     /* 398531 */     GIR_Done,
     /* 398532 */   // Label 8138: @398532
     /* 398532 */   GIM_Reject,
     /* 398533 */ // Label 8136: @398533
     /* 398533 */ GIM_Reject,
     /* 398534 */ // Label 8130: @398534
     /* 398534 */ GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(398578),
     /* 398539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398550 */   GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(398565), // Rule ID 977 //
     /* 398555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398558 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 398558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 398563 */     GIR_RootConstrainSelectedInstOperands,
     /* 398564 */     // GIR_Coverage, 977,
     /* 398564 */     GIR_Done,
     /* 398565 */   // Label 8140: @398565
     /* 398565 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(398577), // Rule ID 4942 //
     /* 398570 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 398570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 398575 */     GIR_RootConstrainSelectedInstOperands,
     /* 398576 */     // GIR_Coverage, 4942,
     /* 398576 */     GIR_Done,
     /* 398577 */   // Label 8141: @398577
     /* 398577 */   GIM_Reject,
     /* 398578 */ // Label 8139: @398578
     /* 398578 */ GIM_Reject,
     /* 398579 */ // Label 8131: @398579
     /* 398579 */ GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(398623),
     /* 398584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398595 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(398610), // Rule ID 980 //
     /* 398600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398603 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 398603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 398608 */     GIR_RootConstrainSelectedInstOperands,
     /* 398609 */     // GIR_Coverage, 980,
     /* 398609 */     GIR_Done,
     /* 398610 */   // Label 8143: @398610
     /* 398610 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(398622), // Rule ID 4946 //
     /* 398615 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 398615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 398620 */     GIR_RootConstrainSelectedInstOperands,
     /* 398621 */     // GIR_Coverage, 4946,
     /* 398621 */     GIR_Done,
     /* 398622 */   // Label 8144: @398622
     /* 398622 */   GIM_Reject,
     /* 398623 */ // Label 8142: @398623
     /* 398623 */ GIM_Reject,
     /* 398624 */ // Label 8132: @398624
     /* 398624 */ GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(398650), // Rule ID 975 //
     /* 398629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398643 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 398643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 398648 */   GIR_RootConstrainSelectedInstOperands,
     /* 398649 */   // GIR_Coverage, 975,
     /* 398649 */   GIR_Done,
     /* 398650 */ // Label 8145: @398650
     /* 398650 */ GIM_Reject,
     /* 398651 */ // Label 8133: @398651
     /* 398651 */ GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(398695),
     /* 398656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398667 */   GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(398682), // Rule ID 978 //
     /* 398672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398675 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 398675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 398680 */     GIR_RootConstrainSelectedInstOperands,
     /* 398681 */     // GIR_Coverage, 978,
     /* 398681 */     GIR_Done,
     /* 398682 */   // Label 8147: @398682
     /* 398682 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(398694), // Rule ID 4944 //
     /* 398687 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 398687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 398692 */     GIR_RootConstrainSelectedInstOperands,
     /* 398693 */     // GIR_Coverage, 4944,
     /* 398693 */     GIR_Done,
     /* 398694 */   // Label 8148: @398694
     /* 398694 */   GIM_Reject,
     /* 398695 */ // Label 8146: @398695
     /* 398695 */ GIM_Reject,
     /* 398696 */ // Label 8134: @398696
     /* 398696 */ GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(398722), // Rule ID 976 //
     /* 398701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398715 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 398715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 398720 */   GIR_RootConstrainSelectedInstOperands,
     /* 398721 */   // GIR_Coverage, 976,
     /* 398721 */   GIR_Done,
     /* 398722 */ // Label 8149: @398722
     /* 398722 */ GIM_Reject,
     /* 398723 */ // Label 8135: @398723
     /* 398723 */ GIM_Reject,
     /* 398724 */ // Label 139: @398724
     /* 398724 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8156*/ GIMT_Encode4(398929),
     /* 398735 */ /*GILLT_s64*//*Label 8150*/ GIMT_Encode4(398767), GIMT_Encode4(0),
     /* 398743 */ /*GILLT_v2s32*//*Label 8151*/ GIMT_Encode4(398794),
     /* 398747 */ /*GILLT_v2s64*//*Label 8152*/ GIMT_Encode4(398821),
     /* 398751 */ /*GILLT_v4s16*//*Label 8153*/ GIMT_Encode4(398848),
     /* 398755 */ /*GILLT_v4s32*//*Label 8154*/ GIMT_Encode4(398875), GIMT_Encode4(0),
     /* 398763 */ /*GILLT_v8s16*//*Label 8155*/ GIMT_Encode4(398902),
     /* 398767 */ // Label 8150: @398767
     /* 398767 */ GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(398793), // Rule ID 1001 //
     /* 398772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398786 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 398786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 398791 */   GIR_RootConstrainSelectedInstOperands,
     /* 398792 */   // GIR_Coverage, 1001,
     /* 398792 */   GIR_Done,
     /* 398793 */ // Label 8157: @398793
     /* 398793 */ GIM_Reject,
     /* 398794 */ // Label 8151: @398794
     /* 398794 */ GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(398820), // Rule ID 997 //
     /* 398799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 398805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398813 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 398813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 398818 */   GIR_RootConstrainSelectedInstOperands,
     /* 398819 */   // GIR_Coverage, 997,
     /* 398819 */   GIR_Done,
     /* 398820 */ // Label 8158: @398820
     /* 398820 */ GIM_Reject,
     /* 398821 */ // Label 8152: @398821
     /* 398821 */ GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(398847), // Rule ID 1003 //
     /* 398826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398840 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 398840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 398845 */   GIR_RootConstrainSelectedInstOperands,
     /* 398846 */   // GIR_Coverage, 1003,
     /* 398846 */   GIR_Done,
     /* 398847 */ // Label 8159: @398847
     /* 398847 */ GIM_Reject,
     /* 398848 */ // Label 8153: @398848
     /* 398848 */ GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(398874), // Rule ID 993 //
     /* 398853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 398859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398867 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 398867 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 398872 */   GIR_RootConstrainSelectedInstOperands,
     /* 398873 */   // GIR_Coverage, 993,
     /* 398873 */   GIR_Done,
     /* 398874 */ // Label 8160: @398874
     /* 398874 */ GIM_Reject,
     /* 398875 */ // Label 8154: @398875
     /* 398875 */ GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(398901), // Rule ID 999 //
     /* 398880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398894 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 398894 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 398899 */   GIR_RootConstrainSelectedInstOperands,
     /* 398900 */   // GIR_Coverage, 999,
     /* 398900 */   GIR_Done,
     /* 398901 */ // Label 8161: @398901
     /* 398901 */ GIM_Reject,
     /* 398902 */ // Label 8155: @398902
     /* 398902 */ GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(398928), // Rule ID 995 //
     /* 398907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398921 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 398921 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 398926 */   GIR_RootConstrainSelectedInstOperands,
     /* 398927 */   // GIR_Coverage, 995,
     /* 398927 */   GIR_Done,
     /* 398928 */ // Label 8162: @398928
     /* 398928 */ GIM_Reject,
     /* 398929 */ // Label 8156: @398929
     /* 398929 */ GIM_Reject,
     /* 398930 */ // Label 140: @398930
     /* 398930 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8165*/ GIMT_Encode4(399328),
     /* 398941 */ /*GILLT_v2s64*//*Label 8163*/ GIMT_Encode4(398953), GIMT_Encode4(0),
     /* 398949 */ /*GILLT_v4s32*//*Label 8164*/ GIMT_Encode4(399091),
     /* 398953 */ // Label 8163: @398953
     /* 398953 */ GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(399012), // Rule ID 5831 //
     /* 398958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398969 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 398969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 398976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398981 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 398985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 398990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 399001 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399011 */   // GIR_Coverage, 5831,
     /* 399011 */   GIR_EraseRootFromParent_Done,
     /* 399012 */ // Label 8166: @399012
     /* 399012 */ GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(399090), // Rule ID 5953 //
     /* 399017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399028 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 399028 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 399031 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 399035 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399040 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 399049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 399071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 399074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399079 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399084 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399089 */   // GIR_Coverage, 5953,
     /* 399089 */   GIR_EraseRootFromParent_Done,
     /* 399090 */ // Label 8167: @399090
     /* 399090 */ GIM_Reject,
     /* 399091 */ // Label 8164: @399091
     /* 399091 */ GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(399150), // Rule ID 5827 //
     /* 399096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399107 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 399107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 399110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 399114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399119 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 399128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399133 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 399139 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399144 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399149 */   // GIR_Coverage, 5827,
     /* 399149 */   GIR_EraseRootFromParent_Done,
     /* 399150 */ // Label 8168: @399150
     /* 399150 */ GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(399209), // Rule ID 5828 //
     /* 399155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399166 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 399166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 399169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 399173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399178 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 399187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399192 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 399198 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399208 */   // GIR_Coverage, 5828,
     /* 399208 */   GIR_EraseRootFromParent_Done,
     /* 399209 */ // Label 8169: @399209
     /* 399209 */ GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(399268), // Rule ID 5829 //
     /* 399214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399225 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 399225 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 399228 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 399232 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399237 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 399246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399251 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 399257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399262 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399267 */   // GIR_Coverage, 5829,
     /* 399267 */   GIR_EraseRootFromParent_Done,
     /* 399268 */ // Label 8170: @399268
     /* 399268 */ GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(399327), // Rule ID 5830 //
     /* 399273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399284 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 399284 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 399287 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 399291 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399296 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 399300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 399305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 399316 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399321 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399326 */   // GIR_Coverage, 5830,
     /* 399326 */   GIR_EraseRootFromParent_Done,
     /* 399327 */ // Label 8171: @399327
     /* 399327 */ GIM_Reject,
     /* 399328 */ // Label 8165: @399328
     /* 399328 */ GIM_Reject,
     /* 399329 */ // Label 141: @399329
     /* 399329 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8176*/ GIMT_Encode4(399698),
     /* 399340 */ /*GILLT_v2s32*//*Label 8172*/ GIMT_Encode4(399400), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 399352 */ /*GILLT_v4s32*//*Label 8173*/ GIMT_Encode4(399520), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 399384 */ /*GILLT_nxv2s64*//*Label 8174*/ GIMT_Encode4(399640), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 399396 */ /*GILLT_nxv4s32*//*Label 8175*/ GIMT_Encode4(399669),
     /* 399400 */ // Label 8172: @399400
     /* 399400 */ GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(399519),
     /* 399405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 399411 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 399414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399426 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(399499), // Rule ID 26 //
     /* 399431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 399434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 399442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399475 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399479 */     // MIs[3] Operand 1
     /* 399479 */     // No operand predicates
     /* 399479 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399481 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 399484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 399488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399497 */     GIR_RootConstrainSelectedInstOperands,
     /* 399498 */     // GIR_Coverage, 26,
     /* 399498 */     GIR_EraseRootFromParent_Done,
     /* 399499 */   // Label 8178: @399499
     /* 399499 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(399518), // Rule ID 22 //
     /* 399504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 399507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399511 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 399511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 399516 */     GIR_RootConstrainSelectedInstOperands,
     /* 399517 */     // GIR_Coverage, 22,
     /* 399517 */     GIR_Done,
     /* 399518 */   // Label 8179: @399518
     /* 399518 */   GIM_Reject,
     /* 399519 */ // Label 8177: @399519
     /* 399519 */ GIM_Reject,
     /* 399520 */ // Label 8173: @399520
     /* 399520 */ GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(399639),
     /* 399525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 399531 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 399534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399546 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(399619), // Rule ID 27 //
     /* 399551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 399554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 399562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399595 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399599 */     // MIs[3] Operand 1
     /* 399599 */     // No operand predicates
     /* 399599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399601 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 399604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 399608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399617 */     GIR_RootConstrainSelectedInstOperands,
     /* 399618 */     // GIR_Coverage, 27,
     /* 399618 */     GIR_EraseRootFromParent_Done,
     /* 399619 */   // Label 8181: @399619
     /* 399619 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(399638), // Rule ID 23 //
     /* 399624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 399627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399631 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 399631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 399636 */     GIR_RootConstrainSelectedInstOperands,
     /* 399637 */     // GIR_Coverage, 23,
     /* 399637 */     GIR_Done,
     /* 399638 */   // Label 8182: @399638
     /* 399638 */   GIM_Reject,
     /* 399639 */ // Label 8180: @399639
     /* 399639 */ GIM_Reject,
     /* 399640 */ // Label 8174: @399640
     /* 399640 */ GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(399668), // Rule ID 2977 //
     /* 399645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 399651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 399654 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 399657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399661 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 399661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 399666 */   GIR_RootConstrainSelectedInstOperands,
     /* 399667 */   // GIR_Coverage, 2977,
     /* 399667 */   GIR_Done,
     /* 399668 */ // Label 8183: @399668
     /* 399668 */ GIM_Reject,
     /* 399669 */ // Label 8175: @399669
     /* 399669 */ GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(399697), // Rule ID 2976 //
     /* 399674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 399680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 399683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 399686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399690 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 399690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 399695 */   GIR_RootConstrainSelectedInstOperands,
     /* 399696 */   // GIR_Coverage, 2976,
     /* 399696 */   GIR_Done,
     /* 399697 */ // Label 8184: @399697
     /* 399697 */ GIM_Reject,
     /* 399698 */ // Label 8176: @399698
     /* 399698 */ GIM_Reject,
     /* 399699 */ // Label 142: @399699
     /* 399699 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8188*/ GIMT_Encode4(399815),
     /* 399710 */ /*GILLT_s16*//*Label 8185*/ GIMT_Encode4(399722),
     /* 399714 */ /*GILLT_s32*//*Label 8186*/ GIMT_Encode4(399753),
     /* 399718 */ /*GILLT_s64*//*Label 8187*/ GIMT_Encode4(399784),
     /* 399722 */ // Label 8185: @399722
     /* 399722 */ GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(399752), // Rule ID 1651 //
     /* 399727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 399730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 399733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 399741 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 399741 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 399746 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399750 */   GIR_RootConstrainSelectedInstOperands,
     /* 399751 */   // GIR_Coverage, 1651,
     /* 399751 */   GIR_Done,
     /* 399752 */ // Label 8189: @399752
     /* 399752 */ GIM_Reject,
     /* 399753 */ // Label 8186: @399753
     /* 399753 */ GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(399783), // Rule ID 1650 //
     /* 399758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 399761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 399764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399772 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 399772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 399777 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399781 */   GIR_RootConstrainSelectedInstOperands,
     /* 399782 */   // GIR_Coverage, 1650,
     /* 399782 */   GIR_Done,
     /* 399783 */ // Label 8190: @399783
     /* 399783 */ GIM_Reject,
     /* 399784 */ // Label 8187: @399784
     /* 399784 */ GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(399814), // Rule ID 1649 //
     /* 399789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 399792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 399795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399803 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 399803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 399808 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399812 */   GIR_RootConstrainSelectedInstOperands,
     /* 399813 */   // GIR_Coverage, 1649,
     /* 399813 */   GIR_Done,
     /* 399814 */ // Label 8191: @399814
     /* 399814 */ GIM_Reject,
     /* 399815 */ // Label 8188: @399815
     /* 399815 */ GIM_Reject,
     /* 399816 */ // Label 143: @399816
     /* 399816 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8195*/ GIMT_Encode4(401048),
     /* 399827 */ /*GILLT_v2s64*//*Label 8192*/ GIMT_Encode4(399847), GIMT_Encode4(0),
     /* 399835 */ /*GILLT_v4s32*//*Label 8193*/ GIMT_Encode4(400408), GIMT_Encode4(0),
     /* 399843 */ /*GILLT_v8s16*//*Label 8194*/ GIMT_Encode4(400969),
     /* 399847 */ // Label 8192: @399847
     /* 399847 */ GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(400407),
     /* 399852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399862 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(399954), // Rule ID 2047 //
     /* 399867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399911 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399915 */     // MIs[3] Operand 1
     /* 399915 */     // No operand predicates
     /* 399915 */     // MIs[1] Operand 2
     /* 399915 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 399926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 399935 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 399938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 399945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399952 */     GIR_RootConstrainSelectedInstOperands,
     /* 399953 */     // GIR_Coverage, 2047,
     /* 399953 */     GIR_EraseRootFromParent_Done,
     /* 399954 */   // Label 8197: @399954
     /* 399954 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(400046), // Rule ID 13414 //
     /* 399959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399999 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400003 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400007 */     // MIs[3] Operand 1
     /* 400007 */     // No operand predicates
     /* 400007 */     // MIs[1] Operand 2
     /* 400007 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 400018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 400027 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 400030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 400037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400044 */     GIR_RootConstrainSelectedInstOperands,
     /* 400045 */     // GIR_Coverage, 13414,
     /* 400045 */     GIR_EraseRootFromParent_Done,
     /* 400046 */   // Label 8198: @400046
     /* 400046 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(400132), // Rule ID 13412 //
     /* 400051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400095 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400099 */     // MIs[3] Operand 1
     /* 400099 */     // No operand predicates
     /* 400099 */     // MIs[1] Operand 2
     /* 400099 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400116 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 400119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400130 */     GIR_RootConstrainSelectedInstOperands,
     /* 400131 */     // GIR_Coverage, 13412,
     /* 400131 */     GIR_EraseRootFromParent_Done,
     /* 400132 */   // Label 8199: @400132
     /* 400132 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(400218), // Rule ID 2045 //
     /* 400137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400185 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400189 */     // MIs[3] Operand 1
     /* 400189 */     // No operand predicates
     /* 400189 */     // MIs[1] Operand 2
     /* 400189 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400202 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 400205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400216 */     GIR_RootConstrainSelectedInstOperands,
     /* 400217 */     // GIR_Coverage, 2045,
     /* 400217 */     GIR_EraseRootFromParent_Done,
     /* 400218 */   // Label 8200: @400218
     /* 400218 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(400257), // Rule ID 1734 //
     /* 400223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 400233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 400240 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 400240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 400243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 400250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 400255 */     GIR_RootConstrainSelectedInstOperands,
     /* 400256 */     // GIR_Coverage, 1734,
     /* 400256 */     GIR_EraseRootFromParent_Done,
     /* 400257 */   // Label 8201: @400257
     /* 400257 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(400320), // Rule ID 13413 //
     /* 400262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400294 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400298 */     // MIs[2] Operand 1
     /* 400298 */     // No operand predicates
     /* 400298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400304 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 400307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400318 */     GIR_RootConstrainSelectedInstOperands,
     /* 400319 */     // GIR_Coverage, 13413,
     /* 400319 */     GIR_EraseRootFromParent_Done,
     /* 400320 */   // Label 8202: @400320
     /* 400320 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(400383), // Rule ID 2046 //
     /* 400325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400361 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400365 */     // MIs[2] Operand 1
     /* 400365 */     // No operand predicates
     /* 400365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400367 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 400370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400381 */     GIR_RootConstrainSelectedInstOperands,
     /* 400382 */     // GIR_Coverage, 2046,
     /* 400382 */     GIR_EraseRootFromParent_Done,
     /* 400383 */   // Label 8203: @400383
     /* 400383 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(400406), // Rule ID 1733 //
     /* 400388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400399 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 400399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 400404 */     GIR_RootConstrainSelectedInstOperands,
     /* 400405 */     // GIR_Coverage, 1733,
     /* 400405 */     GIR_Done,
     /* 400406 */   // Label 8204: @400406
     /* 400406 */   GIM_Reject,
     /* 400407 */ // Label 8196: @400407
     /* 400407 */ GIM_Reject,
     /* 400408 */ // Label 8193: @400408
     /* 400408 */ GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(400968),
     /* 400413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 400419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400423 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(400515), // Rule ID 2044 //
     /* 400428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400472 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400476 */     // MIs[3] Operand 1
     /* 400476 */     // No operand predicates
     /* 400476 */     // MIs[1] Operand 2
     /* 400476 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 400487 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 400496 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 400499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 400506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400513 */     GIR_RootConstrainSelectedInstOperands,
     /* 400514 */     // GIR_Coverage, 2044,
     /* 400514 */     GIR_EraseRootFromParent_Done,
     /* 400515 */   // Label 8206: @400515
     /* 400515 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(400607), // Rule ID 13411 //
     /* 400520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400551 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400564 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400568 */     // MIs[3] Operand 1
     /* 400568 */     // No operand predicates
     /* 400568 */     // MIs[1] Operand 2
     /* 400568 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 400579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 400588 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 400591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 400598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400605 */     GIR_RootConstrainSelectedInstOperands,
     /* 400606 */     // GIR_Coverage, 13411,
     /* 400606 */     GIR_EraseRootFromParent_Done,
     /* 400607 */   // Label 8207: @400607
     /* 400607 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(400693), // Rule ID 13409 //
     /* 400612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400656 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400660 */     // MIs[3] Operand 1
     /* 400660 */     // No operand predicates
     /* 400660 */     // MIs[1] Operand 2
     /* 400660 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400677 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 400680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400691 */     GIR_RootConstrainSelectedInstOperands,
     /* 400692 */     // GIR_Coverage, 13409,
     /* 400692 */     GIR_EraseRootFromParent_Done,
     /* 400693 */   // Label 8208: @400693
     /* 400693 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(400779), // Rule ID 2042 //
     /* 400698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400746 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400750 */     // MIs[3] Operand 1
     /* 400750 */     // No operand predicates
     /* 400750 */     // MIs[1] Operand 2
     /* 400750 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400761 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400763 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 400766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400777 */     GIR_RootConstrainSelectedInstOperands,
     /* 400778 */     // GIR_Coverage, 2042,
     /* 400778 */     GIR_EraseRootFromParent_Done,
     /* 400779 */   // Label 8209: @400779
     /* 400779 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(400818), // Rule ID 1732 //
     /* 400784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 400794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 400801 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 400801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 400804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 400811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 400816 */     GIR_RootConstrainSelectedInstOperands,
     /* 400817 */     // GIR_Coverage, 1732,
     /* 400817 */     GIR_EraseRootFromParent_Done,
     /* 400818 */   // Label 8210: @400818
     /* 400818 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(400881), // Rule ID 13410 //
     /* 400823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400855 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400859 */     // MIs[2] Operand 1
     /* 400859 */     // No operand predicates
     /* 400859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400865 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 400868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400879 */     GIR_RootConstrainSelectedInstOperands,
     /* 400880 */     // GIR_Coverage, 13410,
     /* 400880 */     GIR_EraseRootFromParent_Done,
     /* 400881 */   // Label 8211: @400881
     /* 400881 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(400944), // Rule ID 2043 //
     /* 400886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400922 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400926 */     // MIs[2] Operand 1
     /* 400926 */     // No operand predicates
     /* 400926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400928 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 400931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400942 */     GIR_RootConstrainSelectedInstOperands,
     /* 400943 */     // GIR_Coverage, 2043,
     /* 400943 */     GIR_EraseRootFromParent_Done,
     /* 400944 */   // Label 8212: @400944
     /* 400944 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(400967), // Rule ID 1731 //
     /* 400949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400960 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 400960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 400965 */     GIR_RootConstrainSelectedInstOperands,
     /* 400966 */     // GIR_Coverage, 1731,
     /* 400966 */     GIR_Done,
     /* 400967 */   // Label 8213: @400967
     /* 400967 */   GIM_Reject,
     /* 400968 */ // Label 8205: @400968
     /* 400968 */ GIM_Reject,
     /* 400969 */ // Label 8194: @400969
     /* 400969 */ GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(401047),
     /* 400974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 400977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 400980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400984 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(401023), // Rule ID 1730 //
     /* 400989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 400999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 401006 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 401006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 401009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 401016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 401021 */     GIR_RootConstrainSelectedInstOperands,
     /* 401022 */     // GIR_Coverage, 1730,
     /* 401022 */     GIR_EraseRootFromParent_Done,
     /* 401023 */   // Label 8215: @401023
     /* 401023 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(401046), // Rule ID 1729 //
     /* 401028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401039 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 401039 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 401044 */     GIR_RootConstrainSelectedInstOperands,
     /* 401045 */     // GIR_Coverage, 1729,
     /* 401045 */     GIR_Done,
     /* 401046 */   // Label 8216: @401046
     /* 401046 */   GIM_Reject,
     /* 401047 */ // Label 8214: @401047
     /* 401047 */ GIM_Reject,
     /* 401048 */ // Label 8195: @401048
     /* 401048 */ GIM_Reject,
     /* 401049 */ // Label 144: @401049
     /* 401049 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8235*/ GIMT_Encode4(401828),
     /* 401060 */ /*GILLT_v2s32*//*Label 8217*/ GIMT_Encode4(401136),
     /* 401064 */ /*GILLT_v2s64*//*Label 8218*/ GIMT_Encode4(401191),
     /* 401068 */ /*GILLT_v4s16*//*Label 8219*/ GIMT_Encode4(401246),
     /* 401072 */ /*GILLT_v4s32*//*Label 8220*/ GIMT_Encode4(401301),
     /* 401076 */ /*GILLT_v8s8*//*Label 8221*/ GIMT_Encode4(401356),
     /* 401080 */ /*GILLT_v8s16*//*Label 8222*/ GIMT_Encode4(401390),
     /* 401084 */ /*GILLT_v16s8*//*Label 8223*/ GIMT_Encode4(401445), GIMT_Encode4(0),
     /* 401092 */ /*GILLT_nxv2s1*//*Label 8224*/ GIMT_Encode4(401479),
     /* 401096 */ /*GILLT_nxv2s16*//*Label 8225*/ GIMT_Encode4(401505),
     /* 401100 */ /*GILLT_nxv2s32*//*Label 8226*/ GIMT_Encode4(401531),
     /* 401104 */ /*GILLT_nxv2s64*//*Label 8227*/ GIMT_Encode4(401557),
     /* 401108 */ /*GILLT_nxv4s1*//*Label 8228*/ GIMT_Encode4(401604),
     /* 401112 */ /*GILLT_nxv4s16*//*Label 8229*/ GIMT_Encode4(401630),
     /* 401116 */ /*GILLT_nxv4s32*//*Label 8230*/ GIMT_Encode4(401656),
     /* 401120 */ /*GILLT_nxv8s1*//*Label 8231*/ GIMT_Encode4(401703),
     /* 401124 */ /*GILLT_nxv8s16*//*Label 8232*/ GIMT_Encode4(401729),
     /* 401128 */ /*GILLT_nxv16s1*//*Label 8233*/ GIMT_Encode4(401776),
     /* 401132 */ /*GILLT_nxv16s8*//*Label 8234*/ GIMT_Encode4(401802),
     /* 401136 */ // Label 8217: @401136
     /* 401136 */ GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(401190),
     /* 401141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401159 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(401174), // Rule ID 1867 //
     /* 401164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401167 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 401167 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 401172 */     GIR_RootConstrainSelectedInstOperands,
     /* 401173 */     // GIR_Coverage, 1867,
     /* 401173 */     GIR_Done,
     /* 401174 */   // Label 8237: @401174
     /* 401174 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(401189), // Rule ID 2496 //
     /* 401179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401182 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 401187 */     GIR_RootConstrainSelectedInstOperands,
     /* 401188 */     // GIR_Coverage, 2496,
     /* 401188 */     GIR_Done,
     /* 401189 */   // Label 8238: @401189
     /* 401189 */   GIM_Reject,
     /* 401190 */ // Label 8236: @401190
     /* 401190 */ GIM_Reject,
     /* 401191 */ // Label 8218: @401191
     /* 401191 */ GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(401245),
     /* 401196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401214 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(401229), // Rule ID 1869 //
     /* 401219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401222 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 401222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 401227 */     GIR_RootConstrainSelectedInstOperands,
     /* 401228 */     // GIR_Coverage, 1869,
     /* 401228 */     GIR_Done,
     /* 401229 */   // Label 8240: @401229
     /* 401229 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(401244), // Rule ID 2498 //
     /* 401234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401237 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401237 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 401242 */     GIR_RootConstrainSelectedInstOperands,
     /* 401243 */     // GIR_Coverage, 2498,
     /* 401243 */     GIR_Done,
     /* 401244 */   // Label 8241: @401244
     /* 401244 */   GIM_Reject,
     /* 401245 */ // Label 8239: @401245
     /* 401245 */ GIM_Reject,
     /* 401246 */ // Label 8219: @401246
     /* 401246 */ GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(401300),
     /* 401251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401269 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(401284), // Rule ID 1865 //
     /* 401274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401277 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 401277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 401282 */     GIR_RootConstrainSelectedInstOperands,
     /* 401283 */     // GIR_Coverage, 1865,
     /* 401283 */     GIR_Done,
     /* 401284 */   // Label 8243: @401284
     /* 401284 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(401299), // Rule ID 2494 //
     /* 401289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401292 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401292 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 401297 */     GIR_RootConstrainSelectedInstOperands,
     /* 401298 */     // GIR_Coverage, 2494,
     /* 401298 */     GIR_Done,
     /* 401299 */   // Label 8244: @401299
     /* 401299 */   GIM_Reject,
     /* 401300 */ // Label 8242: @401300
     /* 401300 */ GIM_Reject,
     /* 401301 */ // Label 8220: @401301
     /* 401301 */ GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(401355),
     /* 401306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 401312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401324 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(401339), // Rule ID 1868 //
     /* 401329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401332 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 401332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 401337 */     GIR_RootConstrainSelectedInstOperands,
     /* 401338 */     // GIR_Coverage, 1868,
     /* 401338 */     GIR_Done,
     /* 401339 */   // Label 8246: @401339
     /* 401339 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(401354), // Rule ID 2497 //
     /* 401344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401347 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 401352 */     GIR_RootConstrainSelectedInstOperands,
     /* 401353 */     // GIR_Coverage, 2497,
     /* 401353 */     GIR_Done,
     /* 401354 */   // Label 8247: @401354
     /* 401354 */   GIM_Reject,
     /* 401355 */ // Label 8245: @401355
     /* 401355 */ GIM_Reject,
     /* 401356 */ // Label 8221: @401356
     /* 401356 */ GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(401389), // Rule ID 1863 //
     /* 401361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 401367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 401370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401382 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 401382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 401387 */   GIR_RootConstrainSelectedInstOperands,
     /* 401388 */   // GIR_Coverage, 1863,
     /* 401388 */   GIR_Done,
     /* 401389 */ // Label 8248: @401389
     /* 401389 */ GIM_Reject,
     /* 401390 */ // Label 8222: @401390
     /* 401390 */ GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(401444),
     /* 401395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 401401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401413 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(401428), // Rule ID 1866 //
     /* 401418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401421 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 401421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 401426 */     GIR_RootConstrainSelectedInstOperands,
     /* 401427 */     // GIR_Coverage, 1866,
     /* 401427 */     GIR_Done,
     /* 401428 */   // Label 8250: @401428
     /* 401428 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(401443), // Rule ID 2495 //
     /* 401433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401436 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 401441 */     GIR_RootConstrainSelectedInstOperands,
     /* 401442 */     // GIR_Coverage, 2495,
     /* 401442 */     GIR_Done,
     /* 401443 */   // Label 8251: @401443
     /* 401443 */   GIM_Reject,
     /* 401444 */ // Label 8249: @401444
     /* 401444 */ GIM_Reject,
     /* 401445 */ // Label 8223: @401445
     /* 401445 */ GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(401478), // Rule ID 1864 //
     /* 401450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 401456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 401459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401471 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 401471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 401476 */   GIR_RootConstrainSelectedInstOperands,
     /* 401477 */   // GIR_Coverage, 1864,
     /* 401477 */   GIR_Done,
     /* 401478 */ // Label 8252: @401478
     /* 401478 */ GIM_Reject,
     /* 401479 */ // Label 8224: @401479
     /* 401479 */ GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(401504), // Rule ID 8898 //
     /* 401484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 401490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 401493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401497 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 401497 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 401502 */   GIR_RootConstrainSelectedInstOperands,
     /* 401503 */   // GIR_Coverage, 8898,
     /* 401503 */   GIR_Done,
     /* 401504 */ // Label 8253: @401504
     /* 401504 */ GIM_Reject,
     /* 401505 */ // Label 8225: @401505
     /* 401505 */ GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(401530), // Rule ID 8874 //
     /* 401510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 401516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 401519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401523 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 401523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 401528 */   GIR_RootConstrainSelectedInstOperands,
     /* 401529 */   // GIR_Coverage, 8874,
     /* 401529 */   GIR_Done,
     /* 401530 */ // Label 8254: @401530
     /* 401530 */ GIM_Reject,
     /* 401531 */ // Label 8226: @401531
     /* 401531 */ GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(401556), // Rule ID 8875 //
     /* 401536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 401542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 401545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401549 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 401549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 401554 */   GIR_RootConstrainSelectedInstOperands,
     /* 401555 */   // GIR_Coverage, 8875,
     /* 401555 */   GIR_Done,
     /* 401556 */ // Label 8255: @401556
     /* 401556 */ GIM_Reject,
     /* 401557 */ // Label 8227: @401557
     /* 401557 */ GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(401603),
     /* 401562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 401565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 401568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401572 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(401587), // Rule ID 8870 //
     /* 401577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401580 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 401580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 401585 */     GIR_RootConstrainSelectedInstOperands,
     /* 401586 */     // GIR_Coverage, 8870,
     /* 401586 */     GIR_Done,
     /* 401587 */   // Label 8257: @401587
     /* 401587 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(401602), // Rule ID 8876 //
     /* 401592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401595 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 401595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 401600 */     GIR_RootConstrainSelectedInstOperands,
     /* 401601 */     // GIR_Coverage, 8876,
     /* 401601 */     GIR_Done,
     /* 401602 */   // Label 8258: @401602
     /* 401602 */   GIM_Reject,
     /* 401603 */ // Label 8256: @401603
     /* 401603 */ GIM_Reject,
     /* 401604 */ // Label 8228: @401604
     /* 401604 */ GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(401629), // Rule ID 8897 //
     /* 401609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 401615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 401618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401622 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 401622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 401627 */   GIR_RootConstrainSelectedInstOperands,
     /* 401628 */   // GIR_Coverage, 8897,
     /* 401628 */   GIR_Done,
     /* 401629 */ // Label 8259: @401629
     /* 401629 */ GIM_Reject,
     /* 401630 */ // Label 8229: @401630
     /* 401630 */ GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(401655), // Rule ID 8872 //
     /* 401635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 401641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 401644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401648 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 401648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 401653 */   GIR_RootConstrainSelectedInstOperands,
     /* 401654 */   // GIR_Coverage, 8872,
     /* 401654 */   GIR_Done,
     /* 401655 */ // Label 8260: @401655
     /* 401655 */ GIM_Reject,
     /* 401656 */ // Label 8230: @401656
     /* 401656 */ GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(401702),
     /* 401661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 401664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 401667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401671 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(401686), // Rule ID 8869 //
     /* 401676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401679 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 401679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 401684 */     GIR_RootConstrainSelectedInstOperands,
     /* 401685 */     // GIR_Coverage, 8869,
     /* 401685 */     GIR_Done,
     /* 401686 */   // Label 8262: @401686
     /* 401686 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(401701), // Rule ID 8873 //
     /* 401691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401694 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 401694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 401699 */     GIR_RootConstrainSelectedInstOperands,
     /* 401700 */     // GIR_Coverage, 8873,
     /* 401700 */     GIR_Done,
     /* 401701 */   // Label 8263: @401701
     /* 401701 */   GIM_Reject,
     /* 401702 */ // Label 8261: @401702
     /* 401702 */ GIM_Reject,
     /* 401703 */ // Label 8231: @401703
     /* 401703 */ GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(401728), // Rule ID 8896 //
     /* 401708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 401714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 401717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401721 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 401721 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 401726 */   GIR_RootConstrainSelectedInstOperands,
     /* 401727 */   // GIR_Coverage, 8896,
     /* 401727 */   GIR_Done,
     /* 401728 */ // Label 8264: @401728
     /* 401728 */ GIM_Reject,
     /* 401729 */ // Label 8232: @401729
     /* 401729 */ GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(401775),
     /* 401734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 401737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 401740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401744 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(401759), // Rule ID 8868 //
     /* 401749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401752 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 401752 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 401757 */     GIR_RootConstrainSelectedInstOperands,
     /* 401758 */     // GIR_Coverage, 8868,
     /* 401758 */     GIR_Done,
     /* 401759 */   // Label 8266: @401759
     /* 401759 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(401774), // Rule ID 8871 //
     /* 401764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401767 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 401767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 401772 */     GIR_RootConstrainSelectedInstOperands,
     /* 401773 */     // GIR_Coverage, 8871,
     /* 401773 */     GIR_Done,
     /* 401774 */   // Label 8267: @401774
     /* 401774 */   GIM_Reject,
     /* 401775 */ // Label 8265: @401775
     /* 401775 */ GIM_Reject,
     /* 401776 */ // Label 8233: @401776
     /* 401776 */ GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(401801), // Rule ID 2405 //
     /* 401781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 401787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 401790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 401794 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 401794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 401799 */   GIR_RootConstrainSelectedInstOperands,
     /* 401800 */   // GIR_Coverage, 2405,
     /* 401800 */   GIR_Done,
     /* 401801 */ // Label 8268: @401801
     /* 401801 */ GIM_Reject,
     /* 401802 */ // Label 8234: @401802
     /* 401802 */ GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(401827), // Rule ID 8867 //
     /* 401807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 401810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 401813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 401816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 401820 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 401820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 401825 */   GIR_RootConstrainSelectedInstOperands,
     /* 401826 */   // GIR_Coverage, 8867,
     /* 401826 */   GIR_Done,
     /* 401827 */ // Label 8269: @401827
     /* 401827 */ GIM_Reject,
     /* 401828 */ // Label 8235: @401828
     /* 401828 */ GIM_Reject,
     /* 401829 */ // Label 145: @401829
     /* 401829 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8288*/ GIMT_Encode4(402608),
     /* 401840 */ /*GILLT_v2s32*//*Label 8270*/ GIMT_Encode4(401916),
     /* 401844 */ /*GILLT_v2s64*//*Label 8271*/ GIMT_Encode4(401971),
     /* 401848 */ /*GILLT_v4s16*//*Label 8272*/ GIMT_Encode4(402026),
     /* 401852 */ /*GILLT_v4s32*//*Label 8273*/ GIMT_Encode4(402081),
     /* 401856 */ /*GILLT_v8s8*//*Label 8274*/ GIMT_Encode4(402136),
     /* 401860 */ /*GILLT_v8s16*//*Label 8275*/ GIMT_Encode4(402170),
     /* 401864 */ /*GILLT_v16s8*//*Label 8276*/ GIMT_Encode4(402225), GIMT_Encode4(0),
     /* 401872 */ /*GILLT_nxv2s1*//*Label 8277*/ GIMT_Encode4(402259),
     /* 401876 */ /*GILLT_nxv2s16*//*Label 8278*/ GIMT_Encode4(402285),
     /* 401880 */ /*GILLT_nxv2s32*//*Label 8279*/ GIMT_Encode4(402311),
     /* 401884 */ /*GILLT_nxv2s64*//*Label 8280*/ GIMT_Encode4(402337),
     /* 401888 */ /*GILLT_nxv4s1*//*Label 8281*/ GIMT_Encode4(402384),
     /* 401892 */ /*GILLT_nxv4s16*//*Label 8282*/ GIMT_Encode4(402410),
     /* 401896 */ /*GILLT_nxv4s32*//*Label 8283*/ GIMT_Encode4(402436),
     /* 401900 */ /*GILLT_nxv8s1*//*Label 8284*/ GIMT_Encode4(402483),
     /* 401904 */ /*GILLT_nxv8s16*//*Label 8285*/ GIMT_Encode4(402509),
     /* 401908 */ /*GILLT_nxv16s1*//*Label 8286*/ GIMT_Encode4(402556),
     /* 401912 */ /*GILLT_nxv16s8*//*Label 8287*/ GIMT_Encode4(402582),
     /* 401916 */ // Label 8270: @401916
     /* 401916 */ GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(401970),
     /* 401921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401939 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(401954), // Rule ID 1874 //
     /* 401944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401947 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 401947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 401952 */     GIR_RootConstrainSelectedInstOperands,
     /* 401953 */     // GIR_Coverage, 1874,
     /* 401953 */     GIR_Done,
     /* 401954 */   // Label 8290: @401954
     /* 401954 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(401969), // Rule ID 5444 //
     /* 401959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401962 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 401967 */     GIR_RootConstrainSelectedInstOperands,
     /* 401968 */     // GIR_Coverage, 5444,
     /* 401968 */     GIR_Done,
     /* 401969 */   // Label 8291: @401969
     /* 401969 */   GIM_Reject,
     /* 401970 */ // Label 8289: @401970
     /* 401970 */ GIM_Reject,
     /* 401971 */ // Label 8271: @401971
     /* 401971 */ GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(402025),
     /* 401976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401990 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401994 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(402009), // Rule ID 1876 //
     /* 401999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402002 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 402002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 402007 */     GIR_RootConstrainSelectedInstOperands,
     /* 402008 */     // GIR_Coverage, 1876,
     /* 402008 */     GIR_Done,
     /* 402009 */   // Label 8293: @402009
     /* 402009 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(402024), // Rule ID 5446 //
     /* 402014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402017 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 402017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 402022 */     GIR_RootConstrainSelectedInstOperands,
     /* 402023 */     // GIR_Coverage, 5446,
     /* 402023 */     GIR_Done,
     /* 402024 */   // Label 8294: @402024
     /* 402024 */   GIM_Reject,
     /* 402025 */ // Label 8292: @402025
     /* 402025 */ GIM_Reject,
     /* 402026 */ // Label 8272: @402026
     /* 402026 */ GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(402080),
     /* 402031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 402037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402049 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(402064), // Rule ID 1872 //
     /* 402054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402057 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 402057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 402062 */     GIR_RootConstrainSelectedInstOperands,
     /* 402063 */     // GIR_Coverage, 1872,
     /* 402063 */     GIR_Done,
     /* 402064 */   // Label 8296: @402064
     /* 402064 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(402079), // Rule ID 5442 //
     /* 402069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402072 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 402072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 402077 */     GIR_RootConstrainSelectedInstOperands,
     /* 402078 */     // GIR_Coverage, 5442,
     /* 402078 */     GIR_Done,
     /* 402079 */   // Label 8297: @402079
     /* 402079 */   GIM_Reject,
     /* 402080 */ // Label 8295: @402080
     /* 402080 */ GIM_Reject,
     /* 402081 */ // Label 8273: @402081
     /* 402081 */ GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(402135),
     /* 402086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 402092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402100 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402104 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(402119), // Rule ID 1875 //
     /* 402109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402112 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 402112 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 402117 */     GIR_RootConstrainSelectedInstOperands,
     /* 402118 */     // GIR_Coverage, 1875,
     /* 402118 */     GIR_Done,
     /* 402119 */   // Label 8299: @402119
     /* 402119 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(402134), // Rule ID 5445 //
     /* 402124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402127 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 402127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 402132 */     GIR_RootConstrainSelectedInstOperands,
     /* 402133 */     // GIR_Coverage, 5445,
     /* 402133 */     GIR_Done,
     /* 402134 */   // Label 8300: @402134
     /* 402134 */   GIM_Reject,
     /* 402135 */ // Label 8298: @402135
     /* 402135 */ GIM_Reject,
     /* 402136 */ // Label 8274: @402136
     /* 402136 */ GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(402169), // Rule ID 1870 //
     /* 402141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 402147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 402150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402162 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 402162 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 402167 */   GIR_RootConstrainSelectedInstOperands,
     /* 402168 */   // GIR_Coverage, 1870,
     /* 402168 */   GIR_Done,
     /* 402169 */ // Label 8301: @402169
     /* 402169 */ GIM_Reject,
     /* 402170 */ // Label 8275: @402170
     /* 402170 */ GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(402224),
     /* 402175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 402181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402193 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(402208), // Rule ID 1873 //
     /* 402198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402201 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 402201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 402206 */     GIR_RootConstrainSelectedInstOperands,
     /* 402207 */     // GIR_Coverage, 1873,
     /* 402207 */     GIR_Done,
     /* 402208 */   // Label 8303: @402208
     /* 402208 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(402223), // Rule ID 5443 //
     /* 402213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402216 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 402216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 402221 */     GIR_RootConstrainSelectedInstOperands,
     /* 402222 */     // GIR_Coverage, 5443,
     /* 402222 */     GIR_Done,
     /* 402223 */   // Label 8304: @402223
     /* 402223 */   GIM_Reject,
     /* 402224 */ // Label 8302: @402224
     /* 402224 */ GIM_Reject,
     /* 402225 */ // Label 8276: @402225
     /* 402225 */ GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(402258), // Rule ID 1871 //
     /* 402230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 402239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402251 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 402251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 402256 */   GIR_RootConstrainSelectedInstOperands,
     /* 402257 */   // GIR_Coverage, 1871,
     /* 402257 */   GIR_Done,
     /* 402258 */ // Label 8305: @402258
     /* 402258 */ GIM_Reject,
     /* 402259 */ // Label 8277: @402259
     /* 402259 */ GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(402284), // Rule ID 8901 //
     /* 402264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 402270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 402273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402277 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 402277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 402282 */   GIR_RootConstrainSelectedInstOperands,
     /* 402283 */   // GIR_Coverage, 8901,
     /* 402283 */   GIR_Done,
     /* 402284 */ // Label 8306: @402284
     /* 402284 */ GIM_Reject,
     /* 402285 */ // Label 8278: @402285
     /* 402285 */ GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(402310), // Rule ID 8884 //
     /* 402290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 402296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 402299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402303 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 402303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 402308 */   GIR_RootConstrainSelectedInstOperands,
     /* 402309 */   // GIR_Coverage, 8884,
     /* 402309 */   GIR_Done,
     /* 402310 */ // Label 8307: @402310
     /* 402310 */ GIM_Reject,
     /* 402311 */ // Label 8279: @402311
     /* 402311 */ GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(402336), // Rule ID 8885 //
     /* 402316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 402322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 402325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402329 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 402329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 402334 */   GIR_RootConstrainSelectedInstOperands,
     /* 402335 */   // GIR_Coverage, 8885,
     /* 402335 */   GIR_Done,
     /* 402336 */ // Label 8308: @402336
     /* 402336 */ GIM_Reject,
     /* 402337 */ // Label 8280: @402337
     /* 402337 */ GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(402383),
     /* 402342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 402345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 402348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402352 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(402367), // Rule ID 8880 //
     /* 402357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402360 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 402360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 402365 */     GIR_RootConstrainSelectedInstOperands,
     /* 402366 */     // GIR_Coverage, 8880,
     /* 402366 */     GIR_Done,
     /* 402367 */   // Label 8310: @402367
     /* 402367 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(402382), // Rule ID 8886 //
     /* 402372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402375 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 402375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 402380 */     GIR_RootConstrainSelectedInstOperands,
     /* 402381 */     // GIR_Coverage, 8886,
     /* 402381 */     GIR_Done,
     /* 402382 */   // Label 8311: @402382
     /* 402382 */   GIM_Reject,
     /* 402383 */ // Label 8309: @402383
     /* 402383 */ GIM_Reject,
     /* 402384 */ // Label 8281: @402384
     /* 402384 */ GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(402409), // Rule ID 8900 //
     /* 402389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 402395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 402398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402402 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 402402 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 402407 */   GIR_RootConstrainSelectedInstOperands,
     /* 402408 */   // GIR_Coverage, 8900,
     /* 402408 */   GIR_Done,
     /* 402409 */ // Label 8312: @402409
     /* 402409 */ GIM_Reject,
     /* 402410 */ // Label 8282: @402410
     /* 402410 */ GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(402435), // Rule ID 8882 //
     /* 402415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 402421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 402424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402428 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 402428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 402433 */   GIR_RootConstrainSelectedInstOperands,
     /* 402434 */   // GIR_Coverage, 8882,
     /* 402434 */   GIR_Done,
     /* 402435 */ // Label 8313: @402435
     /* 402435 */ GIM_Reject,
     /* 402436 */ // Label 8283: @402436
     /* 402436 */ GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(402482),
     /* 402441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 402444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 402447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402451 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(402466), // Rule ID 8879 //
     /* 402456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402459 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 402459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 402464 */     GIR_RootConstrainSelectedInstOperands,
     /* 402465 */     // GIR_Coverage, 8879,
     /* 402465 */     GIR_Done,
     /* 402466 */   // Label 8315: @402466
     /* 402466 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(402481), // Rule ID 8883 //
     /* 402471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402474 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 402474 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 402479 */     GIR_RootConstrainSelectedInstOperands,
     /* 402480 */     // GIR_Coverage, 8883,
     /* 402480 */     GIR_Done,
     /* 402481 */   // Label 8316: @402481
     /* 402481 */   GIM_Reject,
     /* 402482 */ // Label 8314: @402482
     /* 402482 */ GIM_Reject,
     /* 402483 */ // Label 8284: @402483
     /* 402483 */ GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(402508), // Rule ID 8899 //
     /* 402488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 402494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 402497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402501 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 402501 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 402506 */   GIR_RootConstrainSelectedInstOperands,
     /* 402507 */   // GIR_Coverage, 8899,
     /* 402507 */   GIR_Done,
     /* 402508 */ // Label 8317: @402508
     /* 402508 */ GIM_Reject,
     /* 402509 */ // Label 8285: @402509
     /* 402509 */ GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(402555),
     /* 402514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 402517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 402520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402524 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(402539), // Rule ID 8878 //
     /* 402529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402532 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 402532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 402537 */     GIR_RootConstrainSelectedInstOperands,
     /* 402538 */     // GIR_Coverage, 8878,
     /* 402538 */     GIR_Done,
     /* 402539 */   // Label 8319: @402539
     /* 402539 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(402554), // Rule ID 8881 //
     /* 402544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402547 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 402547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 402552 */     GIR_RootConstrainSelectedInstOperands,
     /* 402553 */     // GIR_Coverage, 8881,
     /* 402553 */     GIR_Done,
     /* 402554 */   // Label 8320: @402554
     /* 402554 */   GIM_Reject,
     /* 402555 */ // Label 8318: @402555
     /* 402555 */ GIM_Reject,
     /* 402556 */ // Label 8286: @402556
     /* 402556 */ GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(402581), // Rule ID 2409 //
     /* 402561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 402567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 402570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 402574 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 402574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 402579 */   GIR_RootConstrainSelectedInstOperands,
     /* 402580 */   // GIR_Coverage, 2409,
     /* 402580 */   GIR_Done,
     /* 402581 */ // Label 8321: @402581
     /* 402581 */ GIM_Reject,
     /* 402582 */ // Label 8287: @402582
     /* 402582 */ GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(402607), // Rule ID 8877 //
     /* 402587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 402590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 402593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 402596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 402600 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 402600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 402605 */   GIR_RootConstrainSelectedInstOperands,
     /* 402606 */   // GIR_Coverage, 8877,
     /* 402606 */   GIR_Done,
     /* 402607 */ // Label 8322: @402607
     /* 402607 */ GIM_Reject,
     /* 402608 */ // Label 8288: @402608
     /* 402608 */ GIM_Reject,
     /* 402609 */ // Label 146: @402609
     /* 402609 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8329*/ GIMT_Encode4(402814),
     /* 402620 */ /*GILLT_s64*//*Label 8323*/ GIMT_Encode4(402652), GIMT_Encode4(0),
     /* 402628 */ /*GILLT_v2s32*//*Label 8324*/ GIMT_Encode4(402679),
     /* 402632 */ /*GILLT_v2s64*//*Label 8325*/ GIMT_Encode4(402706),
     /* 402636 */ /*GILLT_v4s16*//*Label 8326*/ GIMT_Encode4(402733),
     /* 402640 */ /*GILLT_v4s32*//*Label 8327*/ GIMT_Encode4(402760), GIMT_Encode4(0),
     /* 402648 */ /*GILLT_v8s16*//*Label 8328*/ GIMT_Encode4(402787),
     /* 402652 */ // Label 8323: @402652
     /* 402652 */ GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(402678), // Rule ID 1062 //
     /* 402657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402671 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 402671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 402676 */   GIR_RootConstrainSelectedInstOperands,
     /* 402677 */   // GIR_Coverage, 1062,
     /* 402677 */   GIR_Done,
     /* 402678 */ // Label 8330: @402678
     /* 402678 */ GIM_Reject,
     /* 402679 */ // Label 8324: @402679
     /* 402679 */ GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(402705), // Rule ID 1058 //
     /* 402684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402698 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 402698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 402703 */   GIR_RootConstrainSelectedInstOperands,
     /* 402704 */   // GIR_Coverage, 1058,
     /* 402704 */   GIR_Done,
     /* 402705 */ // Label 8331: @402705
     /* 402705 */ GIM_Reject,
     /* 402706 */ // Label 8325: @402706
     /* 402706 */ GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(402732), // Rule ID 1064 //
     /* 402711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402725 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 402725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 402730 */   GIR_RootConstrainSelectedInstOperands,
     /* 402731 */   // GIR_Coverage, 1064,
     /* 402731 */   GIR_Done,
     /* 402732 */ // Label 8332: @402732
     /* 402732 */ GIM_Reject,
     /* 402733 */ // Label 8326: @402733
     /* 402733 */ GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(402759), // Rule ID 1054 //
     /* 402738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 402744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402752 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 402752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 402757 */   GIR_RootConstrainSelectedInstOperands,
     /* 402758 */   // GIR_Coverage, 1054,
     /* 402758 */   GIR_Done,
     /* 402759 */ // Label 8333: @402759
     /* 402759 */ GIM_Reject,
     /* 402760 */ // Label 8327: @402760
     /* 402760 */ GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(402786), // Rule ID 1060 //
     /* 402765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402779 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 402779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 402784 */   GIR_RootConstrainSelectedInstOperands,
     /* 402785 */   // GIR_Coverage, 1060,
     /* 402785 */   GIR_Done,
     /* 402786 */ // Label 8334: @402786
     /* 402786 */ GIM_Reject,
     /* 402787 */ // Label 8328: @402787
     /* 402787 */ GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(402813), // Rule ID 1056 //
     /* 402792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402806 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 402806 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 402811 */   GIR_RootConstrainSelectedInstOperands,
     /* 402812 */   // GIR_Coverage, 1056,
     /* 402812 */   GIR_Done,
     /* 402813 */ // Label 8335: @402813
     /* 402813 */ GIM_Reject,
     /* 402814 */ // Label 8329: @402814
     /* 402814 */ GIM_Reject,
     /* 402815 */ // Label 147: @402815
     /* 402815 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8338*/ GIMT_Encode4(403681),
     /* 402826 */ /*GILLT_v2s64*//*Label 8336*/ GIMT_Encode4(402838), GIMT_Encode4(0),
     /* 402834 */ /*GILLT_v4s32*//*Label 8337*/ GIMT_Encode4(403132),
     /* 402838 */ // Label 8336: @402838
     /* 402838 */ GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(402920), // Rule ID 5817 //
     /* 402843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 402858 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 402861 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 402866 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 402870 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402875 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402877 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 402877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 402880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 402884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402889 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 402893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 402895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 402898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402903 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 402909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402914 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402919 */   // GIR_Coverage, 5817,
     /* 402919 */   GIR_EraseRootFromParent_Done,
     /* 402920 */ // Label 8339: @402920
     /* 402920 */ GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(402994), // Rule ID 5816 //
     /* 402925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402932 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402936 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 402940 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402944 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402949 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 402951 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 402951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 402954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 402958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402963 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 402967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 402969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 402972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 402977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 402983 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402988 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 402993 */   // GIR_Coverage, 5816,
     /* 402993 */   GIR_EraseRootFromParent_Done,
     /* 402994 */ // Label 8340: @402994
     /* 402994 */ GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(403053), // Rule ID 5826 //
     /* 402999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403010 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 403010 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 403013 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 403017 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403022 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 403042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403052 */   // GIR_Coverage, 5826,
     /* 403052 */   GIR_EraseRootFromParent_Done,
     /* 403053 */ // Label 8341: @403053
     /* 403053 */ GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(403131), // Rule ID 5954 //
     /* 403058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403069 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 403069 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 403072 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 403076 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403081 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 403087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 403090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 403094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 403104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403106 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 403115 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403120 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403125 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403130 */   // GIR_Coverage, 5954,
     /* 403130 */   GIR_EraseRootFromParent_Done,
     /* 403131 */ // Label 8342: @403131
     /* 403131 */ GIM_Reject,
     /* 403132 */ // Label 8337: @403132
     /* 403132 */ GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(403214), // Rule ID 5819 //
     /* 403137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403144 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403148 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 403152 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 403155 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 403160 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 403164 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403169 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403171 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 403171 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403174 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 403178 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403183 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 403187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 403203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403208 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403213 */   // GIR_Coverage, 5819,
     /* 403213 */   GIR_EraseRootFromParent_Done,
     /* 403214 */ // Label 8343: @403214
     /* 403214 */ GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(403296), // Rule ID 5821 //
     /* 403219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403226 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403230 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 403234 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 403237 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 403242 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 403246 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403251 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403253 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 403253 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403256 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 403260 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403265 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 403269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403279 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 403285 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403290 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403295 */   // GIR_Coverage, 5821,
     /* 403295 */   GIR_EraseRootFromParent_Done,
     /* 403296 */ // Label 8344: @403296
     /* 403296 */ GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(403370), // Rule ID 5818 //
     /* 403301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 403316 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403320 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403325 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403327 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 403327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 403334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403339 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 403343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403353 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 403359 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403369 */   // GIR_Coverage, 5818,
     /* 403369 */   GIR_EraseRootFromParent_Done,
     /* 403370 */ // Label 8345: @403370
     /* 403370 */ GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(403444), // Rule ID 5820 //
     /* 403375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 403390 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403394 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403399 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403401 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 403401 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403404 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 403408 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403413 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 403417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403427 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 403433 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403438 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403443 */   // GIR_Coverage, 5820,
     /* 403443 */   GIR_EraseRootFromParent_Done,
     /* 403444 */ // Label 8346: @403444
     /* 403444 */ GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(403503), // Rule ID 5822 //
     /* 403449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403460 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 403460 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403463 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 403467 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403472 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403486 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 403492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403497 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403502 */   // GIR_Coverage, 5822,
     /* 403502 */   GIR_EraseRootFromParent_Done,
     /* 403503 */ // Label 8347: @403503
     /* 403503 */ GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(403562), // Rule ID 5823 //
     /* 403508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403519 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 403519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 403526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403531 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403535 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 403551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403556 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403561 */   // GIR_Coverage, 5823,
     /* 403561 */   GIR_EraseRootFromParent_Done,
     /* 403562 */ // Label 8348: @403562
     /* 403562 */ GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(403621), // Rule ID 5824 //
     /* 403567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403578 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 403578 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403581 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 403585 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403590 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 403610 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403620 */   // GIR_Coverage, 5824,
     /* 403620 */   GIR_EraseRootFromParent_Done,
     /* 403621 */ // Label 8349: @403621
     /* 403621 */ GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(403680), // Rule ID 5825 //
     /* 403626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403637 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 403637 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403640 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 403644 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403649 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 403669 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403679 */   // GIR_Coverage, 5825,
     /* 403679 */   GIR_EraseRootFromParent_Done,
     /* 403680 */ // Label 8350: @403680
     /* 403680 */ GIM_Reject,
     /* 403681 */ // Label 8338: @403681
     /* 403681 */ GIM_Reject,
     /* 403682 */ // Label 148: @403682
     /* 403682 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8355*/ GIMT_Encode4(404051),
     /* 403693 */ /*GILLT_v2s32*//*Label 8351*/ GIMT_Encode4(403753), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 403705 */ /*GILLT_v4s32*//*Label 8352*/ GIMT_Encode4(403873), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 403737 */ /*GILLT_nxv2s64*//*Label 8353*/ GIMT_Encode4(403993), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 403749 */ /*GILLT_nxv4s32*//*Label 8354*/ GIMT_Encode4(404022),
     /* 403753 */ // Label 8351: @403753
     /* 403753 */ GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(403872),
     /* 403758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 403764 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 403767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403779 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(403852), // Rule ID 28 //
     /* 403784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 403787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 403795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 403807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403828 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 403832 */     // MIs[3] Operand 1
     /* 403832 */     // No operand predicates
     /* 403832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403834 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 403834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 403837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403839 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 403841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403850 */     GIR_RootConstrainSelectedInstOperands,
     /* 403851 */     // GIR_Coverage, 28,
     /* 403851 */     GIR_EraseRootFromParent_Done,
     /* 403852 */   // Label 8357: @403852
     /* 403852 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(403871), // Rule ID 24 //
     /* 403857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 403860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403864 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 403864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 403869 */     GIR_RootConstrainSelectedInstOperands,
     /* 403870 */     // GIR_Coverage, 24,
     /* 403870 */     GIR_Done,
     /* 403871 */   // Label 8358: @403871
     /* 403871 */   GIM_Reject,
     /* 403872 */ // Label 8356: @403872
     /* 403872 */ GIM_Reject,
     /* 403873 */ // Label 8352: @403873
     /* 403873 */ GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(403992),
     /* 403878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 403884 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 403887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403899 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(403972), // Rule ID 29 //
     /* 403904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 403907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 403915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 403927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403948 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 403952 */     // MIs[3] Operand 1
     /* 403952 */     // No operand predicates
     /* 403952 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403954 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 403954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 403957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 403961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403970 */     GIR_RootConstrainSelectedInstOperands,
     /* 403971 */     // GIR_Coverage, 29,
     /* 403971 */     GIR_EraseRootFromParent_Done,
     /* 403972 */   // Label 8360: @403972
     /* 403972 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(403991), // Rule ID 25 //
     /* 403977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 403980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403984 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 403984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 403989 */     GIR_RootConstrainSelectedInstOperands,
     /* 403990 */     // GIR_Coverage, 25,
     /* 403990 */     GIR_Done,
     /* 403991 */   // Label 8361: @403991
     /* 403991 */   GIM_Reject,
     /* 403992 */ // Label 8359: @403992
     /* 403992 */ GIM_Reject,
     /* 403993 */ // Label 8353: @403993
     /* 403993 */ GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(404021), // Rule ID 7588 //
     /* 403998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 404004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 404007 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 404010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404014 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 404014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 404019 */   GIR_RootConstrainSelectedInstOperands,
     /* 404020 */   // GIR_Coverage, 7588,
     /* 404020 */   GIR_Done,
     /* 404021 */ // Label 8362: @404021
     /* 404021 */ GIM_Reject,
     /* 404022 */ // Label 8354: @404022
     /* 404022 */ GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(404050), // Rule ID 7587 //
     /* 404027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 404033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 404036 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 404039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404043 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 404043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 404048 */   GIR_RootConstrainSelectedInstOperands,
     /* 404049 */   // GIR_Coverage, 7587,
     /* 404049 */   GIR_Done,
     /* 404050 */ // Label 8363: @404050
     /* 404050 */ GIM_Reject,
     /* 404051 */ // Label 8355: @404051
     /* 404051 */ GIM_Reject,
     /* 404052 */ // Label 149: @404052
     /* 404052 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8367*/ GIMT_Encode4(404168),
     /* 404063 */ /*GILLT_s16*//*Label 8364*/ GIMT_Encode4(404075),
     /* 404067 */ /*GILLT_s32*//*Label 8365*/ GIMT_Encode4(404106),
     /* 404071 */ /*GILLT_s64*//*Label 8366*/ GIMT_Encode4(404137),
     /* 404075 */ // Label 8364: @404075
     /* 404075 */ GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(404105), // Rule ID 1662 //
     /* 404080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 404083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 404086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404094 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 404094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 404099 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404103 */   GIR_RootConstrainSelectedInstOperands,
     /* 404104 */   // GIR_Coverage, 1662,
     /* 404104 */   GIR_Done,
     /* 404105 */ // Label 8368: @404105
     /* 404105 */ GIM_Reject,
     /* 404106 */ // Label 8365: @404106
     /* 404106 */ GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(404136), // Rule ID 1661 //
     /* 404111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 404114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 404117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404125 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 404125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 404130 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404134 */   GIR_RootConstrainSelectedInstOperands,
     /* 404135 */   // GIR_Coverage, 1661,
     /* 404135 */   GIR_Done,
     /* 404136 */ // Label 8369: @404136
     /* 404136 */ GIM_Reject,
     /* 404137 */ // Label 8366: @404137
     /* 404137 */ GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(404167), // Rule ID 1660 //
     /* 404142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 404145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 404148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404156 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 404156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 404161 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404165 */   GIR_RootConstrainSelectedInstOperands,
     /* 404166 */   // GIR_Coverage, 1660,
     /* 404166 */   GIR_Done,
     /* 404167 */ // Label 8370: @404167
     /* 404167 */ GIM_Reject,
     /* 404168 */ // Label 8367: @404168
     /* 404168 */ GIM_Reject,
     /* 404169 */ // Label 150: @404169
     /* 404169 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8374*/ GIMT_Encode4(405401),
     /* 404180 */ /*GILLT_v2s64*//*Label 8371*/ GIMT_Encode4(404200), GIMT_Encode4(0),
     /* 404188 */ /*GILLT_v4s32*//*Label 8372*/ GIMT_Encode4(404761), GIMT_Encode4(0),
     /* 404196 */ /*GILLT_v8s16*//*Label 8373*/ GIMT_Encode4(405322),
     /* 404200 */ // Label 8371: @404200
     /* 404200 */ GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(404760),
     /* 404205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 404208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 404211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404215 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(404307), // Rule ID 2099 //
     /* 404220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404264 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404268 */     // MIs[3] Operand 1
     /* 404268 */     // No operand predicates
     /* 404268 */     // MIs[1] Operand 2
     /* 404268 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 404279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 404288 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 404291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 404298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404305 */     GIR_RootConstrainSelectedInstOperands,
     /* 404306 */     // GIR_Coverage, 2099,
     /* 404306 */     GIR_EraseRootFromParent_Done,
     /* 404307 */   // Label 8376: @404307
     /* 404307 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(404399), // Rule ID 13444 //
     /* 404312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404360 */     // MIs[3] Operand 1
     /* 404360 */     // No operand predicates
     /* 404360 */     // MIs[1] Operand 2
     /* 404360 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 404371 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 404380 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 404383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 404390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404397 */     GIR_RootConstrainSelectedInstOperands,
     /* 404398 */     // GIR_Coverage, 13444,
     /* 404398 */     GIR_EraseRootFromParent_Done,
     /* 404399 */   // Label 8377: @404399
     /* 404399 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(404485), // Rule ID 13442 //
     /* 404404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404448 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404452 */     // MIs[3] Operand 1
     /* 404452 */     // No operand predicates
     /* 404452 */     // MIs[1] Operand 2
     /* 404452 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 404463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404467 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404469 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 404472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404483 */     GIR_RootConstrainSelectedInstOperands,
     /* 404484 */     // GIR_Coverage, 13442,
     /* 404484 */     GIR_EraseRootFromParent_Done,
     /* 404485 */   // Label 8378: @404485
     /* 404485 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(404571), // Rule ID 2097 //
     /* 404490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404538 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404542 */     // MIs[3] Operand 1
     /* 404542 */     // No operand predicates
     /* 404542 */     // MIs[1] Operand 2
     /* 404542 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 404553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404555 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 404558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404569 */     GIR_RootConstrainSelectedInstOperands,
     /* 404570 */     // GIR_Coverage, 2097,
     /* 404570 */     GIR_EraseRootFromParent_Done,
     /* 404571 */   // Label 8379: @404571
     /* 404571 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(404610), // Rule ID 1824 //
     /* 404576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 404586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 404593 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 404593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 404596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 404603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 404608 */     GIR_RootConstrainSelectedInstOperands,
     /* 404609 */     // GIR_Coverage, 1824,
     /* 404609 */     GIR_EraseRootFromParent_Done,
     /* 404610 */   // Label 8380: @404610
     /* 404610 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(404673), // Rule ID 13443 //
     /* 404615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404647 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404651 */     // MIs[2] Operand 1
     /* 404651 */     // No operand predicates
     /* 404651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404657 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 404660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404671 */     GIR_RootConstrainSelectedInstOperands,
     /* 404672 */     // GIR_Coverage, 13443,
     /* 404672 */     GIR_EraseRootFromParent_Done,
     /* 404673 */   // Label 8381: @404673
     /* 404673 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(404736), // Rule ID 2098 //
     /* 404678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404714 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404718 */     // MIs[2] Operand 1
     /* 404718 */     // No operand predicates
     /* 404718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404720 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 404723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404734 */     GIR_RootConstrainSelectedInstOperands,
     /* 404735 */     // GIR_Coverage, 2098,
     /* 404735 */     GIR_EraseRootFromParent_Done,
     /* 404736 */   // Label 8382: @404736
     /* 404736 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(404759), // Rule ID 1823 //
     /* 404741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404752 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 404752 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 404757 */     GIR_RootConstrainSelectedInstOperands,
     /* 404758 */     // GIR_Coverage, 1823,
     /* 404758 */     GIR_Done,
     /* 404759 */   // Label 8383: @404759
     /* 404759 */   GIM_Reject,
     /* 404760 */ // Label 8375: @404760
     /* 404760 */ GIM_Reject,
     /* 404761 */ // Label 8372: @404761
     /* 404761 */ GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(405321),
     /* 404766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 404769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 404772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404776 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(404868), // Rule ID 2096 //
     /* 404781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 404804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404825 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404829 */     // MIs[3] Operand 1
     /* 404829 */     // No operand predicates
     /* 404829 */     // MIs[1] Operand 2
     /* 404829 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 404840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 404849 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 404852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 404859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404866 */     GIR_RootConstrainSelectedInstOperands,
     /* 404867 */     // GIR_Coverage, 2096,
     /* 404867 */     GIR_EraseRootFromParent_Done,
     /* 404868 */   // Label 8385: @404868
     /* 404868 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(404960), // Rule ID 13441 //
     /* 404873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 404896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404900 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404917 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404921 */     // MIs[3] Operand 1
     /* 404921 */     // No operand predicates
     /* 404921 */     // MIs[1] Operand 2
     /* 404921 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 404932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 404941 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 404944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 404951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404958 */     GIR_RootConstrainSelectedInstOperands,
     /* 404959 */     // GIR_Coverage, 13441,
     /* 404959 */     GIR_EraseRootFromParent_Done,
     /* 404960 */   // Label 8386: @404960
     /* 404960 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(405046), // Rule ID 13439 //
     /* 404965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 404988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405013 */     // MIs[3] Operand 1
     /* 405013 */     // No operand predicates
     /* 405013 */     // MIs[1] Operand 2
     /* 405013 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 405024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405030 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 405033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405044 */     GIR_RootConstrainSelectedInstOperands,
     /* 405045 */     // GIR_Coverage, 13439,
     /* 405045 */     GIR_EraseRootFromParent_Done,
     /* 405046 */   // Label 8387: @405046
     /* 405046 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(405132), // Rule ID 2094 //
     /* 405051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405099 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405103 */     // MIs[3] Operand 1
     /* 405103 */     // No operand predicates
     /* 405103 */     // MIs[1] Operand 2
     /* 405103 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 405114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405116 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 405119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405130 */     GIR_RootConstrainSelectedInstOperands,
     /* 405131 */     // GIR_Coverage, 2094,
     /* 405131 */     GIR_EraseRootFromParent_Done,
     /* 405132 */   // Label 8388: @405132
     /* 405132 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(405171), // Rule ID 1822 //
     /* 405137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 405147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 405154 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 405154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 405157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 405169 */     GIR_RootConstrainSelectedInstOperands,
     /* 405170 */     // GIR_Coverage, 1822,
     /* 405170 */     GIR_EraseRootFromParent_Done,
     /* 405171 */   // Label 8389: @405171
     /* 405171 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(405234), // Rule ID 13440 //
     /* 405176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405208 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405212 */     // MIs[2] Operand 1
     /* 405212 */     // No operand predicates
     /* 405212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405218 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 405221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405232 */     GIR_RootConstrainSelectedInstOperands,
     /* 405233 */     // GIR_Coverage, 13440,
     /* 405233 */     GIR_EraseRootFromParent_Done,
     /* 405234 */   // Label 8390: @405234
     /* 405234 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(405297), // Rule ID 2095 //
     /* 405239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405275 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405279 */     // MIs[2] Operand 1
     /* 405279 */     // No operand predicates
     /* 405279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405281 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 405284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405295 */     GIR_RootConstrainSelectedInstOperands,
     /* 405296 */     // GIR_Coverage, 2095,
     /* 405296 */     GIR_EraseRootFromParent_Done,
     /* 405297 */   // Label 8391: @405297
     /* 405297 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(405320), // Rule ID 1821 //
     /* 405302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405313 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 405313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 405318 */     GIR_RootConstrainSelectedInstOperands,
     /* 405319 */     // GIR_Coverage, 1821,
     /* 405319 */     GIR_Done,
     /* 405320 */   // Label 8392: @405320
     /* 405320 */   GIM_Reject,
     /* 405321 */ // Label 8384: @405321
     /* 405321 */ GIM_Reject,
     /* 405322 */ // Label 8373: @405322
     /* 405322 */ GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(405400),
     /* 405327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 405330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 405333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405337 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(405376), // Rule ID 1820 //
     /* 405342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 405352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 405359 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 405359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 405362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 405374 */     GIR_RootConstrainSelectedInstOperands,
     /* 405375 */     // GIR_Coverage, 1820,
     /* 405375 */     GIR_EraseRootFromParent_Done,
     /* 405376 */   // Label 8394: @405376
     /* 405376 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(405399), // Rule ID 1819 //
     /* 405381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405392 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 405392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 405397 */     GIR_RootConstrainSelectedInstOperands,
     /* 405398 */     // GIR_Coverage, 1819,
     /* 405398 */     GIR_Done,
     /* 405399 */   // Label 8395: @405399
     /* 405399 */   GIM_Reject,
     /* 405400 */ // Label 8393: @405400
     /* 405400 */ GIM_Reject,
     /* 405401 */ // Label 8374: @405401
     /* 405401 */ GIM_Reject,
     /* 405402 */ // Label 151: @405402
     /* 405402 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8414*/ GIMT_Encode4(406181),
     /* 405413 */ /*GILLT_v2s32*//*Label 8396*/ GIMT_Encode4(405489),
     /* 405417 */ /*GILLT_v2s64*//*Label 8397*/ GIMT_Encode4(405544),
     /* 405421 */ /*GILLT_v4s16*//*Label 8398*/ GIMT_Encode4(405599),
     /* 405425 */ /*GILLT_v4s32*//*Label 8399*/ GIMT_Encode4(405654),
     /* 405429 */ /*GILLT_v8s8*//*Label 8400*/ GIMT_Encode4(405709),
     /* 405433 */ /*GILLT_v8s16*//*Label 8401*/ GIMT_Encode4(405743),
     /* 405437 */ /*GILLT_v16s8*//*Label 8402*/ GIMT_Encode4(405798), GIMT_Encode4(0),
     /* 405445 */ /*GILLT_nxv2s1*//*Label 8403*/ GIMT_Encode4(405832),
     /* 405449 */ /*GILLT_nxv2s16*//*Label 8404*/ GIMT_Encode4(405858),
     /* 405453 */ /*GILLT_nxv2s32*//*Label 8405*/ GIMT_Encode4(405884),
     /* 405457 */ /*GILLT_nxv2s64*//*Label 8406*/ GIMT_Encode4(405910),
     /* 405461 */ /*GILLT_nxv4s1*//*Label 8407*/ GIMT_Encode4(405957),
     /* 405465 */ /*GILLT_nxv4s16*//*Label 8408*/ GIMT_Encode4(405983),
     /* 405469 */ /*GILLT_nxv4s32*//*Label 8409*/ GIMT_Encode4(406009),
     /* 405473 */ /*GILLT_nxv8s1*//*Label 8410*/ GIMT_Encode4(406056),
     /* 405477 */ /*GILLT_nxv8s16*//*Label 8411*/ GIMT_Encode4(406082),
     /* 405481 */ /*GILLT_nxv16s1*//*Label 8412*/ GIMT_Encode4(406129),
     /* 405485 */ /*GILLT_nxv16s8*//*Label 8413*/ GIMT_Encode4(406155),
     /* 405489 */ // Label 8396: @405489
     /* 405489 */ GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(405543),
     /* 405494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 405497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 405500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405512 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(405527), // Rule ID 1881 //
     /* 405517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405520 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 405520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 405525 */     GIR_RootConstrainSelectedInstOperands,
     /* 405526 */     // GIR_Coverage, 1881,
     /* 405526 */     GIR_Done,
     /* 405527 */   // Label 8416: @405527
     /* 405527 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(405542), // Rule ID 5449 //
     /* 405532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405535 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 405535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 405540 */     GIR_RootConstrainSelectedInstOperands,
     /* 405541 */     // GIR_Coverage, 5449,
     /* 405541 */     GIR_Done,
     /* 405542 */   // Label 8417: @405542
     /* 405542 */   GIM_Reject,
     /* 405543 */ // Label 8415: @405543
     /* 405543 */ GIM_Reject,
     /* 405544 */ // Label 8397: @405544
     /* 405544 */ GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(405598),
     /* 405549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 405555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405563 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405567 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(405582), // Rule ID 1883 //
     /* 405572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405575 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 405575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 405580 */     GIR_RootConstrainSelectedInstOperands,
     /* 405581 */     // GIR_Coverage, 1883,
     /* 405581 */     GIR_Done,
     /* 405582 */   // Label 8419: @405582
     /* 405582 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(405597), // Rule ID 5451 //
     /* 405587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405590 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 405590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 405595 */     GIR_RootConstrainSelectedInstOperands,
     /* 405596 */     // GIR_Coverage, 5451,
     /* 405596 */     GIR_Done,
     /* 405597 */   // Label 8420: @405597
     /* 405597 */   GIM_Reject,
     /* 405598 */ // Label 8418: @405598
     /* 405598 */ GIM_Reject,
     /* 405599 */ // Label 8398: @405599
     /* 405599 */ GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(405653),
     /* 405604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 405607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 405610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405618 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405622 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(405637), // Rule ID 1879 //
     /* 405627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405630 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 405630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 405635 */     GIR_RootConstrainSelectedInstOperands,
     /* 405636 */     // GIR_Coverage, 1879,
     /* 405636 */     GIR_Done,
     /* 405637 */   // Label 8422: @405637
     /* 405637 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(405652), // Rule ID 5447 //
     /* 405642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405645 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 405645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 405650 */     GIR_RootConstrainSelectedInstOperands,
     /* 405651 */     // GIR_Coverage, 5447,
     /* 405651 */     GIR_Done,
     /* 405652 */   // Label 8423: @405652
     /* 405652 */   GIM_Reject,
     /* 405653 */ // Label 8421: @405653
     /* 405653 */ GIM_Reject,
     /* 405654 */ // Label 8399: @405654
     /* 405654 */ GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(405708),
     /* 405659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 405665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405673 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405677 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(405692), // Rule ID 1882 //
     /* 405682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405685 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 405685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 405690 */     GIR_RootConstrainSelectedInstOperands,
     /* 405691 */     // GIR_Coverage, 1882,
     /* 405691 */     GIR_Done,
     /* 405692 */   // Label 8425: @405692
     /* 405692 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(405707), // Rule ID 5450 //
     /* 405697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405700 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 405700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 405705 */     GIR_RootConstrainSelectedInstOperands,
     /* 405706 */     // GIR_Coverage, 5450,
     /* 405706 */     GIR_Done,
     /* 405707 */   // Label 8426: @405707
     /* 405707 */   GIM_Reject,
     /* 405708 */ // Label 8424: @405708
     /* 405708 */ GIM_Reject,
     /* 405709 */ // Label 8400: @405709
     /* 405709 */ GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(405742), // Rule ID 1877 //
     /* 405714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 405720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 405723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405735 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 405735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 405740 */   GIR_RootConstrainSelectedInstOperands,
     /* 405741 */   // GIR_Coverage, 1877,
     /* 405741 */   GIR_Done,
     /* 405742 */ // Label 8427: @405742
     /* 405742 */ GIM_Reject,
     /* 405743 */ // Label 8401: @405743
     /* 405743 */ GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(405797),
     /* 405748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 405754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405766 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(405781), // Rule ID 1880 //
     /* 405771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405774 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 405774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 405779 */     GIR_RootConstrainSelectedInstOperands,
     /* 405780 */     // GIR_Coverage, 1880,
     /* 405780 */     GIR_Done,
     /* 405781 */   // Label 8429: @405781
     /* 405781 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(405796), // Rule ID 5448 //
     /* 405786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405789 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 405789 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 405794 */     GIR_RootConstrainSelectedInstOperands,
     /* 405795 */     // GIR_Coverage, 5448,
     /* 405795 */     GIR_Done,
     /* 405796 */   // Label 8430: @405796
     /* 405796 */   GIM_Reject,
     /* 405797 */ // Label 8428: @405797
     /* 405797 */ GIM_Reject,
     /* 405798 */ // Label 8402: @405798
     /* 405798 */ GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(405831), // Rule ID 1878 //
     /* 405803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 405809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 405812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405824 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 405824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 405829 */   GIR_RootConstrainSelectedInstOperands,
     /* 405830 */   // GIR_Coverage, 1878,
     /* 405830 */   GIR_Done,
     /* 405831 */ // Label 8431: @405831
     /* 405831 */ GIM_Reject,
     /* 405832 */ // Label 8403: @405832
     /* 405832 */ GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(405857), // Rule ID 8892 //
     /* 405837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 405843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 405846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 405850 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 405850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 405855 */   GIR_RootConstrainSelectedInstOperands,
     /* 405856 */   // GIR_Coverage, 8892,
     /* 405856 */   GIR_Done,
     /* 405857 */ // Label 8432: @405857
     /* 405857 */ GIM_Reject,
     /* 405858 */ // Label 8404: @405858
     /* 405858 */ GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(405883), // Rule ID 8854 //
     /* 405863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 405869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 405872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405876 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 405876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 405881 */   GIR_RootConstrainSelectedInstOperands,
     /* 405882 */   // GIR_Coverage, 8854,
     /* 405882 */   GIR_Done,
     /* 405883 */ // Label 8433: @405883
     /* 405883 */ GIM_Reject,
     /* 405884 */ // Label 8405: @405884
     /* 405884 */ GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(405909), // Rule ID 8855 //
     /* 405889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 405895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 405898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405902 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 405902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 405907 */   GIR_RootConstrainSelectedInstOperands,
     /* 405908 */   // GIR_Coverage, 8855,
     /* 405908 */   GIR_Done,
     /* 405909 */ // Label 8434: @405909
     /* 405909 */ GIM_Reject,
     /* 405910 */ // Label 8406: @405910
     /* 405910 */ GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(405956),
     /* 405915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 405918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 405921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 405925 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(405940), // Rule ID 8850 //
     /* 405930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405933 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 405933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 405938 */     GIR_RootConstrainSelectedInstOperands,
     /* 405939 */     // GIR_Coverage, 8850,
     /* 405939 */     GIR_Done,
     /* 405940 */   // Label 8436: @405940
     /* 405940 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(405955), // Rule ID 8856 //
     /* 405945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405948 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 405948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 405953 */     GIR_RootConstrainSelectedInstOperands,
     /* 405954 */     // GIR_Coverage, 8856,
     /* 405954 */     GIR_Done,
     /* 405955 */   // Label 8437: @405955
     /* 405955 */   GIM_Reject,
     /* 405956 */ // Label 8435: @405956
     /* 405956 */ GIM_Reject,
     /* 405957 */ // Label 8407: @405957
     /* 405957 */ GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(405982), // Rule ID 8891 //
     /* 405962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 405968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 405971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 405975 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 405975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 405980 */   GIR_RootConstrainSelectedInstOperands,
     /* 405981 */   // GIR_Coverage, 8891,
     /* 405981 */   GIR_Done,
     /* 405982 */ // Label 8438: @405982
     /* 405982 */ GIM_Reject,
     /* 405983 */ // Label 8408: @405983
     /* 405983 */ GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(406008), // Rule ID 8852 //
     /* 405988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 405991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 405994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 405997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406001 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 406001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 406006 */   GIR_RootConstrainSelectedInstOperands,
     /* 406007 */   // GIR_Coverage, 8852,
     /* 406007 */   GIR_Done,
     /* 406008 */ // Label 8439: @406008
     /* 406008 */ GIM_Reject,
     /* 406009 */ // Label 8409: @406009
     /* 406009 */ GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(406055),
     /* 406014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 406017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 406020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406024 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(406039), // Rule ID 8849 //
     /* 406029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406032 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 406032 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 406037 */     GIR_RootConstrainSelectedInstOperands,
     /* 406038 */     // GIR_Coverage, 8849,
     /* 406038 */     GIR_Done,
     /* 406039 */   // Label 8441: @406039
     /* 406039 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(406054), // Rule ID 8853 //
     /* 406044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406047 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 406047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 406052 */     GIR_RootConstrainSelectedInstOperands,
     /* 406053 */     // GIR_Coverage, 8853,
     /* 406053 */     GIR_Done,
     /* 406054 */   // Label 8442: @406054
     /* 406054 */   GIM_Reject,
     /* 406055 */ // Label 8440: @406055
     /* 406055 */ GIM_Reject,
     /* 406056 */ // Label 8410: @406056
     /* 406056 */ GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(406081), // Rule ID 8890 //
     /* 406061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 406067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 406070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406074 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 406074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 406079 */   GIR_RootConstrainSelectedInstOperands,
     /* 406080 */   // GIR_Coverage, 8890,
     /* 406080 */   GIR_Done,
     /* 406081 */ // Label 8443: @406081
     /* 406081 */ GIM_Reject,
     /* 406082 */ // Label 8411: @406082
     /* 406082 */ GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(406128),
     /* 406087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 406090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 406093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406097 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(406112), // Rule ID 8848 //
     /* 406102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406105 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 406105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 406110 */     GIR_RootConstrainSelectedInstOperands,
     /* 406111 */     // GIR_Coverage, 8848,
     /* 406111 */     GIR_Done,
     /* 406112 */   // Label 8445: @406112
     /* 406112 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(406127), // Rule ID 8851 //
     /* 406117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406120 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 406120 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 406125 */     GIR_RootConstrainSelectedInstOperands,
     /* 406126 */     // GIR_Coverage, 8851,
     /* 406126 */     GIR_Done,
     /* 406127 */   // Label 8446: @406127
     /* 406127 */   GIM_Reject,
     /* 406128 */ // Label 8444: @406128
     /* 406128 */ GIM_Reject,
     /* 406129 */ // Label 8412: @406129
     /* 406129 */ GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(406154), // Rule ID 2397 //
     /* 406134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 406140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 406143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406147 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 406147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 406152 */   GIR_RootConstrainSelectedInstOperands,
     /* 406153 */   // GIR_Coverage, 2397,
     /* 406153 */   GIR_Done,
     /* 406154 */ // Label 8447: @406154
     /* 406154 */ GIM_Reject,
     /* 406155 */ // Label 8413: @406155
     /* 406155 */ GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(406180), // Rule ID 8847 //
     /* 406160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 406166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 406169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406173 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 406173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 406178 */   GIR_RootConstrainSelectedInstOperands,
     /* 406179 */   // GIR_Coverage, 8847,
     /* 406179 */   GIR_Done,
     /* 406180 */ // Label 8448: @406180
     /* 406180 */ GIM_Reject,
     /* 406181 */ // Label 8414: @406181
     /* 406181 */ GIM_Reject,
     /* 406182 */ // Label 152: @406182
     /* 406182 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8467*/ GIMT_Encode4(406961),
     /* 406193 */ /*GILLT_v2s32*//*Label 8449*/ GIMT_Encode4(406269),
     /* 406197 */ /*GILLT_v2s64*//*Label 8450*/ GIMT_Encode4(406324),
     /* 406201 */ /*GILLT_v4s16*//*Label 8451*/ GIMT_Encode4(406379),
     /* 406205 */ /*GILLT_v4s32*//*Label 8452*/ GIMT_Encode4(406434),
     /* 406209 */ /*GILLT_v8s8*//*Label 8453*/ GIMT_Encode4(406489),
     /* 406213 */ /*GILLT_v8s16*//*Label 8454*/ GIMT_Encode4(406523),
     /* 406217 */ /*GILLT_v16s8*//*Label 8455*/ GIMT_Encode4(406578), GIMT_Encode4(0),
     /* 406225 */ /*GILLT_nxv2s1*//*Label 8456*/ GIMT_Encode4(406612),
     /* 406229 */ /*GILLT_nxv2s16*//*Label 8457*/ GIMT_Encode4(406638),
     /* 406233 */ /*GILLT_nxv2s32*//*Label 8458*/ GIMT_Encode4(406664),
     /* 406237 */ /*GILLT_nxv2s64*//*Label 8459*/ GIMT_Encode4(406690),
     /* 406241 */ /*GILLT_nxv4s1*//*Label 8460*/ GIMT_Encode4(406737),
     /* 406245 */ /*GILLT_nxv4s16*//*Label 8461*/ GIMT_Encode4(406763),
     /* 406249 */ /*GILLT_nxv4s32*//*Label 8462*/ GIMT_Encode4(406789),
     /* 406253 */ /*GILLT_nxv8s1*//*Label 8463*/ GIMT_Encode4(406836),
     /* 406257 */ /*GILLT_nxv8s16*//*Label 8464*/ GIMT_Encode4(406862),
     /* 406261 */ /*GILLT_nxv16s1*//*Label 8465*/ GIMT_Encode4(406909),
     /* 406265 */ /*GILLT_nxv16s8*//*Label 8466*/ GIMT_Encode4(406935),
     /* 406269 */ // Label 8449: @406269
     /* 406269 */ GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(406323),
     /* 406274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 406280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406292 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(406307), // Rule ID 1888 //
     /* 406297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406300 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 406300 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 406305 */     GIR_RootConstrainSelectedInstOperands,
     /* 406306 */     // GIR_Coverage, 1888,
     /* 406306 */     GIR_Done,
     /* 406307 */   // Label 8469: @406307
     /* 406307 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(406322), // Rule ID 5454 //
     /* 406312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406315 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 406315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 406320 */     GIR_RootConstrainSelectedInstOperands,
     /* 406321 */     // GIR_Coverage, 5454,
     /* 406321 */     GIR_Done,
     /* 406322 */   // Label 8470: @406322
     /* 406322 */   GIM_Reject,
     /* 406323 */ // Label 8468: @406323
     /* 406323 */ GIM_Reject,
     /* 406324 */ // Label 8450: @406324
     /* 406324 */ GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(406378),
     /* 406329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 406335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406347 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(406362), // Rule ID 1890 //
     /* 406352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406355 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 406355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 406360 */     GIR_RootConstrainSelectedInstOperands,
     /* 406361 */     // GIR_Coverage, 1890,
     /* 406361 */     GIR_Done,
     /* 406362 */   // Label 8472: @406362
     /* 406362 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(406377), // Rule ID 5456 //
     /* 406367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406370 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 406370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 406375 */     GIR_RootConstrainSelectedInstOperands,
     /* 406376 */     // GIR_Coverage, 5456,
     /* 406376 */     GIR_Done,
     /* 406377 */   // Label 8473: @406377
     /* 406377 */   GIM_Reject,
     /* 406378 */ // Label 8471: @406378
     /* 406378 */ GIM_Reject,
     /* 406379 */ // Label 8451: @406379
     /* 406379 */ GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(406433),
     /* 406384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 406390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406402 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(406417), // Rule ID 1886 //
     /* 406407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406410 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 406410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 406415 */     GIR_RootConstrainSelectedInstOperands,
     /* 406416 */     // GIR_Coverage, 1886,
     /* 406416 */     GIR_Done,
     /* 406417 */   // Label 8475: @406417
     /* 406417 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(406432), // Rule ID 5452 //
     /* 406422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406425 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 406425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 406430 */     GIR_RootConstrainSelectedInstOperands,
     /* 406431 */     // GIR_Coverage, 5452,
     /* 406431 */     GIR_Done,
     /* 406432 */   // Label 8476: @406432
     /* 406432 */   GIM_Reject,
     /* 406433 */ // Label 8474: @406433
     /* 406433 */ GIM_Reject,
     /* 406434 */ // Label 8452: @406434
     /* 406434 */ GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(406488),
     /* 406439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 406445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406457 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(406472), // Rule ID 1889 //
     /* 406462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406465 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 406465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 406470 */     GIR_RootConstrainSelectedInstOperands,
     /* 406471 */     // GIR_Coverage, 1889,
     /* 406471 */     GIR_Done,
     /* 406472 */   // Label 8478: @406472
     /* 406472 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(406487), // Rule ID 5455 //
     /* 406477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406480 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 406480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 406485 */     GIR_RootConstrainSelectedInstOperands,
     /* 406486 */     // GIR_Coverage, 5455,
     /* 406486 */     GIR_Done,
     /* 406487 */   // Label 8479: @406487
     /* 406487 */   GIM_Reject,
     /* 406488 */ // Label 8477: @406488
     /* 406488 */ GIM_Reject,
     /* 406489 */ // Label 8453: @406489
     /* 406489 */ GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(406522), // Rule ID 1884 //
     /* 406494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 406500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 406503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406515 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 406515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 406520 */   GIR_RootConstrainSelectedInstOperands,
     /* 406521 */   // GIR_Coverage, 1884,
     /* 406521 */   GIR_Done,
     /* 406522 */ // Label 8480: @406522
     /* 406522 */ GIM_Reject,
     /* 406523 */ // Label 8454: @406523
     /* 406523 */ GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(406577),
     /* 406528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 406534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406546 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(406561), // Rule ID 1887 //
     /* 406551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406554 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 406554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 406559 */     GIR_RootConstrainSelectedInstOperands,
     /* 406560 */     // GIR_Coverage, 1887,
     /* 406560 */     GIR_Done,
     /* 406561 */   // Label 8482: @406561
     /* 406561 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(406576), // Rule ID 5453 //
     /* 406566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406569 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 406569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 406574 */     GIR_RootConstrainSelectedInstOperands,
     /* 406575 */     // GIR_Coverage, 5453,
     /* 406575 */     GIR_Done,
     /* 406576 */   // Label 8483: @406576
     /* 406576 */   GIM_Reject,
     /* 406577 */ // Label 8481: @406577
     /* 406577 */ GIM_Reject,
     /* 406578 */ // Label 8455: @406578
     /* 406578 */ GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(406611), // Rule ID 1885 //
     /* 406583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 406589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 406592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406604 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 406604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 406609 */   GIR_RootConstrainSelectedInstOperands,
     /* 406610 */   // GIR_Coverage, 1885,
     /* 406610 */   GIR_Done,
     /* 406611 */ // Label 8484: @406611
     /* 406611 */ GIM_Reject,
     /* 406612 */ // Label 8456: @406612
     /* 406612 */ GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(406637), // Rule ID 8895 //
     /* 406617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 406623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 406626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406630 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 406630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 406635 */   GIR_RootConstrainSelectedInstOperands,
     /* 406636 */   // GIR_Coverage, 8895,
     /* 406636 */   GIR_Done,
     /* 406637 */ // Label 8485: @406637
     /* 406637 */ GIM_Reject,
     /* 406638 */ // Label 8457: @406638
     /* 406638 */ GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(406663), // Rule ID 8864 //
     /* 406643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 406649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 406652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406656 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 406656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 406661 */   GIR_RootConstrainSelectedInstOperands,
     /* 406662 */   // GIR_Coverage, 8864,
     /* 406662 */   GIR_Done,
     /* 406663 */ // Label 8486: @406663
     /* 406663 */ GIM_Reject,
     /* 406664 */ // Label 8458: @406664
     /* 406664 */ GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(406689), // Rule ID 8865 //
     /* 406669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 406675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 406678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406682 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 406682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 406687 */   GIR_RootConstrainSelectedInstOperands,
     /* 406688 */   // GIR_Coverage, 8865,
     /* 406688 */   GIR_Done,
     /* 406689 */ // Label 8487: @406689
     /* 406689 */ GIM_Reject,
     /* 406690 */ // Label 8459: @406690
     /* 406690 */ GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(406736),
     /* 406695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 406698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 406701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406705 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(406720), // Rule ID 8860 //
     /* 406710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406713 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 406713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 406718 */     GIR_RootConstrainSelectedInstOperands,
     /* 406719 */     // GIR_Coverage, 8860,
     /* 406719 */     GIR_Done,
     /* 406720 */   // Label 8489: @406720
     /* 406720 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(406735), // Rule ID 8866 //
     /* 406725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406728 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 406728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 406733 */     GIR_RootConstrainSelectedInstOperands,
     /* 406734 */     // GIR_Coverage, 8866,
     /* 406734 */     GIR_Done,
     /* 406735 */   // Label 8490: @406735
     /* 406735 */   GIM_Reject,
     /* 406736 */ // Label 8488: @406736
     /* 406736 */ GIM_Reject,
     /* 406737 */ // Label 8460: @406737
     /* 406737 */ GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(406762), // Rule ID 8894 //
     /* 406742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 406748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 406751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406755 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 406755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 406760 */   GIR_RootConstrainSelectedInstOperands,
     /* 406761 */   // GIR_Coverage, 8894,
     /* 406761 */   GIR_Done,
     /* 406762 */ // Label 8491: @406762
     /* 406762 */ GIM_Reject,
     /* 406763 */ // Label 8461: @406763
     /* 406763 */ GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(406788), // Rule ID 8862 //
     /* 406768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 406774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 406777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406781 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 406781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 406786 */   GIR_RootConstrainSelectedInstOperands,
     /* 406787 */   // GIR_Coverage, 8862,
     /* 406787 */   GIR_Done,
     /* 406788 */ // Label 8492: @406788
     /* 406788 */ GIM_Reject,
     /* 406789 */ // Label 8462: @406789
     /* 406789 */ GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(406835),
     /* 406794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 406797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 406800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406804 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(406819), // Rule ID 8859 //
     /* 406809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406812 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 406812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 406817 */     GIR_RootConstrainSelectedInstOperands,
     /* 406818 */     // GIR_Coverage, 8859,
     /* 406818 */     GIR_Done,
     /* 406819 */   // Label 8494: @406819
     /* 406819 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(406834), // Rule ID 8863 //
     /* 406824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406827 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 406827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 406832 */     GIR_RootConstrainSelectedInstOperands,
     /* 406833 */     // GIR_Coverage, 8863,
     /* 406833 */     GIR_Done,
     /* 406834 */   // Label 8495: @406834
     /* 406834 */   GIM_Reject,
     /* 406835 */ // Label 8493: @406835
     /* 406835 */ GIM_Reject,
     /* 406836 */ // Label 8463: @406836
     /* 406836 */ GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(406861), // Rule ID 8893 //
     /* 406841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 406847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 406850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406854 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 406854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 406859 */   GIR_RootConstrainSelectedInstOperands,
     /* 406860 */   // GIR_Coverage, 8893,
     /* 406860 */   GIR_Done,
     /* 406861 */ // Label 8496: @406861
     /* 406861 */ GIM_Reject,
     /* 406862 */ // Label 8464: @406862
     /* 406862 */ GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(406908),
     /* 406867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 406870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 406873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406877 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(406892), // Rule ID 8858 //
     /* 406882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406885 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 406885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 406890 */     GIR_RootConstrainSelectedInstOperands,
     /* 406891 */     // GIR_Coverage, 8858,
     /* 406891 */     GIR_Done,
     /* 406892 */   // Label 8498: @406892
     /* 406892 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(406907), // Rule ID 8861 //
     /* 406897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406900 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 406900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 406905 */     GIR_RootConstrainSelectedInstOperands,
     /* 406906 */     // GIR_Coverage, 8861,
     /* 406906 */     GIR_Done,
     /* 406907 */   // Label 8499: @406907
     /* 406907 */   GIM_Reject,
     /* 406908 */ // Label 8497: @406908
     /* 406908 */ GIM_Reject,
     /* 406909 */ // Label 8465: @406909
     /* 406909 */ GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(406934), // Rule ID 2401 //
     /* 406914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 406920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 406923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406927 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 406927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 406932 */   GIR_RootConstrainSelectedInstOperands,
     /* 406933 */   // GIR_Coverage, 2401,
     /* 406933 */   GIR_Done,
     /* 406934 */ // Label 8500: @406934
     /* 406934 */ GIM_Reject,
     /* 406935 */ // Label 8466: @406935
     /* 406935 */ GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(406960), // Rule ID 8857 //
     /* 406940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 406946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 406949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406953 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 406953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 406958 */   GIR_RootConstrainSelectedInstOperands,
     /* 406959 */   // GIR_Coverage, 8857,
     /* 406959 */   GIR_Done,
     /* 406960 */ // Label 8501: @406960
     /* 406960 */ GIM_Reject,
     /* 406961 */ // Label 8467: @406961
     /* 406961 */ GIM_Reject,
     /* 406962 */ // Label 153: @406962
     /* 406962 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8510*/ GIMT_Encode4(407659),
     /* 406973 */ /*GILLT_s64*//*Label 8502*/ GIMT_Encode4(407009), GIMT_Encode4(0),
     /* 406981 */ /*GILLT_v2s32*//*Label 8503*/ GIMT_Encode4(407120),
     /* 406985 */ /*GILLT_v2s64*//*Label 8504*/ GIMT_Encode4(407197),
     /* 406989 */ /*GILLT_v4s16*//*Label 8505*/ GIMT_Encode4(407274),
     /* 406993 */ /*GILLT_v4s32*//*Label 8506*/ GIMT_Encode4(407351),
     /* 406997 */ /*GILLT_v8s8*//*Label 8507*/ GIMT_Encode4(407428),
     /* 407001 */ /*GILLT_v8s16*//*Label 8508*/ GIMT_Encode4(407505),
     /* 407005 */ /*GILLT_v16s8*//*Label 8509*/ GIMT_Encode4(407582),
     /* 407009 */ // Label 8502: @407009
     /* 407009 */ GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(407119),
     /* 407014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 407017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407025 */   GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(407050), // Rule ID 5226 //
     /* 407030 */     // MIs[0] Operand 2
     /* 407030 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 407041 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 407041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 407044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407048 */     GIR_RootConstrainSelectedInstOperands,
     /* 407049 */     // GIR_Coverage, 5226,
     /* 407049 */     GIR_EraseRootFromParent_Done,
     /* 407050 */   // Label 8512: @407050
     /* 407050 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(407084), // Rule ID 2111 //
     /* 407055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407058 */     // MIs[0] imm
     /* 407058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407066 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 407070 */     // MIs[1] Operand 1
     /* 407070 */     // No operand predicates
     /* 407070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407072 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 407072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 407075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407082 */     GIR_RootConstrainSelectedInstOperands,
     /* 407083 */     // GIR_Coverage, 2111,
     /* 407083 */     GIR_EraseRootFromParent_Done,
     /* 407084 */   // Label 8513: @407084
     /* 407084 */   GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(407118), // Rule ID 6241 //
     /* 407089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407092 */     // MIs[0] imm
     /* 407092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 407104 */     // MIs[1] Operand 1
     /* 407104 */     // No operand predicates
     /* 407104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407106 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 407106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 407109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407116 */     GIR_RootConstrainSelectedInstOperands,
     /* 407117 */     // GIR_Coverage, 6241,
     /* 407117 */     GIR_EraseRootFromParent_Done,
     /* 407118 */   // Label 8514: @407118
     /* 407118 */   GIM_Reject,
     /* 407119 */ // Label 8511: @407119
     /* 407119 */ GIM_Reject,
     /* 407120 */ // Label 8503: @407120
     /* 407120 */ GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(407196),
     /* 407125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 407128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407136 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(407161), // Rule ID 4871 //
     /* 407141 */     // MIs[0] Operand 2
     /* 407141 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 407152 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 407152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 407155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407159 */     GIR_RootConstrainSelectedInstOperands,
     /* 407160 */     // GIR_Coverage, 4871,
     /* 407160 */     GIR_EraseRootFromParent_Done,
     /* 407161 */   // Label 8516: @407161
     /* 407161 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(407195), // Rule ID 2218 //
     /* 407166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407169 */     // MIs[0] imm
     /* 407169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 407181 */     // MIs[1] Operand 1
     /* 407181 */     // No operand predicates
     /* 407181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407183 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 407183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 407186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407193 */     GIR_RootConstrainSelectedInstOperands,
     /* 407194 */     // GIR_Coverage, 2218,
     /* 407194 */     GIR_EraseRootFromParent_Done,
     /* 407195 */   // Label 8517: @407195
     /* 407195 */   GIM_Reject,
     /* 407196 */ // Label 8515: @407196
     /* 407196 */ GIM_Reject,
     /* 407197 */ // Label 8504: @407197
     /* 407197 */ GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(407273),
     /* 407202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407213 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(407238), // Rule ID 4875 //
     /* 407218 */     // MIs[0] Operand 2
     /* 407218 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 407229 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 407229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 407232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407236 */     GIR_RootConstrainSelectedInstOperands,
     /* 407237 */     // GIR_Coverage, 4875,
     /* 407237 */     GIR_EraseRootFromParent_Done,
     /* 407238 */   // Label 8519: @407238
     /* 407238 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(407272), // Rule ID 2220 //
     /* 407243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407246 */     // MIs[0] imm
     /* 407246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 407258 */     // MIs[1] Operand 1
     /* 407258 */     // No operand predicates
     /* 407258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407260 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 407260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 407263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407270 */     GIR_RootConstrainSelectedInstOperands,
     /* 407271 */     // GIR_Coverage, 2220,
     /* 407271 */     GIR_EraseRootFromParent_Done,
     /* 407272 */   // Label 8520: @407272
     /* 407272 */   GIM_Reject,
     /* 407273 */ // Label 8518: @407273
     /* 407273 */ GIM_Reject,
     /* 407274 */ // Label 8505: @407274
     /* 407274 */ GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(407350),
     /* 407279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407290 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(407315), // Rule ID 4870 //
     /* 407295 */     // MIs[0] Operand 2
     /* 407295 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 407306 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 407306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 407309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407313 */     GIR_RootConstrainSelectedInstOperands,
     /* 407314 */     // GIR_Coverage, 4870,
     /* 407314 */     GIR_EraseRootFromParent_Done,
     /* 407315 */   // Label 8522: @407315
     /* 407315 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(407349), // Rule ID 2216 //
     /* 407320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407323 */     // MIs[0] imm
     /* 407323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 407335 */     // MIs[1] Operand 1
     /* 407335 */     // No operand predicates
     /* 407335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407337 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 407337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 407340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407347 */     GIR_RootConstrainSelectedInstOperands,
     /* 407348 */     // GIR_Coverage, 2216,
     /* 407348 */     GIR_EraseRootFromParent_Done,
     /* 407349 */   // Label 8523: @407349
     /* 407349 */   GIM_Reject,
     /* 407350 */ // Label 8521: @407350
     /* 407350 */ GIM_Reject,
     /* 407351 */ // Label 8506: @407351
     /* 407351 */ GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(407427),
     /* 407356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407367 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(407392), // Rule ID 4874 //
     /* 407372 */     // MIs[0] Operand 2
     /* 407372 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 407383 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 407383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 407386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407390 */     GIR_RootConstrainSelectedInstOperands,
     /* 407391 */     // GIR_Coverage, 4874,
     /* 407391 */     GIR_EraseRootFromParent_Done,
     /* 407392 */   // Label 8525: @407392
     /* 407392 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(407426), // Rule ID 2219 //
     /* 407397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407400 */     // MIs[0] imm
     /* 407400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 407412 */     // MIs[1] Operand 1
     /* 407412 */     // No operand predicates
     /* 407412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407414 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 407414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 407417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407424 */     GIR_RootConstrainSelectedInstOperands,
     /* 407425 */     // GIR_Coverage, 2219,
     /* 407425 */     GIR_EraseRootFromParent_Done,
     /* 407426 */   // Label 8526: @407426
     /* 407426 */   GIM_Reject,
     /* 407427 */ // Label 8524: @407427
     /* 407427 */ GIM_Reject,
     /* 407428 */ // Label 8507: @407428
     /* 407428 */ GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(407504),
     /* 407433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407444 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(407469), // Rule ID 4869 //
     /* 407449 */     // MIs[0] Operand 2
     /* 407449 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 407460 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 407460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 407463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407467 */     GIR_RootConstrainSelectedInstOperands,
     /* 407468 */     // GIR_Coverage, 4869,
     /* 407468 */     GIR_EraseRootFromParent_Done,
     /* 407469 */   // Label 8528: @407469
     /* 407469 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(407503), // Rule ID 2214 //
     /* 407474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407477 */     // MIs[0] imm
     /* 407477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 407489 */     // MIs[1] Operand 1
     /* 407489 */     // No operand predicates
     /* 407489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407491 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 407491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 407494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407501 */     GIR_RootConstrainSelectedInstOperands,
     /* 407502 */     // GIR_Coverage, 2214,
     /* 407502 */     GIR_EraseRootFromParent_Done,
     /* 407503 */   // Label 8529: @407503
     /* 407503 */   GIM_Reject,
     /* 407504 */ // Label 8527: @407504
     /* 407504 */ GIM_Reject,
     /* 407505 */ // Label 8508: @407505
     /* 407505 */ GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(407581),
     /* 407510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407521 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(407546), // Rule ID 4873 //
     /* 407526 */     // MIs[0] Operand 2
     /* 407526 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 407537 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 407537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 407540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407544 */     GIR_RootConstrainSelectedInstOperands,
     /* 407545 */     // GIR_Coverage, 4873,
     /* 407545 */     GIR_EraseRootFromParent_Done,
     /* 407546 */   // Label 8531: @407546
     /* 407546 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(407580), // Rule ID 2217 //
     /* 407551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407554 */     // MIs[0] imm
     /* 407554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 407566 */     // MIs[1] Operand 1
     /* 407566 */     // No operand predicates
     /* 407566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407568 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 407568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 407571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407578 */     GIR_RootConstrainSelectedInstOperands,
     /* 407579 */     // GIR_Coverage, 2217,
     /* 407579 */     GIR_EraseRootFromParent_Done,
     /* 407580 */   // Label 8532: @407580
     /* 407580 */   GIM_Reject,
     /* 407581 */ // Label 8530: @407581
     /* 407581 */ GIM_Reject,
     /* 407582 */ // Label 8509: @407582
     /* 407582 */ GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(407658),
     /* 407587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407598 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(407623), // Rule ID 4872 //
     /* 407603 */     // MIs[0] Operand 2
     /* 407603 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 407614 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 407614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 407617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407621 */     GIR_RootConstrainSelectedInstOperands,
     /* 407622 */     // GIR_Coverage, 4872,
     /* 407622 */     GIR_EraseRootFromParent_Done,
     /* 407623 */   // Label 8534: @407623
     /* 407623 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(407657), // Rule ID 2215 //
     /* 407628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407631 */     // MIs[0] imm
     /* 407631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 407643 */     // MIs[1] Operand 1
     /* 407643 */     // No operand predicates
     /* 407643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407645 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 407645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 407648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407655 */     GIR_RootConstrainSelectedInstOperands,
     /* 407656 */     // GIR_Coverage, 2215,
     /* 407656 */     GIR_EraseRootFromParent_Done,
     /* 407657 */   // Label 8535: @407657
     /* 407657 */   GIM_Reject,
     /* 407658 */ // Label 8533: @407658
     /* 407658 */ GIM_Reject,
     /* 407659 */ // Label 8510: @407659
     /* 407659 */ GIM_Reject,
     /* 407660 */ // Label 154: @407660
     /* 407660 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8544*/ GIMT_Encode4(408115),
     /* 407671 */ /*GILLT_s64*//*Label 8536*/ GIMT_Encode4(407707), GIMT_Encode4(0),
     /* 407679 */ /*GILLT_v2s32*//*Label 8537*/ GIMT_Encode4(407793),
     /* 407683 */ /*GILLT_v2s64*//*Label 8538*/ GIMT_Encode4(407839),
     /* 407687 */ /*GILLT_v4s16*//*Label 8539*/ GIMT_Encode4(407885),
     /* 407691 */ /*GILLT_v4s32*//*Label 8540*/ GIMT_Encode4(407931),
     /* 407695 */ /*GILLT_v8s8*//*Label 8541*/ GIMT_Encode4(407977),
     /* 407699 */ /*GILLT_v8s16*//*Label 8542*/ GIMT_Encode4(408023),
     /* 407703 */ /*GILLT_v16s8*//*Label 8543*/ GIMT_Encode4(408069),
     /* 407707 */ // Label 8536: @407707
     /* 407707 */ GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(407792),
     /* 407712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 407715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407723 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(407757), // Rule ID 2120 //
     /* 407728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407731 */     // MIs[0] imm
     /* 407731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 407743 */     // MIs[1] Operand 1
     /* 407743 */     // No operand predicates
     /* 407743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407745 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 407745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 407748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407755 */     GIR_RootConstrainSelectedInstOperands,
     /* 407756 */     // GIR_Coverage, 2120,
     /* 407756 */     GIR_EraseRootFromParent_Done,
     /* 407757 */   // Label 8546: @407757
     /* 407757 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(407791), // Rule ID 6247 //
     /* 407762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407765 */     // MIs[0] imm
     /* 407765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 407777 */     // MIs[1] Operand 1
     /* 407777 */     // No operand predicates
     /* 407777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407779 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 407779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 407782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407789 */     GIR_RootConstrainSelectedInstOperands,
     /* 407790 */     // GIR_Coverage, 6247,
     /* 407790 */     GIR_EraseRootFromParent_Done,
     /* 407791 */   // Label 8547: @407791
     /* 407791 */   GIM_Reject,
     /* 407792 */ // Label 8545: @407792
     /* 407792 */ GIM_Reject,
     /* 407793 */ // Label 8537: @407793
     /* 407793 */ GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(407838), // Rule ID 2277 //
     /* 407798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 407804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407812 */   // MIs[0] imm
     /* 407812 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407820 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 407824 */   // MIs[1] Operand 1
     /* 407824 */   // No operand predicates
     /* 407824 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407826 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 407826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 407829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407831 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407833 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407836 */   GIR_RootConstrainSelectedInstOperands,
     /* 407837 */   // GIR_Coverage, 2277,
     /* 407837 */   GIR_EraseRootFromParent_Done,
     /* 407838 */ // Label 8548: @407838
     /* 407838 */ GIM_Reject,
     /* 407839 */ // Label 8538: @407839
     /* 407839 */ GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(407884), // Rule ID 2279 //
     /* 407844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407858 */   // MIs[0] imm
     /* 407858 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407862 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407866 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 407870 */   // MIs[1] Operand 1
     /* 407870 */   // No operand predicates
     /* 407870 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407872 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 407872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 407875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407877 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407879 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407882 */   GIR_RootConstrainSelectedInstOperands,
     /* 407883 */   // GIR_Coverage, 2279,
     /* 407883 */   GIR_EraseRootFromParent_Done,
     /* 407884 */ // Label 8549: @407884
     /* 407884 */ GIM_Reject,
     /* 407885 */ // Label 8539: @407885
     /* 407885 */ GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(407930), // Rule ID 2275 //
     /* 407890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407904 */   // MIs[0] imm
     /* 407904 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407908 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407912 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 407916 */   // MIs[1] Operand 1
     /* 407916 */   // No operand predicates
     /* 407916 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407918 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 407918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 407921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407923 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407925 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407928 */   GIR_RootConstrainSelectedInstOperands,
     /* 407929 */   // GIR_Coverage, 2275,
     /* 407929 */   GIR_EraseRootFromParent_Done,
     /* 407930 */ // Label 8550: @407930
     /* 407930 */ GIM_Reject,
     /* 407931 */ // Label 8540: @407931
     /* 407931 */ GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(407976), // Rule ID 2278 //
     /* 407936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407950 */   // MIs[0] imm
     /* 407950 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407954 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407958 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 407962 */   // MIs[1] Operand 1
     /* 407962 */   // No operand predicates
     /* 407962 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407964 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 407964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 407967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407969 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407971 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 407974 */   GIR_RootConstrainSelectedInstOperands,
     /* 407975 */   // GIR_Coverage, 2278,
     /* 407975 */   GIR_EraseRootFromParent_Done,
     /* 407976 */ // Label 8551: @407976
     /* 407976 */ GIM_Reject,
     /* 407977 */ // Label 8541: @407977
     /* 407977 */ GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(408022), // Rule ID 2273 //
     /* 407982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407996 */   // MIs[0] imm
     /* 407996 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408000 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408004 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 408008 */   // MIs[1] Operand 1
     /* 408008 */   // No operand predicates
     /* 408008 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408010 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 408010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 408013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408015 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408017 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 408020 */   GIR_RootConstrainSelectedInstOperands,
     /* 408021 */   // GIR_Coverage, 2273,
     /* 408021 */   GIR_EraseRootFromParent_Done,
     /* 408022 */ // Label 8552: @408022
     /* 408022 */ GIM_Reject,
     /* 408023 */ // Label 8542: @408023
     /* 408023 */ GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(408068), // Rule ID 2276 //
     /* 408028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408042 */   // MIs[0] imm
     /* 408042 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408046 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408050 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 408054 */   // MIs[1] Operand 1
     /* 408054 */   // No operand predicates
     /* 408054 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408056 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 408056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 408059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408061 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408063 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 408066 */   GIR_RootConstrainSelectedInstOperands,
     /* 408067 */   // GIR_Coverage, 2276,
     /* 408067 */   GIR_EraseRootFromParent_Done,
     /* 408068 */ // Label 8553: @408068
     /* 408068 */ GIM_Reject,
     /* 408069 */ // Label 8543: @408069
     /* 408069 */ GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(408114), // Rule ID 2274 //
     /* 408074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 408080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408088 */   // MIs[0] imm
     /* 408088 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408092 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408096 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 408100 */   // MIs[1] Operand 1
     /* 408100 */   // No operand predicates
     /* 408100 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408102 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 408102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 408105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408107 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408109 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 408112 */   GIR_RootConstrainSelectedInstOperands,
     /* 408113 */   // GIR_Coverage, 2274,
     /* 408113 */   GIR_EraseRootFromParent_Done,
     /* 408114 */ // Label 8554: @408114
     /* 408114 */ GIM_Reject,
     /* 408115 */ // Label 8544: @408115
     /* 408115 */ GIM_Reject,
     /* 408116 */ // Label 155: @408116
     /* 408116 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8573*/ GIMT_Encode4(408895),
     /* 408127 */ /*GILLT_v2s32*//*Label 8555*/ GIMT_Encode4(408203),
     /* 408131 */ /*GILLT_v2s64*//*Label 8556*/ GIMT_Encode4(408258),
     /* 408135 */ /*GILLT_v4s16*//*Label 8557*/ GIMT_Encode4(408313),
     /* 408139 */ /*GILLT_v4s32*//*Label 8558*/ GIMT_Encode4(408368),
     /* 408143 */ /*GILLT_v8s8*//*Label 8559*/ GIMT_Encode4(408423),
     /* 408147 */ /*GILLT_v8s16*//*Label 8560*/ GIMT_Encode4(408457),
     /* 408151 */ /*GILLT_v16s8*//*Label 8561*/ GIMT_Encode4(408512), GIMT_Encode4(0),
     /* 408159 */ /*GILLT_nxv2s1*//*Label 8562*/ GIMT_Encode4(408546),
     /* 408163 */ /*GILLT_nxv2s16*//*Label 8563*/ GIMT_Encode4(408572),
     /* 408167 */ /*GILLT_nxv2s32*//*Label 8564*/ GIMT_Encode4(408598),
     /* 408171 */ /*GILLT_nxv2s64*//*Label 8565*/ GIMT_Encode4(408624),
     /* 408175 */ /*GILLT_nxv4s1*//*Label 8566*/ GIMT_Encode4(408671),
     /* 408179 */ /*GILLT_nxv4s16*//*Label 8567*/ GIMT_Encode4(408697),
     /* 408183 */ /*GILLT_nxv4s32*//*Label 8568*/ GIMT_Encode4(408723),
     /* 408187 */ /*GILLT_nxv8s1*//*Label 8569*/ GIMT_Encode4(408770),
     /* 408191 */ /*GILLT_nxv8s16*//*Label 8570*/ GIMT_Encode4(408796),
     /* 408195 */ /*GILLT_nxv16s1*//*Label 8571*/ GIMT_Encode4(408843),
     /* 408199 */ /*GILLT_nxv16s8*//*Label 8572*/ GIMT_Encode4(408869),
     /* 408203 */ // Label 8555: @408203
     /* 408203 */ GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(408257),
     /* 408208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 408214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408222 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408226 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(408241), // Rule ID 1895 //
     /* 408231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408234 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 408234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 408239 */     GIR_RootConstrainSelectedInstOperands,
     /* 408240 */     // GIR_Coverage, 1895,
     /* 408240 */     GIR_Done,
     /* 408241 */   // Label 8575: @408241
     /* 408241 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(408256), // Rule ID 5459 //
     /* 408246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408249 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 408249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 408254 */     GIR_RootConstrainSelectedInstOperands,
     /* 408255 */     // GIR_Coverage, 5459,
     /* 408255 */     GIR_Done,
     /* 408256 */   // Label 8576: @408256
     /* 408256 */   GIM_Reject,
     /* 408257 */ // Label 8574: @408257
     /* 408257 */ GIM_Reject,
     /* 408258 */ // Label 8556: @408258
     /* 408258 */ GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(408312),
     /* 408263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 408269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408281 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(408296), // Rule ID 1897 //
     /* 408286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408289 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 408289 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 408294 */     GIR_RootConstrainSelectedInstOperands,
     /* 408295 */     // GIR_Coverage, 1897,
     /* 408295 */     GIR_Done,
     /* 408296 */   // Label 8578: @408296
     /* 408296 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(408311), // Rule ID 5461 //
     /* 408301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408304 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 408304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 408309 */     GIR_RootConstrainSelectedInstOperands,
     /* 408310 */     // GIR_Coverage, 5461,
     /* 408310 */     GIR_Done,
     /* 408311 */   // Label 8579: @408311
     /* 408311 */   GIM_Reject,
     /* 408312 */ // Label 8577: @408312
     /* 408312 */ GIM_Reject,
     /* 408313 */ // Label 8557: @408313
     /* 408313 */ GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(408367),
     /* 408318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 408324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408336 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(408351), // Rule ID 1893 //
     /* 408341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408344 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 408344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 408349 */     GIR_RootConstrainSelectedInstOperands,
     /* 408350 */     // GIR_Coverage, 1893,
     /* 408350 */     GIR_Done,
     /* 408351 */   // Label 8581: @408351
     /* 408351 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(408366), // Rule ID 5457 //
     /* 408356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408359 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 408359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 408364 */     GIR_RootConstrainSelectedInstOperands,
     /* 408365 */     // GIR_Coverage, 5457,
     /* 408365 */     GIR_Done,
     /* 408366 */   // Label 8582: @408366
     /* 408366 */   GIM_Reject,
     /* 408367 */ // Label 8580: @408367
     /* 408367 */ GIM_Reject,
     /* 408368 */ // Label 8558: @408368
     /* 408368 */ GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(408422),
     /* 408373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 408379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408391 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(408406), // Rule ID 1896 //
     /* 408396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408399 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 408399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 408404 */     GIR_RootConstrainSelectedInstOperands,
     /* 408405 */     // GIR_Coverage, 1896,
     /* 408405 */     GIR_Done,
     /* 408406 */   // Label 8584: @408406
     /* 408406 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(408421), // Rule ID 5460 //
     /* 408411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408414 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 408414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 408419 */     GIR_RootConstrainSelectedInstOperands,
     /* 408420 */     // GIR_Coverage, 5460,
     /* 408420 */     GIR_Done,
     /* 408421 */   // Label 8585: @408421
     /* 408421 */   GIM_Reject,
     /* 408422 */ // Label 8583: @408422
     /* 408422 */ GIM_Reject,
     /* 408423 */ // Label 8559: @408423
     /* 408423 */ GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(408456), // Rule ID 1891 //
     /* 408428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 408434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 408437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408449 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 408449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 408454 */   GIR_RootConstrainSelectedInstOperands,
     /* 408455 */   // GIR_Coverage, 1891,
     /* 408455 */   GIR_Done,
     /* 408456 */ // Label 8586: @408456
     /* 408456 */ GIM_Reject,
     /* 408457 */ // Label 8560: @408457
     /* 408457 */ GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(408511),
     /* 408462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 408468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408480 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(408495), // Rule ID 1894 //
     /* 408485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408488 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 408488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 408493 */     GIR_RootConstrainSelectedInstOperands,
     /* 408494 */     // GIR_Coverage, 1894,
     /* 408494 */     GIR_Done,
     /* 408495 */   // Label 8588: @408495
     /* 408495 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(408510), // Rule ID 5458 //
     /* 408500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408503 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 408503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 408508 */     GIR_RootConstrainSelectedInstOperands,
     /* 408509 */     // GIR_Coverage, 5458,
     /* 408509 */     GIR_Done,
     /* 408510 */   // Label 8589: @408510
     /* 408510 */   GIM_Reject,
     /* 408511 */ // Label 8587: @408511
     /* 408511 */ GIM_Reject,
     /* 408512 */ // Label 8561: @408512
     /* 408512 */ GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(408545), // Rule ID 1892 //
     /* 408517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 408523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 408526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408538 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 408538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 408543 */   GIR_RootConstrainSelectedInstOperands,
     /* 408544 */   // GIR_Coverage, 1892,
     /* 408544 */   GIR_Done,
     /* 408545 */ // Label 8590: @408545
     /* 408545 */ GIM_Reject,
     /* 408546 */ // Label 8562: @408546
     /* 408546 */ GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(408571), // Rule ID 3339 //
     /* 408551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 408557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 408560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 408564 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 408564 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 408569 */   GIR_RootConstrainSelectedInstOperands,
     /* 408570 */   // GIR_Coverage, 3339,
     /* 408570 */   GIR_Done,
     /* 408571 */ // Label 8591: @408571
     /* 408571 */ GIM_Reject,
     /* 408572 */ // Label 8563: @408572
     /* 408572 */ GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(408597), // Rule ID 2870 //
     /* 408577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 408583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 408586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408590 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 408590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 408595 */   GIR_RootConstrainSelectedInstOperands,
     /* 408596 */   // GIR_Coverage, 2870,
     /* 408596 */   GIR_Done,
     /* 408597 */ // Label 8592: @408597
     /* 408597 */ GIM_Reject,
     /* 408598 */ // Label 8564: @408598
     /* 408598 */ GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(408623), // Rule ID 2871 //
     /* 408603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 408609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 408612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408616 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 408616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 408621 */   GIR_RootConstrainSelectedInstOperands,
     /* 408622 */   // GIR_Coverage, 2871,
     /* 408622 */   GIR_Done,
     /* 408623 */ // Label 8593: @408623
     /* 408623 */ GIM_Reject,
     /* 408624 */ // Label 8565: @408624
     /* 408624 */ GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(408670),
     /* 408629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 408632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 408635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408639 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(408654), // Rule ID 2866 //
     /* 408644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408647 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 408647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 408652 */     GIR_RootConstrainSelectedInstOperands,
     /* 408653 */     // GIR_Coverage, 2866,
     /* 408653 */     GIR_Done,
     /* 408654 */   // Label 8595: @408654
     /* 408654 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(408669), // Rule ID 2872 //
     /* 408659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408662 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 408662 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 408667 */     GIR_RootConstrainSelectedInstOperands,
     /* 408668 */     // GIR_Coverage, 2872,
     /* 408668 */     GIR_Done,
     /* 408669 */   // Label 8596: @408669
     /* 408669 */   GIM_Reject,
     /* 408670 */ // Label 8594: @408670
     /* 408670 */ GIM_Reject,
     /* 408671 */ // Label 8566: @408671
     /* 408671 */ GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(408696), // Rule ID 3338 //
     /* 408676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 408682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 408685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 408689 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 408689 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 408694 */   GIR_RootConstrainSelectedInstOperands,
     /* 408695 */   // GIR_Coverage, 3338,
     /* 408695 */   GIR_Done,
     /* 408696 */ // Label 8597: @408696
     /* 408696 */ GIM_Reject,
     /* 408697 */ // Label 8567: @408697
     /* 408697 */ GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(408722), // Rule ID 2868 //
     /* 408702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 408708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 408711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408715 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 408715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 408720 */   GIR_RootConstrainSelectedInstOperands,
     /* 408721 */   // GIR_Coverage, 2868,
     /* 408721 */   GIR_Done,
     /* 408722 */ // Label 8598: @408722
     /* 408722 */ GIM_Reject,
     /* 408723 */ // Label 8568: @408723
     /* 408723 */ GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(408769),
     /* 408728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 408731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 408734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408738 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(408753), // Rule ID 2865 //
     /* 408743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408746 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 408746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 408751 */     GIR_RootConstrainSelectedInstOperands,
     /* 408752 */     // GIR_Coverage, 2865,
     /* 408752 */     GIR_Done,
     /* 408753 */   // Label 8600: @408753
     /* 408753 */   GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(408768), // Rule ID 2869 //
     /* 408758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408761 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 408761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 408766 */     GIR_RootConstrainSelectedInstOperands,
     /* 408767 */     // GIR_Coverage, 2869,
     /* 408767 */     GIR_Done,
     /* 408768 */   // Label 8601: @408768
     /* 408768 */   GIM_Reject,
     /* 408769 */ // Label 8599: @408769
     /* 408769 */ GIM_Reject,
     /* 408770 */ // Label 8569: @408770
     /* 408770 */ GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(408795), // Rule ID 3337 //
     /* 408775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 408781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 408784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 408788 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 408788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 408793 */   GIR_RootConstrainSelectedInstOperands,
     /* 408794 */   // GIR_Coverage, 3337,
     /* 408794 */   GIR_Done,
     /* 408795 */ // Label 8602: @408795
     /* 408795 */ GIM_Reject,
     /* 408796 */ // Label 8570: @408796
     /* 408796 */ GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(408842),
     /* 408801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 408804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 408807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408811 */   GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(408826), // Rule ID 2864 //
     /* 408816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408819 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 408819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 408824 */     GIR_RootConstrainSelectedInstOperands,
     /* 408825 */     // GIR_Coverage, 2864,
     /* 408825 */     GIR_Done,
     /* 408826 */   // Label 8604: @408826
     /* 408826 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(408841), // Rule ID 2867 //
     /* 408831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408834 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 408834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 408839 */     GIR_RootConstrainSelectedInstOperands,
     /* 408840 */     // GIR_Coverage, 2867,
     /* 408840 */     GIR_Done,
     /* 408841 */   // Label 8605: @408841
     /* 408841 */   GIM_Reject,
     /* 408842 */ // Label 8603: @408842
     /* 408842 */ GIM_Reject,
     /* 408843 */ // Label 8571: @408843
     /* 408843 */ GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(408868), // Rule ID 2389 //
     /* 408848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 408854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 408857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 408861 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 408861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 408866 */   GIR_RootConstrainSelectedInstOperands,
     /* 408867 */   // GIR_Coverage, 2389,
     /* 408867 */   GIR_Done,
     /* 408868 */ // Label 8606: @408868
     /* 408868 */ GIM_Reject,
     /* 408869 */ // Label 8572: @408869
     /* 408869 */ GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(408894), // Rule ID 2863 //
     /* 408874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 408880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 408883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408887 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 408887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 408892 */   GIR_RootConstrainSelectedInstOperands,
     /* 408893 */   // GIR_Coverage, 2863,
     /* 408893 */   GIR_Done,
     /* 408894 */ // Label 8607: @408894
     /* 408894 */ GIM_Reject,
     /* 408895 */ // Label 8573: @408895
     /* 408895 */ GIM_Reject,
     /* 408896 */ // Label 156: @408896
     /* 408896 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8626*/ GIMT_Encode4(409675),
     /* 408907 */ /*GILLT_v2s32*//*Label 8608*/ GIMT_Encode4(408983),
     /* 408911 */ /*GILLT_v2s64*//*Label 8609*/ GIMT_Encode4(409038),
     /* 408915 */ /*GILLT_v4s16*//*Label 8610*/ GIMT_Encode4(409093),
     /* 408919 */ /*GILLT_v4s32*//*Label 8611*/ GIMT_Encode4(409148),
     /* 408923 */ /*GILLT_v8s8*//*Label 8612*/ GIMT_Encode4(409203),
     /* 408927 */ /*GILLT_v8s16*//*Label 8613*/ GIMT_Encode4(409237),
     /* 408931 */ /*GILLT_v16s8*//*Label 8614*/ GIMT_Encode4(409292), GIMT_Encode4(0),
     /* 408939 */ /*GILLT_nxv2s1*//*Label 8615*/ GIMT_Encode4(409326),
     /* 408943 */ /*GILLT_nxv2s16*//*Label 8616*/ GIMT_Encode4(409352),
     /* 408947 */ /*GILLT_nxv2s32*//*Label 8617*/ GIMT_Encode4(409378),
     /* 408951 */ /*GILLT_nxv2s64*//*Label 8618*/ GIMT_Encode4(409404),
     /* 408955 */ /*GILLT_nxv4s1*//*Label 8619*/ GIMT_Encode4(409451),
     /* 408959 */ /*GILLT_nxv4s16*//*Label 8620*/ GIMT_Encode4(409477),
     /* 408963 */ /*GILLT_nxv4s32*//*Label 8621*/ GIMT_Encode4(409503),
     /* 408967 */ /*GILLT_nxv8s1*//*Label 8622*/ GIMT_Encode4(409550),
     /* 408971 */ /*GILLT_nxv8s16*//*Label 8623*/ GIMT_Encode4(409576),
     /* 408975 */ /*GILLT_nxv16s1*//*Label 8624*/ GIMT_Encode4(409623),
     /* 408979 */ /*GILLT_nxv16s8*//*Label 8625*/ GIMT_Encode4(409649),
     /* 408983 */ // Label 8608: @408983
     /* 408983 */ GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(409037),
     /* 408988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 408994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409002 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409006 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(409021), // Rule ID 1902 //
     /* 409011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409014 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 409014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 409019 */     GIR_RootConstrainSelectedInstOperands,
     /* 409020 */     // GIR_Coverage, 1902,
     /* 409020 */     GIR_Done,
     /* 409021 */   // Label 8628: @409021
     /* 409021 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(409036), // Rule ID 5464 //
     /* 409026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409029 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 409029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 409034 */     GIR_RootConstrainSelectedInstOperands,
     /* 409035 */     // GIR_Coverage, 5464,
     /* 409035 */     GIR_Done,
     /* 409036 */   // Label 8629: @409036
     /* 409036 */   GIM_Reject,
     /* 409037 */ // Label 8627: @409037
     /* 409037 */ GIM_Reject,
     /* 409038 */ // Label 8609: @409038
     /* 409038 */ GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(409092),
     /* 409043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 409049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409061 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(409076), // Rule ID 1904 //
     /* 409066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409069 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 409069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 409074 */     GIR_RootConstrainSelectedInstOperands,
     /* 409075 */     // GIR_Coverage, 1904,
     /* 409075 */     GIR_Done,
     /* 409076 */   // Label 8631: @409076
     /* 409076 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(409091), // Rule ID 5466 //
     /* 409081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409084 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 409084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 409089 */     GIR_RootConstrainSelectedInstOperands,
     /* 409090 */     // GIR_Coverage, 5466,
     /* 409090 */     GIR_Done,
     /* 409091 */   // Label 8632: @409091
     /* 409091 */   GIM_Reject,
     /* 409092 */ // Label 8630: @409092
     /* 409092 */ GIM_Reject,
     /* 409093 */ // Label 8610: @409093
     /* 409093 */ GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(409147),
     /* 409098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 409101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 409104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409112 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409116 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(409131), // Rule ID 1900 //
     /* 409121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409124 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 409124 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 409129 */     GIR_RootConstrainSelectedInstOperands,
     /* 409130 */     // GIR_Coverage, 1900,
     /* 409130 */     GIR_Done,
     /* 409131 */   // Label 8634: @409131
     /* 409131 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(409146), // Rule ID 5462 //
     /* 409136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409139 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 409139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 409144 */     GIR_RootConstrainSelectedInstOperands,
     /* 409145 */     // GIR_Coverage, 5462,
     /* 409145 */     GIR_Done,
     /* 409146 */   // Label 8635: @409146
     /* 409146 */   GIM_Reject,
     /* 409147 */ // Label 8633: @409147
     /* 409147 */ GIM_Reject,
     /* 409148 */ // Label 8611: @409148
     /* 409148 */ GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(409202),
     /* 409153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 409159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409167 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409171 */   GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(409186), // Rule ID 1903 //
     /* 409176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409179 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 409179 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 409184 */     GIR_RootConstrainSelectedInstOperands,
     /* 409185 */     // GIR_Coverage, 1903,
     /* 409185 */     GIR_Done,
     /* 409186 */   // Label 8637: @409186
     /* 409186 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(409201), // Rule ID 5465 //
     /* 409191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409194 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 409194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 409199 */     GIR_RootConstrainSelectedInstOperands,
     /* 409200 */     // GIR_Coverage, 5465,
     /* 409200 */     GIR_Done,
     /* 409201 */   // Label 8638: @409201
     /* 409201 */   GIM_Reject,
     /* 409202 */ // Label 8636: @409202
     /* 409202 */ GIM_Reject,
     /* 409203 */ // Label 8612: @409203
     /* 409203 */ GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(409236), // Rule ID 1898 //
     /* 409208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 409214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 409217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409229 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 409229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 409234 */   GIR_RootConstrainSelectedInstOperands,
     /* 409235 */   // GIR_Coverage, 1898,
     /* 409235 */   GIR_Done,
     /* 409236 */ // Label 8639: @409236
     /* 409236 */ GIM_Reject,
     /* 409237 */ // Label 8613: @409237
     /* 409237 */ GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(409291),
     /* 409242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 409248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409260 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(409275), // Rule ID 1901 //
     /* 409265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409268 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 409268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 409273 */     GIR_RootConstrainSelectedInstOperands,
     /* 409274 */     // GIR_Coverage, 1901,
     /* 409274 */     GIR_Done,
     /* 409275 */   // Label 8641: @409275
     /* 409275 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(409290), // Rule ID 5463 //
     /* 409280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409283 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 409283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 409288 */     GIR_RootConstrainSelectedInstOperands,
     /* 409289 */     // GIR_Coverage, 5463,
     /* 409289 */     GIR_Done,
     /* 409290 */   // Label 8642: @409290
     /* 409290 */   GIM_Reject,
     /* 409291 */ // Label 8640: @409291
     /* 409291 */ GIM_Reject,
     /* 409292 */ // Label 8614: @409292
     /* 409292 */ GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(409325), // Rule ID 1899 //
     /* 409297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 409303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 409306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409318 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 409318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 409323 */   GIR_RootConstrainSelectedInstOperands,
     /* 409324 */   // GIR_Coverage, 1899,
     /* 409324 */   GIR_Done,
     /* 409325 */ // Label 8643: @409325
     /* 409325 */ GIM_Reject,
     /* 409326 */ // Label 8615: @409326
     /* 409326 */ GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(409351), // Rule ID 8889 //
     /* 409331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 409337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 409340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 409344 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 409344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 409349 */   GIR_RootConstrainSelectedInstOperands,
     /* 409350 */   // GIR_Coverage, 8889,
     /* 409350 */   GIR_Done,
     /* 409351 */ // Label 8644: @409351
     /* 409351 */ GIM_Reject,
     /* 409352 */ // Label 8616: @409352
     /* 409352 */ GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(409377), // Rule ID 8844 //
     /* 409357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 409363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 409366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409370 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 409370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 409375 */   GIR_RootConstrainSelectedInstOperands,
     /* 409376 */   // GIR_Coverage, 8844,
     /* 409376 */   GIR_Done,
     /* 409377 */ // Label 8645: @409377
     /* 409377 */ GIM_Reject,
     /* 409378 */ // Label 8617: @409378
     /* 409378 */ GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(409403), // Rule ID 8845 //
     /* 409383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 409389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 409392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409396 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 409396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 409401 */   GIR_RootConstrainSelectedInstOperands,
     /* 409402 */   // GIR_Coverage, 8845,
     /* 409402 */   GIR_Done,
     /* 409403 */ // Label 8646: @409403
     /* 409403 */ GIM_Reject,
     /* 409404 */ // Label 8618: @409404
     /* 409404 */ GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(409450),
     /* 409409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 409412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 409415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409419 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(409434), // Rule ID 8840 //
     /* 409424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409427 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 409427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 409432 */     GIR_RootConstrainSelectedInstOperands,
     /* 409433 */     // GIR_Coverage, 8840,
     /* 409433 */     GIR_Done,
     /* 409434 */   // Label 8648: @409434
     /* 409434 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(409449), // Rule ID 8846 //
     /* 409439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409442 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 409442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 409447 */     GIR_RootConstrainSelectedInstOperands,
     /* 409448 */     // GIR_Coverage, 8846,
     /* 409448 */     GIR_Done,
     /* 409449 */   // Label 8649: @409449
     /* 409449 */   GIM_Reject,
     /* 409450 */ // Label 8647: @409450
     /* 409450 */ GIM_Reject,
     /* 409451 */ // Label 8619: @409451
     /* 409451 */ GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(409476), // Rule ID 8888 //
     /* 409456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 409462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 409465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 409469 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 409469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 409474 */   GIR_RootConstrainSelectedInstOperands,
     /* 409475 */   // GIR_Coverage, 8888,
     /* 409475 */   GIR_Done,
     /* 409476 */ // Label 8650: @409476
     /* 409476 */ GIM_Reject,
     /* 409477 */ // Label 8620: @409477
     /* 409477 */ GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(409502), // Rule ID 8842 //
     /* 409482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 409488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 409491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409495 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 409495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 409500 */   GIR_RootConstrainSelectedInstOperands,
     /* 409501 */   // GIR_Coverage, 8842,
     /* 409501 */   GIR_Done,
     /* 409502 */ // Label 8651: @409502
     /* 409502 */ GIM_Reject,
     /* 409503 */ // Label 8621: @409503
     /* 409503 */ GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(409549),
     /* 409508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 409511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 409514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409518 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(409533), // Rule ID 8839 //
     /* 409523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409526 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 409526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 409531 */     GIR_RootConstrainSelectedInstOperands,
     /* 409532 */     // GIR_Coverage, 8839,
     /* 409532 */     GIR_Done,
     /* 409533 */   // Label 8653: @409533
     /* 409533 */   GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(409548), // Rule ID 8843 //
     /* 409538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409541 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 409541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 409546 */     GIR_RootConstrainSelectedInstOperands,
     /* 409547 */     // GIR_Coverage, 8843,
     /* 409547 */     GIR_Done,
     /* 409548 */   // Label 8654: @409548
     /* 409548 */   GIM_Reject,
     /* 409549 */ // Label 8652: @409549
     /* 409549 */ GIM_Reject,
     /* 409550 */ // Label 8622: @409550
     /* 409550 */ GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(409575), // Rule ID 8887 //
     /* 409555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 409561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 409564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 409568 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 409568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 409573 */   GIR_RootConstrainSelectedInstOperands,
     /* 409574 */   // GIR_Coverage, 8887,
     /* 409574 */   GIR_Done,
     /* 409575 */ // Label 8655: @409575
     /* 409575 */ GIM_Reject,
     /* 409576 */ // Label 8623: @409576
     /* 409576 */ GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(409622),
     /* 409581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 409584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 409587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409591 */   GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(409606), // Rule ID 8838 //
     /* 409596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409599 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 409599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 409604 */     GIR_RootConstrainSelectedInstOperands,
     /* 409605 */     // GIR_Coverage, 8838,
     /* 409605 */     GIR_Done,
     /* 409606 */   // Label 8657: @409606
     /* 409606 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(409621), // Rule ID 8841 //
     /* 409611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409614 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 409614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 409619 */     GIR_RootConstrainSelectedInstOperands,
     /* 409620 */     // GIR_Coverage, 8841,
     /* 409620 */     GIR_Done,
     /* 409621 */   // Label 8658: @409621
     /* 409621 */   GIM_Reject,
     /* 409622 */ // Label 8656: @409622
     /* 409622 */ GIM_Reject,
     /* 409623 */ // Label 8624: @409623
     /* 409623 */ GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(409648), // Rule ID 2393 //
     /* 409628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 409634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 409637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 409641 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 409641 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 409646 */   GIR_RootConstrainSelectedInstOperands,
     /* 409647 */   // GIR_Coverage, 2393,
     /* 409647 */   GIR_Done,
     /* 409648 */ // Label 8659: @409648
     /* 409648 */ GIM_Reject,
     /* 409649 */ // Label 8625: @409649
     /* 409649 */ GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(409674), // Rule ID 8837 //
     /* 409654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 409660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 409663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409667 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 409667 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 409672 */   GIR_RootConstrainSelectedInstOperands,
     /* 409673 */   // GIR_Coverage, 8837,
     /* 409673 */   GIR_Done,
     /* 409674 */ // Label 8660: @409674
     /* 409674 */ GIM_Reject,
     /* 409675 */ // Label 8626: @409675
     /* 409675 */ GIM_Reject,
     /* 409676 */ // Label 157: @409676
     /* 409676 */ GIM_Reject,
     /* 409677 */ }; // Size: 409677 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
